/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/cancellation","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/hover/updatableHoverWidget","vs/base/common/assert","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/utils","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/hover/updatableHoverWidget","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(ie){for(var t=[],n=0,F=ie.length;n<F;n++)t[n]=ge[ie[n]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:zt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Rt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,n,F){return t.apply(n,F)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Rt||(Rt=function(t,n){return new t(...n)});const oi=ct(Array.prototype.forEach),xt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),Dt=ct(String.prototype.toLowerCase),It=ct(String.prototype.toString),ai=ct(String.prototype.match),dt=ct(String.prototype.replace),li=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(ie){return function(t){for(var n=arguments.length,F=new Array(n>1?n-1:0),B=1;B<n;B++)F[B-1]=arguments[B];return Nt(ie,t,F)}}function ui(ie){return function(){for(var t=arguments.length,n=new Array(t),F=0;F<t;F++)n[F]=arguments[F];return Rt(ie,n)}}function He(ie,t,n){var F;n=(F=n)!==null&&F!==void 0?F:Dt,zt&&zt(ie,null);let B=t.length;for(;B--;){let W=t[B];if(typeof W=="string"){const A=n(W);A!==W&&(ii(t)||(t[B]=A),W=A)}ie[W]=!0}return ie}function bt(ie){const t=ri(null);for(const[n,F]of Bt(ie))t[n]=F;return t}function Et(ie,t){for(;ie!==null;){const F=si(ie,t);if(F){if(F.get)return ct(F.get);if(typeof F.value=="function")return ct(F.value)}ie=ni(ie)}function n(F){return console.warn("fallback value for",F),null}return n}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Mt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),jt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Ct=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,yi=function(t,n){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let F=null;const B="data-tt-policy-suffix";n&&n.hasAttribute(B)&&(F=n.getAttribute(B));const W="dompurify"+(F?"#"+F:"");try{return t.createPolicy(W,{createHTML(A){return A},createScriptURL(A){return A}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Yt(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Be=>Yt(Be);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const n=ie.document,F=n.currentScript;let{document:B}=ie;const{DocumentFragment:W,HTMLTemplateElement:A,Node:k,Element:m,NodeFilter:b,NamedNodeMap:v=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:z,DOMParser:u,trustedTypes:f}=ie,e=m.prototype,i=Et(e,"cloneNode"),r=Et(e,"nextSibling"),h=Et(e,"childNodes"),g=Et(e,"parentNode");if(typeof A=="function"){const Be=B.createElement("template");Be.content&&Be.content.ownerDocument&&(B=Be.content.ownerDocument)}let w,a="";const{implementation:d,createNodeIterator:o,createDocumentFragment:C,getElementsByTagName:N}=B,{importNode:O}=n;let P={};t.isSupported=typeof Bt=="function"&&typeof g=="function"&&d&&d.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:L,ERB_EXPR:$,TMPLIT_EXPR:M,DATA_ATTR:V,ARIA_ATTR:I,IS_SCRIPT_OR_DATA:j,ATTR_WHITESPACE:T}=Gt;let{IS_ALLOWED_URI:K}=Gt,Z=null;const ce=He({},[...Ht,...Lt,...Mt,...jt,...Wt]);let re=null;const te=He({},[...Vt,...Ot,...qt,...Ct]);let $e=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),De=null,Te=null,Pe=!0,he=!0,_=!1,le=!0,ae=!1,J=!1,G=!1,se=!1,fe=!1,ve=!1,Ne=!1,Ae=!0,Le=!1;const x="user-content-";let c=!0,D=!1,l={},p=null;const S=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let s=null;const E=He({},["audio","video","img","source","image","track"]);let y=null;const R=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),H="http://www.w3.org/1998/Math/MathML",X="http://www.w3.org/2000/svg",U="http://www.w3.org/1999/xhtml";let oe=U,we=!1,me=null;const Ie=He({},[H,X,U],It);let ke;const je=["application/xhtml+xml","text/html"],Ee="text/html";let Se,We=null;const Ue=B.createElement("form"),Ye=function(ue){return ue instanceof RegExp||ue instanceof Function},_e=function(ue){if(!(We&&We===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=bt(ue),ke=je.indexOf(ue.PARSER_MEDIA_TYPE)===-1?ke=Ee:ke=ue.PARSER_MEDIA_TYPE,Se=ke==="application/xhtml+xml"?It:Dt,Z="ALLOWED_TAGS"in ue?He({},ue.ALLOWED_TAGS,Se):ce,re="ALLOWED_ATTR"in ue?He({},ue.ALLOWED_ATTR,Se):te,me="ALLOWED_NAMESPACES"in ue?He({},ue.ALLOWED_NAMESPACES,It):Ie,y="ADD_URI_SAFE_ATTR"in ue?He(bt(R),ue.ADD_URI_SAFE_ATTR,Se):R,s="ADD_DATA_URI_TAGS"in ue?He(bt(E),ue.ADD_DATA_URI_TAGS,Se):E,p="FORBID_CONTENTS"in ue?He({},ue.FORBID_CONTENTS,Se):S,De="FORBID_TAGS"in ue?He({},ue.FORBID_TAGS,Se):{},Te="FORBID_ATTR"in ue?He({},ue.FORBID_ATTR,Se):{},l="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Pe=ue.ALLOW_ARIA_ATTR!==!1,he=ue.ALLOW_DATA_ATTR!==!1,_=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,le=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,ae=ue.SAFE_FOR_TEMPLATES||!1,J=ue.WHOLE_DOCUMENT||!1,fe=ue.RETURN_DOM||!1,ve=ue.RETURN_DOM_FRAGMENT||!1,Ne=ue.RETURN_TRUSTED_TYPE||!1,se=ue.FORCE_BODY||!1,Ae=ue.SANITIZE_DOM!==!1,Le=ue.SANITIZE_NAMED_PROPS||!1,c=ue.KEEP_CONTENT!==!1,D=ue.IN_PLACE||!1,K=ue.ALLOWED_URI_REGEXP||Kt,oe=ue.NAMESPACE||U,$e=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&Ye(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&($e.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&Ye(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&($e.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&($e.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),ae&&(he=!1),ve&&(fe=!0),l&&(Z=He({},[...Wt]),re=[],l.html===!0&&(He(Z,Ht),He(re,Vt)),l.svg===!0&&(He(Z,Lt),He(re,Ot),He(re,Ct)),l.svgFilters===!0&&(He(Z,Mt),He(re,Ot),He(re,Ct)),l.mathMl===!0&&(He(Z,jt),He(re,qt),He(re,Ct))),ue.ADD_TAGS&&(Z===ce&&(Z=bt(Z)),He(Z,ue.ADD_TAGS,Se)),ue.ADD_ATTR&&(re===te&&(re=bt(re)),He(re,ue.ADD_ATTR,Se)),ue.ADD_URI_SAFE_ATTR&&He(y,ue.ADD_URI_SAFE_ATTR,Se),ue.FORBID_CONTENTS&&(p===S&&(p=bt(p)),He(p,ue.FORBID_CONTENTS,Se)),c&&(Z["#text"]=!0),J&&He(Z,["html","head","body"]),Z.table&&(He(Z,["tbody"]),delete De.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');w=ue.TRUSTED_TYPES_POLICY,a=w.createHTML("")}else w===void 0&&(w=yi(f,F)),w!==null&&typeof a=="string"&&(a=w.createHTML(""));ot&&ot(ue),We=ue}},Y=He({},["mi","mo","mn","ms","mtext"]),ne=He({},["foreignobject","desc","title","annotation-xml"]),pe=He({},["title","style","font","a","script"]),ye=He({},Lt);He(ye,Mt),He(ye,ci);const Re=He({},jt);He(Re,fi);const xe=function(ue){let Fe=g(ue);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:oe,tagName:"template"});const Me=Dt(ue.tagName),Qe=Dt(Fe.tagName);return me[ue.namespaceURI]?ue.namespaceURI===X?Fe.namespaceURI===U?Me==="svg":Fe.namespaceURI===H?Me==="svg"&&(Qe==="annotation-xml"||Y[Qe]):!!ye[Me]:ue.namespaceURI===H?Fe.namespaceURI===U?Me==="math":Fe.namespaceURI===X?Me==="math"&&ne[Qe]:!!Re[Me]:ue.namespaceURI===U?Fe.namespaceURI===X&&!ne[Qe]||Fe.namespaceURI===H&&!Y[Qe]?!1:!Re[Me]&&(pe[Me]||!ye[Me]):!!(ke==="application/xhtml+xml"&&me[ue.namespaceURI]):!1},Ve=function(ue){wt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},et=function(ue,Fe){try{wt(t.removed,{attribute:Fe.getAttributeNode(ue),from:Fe})}catch{wt(t.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(ue),ue==="is"&&!re[ue])if(fe||ve)try{Ve(Fe)}catch{}else try{Fe.setAttribute(ue,"")}catch{}},it=function(ue){let Fe,Me;if(se)ue="<remove></remove>"+ue;else{const lt=ai(ue,/^[\r\n\t ]+/);Me=lt&&lt[0]}ke==="application/xhtml+xml"&&oe===U&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Qe=w?w.createHTML(ue):ue;if(oe===U)try{Fe=new u().parseFromString(Qe,ke)}catch{}if(!Fe||!Fe.documentElement){Fe=d.createDocument(oe,"template",null);try{Fe.documentElement.innerHTML=we?a:Qe}catch{}}const nt=Fe.body||Fe.documentElement;return ue&&Me&&nt.insertBefore(B.createTextNode(Me),nt.childNodes[0]||null),oe===U?N.call(Fe,J?"html":"body")[0]:J?Fe.documentElement:nt},st=function(ue){return o.call(ue.ownerDocument||ue,ue,b.SHOW_ELEMENT|b.SHOW_COMMENT|b.SHOW_TEXT,null,!1)},Je=function(ue){return ue instanceof z&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof v)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},rt=function(ue){return typeof k=="object"?ue instanceof k:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},tt=function(ue,Fe,Me){P[ue]&&oi(P[ue],Qe=>{Qe.call(t,Fe,Me,We)})},mt=function(ue){let Fe;if(tt("beforeSanitizeElements",ue,null),Je(ue))return Ve(ue),!0;const Me=Se(ue.nodeName);if(tt("uponSanitizeElement",ue,{tagName:Me,allowedTags:Z}),ue.hasChildNodes()&&!rt(ue.firstElementChild)&&(!rt(ue.content)||!rt(ue.content.firstElementChild))&&ht(/<[/\w]/g,ue.innerHTML)&&ht(/<[/\w]/g,ue.textContent))return Ve(ue),!0;if(!Z[Me]||De[Me]){if(!De[Me]&&At(Me)&&($e.tagNameCheck instanceof RegExp&&ht($e.tagNameCheck,Me)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(Me)))return!1;if(c&&!p[Me]){const Qe=g(ue)||ue.parentNode,nt=h(ue)||ue.childNodes;if(nt&&Qe){const lt=nt.length;for(let Xe=lt-1;Xe>=0;--Xe)Qe.insertBefore(i(nt[Xe],!0),r(ue))}}return Ve(ue),!0}return ue instanceof m&&!xe(ue)||(Me==="noscript"||Me==="noembed"||Me==="noframes")&&ht(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Ve(ue),!0):(ae&&ue.nodeType===3&&(Fe=ue.textContent,Fe=dt(Fe,L," "),Fe=dt(Fe,$," "),Fe=dt(Fe,M," "),ue.textContent!==Fe&&(wt(t.removed,{element:ue.cloneNode()}),ue.textContent=Fe)),tt("afterSanitizeElements",ue,null),!1)},gt=function(ue,Fe,Me){if(Ae&&(Fe==="id"||Fe==="name")&&(Me in B||Me in Ue))return!1;if(!(he&&!Te[Fe]&&ht(V,Fe))){if(!(Pe&&ht(I,Fe))){if(!re[Fe]||Te[Fe]){if(!(At(ue)&&($e.tagNameCheck instanceof RegExp&&ht($e.tagNameCheck,ue)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(ue))&&($e.attributeNameCheck instanceof RegExp&&ht($e.attributeNameCheck,Fe)||$e.attributeNameCheck instanceof Function&&$e.attributeNameCheck(Fe))||Fe==="is"&&$e.allowCustomizedBuiltInElements&&($e.tagNameCheck instanceof RegExp&&ht($e.tagNameCheck,Me)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(Me))))return!1}else if(!y[Fe]){if(!ht(K,dt(Me,T,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&ue!=="script"&&li(Me,"data:")===0&&s[ue])){if(!(_&&!ht(j,dt(Me,T,"")))){if(Me)return!1}}}}}}return!0},At=function(ue){return ue.indexOf("-")>0},kt=function(ue){let Fe,Me,Qe,nt;tt("beforeSanitizeAttributes",ue,null);const{attributes:lt}=ue;if(!lt)return;const Xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:re};for(nt=lt.length;nt--;){Fe=lt[nt];const{name:ut,namespaceURI:$t}=Fe;if(Me=ut==="value"?Fe.value:hi(Fe.value),Qe=Se(ut),Xe.attrName=Qe,Xe.attrValue=Me,Xe.keepAttr=!0,Xe.forceKeepAttr=void 0,tt("uponSanitizeAttribute",ue,Xe),Me=Xe.attrValue,Xe.forceKeepAttr||(et(ut,ue),!Xe.keepAttr))continue;if(!le&&ht(/\/>/i,Me)){et(ut,ue);continue}ae&&(Me=dt(Me,L," "),Me=dt(Me,$," "),Me=dt(Me,M," "));const Tt=Se(ue.nodeName);if(gt(Tt,Qe,Me)){if(Le&&(Qe==="id"||Qe==="name")&&(et(ut,ue),Me=x+Me),w&&typeof f=="object"&&typeof f.getAttributeType=="function"&&!$t)switch(f.getAttributeType(Tt,Qe)){case"TrustedHTML":{Me=w.createHTML(Me);break}case"TrustedScriptURL":{Me=w.createScriptURL(Me);break}}try{$t?ue.setAttributeNS($t,ut,Me):ue.setAttribute(ut,Me),xt(t.removed)}catch{}}}tt("afterSanitizeAttributes",ue,null)},St=function Be(ue){let Fe;const Me=st(ue);for(tt("beforeSanitizeShadowDOM",ue,null);Fe=Me.nextNode();)tt("uponSanitizeShadowNode",Fe,null),!mt(Fe)&&(Fe.content instanceof W&&Be(Fe.content),kt(Fe));tt("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Be){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Me,Qe,nt;if(we=!Be,we&&(Be="<!-->"),typeof Be!="string"&&!rt(Be))if(typeof Be.toString=="function"){if(Be=Be.toString(),typeof Be!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Be;if(G||_e(ue),t.removed=[],typeof Be=="string"&&(D=!1),D){if(Be.nodeName){const ut=Se(Be.nodeName);if(!Z[ut]||De[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Be instanceof k)Fe=it("<!---->"),Me=Fe.ownerDocument.importNode(Be,!0),Me.nodeType===1&&Me.nodeName==="BODY"||Me.nodeName==="HTML"?Fe=Me:Fe.appendChild(Me);else{if(!fe&&!ae&&!J&&Be.indexOf("<")===-1)return w&&Ne?w.createHTML(Be):Be;if(Fe=it(Be),!Fe)return fe?null:Ne?a:""}Fe&&se&&Ve(Fe.firstChild);const lt=st(D?Be:Fe);for(;Qe=lt.nextNode();)mt(Qe)||(Qe.content instanceof W&&St(Qe.content),kt(Qe));if(D)return Be;if(fe){if(ve)for(nt=C.call(Fe.ownerDocument);Fe.firstChild;)nt.appendChild(Fe.firstChild);else nt=Fe;return(re.shadowroot||re.shadowrootmode)&&(nt=O.call(n,nt,!0)),nt}let Xe=J?Fe.outerHTML:Fe.innerHTML;return J&&Z["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Qt,Fe.ownerDocument.doctype.name)&&(Xe="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Xe),ae&&(Xe=dt(Xe,L," "),Xe=dt(Xe,$," "),Xe=dt(Xe,M," ")),w&&Ne?w.createHTML(Xe):Xe},t.setConfig=function(Be){_e(Be),G=!0},t.clearConfig=function(){We=null,G=!1},t.isValidAttribute=function(Be,ue,Fe){We||_e({});const Me=Se(Be),Qe=Se(ue);return gt(Me,Qe,Fe)},t.addHook=function(Be,ue){typeof ue=="function"&&(P[Be]=P[Be]||[],wt(P[Be],ue))},t.removeHook=function(Be){if(P[Be])return xt(P[Be])},t.removeHooks=function(Be){P[Be]&&(P[Be]=[])},t.removeAllHooks=function(){P={}},t}var Di=Yt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(ge[51],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MS=void 0,t.$NS=B;class n{constructor(A){this.domNode=A,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(A){const k=F(A);this.a!==k&&(this.a=k,this.domNode.style.maxWidth=this.a)}setWidth(A){const k=F(A);this.b!==k&&(this.b=k,this.domNode.style.width=this.b)}setHeight(A){const k=F(A);this.c!==k&&(this.c=k,this.domNode.style.height=this.c)}setTop(A){const k=F(A);this.d!==k&&(this.d=k,this.domNode.style.top=this.d)}setLeft(A){const k=F(A);this.e!==k&&(this.e=k,this.domNode.style.left=this.e)}setBottom(A){const k=F(A);this.f!==k&&(this.f=k,this.domNode.style.bottom=this.f)}setRight(A){const k=F(A);this.g!==k&&(this.g=k,this.domNode.style.right=this.g)}setPaddingTop(A){const k=F(A);this.h!==k&&(this.h=k,this.domNode.style.paddingTop=this.h)}setPaddingLeft(A){const k=F(A);this.i!==k&&(this.i=k,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(A){const k=F(A);this.j!==k&&(this.j=k,this.domNode.style.paddingBottom=this.j)}setPaddingRight(A){const k=F(A);this.k!==k&&(this.k=k,this.domNode.style.paddingRight=this.k)}setFontFamily(A){this.l!==A&&(this.l=A,this.domNode.style.fontFamily=this.l)}setFontWeight(A){this.m!==A&&(this.m=A,this.domNode.style.fontWeight=this.m)}setFontSize(A){const k=F(A);this.n!==k&&(this.n=k,this.domNode.style.fontSize=this.n)}setFontStyle(A){this.o!==A&&(this.o=A,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(A){this.p!==A&&(this.p=A,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(A){this.q!==A&&(this.q=A,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(A){this.r!==A&&(this.r=A,this.domNode.style.textDecoration=this.r)}setLineHeight(A){const k=F(A);this.s!==k&&(this.s=k,this.domNode.style.lineHeight=this.s)}setLetterSpacing(A){const k=F(A);this.t!==k&&(this.t=k,this.domNode.style.letterSpacing=this.t)}setClassName(A){this.u!==A&&(this.u=A,this.domNode.className=this.u)}toggleClassName(A,k){this.domNode.classList.toggle(A,k),this.u=this.domNode.className}setDisplay(A){this.v!==A&&(this.v=A,this.domNode.style.display=this.v)}setPosition(A){this.w!==A&&(this.w=A,this.domNode.style.position=this.w)}setVisibility(A){this.x!==A&&(this.x=A,this.domNode.style.visibility=this.x)}setColor(A){this.y!==A&&(this.y=A,this.domNode.style.color=this.y)}setBackgroundColor(A){this.z!==A&&(this.z=A,this.domNode.style.backgroundColor=this.z)}setLayerHinting(A){this.A!==A&&(this.A=A,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(A){this.C!==A&&(this.C=A,this.domNode.style.boxShadow=A)}setContain(A){this.B!==A&&(this.B=A,this.domNode.style.contain=this.B)}setAttribute(A,k){this.domNode.setAttribute(A,k)}removeAttribute(A){this.domNode.removeAttribute(A)}appendChild(A){this.domNode.appendChild(A.domNode)}removeChild(A){this.domNode.removeChild(A.domNode)}}t.$MS=n;function F(W){return typeof W=="number"?`${W}px`:W}function B(W){return new n(W)}}),define(ge[79],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Q=void 0,t.$6Q=W;const n=new WeakMap;function F(k){if(!k.parent||k.parent===k)return null;try{const m=k.location,b=k.parent.location;if(m.origin!=="null"&&b.origin!=="null"&&m.origin!==b.origin)return null}catch{return null}return k.parent}class B{static a(m){let b=n.get(m);if(!b){b=[],n.set(m,b);let v=m,z;do z=F(v),z?b.push({window:new WeakRef(v),iframeElement:v.frameElement||null}):b.push({window:new WeakRef(v),iframeElement:null}),v=z;while(v)}return b.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,b){if(!b||m===b)return{top:0,left:0};let v=0,z=0;const u=this.a(m);for(const f of u){const e=f.window.deref();if(v+=e?.scrollY??0,z+=e?.scrollX??0,e===b||!f.iframeElement)break;const i=f.iframeElement.getBoundingClientRect();v+=i.top,z+=i.left}return{top:v,left:z}}}t.$5Q=B;async function W(k,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const b=JSON.stringify({parentOrigin:k,salt:m}),z=new TextEncoder().encode(b),u=await crypto.subtle.digest("sha-256",z);return A(u)}function A(k){const b=Array.from(new Uint8Array(k)).map(v=>v.toString(16).padStart(2,"0")).join("");return BigInt(`0x${b}`).toString(32).padStart(52,"0")}}),define(ge[80],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wT=t.$vT=t.$uT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var n;(function(A){A[A.Copy=0]="Copy",A[A.Move=1]="Move"})(n||(t.ListDragOverEffectType=n={}));var F;(function(A){A.Over="drop-target",A.Before="drop-target-before",A.After="drop-target-after"})(F||(t.ListDragOverEffectPosition=F={})),t.$uT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class B extends Error{constructor(k,m){super(`ListError [${k}] ${m}`)}}t.$vT=B;class W{constructor(){this.c=new WeakMap}getHeight(k){return this.c.get(k)??this.d(k)}setDynamicHeight(k,m){m>0&&this.c.set(k,m)}}t.$wT=W}),define(ge[81],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kT=void 0;class n{constructor(B){this.a=B}splice(B,W,A){this.a.forEach(k=>k.splice(B,W,A))}}t.$kT=n}),define(ge[52],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SS=void 0;const n=20;class F{constructor(W,A,k,m,b,v){this.a=Math.round(A),this.b=Math.round(k),this.c=Math.round(W),this.d=m,this.e=b,this.f=v,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new F(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const A=Math.round(W);return this.d!==A?(this.d=A,this.m(),!0):!1}setScrollSize(W){const A=Math.round(W);return this.e!==A?(this.e=A,this.m(),!0):!1}setScrollPosition(W){const A=Math.round(W);return this.f!==A?(this.f=A,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,A,k,m,b){const v=Math.max(0,k-W),z=Math.max(0,v-2*A),u=m>0&&m>k;if(!u)return{computedAvailableSize:Math.round(v),computedIsNeeded:u,computedSliderSize:Math.round(z),computedSliderRatio:0,computedSliderPosition:0};const f=Math.round(Math.max(n,Math.floor(k*z/m))),e=(z-f)/(m-k),i=b*e;return{computedAvailableSize:Math.round(v),computedIsNeeded:u,computedSliderSize:Math.round(f),computedSliderRatio:e,computedSliderPosition:Math.round(i)}}m(){const W=F.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const A=W-this.c-this.i/2;return Math.round(A/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const A=W-this.c;let k=this.f;return A<this.k?k-=this.d:k+=this.d,k}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const A=this.k+W;return Math.round(A/this.j)}}t.$SS=F}),define(ge[30],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pV=t.$oV=t.$nV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var F;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(F||(t.ObjectTreeElementCollapseState=F={}));var B;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(B||(t.TreeMouseEventTarget=B={}));var W;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(W||(t.TreeDragOverBubble=W={})),t.$nV={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:m}}};class A extends Error{constructor(b,v){super(`TreeError [${b}] ${v}`)}}t.$oV=A;class k{constructor(b){this.a=b,this.b=new WeakMap}map(b){let v=this.b.get(b);return v||(v=this.a(b),this.b.set(b,v)),v}}t.$pV=k}),define(ge[22],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IQ=void 0,t.$HQ=n,t.$JQ=F;function n(B,W){const A=B;typeof A.vscodeWindowId!="number"&&Object.defineProperty(A,"vscodeWindowId",{get:()=>W})}t.$IQ=window;function F(B){return B===t.$IQ?!1:typeof B?.vscodeWindowId=="number"}}),define(ge[82],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=n,t.$gb=F,t.$hb=B,t.$ib=W,t.$jb=A,t.$kb=k,t.$lb=m,t.$nb=v,t.$ob=z,t.$pb=u,t.$qb=f,t.$rb=e;function n(i,r,h){const g=F(i,r);if(g!==-1)return i[g]}function F(i,r,h=i.length-1){for(let g=h;g>=0;g--){const w=i[g];if(r(w))return g}return-1}function B(i,r){const h=W(i,r);return h===-1?void 0:i[h]}function W(i,r,h=0,g=i.length){let w=h,a=g;for(;w<a;){const d=Math.floor((w+a)/2);r(i[d])?w=d+1:a=d}return w-1}function A(i,r){const h=k(i,r);return h===i.length?void 0:i[h]}function k(i,r,h=0,g=i.length){let w=h,a=g;for(;w<a;){const d=Math.floor((w+a)/2);r(i[d])?a=d:w=d+1}return w}function m(i,r,h=0,g=i.length){const w=k(i,r,h,g);return w===i.length?-1:w}class b{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(b.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!r(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const h=W(this.e,r,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$mb=b;function v(i,r){if(i.length===0)return;let h=i[0];for(let g=1;g<i.length;g++){const w=i[g];r(w,h)>0&&(h=w)}return h}function z(i,r){if(i.length===0)return;let h=i[0];for(let g=1;g<i.length;g++){const w=i[g];r(w,h)>=0&&(h=w)}return h}function u(i,r){return v(i,(h,g)=>-r(h,g))}function f(i,r){if(i.length===0)return-1;let h=0;for(let g=1;g<i.length;g++){const w=i[g];r(w,i[h])>0&&(h=g)}return h}function e(i,r){for(const h of i){const g=r(h);if(g!==void 0)return g}}}),define(ge[83],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=n,t.$L=F,t.$M=B,t.$N=W;function n(A,k){const m=Object.create(null);for(const b of A){const v=k(b);let z=m[v];z||(z=m[v]=[]),z.push(b)}return m}function F(A,k){const m=[],b=[];for(const v of A)k.has(v)||m.push(v);for(const v of k)A.has(v)||b.push(v);return{removed:m,added:b}}function B(A,k){const m=[],b=[];for(const[v,z]of A)k.has(v)||m.push(z);for(const[v,z]of k)A.has(v)||b.push(z);return{removed:m,added:b}}function W(A,k){const m=new Set;for(const b of k)A.has(b)&&m.add(b);return m}}),define(ge[84],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gt=t.$Ft=t.$Et=t.$Dt=void 0;function n(k,m){const b=Math.pow(10,m);return Math.round(k*b)/b}class F{constructor(m,b,v,z=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,b))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=n(Math.max(Math.min(1,z),0),3)}static equals(m,b){return m.r===b.r&&m.g===b.g&&m.b===b.b&&m.a===b.a}}t.$Dt=F;class B{constructor(m,b,v,z){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=n(Math.max(Math.min(1,b),0),3),this.l=n(Math.max(Math.min(1,v),0),3),this.a=n(Math.max(Math.min(1,z),0),3)}static equals(m,b){return m.h===b.h&&m.s===b.s&&m.l===b.l&&m.a===b.a}static fromRGBA(m){const b=m.r/255,v=m.g/255,z=m.b/255,u=m.a,f=Math.max(b,v,z),e=Math.min(b,v,z);let i=0,r=0;const h=(e+f)/2,g=f-e;if(g>0){switch(r=Math.min(h<=.5?g/(2*h):g/(2-2*h),1),f){case b:i=(v-z)/g+(v<z?6:0);break;case v:i=(z-b)/g+2;break;case z:i=(b-v)/g+4;break}i*=60,i=Math.round(i)}return new B(i,r,h,u)}static i(m,b,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?m+(b-m)*6*v:v<1/2?b:v<2/3?m+(b-m)*(2/3-v)*6:m}static toRGBA(m){const b=m.h/360,{s:v,l:z,a:u}=m;let f,e,i;if(v===0)f=e=i=z;else{const r=z<.5?z*(1+v):z+v-z*v,h=2*z-r;f=B.i(h,r,b+1/3),e=B.i(h,r,b),i=B.i(h,r,b-1/3)}return new F(Math.round(f*255),Math.round(e*255),Math.round(i*255),u)}}t.$Et=B;class W{constructor(m,b,v,z){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=n(Math.max(Math.min(1,b),0),3),this.v=n(Math.max(Math.min(1,v),0),3),this.a=n(Math.max(Math.min(1,z),0),3)}static equals(m,b){return m.h===b.h&&m.s===b.s&&m.v===b.v&&m.a===b.a}static fromRGBA(m){const b=m.r/255,v=m.g/255,z=m.b/255,u=Math.max(b,v,z),f=Math.min(b,v,z),e=u-f,i=u===0?0:e/u;let r;return e===0?r=0:u===b?r=((v-z)/e%6+6)%6:u===v?r=(z-b)/e+2:r=(b-v)/e+4,new W(Math.round(r*60),i,u,m.a)}static toRGBA(m){const{h:b,s:v,v:z,a:u}=m,f=z*v,e=f*(1-Math.abs(b/60%2-1)),i=z-f;let[r,h,g]=[0,0,0];return b<60?(r=f,h=e):b<120?(r=e,h=f):b<180?(h=f,g=e):b<240?(h=e,g=f):b<300?(r=e,g=f):b<=360&&(r=f,g=e),r=Math.round((r+i)*255),h=Math.round((h+i)*255),g=Math.round((g+i)*255),new F(r,h,g,u)}}t.$Ft=W;class A{static fromHex(m){return A.Format.CSS.parseHex(m)||A.red}static equals(m,b){return!m&&!b?!0:!m||!b?!1:m.equals(b)}get hsla(){return this.i?this.i:B.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof F)this.rgba=m;else if(m instanceof B)this.i=m,this.rgba=B.toRGBA(m);else if(m instanceof W)this.j=m,this.rgba=W.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&F.equals(this.rgba,m.rgba)&&B.equals(this.hsla,m.hsla)&&W.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=A.k(this.rgba.r),b=A.k(this.rgba.g),v=A.k(this.rgba.b),z=.2126*m+.7152*b+.0722*v;return n(z,4)}static k(m){const b=m/255;return b<=.03928?b/12.92:Math.pow((b+.055)/1.055,2.4)}getContrastRatio(m){const b=this.getRelativeLuminance(),v=m.getRelativeLuminance();return b>v?(b+.05)/(v+.05):(v+.05)/(b+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const b=this.getRelativeLuminance(),v=m.getRelativeLuminance();return b>v}isDarkerThan(m){const b=this.getRelativeLuminance(),v=m.getRelativeLuminance();return b<v}lighten(m){return new A(new B(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new A(new B(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:b,g:v,b:z,a:u}=this.rgba;return new A(new F(b,v,z,u*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const b=m.rgba,v=this.rgba.a,z=b.a,u=v+z*(1-v);if(u<1e-6)return A.transparent;const f=this.rgba.r*v/u+b.r*z*(1-v)/u,e=this.rgba.g*v/u+b.g*z*(1-v)/u,i=this.rgba.b*v/u+b.b*z*(1-v)/u;return new A(new F(f,e,i,u))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:b,g:v,b:z,a:u}=this.rgba;return new A(new F(m.rgba.r-u*(m.rgba.r-b),m.rgba.g-u*(m.rgba.g-v),m.rgba.b-u*(m.rgba.b-z),1))}flatten(...m){const b=m.reduceRight((v,z)=>A.o(z,v));return A.o(this,b)}static o(m,b){const v=1-m.rgba.a;return new A(new F(v*b.rgba.r+m.rgba.a*m.rgba.r,v*b.rgba.g+m.rgba.a*m.rgba.g,v*b.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(m,b,v){if(m.isLighterThan(b))return m;v=v||.5;const z=m.getRelativeLuminance(),u=b.getRelativeLuminance();return v=v*(u-z)/u,m.lighten(v)}static getDarkerColor(m,b,v){if(m.isDarkerThan(b))return m;v=v||.5;const z=m.getRelativeLuminance(),u=b.getRelativeLuminance();return v=v*(z-u)/z,m.darken(v)}static{this.white=new A(new F(255,255,255,1))}static{this.black=new A(new F(0,0,0,1))}static{this.red=new A(new F(255,0,0,1))}static{this.blue=new A(new F(0,0,255,1))}static{this.green=new A(new F(0,255,0,1))}static{this.cyan=new A(new F(0,255,255,1))}static{this.lightgrey=new A(new F(211,211,211,1))}static{this.transparent=new A(new F(0,0,0,0))}}t.$Gt=A,function(k){let m;(function(b){let v;(function(z){function u(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:k.Format.CSS.formatRGBA(o)}z.formatRGB=u;function f(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}z.formatRGBA=f;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(o)}z.formatHSL=e;function i(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}z.formatHSLA=i;function r(o){const C=o.toString(16);return C.length!==2?"0"+C:C}function h(o){return`#${r(o.rgba.r)}${r(o.rgba.g)}${r(o.rgba.b)}`}z.formatHex=h;function g(o,C=!1){return C&&o.rgba.a===1?k.Format.CSS.formatHex(o):`#${r(o.rgba.r)}${r(o.rgba.g)}${r(o.rgba.b)}${r(Math.round(o.rgba.a*255))}`}z.formatHexA=g;function w(o){return o.isOpaque()?k.Format.CSS.formatHex(o):k.Format.CSS.formatRGBA(o)}z.format=w;function a(o){const C=o.length;if(C===0||o.charCodeAt(0)!==35)return null;if(C===7){const N=16*d(o.charCodeAt(1))+d(o.charCodeAt(2)),O=16*d(o.charCodeAt(3))+d(o.charCodeAt(4)),P=16*d(o.charCodeAt(5))+d(o.charCodeAt(6));return new k(new F(N,O,P,1))}if(C===9){const N=16*d(o.charCodeAt(1))+d(o.charCodeAt(2)),O=16*d(o.charCodeAt(3))+d(o.charCodeAt(4)),P=16*d(o.charCodeAt(5))+d(o.charCodeAt(6)),L=16*d(o.charCodeAt(7))+d(o.charCodeAt(8));return new k(new F(N,O,P,L/255))}if(C===4){const N=d(o.charCodeAt(1)),O=d(o.charCodeAt(2)),P=d(o.charCodeAt(3));return new k(new F(16*N+N,16*O+O,16*P+P))}if(C===5){const N=d(o.charCodeAt(1)),O=d(o.charCodeAt(2)),P=d(o.charCodeAt(3)),L=d(o.charCodeAt(4));return new k(new F(16*N+N,16*O+O,16*P+P,(16*L+L)/255))}return null}z.parseHex=a;function d(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=b.CSS||(b.CSS={}))})(m=k.Format||(k.Format={}))}(A||(t.$Gt=A={}))}),define(ge[31],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mh=F,t.$Nh=B,t.$Oh=W;function n(A){return(k,m,b)=>{let v=null,z=null;if(typeof b.value=="function"?(v="value",z=b.value):typeof b.get=="function"&&(v="get",z=b.get),!z)throw new Error("not supported");b[v]=A(z,m)}}function F(A,k,m){let b=null,v=null;if(typeof m.value=="function"?(b="value",v=m.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(b="get",v=m.get),!v)throw new Error("not supported");const z=`$memoize$${k}`;m[b]=function(...u){return this.hasOwnProperty(z)||Object.defineProperty(this,z,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,u)}),this[z]}}function B(A,k,m){return n((b,v)=>{const z=`$debounce$${v}`,u=`$debounce$result$${v}`;return function(...f){this[u]||(this[u]=m?m():void 0),clearTimeout(this[z]),k&&(this[u]=k(this[u],...f),f=[this[u]]),this[z]=setTimeout(()=>{b.apply(this,f),this[u]=m?m():void 0},A)}})}function W(A,k,m){return n((b,v)=>{const z=`$throttle$timer$${v}`,u=`$throttle$result$${v}`,f=`$throttle$lastRun$${v}`,e=`$throttle$pending$${v}`;return function(...i){if(this[u]||(this[u]=m?m():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[u]=k(this[u],...i)),this[e])return;const r=this[f]+A;r<=Date.now()?(this[f]=Date.now(),b.apply(this,[this[u]]),this[u]=m?m():void 0):(this[e]=!0,this[z]=setTimeout(()=>{this[e]=!1,this[f]=Date.now(),b.apply(this,[this[u]]),this[u]=m?m():void 0},r-Date.now()))}})}}),define(ge[85],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ft=void 0;class n{constructor(B,W,A,k){this.originalStart=B,this.originalLength=W,this.modifiedStart=A,this.modifiedLength=k}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ft=n}),define(ge[6],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=F,t.$Z=B,t.$1=W,t.$2=A,t.$3=k,t.$4=b,t.$6=z,t.$7=u,t.$8=f,t.$0=i;class n{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?w.isErrorNoTelemetry(o)?new w(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(C=>{C(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$W=n,t.$X=new n;function F(d){t.$X.setUnexpectedErrorHandler(d)}function B(d){if(!d||typeof d!="object")return!1;const o=d;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}function W(d){b(d)||t.$X.onUnexpectedError(d)}function A(d){b(d)||t.$X.onUnexpectedExternalError(d)}function k(d){if(d instanceof Error){const{name:o,message:C}=d,N=d.stacktrace||d.stack;return{$isError:!0,name:o,message:C,stack:N,noTelemetry:w.isErrorNoTelemetry(d)}}return d}const m="Canceled";function b(d){return d instanceof v?!0:d instanceof Error&&d.name===m&&d.message===m}class v extends Error{constructor(){super(m),this.name=this.message}}t.$5=v;function z(){const d=new Error(m);return d.name=d.message,d}function u(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function f(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function i(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class r extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$$=r;class h extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$_=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=g;class w extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof w)return o;const C=new w;return C.message=o.message,C.stack=o.stack,C}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$bb=w;class a extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}t.$cb=a}),define(ge[12],be([1,0,6,82]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=B,t.$tb=W,t.$ub=A,t.$vb=k,t.$wb=m,t.$xb=b,t.$yb=v,t.$zb=z,t.$Ab=u,t.$Bb=f,t.$Cb=e,t.$Db=i,t.$Eb=r,t.top=h,t.$Gb=g,t.$Hb=a,t.$Ib=d,t.$Jb=o,t.$Kb=C,t.$Lb=N,t.$Mb=O,t.$Nb=P,t.$Ob=L,t.$Pb=$,t.$Qb=M,t.$Rb=V,t.$Sb=I,t.$Tb=j,t.$Ub=T,t.$Vb=K,t.$Wb=Z,t.$Xb=ce,t.$Yb=re,t.$Zb=te,t.$1b=$e,t.$2b=De,t.$3b=Te,t.$4b=Pe,t.$5b=he,t.$6b=_,t.$7b=J,t.$8b=G,t.$$b=ve;function B(x,c=0){return x[x.length-(1+c)]}function W(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function A(x,c,D=(l,p)=>l===p){if(x===c)return!0;if(!x||!c||x.length!==c.length)return!1;for(let l=0,p=x.length;l<p;l++)if(!D(x[l],c[l]))return!1;return!0}function k(x,c){const D=x.length-1;c<D&&(x[c]=x[D]),x.pop()}function m(x,c,D){return b(x.length,l=>D(x[l],c))}function b(x,c){let D=0,l=x-1;for(;D<=l;){const p=(D+l)/2|0,S=c(p);if(S<0)D=p+1;else if(S>0)l=p-1;else return p}return-(D+1)}function v(x,c,D){if(x=x|0,x>=c.length)throw new TypeError("invalid index");const l=c[Math.floor(c.length*Math.random())],p=[],S=[],s=[];for(const E of c){const y=D(E,l);y<0?p.push(E):y>0?S.push(E):s.push(E)}return x<p.length?v(x,p,D):x<p.length+s.length?s[0]:v(x-(p.length+s.length),S,D)}function z(x,c){const D=[];let l;for(const p of x.slice(0).sort(c))!l||c(l[0],p)!==0?(l=[p],D.push(l)):l.push(p);return D}function*u(x,c){let D,l;for(const p of x)l!==void 0&&c(l,p)?D.push(p):(D&&(yield D),D=[p]),l=p;D&&(yield D)}function f(x,c){for(let D=0;D<=x.length;D++)c(D===0?void 0:x[D-1],D===x.length?void 0:x[D])}function e(x,c){for(let D=0;D<x.length;D++)c(D===0?void 0:x[D-1],x[D],D+1===x.length?void 0:x[D+1])}function i(x,c,D){const l=[];function p(E,y,R){if(y===0&&R.length===0)return;const H=l[l.length-1];H&&H.start+H.deleteCount===E?(H.deleteCount+=y,H.toInsert.push(...R)):l.push({start:E,deleteCount:y,toInsert:R})}let S=0,s=0;for(;;){if(S===x.length){p(S,0,c.slice(s));break}if(s===c.length){p(S,x.length-S,[]);break}const E=x[S],y=c[s],R=D(E,y);R===0?(S+=1,s+=1):R<0?(p(S,1,[]),S+=1):R>0&&(p(S,0,[y]),s+=1)}return l}function r(x,c,D){const l=i(x,c,D),p=[],S=[];for(const s of l)p.push(...x.slice(s.start,s.start+s.deleteCount)),S.push(...s.toInsert);return{removed:p,added:S}}function h(x,c,D){if(D===0)return[];const l=x.slice(0,D).sort(c);return w(x,c,l,D,x.length),l}function g(x,c,D,l,p){return D===0?Promise.resolve([]):new Promise((S,s)=>{(async()=>{const E=x.length,y=x.slice(0,D).sort(c);for(let R=D,H=Math.min(D+l,E);R<E;R=H,H=Math.min(H+l,E)){if(R>D&&await new Promise(X=>setTimeout(X)),p&&p.isCancellationRequested)throw new n.$5;w(x,c,y,R,H)}return y})().then(S,s)})}function w(x,c,D,l,p){for(const S=D.length;l<p;l++){const s=x[l];if(c(s,D[S-1])<0){D.pop();const E=(0,F.$kb)(D,y=>c(s,y)<0);D.splice(E,0,s)}}}function a(x){return x.filter(c=>!!c)}function d(x){let c=0;for(let D=0;D<x.length;D++)x[D]&&(x[c]=x[D],c+=1);x.length=c}function o(x,c,D){x.splice(D,0,x.splice(c,1)[0])}function C(x){return!Array.isArray(x)||x.length===0}function N(x){return Array.isArray(x)&&x.length>0}function O(x,c=D=>D){const D=new Set;return x.filter(l=>{const p=c(l);return D.has(p)?!1:(D.add(p),!0)})}function P(x){const c=new Set;return D=>{const l=x(D);return c.has(l)?!1:(c.add(l),!0)}}function L(x,c){return x.length>0?x[0]:c}function $(x,c){return x.length>0?x[x.length-1]:c}function M(x,c,D=(l,p)=>l===p){let l=0;for(let p=0,S=Math.min(x.length,c.length);p<S&&D(x[p],c[p]);p++)l++;return l}function V(x){return[].concat(...x)}function I(x,c){let D=typeof c=="number"?x:0;typeof c=="number"?D=x:(D=0,c=x);const l=[];if(D<=c)for(let p=D;p<c;p++)l.push(p);else for(let p=D;p>c;p--)l.push(p);return l}function j(x,c,D){return x.reduce((l,p)=>(l[c(p)]=D?D(p):p,l),Object.create(null))}function T(x,c){return x.push(c),()=>K(x,c)}function K(x,c){const D=x.indexOf(c);if(D>-1)return x.splice(D,1),c}function Z(x,c,D){const l=x.slice(0,c),p=x.slice(c);return l.concat(D,p)}function ce(x,c){let D;if(typeof c=="number"){let l=c;D=()=>{const p=Math.sin(l++)*179426549;return p-Math.floor(p)}}else D=Math.random;for(let l=x.length-1;l>0;l-=1){const p=Math.floor(D()*(l+1)),S=x[l];x[l]=x[p],x[p]=S}}function re(x,c){const D=x.indexOf(c);D>-1&&(x.splice(D,1),x.unshift(c))}function te(x,c){const D=x.indexOf(c);D>-1&&(x.splice(D,1),x.push(c))}function $e(x,c){for(const D of c)x.push(D)}function De(x,c){return Array.isArray(x)?x.map(c):c(x)}function Te(x){return Array.isArray(x)?x:[x]}function Pe(x){return x[Math.floor(Math.random()*x.length)]}function he(x,c,D){const l=le(x,c),p=x.length,S=D.length;x.length=p+S;for(let s=p-1;s>=l;s--)x[s+S]=x[s];for(let s=0;s<S;s++)x[s+l]=D[s]}function _(x,c,D,l){const p=le(x,c);let S=x.splice(p,D);return S===void 0&&(S=[]),he(x,p,l),S}function le(x,c){return c<0?Math.max(c+x.length,0):Math.min(c,x.length)}var ae;(function(x){function c(S){return S<0}x.isLessThan=c;function D(S){return S<=0}x.isLessThanOrEqual=D;function l(S){return S>0}x.isGreaterThan=l;function p(S){return S===0}x.isNeitherLessOrGreaterThan=p,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(ae||(t.CompareResult=ae={}));function J(x,c){return(D,l)=>c(x(D),x(l))}function G(...x){return(c,D)=>{for(const l of x){const p=l(c,D);if(!ae.isNeitherLessOrGreaterThan(p))return p}return ae.neitherLessOrGreaterThan}}const se=(x,c)=>x-c;t.$9b=se;const fe=(x,c)=>(0,t.$9b)(x?1:0,c?1:0);t.$0b=fe;function ve(x){return(c,D)=>-x(c,D)}class Ne{constructor(c){this.g=c,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(c){let D=this.c;for(;D<this.g.length&&c(this.g[D]);)D++;const l=D===this.c?null:this.g.slice(this.c,D);return this.c=D,l}takeFromEndWhile(c){let D=this.d;for(;D>=0&&c(this.g[D]);)D--;const l=D===this.d?null:this.g.slice(D+1,this.d+1);return this.d=D,l}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const c=this.g[this.c];return this.c++,c}removeLast(){const c=this.g[this.d];return this.d--,c}takeCount(c){const D=this.g.slice(this.c,this.c+c);return this.c+=c,D}}t.$_b=Ne;class Ae{static{this.empty=new Ae(c=>{})}constructor(c){this.iterate=c}forEach(c){this.iterate(D=>(c(D),!0))}toArray(){const c=[];return this.iterate(D=>(c.push(D),!0)),c}filter(c){return new Ae(D=>this.iterate(l=>c(l)?D(l):!0))}map(c){return new Ae(D=>this.iterate(l=>D(c(l))))}some(c){let D=!1;return this.iterate(l=>(D=c(l),!D)),D}findFirst(c){let D;return this.iterate(l=>c(l)?(D=l,!1):!0),D}findLast(c){let D;return this.iterate(l=>(c(l)&&(D=l),!0)),D}findLastMaxBy(c){let D,l=!0;return this.iterate(p=>((l||ae.isGreaterThan(c(p,D)))&&(l=!1,D=p),!0)),D}}t.$ac=Ae;class Le{constructor(c){this.c=c}static createSortPermutation(c,D){const l=Array.from(c.keys()).sort((p,S)=>D(c[p],c[S]));return new Le(l)}apply(c){return c.map((D,l)=>c[this.c[l]])}inverse(){const c=this.c.slice();for(let D=0;D<this.c.length;D++)c[this.c[D]]=D;return new Le(c)}}t.$bc=Le}),define(ge[37],be([1,0,6]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=F,t.$0c=B,t.$$c=W,t.$_c=A,t.$ad=k,t.$bd=m;function F(b,v){if(!b)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}function B(b,v="Unreachable"){throw new Error(v)}function W(b){if(!b)throw new n.$cb("Assertion Failed")}function A(b){b||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function k(b){if(!b()){debugger;b(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function m(b,v){let z=0;for(;z<b.length-1;){const u=b[z],f=b[z+1];if(!v(u,f))return!1;z++}return!0}}),define(ge[53],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=n;function n(F,B){const W=this;let A=!1,k;return function(){if(A)return k;if(A=!0,B)try{k=F.apply(W,arguments)}finally{B()}else k=F.apply(W,arguments);return k}}}),define(ge[86],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RO=t.$QO=void 0;class n{constructor(B){this.a=B,this.b=0}nextId(){return this.a+ ++this.b}}t.$QO=n,t.$RO=new n("id#")}),define(ge[32],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var n;(function(F){function B(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}F.is=B;const W=Object.freeze([]);function A(){return W}F.empty=A;function*k(o){yield o}F.single=k;function m(o){return B(o)?o:k(o)}F.wrap=m;function b(o){return o||W}F.from=b;function*v(o){for(let C=o.length-1;C>=0;C--)yield o[C]}F.reverse=v;function z(o){return!o||o[Symbol.iterator]().next().done===!0}F.isEmpty=z;function u(o){return o[Symbol.iterator]().next().value}F.first=u;function f(o,C){for(const N of o)if(C(N))return!0;return!1}F.some=f;function e(o,C){for(const N of o)if(C(N))return N}F.find=e;function*i(o,C){for(const N of o)C(N)&&(yield N)}F.filter=i;function*r(o,C){let N=0;for(const O of o)yield C(O,N++)}F.map=r;function*h(...o){for(const C of o)yield*C}F.concat=h;function g(o,C,N){let O=N;for(const P of o)O=C(O,P);return O}F.reduce=g;function*w(o,C,N=o.length){for(C<0&&(C+=o.length),N<0?N+=o.length:N>o.length&&(N=o.length);C<N;C++)yield o[C]}F.slice=w;function a(o,C=Number.POSITIVE_INFINITY){const N=[];if(C===0)return[N,o];const O=o[Symbol.iterator]();for(let P=0;P<C;P++){const L=O.next();if(L.done)return[N,F.empty()];N.push(L.value)}return[N,{[Symbol.iterator](){return O}}]}F.consume=a;async function d(o){const C=[];for await(const N of o)C.push(N);return Promise.resolve(C)}F.asyncToArray=d})(n||(t.Iterable=n={}))}),define(ge[54],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$nr=t.$mr=t.$lr=t.$kr=t.$jr=t.ScanCode=t.KeyCode=void 0,t.$or=f;var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const W=new B,A=new B,k=new B;t.$jr=new Array(230),t.$kr={};const m=[],b=Object.create(null),v=Object.create(null);t.$lr={lowerCaseToEnum:e=>v[e]||0,toEnum:e=>b[e]||0,toString:e=>m[e]||"None"},t.$mr=[],t.$nr=[];for(let e=0;e<=193;e++)t.$mr[e]=-1;for(let e=0;e<=132;e++)t.$nr[e]=-1;(function(){const e="",i=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],r=[],h=[];for(const g of i){const[w,a,d,o,C,N,O,P,L]=g;if(h[a]||(h[a]=!0,m[a]=d,b[d]=a,v[d.toLowerCase()]=a,w&&(t.$mr[a]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$nr[o]=a))),!r[o]){if(r[o]=!0,!C)throw new Error(`String representation missing for key code ${o} around scan code ${d}`);W.define(o,C),A.define(o,P||C),k.define(o,L||P||C)}N&&(t.$jr[N]=o),O&&(t.$kr[O]=o)}t.$nr[3]=46})();var z;(function(e){function i(d){return W.keyCodeToStr(d)}e.toString=i;function r(d){return W.strToKeyCode(d)}e.fromString=r;function h(d){return A.keyCodeToStr(d)}e.toUserSettingsUS=h;function g(d){return k.keyCodeToStr(d)}e.toUserSettingsGeneral=g;function w(d){return A.strToKeyCode(d)||k.strToKeyCode(d)}e.fromUserSettings=w;function a(d){if(d>=98&&d<=113)return null;switch(d){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(d)}e.toElectronAccelerator=a})(z||(t.KeyCodeUtils=z={}));var u;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(u||(t.KeyMod=u={}));function f(e,i){const r=(i&65535)<<16>>>0;return(e|r)>>>0}}),define(ge[87],be([1,0,6]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vr=t.$ur=t.$tr=t.$sr=t.$rr=void 0,t.$pr=B,t.$qr=W;var F;(function(z){z[z.CtrlCmd=2048]="CtrlCmd",z[z.Shift=1024]="Shift",z[z.Alt=512]="Alt",z[z.WinCtrl=256]="WinCtrl",z[z.KeyCode=255]="KeyCode"})(F||(F={}));function B(z,u){if(typeof z=="number"){if(z===0)return null;const f=(z&65535)>>>0,e=(z&4294901760)>>>16;return e!==0?new m([W(f,u),W(e,u)]):new m([W(f,u)])}else{const f=[];for(let e=0;e<z.length;e++)f.push(W(z[e],u));return new m(f)}}function W(z,u){const f=!!(z&2048),e=!!(z&256),i=u===2?e:f,r=!!(z&1024),h=!!(z&512),g=u===2?f:e,w=z&255;return new A(i,r,h,g,w)}class A{constructor(u,f,e,i,r){this.ctrlKey=u,this.shiftKey=f,this.altKey=e,this.metaKey=i,this.keyCode=r}equals(u){return u instanceof A&&this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`K${u}${f}${e}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$rr=A;class k{constructor(u,f,e,i,r){this.ctrlKey=u,this.shiftKey=f,this.altKey=e,this.metaKey=i,this.scanCode=r}equals(u){return u instanceof k&&this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.scanCode===u.scanCode}getHashCode(){const u=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",e=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`S${u}${f}${e}${i}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$sr=k;class m{constructor(u){if(u.length===0)throw(0,n.$7)("chords");this.chords=u}getHashCode(){let u="";for(let f=0,e=this.chords.length;f<e;f++)f!==0&&(u+=";"),u+=this.chords[f].getHashCode();return u}equals(u){if(u===null||this.chords.length!==u.chords.length)return!1;for(let f=0;f<this.chords.length;f++)if(!this.chords[f].equals(u.chords[f]))return!1;return!0}}t.$tr=m;class b{constructor(u,f,e,i,r,h){this.ctrlKey=u,this.shiftKey=f,this.altKey=e,this.metaKey=i,this.keyLabel=r,this.keyAriaLabel=h}}t.$ur=b;class v{}t.$vr=v}),define(ge[23],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class n{constructor(B){this.d=B,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(B){this.c=B}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=n}),define(ge[14],be([1,0,23]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8S=k,t.$9S=m,t.$0S=b;let B=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const W=new n.$V(()=>B("mouse",!1)),A=new n.$V(()=>B("element",!1));function k(v){B=v}function m(v){return v==="element"?A.value:W.value}function b(){return B("element",!0)}}),define(ge[55],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(W){this.element=W,this.next=n.Undefined,this.prev=n.Undefined}}class F{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let W=this.a;for(;W!==n.Undefined;){const A=W.next;W.prev=n.Undefined,W.next=n.Undefined,W=A}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,A){const k=new n(W);if(this.a===n.Undefined)this.a=k,this.b=k;else if(A){const b=this.b;this.b=k,k.prev=b,b.next=k}else{const b=this.a;this.a=k,k.next=b,b.prev=k}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(k))}}shift(){if(this.a!==n.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==n.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==n.Undefined&&W.next!==n.Undefined){const A=W.prev;A.next=W.next,W.next.prev=A}else W.prev===n.Undefined&&W.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):W.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):W.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==n.Undefined;)yield W.element,W=W.next}}t.$5c=F}),define(ge[38],be([1,0]),function(ie,t){"use strict";var n,F,B;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=W,t.$zc=A,t.$Ac=k,t.$Ic=g;function W(w,a,d){let o=w.get(a);return o===void 0&&(o=d,w.set(a,o)),o}function A(w){const a=[];return w.forEach((d,o)=>{a.push(`${o} => ${d}`)}),`Map(${w.size}) {${a.join(", ")}}`}function k(w){const a=[];return w.forEach(d=>{a.push(d)}),`Set(${w.size}) {${a.join(", ")}}`}class m{constructor(a,d){this.uri=a,this.value=d}}function b(w){return Array.isArray(w)}class v{static{this.c=a=>a.toString()}constructor(a,d){if(this[n]="ResourceMap",a instanceof v)this.d=new Map(a.d),this.e=d??v.c;else if(b(a)){this.d=new Map,this.e=d??v.c;for(const[o,C]of a)this.set(o,C)}else this.d=new Map,this.e=a??v.c}set(a,d){return this.d.set(this.e(a),new m(a,d)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,d){typeof d<"u"&&(a=a.bind(d));for(const[o,C]of this.d)a(C.value,C.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}t.$Bc=v;class z{constructor(a,d){this[F]="ResourceSet",!a||typeof a=="function"?this.c=new v(a):(this.c=new v(d),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,d){this.c.forEach((o,C)=>a.call(d,C,C,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=z;var u;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(u||(t.Touch=u={}));class f{constructor(){this[B]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,d=0){const o=this.c.get(a);if(o)return d!==0&&this.l(o,d),o.value}set(a,d,o=0){let C=this.c.get(a);if(C)C.value=d,o!==0&&this.l(C,o);else{switch(C={key:a,value:d,next:void 0,previous:void 0},o){case 0:this.j(C);break;case 1:this.i(C);break;case 2:this.j(C);break;default:this.j(C);break}this.c.set(a,C),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const d=this.c.get(a);if(d)return this.c.delete(a),this.k(d),this.f--,d.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.k(a),this.f--,a.value}forEach(a,d){const o=this.g;let C=this.d;for(;C;){if(d?a.bind(d)(C.value,C.key,this):a(C.value,C.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");C=C.next}}keys(){const a=this,d=this.g;let o=this.d;const C={[Symbol.iterator](){return C},next(){if(a.g!==d)throw new Error("LinkedMap got modified during iteration.");if(o){const N={value:o.key,done:!1};return o=o.next,N}else return{value:void 0,done:!0}}};return C}values(){const a=this,d=this.g;let o=this.d;const C={[Symbol.iterator](){return C},next(){if(a.g!==d)throw new Error("LinkedMap got modified during iteration.");if(o){const N={value:o.value,done:!1};return o=o.next,N}else return{value:void 0,done:!0}}};return C}entries(){const a=this,d=this.g;let o=this.d;const C={[Symbol.iterator](){return C},next(){if(a.g!==d)throw new Error("LinkedMap got modified during iteration.");if(o){const N={value:[o.key,o.value],done:!1};return o=o.next,N}else return{value:void 0,done:!0}}};return C}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let d=this.d,o=this.size;for(;d&&o>a;)this.c.delete(d.key),d=d.next,o--;this.d=d,this.f=o,d&&(d.previous=void 0),this.g++}i(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}j(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}k(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const d=a.next,o=a.previous;if(!d||!o)throw new Error("Invalid list");d.previous=o,o.next=d}a.next=void 0,a.previous=void 0,this.g++}l(a,d){if(!this.d||!this.e)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(a===this.d)return;const o=a.next,C=a.previous;a===this.e?(C.next=void 0,this.e=C):(o.previous=C,C.next=o),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(d===2){if(a===this.e)return;const o=a.next,C=a.previous;a===this.d?(o.previous=void 0,this.d=o):(o.previous=C,C.next=o),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((d,o)=>{a.push([o,d])}),a}fromJSON(a){this.clear();for(const[d,o]of a)this.set(d,o)}}t.$Dc=f;class e extends f{constructor(a,d=1){super(),this.m=a,this.n=Math.min(Math.max(0,d),1)}get limit(){return this.m}set limit(a){this.m=a,this.o()}get ratio(){return this.n}set ratio(a){this.n=Math.min(Math.max(0,a),1),this.o()}get(a,d=2){return super.get(a,d)}peek(a){return super.get(a,0)}set(a,d){return super.set(a,d,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class i{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let d=this.c.get(a)||0;return d===0?!1:(d--,d===0?this.c.delete(a):this.c.set(a,d),!0)}has(a){return this.c.has(a)}}t.$Fc=i;class r{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[d,o]of a)this.set(d,o)}clear(){this.c.clear(),this.d.clear()}set(a,d){this.c.set(a,d),this.d.set(d,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const d=this.c.get(a);return d===void 0?!1:(this.c.delete(a),this.d.delete(d),!0)}forEach(a,d){this.c.forEach((o,C)=>{a.call(d,o,C,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=r;class h{constructor(){this.c=new Map}add(a,d){let o=this.c.get(a);o||(o=new Set,this.c.set(a,o)),o.add(d)}delete(a,d){const o=this.c.get(a);o&&(o.delete(d),o.size===0&&this.c.delete(a))}forEach(a,d){const o=this.c.get(a);o&&o.forEach(d)}get(a){const d=this.c.get(a);return d||new Set}}t.$Hc=h;function g(w,a){if(w===a)return!0;if(w.size!==a.size)return!1;for(const[d,o]of w)if(!a.has(d)||a.get(d)!==o)return!1;for(const[d]of a)if(!w.has(d))return!1;return!0}}),define(ge[2],be([1,0,12,83,38,53,32]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=v,t.$Lc=z,t.$Mc=u,t.$Nc=i,t.$Oc=r,t.$Pc=h,t.$Qc=g,t.$Rc=w,t.$Sc=a,t.$3c=V;const k=!1;let m=null;class b{constructor(){this.b=new Map}static{this.a=0}c(T){let K=this.b.get(T);return K||(K={parent:null,source:null,isSingleton:!1,value:T,idx:b.a++},this.b.set(T,K)),K}trackDisposable(T){const K=this.c(T);K.source||(K.source=new Error().stack)}setParent(T,K){const Z=this.c(T);Z.parent=K}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,K){const Z=K.get(T);if(Z)return Z;const ce=T.parent?this.f(this.c(T.parent),K):T;return K.set(T,ce),ce}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,T).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(T=10,K){let Z;if(K)Z=K;else{const De=new Map,Te=[...this.b.values()].filter(he=>he.source!==null&&!this.f(he,De).isSingleton);if(Te.length===0)return;const Pe=new Set(Te.map(he=>he.value));if(Z=Te.filter(he=>!(he.parent&&Pe.has(he.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function ce(De){function Te(he,_){for(;he.length>0&&_.some(le=>typeof le=="string"?le===he[0]:he[0].match(le));)he.shift()}const Pe=De.source.split(`
`).map(he=>he.trim().replace("at ","")).filter(he=>he!=="");return Te(Pe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Pe.reverse()}const re=new B.$Hc;for(const De of Z){const Te=ce(De);for(let Pe=0;Pe<=Te.length;Pe++)re.add(Te.slice(0,Pe).join(`
`),De)}Z.sort((0,n.$7b)(De=>De.idx,n.$9b));let te="",$e=0;for(const De of Z.slice(0,T)){$e++;const Te=ce(De),Pe=[];for(let he=0;he<Te.length;he++){let _=Te[he];_=`(shared with ${re.get(Te.slice(0,he+1).join(`
`)).size}/${Z.length} leaks) at ${_}`;const ae=re.get(Te.slice(0,he).join(`
`)),J=(0,F.$K)([...ae].map(G=>ce(G)[he]),G=>G);delete J[Te[he]];for(const[G,se]of Object.entries(J))Pe.unshift(`    - stacktraces of ${se.length} other leaks continue with ${G}`);Pe.unshift(_)}te+=`


==================== Leaking disposable ${$e}/${Z.length}: ${De.value.constructor.name} ====================
${Pe.join(`
`)}
============================================================

`}return Z.length>T&&(te+=`


... and ${Z.length-T} more leaking disposables

`),{leaks:Z,details:te}}}t.$Jc=b;function v(j){m=j}if(k){const j="__is_disposable_tracked__";v(new class{trackDisposable(T){const K=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[j]||console.log(K)},3e3)}setParent(T,K){if(T&&T!==o.None)try{T[j]=!0}catch{}}markAsDisposed(T){if(T&&T!==o.None)try{T[j]=!0}catch{}}markAsSingleton(T){}})}function z(j){return m?.trackDisposable(j),j}function u(j){m?.markAsDisposed(j)}function f(j,T){m?.setParent(j,T)}function e(j,T){if(m)for(const K of j)m.setParent(K,T)}function i(j){return m?.markAsSingleton(j),j}function r(j){return typeof j.dispose=="function"&&j.dispose.length===0}function h(j){if(A.Iterable.is(j)){const T=[];for(const K of j)if(K)try{K.dispose()}catch(Z){T.push(Z)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(j)?[]:j}else if(j)return j.dispose(),j}function g(j){for(const T of j)r(T)&&T.dispose();return[]}function w(...j){const T=a(()=>h(j));return e(j,T),T}function a(j){const T=z({dispose:(0,W.$db)(()=>{u(T),j()})});return T}class d{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,z(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return f(T,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),f(T,null))}}t.$Tc=d;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new d,z(this),f(this.q,this)}dispose(){u(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}t.$Uc=o;class C{constructor(){this.b=!1,z(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&f(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&f(T,null),T}}t.$Vc=C;class N{constructor(T){this.a=new C,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=N;class O{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=O;class P{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,z(this)}set(T){let K=T;return this.unset=()=>K=void 0,this.isset=()=>K!==void 0,this.dispose=()=>{K&&(K(),K=void 0,u(this))},this}}t.$Yc=P;class L{constructor(){this.a=new Map}acquire(T,...K){let Z=this.a.get(T);Z||(Z={counter:0,object:this.b(T,...K)},this.a.set(T,Z));const{object:ce}=Z,re=(0,W.$db)(()=>{--Z.counter===0&&(this.c(T,Z.object),this.a.delete(T))});return Z.counter++,{object:ce,dispose:re}}}t.$Zc=L;class ${constructor(T){this.a=T}async acquire(T,...K){const Z=this.a.acquire(T,...K);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(ce){throw Z.dispose(),ce}}}t.$1c=$;class M{constructor(T){this.object=T}dispose(){}}t.$2c=M;function V(j){const T=new d;try{j(T)}finally{T.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,z(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,K,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(T)?.dispose(),this.a.set(T,K)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=I}),function(ie,t){typeof define=="function"&&define.amd?define(ge[88],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(x,c){for(var D=0;D<c.length;D++){var l=c[D];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(x,l.key,l)}}function n(x,c,D){return c&&t(x.prototype,c),D&&t(x,D),Object.defineProperty(x,"prototype",{writable:!1}),x}function F(x,c){if(x){if(typeof x=="string")return B(x,c);var D=Object.prototype.toString.call(x).slice(8,-1);if(D==="Object"&&x.constructor&&(D=x.constructor.name),D==="Map"||D==="Set")return Array.from(x);if(D==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(D))return B(x,c)}}function B(x,c){(c==null||c>x.length)&&(c=x.length);for(var D=0,l=new Array(c);D<c;D++)l[D]=x[D];return l}function W(x,c){var D=typeof Symbol<"u"&&x[Symbol.iterator]||x["@@iterator"];if(D)return(D=D.call(x)).next.bind(D);if(Array.isArray(x)||(D=F(x))||c&&x&&typeof x.length=="number"){D&&(x=D);var l=0;return function(){return l>=x.length?{done:!0}:{done:!1,value:x[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=A();function k(x){ie.defaults=x}var m=/[&<>"']/,b=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,z=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(c){return u[c]};function e(x,c){if(c){if(m.test(x))return x.replace(b,f)}else if(v.test(x))return x.replace(z,f);return x}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(x){return x.replace(i,function(c,D){return D=D.toLowerCase(),D==="colon"?":":D.charAt(0)==="#"?D.charAt(1)==="x"?String.fromCharCode(parseInt(D.substring(2),16)):String.fromCharCode(+D.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(x,c){x=typeof x=="string"?x:x.source,c=c||"";var D={replace:function(p,S){return S=S.source||S,S=S.replace(h,"$1"),x=x.replace(p,S),D},getRegex:function(){return new RegExp(x,c)}};return D}var w=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(x,c,D){if(x){var l;try{l=decodeURIComponent(r(D)).replace(w,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}c&&!a.test(D)&&(D=P(c,D));try{D=encodeURI(D).replace(/%25/g,"%")}catch{return null}return D}var o={},C=/^[^:]+:\/*[^/]*$/,N=/^([^:]+:)[\s\S]*$/,O=/^([^:]+:\/*[^/]*)[\s\S]*$/;function P(x,c){o[" "+x]||(C.test(x)?o[" "+x]=x+"/":o[" "+x]=V(x,"/",!0)),x=o[" "+x];var D=x.indexOf(":")===-1;return c.substring(0,2)==="//"?D?c:x.replace(N,"$1")+c:c.charAt(0)==="/"?D?c:x.replace(O,"$1")+c:x+c}var L={exec:function(){}};function $(x){for(var c=1,D,l;c<arguments.length;c++){D=arguments[c];for(l in D)Object.prototype.hasOwnProperty.call(D,l)&&(x[l]=D[l])}return x}function M(x,c){var D=x.replace(/\|/g,function(S,s,E){for(var y=!1,R=s;--R>=0&&E[R]==="\\";)y=!y;return y?"|":" |"}),l=D.split(/ \|/),p=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>c)l.splice(c);else for(;l.length<c;)l.push("");for(;p<l.length;p++)l[p]=l[p].trim().replace(/\\\|/g,"|");return l}function V(x,c,D){var l=x.length;if(l===0)return"";for(var p=0;p<l;){var S=x.charAt(l-p-1);if(S===c&&!D)p++;else if(S!==c&&D)p++;else break}return x.slice(0,l-p)}function I(x,c){if(x.indexOf(c[1])===-1)return-1;for(var D=x.length,l=0,p=0;p<D;p++)if(x[p]==="\\")p++;else if(x[p]===c[0])l++;else if(x[p]===c[1]&&(l--,l<0))return p;return-1}function j(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(x,c){if(c<1)return"";for(var D="";c>1;)c&1&&(D+=x),c>>=1,x+=x;return D+x}function K(x,c,D,l){var p=c.href,S=c.title?e(c.title):null,s=x[1].replace(/\\([\[\]])/g,"$1");if(x[0].charAt(0)!=="!"){l.state.inLink=!0;var E={type:"link",raw:D,href:p,title:S,text:s,tokens:l.inlineTokens(s)};return l.state.inLink=!1,E}return{type:"image",raw:D,href:p,title:S,text:e(s)}}function Z(x,c){var D=x.match(/^(\s+)(?:```)/);if(D===null)return c;var l=D[1];return c.split(`
`).map(function(p){var S=p.match(/^\s+/);if(S===null)return p;var s=S[0];return s.length>=l.length?p.slice(l.length):p}).join(`
`)}var ce=function(){function x(D){this.options=D||ie.defaults}var c=x.prototype;return c.space=function(l){var p=this.rules.block.newline.exec(l);if(p&&p[0].length>0)return{type:"space",raw:p[0]}},c.code=function(l){var p=this.rules.block.code.exec(l);if(p){var S=p[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:p[0],codeBlockStyle:"indented",text:this.options.pedantic?S:V(S,`
`)}}},c.fences=function(l){var p=this.rules.block.fences.exec(l);if(p){var S=p[0],s=Z(S,p[3]||"");return{type:"code",raw:S,lang:p[2]?p[2].trim():p[2],text:s}}},c.heading=function(l){var p=this.rules.block.heading.exec(l);if(p){var S=p[2].trim();if(/#$/.test(S)){var s=V(S,"#");(this.options.pedantic||!s||/ $/.test(s))&&(S=s.trim())}return{type:"heading",raw:p[0],depth:p[1].length,text:S,tokens:this.lexer.inline(S)}}},c.hr=function(l){var p=this.rules.block.hr.exec(l);if(p)return{type:"hr",raw:p[0]}},c.blockquote=function(l){var p=this.rules.block.blockquote.exec(l);if(p){var S=p[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:p[0],tokens:this.lexer.blockTokens(S,[]),text:S}}},c.list=function(l){var p=this.rules.block.list.exec(l);if(p){var S,s,E,y,R,H,X,U,oe,we,me,Ie,ke=p[1].trim(),je=ke.length>1,Ee={type:"list",raw:"",ordered:je,start:je?+ke.slice(0,-1):"",loose:!1,items:[]};ke=je?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=je?ke:"[*+-]");for(var Se=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(Ie=!1,!(!(p=Se.exec(l))||this.rules.block.hr.test(l)));){if(S=p[0],l=l.substring(S.length),U=p[2].split(`
`,1)[0],oe=l.split(`
`,1)[0],this.options.pedantic?(y=2,me=U.trimLeft()):(y=p[2].search(/[^ ]/),y=y>4?1:y,me=U.slice(y),y+=p[1].length),H=!1,!U&&/^ *$/.test(oe)&&(S+=oe+`
`,l=l.substring(oe.length+1),Ie=!0),!Ie)for(var We=new RegExp("^ {0,"+Math.min(3,y-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,y-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,y-1)+"}(?:```|~~~)"),_e=new RegExp("^ {0,"+Math.min(3,y-1)+"}#");l&&(we=l.split(`
`,1)[0],U=we,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(U)||_e.test(U)||We.test(U)||Ue.test(l)));){if(U.search(/[^ ]/)>=y||!U.trim())me+=`
`+U.slice(y);else if(!H)me+=`
`+U;else break;!H&&!U.trim()&&(H=!0),S+=we+`
`,l=l.substring(we.length+1)}Ee.loose||(X?Ee.loose=!0:/\n *\n *$/.test(S)&&(X=!0)),this.options.gfm&&(s=/^\[[ xX]\] /.exec(me),s&&(E=s[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),Ee.items.push({type:"list_item",raw:S,task:!!s,checked:E,loose:!1,text:me}),Ee.raw+=S}Ee.items[Ee.items.length-1].raw=S.trimRight(),Ee.items[Ee.items.length-1].text=me.trimRight(),Ee.raw=Ee.raw.trimRight();var Y=Ee.items.length;for(R=0;R<Y;R++){this.lexer.state.top=!1,Ee.items[R].tokens=this.lexer.blockTokens(Ee.items[R].text,[]);var ne=Ee.items[R].tokens.filter(function(ye){return ye.type==="space"}),pe=ne.every(function(ye){for(var Re=ye.raw.split(""),xe=0,Ve=W(Re),et;!(et=Ve()).done;){var it=et.value;if(it===`
`&&(xe+=1),xe>1)return!0}return!1});!Ee.loose&&ne.length&&pe&&(Ee.loose=!0,Ee.items[R].loose=!0)}return Ee}},c.html=function(l){var p=this.rules.block.html.exec(l);if(p){var S={type:"html",raw:p[0],pre:!this.options.sanitizer&&(p[1]==="pre"||p[1]==="script"||p[1]==="style"),text:p[0]};if(this.options.sanitize){var s=this.options.sanitizer?this.options.sanitizer(p[0]):e(p[0]);S.type="paragraph",S.text=s,S.tokens=this.lexer.inline(s)}return S}},c.def=function(l){var p=this.rules.block.def.exec(l);if(p){p[3]&&(p[3]=p[3].substring(1,p[3].length-1));var S=p[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:S,raw:p[0],href:p[2],title:p[3]}}},c.table=function(l){var p=this.rules.block.table.exec(l);if(p){var S={type:"table",header:M(p[1]).map(function(X){return{text:X}}),align:p[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:p[3]&&p[3].trim()?p[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(S.header.length===S.align.length){S.raw=p[0];var s=S.align.length,E,y,R,H;for(E=0;E<s;E++)/^ *-+: *$/.test(S.align[E])?S.align[E]="right":/^ *:-+: *$/.test(S.align[E])?S.align[E]="center":/^ *:-+ *$/.test(S.align[E])?S.align[E]="left":S.align[E]=null;for(s=S.rows.length,E=0;E<s;E++)S.rows[E]=M(S.rows[E],S.header.length).map(function(X){return{text:X}});for(s=S.header.length,y=0;y<s;y++)S.header[y].tokens=this.lexer.inline(S.header[y].text);for(s=S.rows.length,y=0;y<s;y++)for(H=S.rows[y],R=0;R<H.length;R++)H[R].tokens=this.lexer.inline(H[R].text);return S}}},c.lheading=function(l){var p=this.rules.block.lheading.exec(l);if(p)return{type:"heading",raw:p[0],depth:p[2].charAt(0)==="="?1:2,text:p[1],tokens:this.lexer.inline(p[1])}},c.paragraph=function(l){var p=this.rules.block.paragraph.exec(l);if(p){var S=p[1].charAt(p[1].length-1)===`
`?p[1].slice(0,-1):p[1];return{type:"paragraph",raw:p[0],text:S,tokens:this.lexer.inline(S)}}},c.text=function(l){var p=this.rules.block.text.exec(l);if(p)return{type:"text",raw:p[0],text:p[0],tokens:this.lexer.inline(p[0])}},c.escape=function(l){var p=this.rules.inline.escape.exec(l);if(p)return{type:"escape",raw:p[0],text:e(p[1])}},c.tag=function(l){var p=this.rules.inline.tag.exec(l);if(p)return!this.lexer.state.inLink&&/^<a /i.test(p[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(p[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(p[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(p[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:p[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(p[0]):e(p[0]):p[0]}},c.link=function(l){var p=this.rules.inline.link.exec(l);if(p){var S=p[2].trim();if(!this.options.pedantic&&/^</.test(S)){if(!/>$/.test(S))return;var s=V(S.slice(0,-1),"\\");if((S.length-s.length)%2===0)return}else{var E=I(p[2],"()");if(E>-1){var y=p[0].indexOf("!")===0?5:4,R=y+p[1].length+E;p[2]=p[2].substring(0,E),p[0]=p[0].substring(0,R).trim(),p[3]=""}}var H=p[2],X="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(H);U&&(H=U[1],X=U[3])}else X=p[3]?p[3].slice(1,-1):"";return H=H.trim(),/^</.test(H)&&(this.options.pedantic&&!/>$/.test(S)?H=H.slice(1):H=H.slice(1,-1)),K(p,{href:H&&H.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},p[0],this.lexer)}},c.reflink=function(l,p){var S;if((S=this.rules.inline.reflink.exec(l))||(S=this.rules.inline.nolink.exec(l))){var s=(S[2]||S[1]).replace(/\s+/g," ");if(s=p[s.toLowerCase()],!s||!s.href){var E=S[0].charAt(0);return{type:"text",raw:E,text:E}}return K(S,s,S[0],this.lexer)}},c.emStrong=function(l,p,S){S===void 0&&(S="");var s=this.rules.inline.emStrong.lDelim.exec(l);if(s&&!(s[3]&&S.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var E=s[1]||s[2]||"";if(!E||E&&(S===""||this.rules.inline.punctuation.exec(S))){var y=s[0].length-1,R,H,X=y,U=0,oe=s[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,p=p.slice(-1*l.length+y);(s=oe.exec(p))!=null;)if(R=s[1]||s[2]||s[3]||s[4]||s[5]||s[6],!!R){if(H=R.length,s[3]||s[4]){X+=H;continue}else if((s[5]||s[6])&&y%3&&!((y+H)%3)){U+=H;continue}if(X-=H,!(X>0)){if(H=Math.min(H,H+X+U),Math.min(y,H)%2){var we=l.slice(1,y+s.index+H);return{type:"em",raw:l.slice(0,y+s.index+H+1),text:we,tokens:this.lexer.inlineTokens(we)}}var me=l.slice(2,y+s.index+H-1);return{type:"strong",raw:l.slice(0,y+s.index+H+1),text:me,tokens:this.lexer.inlineTokens(me)}}}}}},c.codespan=function(l){var p=this.rules.inline.code.exec(l);if(p){var S=p[2].replace(/\n/g," "),s=/[^ ]/.test(S),E=/^ /.test(S)&&/ $/.test(S);return s&&E&&(S=S.substring(1,S.length-1)),S=e(S,!0),{type:"codespan",raw:p[0],text:S}}},c.br=function(l){var p=this.rules.inline.br.exec(l);if(p)return{type:"br",raw:p[0]}},c.del=function(l){var p=this.rules.inline.del.exec(l);if(p)return{type:"del",raw:p[0],text:p[2],tokens:this.lexer.inlineTokens(p[2])}},c.autolink=function(l,p){var S=this.rules.inline.autolink.exec(l);if(S){var s,E;return S[2]==="@"?(s=e(this.options.mangle?p(S[1]):S[1]),E="mailto:"+s):(s=e(S[1]),E=s),{type:"link",raw:S[0],text:s,href:E,tokens:[{type:"text",raw:s,text:s}]}}},c.url=function(l,p){var S;if(S=this.rules.inline.url.exec(l)){var s,E;if(S[2]==="@")s=e(this.options.mangle?p(S[0]):S[0]),E="mailto:"+s;else{var y;do y=S[0],S[0]=this.rules.inline._backpedal.exec(S[0])[0];while(y!==S[0]);s=e(S[0]),S[1]==="www."?E="http://"+s:E=s}return{type:"link",raw:S[0],text:s,href:E,tokens:[{type:"text",raw:s,text:s}]}}},c.inlineText=function(l,p){var S=this.rules.inline.text.exec(l);if(S){var s;return this.lexer.state.inRawBlock?s=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(S[0]):e(S[0]):S[0]:s=e(this.options.smartypants?p(S[0]):S[0]),{type:"text",raw:S[0],text:s}}},x}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:L,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=g(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=g(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=g(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=g(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=g(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=g(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=$({},re),re.gfm=$({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=g(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=g(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=$({},re.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:L,paragraph:g(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:L,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:L,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=g(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=g(re._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=g(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=g(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=g(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=g(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=g(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=g(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=g(te.reflink).replace("label",te._label).replace("ref",re._label).getRegex(),te.nolink=g(te.nolink).replace("ref",re._label).getRegex(),te.reflinkSearch=g(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=$({},te),te.pedantic=$({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=$({},te.normal,{escape:g(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=g(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=$({},te.gfm,{br:g(te.br).replace("{2,}","*").getRegex(),text:g(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $e(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function De(x){var c="",D,l,p=x.length;for(D=0;D<p;D++)l=x.charCodeAt(D),Math.random()>.5&&(l="x"+l.toString(16)),c+="&#"+l+";";return c}var Te=function(){function x(D){this.tokens=[],this.tokens.links=Object.create(null),this.options=D||ie.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:re.normal,inline:te.normal};this.options.pedantic?(l.block=re.pedantic,l.inline=te.pedantic):this.options.gfm&&(l.block=re.gfm,this.options.breaks?l.inline=te.breaks:l.inline=te.gfm),this.tokenizer.rules=l}x.lex=function(l,p){var S=new x(p);return S.lex(l)},x.lexInline=function(l,p){var S=new x(p);return S.inlineTokens(l)};var c=x.prototype;return c.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var p;p=this.inlineQueue.shift();)this.inlineTokens(p.src,p.tokens);return this.tokens},c.blockTokens=function(l,p){var S=this;p===void 0&&(p=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(X,U,oe){return U+"    ".repeat(oe.length)});for(var s,E,y,R;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(s=X.call({lexer:S},l,p))?(l=l.substring(s.raw.length),p.push(s),!0):!1}))){if(s=this.tokenizer.space(l)){l=l.substring(s.raw.length),s.raw.length===1&&p.length>0?p[p.length-1].raw+=`
`:p.push(s);continue}if(s=this.tokenizer.code(l)){l=l.substring(s.raw.length),E=p[p.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue[this.inlineQueue.length-1].src=E.text):p.push(s);continue}if(s=this.tokenizer.fences(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.heading(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.hr(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.blockquote(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.list(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.html(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.def(l)){l=l.substring(s.raw.length),E=p[p.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+s.raw,E.text+=`
`+s.raw,this.inlineQueue[this.inlineQueue.length-1].src=E.text):this.tokens.links[s.tag]||(this.tokens.links[s.tag]={href:s.href,title:s.title});continue}if(s=this.tokenizer.table(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.lheading(l)){l=l.substring(s.raw.length),p.push(s);continue}if(y=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,U=l.slice(1),oe=void 0;S.options.extensions.startBlock.forEach(function(we){oe=we.call({lexer:this},U),typeof oe=="number"&&oe>=0&&(X=Math.min(X,oe))}),X<1/0&&X>=0&&(y=l.substring(0,X+1))}(),this.state.top&&(s=this.tokenizer.paragraph(y))){E=p[p.length-1],R&&E.type==="paragraph"?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):p.push(s),R=y.length!==l.length,l=l.substring(s.raw.length);continue}if(s=this.tokenizer.text(l)){l=l.substring(s.raw.length),E=p[p.length-1],E&&E.type==="text"?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):p.push(s);continue}if(l){var H="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return this.state.top=!0,p},c.inline=function(l,p){return p===void 0&&(p=[]),this.inlineQueue.push({src:l,tokens:p}),p},c.inlineTokens=function(l,p){var S=this;p===void 0&&(p=[]);var s,E,y,R=l,H,X,U;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(H=this.tokenizer.rules.inline.reflinkSearch.exec(R))!=null;)oe.includes(H[0].slice(H[0].lastIndexOf("[")+1,-1))&&(R=R.slice(0,H.index)+"["+T("a",H[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(H=this.tokenizer.rules.inline.blockSkip.exec(R))!=null;)R=R.slice(0,H.index)+"["+T("a",H[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(H=this.tokenizer.rules.inline.escapedEmSt.exec(R))!=null;)R=R.slice(0,H.index)+"++"+R.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(X||(U=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(me){return(s=me.call({lexer:S},l,p))?(l=l.substring(s.raw.length),p.push(s),!0):!1}))){if(s=this.tokenizer.escape(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.tag(l)){l=l.substring(s.raw.length),E=p[p.length-1],E&&s.type==="text"&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):p.push(s);continue}if(s=this.tokenizer.link(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(s.raw.length),E=p[p.length-1],E&&s.type==="text"&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):p.push(s);continue}if(s=this.tokenizer.emStrong(l,R,U)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.codespan(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.br(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.del(l)){l=l.substring(s.raw.length),p.push(s);continue}if(s=this.tokenizer.autolink(l,De)){l=l.substring(s.raw.length),p.push(s);continue}if(!this.state.inLink&&(s=this.tokenizer.url(l,De))){l=l.substring(s.raw.length),p.push(s);continue}if(y=l,this.options.extensions&&this.options.extensions.startInline&&function(){var me=1/0,Ie=l.slice(1),ke=void 0;S.options.extensions.startInline.forEach(function(je){ke=je.call({lexer:this},Ie),typeof ke=="number"&&ke>=0&&(me=Math.min(me,ke))}),me<1/0&&me>=0&&(y=l.substring(0,me+1))}(),s=this.tokenizer.inlineText(y,$e)){l=l.substring(s.raw.length),s.raw.slice(-1)!=="_"&&(U=s.raw.slice(-1)),X=!0,E=p[p.length-1],E&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):p.push(s);continue}if(l){var we="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return p},n(x,null,[{key:"rules",get:function(){return{block:re,inline:te}}}]),x}(),Pe=function(){function x(D){this.options=D||ie.defaults}var c=x.prototype;return c.code=function(l,p,S){var s=(p||"").match(/\S*/)[0];if(this.options.highlight){var E=this.options.highlight(l,s);E!=null&&E!==l&&(S=!0,l=E)}return l=l.replace(/\n$/,"")+`
`,s?'<pre><code class="'+this.options.langPrefix+e(s,!0)+'">'+(S?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(S?l:e(l,!0))+`</code></pre>
`},c.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},c.html=function(l){return l},c.heading=function(l,p,S,s){if(this.options.headerIds){var E=this.options.headerPrefix+s.slug(S);return"<h"+p+' id="'+E+'">'+l+"</h"+p+`>
`}return"<h"+p+">"+l+"</h"+p+`>
`},c.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},c.list=function(l,p,S){var s=p?"ol":"ul",E=p&&S!==1?' start="'+S+'"':"";return"<"+s+E+`>
`+l+"</"+s+`>
`},c.listitem=function(l){return"<li>"+l+`</li>
`},c.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},c.paragraph=function(l){return"<p>"+l+`</p>
`},c.table=function(l,p){return p&&(p="<tbody>"+p+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+p+`</table>
`},c.tablerow=function(l){return`<tr>
`+l+`</tr>
`},c.tablecell=function(l,p){var S=p.header?"th":"td",s=p.align?"<"+S+' align="'+p.align+'">':"<"+S+">";return s+l+("</"+S+`>
`)},c.strong=function(l){return"<strong>"+l+"</strong>"},c.em=function(l){return"<em>"+l+"</em>"},c.codespan=function(l){return"<code>"+l+"</code>"},c.br=function(){return this.options.xhtml?"<br/>":"<br>"},c.del=function(l){return"<del>"+l+"</del>"},c.link=function(l,p,S){if(l=d(this.options.sanitize,this.options.baseUrl,l),l===null)return S;var s='<a href="'+e(l)+'"';return p&&(s+=' title="'+p+'"'),s+=">"+S+"</a>",s},c.image=function(l,p,S){if(l=d(this.options.sanitize,this.options.baseUrl,l),l===null)return S;var s='<img src="'+l+'" alt="'+S+'"';return p&&(s+=' title="'+p+'"'),s+=this.options.xhtml?"/>":">",s},c.text=function(l){return l},x}(),he=function(){function x(){}var c=x.prototype;return c.strong=function(l){return l},c.em=function(l){return l},c.codespan=function(l){return l},c.del=function(l){return l},c.html=function(l){return l},c.text=function(l){return l},c.link=function(l,p,S){return""+S},c.image=function(l,p,S){return""+S},c.br=function(){return""},x}(),_=function(){function x(){this.seen={}}var c=x.prototype;return c.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},c.getNextSafeSlug=function(l,p){var S=l,s=0;if(this.seen.hasOwnProperty(S)){s=this.seen[l];do s++,S=l+"-"+s;while(this.seen.hasOwnProperty(S))}return p||(this.seen[l]=s,this.seen[S]=0),S},c.slug=function(l,p){p===void 0&&(p={});var S=this.serialize(l);return this.getNextSafeSlug(S,p.dryrun)},x}(),le=function(){function x(D){this.options=D||ie.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new he,this.slugger=new _}x.parse=function(l,p){var S=new x(p);return S.parse(l)},x.parseInline=function(l,p){var S=new x(p);return S.parseInline(l)};var c=x.prototype;return c.parse=function(l,p){p===void 0&&(p=!0);var S="",s,E,y,R,H,X,U,oe,we,me,Ie,ke,je,Ee,Se,We,Ue,Ye,_e,Y=l.length;for(s=0;s<Y;s++){if(me=l[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(_e=this.options.extensions.renderers[me.type].call({parser:this},me),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(me.type))){S+=_e||"";continue}switch(me.type){case"space":continue;case"hr":{S+=this.renderer.hr();continue}case"heading":{S+=this.renderer.heading(this.parseInline(me.tokens),me.depth,r(this.parseInline(me.tokens,this.textRenderer)),this.slugger);continue}case"code":{S+=this.renderer.code(me.text,me.lang,me.escaped);continue}case"table":{for(oe="",U="",R=me.header.length,E=0;E<R;E++)U+=this.renderer.tablecell(this.parseInline(me.header[E].tokens),{header:!0,align:me.align[E]});for(oe+=this.renderer.tablerow(U),we="",R=me.rows.length,E=0;E<R;E++){for(X=me.rows[E],U="",H=X.length,y=0;y<H;y++)U+=this.renderer.tablecell(this.parseInline(X[y].tokens),{header:!1,align:me.align[y]});we+=this.renderer.tablerow(U)}S+=this.renderer.table(oe,we);continue}case"blockquote":{we=this.parse(me.tokens),S+=this.renderer.blockquote(we);continue}case"list":{for(Ie=me.ordered,ke=me.start,je=me.loose,R=me.items.length,we="",E=0;E<R;E++)Se=me.items[E],We=Se.checked,Ue=Se.task,Ee="",Se.task&&(Ye=this.renderer.checkbox(We),je?Se.tokens.length>0&&Se.tokens[0].type==="paragraph"?(Se.tokens[0].text=Ye+" "+Se.tokens[0].text,Se.tokens[0].tokens&&Se.tokens[0].tokens.length>0&&Se.tokens[0].tokens[0].type==="text"&&(Se.tokens[0].tokens[0].text=Ye+" "+Se.tokens[0].tokens[0].text)):Se.tokens.unshift({type:"text",text:Ye}):Ee+=Ye),Ee+=this.parse(Se.tokens,je),we+=this.renderer.listitem(Ee,Ue,We);S+=this.renderer.list(we,Ie,ke);continue}case"html":{S+=this.renderer.html(me.text);continue}case"paragraph":{S+=this.renderer.paragraph(this.parseInline(me.tokens));continue}case"text":{for(we=me.tokens?this.parseInline(me.tokens):me.text;s+1<Y&&l[s+1].type==="text";)me=l[++s],we+=`
`+(me.tokens?this.parseInline(me.tokens):me.text);S+=p?this.renderer.paragraph(we):we;continue}default:{var ne='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return S},c.parseInline=function(l,p){p=p||this.renderer;var S="",s,E,y,R=l.length;for(s=0;s<R;s++){if(E=l[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[E.type]&&(y=this.options.extensions.renderers[E.type].call({parser:this},E),y!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(E.type))){S+=y||"";continue}switch(E.type){case"escape":{S+=p.text(E.text);break}case"html":{S+=p.html(E.text);break}case"link":{S+=p.link(E.href,E.title,this.parseInline(E.tokens,p));break}case"image":{S+=p.image(E.href,E.title,E.text);break}case"strong":{S+=p.strong(this.parseInline(E.tokens,p));break}case"em":{S+=p.em(this.parseInline(E.tokens,p));break}case"codespan":{S+=p.codespan(E.text);break}case"br":{S+=p.br();break}case"del":{S+=p.del(this.parseInline(E.tokens,p));break}case"text":{S+=p.text(E.text);break}default:{var H='Token with "'+E.type+'" type was not found.';if(this.options.silent){console.error(H);return}else throw new Error(H)}}}return S},x}();function ae(x,c,D){if(typeof x>"u"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof c=="function"&&(D=c,c=null),c=$({},ae.defaults,c||{}),j(c),D){var l=c.highlight,p;try{p=Te.lex(x,c)}catch(R){return D(R)}var S=function(H){var X;if(!H)try{c.walkTokens&&ae.walkTokens(p,c.walkTokens),X=le.parse(p,c)}catch(U){H=U}return c.highlight=l,H?D(H):D(null,X)};if(!l||l.length<3||(delete c.highlight,!p.length))return S();var s=0;ae.walkTokens(p,function(R){R.type==="code"&&(s++,setTimeout(function(){l(R.text,R.lang,function(H,X){if(H)return S(H);X!=null&&X!==R.text&&(R.text=X,R.escaped=!0),s--,s===0&&S()})},0))}),s===0&&S();return}function E(R){if(R.message+=`
Please report this to https://github.com/markedjs/marked.`,c.silent)return"<p>An error occurred:</p><pre>"+e(R.message+"",!0)+"</pre>";throw R}try{var y=Te.lex(x,c);if(c.walkTokens){if(c.async)return Promise.all(ae.walkTokens(y,c.walkTokens)).then(function(){return le.parse(y,c)}).catch(E);ae.walkTokens(y,c.walkTokens)}return le.parse(y,c)}catch(R){E(R)}}ae.options=ae.setOptions=function(x){return $(ae.defaults,x),k(ae.defaults),ae},ae.getDefaults=A,ae.defaults=ie.defaults,ae.use=function(){for(var x=arguments.length,c=new Array(x),D=0;D<x;D++)c[D]=arguments[D];var l=$.apply(void 0,[{}].concat(c)),p=ae.defaults.extensions||{renderers:{},childTokens:{}},S;c.forEach(function(s){if(s.extensions&&(S=!0,s.extensions.forEach(function(y){if(!y.name)throw new Error("extension name required");if(y.renderer){var R=p.renderers?p.renderers[y.name]:null;R?p.renderers[y.name]=function(){for(var H=arguments.length,X=new Array(H),U=0;U<H;U++)X[U]=arguments[U];var oe=y.renderer.apply(this,X);return oe===!1&&(oe=R.apply(this,X)),oe}:p.renderers[y.name]=y.renderer}if(y.tokenizer){if(!y.level||y.level!=="block"&&y.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");p[y.level]?p[y.level].unshift(y.tokenizer):p[y.level]=[y.tokenizer],y.start&&(y.level==="block"?p.startBlock?p.startBlock.push(y.start):p.startBlock=[y.start]:y.level==="inline"&&(p.startInline?p.startInline.push(y.start):p.startInline=[y.start]))}y.childTokens&&(p.childTokens[y.name]=y.childTokens)})),s.renderer&&function(){var y=ae.defaults.renderer||new Pe,R=function(U){var oe=y[U];y[U]=function(){for(var we=arguments.length,me=new Array(we),Ie=0;Ie<we;Ie++)me[Ie]=arguments[Ie];var ke=s.renderer[U].apply(y,me);return ke===!1&&(ke=oe.apply(y,me)),ke}};for(var H in s.renderer)R(H);l.renderer=y}(),s.tokenizer&&function(){var y=ae.defaults.tokenizer||new ce,R=function(U){var oe=y[U];y[U]=function(){for(var we=arguments.length,me=new Array(we),Ie=0;Ie<we;Ie++)me[Ie]=arguments[Ie];var ke=s.tokenizer[U].apply(y,me);return ke===!1&&(ke=oe.apply(y,me)),ke}};for(var H in s.tokenizer)R(H);l.tokenizer=y}(),s.walkTokens){var E=ae.defaults.walkTokens;l.walkTokens=function(y){var R=[];return R.push(s.walkTokens.call(this,y)),E&&(R=R.concat(E.call(this,y))),R}}S&&(l.extensions=p),ae.setOptions(l)})},ae.walkTokens=function(x,c){for(var D=[],l=function(){var E=S.value;switch(D=D.concat(c.call(ae,E)),E.type){case"table":{for(var y=W(E.header),R;!(R=y()).done;){var H=R.value;D=D.concat(ae.walkTokens(H.tokens,c))}for(var X=W(E.rows),U;!(U=X()).done;)for(var oe=U.value,we=W(oe),me;!(me=we()).done;){var Ie=me.value;D=D.concat(ae.walkTokens(Ie.tokens,c))}break}case"list":{D=D.concat(ae.walkTokens(E.items,c));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[E.type]?ae.defaults.extensions.childTokens[E.type].forEach(function(ke){D=D.concat(ae.walkTokens(E[ke],c))}):E.tokens&&(D=D.concat(ae.walkTokens(E.tokens,c)))}},p=W(x),S;!(S=p()).done;)l();return D},ae.parseInline=function(x,c){if(typeof x>"u"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");c=$({},ae.defaults,c||{}),j(c);try{var D=Te.lexInline(x,c);return c.walkTokens&&ae.walkTokens(D,c.walkTokens),le.parseInline(D,c)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,c.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},ae.Parser=le,ae.parser=le.parse,ae.Renderer=Pe,ae.TextRenderer=he,ae.Lexer=Te,ae.lexer=Te.lex,ae.Tokenizer=ce,ae.Slugger=_,ae.parse=ae;var J=ae.options,G=ae.setOptions,se=ae.use,fe=ae.walkTokens,ve=ae.parseInline,Ne=ae,Ae=le.parse,Le=Te.lex;ie.Lexer=Te,ie.Parser=le,ie.Renderer=Pe,ie.Slugger=_,ie.TextRenderer=he,ie.Tokenizer=ce,ie.getDefaults=A,ie.lexer=Le,ie.marked=ae,ie.options=J,ie.parse=Ne,ie.parseInline=ve,ie.parser=Ae,ie.setOptions=G,ie.use=se,ie.walkTokens=fe,Object.defineProperty(ie,"__esModule",{value:!0})}),define(ge[89],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hk=n;function n(i){const r=W(i);if(r&&r.length>0)return new Uint32Array(r)}let F=0;const B=new Uint32Array(10);function W(i){if(F=0,A(i,z,4352),F>0||(A(i,u,4449),F>0)||(A(i,f,4520),F>0)||(A(i,e,12593),F))return B.subarray(0,F);if(i>=44032&&i<=55203){const r=i-44032,h=r%588,g=Math.floor(r/588),w=Math.floor(h/28),a=h%28-1;if(g<z.length?A(g,z,0):4352+g-12593<e.length&&A(4352+g,e,12593),w<u.length?A(w,u,0):4449+w-12593<e.length&&A(4449+w-12593,e,12593),a>=0&&(a<f.length?A(a,f,0):4520+a-12593<e.length&&A(4520+a-12593,e,12593)),F>0)return B.subarray(0,F)}}function A(i,r,h){i>=h&&i<h+r.length&&k(r[i-h])}function k(i){i!==0&&(B[F++]=i&255,i>>8&&(B[F++]=i>>8&255),i>>16&&(B[F++]=i>>16&255))}var m;(function(i){i[i.InitialConsonant=4352]="InitialConsonant",i[i.Vowel=4449]="Vowel",i[i.FinalConsonant=4520]="FinalConsonant",i[i.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var b;(function(i){i[i.NUL=0]="NUL",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z"})(b||(b={}));var v;(function(i){i[i.fa=24934]="fa",i[i.fg=26470]="fg",i[i.fq=29030]="fq",i[i.fr=29286]="fr",i[i.ft=29798]="ft",i[i.fv=30310]="fv",i[i.fx=30822]="fx",i[i.hk=27496]="hk",i[i.hl=27752]="hl",i[i.ho=28520]="ho",i[i.ml=27757]="ml",i[i.nj=27246]="nj",i[i.nl=27758]="nl",i[i.np=28782]="np",i[i.qt=29809]="qt",i[i.rt=29810]="rt",i[i.sg=26483]="sg",i[i.sw=30579]="sw"})(v||(v={}));const z=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),f=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ge[90],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GU=void 0;class n{constructor(B,W=0,A=B.length,k=W-1){this.a=B,this.b=W,this.c=A,this.d=k}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$GU=n}),define(ge[91],be([1,0,90]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IU=t.$HU=void 0;class F{constructor(A=[],k=10){this.h(A),this.b=k,this.d()}getHistory(){return this.j}add(A){this.a.delete(A),this.a.add(A),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(A){return this.a.has(A)}clear(){this.h([]),this.d()}d(){this.f();const A=this.j;this.c=new n.$GU(A,0,A.length,A.length)}f(){const A=this.j;A.length>this.b&&this.h(A.slice(A.length-this.b))}g(){const A=this.c.current();return A?this.j.indexOf(A):-1}h(A){this.a=new Set;for(const k of A)this.a.add(k)}get j(){const A=[];return this.a.forEach(k=>A.push(k)),A}}t.$HU=F;class B{get size(){return this.f}constructor(A,k=10){if(this.g=k,A.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:A[0],previous:void 0,next:void 0},this.a=new Set([A[0]]);for(let m=1;m<A.length;m++)this.add(A[m])}add(A){const k={value:A,previous:this.c,next:void 0};for(this.c.next=k,this.c=k,this.d=this.c,this.f++,this.a.has(A)?this.h(A):this.a.add(A);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(A){if(this.c.value===A)return A;const k=this.c.value;return this.a.delete(k),this.c.value=A,this.a.has(A)?this.h(A):this.a.add(A),k}prepend(A){if(this.f===this.g||this.a.has(A))return;const k={value:A,previous:void 0,next:this.b};this.b.previous=k,this.b=k,this.f++,this.a.add(A)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(A){return this.a.has(A)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let A=this.b;for(;A;)yield A.value,A=A.next}h(A){let k=this.b;for(;k!==this.c;)k.value===A&&(k===this.b?(this.b=this.b.next,this.b.previous=void 0):(k.previous.next=k.next,k.next.previous=k.previous),this.f--),k=k.next}}t.$IU=B}),define(ge[39],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rm=t.$qm=t.$pm=void 0,t.$nm=n,t.rot=F;function n(k,m,b){return Math.min(Math.max(k,m),b)}function F(k,m){return(m+k%m)%m}class B{constructor(){this.a=0}getNext(){return this.a++}}t.$pm=B;class W{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$qm=W;class A{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const b=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$rm=A}),define(ge[26],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0,t.$7c=W,t.$8c=u;class n{constructor(e,i,r){this.owner=e,this.debugNameSource=i,this.referenceFn=r}getDebugName(e){return W(e,this)}}t.$6c=n;const F=new Map,B=new WeakMap;function W(f,e){const i=B.get(f);if(i)return i;const r=A(f,e);if(r){let h=F.get(r)??0;h++,F.set(r,h);const g=h===1?r:`${r}#${h}`;return B.set(f,g),g}}function A(f,e){const i=B.get(f);if(i)return i;const r=e.owner?v(e.owner)+".":"";let h;const g=e.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(h=g(),h!==void 0)return r+h}else return r+g;const w=e.referenceFn;if(w!==void 0&&(h=u(w),h!==void 0))return r+h;if(e.owner!==void 0){const a=k(e.owner,f);if(a!==void 0)return r+a}}function k(f,e){for(const i in f)if(f[i]===e)return i}const m=new Map,b=new WeakMap;function v(f){const e=b.get(f);if(e)return e;const i=z(f);let r=m.get(i)??0;r++,m.set(i,r);const h=r===1?i:`${i}#${r}`;return b.set(f,h),h}function z(f){const e=f.constructor;return e?e.name:"Object"}function u(f){const e=f.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(ge[27],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ad=void 0,t.$yd=F,t.$zd=B;let n;function F(i){n=i}function B(){return n}class W{constructor(){this.a=0,this.d=new WeakMap}b(r){return A([k(f("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[k(" "),b(v(r.oldValue,70),{color:"red",strikeThrough:!0}),k(" "),b(v(r.newValue,60),{color:"green"})]:[k(" (unchanged)")]:[k(" "),b(v(r.newValue,60),{color:"green"}),k(" (initial)")]}handleObservableChanged(r,h){console.log(...this.b([m("observable value changed"),b(r.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(r){if(r.size!==0)return b(" (changed deps: "+[...r].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(g,w)=>(this.d.get(r).add(g),h.apply(r,[g,w]))}handleDerivedRecomputed(r,h){const g=this.d.get(r);console.log(...this.b([m("derived recomputed"),b(r.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(g),{data:[{fn:r._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(r,h){console.log(...this.b([m("observable from event triggered"),b(r.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(g,w)=>(this.d.get(r).add(g),h.apply(r,[g,w]))}handleAutorunTriggered(r){const h=this.d.get(r);console.log(...this.b([m("autorun"),b(r.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:r._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let h=r.getDebugName();h===void 0&&(h=""),console.log(...this.b([m("transaction"),b(h,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Ad=W;function A(i){const r=new Array,h=[];let g="";function w(d){if("length"in d)for(const o of d)o&&w(o);else"text"in d?(g+=`%c${d.text}`,r.push(d.style),d.data&&h.push(...d.data)):"data"in d&&h.push(...d.data)}w(i);const a=[g,...r];return a.push(...h),a}function k(i){return b(i,{color:"black"})}function m(i){return b(e(`${i}: `,10),{color:"black",bold:!0})}function b(i,r={color:"black"}){function h(w){return Object.entries(w).reduce((a,[d,o])=>`${a}${d}:${o};`,"")}const g={color:r.color};return r.strikeThrough&&(g["text-decoration"]="line-through"),r.bold&&(g["font-weight"]="bold"),{text:i,style:h(g)}}function v(i,r){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=r?`"${i}"`:`"${i.substr(0,r-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?z(i,r):u(i,r);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function z(i,r){let h="[ ",g=!0;for(const w of i){if(g||(h+=", "),h.length-5>r){h+="...";break}g=!1,h+=`${v(w,r-h.length)}`}return h+=" ]",h}function u(i,r){let h="{ ",g=!0;for(const[w,a]of Object.entries(i)){if(g||(h+=", "),h.length-5>r){h+="...";break}g=!1,h+=`${w}: ${v(a,r-h.length)}`}return h+=" }",h}function f(i,r){let h="";for(let g=1;g<=r;g++)h+=i;return h}function e(i,r){for(;i.length<r;)i+=" ";return i}}),define(ge[40],be([1,0,37,2,26,27]),function(ie,t,n,F,B,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$id=void 0,t.$cd=A,t.$dd=k,t.$ed=m,t.$fd=b,t.$gd=v,t.$hd=z;function A(e){return new f(new B.$6c(void 0,void 0,e),e,void 0,void 0)}function k(e,i){return new f(new B.$6c(e.owner,e.debugName,e.debugReferenceFn??i),i,void 0,void 0)}function m(e,i){return new f(new B.$6c(e.owner,e.debugName,e.debugReferenceFn??i),i,e.createEmptyChangeSummary,e.handleChange)}function b(e,i){const r=new F.$Tc,h=m({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(g,w)=>{r.clear(),i(g,w,r)});return(0,F.$Sc)(()=>{h.dispose(),r.dispose()})}function v(e){const i=new F.$Tc,r=k({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{i.clear(),e(h,i)});return(0,F.$Sc)(()=>{r.dispose(),i.dispose()})}function z(e,i){let r;return k({debugReferenceFn:i},h=>{const g=e.read(h),w=r;r=g,i({lastValue:w,newValue:g})})}var u;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(u||(u={}));class f{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(i,r,h,g){this.h=i,this._runFn=r,this.i=h,this.j=g,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,W.$zd)()?.handleAutorunCreated(this),this.k(),(0,F.$Lc)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,F.$Mc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;const r=this.c;try{if(!r){(0,W.$zd)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.i?.(),this._runFn(this,h)}}finally{r||(0,W.$zd)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,n.$ad)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,r){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:r,didChange:g=>g===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const r=i.get();return this.e.add(i),this.f.delete(i),r}}t.$id=f,function(e){e.Observer=f}(A||(t.$cd=A={}))}),define(ge[33],be([1,0,26,27]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=t.$Td=t.$Rd=t.$Md=t.$Ld=void 0,t.$Id=W,t.$Jd=k,t.$Kd=b,t.$Nd=u,t.$Od=e,t.$Pd=i,t.$Qd=r,t.$Sd=g,t.$Ud=a;let B;function W(o){B=o}let A;function k(o){A=o}let m;function b(o){m=o}class v{get TChange(){return null}reportChanges(){this.get()}read(C){return C?C.readObservable(this):this.get()}map(C,N){const O=N===void 0?void 0:C,P=N===void 0?C:N;return m({owner:O,debugName:()=>{const L=(0,n.$8c)(P);if(L!==void 0)return L;const M=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(P.toString());if(M)return`${this.debugName}.${M[2]}`;if(!O)return`${this.debugName} (mapped)`}},L=>P(this.read(L),L))}recomputeInitiallyAndOnChange(C,N){return C.add(B(this,N)),this}keepObserved(C){return C.add(A(this)),this}}t.$Ld=v;class z extends v{constructor(){super(...arguments),this.c=new Set}addObserver(C){const N=this.c.size;this.c.add(C),N===0&&this.f()}removeObserver(C){this.c.delete(C)&&this.c.size===0&&this.g()}f(){}g(){}}t.$Md=z;function u(o,C){const N=new h(o,C);try{o(N)}finally{N.finish()}}let f;function e(o){if(f)o(f);else{const C=new h(o,void 0);f=C;try{o(C)}finally{C.finish(),f=void 0}}}async function i(o,C){const N=new h(o,C);try{await o(N)}finally{N.finish()}}function r(o,C,N){o?C(o):u(C,N)}class h{constructor(C,N){this._fn=C,this.b=N,this.a=[],(0,F.$zd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,n.$8c)(this._fn)}updateObserver(C,N){this.a.push({observer:C,observable:N}),C.beginUpdate(N)}finish(){const C=this.a;for(let N=0;N<C.length;N++){const{observer:O,observable:P}=C[N];O.endUpdate(P)}this.a=null,(0,F.$zd)()?.handleEndTransaction()}}t.$Rd=h;function g(o,C){return typeof o=="string"?new w(void 0,o,C):new w(o,void 0,C)}class w extends z{get debugName(){return new n.$6c(this.b,this.d,void 0).getDebugName(this)??"ObservableValue"}constructor(C,N,O){super(),this.b=C,this.d=N,this.a=O}get(){return this.a}set(C,N,O){if(this.a===C)return;let P;N||(N=P=new h(()=>{},()=>`Setting ${this.debugName}`));try{const L=this.a;this.e(C),(0,F.$zd)()?.handleObservableChanged(this,{oldValue:L,newValue:C,change:O,didChange:!0,hadValue:!0});for(const $ of this.c)N.updateObserver($,this),$.handleChange(this,O)}finally{P&&P.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(C){this.a=C}}t.$Td=w;function a(o,C){return typeof o=="string"?new d(void 0,o,C):new d(o,void 0,C)}class d extends w{e(C){this.a!==C&&(this.a&&this.a.dispose(),this.a=C)}dispose(){this.a?.dispose()}}t.$Vd=d}),define(ge[41],be([1,0,37,2,33,26,27]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hd=t.$Bd=void 0,t.$Cd=m,t.$Dd=b,t.$Ed=v,t.$Fd=z,t.$Gd=u;const k=(i,r)=>i===r;t.$Bd=k;function m(i,r){return r!==void 0?new e(new W.$6c(i,void 0,r),r,void 0,void 0,void 0,t.$Bd):new e(new W.$6c(void 0,void 0,i),i,void 0,void 0,void 0,t.$Bd)}function b(i,r){return new e(new W.$6c(i.owner,i.debugName,i.debugReferenceFn),r,void 0,void 0,i.onLastObserverRemoved,i.equalityComparer??t.$Bd)}(0,B.$Kd)(b);function v(i,r){return new e(new W.$6c(i.owner,i.debugName,void 0),r,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??t.$Bd)}function z(i,r){let h,g;r===void 0?(h=i,g=void 0):(g=i,h=r);const w=new F.$Tc;return new e(new W.$6c(g,void 0,h),a=>(w.clear(),h(a,w)),void 0,void 0,()=>w.dispose(),t.$Bd)}function u(i,r){let h,g;r===void 0?(h=i,g=void 0):(g=i,h=r);const w=new F.$Tc;return new e(new W.$6c(g,void 0,h),a=>{w.clear();const d=h(a);return d&&w.add(d),d},void 0,void 0,()=>w.dispose(),t.$Bd)}var f;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(f||(f={}));class e extends B.$Md{get debugName(){return this.n.getDebugName(this)??"(anonymous)"}constructor(r,h,g,w,a=void 0,d){super(),this.n=r,this._computeFn=h,this.p=g,this.q=w,this.s=a,this.t=d,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.p?.(),(0,A.$zd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const r of this.k)r.removeObserver(this);this.k.clear(),this.s?.()}get(){if(this.c.size===0){const r=this._computeFn(this,this.p?.());return this.g(),r}else{do{if(this.e===1){for(const r of this.k)if(r.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const r=this.l;this.l=this.k,this.k=r;const h=this.e!==0,g=this.h;this.e=3;const w=this.m;this.m=this.p?.();try{this.h=this._computeFn(this,w)}finally{for(const d of this.l)d.removeObserver(this);this.l.clear()}const a=h&&!this.t(g,this.h);if((0,A.$zd)()?.handleDerivedRecomputed(this,{oldValue:g,newValue:this.h,change:void 0,didChange:a,hadValue:h}),a)for(const d of this.c)d.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(r){this.j++;const h=this.j===1;if(this.e===3&&(this.e=1,!h))for(const g of this.c)g.handlePossibleChange(this);if(h)for(const g of this.c)g.beginUpdate(this)}endUpdate(r){if(this.j--,this.j===0){const h=[...this.c];for(const g of h)g.endUpdate(this)}(0,n.$ad)(()=>this.j>=0)}handlePossibleChange(r){if(this.e===3&&this.k.has(r)&&!this.l.has(r)){this.e=1;for(const h of this.c)h.handlePossibleChange(this)}}handleChange(r,h){if(this.k.has(r)&&!this.l.has(r)){const g=this.q?this.q({changedObservable:r,change:h,didChange:a=>a===r},this.m):!0,w=this.e===3;if(g&&(this.e===1||w)&&(this.e=2,w))for(const a of this.c)a.handlePossibleChange(this)}}readObservable(r){r.addObserver(this);const h=r.get();return this.k.add(r),this.l.delete(r),h}addObserver(r){const h=!this.c.has(r)&&this.j>0;super.addObserver(r),h&&r.beginUpdate(this)}removeObserver(r){const h=this.c.has(r)&&this.j>0;super.removeObserver(r),h&&r.endUpdate(this)}}t.$Hd=e}),define(ge[92],be([1,0,2,40,33,26,41,27]),function(ie,t,n,F,B,W,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ud=t.$md=void 0,t.$jd=m,t.$kd=v,t.$ld=z,t.$nd=f,t.$od=i,t.$pd=h,t.$qd=g,t.$rd=w,t.$sd=a,t.$td=d,t.$vd=C,t.$wd=N,t.$xd=O;function m(L){return new b(L)}class b extends B.$Ld{constructor($){super(),this.a=$}get debugName(){return this.toString()}get(){return this.a}addObserver($){}removeObserver($){}toString(){return`Const: ${this.a}`}}function v(L){const $=(0,B.$Sd)("promiseValue",{});return L.then(M=>{$.set({value:M},void 0)}),$}function z(L,$){return new u(L,$)}class u extends B.$Md{constructor($,M){super(),this.h=$,this._getValue=M,this.b=!1,this.l=V=>{const I=this._getValue(V),j=this.a,T=!this.b||j!==I;let K=!1;T&&(this.a=I,this.b&&(K=!0,(0,B.$Qd)(u.globalTransaction,Z=>{(0,k.$zd)()?.handleFromEventObservableTriggered(this,{oldValue:j,newValue:I,change:void 0,didChange:T,hadValue:this.b});for(const ce of this.c)Z.updateObserver(ce,this),ce.handleChange(this,void 0)},()=>{const Z=this.j();return"Event fired"+(Z?`: ${Z}`:"")})),this.b=!0),K||(0,k.$zd)()?.handleFromEventObservableTriggered(this,{oldValue:j,newValue:I,change:void 0,didChange:T,hadValue:this.b})}}j(){return(0,W.$8c)(this._getValue)}get debugName(){const $=this.j();return"From Event"+($?`: ${$}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}t.$md=u,function(L){L.Observer=u;function $(M,V){let I=!1;u.globalTransaction===void 0&&(u.globalTransaction=M,I=!0);try{V()}finally{I&&(u.globalTransaction=void 0)}}L.batchEventsGlobally=$}(z||(t.$ld=z={}));function f(L,$){return new e(L,$)}class e extends B.$Md{constructor($,M){super(),this.debugName=$,this.b=M,this.h=()=>{(0,B.$Nd)(V=>{for(const I of this.c)V.updateObserver(I,this),I.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(L){return typeof L=="string"?new r(L):new r(void 0,L)}class r extends B.$Md{get debugName(){return new W.$6c(this.b,this.a,void 0).getDebugName(this)??"Observable Signal"}constructor($,M){super(),this.a=$,this.b=M}trigger($,M){if(!$){(0,B.$Nd)(V=>{this.trigger(V,M)},()=>`Trigger signal ${this.debugName}`);return}for(const V of this.c)$.updateObserver(V,this),V.handleChange(this,M)}get(){}}function h(L,$,M){const V=(0,B.$Sd)("debounced",void 0);let I;return M.add((0,F.$cd)(j=>{const T=L.read(j);I&&clearTimeout(I),I=setTimeout(()=>{(0,B.$Nd)(K=>{V.set(T,K)})},$)})),V}function g(L,$){let M=!1,V,I;return z(j=>{const T=(0,F.$cd)(K=>{const Z=L.read(K);M?(I&&clearTimeout(I),I=setTimeout(()=>{V=Z,j()},$)):(M=!0,V=Z)});return{dispose(){T.dispose(),M=!1,V=void 0}}},()=>M?V:L.get())}function w(L,$,M){const V=(0,B.$Sd)("triggeredRecently",!1);let I;return M.add(L(()=>{V.set(!0,void 0),I&&clearTimeout(I),I=setTimeout(()=>{V.set(!1,void 0)},$)})),V}function a(L){const $=new o(!1,void 0);return L.addObserver($),(0,n.$Sc)(()=>{L.removeObserver($)})}(0,B.$Jd)(a);function d(L,$){const M=new o(!0,$);return L.addObserver(M),$?$(L.get()):L.reportChanges(),(0,n.$Sc)(()=>{L.removeObserver(M)})}(0,B.$Id)(d);class o{constructor($,M){this.b=$,this.c=M,this.a=0}beginUpdate($){this.a++}endUpdate($){this.a--,this.a===0&&this.b&&(this.c?this.c($.get()):$.reportChanges())}handlePossibleChange($){}handleChange($,M){}}t.$ud=o;function C(L){let $;return(0,A.$Cd)(V=>($=L(V,$),$))}function N(L,$){let M;const V=(0,B.$Sd)("derivedObservableWithWritableCache.counter",0),I=(0,A.$Cd)(L,j=>(V.read(j),M=$(j,M),M));return Object.assign(I,{clearCache:j=>{M=void 0,V.set(V.get()+1,j)}})}function O(L,$,M,V){let I=new P(M,V);return(0,A.$Dd)({debugReferenceFn:M,owner:L,onLastObserverRemoved:()=>{I.dispose(),I=new P(M)}},T=>(I.setItems($.read(T)),I.getItems()))}class P{constructor($,M){this.c=$,this.e=M,this.a=new Map,this.b=[]}dispose(){this.a.forEach($=>$.store.dispose()),this.a.clear()}setItems($){const M=[],V=new Set(this.a.keys());for(const I of $){const j=this.e?this.e(I):I;let T=this.a.get(j);if(T)V.delete(j);else{const K=new n.$Tc;T={out:this.c(I,K),store:K},this.a.set(j,T)}M.push(T.out)}for(const I of V)this.a.get(I).store.dispose(),this.a.delete(I);this.b=M}getItems(){return this.b}}}),define(ge[56],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var n;(function(F){function B(m,b){if(m.start>=b.end||b.start>=m.end)return{start:0,end:0};const v=Math.max(m.start,b.start),z=Math.min(m.end,b.end);return z-v<=0?{start:0,end:0}:{start:v,end:z}}F.intersect=B;function W(m){return m.end-m.start<=0}F.isEmpty=W;function A(m,b){return!W(B(m,b))}F.intersects=A;function k(m,b){const v=[],z={start:m.start,end:Math.min(b.start,m.end)},u={start:Math.max(b.end,m.start),end:m.end};return W(z)||v.push(z),W(u)||v.push(u),v}F.relativeComplement=k})(n||(t.Range=n={}))}),define(ge[93],be([1,0,56]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0,t.$lT=F,t.$mT=B,t.$nT=W;function F(m,b){const v=[];for(const z of b){if(m.start>=z.range.end)continue;if(m.end<z.range.start)break;const u=n.Range.intersect(m,z.range);n.Range.isEmpty(u)||v.push({range:u,size:z.size})}return v}function B({start:m,end:b},v){return{start:m+v,end:b+v}}function W(m){const b=[];let v=null;for(const z of m){const u=z.range.start,f=z.range.end,e=z.size;if(v&&e===v.size){v.range.end=f;continue}v={range:{start:u,end:f},size:e},b.push(v)}return b}function A(...m){return W(m.reduce((b,v)=>b.concat(v),[]))}class k{get paddingTop(){return this.c}set paddingTop(b){this.b=this.b+b-this.c,this.c=b}constructor(b){this.a=[],this.b=0,this.c=0,this.c=b??0,this.b=this.c}splice(b,v,z=[]){const u=z.length-v,f=F({start:0,end:b},this.a),e=F({start:b+v,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:B(r.range,u),size:r.size})),i=z.map((r,h)=>({range:{start:b+h,end:b+h+1},size:r.size}));this.a=A(f,i,e),this.b=this.c+this.a.reduce((r,h)=>r+h.size*(h.range.end-h.range.start),0)}get count(){const b=this.a.length;return b?this.a[b-1].range.end:0}get size(){return this.b}indexAt(b){if(b<0)return-1;if(b<this.c)return 0;let v=0,z=this.c;for(const u of this.a){const f=u.range.end-u.range.start,e=z+f*u.size;if(b<e)return v+Math.floor((b-z)/u.size);v+=f,z=e}return v}indexAfter(b){return Math.min(this.indexAt(b)+1,this.count)}positionAt(b){if(b<0)return-1;let v=0,z=0;for(const u of this.a){const f=u.range.end-u.range.start,e=z+f;if(b<e)return this.c+v+(b-z)*u.size;v+=f*u.size,z=e}return-1}}t.$oT=k}),define(ge[94],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(W){return new F(W)}constructor(W){this.c=n&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$3d=F}),define(ge[4],be([1,0,6,53,2,55,94]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$5d=t.Event=void 0,t.$6d=f;const k=!1,m=!1,b=!1;var v;(function(j){j.None=()=>B.$Uc.None;function T(S){if(b){const{onDidAddListener:s}=S,E=i.create();let y=0;S.onDidAddListener=()=>{++y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),E.print()),s?.()}}}function K(S,s){return _(S,()=>{},0,void 0,!0,void 0,s)}j.defer=K;function Z(S){return(s,E=null,y)=>{let R=!1,H;return H=S(X=>{if(!R)return H?H.dispose():R=!0,s.call(E,X)},null,y),R&&H.dispose(),H}}j.once=Z;function ce(S,s,E){return Pe((y,R=null,H)=>S(X=>y.call(R,s(X)),null,H),E)}j.map=ce;function re(S,s,E){return Pe((y,R=null,H)=>S(X=>{s(X),y.call(R,X)},null,H),E)}j.forEach=re;function te(S,s,E){return Pe((y,R=null,H)=>S(X=>s(X)&&y.call(R,X),null,H),E)}j.filter=te;function $e(S){return S}j.signal=$e;function De(...S){return(s,E=null,y)=>{const R=(0,B.$Rc)(...S.map(H=>H(X=>s.call(E,X))));return he(R,y)}}j.any=De;function Te(S,s,E,y){let R=E;return ce(S,H=>(R=s(R,H),R),y)}j.reduce=Te;function Pe(S,s){let E;const y={onWillAddFirstListener(){E=S(R.fire,R)},onDidRemoveLastListener(){E?.dispose()}};s||T(y);const R=new d(y);return s?.add(R),R.event}function he(S,s){return s instanceof Array?s.push(S):s&&s.add(S),S}function _(S,s,E=100,y=!1,R=!1,H,X){let U,oe,we,me=0,Ie;const ke={leakWarningThreshold:H,onWillAddFirstListener(){U=S(Ee=>{me++,oe=s(oe,Ee),y&&!we&&(je.fire(oe),oe=void 0),Ie=()=>{const Se=oe;oe=void 0,we=void 0,(!y||me>1)&&je.fire(Se),me=0},typeof E=="number"?(clearTimeout(we),we=setTimeout(Ie,E)):we===void 0&&(we=0,queueMicrotask(Ie))})},onWillRemoveListener(){R&&me>0&&Ie?.()},onDidRemoveLastListener(){Ie=void 0,U.dispose()}};X||T(ke);const je=new d(ke);return X?.add(je),je.event}j.debounce=_;function le(S,s=0,E){return j.debounce(S,(y,R)=>y?(y.push(R),y):[R],s,void 0,!0,void 0,E)}j.accumulate=le;function ae(S,s=(y,R)=>y===R,E){let y=!0,R;return te(S,H=>{const X=y||!s(H,R);return y=!1,R=H,X},E)}j.latch=ae;function J(S,s,E){return[j.filter(S,s,E),j.filter(S,y=>!s(y),E)]}j.split=J;function G(S,s=!1,E=[],y){let R=E.slice(),H=S(oe=>{R?R.push(oe):U.fire(oe)});y&&y.add(H);const X=()=>{R?.forEach(oe=>U.fire(oe)),R=null},U=new d({onWillAddFirstListener(){H||(H=S(oe=>U.fire(oe)),y&&y.add(H))},onDidAddFirstListener(){R&&(s?setTimeout(X):X())},onDidRemoveLastListener(){H&&H.dispose(),H=null}});return y&&y.add(U),U.event}j.buffer=G;function se(S,s){return(y,R,H)=>{const X=s(new ve);return S(function(U){const oe=X.evaluate(U);oe!==fe&&y.call(R,oe)},void 0,H)}}j.chain=se;const fe=Symbol("HaltChainable");class ve{constructor(){this.f=[]}map(s){return this.f.push(s),this}forEach(s){return this.f.push(E=>(s(E),E)),this}filter(s){return this.f.push(E=>s(E)?E:fe),this}reduce(s,E){let y=E;return this.f.push(R=>(y=s(y,R),y)),this}latch(s=(E,y)=>E===y){let E=!0,y;return this.f.push(R=>{const H=E||!s(R,y);return E=!1,y=R,H?R:fe}),this}evaluate(s){for(const E of this.f)if(s=E(s),s===fe)break;return s}}function Ne(S,s,E=y=>y){const y=(...U)=>X.fire(E(...U)),R=()=>S.on(s,y),H=()=>S.removeListener(s,y),X=new d({onWillAddFirstListener:R,onDidRemoveLastListener:H});return X.event}j.fromNodeEventEmitter=Ne;function Ae(S,s,E=y=>y){const y=(...U)=>X.fire(E(...U)),R=()=>S.addEventListener(s,y),H=()=>S.removeEventListener(s,y),X=new d({onWillAddFirstListener:R,onDidRemoveLastListener:H});return X.event}j.fromDOMEventEmitter=Ae;function Le(S){return new Promise(s=>Z(S)(s))}j.toPromise=Le;function x(S){const s=new d;return S.then(E=>{s.fire(E)},()=>{s.fire(void 0)}).finally(()=>{s.dispose()}),s.event}j.fromPromise=x;function c(S,s,E){return s(E),S(y=>s(y))}j.runAndSubscribe=c;class D{constructor(s,E){this._observable=s,this.f=0,this.g=!1;const y={onWillAddFirstListener:()=>{s.addObserver(this)},onDidRemoveLastListener:()=>{s.removeObserver(this)}};E||T(y),this.emitter=new d(y),E&&E.add(this.emitter)}beginUpdate(s){this.f++}handlePossibleChange(s){}handleChange(s,E){this.g=!0}endUpdate(s){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function l(S,s){return new D(S,s).emitter.event}j.fromObservable=l;function p(S){return(s,E,y)=>{let R=0,H=!1;const X={beginUpdate(){R++},endUpdate(){R--,R===0&&(S.reportChanges(),H&&(H=!1,s.call(E)))},handlePossibleChange(){},handleChange(){H=!0}};S.addObserver(X),S.reportChanges();const U={dispose(){S.removeObserver(X)}};return y instanceof B.$Tc?y.add(U):Array.isArray(y)&&y.push(U),U}}j.fromObservableLight=p})(v||(t.Event=v={}));class z{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${z.f++}`,z.all.add(this)}start(T){this.g=new A.$3d,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}t.$5d=z;let u=-1;function f(j){const T=u;return u=j,{dispose(){u=T}}}class e{constructor(T,K=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=K,this.g=0}dispose(){this.f?.clear()}check(T,K){const Z=this.threshold;if(Z<=0||K<Z)return;this.f||(this.f=new Map);const ce=this.f.get(T.value)||0;if(this.f.set(T.value,ce+1),this.g-=1,this.g<=0){this.g=Z*.5;let re,te=0;for(const[$e,De]of this.f)(!re||te<De)&&(re=$e,te=De);console.warn(`[${this.name}] potential listener LEAK detected, having ${K} listeners already. MOST frequent listener (${te}):`),console.warn(re)}return()=>{const re=this.f.get(T.value)||0;this.f.set(T.value,re-1)}}}class i{static create(){return new i(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let r=0;class h{constructor(T){this.value=T,this.id=r++}}const g=2,w=(j,T)=>{if(j instanceof h)T(j);else for(let K=0;K<j.length;K++){const Z=j[K];Z&&T(Z)}},a=k?new FinalizationRegistry(j=>{typeof j=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(j))}):void 0;class d{constructor(T){this.w=0,this.f=T,this.g=u>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new z(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const T=this.t;queueMicrotask(()=>{w(T,K=>K.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,K,Z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),B.$Uc.None;if(this.m)return B.$Uc.None;K&&(T=T.bind(K));const ce=new h(T);let re,te;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ce.stack=i.create(),re=this.g.check(ce.stack,this.w+1)),m&&(ce.stack=te??i.create()),this.t?this.t instanceof h?(this.u??=new C,this.t=[this.t,ce]):this.t.push(ce):(this.f?.onWillAddFirstListener?.(this),this.t=ce,this.f?.onDidAddFirstListener?.(this)),this.w++;const $e=(0,B.$Sc)(()=>{a?.unregister($e),re?.(),this.x(ce)});if(Z instanceof B.$Tc?Z.add($e):Array.isArray(Z)&&Z.push($e),a){const De=new Error().stack.split(`
`).slice(2).join(`
`).trim();a.register($e,De,$e)}return $e},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const K=this.t,Z=K.indexOf(T);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,K[Z]=void 0;const ce=this.u.current===this;if(this.w*g<=K.length){let re=0;for(let te=0;te<K.length;te++)K[te]?K[re++]=K[te]:ce&&(this.u.end--,re<this.u.i&&this.u.i--);K.length=re}}y(T,K){if(!T)return;const Z=this.f?.onListenerError||n.$1;if(!Z){T.value(K);return}try{T.value(K)}catch(ce){Z(ce)}}z(T){const K=T.current.t;for(;T.i<T.end;)this.y(K[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,T);else{const K=this.u;K.enqueue(this,T,this.t.length),this.z(K)}this.j?.stop()}hasListeners(){return this.w>0}}t.$7d=d;const o=()=>new C;t.$8d=o;class C{constructor(){this.i=-1,this.end=0}enqueue(T,K,Z){this.i=0,this.end=Z,this.current=T,this.value=K}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class N extends d{async fireAsync(T,K,Z){if(this.t)for(this.h||(this.h=new W.$5c),w(this.t,ce=>this.h.push([ce.value,T]));this.h.size>0&&!K.isCancellationRequested;){const[ce,re]=this.h.shift(),te=[],$e={...re,token:K,waitUntil:De=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");Z&&(De=Z(De,ce)),te.push(De)}};try{ce($e)}catch(De){(0,n.$1)(De);continue}Object.freeze(te),await Promise.allSettled(te).then(De=>{for(const Te of De)Te.status==="rejected"&&(0,n.$1)(Te.reason)})}}}t.$9d=N;class O extends d{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new W.$5c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}t.$0d=O;class P extends O{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}t.$$d=P;class L extends d{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(K=>super.fire(K)),this.h=[]}))}}t.$_d=L;class ${constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const K={event:T,listener:null};this.h.push(K),this.g&&this.m(K);const Z=()=>{this.g&&this.o(K);const ce=this.h.indexOf(K);this.h.splice(ce,1)};return(0,B.$Sc)((0,F.$db)(Z))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(K=>this.f.fire(K))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}t.$ae=$;class M{constructor(T,K,Z,ce){this.f=new B.$Tc;const re=this.f.add(new $),te=this.f.add(new B.$4c);function $e(De){te.set(De,re.add(ce(De)))}for(const De of T)$e(De);this.f.add(K(De=>{$e(De)})),this.f.add(Z(De=>{te.deleteAndDispose(De)})),this.event=re.event}dispose(){this.f.dispose()}}t.$be=M;class V{constructor(){this.f=[]}wrapEvent(T){return(K,Z,ce)=>T(re=>{const te=this.f[this.f.length-1];te?te.push(()=>K.call(Z,re)):K.call(Z,re)},void 0,ce)}bufferEvents(T){const K=[];this.f.push(K);const Z=T();return this.f.pop(),K.forEach(ce=>ce()),Z}}t.$ce=V;class I{constructor(){this.f=!1,this.g=v.None,this.h=B.$Uc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$de=I}),define(ge[17],be([1,0,22,4]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Q=t.$ZQ=t.$YQ=t.$XQ=t.$WQ=t.$VQ=t.$UQ=t.$TQ=t.$OQ=void 0,t.$LQ=W,t.$MQ=A,t.$NQ=k,t.$PQ=m,t.$QQ=b,t.$RQ=v,t.$SQ=z,t.$2Q=e,t.$3Q=i;class B{constructor(){this.a=new Map,this.b=new F.$7d,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new F.$7d,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new B}getZoomLevel(h){return this.a.get(this.f(h))??0}setZoomLevel(h,g){if(this.getZoomLevel(g)===h)return;const w=this.f(g);this.a.set(w,h),this.b.fire(w)}getZoomFactor(h){return this.c.get(this.f(h))??1}setZoomFactor(h,g){this.c.set(this.f(g),h)}setFullscreen(h,g){if(this.isFullscreen(g)===h)return;const w=this.f(g);this.e.set(w,h),this.d.fire(w)}isFullscreen(h){return!!this.e.get(this.f(h))}f(h){return h.vscodeWindowId}}function W(r,h,g){typeof h=="string"&&(h=r.matchMedia(h)),h.addEventListener("change",g)}function A(r,h){B.INSTANCE.setZoomLevel(r,h)}function k(r){return B.INSTANCE.getZoomLevel(r)}t.$OQ=B.INSTANCE.onDidChangeZoomLevel;function m(r){return B.INSTANCE.getZoomFactor(r)}function b(r,h){B.INSTANCE.setZoomFactor(r,h)}function v(r,h){B.INSTANCE.setFullscreen(r,h)}function z(r){return B.INSTANCE.isFullscreen(r)}t.$TQ=B.INSTANCE.onDidChangeFullscreen;const u=navigator.userAgent;t.$UQ=u.indexOf("Firefox")>=0,t.$VQ=u.indexOf("AppleWebKit")>=0,t.$WQ=u.indexOf("Chrome")>=0,t.$XQ=!t.$WQ&&u.indexOf("Safari")>=0,t.$YQ=!t.$WQ&&!t.$XQ&&t.$VQ,t.$ZQ=u.indexOf("Electron/")>=0,t.$1Q=u.indexOf("Android")>=0;let f=!1;if(typeof n.$IQ.matchMedia=="function"){const r=n.$IQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),h=n.$IQ.matchMedia("(display-mode: fullscreen)");f=r.matches,W(n.$IQ,r,({matches:g})=>{f&&h.matches||(f=g)})}function e(){return f}function i(){return navigator?.windowControlsOverlay?.visible}}),define(ge[24],be([1,0,4]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=void 0;class F{get event(){return this.a.event}constructor(W,A,k){const m=b=>this.a.fire(b);this.a=new n.$7d({onWillAddFirstListener:()=>W.addEventListener(A,m,k),onDidRemoveLastListener:()=>W.removeEventListener(A,m,k)})}dispose(){this.a.dispose()}}t.$gT=F}),define(ge[28],be([1,0,4]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=t.CancellationToken=void 0;const F=Object.freeze(function(k,m){const b=setTimeout(k.bind(m),0);return{dispose(){clearTimeout(b)}}});var B;(function(k){function m(b){return b===k.None||b===k.Cancelled||b instanceof W?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}k.isCancellationToken=m,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(B||(t.CancellationToken=B={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new n.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new W),this.f}cancel(){this.f?this.f instanceof W&&this.f.cancel():this.f=B.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof W&&this.f.dispose():this.f=B.None}}t.$ee=A}),define(ge[95],be([1,0,28]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.$Pe=void 0;class F{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new n.$ee,m=this.b(k.token);return this.a={promise:m,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}t.$Pe=F;class B{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const m=JSON.stringify(k);return this.b!==m&&(this.b=m,this.a=this.c(k)),this.a}}t.$Qe=B;class W{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const m=this.b(k);return this.a.set(k,m),m}}t.$Re=W}),define(ge[96],be([1,0,40,33,41,28,26]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zd=t.$Yd=t.$Xd=t.$Wd=void 0,t.$1d=z,t.$2d=u;class k{get cachedValue(){return this.a}constructor(e){this.b=e,this.a=(0,F.$Sd)(this,void 0)}getValue(){let e=this.a.get();return e||(e=this.b(),this.a.set(e,void 0)),e}}t.$Wd=k;class m{constructor(e){this.a=(0,F.$Sd)(this,void 0),this.promiseResult=this.a,this.promise=e.then(i=>((0,F.$Nd)(r=>{this.a.set(new b(i,void 0),r)}),i),i=>{throw(0,F.$Nd)(r=>{this.a.set(new b(void 0,i),r)}),i})}}t.$Xd=m;class b{constructor(e,i){this.data=e,this.error=i}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$Yd=b;class v{constructor(e){this.b=e,this.a=new k(()=>new m(this.b())),this.cachedPromiseResult=(0,B.$Cd)(this,i=>this.a.cachedValue.read(i)?.promiseResult.read(i))}getPromise(){return this.a.getValue().promise}}t.$Zd=v;function z(f,e,i){return new Promise((r,h)=>{let g=!0,w=!1;const a=f.map(o=>({isFinished:e(o),error:i?i(o):!1,state:o})),d=(0,n.$cd)(o=>{const{isFinished:C,error:N,state:O}=a.read(o);(C||N)&&(g?w=!0:d.dispose(),N?h(N===!0?O:N):r(O))});g=!1,w&&d.dispose()})}function u(f,e){let i,r;e===void 0?(i=f,r=void 0):(r=f,i=e);let h;return new B.$Hd(new A.$6c(r,void 0,i),g=>(h&&h.dispose(!0),h=new W.$ee,i(g,h.token)),void 0,void 0,()=>h?.dispose(),B.$Bd)}}),define(ge[57],be([1,0,33,41,40,92,96,27]),function(ie,t,n,F,B,W,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return n.$Sd}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return n.$Ud}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return n.$Nd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return n.$Qd}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return F.$Cd}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return F.$Dd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return F.$Ed}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return F.$Fd}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return B.$cd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return B.$hd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return B.$ed}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return B.$gd}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return B.$dd}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return B.$fd}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return W.$jd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return W.$pd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return W.$vd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return W.$wd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return W.$sd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return W.$td}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return W.$ld}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return W.$kd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return W.$od}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return W.$nd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return W.$rd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return A.$Wd}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return A.$Zd}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return A.$Xd}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return A.$Yd}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return A.$1d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return A.$2d}}),!1&&(0,k.$yd)(new k.$Ad)}),define(ge[58],be([1,0,4,2]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hs=t.$Gs=t.$Fs=t.$Es=t.ScrollbarVisibility=void 0;var B;(function(f){f[f.Auto=1]="Auto",f[f.Hidden=2]="Hidden",f[f.Visible=3]="Visible"})(B||(t.ScrollbarVisibility=B={}));class W{constructor(e,i,r,h,g,w,a){this.c=e,this._scrollStateBrand=void 0,this.c&&(i=i|0,r=r|0,h=h|0,g=g|0,w=w|0,a=a|0),this.rawScrollLeft=h,this.rawScrollTop=a,i<0&&(i=0),h+i>r&&(h=r-i),h<0&&(h=0),g<0&&(g=0),a+g>w&&(a=w-g),a<0&&(a=0),this.width=i,this.scrollWidth=r,this.scrollLeft=h,this.height=g,this.scrollHeight=w,this.scrollTop=a}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,i){return new W(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,i?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,i?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,i){const r=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,g=this.scrollLeft!==e.scrollLeft,w=this.height!==e.height,a=this.scrollHeight!==e.scrollHeight,d=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:i,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:h,scrollLeftChanged:g,heightChanged:w,scrollHeightChanged:a,scrollTopChanged:d}}}t.$Es=W;class A extends F.$Uc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new n.$7d),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new W(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,i){const r=this.g.withScrollDimensions(e,i);this.n(r,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const i=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(i,!1)}setScrollPositionSmooth(e,i){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let h;i?h=new v(this.h.from,r,this.h.startTime,this.h.duration):h=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=h}else{const r=this.g.withScrollPosition(e);this.h=v.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),i=this.g.withScrollPosition(e);if(this.n(i,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,i){const r=this.g;r.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(r,i)))}}t.$Fs=A;class k{constructor(e,i,r){this.scrollLeft=e,this.scrollTop=i,this.isDone=r}}t.$Gs=k;function m(f,e){const i=e-f;return function(r){return f+i*u(r)}}function b(f,e,i){return function(r){return r<i?f(r/i):e((r-i)/(1-i))}}class v{constructor(e,i,r,h){this.from=e,this.to=i,this.duration=h,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,i,r){if(Math.abs(e-i)>2.5*r){let g,w;return e<i?(g=e+.75*r,w=i-.75*r):(g=e-.75*r,w=i+.75*r),b(m(e,g),m(w,i),.33)}return m(e,i)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const i=(e-this.startTime)/this.duration;if(i<1){const r=this.c(i),h=this.d(i);return new k(r,h,!1)}return new k(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,i,r){return v.start(e,i,r)}static start(e,i,r){r=r+10;const h=Date.now()-10;return new v(e,i,h,r)}}t.$Hs=v;function z(f){return Math.pow(f,3)}function u(f){return 1-z(1-f)}}),define(ge[97],be([1,0,6,2]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=B,t.$ge=W,t.$he=A,t.$ie=k,t.$je=b,t.$ke=v,t.$le=z,t.$me=u,t.$ne=f,t.$oe=e,t.$pe=i,t.$qe=r,t.$re=h,t.$se=g,t.$te=w;function B(a){const d=a;return d?typeof d.read=="function":!1}function W(a){const d=a;return d?[d.on,d.pause,d.resume,d.destroy].every(o=>typeof o=="function"):!1}function A(a){const d=a;return d?W(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}function k(a,d){return new m(a,d)}class m{constructor(d,o){this.e=d,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(o=>o(d))}h(d){this.c.error.length===0?(0,n.$1)(d):this.c.error.slice(0).forEach(o=>o(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,o){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(d,o){if(this.a.destroyed)return;let C;switch(d){case"data":C=this.c.data;break;case"end":C=this.c.end;break;case"error":C=this.c.error;break}if(C){const N=C.indexOf(o);N>=0&&C.splice(N,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(C=>C())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(a,d){const o=[];let C;for(;(C=a.read())!==null;)o.push(C);return d(o)}function v(a,d,o){const C=[];let N;for(;(N=a.read())!==null&&C.length<o;)C.push(N);return N===null&&C.length>0?d(C):{read:()=>{if(C.length>0)return C.shift();if(typeof N<"u"){const O=N;return N=void 0,O}return a.read()}}}function z(a,d){return new Promise((o,C)=>{const N=[];u(a,{onData:O=>{d&&N.push(O)},onError:O=>{d?C(O):o(void 0)},onEnd:()=>{o(d?d(N):void 0)}})})}function u(a,d,o){a.on("error",C=>{o?.isCancellationRequested||d.onError(C)}),a.on("end",()=>{o?.isCancellationRequested||d.onEnd()}),a.on("data",C=>{o?.isCancellationRequested||d.onData(C)})}function f(a,d){return new Promise((o,C)=>{const N=new F.$Tc,O=[],P=M=>{if(O.push(M),O.length>d)return N.dispose(),a.pause(),o({stream:a,buffer:O,ended:!1})},L=M=>(N.dispose(),C(M)),$=()=>(N.dispose(),o({stream:a,buffer:O,ended:!0}));N.add((0,F.$Sc)(()=>a.removeListener("error",L))),a.on("error",L),N.add((0,F.$Sc)(()=>a.removeListener("end",$))),a.on("end",$),N.add((0,F.$Sc)(()=>a.removeListener("data",P))),a.on("data",P)})}function e(a,d){const o=k(d);return o.end(a),o}function i(){const a=k(()=>{throw new Error("not supported")});return a.end(),a}function r(a){let d=!1;return{read:()=>d?null:(d=!0,a)}}function h(a,d,o){const C=k(o);return u(a,{onData:N=>C.write(d.data(N)),onError:N=>C.error(d.error?d.error(N):N),onEnd:()=>C.end()}),C}function g(a,d,o){let C=!1;return{read:()=>{const N=d.read();return C?N:(C=!0,N!==null?o([a,N]):a)}}}function w(a,d,o){let C=!1;const N=k(o);return u(d,{onData:O=>C?N.write(O):(C=!0,N.write(o([a,O]))),onError:O=>N.error(O),onEnd:()=>{C||(C=!0,N.write(a)),N.end()}}),N}}),define(ge[42],be([1,0,23,97]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=void 0,t.$ve=b,t.$we=v,t.$xe=z,t.$ye=u,t.$ze=f,t.$Ae=e,t.$Be=i,t.$Ce=r,t.$De=h,t.$Ee=g,t.$Fe=w,t.$Ge=a,t.$He=d,t.$Ie=o,t.$Je=C,t.$Ke=N,t.$Le=O,t.$Me=P,t.$Ne=L,t.$Oe=V;const B=typeof Buffer<"u",W=new n.$V(()=>new Uint8Array(256));let A,k;class m{static alloc(j){return B?new m(Buffer.allocUnsafe(j)):new m(new Uint8Array(j))}static wrap(j){return B&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new m(j)}static fromString(j,T){return!(T?.dontUseNodeBuffer||!1)&&B?new m(Buffer.from(j)):(A||(A=new TextEncoder),new m(A.encode(j)))}static fromByteArray(j){const T=m.alloc(j.length);for(let K=0,Z=j.length;K<Z;K++)T.buffer[K]=j[K];return T}static concat(j,T){if(typeof T>"u"){T=0;for(let ce=0,re=j.length;ce<re;ce++)T+=j[ce].byteLength}const K=m.alloc(T);let Z=0;for(let ce=0,re=j.length;ce<re;ce++){const te=j[ce];K.set(te,Z),Z+=te.byteLength}return K}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=m.alloc(this.byteLength);return j.set(this),j}toString(){return B?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(j,T){return new m(this.buffer.subarray(j,T))}set(j,T){if(j instanceof m)this.buffer.set(j.buffer,T);else if(j instanceof Uint8Array)this.buffer.set(j,T);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),T);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return u(this.buffer,j)}writeUInt32BE(j,T){f(this.buffer,j,T)}readUInt32LE(j){return e(this.buffer,j)}writeUInt32LE(j,T){i(this.buffer,j,T)}readUInt8(j){return r(this.buffer,j)}writeUInt8(j,T){h(this.buffer,j,T)}indexOf(j,T=0){return b(this.buffer,j instanceof m?j.buffer:j,T)}}t.$ue=m;function b(I,j,T=0){const K=j.byteLength,Z=I.byteLength;if(K===0)return 0;if(K===1)return I.indexOf(j[0]);if(K>Z-T)return-1;const ce=W.value;ce.fill(j.length);for(let De=0;De<j.length;De++)ce[j[De]]=j.length-De-1;let re=T+j.length-1,te=re,$e=-1;for(;re<Z;)if(I[re]===j[te]){if(te===0){$e=re;break}re--,te--}else re+=Math.max(j.length-te,ce[I[re]]),te=j.length-1;return $e}function v(I,j){return I[j+0]<<0>>>0|I[j+1]<<8>>>0}function z(I,j,T){I[T+0]=j&255,j=j>>>8,I[T+1]=j&255}function u(I,j){return I[j]*2**24+I[j+1]*2**16+I[j+2]*2**8+I[j+3]}function f(I,j,T){I[T+3]=j,j=j>>>8,I[T+2]=j,j=j>>>8,I[T+1]=j,j=j>>>8,I[T]=j}function e(I,j){return I[j+0]<<0>>>0|I[j+1]<<8>>>0|I[j+2]<<16>>>0|I[j+3]<<24>>>0}function i(I,j,T){I[T+0]=j&255,j=j>>>8,I[T+1]=j&255,j=j>>>8,I[T+2]=j&255,j=j>>>8,I[T+3]=j&255}function r(I,j){return I[j]}function h(I,j,T){I[T]=j}function g(I){return F.$je(I,j=>m.concat(j))}function w(I){return F.$qe(I)}function a(I){return F.$le(I,j=>m.concat(j))}async function d(I){return I.ended?m.concat(I.buffer):m.concat([...I.buffer,await a(I.stream)])}function o(I){return F.$oe(I,j=>m.concat(j))}function C(I){return F.$re(I,{data:j=>typeof j=="string"?m.fromString(j):m.wrap(j)},j=>m.concat(j))}function N(I){return F.$ie(j=>m.concat(j),I)}function O(I,j){return F.$se(I,j,T=>m.concat(T))}function P(I,j){return F.$te(I,j,T=>m.concat(T))}function L(I){let j=0,T=0,K=0;const Z=new Uint8Array(Math.floor(I.length/4*3)),ce=te=>{switch(T){case 3:Z[K++]=j|te,T=0;break;case 2:Z[K++]=j|te>>>2,j=te<<6,T=3;break;case 1:Z[K++]=j|te>>>4,j=te<<4,T=2;break;default:j=te<<2,T=1}};for(let te=0;te<I.length;te++){const $e=I.charCodeAt(te);if($e>=65&&$e<=90)ce($e-65);else if($e>=97&&$e<=122)ce($e-97+26);else if($e>=48&&$e<=57)ce($e-48+52);else if($e===43||$e===45)ce(62);else if($e===47||$e===95)ce(63);else{if($e===61)break;throw new SyntaxError(`Unexpected base64 character ${I[te]}`)}}const re=K;for(;T>0;)ce(0);return m.wrap(Z).slice(0,re)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function V({buffer:I},j=!0,T=!1){const K=T?M:$;let Z="";const ce=I.byteLength%3;let re=0;for(;re<I.byteLength-ce;re+=3){const te=I[re+0],$e=I[re+1],De=I[re+2];Z+=K[te>>>2],Z+=K[(te<<4|$e>>>4)&63],Z+=K[($e<<2|De>>>6)&63],Z+=K[De&63]}if(ce===1){const te=I[re+0];Z+=K[te>>>2],Z+=K[te<<4&63],j&&(Z+="==")}else if(ce===2){const te=I[re+0],$e=I[re+1];Z+=K[te>>>2],Z+=K[(te<<4|$e>>>4)&63],Z+=K[$e<<2&63],j&&(Z+="=")}return Z}}),define(ge[10],be([1,0,95,23]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uf=t.$Tf=t.$Sf=t.GraphemeBreakType=t.$If=t.$Bf=t.$uf=t.$tf=void 0,t.$Ue=B,t.$Ve=A,t.$We=m,t.$Xe=b,t.$Ye=v,t.$Ze=z,t.$1e=u,t.$2e=f,t.$3e=e,t.$4e=i,t.$5e=r,t.$6e=h,t.$7e=g,t.$8e=w,t.$9e=a,t.$0e=d,t.$$e=o,t.$_e=C,t.$af=N,t.$bf=O,t.$cf=P,t.$df=L,t.$ef=$,t.$ff=M,t.$gf=V,t.$hf=I,t.$if=j,t.$jf=T,t.$kf=K,t.$lf=Z,t.$mf=ce,t.$nf=re,t.$of=te,t.$pf=$e,t.$qf=De,t.$rf=Te,t.$sf=Pe,t.$vf=ae,t.$wf=J,t.$xf=G,t.$yf=se,t.$zf=Ne,t.$Af=Le,t.$Cf=x,t.$Df=c,t.$Ef=D,t.$Ff=l,t.$Gf=S,t.$Hf=s,t.$Jf=E,t.$Kf=y,t.$Lf=R,t.$Mf=H,t.$Nf=X,t.$Of=U,t.$Pf=oe,t.$Qf=we,t.$Rf=Ee;function B(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}const W=/{(\d+)}/g;function A(Y,...ne){return ne.length===0?Y:Y.replace(W,function(pe,ye){const Re=parseInt(ye,10);return isNaN(Re)||Re<0||Re>=ne.length?pe:ne[Re]})}const k=/{([^}]+)}/g;function m(Y,ne){return Object.keys(ne).length===0?Y:Y.replace(k,(pe,ye)=>ne[ye]??pe)}function b(Y){return Y.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}function v(Y){return Y.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}function z(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function u(Y,ne){let pe=0;const ye=ne.charCodeAt(0);for(let Re=Y.length-1;Re>=0;Re--)Y.charCodeAt(Re)===ye&&pe++;return pe}function f(Y,ne,pe="\u2026"){return Y.length<=ne?Y:`${Y.substr(0,ne)}${pe}`}function e(Y,ne,pe="\u2026"){if(Y.length<=ne)return Y;const ye=Math.ceil(ne/2)-pe.length/2,Re=Math.floor(ne/2)-pe.length/2;return`${Y.substr(0,ye)}${pe}${Y.substr(Y.length-Re)}`}function i(Y,ne=" "){const pe=r(Y,ne);return h(pe,ne)}function r(Y,ne){if(!Y||!ne)return Y;const pe=ne.length;if(pe===0||Y.length===0)return Y;let ye=0;for(;Y.indexOf(ne,ye)===ye;)ye=ye+pe;return Y.substring(ye)}function h(Y,ne){if(!Y||!ne)return Y;const pe=ne.length,ye=Y.length;if(pe===0||ye===0)return Y;let Re=ye,xe=-1;for(;xe=Y.lastIndexOf(ne,Re-1),!(xe===-1||xe+pe!==Re);){if(xe===0)return"";Re=xe}return Y.substring(0,Re)}function g(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function w(Y){return Y.replace(/\*/g,"")}function a(Y,ne,pe={}){if(!Y)throw new Error("Cannot create regex from empty string");ne||(Y=z(Y)),pe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(Y,ye)}function d(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}function o(Y){return Y.split(/\r\n|\r|\n/)}function C(Y){const ne=[],pe=Y.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ne.push(pe[2*ye]+(pe[2*ye+1]??""));return ne}function N(Y){for(let ne=0,pe=Y.length;ne<pe;ne++){const ye=Y.charCodeAt(ne);if(ye!==32&&ye!==9)return ne}return-1}function O(Y,ne=0,pe=Y.length){for(let ye=ne;ye<pe;ye++){const Re=Y.charCodeAt(ye);if(Re!==32&&Re!==9)return Y.substring(ne,ye)}return Y.substring(ne,pe)}function P(Y,ne=Y.length-1){for(let pe=ne;pe>=0;pe--){const ye=Y.charCodeAt(pe);if(ye!==32&&ye!==9)return pe}return-1}function L(Y,ne,pe){const ye=[];let Re=0;for(const xe of Y.matchAll(ne)){if(ye.push(Y.slice(Re,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Re=xe.index+xe[0].length,ye.push(pe(xe[0],...xe.slice(1),xe.index,Y,xe.groups))}return ye.push(Y.slice(Re)),Promise.all(ye).then(xe=>xe.join(""))}function $(Y,ne){return Y<ne?-1:Y>ne?1:0}function M(Y,ne,pe=0,ye=Y.length,Re=0,xe=ne.length){for(;pe<ye&&Re<xe;pe++,Re++){const it=Y.charCodeAt(pe),st=ne.charCodeAt(Re);if(it<st)return-1;if(it>st)return 1}const Ve=ye-pe,et=xe-Re;return Ve<et?-1:Ve>et?1:0}function V(Y,ne){return I(Y,ne,0,Y.length,0,ne.length)}function I(Y,ne,pe=0,ye=Y.length,Re=0,xe=ne.length){for(;pe<ye&&Re<xe;pe++,Re++){let it=Y.charCodeAt(pe),st=ne.charCodeAt(Re);if(it===st)continue;if(it>=128||st>=128)return M(Y.toLowerCase(),ne.toLowerCase(),pe,ye,Re,xe);T(it)&&(it-=32),T(st)&&(st-=32);const Je=it-st;if(Je!==0)return Je}const Ve=ye-pe,et=xe-Re;return Ve<et?-1:Ve>et?1:0}function j(Y){return Y>=48&&Y<=57}function T(Y){return Y>=97&&Y<=122}function K(Y){return Y>=65&&Y<=90}function Z(Y,ne){return Y.length===ne.length&&I(Y,ne)===0}function ce(Y,ne){const pe=ne.length;return ne.length>Y.length?!1:I(Y,ne,0,pe)===0}function re(Y,ne){const pe=Math.min(Y.length,ne.length);let ye;for(ye=0;ye<pe;ye++)if(Y.charCodeAt(ye)!==ne.charCodeAt(ye))return ye;return pe}function te(Y,ne){const pe=Math.min(Y.length,ne.length);let ye;const Re=Y.length-1,xe=ne.length-1;for(ye=0;ye<pe;ye++)if(Y.charCodeAt(Re-ye)!==ne.charCodeAt(xe-ye))return ye;return pe}function $e(Y){return 55296<=Y&&Y<=56319}function De(Y){return 56320<=Y&&Y<=57343}function Te(Y,ne){return(Y-55296<<10)+(ne-56320)+65536}function Pe(Y,ne,pe){const ye=Y.charCodeAt(pe);if($e(ye)&&pe+1<ne){const Re=Y.charCodeAt(pe+1);if(De(Re))return Te(ye,Re)}return ye}function he(Y,ne){const pe=Y.charCodeAt(ne-1);if(De(pe)&&ne>1){const ye=Y.charCodeAt(ne-2);if($e(ye))return Te(ye,pe)}return pe}class _{get offset(){return this.e}constructor(ne,pe=0){this.c=ne,this.d=ne.length,this.e=pe}setOffset(ne){this.e=ne}prevCodePoint(){const ne=he(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Pe(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$tf=_;class le{get offset(){return this.c.offset}constructor(ne,pe=0){this.c=new _(ne,pe)}nextGraphemeLength(){const ne=ke.getInstance(),pe=this.c,ye=pe.offset;let Re=ne.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const xe=pe.offset,Ve=ne.getGraphemeBreakType(pe.nextCodePoint());if(me(Re,Ve)){pe.setOffset(xe);break}Re=Ve}return pe.offset-ye}prevGraphemeLength(){const ne=ke.getInstance(),pe=this.c,ye=pe.offset;let Re=ne.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const xe=pe.offset,Ve=ne.getGraphemeBreakType(pe.prevCodePoint());if(me(Ve,Re)){pe.setOffset(xe);break}Re=Ve}return ye-pe.offset}eol(){return this.c.eol()}}t.$uf=le;function ae(Y,ne){return new le(Y,ne).nextGraphemeLength()}function J(Y,ne){return new le(Y,ne).prevGraphemeLength()}function G(Y,ne){ne>0&&De(Y.charCodeAt(ne))&&ne--;const pe=ne+ae(Y,ne);return[pe-J(Y,pe),pe]}function se(Y){const ne=new le(Y);let pe=0;for(;!ne.eol();)pe++,ne.nextGraphemeLength();return pe}let fe;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ne(Y){return fe||(fe=ve()),fe.test(Y)}const Ae=/^[\t\n\r\x20-\x7E]*$/;function Le(Y){return Ae.test(Y)}t.$Bf=/[\u2028\u2029]/;function x(Y){return t.$Bf.test(Y)}function c(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}function D(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}function l(Y,ne,pe=""){const ye=Y.trimStart();if(ye.length<ne)return ye;const Re=/\b/g;let xe=0;for(;Re.test(ye)&&!(ye.length-Re.lastIndex<ne);)xe=Re.lastIndex,Re.lastIndex+=1;return xe===0?ye:pe+ye.substring(xe).trimStart()}const p=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*S(Y){let ne=0;for(const pe of Y.matchAll(p))ne!==pe.index&&(yield{isCode:!1,str:Y.substring(ne,pe.index)}),yield{isCode:!0,str:pe[0]},ne=pe.index+pe[0].length;ne!==Y.length&&(yield{isCode:!1,str:Y.substring(ne)})}function s(Y){return Y&&(Y=Y.replace(p,"")),Y}t.$If="\uFEFF";function E(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}function y(Y){return E(Y)?Y.substr(1):Y}function R(Y,ne){if(!Y||!ne||Y.length<ne.length)return!1;const pe=ne.length,ye=Y.toLowerCase();let Re=0,xe=-1;for(;Re<pe;){const Ve=ye.indexOf(ne[Re],xe+1);if(Ve<0)return!1;xe=Ve,Re++}return!0}function H(Y,ne=!1){return Y?(ne&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}function X(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}function U(Y,ne=1){if(ne===0)return"";let pe=-1;do pe=Y.indexOf(`
`,pe+1),ne--;while(ne>0&&pe>=0);return pe===-1?Y:(Y[pe-1]==="\r"&&pe--,Y.substr(0,pe))}function oe(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}function we(Y){return ke.getInstance().getGraphemeBreakType(Y)}function me(Y,ne){return Y===0?ne!==5&&ne!==7:Y===2&&ne===3?!1:Y===4||Y===2||Y===3||ne===4||ne===2||ne===3?!0:!(Y===8&&(ne===8||ne===9||ne===11||ne===12)||(Y===11||Y===9)&&(ne===9||ne===10)||(Y===12||Y===10)&&ne===10||ne===5||ne===13||ne===7||Y===1||Y===13&&ne===14||Y===6&&ne===6)}var Ie;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(t.GraphemeBreakType=Ie={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=je()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const pe=this.d,ye=pe.length/3;let Re=1;for(;Re<=ye;)if(ne<pe[3*Re])Re=2*Re;else if(ne>pe[3*Re+1])Re=2*Re+1;else return pe[3*Re+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(Y,ne){if(Y===0)return 0;const pe=Se(Y,ne);if(pe!==void 0)return pe;const ye=new _(ne,Y);return ye.prevCodePoint(),ye.offset}function Se(Y,ne){const pe=new _(ne,Y);let ye=pe.prevCodePoint();for(;We(ye)||ye===65039||ye===8419;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!D(ye))return;let Re=pe.offset;return Re>0&&pe.prevCodePoint()===8205&&(Re=pe.offset),Re}function We(Y){return 127995<=Y&&Y<=127999}var Ue;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.$Sf="\xA0";class Ye{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$Qe(ne=>{function pe(Je){const rt=new Map;for(let tt=0;tt<Je.length;tt+=2)rt.set(Je[tt],Je[tt+1]);return rt}function ye(Je,rt){const tt=new Map(Je);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Re(Je,rt){if(!Je)return rt;const tt=new Map;for(const[mt,gt]of Je)rt.has(mt)&&tt.set(mt,gt);return tt}const xe=this.c.value;let Ve=ne.filter(Je=>!Je.startsWith("_")&&Je in xe);Ve.length===0&&(Ve=["_default"]);let et;for(const Je of Ve){const rt=pe(xe[Je]);et=Re(et,rt)}const it=pe(xe._common),st=ye(it,et);return new Ye(st)})}static getInstance(ne){return Ye.d.get(Array.from(ne))}static{this.e=new F.$V(()=>Object.keys(Ye.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Tf=Ye;class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(ne){return _e.e().has(ne)}static get codePoints(){return _e.e()}}t.$Uf=_e}),define(ge[43],be([1,0,38,89,10]),function(ie,t,n,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vk=t.FuzzyScore=t.$kk=t.$jk=void 0,t.or=W,t.$lk=k,t.$mk=m,t.$nk=z,t.$ok=L,t.$pk=$,t.$qk=K,t.$rk=Z,t.$sk=ce,t.$tk=re,t.$uk=Ne,t.$wk=c,t.$xk=p,t.$yk=S;function W(...y){return function(R,H){for(let X=0,U=y.length;X<U;X++){const oe=y[X](R,H);if(oe)return oe}return null}}t.$jk=A.bind(void 0,!1),t.$kk=A.bind(void 0,!0);function A(y,R,H){if(!H||H.length<R.length)return null;let X;return y?X=B.$mf(H,R):X=H.indexOf(R)===0,X?R.length>0?[{start:0,end:R.length}]:[]:null}function k(y,R){const H=R.toLowerCase().indexOf(y.toLowerCase());return H===-1?null:[{start:H,end:H+y.length}]}function m(y,R){return b(y.toLowerCase(),R.toLowerCase(),0,0)}function b(y,R,H,X){if(H===y.length)return[];if(X===R.length)return null;if(y[H]===R[X]){let U=null;return(U=b(y,R,H+1,X+1))?a({start:X,end:X+1},U):null}return b(y,R,H,X+1)}function v(y){return 97<=y&&y<=122}function z(y){return 65<=y&&y<=90}function u(y){return 48<=y&&y<=57}function f(y){return y===32||y===9||y===10||y===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(y=>e.add(y.charCodeAt(0)));function i(y){return f(y)||e.has(y)}function r(y,R){return y===R||i(y)&&i(R)}const h=new Map;function g(y){if(h.has(y))return h.get(y);let R;const H=(0,F.$hk)(y);return H&&(R=H),h.set(y,R),R}function w(y){return v(y)||z(y)||u(y)}function a(y,R){return R.length===0?R=[y]:y.end===R[0].start?R[0].start=y.start:R.unshift(y),R}function d(y,R){for(let H=R;H<y.length;H++){const X=y.charCodeAt(H);if(z(X)||u(X)||H>0&&!w(y.charCodeAt(H-1)))return H}return y.length}function o(y,R,H,X){if(H===y.length)return[];if(X===R.length)return null;if(y[H]!==R[X].toLowerCase())return null;{let U=null,oe=X+1;for(U=o(y,R,H+1,X+1);!U&&(oe=d(R,oe))<R.length;)U=o(y,R,H+1,oe),oe++;return U===null?null:a({start:X,end:X+1},U)}}function C(y){let R=0,H=0,X=0,U=0,oe=0;for(let je=0;je<y.length;je++)oe=y.charCodeAt(je),z(oe)&&R++,v(oe)&&H++,w(oe)&&X++,u(oe)&&U++;const we=R/y.length,me=H/y.length,Ie=X/y.length,ke=U/y.length;return{upperPercent:we,lowerPercent:me,alphaPercent:Ie,numericPercent:ke}}function N(y){const{upperPercent:R,lowerPercent:H}=y;return H===0&&R>.6}function O(y){const{upperPercent:R,lowerPercent:H,alphaPercent:X,numericPercent:U}=y;return H>.2&&R<.8&&X>.6&&U<.2}function P(y){let R=0,H=0,X=0,U=0;for(let oe=0;oe<y.length;oe++)X=y.charCodeAt(oe),z(X)&&R++,v(X)&&H++,f(X)&&U++;return(R===0||H===0)&&U===0?y.length<=30:R<=5}function L(y,R){if(!R||(R=R.trim(),R.length===0)||!P(y))return null;R.length>60&&(R=R.substring(0,60));const H=C(R);if(!O(H)){if(!N(H))return null;R=R.toLowerCase()}let X=null,U=0;for(y=y.toLowerCase();U<R.length&&(X=o(y,R,0,U))===null;)U=d(R,U+1);return X}function $(y,R,H=!1){if(!R||R.length===0)return null;let X=null,U=0;for(y=y.toLowerCase(),R=R.toLowerCase();U<R.length&&(X=M(y,R,0,U,H),X===null);)U=V(R,U+1);return X}function M(y,R,H,X,U){let oe=0;if(H===y.length)return[];if(X===R.length)return null;if(!r(y.charCodeAt(H),R.charCodeAt(X))){const Ie=g(y.charCodeAt(H));if(!Ie)return null;for(let ke=0;ke<Ie.length;ke++)if(!r(Ie[ke],R.charCodeAt(X+ke)))return null;oe+=Ie.length-1}let we=null,me=X+oe+1;if(we=M(y,R,H+1,me,U),!U)for(;!we&&(me=V(R,me))<R.length;)we=M(y,R,H+1,me,U),me++;if(!we)return null;if(y.charCodeAt(H)!==R.charCodeAt(X)){const Ie=g(y.charCodeAt(H));if(!Ie)return we;for(let ke=0;ke<Ie.length;ke++)if(Ie[ke]!==R.charCodeAt(X+ke))return we}return a({start:X,end:X+oe+1},we)}function V(y,R){for(let H=R;H<y.length;H++)if(i(y.charCodeAt(H))||H>0&&i(y.charCodeAt(H-1)))return H;return y.length}const I=W(t.$kk,L,k),j=W(t.$kk,L,m),T=new n.$Ec(1e4);function K(y,R,H=!1){if(typeof y!="string"||typeof R!="string")return null;let X=T.get(y);X||(X=new RegExp(B.$7e(y),"i"),T.set(y,X));const U=X.exec(R);return U?[{start:U.index,end:U.index+U[0].length}]:H?j(y,R):I(y,R)}function Z(y,R){const H=c(y,y.toLowerCase(),0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?re(H):null}function ce(y,R,H,X,U,oe){const we=Math.min(13,y.length);for(;H<we;H++){const me=c(y,R,H,X,U,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(me)return me}return[0,oe]}function re(y){if(typeof y>"u")return[];const R=[],H=y[1];for(let X=y.length-1;X>1;X--){const U=y[X]+H,oe=R[R.length-1];oe&&oe.end===U?oe.end=U+1:R.push({start:U,end:U+1})}return R}const te=128;function $e(){const y=[],R=[];for(let H=0;H<=te;H++)R[H]=0;for(let H=0;H<=te;H++)y.push(R.slice(0));return y}function De(y){const R=[];for(let H=0;H<=y;H++)R[H]=0;return R}const Te=De(2*te),Pe=De(2*te),he=$e(),_=$e(),le=$e(),ae=!1;function J(y,R,H,X,U){function oe(me,Ie,ke=" "){for(;me.length<Ie;)me=ke+me;return me}let we=` |   |${X.split("").map(me=>oe(me,3)).join("|")}
`;for(let me=0;me<=H;me++)me===0?we+=" |":we+=`${R[me-1]}|`,we+=y[me].slice(0,U+1).map(Ie=>oe(Ie.toString(),3)).join("|")+`
`;return we}function G(y,R,H,X){y=y.substr(R),H=H.substr(X),console.log(J(_,y,y.length,H,H.length)),console.log(J(le,y,y.length,H,H.length)),console.log(J(he,y,y.length,H,H.length))}function se(y,R){if(R<0||R>=y.length)return!1;const H=y.codePointAt(R);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!B.$Ef(H)}}function fe(y,R){if(R<0||R>=y.length)return!1;switch(y.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function ve(y,R,H){return R[y]!==H[y]}function Ne(y,R,H,X,U,oe,we=!1){for(;R<H&&U<oe;)y[R]===X[U]&&(we&&(Te[R]=U),R+=1),U+=1;return R===H}var Ae;(function(y){y[y.Diag=1]="Diag",y[y.Left=2]="Left",y[y.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var Le;(function(y){y.Default=[-100,0];function R(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}y.isDefault=R})(Le||(t.FuzzyScore=Le={}));class x{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(R,H){this.firstMatchCanBeWeak=R,this.boostFullMatch=H}}t.$vk=x;function c(y,R,H,X,U,oe,we=x.default){const me=y.length>te?te:y.length,Ie=X.length>te?te:X.length;if(H>=me||oe>=Ie||me-H>Ie-oe||!Ne(R,H,me,U,oe,Ie,!0))return;D(me,Ie,H,oe,R,U);let ke=1,je=1,Ee=H,Se=oe;const We=[!1];for(ke=1,Ee=H;Ee<me;ke++,Ee++){const ne=Te[Ee],pe=Pe[Ee],ye=Ee+1<me?Pe[Ee+1]:Ie;for(je=ne-oe+1,Se=ne;Se<ye;je++,Se++){let Re=Number.MIN_SAFE_INTEGER,xe=!1;Se<=pe&&(Re=l(y,R,Ee,H,X,U,Se,Ie,oe,he[ke-1][je-1]===0,We));let Ve=0;Re!==Number.MAX_SAFE_INTEGER&&(xe=!0,Ve=Re+_[ke-1][je-1]);const et=Se>ne,it=et?_[ke][je-1]+(he[ke][je-1]>0?-5:0):0,st=Se>ne+1&&he[ke][je-1]>0,Je=st?_[ke][je-2]+(he[ke][je-2]>0?-5:0):0;if(st&&(!et||Je>=it)&&(!xe||Je>=Ve))_[ke][je]=Je,le[ke][je]=3,he[ke][je]=0;else if(et&&(!xe||it>=Ve))_[ke][je]=it,le[ke][je]=2,he[ke][je]=0;else if(xe)_[ke][je]=Ve,le[ke][je]=1,he[ke][je]=he[ke-1][je-1]+1;else throw new Error("not possible")}}if(ae&&G(y,H,X,oe),!We[0]&&!we.firstMatchCanBeWeak)return;ke--,je--;const Ue=[_[ke][je],oe];let Ye=0,_e=0;for(;ke>=1;){let ne=je;do{const pe=le[ke][ne];if(pe===3)ne=ne-2;else if(pe===2)ne=ne-1;else break}while(ne>=1);Ye>1&&R[H+ke-1]===U[oe+je-1]&&!ve(ne+oe-1,X,U)&&Ye+1>he[ke][ne]&&(ne=je),ne===je?Ye++:Ye=1,_e||(_e=ne),ke--,je=ne-1,Ue.push(je)}Ie===me&&we.boostFullMatch&&(Ue[0]+=2);const Y=_e-me;return Ue[0]-=Y,Ue}function D(y,R,H,X,U,oe){let we=y-1,me=R-1;for(;we>=H&&me>=X;)U[we]===oe[me]&&(Pe[we]=me,we--),me--}function l(y,R,H,X,U,oe,we,me,Ie,ke,je){if(R[H]!==oe[we])return Number.MIN_SAFE_INTEGER;let Ee=1,Se=!1;return we===H-X?Ee=y[H]===U[we]?7:5:ve(we,U,oe)&&(we===0||!ve(we-1,U,oe))?(Ee=y[H]===U[we]?7:5,Se=!0):se(oe,we)&&(we===0||!se(oe,we-1))?Ee=5:(se(oe,we-1)||fe(oe,we-1))&&(Ee=5,Se=!0),Ee>1&&H===X&&(je[0]=!0),Se||(Se=ve(we,U,oe)||se(oe,we-1)||fe(oe,we-1)),H===X?we>Ie&&(Ee-=Se?3:5):ke?Ee+=Se?2:0:Ee+=Se?0:1,we+1===me&&(Ee-=Se?3:5),Ee}function p(y,R,H,X,U,oe,we){return s(y,R,H,X,U,oe,!0,we)}function S(y,R,H,X,U,oe,we){return s(y,R,H,X,U,oe,!1,we)}function s(y,R,H,X,U,oe,we,me){let Ie=c(y,R,H,X,U,oe,me);if(Ie&&!we)return Ie;if(y.length>=3){const ke=Math.min(7,y.length-1);for(let je=H+1;je<ke;je++){const Ee=E(y,je);if(Ee){const Se=c(Ee,Ee.toLowerCase(),H,X,U,oe,me);Se&&(Se[0]-=3,(!Ie||Se[0]>Ie[0])&&(Ie=Se))}}}return Ie}function E(y,R){if(R+1>=y.length)return;const H=y[R],X=y[R+1];if(H!==X)return y.slice(0,R)+X+H+y.slice(R+2)}}),define(ge[59],be([1,0,10]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cj=t.$aj=void 0,t.$9i=F,t.$0i=B,t.$$i=W,t.$_i=k,t.$bj=i;function F(h){return B(h,0)}function B(h,g){switch(typeof h){case"object":return h===null?W(349,g):Array.isArray(h)?m(h,g):b(h,g);case"string":return k(h,g);case"boolean":return A(h,g);case"number":return W(h,g);case"undefined":return W(937,g);default:return W(617,g)}}function W(h,g){return(g<<5)-g+h|0}function A(h,g){return W(h?433:863,g)}function k(h,g){g=W(149417,g);for(let w=0,a=h.length;w<a;w++)g=W(h.charCodeAt(w),g);return g}function m(h,g){return g=W(104579,g),h.reduce((w,a)=>B(a,w),g)}function b(h,g){return g=W(181387,g),Object.keys(h).sort().reduce((w,a)=>(w=k(a,w),B(h[a],w)),g)}class v{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=B(g,this.g),this.g}}t.$aj=v;var z;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(z||(z={}));function u(h,g,w=32){const a=w-g,d=~((1<<a)-1);return(h<<g|(d&h)>>>a)>>>0}function f(h,g=0,w=h.byteLength,a=0){for(let d=0;d<w;d++)h[g+d]=a}function e(h,g,w="0"){for(;h.length<g;)h=w+h;return h}function i(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(w=>w.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),g/4)}class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const w=g.length;if(w===0)return;const a=this.p;let d=this.r,o=this.u,C,N;for(o!==0?(C=o,N=-1,o=0):(C=g.charCodeAt(0),N=0);;){let O=C;if(n.$pf(C))if(N+1<w){const P=g.charCodeAt(N+1);n.$qf(P)?(N++,O=n.$rf(C,P)):O=65533}else{o=C;break}else n.$qf(C)&&(O=65533);if(d=this.w(a,d,O),N++,N<w)C=g.charCodeAt(N);else break}this.r=d,this.u=o}w(g,w,a){return a<128?g[w++]=a:a<2048?(g[w++]=192|(a&1984)>>>6,g[w++]=128|(a&63)>>>0):a<65536?(g[w++]=224|(a&61440)>>>12,g[w++]=128|(a&4032)>>>6,g[w++]=128|(a&63)>>>0):(g[w++]=240|(a&1835008)>>>18,g[w++]=128|(a&258048)>>>12,g[w++]=128|(a&4032)>>>6,g[w++]=128|(a&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),i(this.h)+i(this.l)+i(this.m)+i(this.n)+i(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=r.g,w=this.q;for(let $=0;$<64;$+=4)g.setUint32($,w.getUint32($,!1),!1);for(let $=64;$<320;$+=4)g.setUint32($,u(g.getUint32($-12,!1)^g.getUint32($-32,!1)^g.getUint32($-56,!1)^g.getUint32($-64,!1),1),!1);let a=this.h,d=this.l,o=this.m,C=this.n,N=this.o,O,P,L;for(let $=0;$<80;$++)$<20?(O=d&o|~d&C,P=1518500249):$<40?(O=d^o^C,P=1859775393):$<60?(O=d&o|d&C|o&C,P=2400959708):(O=d^o^C,P=3395469782),L=u(a,5)+O+N+P+g.getUint32($*4,!1)&4294967295,N=C,C=o,o=u(d,30),d=a,a=L;this.h=this.h+a&4294967295,this.l=this.l+d&4294967295,this.m=this.m+o&4294967295,this.n=this.n+C&4294967295,this.o=this.o+N&4294967295}}t.$cj=r}),define(ge[98],be([1,0,85,59]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$it=t.$gt=void 0,t.$ht=W;class B{constructor(u){this.a=u}getElements(){const u=this.a,f=new Int32Array(u.length);for(let e=0,i=u.length;e<i;e++)f[e]=u.charCodeAt(e);return f}}t.$gt=B;function W(z,u,f){return new v(new B(z),new B(u)).ComputeDiff(f).changes}class A{static Assert(u,f){if(!u)throw new Error(f)}}class k{static Copy(u,f,e,i,r){for(let h=0;h<r;h++)e[i+h]=u[f+h]}static Copy2(u,f,e,i,r){for(let h=0;h<r;h++)e[i+h]=u[f+h]}}var m;(function(z){z[z.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class b{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new n.$ft(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(u,f){this.b=Math.min(this.b,u),this.c=Math.min(this.c,f),this.d++}AddModifiedElement(u,f){this.b=Math.min(this.b,u),this.c=Math.min(this.c,f),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class v{constructor(u,f,e=null){this.a=e,this.b=u,this.c=f;const[i,r,h]=v.o(u),[g,w,a]=v.o(f);this.d=h&&a,this.e=i,this.f=r,this.g=g,this.h=w,this.k=[],this.m=[]}static n(u){return u.length>0&&typeof u[0]=="string"}static o(u){const f=u.getElements();if(v.n(f)){const e=new Int32Array(f.length);for(let i=0,r=f.length;i<r;i++)e[i]=(0,F.$_i)(f[i],0);return[f,e,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}p(u,f){return this.f[u]!==this.h[f]?!1:this.d?this.e[u]===this.g[f]:!0}q(u,f){if(!this.p(u,f))return!1;const e=v.r(this.b,u),i=v.r(this.c,f);return e===i}static r(u,f){return typeof u.getStrictElement=="function"?u.getStrictElement(f):null}s(u,f){return this.f[u]!==this.f[f]?!1:this.d?this.e[u]===this.e[f]:!0}u(u,f){return this.h[u]!==this.h[f]?!1:this.d?this.g[u]===this.g[f]:!0}ComputeDiff(u){return this.v(0,this.f.length-1,0,this.h.length-1,u)}v(u,f,e,i,r){const h=[!1];let g=this.w(u,f,e,i,h);return r&&(g=this.z(g)),{quitEarly:h[0],changes:g}}w(u,f,e,i,r){for(r[0]=!1;u<=f&&e<=i&&this.p(u,e);)u++,e++;for(;f>=u&&i>=e&&this.p(f,i);)f--,i--;if(u>f||e>i){let o;return e<=i?(A.Assert(u===f+1,"originalStart should only be one more than originalEnd"),o=[new n.$ft(u,0,e,i-e+1)]):u<=f?(A.Assert(e===i+1,"modifiedStart should only be one more than modifiedEnd"),o=[new n.$ft(u,f-u+1,e,0)]):(A.Assert(u===f+1,"originalStart should only be one more than originalEnd"),A.Assert(e===i+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const h=[0],g=[0],w=this.y(u,f,e,i,h,g,r),a=h[0],d=g[0];if(w!==null)return w;if(!r[0]){const o=this.w(u,a,e,d,r);let C=[];return r[0]?C=[new n.$ft(a+1,f-(a+1)+1,d+1,i-(d+1)+1)]:C=this.w(a+1,f,d+1,i,r),this.H(o,C)}return[new n.$ft(u,f-u+1,e,i-e+1)]}x(u,f,e,i,r,h,g,w,a,d,o,C,N,O,P,L,$,M){let V=null,I=null,j=new b,T=f,K=e,Z=N[0]-L[0]-i,ce=-1073741824,re=this.k.length-1;do{const te=Z+u;te===T||te<K&&a[te-1]<a[te+1]?(o=a[te+1],O=o-Z-i,o<ce&&j.MarkNextChange(),ce=o,j.AddModifiedElement(o+1,O),Z=te+1-u):(o=a[te-1]+1,O=o-Z-i,o<ce&&j.MarkNextChange(),ce=o-1,j.AddOriginalElement(o,O+1),Z=te-1-u),re>=0&&(a=this.k[re],u=a[0],T=1,K=a.length-1)}while(--re>=-1);if(V=j.getReverseChanges(),M[0]){let te=N[0]+1,$e=L[0]+1;if(V!==null&&V.length>0){const De=V[V.length-1];te=Math.max(te,De.getOriginalEnd()),$e=Math.max($e,De.getModifiedEnd())}I=[new n.$ft(te,C-te+1,$e,P-$e+1)]}else{j=new b,T=h,K=g,Z=N[0]-L[0]-w,ce=1073741824,re=$?this.m.length-1:this.m.length-2;do{const te=Z+r;te===T||te<K&&d[te-1]>=d[te+1]?(o=d[te+1]-1,O=o-Z-w,o>ce&&j.MarkNextChange(),ce=o+1,j.AddOriginalElement(o+1,O+1),Z=te+1-r):(o=d[te-1],O=o-Z-w,o>ce&&j.MarkNextChange(),ce=o,j.AddModifiedElement(o+1,O+1),Z=te-1-r),re>=0&&(d=this.m[re],r=d[0],T=1,K=d.length-1)}while(--re>=-1);I=j.getChanges()}return this.H(V,I)}y(u,f,e,i,r,h,g){let w=0,a=0,d=0,o=0,C=0,N=0;u--,e--,r[0]=0,h[0]=0,this.k=[],this.m=[];const O=f-u+(i-e),P=O+1,L=new Int32Array(P),$=new Int32Array(P),M=i-e,V=f-u,I=u-e,j=f-i,K=(V-M)%2===0;L[M]=u,$[V]=f,g[0]=!1;for(let Z=1;Z<=O/2+1;Z++){let ce=0,re=0;d=this.J(M-Z,Z,M,P),o=this.J(M+Z,Z,M,P);for(let $e=d;$e<=o;$e+=2){$e===d||$e<o&&L[$e-1]<L[$e+1]?w=L[$e+1]:w=L[$e-1]+1,a=w-($e-M)-I;const De=w;for(;w<f&&a<i&&this.p(w+1,a+1);)w++,a++;if(L[$e]=w,w+a>ce+re&&(ce=w,re=a),!K&&Math.abs($e-V)<=Z-1&&w>=$[$e])return r[0]=w,h[0]=a,De<=$[$e]&&1447>0&&Z<=1448?this.x(M,d,o,I,V,C,N,j,L,$,w,f,r,a,i,h,K,g):null}const te=(ce-u+(re-e)-Z)/2;if(this.a!==null&&!this.a(ce,te))return g[0]=!0,r[0]=ce,h[0]=re,te>0&&1447>0&&Z<=1448?this.x(M,d,o,I,V,C,N,j,L,$,w,f,r,a,i,h,K,g):(u++,e++,[new n.$ft(u,f-u+1,e,i-e+1)]);C=this.J(V-Z,Z,V,P),N=this.J(V+Z,Z,V,P);for(let $e=C;$e<=N;$e+=2){$e===C||$e<N&&$[$e-1]>=$[$e+1]?w=$[$e+1]-1:w=$[$e-1],a=w-($e-V)-j;const De=w;for(;w>u&&a>e&&this.p(w,a);)w--,a--;if($[$e]=w,K&&Math.abs($e-M)<=Z&&w<=L[$e])return r[0]=w,h[0]=a,De>=L[$e]&&1447>0&&Z<=1448?this.x(M,d,o,I,V,C,N,j,L,$,w,f,r,a,i,h,K,g):null}if(Z<=1447){let $e=new Int32Array(o-d+2);$e[0]=M-d+1,k.Copy2(L,d,$e,1,o-d+1),this.k.push($e),$e=new Int32Array(N-C+2),$e[0]=V-C+1,k.Copy2($,C,$e,1,N-C+1),this.m.push($e)}}return this.x(M,d,o,I,V,C,N,j,L,$,w,f,r,a,i,h,K,g)}z(u){for(let f=0;f<u.length;f++){const e=u[f],i=f<u.length-1?u[f+1].originalStart:this.f.length,r=f<u.length-1?u[f+1].modifiedStart:this.h.length,h=e.originalLength>0,g=e.modifiedLength>0;for(;e.originalStart+e.originalLength<i&&e.modifiedStart+e.modifiedLength<r&&(!h||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!g||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const w=[null];if(f<u.length-1&&this.I(u[f],u[f+1],w)){u[f]=w[0],u.splice(f+1,1),f--;continue}}for(let f=u.length-1;f>=0;f--){const e=u[f];let i=0,r=0;if(f>0){const o=u[f-1];i=o.originalStart+o.originalLength,r=o.modifiedStart+o.modifiedLength}const h=e.originalLength>0,g=e.modifiedLength>0;let w=0,a=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const C=e.originalStart-o,N=e.modifiedStart-o;if(C<i||N<r||h&&!this.s(C,C+e.originalLength)||g&&!this.u(N,N+e.modifiedLength))break;const P=(C===i&&N===r?5:0)+this.G(C,e.originalLength,N,e.modifiedLength);P>a&&(a=P,w=o)}e.originalStart-=w,e.modifiedStart-=w;const d=[null];if(f>0&&this.I(u[f-1],u[f],d)){u[f-1]=d[0],u.splice(f,1),f++;continue}}if(this.d)for(let f=1,e=u.length;f<e;f++){const i=u[f-1],r=u[f],h=r.originalStart-i.originalStart-i.originalLength,g=i.originalStart,w=r.originalStart+r.originalLength,a=w-g,d=i.modifiedStart,o=r.modifiedStart+r.modifiedLength,C=o-d;if(h<5&&a<20&&C<20){const N=this.A(g,a,d,C,h);if(N){const[O,P]=N;(O!==i.originalStart+i.originalLength||P!==i.modifiedStart+i.modifiedLength)&&(i.originalLength=O-i.originalStart,i.modifiedLength=P-i.modifiedStart,r.originalStart=O+h,r.modifiedStart=P+h,r.originalLength=w-r.originalStart,r.modifiedLength=o-r.modifiedStart)}}}return u}A(u,f,e,i,r){if(f<r||i<r)return null;const h=u+f-r+1,g=e+i-r+1;let w=0,a=0,d=0;for(let o=u;o<h;o++)for(let C=e;C<g;C++){const N=this.B(o,C,r);N>0&&N>w&&(w=N,a=o,d=C)}return w>0?[a,d]:null}B(u,f,e){let i=0;for(let r=0;r<e;r++){if(!this.p(u+r,f+r))return 0;i+=this.e[u+r].length}return i}C(u){return u<=0||u>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[u])}D(u,f){if(this.C(u)||this.C(u-1))return!0;if(f>0){const e=u+f;if(this.C(e-1)||this.C(e))return!0}return!1}E(u){return u<=0||u>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[u])}F(u,f){if(this.E(u)||this.E(u-1))return!0;if(f>0){const e=u+f;if(this.E(e-1)||this.E(e))return!0}return!1}G(u,f,e,i){const r=this.D(u,f)?1:0,h=this.F(e,i)?1:0;return r+h}H(u,f){const e=[];if(u.length===0||f.length===0)return f.length>0?f:u;if(this.I(u[u.length-1],f[0],e)){const i=new Array(u.length+f.length-1);return k.Copy(u,0,i,0,u.length-1),i[u.length-1]=e[0],k.Copy(f,1,i,u.length,f.length-1),i}else{const i=new Array(u.length+f.length);return k.Copy(u,0,i,0,u.length),k.Copy(f,0,i,u.length,f.length),i}}I(u,f,e){if(A.Assert(u.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),A.Assert(u.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),u.originalStart+u.originalLength>=f.originalStart||u.modifiedStart+u.modifiedLength>=f.modifiedStart){const i=u.originalStart;let r=u.originalLength;const h=u.modifiedStart;let g=u.modifiedLength;return u.originalStart+u.originalLength>=f.originalStart&&(r=f.originalStart+f.originalLength-u.originalStart),u.modifiedStart+u.modifiedLength>=f.modifiedStart&&(g=f.modifiedStart+f.modifiedLength-u.modifiedStart),e[0]=new n.$ft(i,r,h,g),!0}else return e[0]=null,!1}J(u,f,e,i){if(u>=0&&u<i)return u;const r=e,h=i-e-1,g=f%2===0;if(u<0){const w=r%2===0;return g===w?0:1}else{const w=h%2===0;return g===w?i-1:i-2}}}t.$it=v}),define(ge[60],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=void 0,t.$4d=Symbol("MicrotaskDelay")}),define(ge[99],be([1,0,12,10]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oi=t.$ni=t.$mi=t.$li=t.$ki=void 0;class B{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const e=f.charCodeAt(0),i=this.b.charCodeAt(this.c);return e-i}value(){return this.b[this.c]}}t.$ki=B;class W{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,F.$ff)(f,this.b,0,f.length,this.c,this.d):(0,F.$hf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$li=W;class A{constructor(f=!0,e=!0){this.f=f,this.g=e}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let e=f.length-1;e>=0;e--,this.c--){const i=this.b.charCodeAt(e);if(!(i===47||this.f&&i===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,F.$ff)(f,this.b,0,f.length,this.d,this.e):(0,F.$hf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$mi=A;var k;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(k||(k={}));class m{constructor(f,e){this.f=f,this.g=e,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,F.$gf)(f,this.c.scheme);if(this.d[this.e]===2)return(0,F.$gf)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,F.$ef)(f,this.c.query);if(this.d[this.e]===5)return(0,F.$ef)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$ni=m;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(v||(v={}));class z{static forUris(f=()=>!1,e=()=>!1){return new z(new m(f,e))}static forPaths(f=!1){return new z(new A(void 0,!f))}static forStrings(){return new z(new B)}static forConfigKeys(){return new z(new W)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,e){if(e){const i=e.slice(0);(0,n.$Xb)(i);for(const r of i)this.set(r,f)}else{const i=f.slice(0);(0,n.$Xb)(i);for(const r of i)this.set(r[0],r[1])}}set(f,e){const i=this.b.reset(f);let r;this.c||(this.c=new b,this.c.segment=i.value());const h=[];for(r=this.c;;){const w=i.cmp(r.segment);if(w>0)r.left||(r.left=new b,r.left.segment=i.value()),h.push([-1,r]),r=r.left;else if(w<0)r.right||(r.right=new b,r.right.segment=i.value()),h.push([1,r]),r=r.right;else if(i.hasNext())i.next(),r.mid||(r.mid=new b,r.mid.segment=i.value()),h.push([0,r]),r=r.mid;else break}const g=r.value;r.value=e,r.key=f;for(let w=h.length-1;w>=0;w--){const a=h[w][1];a.updateHeight();const d=a.balanceFactor();if(d<-1||d>1){const o=h[w][0],C=h[w+1][0];if(o===1&&C===1)h[w][1]=a.rotateLeft();else if(o===-1&&C===-1)h[w][1]=a.rotateRight();else if(o===1&&C===-1)a.right=h[w+1][1]=h[w+1][1].rotateRight(),h[w][1]=a.rotateLeft();else if(o===-1&&C===1)a.left=h[w+1][1]=h[w+1][1].rotateLeft(),h[w][1]=a.rotateRight();else throw new Error;if(w>0)switch(h[w-1][0]){case-1:h[w-1][1].left=h[w][1];break;case 1:h[w-1][1].right=h[w][1];break;case 0:h[w-1][1].mid=h[w][1];break}else this.c=h[0][1]}}return g}get(f){return this.d(f)?.value}d(f){const e=this.b.reset(f);let i=this.c;for(;i;){const r=e.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(e.hasNext())e.next(),i=i.mid;else break}return i}has(f){const e=this.d(f);return!(e?.value===void 0&&e?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,e){const i=this.b.reset(f),r=[];let h=this.c;for(;h;){const g=i.cmp(h.segment);if(g>0)r.push([-1,h]),h=h.left;else if(g<0)r.push([1,h]),h=h.right;else if(i.hasNext())i.next(),r.push([0,h]),h=h.mid;else break}if(h){if(e?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:w,value:a,segment:d}=g;this.e(g.key,!1),h.key=w,h.value=a,h.segment=d}}else{const g=h.left??h.right;if(r.length>0){const[w,a]=r[r.length-1];switch(w){case-1:a.left=g;break;case 0:a.mid=g;break;case 1:a.right=g;break}}else this.c=g}for(let g=r.length-1;g>=0;g--){const w=r[g][1];w.updateHeight();const a=w.balanceFactor();if(a>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),r[g][1]=w.rotateLeft()):a<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),r[g][1]=w.rotateRight()),g>0)switch(r[g-1][0]){case-1:r[g-1][1].left=r[g][1];break;case 1:r[g-1][1].right=r[g][1];break;case 0:r[g-1][1].mid=r[g][1];break}else this.c=r[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const e=this.b.reset(f);let i=this.c,r;for(;i;){const h=e.cmp(i.segment);if(h>0)i=i.left;else if(h<0)i=i.right;else if(e.hasNext())e.next(),r=i.value||r,i=i.mid;else break}return i&&i.value||r}findSuperstr(f){return this.g(f,!1)}g(f,e){const i=this.b.reset(f);let r=this.c;for(;r;){const h=i.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else return r.mid?this.h(r.mid):e?r.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[e,i]of this)f(i,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const e=[];return this.j(f,e),e[Symbol.iterator]()}j(f,e){f&&(f.left&&this.j(f.left,e),f.value&&e.push([f.key,f.value]),f.mid&&this.j(f.mid,e),f.right&&this.j(f.right,e))}_isBalanced(){const f=e=>{if(!e)return!0;const i=e.balanceFactor();return i<-1||i>1?!1:f(e.left)&&f(e.right)};return f(this.c)}}t.$oi=z}),define(ge[7],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vf=n,t.$Wf=F,t.$Xf=B,t.$Yf=W,t.$Zf=A,t.$1f=k,t.$2f=m,t.$3f=b,t.$4f=v,t.$5f=z,t.$6f=u,t.$7f=f,t.$8f=e,t.$9f=r,t.$0f=h,t.$$f=g,t.$_f=w,t.$ag=a;function n(d){return typeof d=="string"}function F(d){return Array.isArray(d)&&d.every(o=>n(o))}function B(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}function W(d){const o=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof o}function A(d){return typeof d=="number"&&!isNaN(d)}function k(d){return!!d&&typeof d[Symbol.iterator]=="function"}function m(d){return d===!0||d===!1}function b(d){return typeof d>"u"}function v(d){return!z(d)}function z(d){return b(d)||d===null}function u(d,o){if(!d)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}function f(d){if(z(d))throw new Error("Assertion Failed: argument is undefined or null");return d}function e(...d){const o=[];for(let C=0;C<d.length;C++){const N=d[C];if(z(N))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);o.push(N)}return o}const i=Object.prototype.hasOwnProperty;function r(d){if(!B(d))return!1;for(const o in d)if(i.call(d,o))return!1;return!0}function h(d){return typeof d=="function"}function g(...d){return d.length>0&&d.every(h)}function w(d,o){const C=Math.min(d.length,o.length);for(let N=0;N<C;N++)a(d[N],o[N])}function a(d,o){if(n(o)){if(typeof d!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(h(o)){try{if(d instanceof o)return}catch{}if(!z(d)&&d.constructor===o||o.length===1&&o.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ge[44],be([1,0,7]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=B,t.$Dj=W;const F=Object.create(null);function B(A,k){if((0,n.$Vf)(k)){const m=F[k];if(m===void 0)throw new Error(`${A} references an unknown codicon: ${k}`);k=m}return F[A]=k,{id:A}}function W(){return F}}),define(ge[100],be([1,0,44]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ej=void 0,t.$Ej={add:(0,n.$Cj)("add",6e4),plus:(0,n.$Cj)("plus",6e4),gistNew:(0,n.$Cj)("gist-new",6e4),repoCreate:(0,n.$Cj)("repo-create",6e4),lightbulb:(0,n.$Cj)("lightbulb",60001),lightBulb:(0,n.$Cj)("light-bulb",60001),repo:(0,n.$Cj)("repo",60002),repoDelete:(0,n.$Cj)("repo-delete",60002),gistFork:(0,n.$Cj)("gist-fork",60003),repoForked:(0,n.$Cj)("repo-forked",60003),gitPullRequest:(0,n.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Cj)("record-keys",60005),keyboard:(0,n.$Cj)("keyboard",60005),tag:(0,n.$Cj)("tag",60006),gitPullRequestLabel:(0,n.$Cj)("git-pull-request-label",60006),tagAdd:(0,n.$Cj)("tag-add",60006),tagRemove:(0,n.$Cj)("tag-remove",60006),person:(0,n.$Cj)("person",60007),personFollow:(0,n.$Cj)("person-follow",60007),personOutline:(0,n.$Cj)("person-outline",60007),personFilled:(0,n.$Cj)("person-filled",60007),gitBranch:(0,n.$Cj)("git-branch",60008),gitBranchCreate:(0,n.$Cj)("git-branch-create",60008),gitBranchDelete:(0,n.$Cj)("git-branch-delete",60008),sourceControl:(0,n.$Cj)("source-control",60008),mirror:(0,n.$Cj)("mirror",60009),mirrorPublic:(0,n.$Cj)("mirror-public",60009),star:(0,n.$Cj)("star",60010),starAdd:(0,n.$Cj)("star-add",60010),starDelete:(0,n.$Cj)("star-delete",60010),starEmpty:(0,n.$Cj)("star-empty",60010),comment:(0,n.$Cj)("comment",60011),commentAdd:(0,n.$Cj)("comment-add",60011),alert:(0,n.$Cj)("alert",60012),warning:(0,n.$Cj)("warning",60012),search:(0,n.$Cj)("search",60013),searchSave:(0,n.$Cj)("search-save",60013),logOut:(0,n.$Cj)("log-out",60014),signOut:(0,n.$Cj)("sign-out",60014),logIn:(0,n.$Cj)("log-in",60015),signIn:(0,n.$Cj)("sign-in",60015),eye:(0,n.$Cj)("eye",60016),eyeUnwatch:(0,n.$Cj)("eye-unwatch",60016),eyeWatch:(0,n.$Cj)("eye-watch",60016),circleFilled:(0,n.$Cj)("circle-filled",60017),primitiveDot:(0,n.$Cj)("primitive-dot",60017),closeDirty:(0,n.$Cj)("close-dirty",60017),debugBreakpoint:(0,n.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Cj)("primitive-square",60018),edit:(0,n.$Cj)("edit",60019),pencil:(0,n.$Cj)("pencil",60019),info:(0,n.$Cj)("info",60020),issueOpened:(0,n.$Cj)("issue-opened",60020),gistPrivate:(0,n.$Cj)("gist-private",60021),gitForkPrivate:(0,n.$Cj)("git-fork-private",60021),lock:(0,n.$Cj)("lock",60021),mirrorPrivate:(0,n.$Cj)("mirror-private",60021),close:(0,n.$Cj)("close",60022),removeClose:(0,n.$Cj)("remove-close",60022),x:(0,n.$Cj)("x",60022),repoSync:(0,n.$Cj)("repo-sync",60023),sync:(0,n.$Cj)("sync",60023),clone:(0,n.$Cj)("clone",60024),desktopDownload:(0,n.$Cj)("desktop-download",60024),beaker:(0,n.$Cj)("beaker",60025),microscope:(0,n.$Cj)("microscope",60025),vm:(0,n.$Cj)("vm",60026),deviceDesktop:(0,n.$Cj)("device-desktop",60026),file:(0,n.$Cj)("file",60027),fileText:(0,n.$Cj)("file-text",60027),more:(0,n.$Cj)("more",60028),ellipsis:(0,n.$Cj)("ellipsis",60028),kebabHorizontal:(0,n.$Cj)("kebab-horizontal",60028),mailReply:(0,n.$Cj)("mail-reply",60029),reply:(0,n.$Cj)("reply",60029),organization:(0,n.$Cj)("organization",60030),organizationFilled:(0,n.$Cj)("organization-filled",60030),organizationOutline:(0,n.$Cj)("organization-outline",60030),newFile:(0,n.$Cj)("new-file",60031),fileAdd:(0,n.$Cj)("file-add",60031),newFolder:(0,n.$Cj)("new-folder",60032),fileDirectoryCreate:(0,n.$Cj)("file-directory-create",60032),trash:(0,n.$Cj)("trash",60033),trashcan:(0,n.$Cj)("trashcan",60033),history:(0,n.$Cj)("history",60034),clock:(0,n.$Cj)("clock",60034),folder:(0,n.$Cj)("folder",60035),fileDirectory:(0,n.$Cj)("file-directory",60035),symbolFolder:(0,n.$Cj)("symbol-folder",60035),logoGithub:(0,n.$Cj)("logo-github",60036),markGithub:(0,n.$Cj)("mark-github",60036),github:(0,n.$Cj)("github",60036),terminal:(0,n.$Cj)("terminal",60037),console:(0,n.$Cj)("console",60037),repl:(0,n.$Cj)("repl",60037),zap:(0,n.$Cj)("zap",60038),symbolEvent:(0,n.$Cj)("symbol-event",60038),error:(0,n.$Cj)("error",60039),stop:(0,n.$Cj)("stop",60039),variable:(0,n.$Cj)("variable",60040),symbolVariable:(0,n.$Cj)("symbol-variable",60040),array:(0,n.$Cj)("array",60042),symbolArray:(0,n.$Cj)("symbol-array",60042),symbolModule:(0,n.$Cj)("symbol-module",60043),symbolPackage:(0,n.$Cj)("symbol-package",60043),symbolNamespace:(0,n.$Cj)("symbol-namespace",60043),symbolObject:(0,n.$Cj)("symbol-object",60043),symbolMethod:(0,n.$Cj)("symbol-method",60044),symbolFunction:(0,n.$Cj)("symbol-function",60044),symbolConstructor:(0,n.$Cj)("symbol-constructor",60044),symbolBoolean:(0,n.$Cj)("symbol-boolean",60047),symbolNull:(0,n.$Cj)("symbol-null",60047),symbolNumeric:(0,n.$Cj)("symbol-numeric",60048),symbolNumber:(0,n.$Cj)("symbol-number",60048),symbolStructure:(0,n.$Cj)("symbol-structure",60049),symbolStruct:(0,n.$Cj)("symbol-struct",60049),symbolParameter:(0,n.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Cj)("symbol-type-parameter",60050),symbolKey:(0,n.$Cj)("symbol-key",60051),symbolText:(0,n.$Cj)("symbol-text",60051),symbolReference:(0,n.$Cj)("symbol-reference",60052),goToFile:(0,n.$Cj)("go-to-file",60052),symbolEnum:(0,n.$Cj)("symbol-enum",60053),symbolValue:(0,n.$Cj)("symbol-value",60053),symbolRuler:(0,n.$Cj)("symbol-ruler",60054),symbolUnit:(0,n.$Cj)("symbol-unit",60054),activateBreakpoints:(0,n.$Cj)("activate-breakpoints",60055),archive:(0,n.$Cj)("archive",60056),arrowBoth:(0,n.$Cj)("arrow-both",60057),arrowDown:(0,n.$Cj)("arrow-down",60058),arrowLeft:(0,n.$Cj)("arrow-left",60059),arrowRight:(0,n.$Cj)("arrow-right",60060),arrowSmallDown:(0,n.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Cj)("arrow-small-up",60064),arrowUp:(0,n.$Cj)("arrow-up",60065),bell:(0,n.$Cj)("bell",60066),bold:(0,n.$Cj)("bold",60067),book:(0,n.$Cj)("book",60068),bookmark:(0,n.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Cj)("briefcase",60076),broadcast:(0,n.$Cj)("broadcast",60077),browser:(0,n.$Cj)("browser",60078),bug:(0,n.$Cj)("bug",60079),calendar:(0,n.$Cj)("calendar",60080),caseSensitive:(0,n.$Cj)("case-sensitive",60081),check:(0,n.$Cj)("check",60082),checklist:(0,n.$Cj)("checklist",60083),chevronDown:(0,n.$Cj)("chevron-down",60084),chevronLeft:(0,n.$Cj)("chevron-left",60085),chevronRight:(0,n.$Cj)("chevron-right",60086),chevronUp:(0,n.$Cj)("chevron-up",60087),chromeClose:(0,n.$Cj)("chrome-close",60088),chromeMaximize:(0,n.$Cj)("chrome-maximize",60089),chromeMinimize:(0,n.$Cj)("chrome-minimize",60090),chromeRestore:(0,n.$Cj)("chrome-restore",60091),circleOutline:(0,n.$Cj)("circle-outline",60092),circle:(0,n.$Cj)("circle",60092),debugBreakpointUnverified:(0,n.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Cj)("circle-slash",60093),circuitBoard:(0,n.$Cj)("circuit-board",60094),clearAll:(0,n.$Cj)("clear-all",60095),clippy:(0,n.$Cj)("clippy",60096),closeAll:(0,n.$Cj)("close-all",60097),cloudDownload:(0,n.$Cj)("cloud-download",60098),cloudUpload:(0,n.$Cj)("cloud-upload",60099),code:(0,n.$Cj)("code",60100),collapseAll:(0,n.$Cj)("collapse-all",60101),colorMode:(0,n.$Cj)("color-mode",60102),commentDiscussion:(0,n.$Cj)("comment-discussion",60103),creditCard:(0,n.$Cj)("credit-card",60105),dash:(0,n.$Cj)("dash",60108),dashboard:(0,n.$Cj)("dashboard",60109),database:(0,n.$Cj)("database",60110),debugContinue:(0,n.$Cj)("debug-continue",60111),debugDisconnect:(0,n.$Cj)("debug-disconnect",60112),debugPause:(0,n.$Cj)("debug-pause",60113),debugRestart:(0,n.$Cj)("debug-restart",60114),debugStart:(0,n.$Cj)("debug-start",60115),debugStepInto:(0,n.$Cj)("debug-step-into",60116),debugStepOut:(0,n.$Cj)("debug-step-out",60117),debugStepOver:(0,n.$Cj)("debug-step-over",60118),debugStop:(0,n.$Cj)("debug-stop",60119),debug:(0,n.$Cj)("debug",60120),deviceCameraVideo:(0,n.$Cj)("device-camera-video",60121),deviceCamera:(0,n.$Cj)("device-camera",60122),deviceMobile:(0,n.$Cj)("device-mobile",60123),diffAdded:(0,n.$Cj)("diff-added",60124),diffIgnored:(0,n.$Cj)("diff-ignored",60125),diffModified:(0,n.$Cj)("diff-modified",60126),diffRemoved:(0,n.$Cj)("diff-removed",60127),diffRenamed:(0,n.$Cj)("diff-renamed",60128),diff:(0,n.$Cj)("diff",60129),diffSidebyside:(0,n.$Cj)("diff-sidebyside",60129),discard:(0,n.$Cj)("discard",60130),editorLayout:(0,n.$Cj)("editor-layout",60131),emptyWindow:(0,n.$Cj)("empty-window",60132),exclude:(0,n.$Cj)("exclude",60133),extensions:(0,n.$Cj)("extensions",60134),eyeClosed:(0,n.$Cj)("eye-closed",60135),fileBinary:(0,n.$Cj)("file-binary",60136),fileCode:(0,n.$Cj)("file-code",60137),fileMedia:(0,n.$Cj)("file-media",60138),filePdf:(0,n.$Cj)("file-pdf",60139),fileSubmodule:(0,n.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Cj)("file-symlink-file",60142),fileZip:(0,n.$Cj)("file-zip",60143),files:(0,n.$Cj)("files",60144),filter:(0,n.$Cj)("filter",60145),flame:(0,n.$Cj)("flame",60146),foldDown:(0,n.$Cj)("fold-down",60147),foldUp:(0,n.$Cj)("fold-up",60148),fold:(0,n.$Cj)("fold",60149),folderActive:(0,n.$Cj)("folder-active",60150),folderOpened:(0,n.$Cj)("folder-opened",60151),gear:(0,n.$Cj)("gear",60152),gift:(0,n.$Cj)("gift",60153),gistSecret:(0,n.$Cj)("gist-secret",60154),gist:(0,n.$Cj)("gist",60155),gitCommit:(0,n.$Cj)("git-commit",60156),gitCompare:(0,n.$Cj)("git-compare",60157),compareChanges:(0,n.$Cj)("compare-changes",60157),gitMerge:(0,n.$Cj)("git-merge",60158),githubAction:(0,n.$Cj)("github-action",60159),githubAlt:(0,n.$Cj)("github-alt",60160),globe:(0,n.$Cj)("globe",60161),grabber:(0,n.$Cj)("grabber",60162),graph:(0,n.$Cj)("graph",60163),gripper:(0,n.$Cj)("gripper",60164),heart:(0,n.$Cj)("heart",60165),home:(0,n.$Cj)("home",60166),horizontalRule:(0,n.$Cj)("horizontal-rule",60167),hubot:(0,n.$Cj)("hubot",60168),inbox:(0,n.$Cj)("inbox",60169),issueReopened:(0,n.$Cj)("issue-reopened",60171),issues:(0,n.$Cj)("issues",60172),italic:(0,n.$Cj)("italic",60173),jersey:(0,n.$Cj)("jersey",60174),json:(0,n.$Cj)("json",60175),kebabVertical:(0,n.$Cj)("kebab-vertical",60176),key:(0,n.$Cj)("key",60177),law:(0,n.$Cj)("law",60178),lightbulbAutofix:(0,n.$Cj)("lightbulb-autofix",60179),linkExternal:(0,n.$Cj)("link-external",60180),link:(0,n.$Cj)("link",60181),listOrdered:(0,n.$Cj)("list-ordered",60182),listUnordered:(0,n.$Cj)("list-unordered",60183),liveShare:(0,n.$Cj)("live-share",60184),loading:(0,n.$Cj)("loading",60185),location:(0,n.$Cj)("location",60186),mailRead:(0,n.$Cj)("mail-read",60187),mail:(0,n.$Cj)("mail",60188),markdown:(0,n.$Cj)("markdown",60189),megaphone:(0,n.$Cj)("megaphone",60190),mention:(0,n.$Cj)("mention",60191),milestone:(0,n.$Cj)("milestone",60192),gitPullRequestMilestone:(0,n.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Cj)("mortar-board",60193),move:(0,n.$Cj)("move",60194),multipleWindows:(0,n.$Cj)("multiple-windows",60195),mute:(0,n.$Cj)("mute",60196),noNewline:(0,n.$Cj)("no-newline",60197),note:(0,n.$Cj)("note",60198),octoface:(0,n.$Cj)("octoface",60199),openPreview:(0,n.$Cj)("open-preview",60200),package:(0,n.$Cj)("package",60201),paintcan:(0,n.$Cj)("paintcan",60202),pin:(0,n.$Cj)("pin",60203),play:(0,n.$Cj)("play",60204),run:(0,n.$Cj)("run",60204),plug:(0,n.$Cj)("plug",60205),preserveCase:(0,n.$Cj)("preserve-case",60206),preview:(0,n.$Cj)("preview",60207),project:(0,n.$Cj)("project",60208),pulse:(0,n.$Cj)("pulse",60209),question:(0,n.$Cj)("question",60210),quote:(0,n.$Cj)("quote",60211),radioTower:(0,n.$Cj)("radio-tower",60212),reactions:(0,n.$Cj)("reactions",60213),references:(0,n.$Cj)("references",60214),refresh:(0,n.$Cj)("refresh",60215),regex:(0,n.$Cj)("regex",60216),remoteExplorer:(0,n.$Cj)("remote-explorer",60217),remote:(0,n.$Cj)("remote",60218),remove:(0,n.$Cj)("remove",60219),replaceAll:(0,n.$Cj)("replace-all",60220),replace:(0,n.$Cj)("replace",60221),repoClone:(0,n.$Cj)("repo-clone",60222),repoForcePush:(0,n.$Cj)("repo-force-push",60223),repoPull:(0,n.$Cj)("repo-pull",60224),repoPush:(0,n.$Cj)("repo-push",60225),report:(0,n.$Cj)("report",60226),requestChanges:(0,n.$Cj)("request-changes",60227),rocket:(0,n.$Cj)("rocket",60228),rootFolderOpened:(0,n.$Cj)("root-folder-opened",60229),rootFolder:(0,n.$Cj)("root-folder",60230),rss:(0,n.$Cj)("rss",60231),ruby:(0,n.$Cj)("ruby",60232),saveAll:(0,n.$Cj)("save-all",60233),saveAs:(0,n.$Cj)("save-as",60234),save:(0,n.$Cj)("save",60235),screenFull:(0,n.$Cj)("screen-full",60236),screenNormal:(0,n.$Cj)("screen-normal",60237),searchStop:(0,n.$Cj)("search-stop",60238),server:(0,n.$Cj)("server",60240),settingsGear:(0,n.$Cj)("settings-gear",60241),settings:(0,n.$Cj)("settings",60242),shield:(0,n.$Cj)("shield",60243),smiley:(0,n.$Cj)("smiley",60244),sortPrecedence:(0,n.$Cj)("sort-precedence",60245),splitHorizontal:(0,n.$Cj)("split-horizontal",60246),splitVertical:(0,n.$Cj)("split-vertical",60247),squirrel:(0,n.$Cj)("squirrel",60248),starFull:(0,n.$Cj)("star-full",60249),starHalf:(0,n.$Cj)("star-half",60250),symbolClass:(0,n.$Cj)("symbol-class",60251),symbolColor:(0,n.$Cj)("symbol-color",60252),symbolConstant:(0,n.$Cj)("symbol-constant",60253),symbolEnumMember:(0,n.$Cj)("symbol-enum-member",60254),symbolField:(0,n.$Cj)("symbol-field",60255),symbolFile:(0,n.$Cj)("symbol-file",60256),symbolInterface:(0,n.$Cj)("symbol-interface",60257),symbolKeyword:(0,n.$Cj)("symbol-keyword",60258),symbolMisc:(0,n.$Cj)("symbol-misc",60259),symbolOperator:(0,n.$Cj)("symbol-operator",60260),symbolProperty:(0,n.$Cj)("symbol-property",60261),wrench:(0,n.$Cj)("wrench",60261),wrenchSubaction:(0,n.$Cj)("wrench-subaction",60261),symbolSnippet:(0,n.$Cj)("symbol-snippet",60262),tasklist:(0,n.$Cj)("tasklist",60263),telescope:(0,n.$Cj)("telescope",60264),textSize:(0,n.$Cj)("text-size",60265),threeBars:(0,n.$Cj)("three-bars",60266),thumbsdown:(0,n.$Cj)("thumbsdown",60267),thumbsup:(0,n.$Cj)("thumbsup",60268),tools:(0,n.$Cj)("tools",60269),triangleDown:(0,n.$Cj)("triangle-down",60270),triangleLeft:(0,n.$Cj)("triangle-left",60271),triangleRight:(0,n.$Cj)("triangle-right",60272),triangleUp:(0,n.$Cj)("triangle-up",60273),twitter:(0,n.$Cj)("twitter",60274),unfold:(0,n.$Cj)("unfold",60275),unlock:(0,n.$Cj)("unlock",60276),unmute:(0,n.$Cj)("unmute",60277),unverified:(0,n.$Cj)("unverified",60278),verified:(0,n.$Cj)("verified",60279),versions:(0,n.$Cj)("versions",60280),vmActive:(0,n.$Cj)("vm-active",60281),vmOutline:(0,n.$Cj)("vm-outline",60282),vmRunning:(0,n.$Cj)("vm-running",60283),watch:(0,n.$Cj)("watch",60284),whitespace:(0,n.$Cj)("whitespace",60285),wholeWord:(0,n.$Cj)("whole-word",60286),window:(0,n.$Cj)("window",60287),wordWrap:(0,n.$Cj)("word-wrap",60288),zoomIn:(0,n.$Cj)("zoom-in",60289),zoomOut:(0,n.$Cj)("zoom-out",60290),listFilter:(0,n.$Cj)("list-filter",60291),listFlat:(0,n.$Cj)("list-flat",60292),listSelection:(0,n.$Cj)("list-selection",60293),selection:(0,n.$Cj)("selection",60293),listTree:(0,n.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Cj)("symbol-string",60301),debugReverseContinue:(0,n.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Cj)("debug-step-back",60303),debugRestartFrame:(0,n.$Cj)("debug-restart-frame",60304),debugAlt:(0,n.$Cj)("debug-alt",60305),callIncoming:(0,n.$Cj)("call-incoming",60306),callOutgoing:(0,n.$Cj)("call-outgoing",60307),menu:(0,n.$Cj)("menu",60308),expandAll:(0,n.$Cj)("expand-all",60309),feedback:(0,n.$Cj)("feedback",60310),gitPullRequestReviewer:(0,n.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Cj)("ungroup-by-ref-type",60312),account:(0,n.$Cj)("account",60313),gitPullRequestAssignee:(0,n.$Cj)("git-pull-request-assignee",60313),bellDot:(0,n.$Cj)("bell-dot",60314),debugConsole:(0,n.$Cj)("debug-console",60315),library:(0,n.$Cj)("library",60316),output:(0,n.$Cj)("output",60317),runAll:(0,n.$Cj)("run-all",60318),syncIgnored:(0,n.$Cj)("sync-ignored",60319),pinned:(0,n.$Cj)("pinned",60320),githubInverted:(0,n.$Cj)("github-inverted",60321),serverProcess:(0,n.$Cj)("server-process",60322),serverEnvironment:(0,n.$Cj)("server-environment",60323),pass:(0,n.$Cj)("pass",60324),issueClosed:(0,n.$Cj)("issue-closed",60324),stopCircle:(0,n.$Cj)("stop-circle",60325),playCircle:(0,n.$Cj)("play-circle",60326),record:(0,n.$Cj)("record",60327),debugAltSmall:(0,n.$Cj)("debug-alt-small",60328),vmConnect:(0,n.$Cj)("vm-connect",60329),cloud:(0,n.$Cj)("cloud",60330),merge:(0,n.$Cj)("merge",60331),export:(0,n.$Cj)("export",60332),graphLeft:(0,n.$Cj)("graph-left",60333),magnet:(0,n.$Cj)("magnet",60334),notebook:(0,n.$Cj)("notebook",60335),redo:(0,n.$Cj)("redo",60336),checkAll:(0,n.$Cj)("check-all",60337),pinnedDirty:(0,n.$Cj)("pinned-dirty",60338),passFilled:(0,n.$Cj)("pass-filled",60339),circleLargeFilled:(0,n.$Cj)("circle-large-filled",60340),circleLarge:(0,n.$Cj)("circle-large",60341),circleLargeOutline:(0,n.$Cj)("circle-large-outline",60341),combine:(0,n.$Cj)("combine",60342),gather:(0,n.$Cj)("gather",60342),table:(0,n.$Cj)("table",60343),variableGroup:(0,n.$Cj)("variable-group",60344),typeHierarchy:(0,n.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Cj)("git-pull-request-create",60348),runAbove:(0,n.$Cj)("run-above",60349),runBelow:(0,n.$Cj)("run-below",60350),notebookTemplate:(0,n.$Cj)("notebook-template",60351),debugRerun:(0,n.$Cj)("debug-rerun",60352),workspaceTrusted:(0,n.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Cj)("workspace-unknown",60355),terminalCmd:(0,n.$Cj)("terminal-cmd",60356),terminalDebian:(0,n.$Cj)("terminal-debian",60357),terminalLinux:(0,n.$Cj)("terminal-linux",60358),terminalPowershell:(0,n.$Cj)("terminal-powershell",60359),terminalTmux:(0,n.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Cj)("terminal-ubuntu",60361),terminalBash:(0,n.$Cj)("terminal-bash",60362),arrowSwap:(0,n.$Cj)("arrow-swap",60363),copy:(0,n.$Cj)("copy",60364),personAdd:(0,n.$Cj)("person-add",60365),filterFilled:(0,n.$Cj)("filter-filled",60366),wand:(0,n.$Cj)("wand",60367),debugLineByLine:(0,n.$Cj)("debug-line-by-line",60368),inspect:(0,n.$Cj)("inspect",60369),layers:(0,n.$Cj)("layers",60370),layersDot:(0,n.$Cj)("layers-dot",60371),layersActive:(0,n.$Cj)("layers-active",60372),compass:(0,n.$Cj)("compass",60373),compassDot:(0,n.$Cj)("compass-dot",60374),compassActive:(0,n.$Cj)("compass-active",60375),azure:(0,n.$Cj)("azure",60376),issueDraft:(0,n.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Cj)("git-pull-request-draft",60379),debugAll:(0,n.$Cj)("debug-all",60380),debugCoverage:(0,n.$Cj)("debug-coverage",60381),runErrors:(0,n.$Cj)("run-errors",60382),folderLibrary:(0,n.$Cj)("folder-library",60383),debugContinueSmall:(0,n.$Cj)("debug-continue-small",60384),beakerStop:(0,n.$Cj)("beaker-stop",60385),graphLine:(0,n.$Cj)("graph-line",60386),graphScatter:(0,n.$Cj)("graph-scatter",60387),pieChart:(0,n.$Cj)("pie-chart",60388),bracket:(0,n.$Cj)("bracket",60175),bracketDot:(0,n.$Cj)("bracket-dot",60389),bracketError:(0,n.$Cj)("bracket-error",60390),lockSmall:(0,n.$Cj)("lock-small",60391),azureDevops:(0,n.$Cj)("azure-devops",60392),verifiedFilled:(0,n.$Cj)("verified-filled",60393),newline:(0,n.$Cj)("newline",60394),layout:(0,n.$Cj)("layout",60395),layoutActivitybarLeft:(0,n.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Cj)("layout-panel-right",60401),layoutPanel:(0,n.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Cj)("layout-statusbar",60405),layoutMenubar:(0,n.$Cj)("layout-menubar",60406),layoutCentered:(0,n.$Cj)("layout-centered",60407),target:(0,n.$Cj)("target",60408),indent:(0,n.$Cj)("indent",60409),recordSmall:(0,n.$Cj)("record-small",60410),errorSmall:(0,n.$Cj)("error-small",60411),terminalDecorationError:(0,n.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Cj)("layout-sidebar-left-off",60418),blank:(0,n.$Cj)("blank",60419),heartFilled:(0,n.$Cj)("heart-filled",60420),map:(0,n.$Cj)("map",60421),mapHorizontal:(0,n.$Cj)("map-horizontal",60421),foldHorizontal:(0,n.$Cj)("fold-horizontal",60421),mapFilled:(0,n.$Cj)("map-filled",60422),mapHorizontalFilled:(0,n.$Cj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Cj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Cj)("circle-small",60423),bellSlash:(0,n.$Cj)("bell-slash",60424),bellSlashDot:(0,n.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Cj)("search-fuzzy",60429),commentDraft:(0,n.$Cj)("comment-draft",60430),send:(0,n.$Cj)("send",60431),sparkle:(0,n.$Cj)("sparkle",60432),insert:(0,n.$Cj)("insert",60433),mic:(0,n.$Cj)("mic",60434),thumbsdownFilled:(0,n.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Cj)("thumbsup-filled",60436),coffee:(0,n.$Cj)("coffee",60437),snake:(0,n.$Cj)("snake",60438),game:(0,n.$Cj)("game",60439),vr:(0,n.$Cj)("vr",60440),chip:(0,n.$Cj)("chip",60441),piano:(0,n.$Cj)("piano",60442),music:(0,n.$Cj)("music",60443),micFilled:(0,n.$Cj)("mic-filled",60444),repoFetch:(0,n.$Cj)("repo-fetch",60445),copilot:(0,n.$Cj)("copilot",60446),lightbulbSparkle:(0,n.$Cj)("lightbulb-sparkle",60447),robot:(0,n.$Cj)("robot",60448),sparkleFilled:(0,n.$Cj)("sparkle-filled",60449),diffSingle:(0,n.$Cj)("diff-single",60450),diffMultiple:(0,n.$Cj)("diff-multiple",60451),surroundWith:(0,n.$Cj)("surround-with",60452),share:(0,n.$Cj)("share",60453),gitStash:(0,n.$Cj)("git-stash",60454),gitStashApply:(0,n.$Cj)("git-stash-apply",60455),gitStashPop:(0,n.$Cj)("git-stash-pop",60456),vscode:(0,n.$Cj)("vscode",60457),vscodeInsiders:(0,n.$Cj)("vscode-insiders",60458),codeOss:(0,n.$Cj)("code-oss",60459),runCoverage:(0,n.$Cj)("run-coverage",60460),runAllCoverage:(0,n.$Cj)("run-all-coverage",60461),coverage:(0,n.$Cj)("coverage",60462),githubProject:(0,n.$Cj)("github-project",60463),mapVertical:(0,n.$Cj)("map-vertical",60464),foldVertical:(0,n.$Cj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Cj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Cj)("fold-vertical-filled",60465)}}),define(ge[18],be([1,0,44,100]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hj=t.$Gj=void 0,t.$Fj=B;function B(){return Object.values(t.$Hj)}t.$Gj={dialogError:(0,n.$Cj)("dialog-error","error"),dialogWarning:(0,n.$Cj)("dialog-warning","warning"),dialogInfo:(0,n.$Cj)("dialog-info","info"),dialogClose:(0,n.$Cj)("dialog-close","close"),treeItemExpanded:(0,n.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Cj)("tree-item-loading","loading"),menuSelection:(0,n.$Cj)("menu-selection","check"),menuSubmenu:(0,n.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Cj)("toolbar-more","more"),quickInputBack:(0,n.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Cj)("drop-down-button",60084),symbolCustomColor:(0,n.$Cj)("symbol-customcolor",60252),exportIcon:(0,n.$Cj)("export",60332),workspaceUnspecified:(0,n.$Cj)("workspace-unspecified",60355),newLine:(0,n.$Cj)("newline",60394),thumbsDownFilled:(0,n.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Cj)("thumbsup-filled",60436),gitFetch:(0,n.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Cj)("debug-breakpoint-pending",60377)},t.$Hj={...F.$Ej,...t.$Gj}}),define(ge[61],be([1,0,7]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$On=F,t.$Pn=B,t.$Qn=A,t.$Rn=m,t.$Sn=b,t.$Tn=v,t.$Un=z,t.$Vn=u,t.$Wn=f,t.$Xn=e,t.$Yn=i,t.$Zn=r;function F(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([w,a])=>{g[w]=a&&typeof a=="object"?F(a):a}),g}function B(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const w=g.shift();Object.freeze(w);for(const a in w)if(W.call(w,a)){const d=w[a];typeof d=="object"&&!Object.isFrozen(d)&&!(0,n.$Yf)(d)&&g.push(d)}}return h}const W=Object.prototype.hasOwnProperty;function A(h,g){return k(h,g,new Set)}function k(h,g,w){if((0,n.$5f)(h))return h;const a=g(h);if(typeof a<"u")return a;if(Array.isArray(h)){const d=[];for(const o of h)d.push(k(o,g,w));return d}if((0,n.$Xf)(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const d={};for(const o in h)W.call(h,o)&&(d[o]=k(h[o],g,w));return w.delete(h),d}return h}function m(h,g,w=!0){return(0,n.$Xf)(h)?((0,n.$Xf)(g)&&Object.keys(g).forEach(a=>{a in h?w&&((0,n.$Xf)(h[a])&&(0,n.$Xf)(g[a])?m(h[a],g[a],w):h[a]=g[a]):h[a]=g[a]}),h):g}function b(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let w,a;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(w=0;w<h.length;w++)if(!b(h[w],g[w]))return!1}else{const d=[];for(a in h)d.push(a);d.sort();const o=[];for(a in g)o.push(a);if(o.sort(),!b(d,o))return!1;for(w=0;w<d.length;w++)if(!b(h[d[w]],g[d[w]]))return!1}return!0}function v(h){const g=new Set;return JSON.stringify(h,(w,a)=>{if((0,n.$Xf)(a)||Array.isArray(a)){if(g.has(a))return"[Circular]";g.add(a)}return a})}function z(h,g){const w=Object.create(null);return!h||!g||Object.keys(g).forEach(d=>{const o=h[d],C=g[d];b(o,C)||(w[d]=C)}),w}function u(h,g){const w=g.toLowerCase(),a=Object.keys(h).find(d=>d.toLowerCase()===w);return a?h[a]:h[g]}function f(h,g){const w=Object.create(null);for(const[a,d]of Object.entries(h))g(a,d)&&(w[a]=d);return w}function e(h){let g=[];for(;Object.prototype!==h;)g=g.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return g}function i(h){const g=[];for(const w of e(h))typeof h[w]=="function"&&g.push(w);return g}function r(h,g){const w=d=>function(){const o=Array.prototype.slice.call(arguments,0);return g(d,o)},a={};for(const d of h)a[d]=w(d);return a}}),define(ge[19],be([1,0,18]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Ij=B;var F;(function(A){function k(m){return m&&typeof m=="object"&&typeof m.id=="string"}A.isThemeColor=k})(F||(t.ThemeColor=F={}));function B(A){return{id:A}}var W;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function m(g){const w=k.exec(g.id);if(!w)return m(n.$Hj.error);const[,a,d]=w,o=["codicon","codicon-"+a];return d&&o.push("codicon-modifier-"+d.substring(1)),o}A.asClassNameArray=m;function b(g){return m(g).join(" ")}A.asClassName=b;function v(g){return"."+m(g).join(".")}A.asCSSSelector=v;function z(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||F.isThemeColor(g.color))}A.isThemeIcon=z;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function f(g){const w=u.exec(g);if(!w)return;const[,a]=w;return{id:a}}A.fromString=f;function e(g){return{id:g}}A.fromId=e;function i(g,w){let a=g.id;const d=a.lastIndexOf("~");return d!==-1&&(a=a.substring(0,d)),w&&(a=`${a}~${w}`),{id:a}}A.modify=i;function r(g){const w=g.id.lastIndexOf("~");if(w!==-1)return g.id.substring(w+1)}A.getModifier=r;function h(g,w){return g.id===w.id&&g.color?.id===w.color?.id}A.isEqual=h})(W||(t.ThemeIcon=W={}))}),define(ge[45],be([1,0,43,10,19]),function(ie,t,n,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zk=m,t.$Ak=v,t.$Bk=u,t.$Ck=f,t.$Dk=i,t.$Ek=r;const W="$(",A=new RegExp(`\\$\\(${B.ThemeIcon.iconNameExpression}(?:${B.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${A.source}`,"g");function m(h){return h.replace(k,(g,w)=>w?g:`\\${g}`)}const b=new RegExp(`\\\\${A.source}`,"g");function v(h){return h.replace(b,g=>`\\${g}`)}const z=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(h){return h.indexOf(W)===-1?h:h.replace(z,(g,w,a,d)=>a?g:w||d||"")}function f(h){return h?h.replace(/\$\((.*?)\)/g,(g,w)=>` ${w} `).trim():""}const e=new RegExp(`\\$\\(${B.ThemeIcon.iconNameCharacter}+\\)`,"g");function i(h){e.lastIndex=0;let g="";const w=[];let a=0;for(;;){const d=e.lastIndex,o=e.exec(h),C=h.substring(d,o?.index);if(C.length>0){g+=C;for(let N=0;N<C.length;N++)w.push(a)}if(!o)break;a+=o[0].length}return{text:g,iconOffsets:w}}function r(h,g,w=!1){const{text:a,iconOffsets:d}=g;if(!d||d.length===0)return(0,n.$qk)(h,a,w);const o=(0,F.$5e)(a," "),C=a.length-o.length,N=(0,n.$qk)(h,o,w);if(N)for(const O of N){const P=d[O.start+C]+C;O.start+=P,O.end+=P}return N}}),define(ge[101],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$V=t.$0V=void 0,t.$0V="vscode:contextmenu",t.$$V="vscode:onCloseContextMenu"}),define(ge[102],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fW=void 0;class n{constructor(B,W){this.a=B,this.onMessage=W}send(B){try{this.a.send("vscode:message",B.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$fW=n}),define(ge[34],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const n=globalThis.vscode;t.$O=n.ipcRenderer,t.$P=n.ipcMessagePort,t.$Q=n.webFrame,t.$R=n.process,t.$S=n.context}),define(ge[103],be([1,0,101,34]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bW=W;let B=0;function W(k,m,b){const v=[],z=B++,u=`vscode:onContextMenu${z}`,f=(e,i,r)=>{v[i].click?.(r)};F.$O.once(u,f),F.$O.once(n.$$V,(e,i)=>{i===z&&(F.$O.removeListener(u,f),b?.())}),F.$O.send(n.$0V,z,k.map(e=>A(e,v)),u,m)}function A(k,m){const b={id:m.length,label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:typeof k.enabled=="boolean"?k.enabled:!0,visible:typeof k.visible=="boolean"?k.visible:!0};return m.push(k),Array.isArray(k.submenu)&&(b.submenu=k.submenu.map(v=>A(v,m))),b}}),define(ge[62],be([8]),{}),define(ge[104],be([8]),{}),define(ge[105],be([8]),{}),define(ge[106],be([8]),{}),define(ge[107],be([1,0,105,106]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[108],be([8]),{}),define(ge[109],be([8]),{}),define(ge[110],be([8]),{}),define(ge[111],be([8]),{}),define(ge[112],be([8]),{}),define(ge[113],be([8]),{}),define(ge[114],be([8]),{}),define(ge[115],be([8]),{}),define(ge[116],be([8]),{}),define(ge[117],be([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[118],be([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[119],be([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[120],be([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/hover/updatableHoverWidget",t)}),define(ge[121],be([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[122],be([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[123],be([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[124],be([13,11]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(ge[46],be([1,0,4,2,124]),function(ie,t,n,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4i=t.$3i=t.$2i=t.$1i=t.$Zi=void 0,t.$5i=v;class W extends F.$Uc{constructor(u,f="",e="",i=!0,r){super(),this.h=this.B(new n.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=f,this.u=e,this.w=i,this.C=r}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,f){this.C&&await this.C(u)}}t.$Zi=W;class A extends F.$Uc{constructor(){super(...arguments),this.f=this.B(new n.$7d),this.onWillRun=this.f.event,this.m=this.B(new n.$7d),this.onDidRun=this.m.event}async run(u,f){if(!u.enabled)return;this.f.fire({action:u});let e;try{await this.u(u,f)}catch(i){e=i}this.m.fire({action:u,error:e})}async u(u,f){await u.run(f)}}t.$1i=A;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let f=[];for(const e of u)e.length&&(f.length?f=[...f,new k,...e]:f=e);return f}static{this.ID="vs.actions.separator"}async run(){}}t.$2i=k;class m{get actions(){return this.a}constructor(u,f,e,i){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=f,this.class=i,this.a=e}async run(){}}t.$3i=m;class b extends W{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,B.localize(0,null),void 0,!1)}}t.$4i=b;function v(z){return{id:z.id,label:z.label,class:z.class,enabled:z.enabled??!0,checked:z.checked,run:async(...u)=>z.run(...u),tooltip:z.label}}}),define(ge[125],be([13,11]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(ge[5],be([1,0,125]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=C,t.$D=M,t.$J=V,t.$g="en";let F=!1,B=!1,W=!1,A=!1,k=!1,m=!1,b=!1,v=!1,z=!1,u=!1,f,e=t.$g,i=t.$g,r,h;const g=globalThis;let w;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?w=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const a=typeof w?.versions?.electron=="string",d=a&&w?.type==="renderer";if(typeof w=="object"){F=w.platform==="win32",B=w.platform==="darwin",W=w.platform==="linux",A=W&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,b=a,z=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t.$g,e=t.$g;const I=w.env.VSCODE_NLS_CONFIG;if(I)try{const j=JSON.parse(I),T=j.availableLanguages["*"];f=j.locale,i=j.osLocale,e=T||t.$g,r=j._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!d?(h=navigator.userAgent,F=h.indexOf("Windows")>=0,B=h.indexOf("Macintosh")>=0,v=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=h.indexOf("Linux")>=0,u=h?.indexOf("Mobi")>=0,m=!0,f=n.getConfiguredDefaultLocale(n.localize(0,null))||t.$g,e=f,i=navigator.language):console.error("Unable to resolve platform.");var o;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(o||(t.Platform=o={}));function C(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let N=0;B?N=1:F?N=3:W&&(N=2),t.$i=F,t.$j=B,t.$k=W,t.$l=A,t.$m=k,t.$n=b,t.$o=m,t.$p=m&&typeof g.importScripts=="function",t.$q=t.$p?g.origin:void 0,t.$r=v,t.$s=u,t.$t=z,t.$u=N,t.$v=h,t.$w=e;var O;(function(I){function j(){return t.$w}I.value=j;function T(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}I.isDefaultVariant=T;function K(){return t.$w==="en"}I.isDefault=K})(O||(t.Language=O={})),t.$x=f,t.$y=i,t.$z=r,t.$A=typeof g.postMessage=="function"&&!g.importScripts,t.$B=(()=>{if(t.$A){const I=[];g.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let K=0,Z=I.length;K<Z;K++){const ce=I[K];if(ce.id===T.data.vscodeScheduleAsyncWork){I.splice(K,1),ce.callback();return}}});let j=0;return T=>{const K=++j;I.push({id:K,callback:T}),g.postMessage({vscodeScheduleAsyncWork:K},"*")}}return I=>setTimeout(I)})();var P;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(P||(t.OperatingSystem=P={})),t.OS=B||v?2:F?1:3;let L=!0,$=!1;function M(){if(!$){$=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,L=new Uint16Array(I.buffer)[0]===513}return L}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function V(I){return parseFloat(I)>=20}}),define(ge[126],be([1,0,17,22,5]),function(ie,t,n,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Q=t.KeyboardSupport=void 0;var W;(function(A){A[A.Always=0]="Always",A[A.FullScreen=1]="FullScreen",A[A.None=2]="None"})(W||(t.KeyboardSupport=W={})),t.$4Q={clipboard:{writeText:B.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:B.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:B.$m||n.$2Q()?0:navigator.keyboard||n.$XQ?1:2,touch:"ontouchstart"in F.$IQ||navigator.maxTouchPoints>0,pointerEvents:F.$IQ.PointerEvent&&("ontouchstart"in F.$IQ||navigator.maxTouchPoints>0)}}),define(ge[15],be([1,0,17,54,87,5]),function(ie,t,n,F,B,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=void 0,t.$0Q=z,t.$$Q=u;function A(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return F.KeyCodeUtils.fromString(r)}const i=e.keyCode;if(i===3)return 7;if(n.$UQ)switch(i){case 59:return 85;case 60:if(W.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.$j)return 57;break}else if(n.$VQ){if(W.$j&&i===93)return 57;if(!W.$j&&i===92)return 57}return F.$jr[i]||0}const k=W.$j?256:2048,m=512,b=1024,v=W.$j?2048:256;function z(e){const i=[];return e.ctrlKey&&i.push("ctrl"),e.shiftKey&&i.push("shift"),e.altKey&&i.push("alt"),e.metaKey&&i.push("meta"),`modifiers: [${i.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function u(e){const i=[];return e.ctrlKey&&i.push("ctrl"),e.shiftKey&&i.push("shift"),e.altKey&&i.push("alt"),e.metaKey&&i.push("meta"),`modifiers: [${i.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${F.KeyCodeUtils.toString(e.keyCode)}')`}class f{constructor(i){this._standardKeyboardEventBrand=!0;const r=i;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=A(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(i){return this.a===i}c(){let i=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(i=this.keyCode);let r=0;return this.ctrlKey&&(r|=k),this.altKey&&(r|=m),this.shiftKey&&(r|=b),this.metaKey&&(r|=v),r|=i,r}d(){let i=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(i=this.keyCode),new B.$rr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,i)}}t.$_Q=f}),define(ge[20],be([1,0,17,79,5]),function(ie,t,n,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Q=t.$8Q=t.$7Q=void 0;class W{constructor(b,v){this.timestamp=Date.now(),this.browserEvent=v,this.leftButton=v.button===0,this.middleButton=v.button===1,this.rightButton=v.button===2,this.buttons=v.buttons,this.target=v.target,this.detail=v.detail||1,v.type==="dblclick"&&(this.detail=2),this.ctrlKey=v.ctrlKey,this.shiftKey=v.shiftKey,this.altKey=v.altKey,this.metaKey=v.metaKey,typeof v.pageX=="number"?(this.posx=v.pageX,this.posy=v.pageY):(this.posx=v.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=v.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const z=F.$5Q.getPositionOfChildWindowRelativeToAncestorWindow(b,v.view);this.posx-=z.left,this.posy-=z.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$7Q=W;class A extends W{constructor(b,v){super(b,v),this.dataTransfer=v.dataTransfer}}t.$8Q=A;class k{constructor(b,v=0,z=0){this.browserEvent=b||null,this.target=b?b.target||b.targetNode||b.srcElement:null,this.deltaY=z,this.deltaX=v;let u=!1;if(n.$WQ){const f=navigator.userAgent.match(/Chrome\/(\d+)/);u=(f?parseInt(f[1]):123)<=122}if(b){const f=b,e=b,i=b.view?.devicePixelRatio||1;if(typeof f.wheelDeltaY<"u")u?this.deltaY=f.wheelDeltaY/(120*i):this.deltaY=f.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(b.type==="wheel"){const r=b;r.deltaMode===r.DOM_DELTA_LINE?n.$UQ&&!B.$j?this.deltaY=-b.deltaY/3:this.deltaY=-b.deltaY:this.deltaY=-b.deltaY/40}if(typeof f.wheelDeltaX<"u")n.$XQ&&B.$i?this.deltaX=-(f.wheelDeltaX/120):u?this.deltaX=f.wheelDeltaX/(120*i):this.deltaX=f.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-b.detail/3;else if(b.type==="wheel"){const r=b;r.deltaMode===r.DOM_DELTA_LINE?n.$UQ&&!B.$j?this.deltaX=-b.deltaX/3:this.deltaX=-b.deltaX:this.deltaX=-b.deltaX/40}this.deltaY===0&&this.deltaX===0&&b.wheelDelta&&(u?this.deltaY=b.wheelDelta/(120*i):this.deltaY=b.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$9Q=k}),define(ge[127],be([1,0,5]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let F;const B=globalThis.vscode;if(typeof B<"u"&&typeof B.process<"u"){const W=B.process;F={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$ec=F.platform,t.$fc=F.arch}),define(ge[25],be([1,0,127]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const F=65,B=97,W=90,A=122,k=46,m=47,b=92,v=58,z=63;class u extends Error{constructor(C,N,O){let P;typeof N=="string"&&N.indexOf("not ")===0?(P="must not be",N=N.replace(/^not /,"")):P="must be";const L=C.indexOf(".")!==-1?"property":"argument";let $=`The "${C}" ${L} ${P} of type ${N}`;$+=`. Received type ${typeof O}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function f(o,C){if(o===null||typeof o!="object")throw new u(C,"Object",o)}function e(o,C){if(typeof o!="string")throw new u(C,"string",o)}const i=n.$ec==="win32";function r(o){return o===m||o===b}function h(o){return o===m}function g(o){return o>=F&&o<=W||o>=B&&o<=A}function w(o,C,N,O){let P="",L=0,$=-1,M=0,V=0;for(let I=0;I<=o.length;++I){if(I<o.length)V=o.charCodeAt(I);else{if(O(V))break;V=m}if(O(V)){if(!($===I-1||M===1))if(M===2){if(P.length<2||L!==2||P.charCodeAt(P.length-1)!==k||P.charCodeAt(P.length-2)!==k){if(P.length>2){const j=P.lastIndexOf(N);j===-1?(P="",L=0):(P=P.slice(0,j),L=P.length-1-P.lastIndexOf(N)),$=I,M=0;continue}else if(P.length!==0){P="",L=0,$=I,M=0;continue}}C&&(P+=P.length>0?`${N}..`:"..",L=2)}else P.length>0?P+=`${N}${o.slice($+1,I)}`:P=o.slice($+1,I),L=I-$-1;$=I,M=0}else V===k&&M!==-1?++M:M=-1}return P}function a(o,C){f(C,"pathObject");const N=C.dir||C.root,O=C.base||`${C.name||""}${C.ext||""}`;return N?N===C.root?`${N}${O}`:`${N}${o}${O}`:O}t.$gc={resolve(...o){let C="",N="",O=!1;for(let P=o.length-1;P>=-1;P--){let L;if(P>=0){if(L=o[P],e(L,"path"),L.length===0)continue}else C.length===0?L=n.cwd():(L=n.env[`=${C}`]||n.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==C.toLowerCase()&&L.charCodeAt(2)===b)&&(L=`${C}\\`));const $=L.length;let M=0,V="",I=!1;const j=L.charCodeAt(0);if($===1)r(j)&&(M=1,I=!0);else if(r(j))if(I=!0,r(L.charCodeAt(1))){let T=2,K=T;for(;T<$&&!r(L.charCodeAt(T));)T++;if(T<$&&T!==K){const Z=L.slice(K,T);for(K=T;T<$&&r(L.charCodeAt(T));)T++;if(T<$&&T!==K){for(K=T;T<$&&!r(L.charCodeAt(T));)T++;(T===$||T!==K)&&(V=`\\\\${Z}\\${L.slice(K,T)}`,M=T)}}}else M=1;else g(j)&&L.charCodeAt(1)===v&&(V=L.slice(0,2),M=2,$>2&&r(L.charCodeAt(2))&&(I=!0,M=3));if(V.length>0)if(C.length>0){if(V.toLowerCase()!==C.toLowerCase())continue}else C=V;if(O){if(C.length>0)break}else if(N=`${L.slice(M)}\\${N}`,O=I,I&&C.length>0)break}return N=w(N,!O,"\\",r),O?`${C}\\${N}`:`${C}${N}`||"."},normalize(o){e(o,"path");const C=o.length;if(C===0)return".";let N=0,O,P=!1;const L=o.charCodeAt(0);if(C===1)return h(L)?"\\":o;if(r(L))if(P=!0,r(o.charCodeAt(1))){let M=2,V=M;for(;M<C&&!r(o.charCodeAt(M));)M++;if(M<C&&M!==V){const I=o.slice(V,M);for(V=M;M<C&&r(o.charCodeAt(M));)M++;if(M<C&&M!==V){for(V=M;M<C&&!r(o.charCodeAt(M));)M++;if(M===C)return`\\\\${I}\\${o.slice(V)}\\`;M!==V&&(O=`\\\\${I}\\${o.slice(V,M)}`,N=M)}}}else N=1;else g(L)&&o.charCodeAt(1)===v&&(O=o.slice(0,2),N=2,C>2&&r(o.charCodeAt(2))&&(P=!0,N=3));let $=N<C?w(o.slice(N),!P,"\\",r):"";return $.length===0&&!P&&($="."),$.length>0&&r(o.charCodeAt(C-1))&&($+="\\"),O===void 0?P?`\\${$}`:$:P?`${O}\\${$}`:`${O}${$}`},isAbsolute(o){e(o,"path");const C=o.length;if(C===0)return!1;const N=o.charCodeAt(0);return r(N)||C>2&&g(N)&&o.charCodeAt(1)===v&&r(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let C,N;for(let L=0;L<o.length;++L){const $=o[L];e($,"path"),$.length>0&&(C===void 0?C=N=$:C+=`\\${$}`)}if(C===void 0)return".";let O=!0,P=0;if(typeof N=="string"&&r(N.charCodeAt(0))){++P;const L=N.length;L>1&&r(N.charCodeAt(1))&&(++P,L>2&&(r(N.charCodeAt(2))?++P:O=!1))}if(O){for(;P<C.length&&r(C.charCodeAt(P));)P++;P>=2&&(C=`\\${C.slice(P)}`)}return t.$gc.normalize(C)},relative(o,C){if(e(o,"from"),e(C,"to"),o===C)return"";const N=t.$gc.resolve(o),O=t.$gc.resolve(C);if(N===O||(o=N.toLowerCase(),C=O.toLowerCase(),o===C))return"";let P=0;for(;P<o.length&&o.charCodeAt(P)===b;)P++;let L=o.length;for(;L-1>P&&o.charCodeAt(L-1)===b;)L--;const $=L-P;let M=0;for(;M<C.length&&C.charCodeAt(M)===b;)M++;let V=C.length;for(;V-1>M&&C.charCodeAt(V-1)===b;)V--;const I=V-M,j=$<I?$:I;let T=-1,K=0;for(;K<j;K++){const ce=o.charCodeAt(P+K);if(ce!==C.charCodeAt(M+K))break;ce===b&&(T=K)}if(K!==j){if(T===-1)return O}else{if(I>j){if(C.charCodeAt(M+K)===b)return O.slice(M+K+1);if(K===2)return O.slice(M+K)}$>j&&(o.charCodeAt(P+K)===b?T=K:K===2&&(T=3)),T===-1&&(T=0)}let Z="";for(K=P+T+1;K<=L;++K)(K===L||o.charCodeAt(K)===b)&&(Z+=Z.length===0?"..":"\\..");return M+=T,Z.length>0?`${Z}${O.slice(M,V)}`:(O.charCodeAt(M)===b&&++M,O.slice(M,V))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const C=t.$gc.resolve(o);if(C.length<=2)return o;if(C.charCodeAt(0)===b){if(C.charCodeAt(1)===b){const N=C.charCodeAt(2);if(N!==z&&N!==k)return`\\\\?\\UNC\\${C.slice(2)}`}}else if(g(C.charCodeAt(0))&&C.charCodeAt(1)===v&&C.charCodeAt(2)===b)return`\\\\?\\${C}`;return o},dirname(o){e(o,"path");const C=o.length;if(C===0)return".";let N=-1,O=0;const P=o.charCodeAt(0);if(C===1)return r(P)?o:".";if(r(P)){if(N=O=1,r(o.charCodeAt(1))){let M=2,V=M;for(;M<C&&!r(o.charCodeAt(M));)M++;if(M<C&&M!==V){for(V=M;M<C&&r(o.charCodeAt(M));)M++;if(M<C&&M!==V){for(V=M;M<C&&!r(o.charCodeAt(M));)M++;if(M===C)return o;M!==V&&(N=O=M+1)}}}}else g(P)&&o.charCodeAt(1)===v&&(N=C>2&&r(o.charCodeAt(2))?3:2,O=N);let L=-1,$=!0;for(let M=C-1;M>=O;--M)if(r(o.charCodeAt(M))){if(!$){L=M;break}}else $=!1;if(L===-1){if(N===-1)return".";L=N}return o.slice(0,L)},basename(o,C){C!==void 0&&e(C,"ext"),e(o,"path");let N=0,O=-1,P=!0,L;if(o.length>=2&&g(o.charCodeAt(0))&&o.charCodeAt(1)===v&&(N=2),C!==void 0&&C.length>0&&C.length<=o.length){if(C===o)return"";let $=C.length-1,M=-1;for(L=o.length-1;L>=N;--L){const V=o.charCodeAt(L);if(r(V)){if(!P){N=L+1;break}}else M===-1&&(P=!1,M=L+1),$>=0&&(V===C.charCodeAt($)?--$===-1&&(O=L):($=-1,O=M))}return N===O?O=M:O===-1&&(O=o.length),o.slice(N,O)}for(L=o.length-1;L>=N;--L)if(r(o.charCodeAt(L))){if(!P){N=L+1;break}}else O===-1&&(P=!1,O=L+1);return O===-1?"":o.slice(N,O)},extname(o){e(o,"path");let C=0,N=-1,O=0,P=-1,L=!0,$=0;o.length>=2&&o.charCodeAt(1)===v&&g(o.charCodeAt(0))&&(C=O=2);for(let M=o.length-1;M>=C;--M){const V=o.charCodeAt(M);if(r(V)){if(!L){O=M+1;break}continue}P===-1&&(L=!1,P=M+1),V===k?N===-1?N=M:$!==1&&($=1):N!==-1&&($=-1)}return N===-1||P===-1||$===0||$===1&&N===P-1&&N===O+1?"":o.slice(N,P)},format:a.bind(null,"\\"),parse(o){e(o,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return C;const N=o.length;let O=0,P=o.charCodeAt(0);if(N===1)return r(P)?(C.root=C.dir=o,C):(C.base=C.name=o,C);if(r(P)){if(O=1,r(o.charCodeAt(1))){let T=2,K=T;for(;T<N&&!r(o.charCodeAt(T));)T++;if(T<N&&T!==K){for(K=T;T<N&&r(o.charCodeAt(T));)T++;if(T<N&&T!==K){for(K=T;T<N&&!r(o.charCodeAt(T));)T++;T===N?O=T:T!==K&&(O=T+1)}}}}else if(g(P)&&o.charCodeAt(1)===v){if(N<=2)return C.root=C.dir=o,C;if(O=2,r(o.charCodeAt(2))){if(N===3)return C.root=C.dir=o,C;O=3}}O>0&&(C.root=o.slice(0,O));let L=-1,$=O,M=-1,V=!0,I=o.length-1,j=0;for(;I>=O;--I){if(P=o.charCodeAt(I),r(P)){if(!V){$=I+1;break}continue}M===-1&&(V=!1,M=I+1),P===k?L===-1?L=I:j!==1&&(j=1):L!==-1&&(j=-1)}return M!==-1&&(L===-1||j===0||j===1&&L===M-1&&L===$+1?C.base=C.name=o.slice($,M):(C.name=o.slice($,L),C.base=o.slice($,M),C.ext=o.slice(L,M))),$>0&&$!==O?C.dir=o.slice(0,$-1):C.dir=C.root,C},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(i){const o=/\\/g;return()=>{const C=n.cwd().replace(o,"/");return C.slice(C.indexOf("/"))}}return()=>n.cwd()})();t.$hc={resolve(...o){let C="",N=!1;for(let O=o.length-1;O>=-1&&!N;O--){const P=O>=0?o[O]:d();e(P,"path"),P.length!==0&&(C=`${P}/${C}`,N=P.charCodeAt(0)===m)}return C=w(C,!N,"/",h),N?`/${C}`:C.length>0?C:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const C=o.charCodeAt(0)===m,N=o.charCodeAt(o.length-1)===m;return o=w(o,!C,"/",h),o.length===0?C?"/":N?"./":".":(N&&(o+="/"),C?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===m},join(...o){if(o.length===0)return".";let C;for(let N=0;N<o.length;++N){const O=o[N];e(O,"path"),O.length>0&&(C===void 0?C=O:C+=`/${O}`)}return C===void 0?".":t.$hc.normalize(C)},relative(o,C){if(e(o,"from"),e(C,"to"),o===C||(o=t.$hc.resolve(o),C=t.$hc.resolve(C),o===C))return"";const N=1,O=o.length,P=O-N,L=1,$=C.length-L,M=P<$?P:$;let V=-1,I=0;for(;I<M;I++){const T=o.charCodeAt(N+I);if(T!==C.charCodeAt(L+I))break;T===m&&(V=I)}if(I===M)if($>M){if(C.charCodeAt(L+I)===m)return C.slice(L+I+1);if(I===0)return C.slice(L+I)}else P>M&&(o.charCodeAt(N+I)===m?V=I:I===0&&(V=0));let j="";for(I=N+V+1;I<=O;++I)(I===O||o.charCodeAt(I)===m)&&(j+=j.length===0?"..":"/..");return`${j}${C.slice(L+V)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const C=o.charCodeAt(0)===m;let N=-1,O=!0;for(let P=o.length-1;P>=1;--P)if(o.charCodeAt(P)===m){if(!O){N=P;break}}else O=!1;return N===-1?C?"/":".":C&&N===1?"//":o.slice(0,N)},basename(o,C){C!==void 0&&e(C,"ext"),e(o,"path");let N=0,O=-1,P=!0,L;if(C!==void 0&&C.length>0&&C.length<=o.length){if(C===o)return"";let $=C.length-1,M=-1;for(L=o.length-1;L>=0;--L){const V=o.charCodeAt(L);if(V===m){if(!P){N=L+1;break}}else M===-1&&(P=!1,M=L+1),$>=0&&(V===C.charCodeAt($)?--$===-1&&(O=L):($=-1,O=M))}return N===O?O=M:O===-1&&(O=o.length),o.slice(N,O)}for(L=o.length-1;L>=0;--L)if(o.charCodeAt(L)===m){if(!P){N=L+1;break}}else O===-1&&(P=!1,O=L+1);return O===-1?"":o.slice(N,O)},extname(o){e(o,"path");let C=-1,N=0,O=-1,P=!0,L=0;for(let $=o.length-1;$>=0;--$){const M=o.charCodeAt($);if(M===m){if(!P){N=$+1;break}continue}O===-1&&(P=!1,O=$+1),M===k?C===-1?C=$:L!==1&&(L=1):C!==-1&&(L=-1)}return C===-1||O===-1||L===0||L===1&&C===O-1&&C===N+1?"":o.slice(C,O)},format:a.bind(null,"/"),parse(o){e(o,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return C;const N=o.charCodeAt(0)===m;let O;N?(C.root="/",O=1):O=0;let P=-1,L=0,$=-1,M=!0,V=o.length-1,I=0;for(;V>=O;--V){const j=o.charCodeAt(V);if(j===m){if(!M){L=V+1;break}continue}$===-1&&(M=!1,$=V+1),j===k?P===-1?P=V:I!==1&&(I=1):P!==-1&&(I=-1)}if($!==-1){const j=L===0&&N?1:L;P===-1||I===0||I===1&&P===$-1&&P===L+1?C.base=C.name=o.slice(j,$):(C.name=o.slice(j,P),C.base=o.slice(j,$),C.ext=o.slice(P,$))}return L>0?C.dir=o.slice(0,L-1):N&&(C.dir="/"),C},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=i?t.$gc.normalize:t.$hc.normalize,t.$jc=i?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=i?t.$gc.join:t.$hc.join,t.$lc=i?t.$gc.resolve:t.$hc.resolve,t.$mc=i?t.$gc.relative:t.$hc.relative,t.$nc=i?t.$gc.dirname:t.$hc.dirname,t.$oc=i?t.$gc.basename:t.$hc.basename,t.$pc=i?t.$gc.extname:t.$hc.extname,t.$qc=i?t.$gc.format:t.$hc.format,t.$rc=i?t.$gc.parse:t.$hc.parse,t.$sc=i?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=i?t.$gc.sep:t.$hc.sep,t.$uc=i?t.$gc.delimiter:t.$hc.delimiter}),define(ge[128],be([1,0,25,5,10,7]),function(ie,t,n,F,B,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bg=A,t.$cg=k,t.$dg=m,t.$eg=b,t.$fg=v,t.$gg=e,t.$hg=i,t.$ig=r,t.$jg=h,t.$kg=g,t.$lg=w,t.$mg=a,t.$ng=d,t.$og=o,t.$pg=C,t.$qg=P;function A(L){return L===47||L===92}function k(L){return L.replace(/[\\/]/g,n.$hc.sep)}function m(L){return L.indexOf("/")===-1&&(L=k(L)),/^[a-zA-Z]:(\/|$)/.test(L)&&(L="/"+L),L}function b(L,$=n.$hc.sep){if(!L)return"";const M=L.length,V=L.charCodeAt(0);if(A(V)){if(A(L.charCodeAt(1))&&!A(L.charCodeAt(2))){let j=3;const T=j;for(;j<M&&!A(L.charCodeAt(j));j++);if(T!==j&&!A(L.charCodeAt(j+1))){for(j+=1;j<M;j++)if(A(L.charCodeAt(j)))return L.slice(0,j+1).replace(/[\\/]/g,$)}}return $}else if(h(V)&&L.charCodeAt(1)===58)return A(L.charCodeAt(2))?L.slice(0,2)+$:L.slice(0,2);let I=L.indexOf("://");if(I!==-1){for(I+=3;I<M;I++)if(A(L.charCodeAt(I)))return L.slice(0,I+1)}return""}function v(L){if(!F.$i||!L||L.length<5)return!1;let $=L.charCodeAt(0);if($!==92||($=L.charCodeAt(1),$!==92))return!1;let M=2;const V=M;for(;M<L.length&&($=L.charCodeAt(M),$!==92);M++);return!(V===M||($=L.charCodeAt(M+1),isNaN($)||$===92))}const z=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(L,$=F.$i){const M=$?z:u;return!(!L||L.length===0||/^\s+$/.test(L)||(M.lastIndex=0,M.test(L))||$&&f.test(L)||L==="."||L===".."||$&&L[L.length-1]==="."||$&&L.length!==L.trim().length||L.length>255)}function i(L,$,M){const V=L===$;return!M||V?V:!L||!$?!1:(0,B.$lf)(L,$)}function r(L,$,M,V=n.sep){if(L===$)return!0;if(!L||!$||$.length>L.length)return!1;if(M){if(!(0,B.$mf)(L,$))return!1;if($.length===L.length)return!0;let j=$.length;return $.charAt($.length-1)===V&&j--,L.charAt(j)===V}return $.charAt($.length-1)!==V&&($+=V),L.indexOf($)===0}function h(L){return L>=65&&L<=90||L>=97&&L<=122}function g(L,$){return F.$i&&L.endsWith(":")&&(L+=n.sep),(0,n.$jc)(L)||(L=(0,n.$kc)($,L)),L=(0,n.$ic)(L),F.$i?(L=(0,B.$6e)(L,n.sep),L.endsWith(":")&&(L+=n.sep)):(L=(0,B.$6e)(L,n.sep),L||(L=n.sep)),L}function w(L){const $=(0,n.$ic)(L);return F.$i?L.length>3?!1:a($)&&(L.length===2||$.charCodeAt(2)===92):$===n.$hc.sep}function a(L,$=F.$i){return $?h(L.charCodeAt(0))&&L.charCodeAt(1)===58:!1}function d(L,$=F.$i){return a(L,$)?L[0]:void 0}function o(L,$,M){return $.length>L.length?-1:L===$?0:(M&&(L=L.toLowerCase(),$=$.toLowerCase()),L.indexOf($))}function C(L){const $=L.split(":");let M,V,I;for(const j of $){const T=Number(j);(0,W.$Zf)(T)?V===void 0?V=T:I===void 0&&(I=T):M=M?[M,j].join(":"):j}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:V!==void 0?V:void 0,column:I!==void 0?I:V!==void 0?1:void 0}}const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(L,$,M=8){let V="";for(let j=0;j<M;j++){let T;j===0&&F.$i&&!$&&(M===3||M===4)?T=O:T=N,V+=T.charAt(Math.floor(Math.random()*T.length))}let I;return $?I=`${$}-${V}`:I=V,L?(0,n.$kc)(L,I):I}}),define(ge[129],be([1,0,25]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=void 0,t.$As=W,t.$Bs=A,t.$Cs=k,t.$Ds=b,t.$zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(v){const z=(0,n.$pc)(v),u=F[z.toLowerCase()];return u!==void 0?u:A(v)}function A(v){const z=(0,n.$pc)(v);return B[z.toLowerCase()]}function k(v){for(const z in B)if(B[z]===v)return z}const m=/^(.+)\/(.+?)(;.+)?$/;function b(v,z){const u=m.exec(v);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:z?void 0:v}}),define(ge[16],be([1,0,25,5]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=a;const B=/^\w[\w\d+.-]*$/,W=/^\//,A=/^\/\//;function k(O,P){if(!O.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${O.authority}", path: "${O.path}", query: "${O.query}", fragment: "${O.fragment}"}`);if(O.scheme&&!B.test(O.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(O.path){if(O.authority){if(!W.test(O.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(O.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(O,P){return!O&&!P?"file":O}function b(O,P){switch(O){case"https":case"http":case"file":P?P[0]!==z&&(P=z+P):P=z;break}return P}const v="",z="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(P){return P instanceof f?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,L,$,M,V,I=!1){typeof P=="object"?(this.scheme=P.scheme||v,this.authority=P.authority||v,this.path=P.path||v,this.query=P.query||v,this.fragment=P.fragment||v):(this.scheme=m(P,I),this.authority=L||v,this.path=b(this.scheme,$||v),this.query=M||v,this.fragment=V||v,k(this,I))}get fsPath(){return a(this,!1)}with(P){if(!P)return this;let{scheme:L,authority:$,path:M,query:V,fragment:I}=P;return L===void 0?L=this.scheme:L===null&&(L=v),$===void 0?$=this.authority:$===null&&($=v),M===void 0?M=this.path:M===null&&(M=v),V===void 0?V=this.query:V===null&&(V=v),I===void 0?I=this.fragment:I===null&&(I=v),L===this.scheme&&$===this.authority&&M===this.path&&V===this.query&&I===this.fragment?this:new r(L,$,M,V,I)}static parse(P,L=!1){const $=u.exec(P);return $?new r($[2]||v,N($[4]||v),N($[5]||v),N($[7]||v),N($[9]||v),L):new r(v,v,v,v,v)}static file(P){let L=v;if(F.$i&&(P=P.replace(/\\/g,z)),P[0]===z&&P[1]===z){const $=P.indexOf(z,2);$===-1?(L=P.substring(2),P=z):(L=P.substring(2,$),P=P.substring($)||z)}return new r("file",L,P,v,v)}static from(P,L){return new r(P.scheme,P.authority,P.path,P.query,P.fragment,L)}static joinPath(P,...L){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return F.$i&&P.scheme==="file"?$=f.file(n.$gc.join(a(P,!0),...L)).path:$=n.$hc.join(P.path,...L),P.with({path:$})}toString(P=!1){return d(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof f)return P;{const L=new r(P);return L._formatted=P.external??null,L._fsPath=P._sep===i?P.fsPath??null:null,L}}else return P}}t.URI=f;function e(O){return!O||typeof O!="object"?!1:typeof O.scheme=="string"&&(typeof O.authority=="string"||typeof O.authority>"u")&&(typeof O.path=="string"||typeof O.path>"u")&&(typeof O.query=="string"||typeof O.query>"u")&&(typeof O.fragment=="string"||typeof O.fragment>"u")}const i=F.$i?1:void 0;class r extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(P=!1){return P?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const P={$mid:1};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=i),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(O,P,L){let $,M=-1;for(let V=0;V<O.length;V++){const I=O.charCodeAt(V);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||P&&I===47||L&&I===91||L&&I===93||L&&I===58)M!==-1&&($+=encodeURIComponent(O.substring(M,V)),M=-1),$!==void 0&&($+=O.charAt(V));else{$===void 0&&($=O.substr(0,V));const j=h[I];j!==void 0?(M!==-1&&($+=encodeURIComponent(O.substring(M,V)),M=-1),$+=j):M===-1&&(M=V)}}return M!==-1&&($+=encodeURIComponent(O.substring(M))),$!==void 0?$:O}function w(O){let P;for(let L=0;L<O.length;L++){const $=O.charCodeAt(L);$===35||$===63?(P===void 0&&(P=O.substr(0,L)),P+=h[$]):P!==void 0&&(P+=O[L])}return P!==void 0?P:O}function a(O,P){let L;return O.authority&&O.path.length>1&&O.scheme==="file"?L=`//${O.authority}${O.path}`:O.path.charCodeAt(0)===47&&(O.path.charCodeAt(1)>=65&&O.path.charCodeAt(1)<=90||O.path.charCodeAt(1)>=97&&O.path.charCodeAt(1)<=122)&&O.path.charCodeAt(2)===58?P?L=O.path.substr(1):L=O.path[1].toLowerCase()+O.path.substr(2):L=O.path,F.$i&&(L=L.replace(/\//g,"\\")),L}function d(O,P){const L=P?w:g;let $="",{scheme:M,authority:V,path:I,query:j,fragment:T}=O;if(M&&($+=M,$+=":"),(V||M==="file")&&($+=z,$+=z),V){let K=V.indexOf("@");if(K!==-1){const Z=V.substr(0,K);V=V.substr(K+1),K=Z.lastIndexOf(":"),K===-1?$+=L(Z,!1,!1):($+=L(Z.substr(0,K),!1,!1),$+=":",$+=L(Z.substr(K+1),!1,!0)),$+="@"}V=V.toLowerCase(),K=V.lastIndexOf(":"),K===-1?$+=L(V,!1,!0):($+=L(V.substr(0,K),!1,!0),$+=V.substr(K))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const K=I.charCodeAt(1);K>=65&&K<=90&&(I=`/${String.fromCharCode(K+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const K=I.charCodeAt(0);K>=65&&K<=90&&(I=`${String.fromCharCode(K+32)}:${I.substr(2)}`)}$+=L(I,!0,!1)}return j&&($+="?",$+=L(j,!1,!1)),T&&($+="#",$+=P?T:g(T,!1,!1)),$}function o(O){try{return decodeURIComponent(O)}catch{return O.length>3?O.substr(0,3)+o(O.substr(3)):O}}const C=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(O){return O.match(C)?O.replace(C,P=>o(P)):O}}),define(ge[63],be([1,0,42,16]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ph=B,t.$Qh=W,t.$Rh=k;function B(m){return JSON.stringify(m,A)}function W(m){let b=JSON.parse(m);return b=k(b),b}function A(m,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function k(m,b=0){if(!m||b>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return F.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof n.$ue||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let v=0;v<m.length;++v)m[v]=k(m[v],b+1);else for(const v in m)Object.hasOwnProperty.call(m,v)&&(m[v]=k(m[v],b+1))}return m}}),define(ge[35],be([1,0,6,5,10,16,25]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$vg=t.$ug=t.$tg=t.Schemas=void 0,t.$rg=m,t.$sg=b,t.$wg=z;var k;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.codeSetting="code-setting"})(k||(t.Schemas=k={}));function m(e,i){return W.URI.isUri(e)?(0,B.$lf)(e.scheme,i):(0,B.$mf)(e,i+":")}function b(e,...i){return i.some(r=>m(e,r))}t.$tg="vscode-tkn",t.$ug="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(i){this.d=i}setDelegate(i){this.e=i}setServerRootPath(i,r){this.f=z(i,r)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,k.vscodeRemoteResource)}set(i,r,h){this.a[i]=r,this.b[i]=h}setConnectionToken(i,r){this.c[i]=r}getPreferredWebSchema(){return this.d}rewrite(i){if(this.e)try{return this.e(i)}catch(d){return n.$1(d),i}const r=i.authority;let h=this.a[r];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const g=this.b[r],w=this.c[r];let a=`path=${encodeURIComponent(i.path)}`;return typeof w=="string"&&(a+=`&${t.$ug}=${encodeURIComponent(w)}`),W.URI.from({scheme:F.$o?this.d:k.vscodeRemoteResource,authority:`${h}:${g}`,path:this.g,query:a})}}t.$vg=new v;function z(e,i){return A.$hc.join(i??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$xg="vs/../../extensions",t.$yg="vs/../../node_modules",t.$zg="vs/../../node_modules.asar",t.$Ag="vs/../../node_modules.asar.unpacked",t.$Bg="vscode-app";class u{static{this.a=t.$Bg}asBrowserUri(i){const r=this.b(i,ie);return this.uriToBrowserUri(r)}uriToBrowserUri(i){return i.scheme===k.vscodeRemote?t.$vg.rewrite(i):i.scheme===k.file&&(F.$m||F.$q===`${k.vscodeFileResource}://${u.a}`)?i.with({scheme:k.vscodeFileResource,authority:i.authority||u.a,query:null,fragment:null}):i}asFileUri(i){const r=this.b(i,ie);return this.uriToFileUri(r)}uriToFileUri(i){return i.scheme===k.vscodeFileResource?i.with({scheme:k.file,authority:i.authority!==u.a?i.authority:null,query:null,fragment:null}):i}b(i,r){return W.URI.isUri(i)?i:W.URI.parse(r.toUrl(i))}}t.$Cg=new u;var f;(function(e){const i=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(i.get("3"));const r="vscode-coi";function h(w){let a;typeof w=="string"?a=new URL(w).searchParams:w instanceof URL?a=w.searchParams:W.URI.isUri(w)&&(a=new URL(w.toString(!0)).searchParams);const d=a?.get(r);if(d)return i.get(d)}e.getHeadersFromQuery=h;function g(w,a,d){if(!globalThis.crossOriginIsolated)return;const o=a&&d?"3":d?"2":"1";w instanceof URLSearchParams?w.set(r,o):w[r]=o}e.addSearchParam=g})(f||(t.COI=f={}))}),define(ge[47],be([1,0,128,35,25,5,10,16]),function(ie,t,n,F,B,W,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=void 0,t.$Jg=m,t.$5g=v,t.$6g=u;function m(f){return(0,k.$xc)(f,!0)}class b{constructor(e){this.a=e}compare(e,i,r=!1){return e===i?0:(0,A.$ef)(this.getComparisonKey(e,r),this.getComparisonKey(i,r))}isEqual(e,i,r=!1){return e===i?!0:!e||!i?!1:this.getComparisonKey(e,r)===this.getComparisonKey(i,r)}getComparisonKey(e,i=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,i,r=!1){if(e.scheme===i.scheme){if(e.scheme===F.Schemas.file)return n.$ig(m(e),m(i),this.a(e))&&e.query===i.query&&(r||e.fragment===i.fragment);if((0,t.$1g)(e.authority,i.authority))return n.$ig(e.path,i.path,this.a(e),"/")&&e.query===i.query&&(r||e.fragment===i.fragment)}return!1}joinPath(e,...i){return k.URI.joinPath(e,...i)}basenameOrAuthority(e){return(0,t.$Sg)(e)||e.authority}basename(e){return B.$hc.basename(e.path)}extname(e){return B.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let i;return e.scheme===F.Schemas.file?i=k.URI.file(B.$nc(m(e))).path:(i=B.$hc.dirname(e.path),e.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),i="/")),e.with({path:i})}normalizePath(e){if(!e.path.length)return e;let i;return e.scheme===F.Schemas.file?i=k.URI.file(B.$ic(m(e))).path:i=B.$hc.normalize(e.path),e.with({path:i})}relativePath(e,i){if(e.scheme!==i.scheme||!(0,t.$1g)(e.authority,i.authority))return;if(e.scheme===F.Schemas.file){const g=B.$mc(m(e),m(i));return W.$i?n.$cg(g):g}let r=e.path||"/";const h=i.path||"/";if(this.a(e)){let g=0;for(const w=Math.min(r.length,h.length);g<w&&!(r.charCodeAt(g)!==h.charCodeAt(g)&&r.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);r=h.substr(0,g)+r.substr(g)}return B.$hc.relative(r,h)}resolvePath(e,i){if(e.scheme===F.Schemas.file){const r=k.URI.file(B.$lc(m(e),i));return e.with({authority:r.authority,path:r.path})}return i=n.$dg(i),e.with({path:B.$hc.resolve(e.path,i)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,i){return e===i||e!==void 0&&i!==void 0&&(0,A.$lf)(e,i)}hasTrailingPathSeparator(e,i=B.sep){if(e.scheme===F.Schemas.file){const r=m(e);return r.length>n.$eg(r).length&&r[r.length-1]===i}else{const r=e.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,i=B.sep){return(0,t.$2g)(e,i)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,i=B.sep){let r=!1;if(e.scheme===F.Schemas.file){const h=m(e);r=h!==void 0&&h.length===n.$eg(h).length&&h[h.length-1]===i}else{i="/";const h=e.path;r=h.length===1&&h.charCodeAt(h.length-1)===47}return!r&&!(0,t.$2g)(e,i)?e.with({path:e.path+"/"}):e}}t.$Kg=b,t.$Lg=new b(()=>!1),t.$Mg=new b(f=>f.scheme===F.Schemas.file?!W.$k:!0),t.$Ng=new b(f=>!0),t.$Og=t.$Lg.isEqual.bind(t.$Lg),t.$Pg=t.$Lg.isEqualOrParent.bind(t.$Lg),t.$Qg=t.$Lg.getComparisonKey.bind(t.$Lg),t.$Rg=t.$Lg.basenameOrAuthority.bind(t.$Lg),t.$Sg=t.$Lg.basename.bind(t.$Lg),t.$Tg=t.$Lg.extname.bind(t.$Lg),t.$Ug=t.$Lg.dirname.bind(t.$Lg),t.$Vg=t.$Lg.joinPath.bind(t.$Lg),t.$Wg=t.$Lg.normalizePath.bind(t.$Lg),t.$Xg=t.$Lg.relativePath.bind(t.$Lg),t.$Yg=t.$Lg.resolvePath.bind(t.$Lg),t.$Zg=t.$Lg.isAbsolutePath.bind(t.$Lg),t.$1g=t.$Lg.isEqualAuthority.bind(t.$Lg),t.$2g=t.$Lg.hasTrailingPathSeparator.bind(t.$Lg),t.$3g=t.$Lg.removeTrailingPathSeparator.bind(t.$Lg),t.$4g=t.$Lg.addTrailingPathSeparator.bind(t.$Lg);function v(f,e){const i=[];for(let r=0;r<f.length;r++){const h=e(f[r]);f.some((g,w)=>w===r?!1:(0,t.$Pg)(h,e(g)))||i.push(f[r])}return i}var z;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function e(i){const r=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(w=>{const[a,d]=w.split(":");a&&d&&r.set(a,d)});const g=i.path.substring(0,i.path.indexOf(";"));return g&&r.set(f.META_DATA_MIME,g),r}f.parseMetaData=e})(z||(t.DataUri=z={}));function u(f,e,i){if(e){let r=f.path;return r&&r[0]!==B.$hc.sep&&(r=B.$hc.sep+r),f.with({scheme:i,authority:e,path:r})}return f.with({scheme:i})}}),define(ge[9],be([1,0,28,6,4,2,47,5,60,23]),function(ie,t,n,F,B,W,A,k,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.Promises=t.$Fh=t.$Eh=t.$Dh=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=void 0,t.$7g=v,t.$8g=z,t.$9g=u,t.$0g=f,t.$$g=e,t.$_g=i,t.$ah=r,t.$bh=h,t.$jh=L,t.$kh=$,t.$lh=M,t.$mh=V,t.$nh=I,t.$Ch=_,t.$Kh=x;function v(D){return!!D&&typeof D.then=="function"}function z(D){const l=new n.$ee,p=D(l.token),S=new Promise((s,E)=>{const y=l.token.onCancellationRequested(()=>{y.dispose(),E(new F.$5)});Promise.resolve(p).then(R=>{y.dispose(),l.dispose(),s(R)},R=>{y.dispose(),l.dispose(),E(R)})});return new class{cancel(){l.cancel(),l.dispose()}then(s,E){return S.then(s,E)}catch(s){return this.then(void 0,s)}finally(s){return S.finally(s)}}}function u(D,l,p){return new Promise((S,s)=>{const E=l.onCancellationRequested(()=>{E.dispose(),S(p)});D.then(S,s).finally(()=>E.dispose())})}function f(D,l){return new Promise((p,S)=>{const s=l.onCancellationRequested(()=>{s.dispose(),S(new F.$5)});D.then(p,S).finally(()=>s.dispose())})}async function e(D){let l=-1;const p=D.map((S,s)=>S.then(E=>(l=s,E)));try{return await Promise.race(p)}finally{D.forEach((S,s)=>{s!==l&&S.cancel()})}}function i(D,l,p){let S;const s=setTimeout(()=>{S?.(void 0),p?.()},l);return Promise.race([D.finally(()=>clearTimeout(s)),new Promise(E=>S=E)])}function r(D){return new Promise((l,p)=>{const S=D();v(S)?S.then(l,p):l(S)})}function h(){let D,l;return{promise:new Promise((S,s)=>{D=S,l=s}),resolve:D,reject:l}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const p=()=>{if(this.b=null,this.f)return;const S=this.queue(this.d);return this.d=null,S};this.b=new Promise(S=>{this.a.then(p,p).then(S)})}return new Promise((p,S)=>{this.b.then(p,S)})}return this.a=l(),new Promise((p,S)=>{this.a.then(s=>{this.a=null,p(s)},s=>{this.a=null,S(s)})})}dispose(){this.f=!0}}t.$ch=g;class w{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}t.$dh=w;class a{constructor(){this.a=new Map}queue(l,p){const s=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(p).finally(()=>{this.a.get(l)===s&&this.a.delete(l)});return this.a.set(l,s),s}}t.$eh=a;const d=(D,l)=>{let p=!0;const S=setTimeout(()=>{p=!1,l()},D);return{isTriggered:()=>p,dispose:()=>{clearTimeout(S),p=!1}}},o=D=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,D())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class C{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,p=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((s,E)=>{this.d=s,this.f=E}).then(()=>{if(this.b=null,this.d=null,this.g){const s=this.g;return this.g=null,s()}}));const S=()=>{this.a=null,this.d?.(null)};return this.a=p===m.$4d?o(S):d(p,S),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$fh=C;class N{constructor(l){this.a=new C(l),this.b=new g}trigger(l,p){return this.a.trigger(()=>this.b.queue(l),p)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$gh=N;class O{constructor(){this.a=!1,this.b=new Promise((l,p)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$hh=O;class P extends O{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}t.$ih=P;function L(D,l){return l?new Promise((p,S)=>{const s=setTimeout(()=>{E.dispose(),p()},D),E=l.onCancellationRequested(()=>{clearTimeout(s),E.dispose(),S(new F.$5)})}):z(p=>L(D,p))}function $(D,l=0,p){const S=setTimeout(()=>{D(),p&&s.dispose()},l),s=(0,W.$Sc)(()=>{clearTimeout(S),p?.deleteAndLeak(s)});return p?.add(s),s}function M(D){const l=[];let p=0;const S=D.length;function s(){return p<S?D[p++]():null}function E(y){y!=null&&l.push(y);const R=s();return R?R.then(E):Promise.resolve(l)}return Promise.resolve(null).then(E)}function V(D,l=S=>!!S,p=null){let S=0;const s=D.length,E=()=>{if(S>=s)return Promise.resolve(p);const y=D[S++];return Promise.resolve(y()).then(H=>l(H)?Promise.resolve(H):E())};return E()}function I(D,l=S=>!!S,p=null){if(D.length===0)return Promise.resolve(p);let S=D.length;const s=()=>{S=-1;for(const E of D)E.cancel?.()};return new Promise((E,y)=>{for(const R of D)R.then(H=>{--S>=0&&l(H)?(s(),E(H)):S===0&&E(p)}).catch(H=>{--S>=0&&(s(),y(H))})})}class j{constructor(l){this.a=0,this.b=!1,this.f=l,this.g=[],this.d=0,this.h=new B.$7d}whenIdle(){return this.size>0?B.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(l){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((p,S)=>{this.g.push({factory:l,c:p,e:S}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const l=this.g.shift();this.d++;const p=l.factory();p.then(l.c,l.e),p.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$oh=j;class T extends j{constructor(){super(1)}}t.$ph=T;class K{constructor(){this.a=new le,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}t.$qh=K;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new G;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueSize(l,p=A.$Lg){const S=p.getComparisonKey(l);return this.a.get(S)?.size??0}queueFor(l,p,S=A.$Lg){const s=S.getComparisonKey(l);let E=this.a.get(s);if(!E){E=new T;const y=this.f++,R=B.Event.once(E.onDrained)(()=>{E?.dispose(),this.a.delete(s),this.h(),this.d?.deleteAndDispose(y),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new W.$4c),this.d.set(y,R),this.a.set(s,E)}return E.queue(p)}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$rh=Z;class ce{constructor(l,p){this.a=-1,typeof l=="function"&&typeof p=="number"&&this.setIfNotSet(l,p)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,p){this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},p)}setIfNotSet(l,p){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},p))}}t.$sh=ce;class re{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(l,p,S=globalThis){this.cancel();const s=S.setInterval(()=>{l()},p);this.d=(0,W.$Sc)(()=>{S.clearInterval(s),this.d=void 0})}dispose(){this.cancel()}}t.$th=re;class te{constructor(l,p){this.b=-1,this.a=l,this.d=p,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$uh=te;class $e{constructor(l,p){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.a=l,this.b=p,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$vh=$e;class De extends te{constructor(l,p){super(l,p),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}t.$wh=De;class Te extends W.$Uc{constructor(l,p){super(),this.g=l,this.h=p,this.a=[],this.b=this.B(new W.$Vc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const p of l)this.a.push(p);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$xh=Te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$zh=(D,l)=>{(0,k.$B)(()=>{if(p)return;const S=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$zh=(D,l,p)=>{const S=D.requestIdleCallback(l,typeof p=="number"?{timeout:p}:void 0);let s=!1;return{dispose(){s||(s=!0,D.cancelIdleCallback(S))}}},t.$yh=D=>(0,t.$zh)(globalThis,D)}();class Pe{constructor(l,p){this.g=!1,this.d=()=>{try{this.j=p()}catch(S){this.l=S}finally{this.g=!0}},this.f=(0,t.$zh)(l,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Ah=Pe;class he extends Pe{constructor(l){super(globalThis,l)}}t.$Bh=he;async function _(D,l,p){let S;for(let s=0;s<p;s++)try{return await D()}catch(E){S=E,await L(l)}throw S}class le{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,p,S){return this.a={taskId:l,cancel:()=>S?.(),promise:p},p.then(()=>this.d(l),()=>this.d(l)),p}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{const{promise:p,resolve:S,reject:s}=h();this.b={run:l,promise:p,promiseResolve:S,promiseReject:s}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Dh=le;class ae{constructor(l,p=()=>Date.now()){this.d=l,this.f=p,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}t.$Eh=ae;var J;(function(D){D[D.Resolved=0]="Resolved",D[D.Rejected=1]="Rejected"})(J||(J={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((l,p)=>{this.a=l,this.b=p})}complete(l){return new Promise(p=>{this.a(l),this.d={outcome:0,value:l},p()})}error(l){return new Promise(p=>{this.b(l),this.d={outcome:1,value:l},p()})}cancel(){return this.error(new F.$5)}}t.$Fh=G;var se;(function(D){async function l(S){let s;const E=await Promise.all(S.map(y=>y.then(R=>R,R=>{s||(s=R)})));if(typeof s<"u")throw s;return E}D.settled=l;function p(S){return new Promise(async(s,E)=>{try{await S(s,E)}catch(y){E(y)}})}D.withAsyncBody=p})(se||(t.Promises=se={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(l){this.a=void 0,this.b=void 0,this.d=!1,this.promise=l.then(p=>(this.a=p,this.d=!0,p),p=>{throw this.b=p,this.d=!0,p})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Gh=fe;class ve{constructor(l){this.b=l,this.a=new b.$V(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Hh=ve;var Ne;(function(D){D[D.Initial=0]="Initial",D[D.DoneOK=1]="DoneOK",D[D.DoneError=2]="DoneError"})(Ne||(Ne={}));class Ae{static fromArray(l){return new Ae(p=>{p.emitMany(l)})}static fromPromise(l){return new Ae(async p=>{p.emitMany(await l)})}static fromPromises(l){return new Ae(async p=>{await Promise.all(l.map(async S=>p.emitOne(await S)))})}static merge(l){return new Ae(async p=>{await Promise.all(l.map(async S=>{for await(const s of S)p.emitOne(s)}))})}static{this.EMPTY=Ae.fromArray([])}constructor(l){this.a=0,this.b=[],this.d=null,this.f=new B.$7d,queueMicrotask(async()=>{const p={emitOne:S=>this.g(S),emitMany:S=>this.h(S),reject:S=>this.k(S)};try{await Promise.resolve(l(p)),this.j()}catch(S){this.k(S)}finally{p.emitOne=void 0,p.emitMany=void 0,p.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===1)return{done:!0,value:void 0};await B.Event.toPromise(this.f.event)}while(!0)}}}static map(l,p){return new Ae(async S=>{for await(const s of l)S.emitOne(p(s))})}map(l){return Ae.map(this,l)}static filter(l,p){return new Ae(async S=>{for await(const s of l)p(s)&&S.emitOne(s)})}filter(l){return Ae.filter(this,l)}static coalesce(l){return Ae.filter(l,p=>!!p)}coalesce(){return Ae.coalesce(this)}static async toPromise(l){const p=[];for await(const S of l)p.push(S);return p}toPromise(){return Ae.toPromise(this)}g(l){this.a===0&&(this.b.push(l),this.f.fire())}h(l){this.a===0&&(this.b=this.b.concat(l),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(l){this.a===0&&(this.a=2,this.d=l,this.f.fire())}}t.$Ih=Ae;class Le extends Ae{constructor(l,p){super(p),this.l=l}cancel(){this.l.cancel()}}t.$Jh=Le;function x(D){const l=new n.$ee,p=D(l.token);return new Le(l,async S=>{const s=l.token.onCancellationRequested(()=>{s.dispose(),l.dispose(),S.reject(new F.$5)});try{for await(const E of p){if(l.token.isCancellationRequested)return;S.emitOne(E)}s.dispose(),l.dispose()}catch(E){s.dispose(),l.dispose(),S.reject(E)}})}class c{constructor(){this.a=new G,this.b=new Ae(S=>{if(l){S.reject(l);return}return p&&S.emitMany(p),this.d=s=>S.reject(s),this.f=s=>S.emitOne(s),this.a.p});let l,p;this.f=S=>{p||(p=[]),p.push(S)},this.d=S=>{l||(l=S)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(l){this.d(l),this.a.complete()}emitOne(l){this.f(l)}}t.$Lh=c}),define(ge[3],be([1,0,17,126,15,20,9,6,4,130,2,35,5,16,59,22]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f,e,i){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$ES=t.$CS=t.$zS=t.DetectedFullscreenMode=t.Namespace=t.$0R=t.$8R=t.$YR=t.$uR=t.$oR=t.$mR=t.$lR=t.$kR=t.$fR=t.$eR=t.$dR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$bR=h,t.$cR=w,t.$gR=O,t.$hR=P,t.$iR=L,t.$jR=$,t.$nR=V,t.$pR=T,t.$qR=K,t.$rR=te,t.$sR=$e,t.$tR=De,t.$vR=he,t.$wR=_,t.$xR=le,t.$yR=ae,t.$zR=J,t.$AR=G,t.$BR=se,t.$CR=fe,t.$DR=ve,t.$ER=Ne,t.$FR=Le,t.$GR=x,t.$HR=D,t.$IR=p,t.$JR=S,t.$KR=s,t.$LR=E,t.$MR=y,t.$NR=R,t.$OR=H,t.$PR=X,t.$QR=U,t.$RR=oe,t.$SR=we,t.$TR=me,t.$UR=ke,t.$VR=je,t.$WR=Se,t.$XR=We,t.$ZR=Ye,t.$1R=_e,t.$2R=Re,t.$3R=xe,t.$4R=et,t.$5R=it,t.$6R=st,t.$7R=Je,t.$9R=rt,t.$$R=tt,t.$_R=mt,t.$aS=At,t.$bS=kt,t.$cS=St,t.$dS=Be,t.$eS=ue,t.$=nt,t.$gS=lt,t.$hS=Xe,t.$iS=ut,t.$jS=$t,t.$kS=Xt,t.$lS=Ci,t.$mS=Ai,t.$nS=ki,t.$oS=Si,t.$pS=Ti,t.$qS=Fi,t.$rS=Ni,t.$sS=Ri,t.$tS=Ii,t.$uS=Ut,t.$vS=Li,t.$wS=Mi,t.$xS=ji,t.$yS=_t,t.$AS=Bi,t.$BS=xi,t.$DS=Hi,t.h=qi,t.$GS=ti,t.$HS=Qi,r=function(){const q=new Map;(0,i.$HQ)(i.$IQ,1);const Q={window:i.$IQ,disposables:new v.$Tc};q.set(i.$IQ.vscodeWindowId,Q);const ee=new m.$7d,de=new m.$7d,Ce=new m.$7d;function ze(Oe,qe){return(typeof Oe=="number"?q.get(Oe):void 0)??(qe?Q:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:Ce.event,onDidUnregisterWindow:de.event,registerWindow(Oe){if(q.has(Oe.vscodeWindowId))return v.$Uc.None;const qe=new v.$Tc,Ke={window:Oe,disposables:qe.add(new v.$Tc)};return q.set(Oe.vscodeWindowId,Ke),qe.add((0,v.$Sc)(()=>{q.delete(Oe.vscodeWindowId),de.fire(Oe)})),qe.add(w(Oe,t.$8R.BEFORE_UNLOAD,()=>{Ce.fire(Oe)})),ee.fire(Ke),qe},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return q.has(Oe)},getWindowById:ze,getWindow(Oe){const qe=Oe;if(qe?.ownerDocument?.defaultView)return qe.ownerDocument.defaultView.window;const Ke=Oe;return Ke?.view?Ke.view.window:i.$IQ},getDocument(Oe){const qe=Oe;return(0,t.getWindow)(qe).document}}}(),t.registerWindow=r.registerWindow,t.getWindow=r.getWindow,t.getDocument=r.getDocument,t.getWindows=r.getWindows,t.getWindowsCount=r.getWindowsCount,t.getWindowId=r.getWindowId,t.getWindowById=r.getWindowById,t.hasWindow=r.hasWindow,t.onDidRegisterWindow=r.onDidRegisterWindow,t.onWillUnregisterWindow=r.onWillUnregisterWindow,t.onDidUnregisterWindow=r.onDidUnregisterWindow;function h(q){for(;q.firstChild;)q.firstChild.remove()}class g{constructor(Q,ee,de,Ce){this.f=Q,this.g=ee,this.d=de,this.j=Ce||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function w(q,Q,ee,de){return new g(q,Q,ee,de)}function a(q,Q){return function(ee){return Q(new W.$7Q(q,ee))}}function d(q){return function(Q){return q(new B.$_Q(Q))}}const o=function(Q,ee,de,Ce){let ze=de;return ee==="click"||ee==="mousedown"?ze=a((0,t.getWindow)(Q),de):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(ze=d(de)),w(Q,ee,ze,Ce)};t.$dR=o;const C=function(Q,ee,de){const Ce=a((0,t.getWindow)(Q),ee);return O(Q,Ce,de)};t.$eR=C;const N=function(Q,ee,de){const Ce=a((0,t.getWindow)(Q),ee);return L(Q,Ce,de)};t.$fR=N;function O(q,Q,ee){return w(q,u.$r&&F.$4Q.pointerEvents?t.$8R.POINTER_DOWN:t.$8R.MOUSE_DOWN,Q,ee)}function P(q,Q,ee){return w(q,u.$r&&F.$4Q.pointerEvents?t.$8R.POINTER_MOVE:t.$8R.MOUSE_MOVE,Q,ee)}function L(q,Q,ee){return w(q,u.$r&&F.$4Q.pointerEvents?t.$8R.POINTER_UP:t.$8R.MOUSE_UP,Q,ee)}function $(q,Q,ee){return(0,A.$zh)(q,Q,ee)}class M extends A.$Ah{constructor(Q,ee){super(Q,ee)}}t.$kR=M;function V(q,Q,ee,de){let Ce=0;const ze=q.setInterval(()=>{Ce++,(typeof de=="number"&&Ce>=de||Q()===!0)&&Oe.dispose()},ee),Oe=(0,v.$Sc)(()=>{q.clearInterval(ze)});return Oe}class I extends A.$th{constructor(Q){super(),this.f=Q&&(0,t.getWindow)(Q)}cancelAndSet(Q,ee,de){return super.cancelAndSet(Q,ee,de??this.f)}}t.$oR=I;class j{constructor(Q,ee=0){this.d=Q,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,k.$1)(Q)}}static sort(Q,ee){return ee.priority-Q.priority}}(function(){const q=new Map,Q=new Map,ee=new Map,de=new Map,Ce=ze=>{ee.set(ze,!1);const Oe=q.get(ze)??[];for(Q.set(ze,Oe),q.set(ze,[]),de.set(ze,!0);Oe.length>0;)Oe.sort(j.sort),Oe.shift().execute();de.set(ze,!1)};t.$mR=(ze,Oe,qe=0)=>{const Ke=(0,t.getWindowId)(ze),Ge=new j(Oe,qe);let at=q.get(Ke);return at||(at=[],q.set(Ke,at)),at.push(Ge),ee.get(Ke)||(ee.set(Ke,!0),ze.requestAnimationFrame(()=>Ce(Ke))),Ge},t.$lR=(ze,Oe,qe)=>{const Ke=(0,t.getWindowId)(ze);if(de.get(Ke)){const Ge=new j(Oe,qe);let at=Q.get(Ke);return at||(at=[],Q.set(Ke,at)),at.push(Ge),Ge}else return(0,t.$mR)(ze,Oe,qe)}})();function T(q,Q){return(0,t.$mR)(q,Q,1e4)}function K(q,Q){return(0,t.$mR)(q,Q,-1e4)}const Z=8,ce=function(q,Q){return Q};class re extends v.$Uc{constructor(Q,ee,de,Ce=ce,ze=Z){super();let Oe=null,qe=0;const Ke=this.B(new A.$sh),Ge=()=>{qe=new Date().getTime(),de(Oe),Oe=null};this.B(w(Q,ee,at=>{Oe=Ce(Oe,at);const Ft=new Date().getTime()-qe;Ft>=ze?(Ke.cancel(),Ge()):Ke.setIfNotSet(Ge,ze-Ft)}))}}function te(q,Q,ee,de,Ce){return new re(q,Q,ee,de,Ce)}function $e(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}function De(q,Q){const ee=(0,t.getWindow)(q),de=ee.document;if(q!==de.body)return new Pe(q.clientWidth,q.clientHeight);if(u.$r&&ee?.visualViewport)return new Pe(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Pe(ee.innerWidth,ee.innerHeight);if(de.body&&de.body.clientWidth&&de.body.clientHeight)return new Pe(de.body.clientWidth,de.body.clientHeight);if(de.documentElement&&de.documentElement.clientWidth&&de.documentElement.clientHeight)return new Pe(de.documentElement.clientWidth,de.documentElement.clientHeight);if(Q)return De(Q);throw new Error("Unable to figure out browser width and height")}class Te{static d(Q,ee){return parseFloat(ee)||0}static f(Q,ee,de){const Ce=$e(Q),ze=Ce?Ce.getPropertyValue(ee):"0";return Te.d(Q,ze)}static getBorderLeftWidth(Q){return Te.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return Te.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return Te.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return Te.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return Te.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return Te.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return Te.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return Te.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return Te.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return Te.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return Te.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return Te.f(Q,"margin-bottom","marginBottom")}}class Pe{static{this.None=new Pe(0,0)}constructor(Q,ee){this.width=Q,this.height=ee}with(Q=this.width,ee=this.height){return Q!==this.width||ee!==this.height?new Pe(Q,ee):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof Pe?Q:new Pe(Q.width,Q.height)}static equals(Q,ee){return Q===ee?!0:!Q||!ee?!1:Q.width===ee.width&&Q.height===ee.height}}t.$uR=Pe;function he(q){let Q=q.offsetParent,ee=q.offsetTop,de=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){ee-=q.scrollTop;const Ce=E(q)?null:$e(q);Ce&&(de-=Ce.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===Q&&(de+=Te.getBorderLeftWidth(q),ee+=Te.getBorderTopWidth(q),ee+=q.offsetTop,de+=q.offsetLeft,Q=q.offsetParent)}return{left:de,top:ee}}function _(q,Q,ee){typeof Q=="number"&&(q.style.width=`${Q}px`),typeof ee=="number"&&(q.style.height=`${ee}px`)}function le(q,Q,ee,de,Ce,ze="absolute"){typeof Q=="number"&&(q.style.top=`${Q}px`),typeof ee=="number"&&(q.style.right=`${ee}px`),typeof de=="number"&&(q.style.bottom=`${de}px`),typeof Ce=="number"&&(q.style.left=`${Ce}px`),q.style.position=ze}function ae(q){const Q=q.getBoundingClientRect(),ee=(0,t.getWindow)(q);return{left:Q.left+ee.scrollX,top:Q.top+ee.scrollY,width:Q.width,height:Q.height}}function J(q){let Q=q,ee=1;do{const de=$e(Q).zoom;de!=null&&de!=="1"&&(ee*=de),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return ee}function G(q){const Q=Te.getMarginLeft(q)+Te.getMarginRight(q);return q.offsetWidth+Q}function se(q){const Q=Te.getBorderLeftWidth(q)+Te.getBorderRightWidth(q),ee=Te.getPaddingLeft(q)+Te.getPaddingRight(q);return q.offsetWidth-Q-ee}function fe(q){const Q=Te.getMarginLeft(q)+Te.getMarginRight(q);return q.scrollWidth+Q}function ve(q){const Q=Te.getBorderTopWidth(q)+Te.getBorderBottomWidth(q),ee=Te.getPaddingTop(q)+Te.getPaddingBottom(q);return q.offsetHeight-Q-ee}function Ne(q){const Q=Te.getMarginTop(q)+Te.getMarginBottom(q);return q.offsetHeight+Q}function Ae(q,Q){if(q===null)return 0;const ee=he(q),de=he(Q);return ee.left-de.left}function Le(q,Q){const ee=Q.map(Ce=>Math.max(fe(Ce),G(Ce))+Ae(Ce,q)||0);return Math.max(...ee)}function x(q,Q){return!!Q?.contains(q)}const c="parentFlowToElementId";function D(q,Q){q.dataset[c]=Q.id}function l(q){const Q=q.dataset[c];return typeof Q=="string"?q.ownerDocument.getElementById(Q):null}function p(q,Q){let ee=q;for(;ee;){if(ee===Q)return!0;if(ee instanceof HTMLElement){const de=l(ee);if(de){ee=de;continue}}ee=ee.parentNode}return!1}function S(q,Q,ee){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(Q))return q;if(ee){if(typeof ee=="string"){if(q.classList.contains(ee))return null}else if(q===ee)return null}q=q.parentNode}return null}function s(q,Q,ee){return!!S(q,Q,ee)}function E(q){return q&&!!q.host&&!!q.mode}function y(q){return!!R(q)}function R(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return E(q)?q:null}function H(){let q=we().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}function X(q){return H()===q}function U(q){return x(H(),q)}function oe(q){return q.ownerDocument===we()}function we(){return(0,t.getWindowsCount)()<=1?i.$IQ.document:Array.from((0,t.getWindows)()).map(({window:Q})=>Q.document).find(Q=>Q.hasFocus())??i.$IQ.document}function me(){return we().defaultView?.window??i.$IQ}const Ie=new Map;function ke(q){return Ie.has(q)}function je(){return new Ee}class Ee{constructor(){this.d="",this.f=void 0}setStyle(Q){Q!==this.d&&(this.d=Q,this.f?this.f.innerText=Q:this.f=Se(i.$IQ.document.head,ee=>ee.innerText=Q))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Se(q=i.$IQ.document.head,Q,ee){const de=document.createElement("style");if(de.type="text/css",de.media="screen",Q?.(de),q.appendChild(de),ee&&ee.add((0,v.$Sc)(()=>q.removeChild(de))),q===i.$IQ.document.head){const Ce=new Set;Ie.set(de,Ce);for(const{window:ze,disposables:Oe}of(0,t.getWindows)()){if(ze===i.$IQ)continue;const qe=Oe.add(Ue(de,Ce,ze));ee?.add(qe)}}return de}function We(q){const Q=new v.$Tc;for(const[ee,de]of Ie)Q.add(Ue(ee,de,q));return Q}function Ue(q,Q,ee){const de=new v.$Tc,Ce=q.cloneNode(!0);ee.document.head.appendChild(Ce),de.add((0,v.$Sc)(()=>ee.document.head.removeChild(Ce)));for(const ze of ye(q))Ce.sheet?.insertRule(ze.cssText,Ce.sheet?.cssRules.length);return de.add(t.$YR.observe(q,de,{childList:!0})(()=>{Ce.textContent=q.textContent})),Q.add(Ce),de.add((0,v.$Sc)(()=>Q.delete(Ce))),de}t.$YR=new class{constructor(){this.mutationObservers=new Map}observe(q,Q,ee){let de=this.mutationObservers.get(q);de||(de=new Map,this.mutationObservers.set(q,de));const Ce=(0,e.$9i)(ee);let ze=de.get(Ce);if(ze)ze.users+=1;else{const Oe=new m.$7d,qe=new MutationObserver(Ge=>Oe.fire(Ge));qe.observe(q,ee);const Ke=ze={users:1,observer:qe,onDidMutate:Oe.event};Q.add((0,v.$Sc)(()=>{Ke.users-=1,Ke.users===0&&(Oe.dispose(),qe.disconnect(),de?.delete(Ce),de?.size===0&&this.mutationObservers.delete(q))})),de.set(Ce,ze)}return ze.onDidMutate}};function Ye(q=i.$IQ.document.head){return Y("meta",q)}function _e(q=i.$IQ.document.head){return Y("link",q)}function Y(q,Q=i.$IQ.document.head){const ee=document.createElement(q);return Q.appendChild(ee),ee}let ne=null;function pe(){return ne||(ne=Se()),ne}function ye(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Re(q,Q,ee=pe()){if(!(!ee||!Q)){ee.sheet?.insertRule(`${q} {${Q}}`,0);for(const de of Ie.get(ee)??[])Re(q,Q,de)}}function xe(q,Q=pe()){if(!Q)return;const ee=ye(Q),de=[];for(let Ce=0;Ce<ee.length;Ce++){const ze=ee[Ce];Ve(ze)&&ze.selectorText.indexOf(q)!==-1&&de.push(Ce)}for(let Ce=de.length-1;Ce>=0;Ce--)Q.sheet?.deleteRule(de[Ce]);for(const Ce of Ie.get(Q)??[])xe(q,Ce)}function Ve(q){return typeof q.selectorText=="string"}function et(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}function it(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}function st(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}function Je(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$8R={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:n.$VQ?"webkitAnimationStart":"animationstart",ANIMATION_END:n.$VQ?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:n.$VQ?"webkitAnimationIteration":"animationiteration"};function rt(q){const Q=q;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$0R={stop:(q,Q)=>(q.preventDefault(),Q&&q.stopPropagation(),q)};function tt(q){const Q=[];for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)Q[ee]=q.scrollTop,q=q.parentNode;return Q}function mt(q,Q){for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)q.scrollTop!==Q[ee]&&(q.scrollTop=Q[ee]),q=q.parentNode}class gt extends v.$Uc{static m(Q){if(Q instanceof HTMLElement){const ee=R(Q),de=ee?ee.activeElement:Q.ownerDocument.activeElement;return x(de,Q)}else{const ee=Q;return x(ee.document.activeElement,ee.document)}}constructor(Q){super(),this.f=this.B(new m.$7d),this.onDidFocus=this.f.event,this.g=this.B(new m.$7d),this.onDidBlur=this.g.event;let ee=gt.m(Q),de=!1;const Ce=()=>{de=!1,ee||(ee=!0,this.f.fire())},ze=()=>{ee&&(de=!0,(Q instanceof HTMLElement?(0,t.getWindow)(Q):Q).setTimeout(()=>{de&&(de=!1,ee=!1,this.g.fire())},0))};this.j=()=>{gt.m(Q)!==ee&&(ee?ze():Ce())},this.B(w(Q,t.$8R.FOCUS,Ce,!0)),this.B(w(Q,t.$8R.BLUR,ze,!0)),Q instanceof HTMLElement&&(this.B(w(Q,t.$8R.FOCUS_IN,()=>this.j())),this.B(w(Q,t.$8R.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(q){return new gt(q)}function kt(q,Q){return q.after(Q),Q}function St(q,...Q){if(q.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}function Be(q,Q){return q.insertBefore(Q,q.firstChild),Q}function ue(q,...Q){q.innerText="",St(q,...Q)}const Fe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Me;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(Me||(t.Namespace=Me={}));function Qe(q,Q,ee,...de){const Ce=Fe.exec(Q);if(!Ce)throw new Error("Bad use of emmet");const ze=Ce[1]||"div";let Oe;return q!==Me.HTML?Oe=document.createElementNS(q,ze):Oe=document.createElement(ze),Ce[3]&&(Oe.id=Ce[3]),Ce[4]&&(Oe.className=Ce[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([qe,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(qe)?Oe[qe]=Ke:qe==="selected"?Ke&&Oe.setAttribute(qe,"true"):Oe.setAttribute(qe,Ke))}),Oe.append(...de),Oe}function nt(q,Q,...ee){return Qe(Me.HTML,q,Q,...ee)}nt.SVG=function(q,Q,...ee){return Qe(Me.SVG,q,Q,...ee)};function lt(q,Q){const ee=[];return q.forEach((de,Ce)=>{Ce>0&&(Q instanceof Node?ee.push(Q.cloneNode()):ee.push(document.createTextNode(Q))),ee.push(de)}),ee}function Xe(q,...Q){q?ut(...Q):$t(...Q)}function ut(...q){for(const Q of q)Q.style.display="",Q.removeAttribute("aria-hidden")}function $t(...q){for(const Q of q)Q.style.display="none",Q.setAttribute("aria-hidden","true")}function Tt(q,Q){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(Q))return q;q=q.parentNode}return null}function Xt(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&Tt(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}function Ci(q){return Q=>{Q.preventDefault(),Q.stopPropagation(),q(Q)}}function Ai(q){return new Promise(Q=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)Q(void 0);else{const de=()=>{q.window.removeEventListener("DOMContentLoaded",de,!1),Q()};q.window.addEventListener("DOMContentLoaded",de,!1)}})}function ki(q,Q){const ee=q.devicePixelRatio*Q;return Math.max(1,Math.floor(ee))/q.devicePixelRatio}function Si(q){i.$IQ.open(q,"_blank","noopener")}const Zt=780,Jt=640;function Ti(q){const Q=Math.floor(i.$IQ.screenLeft+i.$IQ.innerWidth/2-Zt/2),ee=Math.floor(i.$IQ.screenTop+i.$IQ.innerHeight/2-Jt/2);i.$IQ.open(q,"_blank",`width=${Zt},height=${Jt},top=${ee},left=${Q}`)}function Fi(q,Q=!0){const ee=i.$IQ.open();return ee?(Q&&(ee.opener=null),ee.location.href=q,!0):!1}function Ni(q,Q){const ee=()=>{Q(),de=(0,t.$mR)(q,ee)};let de=(0,t.$mR)(q,ee);return(0,v.$Sc)(()=>de.dispose())}z.$vg.setPreferredWebSchema(/^https:/.test(i.$IQ.location.href)?"https":"http");function Ri(q){return q?`url('${z.$Cg.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ii(q){return`'${q.replace(/'/g,"%27")}'`}function Ut(q,Q){if(q!==void 0){const ee=q.match(/^\s*var\((.+)\)$/);if(ee){const de=ee[1].split(",",2);return de.length===2&&(Q=Ut(de[1].trim(),Q)),`var(${de[0]}, ${Q})`}return q}return Q}function Li(q,Q){let ee;if(f.URI.isUri(q))ee=q.toString(!0);else{const ze=new Blob([q]);ee=URL.createObjectURL(ze),setTimeout(()=>URL.revokeObjectURL(ee))}const de=me(),Ce=document.createElement("a");de.document.body.appendChild(Ce),Ce.download=Q,Ce.href=ee,Ce.click(),setTimeout(()=>de.document.body.removeChild(Ce))}function Mi(){return new Promise(q=>{const Q=me(),ee=document.createElement("input");Q.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(ee,"input"))(()=>{q(ee.files??void 0)}),ee.click(),setTimeout(()=>Q.document.body.removeChild(ee))})}var yt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function ji(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:yt.BROWSER,guess:!1}:(u.$j||u.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:yt.BROWSER,guess:!0}:null}function _t(q,Q=!1){const ee=document.createElement("a");return b.addHook("afterSanitizeAttributes",de=>{for(const Ce of["href","src"])if(de.hasAttribute(Ce)){const ze=de.getAttribute(Ce);if(Ce==="href"&&ze.startsWith("#"))continue;if(ee.href=ze,!q.includes(ee.protocol.replace(/:$/,""))){if(Q&&Ce==="src"&&ee.href.startsWith("data:"))continue;de.removeAttribute(Ce)}}}),(0,v.$Sc)(()=>{b.removeHook("afterSanitizeAttributes")})}const Oi=[z.Schemas.http,z.Schemas.https,z.Schemas.command];t.$zS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(q,Q){const ee=_t(Oi);try{const de=b.sanitize(Q,Pi);q.innerHTML=de}finally{ee.dispose()}}function zi(q){const Q=new Uint16Array(q.length);for(let Ce=0;Ce<Q.length;Ce++)Q[Ce]=q.charCodeAt(Ce);let ee="";const de=new Uint8Array(Q.buffer);for(let Ce=0;Ce<de.length;Ce++)ee+=String.fromCharCode(de[Ce]);return ee}function xi(q){return btoa(zi(q))}class pt extends m.$7d{constructor(){super(),this.o=new v.$Tc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Q,disposables:ee})=>this.C(Q,ee),{window:i.$IQ,disposables:this.o}))}C(Q,ee){ee.add(w(Q,"keydown",de=>{if(de.defaultPrevented)return;const Ce=new B.$_Q(de);if(!(Ce.keyCode===6&&de.repeat)){if(de.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(de.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(de.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(de.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Ce.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyPressed&&(this.A.event=de,this.fire(this.A))}},!0)),ee.add(w(Q,"keyup",de=>{de.defaultPrevented||(!de.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!de.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!de.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!de.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyReleased&&(this.A.event=de,this.fire(this.A)))},!0)),ee.add(w(Q.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(w(Q.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(w(Q.document.body,"mousemove",de=>{de.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add(w(Q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$CS=pt;function Hi(q){const Q=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}class Wi extends v.$Uc{constructor(Q,ee){super(),this.j=Q,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(w(this.j,t.$8R.DRAG_START,Q=>{this.m.onDragStart?.(Q)})),this.m.onDrag&&this.B(w(this.j,t.$8R.DRAG,Q=>{this.m.onDrag?.(Q)})),this.B(w(this.j,t.$8R.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter?.(Q)})),this.B(w(this.j,t.$8R.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B(w(this.j,t.$8R.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Q))})),this.B(w(this.j,t.$8R.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd?.(Q)})),this.B(w(this.j,t.$8R.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop?.(Q)}))}}t.$ES=Wi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(q,...Q){let ee,de;Array.isArray(Q[0])?(ee={},de=Q[0]):(ee=Q[0]||{},de=Q[1]);const Ce=Vi.exec(q);if(!Ce||!Ce.groups)throw new Error("Bad use of h");const ze=Ce.groups.tag||"div",Oe=document.createElement(ze);Ce.groups.id&&(Oe.id=Ce.groups.id);const qe=[];if(Ce.groups.class)for(const Ge of Ce.groups.class.split("."))Ge!==""&&qe.push(Ge);if(ee.className!==void 0)for(const Ge of ee.className.split("."))Ge!==""&&qe.push(Ge);qe.length>0&&(Oe.className=qe.join(" "));const Ke={};if(Ce.groups.name&&(Ke[Ce.groups.name]=Oe),de)for(const Ge of de)Ge instanceof HTMLElement?Oe.appendChild(Ge):typeof Ge=="string"?Oe.append(Ge):"root"in Ge&&(Object.assign(Ke,Ge),Oe.appendChild(Ge.root));for(const[Ge,at]of Object.entries(ee))if(Ge!=="className")if(Ge==="style")for(const[Ft,Pt]of Object.entries(at))Oe.style.setProperty(ei(Ft),typeof Pt=="number"?Pt+"px":""+Pt);else Ge==="tabIndex"?Oe.tabIndex=at:Oe.setAttribute(ei(Ge),at.toString());return Ke.root=Oe,Ke}function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,Q,ee){for(const{name:de,value:Ce}of q.attributes)(!ee||ee.includes(de))&&Q.setAttribute(de,Ce)}function Ki(q,Q,ee){const de=q.getAttribute(ee);de?Q.setAttribute(ee,de):Q.removeAttribute(ee)}function Qi(q,Q,ee){ti(q,Q,ee);const de=new v.$Tc;return de.add(t.$YR.observe(q,de,{attributes:!0,attributeFilter:ee})(Ce=>{for(const ze of Ce)ze.type==="attributes"&&ze.attributeName&&Ki(q,Q,ze.attributeName)})),de}}),define(ge[64],be([1,0,3,2,129]),function(ie,t,n,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JS=t.$IS=void 0,t.$KS=A;class W extends F.$Uc{constructor(m,b){super(),this.B((0,n.$cR)(m,"dragover",v=>{v.preventDefault(),this.a||(this.a=setTimeout(()=>{b(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(v=>{this.B((0,n.$cR)(m,v,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$IS=W,t.$JS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.$zs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function A(k,m,b,v,z){const u=document.createElement("div");if(u.className=b,u.textContent=m,z&&(u.style.color=z),v&&(u.style.background=v),k.dataTransfer){const f=(0,n.getWindow)(k).document;f.body.appendChild(u),k.dataTransfer.setDragImage(u,-10,-10),setTimeout(()=>f.body.removeChild(u),0)}}}),define(ge[65],be([1,0,3]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dT=F,t.$eT=B,t.$fT=W;function F(u,f={}){const e=W(f);return e.textContent=u,e}function B(u,f={}){const e=W(f);return m(e,b(u,!!f.renderCodeSegments),f.actionHandler,f.renderCodeSegments),e}function W(u){const f=u.inline?"span":"div",e=document.createElement(f);return u.className&&(e.className=u.className),e}class A{constructor(f){this.b=f,this.c=0}eos(){return this.c>=this.b.length}next(){const f=this.peek();return this.advance(),f}peek(){return this.b[this.c]}advance(){this.c++}}var k;(function(u){u[u.Invalid=0]="Invalid",u[u.Root=1]="Root",u[u.Text=2]="Text",u[u.Bold=3]="Bold",u[u.Italics=4]="Italics",u[u.Action=5]="Action",u[u.ActionClose=6]="ActionClose",u[u.Code=7]="Code",u[u.NewLine=8]="NewLine"})(k||(k={}));function m(u,f,e,i){let r;if(f.type===2)r=document.createTextNode(f.content||"");else if(f.type===3)r=document.createElement("b");else if(f.type===4)r=document.createElement("i");else if(f.type===7&&i)r=document.createElement("code");else if(f.type===5&&e){const h=document.createElement("a");e.disposables.add(n.$dR(h,"click",g=>{e.callback(String(f.index),g)})),r=h}else f.type===8?r=document.createElement("br"):f.type===1&&(r=u);r&&u!==r&&u.appendChild(r),r&&Array.isArray(f.children)&&f.children.forEach(h=>{m(r,h,e,i)})}function b(u,f){const e={type:1,children:[]};let i=0,r=e;const h=[],g=new A(u);for(;!g.eos();){let w=g.next();const a=w==="\\"&&z(g.peek(),f)!==0;if(a&&(w=g.next()),!a&&v(w,f)&&w===g.peek()){g.advance(),r.type===2&&(r=h.pop());const d=z(w,f);if(r.type===d||r.type===5&&d===6)r=h.pop();else{const o={type:d,children:[]};d===5&&(o.index=i,i++),r.children.push(o),h.push(r),r=o}}else if(w===`
`)r.type===2&&(r=h.pop()),r.children.push({type:8});else if(r.type!==2){const d={type:2,content:w};r.children.push(d),h.push(r),r=d}else r.content+=w}return r.type===2&&(r=h.pop()),h.length,e}function v(u,f){return z(u,f)!==0}function z(u,f){switch(u){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return f?7:0;default:return 0}}}),define(ge[66],be([1,0,3,2]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OS=void 0;class B{constructor(){this.a=new F.$Tc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(A,k){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const m=this.c;this.c=null,A&&m&&m(k)}isMonitoring(){return!!this.b}startMonitoring(A,k,m,b,v){this.isMonitoring()&&this.stopMonitoring(!1),this.b=b,this.c=v;let z=A;try{A.setPointerCapture(k),this.a.add((0,F.$Sc)(()=>{try{A.releasePointerCapture(k)}catch{}}))}catch{z=n.getWindow(A)}this.a.add(n.$cR(z,n.$8R.POINTER_MOVE,u=>{if(u.buttons!==m){this.stopMonitoring(!0);return}u.preventDefault(),this.b(u)})),this.a.add(n.$cR(z,n.$8R.POINTER_UP,u=>this.stopMonitoring(!0)))}}t.$OS=B});var Ze=this&&this.__decorate||function(ie,t,n,F){var B=arguments.length,W=B<3?t:F===null?F=Object.getOwnPropertyDescriptor(t,n):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(ie,t,n,F);else for(var k=ie.length-1;k>=0;k--)(A=ie[k])&&(W=(B<3?A(W):B>3?A(t,n,W):A(t,n))||W);return B>3&&W&&Object.defineProperty(t,n,W),W};define(ge[29],be([1,0,3,22,12,31,4,2,55]),function(ie,t,n,F,B,W,A,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LS=t.EventType=void 0;var b;(function(z){z.Tap="-monaco-gesturetap",z.Change="-monaco-gesturechange",z.Start="-monaco-gesturestart",z.End="-monaco-gesturesend",z.Contextmenu="-monaco-gesturecontextmenu"})(b||(t.EventType=b={}));class v extends k.$Uc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new m.$5c,this.m=new m.$5c,this.r={},this.n=null,this.s=0,this.B(A.Event.runAndSubscribe(n.onDidRegisterWindow,({window:u,disposables:f})=>{f.add(n.$cR(u.document,"touchstart",e=>this.w(e),{passive:!1})),f.add(n.$cR(u.document,"touchend",e=>this.z(u,e))),f.add(n.$cR(u.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:F.$IQ,disposables:this.q}))}static addTarget(u){if(!v.isTouchDevice())return k.$Uc.None;v.f||(v.f=(0,k.$Nc)(new v));const f=v.f.j.push(u);return(0,k.$Sc)(f)}static ignoreTarget(u){if(!v.isTouchDevice())return k.$Uc.None;v.f||(v.f=(0,k.$Nc)(new v));const f=v.f.m.push(u);return(0,k.$Sc)(f)}static isTouchDevice(){return"ontouchstart"in F.$IQ||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(u){const f=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,i=u.targetTouches.length;e<i;e++){const r=u.targetTouches.item(e);this.r[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:f,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[f],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const h=this.C(b.Start,r.target);h.pageX=r.pageX,h.pageY=r.pageY,this.D(h)}this.h&&(u.preventDefault(),u.stopPropagation(),this.h=!1)}z(u,f){const e=Date.now(),i=Object.keys(this.r).length;for(let r=0,h=f.changedTouches.length;r<h;r++){const g=f.changedTouches.item(r);if(!this.r.hasOwnProperty(String(g.identifier))){console.warn("move of an UNKNOWN touch",g);continue}const w=this.r[g.identifier],a=Date.now()-w.initialTimeStamp;if(a<v.g&&Math.abs(w.initialPageX-B.$sb(w.rollingPageX))<30&&Math.abs(w.initialPageY-B.$sb(w.rollingPageY))<30){const d=this.C(b.Tap,w.initialTarget);d.pageX=B.$sb(w.rollingPageX),d.pageY=B.$sb(w.rollingPageY),this.D(d)}else if(a>=v.g&&Math.abs(w.initialPageX-B.$sb(w.rollingPageX))<30&&Math.abs(w.initialPageY-B.$sb(w.rollingPageY))<30){const d=this.C(b.Contextmenu,w.initialTarget);d.pageX=B.$sb(w.rollingPageX),d.pageY=B.$sb(w.rollingPageY),this.D(d)}else if(i===1){const d=B.$sb(w.rollingPageX),o=B.$sb(w.rollingPageY),C=B.$sb(w.rollingTimestamps)-w.rollingTimestamps[0],N=d-w.rollingPageX[0],O=o-w.rollingPageY[0],P=[...this.j].filter(L=>w.initialTarget instanceof Node&&L.contains(w.initialTarget));this.F(u,P,e,Math.abs(N)/C,N>0?1:-1,d,Math.abs(O)/C,O>0?1:-1,o)}this.D(this.C(b.End,w.initialTarget)),delete this.r[g.identifier]}this.h&&(f.preventDefault(),f.stopPropagation(),this.h=!1)}C(u,f){const e=document.createEvent("CustomEvent");return e.initEvent(u,!1,!0),e.initialTarget=f,e.tapCount=0,e}D(u){if(u.type===b.Tap){const f=new Date().getTime();let e=0;f-this.s>v.u?e=1:e=2,this.s=f,u.tapCount=e}else(u.type===b.Change||u.type===b.Contextmenu)&&(this.s=0);if(u.initialTarget instanceof Node){for(const e of this.m)if(e.contains(u.initialTarget))return;const f=[];for(const e of this.j)if(e.contains(u.initialTarget)){let i=0,r=u.initialTarget;for(;r&&r!==e;)i++,r=r.parentElement;f.push([i,e])}f.sort((e,i)=>e[0]-i[0]);for(const[e,i]of f)i.dispatchEvent(u),this.h=!0}}F(u,f,e,i,r,h,g,w,a){this.n=n.$mR(u,()=>{const d=Date.now(),o=d-e;let C=0,N=0,O=!0;i+=v.c*o,g+=v.c*o,i>0&&(O=!1,C=r*i*o),g>0&&(O=!1,N=w*g*o);const P=this.C(b.Change);P.translationX=C,P.translationY=N,f.forEach(L=>L.dispatchEvent(P)),O||this.F(u,f,d,i,r,h+C,g,w,a+N)})}G(u){const f=Date.now();for(let e=0,i=u.changedTouches.length;e<i;e++){const r=u.changedTouches.item(e);if(!this.r.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const h=this.r[r.identifier],g=this.C(b.Change,h.initialTarget);g.translationX=r.pageX-B.$sb(h.rollingPageX),g.translationY=r.pageY-B.$sb(h.rollingPageY),g.pageX=r.pageX,g.pageY=r.pageY,this.D(g),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(r.pageX),h.rollingPageY.push(r.pageY),h.rollingTimestamps.push(f)}this.h&&(u.preventDefault(),u.stopPropagation(),this.h=!1)}}t.$LS=v,Ze([W.$Mh],v,"isTouchDevice",null)}),define(ge[67],be([1,0,3,104]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hT=b,t.$iT=v,t.$jT=z;const F=2e4;let B,W,A,k,m;function b(f){B=document.createElement("div"),B.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),B.appendChild(r),r};W=e(),A=e();const i=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),B.appendChild(r),r};k=i(),m=i(),f.appendChild(B)}function v(f){B&&(W.textContent!==f?(n.$bR(A),u(W,f)):(n.$bR(W),u(A,f)))}function z(f){B&&(k.textContent!==f?(n.$bR(m),u(k,f)):(n.$bR(k),u(m,f)))}function u(f,e){n.$bR(f),e.length>F&&(e=e.substr(0,F)),f.textContent=e,f.style.visibility="hidden",f.style.visibility="visible"}}),define(ge[131],be([1,0,3,19]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MT=W,t.$NT=A;const B=new RegExp(`(\\\\)?\\$\\((${F.ThemeIcon.iconNameExpression}(?:${F.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(k){const m=new Array;let b,v=0,z=0;for(;(b=B.exec(k))!==null;){z=b.index||0,v<z&&m.push(k.substring(v,z)),v=(b.index||0)+b[0].length;const[,u,f]=b;m.push(u?`$(${f})`:A({id:f}))}return v<k.length&&m.push(k.substring(v)),m}function A(k){const m=n.$("span");return m.classList.add(...F.ThemeIcon.asClassNameArray(k)),m}}),define(ge[132],be([1,0,3]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=void 0;function F(W){try{W.parentElement?.removeChild(W)}catch{}}class B{constructor(A){this.d=A,this.a=new Map,this.b=new Set,this.c=!1}alloc(A){let k=this.h(A).pop(),m=!1;if(k)m=this.b.has(k.domNode),m&&this.b.delete(k.domNode);else{const b=(0,n.$)(".monaco-list-row"),z=this.i(A).renderTemplate(b);k={domNode:b,templateId:A,templateData:z}}return{row:k,isReusingConnectedDomNode:m}}release(A){A&&this.f(A)}transact(A){if(this.c)throw new Error("Already in transaction");this.c=!0;try{A()}finally{for(const k of this.b)this.g(k);this.b.clear(),this.c=!1}}f(A){const{domNode:k,templateId:m}=A;k&&(this.c?this.b.add(k):this.g(k)),this.h(m).push(A)}g(A){A.classList.remove("scrolling"),F(A)}h(A){let k=this.a.get(A);return k||(k=[],this.a.set(A,k)),k}dispose(){this.a.forEach((A,k)=>{for(const m of A)this.i(k).disposeTemplate(m.templateData),m.templateData=null}),this.a.clear(),this.b.clear()}i(A){const k=this.d.get(A);if(!k)throw new Error(`No renderer found for ${A}`);return k}}t.$pT=B}),define(ge[133],be([1,0,9,2]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TS=void 0;class B extends F.$Uc{constructor(A,k,m){super(),this.a=A,this.b=k,this.c=m,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new n.$sh)}setVisibility(A){this.a!==A&&(this.a=A,this.s())}setShouldBeVisible(A){this.g=A,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const A=this.r();this.h!==A&&(this.h=A,this.ensureVisibility())}setIsNeeded(A){this.j!==A&&(this.j=A,this.ensureVisibility())}setDomNode(A){this.f=A,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(A){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(A?" fade":"")))}}t.$TS=B}),define(ge[134],be([1,0,3,29,12,4,2,5]),function(ie,t,n,F,B,W,A,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=void 0;class m extends A.$Uc{constructor(v,z,u,f){super(),this.f=0,this.b=f||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.$7d),this.h=u,this.j(),this.setOptions(v,z)}j(){this.B(F.$LS.addTarget(this.a)),[F.EventType.Tap].forEach(v=>{this.B(n.$cR(this.a,v,z=>{this.a.focus()}))}),this.B(n.$dR(this.a,"click",v=>{n.$0R.stop(v,!0)})),this.B(n.$dR(this.a,"change",v=>{this.a.title=v.target.value,this.g.fire({index:v.target.selectedIndex,selected:v.target.value})})),this.B(n.$dR(this.a,"keydown",v=>{let z=!1;k.$j?(v.keyCode===18||v.keyCode===16||v.keyCode===10)&&(z=!0):(v.keyCode===18&&v.altKey||v.keyCode===10||v.keyCode===3)&&(z=!0),z&&v.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(v,z){(!this.c||!B.$ub(this.c,v))&&(this.c=v,this.a.options.length=0,this.c.forEach((u,f)=>{this.a.add(this.m(u.text,f,u.isDisabled))})),z!==void 0&&this.select(z)}select(v){this.c.length===0?this.f=0:v>=0&&v<this.c.length?this.f=v:v>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(v){this.b.ariaLabel=v,this.a.setAttribute("aria-label",v)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(v){this.a.tabIndex=v?0:-1}render(v){v.classList.add("select-container"),v.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(v){this.h=v,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(v,z,u){const f=document.createElement("option");return f.value=v,f.text=v,f.disabled=!!u,f}}t.$UT=m}),define(ge[68],be([1,0,30,12,9,60,98,4,32]),function(ie,t,n,F,B,W,A,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sV=void 0,t.$qV=b,t.$rV=v;function b(f){return typeof f=="object"&&"visibility"in f&&"data"in f}function v(f){switch(f){case!0:return 1;case!1:return 0;default:return f}}function z(f){return typeof f.collapsible=="boolean"}class u{constructor(e,i,r,h={}){this.p=e,this.q=i,this.rootRef=[],this.d=new k.$ce,this.f=new k.$7d,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new k.$7d,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new k.$7d,this.onDidSplice=this.m.event,this.o=new B.$fh(W.$4d),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,i,r=m.Iterable.empty(),h={}){if(e.length===0)throw new n.$oV(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,i,r,h):this.t(e,i,r,h)}s(e,i,r,h=m.Iterable.empty(),g,w=g.diffDepth??0){const{parentNode:a}=this.H(i);if(!a.lastDiffIds)return this.t(i,r,h,g);const d=[...h],o=i[i.length-1],C=new A.$it({getElements:()=>a.lastDiffIds},{getElements:()=>[...a.children.slice(0,o),...d,...a.children.slice(o+r)].map($=>e.getId($.element).toString())}).ComputeDiff(!1);if(C.quitEarly)return a.lastDiffIds=void 0,this.t(i,r,d,g);const N=i.slice(0,-1),O=($,M,V)=>{if(w>0)for(let I=0;I<V;I++)$--,M--,this.s(e,[...N,$,0],Number.MAX_SAFE_INTEGER,d[M].children,g,w-1)};let P=Math.min(a.children.length,o+r),L=d.length;for(const $ of C.changes.sort((M,V)=>V.originalStart-M.originalStart))O(P,L,P-($.originalStart+$.originalLength)),P=$.originalStart,L=$.modifiedStart-o,this.t([...N,P],$.originalLength,m.Iterable.slice(d,L,L+$.modifiedLength),g);O(P,L,P)}t(e,i,r=m.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:g,diffIdentityProvider:w}){const{parentNode:a,listIndex:d,revealed:o,visible:C}=this.H(e),N=[],O=m.Iterable.map(r,K=>this.x(K,a,a.visible?1:0,o,N,h)),P=e[e.length-1];let L=0;for(let K=P;K>=0&&K<a.children.length;K--){const Z=a.children[K];if(Z.visible){L=Z.visibleChildIndex;break}}const $=[];let M=0,V=0;for(const K of O)$.push(K),V+=K.renderNodeCount,K.visible&&(K.visibleChildIndex=L+M++);const I=(0,F.$6b)(a.children,P,i,$);w?a.lastDiffIds?(0,F.$6b)(a.lastDiffIds,P,i,$.map(K=>w.getId(K.element).toString())):a.lastDiffIds=a.children.map(K=>w.getId(K.element).toString()):a.lastDiffIds=void 0;let j=0;for(const K of I)K.visible&&j++;if(j!==0)for(let K=P+$.length;K<a.children.length;K++){const Z=a.children[K];Z.visible&&(Z.visibleChildIndex-=j)}if(a.visibleChildrenCount+=M-j,o&&C){const K=I.reduce((Z,ce)=>Z+(ce.visible?ce.renderNodeCount:0),0);this.C(a,V-K),this.q.splice(d,K,N)}if(I.length>0&&g){const K=Z=>{g(Z),Z.children.forEach(K)};I.forEach(K)}this.m.fire({insertedNodes:$,deletedNodes:I});let T=a;for(;T;){if(T.visibility===2){this.o.trigger(()=>this.refilter());break}T=T.parent}}rerender(e){if(e.length===0)throw new n.$oV(this.p,"Invalid tree location");const{node:i,listIndex:r,revealed:h}=this.G(e);i.visible&&h&&this.q.splice(r,1,[i])}updateElementHeight(e,i){if(e.length===0)throw new n.$oV(this.p,"Invalid tree location");const{listIndex:r}=this.G(e);this.q.updateElementHeight(r,i)}has(e){return this.E(e)}getListIndex(e){const{listIndex:i,visible:r,revealed:h}=this.G(e);return r&&h?i:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,i){const r=this.F(e);typeof i>"u"&&(i=!r.collapsible);const h={collapsible:i};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,i,r){const h=this.F(e);typeof i>"u"&&(i=!h.collapsed);const g={collapsed:i,recursive:r||!1};return this.d.bufferEvents(()=>this.u(e,g))}u(e,i){const{node:r,listIndex:h,revealed:g}=this.G(e),w=this.v(r,h,g,i);if(r!==this.c&&this.l&&w&&!z(i)&&r.collapsible&&!r.collapsed&&!i.recursive){let a=-1;for(let d=0;d<r.children.length;d++)if(r.children[d].visible)if(a>-1){a=-1;break}else a=d;a>-1&&this.u([...e,a],i)}return w}v(e,i,r,h){const g=this.w(e,h,!1);if(!r||!e.visible||!g)return g;const w=e.renderNodeCount,a=this.y(e),d=w-(i===-1?0:1);return this.q.splice(i+1,d,a.slice(1)),g}w(e,i,r){let h;if(e===this.c?h=!1:(z(i)?(h=e.collapsible!==i.collapsible,e.collapsible=i.collapsible):e.collapsible?(h=e.collapsed!==i.collapsed,e.collapsed=i.collapsed):h=!1,h&&this.f.fire({node:e,deep:r})),!z(i)&&i.recursive)for(const g of e.children)h=this.w(g,i,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let i=this.F(e);for(;i.parent;)i=i.parent,e=e.slice(0,e.length-1),i.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,i=this.A(this.c);this.q.splice(0,e,i),this.o.cancel()}x(e,i,r,h,g,w){const a={parent:i,element:e.element,children:[],depth:i.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},d=this.D(a,r);a.visibility=d,h&&g.push(a);const o=e.children||m.Iterable.empty(),C=h&&d!==0&&!a.collapsed;let N=0,O=1;for(const P of o){const L=this.x(P,a,d,C,g,w);a.children.push(L),O+=L.renderNodeCount,L.visible&&(L.visibleChildIndex=N++)}return this.j||(a.collapsible=a.collapsible||a.children.length>0),a.visibleChildrenCount=N,a.visible=d===2?N>0:d===1,a.visible?a.collapsed||(a.renderNodeCount=O):(a.renderNodeCount=0,h&&g.pop()),w?.(a),a}y(e){const i=e.renderNodeCount,r=[];return this.z(e,r),this.C(e.parent,r.length-i),r}z(e,i){if(e.visible===!1)return 0;if(i.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this.z(r,i);return this.g.fire(e),e.renderNodeCount}A(e){const i=e.renderNodeCount,r=[];return this.B(e,e.visible?1:0,r),this.C(e.parent,r.length-i),r}B(e,i,r,h=!0){let g;if(e!==this.c){if(g=this.D(e,i),g===0)return e.visible=!1,e.renderNodeCount=0,!1;h&&r.push(e)}const w=r.length;e.renderNodeCount=e===this.c?0:1;let a=!1;if(!e.collapsed||g!==0){let d=0;for(const o of e.children)a=this.B(o,g,r,h&&!e.collapsed)||a,o.visible&&(o.visibleChildIndex=d++);e.visibleChildrenCount=d}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=g===2?a:g===1,e.visibility=g),e.visible?e.collapsed||(e.renderNodeCount+=r.length-w):(e.renderNodeCount=0,h&&r.pop()),this.g.fire(e),e.visible}C(e,i){if(i!==0)for(;e;)e.renderNodeCount+=i,this.g.fire(e),e=e.parent}D(e,i){const r=this.k?this.k.filter(e.element,i):1;return typeof r=="boolean"?(e.filterData=void 0,r?1:0):b(r)?(e.filterData=r.data,v(r.visibility)):(e.filterData=void 0,v(r))}E(e,i=this.c){if(!e||e.length===0)return!0;const[r,...h]=e;return r<0||r>i.children.length?!1:this.E(h,i.children[r])}F(e,i=this.c){if(!e||e.length===0)return i;const[r,...h]=e;if(r<0||r>i.children.length)throw new n.$oV(this.p,"Invalid tree location");return this.F(h,i.children[r])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:i,listIndex:r,revealed:h,visible:g}=this.H(e),w=e[e.length-1];if(w<0||w>i.children.length)throw new n.$oV(this.p,"Invalid tree location");const a=i.children[w];return{node:a,listIndex:r,revealed:h,visible:g&&a.visible}}H(e,i=this.c,r=0,h=!0,g=!0){const[w,...a]=e;if(w<0||w>i.children.length)throw new n.$oV(this.p,"Invalid tree location");for(let d=0;d<w;d++)r+=i.children[d].renderNodeCount;return h=h&&!i.collapsed,g=g&&i.visible,a.length===0?{parentNode:i,listIndex:r,revealed:h,visible:g}:this.H(a,i.children[w],r+1,h,g)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const i=[];let r=e;for(;r.parent;)i.push(r.parent.children.indexOf(r)),r=r.parent;return i.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,F.$tb)(e)[0]}getFirstElementChild(e){const i=this.F(e);if(i.children.length!==0)return i.children[0].element}getLastElementAncestor(e=[]){const i=this.F(e);if(i.children.length!==0)return this.I(i)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$sV=u}),define(ge[135],be([1,0,68,30,32]),function(ie,t,n,F,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zV=void 0;class W{get size(){return this.d.size}constructor(k,m,b={}){this.k=k,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new n.$sV(k,m,null,b),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,b.sorter&&(this.j={compare(v,z){return b.sorter.compare(v.element,z.element)}}),this.h=b.identityProvider}setChildren(k,m=B.Iterable.empty(),b={}){const v=this.o(k);this.l(v,this.m(m),b)}l(k,m=B.Iterable.empty(),b){const v=new Set,z=new Set,u=e=>{if(e.element===null)return;const i=e;if(v.add(i.element),this.d.set(i.element,i),this.h){const r=this.h.getId(i.element).toString();z.add(r),this.f.set(r,i)}b.onDidCreateNode?.(i)},f=e=>{if(e.element===null)return;const i=e;if(v.has(i.element)||this.d.delete(i.element),this.h){const r=this.h.getId(i.element).toString();z.has(r)||this.f.delete(r)}b.onDidDeleteNode?.(i)};this.c.splice([...k,0],Number.MAX_VALUE,m,{...b,onDidCreateNode:u,onDidDeleteNode:f})}m(k=B.Iterable.empty()){return this.j&&(k=[...k].sort(this.j.compare.bind(this.j))),B.Iterable.map(k,m=>{let b=this.d.get(m.element);if(!b&&this.h){const u=this.h.getId(m.element).toString();b=this.f.get(u)}if(!b){let u;return typeof m.collapsed>"u"?u=void 0:m.collapsed===F.ObjectTreeElementCollapseState.Collapsed||m.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed?u=!0:m.collapsed===F.ObjectTreeElementCollapseState.Expanded||m.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?u=!1:u=!!m.collapsed,{...m,children:this.m(m.children),collapsed:u}}const v=typeof m.collapsible=="boolean"?m.collapsible:b.collapsible;let z;return typeof m.collapsed>"u"||m.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?z=b.collapsed:m.collapsed===F.ObjectTreeElementCollapseState.Collapsed?z=!0:m.collapsed===F.ObjectTreeElementCollapseState.Expanded?z=!1:z=!!m.collapsed,{...m,collapsible:v,collapsed:z,children:this.m(m.children)}})}rerender(k){const m=this.o(k);this.c.rerender(m)}updateElementHeight(k,m){const b=this.o(k);this.c.updateElementHeight(b,m)}resort(k=null,m=!0){if(!this.j)return;const b=this.o(k),v=this.c.getNode(b);this.l(b,this.n(v,m),{})}n(k,m,b=!0){let v=[...k.children];return(m||b)&&(v=v.sort(this.j.compare.bind(this.j))),B.Iterable.map(v,z=>({element:z.element,collapsible:z.collapsible,collapsed:z.collapsed,children:this.n(z,m,!1)}))}getFirstElementChild(k=null){const m=this.o(k);return this.c.getFirstElementChild(m)}getLastElementAncestor(k=null){const m=this.o(k);return this.c.getLastElementAncestor(m)}has(k){return this.d.has(k)}getListIndex(k){const m=this.o(k);return this.c.getListIndex(m)}getListRenderCount(k){const m=this.o(k);return this.c.getListRenderCount(m)}isCollapsible(k){const m=this.o(k);return this.c.isCollapsible(m)}setCollapsible(k,m){const b=this.o(k);return this.c.setCollapsible(b,m)}isCollapsed(k){const m=this.o(k);return this.c.isCollapsed(m)}setCollapsed(k,m,b){const v=this.o(k);return this.c.setCollapsed(v,m,b)}expandTo(k){const m=this.o(k);this.c.expandTo(m)}refilter(){this.c.refilter()}getNode(k=null){if(k===null)return this.c.getNode(this.c.rootRef);const m=this.d.get(k);if(!m)throw new F.$oV(this.k,`Tree element not found: ${k}`);return m}getNodeLocation(k){return k.element}getParentNodeLocation(k){if(k===null)throw new F.$oV(this.k,"Invalid getParentNodeLocation call");const m=this.d.get(k);if(!m)throw new F.$oV(this.k,`Tree element not found: ${k}`);const b=this.c.getNodeLocation(m),v=this.c.getParentNodeLocation(b);return this.c.getNode(v).element}o(k){if(k===null)return[];const m=this.d.get(k);if(!m)throw new F.$oV(this.k,`Tree element not found: ${k}`);return this.c.getNodeLocation(m)}}t.$zV=W}),define(ge[21],be([1,0,3,15,20,29,2]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PS=void 0;class k extends A.$Uc{f(b,v){this.B(n.$cR(b,n.$8R.CLICK,z=>v(new B.$7Q(n.getWindow(b),z))))}j(b,v){this.B(n.$cR(b,n.$8R.MOUSE_DOWN,z=>v(new B.$7Q(n.getWindow(b),z))))}m(b,v){this.B(n.$cR(b,n.$8R.MOUSE_OVER,z=>v(new B.$7Q(n.getWindow(b),z))))}u(b,v){this.B(n.$cR(b,n.$8R.MOUSE_LEAVE,z=>v(new B.$7Q(n.getWindow(b),z))))}z(b,v){this.B(n.$cR(b,n.$8R.KEY_DOWN,z=>v(new F.$_Q(z))))}C(b,v){this.B(n.$cR(b,n.$8R.KEY_UP,z=>v(new F.$_Q(z))))}D(b,v){this.B(n.$cR(b,n.$8R.INPUT,v))}F(b,v){this.B(n.$cR(b,n.$8R.BLUR,v))}G(b,v){this.B(n.$cR(b,n.$8R.FOCUS,v))}H(b,v){this.B(n.$cR(b,n.$8R.CHANGE,v))}I(b){return W.$LS.ignoreTarget(b)}}t.$PS=k}),define(ge[48],be([1,0,66,21,9,19,3]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RS=t.$QS=void 0,t.$QS=11;class k extends F.$PS{constructor(b){super(),this.a=b.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=b.bgWidth+"px",this.bgDomNode.style.height=b.bgHeight+"px",typeof b.top<"u"&&(this.bgDomNode.style.top="0px"),typeof b.left<"u"&&(this.bgDomNode.style.left="0px"),typeof b.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof b.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=b.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(b.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$QS+"px",this.domNode.style.height=t.$QS+"px",typeof b.top<"u"&&(this.domNode.style.top=b.top+"px"),typeof b.left<"u"&&(this.domNode.style.left=b.left+"px"),typeof b.bottom<"u"&&(this.domNode.style.bottom=b.bottom+"px"),typeof b.right<"u"&&(this.domNode.style.right=b.right+"px"),this.g=this.B(new n.$OS),this.B(A.$dR(this.bgDomNode,A.$8R.POINTER_DOWN,v=>this.h(v))),this.B(A.$dR(this.domNode,A.$8R.POINTER_DOWN,v=>this.h(v))),this.b=this.B(new A.$oR),this.c=this.B(new B.$sh)}h(b){if(!b.target||!(b.target instanceof Element))return;const v=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,A.getWindow(b))};this.a(),this.b.cancel(),this.c.cancelAndSet(v,200),this.g.startMonitoring(b.target,b.pointerId,b.buttons,z=>{},()=>{this.b.cancel(),this.c.cancel()}),b.preventDefault()}}t.$RS=k}),define(ge[69],be([1,0,3,51,66,48,133,21,5]),function(ie,t,n,F,B,W,A,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$US=void 0;const b=140;class v extends k.$PS{constructor(u){super(),this.g=u.lazyRender,this.a=u.host,this.b=u.scrollable,this.c=u.scrollByPage,this.h=u.scrollbarState,this.n=this.B(new A.$TS(u.visibility,"visible scrollbar "+u.extraScrollbarClassName,"invisible scrollbar "+u.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new B.$OS),this.s=!0,this.domNode=(0,F.$NS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(n.$cR(this.domNode.domNode,n.$8R.POINTER_DOWN,f=>this.M(f)))}t(u){const f=this.B(new W.$RS(u));this.domNode.domNode.appendChild(f.bgDomNode),this.domNode.domNode.appendChild(f.domNode)}w(u,f,e,i){this.slider=(0,F.$NS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(u),this.slider.setLeft(f),typeof e=="number"&&this.slider.setWidth(e),typeof i=="number"&&this.slider.setHeight(i),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(n.$cR(this.slider.domNode,n.$8R.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.O(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}y(u){return this.h.setVisibleSize(u)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(u){return this.h.setScrollSize(u)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(u){return this.h.setScrollPosition(u)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(u){u.target===this.domNode.domNode&&this.N(u)}delegatePointerDown(u){const f=this.domNode.domNode.getClientRects()[0].top,e=f+this.h.getSliderPosition(),i=f+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.U(u);e<=r&&r<=i?u.button===0&&(u.preventDefault(),this.O(u)):this.N(u)}N(u){let f,e;if(u.target===this.domNode.domNode&&typeof u.offsetX=="number"&&typeof u.offsetY=="number")f=u.offsetX,e=u.offsetY;else{const r=n.$yR(this.domNode.domNode);f=u.pageX-r.left,e=u.pageY-r.top}const i=this.S(f,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(i):this.h.getDesiredScrollPositionFromOffset(i)),u.button===0&&(u.preventDefault(),this.O(u))}O(u){if(!u.target||!(u.target instanceof Element))return;const f=this.U(u),e=this.W(u),i=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(u.target,u.pointerId,u.buttons,r=>{const h=this.W(r),g=Math.abs(h-e);if(m.$i&&g>b){this.P(i.getScrollPosition());return}const a=this.U(r)-f;this.P(i.getDesiredScrollPositionFromDelta(a))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(u){const f={};this.writeScrollPosition(f,u),this.b.setScrollPositionNow(f)}updateScrollbarSize(u){this.X(u),this.h.setScrollbarSize(u),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$US=v}),define(ge[136],be([1,0,20,69,48,52,18]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VS=void 0;class k extends F.$US{constructor(b,v,z){const u=b.getScrollDimensions(),f=b.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:z,scrollbarState:new W.$SS(v.horizontalHasArrows?v.arrowSize:0,v.horizontal===2?0:v.horizontalScrollbarSize,v.vertical===2?0:v.verticalScrollbarSize,u.width,u.scrollWidth,f.scrollLeft),visibility:v.horizontal,extraScrollbarClassName:"horizontal",scrollable:b,scrollByPage:v.scrollByPage}),v.horizontalHasArrows){const e=(v.arrowSize-B.$QS)/2,i=(v.horizontalScrollbarSize-B.$QS)/2;this.t({className:"scra",icon:A.$Hj.scrollbarButtonLeft,top:i,left:e,bottom:void 0,right:void 0,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new n.$9Q(null,1,0))}),this.t({className:"scra",icon:A.$Hj.scrollbarButtonRight,top:i,left:void 0,bottom:void 0,right:e,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new n.$9Q(null,-1,0))})}this.w(Math.floor((v.horizontalScrollbarSize-v.horizontalSliderSize)/2),0,void 0,v.horizontalSliderSize)}R(b,v){this.slider.setWidth(b),this.slider.setLeft(v)}Q(b,v){this.domNode.setWidth(b),this.domNode.setHeight(v),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(b){return this.s=this.J(b.scrollWidth)||this.s,this.s=this.L(b.scrollLeft)||this.s,this.s=this.y(b.width)||this.s,this.s}S(b,v){return b}U(b){return b.pageX}W(b){return b.pageY}X(b){this.slider.setHeight(b)}writeScrollPosition(b,v){b.scrollLeft=v}updateOptions(b){this.updateScrollbarSize(b.horizontal===2?0:b.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.n.setVisibility(b.horizontal),this.c=b.scrollByPage}}t.$VS=k}),define(ge[137],be([1,0,20,69,48,52,18]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WS=void 0;class k extends F.$US{constructor(b,v,z){const u=b.getScrollDimensions(),f=b.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:z,scrollbarState:new W.$SS(v.verticalHasArrows?v.arrowSize:0,v.vertical===2?0:v.verticalScrollbarSize,0,u.height,u.scrollHeight,f.scrollTop),visibility:v.vertical,extraScrollbarClassName:"vertical",scrollable:b,scrollByPage:v.scrollByPage}),v.verticalHasArrows){const e=(v.arrowSize-B.$QS)/2,i=(v.verticalScrollbarSize-B.$QS)/2;this.t({className:"scra",icon:A.$Hj.scrollbarButtonUp,top:e,left:i,bottom:void 0,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this.a.onMouseWheel(new n.$9Q(null,0,1))}),this.t({className:"scra",icon:A.$Hj.scrollbarButtonDown,top:void 0,left:i,bottom:e,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this.a.onMouseWheel(new n.$9Q(null,0,-1))})}this.w(0,Math.floor((v.verticalScrollbarSize-v.verticalSliderSize)/2),v.verticalSliderSize,void 0)}R(b,v){this.slider.setHeight(b),this.slider.setTop(v)}Q(b,v){this.domNode.setWidth(v),this.domNode.setHeight(b),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(b){return this.s=this.J(b.scrollHeight)||this.s,this.s=this.L(b.scrollTop)||this.s,this.s=this.y(b.height)||this.s,this.s}S(b,v){return v}U(b){return b.pageY}W(b){return b.pageX}X(b){this.slider.setWidth(b)}writeScrollPosition(b,v){b.scrollTop=v}updateOptions(b){this.updateScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(b.vertical),this.c=b.scrollByPage}}t.$WS=k}),define(ge[70],be([1,0,17,3,51,20,136,137,21,9,4,2,5,58,111]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2S=t.$1S=t.$ZS=t.$YS=t.$XS=void 0;const e=500,i=50,r=!0;class h{constructor(O,P,L){this.timestamp=O,this.deltaX=P,this.deltaY=L,this.score=0}}class g{static{this.INSTANCE=new g}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let O=1,P=0,L=1,$=this.d;do{const M=$===this.c?O:Math.pow(2,-L);if(O-=M,P+=this.b[$].score*M,$===this.c)break;$=(this.a+$-1)%this.a,L++}while(!0);return P<=.5}acceptStandardWheelEvent(O){if(n.$WQ){const P=F.getWindow(O.browserEvent),L=(0,n.$PQ)(P);this.accept(Date.now(),O.deltaX*L,O.deltaY*L)}else this.accept(Date.now(),O.deltaX,O.deltaY)}accept(O,P,L){let $=null;const M=new h(O,P,L);this.c===-1&&this.d===-1?(this.b[0]=M,this.c=0,this.d=0):($=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=M),M.score=this.f(M,$)}f(O,P){if(Math.abs(O.deltaX)>0&&Math.abs(O.deltaY)>0)return 1;let L=.5;if((!this.g(O.deltaX)||!this.g(O.deltaY))&&(L+=.25),P){const $=Math.abs(O.deltaX),M=Math.abs(O.deltaY),V=Math.abs(P.deltaX),I=Math.abs(P.deltaY),j=Math.max(Math.min($,V),1),T=Math.max(Math.min(M,I),1),K=Math.max($,V),Z=Math.max(M,I);K%j===0&&Z%T===0&&(L-=.5)}return Math.min(Math.max(L,0),1)}g(O){return Math.abs(Math.round(O)-O)<.01}}t.$XS=g;class w extends m.$PS{get options(){return this.a}constructor(O,P,L){super(),this.O=this.B(new v.$7d),this.onScroll=this.O.event,this.P=this.B(new v.$7d),this.onWillScroll=this.P.event,O.style.overflow="hidden",this.a=C(P),this.b=L,this.B(this.b.onScroll(M=>{this.P.fire(M),this.S(M),this.O.fire(M)}));const $={onMouseWheel:M=>this.R(M),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new k.$WS(this.b,this.a,$)),this.g=this.B(new A.$VS(this.b,this.a,$)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(O),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,B.$NS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,B.$NS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,B.$NS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,M=>this.Z(M)),this.u(this.t,M=>this.Y(M)),this.L=this.B(new b.$sh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,z.$Pc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(O){this.c.delegatePointerDown(O)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(O){this.b.setScrollDimensions(O,!1)}updateClassName(O){this.a.className=O,u.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(O){typeof O.handleMouseWheel<"u"&&(this.a.handleMouseWheel=O.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof O.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=O.mouseWheelScrollSensitivity),typeof O.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=O.fastScrollSensitivity),typeof O.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=O.scrollPredominantAxis),typeof O.horizontal<"u"&&(this.a.horizontal=O.horizontal),typeof O.vertical<"u"&&(this.a.vertical=O.vertical),typeof O.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=O.horizontalScrollbarSize),typeof O.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=O.verticalScrollbarSize),typeof O.scrollByPage<"u"&&(this.a.scrollByPage=O.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(O){this.N=O}delegateScrollFromMouseWheelEvent(O){this.R(new W.$9Q(O))}Q(O){if(this.w.length>0!==O&&(this.w=(0,z.$Pc)(this.w),O)){const L=$=>{this.R(new W.$9Q($))};this.w.push(F.$cR(this.t,F.$8R.MOUSE_WHEEL,L,{passive:!1}))}}R(O){if(O.browserEvent?.defaultPrevented)return;const P=g.INSTANCE;r&&P.acceptStandardWheelEvent(O);let L=!1;if(O.deltaY||O.deltaX){let M=O.deltaY*this.a.mouseWheelScrollSensitivity,V=O.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&V+M===0?V=M=0:Math.abs(M)>=Math.abs(V)?V=0:M=0),this.a.flipAxes&&([M,V]=[V,M]);const I=!u.$j&&O.browserEvent&&O.browserEvent.shiftKey;(this.a.scrollYToX||I)&&!V&&(V=M,M=0),O.browserEvent&&O.browserEvent.altKey&&(V=V*this.a.fastScrollSensitivity,M=M*this.a.fastScrollSensitivity);const j=this.b.getFutureScrollPosition();let T={};if(M){const K=i*M,Z=j.scrollTop-(K<0?Math.floor(K):Math.ceil(K));this.c.writeScrollPosition(T,Z)}if(V){const K=i*V,Z=j.scrollLeft-(K<0?Math.floor(K):Math.ceil(K));this.g.writeScrollPosition(T,Z)}T=this.b.validateScrollPosition(T),(j.scrollLeft!==T.scrollLeft||j.scrollTop!==T.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&P.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(T):this.b.setScrollPositionNow(T),L=!0)}let $=L;!$&&this.a.alwaysConsumeMouseWheel&&($=!0),!$&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&($=!0),$&&(O.preventDefault(),O.stopPropagation())}S(O){this.M=this.g.onDidScroll(O)||this.M,this.M=this.c.onDidScroll(O)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const O=this.b.getCurrentScrollPosition(),P=O.scrollTop>0,L=O.scrollLeft>0,$=L?" left":"",M=P?" top":"",V=L||P?" top-left-corner":"";this.n.setClassName(`shadow${$}`),this.r.setClassName(`shadow${M}`),this.s.setClassName(`shadow${V}${M}${$}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(O){this.J=!1,this.ab()}Z(O){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$YS=w;class a extends w{constructor(O,P){P=P||{},P.mouseWheelSmoothScroll=!1;const L=new f.$Fs({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:$=>F.$mR(F.getWindow(O),$)});super(O,P,L),this.B(L)}setScrollPosition(O){this.b.setScrollPositionNow(O)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$ZS=a;class d extends w{constructor(O,P,L){super(O,P,L)}setScrollPosition(O){O.reuseAnimation?this.b.setScrollPositionSmooth(O,O.reuseAnimation):this.b.setScrollPositionNow(O)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$1S=d;class o extends w{constructor(O,P){P=P||{},P.mouseWheelSmoothScroll=!1;const L=new f.$Fs({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:$=>F.$mR(F.getWindow(O),$)});super(O,P,L),this.B(L),this.cb=O,this.B(this.onScroll($=>{$.scrollTopChanged&&(this.cb.scrollTop=$.scrollTop),$.scrollLeftChanged&&(this.cb.scrollLeft=$.scrollLeft)})),this.scanDomNode()}setScrollPosition(O){this.b.setScrollPositionNow(O)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$2S=o;function C(N){const O={lazyRender:typeof N.lazyRender<"u"?N.lazyRender:!1,className:typeof N.className<"u"?N.className:"",useShadows:typeof N.useShadows<"u"?N.useShadows:!0,handleMouseWheel:typeof N.handleMouseWheel<"u"?N.handleMouseWheel:!0,flipAxes:typeof N.flipAxes<"u"?N.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof N.consumeMouseWheelIfScrollbarIsNeeded<"u"?N.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof N.alwaysConsumeMouseWheel<"u"?N.alwaysConsumeMouseWheel:!1,scrollYToX:typeof N.scrollYToX<"u"?N.scrollYToX:!1,mouseWheelScrollSensitivity:typeof N.mouseWheelScrollSensitivity<"u"?N.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof N.fastScrollSensitivity<"u"?N.fastScrollSensitivity:5,scrollPredominantAxis:typeof N.scrollPredominantAxis<"u"?N.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof N.mouseWheelSmoothScroll<"u"?N.mouseWheelSmoothScroll:!0,arrowSize:typeof N.arrowSize<"u"?N.arrowSize:11,listenOnDomNode:typeof N.listenOnDomNode<"u"?N.listenOnDomNode:null,horizontal:typeof N.horizontal<"u"?N.horizontal:1,horizontalScrollbarSize:typeof N.horizontalScrollbarSize<"u"?N.horizontalScrollbarSize:10,horizontalSliderSize:typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:0,horizontalHasArrows:typeof N.horizontalHasArrows<"u"?N.horizontalHasArrows:!1,vertical:typeof N.vertical<"u"?N.vertical:1,verticalScrollbarSize:typeof N.verticalScrollbarSize<"u"?N.verticalScrollbarSize:10,verticalHasArrows:typeof N.verticalHasArrows<"u"?N.verticalHasArrows:!1,verticalSliderSize:typeof N.verticalSliderSize<"u"?N.verticalSliderSize:0,scrollByPage:typeof N.scrollByPage<"u"?N.scrollByPage:!1};return O.horizontalSliderSize=typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:O.horizontalScrollbarSize,O.verticalSliderSize=typeof N.verticalSliderSize<"u"?N.verticalSliderSize:O.verticalScrollbarSize,u.$j&&(O.className+=" mac"),O}}),define(ge[71],be([1,0,64,3,24,29,70,12,9,31,4,2,56,58,93,132,6,39]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f,e,i,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tT=t.$sT=t.$rT=t.$qT=t.ListViewTargetSector=void 0;const g={CurrentDragAndDropData:void 0};var w;(function(L){L[L.TOP=0]="TOP",L[L.CENTER_TOP=1]="CENTER_TOP",L[L.CENTER_BOTTOM=2]="CENTER_BOTTOM",L[L.BOTTOM=3]="BOTTOM"})(w||(t.ListViewTargetSector=w={}));const a={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(L){return[L]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class d{get context(){return this.d}set context($){this.d=$}constructor($){this.elements=$}update(){}getData(){return this.elements}}t.$qT=d;class o{constructor($){this.elements=$}update(){}getData(){return this.elements}}t.$rT=o;class C{constructor(){this.types=[],this.files=[]}update($){if($.types&&this.types.splice(0,this.types.length,...$.types),$.files){this.files.splice(0,this.files.length);for(let M=0;M<$.files.length;M++){const V=$.files.item(M);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.$sT=C;function N(L,$){return Array.isArray(L)&&Array.isArray($)?(0,k.$ub)(L,$):L===$}class O{constructor($){$?.getSetSize?this.getSetSize=$.getSetSize.bind($):this.getSetSize=(M,V,I)=>I,$?.getPosInSet?this.getPosInSet=$.getPosInSet.bind($):this.getPosInSet=(M,V)=>V+1,$?.getRole?this.getRole=$.getRole.bind($):this.getRole=M=>"listitem",$?.isChecked?this.isChecked=$.isChecked.bind($):this.isChecked=M=>{}}}class P{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q($){if($!==this.P){if($&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=$,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const M of this.d)this.ab(M);this.X(),this.q.setScrollDimensions({width:(0,F.$BR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor($,M,V,I=a){if(this.R=M,this.domId=`list_id_${++P.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new m.$fh(50),this.v=!1,this.x=z.$Uc.None,this.y=0,this.G=!1,this.K=z.$Uc.None,this.L=z.$Uc.None,this.M=new z.$Tc,this.N=new v.$7d,this.O=new v.$7d,this.onDidChangeContentHeight=v.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=v.Event.latch(this.O.event,void 0,this.M),this.P=!1,I.horizontalScrolling&&I.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(I.paddingTop??0);for(const T of V)this.j.set(T.templateId,T);this.h=this.M.add(new i.$pT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof I.mouseSupport=="boolean"?I.mouseSupport:!0),this.P=I.horizontalScrolling??a.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof I.paddingBottom>"u"?0:I.paddingBottom,this.D=new O(I.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(I.transformOptimization??a.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(W.$LS.addTarget(this.o)),this.p=this.M.add(new f.$Fs({forceIntegerValues:!0,smoothScrollDuration:I.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:T=>(0,F.$mR)((0,F.getWindow)(this.domNode),T)})),this.q=this.M.add(new A.$1S(this.o,{alwaysConsumeMouseWheel:I.alwaysConsumeMouseWheel??a.alwaysConsumeMouseWheel,horizontal:1,vertical:I.verticalScrollMode??a.verticalScrollMode,useShadows:I.useShadows??a.useShadows,mouseWheelScrollSensitivity:I.mouseWheelScrollSensitivity,fastScrollSensitivity:I.fastScrollSensitivity,scrollByPage:I.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),$.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,F.$cR)(this.o,W.EventType.Change,T=>this.jb(T))),this.M.add((0,F.$cR)(this.q.getDomNode(),"scroll",T=>T.target.scrollTop=0)),this.M.add((0,F.$cR)(this.domNode,"dragover",T=>this.lb(this.hb(T)))),this.M.add((0,F.$cR)(this.domNode,"drop",T=>this.nb(this.hb(T)))),this.M.add((0,F.$cR)(this.domNode,"dragleave",T=>this.mb(this.hb(T)))),this.M.add((0,F.$cR)(this.domNode,"dragend",T=>this.ob(T))),this.z=I.setRowLineHeight??a.setRowLineHeight,this.A=I.setRowHeight??a.setRowHeight,this.B=I.supportDynamicHeights??a.supportDynamicHeights,this.F=I.dnd??this.M.add(a.dnd),this.layout(I.initialSize?.height,I.initialSize?.width)}updateOptions($){$.paddingBottom!==void 0&&(this.C=$.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),$.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration($.smoothScrolling?125:0),$.horizontalScrolling!==void 0&&(this.Q=$.horizontalScrolling);let M;if($.scrollByPage!==void 0&&(M={...M??{},scrollByPage:$.scrollByPage}),$.mouseWheelScrollSensitivity!==void 0&&(M={...M??{},mouseWheelScrollSensitivity:$.mouseWheelScrollSensitivity}),$.fastScrollSensitivity!==void 0&&(M={...M??{},fastScrollSensitivity:$.fastScrollSensitivity}),M&&this.q.updateOptions(M),$.paddingTop!==void 0&&$.paddingTop!==this.g.paddingTop){const V=this.vb(this.k,this.m),I=$.paddingTop-this.g.paddingTop;this.g.paddingTop=$.paddingTop,this.Y(V,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent($){this.q.delegateScrollFromMouseWheelEvent($)}delegateVerticalScrollbarPointerDown($){this.q.delegateVerticalScrollbarPointerDown($)}updateElementHeight($,M,V){if($<0||$>=this.d.length)return;const I=this.d[$].size;if(typeof M>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[$].lastDynamicHeightWidth=void 0,M=I+this.xb($)}if(I===M)return;const j=this.vb(this.k,this.m);let T=0;$<j.start||V!==null&&V>$&&V<j.end?T=M-I:T=0,this.g.splice($,1,[{size:M}]),this.d[$].size=M,this.Y(j,Math.max(0,this.k+T),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S($){return new e.$oT($)}splice($,M,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U($,M,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U($,M,V=[]){const I=this.vb(this.k,this.m),j={start:$,end:$+M},T=u.Range.intersect(I,j),K=new Map;for(let G=T.end-1;G>=T.start;G--){const se=this.d[G];if(se.dragStartDisposable.dispose(),se.checkedDisposable.dispose(),se.row){let fe=K.get(se.templateId);fe||(fe=[],K.set(se.templateId,fe));const ve=this.j.get(se.templateId);ve&&ve.disposeElement&&ve.disposeElement(se.element,G,se.row.templateData,se.size),fe.push(se.row)}se.row=null,se.stale=!0}const Z={start:$+M,end:this.d.length},ce=u.Range.intersect(Z,I),re=u.Range.relativeComplement(Z,I),te=V.map(G=>({id:String(this.f++),element:G,templateId:this.R.getTemplateId(G),size:this.R.getHeight(G),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(G),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:z.$Uc.None,checkedDisposable:z.$Uc.None,stale:!1}));let $e;$===0&&M>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,te),$e=this.d,this.d=te):(this.g.splice($,M,te),$e=this.d.splice($,M,...te));const De=V.length-M,Te=this.vb(this.k,this.m),Pe=(0,e.$mT)(ce,De),he=u.Range.intersect(Te,Pe);for(let G=he.start;G<he.end;G++)this.bb(this.d[G],G);const _=u.Range.relativeComplement(Pe,Te);for(const G of _)for(let se=G.start;se<G.end;se++)this.db(se);const le=re.map(G=>(0,e.$mT)(G,De)),J=[{start:$,end:$+V.length},...le].map(G=>u.Range.intersect(Te,G)).reverse();for(const G of J)for(let se=G.end-1;se>=G.start;se--){const fe=this.d[se],Ne=K.get(fe.templateId)?.pop();this.Z(se,Ne)}for(const G of K.values())for(const se of G)this.h.release(se);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),$e.map(G=>G.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,F.$mR)((0,F.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let $=0;for(const M of this.d)typeof M.width<"u"&&($=Math.max($,M.width));this.E=$,this.q.setScrollDimensions({scrollWidth:$===0?0:$+10}),this.O.fire(this.E)}updateWidth($){if(!this.Q||typeof this.E>"u")return;const M=this.d[$];this.ab(M),typeof M.width<"u"&&M.width>this.E&&(this.E=M.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const $ of this.d)$.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const $=this.firstVisibleIndex,M=this.g.positionAt($),V=this.g.positionAt($+1);return V!==-1&&(V-M)/2+M<this.scrollTop?$+1:$}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element($){return this.d[$].element}indexOf($){return this.d.findIndex(M=>M.element===$)}domElement($){const M=this.d[$].row;return M&&M.domNode}elementHeight($){return this.d[$].size}elementTop($){return this.g.positionAt($)}indexAt($){return this.g.indexAt($)}indexAfter($){return this.g.indexAfter($)}layout($,M){const V={height:typeof $=="number"?$:(0,F.$DR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof M<"u"&&(this.n=M,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof M=="number"?M:(0,F.$BR)(this.domNode)})}Y($,M,V,I,j,T=!1){const K=this.vb(M,V),Z=u.Range.relativeComplement(K,$).reverse(),ce=u.Range.relativeComplement($,K);if(T){const re=u.Range.intersect($,K);for(let te=re.start;te<re.end;te++)this.bb(this.d[te],te)}this.h.transact(()=>{for(const re of ce)for(let te=re.start;te<re.end;te++)this.db(te);for(const re of Z)for(let te=re.end-1;te>=re.start;te--)this.Z(te)}),I!==void 0&&(this.o.style.left=`-${I}px`),this.o.style.top=`-${M}px`,this.Q&&j!==void 0&&(this.o.style.width=`${Math.max(j,this.n)}px`),this.k=M,this.m=V}Z($,M){const V=this.d[$];if(!V.row)if(M)V.row=M,V.stale=!0;else{const Z=this.h.alloc(V.templateId);V.row=Z.row,V.stale||=Z.isReusingConnectedDomNode}const I=this.D.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",I);const j=this.D.isChecked(V.element);if(typeof j=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!j));else if(j){const Z=ce=>V.row.domNode.setAttribute("aria-checked",String(!!ce));Z(j.value),V.checkedDisposable=j.onDidChange(Z)}if(V.stale||!V.row.domNode.parentElement){const Z=this.d.at($+1)?.row?.domNode??null;this.o.insertBefore(V.row.domNode,Z),V.stale=!1}this.bb(V,$);const T=this.j.get(V.templateId);if(!T)throw new Error(`No renderer found for template id ${V.templateId}`);T?.renderElement(V.element,$,V.row.templateData,V.size);const K=this.F.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!K,K&&(V.dragStartDisposable=(0,F.$cR)(V.row.domNode,"dragstart",Z=>this.kb(V.element,K,Z))),this.Q&&(this.ab(V),this.W())}ab($){if(!$.row||!$.row.domNode)return;$.row.domNode.style.width="fit-content",$.width=(0,F.$BR)($.row.domNode);const M=(0,F.getWindow)($.row.domNode).getComputedStyle($.row.domNode);M.paddingLeft&&($.width+=parseFloat(M.paddingLeft)),M.paddingRight&&($.width+=parseFloat(M.paddingRight)),$.row.domNode.style.width=""}bb($,M){$.row.domNode.style.top=`${this.elementTop(M)}px`,this.A&&($.row.domNode.style.height=`${$.size}px`),this.z&&($.row.domNode.style.lineHeight=`${$.size}px`),$.row.domNode.setAttribute("data-index",`${M}`),$.row.domNode.setAttribute("data-last-element",M===this.length-1?"true":"false"),$.row.domNode.setAttribute("data-parity",M%2===0?"even":"odd"),$.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize($.element,M,this.length))),$.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet($.element,M))),$.row.domNode.setAttribute("id",this.getElementDomId(M)),$.row.domNode.classList.toggle("drop-target",$.dropTarget)}db($){const M=this.d[$];if(M.dragStartDisposable.dispose(),M.checkedDisposable.dispose(),M.row){const V=this.j.get(M.templateId);V&&V.disposeElement&&V.disposeElement(M.element,$,M.row.templateData,M.size),this.h.release(M.row),M.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop($,M){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:$,reuseAnimation:M})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft($){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:$})}get scrollTop(){return this.getScrollTop()}set scrollTop($){this.setScrollTop($)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return v.Event.map(this.M.add(new B.$gT(this.domNode,"click")).event,$=>this.eb($),this.M)}get onMouseDblClick(){return v.Event.map(this.M.add(new B.$gT(this.domNode,"dblclick")).event,$=>this.eb($),this.M)}get onMouseMiddleClick(){return v.Event.filter(v.Event.map(this.M.add(new B.$gT(this.domNode,"auxclick")).event,$=>this.eb($),this.M),$=>$.browserEvent.button===1,this.M)}get onMouseUp(){return v.Event.map(this.M.add(new B.$gT(this.domNode,"mouseup")).event,$=>this.eb($),this.M)}get onMouseDown(){return v.Event.map(this.M.add(new B.$gT(this.domNode,"mousedown")).event,$=>this.eb($),this.M)}get onMouseOver(){return v.Event.map(this.M.add(new B.$gT(this.domNode,"mouseover")).event,$=>this.eb($),this.M)}get onMouseMove(){return v.Event.map(this.M.add(new B.$gT(this.domNode,"mousemove")).event,$=>this.eb($),this.M)}get onMouseOut(){return v.Event.map(this.M.add(new B.$gT(this.domNode,"mouseout")).event,$=>this.eb($),this.M)}get onContextMenu(){return v.Event.any(v.Event.map(this.M.add(new B.$gT(this.domNode,"contextmenu")).event,$=>this.eb($),this.M),v.Event.map(this.M.add(new B.$gT(this.domNode,W.EventType.Contextmenu)).event,$=>this.gb($),this.M))}get onTouchStart(){return v.Event.map(this.M.add(new B.$gT(this.domNode,"touchstart")).event,$=>this.fb($),this.M)}get onTap(){return v.Event.map(this.M.add(new B.$gT(this.o,W.EventType.Tap)).event,$=>this.gb($),this.M)}eb($){const M=this.ub($.target||null),V=typeof M>"u"?void 0:this.d[M],I=V&&V.element;return{browserEvent:$,index:M,element:I}}fb($){const M=this.ub($.target||null),V=typeof M>"u"?void 0:this.d[M],I=V&&V.element;return{browserEvent:$,index:M,element:I}}gb($){const M=this.ub($.initialTarget||null),V=typeof M>"u"?void 0:this.d[M],I=V&&V.element;return{browserEvent:$,index:M,element:I}}hb($){const M=this.ub($.target||null),V=typeof M>"u"?void 0:this.d[M],I=V&&V.element,j=this.tb($,M);return{browserEvent:$,index:M,element:I,sector:j}}ib($){try{const M=this.vb(this.k,this.m);this.Y(M,$.scrollTop,$.height,$.scrollLeft,$.scrollWidth),this.B&&this.wb($.scrollTop,$.height,$.inSmoothScrolling)}catch(M){throw console.error("Got bad scroll event:",$),M}}jb($){$.preventDefault(),$.stopPropagation(),this.scrollTop-=$.translationY}kb($,M,V){if(!V.dataTransfer)return;const I=this.F.getDragElements($);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(n.$JS.TEXT,M),V.dataTransfer.setDragImage){let j;this.F.getDragLabel&&(j=this.F.getDragLabel(I,V)),typeof j>"u"&&(j=String(I.length));const T=(0,F.$)(".monaco-drag-image");T.textContent=j;const Z=(ce=>{for(;ce&&!ce.classList.contains("monaco-workbench");)ce=ce.parentElement;return ce||this.domNode.ownerDocument})(this.domNode);Z.appendChild(T),V.dataTransfer.setDragImage(T,-10,-10),setTimeout(()=>Z.removeChild(T),0)}this.domNode.classList.add("dragging"),this.H=new d(I),g.CurrentDragAndDropData=new o(I),this.F.onDragStart?.(this.H,V)}lb($){if($.browserEvent.preventDefault(),this.L.dispose(),g.CurrentDragAndDropData&&g.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb($.browserEvent),!$.browserEvent.dataTransfer))return!1;if(!this.H)if(g.CurrentDragAndDropData)this.H=g.CurrentDragAndDropData;else{if(!$.browserEvent.dataTransfer.types)return!1;this.H=new C}const M=this.F.onDragOver(this.H,$.element,$.index,$.sector,$.browserEvent);if(this.G=typeof M=="boolean"?M:M.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;$.browserEvent.dataTransfer.dropEffect=typeof M!="boolean"&&M.effect?.type===0?"copy":"move";let V;typeof M!="boolean"&&M.feedback?V=M.feedback:typeof $.index>"u"?V=[-1]:V=[$.index],V=(0,k.$Mb)(V).filter(j=>j>=-1&&j<this.length).sort((j,T)=>j-T),V=V[0]===-1?[-1]:V;let I=typeof M!="boolean"&&M.effect&&M.effect.position?M.effect.position:"drop-target";if(N(this.I,V)&&this.J===I)return!0;if(this.I=V,this.J=I,this.K.dispose(),V[0]===-1)this.domNode.classList.add(I),this.o.classList.add(I),this.K=(0,z.$Sc)(()=>{this.domNode.classList.remove(I),this.o.classList.remove(I)});else{if(V.length>1&&I!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");I==="drop-target-after"&&V[0]<this.length-1&&(V[0]+=1,I="drop-target-before");for(const j of V){const T=this.d[j];T.dropTarget=!0,T.row?.domNode.classList.add(I)}this.K=(0,z.$Sc)(()=>{for(const j of V){const T=this.d[j];T.dropTarget=!1,T.row?.domNode.classList.remove(I)}})}return!0}mb($){this.L.dispose(),this.L=(0,m.$kh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,$.element,$.index,$.browserEvent)}nb($){if(!this.G)return;const M=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,!(!M||!$.browserEvent.dataTransfer)&&($.browserEvent.preventDefault(),M.update($.browserEvent.dataTransfer),this.F.drop(M,$.element,$.index,$.sector,$.browserEvent))}ob($){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,this.F.onDragEnd?.($)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=z.$Uc.None}qb($){if(!this.w){const M=(0,F.$vR)(this.domNode).top;this.w=(0,F.$rS)((0,F.getWindow)(this.domNode),this.rb.bind(this,M))}this.x.dispose(),this.x=(0,m.$kh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=$.pageY}rb($){if(this.y===void 0)return;const M=this.y-$,V=this.renderHeight-35;M<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(M-35))):M>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(M-V))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb($,M){if(M===void 0)return;const V=$.offsetY/this.d[M].size,I=Math.floor(V/.25);return(0,h.$nm)(I,0,3)}ub($){const M=this.q.getDomNode();let V=$;for(;V instanceof HTMLElement&&V!==this.o&&M.contains(V);){const I=V.getAttribute("data-index");if(I){const j=Number(I);if(!isNaN(j))return j}V=V.parentElement}}vb($,M){return{start:this.g.indexAt($),end:this.g.indexAfter($+M-1)}}wb($,M,V){const I=this.vb($,M);let j,T;$===this.elementTop(I.start)?(j=I.start,T=0):I.end-I.start>1&&(j=I.start+1,T=this.elementTop(j)-$);let K=0;for(;;){const Z=this.vb($,M);let ce=!1;for(let re=Z.start;re<Z.end;re++){const te=this.xb(re);te!==0&&this.g.splice(re,1,[this.d[re]]),K+=te,ce=ce||te!==0}if(!ce){K!==0&&this.V();const re=u.Range.relativeComplement(I,Z);for(const $e of re)for(let De=$e.start;De<$e.end;De++)this.d[De].row&&this.db(De);const te=u.Range.relativeComplement(Z,I).reverse();for(const $e of te)for(let De=$e.end-1;De>=$e.start;De--)this.Z(De);for(let $e=Z.start;$e<Z.end;$e++)this.d[$e].row&&this.bb(this.d[$e],$e);if(typeof j=="number"){const $e=this.p.getFutureScrollPosition().scrollTop-$,De=this.elementTop(j)-T+$e;this.setScrollTop(De,V)}this.N.fire(this.contentHeight);return}}}xb($){const M=this.d[$];if(this.R.getDynamicHeight){const T=this.R.getDynamicHeight(M.element);if(T!==null){const K=M.size;return M.size=T,M.lastDynamicHeightWidth=this.n,T-K}}if(!M.hasDynamicHeight||M.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(M.element))return 0;const V=M.size;if(M.row)return M.row.domNode.style.height="",M.size=M.row.domNode.offsetHeight,M.lastDynamicHeightWidth=this.n,M.size-V;const{row:I}=this.h.alloc(M.templateId);I.domNode.style.height="",this.o.appendChild(I.domNode);const j=this.j.get(M.templateId);if(!j)throw new r.$cb("Missing renderer for templateId: "+M.templateId);return j.renderElement(M.element,$,I.templateData,void 0),M.size=I.domNode.offsetHeight,j.disposeElement?.(M.element,$,I.templateData,void 0),this.R.setDynamicHeight?.(M.element,M.size),M.lastDynamicHeightWidth=this.n,this.o.removeChild(I.domNode),this.h.release(I),M.size-V}getElementDomId($){return`${this.domId}_${$}`}dispose(){for(const $ of this.d)if($.dragStartDisposable.dispose(),$.checkedDisposable.dispose(),$.row){const M=this.j.get($.row.templateId);M&&(M.disposeElement?.($.element,-1,$.row.templateData,void 0),M.disposeTemplate($.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$tT=P,Ze([b.$Mh],P.prototype,"onMouseClick",null),Ze([b.$Mh],P.prototype,"onMouseDblClick",null),Ze([b.$Mh],P.prototype,"onMouseMiddleClick",null),Ze([b.$Mh],P.prototype,"onMouseUp",null),Ze([b.$Mh],P.prototype,"onMouseDown",null),Ze([b.$Mh],P.prototype,"onMouseOver",null),Ze([b.$Mh],P.prototype,"onMouseMove",null),Ze([b.$Mh],P.prototype,"onMouseOut",null),Ze([b.$Mh],P.prototype,"onContextMenu",null),Ze([b.$Mh],P.prototype,"onTouchStart",null),Ze([b.$Mh],P.prototype,"onTap",null)}),define(ge[49],be([1,0,3,24,15,29,67,81,12,9,84,31,4,43,2,39,5,7,80,71,20,57,110]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f,e,i,r,h,g,w,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LT=t.$KT=t.$JT=t.$IT=t.$FT=t.TypeNavigationMode=void 0,t.$xT=P,t.$yT=$,t.$zT=M,t.$AT=V,t.$BT=I,t.$CT=j,t.$DT=T,t.$ET=K,t.$GT=De,t.$HT=Te;class o{constructor(c){this.d=c,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(c){return c}renderElement(c,D,l){const p=this.c.findIndex(S=>S.templateData===l);if(p>=0){const S=this.c[p];this.d.unrender(l),S.index=D}else{const S={index:D,templateData:l};this.c.push(S)}this.d.renderIndex(D,l)}splice(c,D,l){const p=[];for(const S of this.c)S.index<c?p.push(S):S.index>=c+D&&p.push({index:S.index+l-D,templateData:S.templateData});this.c=p}renderIndexes(c){for(const{index:D,templateData:l}of this.c)c.indexOf(D)>-1&&this.d.renderIndex(D,l)}disposeTemplate(c){const D=this.c.findIndex(l=>l.templateData===c);D<0||this.c.splice(D,1)}}class C{get name(){return this.g}get renderer(){return new o(this)}constructor(c){this.g=c,this.c=[],this.d=[],this.f=new u.$7d,this.onChange=this.f.event}splice(c,D,l){const p=l.length-D,S=c+D,s=[];let E=0;for(;E<this.d.length&&this.d[E]<c;)s.push(this.d[E++]);for(let y=0;y<l.length;y++)l[y]&&s.push(y+c);for(;E<this.d.length&&this.d[E]>=S;)s.push(this.d[E++]+p);this.renderer.splice(c,D,l.length),this.h(s,s)}renderIndex(c,D){D.classList.toggle(this.g,this.contains(c))}unrender(c){c.classList.remove(this.g)}set(c,D){return this.h(c,[...c].sort(fe),D)}h(c,D,l){const p=this.c,S=this.d;this.c=c,this.d=D;const s=G(S,c);return this.renderer.renderIndexes(s),this.f.fire({indexes:c,browserEvent:l}),p}get(){return this.c}contains(c){return(0,m.$wb)(this.d,c,fe)>=0}dispose(){(0,e.$Pc)(this.f)}}Ze([z.$Mh],C.prototype,"renderer",null);class N extends C{constructor(c){super("selected"),this.k=c}renderIndex(c,D){super.renderIndex(c,D),this.k&&(this.contains(c)?D.setAttribute("aria-selected","true"):D.setAttribute("aria-selected","false"))}}class O{constructor(c,D,l){this.c=c,this.d=D,this.f=l}splice(c,D,l){if(!this.f)return this.c.splice(c,D,new Array(l.length).fill(!1));const p=this.c.get().map(E=>this.f.getId(this.d.element(E)).toString());if(p.length===0)return this.c.splice(c,D,new Array(l.length).fill(!1));const S=new Set(p),s=l.map(E=>S.has(this.f.getId(E).toString()));this.c.splice(c,D,s)}}function P(x){return x.tagName==="INPUT"||x.tagName==="TEXTAREA"}function L(x,c){return x.classList.contains(c)?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:L(x.parentElement,c)}function $(x){return L(x,"monaco-editor")}function M(x){return L(x,"monaco-custom-toggle")}function V(x){return L(x,"action-item")}function I(x){return L(x,"monaco-tl-twistie")}function j(x){return L(x,"monaco-tree-sticky-row")}function T(x){return x.classList.contains("monaco-tree-sticky-container")}function K(x){return x.tagName==="A"&&x.classList.contains("monaco-button")||x.tagName==="DIV"&&x.classList.contains("monaco-button-dropdown")?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:K(x.parentElement)}class Z{get g(){return u.Event.chain(this.c.add(new F.$gT(this.k.domNode,"keydown")).event,c=>c.filter(D=>!P(D.target)).map(D=>new B.$_Q(D)))}constructor(c,D,l){this.h=c,this.k=D,this.c=new e.$Tc,this.d=new e.$Tc,this.f=l.multipleSelectionSupport,this.c.add(this.g(p=>{switch(p.keyCode){case 3:return this.l(p);case 16:return this.o(p);case 18:return this.p(p);case 11:return this.q(p);case 12:return this.s(p);case 9:return this.u(p);case 31:this.f&&(r.$j?p.metaKey:p.ctrlKey)&&this.t(p)}}))}updateOptions(c){c.multipleSelectionSupport!==void 0&&(this.f=c.multipleSelectionSupport)}l(c){c.preventDefault(),c.stopPropagation(),this.h.setSelection(this.h.getFocus(),c.browserEvent)}o(c){c.preventDefault(),c.stopPropagation(),this.h.focusPrevious(1,!1,c.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}p(c){c.preventDefault(),c.stopPropagation(),this.h.focusNext(1,!1,c.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}q(c){c.preventDefault(),c.stopPropagation(),this.h.focusPreviousPage(c.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}s(c){c.preventDefault(),c.stopPropagation(),this.h.focusNextPage(c.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}t(c){c.preventDefault(),c.stopPropagation(),this.h.setSelection((0,m.$Sb)(this.h.length),c.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(c){this.h.getSelection().length&&(c.preventDefault(),c.stopPropagation(),this.h.setSelection([],c.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ze([z.$Mh],Z.prototype,"g",null);var ce;(function(x){x[x.Automatic=0]="Automatic",x[x.Trigger=1]="Trigger"})(ce||(t.TypeNavigationMode=ce={}));var re;(function(x){x[x.Idle=0]="Idle",x[x.Typing=1]="Typing"})(re||(re={})),t.$FT=new class{mightProducePrintableCharacter(x){return x.ctrlKey||x.metaKey||x.altKey?!1:x.keyCode>=31&&x.keyCode<=56||x.keyCode>=21&&x.keyCode<=30||x.keyCode>=98&&x.keyCode<=107||x.keyCode>=85&&x.keyCode<=95}};class te{constructor(c,D,l,p,S){this.o=c,this.p=D,this.q=l,this.s=p,this.t=S,this.c=!1,this.d=re.Idle,this.f=ce.Automatic,this.g=!1,this.h=-1,this.k=new e.$Tc,this.l=new e.$Tc,this.updateOptions(c.options)}updateOptions(c){c.typeNavigationEnabled??!0?this.u():this.v(),this.f=c.typeNavigationMode??ce.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let c=!1;const D=u.Event.chain(this.k.add(new F.$gT(this.p.domNode,"keydown")).event,S=>S.filter(s=>!P(s.target)).filter(()=>this.f===ce.Automatic||this.g).map(s=>new B.$_Q(s)).filter(s=>c||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>n.$0R.stop(s,!0)).map(s=>s.browserEvent.key)),l=u.Event.debounce(D,()=>null,800,void 0,void 0,void 0,this.k);u.Event.reduce(u.Event.any(D,l),(S,s)=>s===null?null:(S||"")+s,void 0,this.k)(this.x,this,this.k),l(this.w,this,this.k),D(()=>c=!0,void 0,this.k),l(()=>c=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const c=this.o.getFocus();if(c.length>0&&c[0]===this.h){const D=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(c[0]));typeof D=="string"?(0,A.$iT)(D):D&&(0,A.$iT)(D.get())}this.h=-1}x(c){if(!c){this.d=re.Idle,this.g=!1;return}const D=this.o.getFocus(),l=D.length>0?D[0]:0,p=this.d===re.Idle?1:0;this.d=re.Typing;for(let S=0;S<this.o.length;S++){const s=(l+S+p)%this.o.length,E=this.q.getKeyboardNavigationLabel(this.p.element(s)),y=E&&E.toString();if(this.o.options.typeNavigationEnabled){if(typeof y<"u"){if((0,f.$kk)(c,y)){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}const R=(0,f.$rk)(c,y);if(R&&R[0].end-R[0].start>1&&R.length===1){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof y>"u"||(0,f.$kk)(c,y)){this.h=l,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class $e{constructor(c,D){this.d=c,this.f=D,this.c=new e.$Tc;const l=u.Event.chain(this.c.add(new F.$gT(D.domNode,"keydown")).event,S=>S.filter(s=>!P(s.target)).map(s=>new B.$_Q(s)));u.Event.chain(l,S=>S.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(c){if(c.target!==this.f.domNode)return;const D=this.d.getFocus();if(D.length===0)return;const l=this.f.domElement(D[0]);if(!l)return;const p=l.querySelector("[tabIndex]");if(!p||!(p instanceof HTMLElement)||p.tabIndex===-1)return;const S=(0,n.getWindow)(p).getComputedStyle(p);S.visibility==="hidden"||S.display==="none"||(c.preventDefault(),c.stopPropagation(),p.focus())}dispose(){this.c.dispose()}}function De(x){return r.$j?x.browserEvent.metaKey:x.browserEvent.ctrlKey}function Te(x){return x.browserEvent.shiftKey}function Pe(x){return(0,n.$4R)(x)&&x.button===2}const he={isSelectionSingleChangeEvent:De,isSelectionRangeChangeEvent:Te};class _{constructor(c){this.k=c,this.f=new e.$Tc,this.g=new u.$7d,this.onPointer=this.g.event,c.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||he),this.d=typeof c.options.mouseSupport>"u"||!!c.options.mouseSupport,this.d&&(c.onMouseDown(this.s,this,this.f),c.onContextMenu(this.t,this,this.f),c.onMouseDblClick(this.v,this,this.f),c.onTouchStart(this.s,this,this.f),this.f.add(W.$LS.addTarget(c.getHTMLElement()))),u.Event.any(c.onMouseClick,c.onMouseMiddleClick,c.onTap)(this.u,this,this.f)}updateOptions(c){c.multipleSelectionSupport!==void 0&&(this.c=void 0,c.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||he))}o(c){return this.c?this.c.isSelectionSingleChangeEvent(c):!1}p(c){return this.c?this.c.isSelectionRangeChangeEvent(c):!1}q(c){return this.o(c)||this.p(c)}s(c){$(c.browserEvent.target)||(0,n.$OR)()!==c.browserEvent.target&&this.k.domFocus()}t(c){if(P(c.browserEvent.target)||$(c.browserEvent.target))return;const D=typeof c.index>"u"?[]:[c.index];this.k.setFocus(D,c.browserEvent)}u(c){if(!this.d||P(c.browserEvent.target)||$(c.browserEvent.target)||c.browserEvent.isHandledByList)return;c.browserEvent.isHandledByList=!0;const D=c.index;if(typeof D>"u"){this.k.setFocus([],c.browserEvent),this.k.setSelection([],c.browserEvent),this.k.setAnchor(void 0);return}if(this.q(c))return this.w(c);this.k.setFocus([D],c.browserEvent),this.k.setAnchor(D),Pe(c.browserEvent)||this.k.setSelection([D],c.browserEvent),this.g.fire(c)}v(c){if(P(c.browserEvent.target)||$(c.browserEvent.target)||this.q(c)||c.browserEvent.isHandledByList)return;c.browserEvent.isHandledByList=!0;const D=this.k.getFocus();this.k.setSelection(D,c.browserEvent)}w(c){const D=c.index;let l=this.k.getAnchor();if(this.p(c)){typeof l>"u"&&(l=this.k.getFocus()[0]??D,this.k.setAnchor(l));const p=Math.min(l,D),S=Math.max(l,D),s=(0,m.$Sb)(p,S+1),E=this.k.getSelection(),y=J(G(E,[l]),l);if(y.length===0)return;const R=G(s,se(E,y));this.k.setSelection(R,c.browserEvent),this.k.setFocus([D],c.browserEvent)}else if(this.o(c)){const p=this.k.getSelection(),S=p.filter(s=>s!==D);this.k.setFocus([D]),this.k.setAnchor(D),p.length===S.length?this.k.setSelection([...S,D],c.browserEvent):this.k.setSelection(S,c.browserEvent)}}dispose(){this.f.dispose()}}t.$IT=_;class le{constructor(c,D){this.c=c,this.d=D}style(c){const D=this.d&&`.${this.d}`,l=[];c.listBackground&&l.push(`.monaco-list${D} .monaco-list-rows { background: ${c.listBackground}; }`),c.listFocusBackground&&(l.push(`.monaco-list${D}:focus .monaco-list-row.focused { background-color: ${c.listFocusBackground}; }`),l.push(`.monaco-list${D}:focus .monaco-list-row.focused:hover { background-color: ${c.listFocusBackground}; }`)),c.listFocusForeground&&l.push(`.monaco-list${D}:focus .monaco-list-row.focused { color: ${c.listFocusForeground}; }`),c.listActiveSelectionBackground&&(l.push(`.monaco-list${D}:focus .monaco-list-row.selected { background-color: ${c.listActiveSelectionBackground}; }`),l.push(`.monaco-list${D}:focus .monaco-list-row.selected:hover { background-color: ${c.listActiveSelectionBackground}; }`)),c.listActiveSelectionForeground&&l.push(`.monaco-list${D}:focus .monaco-list-row.selected { color: ${c.listActiveSelectionForeground}; }`),c.listActiveSelectionIconForeground&&l.push(`.monaco-list${D}:focus .monaco-list-row.selected .codicon { color: ${c.listActiveSelectionIconForeground}; }`),c.listFocusAndSelectionBackground&&l.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.selected.focused { background-color: ${c.listFocusAndSelectionBackground}; }
			`),c.listFocusAndSelectionForeground&&l.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.selected.focused { color: ${c.listFocusAndSelectionForeground}; }
			`),c.listInactiveFocusForeground&&(l.push(`.monaco-list${D} .monaco-list-row.focused { color:  ${c.listInactiveFocusForeground}; }`),l.push(`.monaco-list${D} .monaco-list-row.focused:hover { color:  ${c.listInactiveFocusForeground}; }`)),c.listInactiveSelectionIconForeground&&l.push(`.monaco-list${D} .monaco-list-row.focused .codicon { color:  ${c.listInactiveSelectionIconForeground}; }`),c.listInactiveFocusBackground&&(l.push(`.monaco-list${D} .monaco-list-row.focused { background-color:  ${c.listInactiveFocusBackground}; }`),l.push(`.monaco-list${D} .monaco-list-row.focused:hover { background-color:  ${c.listInactiveFocusBackground}; }`)),c.listInactiveSelectionBackground&&(l.push(`.monaco-list${D} .monaco-list-row.selected { background-color:  ${c.listInactiveSelectionBackground}; }`),l.push(`.monaco-list${D} .monaco-list-row.selected:hover { background-color:  ${c.listInactiveSelectionBackground}; }`)),c.listInactiveSelectionForeground&&l.push(`.monaco-list${D} .monaco-list-row.selected { color: ${c.listInactiveSelectionForeground}; }`),c.listHoverBackground&&l.push(`.monaco-list${D}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${c.listHoverBackground}; }`),c.listHoverForeground&&l.push(`.monaco-list${D}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${c.listHoverForeground}; }`);const p=(0,n.$uS)(c.listFocusAndSelectionOutline,(0,n.$uS)(c.listSelectionOutline,c.listFocusOutline??""));p&&l.push(`.monaco-list${D}:focus .monaco-list-row.focused.selected { outline: 1px solid ${p}; outline-offset: -1px;}`),c.listFocusOutline&&l.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }
			`);const S=(0,n.$uS)(c.listSelectionOutline,c.listInactiveFocusOutline??"");S&&l.push(`.monaco-list${D} .monaco-list-row.focused.selected { outline: 1px dotted ${S}; outline-offset: -1px; }`),c.listSelectionOutline&&l.push(`.monaco-list${D} .monaco-list-row.selected { outline: 1px dotted ${c.listSelectionOutline}; outline-offset: -1px; }`),c.listInactiveFocusOutline&&l.push(`.monaco-list${D} .monaco-list-row.focused { outline: 1px dotted ${c.listInactiveFocusOutline}; outline-offset: -1px; }`),c.listHoverOutline&&l.push(`.monaco-list${D} .monaco-list-row:hover { outline: 1px dashed ${c.listHoverOutline}; outline-offset: -1px; }`),c.listDropOverBackground&&l.push(`
				.monaco-list${D}.drop-target,
				.monaco-list${D} .monaco-list-rows.drop-target,
				.monaco-list${D} .monaco-list-row.drop-target { background-color: ${c.listDropOverBackground} !important; color: inherit !important; }
			`),c.listDropBetweenBackground&&(l.push(`
			.monaco-list${D} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${D} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${c.listDropBetweenBackground};
			}`),l.push(`
			.monaco-list${D} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${D} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${c.listDropBetweenBackground};
			}`)),c.tableColumnsBorder&&l.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${c.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),c.tableOddRowsBackgroundColor&&l.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${c.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=l.join(`
`)}}t.$JT=le,t.$KT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:v.$Gt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:v.$Gt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:v.$Gt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function J(x,c){const D=x.indexOf(c);if(D===-1)return[];const l=[];let p=D-1;for(;p>=0&&x[p]===c-(D-p);)l.push(x[p--]);for(l.reverse(),p=D;p<x.length&&x[p]===c+(p-D);)l.push(x[p++]);return l}function G(x,c){const D=[];let l=0,p=0;for(;l<x.length||p<c.length;)if(l>=x.length)D.push(c[p++]);else if(p>=c.length)D.push(x[l++]);else if(x[l]===c[p]){D.push(x[l]),l++,p++;continue}else x[l]<c[p]?D.push(x[l++]):D.push(c[p++]);return D}function se(x,c){const D=[];let l=0,p=0;for(;l<x.length||p<c.length;)if(l>=x.length)D.push(c[p++]);else if(p>=c.length)D.push(x[l++]);else if(x[l]===c[p]){l++,p++;continue}else x[l]<c[p]?D.push(x[l++]):p++;return D}const fe=(x,c)=>x-c;class ve{constructor(c,D){this.c=c,this.d=D}get templateId(){return this.c}renderTemplate(c){return this.d.map(D=>D.renderTemplate(c))}renderElement(c,D,l,p){let S=0;for(const s of this.d)s.renderElement(c,D,l[S++],p)}disposeElement(c,D,l,p){let S=0;for(const s of this.d)s.disposeElement?.(c,D,l[S],p),S+=1}disposeTemplate(c){let D=0;for(const l of this.d)l.disposeTemplate(c[D++])}}class Ne{constructor(c){this.c=c,this.templateId="a18n"}renderTemplate(c){return{container:c,disposables:new e.$Tc}}renderElement(c,D,l){const p=this.c.getAriaLabel(c),S=p&&typeof p!="string"?p:(0,d.constObservable)(p);l.disposables.add((0,d.autorun)(E=>{this.d(E.readObservable(S),l.container)}));const s=this.c.getAriaLevel&&this.c.getAriaLevel(c);typeof s=="number"?l.container.setAttribute("aria-level",`${s}`):l.container.removeAttribute("aria-level")}d(c,D){c?D.setAttribute("aria-label",c):D.removeAttribute("aria-label")}disposeElement(c,D,l,p){l.disposables.clear()}disposeTemplate(c){c.disposables.dispose()}}class Ae{constructor(c,D){this.c=c,this.d=D}getDragElements(c){const D=this.c.getSelectedElements();return D.indexOf(c)>-1?D:[c]}getDragURI(c){return this.d.getDragURI(c)}getDragLabel(c,D){if(this.d.getDragLabel)return this.d.getDragLabel(c,D)}onDragStart(c,D){this.d.onDragStart?.(c,D)}onDragOver(c,D,l,p,S){return this.d.onDragOver(c,D,l,p,S)}onDragLeave(c,D,l,p){this.d.onDragLeave?.(c,D,l,p)}onDragEnd(c){this.d.onDragEnd?.(c)}drop(c,D,l,p,S){this.d.drop(c,D,l,p,S)}dispose(){this.d.dispose()}}class Le{get onDidChangeFocus(){return u.Event.map(this.g.wrapEvent(this.c.onChange),c=>this.G(c),this.y)}get onDidChangeSelection(){return u.Event.map(this.g.wrapEvent(this.d.onChange),c=>this.G(c),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let c=!1;const D=u.Event.chain(this.y.add(new F.$gT(this.k.domNode,"keydown")).event,S=>S.map(s=>new B.$_Q(s)).filter(s=>c=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>n.$0R.stop(s,!0)).filter(()=>!1)),l=u.Event.chain(this.y.add(new F.$gT(this.k.domNode,"keyup")).event,S=>S.forEach(()=>c=!1).map(s=>new B.$_Q(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>n.$0R.stop(s,!0)).map(({browserEvent:s})=>{const E=this.getFocus(),y=E.length?E[0]:void 0,R=typeof y<"u"?this.k.element(y):void 0,H=typeof y<"u"?this.k.domElement(y):this.k.domNode;return{index:y,element:R,anchor:H,browserEvent:s}})),p=u.Event.chain(this.k.onContextMenu,S=>S.filter(s=>!c).map(({element:s,index:E,browserEvent:y})=>({element:s,index:E,anchor:new a.$7Q((0,n.getWindow)(this.k.domNode),y),browserEvent:y})));return u.Event.any(D,l,p)}get onKeyDown(){return this.y.add(new F.$gT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new F.$gT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new F.$gT(this.k.domNode,"keypress")).event}get onDidFocus(){return u.Event.signal(this.y.add(new F.$gT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return u.Event.signal(this.y.add(new F.$gT(this.k.domNode,"blur",!0)).event)}constructor(c,D,l,p,S=ae){this.A=c,this.B=S,this.c=new C("focused"),this.f=new C("anchor"),this.g=new u.$ce,this.x="",this.y=new e.$Tc,this.z=new u.$7d,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(s!=="listbox");const E=[this.c.renderer,this.d.renderer];this.u=S.accessibilityProvider,this.u&&(E.push(new Ne(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),p=p.map(R=>new ve(R.templateId,[...E,R]));const y={...S,dnd:S.dnd&&new Ae(this,S.dnd)};if(this.k=this.C(D,l,p,y),this.k.domNode.setAttribute("role",s),S.styleController)this.q=S.styleController(this.k.domId);else{const R=(0,n.$WR)(this.k.domNode);this.q=new le(R,this.k.domId)}if(this.o=new k.$kT([new O(this.c,this.k,S.identityProvider),new O(this.d,this.k,S.identityProvider),new O(this.f,this.k,S.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new $e(this,this.k)),(typeof S.keyboardSupport!="boolean"||S.keyboardSupport)&&(this.v=new Z(this,this.k,S),this.y.add(this.v)),S.keyboardNavigationLabelProvider){const R=S.keyboardNavigationDelegate||t.$FT;this.t=new te(this,this.k,S.keyboardNavigationLabelProvider,S.keyboardNavigationEventFilter??(()=>!0),R),this.y.add(this.t)}this.w=this.D(S),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(c,D,l,p){return new w.$tT(c,D,l,p)}D(c){return new _(this)}updateOptions(c={}){this.B={...this.B,...c},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(c),this.v?.updateOptions(c),this.k.updateOptions(c)}get options(){return this.B}splice(c,D,l=[]){if(c<0||c>this.k.length)throw new g.$vT(this.A,`Invalid start index: ${c}`);if(D<0)throw new g.$vT(this.A,`Invalid delete count: ${D}`);D===0&&l.length===0||this.g.bufferEvents(()=>this.o.splice(c,D,l))}updateWidth(c){this.k.updateWidth(c)}updateElementHeight(c,D){this.k.updateElementHeight(c,D,null)}rerender(){this.k.rerender()}element(c){return this.k.element(c)}indexOf(c){return this.k.indexOf(c)}indexAt(c){return this.k.indexAt(c)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(c){this.k.setScrollTop(c)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(c){this.k.setScrollLeft(c)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(c){this.x=c,this.k.domNode.setAttribute("aria-label",c)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(c,D){this.k.layout(c,D)}triggerTypeNavigation(){this.t?.trigger()}setSelection(c,D){for(const l of c)if(l<0||l>=this.length)throw new g.$vT(this.A,`Invalid index ${l}`);this.d.set(c,D)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(c=>this.k.element(c))}setAnchor(c){if(typeof c>"u"){this.f.set([]);return}if(c<0||c>=this.length)throw new g.$vT(this.A,`Invalid index ${c}`);this.f.set([c])}getAnchor(){return(0,m.$Ob)(this.f.get(),void 0)}getAnchorElement(){const c=this.getAnchor();return typeof c>"u"?void 0:this.element(c)}setFocus(c,D){for(const l of c)if(l<0||l>=this.length)throw new g.$vT(this.A,`Invalid index ${l}`);this.c.set(c,D)}focusNext(c=1,D=!1,l,p){if(this.length===0)return;const S=this.c.get(),s=this.E(S.length>0?S[0]+c:0,D,p);s>-1&&this.setFocus([s],l)}focusPrevious(c=1,D=!1,l,p){if(this.length===0)return;const S=this.c.get(),s=this.F(S.length>0?S[0]-c:0,D,p);s>-1&&this.setFocus([s],l)}async focusNextPage(c,D){let l=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);l=l===0?0:l-1;const p=this.getFocus()[0];if(p!==l&&(p===void 0||l>p)){const S=this.F(l,!1,D);S>-1&&p!==S?this.setFocus([S],c):this.setFocus([l],c)}else{const S=this.k.getScrollTop();let s=S+this.k.renderHeight;l>p&&(s-=this.k.elementHeight(l)),this.k.setScrollTop(s),this.k.getScrollTop()!==S&&(this.setFocus([]),await(0,b.$jh)(0),await this.focusNextPage(c,D))}}async focusPreviousPage(c,D,l=()=>0){let p;const S=l(),s=this.k.getScrollTop()+S;s===0?p=this.k.indexAt(s):p=this.k.indexAfter(s-1);const E=this.getFocus()[0];if(E!==p&&(E===void 0||E>=p)){const y=this.E(p,!1,D);y>-1&&E!==y?this.setFocus([y],c):this.setFocus([p],c)}else{const y=s;this.k.setScrollTop(s-this.k.renderHeight-S),this.k.getScrollTop()+l()!==y&&(this.setFocus([]),await(0,b.$jh)(0),await this.focusPreviousPage(c,D,l))}}focusLast(c,D){if(this.length===0)return;const l=this.F(this.length-1,!1,D);l>-1&&this.setFocus([l],c)}focusFirst(c,D){this.focusNth(0,c,D)}focusNth(c,D,l){if(this.length===0)return;const p=this.E(c,!1,l);p>-1&&this.setFocus([p],D)}E(c,D=!1,l){for(let p=0;p<this.length;p++){if(c>=this.length&&!D)return-1;if(c=c%this.length,!l||l(this.element(c)))return c;c++}return-1}F(c,D=!1,l){for(let p=0;p<this.length;p++){if(c<0&&!D)return-1;if(c=(this.length+c%this.length)%this.length,!l||l(this.element(c)))return c;c--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(c=>this.k.element(c))}reveal(c,D,l=0){if(c<0||c>=this.length)throw new g.$vT(this.A,`Invalid index ${c}`);const p=this.k.getScrollTop(),S=this.k.elementTop(c),s=this.k.elementHeight(c);if((0,h.$Zf)(D)){const E=s-this.k.renderHeight+l;this.k.setScrollTop(E*(0,i.$nm)(D,0,1)+S-l)}else{const E=S+s,y=p+this.k.renderHeight;S<p+l&&E>=y||(S<p+l||E>=y&&s>=this.k.renderHeight?this.k.setScrollTop(S-l):E>=y&&this.k.setScrollTop(E-this.k.renderHeight))}}getRelativeTop(c,D=0){if(c<0||c>=this.length)throw new g.$vT(this.A,`Invalid index ${c}`);const l=this.k.getScrollTop(),p=this.k.elementTop(c),S=this.k.elementHeight(c);if(p<l+D||p+S>l+this.k.renderHeight)return null;const s=S-this.k.renderHeight+D;return Math.abs((l+D-p)/s)}isDOMFocused(){return(0,n.$PR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(c){return this.k.getElementDomId(c)}getElementTop(c){return this.k.elementTop(c)}style(c){this.q.style(c)}G({indexes:c,browserEvent:D}){return{indexes:c,elements:c.map(l=>this.k.element(l)),browserEvent:D}}H(){const c=this.c.get();this.k.domNode.classList.toggle("element-focused",c.length>0),this.I()}I(){const c=this.c.get();if(c.length>0){let D;this.u?.getActiveDescendantId&&(D=this.u.getActiveDescendantId(this.k.element(c[0]))),this.k.domNode.setAttribute("aria-activedescendant",D||this.k.getElementDomId(c[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const c=this.d.get();this.k.domNode.classList.toggle("selection-none",c.length===0),this.k.domNode.classList.toggle("selection-single",c.length===1),this.k.domNode.classList.toggle("selection-multiple",c.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$LT=Le,Ze([z.$Mh],Le.prototype,"onDidChangeFocus",null),Ze([z.$Mh],Le.prototype,"onDidChangeSelection",null),Ze([z.$Mh],Le.prototype,"onContextMenu",null),Ze([z.$Mh],Le.prototype,"onKeyDown",null),Ze([z.$Mh],Le.prototype,"onKeyUp",null),Ze([z.$Mh],Le.prototype,"onKeyPress",null),Ze([z.$Mh],Le.prototype,"onDidFocus",null),Ze([z.$Mh],Le.prototype,"onDidBlur",null)}),define(ge[72],be([1,0,6,45,47,10,16]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fk=t.MarkdownStringTextNewlineStyle=void 0,t.$Gk=b,t.$Hk=v,t.$Ik=z,t.$Jk=u,t.$Kk=f,t.$Lk=e,t.$Mk=i,t.$Nk=r;var k;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(k||(t.MarkdownStringTextNewlineStyle=k={}));class m{constructor(g="",w=!1){if(this.value=g,typeof this.value!="string")throw(0,n.$7)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(g,w=0){return this.value+=u(this.supportThemeIcons?(0,F.$zk)(g):g).replace(/([ \t]+)/g,(a,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,w){return this.value+=`
${f(w,g)}
`,this}appendLink(g,w,a){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(g),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(g,w){const a=new RegExp((0,W.$Ze)(w),"g");return g.replace(a,(d,o)=>g.charAt(o-1)!=="\\"?`\\${d}`:d)}}t.$Fk=m;function b(h){return v(h)?!h.value:Array.isArray(h)?h.every(b):!0}function v(h){return h instanceof m?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function z(h,g){return h===g?!0:!h||!g?!1:h.value===g.value&&h.isTrusted===g.isTrusted&&h.supportThemeIcons===g.supportThemeIcons&&h.supportHtml===g.supportHtml&&(h.baseUri===g.baseUri||!!h.baseUri&&!!g.baseUri&&(0,B.$Og)(A.URI.from(h.baseUri),A.URI.from(g.baseUri)))}function u(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function f(h,g){const w=h.match(/^`+/gm)?.reduce((d,o)=>d.length>o.length?d:o).length??0,a=w>=3?w+1:3;return[`${"`".repeat(a)}${g}`,h,`${"`".repeat(a)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function i(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(h){const g=[],w=h.split("|").map(d=>d.trim());h=w[0];const a=w[1];if(a){const d=/height=(\d+)/.exec(a),o=/width=(\d+)/.exec(a),C=d?d[1]:"",N=o?o[1]:"",O=isFinite(parseInt(N)),P=isFinite(parseInt(C));O&&g.push(`width="${N}"`),P&&g.push(`height="${C}"`)}return{href:h,dimensions:g}}}),define(ge[138],be([1,0,3,130,24,65,15,20,131,6,4,72,45,86,23,2,88,63,35,61,47,10,16]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f,e,i,r,h,g,w,a,d,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PT=void 0,t.$OT=N,t.$QT=M,t.$RT=V,t.$ST=ce;const C=Object.freeze({image:(G,se,fe)=>{let ve=[],Ne=[];return G&&({href:G,dimensions:ve}=(0,z.$Nk)(G),Ne.push(`src="${(0,z.$Lk)(G)}"`)),fe&&Ne.push(`alt="${(0,z.$Lk)(fe)}"`),se&&Ne.push(`title="${(0,z.$Lk)(se)}"`),ve.length&&(Ne=Ne.concat(ve)),"<img "+Ne.join(" ")+">"},paragraph:G=>`<p>${G}</p>`,link:(G,se,fe)=>typeof G!="string"?"":(G===fe&&(fe=(0,z.$Mk)(fe)),se=typeof se=="string"?(0,z.$Lk)((0,z.$Mk)(se)):"",G=(0,z.$Mk)(G),G=G.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${G}" title="${se||G}" draggable="false">${fe}</a>`)});function N(G,se={},fe={}){const ve=new i.$Tc;let Ne=!1;const Ae=(0,W.$fT)(se),Le=function(y){let R;try{R=(0,h.$Qh)(decodeURIComponent(y))}catch{}return R?(R=(0,w.$Qn)(R,H=>{if(G.uris&&G.uris[H])return o.URI.revive(G.uris[H])}),encodeURIComponent(JSON.stringify(R))):y},x=function(y,R){const H=G.uris&&G.uris[y];let X=o.URI.revive(H);return R?y.startsWith(g.Schemas.data+":")?y:(X||(X=o.URI.parse(y)),g.$Cg.uriToBrowserUri(X).toString(!0)):!X||o.URI.parse(y).toString()===X.toString()?y:(X.query&&(X=X.with({query:Le(X.query)})),X.toString())},c=new r.marked.Renderer;c.image=C.image,c.link=C.link,c.paragraph=C.paragraph;const D=[],l=[];if(se.codeBlockRendererSync?c.code=(y,R)=>{const H=f.$RO.nextId(),X=se.codeBlockRendererSync(O(R),y);return l.push([H,X]),`<div class="code" data-code="${H}">${(0,d.$Ye)(y)}</div>`}:se.codeBlockRenderer&&(c.code=(y,R)=>{const H=f.$RO.nextId(),X=se.codeBlockRenderer(O(R),y);return D.push(X.then(U=>[H,U])),`<div class="code" data-code="${H}">${(0,d.$Ye)(y)}</div>`}),se.actionHandler){const y=function(X){let U=X.target;if(!(U.tagName!=="A"&&(U=U.parentElement,!U||U.tagName!=="A")))try{let oe=U.dataset.href;oe&&(G.baseUri&&(oe=P(o.URI.from(G.baseUri),oe)),se.actionHandler.callback(oe,X))}catch(oe){(0,b.$1)(oe)}finally{X.preventDefault()}},R=se.actionHandler.disposables.add(new B.$gT(Ae,"click")),H=se.actionHandler.disposables.add(new B.$gT(Ae,"auxclick"));se.actionHandler.disposables.add(v.Event.any(R.event,H.event)(X=>{const U=new k.$7Q(n.getWindow(Ae),X);!U.leftButton&&!U.middleButton||y(U)})),se.actionHandler.disposables.add(n.$cR(Ae,"keydown",X=>{const U=new A.$_Q(X);!U.equals(10)&&!U.equals(3)||y(U)}))}G.supportHtml||(fe.sanitizer=y=>(G.isTrusted?y.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?y:"",fe.sanitize=!0,fe.silent=!0),fe.renderer=c;let p=G.value??"";p.length>1e5&&(p=`${p.substr(0,1e5)}\u2026`),G.supportThemeIcons&&(p=(0,u.$Ak)(p));let S;if(se.fillInIncompleteTokens){const y={...r.marked.defaults,...fe},R=r.marked.lexer(p,y),H=ce(R);S=r.marked.parser(H,y)}else S=r.marked.parse(p,fe);G.supportThemeIcons&&(S=(0,m.$MT)(S).map(R=>typeof R=="string"?R:R.outerHTML).join(""));const E=new DOMParser().parseFromString(L(G,S),"text/html");if(E.body.querySelectorAll("img").forEach(y=>{const R=y.getAttribute("src");if(R){let H=R;try{G.baseUri&&(H=P(o.URI.from(G.baseUri),H))}catch{}y.src=x(H,!0)}}),E.body.querySelectorAll("a").forEach(y=>{const R=y.getAttribute("href");if(y.setAttribute("href",""),!R||/^data:|javascript:/i.test(R)||/^command:/i.test(R)&&!G.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(R))y.replaceWith(...y.childNodes);else{let H=x(R,!1);G.baseUri&&(H=P(o.URI.from(G.baseUri),R)),y.dataset.href=H}}),Ae.innerHTML=L(G,E.body.innerHTML),D.length>0)Promise.all(D).then(y=>{if(Ne)return;const R=new Map(y),H=Ae.querySelectorAll("div[data-code]");for(const X of H){const U=R.get(X.dataset.code??"");U&&n.$eS(X,U)}se.asyncRenderCallback?.()});else if(l.length>0){const y=new Map(l),R=Ae.querySelectorAll("div[data-code]");for(const H of R){const X=y.get(H.dataset.code??"");X&&n.$eS(H,X)}}if(se.asyncRenderCallback)for(const y of Ae.getElementsByTagName("img")){const R=ve.add(n.$cR(y,"load",()=>{R.dispose(),se.asyncRenderCallback()}))}return{element:Ae,dispose:()=>{Ne=!0,ve.dispose()}}}function O(G){if(!G)return"";const se=G.split(/[\s+|:|,|\{|\?]/,1);return se.length?se[0]:G}function P(G,se){return/^\w[\w\d+.-]*:/.test(se)?se:G.path.endsWith("/")?(0,a.$Yg)(G,se).toString():(0,a.$Yg)((0,a.$Ug)(G),se).toString()}function L(G,se){const{config:fe,allowedSchemes:ve}=$(G);F.addHook("uponSanitizeAttribute",(Ae,Le)=>{if(Le.attrName==="style"||Le.attrName==="class"){if(Ae.tagName==="SPAN"){if(Le.attrName==="style"){Le.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Le.attrValue);return}else if(Le.attrName==="class"){Le.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Le.attrValue);return}}Le.keepAttr=!1;return}else if(Ae.tagName==="INPUT"&&Ae.attributes.getNamedItem("type")?.value==="checkbox"){if(Le.attrName==="type"&&Le.attrValue==="checkbox"||Le.attrName==="disabled"||Le.attrName==="checked"){Le.keepAttr=!0;return}Le.keepAttr=!1}}),F.addHook("uponSanitizeElement",(Ae,Le)=>{Le.tagName==="input"&&(Ae.attributes.getNamedItem("type")?.value==="checkbox"?Ae.setAttribute("disabled",""):Ae.parentElement?.removeChild(Ae))});const Ne=n.$yS(ve);try{return F.sanitize(se,{...fe,RETURN_TRUSTED_TYPE:!0})}finally{F.removeHook("uponSanitizeAttribute"),Ne.dispose()}}t.$PT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function $(G){const se=[g.Schemas.http,g.Schemas.https,g.Schemas.mailto,g.Schemas.data,g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemote,g.Schemas.vscodeRemoteResource];return G.isTrusted&&se.push(g.Schemas.command),{config:{ALLOWED_TAGS:[...n.$zS],ALLOWED_ATTR:t.$PT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:se}}function M(G){return typeof G=="string"?G:V(G)}function V(G){let se=G.value??"";se.length>1e5&&(se=`${se.substr(0,1e5)}\u2026`);const fe=r.marked.parse(se,{renderer:j.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ve=>I.get(ve)??ve);return L({isTrusted:!1},fe).toString()}const I=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),j=new e.$V(()=>{const G=new r.marked.Renderer;return G.code=se=>se,G.blockquote=se=>se,G.html=se=>"",G.heading=(se,fe,ve)=>se+`
`,G.hr=()=>"",G.list=(se,fe)=>se,G.listitem=se=>se+`
`,G.paragraph=se=>se+`
`,G.table=(se,fe)=>se+fe+`
`,G.tablerow=se=>se,G.tablecell=(se,fe)=>se+" ",G.strong=se=>se,G.em=se=>se,G.codespan=se=>se,G.br=()=>`
`,G.del=se=>se,G.image=(se,fe,ve)=>"",G.text=se=>se,G.link=(se,fe,ve)=>ve,G});function T(G){let se="";return G.forEach(fe=>{se+=fe.raw}),se}function K(G){for(let se=0;se<G.tokens.length;se++){const fe=G.tokens[se];if(fe.type==="text"){const ve=fe.raw.split(`
`),Ne=ve[ve.length-1];if(Ne.includes("`"))return te(G);if(Ne.includes("**"))return _(G);if(Ne.match(/\*\w/))return $e(G);if(Ne.match(/(^|\s)__\w/))return le(G);if(Ne.match(/(^|\s)_\w/))return De(G);if(Ne.match(/(^|\s)\[.*\]\(\w*/)){const Ae=G.tokens.slice(se+1);return Ae[0]?.type==="link"&&Ae[1]?.type==="text"&&Ae[1].raw.match(/^ *"[^"]*$/)?Pe(G):Te(G)}else{if(Z(Ne))return Te(G);if(Ne.match(/(^|\s)\[\w/)&&!G.tokens.slice(se+1).some(Ae=>Z(Ae.raw)))return he(G)}}}}function Z(G){return!!G.match(/^[^\[]*\]\([^\)]*$/)}function ce(G){let se,fe;for(se=0;se<G.length;se++){const ve=G[se];let Ne;if(ve.type==="paragraph"&&(Ne=ve.raw.match(/(\n|^)(````*)/))){const Ae=Ne[2];fe=re(G.slice(se),Ae);break}if(ve.type==="paragraph"&&ve.raw.match(/(\n|^)\|/)){fe=J(G.slice(se));break}if(se===G.length-1&&ve.type==="paragraph"){const Ae=K(ve);if(Ae){fe=[Ae];break}}}if(fe){const ve=[...G.slice(0,se),...fe];return ve.links=G.links,ve}return G}function re(G,se){const fe=T(G);return r.marked.lexer(fe+`
${se}`)}function te(G){return ae(G,"`")}function $e(G){return ae(G,"*")}function De(G){return ae(G,"_")}function Te(G){return ae(G,")")}function Pe(G){return ae(G,'")')}function he(G){return ae(G,"](about:blank)")}function _(G){return ae(G,"**")}function le(G){return ae(G,"__")}function ae(G,se){const fe=T(Array.isArray(G)?G:[G]);return r.marked.lexer(fe+se)[0]}function J(G){const se=T(G),fe=se.split(`
`);let ve,Ne=!1;for(let Ae=0;Ae<fe.length;Ae++){const Le=fe[Ae].trim();if(typeof ve>"u"&&Le.match(/^\s*\|/)){const x=Le.match(/(\|[^\|]+)(?=\||$)/g);x&&(ve=x.length)}else if(typeof ve=="number")if(Le.match(/^\s*\|/)){if(Ae!==fe.length-1)return;Ne=!0}else return}if(typeof ve=="number"&&ve>0){const Ae=Ne?fe.slice(0,-1).join(`
`):se,Le=!!Ae.match(/\|\s*$/),x=Ae+(Le?"":"|")+`
|${" --- |".repeat(ve)}`;return r.marked.lexer(x)}}}),define(ge[36],be([1,0,3,9,28,72,45,2,7,120]),function(ie,t,n,F,B,W,A,k,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6S=v,t.$7S=f;function v(e,i){(0,m.$Vf)(i)?e.title=(0,A.$Bk)(i):i?.markdownNotSupportedFallback?e.title=i.markdownNotSupportedFallback:e.removeAttribute("title")}class z{constructor(i,r,h){this.c=i,this.d=r,this.f=h}async update(i,r,h){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let g;if(i===void 0||(0,m.$Vf)(i)||i instanceof HTMLElement)g=i;else if(!(0,m.$0f)(i.markdown))g=i.markdown??i.markdownNotSupportedFallback;else{this.a||this.g((0,b.localize)(0,null),r),this.b=new B.$ee;const w=this.b.token;if(g=await i.markdown(w),g===void 0&&(g=i.markdownNotSupportedFallback),this.isDisposed||w.isCancellationRequested)return}this.g(g,r,h)}g(i,r,h){const g=this.a;if(this.h(i)){const w={content:i,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!g},position:{hoverPosition:2},...h};this.a=this.c.showHover(w,r)}g?.dispose()}h(i){return i?(0,W.$Hk)(i)?!!i.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function u(e,i){for(i=i??n.getWindow(e).document.body;!e.hasAttribute("custom-hover")&&e!==i;)e=e.parentElement;return e}function f(e,i,r,h){i.setAttribute("custom-hover","true"),i.title!==""&&(console.warn("HTML element already has a title attribute, which will conflict with the custom hover. Please remove the title attribute."),console.trace("Stack trace:",i.title),i.title="");let g,w;const a=(j,T)=>{const K=w!==void 0;j&&(w?.dispose(),w=void 0),T&&(g?.dispose(),g=void 0),K&&(e.onDidHideHover?.(),w=void 0)},d=(j,T,K)=>new F.$sh(async()=>{(!w||w.isDisposed)&&(w=new z(e,K||i,j>0),await w.update(typeof r=="function"?r():r,T,h))},j);let o=!1;const C=n.$cR(i,n.$8R.MOUSE_DOWN,()=>{o=!0,a(!0,!0)},!0),N=n.$cR(i,n.$8R.MOUSE_UP,()=>{o=!1},!0),O=n.$cR(i,n.$8R.MOUSE_LEAVE,j=>{o=!1,a(!1,j.fromElement===i)},!0),P=j=>{if(g)return;const T=new k.$Tc,K={targetElements:[i],dispose:()=>{}};if(e.placement===void 0||e.placement==="mouse"){const Z=ce=>{K.x=ce.x+10,ce.target instanceof HTMLElement&&u(ce.target,i)!==i&&a(!0,!0)};T.add(n.$cR(i,n.$8R.MOUSE_MOVE,Z,!0))}g=T,!(j.target instanceof HTMLElement&&u(j.target,i)!==i)&&T.add(d(e.delay,!1,K))},L=n.$cR(i,n.$8R.MOUSE_OVER,P,!0),$=()=>{if(o||g)return;const j={targetElements:[i],dispose:()=>{}},T=new k.$Tc,K=()=>a(!0,!0);T.add(n.$cR(i,n.$8R.BLUR,K,!0)),T.add(d(e.delay,!1,j)),g=T};let M;const V=i.tagName.toLowerCase();return V!=="input"&&V!=="textarea"&&(M=n.$cR(i,n.$8R.FOCUS,$,!0)),{show:j=>{a(!1,!0),d(0,j)},hide:()=>{a(!0,!0)},update:async(j,T)=>{r=j,await w?.update(r,void 0,T)},dispose:()=>{L.dispose(),O.dispose(),C.dispose(),N.dispose(),M?.dispose(),a(!0,!0)}}}}),define(ge[139],be([1,0,3,24,15,138,14,36,49,12,4,54,2,5,122,113]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=void 0;const i=n.$,r="selectOption.entry.template";class h{get templateId(){return r}renderTemplate(a){const d=Object.create(null);return d.root=a,d.text=n.$cS(a,i(".option-text")),d.detail=n.$cS(a,i(".option-detail")),d.decoratorRight=n.$cS(a,i(".option-decorator-right")),d}renderElement(a,d,o){const C=o,N=a.text,O=a.detail,P=a.decoratorRight,L=a.isDisabled;C.text.textContent=N,C.detail.textContent=O||"",C.decoratorRight.innerText=P||"",L?C.root.classList.add("option-disabled"):C.root.classList.remove("option-disabled")}disposeTemplate(a){}}class g extends u.$Uc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(a,d,o,C,N){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=C,this.g=N||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=g.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new v.$7d,this.B(this.r),this.Q(),this.P(o),this.n=d||0,a&&this.setOptions(a,d),this.S()}O(a){!this.M&&a?this.M=this.B((0,k.$7S)((0,A.$9S)("mouse"),this.h,a)):this.M&&this.M.update(a)}getHeight(){return 22}getTemplateId(){return r}P(a){this.u=a,this.w=n.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=n.$cS(this.w,i(".select-box-details-pane"));const d=n.$cS(this.w,i(".select-box-dropdown-container-width-control")),o=n.$cS(d,i(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",n.$cS(o,this.D),this.G=0,this.y=n.$WR(this.w),this.w.setAttribute("draggable","true"),this.B(n.$cR(this.w,n.$8R.DRAG_START,C=>{n.$0R.stop(C,!0)}))}Q(){this.B(n.$dR(this.h,"change",d=>{this.n=d.target.selectedIndex,this.r.fire({index:d.target.selectedIndex,selected:d.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(n.$cR(this.h,n.$8R.CLICK,d=>{n.$0R.stop(d),this.f?this.Z(!0):this.Y()})),this.B(n.$cR(this.h,n.$8R.MOUSE_DOWN,d=>{n.$0R.stop(d)}));let a;this.B(n.$cR(this.h,"touchstart",d=>{a=this.f})),this.B(n.$cR(this.h,"touchend",d=>{n.$0R.stop(d),a?this.Z(!0):this.Y()})),this.B(n.$cR(this.h,n.$8R.KEY_DOWN,d=>{const o=new B.$_Q(d);let C=!1;f.$j?(o.keyCode===18||o.keyCode===16||o.keyCode===10||o.keyCode===3)&&(C=!0):(o.keyCode===18&&o.altKey||o.keyCode===16&&o.altKey||o.keyCode===10||o.keyCode===3)&&(C=!0),C&&(this.Y(),n.$0R.stop(d,!0))}))}get onDidSelect(){return this.r.event}setOptions(a,d){b.$ub(this.m,a)||(this.m=a,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((o,C)=>{this.h.add(this.X(o.text,C,o.isDisabled)),typeof o.description=="string"&&(this.H=!0)})),d!==void 0&&(this.select(d),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(a){a>=0&&a<this.m.length?this.n=a:a>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(a){this.g.ariaLabel=a,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(a){this.h.tabIndex=a?0:-1}render(a){this.j=a,a.classList.add("select-container"),a.appendChild(this.h),this.U()}S(){const a=[];this.s.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=a.join(`
`)}U(){const a=this.s.selectBackground??"",d=this.s.selectForeground??"",o=this.s.selectBorder??"";this.h.style.backgroundColor=a,this.h.style.color=d,this.h.style.borderColor=o}W(){const a=this.s.selectBackground??"",d=n.$uS(this.s.selectListBackground,a);this.C.style.backgroundColor=d,this.I.style.backgroundColor=d;const o=this.s.focusBorder??"";this.w.style.outlineColor=o,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(a,d,o){const C=document.createElement("option");return C.value=a,C.text=a,C.disabled=!!o,C}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:a=>this.ab(a,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:a=>this.ab(a),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(a){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),a&&this.h.focus(),this.u.hideContextView())}ab(a,d){return a.appendChild(this.w),this.cb(d),{dispose:()=>{try{a.removeChild(this.w)}catch{}}}}bb(){let a=0;return this.m.forEach((d,o)=>{this.jb(o),this.I.offsetHeight>a&&(a=this.I.offsetHeight)}),a}cb(a){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const d=n.getWindow(this.h),o=n.$yR(this.h),C=n.getWindow(this.h).getComputedStyle(this.h),N=parseFloat(C.getPropertyValue("--dropdown-padding-top"))+parseFloat(C.getPropertyValue("--dropdown-padding-bottom")),O=d.innerHeight-o.top-o.height-(this.g.minBottomMargin||0),P=o.top-g.b,L=this.h.offsetWidth,$=this.db(this.D),M=Math.max($,Math.round(L)).toString()+"px";this.w.style.width=M,this.z.getHTMLElement().style.height="",this.z.layout();let V=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const I=this.H?this.L:0,j=V+N+I,T=Math.floor((O-N-I)/this.getHeight()),K=Math.floor((P-N-I)/this.getHeight());if(a)return o.top+o.height>d.innerHeight-22||o.top<g.b||T<1&&K<1?!1:(T<g.c&&K>T&&this.m.length>T?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(o.top+o.height>d.innerHeight-22||o.top<g.b||this.G===0&&T<1||this.G===1&&K<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&T+K<1)return this.Z(!0),!1;j>O&&(V=T*this.getHeight())}else j>P&&(V=K*this.getHeight());return this.z.layout(V),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=V+N+"px",this.w.style.height=""):this.w.style.height=V+N+"px",this.jb(this.n),this.w.style.width=M,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(a){let d=0;if(a){let o=0,C=0;this.m.forEach((N,O)=>{const P=N.detail?N.detail.length:0,L=N.decoratorRight?N.decoratorRight.length:0,$=N.text.length+P+L;$>C&&(o=O,C=$)}),a.textContent=this.m[o].text+(this.m[o].decoratorRight?this.m[o].decoratorRight+" ":""),d=n.$AR(a)}return d}eb(a){if(this.z)return;this.C=n.$cS(a,i(".select-box-dropdown-list-container")),this.t=new h,this.z=new m.$LT("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:C=>{let N=C.text;return C.detail&&(N+=`. ${C.detail}`),C.decoratorRight&&(N+=`. ${C.decoratorRight}`),C.description&&(N+=`. ${C.description}`),N},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>f.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const d=this.B(new F.$gT(this.C,"keydown")),o=v.Event.chain(d.event,C=>C.filter(()=>this.z.length>0).map(N=>new B.$_Q(N)));this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===3))(this.lb,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===2))(this.lb,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===9))(this.kb,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===16))(this.nb,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===18))(this.mb,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===12))(this.pb,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===11))(this.ob,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===14))(this.qb,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode===13))(this.rb,this)),this.B(v.Event.chain(o,C=>C.filter(N=>N.keyCode>=21&&N.keyCode<=56||N.keyCode>=85&&N.keyCode<=113))(this.sb,this)),this.B(n.$cR(this.z.getHTMLElement(),n.$8R.POINTER_UP,C=>this.fb(C))),this.B(this.z.onMouseOver(C=>typeof C.index<"u"&&this.z.setFocus([C.index]))),this.B(this.z.onDidChangeFocus(C=>this.ib(C))),this.B(n.$cR(this.w,n.$8R.FOCUS_OUT,C=>{!this.f||n.$GR(C.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(a){if(!this.z.length)return;n.$0R.stop(a);const d=a.target;if(!d||d.classList.contains("slider"))return;const o=d.closest(".monaco-list-row");if(!o)return;const C=Number(o.getAttribute("data-index")),N=o.classList.contains("option-disabled");C>=0&&C<this.m.length&&!N&&(this.n=C,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(a,d){const o=N=>{for(let O=0;O<N.childNodes.length;O++){const P=N.childNodes.item(O);(P.tagName&&P.tagName.toLowerCase())==="img"?N.removeChild(P):o(P)}},C=(0,W.$OT)({value:a,supportThemeIcons:!0},{actionHandler:d});return C.element.classList.add("select-box-description-markdown"),o(C.element),C.element}ib(a){!this.f||!this.H||this.jb(a.indexes[0])}jb(a){this.I.innerText="";const d=this.m[a],o=d?.description??"",C=d?.descriptionIsMarkdown??!1;if(o){if(C){const N=d.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(o,N))}else this.I.innerText=o;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(a){n.$0R.stop(a),this.select(this.F),this.Z(!0)}lb(a){n.$0R.stop(a),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(a){if(this.n<this.m.length-1){n.$0R.stop(a,!0);const d=this.m[this.n+1].isDisabled;if(d&&this.m.length>this.n+2)this.n+=2;else{if(d)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(a){this.n>0&&(n.$0R.stop(a,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(a){n.$0R.stop(a),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(a){n.$0R.stop(a),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(a){n.$0R.stop(a),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(a){n.$0R.stop(a),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(a){const d=z.KeyCodeUtils.toString(a.keyCode);let o=-1;for(let C=0;C<this.m.length-1;C++)if(o=(C+this.n+1)%this.m.length,this.m[o].text.charAt(0).toUpperCase()===d&&!this.m[o].isDisabled){this.select(o),this.z.setFocus([o]),this.z.reveal(this.z.getFocus()[0]),n.$0R.stop(a);break}}dispose(){this.Z(!1),super.dispose()}}t.$TT=g}),define(ge[140],be([1,0,49,139,134,21,5,112]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WT=t.$VT=void 0,t.$VT={...n.$KT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class k extends W.$PS{constructor(b,v,z,u,f){super(),A.$j&&!f?.useCustomDrawn?this.a=new B.$UT(b,v,u,f):this.a=new F.$TT(b,v,z,u,f),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(b,v){this.a.setOptions(b,v)}select(b){this.a.select(b)}setAriaLabel(b){this.a.setAriaLabel(b)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(b){this.a.setFocusable(b)}render(b){this.a.render(b)}}t.$WT=k}),define(ge[73],be([1,0,17,64,3,29,14,36,140,46,2,5,7,117,62]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5T=t.$4T=t.$3T=void 0;class e extends v.$Uc{get action(){return this._action}constructor(g,w,a={}){super(),this.m=a,this._context=g||this,this._action=w,w instanceof b.$Zi&&this.B(w.onDidChange(d=>{this.element&&this.t(d)}))}t(g){g.enabled!==void 0&&this.u(),g.checked!==void 0&&this.H(),g.class!==void 0&&this.G(),g.label!==void 0&&(this.w(),this.D()),g.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new b.$1i)),this.j}set actionRunner(g){this.j=g}isEnabled(){return this._action.enabled}setActionContext(g){this._context=g}render(g){const w=this.element=g;this.B(W.$LS.addTarget(g));const a=this.m&&this.m.draggable;a&&(g.draggable=!0,n.$UQ&&this.B((0,B.$cR)(g,B.$8R.DRAG_START,d=>d.dataTransfer?.setData(F.$JS.TEXT,this._action.label)))),this.B((0,B.$cR)(w,W.EventType.Tap,d=>this.onClick(d,!0))),this.B((0,B.$cR)(w,B.$8R.MOUSE_DOWN,d=>{a||B.$0R.stop(d,!0),this._action.enabled&&d.button===0&&w.classList.add("active")})),z.$j&&this.B((0,B.$cR)(w,B.$8R.CONTEXT_MENU,d=>{d.button===0&&d.ctrlKey===!0&&this.onClick(d)})),this.B((0,B.$cR)(w,B.$8R.CLICK,d=>{B.$0R.stop(d,!0),this.m&&this.m.isMenu||this.onClick(d)})),this.B((0,B.$cR)(w,B.$8R.DBLCLICK,d=>{B.$0R.stop(d,!0)})),[B.$8R.MOUSE_UP,B.$8R.MOUSE_OUT].forEach(d=>{this.B((0,B.$cR)(w,d,o=>{B.$0R.stop(o),w.classList.remove("active")}))})}onClick(g,w=!1){B.$0R.stop(g,!0);const a=u.$5f(this._context)?this.m?.useEventAsContext?g:{preserveFocus:w}:this._context;this.actionRunner.run(this._action,a)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(g){this.element&&(this.element.tabIndex=g?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const g=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=g;else if(!this.f&&g!==""){const w=this.m.hoverDelegate??(0,A.$9S)("element");this.f=this.q.add((0,k.$7S)(w,this.element,g))}else this.f&&this.f.update(g)}F(){if(this.element){const g=this.C()??"";this.element.setAttribute("aria-label",g)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$3T=e;class i extends e{constructor(g,w,a){super(g,w,a),this.m=a,this.m.icon=a.icon!==void 0?a.icon:!1,this.m.label=a.label!==void 0?a.label:!0,this.L=""}render(g){super.render(g),u.$6f(this.element);const w=document.createElement("a");if(w.classList.add("action-label"),w.setAttribute("role",this.M()),this.I=w,this.element.appendChild(w),this.m.label&&this.m.keybinding){const a=document.createElement("span");a.classList.add("keybinding"),a.textContent=this.m.keybinding,this.element.appendChild(a)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===b.$2i.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(g){this.I&&(this.I.tabIndex=g?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let g=null;return this.action.tooltip?g=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(g=this.action.label,this.m.keybinding&&(g=f.localize(0,null,g,this.m.keybinding))),g??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const g=this.C()??"";this.I.setAttribute("aria-label",g)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$4T=i;class r extends e{constructor(g,w,a,d,o,C,N){super(g,w),this.b=new m.$WT(a,d,o,C,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(g,w){this.b.setOptions(g,w)}select(g){this.b.select(g)}g(){this.B(this.b.onDidSelect(g=>this.n(g.selected,g.index)))}n(g,w){this.actionRunner.run(this._action,this.r(g,w))}r(g,w){return g}setFocusable(g){this.b.setFocusable(g)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(g){this.b.render(g)}}t.$5T=r}),define(ge[74],be([1,0,3,15,73,14,46,4,2,7,62]),function(ie,t,n,F,B,W,A,k,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$S=t.ActionsOrientation=void 0,t.$_S=u;var v;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(v||(t.ActionsOrientation=v={}));class z extends m.$Uc{constructor(e,i={}){super(),this.j=this.B(new m.$Tc),this.s=this.B(new m.$4c),this.y=!1,this.z=!0,this.D=this.B(new k.$7d),this.onDidBlur=this.D.event,this.F=this.B(new k.$7d({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new k.$7d),this.onDidRun=this.H.event,this.I=this.B(new k.$7d),this.onWillRun=this.I.event,this.b=i,this.m=i.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=i.hoverDelegate??this.B((0,W.$0S)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new A.$1i,this.j.add(this.g)),this.j.add(this.g.onDidRun(g=>this.H.fire(g))),this.j.add(this.g.onWillRun(g=>this.I.fire(g))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let r,h;switch(this.n){case 0:r=[15],h=[17];break;case 1:r=[16],h=[18],this.domNode.className+=" vertical";break}this.B(n.$cR(this.domNode,n.$8R.KEY_DOWN,g=>{const w=new F.$_Q(g);let a=!0;const d=typeof this.u=="number"?this.viewItems[this.u]:void 0;r&&(w.equals(r[0])||w.equals(r[1]))?a=this.Q():h&&(w.equals(h[0])||w.equals(h[1]))?a=this.P():w.equals(9)&&this.G?this.F.fire():w.equals(14)?a=this.N():w.equals(13)?a=this.O():w.equals(2)&&d instanceof B.$3T&&d.trapsArrowNavigation?a=this.P():this.L(w)?this.r.keyDown?this.S(w):this.y=!0:a=!1,a&&(w.preventDefault(),w.stopPropagation())})),this.B(n.$cR(this.domNode,n.$8R.KEY_UP,g=>{const w=new F.$_Q(g);this.L(w)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(w)),w.preventDefault(),w.stopPropagation()):(w.equals(2)||w.equals(1026)||w.equals(16)||w.equals(18)||w.equals(15)||w.equals(17))&&this.M()})),this.w=this.B(n.$aS(this.domNode)),this.B(this.w.onDidBlur(()=>{(n.$OR()===this.domNode||!n.$GR(n.$OR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const i=this.viewItems.find(r=>r instanceof B.$3T&&r.isEnabled());i instanceof B.$3T&&i.setFocusable(!0)}else this.viewItems.forEach(i=>{i instanceof B.$3T&&i.setFocusable(!1)})}L(e){let i=!1;return this.r.keys.forEach(r=>{i=i||e.equals(r)}),i}M(){for(let e=0;e<this.C.children.length;e++){const i=this.C.children[e];if(n.$GR(n.$OR(),i)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(i=>i.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(i=>this.H.fire(i))),this.j.add(this.g.onWillRun(i=>this.I.fire(i))),this.viewItems.forEach(i=>i.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(i=>i.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let i=0;i<this.C.childNodes.length;i++)if(this.C.childNodes[i]===e)return this.viewItems[i].action}}push(e,i={}){const r=Array.isArray(e)?e:[e];let h=b.$Zf(i.index)?i.index:null;r.forEach(g=>{const w=document.createElement("li");w.className="action-item",w.setAttribute("role","presentation");let a;const d={hoverDelegate:this.f,...i};this.b.actionViewItemProvider&&(a=this.b.actionViewItemProvider(g,d)),a||(a=new B.$4T(this.context,g,d)),this.b.allowContextMenu||this.s.set(a,n.$cR(w,n.$8R.CONTEXT_MENU,o=>{n.$0R.stop(o,!0)})),a.actionRunner=this.g,a.setActionContext(this.context),a.render(w),this.z&&a instanceof B.$3T&&this.viewItems.length===0&&a.setFocusable(!0),h===null||h<0||h>=this.C.children.length?(this.C.appendChild(w),this.viewItems.push(a)):(this.C.insertBefore(w,this.C.children[h]),this.viewItems.splice(h,0,a),h++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const i=this.C.children.item(e);if(i)return i.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const i=this.C.children.item(e);if(i)return i.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,m.$Pc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,m.$Pc)(this.viewItems),this.s.clearAndDisposeAll(),n.$bR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let i=!1,r;if(e===void 0?i=!0:typeof e=="number"?r=e:typeof e=="boolean"&&(i=e),i&&typeof this.u>"u"){const h=this.viewItems.findIndex(g=>g.isEnabled());this.u=h===-1?void 0:h,this.R(void 0,void 0,!0)}else r!==void 0&&(this.u=r),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const i=this.u;let r;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=i,!1;this.u=(this.u+1)%this.viewItems.length,r=this.viewItems[this.u]}while(this.u!==i&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===A.$2i.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const i=this.u;let r;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=i,!1;this.u=this.viewItems.length-1}r=this.viewItems[this.u]}while(this.u!==i&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===A.$2i.ID));return this.R(!0),!0}R(e,i,r=!1){typeof this.u>"u"&&this.C.focus({preventScroll:i}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const h=this.u!==void 0?this.viewItems[this.u]:void 0;if(h){let g=!0;b.$0f(h.focus)||(g=!1),this.b.focusOnlyEnabledItems&&b.$0f(h.isEnabled)&&!h.isEnabled()&&(g=!1),h.action.id===A.$2i.ID&&(g=!1),g?(r||this.t!==this.u)&&(h.focus(e),this.t=this.u):(this.C.focus({preventScroll:i}),this.t=void 0),g&&h.showHover?.()}}S(e){if(typeof this.u>"u")return;const i=this.viewItems[this.u];if(i instanceof B.$3T){const r=i._context===null||i._context===void 0?e:i._context;this.run(i._action,r)}}async run(e,i){await this.g.run(e,i)}dispose(){this.m=void 0,this.viewItems=(0,m.$Pc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$$S=z;function u(f){if(!f.length)return f;let e=-1;for(let r=0;r<f.length;r++)if(f[r].id!==A.$2i.ID){e=r;break}if(e===-1)return[];f=f.slice(e);for(let r=f.length-1;r>=0&&f[r].id===A.$2i.ID;r--)f.splice(r,1);let i=!1;for(let r=f.length-1;r>=0;r--){const h=f[r].id===A.$2i.ID;h&&!i?f.splice(r,1):h?h&&(i=!1):i=!0}return f}}),define(ge[75],be([1,0,3,24,65,74,67,14,36,70,21,4,91,61,121,109]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LU=t.$KU=t.$JU=t.MessageType=void 0;const i=n.$;var r;(function(w){w[w.INFO=1]="INFO",w[w.WARNING=2]="WARNING",w[w.ERROR=3]="ERROR"})(r||(t.MessageType=r={})),t.$JU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends v.$PS{constructor(a,d,o){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new z.$7d),this.onDidChange=this.P.event,this.Q=this.B(new z.$7d),this.onDidHeightChange=this.Q.event,this.a=d,this.g=o,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=n.$cS(a,i(".monaco-inputbox.idle"));const C=this.g.flexibleHeight?"textarea":"input",N=n.$cS(this.element,i(".ibwrapper"));if(this.b=n.$cS(N,i(C+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=n.$cS(N,i("div.mirror")),this.y.innerText="\xA0",this.N=new b.$ZS(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),n.$cS(a,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(L=>this.b.scrollTop=L.scrollTop));const O=this.B(new F.$gT(a.ownerDocument,"selectionchange")),P=z.Event.filter(O.event,()=>a.ownerDocument.getSelection()?.anchorNode===N);this.B(P(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new W.$$S(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(a){this.n=a,this.b.setAttribute("placeholder",a)}setTooltip(a){this.r=a,this.O?this.O.update(a):this.O=this.B((0,m.$7S)((0,k.$9S)("mouse"),this.b,a))}setAriaLabel(a){this.s=a,a?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(a){this.b.value!==a&&(this.b.value=a,this.Z())}get step(){return this.b.step}set step(a){this.b.step=a}get height(){return typeof this.J=="number"?this.J:n.$ER(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return n.$PR(this.b)}select(a=null){this.b.select(),a&&(this.b.setSelectionRange(a.start,a.end),a.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const a=this.b.selectionStart;if(a===null)return null;const d=this.b.selectionEnd??a;return{start:a,end:d}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(a){a?this.enable():this.disable()}get width(){return n.$AR(this.b)}set width(a){if(this.g.flexibleHeight&&this.g.flexibleWidth){let d=0;if(this.y){const o=parseFloat(this.y.style.paddingLeft||"")||0,C=parseFloat(this.y.style.paddingRight||"")||0;d=o+C}this.b.style.width=a-d+"px"}else this.b.style.width=a+"px";this.y&&(this.y.style.width=a+"px")}set paddingRight(a){this.b.style.width=`calc(100% - ${a}px)`,this.y&&(this.y.style.paddingRight=a+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const a=this.L,d=this.J,o=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:a,height:d}),this.N.setScrollPosition({scrollTop:o})}showMessage(a,d){if(this.w==="open"&&(0,f.$Sn)(this.h,a))return;this.h=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(a.type));const o=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${n.$uS(o.border,"transparent")}`,this.h.content&&(this.hasFocus()||d)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let a=null;return this.t&&(a=this.t(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){const d=this.g.inputBoxStyles;switch(a){case 1:return{border:d.inputValidationInfoBorder,background:d.inputValidationInfoBackground,foreground:d.inputValidationInfoForeground};case 2:return{border:d.inputValidationWarningBorder,background:d.inputValidationWarningBackground,foreground:d.inputValidationWarningForeground};default:return{border:d.inputValidationErrorBorder,background:d.inputValidationErrorBackground,foreground:d.inputValidationErrorForeground}}}W(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let a;const d=()=>a.style.width=n.$AR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:C=>{if(!this.h)return null;a=n.$cS(C,i(".monaco-inputbox-container")),d();const N={inline:!0,className:"monaco-inputbox-message"},O=this.h.formatContent?(0,B.$eT)(this.h.content,N):(0,B.$dT)(this.h.content,N);O.classList.add(this.W(this.h.type));const P=this.stylesForType(this.h.type);return O.style.backgroundColor=P.background??"",O.style.color=P.foreground??"",O.style.border=P.border?`1px solid ${P.border}`:"",n.$cS(a,O),null},onHide:()=>{this.w="closed"},layout:d});let o;this.h.type===3?o=e.localize(0,null,this.h.content):this.h.type===2?o=e.localize(1,null,this.h.content):o=e.localize(2,null,this.h.content),A.$iT(o),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const a=this.value,o=a.charCodeAt(a.length-1)===10?" ":"";(a+o).replace(/\u000c/g,"")?this.y.textContent=a+o:this.y.innerText="\xA0",this.layout()}bb(){const a=this.g.inputBoxStyles,d=a.inputBackground??"",o=a.inputForeground??"",C=a.inputBorder??"";this.element.style.backgroundColor=d,this.element.style.color=o,this.b.style.backgroundColor="inherit",this.b.style.color=o,this.element.style.border=`1px solid ${n.$uS(C,"transparent")}`}layout(){if(!this.y)return;const a=this.L;this.L=n.$ER(this.y),a!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(a){const d=this.inputElement,o=d.selectionStart,C=d.selectionEnd,N=d.value;o!==null&&C!==null&&(this.value=N.substr(0,o)+a+N.substr(C),d.setSelectionRange(o+1,o+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$KU=h;class g extends h{constructor(a,d,o){const C=e.localize(3,null,"\u21C5"),N=e.localize(4,null,"\u21C5");super(a,d,o),this.eb=this.B(new z.$7d),this.onDidFocus=this.eb.event,this.fb=this.B(new z.$7d),this.onDidBlur=this.fb.event,this.cb=new u.$HU(o.history,100);const O=()=>{if(o.showHistoryHint&&o.showHistoryHint()&&!this.n.endsWith(C)&&!this.n.endsWith(N)&&this.cb.getHistory().length){const P=this.n.endsWith(")")?C:N,L=this.n+P;o.showPlaceholderOnFocus&&!n.$PR(this.b)?this.n=L:this.setPlaceHolder(L)}};this.db=new MutationObserver((P,L)=>{P.forEach($=>{$.target.textContent||O()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>O()),this.F(this.b,()=>{const P=L=>{if(this.n.endsWith(L)){const $=this.n.slice(0,this.n.length-L.length);return o.showPlaceholderOnFocus?this.n=$:this.setPlaceHolder($),!0}else return!1};P(N)||P(C)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(a){this.value&&(a||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(a){const d=this.getHistory();this.clearHistory(),a.forEach(o=>{this.cb.add(o)}),d.forEach(o=>{this.cb.add(o)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let a=this.kb();a&&(a=a===this.value?this.kb():a),this.value=a??"",A.$jT(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let a=this.jb();a&&(a=a===this.value?this.jb():a),a&&(this.value=a,A.$jT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(a){super.setPlaceHolder(a),this.setTooltip(a)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let a=this.cb.current();return a||(a=this.cb.last(),this.cb.next()),a}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$LU=g}),define(ge[76],be([1,0,73,21,18,19,4,3,36,14,114]),function(ie,t,n,F,B,W,A,k,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2T=t.$1T=t.$ZT=t.$YT=t.$XT=void 0,t.$XT={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class v extends n.$3T{constructor(i,r,h){super(i,r,h),this.a=this.B(new z({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:h.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:h.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:h.toggleStyles?.inputActiveOptionForeground,hoverDelegate:h.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(i){this.element=i,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(i){this.a.domNode.tabIndex=i?0:-1}}t.$YT=v;class z extends F.$PS{constructor(i){super(),this.a=this.B(new A.$7d),this.onChange=this.a.event,this.b=this.B(new A.$7d),this.onKeyDown=this.b.event,this.c=i,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,m.$7S)(i.hoverDelegate??(0,b.$9S)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,h=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),h.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,h=>{if(h.keyCode===10||h.keyCode===3){this.checked=!this.s,this.a.fire(!0),h.preventDefault(),h.stopPropagation();return}this.b.fire(h)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(i){this.s=i,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(i){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=i,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(i){this.t.update(i),this.domNode.setAttribute("aria-label",i)}}t.$ZT=z;class u extends F.$PS{constructor(i,r,h){super(),this.g=i,this.h=r,this.a=this.B(new A.$7d),this.onChange=this.a.event,this.b=this.B(new z({title:this.g,isChecked:this.h,icon:B.$Hj.check,actionClassName:"monaco-checkbox",...t.$XT})),this.domNode=this.b.domNode,this.c=h,this.n(),this.B(this.b.onChange(g=>{this.n(),this.a.fire(g)}))}get checked(){return this.b.checked}set checked(i){this.b.checked=i,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,k.$PR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$1T=u;class f extends n.$3T{constructor(i,r,h){super(i,r,h),this.a=this.B(new u(this._action.label,!!this._action.checked,h.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(i){if(this.element=i,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const r=this.element.appendChild((0,k.$)("span.checkbox-label",void 0,this._action.label));this.B((0,k.$cR)(r,k.$8R.CLICK,h=>{this.a.checked=!this.a.checked,h.stopPropagation(),h.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(i){this.a.domNode.tabIndex=i?0:-1}}t.$2T=f}),define(ge[141],be([1,0,14,76,18,119]),function(ie,t,n,F,B,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YU=t.$XU=t.$WU=void 0;const A=W.localize(0,null),k=W.localize(1,null),m=W.localize(2,null);class b extends F.$ZT{constructor(f){super({icon:B.$Hj.caseSensitive,title:A+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,n.$9S)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$WU=b;class v extends F.$ZT{constructor(f){super({icon:B.$Hj.wholeWord,title:k+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,n.$9S)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$XU=v;class z extends F.$ZT{constructor(f){super({icon:B.$Hj.regex,title:m+f.appendTitle,isChecked:f.isChecked,hoverDelegate:f.hoverDelegate??(0,n.$9S)("element"),inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.$YU=z}),define(ge[142],be([1,0,3,141,75,21,4,118,2,14,108]),function(ie,t,n,F,B,W,A,k,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZU=void 0;const v=k.localize(0,null);class z extends W.$PS{static{this.OPTION_CHANGE="optionChange"}constructor(f,e,i){super(),this.n=!0,this.s=!1,this.w=this.B(new m.$Vc),this.N=[],this.O=this.B(new A.$7d),this.onDidOptionChange=this.O.event,this.P=this.B(new A.$7d),this.onKeyDown=this.P.event,this.Q=this.B(new A.$7d),this.onMouseDown=this.Q.event,this.R=this.B(new A.$7d),this.onInput=this.R.event,this.S=this.B(new A.$7d),this.onKeyUp=this.S.event,this.U=this.B(new A.$7d),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new A.$7d),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=i.placeholder||"",this.b=i.validation,this.c=i.label||v,this.h=!!i.showCommonFindToggles;const r=i.appendCaseSensitiveLabel||"",h=i.appendWholeWordsLabel||"",g=i.appendRegexLabel||"",w=i.history||[],a=!!i.flexibleHeight,d=!!i.flexibleWidth,o=i.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new B.$LU(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:w,showHistoryHint:i.showHistoryHint,flexibleHeight:a,flexibleWidth:d,flexibleMaxHeight:o,inputBoxStyles:i.inputBoxStyles}));const C=this.B((0,b.$0S)());if(this.h){this.J=this.B(new F.$YU({appendTitle:g,isChecked:!1,hoverDelegate:C,...i.toggleStyles})),this.B(this.J.onChange(O=>{this.O.fire(O),!O&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(O=>{this.W.fire(O)})),this.L=this.B(new F.$XU({appendTitle:h,isChecked:!1,hoverDelegate:C,...i.toggleStyles})),this.B(this.L.onChange(O=>{this.O.fire(O),!O&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new F.$WU({appendTitle:r,isChecked:!1,hoverDelegate:C,...i.toggleStyles})),this.B(this.M.onChange(O=>{this.O.fire(O),!O&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(O=>{this.U.fire(O)}));const N=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,O=>{if(O.equals(15)||O.equals(17)||O.equals(9)){const P=N.indexOf(this.domNode.ownerDocument.activeElement);if(P>=0){let L=-1;O.equals(17)?L=(P+1)%N.length:O.equals(15)&&(P===0?L=N.length-1:L=P-1),O.equals(9)?(N[P].blur(),this.inputBox.focus()):L>=0&&N[L].focus(),n.$0R.stop(O,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(i?.additionalToggles),this.y&&this.domNode.appendChild(this.y),f?.appendChild(this.domNode),this.B(n.$cR(this.inputBox.inputElement,"compositionstart",N=>{this.s=!0})),this.B(n.$cR(this.inputBox.inputElement,"compositionend",N=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,N=>this.P.fire(N)),this.C(this.inputBox.inputElement,N=>this.S.fire(N)),this.D(this.inputBox.inputElement,N=>this.R.fire()),this.j(this.inputBox.inputElement,N=>this.Q.fire(N))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(f){this.inputBox.layout(),this.X(f.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const f of this.N)f.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const f of this.N)f.disable()}setFocusInputOnOptionClick(f){this.n=f}setEnabled(f){f?this.enable():this.disable()}setAdditionalToggles(f){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new m.$Tc;for(const e of f??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(i=>{this.O.fire(i),!i&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(f=!1){f?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,i)=>e+i.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(f){this.inputBox.value!==f&&(this.inputBox.value=f)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(f){this.M&&(this.M.checked=f)}getWholeWords(){return this.L?.checked??!1}setWholeWords(f){this.L&&(this.L.checked=f)}getRegex(){return this.J?.checked??!1}setRegex(f){this.J&&(this.J.checked=f,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(f){this.inputBox.showMessage(f)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$ZU=z}),define(ge[143],be([1,0,3,24,15,74,142,75,71,49,76,68,30,46,12,9,18,19,38,4,43,2,39,7,123,14,57,115]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f,e,i,r,h,g,w,a,d,o,C,N,O,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yV=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$xV=t.$wV=t.$vV=t.RenderIndentGuides=t.$uV=t.$tV=void 0;class L extends m.$qT{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(E=>E.element)),this.c=s}}function $(S){return S instanceof m.$qT?new L(S):S}class M{constructor(s,E){this.d=s,this.f=E,this.b=d.$Uc.None,this.c=new d.$Tc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,E){if(this.f.getDragLabel)return this.f.getDragLabel(s.map(y=>y.element),E)}onDragStart(s,E){this.f.onDragStart?.($(s),E)}onDragOver(s,E,y,R,H,X=!0){const U=this.f.onDragOver($(s),E&&E.element,y,R,H),oe=this.a!==E;if(oe&&(this.b.dispose(),this.a=E),typeof E>"u")return U;if(oe&&typeof U!="boolean"&&U.autoExpand&&(this.b=(0,i.$kh)(()=>{const je=this.d(),Ee=je.getNodeLocation(E);je.isCollapsed(Ee)&&je.setCollapsed(Ee,!1),this.a=void 0},500,this.c)),typeof U=="boolean"||!U.accept||typeof U.bubble>"u"||U.feedback){if(!X){const je=typeof U=="boolean"?U:U.accept,Ee=typeof U=="boolean"?void 0:U.effect;return{accept:je,effect:Ee,feedback:[y]}}return U}if(U.bubble===1){const je=this.d(),Ee=je.getNodeLocation(E),Se=je.getParentNodeLocation(Ee),We=je.getNode(Se),Ue=Se&&je.getListIndex(Se);return this.onDragOver(s,We,Ue,R,H,!1)}const we=this.d(),me=we.getNodeLocation(E),Ie=we.getListIndex(me),ke=we.getListRenderCount(me);return{...U,feedback:(0,e.$Sb)(Ie,Ie+ke)}}drop(s,E,y,R,H){this.b.dispose(),this.a=void 0,this.f.drop($(s),E&&E.element,y,R,H)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function V(S,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(E){return s.identityProvider.getId(E.element)}},dnd:s.dnd&&new M(S,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return s.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return s.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(E){const y=S(),R=y.getNodeLocation(E),H=y.getParentNodeLocation(R);return y.getNode(H).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?E=>s.accessibilityProvider.isChecked(E.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?E=>s.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return s.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?E=>s.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(E=>s.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class I{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,E){this.a.setDynamicHeight?.(s.element,E)}}t.$tV=I;class j{static lift(s){return s instanceof j?s:new j(s)}static empty(s=0){return new j({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const E of s.expanded)this.expanded[E]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$uV=j;var T;(function(S){S.None="none",S.OnHover="onHover",S.Always="always"})(T||(t.RenderIndentGuides=T={}));class K{get elements(){return this.b}constructor(s,E=[]){this.b=E,this.a=new d.$Tc,this.onDidChange=w.Event.forEach(s,y=>this.b=y,this.a)}dispose(){this.a.dispose()}}class Z{static{this.a=8}constructor(s,E,y,R,H,X={}){this.o=s,this.p=E,this.q=R,this.s=H,this.b=new Map,this.c=new Map,this.d=Z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=d.$Uc.None,this.m=new d.$Tc,this.templateId=s.templateId,this.updateOptions(X),w.Event.map(y,U=>U.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const E=(0,o.$nm)(s.indent,0,40);if(E!==this.d){this.d=E;for(const[y,R]of this.c)this.v(y,R)}}if(typeof s.renderIndentGuides<"u"){const E=s.renderIndentGuides!==T.None;if(E!==this.g){this.g=E;for(const[y,R]of this.c)this.w(y,R);if(this.k.dispose(),E){const y=new d.$Tc;this.q.onDidChange(this.x,this,y),this.k=y,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const E=(0,n.$cS)(s,(0,n.$)(".monaco-tl-row")),y=(0,n.$cS)(E,(0,n.$)(".monaco-tl-indent")),R=(0,n.$cS)(E,(0,n.$)(".monaco-tl-twistie")),H=(0,n.$cS)(E,(0,n.$)(".monaco-tl-contents")),X=this.o.renderTemplate(H);return{container:s,indent:y,twistie:R,indentGuidesDisposable:d.$Uc.None,templateData:X}}renderElement(s,E,y,R){this.c.set(s,y),this.b.set(s.element,s),this.v(s,y),this.o.renderElement(s,E,y.templateData,R)}disposeElement(s,E,y,R){y.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,E,y.templateData,R),typeof R=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const E=this.b.get(s);E&&this.u(E)}u(s){const E=this.c.get(s);E&&(this.x(this.q.elements),this.v(s,E))}v(s,E){const y=Z.a+(s.depth-1)*this.d;E.twistie.style.paddingLeft=`${y}px`,E.indent.style.width=`${y+this.d-16}px`,s.collapsible?E.container.setAttribute("aria-expanded",String(!s.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(r.$Hj.treeItemExpanded));let R=!1;this.o.renderTwistie&&(R=this.o.renderTwistie(s.element,E.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(R||E.twistie.classList.add(...h.ThemeIcon.asClassNameArray(r.$Hj.treeItemExpanded)),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",s.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),this.w(s,E)}w(s,E){if((0,n.$bR)(E.indent),E.indentGuidesDisposable.dispose(),!this.g)return;const y=new d.$Tc,R=this.p();for(;;){const H=R.getNodeLocation(s),X=R.getParentNodeLocation(H);if(!X)break;const U=R.getNode(X),oe=(0,n.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(U)&&oe.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(oe):E.indent.insertBefore(oe,E.indent.firstElementChild),this.s.add(U,oe),y.add((0,d.$Sc)(()=>this.s.delete(U,oe))),s=U}E.indentGuidesDisposable=y}x(s){if(!this.g)return;const E=new Set,y=this.p();s.forEach(R=>{const H=y.getNodeLocation(R);try{const X=y.getParentNodeLocation(H);R.collapsible&&R.children.length>0&&!R.collapsed?E.add(R):X&&E.add(y.getNode(X))}catch{}}),this.j.forEach(R=>{E.has(R)||this.s.forEach(R,H=>H.classList.remove("active"))}),E.forEach(R=>{this.j.has(R)||this.s.forEach(R,H=>H.classList.add("active"))}),this.j=E}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,d.$Pc)(this.m)}}t.$vV=Z;class ce{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,E,y){this.g=s,this.j=E,this.k=y,this.a=0,this.b=0,this.c="",this.d="",this.f=new d.$Tc,s.onWillRefilter(this.m,this,this.f)}filter(s,E){let y=1;if(this.k){const X=this.k.filter(s,E);if(typeof X=="boolean"?y=X?1:0:(0,z.$qV)(X)?y=(0,z.$rV)(X.visibility):y=X,y===0)return!1}if(this.a++,!this.c)return this.b++,{data:a.FuzzyScore.Default,visibility:y};const R=this.j.getKeyboardNavigationLabel(s),H=Array.isArray(R)?R:[R];for(const X of H){const U=X&&X.toString();if(typeof U>"u")return{data:a.FuzzyScore.Default,visibility:y};let oe;if(this.g.findMatchType===Te.Contiguous){const we=U.toLowerCase().indexOf(this.d);if(we>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let me=this.d.length;me>0;me--)oe.push(we+me-1)}}else oe=(0,a.$wk)(this.c,this.d,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this.b++,H.length===1?{data:oe,visibility:y}:{data:{label:U,score:oe},visibility:y}}return this.g.findMode===De.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:a.FuzzyScore.Default,visibility:y}}m(){this.a=0,this.b=0}dispose(){(0,d.$Pc)(this.f)}}class re extends v.$ZT{constructor(s){super({icon:r.$Hj.listFilter,title:(0,N.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,O.$9S)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$wV=re;class te extends v.$ZT{constructor(s){super({icon:r.$Hj.searchFuzzy,title:(0,N.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,O.$9S)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$xV=te;const $e={inputBoxStyles:k.$JU,toggleStyles:v.$XT,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var De;(function(S){S[S.Highlight=0]="Highlight",S[S.Filter=1]="Filter"})(De||(t.TreeFindMode=De={}));var Te;(function(S){S[S.Fuzzy=0]="Fuzzy",S[S.Contiguous=1]="Contiguous"})(Te||(t.TreeFindMatchType=Te={}));class Pe extends d.$Uc{set mode(s){this.b.checked=s===De.Filter,this.f.inputBox.setPlaceHolder(s===De.Filter?(0,N.localize)(2,null):(0,N.localize)(3,null))}set matchType(s){this.c.checked=s===Te.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,E,y,R,H,X){super(),this.t=E,this.a=(0,n.h)(".monaco-tree-type-filter",[(0,n.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,n.h)(".monaco-tree-type-filter-input@findInput"),(0,n.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new w.$7d,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,d.$Sc)(()=>s.removeChild(this.a.root)));const U=X?.styles??$e;U.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=U.listFilterWidgetBackground),U.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${U.listFilterWidgetShadow}`);const oe=this.B((0,O.$0S)());this.b=this.B(new re({...U.toggleStyles,isChecked:R===De.Filter,hoverDelegate:oe})),this.c=this.B(new te({...U.toggleStyles,isChecked:H===Te.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=w.Event.map(this.b.onChange,()=>this.b.checked?De.Filter:De.Highlight,this.q),this.onDidChangeMatchType=w.Event.map(this.c.onChange,()=>this.c.checked?Te.Fuzzy:Te.Contiguous,this.q),this.f=this.B(new A.$ZU(this.a.findInput,y,{label:(0,N.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:U.inputBoxStyles,toggleStyles:U.toggleStyles,history:X?.history})),this.g=this.B(new W.$$S(this.a.actionbar)),this.mode=R;const we=this.B(new F.$gT(this.f.inputBox.inputElement,"keydown")),me=w.Event.chain(we.event,Ee=>Ee.map(Se=>new B.$_Q(Se)));this.B(me(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const Ie=this.B(new f.$Zi("close",(0,N.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(Ie,{icon:!0,label:!1});const ke=this.B(new F.$gT(this.a.grab,"mousedown"));this.B(ke.event(Ee=>{const Se=new d.$Tc,We=Se.add(new F.$gT((0,n.getWindow)(Ee),"mousemove")),Ue=Se.add(new F.$gT((0,n.getWindow)(Ee),"mouseup")),Ye=this.m,_e=Ee.pageX,Y=this.s,ne=Ee.pageY;this.a.grab.classList.add("grabbing");const pe=this.a.root.style.transition;this.a.root.style.transition="unset";const ye=Re=>{const xe=Re.pageX-_e;this.m=Ye-xe;const Ve=Re.pageY-ne;this.s=Y+Ve,this.layout()};Se.add(We.event(ye)),Se.add(Ue.event(Re=>{ye(Re),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=pe,Se.dispose()}))}));const je=w.Event.chain(this.B(new F.$gT(this.a.grab,"keydown")).event,Ee=>Ee.map(Se=>new B.$_Q(Se)));this.B(je(Ee=>{let Se,We;if(Ee.keyCode===15?Se=Number.POSITIVE_INFINITY:Ee.keyCode===17?Se=0:Ee.keyCode===10&&(Se=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?We=0:Ee.keyCode===18&&(We=Number.POSITIVE_INFINITY),Se!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=Se,this.layout()),We!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=We;const Ue=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ue},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,o.$nm)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$nm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,i.$jh)(300),super.dispose()}}class he{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,E,y,R,H,X={}){this.t=s,this.u=y,this.v=R,this.w=H,this.x=X,this.b="",this.c="",this.j=0,this.k=new w.$7d,this.onDidChangeMode=this.k.event,this.m=new w.$7d,this.onDidChangeMatchType=this.m.event,this.o=new w.$7d,this.onDidChangePattern=this.o.event,this.p=new w.$7d,this.onDidChangeOpenState=this.p.event,this.q=new d.$Tc,this.s=new d.$Tc,this.d=s.options.defaultFindMode??De.Highlight,this.f=s.options.defaultFindMatchType??Te.Fuzzy,E.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Pe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,y=>!a.FuzzyScore.isDefault(y.filterData));const E=this.t.getFocus();if(E.length>0){const y=E[0];this.t.getRelativeTop(y)===null&&this.t.reveal(y,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,N.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!a.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function _(S,s){return S.position===s.position&&le(S,s)}function le(S,s){return S.node.element===s.node.element&&S.startIndex===s.startIndex&&S.height===s.height&&S.endIndex===s.endIndex}class ae{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const E=this.stickyNodes[this.count-2];return E.position+E.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,le)||this.count===0)return!1;const E=this.stickyNodes[this.count-1],y=s.stickyNodes[s.count-1];return E.position!==y.position}}class J{constrainStickyScrollNodes(s,E,y){for(let R=0;R<s.length;R++){const H=s[R];if(H.position+H.height>y||R>=E)return s.slice(0,R)}return s}}class G extends d.$Uc{constructor(s,E,y,R,H,X={}){super(),this.g=s,this.j=E,this.m=y,this.s=H,this.c=.4;const U=this.validateStickySettings(X);this.b=U.stickyScrollMaxItemCount,this.a=X.stickyScrollDelegate??new J,this.f=this.B(new se(y.getScrollableElement(),y,s,R,H,X.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(y.onDidScroll(()=>this.u())),this.B(y.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let E;if(s===0?E=this.m.firstVisibleIndex:E=this.m.indexAt(s+this.m.scrollTop),!(E<0||E>=this.m.length))return this.m.element(E)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const E=this.w(s);this.f.setState(E)}w(s){const E=[];let y=s,R=0,H=this.z(y,void 0,R);for(;H&&(E.push(H),R+=H.height,!(E.length<=this.b&&(y=this.y(H),!y)));)H=this.z(y,H.node,R);const X=this.H(E);return X.length?new ae(X):void 0}y(s){return this.t(s.position+s.height)}z(s,E,y){const R=this.F(s,E);if(R&&!(R===s&&(!this.J(s)||this.C(s,y))))return this.D(R,y)}C(s,E){const y=this.L(s),R=this.m.getElementTop(y),H=E;return this.m.scrollTop===R-H}D(s,E){const y=this.s.getHeight(s),{startIndex:R,endIndex:H}=this.M(s),X=this.G(H,E,y);return{node:s,position:X,height:y,startIndex:R,endIndex:H}}F(s,E=void 0){let y=s,R=this.I(y);for(;R;){if(R===E)return y;y=R,R=this.I(y)}if(E===void 0)return y}G(s,E,y){let R=this.m.getRelativeTop(s);if(R===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const we=this.s.getHeight(this.m.element(s)),me=this.m.getRelativeTop(s+1);R=me?me-we/this.m.renderHeight:null}if(R===null)return E;const H=this.m.element(s),X=this.s.getHeight(H),oe=R*this.m.renderHeight+X;return E+y>oe&&E<=oe?oe-y:E}H(s){if(s.length===0)return[];const E=this.m.renderHeight*this.c,y=s[s.length-1];if(s.length<=this.b&&y.position+y.height<=E)return s;const R=this.a.constrainStickyScrollNodes(s,this.b,E);if(!R.length)return[];const H=R[R.length-1];if(R.length>this.b||H.position+H.height>E)throw new Error("stickyScrollDelegate violates constraints");return R}I(s){const E=this.j.getNodeLocation(s),y=this.j.getParentNodeLocation(E);return y?this.j.getNode(y):void 0}J(s){const E=this.j.getNodeLocation(s);return this.j.getListRenderCount(E)>1}L(s){const E=this.j.getNodeLocation(s);return this.j.getListIndex(E)}M(s){const E=this.j.getNodeLocation(s),y=this.j.getListIndex(E);if(y<0)throw new Error("Node not found in tree");const R=this.j.getListRenderCount(E),H=y+R-1;return{startIndex:y,endIndex:H}}nodePositionTopBelowWidget(s){const E=[];let y=this.I(s);for(;y;)E.push(y),y=this.I(y);let R=0;for(let H=0;H<E.length&&H<this.b;H++)R+=this.s.getHeight(E[H]);return R}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const E=this.validateStickySettings(s);this.b!==E.stickyScrollMaxItemCount&&(this.b=E.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let E=7;return typeof s.stickyScrollMaxItemCount=="number"&&(E=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:E}}}class se{constructor(s,E,y,R,H,X){this.g=E,this.j=y,this.k=R,this.m=H,this.o=X,this.c=[],this.d=new d.$Tc,this.a=(0,n.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const U=(0,n.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(U),this.f=new fe(this.a,E),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(E=>E.node===s)}setState(s){const E=!!this.b&&this.b.count>0,y=!!s&&s.count>0;if(!E&&!y||E&&y&&this.b.equal(s))return;if(E!==y&&this.s(y),!y){this.b=void 0,this.c=[],this.d.clear();return}const R=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${R.position}px`;else{this.d.clear();const H=Array(s.count);for(let X=s.count-1;X>=0;X--){const U=s.stickyNodes[X],{element:oe,disposable:we}=this.p(U,X,s.count);H[X]=oe,this.a.appendChild(oe),this.d.add(we)}this.f.updateElements(H,s),this.c=H}this.b=s,this.a.style.height=`${R.position+R.height}px`}p(s,E,y){const R=s.startIndex,H=document.createElement("div");H.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(H.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(H.style.lineHeight=`${s.height}px`),H.classList.add("monaco-tree-sticky-row"),H.classList.add("monaco-list-row"),H.setAttribute("data-index",`${R}`),H.setAttribute("data-parity",R%2===0?"even":"odd"),H.setAttribute("id",this.g.getElementID(R));const X=this.q(H,s.node.element,E,y),U=this.m.getTemplateId(s.node),oe=this.k.find(ke=>ke.templateId===U);if(!oe)throw new Error(`No renderer found for template id ${U}`);let we=s.node;we===this.j.getNode(this.j.getNodeLocation(s.node))&&(we=new Proxy(s.node,{}));const me=oe.renderTemplate(H);oe.renderElement(we,s.startIndex,me,s.height);const Ie=(0,d.$Sc)(()=>{X.dispose(),oe.disposeElement(we,s.startIndex,me,s.height),oe.disposeTemplate(me),H.remove()});return{element:H,disposable:Ie}}q(s,E,y,R){if(!this.o)return d.$Uc.None;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(E,y,R))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(E,y))),this.o.getRole&&s.setAttribute("role",this.o.getRole(E)??"treeitem");const H=this.o.getAriaLabel(E),X=H&&typeof H!="string"?H:(0,P.constObservable)(H),U=(0,P.autorun)(we=>{const me=we.readObservable(X);me?s.setAttribute("aria-label",me):s.removeAttribute("aria-label")});typeof H=="string"||H&&s.setAttribute("aria-label",H.get());const oe=this.o.getAriaLevel&&this.o.getAriaLevel(E);return typeof oe=="number"&&s.setAttribute("aria-level",`${oe}`),s.setAttribute("aria-selected",String(!1)),U}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class fe extends d.$Uc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,E){super(),this.s=s,this.t=E,this.a=-1,this.b=[],this.f=new w.$7d,this.onDidChangeHasFocus=this.f.event,this.g=new w.$7d,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(y=>this.w(y))),this.B(this.t.onMouseDown(y=>this.y(y))),this.B(this.t.onContextMenu(y=>this.u(y)))}u(s){const E=s.browserEvent.target;if(!(0,b.$DT)(E)&&!(0,b.$CT)(E)){this.focusedLast()&&this.t.domFocus();return}if(!(0,n.$5R)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const X=this.c.stickyNodes.findIndex(U=>U.node.element===s.element?.element);if(X===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(X);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const R=this.c.stickyNodes[this.a].node.element,H=this.b[this.a];this.g.fire({element:R,anchor:H,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const E=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([E]),this.C(E,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const E=s.browserEvent.target;!(0,b.$DT)(E)&&!(0,b.$CT)(E)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,E){if(E&&E.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(E&&E.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const y=this.a;if(this.D(),this.b=s,this.c=E,E){const R=(0,o.$nm)(y,0,E.count-1);this.F(R)}else this.m&&this.t.domFocus();this.s.tabIndex=E?0:-1}z(s){const E=this.c;if(!E)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<E.count-1)&&E.lastNodePartiallyVisible()){const y=E.stickyNodes[s];this.C(y.endIndex+1,E)}}C(s,E){const y=E.stickyNodes[E.count-1],R=E.count>1?E.stickyNodes[E.count-2]:void 0,H=this.t.getElementTop(s),X=R?R.position+R.height+y.height:y.height;this.t.scrollTop=H-X}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const E=this.a;E>=0&&this.G(this.b[E],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,E){this.I(s,E&&this.m),this.J(s,E)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,E){s.classList.toggle("focused",E)}J(s,E){s.classList.toggle("passive-focused",E)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function ve(S){let s=u.TreeMouseEventTarget.Unknown;return(0,n.$KR)(S.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=u.TreeMouseEventTarget.Twistie:(0,n.$KR)(S.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=u.TreeMouseEventTarget.Element:(0,n.$KR)(S.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=u.TreeMouseEventTarget.Filter),{browserEvent:S.browserEvent,element:S.element?S.element.element:null,target:s}}function Ne(S){const s=(0,b.$DT)(S.browserEvent.target);return{element:S.element?S.element.element:null,browserEvent:S.browserEvent,anchor:S.anchor,isStickyScroll:s}}function Ae(S,s){s(S),S.children.forEach(E=>Ae(E,s))}class Le{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,E){this.g=s,this.j=E,this.a=[],this.c=new w.$7d,this.onDidChange=this.c.event}set(s,E){!E?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,E)}k(s,E,y){if(this.a=[...s],this.b=void 0,this.d=void 0,!E){const R=this;this.c.fire({get elements(){return R.get()},browserEvent:y})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:E}){if(!this.j){const oe=this.m(),we=me=>oe.delete(me);E.forEach(me=>Ae(me,we)),this.set([...oe.values()]);return}const y=new Set,R=oe=>y.add(this.j.getId(oe.element).toString());E.forEach(oe=>Ae(oe,R));const H=new Map,X=oe=>H.set(this.j.getId(oe.element).toString(),oe);s.forEach(oe=>Ae(oe,X));const U=[];for(const oe of this.a){const we=this.j.getId(oe.element).toString();if(!y.has(we))U.push(oe);else{const Ie=H.get(we);Ie&&Ie.visible&&U.push(Ie)}}if(this.a.length>0&&U.length===0){const oe=this.g();oe&&U.push(oe)}this.k(U,!0)}m(){const s=new Set;for(const E of this.a)s.add(E);return s}}class x extends b.$IT{constructor(s,E,y){super(s),this.x=E,this.y=y}u(s){if((0,b.$ET)(s.browserEvent.target)||(0,b.$xT)(s.browserEvent.target)||(0,b.$yT)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const E=s.element;if(!E)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const y=s.browserEvent.target,R=y.classList.contains("monaco-tl-twistie")||y.classList.contains("monaco-icon-label")&&y.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,H=(0,b.$CT)(s.browserEvent.target);let X=!1;if(H?X=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?X=this.x.expandOnlyOnTwistieClick(E.element):X=!!this.x.expandOnlyOnTwistieClick,H)this.A(s,E);else{if(X&&!R&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(E.collapsible&&(!H||R)){const U=this.x.getNodeLocation(E),oe=s.browserEvent.altKey;if(this.x.setFocus([U]),this.x.toggleCollapsed(U,oe),X&&R){s.browserEvent.isHandledByList=!0;return}}H||super.u(s)}A(s,E){if((0,b.$zT)(s.browserEvent.target)||(0,b.$AT)(s.browserEvent.target))return;const y=this.y();if(!y)throw new Error("Sticky scroll controller not found");const R=this.k.indexOf(E),H=this.k.getElementTop(R),X=y.nodePositionTopBelowWidget(E);this.x.scrollTop=H-X,this.k.domFocus(),this.k.setFocus([R]),this.k.setSelection([R])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const E=s.browserEvent.target;if(!(0,b.$DT)(E)&&!(0,b.$CT)(E)){super.s(s);return}}t(s){const E=s.browserEvent.target;if(!(0,b.$DT)(E)&&!(0,b.$CT)(E)){super.t(s);return}}}class c extends b.$LT{constructor(s,E,y,R,H,X,U,oe){super(s,E,y,R,oe),this.p=H,this.s=X,this.K=U}D(s){return new x(this,s.tree,s.stickyScrollProvider)}splice(s,E,y=[]){if(super.splice(s,E,y),y.length===0)return;const R=[],H=[];let X;y.forEach((U,oe)=>{this.p.has(U)&&R.push(s+oe),this.s.has(U)&&H.push(s+oe),this.K.has(U)&&(X=s+oe)}),R.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...R])),H.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...H])),typeof X=="number"&&super.setAnchor(X)}setFocus(s,E,y=!1){super.setFocus(s,E),y||this.p.set(s.map(R=>this.element(R)),E)}setSelection(s,E,y=!1){super.setSelection(s,E),y||this.s.set(s.map(R=>this.element(R)),E)}setAnchor(s,E=!1){super.setAnchor(s),E||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var D;(function(S){S[S.Tree=0]="Tree",S[S.StickyScroll=1]="StickyScroll"})(D||(t.AbstractTreePart=D={}));class l{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return w.Event.map(this.j.onMouseClick,ve)}get onMouseDblClick(){return w.Event.filter(w.Event.map(this.j.onMouseDblClick,ve),s=>s.target!==u.TreeMouseEventTarget.Filter)}get onMouseOver(){return w.Event.map(this.j.onMouseOver,ve)}get onMouseOut(){return w.Event.map(this.j.onMouseOut,ve)}get onContextMenu(){return w.Event.any(w.Event.filter(w.Event.map(this.j.onContextMenu,Ne),s=>!s.isStickyScroll),this.B?.onContextMenu??w.Event.None)}get onTap(){return w.Event.map(this.j.onTap,ve)}get onPointer(){return w.Event.map(this.j.onPointer,ve)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return w.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??De.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??Te.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:w.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,E,y,R,H={}){this.G=s,this.H=H,this.y=new w.$ce,this.onDidChangeFindOpenState=w.Event.None,this.onDidChangeStickyScrollFocused=w.Event.None,this.D=new d.$Tc,this.E=new w.$7d,this.onWillRefilter=this.E.event,this.F=new w.$7d,this.onDidUpdateOptions=this.F.event,this.p=new I(y);const X=new w.$de,U=new w.$de,oe=this.D.add(new K(U.event)),we=new g.$Hc;this.k=R.map(Ee=>new Z(Ee,()=>this.o,X.event,oe,we,H));for(const Ee of this.k)this.D.add(Ee);let me;H.keyboardNavigationLabelProvider&&(me=new ce(this,H.keyboardNavigationLabelProvider,H.filter),H={...H,filter:me},this.D.add(me)),this.q=new Le(()=>this.j.getFocusedElements()[0],H.identityProvider),this.w=new Le(()=>this.j.getSelectedElements()[0],H.identityProvider),this.x=new Le(()=>this.j.getAnchorElement(),H.identityProvider),this.j=new c(s,E,this.p,this.k,this.q,this.w,this.x,{...V(()=>this.o,H),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,H),X.input=this.o.onDidChangeCollapseState;const Ie=w.Event.forEach(this.o.onDidSplice,Ee=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ee),this.w.onDidModelSplice(Ee)})},this.D);Ie(()=>null,null,this.D);const ke=this.D.add(new w.$7d),je=this.D.add(new i.$fh(0));if(this.D.add(w.Event.any(Ie,this.q.onDidChange,this.w.onDidChange)(()=>{je.trigger(()=>{const Ee=new Set;for(const Se of this.q.getNodes())Ee.add(Se);for(const Se of this.w.getNodes())Ee.add(Se);ke.fire([...Ee.values()])})})),U.input=ke.event,H.keyboardSupport!==!1){const Ee=w.Event.chain(this.j.onKeyDown,Se=>Se.filter(We=>!(0,b.$xT)(We.target)).map(We=>new B.$_Q(We)));w.Event.chain(Ee,Se=>Se.filter(We=>We.keyCode===15))(this.J,this,this.D),w.Event.chain(Ee,Se=>Se.filter(We=>We.keyCode===17))(this.K,this,this.D),w.Event.chain(Ee,Se=>Se.filter(We=>We.keyCode===10))(this.L,this,this.D)}if((H.findWidgetEnabled??!0)&&H.keyboardNavigationLabelProvider&&H.contextViewProvider){const Ee=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new he(this,this.o,this.j,me,H.contextViewProvider,Ee),this.A=Se=>this.z.shouldAllowFocus(Se),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=w.Event.None,this.onDidChangeFindMatchType=w.Event.None;H.enableStickyScroll&&(this.B=new G(this,this.o,this.j,this.k,this.p,H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,n.$WR)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===T.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const E of this.k)E.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===T.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new G(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=w.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const E=this.o.getListIndex(s);E!==-1&&this.j.updateWidth(E)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,n.$PR)(this.getHTMLElement())}layout(s,E){this.j.layout(s,E),(0,C.$Zf)(E)&&this.z?.layout(E)}style(s){const E=`.${this.j.domId}`,y=[];s.treeIndentGuidesStroke&&(y.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),y.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`)),s.listBackground&&(y.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${s.listBackground}; }`),y.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${s.listBackground}; }`)),s.listFocusForeground&&(y.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),y.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const R=(0,n.$uS)(s.listFocusAndSelectionOutline,(0,n.$uS)(s.listSelectionOutline,s.listFocusOutline??""));R&&(y.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${R}; outline-offset: -1px;}`),y.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&(y.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),y.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),y.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),y.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),y.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=y.join(`
`),this.j.style(s)}getParentElement(s){const E=this.o.getParentNodeLocation(s);return this.o.getNode(E).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,E=!1){return this.o.setCollapsed(s,!0,E)}expand(s,E=!1){return this.o.setCollapsed(s,!1,E)}toggleCollapsed(s,E=!1){return this.o.setCollapsed(s,void 0,E)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,E){return this.o.setCollapsible(s,E)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const E=this.o.getNode(s);this.x.set([E]);const y=this.o.getListIndex(s);y>-1&&this.j.setAnchor(y,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,E){this.y.bufferEvents(()=>{const y=s.map(H=>this.o.getNode(H));this.w.set(y,E);const R=s.map(H=>this.o.getListIndex(H)).filter(H=>H>-1);this.j.setSelection(R,E,!0)})}getSelection(){return this.w.get()}setFocus(s,E){this.y.bufferEvents(()=>{const y=s.map(H=>this.o.getNode(H));this.q.set(y,E);const R=s.map(H=>this.o.getListIndex(H)).filter(H=>H>-1);this.j.setFocus(R,E,!0)})}focusNext(s=1,E=!1,y,R=(0,n.$5R)(y)&&y.altKey?void 0:this.A){this.j.focusNext(s,E,y,R)}focusPrevious(s=1,E=!1,y,R=(0,n.$5R)(y)&&y.altKey?void 0:this.A){this.j.focusPrevious(s,E,y,R)}focusNextPage(s,E=(0,n.$5R)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,E)}focusPreviousPage(s,E=(0,n.$5R)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,E,()=>this.B?.height??0)}focusLast(s,E=(0,n.$5R)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,E)}focusFirst(s,E=(0,n.$5R)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,E)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,E){this.o.expandTo(s);const y=this.o.getListIndex(s);if(y!==-1)if(!this.B)this.j.reveal(y,E);else{const R=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal(y,E,R)}}getRelativeTop(s){const E=this.o.getListIndex(s);if(E===-1)return null;const y=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(E,y?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new u.$oV(this.G,"Can't get tree view state without an identity provider");const E=X=>s.getId(X).toString(),y=j.empty(this.scrollTop);for(const X of this.getFocus())y.focus.add(E(X));for(const X of this.getSelection())y.selection.add(E(X));const R=this.o.getNode(),H=[R];for(;H.length>0;){const X=H.shift();X!==R&&X.collapsible&&(y.expanded[E(X.element)]=X.collapsed?0:1),H.push(...X.children)}return y}J(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const y=E[0],R=this.o.getNodeLocation(y);if(!this.o.setCollapsed(R,!0)){const X=this.o.getParentNodeLocation(R);if(!X)return;const U=this.o.getListIndex(X);this.j.reveal(U),this.j.setFocus([U])}}K(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const y=E[0],R=this.o.getNodeLocation(y);if(!this.o.setCollapsed(R,!1)){if(!y.children.some(oe=>oe.visible))return;const[X]=this.j.getFocus(),U=X+1;this.j.reveal(U),this.j.setFocus([U])}}L(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const y=E[0],R=this.o.getNodeLocation(y),H=s.browserEvent.altKey;this.o.setCollapsed(R,void 0,H)}navigate(s){return new p(this.j,this.o,s)}dispose(){(0,d.$Pc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$yV=l;class p{constructor(s,E,y){this.b=s,this.c=E,y?this.a=this.c.getListIndex(y):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(ge[144],be([1,0,143,135,30,32]),function(ie,t,n,F,B,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JV=void 0;class A extends n.$yV{constructor(m,b,v,z,u,f={}){super(m,b,v,z,f),this.f=m,this.g=u,this.d=new Map,this.c=f.identityProvider}getInput(){return this.b}setInput(m,b){if(b&&!this.c)throw new B.$oV(this.f,"Can't restore tree view state without an identity provider");if(this.b=m,!m){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!b){this.m(m);return}const v=[],z=[],u=e=>{const i=this.c.getId(e).toString();return!b.expanded[i]},f=e=>{const i=this.c.getId(e.element).toString();b.focus.has(i)&&v.push(e.element),b.selection.has(i)&&z.push(e.element)};this.m(m,u,f),this.setFocus(v),this.setSelection(z),b&&typeof b.scrollTop=="number"&&(this.scrollTop=b.scrollTop)}updateChildren(m=this.b){if(typeof this.b>"u")throw new B.$oV(this.f,"Tree input not set");let b;this.c&&(b=v=>{const z=this.c.getId(v).toString(),u=this.d.get(z);if(u)return u.collapsed}),this.m(m,b)}resort(m=this.b,b=!0){this.o.resort(m===this.b?null:m,b)}refresh(m){if(m===void 0){this.j.rerender();return}this.o.rerender(m)}m(m,b,v){let z;if(this.c){const u=new Set,f=v;v=e=>{const i=this.c.getId(e.element).toString();u.add(i),this.d.set(i,e),f?.(e)},z=e=>{const i=this.c.getId(e.element).toString();u.has(i)||this.d.delete(i)}}this.o.setChildren(m===this.b?null:m,this.s(m,b).elements,{onDidCreateNode:v,onDidDeleteNode:z})}s(m,b){const v=[...this.g.getChildren(m)];return{elements:W.Iterable.map(v,u=>{const{elements:f,size:e}=this.s(u,b),i=this.g.hasChildren?this.g.hasChildren(u):void 0,r=e===0?void 0:b&&b(u);return{element:u,children:f,collapsible:i,collapsed:r}}),size:v.length}}M(m,b,v){return new F.$zV(m,b,v)}}t.$JV=A}),define(ge[77],be([1,0,12,9,42,28,31,6,4,2,63,10,7]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4h=t.ProxyChannel=t.$3h=t.$Zh=t.$Yh=t.$Xh=t.RequestInitiator=t.$Wh=t.$Th=t.$Sh=void 0,t.$Uh=L,t.$Vh=$,t.$1h=K,t.$2h=Z;var f;(function(he){he[he.Promise=100]="Promise",he[he.PromiseCancel=101]="PromiseCancel",he[he.EventListen=102]="EventListen",he[he.EventDispose=103]="EventDispose"})(f||(f={}));function e(he){switch(he){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var i;(function(he){he[he.Initialize=200]="Initialize",he[he.PromiseSuccess=201]="PromiseSuccess",he[he.PromiseError=202]="PromiseError",he[he.PromiseErrorObj=203]="PromiseErrorObj",he[he.EventFire=204]="EventFire"})(i||(i={}));function r(he){switch(he){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(he){he[he.Uninitialized=0]="Uninitialized",he[he.Idle=1]="Idle"})(h||(h={}));function g(he){let _=0;for(let le=0;;le+=7){const ae=he.read(1);if(_|=(ae.buffer[0]&127)<<le,!(ae.buffer[0]&128))return _}}const w=N(0);function a(he,_){if(_===0){he.write(w);return}let le=0;for(let J=_;J!==0;J=J>>>7)le++;const ae=B.$ue.alloc(le);for(let J=0;_!==0;J++)ae.buffer[J]=_&127,_=_>>>7,_>0&&(ae.buffer[J]|=128);he.write(ae)}class d{constructor(_){this.b=_,this.a=0}read(_){const le=this.b.slice(this.a,this.a+_);return this.a+=le.byteLength,le}}t.$Sh=d;class o{constructor(){this.a=[]}get buffer(){return B.$ue.concat(this.a)}write(_){this.a.push(_)}}t.$Th=o;var C;(function(he){he[he.Undefined=0]="Undefined",he[he.String=1]="String",he[he.Buffer=2]="Buffer",he[he.VSBuffer=3]="VSBuffer",he[he.Array=4]="Array",he[he.Object=5]="Object",he[he.Int=6]="Int"})(C||(C={}));function N(he){const _=B.$ue.alloc(1);return _.writeUInt8(he,0),_}const O={Undefined:N(C.Undefined),String:N(C.String),Buffer:N(C.Buffer),VSBuffer:N(C.VSBuffer),Array:N(C.Array),Object:N(C.Object),Uint:N(C.Int)},P=typeof Buffer<"u";function L(he,_){if(typeof _>"u")he.write(O.Undefined);else if(typeof _=="string"){const le=B.$ue.fromString(_);he.write(O.String),a(he,le.byteLength),he.write(le)}else if(P&&Buffer.isBuffer(_)){const le=B.$ue.wrap(_);he.write(O.Buffer),a(he,le.byteLength),he.write(le)}else if(_ instanceof B.$ue)he.write(O.VSBuffer),a(he,_.byteLength),he.write(_);else if(Array.isArray(_)){he.write(O.Array),a(he,_.length);for(const le of _)L(he,le)}else if(typeof _=="number"&&(_|0)===_)he.write(O.Uint),a(he,_);else{const le=B.$ue.fromString(JSON.stringify(_));he.write(O.Object),a(he,le.byteLength),he.write(le)}}function $(he){switch(he.read(1).readUInt8(0)){case C.Undefined:return;case C.String:return he.read(g(he)).toString();case C.Buffer:return he.read(g(he)).buffer;case C.VSBuffer:return he.read(g(he));case C.Array:{const le=g(he),ae=[];for(let J=0;J<le;J++)ae.push($(he));return ae}case C.Object:return JSON.parse(he.read(g(he)).toString());case C.Int:return g(he)}}class M{constructor(_,le,ae=null,J=1e3){this.h=_,this.j=le,this.k=ae,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(_,le){this.b.set(_,le),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const le=this.o([_.type]);this.k?.logOutgoing(le,0,1,r(_.type));return}case 201:case 202:case 204:case 203:{const le=this.o([_.type,_.id],_.data);this.k?.logOutgoing(le,_.id,1,r(_.type),_.data);return}}}o(_,le=void 0){const ae=new o;return L(ae,_),L(ae,le),this.p(ae.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const le=new d(_),ae=$(le),J=$(le),G=ae[0];switch(G){case 100:return this.k?.logIncoming(_.byteLength,ae[1],1,`${e(G)}: ${ae[2]}.${ae[3]}`,J),this.s({type:G,id:ae[1],channelName:ae[2],name:ae[3],arg:J});case 102:return this.k?.logIncoming(_.byteLength,ae[1],1,`${e(G)}: ${ae[2]}.${ae[3]}`,J),this.t({type:G,id:ae[1],channelName:ae[2],name:ae[3],arg:J});case 101:return this.k?.logIncoming(_.byteLength,ae[1],1,`${e(G)}`),this.u({type:G,id:ae[1]});case 103:return this.k?.logIncoming(_.byteLength,ae[1],1,`${e(G)}`),this.u({type:G,id:ae[1]})}}s(_){const le=this.b.get(_.channelName);if(!le){this.v(_);return}const ae=new W.$ee;let J;try{J=le.call(this.j,_.name,_.arg,ae.token)}catch(fe){J=Promise.reject(fe)}const G=_.id;J.then(fe=>{this.m({id:G,data:fe,type:201})},fe=>{fe instanceof Error?this.m({id:G,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:G,data:fe,type:203})}).finally(()=>{se.dispose(),this.d.delete(_.id)});const se=(0,b.$Sc)(()=>ae.cancel());this.d.set(_.id,se)}t(_){const le=this.b.get(_.channelName);if(!le){this.v(_);return}const ae=_.id,G=le.listen(this.j,_.name,_.arg)(se=>this.m({id:ae,data:se,type:204}));this.d.set(_.id,G)}u(_){const le=this.d.get(_.id);le&&(le.dispose(),this.d.delete(_.id))}v(_){let le=this.g.get(_.channelName);le||(le=[],this.g.set(_.channelName,le));const ae=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);le.push({request:_,timeoutTimer:ae})}w(_){const le=this.g.get(_);if(le){for(const ae of le)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}t.$Wh=M;var V;(function(he){he[he.LocalSide=0]="LocalSide",he[he.OtherSide=1]="OtherSide"})(V||(t.RequestInitiator=V={}));class I{constructor(_,le=null){this.l=_,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=le}getChannel(_){const le=this;return{call(ae,J,G){return le.a?Promise.reject(new k.$5):le.m(_,ae,J,G)},listen(ae,J){return le.a?m.Event.None:le.o(_,ae,J)}}}m(_,le,ae,J=W.CancellationToken.None){const G=this.g++,fe={id:G,type:100,channelName:_,name:le,arg:ae};if(J.isCancellationRequested)return Promise.reject(new k.$5);let ve;return new Promise((Ae,Le)=>{if(J.isCancellationRequested)return Le(new k.$5);const x=()=>{const p=S=>{switch(S.type){case 201:this.f.delete(G),Ae(S.data);break;case 202:{this.f.delete(G);const s=new Error(S.data.message);s.stack=Array.isArray(S.data.stack)?S.data.stack.join(`
`):S.data.stack,s.name=S.data.name,Le(s);break}case 203:this.f.delete(G),Le(S.data);break}};this.f.set(G,p),this.p(fe)};let c=null;this.b===h.Idle?x():(c=(0,F.$8g)(p=>this.u()),c.then(()=>{c=null,x()}));const D=()=>{c?(c.cancel(),c=null):this.p({id:G,type:101}),Le(new k.$5)},l=J.onCancellationRequested(D);ve=(0,b.$Rc)((0,b.$Sc)(D),l),this.d.add(ve)}).finally(()=>{ve.dispose(),this.d.delete(ve)})}o(_,le,ae){const J=this.g++,se={id:J,type:102,channelName:_,name:le,arg:ae};let fe=null;const ve=new m.$7d({onWillAddFirstListener:()=>{fe=(0,F.$8g)(Ae=>this.u()),fe.then(()=>{fe=null,this.d.add(ve),this.p(se)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(ve),this.p({id:J,type:103}))}}),Ne=Ae=>ve.fire(Ae.data);return this.f.set(J,Ne),ve.event}p(_){switch(_.type){case 100:case 102:{const le=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(le,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const le=this.q([_.type,_.id]);this.j?.logOutgoing(le,_.id,0,e(_.type));return}}}q(_,le=void 0){const ae=new o;return L(ae,_),L(ae,le),this.r(ae.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const le=new d(_),ae=$(le),J=$(le),G=ae[0];switch(G){case 200:return this.j?.logIncoming(_.byteLength,0,0,r(G)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,ae[1],0,r(G),J),this.t({type:ae[0],id:ae[1],data:J})}}t(_){if(_.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}t.$Xh=I,Ze([A.$Mh],I.prototype,"onDidInitializePromise",null);class j{get connections(){const _=[];return this.f.forEach(le=>_.push(le)),_}constructor(_,le,ae){this.a=new Map,this.f=new Set,this.g=new m.$7d,this.onDidAddConnection=this.g.event,this.h=new m.$7d,this.onDidRemoveConnection=this.h.event,this.j=new b.$Tc,this.j.add(_(({protocol:J,onDidClientDisconnect:G})=>{const se=m.Event.once(J.onMessage);this.j.add(se(fe=>{const ve=new d(fe),Ne=$(ve),Ae=new M(J,Ne,le,ae),Le=new I(J,le);this.a.forEach((c,D)=>Ae.registerChannel(D,c));const x={channelServer:Ae,channelClient:Le,ctx:Ne};this.f.add(x),this.g.fire(x),this.j.add(G(()=>{Ae.dispose(),Le.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(_,le){const ae=this;return{call(J,G,se){let fe;if((0,u.$0f)(le)){const Ne=(0,n.$4b)(ae.connections.filter(le));fe=Ne?Promise.resolve(Ne):m.Event.toPromise(m.Event.filter(ae.onDidAddConnection,le))}else fe=le.routeCall(ae,J,G);const ve=fe.then(Ne=>Ne.channelClient.getChannel(_));return K(ve).call(J,G,se)},listen(J,G){if((0,u.$0f)(le))return ae.k(_,le,J,G);const se=le.routeEvent(ae,J,G).then(fe=>fe.channelClient.getChannel(_));return K(se).listen(J,G)}}}k(_,le,ae,J){const G=this;let se;const fe=new m.$7d({onWillAddFirstListener:()=>{se=new b.$Tc;const ve=new m.$ae,Ne=new Map,Ae=x=>{const D=x.channelClient.getChannel(_).listen(ae,J),l=ve.add(D);Ne.set(x,l)},Le=x=>{const c=Ne.get(x);c&&(c.dispose(),Ne.delete(x))};G.connections.filter(le).forEach(Ae),m.Event.filter(G.onDidAddConnection,le)(Ae,void 0,se),G.onDidRemoveConnection(Le,void 0,se),ve.event(fe.fire,fe,se),se.add(ve)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return fe.event}registerChannel(_,le){this.a.set(_,le);for(const ae of this.f)ae.channelServer.registerChannel(_,le)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Yh=j;class T{constructor(_,le,ae=null){const J=new o;L(J,le),_.send(J.buffer),this.a=new I(_,ae),this.d=new M(_,le,ae)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,le){this.d.registerChannel(_,le)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Zh=T;function K(he){return{call(_,le,ae){return he.then(J=>J.call(_,le,ae))},listen(_,le){const ae=new m.$de;return he.then(J=>ae.input=J.listen(_,le)),ae.event}}}function Z(he){let _=!1;return{call(le,ae,J){return _?he.call(le,ae,J):(0,F.$jh)(0).then(()=>_=!0).then(()=>he.call(le,ae,J))},listen(le,ae){if(_)return he.listen(le,ae);const J=new m.$de;return(0,F.$jh)(0).then(()=>_=!0).then(()=>J.input=he.listen(le,ae)),J.event}}}class ce{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const le of _.connections)if(await Promise.resolve(this.a(le.ctx)))return Promise.resolve(le);return await m.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$3h=ce;var re;(function(he){function _(G,se,fe){const ve=G,Ne=fe&&fe.disableMarshalling,Ae=new Map;for(const Le in ve)ae(Le)&&Ae.set(Le,m.Event.buffer(ve[Le],!0,void 0,se));return new class{listen(Le,x,c){const D=Ae.get(x);if(D)return D;const l=ve[x];if(typeof l=="function"){if(J(x))return l.call(ve,c);if(ae(x))return Ae.set(x,m.Event.buffer(ve[x],!0,void 0,se)),Ae.get(x)}throw new k.$bb(`Event not found: ${x}`)}call(Le,x,c){const D=ve[x];if(typeof D=="function"){if(!Ne&&Array.isArray(c))for(let p=0;p<c.length;p++)c[p]=(0,v.$Rh)(c[p]);let l=D.apply(ve,c);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new k.$bb(`Method not found: ${x}`)}}}he.fromService=_;function le(G,se){const fe=se&&se.disableMarshalling;return new Proxy({},{get(ve,Ne){if(typeof Ne=="string")return se?.properties?.has(Ne)?se.properties.get(Ne):J(Ne)?function(Ae){return G.listen(Ne,Ae)}:ae(Ne)?G.listen(Ne):async function(...Ae){let Le;se&&!(0,u.$5f)(se.context)?Le=[se.context,...Ae]:Le=Ae;const x=await G.call(Ne,Le);return fe?x:(0,v.$Rh)(x)};throw new k.$bb(`Property not found: ${String(Ne)}`)}})}he.toService=le;function ae(G){return G[0]==="o"&&G[1]==="n"&&z.$kf(G.charCodeAt(2))}function J(G){return/^onDynamic/.test(G)&&z.$kf(G.charCodeAt(9))}})(re||(t.ProxyChannel=re={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $e(he){if(Array.isArray(he))return he;if(he&&typeof he=="object"&&typeof he.toString=="function"){const _=he.toString();if(_!=="[object Object]")return _}return he}function De(he){return Array.isArray(he)?he.map($e):$e(he)}function Te(he,_,le,ae,J,G,se){se=De(se);const fe=te[J],ve=fe[ae%fe.length];let Ne=[`%c[${he}]%c[${String(_).padStart(7," ")}]%c[len: ${String(le).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(G)?(Ne=Ne.concat(se),Ne.push(")")):Ne.push(se),console.log.apply(console,Ne)}class Pe{constructor(_,le){this.d=_,this.f=le,this.a=0,this.b=0}logOutgoing(_,le,ae,J,G){this.b+=_,Te(this.d,this.b,_,le,ae,J,G)}logIncoming(_,le,ae,J,G){this.a+=_,Te(this.f,this.a,_,le,ae,J,G)}}t.$4h=Pe}),define(ge[145],be([1,0,42,4,77,102,34]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jW=void 0;class k extends B.$Zh{static f(){const b=F.Event.fromNodeEventEmitter(A.$O,"vscode:message",(v,z)=>n.$ue.wrap(z));return A.$O.send("vscode:hello"),new W.$fW(A.$O,b)}constructor(b){const v=k.f();super(v,b),this.b=v}dispose(){this.b.disconnect(),super.dispose()}}t.$jW=k}),define(ge[146],be([13,11]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(ge[147],be([13,11]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[50],be([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hi=t._util=void 0,t.$ii=B,t.$ji=W;var n;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function k(m){return m[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=k})(n||(t._util=n={})),t.$hi=B("instantiationService");function F(A,k,m){k[n.DI_TARGET]===k?k[n.DI_DEPENDENCIES].push({id:A,index:m}):(k[n.DI_DEPENDENCIES]=[{id:A,index:m}],k[n.DI_TARGET]=k)}function B(A){if(n.serviceIds.has(A))return n.serviceIds.get(A);const k=function(m,b,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(k,m,v)};return k.toString=()=>A,n.serviceIds.set(A,k),k}function W(A){return A}}),define(ge[148],be([1,0,50]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4m=t.$2m=t.ID=void 0,t.$3m=F,t.ID="diagnosticsService",t.$2m=(0,n.$ii)(t.ID);function F(W){return!!W.hostName&&!!W.errorMessage}class B{async getPerformanceInfo(A,k){return{}}async getSystemInfo(A,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,k){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}t.$4m=B}),define(ge[149],be([1,0,99,25,10,7,16,146,50,5,35,23]),function(ie,t,n,F,B,W,A,k,m,b,v,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kl=t.$hl=t.FileKind=t.$gl=t.$fl=t.$el=t.$dl=t.$cl=t.$bl=t.$al=t.FileOperationResult=t.$_k=t.$$k=t.$0k=t.$8k=t.FileChangeType=t.$7k=t.FileOperation=t.$1k=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$Ok=void 0,t.$Pk=u,t.$Qk=i,t.$Rk=h,t.$Sk=g,t.$Tk=w,t.$Uk=a,t.$Vk=d,t.$Wk=o,t.$Xk=C,t.$Yk=N,t.$Zk=O,t.$2k=$,t.$3k=M,t.$4k=V,t.$5k=I,t.$6k=j,t.$9k=re,t.$il=he,t.$jl=_,t.$ll=ae,t.$Ok=(0,m.$ii)("fileService");function u(J){return J.create===!0}var f;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(f||(t.FileType=f={}));var e;(function(J){J[J.Readonly=1]="Readonly",J[J.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function i(J){const G=J;return!!G&&typeof G.onDidChange=="function"}var r;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileAtomicWrite=32768]="FileAtomicWrite",J[J.FileAtomicDelete=65536]="FileAtomicDelete",J[J.FileClone=131072]="FileClone"})(r||(t.FileSystemProviderCapabilities=r={}));function h(J){return!!(J.capabilities&2)}function g(J){return!!(J.capabilities&8)}function w(J){return!!(J.capabilities&131072)}function a(J){return!!(J.capabilities&4)}function d(J){return!!(J.capabilities&16)}function o(J){return h(J)?!!(J.capabilities&16384):!1}function C(J){return h(J)?!!(J.capabilities&32768):!1}function N(J){return!!(J.capabilities&65536)}function O(J){return!!(J.capabilities&2048)}var P;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsStorageQuota="EntryExceedsStorageQuota",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(P||(t.FileSystemProviderErrorCode=P={}));class L extends Error{static create(G,se){const fe=new L(G.toString(),se);return V(fe,se),fe}constructor(G,se){super(G),this.code=se}}t.$1k=L;function $(J,G){return L.create(J,G)}function M(J){return J||$((0,k.localize)(0,null),P.Unknown)}function V(J,G){return J.name=G?`${G} (FileSystemError)`:"FileSystemError",J}function I(J){if(!J)return P.Unknown;if(J instanceof L)return J.code;const G=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!G)return P.Unknown;switch(G[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}function j(J){if(J instanceof te)return J.fileOperationResult;switch(I(J)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 9;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileTooLarge:return 7;default:return 10}}var T;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(T||(t.FileOperation=T={}));class K{constructor(G,se,fe){this.resource=G,this.operation=se,this.target=fe}isOperation(G){return this.operation===G}}t.$7k=K;var Z;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(Z||(t.FileChangeType=Z={}));class ce{static{this.a=null}constructor(G,se){this.c=se,this.b=void 0,this.d=new z.$V(()=>{const fe=n.$oi.forUris(()=>this.c);return fe.fill(this.rawAdded.map(ve=>[ve,!0])),fe}),this.f=new z.$V(()=>{const fe=n.$oi.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(ve=>[ve,!0])),fe}),this.g=new z.$V(()=>{const fe=n.$oi.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(ve=>[ve,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of G){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==ce.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=ce.a):this.b!==void 0&&(this.b=ce.a))}}contains(G,...se){return this.h(G,{includeChildren:!1},...se)}affects(G,...se){return this.h(G,{includeChildren:!0},...se)}h(G,se,...fe){if(!G)return!1;const ve=fe.length>0;return!!((!ve||fe.includes(1))&&(this.d.value.get(G)||se.includeChildren&&this.d.value.findSuperstr(G))||(!ve||fe.includes(0))&&(this.f.value.get(G)||se.includeChildren&&this.f.value.findSuperstr(G))||(!ve||fe.includes(2))&&(this.g.value.findSubstr(G)||se.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$8k=ce;function re(J,G,se){return!J||!G||J===G||G.length>J.length?!1:(G.charAt(G.length-1)!==F.sep&&(G+=F.sep),se?(0,B.$mf)(J,G):J.indexOf(G)===0)}class te extends Error{constructor(G,se,fe){super(G),this.fileOperationResult=se,this.options=fe}}t.$0k=te;class $e extends te{constructor(G,se,fe,ve){super(G,se,ve),this.fileOperationResult=se,this.size=fe}}t.$$k=$e;class De extends te{constructor(G,se,fe){super(G,2,fe),this.stat=se}}t.$_k=De;var Te;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Te||(t.FileOperationResult=Te={})),t.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$cl="files.associations",t.$dl="files.exclude",t.$el="files.readonlyInclude",t.$fl="files.readonlyExclude",t.$gl="files.readonlyFromPermissions";var Pe;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(Pe||(t.FileKind=Pe={})),t.$hl="";function he(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}async function _(J,G){if(!G.hasProvider(A.URI.from({scheme:J.scheme})))return new Promise(se=>{const fe=G.onDidChangeFileSystemProviderRegistrations(ve=>{ve.scheme===J.scheme&&ve.added&&(fe.dispose(),se())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(G){return(0,W.$Zf)(G)||(G=0),G<le.KB?(0,k.localize)(1,null,G.toFixed(0)):G<le.MB?(0,k.localize)(2,null,(G/le.KB).toFixed(2)):G<le.GB?(0,k.localize)(3,null,(G/le.MB).toFixed(2)):G<le.TB?(0,k.localize)(4,null,(G/le.GB).toFixed(2)):(0,k.localize)(5,null,(G/le.TB).toFixed(2))}}t.$kl=le;function ae(J){const G=typeof J=="string"||J?.scheme===v.Schemas.vscodeRemote;return typeof J!="string"&&J?.scheme===v.Schemas.file?1024*le.MB:G?10*le.MB:b.$o?50*le.MB:1024*le.MB}}),define(ge[150],be([1,0,50]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_bc=t.$$bc=void 0,t.$$bc=(0,n.$ii)("mainProcessService");class F{constructor(W,A){this.a=W,this.b=A}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,A){this.a.registerChannel(W,A)}}t.$_bc=F}),define(ge[151],be([1,0,2,145]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$acc=void 0;class B extends n.$Uc{constructor(A){super(),this.a=this.B(new F.$jW(`window:${A}`))}getChannel(A){return this.a.getChannel(A)}registerChannel(A,k){this.a.registerChannel(A,k)}}t.$acc=B});var Ei=this&&this.__param||function(ie,t){return function(n,F){t(n,F,ie)}};define(ge[152],be([1,0,77,150]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ecc=void 0;let B=class{constructor(A,k){return this.windowId=A,n.ProxyChannel.toService(k.getChannel("nativeHost"),{context:A,properties:(()=>{const m=new Map;return m.set("windowId",A),m})()})}};t.$ecc=B,t.$ecc=B=Ze([Ei(1,F.$$bc)],B)}),define(ge[78],be([1,0,37,7]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1n=void 0;class B{constructor(){this.a=new Map}add(A,k){n.ok(F.$Vf(A)),n.ok(F.$Xf(k)),n.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,k)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$1n=new B}),define(ge[153],be([1,0,4,78]),function(ie,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2n=void 0,t.$2n={JSONContribution:"base.contributions.json"};function B(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class W{constructor(){this.b=new n.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,b){this.a[B(m)]=b,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const A=new W;F.$1n.add(t.$2n.JSONContribution,A)}),define(ge[154],be([1,0,9,18,44,19,4,7,16,147,153,78]),function(ie,t,n,F,B,W,A,k,m,b,v,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2w=t.$1w=t.$Zw=t.$Yw=t.$Xw=t.$Ww=t.IconFontDefinition=t.IconContribution=t.$Tw=void 0,t.$Uw=r,t.$Vw=h,t.$Tw={IconContribution:"base.contributions.icons"};var u;(function(d){function o(C,N){let O=C.defaults;for(;W.ThemeIcon.isThemeIcon(O);){const P=i.getIcon(O.id);if(!P)return;O=P.defaults}return O}d.getDefinition=o})(u||(t.IconContribution=u={}));var f;(function(d){function o(N){return{weight:N.weight,style:N.style,src:N.src.map(O=>({format:O.format,location:O.location.toString()}))}}d.toJSONObject=o;function C(N){const O=P=>(0,k.$Vf)(P)?P:void 0;if(N&&Array.isArray(N.src)&&N.src.every(P=>(0,k.$Vf)(P.format)&&(0,k.$Vf)(P.location)))return{weight:O(N.weight),style:O(N.style),src:N.src.map(P=>({format:P.format,location:m.URI.parse(P.location)}))}}d.fromJSONObject=C})(f||(t.IconFontDefinition=f={}));class e{constructor(){this.a=new A.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${W.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,C,N,O){const P=this.b[o];if(P){if(N&&!P.description){P.description=N,this.d.properties[o].markdownDescription=`${N} $(${o})`;const M=this.e.enum.indexOf(o);M!==-1&&(this.e.enumDescriptions[M]=N),this.a.fire()}return P}const L={id:o,description:N,defaults:C,deprecationMessage:O};this.b[o]=L;const $={$ref:"#/definitions/icons"};return O&&($.deprecationMessage=O),N&&($.markdownDescription=`${N}: $(${o})`),this.d.properties[o]=$,this.e.enum.push(o),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const C=this.e.enum.indexOf(o);C!==-1&&(this.e.enum.splice(C,1),this.e.enumDescriptions.splice(C,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,C){const N=this.f[o];return N||(this.f[o]=C,this.a.fire(),C)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(P,L)=>P.id.localeCompare(L.id),C=P=>{for(;W.ThemeIcon.isThemeIcon(P.defaults);)P=this.b[P.defaults.id];return`codicon codicon-${P?P.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const O=Object.keys(this.b).map(P=>this.b[P]);for(const P of O.filter(L=>!!L.description).sort(o))N.push(`|<i class="${C(P)}"></i>|${P.id}|${W.ThemeIcon.isThemeIcon(P.defaults)?P.defaults.id:P.id}|${P.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const P of O.filter(L=>!W.ThemeIcon.isThemeIcon(L.defaults)).sort(o))N.push(`|<i class="${C(P)}"></i>|${P.id}|`);return N.join(`
`)}}const i=new e;z.$1n.add(t.$Tw.IconContribution,i);function r(d,o,C,N){return i.registerIcon(d,o,C,N)}function h(){return i}function g(){const d=(0,B.$Dj)();for(const o in d){const C="\\"+d[o].toString(16);i.registerIcon(o,{fontCharacter:C})}}g(),t.$Ww="vscode://schemas/icons";const w=z.$1n.as(v.$2n.JSONContribution);w.registerSchema(t.$Ww,i.getIconSchema());const a=new n.$uh(()=>w.notifySchemaChanged(t.$Ww),200);i.onDidChange(()=>{a.isScheduled()||a.schedule()}),t.$Xw=r("widget-close",F.$Hj.close,(0,b.localize)(2,null)),t.$Yw=r("goto-previous-location",F.$Hj.arrowUp,(0,b.localize)(3,null)),t.$Zw=r("goto-next-location",F.$Hj.arrowDown,(0,b.localize)(4,null)),t.$1w=W.ThemeIcon.modify(F.$Hj.sync,"spin"),t.$2w=W.ThemeIcon.modify(F.$Hj.loading,"spin")}),define(ge[155],be([1,0,3,4,2,19,154]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GIb=void 0,t.$FIb=k;function k(b){const v=new B.$Tc,z=v.add(new F.$7d),u=(0,A.$Vw)();return v.add(u.onDidChange(()=>z.fire())),b&&v.add(b.onDidProductIconThemeChange(()=>z.fire())),{dispose:()=>v.dispose(),onDidChange:z.event,getCSS(){const f=b?b.getProductIconTheme():new m,e={},i=h=>{const g=f.getIcon(h);if(!g)return;const w=g.font;return w?(e[w.id]=w.definition,`.codicon-${h.id}:before { content: '${g.fontCharacter}'; font-family: ${(0,n.$tS)(w.id)}; }`):`.codicon-${h.id}:before { content: '${g.fontCharacter}'; }`},r=[];for(const h of u.getIcons()){const g=i(h);g&&r.push(g)}for(const h in e){const g=e[h],w=g.weight?`font-weight: ${g.weight};`:"",a=g.style?`font-style: ${g.style};`:"",d=g.src.map(o=>`${(0,n.$sS)(o.location)} format('${o.format}')`).join(", ");r.push(`@font-face { src: ${d}; font-family: ${(0,n.$tS)(h)};${w}${a} font-display: block; }`)}return r.join(`
`)}}}class m{getIcon(v){const z=(0,A.$Vw)();let u=v.defaults;for(;W.ThemeIcon.isThemeIcon(u);){const f=z.getIcon(u.id);if(!f)return;u=f.defaults}return u}}t.$GIb=m}),define(ge[156],be([1,0,5]),function(ie,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$dD=void 0,t.$eD=F,t.$fD=B,t.$gD=W,t.$hD=A,t.$iD=k,t.$jD=z,t.$kD=u,t.$lD=f,t.$mD=e,t.$nD=i,t.$oD=r,t.$dD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function F(h){return typeof h.parentId=="number"}function B(h){return!!h.workspaceUri}function W(h){return!!h.folderUri}function A(h){return!!h.fileUri}function k(h){const g=u(h),w=h.getValue("window.menuBarVisibility");return w==="default"||g&&w==="compact"||n.$j&&n.$m?"classic":w}var m;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(m||(t.TitleBarSetting=m={}));var b;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(b||(t.TitlebarStyle=b={}));var v;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(v||(t.CustomTitleBarVisibility=v={}));function z(h,g){return!0}function u(h,g){return g||(g=f(h)),g==="native"}function f(h){if(n.$o)return"custom";const g=h.getValue("window");if(g){if(n.$j&&g.nativeTabs===!0||n.$j&&g.nativeFullScreen===!1)return"native";const d=g.titleBarStyle;if(d==="native"||d==="custom")return d}return n.$k?"native":"custom"}function e(h){return!(!n.$i||n.$o||u(h))}function i(h){const g=h.getValue("window");return!g||typeof g.nativeFullScreen!="boolean"||g.nativeTabs?!0:g.nativeFullScreen!==!1}function r(h=0){return Math.pow(1.2,h)}}),define(ge[157],be([1,0,17,3,22,34,156]),function(ie,t,n,F,B,W,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hcc=t.$gcc=t.ApplyZoomTarget=void 0,t.$icc=m,t.$jcc=v,t.$kcc=z;var k;(function(u){u[u.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",u[u.ALL_WINDOWS=2]="ALL_WINDOWS"})(k||(t.ApplyZoomTarget=k={})),t.$gcc=8,t.$hcc=-8;function m(u,f){u=Math.min(Math.max(u,t.$hcc),t.$gcc);const e=[];f===k.ACTIVE_WINDOW?e.push((0,F.$TR)()):f===k.ALL_WINDOWS?e.push(...Array.from((0,F.getWindows)()).map(({window:i})=>i)):e.push(f);for(const i of e)b(i)?.webFrame?.setZoomLevel(u),(0,n.$QQ)((0,A.$oD)(u),i),(0,n.$MQ)(u,i)}function b(u){if(u===B.$IQ)return{ipcRenderer:W.$O,webFrame:W.$Q};{const f=u;if(f?.vscode?.ipcRenderer&&f?.vscode?.webFrame)return f.vscode}}function v(u){m((0,n.$NQ)(typeof u=="number"?(0,F.$TR)():u)+1,u)}function z(u){m((0,n.$NQ)(typeof u=="number"?(0,F.$TR)():u)-1,u)}}),define(ge[158],be([1,0,11,3,144,9,103,34,148,149,151,152,155,157,15,22,116,107]),function(ie,t,n,F,B,W,A,k,m,b,v,z,u,f,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=M;const r=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,h=/\s--inspect-port=(?<port>\d+)/;class g{getHeight(I){return 22}getTemplateId(I){return P(I)?"process":N(I)?"machine":(0,m.$3m)(I)?"error":O(I)?"header":""}}class w{hasChildren(I){return(0,m.$3m)(I)?!1:P(I)?!!I.children?.length:!0}getChildren(I){return P(I)?I.children?I.children:[]:(0,m.$3m)(I)?[]:O(I)?I.processRoots.length>1?I.processRoots:[I.processRoots[0].rootProcess]:N(I)?[I.rootProcess]:[I.processes]}}class a{constructor(){this.templateId="header"}renderTemplate(I){const j=(0,F.$cS)(I,(0,F.$)(".row")),T=(0,F.$cS)(j,(0,F.$)(".nameLabel")),K=(0,F.$cS)(j,(0,F.$)(".cpu")),Z=(0,F.$cS)(j,(0,F.$)(".memory")),ce=(0,F.$cS)(j,(0,F.$)(".pid"));return{name:T,CPU:K,memory:Z,PID:ce}}renderElement(I,j,T,K){T.name.textContent=(0,n.localize)(0,null),T.CPU.textContent=(0,n.localize)(1,null),T.PID.textContent=(0,n.localize)(2,null),T.memory.textContent=(0,n.localize)(3,null)}disposeTemplate(I){}}class d{constructor(){this.templateId="machine"}renderTemplate(I){const j=Object.create(null),T=(0,F.$cS)(I,(0,F.$)(".row"));return j.name=(0,F.$cS)(T,(0,F.$)(".nameLabel")),j}renderElement(I,j,T,K){T.name.textContent=I.element.name}disposeTemplate(I){}}class o{constructor(){this.templateId="error"}renderTemplate(I){const j=Object.create(null),T=(0,F.$cS)(I,(0,F.$)(".row"));return j.name=(0,F.$cS)(T,(0,F.$)(".nameLabel")),j}renderElement(I,j,T,K){T.name.textContent=I.element.errorMessage}disposeTemplate(I){}}class C{constructor(I,j,T){this.a=I,this.b=j,this.c=T,this.templateId="process"}renderTemplate(I){const j=(0,F.$cS)(I,(0,F.$)(".row")),T=(0,F.$cS)(j,(0,F.$)(".nameLabel")),K=(0,F.$cS)(j,(0,F.$)(".cpu")),Z=(0,F.$cS)(j,(0,F.$)(".memory")),ce=(0,F.$cS)(j,(0,F.$)(".pid"));return{name:T,CPU:K,PID:ce,memory:Z}}renderElement(I,j,T,K){const{element:Z}=I,ce=Z.pid.toFixed(0);let re=Z.name;this.c.has(Z.pid)&&(re=this.c.get(Z.pid)),T.name.textContent=re,T.name.title=Z.cmd,T.CPU.textContent=Z.load.toFixed(0),T.PID.textContent=ce,T.PID.parentElement.id=`pid-${ce}`;const te=this.a==="win32"?Z.mem:this.b*(Z.mem/100);T.memory.textContent=(te/b.$kl.MB).toFixed(0)}disposeTemplate(I){}}function N(V){return!!V.name&&!!V.rootProcess}function O(V){return!!V.processRoots}function P(V){return!!V.pid}class L{constructor(I,j){this.f=j,this.b=new Map;const T=new v.$acc(I);this.c=new z.$ecc(I,T),this.k(j.styles),this.g(j),k.$O.on("vscode:pidToNameResponse",(K,Z)=>{this.b.clear();for(const[ce,re]of Z)this.b.set(ce,re)}),k.$O.on("vscode:listProcessesResponse",async(K,Z)=>{Z.forEach((ce,re)=>{P(ce.rootProcess)&&(ce.rootProcess.name=re===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Z}}),this.d.layout(i.$IQ.innerHeight,i.$IQ.innerWidth)):await this.h(Z),this.m(0)}),this.a=Date.now(),k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")}g(I){i.$IQ.document.onkeydown=j=>{const T=I.platform==="darwin"?j.metaKey:j.ctrlKey;T&&j.keyCode===87&&(j.stopPropagation(),j.preventDefault(),k.$O.send("vscode:closeProcessExplorer")),T&&j.keyCode===187&&(0,f.$jcc)(i.$IQ),T&&j.keyCode===189&&(0,f.$kcc)(i.$IQ)}}async h(I){const j=i.$IQ.document.getElementById("process-list");if(!j)return;const{totalmem:T}=await this.c.getOSStatistics(),K=[new C(this.f.platform,T,this.b),new a,new d,new o];this.d=new B.$JV("processExplorer",j,new g,K,new w,{identityProvider:{getId:Z=>P(Z)?Z.pid.toString():(0,m.$3m)(Z)?Z.hostName:O(Z)?"processes":N(Z)?Z.name:"header"}}),this.d.setInput({processes:{processRoots:I}}),this.d.layout(i.$IQ.innerHeight,i.$IQ.innerWidth),this.d.onKeyDown(Z=>{const ce=new e.$_Q(Z);if(ce.keyCode===35&&ce.altKey){const re=this.n();Promise.all(re.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Z=>{P(Z.element)&&this.l(Z.element,!0)}),j.style.height=`${i.$IQ.innerHeight}px`,i.$IQ.addEventListener("resize",()=>{j.style.height=`${i.$IQ.innerHeight}px`,this.d?.layout(i.$IQ.innerHeight,i.$IQ.innerWidth)})}i(I){const j=r.exec(I);return j&&j.groups.port!=="0"||I.indexOf("node ")>=0||I.indexOf("node.exe")>=0}j(I){const j={type:"node",request:"attach",name:`process ${I.pid}`};let T=r.exec(I.cmd);T?j.port=Number(T.groups.port):j.processId=String(I.pid),T=h.exec(I.cmd),T&&(j.port=Number(T.groups.port)),k.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[j]})}k(I){const j=(0,F.$WR)(),T=[];I.listFocusBackground&&(T.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${I.listFocusBackground}; }`),T.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${I.listFocusBackground}; }`)),I.listFocusForeground&&T.push(`.monaco-list:focus .monaco-list-row.focused { color: ${I.listFocusForeground}; }`),I.listActiveSelectionBackground&&(T.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${I.listActiveSelectionBackground}; }`),T.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${I.listActiveSelectionBackground}; }`)),I.listActiveSelectionForeground&&T.push(`.monaco-list:focus .monaco-list-row.selected { color: ${I.listActiveSelectionForeground}; }`),I.listHoverBackground&&T.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${I.listHoverBackground}; }`),I.listHoverForeground&&T.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${I.listHoverForeground}; }`),I.listFocusOutline&&T.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${I.listFocusOutline}; outline-offset: -1px; }`),I.listHoverOutline&&T.push(`.monaco-list-row:hover { outline: 1px dashed ${I.listHoverOutline}; outline-offset: -1px; }`),I.scrollbarShadowColor&&T.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${I.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${I.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${I.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),I.scrollbarSliderBackgroundColor&&T.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${I.scrollbarSliderBackgroundColor};
				}
			`),I.scrollbarSliderHoverBackgroundColor&&T.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${I.scrollbarSliderHoverBackgroundColor};
				}
			`),I.scrollbarSliderActiveBackgroundColor&&T.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${I.scrollbarSliderActiveBackgroundColor};
				}
			`),j.textContent=T.join(`
`),I.color&&(i.$IQ.document.body.style.color=I.color)}l(I,j){const T=[],K=Number(I.pid);j&&(T.push({accelerator:"Alt+E",label:(0,n.localize)(4,null),click:()=>{this.c.killProcess(K,"SIGTERM")}}),T.push({label:(0,n.localize)(5,null),click:()=>{this.c.killProcess(K,"SIGKILL")}}),T.push({type:"separator"})),T.push({label:(0,n.localize)(6,null),click:()=>{const Z=this.n();Z?.includes(K)||(Z.length=0,Z.push(K));const ce=Z?.map(re=>i.$IQ.document.getElementById(`pid-${re}`)).filter(re=>!!re);if(ce){const re=ce.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(re.join(`
`))}}}),T.push({label:(0,n.localize)(7,null),click:()=>{const Z=i.$IQ.document.getElementById("process-list");Z&&this.c.writeClipboardText(Z.innerText)}}),I&&j&&this.i(I.cmd)&&(T.push({type:"separator"}),T.push({label:(0,n.localize)(8,null),click:()=>{this.j(I)}})),(0,A.$bW)(T)}m(I){setTimeout(()=>{const j=Date.now(),T=I+j-this.a;this.a=j,T>1e3?(k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")):this.m(T)},200)}n(){return this.d?.getSelection()?.map(I=>{if(!(!I||!("pid"in I)))return I.pid}).filter(I=>!!I)}}function $(){const V=(0,F.$WR)();V.id="codiconStyles";const I=(0,u.$FIb)(void 0);function j(){V.textContent=I.getCSS()}const T=new W.$uh(j,0);I.onDidChange(()=>T.schedule()),T.schedule()}function M(V){const I=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";i.$IQ.document.body.classList.add(I),$(),(0,f.$icc)(V.data.zoomLevel,i.$IQ),new L(V.windowId,V.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/409da0445d397e37a790ce5d2499688955c3fcfa/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
