/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],R=0,N=se.length;R<N;R++)e[R]=le[se[R]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class R{static get(){const A=new Map,j=new Map,D=new Map,I=new Map;function P(f,h){f.has(h.detail)||f.set(h.detail,-h.timestamp)}function d(f,h){const b=f.get(h.detail);b&&(b>=0||f.set(h.detail,b+h.timestamp))}let C=[];typeof se=="function"&&typeof se.getStats=="function"&&(C=se.getStats().slice(0).sort((f,h)=>f.timestamp-h.timestamp));for(const f of C)switch(f.type){case 10:P(A,f);break;case 11:case 12:d(A,f);break;case 21:P(j,f);break;case 22:d(j,f);break;case 33:P(D,f);break;case 34:d(D,f);break;case 31:P(I,f);break;case 32:d(I,f);break}let v=0;D.forEach(f=>v+=f);function m(f){const h=[];return f.forEach((b,p)=>h.push([p,b])),h}return{amdLoad:m(A),amdInvoke:m(j),nodeRequire:m(D),nodeEval:m(I),nodeRequireTotal:v}}static toMarkdownTable(A,j){let D="";const I=[];return A.forEach((P,d)=>{I[d]=P.length}),j.forEach(P=>{P.forEach((d,C)=>{typeof d>"u"&&(d=P[C]="-");const v=d.toString().length;I[C]=Math.max(v,I[C])})}),A.forEach((P,d)=>{D+=`| ${P+" ".repeat(I[d]-P.toString().length)} `}),D+=`|
`,A.forEach((P,d)=>{D+=`| ${"-".repeat(I[d])} `}),D+=`|
`,j.forEach(P=>{P.forEach((d,C)=>{typeof d<"u"&&(D+=`| ${d+" ".repeat(I[C]-d.toString().length)} `)}),D+=`|
`}),D}}e.$U=R}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=R,e.$gb=N,e.$hb=A,e.$ib=j,e.$jb=D,e.$kb=I,e.$lb=P,e.$nb=C,e.$ob=v,e.$pb=m,e.$qb=f,e.$rb=h;function R(b,p,u){const g=N(b,p);if(g!==-1)return b[g]}function N(b,p,u=b.length-1){for(let g=u;g>=0;g--){const l=b[g];if(p(l))return g}return-1}function A(b,p){const u=j(b,p);return u===-1?void 0:b[u]}function j(b,p,u=0,g=b.length){let l=u,c=g;for(;l<c;){const $=Math.floor((l+c)/2);p(b[$])?l=$+1:c=$}return l-1}function D(b,p){const u=I(b,p);return u===b.length?void 0:b[u]}function I(b,p,u=0,g=b.length){let l=u,c=g;for(;l<c;){const $=Math.floor((l+c)/2);p(b[$])?c=$:l=$+1}return l}function P(b,p,u=0,g=b.length){const l=I(b,p,u,g);return l===b.length?-1:l}class d{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(d.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!p(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const u=j(this.e,p,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=d;function C(b,p){if(b.length===0)return;let u=b[0];for(let g=1;g<b.length;g++){const l=b[g];p(l,u)>0&&(u=l)}return u}function v(b,p){if(b.length===0)return;let u=b[0];for(let g=1;g<b.length;g++){const l=b[g];p(l,u)>=0&&(u=l)}return u}function m(b,p){return C(b,(u,g)=>-p(u,g))}function f(b,p){if(b.length===0)return-1;let u=0;for(let g=1;g<b.length;g++){const l=b[g];p(l,b[u])>0&&(u=g)}return u}function h(b,p){for(const u of b){const g=p(u);if(g!==void 0)return g}}}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=R,e.$L=N,e.$M=A,e.$N=j;function R(D,I){const P=Object.create(null);for(const d of D){const C=I(d);let v=P[C];v||(v=P[C]=[]),v.push(d)}return P}function N(D,I){const P=[],d=[];for(const C of D)I.has(C)||P.push(C);for(const C of I)D.has(C)||d.push(C);return{removed:P,added:d}}function A(D,I){const P=[],d=[];for(const[C,v]of D)I.has(C)||P.push(v);for(const[C,v]of I)D.has(C)||d.push(v);return{removed:P,added:d}}function j(D,I){const P=new Set;for(const d of I)D.has(d)&&P.add(d);return P}}),define(le[84],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=N,e.$Nh=A,e.$Oh=j;function R(D){return(I,P,d)=>{let C=null,v=null;if(typeof d.value=="function"?(C="value",v=d.value):typeof d.get=="function"&&(C="get",v=d.get),!v)throw new Error("not supported");d[C]=D(v,P)}}function N(D,I,P){let d=null,C=null;if(typeof P.value=="function"?(d="value",C=P.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(d="get",C=P.get),!C)throw new Error("not supported");const v=`$memoize$${I}`;P[d]=function(...m){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[v]}}function A(D,I,P){return R((d,C)=>{const v=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...f){this[m]||(this[m]=P?P():void 0),clearTimeout(this[v]),I&&(this[m]=I(this[m],...f),f=[this[m]]),this[v]=setTimeout(()=>{d.apply(this,f),this[m]=P?P():void 0},D)}})}function j(D,I,P){return R((d,C)=>{const v=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,f=`$throttle$lastRun$${C}`,h=`$throttle$pending$${C}`;return function(...b){if(this[m]||(this[m]=P?P():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...b)),this[h])return;const p=this[f]+D;p<=Date.now()?(this[f]=Date.now(),d.apply(this,[this[m]]),this[m]=P?P():void 0):(this[h]=!0,this[v]=setTimeout(()=>{this[h]=!1,this[f]=Date.now(),d.apply(this,[this[m]]),this[m]=P?P():void 0},p-Date.now()))}})}}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=A,e.$1=j,e.$2=D,e.$3=I,e.$4=d,e.$6=v,e.$7=m,e.$8=f,e.$0=b;class R{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=R,e.$X=new R;function N($){e.$X.setUnexpectedErrorHandler($)}function A($){if(!$||typeof $!="object")return!1;const i=$;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function j($){d($)||e.$X.onUnexpectedError($)}function D($){d($)||e.$X.onUnexpectedExternalError($)}function I($){if($ instanceof Error){const{name:i,message:o}=$,n=$.stacktrace||$.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:l.isErrorNoTelemetry($)}}return $}const P="Canceled";function d($){return $ instanceof C?!0:$ instanceof Error&&$.name===P&&$.message===P}class C extends Error{constructor(){super(P),this.name=this.message}}e.$5=C;function v(){const $=new Error(P);return $.name=$.message,$}function m($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}function f($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}class h extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=h;function b($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}class p extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=p;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const o=new l;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=l;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=A,e.$tb=j,e.$ub=D,e.$vb=I,e.$wb=P,e.$xb=d,e.$yb=C,e.$zb=v,e.$Ab=m,e.$Bb=f,e.$Cb=h,e.$Db=b,e.$Eb=p,e.top=u,e.$Gb=g,e.$Hb=c,e.$Ib=$,e.$Jb=i,e.$Kb=o,e.$Lb=n,e.$Mb=s,e.$Nb=t,e.$Ob=r,e.$Pb=a,e.$Qb=y,e.$Rb=E,e.$Sb=k,e.$Tb=S,e.$Ub=w,e.$Vb=O,e.$Wb=M,e.$Xb=T,e.$Yb=U,e.$Zb=_,e.$1b=G,e.$2b=Z,e.$3b=V,e.$4b=K,e.$5b=W,e.$6b=B,e.$7b=te,e.$8b=ce,e.$$b=L;function A(J,ee=0){return J[J.length-(1+ee)]}function j(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}function D(J,ee,x=(Q,ne)=>Q===ne){if(J===ee)return!0;if(!J||!ee||J.length!==ee.length)return!1;for(let Q=0,ne=J.length;Q<ne;Q++)if(!x(J[Q],ee[Q]))return!1;return!0}function I(J,ee){const x=J.length-1;ee<x&&(J[ee]=J[x]),J.pop()}function P(J,ee,x){return d(J.length,Q=>x(J[Q],ee))}function d(J,ee){let x=0,Q=J-1;for(;x<=Q;){const ne=(x+Q)/2|0,re=ee(ne);if(re<0)x=ne+1;else if(re>0)Q=ne-1;else return ne}return-(x+1)}function C(J,ee,x){if(J=J|0,J>=ee.length)throw new TypeError("invalid index");const Q=ee[Math.floor(ee.length*Math.random())],ne=[],re=[],ue=[];for(const de of ee){const $e=x(de,Q);$e<0?ne.push(de):$e>0?re.push(de):ue.push(de)}return J<ne.length?C(J,ne,x):J<ne.length+ue.length?ue[0]:C(J-(ne.length+ue.length),re,x)}function v(J,ee){const x=[];let Q;for(const ne of J.slice(0).sort(ee))!Q||ee(Q[0],ne)!==0?(Q=[ne],x.push(Q)):Q.push(ne);return x}function*m(J,ee){let x,Q;for(const ne of J)Q!==void 0&&ee(Q,ne)?x.push(ne):(x&&(yield x),x=[ne]),Q=ne;x&&(yield x)}function f(J,ee){for(let x=0;x<=J.length;x++)ee(x===0?void 0:J[x-1],x===J.length?void 0:J[x])}function h(J,ee){for(let x=0;x<J.length;x++)ee(x===0?void 0:J[x-1],J[x],x+1===J.length?void 0:J[x+1])}function b(J,ee,x){const Q=[];function ne(de,$e,ye){if($e===0&&ye.length===0)return;const Se=Q[Q.length-1];Se&&Se.start+Se.deleteCount===de?(Se.deleteCount+=$e,Se.toInsert.push(...ye)):Q.push({start:de,deleteCount:$e,toInsert:ye})}let re=0,ue=0;for(;;){if(re===J.length){ne(re,0,ee.slice(ue));break}if(ue===ee.length){ne(re,J.length-re,[]);break}const de=J[re],$e=ee[ue],ye=x(de,$e);ye===0?(re+=1,ue+=1):ye<0?(ne(re,1,[]),re+=1):ye>0&&(ne(re,0,[$e]),ue+=1)}return Q}function p(J,ee,x){const Q=b(J,ee,x),ne=[],re=[];for(const ue of Q)ne.push(...J.slice(ue.start,ue.start+ue.deleteCount)),re.push(...ue.toInsert);return{removed:ne,added:re}}function u(J,ee,x){if(x===0)return[];const Q=J.slice(0,x).sort(ee);return l(J,ee,Q,x,J.length),Q}function g(J,ee,x,Q,ne){return x===0?Promise.resolve([]):new Promise((re,ue)=>{(async()=>{const de=J.length,$e=J.slice(0,x).sort(ee);for(let ye=x,Se=Math.min(x+Q,de);ye<de;ye=Se,Se=Math.min(Se+Q,de)){if(ye>x&&await new Promise(Re=>setTimeout(Re)),ne&&ne.isCancellationRequested)throw new R.$5;l(J,ee,$e,ye,Se)}return $e})().then(re,ue)})}function l(J,ee,x,Q,ne){for(const re=x.length;Q<ne;Q++){const ue=J[Q];if(ee(ue,x[re-1])<0){x.pop();const de=(0,N.$kb)(x,$e=>ee(ue,$e)<0);x.splice(de,0,ue)}}}function c(J){return J.filter(ee=>!!ee)}function $(J){let ee=0;for(let x=0;x<J.length;x++)J[x]&&(J[ee]=J[x],ee+=1);J.length=ee}function i(J,ee,x){J.splice(x,0,J.splice(ee,1)[0])}function o(J){return!Array.isArray(J)||J.length===0}function n(J){return Array.isArray(J)&&J.length>0}function s(J,ee=x=>x){const x=new Set;return J.filter(Q=>{const ne=ee(Q);return x.has(ne)?!1:(x.add(ne),!0)})}function t(J){const ee=new Set;return x=>{const Q=J(x);return ee.has(Q)?!1:(ee.add(Q),!0)}}function r(J,ee){return J.length>0?J[0]:ee}function a(J,ee){return J.length>0?J[J.length-1]:ee}function y(J,ee,x=(Q,ne)=>Q===ne){let Q=0;for(let ne=0,re=Math.min(J.length,ee.length);ne<re&&x(J[ne],ee[ne]);ne++)Q++;return Q}function E(J){return[].concat(...J)}function k(J,ee){let x=typeof ee=="number"?J:0;typeof ee=="number"?x=J:(x=0,ee=J);const Q=[];if(x<=ee)for(let ne=x;ne<ee;ne++)Q.push(ne);else for(let ne=x;ne>ee;ne--)Q.push(ne);return Q}function S(J,ee,x){return J.reduce((Q,ne)=>(Q[ee(ne)]=x?x(ne):ne,Q),Object.create(null))}function w(J,ee){return J.push(ee),()=>O(J,ee)}function O(J,ee){const x=J.indexOf(ee);if(x>-1)return J.splice(x,1),ee}function M(J,ee,x){const Q=J.slice(0,ee),ne=J.slice(ee);return Q.concat(x,ne)}function T(J,ee){let x;if(typeof ee=="number"){let Q=ee;x=()=>{const ne=Math.sin(Q++)*179426549;return ne-Math.floor(ne)}}else x=Math.random;for(let Q=J.length-1;Q>0;Q-=1){const ne=Math.floor(x()*(Q+1)),re=J[Q];J[Q]=J[ne],J[ne]=re}}function U(J,ee){const x=J.indexOf(ee);x>-1&&(J.splice(x,1),J.unshift(ee))}function _(J,ee){const x=J.indexOf(ee);x>-1&&(J.splice(x,1),J.push(ee))}function G(J,ee){for(const x of ee)J.push(x)}function Z(J,ee){return Array.isArray(J)?J.map(ee):ee(J)}function V(J){return Array.isArray(J)?J:[J]}function K(J){return J[Math.floor(Math.random()*J.length)]}function W(J,ee,x){const Q=ie(J,ee),ne=J.length,re=x.length;J.length=ne+re;for(let ue=ne-1;ue>=Q;ue--)J[ue+re]=J[ue];for(let ue=0;ue<re;ue++)J[ue+Q]=x[ue]}function B(J,ee,x,Q){const ne=ie(J,ee);let re=J.splice(ne,x);return re===void 0&&(re=[]),W(J,ne,Q),re}function ie(J,ee){return ee<0?Math.max(ee+J.length,0):Math.min(ee,J.length)}var ae;(function(J){function ee(re){return re<0}J.isLessThan=ee;function x(re){return re<=0}J.isLessThanOrEqual=x;function Q(re){return re>0}J.isGreaterThan=Q;function ne(re){return re===0}J.isNeitherLessOrGreaterThan=ne,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function te(J,ee){return(x,Q)=>ee(J(x),J(Q))}function ce(...J){return(ee,x)=>{for(const Q of J){const ne=Q(ee,x);if(!ae.isNeitherLessOrGreaterThan(ne))return ne}return ae.neitherLessOrGreaterThan}}const H=(J,ee)=>J-ee;e.$9b=H;const q=(J,ee)=>(0,e.$9b)(J?1:0,ee?1:0);e.$0b=q;function L(J){return(ee,x)=>-J(ee,x)}class F{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let x=this.c;for(;x<this.g.length&&ee(this.g[x]);)x++;const Q=x===this.c?null:this.g.slice(this.c,x);return this.c=x,Q}takeFromEndWhile(ee){let x=this.d;for(;x>=0&&ee(this.g[x]);)x--;const Q=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const x=this.g.slice(this.c,this.c+ee);return this.c+=ee,x}}e.$_b=F;class z{static{this.empty=new z(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(x=>(ee(x),!0))}toArray(){const ee=[];return this.iterate(x=>(ee.push(x),!0)),ee}filter(ee){return new z(x=>this.iterate(Q=>ee(Q)?x(Q):!0))}map(ee){return new z(x=>this.iterate(Q=>x(ee(Q))))}some(ee){let x=!1;return this.iterate(Q=>(x=ee(Q),!x)),x}findFirst(ee){let x;return this.iterate(Q=>ee(Q)?(x=Q,!1):!0),x}findLast(ee){let x;return this.iterate(Q=>(ee(Q)&&(x=Q),!0)),x}findLastMaxBy(ee){let x,Q=!0;return this.iterate(ne=>((Q||ae.isGreaterThan(ee(ne,x)))&&(Q=!1,x=ne),!0)),x}}e.$ac=z;class Y{constructor(ee){this.c=ee}static createSortPermutation(ee,x){const Q=Array.from(ee.keys()).sort((ne,re)=>x(ee[ne],ee[re]));return new Y(Q)}apply(ee){return ee.map((x,Q)=>ee[this.c[Q]])}inverse(){const ee=this.c.slice();for(let x=0;x<this.c.length;x++)ee[this.c[x]]=x;return new Y(ee)}}e.$bc=Y}),define(le[127],he([0,1,7]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$0c=A,e.$$c=j,e.$_c=D,e.$ad=I,e.$bd=P;function N(d,C){if(!d)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function A(d,C="Unreachable"){throw new Error(C)}function j(d){if(!d)throw new R.$cb("Assertion Failed")}function D(d){d||(0,R.$1)(new R.$cb("Soft Assertion Failed"))}function I(d){if(!d()){debugger;d(),(0,R.$1)(new R.$cb("Assertion Failed"))}}function P(d,C){let v=0;for(;v<d.length-1;){const m=d[v],f=d[v+1];if(!C(m,f))return!1;v++}return!0}}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=R;function R(N,A){const j=this;let D=!1,I;return function(){if(D)return I;if(D=!0,A)try{I=N.apply(j,arguments)}finally{A()}else I=N.apply(j,arguments);return I}}}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(N){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}N.is=A;const j=Object.freeze([]);function D(){return j}N.empty=D;function*I(i){yield i}N.single=I;function P(i){return A(i)?i:I(i)}N.wrap=P;function d(i){return i||j}N.from=d;function*C(i){for(let o=i.length-1;o>=0;o--)yield i[o]}N.reverse=C;function v(i){return!i||i[Symbol.iterator]().next().done===!0}N.isEmpty=v;function m(i){return i[Symbol.iterator]().next().value}N.first=m;function f(i,o){for(const n of i)if(o(n))return!0;return!1}N.some=f;function h(i,o){for(const n of i)if(o(n))return n}N.find=h;function*b(i,o){for(const n of i)o(n)&&(yield n)}N.filter=b;function*p(i,o){let n=0;for(const s of i)yield o(s,n++)}N.map=p;function*u(...i){for(const o of i)yield*o}N.concat=u;function g(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}N.reduce=g;function*l(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}N.slice=l;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,N.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=c;async function $(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}N.asyncToArray=$})(R||(e.Iterable=R={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=D,e.$un=v,e.$vn=m,e.$wn=f,e.$xn=h,e.$yn=b,e.$zn=p,e.$An=u,e.$Bn=g,e.$Cn=l,e.$Dn=c,e.$En=$;var R;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var j;(function(i){i.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function D(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,y=0;function E(U){let _=0,G=0;for(;_<U;){const Z=i.charCodeAt(n);if(Z>=48&&Z<=57)G=G*16+Z-48;else if(Z>=65&&Z<=70)G=G*16+Z-65+10;else if(Z>=97&&Z<=102)G=G*16+Z-97+10;else break;n++,_++}return _<U&&(G=-1),G}function k(U){n=U,t="",r=0,a=16,y=0}function S(){const U=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&d(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&d(i.charCodeAt(n)))for(n++;n<i.length&&d(i.charCodeAt(n));)n++;else return y=3,i.substring(U,n);let _=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&d(i.charCodeAt(n))){for(n++;n<i.length&&d(i.charCodeAt(n));)n++;_=n}else y=3;return i.substring(U,_)}function w(){let U="",_=n;for(;;){if(n>=s){U+=i.substring(_,n),y=2;break}const G=i.charCodeAt(n);if(G===34){U+=i.substring(_,n),n++;break}if(G===92){if(U+=i.substring(_,n),n++,n>=s){y=2;break}switch(i.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const V=E(4);V>=0?U+=String.fromCharCode(V):y=4;break}default:y=5}_=n;continue}if(G>=0&&G<=31)if(P(G)){U+=i.substring(_,n),y=2;break}else y=6;n++}return U}function O(){if(t="",y=0,r=n,n>=s)return r=s,a=17;let U=i.charCodeAt(n);if(I(U)){do n++,t+=String.fromCharCode(U),U=i.charCodeAt(n);while(I(U));return a=15}if(P(U))return n++,t+=String.fromCharCode(U),U===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(U){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=w(),a=10;case 47:{const _=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(i.charCodeAt(n));)n++;return t=i.substring(_,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const G=s-1;let Z=!1;for(;n<G;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Z=!0;break}n++}return Z||(n++,y=1),t=i.substring(_,n),a=13}return t+=String.fromCharCode(U),n++,a=16}case 45:if(t+=String.fromCharCode(U),n++,n===s||!d(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=S(),a=11;default:for(;n<s&&M(U);)n++,U=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(U),n++,a=16}}function M(U){if(I(U)||P(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let U;do U=O();while(U>=12&&U<=15);return U}return{setPosition:k,getPosition:()=>n,scan:o?T:O,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>y}}function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function P(i){return i===10||i===13||i===8232||i===8233}function d(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function v(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function y(E,k,S,w){r.value=E,r.offset=k,r.length=S,r.type=w,r.colonOffset=void 0,t=r}try{l(i,{onObjectBegin:(E,k)=>{if(o<=E)throw s;t=void 0,a=o>E,n.push("")},onObjectProperty:(E,k,S)=>{if(o<k||(y(E,k,S,"property"),n[n.length-1]=E,o<=k+S))throw s},onObjectEnd:(E,k)=>{if(o<=E)throw s;t=void 0,n.pop()},onArrayBegin:(E,k)=>{if(o<=E)throw s;t=void 0,n.push(0)},onArrayEnd:(E,k)=>{if(o<=E)throw s;t=void 0,n.pop()},onLiteralValue:(E,k,S)=>{if(o<k||(y(E,k,S,$(E)),o<=k+S))throw s},onSeparator:(E,k,S)=>{if(o<=k)throw s;if(E===":"&&t&&t.type==="property")t.colonOffset=k,a=!1,t=void 0;else if(E===","){const w=n[n.length-1];typeof w=="number"?n[n.length-1]=w+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(E){if(E!==s)throw E}return{path:n,previousNode:t,isAtPropertyKey:a,matches:E=>{let k=0;for(let S=0;k<E.length&&S<n.length;S++)if(E[k]===n[S]||E[k]==="*")k++;else if(E[k]!=="**")return!1;return k===E.length}}}function m(i,o=[],n=j.DEFAULT){let s=null,t=[];const r=[];function a(E){Array.isArray(t)?t.push(E):s!==null&&(t[s]=E)}return l(i,{onObjectBegin:()=>{const E={};a(E),r.push(t),t=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const E=[];a(E),r.push(t),t=E,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(E,k,S)=>{o.push({error:E,offset:k,length:S})}},n),t[0]}function f(i,o=[],n=j.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(E){s.type==="property"&&(s.length=E-s.offset,s=s.parent)}function r(E){return s.children.push(E),E}l(i,{onObjectBegin:E=>{s=r({type:"object",offset:E,length:-1,parent:s,children:[]})},onObjectProperty:(E,k,S)=>{s=r({type:"property",offset:k,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:E,offset:k,length:S,parent:s})},onObjectEnd:(E,k)=>{s.length=E+k-s.offset,s=s.parent,t(E+k)},onArrayBegin:(E,k)=>{s=r({type:"array",offset:E,length:-1,parent:s,children:[]})},onArrayEnd:(E,k)=>{s.length=E+k-s.offset,s=s.parent,t(E+k)},onLiteralValue:(E,k,S)=>{r({type:$(E),offset:k,length:S,parent:s,value:E}),t(k+S)},onSeparator:(E,k,S)=>{s.type==="property"&&(E===":"?s.colonOffset=k:E===","&&t(k))},onError:(E,k,S)=>{o.push({error:E,offset:k,length:S})}},n);const y=s.children[0];return y&&delete y.parent,y}function h(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}function p(i){switch(i.type){case"array":return i.children.map(p);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=p(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function u(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}function g(i,o,n=!1){if(u(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=g(s[t],o,n);if(r)return r}return i}}function l(i,o,n=j.DEFAULT){const s=D(i,!1);function t(te){return te?()=>te(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(te){return te?ce=>te(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),y=r(o.onObjectProperty),E=t(o.onObjectEnd),k=t(o.onArrayBegin),S=t(o.onArrayEnd),w=r(o.onLiteralValue),O=r(o.onSeparator),M=t(o.onComment),T=r(o.onError),U=n&&n.disallowComments,_=n&&n.allowTrailingComma;function G(){for(;;){const te=s.scan();switch(s.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:U||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(te){case 12:case 13:U?Z(10):M();break;case 16:Z(1);break;case 15:case 14:break;default:return te}}}function Z(te,ce=[],H=[]){if(T(te),ce.length+H.length>0){let q=s.getToken();for(;q!==17;){if(ce.indexOf(q)!==-1){G();break}else if(H.indexOf(q)!==-1)break;q=G()}}}function V(te){const ce=s.getTokenValue();return te?w(ce):y(ce),G(),!0}function K(){switch(s.getToken()){case 11:{let te=0;try{te=JSON.parse(s.getTokenValue()),typeof te!="number"&&(Z(2),te=0)}catch{Z(2)}w(te);break}case 7:w(null);break;case 8:w(!0);break;case 9:w(!1);break;default:return!1}return G(),!0}function W(){return s.getToken()!==10?(Z(3,[],[2,5]),!1):(V(!1),s.getToken()===6?(O(":"),G(),ae()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function B(){a(),G();let te=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(te||Z(4,[],[]),O(","),G(),s.getToken()===2&&_)break}else te&&Z(6,[],[]);W()||Z(4,[],[2,5]),te=!0}return E(),s.getToken()!==2?Z(7,[2],[]):G(),!0}function ie(){k(),G();let te=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(te||Z(4,[],[]),O(","),G(),s.getToken()===4&&_)break}else te&&Z(6,[],[]);ae()||Z(4,[],[4,5]),te=!0}return S(),s.getToken()!==4?Z(8,[4],[]):G(),!0}function ae(){switch(s.getToken()){case 3:return ie();case 1:return B();case 10:return V(!0);default:return K()}}return G(),s.getToken()===17?n.allowEmptyContent?!0:(Z(4,[],[]),!1):ae()?(s.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}function c(i,o){const n=D(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}function $(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[43],he([0,1,34]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=N,e.$Gn=A,e.$Hn=I,e.$In=P;function N(d,C,v){let m,f,h,b,p;if(C){for(b=C.offset,p=b+C.length,h=b;h>0&&!P(d,h-1);)h--;let a=p;for(;a<d.length&&!P(d,a);)a++;f=d.substring(h,a),m=D(f,v)}else f=d,m=0,h=0,b=0,p=d.length;const u=I(v,d);let g=!1,l=0,c;v.insertSpaces?c=j(" ",v.tabSize||4):c="	";const $=(0,R.$tn)(f,!1);let i=!1;function o(){return u+j(c,m+l)}function n(){let a=$.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=$.scan();return i=a===16||$.getTokenError()!==0,a}const s=[];function t(a,y,E){!i&&y<p&&E>b&&d.substring(y,E)!==a&&s.push({offset:y,length:E-y,content:a})}let r=n();if(r!==17){const a=$.getTokenOffset()+h,y=j(c,m);t(y,h,a)}for(;r!==17;){let a=$.getTokenOffset()+$.getTokenLength()+h,y=n(),E="";for(;!g&&(y===12||y===13);){const S=$.getTokenOffset()+h;t(" ",a,S),a=$.getTokenOffset()+$.getTokenLength()+h,E=y===12?o():"",y=n()}if(y===2)r!==1&&(l--,E=o());else if(y===4)r!==3&&(l--,E=o());else{switch(r){case 3:case 1:l++,E=o();break;case 5:case 12:E=o();break;case 13:g?E=o():E=" ";break;case 6:E=" ";break;case 10:if(y===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?E=" ":y!==5&&y!==17&&(i=!0);break;case 16:i=!0;break}g&&(y===12||y===13)&&(E=o())}const k=$.getTokenOffset()+h;t(E,a,k),r=y}return s}function A(d,C){const v=JSON.stringify(d,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?v.replace(/\r\n|\r|\n/g,C.eol):v}function j(d,C){let v="";for(let m=0;m<C;m++)v+=d;return v}function D(d,C){let v=0,m=0;const f=C.tabSize||4;for(;v<d.length;){const h=d.charAt(v);if(h===" ")m++;else if(h==="	")m+=f;else break;v++}return Math.floor(m/f)}function I(d,C){for(let v=0;v<C.length;v++){const m=C.charAt(v);if(m==="\r")return v+1<C.length&&C.charAt(v+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return d&&d.eol||`
`}function P(d,C){return`\r
`.indexOf(d.charAt(C))!==-1}}),define(le[62],he([0,1,34,43]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=A,e.$Kn=j,e.$Ln=D,e.$Mn=I,e.$Nn=P;function A(d,C,v){return j(d,C,void 0,v)}function j(d,C,v,m,f){const h=C.slice(),b=[],p=(0,R.$wn)(d,b);let u,g;for(;h.length>0&&(g=h.pop(),u=(0,R.$xn)(p,h),u===void 0&&v!==void 0);)typeof g=="string"?v={[g]:v}:v=[v];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const l=(0,R.$xn)(u,[g]);if(l!==void 0)if(v===void 0){if(!l.parent)throw new Error("Malformed AST");const c=u.children.indexOf(l.parent);let $,i=l.parent.offset+l.parent.length;if(c>0){const o=u.children[c-1];$=o.offset+o.length}else $=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return D(d,{offset:$,length:i-$,content:""},m)}else return D(d,{offset:l.offset,length:l.length,content:JSON.stringify(v)},m);else{if(v===void 0)return[];const c=`${JSON.stringify(g)}: ${JSON.stringify(v)}`,$=f?f(u.children.map(o=>o.children[0].value)):u.children.length;let i;if($>0){const o=u.children[$-1];i={offset:o.offset+o.length,length:0,content:","+c}}else u.children.length===0?i={offset:u.offset+1,length:0,content:c}:i={offset:u.offset+1,length:0,content:c+","};return D(d,i,m)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(v!==void 0){const l=`${JSON.stringify(v)}`;let c;if(u.children.length===0||g===0)c={offset:u.offset+1,length:0,content:u.children.length===0?l:l+","};else{const $=g===-1||g>u.children.length?u.children.length:g,i=u.children[$-1];c={offset:i.offset+i.length,length:0,content:","+l}}return D(d,c,m)}else{const l=g,c=u.children[l];let $;if(u.children.length===1)$={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===l){const i=u.children[l-1],o=i.offset+i.length,n=u.offset+u.length;$={offset:o,length:n-2-o,content:""}}else $={offset:c.offset,length:u.children[l+1].offset-c.offset,content:""};return D(d,$,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(d,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(v)},m)}}function D(d,C,v){let m=I(d,C),f=C.offset,h=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;f>0&&!(0,N.$In)(m,f-1);)f--;for(;h<m.length&&!(0,N.$In)(m,h);)h++}const b=(0,N.$Fn)(m,{offset:f,length:h-f},v);for(let u=b.length-1;u>=0;u--){const g=b[u];m=I(m,g),f=Math.min(f,g.offset),h=Math.max(h,g.offset+g.length),h+=g.content.length-g.length}const p=d.length-(m.length-h)-f;return[{offset:f,length:p,content:m.substring(f,h)}]}function I(d,C){return d.substring(0,C.offset)+C.content+d.substring(C.offset+C.length)}function P(d,C){const v=C.slice(0).sort((f,h)=>{const b=f.offset-h.offset;return b===0?f.length-h.length:b});let m=d.length;for(let f=v.length-1;f>=0;f--){const h=v[f];if(h.offset+h.length<=m)d=I(d,h);else throw new Error("Overlapping edit");m=h.offset}return d}}),define(le[53],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class R{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=R}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(j){this.element=j,this.next=R.Undefined,this.prev=R.Undefined}}class N{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let j=this.a;for(;j!==R.Undefined;){const D=j.next;j.prev=R.Undefined,j.next=R.Undefined,j=D}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,D){const I=new R(j);if(this.a===R.Undefined)this.a=I,this.b=I;else if(D){const d=this.b;this.b=I,I.prev=d,d.next=I}else{const d=this.a;this.a=I,I.next=d,d.prev=I}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(I))}}shift(){if(this.a!==R.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==R.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==R.Undefined&&j.next!==R.Undefined){const D=j.prev;D.next=j.next,j.next.prev=D}else j.prev===R.Undefined&&j.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):j.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):j.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==R.Undefined;)yield j.element,j=j.next}}e.$5c=N}),define(le[35],he([0,1]),function(se,e){"use strict";var R,N,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=j,e.$zc=D,e.$Ac=I,e.$Ic=g;function j(l,c,$){let i=l.get(c);return i===void 0&&(i=$,l.set(c,i)),i}function D(l){const c=[];return l.forEach(($,i)=>{c.push(`${i} => ${$}`)}),`Map(${l.size}) {${c.join(", ")}}`}function I(l){const c=[];return l.forEach($=>{c.push($)}),`Set(${l.size}) {${c.join(", ")}}`}class P{constructor(c,$){this.uri=c,this.value=$}}function d(l){return Array.isArray(l)}class C{static{this.c=c=>c.toString()}constructor(c,$){if(this[R]="ResourceMap",c instanceof C)this.d=new Map(c.d),this.e=$??C.c;else if(d(c)){this.d=new Map,this.e=$??C.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??C.c}set(c,$){return this.d.set(this.e(c),new P(c,$)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,$){typeof $<"u"&&(c=c.bind($));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Bc=C;class v{constructor(c,$){this[N]="ResourceSet",!c||typeof c=="function"?this.c=new C(c):(this.c=new C($),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,$){this.c.forEach((i,o)=>c.call($,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=v;var m;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class f{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,$=0){const i=this.c.get(c);if(i)return $!==0&&this.l(i,$),i.value}set(c,$,i=0){let o=this.c.get(c);if(o)o.value=$,i!==0&&this.l(o,i);else{switch(o={key:c,value:$,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const $=this.c.get(c);if($)return this.c.delete(c),this.k($),this.f--,$.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,$){const i=this.g;let o=this.d;for(;o;){if($?c.bind($)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,$=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==$)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,$=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==$)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,$=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==$)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let $=this.d,i=this.size;for(;$&&i>c;)this.c.delete($.key),$=$.next,i--;this.d=$,this.f=i,$&&($.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const $=c.next,i=c.previous;if(!$||!i)throw new Error("Invalid list");$.previous=i,i.next=$}c.next=void 0,c.previous=void 0,this.g++}l(c,$){if(!this.d||!this.e)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if($===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach(($,i)=>{c.push([i,$])}),c}fromJSON(c){this.clear();for(const[$,i]of c)this.set($,i)}}e.$Dc=f;class h extends f{constructor(c,$=1){super(),this.m=c,this.n=Math.min(Math.max(0,$),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,$=2){return super.get(c,$)}peek(c){return super.get(c,0)}set(c,$){return super.set(c,$,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=h;class b{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let $=this.c.get(c)||0;return $===0?!1:($--,$===0?this.c.delete(c):this.c.set(c,$),!0)}has(c){return this.c.has(c)}}e.$Fc=b;class p{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[$,i]of c)this.set($,i)}clear(){this.c.clear(),this.d.clear()}set(c,$){this.c.set(c,$),this.d.set($,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const $=this.c.get(c);return $===void 0?!1:(this.c.delete(c),this.d.delete($),!0)}forEach(c,$){this.c.forEach((i,o)=>{c.call($,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=p;class u{constructor(){this.c=new Map}add(c,$){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add($)}delete(c,$){const i=this.c.get(c);i&&(i.delete($),i.size===0&&this.c.delete(c))}forEach(c,$){const i=this.c.get(c);i&&i.forEach($)}get(c){const $=this.c.get(c);return $||new Set}}e.$Hc=u;function g(l,c){if(l===c)return!0;if(l.size!==c.size)return!1;for(const[$,i]of l)if(!c.has($)||c.get($)!==i)return!1;for(const[$]of c)if(!l.has($))return!1;return!0}}),define(le[2],he([0,1,17,126,35,85,61]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=C,e.$Lc=v,e.$Mc=m,e.$Nc=b,e.$Oc=p,e.$Pc=u,e.$Qc=g,e.$Rc=l,e.$Sc=c,e.$3c=E;const I=!1;let P=null;class d{constructor(){this.b=new Map}static{this.a=0}c(w){let O=this.b.get(w);return O||(O={parent:null,source:null,isSingleton:!1,value:w,idx:d.a++},this.b.set(w,O)),O}trackDisposable(w){const O=this.c(w);O.source||(O.source=new Error().stack)}setParent(w,O){const M=this.c(w);M.parent=O}markAsDisposed(w){this.b.delete(w)}markAsSingleton(w){this.c(w).isSingleton=!0}f(w,O){const M=O.get(w);if(M)return M;const T=w.parent?this.f(this.c(w.parent),O):w;return O.set(w,T),T}getTrackedDisposables(){const w=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,w).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(w=10,O){let M;if(O)M=O;else{const Z=new Map,V=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,Z).isSingleton);if(V.length===0)return;const K=new Set(V.map(W=>W.value));if(M=V.filter(W=>!(W.parent&&K.has(W.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function T(Z){function V(W,B){for(;W.length>0&&B.some(ie=>typeof ie=="string"?ie===W[0]:W[0].match(ie));)W.shift()}const K=Z.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return V(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const U=new A.$Hc;for(const Z of M){const V=T(Z);for(let K=0;K<=V.length;K++)U.add(V.slice(0,K).join(`
`),Z)}M.sort((0,R.$7b)(Z=>Z.idx,R.$9b));let _="",G=0;for(const Z of M.slice(0,w)){G++;const V=T(Z),K=[];for(let W=0;W<V.length;W++){let B=V[W];B=`(shared with ${U.get(V.slice(0,W+1).join(`
`)).size}/${M.length} leaks) at ${B}`;const ae=U.get(V.slice(0,W).join(`
`)),te=(0,N.$K)([...ae].map(ce=>T(ce)[W]),ce=>ce);delete te[V[W]];for(const[ce,H]of Object.entries(te))K.unshift(`    - stacktraces of ${H.length} other leaks continue with ${ce}`);K.unshift(B)}_+=`


==================== Leaking disposable ${G}/${M.length}: ${Z.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return M.length>w&&(_+=`


... and ${M.length-w} more leaking disposables

`),{leaks:M,details:_}}}e.$Jc=d;function C(S){P=S}if(I){const S="__is_disposable_tracked__";C(new class{trackDisposable(w){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[S]||console.log(O)},3e3)}setParent(w,O){if(w&&w!==i.None)try{w[S]=!0}catch{}}markAsDisposed(w){if(w&&w!==i.None)try{w[S]=!0}catch{}}markAsSingleton(w){}})}function v(S){return P?.trackDisposable(S),S}function m(S){P?.markAsDisposed(S)}function f(S,w){P?.setParent(S,w)}function h(S,w){if(P)for(const O of S)P.setParent(O,w)}function b(S){return P?.markAsSingleton(S),S}function p(S){return typeof S.dispose=="function"&&S.dispose.length===0}function u(S){if(D.Iterable.is(S)){const w=[];for(const O of S)if(O)try{O.dispose()}catch(M){w.push(M)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function g(S){for(const w of S)p(w)&&w.dispose();return[]}function l(...S){const w=c(()=>u(S));return h(S,w),w}function c(S){const w=v({dispose:(0,j.$db)(()=>{m(w),S()})});return w}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return f(w,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(w),w}delete(w){if(w){if(w===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(w),w.dispose()}}deleteAndLeak(w){w&&this.f.has(w)&&(this.f.delete(w),f(w,null))}}e.$Tc=$;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,v(this),f(this.q,this)}dispose(){m(this),this.q.dispose()}B(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(w)}}e.$Uc=i;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(w){this.b||w===this.a||(this.a?.dispose(),w&&f(w,this),this.a=w)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const w=this.a;return this.a=void 0,w&&f(w,null),w}}e.$Vc=o;class n{constructor(w){this.a=new o,this.b=!1,this.a.value=w}get value(){return this.a.value}set value(w){this.b||w===this.a.value||(this.a.value=w)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class s{constructor(w){this.b=w,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(w){let O=w;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,m(this))},this}}e.$Yc=t;class r{constructor(){this.a=new Map}acquire(w,...O){let M=this.a.get(w);M||(M={counter:0,object:this.b(w,...O)},this.a.set(w,M));const{object:T}=M,U=(0,j.$db)(()=>{--M.counter===0&&(this.c(w,M.object),this.a.delete(w))});return M.counter++,{object:T,dispose:U}}}e.$Zc=r;class a{constructor(w){this.a=w}async acquire(w,...O){const M=this.a.acquire(w,...O);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.$1c=a;class y{constructor(w){this.object=w}dispose(){}}e.$2c=y;function E(S){const w=new $;try{S(w)}finally{w.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(w){return this.a.has(w)}get size(){return this.a.size}get(w){return this.a.get(w)}set(w,O,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(w)?.dispose(),this.a.set(w,O)}deleteAndDispose(w){this.a.get(w)?.dispose(),this.a.delete(w)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=k}),define(le[87],he([0,1,35]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=void 0,e.$Zl=A,e.$1l=D;const N=new R.$Ec(1e4);function A(d){return P(d,"NFC",N)}const j=new R.$Ec(1e4);function D(d){return P(d,"NFD",j)}const I=/[^\u0000-\u0080]/;function P(d,C,v){if(!d)return d;const m=v.get(d);if(m)return m;let f;return I.test(d)?f=d.normalize(C):f=d,v.set(d,f),f}e.$2l=function(){const d=/[\u0300-\u036f]/g;return function(C){return D(C).replace(d,"")}}()}),function(){function se(A){const j=[];typeof A=="number"&&j.push("code/timeOrigin",A);function D(P){j.push(P,Date.now())}function I(){const P=[];for(let d=0;d<j.length;d+=2)P.push({name:j[d],startTime:j[d+1]});return P}return{mark:D,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const D of performance.getEntriesByType("mark"))j.push({name:D.name,startTime:Math.round(A+D.startTime)});return j}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function R(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=R(N))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var N in R)(typeof exports=="object"?exports:se)[N]=R[N]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function R(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return se[N].call(A.exports,A,A.exports,R),A.l=!0,A.exports}return R.m=se,R.c=e,R.d=function(N,A,j){R.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:j})},R.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},R.t=function(N,A){if(1&A&&(N=R(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var j=Object.create(null);if(R.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var D in N)R.d(j,D,function(I){return N[I]}.bind(null,D));return j},R.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return R.d(A,"a",A),A},R.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},R.p="",R(R.s=0)}([function(se,e,R){(function(N){var A;e=se.exports=H,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var fe=Array.prototype.slice.call(arguments,0);fe.unshift("SEMVER"),console.log.apply(console,fe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],P=e.src=[],d=0,C=d++;P[C]="0|[1-9]\\d*";var v=d++;P[v]="[0-9]+";var m=d++;P[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=d++;P[f]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var h=d++;P[h]="("+P[v]+")\\.("+P[v]+")\\.("+P[v]+")";var b=d++;P[b]="(?:"+P[C]+"|"+P[m]+")";var p=d++;P[p]="(?:"+P[v]+"|"+P[m]+")";var u=d++;P[u]="(?:-("+P[b]+"(?:\\."+P[b]+")*))";var g=d++;P[g]="(?:-?("+P[p]+"(?:\\."+P[p]+")*))";var l=d++;P[l]="[0-9A-Za-z-]+";var c=d++;P[c]="(?:\\+("+P[l]+"(?:\\."+P[l]+")*))";var $=d++,i="v?"+P[f]+P[u]+"?"+P[c]+"?";P[$]="^"+i+"$";var o="[v=\\s]*"+P[h]+P[g]+"?"+P[c]+"?",n=d++;P[n]="^"+o+"$";var s=d++;P[s]="((?:<|>)?=?)";var t=d++;P[t]=P[v]+"|x|X|\\*";var r=d++;P[r]=P[C]+"|x|X|\\*";var a=d++;P[a]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[u]+")?"+P[c]+"?)?)?";var y=d++;P[y]="[v=\\s]*("+P[t]+")(?:\\.("+P[t]+")(?:\\.("+P[t]+")(?:"+P[g]+")?"+P[c]+"?)?)?";var E=d++;P[E]="^"+P[s]+"\\s*"+P[a]+"$";var k=d++;P[k]="^"+P[s]+"\\s*"+P[y]+"$";var S=d++;P[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=d++;P[w]="(?:~>?)";var O=d++;P[O]="(\\s*)"+P[w]+"\\s+",I[O]=new RegExp(P[O],"g");var M=d++;P[M]="^"+P[w]+P[a]+"$";var T=d++;P[T]="^"+P[w]+P[y]+"$";var U=d++;P[U]="(?:\\^)";var _=d++;P[_]="(\\s*)"+P[U]+"\\s+",I[_]=new RegExp(P[_],"g");var G=d++;P[G]="^"+P[U]+P[a]+"$";var Z=d++;P[Z]="^"+P[U]+P[y]+"$";var V=d++;P[V]="^"+P[s]+"\\s*("+o+")$|^$";var K=d++;P[K]="^"+P[s]+"\\s*("+i+")$|^$";var W=d++;P[W]="(\\s*)"+P[s]+"\\s*("+o+"|"+P[a]+")",I[W]=new RegExp(P[W],"g");var B=d++;P[B]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=d++;P[ie]="^\\s*("+P[y]+")\\s+-\\s+("+P[y]+")\\s*$";var ae=d++;P[ae]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)A(te,P[te]),I[te]||(I[te]=new RegExp(P[te]));function ce(fe,me){if(fe instanceof H)return fe;if(typeof fe!="string"||fe.length>j||!(me?I[n]:I[$]).test(fe))return null;try{return new H(fe,me)}catch{return null}}function H(fe,me){if(fe instanceof H){if(fe.loose===me)return fe;fe=fe.version}else if(typeof fe!="string")throw new TypeError("Invalid Version: "+fe);if(fe.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof H))return new H(fe,me);A("SemVer",fe,me),this.loose=me;var be=fe.trim().match(me?I[n]:I[$]);if(!be)throw new TypeError("Invalid Version: "+fe);if(this.raw=fe,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<D)return Ie}return Ce}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ce,e.valid=function(fe,me){var be=ce(fe,me);return be?be.version:null},e.clean=function(fe,me){var be=ce(fe.trim().replace(/^[=v]+/,""),me);return be?be.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(fe){return A("SemVer.compare",this.version,this.loose,fe),fe instanceof H||(fe=new H(fe,this.loose)),this.compareMain(fe)||this.comparePre(fe)},H.prototype.compareMain=function(fe){return fe instanceof H||(fe=new H(fe,this.loose)),L(this.major,fe.major)||L(this.minor,fe.minor)||L(this.patch,fe.patch)},H.prototype.comparePre=function(fe){if(fe instanceof H||(fe=new H(fe,this.loose)),this.prerelease.length&&!fe.prerelease.length)return-1;if(!this.prerelease.length&&fe.prerelease.length)return 1;if(!this.prerelease.length&&!fe.prerelease.length)return 0;var me=0;do{var be=this.prerelease[me],Ce=fe.prerelease[me];if(A("prerelease compare",me,be,Ce),be===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(be===void 0)return-1;if(be!==Ce)return L(be,Ce)}while(++me)},H.prototype.inc=function(fe,me){switch(fe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+fe)}return this.format(),this.raw=this.version,this},e.inc=function(fe,me,be,Ce){typeof be=="string"&&(Ce=be,be=void 0);try{return new H(fe,be).inc(me,Ce).version}catch{return null}},e.diff=function(fe,me){if(J(fe,me))return null;var be=ce(fe),Ce=ce(me);if(be.prerelease.length||Ce.prerelease.length){for(var Ie in be)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&be[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in be)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&be[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=L;var q=/^[0-9]+$/;function L(fe,me){var be=q.test(fe),Ce=q.test(me);return be&&Ce&&(fe=+fe,me=+me),be&&!Ce?-1:Ce&&!be?1:fe<me?-1:fe>me?1:0}function F(fe,me,be){return new H(fe,be).compare(new H(me,be))}function z(fe,me,be){return F(fe,me,be)>0}function Y(fe,me,be){return F(fe,me,be)<0}function J(fe,me,be){return F(fe,me,be)===0}function ee(fe,me,be){return F(fe,me,be)!==0}function x(fe,me,be){return F(fe,me,be)>=0}function Q(fe,me,be){return F(fe,me,be)<=0}function ne(fe,me,be,Ce){var Ie;switch(me){case"===":typeof fe=="object"&&(fe=fe.version),typeof be=="object"&&(be=be.version),Ie=fe===be;break;case"!==":typeof fe=="object"&&(fe=fe.version),typeof be=="object"&&(be=be.version),Ie=fe!==be;break;case"":case"=":case"==":Ie=J(fe,be,Ce);break;case"!=":Ie=ee(fe,be,Ce);break;case">":Ie=z(fe,be,Ce);break;case">=":Ie=x(fe,be,Ce);break;case"<":Ie=Y(fe,be,Ce);break;case"<=":Ie=Q(fe,be,Ce);break;default:throw new TypeError("Invalid operator: "+me)}return Ie}function re(fe,me){if(fe instanceof re){if(fe.loose===me)return fe;fe=fe.value}if(!(this instanceof re))return new re(fe,me);A("comparator",fe,me),this.loose=me,this.parse(fe),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(fe,me){return L(me,fe)},e.major=function(fe,me){return new H(fe,me).major},e.minor=function(fe,me){return new H(fe,me).minor},e.patch=function(fe,me){return new H(fe,me).patch},e.compare=F,e.compareLoose=function(fe,me){return F(fe,me,!0)},e.rcompare=function(fe,me,be){return F(me,fe,be)},e.sort=function(fe,me){return fe.sort(function(be,Ce){return e.compare(be,Ce,me)})},e.rsort=function(fe,me){return fe.sort(function(be,Ce){return e.rcompare(be,Ce,me)})},e.gt=z,e.lt=Y,e.eq=J,e.neq=ee,e.gte=x,e.lte=Q,e.cmp=ne,e.Comparator=re;var ue={};function de(fe,me){if(fe instanceof de)return fe.loose===me?fe:new de(fe.raw,me);if(fe instanceof re)return new de(fe.value,me);if(!(this instanceof de))return new de(fe,me);if(this.loose=me,this.raw=fe,this.set=fe.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+fe);this.format()}function $e(fe){return!fe||fe.toLowerCase()==="x"||fe==="*"}function ye(fe,me,be,Ce,Ie,Me,De,qe,Fe,Ue,ze,Ae,oe){return((me=$e(be)?"":$e(Ce)?">="+be+".0.0":$e(Ie)?">="+be+"."+Ce+".0":">="+me)+" "+(qe=$e(Fe)?"":$e(Ue)?"<"+(+Fe+1)+".0.0":$e(ze)?"<"+Fe+"."+(+Ue+1)+".0":Ae?"<="+Fe+"."+Ue+"."+ze+"-"+Ae:"<="+qe)).trim()}function Se(fe,me){for(var be=0;be<fe.length;be++)if(!fe[be].test(me))return!1;if(me.prerelease.length){for(be=0;be<fe.length;be++)if(A(fe[be].semver),fe[be].semver!==ue&&fe[be].semver.prerelease.length>0){var Ce=fe[be].semver;if(Ce.major===me.major&&Ce.minor===me.minor&&Ce.patch===me.patch)return!0}return!1}return!0}function Re(fe,me,be){try{me=new de(me,be)}catch{return!1}return me.test(fe)}function Le(fe,me,be,Ce){var Ie,Me,De,qe,Fe;switch(fe=new H(fe,Ce),me=new de(me,Ce),be){case">":Ie=z,Me=Q,De=Y,qe=">",Fe=">=";break;case"<":Ie=Y,Me=x,De=z,qe="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(fe,me,Ce))return!1;for(var Ue=0;Ue<me.set.length;++Ue){var ze=me.set[Ue],Ae=null,oe=null;if(ze.forEach(function(ge){ge.semver===ue&&(ge=new re(">=0.0.0")),Ae=Ae||ge,oe=oe||ge,Ie(ge.semver,Ae.semver,Ce)?Ae=ge:De(ge.semver,oe.semver,Ce)&&(oe=ge)}),Ae.operator===qe||Ae.operator===Fe||(!oe.operator||oe.operator===qe)&&Me(fe,oe.semver)||oe.operator===Fe&&De(fe,oe.semver))return!1}return!0}re.prototype.parse=function(fe){var me=this.loose?I[V]:I[K],be=fe.match(me);if(!be)throw new TypeError("Invalid comparator: "+fe);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new H(be[2],this.loose):this.semver=ue},re.prototype.toString=function(){return this.value},re.prototype.test=function(fe){return A("Comparator.test",fe,this.loose),this.semver===ue||(typeof fe=="string"&&(fe=new H(fe,this.loose)),ne(fe,this.operator,this.semver,this.loose))},re.prototype.intersects=function(fe,me){if(!(fe instanceof re))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(fe.value,me),Re(this.value,be,me);if(fe.operator==="")return be=new de(this.value,me),Re(fe.semver,be,me);var Ce=!(this.operator!==">="&&this.operator!==">"||fe.operator!==">="&&fe.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||fe.operator!=="<="&&fe.operator!=="<"),Me=this.semver.version===fe.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||fe.operator!==">="&&fe.operator!=="<="),qe=ne(this.semver,"<",fe.semver,me)&&(this.operator===">="||this.operator===">")&&(fe.operator==="<="||fe.operator==="<"),Fe=ne(this.semver,">",fe.semver,me)&&(this.operator==="<="||this.operator==="<")&&(fe.operator===">="||fe.operator===">");return Ce||Ie||Me&&De||qe||Fe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(fe){return fe.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(fe){var me=this.loose;fe=fe.trim(),A("range",fe,me);var be=me?I[ie]:I[B];fe=fe.replace(be,ye),A("hyphen replace",fe),fe=fe.replace(I[W],"$1$2$3"),A("comparator trim",fe,I[W]),fe=(fe=(fe=fe.replace(I[O],"$1~")).replace(I[_],"$1^")).split(/\s+/).join(" ");var Ce=me?I[V]:I[K],Ie=fe.split(" ").map(function(Me){return function(De,qe){return A("comp",De),De=function(Fe,Ue){return Fe.trim().split(/\s+/).map(function(ze){return function(Ae,oe){A("caret",Ae,oe);var ge=oe?I[Z]:I[G];return Ae.replace(ge,function(pe,we,Ee,Pe,Oe){var Ne;return A("caret",Ae,pe,we,Ee,Pe,Oe),$e(we)?Ne="":$e(Ee)?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":$e(Pe)?Ne=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":Oe?(A("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+Pe+Oe+" <"+we+"."+Ee+"."+(+Pe+1):">="+we+"."+Ee+"."+Pe+Oe+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+Pe+Oe+" <"+(+we+1)+".0.0"):(A("no pr"),Ne=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+Pe+" <"+we+"."+Ee+"."+(+Pe+1):">="+we+"."+Ee+"."+Pe+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+Pe+" <"+(+we+1)+".0.0"),A("caret return",Ne),Ne})}(ze,Ue)}).join(" ")}(De,qe),A("caret",De),De=function(Fe,Ue){return Fe.trim().split(/\s+/).map(function(ze){return function(Ae,oe){var ge=oe?I[T]:I[M];return Ae.replace(ge,function(pe,we,Ee,Pe,Oe){var Ne;return A("tilde",Ae,pe,we,Ee,Pe,Oe),$e(we)?Ne="":$e(Ee)?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":$e(Pe)?Ne=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":Oe?(A("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=">="+we+"."+Ee+"."+Pe+Oe+" <"+we+"."+(+Ee+1)+".0"):Ne=">="+we+"."+Ee+"."+Pe+" <"+we+"."+(+Ee+1)+".0",A("tilde return",Ne),Ne})}(ze,Ue)}).join(" ")}(De,qe),A("tildes",De),De=function(Fe,Ue){return A("replaceXRanges",Fe,Ue),Fe.split(/\s+/).map(function(ze){return function(Ae,oe){Ae=Ae.trim();var ge=oe?I[k]:I[E];return Ae.replace(ge,function(pe,we,Ee,Pe,Oe,Ne){A("xRange",Ae,pe,we,Ee,Pe,Oe,Ne);var We=$e(Ee),Be=We||$e(Pe),Te=Be||$e(Oe);return we==="="&&Te&&(we=""),We?pe=we===">"||we==="<"?"<0.0.0":"*":we&&Te?(Be&&(Pe=0),Te&&(Oe=0),we===">"?(we=">=",Be?(Ee=+Ee+1,Pe=0,Oe=0):Te&&(Pe=+Pe+1,Oe=0)):we==="<="&&(we="<",Be?Ee=+Ee+1:Pe=+Pe+1),pe=we+Ee+"."+Pe+"."+Oe):Be?pe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(pe=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),A("xRange return",pe),pe})}(ze,Ue)}).join(" ")}(De,qe),A("xrange",De),De=function(Fe,Ue){return A("replaceStars",Fe,Ue),Fe.trim().replace(I[ae],"")}(De,qe),A("stars",De),De}(Me,me)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(Ce)})),Ie=Ie.map(function(Me){return new re(Me,me)})},de.prototype.intersects=function(fe,me){if(!(fe instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Ce){return fe.set.some(function(Ie){return Ie.every(function(Me){return Ce.intersects(Me,me)})})})})},e.toComparators=function(fe,me){return new de(fe,me).set.map(function(be){return be.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},de.prototype.test=function(fe){if(!fe)return!1;typeof fe=="string"&&(fe=new H(fe,this.loose));for(var me=0;me<this.set.length;me++)if(Se(this.set[me],fe))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(fe,me,be){var Ce=null,Ie=null;try{var Me=new de(me,be)}catch{return null}return fe.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==-1||(Ie=new H(Ce=De,be)))}),Ce},e.minSatisfying=function(fe,me,be){var Ce=null,Ie=null;try{var Me=new de(me,be)}catch{return null}return fe.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==1||(Ie=new H(Ce=De,be)))}),Ce},e.validRange=function(fe,me){try{return new de(fe,me).range||"*"}catch{return null}},e.ltr=function(fe,me,be){return Le(fe,me,"<",be)},e.gtr=function(fe,me,be){return Le(fe,me,">",be)},e.outside=Le,e.prerelease=function(fe,me){var be=ce(fe,me);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(fe,me,be){return fe=new de(fe,be),me=new de(me,be),fe.intersects(me)},e.coerce=function(fe){if(fe instanceof H)return fe;if(typeof fe!="string")return null;var me=fe.match(I[S]);return me==null?null:ce((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,R(1))},function(se,e){var R,N,A=se.exports={};function j(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function I(p){if(R===setTimeout)return setTimeout(p,0);if((R===j||!R)&&setTimeout)return R=setTimeout,setTimeout(p,0);try{return R(p,0)}catch{try{return R.call(null,p,0)}catch{return R.call(this,p,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:j}catch{R=j}try{N=typeof clearTimeout=="function"?clearTimeout:D}catch{N=D}})();var P,d=[],C=!1,v=-1;function m(){C&&P&&(C=!1,P.length?d=P.concat(d):v=-1,d.length&&f())}function f(){if(!C){var p=I(m);C=!0;for(var u=d.length;u;){for(P=d,d=[];++v<u;)P&&P[v].run();v=-1,u=d.length}P=null,C=!1,function(g){if(N===clearTimeout)return clearTimeout(g);if((N===D||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(g);try{N(g)}catch{try{return N.call(null,g)}catch{return N.call(this,g)}}}(p)}}function h(p,u){this.fun=p,this.array=u}function b(){}A.nextTick=function(p){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];d.push(new h(p,u)),d.length!==1||C||I(f)},h.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=b,A.addListener=b,A.once=b,A.off=b,A.removeListener=b,A.removeAllListeners=b,A.emit=b,A.prependListener=b,A.prependOnceListener=b,A.listeners=function(p){return[]},A.binding=function(p){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(p){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class N{constructor(I,P,d){this.level=I,this.key=P,this.value=d,this.forward=[]}}const A=void 0;class j{constructor(I,P=2**16){this.comparator=I,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new N(this.c,A,A)}get size(){return this.f}clear(){this.e=new N(this.c,A,A),this.f=0}has(I){return!!j.g(this,I,this.comparator)}get(I){return j.g(this,I,this.comparator)?.value}set(I,P){return j.h(this,I,P,this.comparator)&&(this.f+=1),this}delete(I){const P=j.k(this,I,this.comparator);return P&&(this.f-=1),P}forEach(I,P){let d=this.e.forward[0];for(;d;)I.call(P,d.value,d.key,this),d=d.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",P=this.e.forward[0];for(;P;)I+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return I}static g(I,P,d){let C=I.e;for(let v=I.d-1;v>=0;v--)for(;C.forward[v]&&d(C.forward[v].key,P)<0;)C=C.forward[v];if(C=C.forward[0],C&&d(C.key,P)===0)return C}static h(I,P,d,C){const v=[];let m=I.e;for(let f=I.d-1;f>=0;f--){for(;m.forward[f]&&C(m.forward[f].key,P)<0;)m=m.forward[f];v[f]=m}if(m=m.forward[0],m&&C(m.key,P)===0)return m.value=d,!1;{const f=j.j(I);if(f>I.d){for(let h=I.d;h<f;h++)v[h]=I.e;I.d=f}m=new N(f,P,d);for(let h=0;h<f;h++)m.forward[h]=v[h].forward[h],v[h].forward[h]=m;return!0}}static j(I,P=.5){let d=1;for(;Math.random()<P&&d<I.c;)d+=1;return d}static k(I,P,d){const C=[];let v=I.e;for(let m=I.d-1;m>=0;m--){for(;v.forward[m]&&d(v.forward[m].key,P)<0;)v=v.forward[m];C[m]=v}if(v=v.forward[0],!v||d(v.key,P)!==0)return!1;for(let m=0;m<I.d&&C[m].forward[m]===v;m++)C[m].forward[m]=v.forward[m];for(;I.d>0&&I.e.forward[I.d-1]===A;)I.d-=1;return!0}}e.$is=j}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(j){return new N(j)}constructor(j){this.c=R&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=N}),define(le[3],he([0,1,7,85,2,86,63]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=f;const I=!1,P=!1,d=!1;var C;(function(S){S.None=()=>A.$Uc.None;function w(re){if(d){const{onDidAddListener:ue}=re,de=b.create();let $e=0;re.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ue?.()}}}function O(re,ue){return B(re,()=>{},0,void 0,!0,void 0,ue)}S.defer=O;function M(re){return(ue,de=null,$e)=>{let ye=!1,Se;return Se=re(Re=>{if(!ye)return Se?Se.dispose():ye=!0,ue.call(de,Re)},null,$e),ye&&Se.dispose(),Se}}S.once=M;function T(re,ue,de){return K(($e,ye=null,Se)=>re(Re=>$e.call(ye,ue(Re)),null,Se),de)}S.map=T;function U(re,ue,de){return K(($e,ye=null,Se)=>re(Re=>{ue(Re),$e.call(ye,Re)},null,Se),de)}S.forEach=U;function _(re,ue,de){return K(($e,ye=null,Se)=>re(Re=>ue(Re)&&$e.call(ye,Re),null,Se),de)}S.filter=_;function G(re){return re}S.signal=G;function Z(...re){return(ue,de=null,$e)=>{const ye=(0,A.$Rc)(...re.map(Se=>Se(Re=>ue.call(de,Re))));return W(ye,$e)}}S.any=Z;function V(re,ue,de,$e){let ye=de;return T(re,Se=>(ye=ue(ye,Se),ye),$e)}S.reduce=V;function K(re,ue){let de;const $e={onWillAddFirstListener(){de=re(ye.fire,ye)},onDidRemoveLastListener(){de?.dispose()}};ue||w($e);const ye=new $($e);return ue?.add(ye),ye.event}function W(re,ue){return ue instanceof Array?ue.push(re):ue&&ue.add(re),re}function B(re,ue,de=100,$e=!1,ye=!1,Se,Re){let Le,fe,me,be=0,Ce;const Ie={leakWarningThreshold:Se,onWillAddFirstListener(){Le=re(De=>{be++,fe=ue(fe,De),$e&&!me&&(Me.fire(fe),fe=void 0),Ce=()=>{const qe=fe;fe=void 0,me=void 0,(!$e||be>1)&&Me.fire(qe),be=0},typeof de=="number"?(clearTimeout(me),me=setTimeout(Ce,de)):me===void 0&&(me=0,queueMicrotask(Ce))})},onWillRemoveListener(){ye&&be>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,Le.dispose()}};Re||w(Ie);const Me=new $(Ie);return Re?.add(Me),Me.event}S.debounce=B;function ie(re,ue=0,de){return S.debounce(re,($e,ye)=>$e?($e.push(ye),$e):[ye],ue,void 0,!0,void 0,de)}S.accumulate=ie;function ae(re,ue=($e,ye)=>$e===ye,de){let $e=!0,ye;return _(re,Se=>{const Re=$e||!ue(Se,ye);return $e=!1,ye=Se,Re},de)}S.latch=ae;function te(re,ue,de){return[S.filter(re,ue,de),S.filter(re,$e=>!ue($e),de)]}S.split=te;function ce(re,ue=!1,de=[],$e){let ye=de.slice(),Se=re(fe=>{ye?ye.push(fe):Le.fire(fe)});$e&&$e.add(Se);const Re=()=>{ye?.forEach(fe=>Le.fire(fe)),ye=null},Le=new $({onWillAddFirstListener(){Se||(Se=re(fe=>Le.fire(fe)),$e&&$e.add(Se))},onDidAddFirstListener(){ye&&(ue?setTimeout(Re):Re())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return $e&&$e.add(Le),Le.event}S.buffer=ce;function H(re,ue){return($e,ye,Se)=>{const Re=ue(new L);return re(function(Le){const fe=Re.evaluate(Le);fe!==q&&$e.call(ye,fe)},void 0,Se)}}S.chain=H;const q=Symbol("HaltChainable");class L{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(de=>(ue(de),de)),this}filter(ue){return this.f.push(de=>ue(de)?de:q),this}reduce(ue,de){let $e=de;return this.f.push(ye=>($e=ue($e,ye),$e)),this}latch(ue=(de,$e)=>de===$e){let de=!0,$e;return this.f.push(ye=>{const Se=de||!ue(ye,$e);return de=!1,$e=ye,Se?ye:q}),this}evaluate(ue){for(const de of this.f)if(ue=de(ue),ue===q)break;return ue}}function F(re,ue,de=$e=>$e){const $e=(...Le)=>Re.fire(de(...Le)),ye=()=>re.on(ue,$e),Se=()=>re.removeListener(ue,$e),Re=new $({onWillAddFirstListener:ye,onDidRemoveLastListener:Se});return Re.event}S.fromNodeEventEmitter=F;function z(re,ue,de=$e=>$e){const $e=(...Le)=>Re.fire(de(...Le)),ye=()=>re.addEventListener(ue,$e),Se=()=>re.removeEventListener(ue,$e),Re=new $({onWillAddFirstListener:ye,onDidRemoveLastListener:Se});return Re.event}S.fromDOMEventEmitter=z;function Y(re){return new Promise(ue=>M(re)(ue))}S.toPromise=Y;function J(re){const ue=new $;return re.then(de=>{ue.fire(de)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}S.fromPromise=J;function ee(re,ue,de){return ue(de),re($e=>ue($e))}S.runAndSubscribe=ee;class x{constructor(ue,de){this._observable=ue,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};de||w($e),this.emitter=new $($e),de&&de.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,de){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Q(re,ue){return new x(re,ue).emitter.event}S.fromObservable=Q;function ne(re){return(ue,de,$e)=>{let ye=0,Se=!1;const Re={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(re.reportChanges(),Se&&(Se=!1,ue.call(de)))},handlePossibleChange(){},handleChange(){Se=!0}};re.addObserver(Re),re.reportChanges();const Le={dispose(){re.removeObserver(Re)}};return $e instanceof A.$Tc?$e.add(Le):Array.isArray($e)&&$e.push(Le),Le}}S.fromObservableLight=ne})(C||(e.Event=C={}));class v{static{this.all=new Set}static{this.f=0}constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${v.f++}`,v.all.add(this)}start(w){this.g=new D.$3d,this.listenerCount=w}stop(){if(this.g){const w=this.g.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this.g=void 0}}}e.$5d=v;let m=-1;function f(S){const w=m;return m=S,{dispose(){m=w}}}class h{constructor(w,O=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=O,this.g=0}dispose(){this.f?.clear()}check(w,O){const M=this.threshold;if(M<=0||O<M)return;this.f||(this.f=new Map);const T=this.f.get(w.value)||0;if(this.f.set(w.value,T+1),this.g-=1,this.g<=0){this.g=M*.5;let U,_=0;for(const[G,Z]of this.f)(!U||_<Z)&&(U=G,_=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${_}):`),console.warn(U)}return()=>{const U=this.f.get(w.value)||0;this.f.set(w.value,U-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class u{constructor(w){this.value=w,this.id=p++}}const g=2,l=(S,w)=>{if(S instanceof u)w(S);else for(let O=0;O<S.length;O++){const M=S[O];M&&w(M)}},c=I?new FinalizationRegistry(S=>{typeof S=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(S))}):void 0;class ${constructor(w){this.w=0,this.f=w,this.g=m>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const w=this.t;queueMicrotask(()=>{l(w,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(w,O,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$Uc.None;if(this.m)return A.$Uc.None;O&&(w=w.bind(O));const T=new u(w);let U,_;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=b.create(),U=this.g.check(T.stack,this.w+1)),P&&(T.stack=_??b.create()),this.t?this.t instanceof u?(this.u??=new o,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const G=(0,A.$Sc)(()=>{c?.unregister(G),U?.(),this.x(T)});if(M instanceof A.$Tc?M.add(G):Array.isArray(M)&&M.push(G),c){const Z=new Error().stack.split(`
`).slice(2).join(`
`).trim();c.register(G,Z,G)}return G},this.q}x(w){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,M=O.indexOf(w);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[M]=void 0;const T=this.u.current===this;if(this.w*g<=O.length){let U=0;for(let _=0;_<O.length;_++)O[_]?O[U++]=O[_]:T&&(this.u.end--,U<this.u.i&&this.u.i--);O.length=U}}y(w,O){if(!w)return;const M=this.f?.onListenerError||R.$1;if(!M){w.value(O);return}try{w.value(O)}catch(T){M(T)}}z(w){const O=w.current.t;for(;w.i<w.end;)this.y(O[w.i++],w.value);w.reset()}fire(w){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,w);else{const O=this.u;O.enqueue(this,w,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=$;const i=()=>new o;e.$8d=i;class o{constructor(){this.i=-1,this.end=0}enqueue(w,O,M){this.i=0,this.end=M,this.current=w,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends ${async fireAsync(w,O,M){if(this.t)for(this.h||(this.h=new j.$5c),l(this.t,T=>this.h.push([T.value,w]));this.h.size>0&&!O.isCancellationRequested;){const[T,U]=this.h.shift(),_=[],G={...U,token:O,waitUntil:Z=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");M&&(Z=M(Z,T)),_.push(Z)}};try{T(G)}catch(Z){(0,R.$1)(Z);continue}Object.freeze(_),await Promise.allSettled(_).then(Z=>{for(const V of Z)V.status==="rejected"&&(0,R.$1)(V.reason)})}}}e.$9d=n;class s extends ${get isPaused(){return this.h!==0}constructor(w){super(w),this.h=0,this.s=new j.$5c,this.A=w?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const w=Array.from(this.s);this.s.clear(),super.fire(this.A(w))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(w){this.w&&(this.h!==0?this.s.push(w):super.fire(w))}}e.$0d=s;class t extends s{constructor(w){super(w),this.k=w.delay??100}fire(w){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(w)}}e.$$d=t;class r extends ${constructor(w){super(w),this.h=[],this.k=w?.merge}fire(w){this.hasListeners()&&(this.h.push(w),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}e.$_d=r;class a{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(w){const O={event:w,listener:null};this.h.push(O),this.g&&this.m(O);const M=()=>{this.g&&this.o(O);const T=this.h.indexOf(O);this.h.splice(T,1)};return(0,A.$Sc)((0,N.$db)(M))}j(){this.g=!0,this.h.forEach(w=>this.m(w))}k(){this.g=!1,this.h.forEach(w=>this.o(w))}m(w){w.listener=w.event(O=>this.f.fire(O))}o(w){w.listener?.dispose(),w.listener=null}dispose(){this.f.dispose();for(const w of this.h)w.listener?.dispose();this.h=[]}}e.$ae=a;class y{constructor(w,O,M,T){this.f=new A.$Tc;const U=this.f.add(new a),_=this.f.add(new A.$4c);function G(Z){_.set(Z,U.add(T(Z)))}for(const Z of w)G(Z);this.f.add(O(Z=>{G(Z)})),this.f.add(M(Z=>{_.deleteAndDispose(Z)})),this.event=U.event}dispose(){this.f.dispose()}}e.$be=y;class E{constructor(){this.f=[]}wrapEvent(w){return(O,M,T)=>w(U=>{const _=this.f[this.f.length-1];_?_.push(()=>O.call(M,U)):O.call(M,U)},void 0,T)}bufferEvents(w){const O=[];this.f.push(O);const M=w();return this.f.pop(),O.forEach(T=>T()),M}}e.$ce=E;class k{constructor(){this.f=!1,this.g=C.None,this.h=A.$Uc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(w){this.g=w,this.f&&(this.h.dispose(),this.h=w(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=k}),define(le[26],he([0,1,3]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const N=Object.freeze(function(I,P){const d=setTimeout(I.bind(P),0);return{dispose(){clearTimeout(d)}}});var A;(function(I){function P(d){return d===I.None||d===I.Cancelled||d instanceof j?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}I.isCancellationToken=P,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(A||(e.CancellationToken=A={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new R.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(P){this.f=void 0,this.g=void 0,this.g=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=A.Cancelled}dispose(P=!1){P&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=A.None}}e.$ee=D}),define(le[129],he([0,1,26]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class N{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new R.$ee,P=this.b(I.token);return this.a={promise:P,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.$Pe=N;class A{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const P=JSON.stringify(I);return this.b!==P&&(this.b=P,this.a=this.c(I)),this.a}}e.$Qe=A;class j{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const P=this.b(I);return this.a.set(I,P),P}}e.$Re=j}),define(le[50],he([0,1,7,2]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=A,e.$ge=j,e.$he=D,e.$ie=I,e.$je=d,e.$ke=C,e.$le=v,e.$me=m,e.$ne=f,e.$oe=h,e.$pe=b,e.$qe=p,e.$re=u,e.$se=g,e.$te=l;function A(c){const $=c;return $?typeof $.read=="function":!1}function j(c){const $=c;return $?[$.on,$.pause,$.resume,$.destroy].every(i=>typeof i=="function"):!1}function D(c){const $=c;return $?j($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function I(c,$){return new P(c,$)}class P{constructor($,i){this.e=$,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(i=>i($))}h($){this.c.error.length===0?(0,R.$1)($):this.c.error.slice(0).forEach(i=>i($))}i(){this.c.end.slice(0).forEach($=>$())}on($,i){if(!this.a.destroyed)switch($){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener($,i){if(this.a.destroyed)return;let o;switch($){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(c,$){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return $(i)}function C(c,$,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?$(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}function v(c,$){return new Promise((i,o)=>{const n=[];m(c,{onData:s=>{$&&n.push(s)},onError:s=>{$?o(s):i(void 0)},onEnd:()=>{i($?$(n):void 0)}})})}function m(c,$,i){c.on("error",o=>{i?.isCancellationRequested||$.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||$.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||$.onData(o)})}function f(c,$){return new Promise((i,o)=>{const n=new N.$Tc,s=[],t=y=>{if(s.push(y),s.length>$)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=y=>(n.dispose(),o(y)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,N.$Sc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,N.$Sc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,N.$Sc)(()=>c.removeListener("data",t))),c.on("data",t)})}function h(c,$){const i=I($);return i.end(c),i}function b(){const c=I(()=>{throw new Error("not supported")});return c.end(),c}function p(c){let $=!1;return{read:()=>$?null:($=!0,c)}}function u(c,$,i){const o=I(i);return m(c,{onData:n=>o.write($.data(n)),onError:n=>o.error($.error?$.error(n):n),onEnd:()=>o.end()}),o}function g(c,$,i){let o=!1;return{read:()=>{const n=$.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}function l(c,$,i){let o=!1;const n=I(i);return m($,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}}),define(le[15],he([0,1,53,50]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=d,e.$we=C,e.$xe=v,e.$ye=m,e.$ze=f,e.$Ae=h,e.$Be=b,e.$Ce=p,e.$De=u,e.$Ee=g,e.$Fe=l,e.$Ge=c,e.$He=$,e.$Ie=i,e.$Je=o,e.$Ke=n,e.$Le=s,e.$Me=t,e.$Ne=r,e.$Oe=E;const A=typeof Buffer<"u",j=new R.$V(()=>new Uint8Array(256));let D,I;class P{static alloc(S){return A?new P(Buffer.allocUnsafe(S)):new P(new Uint8Array(S))}static wrap(S){return A&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new P(S)}static fromString(S,w){return!(w?.dontUseNodeBuffer||!1)&&A?new P(Buffer.from(S)):(D||(D=new TextEncoder),new P(D.encode(S)))}static fromByteArray(S){const w=P.alloc(S.length);for(let O=0,M=S.length;O<M;O++)w.buffer[O]=S[O];return w}static concat(S,w){if(typeof w>"u"){w=0;for(let T=0,U=S.length;T<U;T++)w+=S[T].byteLength}const O=P.alloc(w);let M=0;for(let T=0,U=S.length;T<U;T++){const _=S[T];O.set(_,M),M+=_.byteLength}return O}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=P.alloc(this.byteLength);return S.set(this),S}toString(){return A?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(S,w){return new P(this.buffer.subarray(S,w))}set(S,w){if(S instanceof P)this.buffer.set(S.buffer,w);else if(S instanceof Uint8Array)this.buffer.set(S,w);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),w);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,w){f(this.buffer,S,w)}readUInt32LE(S){return h(this.buffer,S)}writeUInt32LE(S,w){b(this.buffer,S,w)}readUInt8(S){return p(this.buffer,S)}writeUInt8(S,w){u(this.buffer,S,w)}indexOf(S,w=0){return d(this.buffer,S instanceof P?S.buffer:S,w)}}e.$ue=P;function d(k,S,w=0){const O=S.byteLength,M=k.byteLength;if(O===0)return 0;if(O===1)return k.indexOf(S[0]);if(O>M-w)return-1;const T=j.value;T.fill(S.length);for(let Z=0;Z<S.length;Z++)T[S[Z]]=S.length-Z-1;let U=w+S.length-1,_=U,G=-1;for(;U<M;)if(k[U]===S[_]){if(_===0){G=U;break}U--,_--}else U+=Math.max(S.length-_,T[k[U]]),_=S.length-1;return G}function C(k,S){return k[S+0]<<0>>>0|k[S+1]<<8>>>0}function v(k,S,w){k[w+0]=S&255,S=S>>>8,k[w+1]=S&255}function m(k,S){return k[S]*2**24+k[S+1]*2**16+k[S+2]*2**8+k[S+3]}function f(k,S,w){k[w+3]=S,S=S>>>8,k[w+2]=S,S=S>>>8,k[w+1]=S,S=S>>>8,k[w]=S}function h(k,S){return k[S+0]<<0>>>0|k[S+1]<<8>>>0|k[S+2]<<16>>>0|k[S+3]<<24>>>0}function b(k,S,w){k[w+0]=S&255,S=S>>>8,k[w+1]=S&255,S=S>>>8,k[w+2]=S&255,S=S>>>8,k[w+3]=S&255}function p(k,S){return k[S]}function u(k,S,w){k[w]=S}function g(k){return N.$je(k,S=>P.concat(S))}function l(k){return N.$qe(k)}function c(k){return N.$le(k,S=>P.concat(S))}async function $(k){return k.ended?P.concat(k.buffer):P.concat([...k.buffer,await c(k.stream)])}function i(k){return N.$oe(k,S=>P.concat(S))}function o(k){return N.$re(k,{data:S=>typeof S=="string"?P.fromString(S):P.wrap(S)},S=>P.concat(S))}function n(k){return N.$ie(S=>P.concat(S),k)}function s(k,S){return N.$se(k,S,w=>P.concat(w))}function t(k,S){return N.$te(k,S,w=>P.concat(w))}function r(k){let S=0,w=0,O=0;const M=new Uint8Array(Math.floor(k.length/4*3)),T=_=>{switch(w){case 3:M[O++]=S|_,w=0;break;case 2:M[O++]=S|_>>>2,S=_<<6,w=3;break;case 1:M[O++]=S|_>>>4,S=_<<4,w=2;break;default:S=_<<2,w=1}};for(let _=0;_<k.length;_++){const G=k.charCodeAt(_);if(G>=65&&G<=90)T(G-65);else if(G>=97&&G<=122)T(G-97+26);else if(G>=48&&G<=57)T(G-48+52);else if(G===43||G===45)T(62);else if(G===47||G===95)T(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${k[_]}`)}}const U=O;for(;w>0;)T(0);return P.wrap(M).slice(0,U)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:k},S=!0,w=!1){const O=w?y:a;let M="";const T=k.byteLength%3;let U=0;for(;U<k.byteLength-T;U+=3){const _=k[U+0],G=k[U+1],Z=k[U+2];M+=O[_>>>2],M+=O[(_<<4|G>>>4)&63],M+=O[(G<<2|Z>>>6)&63],M+=O[Z&63]}if(T===1){const _=k[U+0];M+=O[_>>>2],M+=O[_<<4&63],S&&(M+="==")}else if(T===2){const _=k[U+0],G=k[U+1];M+=O[_>>>2],M+=O[(_<<4|G>>>4)&63],M+=O[G<<2&63],S&&(M+="=")}return M}}),define(le[27],he([0,1,129,53]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.GraphemeBreakType=e.$If=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=A,e.$Ve=D,e.$We=P,e.$Xe=d,e.$Ye=C,e.$Ze=v,e.$1e=m,e.$2e=f,e.$3e=h,e.$4e=b,e.$5e=p,e.$6e=u,e.$7e=g,e.$8e=l,e.$9e=c,e.$0e=$,e.$$e=i,e.$_e=o,e.$af=n,e.$bf=s,e.$cf=t,e.$df=r,e.$ef=a,e.$ff=y,e.$gf=E,e.$hf=k,e.$if=S,e.$jf=w,e.$kf=O,e.$lf=M,e.$mf=T,e.$nf=U,e.$of=_,e.$pf=G,e.$qf=Z,e.$rf=V,e.$sf=K,e.$vf=ae,e.$wf=te,e.$xf=ce,e.$yf=H,e.$zf=F,e.$Af=Y,e.$Cf=J,e.$Df=ee,e.$Ef=x,e.$Ff=Q,e.$Gf=re,e.$Hf=ue,e.$Jf=de,e.$Kf=$e,e.$Lf=ye,e.$Mf=Se,e.$Nf=Re,e.$Of=Le,e.$Pf=fe,e.$Qf=me,e.$Rf=De;function A(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const j=/{(\d+)}/g;function D(oe,...ge){return ge.length===0?oe:oe.replace(j,function(pe,we){const Ee=parseInt(we,10);return isNaN(Ee)||Ee<0||Ee>=ge.length?pe:ge[Ee]})}const I=/{([^}]+)}/g;function P(oe,ge){return Object.keys(ge).length===0?oe:oe.replace(I,(pe,we)=>ge[we]??pe)}function d(oe){return oe.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function C(oe){return oe.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function v(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(oe,ge){let pe=0;const we=ge.charCodeAt(0);for(let Ee=oe.length-1;Ee>=0;Ee--)oe.charCodeAt(Ee)===we&&pe++;return pe}function f(oe,ge,pe="\u2026"){return oe.length<=ge?oe:`${oe.substr(0,ge)}${pe}`}function h(oe,ge,pe="\u2026"){if(oe.length<=ge)return oe;const we=Math.ceil(ge/2)-pe.length/2,Ee=Math.floor(ge/2)-pe.length/2;return`${oe.substr(0,we)}${pe}${oe.substr(oe.length-Ee)}`}function b(oe,ge=" "){const pe=p(oe,ge);return u(pe,ge)}function p(oe,ge){if(!oe||!ge)return oe;const pe=ge.length;if(pe===0||oe.length===0)return oe;let we=0;for(;oe.indexOf(ge,we)===we;)we=we+pe;return oe.substring(we)}function u(oe,ge){if(!oe||!ge)return oe;const pe=ge.length,we=oe.length;if(pe===0||we===0)return oe;let Ee=we,Pe=-1;for(;Pe=oe.lastIndexOf(ge,Ee-1),!(Pe===-1||Pe+pe!==Ee);){if(Pe===0)return"";Ee=Pe}return oe.substring(0,Ee)}function g(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(oe){return oe.replace(/\*/g,"")}function c(oe,ge,pe={}){if(!oe)throw new Error("Cannot create regex from empty string");ge||(oe=v(oe)),pe.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let we="";return pe.global&&(we+="g"),pe.matchCase||(we+="i"),pe.multiline&&(we+="m"),pe.unicode&&(we+="u"),new RegExp(oe,we)}function $(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function i(oe){return oe.split(/\r\n|\r|\n/)}function o(oe){const ge=[],pe=oe.split(/(\r\n|\r|\n)/);for(let we=0;we<Math.ceil(pe.length/2);we++)ge.push(pe[2*we]+(pe[2*we+1]??""));return ge}function n(oe){for(let ge=0,pe=oe.length;ge<pe;ge++){const we=oe.charCodeAt(ge);if(we!==32&&we!==9)return ge}return-1}function s(oe,ge=0,pe=oe.length){for(let we=ge;we<pe;we++){const Ee=oe.charCodeAt(we);if(Ee!==32&&Ee!==9)return oe.substring(ge,we)}return oe.substring(ge,pe)}function t(oe,ge=oe.length-1){for(let pe=ge;pe>=0;pe--){const we=oe.charCodeAt(pe);if(we!==32&&we!==9)return pe}return-1}function r(oe,ge,pe){const we=[];let Ee=0;for(const Pe of oe.matchAll(ge)){if(we.push(oe.slice(Ee,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Ee=Pe.index+Pe[0].length,we.push(pe(Pe[0],...Pe.slice(1),Pe.index,oe,Pe.groups))}return we.push(oe.slice(Ee)),Promise.all(we).then(Pe=>Pe.join(""))}function a(oe,ge){return oe<ge?-1:oe>ge?1:0}function y(oe,ge,pe=0,we=oe.length,Ee=0,Pe=ge.length){for(;pe<we&&Ee<Pe;pe++,Ee++){const We=oe.charCodeAt(pe),Be=ge.charCodeAt(Ee);if(We<Be)return-1;if(We>Be)return 1}const Oe=we-pe,Ne=Pe-Ee;return Oe<Ne?-1:Oe>Ne?1:0}function E(oe,ge){return k(oe,ge,0,oe.length,0,ge.length)}function k(oe,ge,pe=0,we=oe.length,Ee=0,Pe=ge.length){for(;pe<we&&Ee<Pe;pe++,Ee++){let We=oe.charCodeAt(pe),Be=ge.charCodeAt(Ee);if(We===Be)continue;if(We>=128||Be>=128)return y(oe.toLowerCase(),ge.toLowerCase(),pe,we,Ee,Pe);w(We)&&(We-=32),w(Be)&&(Be-=32);const Te=We-Be;if(Te!==0)return Te}const Oe=we-pe,Ne=Pe-Ee;return Oe<Ne?-1:Oe>Ne?1:0}function S(oe){return oe>=48&&oe<=57}function w(oe){return oe>=97&&oe<=122}function O(oe){return oe>=65&&oe<=90}function M(oe,ge){return oe.length===ge.length&&k(oe,ge)===0}function T(oe,ge){const pe=ge.length;return ge.length>oe.length?!1:k(oe,ge,0,pe)===0}function U(oe,ge){const pe=Math.min(oe.length,ge.length);let we;for(we=0;we<pe;we++)if(oe.charCodeAt(we)!==ge.charCodeAt(we))return we;return pe}function _(oe,ge){const pe=Math.min(oe.length,ge.length);let we;const Ee=oe.length-1,Pe=ge.length-1;for(we=0;we<pe;we++)if(oe.charCodeAt(Ee-we)!==ge.charCodeAt(Pe-we))return we;return pe}function G(oe){return 55296<=oe&&oe<=56319}function Z(oe){return 56320<=oe&&oe<=57343}function V(oe,ge){return(oe-55296<<10)+(ge-56320)+65536}function K(oe,ge,pe){const we=oe.charCodeAt(pe);if(G(we)&&pe+1<ge){const Ee=oe.charCodeAt(pe+1);if(Z(Ee))return V(we,Ee)}return we}function W(oe,ge){const pe=oe.charCodeAt(ge-1);if(Z(pe)&&ge>1){const we=oe.charCodeAt(ge-2);if(G(we))return V(we,pe)}return pe}class B{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=W(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=K(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$tf=B;class ie{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new B(ge,pe)}nextGraphemeLength(){const ge=Ie.getInstance(),pe=this.c,we=pe.offset;let Ee=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Pe=pe.offset,Oe=ge.getGraphemeBreakType(pe.nextCodePoint());if(be(Ee,Oe)){pe.setOffset(Pe);break}Ee=Oe}return pe.offset-we}prevGraphemeLength(){const ge=Ie.getInstance(),pe=this.c,we=pe.offset;let Ee=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Pe=pe.offset,Oe=ge.getGraphemeBreakType(pe.prevCodePoint());if(be(Oe,Ee)){pe.setOffset(Pe);break}Ee=Oe}return we-pe.offset}eol(){return this.c.eol()}}e.$uf=ie;function ae(oe,ge){return new ie(oe,ge).nextGraphemeLength()}function te(oe,ge){return new ie(oe,ge).prevGraphemeLength()}function ce(oe,ge){ge>0&&Z(oe.charCodeAt(ge))&&ge--;const pe=ge+ae(oe,ge);return[pe-te(oe,pe),pe]}function H(oe){const ge=new ie(oe);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let q;function L(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(oe){return q||(q=L()),q.test(oe)}const z=/^[\t\n\r\x20-\x7E]*$/;function Y(oe){return z.test(oe)}e.$Bf=/[\u2028\u2029]/;function J(oe){return e.$Bf.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function x(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function Q(oe,ge,pe=""){const we=oe.trimStart();if(we.length<ge)return we;const Ee=/\b/g;let Pe=0;for(;Ee.test(we)&&!(we.length-Ee.lastIndex<ge);)Pe=Ee.lastIndex,Ee.lastIndex+=1;return Pe===0?we:pe+we.substring(Pe).trimStart()}const ne=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*re(oe){let ge=0;for(const pe of oe.matchAll(ne))ge!==pe.index&&(yield{isCode:!1,str:oe.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==oe.length&&(yield{isCode:!1,str:oe.substring(ge)})}function ue(oe){return oe&&(oe=oe.replace(ne,"")),oe}e.$If="\uFEFF";function de(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function $e(oe){return de(oe)?oe.substr(1):oe}function ye(oe,ge){if(!oe||!ge||oe.length<ge.length)return!1;const pe=ge.length,we=oe.toLowerCase();let Ee=0,Pe=-1;for(;Ee<pe;){const Oe=we.indexOf(ge[Ee],Pe+1);if(Oe<0)return!1;Pe=Oe,Ee++}return!0}function Se(oe,ge=!1){return oe?(ge&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Re(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function Le(oe,ge=1){if(ge===0)return"";let pe=-1;do pe=oe.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?oe:(oe[pe-1]==="\r"&&pe--,oe.substr(0,pe))}function fe(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function me(oe){return Ie.getInstance().getGraphemeBreakType(oe)}function be(oe,ge){return oe===0?ge!==5&&ge!==7:oe===2&&ge===3?!1:oe===4||oe===2||oe===3||ge===4||ge===2||ge===3?!0:!(oe===8&&(ge===8||ge===9||ge===11||ge===12)||(oe===11||oe===9)&&(ge===9||ge===10)||(oe===12||oe===10)&&ge===10||ge===5||ge===13||ge===7||oe===1||oe===13&&ge===14||oe===6&&ge===6)}var Ce;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const pe=this.d,we=pe.length/3;let Ee=1;for(;Ee<=we;)if(ge<pe[3*Ee])Ee=2*Ee;else if(ge>pe[3*Ee+1])Ee=2*Ee+1;else return pe[3*Ee+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(oe,ge){if(oe===0)return 0;const pe=qe(oe,ge);if(pe!==void 0)return pe;const we=new B(ge,oe);return we.prevCodePoint(),we.offset}function qe(oe,ge){const pe=new B(ge,oe);let we=pe.prevCodePoint();for(;Fe(we)||we===65039||we===8419;){if(pe.offset===0)return;we=pe.prevCodePoint()}if(!x(we))return;let Ee=pe.offset;return Ee>0&&pe.prevCodePoint()===8205&&(Ee=pe.offset),Ee}function Fe(oe){return 127995<=oe&&oe<=127999}var Ue;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.$Sf="\xA0";class ze{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$Qe(ge=>{function pe(Te){const Xe=new Map;for(let Ge=0;Ge<Te.length;Ge+=2)Xe.set(Te[Ge],Te[Ge+1]);return Xe}function we(Te,Xe){const Ge=new Map(Te);for(const[_e,tt]of Xe)Ge.set(_e,tt);return Ge}function Ee(Te,Xe){if(!Te)return Xe;const Ge=new Map;for(const[_e,tt]of Te)Xe.has(_e)&&Ge.set(_e,tt);return Ge}const Pe=this.c.value;let Oe=ge.filter(Te=>!Te.startsWith("_")&&Te in Pe);Oe.length===0&&(Oe=["_default"]);let Ne;for(const Te of Oe){const Xe=pe(Pe[Te]);Ne=Ee(Ne,Xe)}const We=pe(Pe._common),Be=we(We,Ne);return new ze(Be)})}static getInstance(ge){return ze.d.get(Array.from(ge))}static{this.e=new N.$V(()=>Object.keys(ze.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return ze.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Tf=ze;class Ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ae.c())),this.d}static isInvisibleCharacter(ge){return Ae.e().has(ge)}static get codePoints(){return Ae.e()}}e.$Uf=Ae}),define(le[54],he([0,1,27]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=N,e.$0i=A,e.$$i=j,e.$_i=I,e.$bj=b;function N(u){return A(u,0)}function A(u,g){switch(typeof u){case"object":return u===null?j(349,g):Array.isArray(u)?P(u,g):d(u,g);case"string":return I(u,g);case"boolean":return D(u,g);case"number":return j(u,g);case"undefined":return j(937,g);default:return j(617,g)}}function j(u,g){return(g<<5)-g+u|0}function D(u,g){return j(u?433:863,g)}function I(u,g){g=j(149417,g);for(let l=0,c=u.length;l<c;l++)g=j(u.charCodeAt(l),g);return g}function P(u,g){return g=j(104579,g),u.reduce((l,c)=>A(c,l),g)}function d(u,g){return g=j(181387,g),Object.keys(u).sort().reduce((l,c)=>(l=I(c,l),A(u[c],l)),g)}class C{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=A(g,this.g),this.g}}e.$aj=C;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function m(u,g,l=32){const c=l-g,$=~((1<<c)-1);return(u<<g|($&u)>>>c)>>>0}function f(u,g=0,l=u.byteLength,c=0){for(let $=0;$<l;$++)u[g+$]=c}function h(u,g,l="0"){for(;u.length<g;)u=l+u;return u}function b(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(l=>l.toString(16).padStart(2,"0")).join(""):h((u>>>0).toString(16),g/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const l=g.length;if(l===0)return;const c=this.p;let $=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=g.charCodeAt(0),n=0);;){let s=o;if(R.$pf(o))if(n+1<l){const t=g.charCodeAt(n+1);R.$qf(t)?(n++,s=R.$rf(o,t)):s=65533}else{i=o;break}else R.$qf(o)&&(s=65533);if($=this.w(c,$,s),n++,n<l)o=g.charCodeAt(n);else break}this.r=$,this.u=i}w(g,l,c){return c<128?g[l++]=c:c<2048?(g[l++]=192|(c&1984)>>>6,g[l++]=128|(c&63)>>>0):c<65536?(g[l++]=224|(c&61440)>>>12,g[l++]=128|(c&4032)>>>6,g[l++]=128|(c&63)>>>0):(g[l++]=240|(c&1835008)>>>18,g[l++]=128|(c&258048)>>>12,g[l++]=128|(c&4032)>>>6,g[l++]=128|(c&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=p.g,l=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,l.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,m(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let c=this.h,$=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=$&i|~$&o,t=1518500249):a<40?(s=$^i^o,t=1859775393):a<60?(s=$&i|$&o|i&o,t=2400959708):(s=$^i^o,t=3395469782),r=m(c,5)+s+n+t+g.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m($,30),$=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+$&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$cj=p}),define(le[88],he([0,1,27]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const j="error",D="warning",I="warn",P="info",d="ignore";function C(m){return m?R.$lf(j,m)?A.Error:R.$lf(D,m)||R.$lf(I,m)?A.Warning:R.$lf(P,m)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function v(m){switch(m){case A.Error:return j;case A.Warning:return D;case A.Info:return P;default:return d}}A.toString=v}(N||(N={})),e.default=N}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(le[51],he([0,1,17,27]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class A{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const h=f.charCodeAt(0),b=this.b.charCodeAt(this.c);return h-b}value(){return this.b[this.c]}}e.$ki=A;class j{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,N.$ff)(f,this.b,0,f.length,this.c,this.d):(0,N.$hf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=j;class D{constructor(f=!0,h=!0){this.f=f,this.g=h}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let h=f.length-1;h>=0;h--,this.c--){const b=this.b.charCodeAt(h);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,N.$ff)(f,this.b,0,f.length,this.d,this.e):(0,N.$hf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=D;var I;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(I||(I={}));class P{constructor(f,h){this.f=f,this.g=h,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,N.$gf)(f,this.c.scheme);if(this.d[this.e]===2)return(0,N.$gf)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,N.$ef)(f,this.c.query);if(this.d[this.e]===5)return(0,N.$ef)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=P;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class v{static forUris(f=()=>!1,h=()=>!1){return new v(new P(f,h))}static forPaths(f=!1){return new v(new D(void 0,!f))}static forStrings(){return new v(new A)}static forConfigKeys(){return new v(new j)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,h){if(h){const b=h.slice(0);(0,R.$Xb)(b);for(const p of b)this.set(p,f)}else{const b=f.slice(0);(0,R.$Xb)(b);for(const p of b)this.set(p[0],p[1])}}set(f,h){const b=this.b.reset(f);let p;this.c||(this.c=new d,this.c.segment=b.value());const u=[];for(p=this.c;;){const l=b.cmp(p.segment);if(l>0)p.left||(p.left=new d,p.left.segment=b.value()),u.push([-1,p]),p=p.left;else if(l<0)p.right||(p.right=new d,p.right.segment=b.value()),u.push([1,p]),p=p.right;else if(b.hasNext())b.next(),p.mid||(p.mid=new d,p.mid.segment=b.value()),u.push([0,p]),p=p.mid;else break}const g=p.value;p.value=h,p.key=f;for(let l=u.length-1;l>=0;l--){const c=u[l][1];c.updateHeight();const $=c.balanceFactor();if($<-1||$>1){const i=u[l][0],o=u[l+1][0];if(i===1&&o===1)u[l][1]=c.rotateLeft();else if(i===-1&&o===-1)u[l][1]=c.rotateRight();else if(i===1&&o===-1)c.right=u[l+1][1]=u[l+1][1].rotateRight(),u[l][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=u[l+1][1]=u[l+1][1].rotateLeft(),u[l][1]=c.rotateRight();else throw new Error;if(l>0)switch(u[l-1][0]){case-1:u[l-1][1].left=u[l][1];break;case 1:u[l-1][1].right=u[l][1];break;case 0:u[l-1][1].mid=u[l][1];break}else this.c=u[0][1]}}return g}get(f){return this.d(f)?.value}d(f){const h=this.b.reset(f);let b=this.c;for(;b;){const p=h.cmp(b.segment);if(p>0)b=b.left;else if(p<0)b=b.right;else if(h.hasNext())h.next(),b=b.mid;else break}return b}has(f){const h=this.d(f);return!(h?.value===void 0&&h?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,h){const b=this.b.reset(f),p=[];let u=this.c;for(;u;){const g=b.cmp(u.segment);if(g>0)p.push([-1,u]),u=u.left;else if(g<0)p.push([1,u]),u=u.right;else if(b.hasNext())b.next(),p.push([0,u]),u=u.mid;else break}if(u){if(h?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:l,value:c,segment:$}=g;this.e(g.key,!1),u.key=l,u.value=c,u.segment=$}}else{const g=u.left??u.right;if(p.length>0){const[l,c]=p[p.length-1];switch(l){case-1:c.left=g;break;case 0:c.mid=g;break;case 1:c.right=g;break}}else this.c=g}for(let g=p.length-1;g>=0;g--){const l=p[g][1];l.updateHeight();const c=l.balanceFactor();if(c>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),p[g][1]=l.rotateLeft()):c<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),p[g][1]=l.rotateRight()),g>0)switch(p[g-1][0]){case-1:p[g-1][1].left=p[g][1];break;case 1:p[g-1][1].right=p[g][1];break;case 0:p[g-1][1].mid=p[g][1];break}else this.c=p[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const h=this.b.reset(f);let b=this.c,p;for(;b;){const u=h.cmp(b.segment);if(u>0)b=b.left;else if(u<0)b=b.right;else if(h.hasNext())h.next(),p=b.value||p,b=b.mid;else break}return b&&b.value||p}findSuperstr(f){return this.g(f,!1)}g(f,h){const b=this.b.reset(f);let p=this.c;for(;p;){const u=b.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(b.hasNext())b.next(),p=p.mid;else return p.mid?this.h(p.mid):h?p.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[h,b]of this)f(b,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const h=[];return this.j(f,h),h[Symbol.iterator]()}j(f,h){f&&(f.left&&this.j(f.left,h),f.value&&h.push([f.key,f.value]),f.mid&&this.j(f.mid,h),f.right&&this.j(f.right,h))}_isBalanced(){const f=h=>{if(!h)return!0;const b=h.balanceFactor();return b<-1||b>1?!1:f(h.left)&&f(h.right)};return f(this.c)}}e.$oi=v}),define(le[13],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=R,e.$Wf=N,e.$Xf=A,e.$Yf=j,e.$Zf=D,e.$1f=I,e.$2f=P,e.$3f=d,e.$4f=C,e.$5f=v,e.$6f=m,e.$7f=f,e.$8f=h,e.$9f=p,e.$0f=u,e.$$f=g,e.$_f=l,e.$ag=c;function R($){return typeof $=="string"}function N($){return Array.isArray($)&&$.every(i=>R(i))}function A($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}function j($){const i=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof i}function D($){return typeof $=="number"&&!isNaN($)}function I($){return!!$&&typeof $[Symbol.iterator]=="function"}function P($){return $===!0||$===!1}function d($){return typeof $>"u"}function C($){return!v($)}function v($){return d($)||$===null}function m($,i){if(!$)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function f($){if(v($))throw new Error("Assertion Failed: argument is undefined or null");return $}function h(...$){const i=[];for(let o=0;o<$.length;o++){const n=$[o];if(v(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}const b=Object.prototype.hasOwnProperty;function p($){if(!A($))return!1;for(const i in $)if(b.call($,i))return!1;return!0}function u($){return typeof $=="function"}function g(...$){return $.length>0&&$.every(u)}function l($,i){const o=Math.min($.length,i.length);for(let n=0;n<o;n++)c($[n],i[n])}function c($,i){if(R(i)){if(typeof $!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if($ instanceof i)return}catch{}if(!v($)&&$.constructor===i||i.length===1&&i.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=N,e.$Pn=A,e.$Qn=D,e.$Rn=P,e.$Sn=d,e.$Tn=C,e.$Un=v,e.$Vn=m,e.$Wn=f,e.$Xn=h,e.$Yn=b,e.$Zn=p;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([l,c])=>{g[l]=c&&typeof c=="object"?N(c):c}),g}function A(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const l=g.shift();Object.freeze(l);for(const c in l)if(j.call(l,c)){const $=l[c];typeof $=="object"&&!Object.isFrozen($)&&!(0,R.$Yf)($)&&g.push($)}}return u}const j=Object.prototype.hasOwnProperty;function D(u,g){return I(u,g,new Set)}function I(u,g,l){if((0,R.$5f)(u))return u;const c=g(u);if(typeof c<"u")return c;if(Array.isArray(u)){const $=[];for(const i of u)$.push(I(i,g,l));return $}if((0,R.$Xf)(u)){if(l.has(u))throw new Error("Cannot clone recursive data-structure");l.add(u);const $={};for(const i in u)j.call(u,i)&&($[i]=I(u[i],g,l));return l.delete(u),$}return u}function P(u,g,l=!0){return(0,R.$Xf)(u)?((0,R.$Xf)(g)&&Object.keys(g).forEach(c=>{c in u?l&&((0,R.$Xf)(u[c])&&(0,R.$Xf)(g[c])?P(u[c],g[c],l):u[c]=g[c]):u[c]=g[c]}),u):g}function d(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let l,c;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(l=0;l<u.length;l++)if(!d(u[l],g[l]))return!1}else{const $=[];for(c in u)$.push(c);$.sort();const i=[];for(c in g)i.push(c);if(i.sort(),!d($,i))return!1;for(l=0;l<$.length;l++)if(!d(u[$[l]],g[$[l]]))return!1}return!0}function C(u){const g=new Set;return JSON.stringify(u,(l,c)=>{if((0,R.$Xf)(c)||Array.isArray(c)){if(g.has(c))return"[Circular]";g.add(c)}return c})}function v(u,g){const l=Object.create(null);return!u||!g||Object.keys(g).forEach($=>{const i=u[$],o=g[$];d(i,o)||(l[$]=o)}),l}function m(u,g){const l=g.toLowerCase(),c=Object.keys(u).find($=>$.toLowerCase()===l);return c?u[c]:u[g]}function f(u,g){const l=Object.create(null);for(const[c,$]of Object.entries(u))g(c,$)&&(l[c]=$);return l}function h(u){let g=[];for(;Object.prototype!==u;)g=g.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return g}function b(u){const g=[];for(const l of h(u))typeof u[l]=="function"&&g.push(l);return g}function p(u,g){const l=$=>function(){const i=Array.prototype.slice.call(arguments,0);return g($,i)},c={};for(const $ of u)c[$]=l($);return c}}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=N;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return R.test(A)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(I){for(let P=0;P<I.length;P++)I[P]=Math.floor(Math.random()*256);return I};const j=new Uint8Array(16),D=[];for(let I=0;I<256;I++)D.push(I.toString(16).padStart(2,"0"));return function(){A(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let P=0,d="";return d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d}}()}),define(le[131],he([0,1,37]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=j;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(D){const I=D.replace(/\-/g,":").toLowerCase();return!N.has(I)}function j(){const D=(0,R.networkInterfaces)();for(const I in D){const P=D[I];if(P){for(const{mac:d}of P)if(A(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[132],he([0,1,273,15]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6V=void 0;class A extends R.Transform{constructor(D){if(super(),typeof D=="number")this.b=D,this.c=1;else{const I=Buffer.isBuffer(D)?D:Buffer.from(D);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(D,I,P){this.a?this.a=Buffer.concat([this.a,D]):this.a=D;let d=0;for(;d<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,N.$ve)(this.a,this.b,d);if(C===-1)break;this.push(this.a.slice(d,C+this.c)),d=C+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),P()}_flush(D){this.a&&this.push(this.a),D()}}e.$6V=A}),define(le[133],he([0,1,64]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hg=void 0,e.$Gg=N,e.$Ig=j;function N(I,P,d,C=1){let v=!1;return new Promise(m=>{const f=setTimeout(()=>{if(!v)return v=!0,m(0)},d);A(I,P,C,h=>{if(!v)return v=!0,clearTimeout(f),m(h)})})}function A(I,P,d,C){if(P===0)return C(0);const v=new R.Socket;v.once("connect",()=>(D(v),A(I+d,P-1,d,C))),v.once("data",()=>{}),v.once("error",m=>(D(v),m.code!=="ECONNREFUSED"?A(I+d,P-1,d,C):C(I))),v.connect(I,"127.0.0.1")}e.$Hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(I,P,d,C="127.0.0.1"){let v=!1,m,f=1;const h=R.createServer({pauseOnConnect:!0});function b(p,u){v||(v=!0,h.removeAllListeners(),h.close(),m&&clearTimeout(m),u(p))}return new Promise(p=>{m=setTimeout(()=>{b(0,p)},d),h.on("listening",()=>{b(I,p)}),h.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<P?(I++,f++,h.listen(I,C)):b(0,p)}),h.on("close",()=>{b(0,p)}),h.listen(I,C)})}function D(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(P){console.error(P)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lW=R;function R(N){return!!N.parentPort}}),define(le[135],he([11,10]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=d,e.$Om=C,e.$Pm=v;const N=60,A=N*60,j=A*24,D=j*7,I=j*30,P=j*365;function d(m,f,h,b){typeof m!="number"&&(m=m.getTime());const p=Math.round((new Date().getTime()-m)/1e3);if(p<-30)return(0,R.localize)(0,null,d(new Date().getTime()+p*1e3,!1));if(!b&&p<30)return(0,R.localize)(1,null);let u;return p<N?(u=p,f?u===1?h?(0,R.localize)(2,null,u):(0,R.localize)(3,null,u):h?(0,R.localize)(4,null,u):(0,R.localize)(5,null,u):u===1?h?(0,R.localize)(6,null,u):(0,R.localize)(7,null,u):h?(0,R.localize)(8,null,u):(0,R.localize)(9,null,u)):p<A?(u=Math.floor(p/N),f?u===1?h?(0,R.localize)(10,null,u):(0,R.localize)(11,null,u):h?(0,R.localize)(12,null,u):(0,R.localize)(13,null,u):u===1?h?(0,R.localize)(14,null,u):(0,R.localize)(15,null,u):h?(0,R.localize)(16,null,u):(0,R.localize)(17,null,u)):p<j?(u=Math.floor(p/A),f?u===1?h?(0,R.localize)(18,null,u):(0,R.localize)(19,null,u):h?(0,R.localize)(20,null,u):(0,R.localize)(21,null,u):u===1?h?(0,R.localize)(22,null,u):(0,R.localize)(23,null,u):h?(0,R.localize)(24,null,u):(0,R.localize)(25,null,u)):p<D?(u=Math.floor(p/j),f?u===1?(0,R.localize)(26,null,u):(0,R.localize)(27,null,u):u===1?(0,R.localize)(28,null,u):(0,R.localize)(29,null,u)):p<I?(u=Math.floor(p/D),f?u===1?h?(0,R.localize)(30,null,u):(0,R.localize)(31,null,u):h?(0,R.localize)(32,null,u):(0,R.localize)(33,null,u):u===1?h?(0,R.localize)(34,null,u):(0,R.localize)(35,null,u):h?(0,R.localize)(36,null,u):(0,R.localize)(37,null,u)):p<P?(u=Math.floor(p/I),f?u===1?h?(0,R.localize)(38,null,u):(0,R.localize)(39,null,u):h?(0,R.localize)(40,null,u):(0,R.localize)(41,null,u):u===1?h?(0,R.localize)(42,null,u):(0,R.localize)(43,null,u):h?(0,R.localize)(44,null,u):(0,R.localize)(45,null,u)):(u=Math.floor(p/P),f?u===1?h?(0,R.localize)(46,null,u):(0,R.localize)(47,null,u):h?(0,R.localize)(48,null,u):(0,R.localize)(49,null,u):u===1?h?(0,R.localize)(50,null,u):(0,R.localize)(51,null,u):h?(0,R.localize)(52,null,u):(0,R.localize)(53,null,u))}function C(m,f){const h=Math.abs(m/1e3);return h<1?f?(0,R.localize)(54,null,m):(0,R.localize)(55,null,m):h<N?f?(0,R.localize)(56,null,Math.round(m)/1e3):(0,R.localize)(57,null,Math.round(m)/1e3):h<A?f?(0,R.localize)(58,null,Math.round(m/(1e3*N))):(0,R.localize)(59,null,Math.round(m/(1e3*N))):h<j?f?(0,R.localize)(60,null,Math.round(m/(1e3*A))):(0,R.localize)(61,null,Math.round(m/(1e3*A))):(0,R.localize)(62,null,Math.round(m/(1e3*j)))}function v(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[136],he([11,10]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,13,136]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=P,e.$7i=d,e.$8i=C;function j(v,m){return m&&(v.stack||v.stacktrace)?A.localize(0,null,I(v),D(v.stack)||D(v.stacktrace)):I(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function I(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?A.localize(1,null,v.message):v.message||A.localize(2,null)}function P(v=null,m=!1){if(!v)return A.localize(3,null);if(Array.isArray(v)){const f=R.$Hb(v),h=P(f[0],m);return f.length>1?A.localize(4,null,h,f.length):h}if(N.$Vf(v))return v;if(v.detail){const f=v.detail;if(f.error)return j(f.error,m);if(f.exception)return j(f.exception,m)}return v.stack?j(v,m):v.message?v.message:A.localize(5,null)}function d(v){const m=v;return m instanceof Error&&Array.isArray(m.actions)}function C(v,m){let f;return typeof v=="string"?f=new Error(v):f=v,f.actions=m,f}}),define(le[137],he([11,10]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=N;function N(A){switch(A){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}}),define(le[139],he([11,10]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=y,e.$J=E,e.$g="en";let N=!1,A=!1,j=!1,D=!1,I=!1,P=!1,d=!1,C=!1,v=!1,m=!1,f,h=e.$g,b=e.$g,p,u;const g=globalThis;let l;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?l=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const c=typeof l?.versions?.electron=="string",$=c&&l?.type==="renderer";if(typeof l=="object"){N=l.platform==="win32",A=l.platform==="darwin",j=l.platform==="linux",D=j&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,d=c,v=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,h=e.$g;const k=l.env.VSCODE_NLS_CONFIG;if(k)try{const S=JSON.parse(k),w=S.availableLanguages["*"];f=S.locale,b=S.osLocale,h=w||e.$g,p=S._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!$?(u=navigator.userAgent,N=u.indexOf("Windows")>=0,A=u.indexOf("Macintosh")>=0,C=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=u.indexOf("Linux")>=0,m=u?.indexOf("Mobi")>=0,P=!0,f=R.getConfiguredDefaultLocale(R.localize(0,null))||e.$g,h=f,b=navigator.language):console.error("Unable to resolve platform.");var i;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;A?n=1:N?n=3:j&&(n=2),e.$i=N,e.$j=A,e.$k=j,e.$l=D,e.$m=I,e.$n=d,e.$o=P,e.$p=P&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=C,e.$s=m,e.$t=v,e.$u=n,e.$v=u,e.$w=h;var s;(function(k){function S(){return e.$w}k.value=S;function w(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=w;function O(){return e.$w==="en"}k.isDefault=O})(s||(e.Language=s={})),e.$x=f,e.$y=b,e.$z=p,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const k=[];g.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let O=0,M=k.length;O<M;O++){const T=k[O];if(T.id===w.data.vscodeScheduleAsyncWork){k.splice(O,1),T.callback();return}}});let S=0;return w=>{const O=++S;k.push({id:O,callback:w}),g.postMessage({vscodeScheduleAsyncWork:O},"*")}}return k=>setTimeout(k)})();var t;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=A||C?2:N?1:3;let r=!0,a=!1;function y(){if(!a){a=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,r=new Uint16Array(k.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function E(k){return parseFloat(k)>=20}}),define(le[36],he([0,1,5]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const j=A.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return R.$i?"win32":R.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(le[140],he([0,1,36]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MV=D;var N;(function(I){I.UNKNOWN="UNKNOWN",I.CINNAMON="CINNAMON",I.DEEPIN="DEEPIN",I.GNOME="GNOME",I.KDE3="KDE3",I.KDE4="KDE4",I.KDE5="KDE5",I.KDE6="KDE6",I.PANTHEON="PANTHEON",I.UNITY="UNITY",I.XFCE="XFCE",I.UKUI="UKUI",I.LXQT="LXQT"})(N||(N={}));const A="XDG_CURRENT_DESKTOP",j="KDE_SESSION_VERSION";function D(){const I=R.env[A];if(I){const d=I.split(":").map(C=>C.trim()).filter(C=>C.length>0);for(const C of d)switch(C){case"Unity":{const v=R.env.DESKTOP_SESSION;return v&&v.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const v=R.env[j];return v==="5"?N.KDE5:v==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const P=R.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return j in R.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?N.GNOME:"KDE_FULL_SESSION"in R.env?j in R.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(le[14],he([0,1,36]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,A=97,j=90,D=122,I=46,P=47,d=92,C=58,v=63;class m extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function h(i,o){if(typeof i!="string")throw new m(o,"string",i)}const b=R.$ec==="win32";function p(i){return i===P||i===d}function u(i){return i===P}function g(i){return i>=N&&i<=j||i>=A&&i<=D}function l(i,o,n,s){let t="",r=0,a=-1,y=0,E=0;for(let k=0;k<=i.length;++k){if(k<i.length)E=i.charCodeAt(k);else{if(s(E))break;E=P}if(s(E)){if(!(a===k-1||y===1))if(y===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==I||t.charCodeAt(t.length-2)!==I){if(t.length>2){const S=t.lastIndexOf(n);S===-1?(t="",r=0):(t=t.slice(0,S),r=t.length-1-t.lastIndexOf(n)),a=k,y=0;continue}else if(t.length!==0){t="",r=0,a=k,y=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,k)}`:t=i.slice(a+1,k),r=k-a-1;a=k,y=0}else E===I&&y!==-1?++y:y=-1}return t}function c(i,o){f(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$gc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],h(r,"path"),r.length===0)continue}else o.length===0?r=R.cwd():(r=R.env[`=${o}`]||R.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${o}\\`));const a=r.length;let y=0,E="",k=!1;const S=r.charCodeAt(0);if(a===1)p(S)&&(y=1,k=!0);else if(p(S))if(k=!0,p(r.charCodeAt(1))){let w=2,O=w;for(;w<a&&!p(r.charCodeAt(w));)w++;if(w<a&&w!==O){const M=r.slice(O,w);for(O=w;w<a&&p(r.charCodeAt(w));)w++;if(w<a&&w!==O){for(O=w;w<a&&!p(r.charCodeAt(w));)w++;(w===a||w!==O)&&(E=`\\\\${M}\\${r.slice(O,w)}`,y=w)}}}else y=1;else g(S)&&r.charCodeAt(1)===C&&(E=r.slice(0,2),y=2,a>2&&p(r.charCodeAt(2))&&(k=!0,y=3));if(E.length>0)if(o.length>0){if(E.toLowerCase()!==o.toLowerCase())continue}else o=E;if(s){if(o.length>0)break}else if(n=`${r.slice(y)}\\${n}`,s=k,k&&o.length>0)break}return n=l(n,!s,"\\",p),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){h(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return u(r)?"\\":i;if(p(r))if(t=!0,p(i.charCodeAt(1))){let y=2,E=y;for(;y<o&&!p(i.charCodeAt(y));)y++;if(y<o&&y!==E){const k=i.slice(E,y);for(E=y;y<o&&p(i.charCodeAt(y));)y++;if(y<o&&y!==E){for(E=y;y<o&&!p(i.charCodeAt(y));)y++;if(y===o)return`\\\\${k}\\${i.slice(E)}\\`;y!==E&&(s=`\\\\${k}\\${i.slice(E,y)}`,n=y)}}}else n=1;else g(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,o>2&&p(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?l(i.slice(n),!t,"\\",p):"";return a.length===0&&!t&&(a="."),a.length>0&&p(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){h(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return p(n)||o>2&&g(n)&&i.charCodeAt(1)===C&&p(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];h(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&p(n.charCodeAt(0))){++t;const r=n.length;r>1&&p(n.charCodeAt(1))&&(++t,r>2&&(p(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&p(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$gc.normalize(o)},relative(i,o){if(h(i,"from"),h(o,"to"),i===o)return"";const n=e.$gc.resolve(i),s=e.$gc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===d;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===d;)r--;const a=r-t;let y=0;for(;y<o.length&&o.charCodeAt(y)===d;)y++;let E=o.length;for(;E-1>y&&o.charCodeAt(E-1)===d;)E--;const k=E-y,S=a<k?a:k;let w=-1,O=0;for(;O<S;O++){const T=i.charCodeAt(t+O);if(T!==o.charCodeAt(y+O))break;T===d&&(w=O)}if(O!==S){if(w===-1)return s}else{if(k>S){if(o.charCodeAt(y+O)===d)return s.slice(y+O+1);if(O===2)return s.slice(y+O)}a>S&&(i.charCodeAt(t+O)===d?w=O:O===2&&(w=3)),w===-1&&(w=0)}let M="";for(O=t+w+1;O<=r;++O)(O===r||i.charCodeAt(O)===d)&&(M+=M.length===0?"..":"\\..");return y+=w,M.length>0?`${M}${s.slice(y,E)}`:(s.charCodeAt(y)===d&&++y,s.slice(y,E))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$gc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===d){if(o.charCodeAt(1)===d){const n=o.charCodeAt(2);if(n!==v&&n!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===d)return`\\\\?\\${o}`;return i},dirname(i){h(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return p(t)?i:".";if(p(t)){if(n=s=1,p(i.charCodeAt(1))){let y=2,E=y;for(;y<o&&!p(i.charCodeAt(y));)y++;if(y<o&&y!==E){for(E=y;y<o&&p(i.charCodeAt(y));)y++;if(y<o&&y!==E){for(E=y;y<o&&!p(i.charCodeAt(y));)y++;if(y===o)return i;y!==E&&(n=s=y+1)}}}}else g(t)&&i.charCodeAt(1)===C&&(n=o>2&&p(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let y=o-1;y>=s;--y)if(p(i.charCodeAt(y))){if(!a){r=y;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&h(o,"ext"),h(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,y=-1;for(r=i.length-1;r>=n;--r){const E=i.charCodeAt(r);if(p(E)){if(!t){n=r+1;break}}else y===-1&&(t=!1,y=r+1),a>=0&&(E===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(p(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){h(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&g(i.charCodeAt(0))&&(o=s=2);for(let y=i.length-1;y>=o;--y){const E=i.charCodeAt(y);if(p(E)){if(!r){s=y+1;break}continue}t===-1&&(r=!1,t=y+1),E===I?n===-1?n=y:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){h(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return p(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(p(t)){if(s=1,p(i.charCodeAt(1))){let w=2,O=w;for(;w<n&&!p(i.charCodeAt(w));)w++;if(w<n&&w!==O){for(O=w;w<n&&p(i.charCodeAt(w));)w++;if(w<n&&w!==O){for(O=w;w<n&&!p(i.charCodeAt(w));)w++;w===n?s=w:w!==O&&(s=w+1)}}}}else if(g(t)&&i.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=i,o;if(s=2,p(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,y=-1,E=!0,k=i.length-1,S=0;for(;k>=s;--k){if(t=i.charCodeAt(k),p(t)){if(!E){a=k+1;break}continue}y===-1&&(E=!1,y=k+1),t===I?r===-1?r=k:S!==1&&(S=1):r!==-1&&(S=-1)}return y!==-1&&(r===-1||S===0||S===1&&r===y-1&&r===a+1?o.base=o.name=i.slice(a,y):(o.name=i.slice(a,r),o.base=i.slice(a,y),o.ext=i.slice(r,y))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(b){const i=/\\/g;return()=>{const o=R.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>R.cwd()})();e.$hc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:$();h(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===P)}return o=l(o,!n,"/",u),n?`/${o}`:o.length>0?o:"."},normalize(i){if(h(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P,n=i.charCodeAt(i.length-1)===P;return i=l(i,!o,"/",u),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return h(i,"path"),i.length>0&&i.charCodeAt(0)===P},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];h(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$hc.normalize(o)},relative(i,o){if(h(i,"from"),h(o,"to"),i===o||(i=e.$hc.resolve(i),o=e.$hc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,y=t<a?t:a;let E=-1,k=0;for(;k<y;k++){const w=i.charCodeAt(n+k);if(w!==o.charCodeAt(r+k))break;w===P&&(E=k)}if(k===y)if(a>y){if(o.charCodeAt(r+k)===P)return o.slice(r+k+1);if(k===0)return o.slice(r+k)}else t>y&&(i.charCodeAt(n+k)===P?E=k:k===0&&(E=0));let S="";for(k=n+E+1;k<=s;++k)(k===s||i.charCodeAt(k)===P)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(r+E)}`},toNamespacedPath(i){return i},dirname(i){if(h(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===P){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&h(o,"ext"),h(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,y=-1;for(r=i.length-1;r>=0;--r){const E=i.charCodeAt(r);if(E===P){if(!t){n=r+1;break}}else y===-1&&(t=!1,y=r+1),a>=0&&(E===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===P){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){h(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const y=i.charCodeAt(a);if(y===P){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),y===I?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){h(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===P;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,y=!0,E=i.length-1,k=0;for(;E>=s;--E){const S=i.charCodeAt(E);if(S===P){if(!y){r=E+1;break}continue}a===-1&&(y=!1,a=E+1),S===I?t===-1?t=E:k!==1&&(k=1):t!==-1&&(k=-1)}if(a!==-1){const S=r===0&&n?1:r;t===-1||k===0||k===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(S,a):(o.name=i.slice(S,t),o.base=i.slice(S,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=b?e.$gc.normalize:e.$hc.normalize,e.$jc=b?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=b?e.$gc.join:e.$hc.join,e.$lc=b?e.$gc.resolve:e.$hc.resolve,e.$mc=b?e.$gc.relative:e.$hc.relative,e.$nc=b?e.$gc.dirname:e.$hc.dirname,e.$oc=b?e.$gc.basename:e.$hc.basename,e.$pc=b?e.$gc.extname:e.$hc.extname,e.$qc=b?e.$gc.format:e.$hc.format,e.$rc=b?e.$gc.parse:e.$hc.parse,e.$sc=b?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=b?e.$gc.sep:e.$hc.sep,e.$uc=b?e.$gc.delimiter:e.$hc.delimiter}),define(le[44],he([0,1,14,5,27,13]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=D,e.$cg=I,e.$dg=P,e.$eg=d,e.$fg=C,e.$gg=h,e.$hg=b,e.$ig=p,e.$jg=u,e.$kg=g,e.$lg=l,e.$mg=c,e.$ng=$,e.$og=i,e.$pg=o,e.$qg=t;function D(r){return r===47||r===92}function I(r){return r.replace(/[\\/]/g,R.$hc.sep)}function P(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function d(r,a=R.$hc.sep){if(!r)return"";const y=r.length,E=r.charCodeAt(0);if(D(E)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let S=3;const w=S;for(;S<y&&!D(r.charCodeAt(S));S++);if(w!==S&&!D(r.charCodeAt(S+1))){for(S+=1;S<y;S++)if(D(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,a)}}return a}else if(u(E)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let k=r.indexOf("://");if(k!==-1){for(k+=3;k<y;k++)if(D(r.charCodeAt(k)))return r.slice(0,k+1)}return""}function C(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let y=2;const E=y;for(;y<r.length&&(a=r.charCodeAt(y),a!==92);y++);return!(E===y||(a=r.charCodeAt(y+1),isNaN(a)||a===92))}const v=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,a=N.$i){const y=a?v:m;return!(!r||r.length===0||/^\s+$/.test(r)||(y.lastIndex=0,y.test(r))||a&&f.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}function b(r,a,y){const E=r===a;return!y||E?E:!r||!a?!1:(0,A.$lf)(r,a)}function p(r,a,y,E=R.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(y){if(!(0,A.$mf)(r,a))return!1;if(a.length===r.length)return!0;let S=a.length;return a.charAt(a.length-1)===E&&S--,r.charAt(S)===E}return a.charAt(a.length-1)!==E&&(a+=E),r.indexOf(a)===0}function u(r){return r>=65&&r<=90||r>=97&&r<=122}function g(r,a){return N.$i&&r.endsWith(":")&&(r+=R.sep),(0,R.$jc)(r)||(r=(0,R.$kc)(a,r)),r=(0,R.$ic)(r),N.$i?(r=(0,A.$6e)(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=(0,A.$6e)(r,R.sep),r||(r=R.sep)),r}function l(r){const a=(0,R.$ic)(r);return N.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===R.$hc.sep}function c(r,a=N.$i){return a?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function $(r,a=N.$i){return c(r,a)?r[0]:void 0}function i(r,a,y){return a.length>r.length?-1:r===a?0:(y&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}function o(r){const a=r.split(":");let y,E,k;for(const S of a){const w=Number(S);(0,j.$Zf)(w)?E===void 0?E=w:k===void 0&&(k=w):y=y?[y,S].join(":"):S}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,y=8){let E="";for(let S=0;S<y;S++){let w;S===0&&N.$i&&!a&&(y===3||y===4)?w=s:w=n,E+=w.charAt(Math.floor(Math.random()*w.length))}let k;return a?k=`${a}-${E}`:k=E,r?(0,R.$kc)(r,k):k}}),define(le[141],he([0,1,14]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0,e.$As=j,e.$Bs=D,e.$Cs=I,e.$Ds=d,e.$zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(C){const v=(0,R.$pc)(C),m=N[v.toLowerCase()];return m!==void 0?m:D(C)}function D(C){const v=(0,R.$pc)(C);return A[v.toLowerCase()]}function I(C){for(const v in A)if(A[v]===C)return v}const P=/^(.+)\/(.+?)(;.+)?$/;function d(C,v){const m=P.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:v?void 0:C}}),define(le[89],he([0,1,5]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$$l=j,e.$_l=D;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var A;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function j(I,...P){const d=P.reduce((m,f)=>(m[f]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!d[m]).forEach(m=>{for(let f=0;f<C.length;f++)if(m.search(C[f])!==-1){delete I[m];break}})}function D(I){I&&(delete I.DEBUG,R.$j&&delete I.DYLD_LIBRARY_PATH,R.$k&&delete I.LD_PRELOAD)}}),define(le[8],he([0,1,14,5]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=h,e.$xc=c;const A=/^\w[\w\d+.-]*$/,j=/^\//,D=/^\/\//;function I(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!j.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,t){return!s&&!t?"file":s}function d(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==v&&(t=v+t):t=v;break}return t}const C="",v="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(t){return t instanceof f?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,y,E,k=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=P(t,k),this.authority=r||C,this.path=d(this.scheme,a||C),this.query=y||C,this.fragment=E||C,I(this,k))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:y,query:E,fragment:k}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),y===void 0?y=this.path:y===null&&(y=C),E===void 0?E=this.query:E===null&&(E=C),k===void 0?k=this.fragment:k===null&&(k=C),r===this.scheme&&a===this.authority&&y===this.path&&E===this.query&&k===this.fragment?this:new p(r,a,y,E,k)}static parse(t,r=!1){const a=m.exec(t);return a?new p(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new p(C,C,C,C,C)}static file(t){let r=C;if(N.$i&&(t=t.replace(/\\/g,v)),t[0]===v&&t[1]===v){const a=t.indexOf(v,2);a===-1?(r=t.substring(2),t=v):(r=t.substring(2,a),t=t.substring(a)||v)}return new p("file",r,t,C,C)}static from(t,r){return new p(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=f.file(R.$gc.join(c(t,!0),...r)).path:a=R.$hc.join(t.path,...r),t.with({path:a})}toString(t=!1){return $(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof f)return t;{const r=new p(t);return r._formatted=t.external??null,r._fsPath=t._sep===b?t.fsPath??null:null,r}}else return t}}e.URI=f;function h(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const b=N.$i?1:void 0;class p extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=b),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(s,t,r){let a,y=-1;for(let E=0;E<s.length;E++){const k=s.charCodeAt(E);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||t&&k===47||r&&k===91||r&&k===93||r&&k===58)y!==-1&&(a+=encodeURIComponent(s.substring(y,E)),y=-1),a!==void 0&&(a+=s.charAt(E));else{a===void 0&&(a=s.substr(0,E));const S=u[k];S!==void 0?(y!==-1&&(a+=encodeURIComponent(s.substring(y,E)),y=-1),a+=S):y===-1&&(y=E)}}return y!==-1&&(a+=encodeURIComponent(s.substring(y))),a!==void 0?a:s}function l(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=u[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.$i&&(r=r.replace(/\//g,"\\")),r}function $(s,t){const r=t?l:g;let a="",{scheme:y,authority:E,path:k,query:S,fragment:w}=s;if(y&&(a+=y,a+=":"),(E||y==="file")&&(a+=v,a+=v),E){let O=E.indexOf("@");if(O!==-1){const M=E.substr(0,O);E=E.substr(O+1),O=M.lastIndexOf(":"),O===-1?a+=r(M,!1,!1):(a+=r(M.substr(0,O),!1,!1),a+=":",a+=r(M.substr(O+1),!1,!0)),a+="@"}E=E.toLowerCase(),O=E.lastIndexOf(":"),O===-1?a+=r(E,!1,!0):(a+=r(E.substr(0,O),!1,!0),a+=E.substr(O))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const O=k.charCodeAt(1);O>=65&&O<=90&&(k=`/${String.fromCharCode(O+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const O=k.charCodeAt(0);O>=65&&O<=90&&(k=`${String.fromCharCode(O+32)}:${k.substr(2)}`)}a+=r(k,!0,!1)}return S&&(a+="?",a+=r(S,!1,!1)),w&&(a+="#",a+=t?w:g(w,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[142],he([0,1,8]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=N,e.$Gq=A,e.$Hq=j,e.log=I;function N(d){const C=d;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function A(d){const C=[];let v;try{const m=JSON.parse(d.arguments),f=m[m.length-1];f&&f.__$stack&&(m.pop(),v=f.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",d.arguments)}return{args:C,stack:v}}function j(d){if(typeof d!="string")return j(A(d).stack);const C=d;if(C){const v=D(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function D(d){if(!d)return d;const C=d.indexOf(`
`);return C===-1?d:d.substring(0,C)}function I(d,C){const{args:v,stack:m}=A(d),f=typeof v[0]=="string"&&v.length===1;let h=D(m);h&&(h=`(${h.trim()})`);let b=[];if(typeof v[0]=="string"?h&&f?b=[`%c[${C}] %c${v[0]} %c${h}`,P("blue"),P(""),P("grey")]:b=[`%c[${C}] %c${v[0]}`,P("blue"),P(""),...v.slice(1)]:b=[`%c[${C}]%`,P("blue"),...v],h&&!f&&b.push(h),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,b)}function P(d){return`color: ${d}`}}),define(le[66],he([0,1,15,8]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=A,e.$Qh=j,e.$Rh=I;function A(P){return JSON.stringify(P,D)}function j(P){let d=JSON.parse(P);return d=I(d),d}function D(P,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function I(P,d=0){if(!P||d>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return N.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof R.$ue||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let C=0;C<P.length;++C)P[C]=I(P[C],d+1);else for(const C in P)Object.hasOwnProperty.call(P,C)&&(P[C]=I(P[C],d+1))}return P}}),define(le[23],he([0,1,7,5,27,8,14]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=P,e.$sg=d,e.$wg=v;var I;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.codeSetting="code-setting"})(I||(e.Schemas=I={}));function P(h,b){return j.URI.isUri(h)?(0,A.$lf)(h.scheme,b):(0,A.$mf)(h,b+":")}function d(h,...b){return b.some(p=>P(h,p))}e.$tg="vscode-tkn",e.$ug="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,p){this.f=v(b,p)}getServerRootPath(){return this.f}get g(){return D.$hc.join(this.f,I.vscodeRemoteResource)}set(b,p,u){this.a[b]=p,this.b[b]=u}setConnectionToken(b,p){this.c[b]=p}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch($){return R.$1($),b}const p=b.authority;let u=this.a[p];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const g=this.b[p],l=this.c[p];let c=`path=${encodeURIComponent(b.path)}`;return typeof l=="string"&&(c+=`&${e.$ug}=${encodeURIComponent(l)}`),j.URI.from({scheme:N.$o?this.d:I.vscodeRemoteResource,authority:`${u}:${g}`,path:this.g,query:c})}}e.$vg=new C;function v(h,b){return D.$hc.join(b??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class m{static{this.a=e.$Bg}asBrowserUri(b){const p=this.b(b,se);return this.uriToBrowserUri(p)}uriToBrowserUri(b){return b.scheme===I.vscodeRemote?e.$vg.rewrite(b):b.scheme===I.file&&(N.$m||N.$q===`${I.vscodeFileResource}://${m.a}`)?b.with({scheme:I.vscodeFileResource,authority:b.authority||m.a,query:null,fragment:null}):b}asFileUri(b){const p=this.b(b,se);return this.uriToFileUri(p)}uriToFileUri(b){return b.scheme===I.vscodeFileResource?b.with({scheme:I.file,authority:b.authority!==m.a?b.authority:null,query:null,fragment:null}):b}b(b,p){return j.URI.isUri(b)?b:j.URI.parse(p.toUrl(b))}}e.$Cg=new m;var f;(function(h){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(b.get("3"));const p="vscode-coi";function u(l){let c;typeof l=="string"?c=new URL(l).searchParams:l instanceof URL?c=l.searchParams:j.URI.isUri(l)&&(c=new URL(l.toString(!0)).searchParams);const $=c?.get(p);if($)return b.get($)}h.getHeadersFromQuery=u;function g(l,c,$){if(!globalThis.crossOriginIsolated)return;const i=c&&$?"3":$?"2":"1";l instanceof URLSearchParams?l.set(p,i):l[p]=i}h.addSearchParam=g})(f||(e.COI=f={}))}),define(le[143],he([0,1,124,23,5,8]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JD=C;class D{constructor(m,f,h){this.id=m,this.dependencies=f,this.callback=h}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,f,h)=>{typeof m!="string"&&(h=f,f=m,m=null),(typeof f!="object"||!Array.isArray(f))&&(h=f,f=null),this.c.push(new D(m,f,h))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const f=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!f)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(m){return new Promise((f,h)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const p=()=>{b.removeEventListener("load",u),b.removeEventListener("error",g)},u=l=>{p(),f(this.c.pop())},g=l=>{p(),h(l)};b.addEventListener("load",u),b.addEventListener("error",g),this.f&&(m=this.f.createScriptURL(m)),b.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(m){return new Promise((f,h)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),f(this.c.pop())}catch(b){h(b)}})}async j(m){try{const f=globalThis._VSCODE_NODE_MODULES.fs,h=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,p=j.URI.parse(m).fsPath,u=f.readFileSync(p).toString(),g=b.wrap(u.replace(/^#!.*/,""));return new h.Script(g).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const P=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function C(v,m,f){if(R.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[v]&&(v=d[v]);const h=`${v}/${m}`;if(P.has(h))return P.get(h);let b;if(/^\w[\w\d+.-]*:\/\//.test(h))b=h;else{const l=`${f&&!A.$o?N.$zg:N.$yg}/${h}`;b=N.$Cg.asBrowserUri(l).toString(!0)}const p=I.INSTANCE.load(b);return P.set(h,p),p}else return await new Promise((h,b)=>{se([v],h,b)})}}),define(le[20],he([0,1,44,23,14,5,27,8]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=P,e.$5g=C,e.$6g=m;function P(f){return(0,I.$xc)(f,!0)}class d{constructor(h){this.a=h}compare(h,b,p=!1){return h===b?0:(0,D.$ef)(this.getComparisonKey(h,p),this.getComparisonKey(b,p))}isEqual(h,b,p=!1){return h===b?!0:!h||!b?!1:this.getComparisonKey(h,p)===this.getComparisonKey(b,p)}getComparisonKey(h,b=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,b,p=!1){if(h.scheme===b.scheme){if(h.scheme===N.Schemas.file)return R.$ig(P(h),P(b),this.a(h))&&h.query===b.query&&(p||h.fragment===b.fragment);if((0,e.$1g)(h.authority,b.authority))return R.$ig(h.path,b.path,this.a(h),"/")&&h.query===b.query&&(p||h.fragment===b.fragment)}return!1}joinPath(h,...b){return I.URI.joinPath(h,...b)}basenameOrAuthority(h){return(0,e.$Sg)(h)||h.authority}basename(h){return A.$hc.basename(h.path)}extname(h){return A.$hc.extname(h.path)}dirname(h){if(h.path.length===0)return h;let b;return h.scheme===N.Schemas.file?b=I.URI.file(A.$nc(P(h))).path:(b=A.$hc.dirname(h.path),h.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),b="/")),h.with({path:b})}normalizePath(h){if(!h.path.length)return h;let b;return h.scheme===N.Schemas.file?b=I.URI.file(A.$ic(P(h))).path:b=A.$hc.normalize(h.path),h.with({path:b})}relativePath(h,b){if(h.scheme!==b.scheme||!(0,e.$1g)(h.authority,b.authority))return;if(h.scheme===N.Schemas.file){const g=A.$mc(P(h),P(b));return j.$i?R.$cg(g):g}let p=h.path||"/";const u=b.path||"/";if(this.a(h)){let g=0;for(const l=Math.min(p.length,u.length);g<l&&!(p.charCodeAt(g)!==u.charCodeAt(g)&&p.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);p=u.substr(0,g)+p.substr(g)}return A.$hc.relative(p,u)}resolvePath(h,b){if(h.scheme===N.Schemas.file){const p=I.URI.file(A.$lc(P(h),b));return h.with({authority:p.authority,path:p.path})}return b=R.$dg(b),h.with({path:A.$hc.resolve(h.path,b)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,b){return h===b||h!==void 0&&b!==void 0&&(0,D.$lf)(h,b)}hasTrailingPathSeparator(h,b=A.sep){if(h.scheme===N.Schemas.file){const p=P(h);return p.length>R.$eg(p).length&&p[p.length-1]===b}else{const p=h.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,b=A.sep){return(0,e.$2g)(h,b)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,b=A.sep){let p=!1;if(h.scheme===N.Schemas.file){const u=P(h);p=u!==void 0&&u.length===R.$eg(u).length&&u[u.length-1]===b}else{b="/";const u=h.path;p=u.length===1&&u.charCodeAt(u.length-1)===47}return!p&&!(0,e.$2g)(h,b)?h.with({path:h.path+"/"}):h}}e.$Kg=d,e.$Lg=new d(()=>!1),e.$Mg=new d(f=>f.scheme===N.Schemas.file?!j.$k:!0),e.$Ng=new d(f=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function C(f,h){const b=[];for(let p=0;p<f.length;p++){const u=h(f[p]);f.some((g,l)=>l===p?!1:(0,e.$Pg)(u,h(g)))||b.push(f[p])}return b}var v;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function h(b){const p=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,$]=l.split(":");c&&$&&p.set(c,$)});const g=b.path.substring(0,b.path.indexOf(";"));return g&&p.set(f.META_DATA_MIME,g),p}f.parseMetaData=h})(v||(e.DataUri=v={}));function m(f,h,b){if(h){let p=f.path;return p&&p[0]!==A.$hc.sep&&(p=A.$hc.sep+p),f.with({scheme:b,authority:h,path:p})}return f.with({scheme:b})}}),define(le[6],he([0,1,26,7,3,2,20,5,130,53]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=C,e.$8g=v,e.$9g=m,e.$0g=f,e.$$g=h,e.$_g=b,e.$ah=p,e.$bh=u,e.$jh=r,e.$kh=a,e.$lh=y,e.$mh=E,e.$nh=k,e.$Ch=B,e.$Kh=J;function C(x){return!!x&&typeof x.then=="function"}function v(x){const Q=new R.$ee,ne=x(Q.token),re=new Promise((ue,de)=>{const $e=Q.token.onCancellationRequested(()=>{$e.dispose(),de(new N.$5)});Promise.resolve(ne).then(ye=>{$e.dispose(),Q.dispose(),ue(ye)},ye=>{$e.dispose(),Q.dispose(),de(ye)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ue,de){return re.then(ue,de)}catch(ue){return this.then(void 0,ue)}finally(ue){return re.finally(ue)}}}function m(x,Q,ne){return new Promise((re,ue)=>{const de=Q.onCancellationRequested(()=>{de.dispose(),re(ne)});x.then(re,ue).finally(()=>de.dispose())})}function f(x,Q){return new Promise((ne,re)=>{const ue=Q.onCancellationRequested(()=>{ue.dispose(),re(new N.$5)});x.then(ne,re).finally(()=>ue.dispose())})}async function h(x){let Q=-1;const ne=x.map((re,ue)=>re.then(de=>(Q=ue,de)));try{return await Promise.race(ne)}finally{x.forEach((re,ue)=>{ue!==Q&&re.cancel()})}}function b(x,Q,ne){let re;const ue=setTimeout(()=>{re?.(void 0),ne?.()},Q);return Promise.race([x.finally(()=>clearTimeout(ue)),new Promise(de=>re=de)])}function p(x){return new Promise((Q,ne)=>{const re=x();C(re)?re.then(Q,ne):Q(re)})}function u(){let x,Q;return{promise:new Promise((re,ue)=>{x=re,Q=ue}),resolve:x,reject:Q}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const ne=()=>{if(this.b=null,this.f)return;const re=this.queue(this.d);return this.d=null,re};this.b=new Promise(re=>{this.a.then(ne,ne).then(re)})}return new Promise((ne,re)=>{this.b.then(ne,re)})}return this.a=Q(),new Promise((ne,re)=>{this.a.then(ue=>{this.a=null,ne(ue)},ue=>{this.a=null,re(ue)})})}dispose(){this.f=!0}}e.$ch=g;class l{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$dh=l;class c{constructor(){this.a=new Map}queue(Q,ne){const ue=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(Q)===ue&&this.a.delete(Q)});return this.a.set(Q,ue),ue}}e.$eh=c;const $=(x,Q)=>{let ne=!0;const re=setTimeout(()=>{ne=!1,Q()},x);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(re),ne=!1}}},i=x=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,x())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class o{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,ne=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ue,de)=>{this.d=ue,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const re=()=>{this.a=null,this.d?.(null)};return this.a=ne===P.$4d?i(re):$(ne,re),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=o;class n{constructor(Q){this.a=new o(Q),this.b=new g}trigger(Q,ne){return this.a.trigger(()=>this.b.queue(Q),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=n;class s{constructor(){this.a=!1,this.b=new Promise((Q,ne)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=s;class t extends s{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$ih=t;function r(x,Q){return Q?new Promise((ne,re)=>{const ue=setTimeout(()=>{de.dispose(),ne()},x),de=Q.onCancellationRequested(()=>{clearTimeout(ue),de.dispose(),re(new N.$5)})}):v(ne=>r(x,ne))}function a(x,Q=0,ne){const re=setTimeout(()=>{x(),ne&&ue.dispose()},Q),ue=(0,j.$Sc)(()=>{clearTimeout(re),ne?.deleteAndLeak(ue)});return ne?.add(ue),ue}function y(x){const Q=[];let ne=0;const re=x.length;function ue(){return ne<re?x[ne++]():null}function de($e){$e!=null&&Q.push($e);const ye=ue();return ye?ye.then(de):Promise.resolve(Q)}return Promise.resolve(null).then(de)}function E(x,Q=re=>!!re,ne=null){let re=0;const ue=x.length,de=()=>{if(re>=ue)return Promise.resolve(ne);const $e=x[re++];return Promise.resolve($e()).then(Se=>Q(Se)?Promise.resolve(Se):de())};return de()}function k(x,Q=re=>!!re,ne=null){if(x.length===0)return Promise.resolve(ne);let re=x.length;const ue=()=>{re=-1;for(const de of x)de.cancel?.()};return new Promise((de,$e)=>{for(const ye of x)ye.then(Se=>{--re>=0&&Q(Se)?(ue(),de(Se)):re===0&&de(ne)}).catch(Se=>{--re>=0&&(ue(),$e(Se))})})}class S{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new A.$7d}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,re)=>{this.g.push({factory:Q,c:ne,e:re}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const ne=Q.factory();ne.then(Q.c,Q.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=S;class w extends S{constructor(){super(1)}}e.$ph=w;class O{constructor(){this.a=new ie,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$qh=O;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new ce;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,ne=D.$Lg){const re=ne.getComparisonKey(Q);return this.a.get(re)?.size??0}queueFor(Q,ne,re=D.$Lg){const ue=re.getComparisonKey(Q);let de=this.a.get(ue);if(!de){de=new w;const $e=this.f++,ye=A.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$4c),this.d.set($e,ye),this.a.set(ue,de)}return de.queue(ne)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=M;class T{constructor(Q,ne){this.a=-1,typeof Q=="function"&&typeof ne=="number"&&this.setIfNotSet(Q,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},ne)}setIfNotSet(Q,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},ne))}}e.$sh=T;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,ne,re=globalThis){this.cancel();const ue=re.setInterval(()=>{Q()},ne);this.d=(0,j.$Sc)(()=>{re.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$th=U;class _{constructor(Q,ne){this.b=-1,this.a=Q,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=_;class G{constructor(Q,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=Q,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=G;class Z extends _{constructor(Q,ne){super(Q,ne),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$wh=Z;class V extends j.$Uc{constructor(Q,ne){super(),this.g=Q,this.h=ne,this.a=[],this.b=this.B(new j.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of Q)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(x,Q)=>{(0,I.$B)(()=>{if(ne)return;const re=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,re-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$zh=(x,Q,ne)=>{const re=x.requestIdleCallback(Q,typeof ne=="number"?{timeout:ne}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,x.cancelIdleCallback(re))}}},e.$yh=x=>(0,e.$zh)(globalThis,x)}();class K{constructor(Q,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(re){this.l=re}finally{this.g=!0}},this.f=(0,e.$zh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=K;class W extends K{constructor(Q){super(globalThis,Q)}}e.$Bh=W;async function B(x,Q,ne){let re;for(let ue=0;ue<ne;ue++)try{return await x()}catch(de){re=de,await r(Q)}throw re}class ie{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,ne,re){return this.a={taskId:Q,cancel:()=>re?.(),promise:ne},ne.then(()=>this.d(Q),()=>this.d(Q)),ne}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:ne,resolve:re,reject:ue}=u();this.b={run:Q,promise:ne,promiseResolve:re,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=ie;class ae{constructor(Q,ne=()=>Date.now()){this.d=Q,this.f=ne,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Eh=ae;var te;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(te||(te={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,ne)=>{this.a=Q,this.b=ne})}complete(Q){return new Promise(ne=>{this.a(Q),this.d={outcome:0,value:Q},ne()})}error(Q){return new Promise(ne=>{this.b(Q),this.d={outcome:1,value:Q},ne()})}cancel(){return this.error(new N.$5)}}e.$Fh=ce;var H;(function(x){async function Q(re){let ue;const de=await Promise.all(re.map($e=>$e.then(ye=>ye,ye=>{ue||(ue=ye)})));if(typeof ue<"u")throw ue;return de}x.settled=Q;function ne(re){return new Promise(async(ue,de)=>{try{await re(ue,de)}catch($e){de($e)}})}x.withAsyncBody=ne})(H||(e.Promises=H={}));class q{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=q;class L{constructor(Q){this.b=Q,this.a=new d.$V(()=>new q(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=L;var F;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(F||(F={}));class z{static fromArray(Q){return new z(ne=>{ne.emitMany(Q)})}static fromPromise(Q){return new z(async ne=>{ne.emitMany(await Q)})}static fromPromises(Q){return new z(async ne=>{await Promise.all(Q.map(async re=>ne.emitOne(await re)))})}static merge(Q){return new z(async ne=>{await Promise.all(Q.map(async re=>{for await(const ue of re)ne.emitOne(ue)}))})}static{this.EMPTY=z.fromArray([])}constructor(Q){this.a=0,this.b=[],this.d=null,this.f=new A.$7d,queueMicrotask(async()=>{const ne={emitOne:re=>this.g(re),emitMany:re=>this.h(re),reject:re=>this.k(re)};try{await Promise.resolve(Q(ne)),this.j()}catch(re){this.k(re)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(Q,ne){return new z(async re=>{for await(const ue of Q)re.emitOne(ne(ue))})}map(Q){return z.map(this,Q)}static filter(Q,ne){return new z(async re=>{for await(const ue of Q)ne(ue)&&re.emitOne(ue)})}filter(Q){return z.filter(this,Q)}static coalesce(Q){return z.filter(Q,ne=>!!ne)}coalesce(){return z.coalesce(this)}static async toPromise(Q){const ne=[];for await(const re of Q)ne.push(re);return ne}toPromise(){return z.toPromise(this)}g(Q){this.a===0&&(this.b.push(Q),this.f.fire())}h(Q){this.a===0&&(this.b=this.b.concat(Q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Q){this.a===0&&(this.a=2,this.d=Q,this.f.fire())}}e.$Ih=z;class Y extends z{constructor(Q,ne){super(ne),this.l=Q}cancel(){this.l.cancel()}}e.$Jh=Y;function J(x){const Q=new R.$ee,ne=x(Q.token);return new Y(Q,async re=>{const ue=Q.token.onCancellationRequested(()=>{ue.dispose(),Q.dispose(),re.reject(new N.$5)});try{for await(const de of ne){if(Q.token.isCancellationRequested)return;re.emitOne(de)}ue.dispose(),Q.dispose()}catch(de){ue.dispose(),Q.dispose(),re.reject(de)}})}class ee{constructor(){this.a=new ce,this.b=new z(re=>{if(Q){re.reject(Q);return}return ne&&re.emitMany(ne),this.d=ue=>re.reject(ue),this.f=ue=>re.emitOne(ue),this.a.p});let Q,ne;this.f=re=>{ne||(ne=[]),ne.push(re)},this.d=re=>{Q||(Q=re)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Lh=ee}),define(le[90],he([0,1,17,6,44,35,14,5,27]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=d,e.$ak=h,e.$bk=w,e.$ck=O,e.$dk=M,e.$ek=T,e.$fk=U,e.$gk=V;function d(){return Object.create(null)}e.$$j="**",e.$_j="/";const C="[/\\\\]",v="[^/\\\\]",m=/\//g;function f(K,W){switch(K){case 0:return"";case 1:return`${v}*?`;default:return`(?:${C}|${v}+${C}${W?`|${C}${v}+`:""})*?`}}function h(K,W){if(!K)return[];const B=[];let ie=!1,ae=!1,te="";for(const ce of K){switch(ce){case W:if(!ie&&!ae){B.push(te),te="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}te+=ce}return te&&B.push(te),B}function b(K){if(!K)return"";let W="";const B=h(K,e.$_j);if(B.every(ie=>ie===e.$$j))W=".*";else{let ie=!1;B.forEach((ae,te)=>{if(ae===e.$$j){if(ie)return;W+=f(2,te===B.length-1)}else{let ce=!1,H="",q=!1,L="";for(const F of ae){if(F!=="}"&&ce){H+=F;continue}if(q&&(F!=="]"||!L)){let z;F==="-"?z=F:(F==="^"||F==="!")&&!L?z="^":F===e.$_j?z="":z=(0,P.$Ze)(F),L+=z;continue}switch(F){case"{":ce=!0;continue;case"[":q=!0;continue;case"}":{const Y=`(?:${h(H,",").map(J=>b(J)).join("|")})`;W+=Y,ce=!1,H="";break}case"]":{W+="["+L+"]",q=!1,L="";break}case"?":W+=v;continue;case"*":W+=f(1);continue;default:W+=(0,P.$Ze)(F)}}te<B.length-1&&(B[te+1]!==e.$$j||te+2<B.length)&&(W+=C)}ie=ae===e.$$j})}return W}const p=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new j.$Ec(1e4),o=function(){return!1},n=function(){return null};function s(K,W){if(!K)return n;let B;typeof K!="string"?B=K.pattern:B=K,B=B.trim();const ie=`${B}_${!!W.trimForExclusions}`;let ae=i.get(ie);if(ae)return t(ae,K);let te;return p.test(B)?ae=a(B.substr(4),B):(te=u.exec(r(B,W)))?ae=y(te[1],B):(W.trimForExclusions?l:g).test(B)?ae=E(B,W):(te=c.exec(r(B,W)))?ae=k(te[1].substr(1),B,!0):(te=$.exec(r(B,W)))?ae=k(te[1],B,!1):ae=S(B),i.set(ie,ae),t(ae,K)}function t(K,W){if(typeof W=="string")return K;const B=function(ie,ae){return(0,A.$ig)(ie,W.base,!I.$k)?K((0,P.$5e)(ie.substr(W.base.length),D.sep),ae):null};return B.allBasenames=K.allBasenames,B.allPaths=K.allPaths,B.basenames=K.basenames,B.patterns=K.patterns,B}function r(K,W){return W.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function a(K,W){return function(B,ie){return typeof B=="string"&&B.endsWith(K)?W:null}}function y(K,W){const B=`/${K}`,ie=`\\${K}`,ae=function(ce,H){return typeof ce!="string"?null:H?H===K?W:null:ce===K||ce.endsWith(B)||ce.endsWith(ie)?W:null},te=[K];return ae.basenames=te,ae.patterns=[W],ae.allBasenames=te,ae}function E(K,W){const B=Z(K.slice(1,-1).split(",").map(H=>s(H,W)).filter(H=>H!==n),K),ie=B.length;if(!ie)return n;if(ie===1)return B[0];const ae=function(H,q){for(let L=0,F=B.length;L<F;L++)if(B[L](H,q))return K;return null},te=B.find(H=>!!H.allBasenames);te&&(ae.allBasenames=te.allBasenames);const ce=B.reduce((H,q)=>q.allPaths?H.concat(q.allPaths):H,[]);return ce.length&&(ae.allPaths=ce),ae}function k(K,W,B){const ie=D.sep===D.$hc.sep,ae=ie?K:K.replace(m,D.sep),te=D.sep+ae,ce=D.$hc.sep+K;let H;return B?H=function(q,L){return typeof q=="string"&&(q===ae||q.endsWith(te)||!ie&&(q===K||q.endsWith(ce)))?W:null}:H=function(q,L){return typeof q=="string"&&(q===ae||!ie&&q===K)?W:null},H.allPaths=[(B?"*/":"./")+K],H}function S(K){try{const W=new RegExp(`^${b(K)}$`);return function(B){return W.lastIndex=0,typeof B=="string"&&W.test(B)?K:null}}catch{return n}}function w(K,W,B){return!K||typeof W!="string"?!1:O(K)(W,void 0,B)}function O(K,W={}){if(!K)return o;if(typeof K=="string"||M(K)){const B=s(K,W);if(B===n)return o;const ie=function(ae,te){return!!B(ae,te)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return _(K,W)}function M(K){const W=K;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function T(K){return K.allBasenames||[]}function U(K){return K.allPaths||[]}function _(K,W){const B=Z(Object.getOwnPropertyNames(K).map(H=>G(H,K[H],W)).filter(H=>H!==n)),ie=B.length;if(!ie)return n;if(!B.some(H=>!!H.requiresSiblings)){if(ie===1)return B[0];const H=function(F,z){let Y;for(let J=0,ee=B.length;J<ee;J++){const x=B[J](F,z);if(typeof x=="string")return x;(0,N.$7g)(x)&&(Y||(Y=[]),Y.push(x))}return Y?(async()=>{for(const J of Y){const ee=await J;if(typeof ee=="string")return ee}return null})():null},q=B.find(F=>!!F.allBasenames);q&&(H.allBasenames=q.allBasenames);const L=B.reduce((F,z)=>z.allPaths?F.concat(z.allPaths):F,[]);return L.length&&(H.allPaths=L),H}const ae=function(H,q,L){let F,z;for(let Y=0,J=B.length;Y<J;Y++){const ee=B[Y];ee.requiresSiblings&&L&&(q||(q=(0,D.$oc)(H)),F||(F=q.substr(0,q.length-(0,D.$pc)(H).length)));const x=ee(H,q,F,L);if(typeof x=="string")return x;(0,N.$7g)(x)&&(z||(z=[]),z.push(x))}return z?(async()=>{for(const Y of z){const J=await Y;if(typeof J=="string")return J}return null})():null},te=B.find(H=>!!H.allBasenames);te&&(ae.allBasenames=te.allBasenames);const ce=B.reduce((H,q)=>q.allPaths?H.concat(q.allPaths):H,[]);return ce.length&&(ae.allPaths=ce),ae}function G(K,W,B){if(W===!1)return n;const ie=s(K,B);if(ie===n)return n;if(typeof W=="boolean")return ie;if(W){const ae=W.when;if(typeof ae=="string"){const te=(ce,H,q,L)=>{if(!L||!ie(ce,H))return null;const F=ae.replace("$(basename)",()=>q),z=L(F);return(0,N.$7g)(z)?z.then(Y=>Y?K:null):z?K:null};return te.requiresSiblings=!0,te}}return ie}function Z(K,W){const B=K.filter(H=>!!H.basenames);if(B.length<2)return K;const ie=B.reduce((H,q)=>{const L=q.basenames;return L?H.concat(L):H},[]);let ae;if(W){ae=[];for(let H=0,q=ie.length;H<q;H++)ae.push(W)}else ae=B.reduce((H,q)=>{const L=q.patterns;return L?H.concat(L):H},[]);const te=function(H,q){if(typeof H!="string")return null;if(!q){let F;for(F=H.length;F>0;F--){const z=H.charCodeAt(F-1);if(z===47||z===92)break}q=H.substr(F)}const L=ie.indexOf(q);return L!==-1?ae[L]:null};te.basenames=ie,te.patterns=ae,te.allBasenames=ie;const ce=K.filter(H=>!H.basenames);return ce.push(te),ce}function V(K,W){return(0,R.$ub)(K,W,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(le[91],he([0,1,15,8]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$mn=I,e.$nn=d,e.$on=C;function A(v){return v.toJSON()}class j{constructor(m){this.a=m}transformIncoming(m){const f=this.a.transformIncoming(m);return f===m?m:A(N.URI.from(f))}transformOutgoing(m){const f=this.a.transformOutgoing(m);return f===m?m:A(N.URI.from(f))}transformOutgoingURI(m){const f=this.a.transformOutgoing(m);return f===m?m:N.URI.from(f)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$kn=j,e.$ln=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,m,f){if(!v||f>200)return null;if(typeof v=="object"){if(v instanceof N.URI)return m.transformOutgoing(v);for(const h in v)if(Object.hasOwnProperty.call(v,h)){const b=D(v[h],m,f+1);b!==null&&(v[h]=b)}}return null}function I(v,m){const f=D(v,m,0);return f===null?v:f}function P(v,m,f,h){if(!v||h>200)return null;if(typeof v=="object"){if(v.$mid===1)return f?N.URI.revive(m.transformIncoming(v)):m.transformIncoming(v);if(v instanceof R.$ue)return null;for(const b in v)if(Object.hasOwnProperty.call(v,b)){const p=P(v[b],m,f,h+1);p!==null&&(v[b]=p)}}return null}function d(v,m){const f=P(v,m,!1,0);return f===null?v:f}function C(v,m){const f=P(v,m,!0,0);return f===null?v:f}}),define(le[144],he([0,1,37,51,32,131,5]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0,e.$rn=P,e.$sn=v,e.$qn=new class{c(m){return this.a||(this.a=N.$oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,f=0;const h=(0,R.networkInterfaces)();for(const b in h){const p=h[b];if(p)for(const{mac:u,internal:g}of p)g||(f+=1,this.c(u.toUpperCase())&&(m+=1))}this.b=f>0?m/f:0}return this.b}};let I;async function P(m){return I||(I=(async()=>await d(m)||A.$Eg())()),I}async function d(m){try{const f=await new Promise((b,p)=>{se(["crypto"],b,p)}),h=(0,j.$pn)();return f.createHash("sha256").update(h,"utf8").digest("hex")}catch(f){m(f);return}}const C="Software\\Microsoft\\SQMClient";async function v(m){if(D.$i){const f=await new Promise((h,b)=>{se(["@vscode/windows-registry"],h,b)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(h){return m(h),""}}return""}}),define(le[145],he([0,1,40,146,14,36]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7V=C,e.$8V=v;const D="XDG_SESSION_TYPE",I="WAYLAND_DISPLAY",P="XDG_RUNTIME_DIR";var d;(function(m){m.Wayland="wayland",m.XWayland="xwayland",m.X11="x11",m.Unknown="unknown"})(d||(d={}));async function C(m){const f=j.env[D];if(f)return f==="wayland"||f==="x11"?f:"unknown";if(j.env[I]){const b=j.env[P];if(b){const p=(0,A.$kc)(b,"wayland-0");try{return await(0,N.access)(p,R.constants.R_OK),"wayland"}catch(u){return m(u),"unknown"}}else return"unknown"}else return"x11"}function v(m,f){if(f)switch(f){case"auto":return m;case"x11":return m==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return m==="wayland"?"xwayland":"x11"}}),define(le[147],he([0,1,40,146,274,5]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=D;async function D(I){if(j.$j||j.$i)return;let P;for(const d of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,N.open)(d,R.constants.R_OK);break}catch{}if(!P){I("Unable to retrieve release information from known identifier paths.");return}try{const d=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const v of(0,A.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!v.includes("="))continue;const m=v.split("=")[0].toUpperCase().trim();if(d.has(m)){const f=v.split("=")[1].replace(/"/g,"").toLowerCase().trim();m==="ID"||m==="DISTRIB_ID"?C.id=f:m==="ID_LIKE"?C.id_like=f:(m==="VERSION_ID"||m==="DISTRIB_RELEASE")&&(C.version_id=f)}}return C}catch(d){I(d)}}}),define(le[31],he([0,1,40,37,275,6,44,87,14,5,20,8]),function(se,e,R,N,A,j,D,I,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=l,e.whenDeleted=i,e.configureFlushOnWrite=r,e.writeFileSync=y;var m;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function f(G,Z=m.UNLINK,V){if((0,D.$lg)(G))throw new Error("rimraf - will refuse to recursively delete root");return Z===m.UNLINK?b(G):h(G,V)}async function h(G,Z=(0,D.$qg)((0,N.tmpdir)())){try{try{await R.promises.rename(G,Z)}catch(V){return V.code==="ENOENT"?void 0:b(G)}b(Z).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function b(G){return(0,A.promisify)(R.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function p(G){if((0,D.$lg)(G))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function u(G,Z){return c(await(Z?g(G):(0,A.promisify)(R.readdir)(G)))}async function g(G){try{return await(0,A.promisify)(R.readdir)(G,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Z=[],V=await u(G);for(const K of V){let W=!1,B=!1,ie=!1;try{const ae=await e.Promises.lstat((0,P.$kc)(G,K));W=ae.isFile(),B=ae.isDirectory(),ie=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}Z.push({name:K,isFile:()=>W,isDirectory:()=>B,isSymbolicLink:()=>ie})}return Z}function l(G){return c(R.readdirSync(G))}function c(G){return G.map(Z=>typeof Z=="string"?d.$j?(0,I.$Zl)(Z):Z:(Z.name=d.$j?(0,I.$Zl)(Z.name):Z.name,Z))}async function $(G){const Z=await u(G),V=[];for(const K of Z)await o.existsDirectory((0,P.$kc)(G,K))&&V.push(K);return V}function i(G,Z=1e3){return new Promise(V=>{let K=!1;const W=setInterval(()=>{K||(K=!0,R.access(G,B=>{K=!1,B&&(clearInterval(W),V(void 0))}))},Z)})}var o;(function(G){async function Z(W){let B;try{if(B=await e.Promises.lstat(W),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(d.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ae}throw ie}}G.stat=Z;async function V(W){try{const{stat:B,symbolicLink:ie}=await G.stat(W);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}G.existsFile=V;async function K(W){try{const{stat:B,symbolicLink:ie}=await G.stat(W);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}G.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const n=new j.$rh;function s(G,Z,V){return n.queueFor(v.URI.file(G),()=>{const K=E(V);return new Promise((W,B)=>a(G,Z,K,ie=>ie?B(ie):W()))},C.$Mg)}let t=!0;function r(G){t=G}function a(G,Z,V,K){if(!t)return R.writeFile(G,Z,{mode:V.mode,flag:V.flag},K);R.open(G,V.flag,V.mode,(W,B)=>{if(W)return K(W);R.writeFile(B,Z,ie=>{if(ie)return R.close(B,()=>K(ie));R.fdatasync(B,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),r(!1)),R.close(B,te=>K(te))))})})}function y(G,Z,V){const K=E(V);if(!t)return R.writeFileSync(G,Z,{mode:K.mode,flag:K.flag});const W=R.openSync(G,K.flag,K.mode);try{R.writeFileSync(W,Z);try{R.fdatasyncSync(W)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{R.closeSync(W)}}function E(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function k(G,Z,V=6e4){if(G!==Z)try{d.$i&&typeof V=="number"?await S(G,Z,Date.now(),V):await(0,A.promisify)(R.rename)(G,Z)}catch(K){if(G.toLowerCase()!==Z.toLowerCase()&&K.code==="EXDEV"||G.endsWith("."))await w(G,Z,{preserveSymlinks:!1}),await f(G,m.MOVE);else throw K}}async function S(G,Z,V,K,W=0){try{return await(0,A.promisify)(R.rename)(G,Z)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-V>=K)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${B}`),B;if(W===0){let ie=!1;try{const{stat:ae}=await o.stat(Z);ae.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,j.$jh)(Math.min(100,W*10)),S(G,Z,V,K,W+1)}}async function w(G,Z,V){return M(G,Z,{root:{source:G,target:Z},options:V,handledSourcePaths:new Set})}const O=511;async function M(G,Z,V){if(V.handledSourcePaths.has(G))return;V.handledSourcePaths.add(G);const{stat:K,symbolicLink:W}=await o.stat(G);if(W){if(V.options.preserveSymlinks)try{return await _(G,Z,V)}catch{}if(W.dangling)return}return K.isDirectory()?T(G,Z,K.mode&O,V):U(G,Z,K.mode&O)}async function T(G,Z,V,K){await e.Promises.mkdir(Z,{recursive:!0,mode:V});const W=await u(G);for(const B of W)await M((0,P.$kc)(G,B),(0,P.$kc)(Z,B),K)}async function U(G,Z,V){await e.Promises.copyFile(G,Z),await e.Promises.chmod(Z,V)}async function _(G,Z,V){let K=await e.Promises.readlink(G);(0,D.$ig)(K,V.root.source,!d.$k)&&(K=(0,P.$kc)(V.root.target,K.substr(V.root.source.length+1))),await e.Promises.symlink(K,Z)}e.Promises=new class{get access(){return(0,A.promisify)(R.access)}get stat(){return(0,A.promisify)(R.stat)}get lstat(){return(0,A.promisify)(R.lstat)}get utimes(){return(0,A.promisify)(R.utimes)}get read(){return(G,Z,V,K,W)=>new Promise((B,ie)=>{R.read(G,Z,V,K,W,(ae,te,ce)=>ae?ie(ae):B({bytesRead:te,buffer:ce}))})}get readFile(){return(0,A.promisify)(R.readFile)}get write(){return(G,Z,V,K,W)=>new Promise((B,ie)=>{R.write(G,Z,V,K,W,(ae,te,ce)=>ae?ie(ae):B({bytesWritten:te,buffer:ce}))})}get appendFile(){return(0,A.promisify)(R.appendFile)}get fdatasync(){return(0,A.promisify)(R.fdatasync)}get truncate(){return(0,A.promisify)(R.truncate)}get copyFile(){return(0,A.promisify)(R.copyFile)}get open(){return(0,A.promisify)(R.open)}get close(){return(0,A.promisify)(R.close)}get symlink(){return(0,A.promisify)(R.symlink)}get readlink(){return(0,A.promisify)(R.readlink)}get chmod(){return(0,A.promisify)(R.chmod)}get mkdir(){return(0,A.promisify)(R.mkdir)}get unlink(){return(0,A.promisify)(R.unlink)}get rmdir(){return(0,A.promisify)(R.rmdir)}get realpath(){return(0,A.promisify)(R.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return $}get writeFile(){return s}get rm(){return f}get rename(){return k}get copy(){return w}}}),define(le[148],he([0,1,40,14,5,27,31]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=I,e.$Oq=P,e.$Pq=d,e.$Qq=C;function I(m){if(A.$k)return m;const f=(0,N.$nc)(m);if(m===f)return m;const h=((0,N.$oc)(m)||m).toLowerCase();try{const p=(0,D.readdirSync)(f).filter(u=>u.toLowerCase()===h);if(p.length===1){const u=I(f);if(u)return(0,N.$kc)(u,p[0])}else if(p.length>1){const u=p.indexOf(h);if(u>=0){const g=I(f);if(g)return(0,N.$kc)(g,p[u])}}}catch{}return null}async function P(m,f){if(A.$k)return m;const h=(0,N.$nc)(m);if(m===h)return m;const b=((0,N.$oc)(m)||m).toLowerCase();try{if(f?.isCancellationRequested)return null;const u=(await D.Promises.readdir(h)).filter(g=>g.toLowerCase()===b);if(u.length===1){const g=await P(h,f);if(g)return(0,N.$kc)(g,u[0])}else if(u.length>1){const g=u.indexOf(b);if(g>=0){const l=await P(h,f);if(l)return(0,N.$kc)(l,u[g])}}}catch{}return null}async function d(m){try{return await D.Promises.realpath(m)}catch{const h=v(m);return await D.Promises.access(h,R.constants.R_OK),h}}function C(m){try{return R.realpathSync(m)}catch{const h=v(m);return R.accessSync(h,R.constants.R_OK),h}}function v(m){return(0,j.$6e)((0,N.$ic)(m),N.sep)}}),define(le[149],he([0,1,14,5,36,89,13,31]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$am=P,e.$bm=d,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function P(v=A.env){return v.comspec||"cmd.exe"}function d(v){let m=[],f=!1;const h=function(b){if(f){m.push(b);return}(!v.send(b,u=>{if(u&&console.error(u),f=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(l=>h(l))}})||N.$i)&&(f=!0)};return{send:h}}var C;(function(v){async function m(f,h,b){if(R.$jc(f))return f;if(h===void 0&&(h=A.cwd()),R.$nc(f)!=="."||(b===void 0&&D.$Vf(A.env.PATH)&&(b=A.env.PATH.split(R.$uc)),b===void 0||b.length===0))return R.$kc(h,f);async function u(g){if(await I.Promises.exists(g)){let l;try{l=await I.Promises.stat(g)}catch(c){c.message.startsWith("EACCES")&&(l=await I.Promises.lstat(g))}return l?!l.isDirectory():!1}return!1}for(const g of b){let l;if(R.$jc(g)?l=R.$kc(g,f):l=R.$kc(h,g,f),await u(l))return l;let c=l+".com";if(await u(c)||(c=l+".exe",await u(c)))return c}return R.$kc(h,f)}v.findExecutable=m})(C||(e.win32=C={}))}),define(le[150],he([0,1,67,23]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=A;function A(D){return new Promise((I,P)=>{let d;const C=new Map;function v(f,h,b,p,u){const g=C.get(h);if(f===D||g){const l={name:m(b),cmd:b,pid:f,ppid:h,load:p,mem:u};C.set(f,l),f===D&&(d=l),g&&(g.children||(g.children=[]),g.children.push(l),g.children.length>1&&(g.children=g.children.sort((c,$)=>c.pid-$.pid)))}}function m(f){const h=/--utility-sub-type=network/i,b=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(b.exec(f))return"electron-crash-reporter";if(p.exec(f))return"winpty-agent";if(u.exec(f))return"conpty-agent";let l=g.exec(f);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?h.exec(f)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const c=/[a-zA-Z-]+\.js/g;let $="";do l=c.exec(f),l&&($+=l+" ");while(l);return $&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${$})`:f}if(process.platform==="win32"){const f=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,b)=>{se(["@vscode/windows-process-tree"],h,b)}).then(h=>{h.getProcessList(D,b=>{if(!b){P(new Error(`Root process ${D} not found`));return}h.getProcessCpuUsage(b,p=>{const u=new Map;p.forEach(g=>{const l=f(g.commandLine||"");u.set(g.pid,{name:m(l),cmd:l,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),d=u.get(D),d?(u.forEach(g=>{const l=u.get(g.ppid);l&&(l.children||(l.children=[]),l.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((l,c)=>l.pid-c.pid))}),I(d)):P(new Error(`Root process ${D} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let f=function(){let h=[d];const b=[];for(;h.length;){const u=h.shift();u&&(b.push(u.pid),u.children&&(h=h.concat(u.children)))}let p=JSON.stringify(N.$Cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+b.join(" "),(0,R.exec)(p,{},(u,g,l)=>{if(u||l)P(u||new Error(l.toString()));else{const c=g.toString().split(`
`);for(let $=0;$<b.length;$++){const i=C.get(b[$]);i.load=parseFloat(c[$])}if(!d){P(new Error(`Root process ${D} not found`));return}I(d)}})};(0,R.exec)("which ps",{},(h,b,p)=>{if(h||p)if(process.platform!=="linux")P(h||new Error(p.toString()));else{const u=JSON.stringify(N.$Cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(u,{},(g,l,c)=>{g||c?P(g||new Error(c.toString())):(j(l,v),f())})}else{const u=b.toString().trim();(0,R.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,c,$)=>{l||$&&!$.includes("screen size is bogus")?P(l||new Error($.toString())):(j(c,v),process.platform==="linux"?f():d?I(d):P(new Error(`Root process ${D} not found`)))})}})}})}function j(D,I){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=D.toString().split(`
`);for(const C of d){const v=P.exec(C.trim());v&&v.length===6&&I(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}});var ve=this&&this.__decorate||function(se,e,R,N){var A=arguments.length,j=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,R):N,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(se,e,R,N);else for(var I=se.length-1;I>=0;I--)(D=se[I])&&(j=(A<3?D(j):A>3?D(e,R,j):D(e,R))||j);return A>3&&j&&Object.defineProperty(e,R,j),j};define(le[41],he([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(se,e,R,N,A,j,D,I,P,d,C,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=r,e.$Vh=a,e.$1h=O,e.$2h=M;var f;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(f||(f={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(b||(b={}));function p(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));function g(W){let B=0;for(let ie=0;;ie+=7){const ae=W.read(1);if(B|=(ae.buffer[0]&127)<<ie,!(ae.buffer[0]&128))return B}}const l=n(0);function c(W,B){if(B===0){W.write(l);return}let ie=0;for(let te=B;te!==0;te=te>>>7)ie++;const ae=A.$ue.alloc(ie);for(let te=0;B!==0;te++)ae.buffer[te]=B&127,B=B>>>7,B>0&&(ae.buffer[te]|=128);W.write(ae)}class ${constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$Sh=$;class i{constructor(){this.a=[]}get buffer(){return A.$ue.concat(this.a)}write(B){this.a.push(B)}}e.$Th=i;var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(o||(o={}));function n(W){const B=A.$ue.alloc(1);return B.writeUInt8(W,0),B}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(W,B){if(typeof B>"u")W.write(s.Undefined);else if(typeof B=="string"){const ie=A.$ue.fromString(B);W.write(s.String),c(W,ie.byteLength),W.write(ie)}else if(t&&Buffer.isBuffer(B)){const ie=A.$ue.wrap(B);W.write(s.Buffer),c(W,ie.byteLength),W.write(ie)}else if(B instanceof A.$ue)W.write(s.VSBuffer),c(W,B.byteLength),W.write(B);else if(Array.isArray(B)){W.write(s.Array),c(W,B.length);for(const ie of B)r(W,ie)}else if(typeof B=="number"&&(B|0)===B)W.write(s.Uint),c(W,B);else{const ie=A.$ue.fromString(JSON.stringify(B));W.write(s.Object),c(W,ie.byteLength),W.write(ie)}}function a(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(g(W)).toString();case o.Buffer:return W.read(g(W)).buffer;case o.VSBuffer:return W.read(g(W));case o.Array:{const ie=g(W),ae=[];for(let te=0;te<ie;te++)ae.push(a(W));return ae}case o.Object:return JSON.parse(W.read(g(W)).toString());case o.Int:return g(W)}}class y{constructor(B,ie,ae=null,te=1e3){this.h=B,this.j=ie,this.k=ae,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,p(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,p(B.type),B.data);return}}}o(B,ie=void 0){const ae=new i;return r(ae,B),r(ae,ie),this.p(ae.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new $(B),ae=a(ie),te=a(ie),ce=ae[0];switch(ce){case 100:return this.k?.logIncoming(B.byteLength,ae[1],1,`${h(ce)}: ${ae[2]}.${ae[3]}`,te),this.s({type:ce,id:ae[1],channelName:ae[2],name:ae[3],arg:te});case 102:return this.k?.logIncoming(B.byteLength,ae[1],1,`${h(ce)}: ${ae[2]}.${ae[3]}`,te),this.t({type:ce,id:ae[1],channelName:ae[2],name:ae[3],arg:te});case 101:return this.k?.logIncoming(B.byteLength,ae[1],1,`${h(ce)}`),this.u({type:ce,id:ae[1]});case 103:return this.k?.logIncoming(B.byteLength,ae[1],1,`${h(ce)}`),this.u({type:ce,id:ae[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const ae=new j.$ee;let te;try{te=ie.call(this.j,B.name,B.arg,ae.token)}catch(q){te=Promise.reject(q)}const ce=B.id;te.then(q=>{this.m({id:ce,data:q,type:201})},q=>{q instanceof Error?this.m({id:ce,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:ce,data:q,type:203})}).finally(()=>{H.dispose(),this.d.delete(B.id)});const H=(0,d.$Sc)(()=>ae.cancel());this.d.set(B.id,H)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const ae=B.id,ce=ie.listen(this.j,B.name,B.arg)(H=>this.m({id:ae,data:H,type:204}));this.d.set(B.id,ce)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const ae=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:ae})}w(B){const ie=this.g.get(B);if(ie){for(const ae of ie)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=y;var E;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class k{constructor(B,ie=null){this.l=B,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=ie}getChannel(B){const ie=this;return{call(ae,te,ce){return ie.a?Promise.reject(new I.$5):ie.m(B,ae,te,ce)},listen(ae,te){return ie.a?P.Event.None:ie.o(B,ae,te)}}}m(B,ie,ae,te=j.CancellationToken.None){const ce=this.g++,q={id:ce,type:100,channelName:B,name:ie,arg:ae};if(te.isCancellationRequested)return Promise.reject(new I.$5);let L;return new Promise((z,Y)=>{if(te.isCancellationRequested)return Y(new I.$5);const J=()=>{const ne=re=>{switch(re.type){case 201:this.f.delete(ce),z(re.data);break;case 202:{this.f.delete(ce);const ue=new Error(re.data.message);ue.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,ue.name=re.data.name,Y(ue);break}case 203:this.f.delete(ce),Y(re.data);break}};this.f.set(ce,ne),this.p(q)};let ee=null;this.b===u.Idle?J():(ee=(0,N.$8g)(ne=>this.u()),ee.then(()=>{ee=null,J()}));const x=()=>{ee?(ee.cancel(),ee=null):this.p({id:ce,type:101}),Y(new I.$5)},Q=te.onCancellationRequested(x);L=(0,d.$Rc)((0,d.$Sc)(x),Q),this.d.add(L)}).finally(()=>{L.dispose(),this.d.delete(L)})}o(B,ie,ae){const te=this.g++,H={id:te,type:102,channelName:B,name:ie,arg:ae};let q=null;const L=new P.$7d({onWillAddFirstListener:()=>{q=(0,N.$8g)(z=>this.u()),q.then(()=>{q=null,this.d.add(L),this.p(H)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(L),this.p({id:te,type:103}))}}),F=z=>L.fire(z.data);return this.f.set(te,F),L.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${h(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,h(B.type));return}}}q(B,ie=void 0){const ae=new i;return r(ae,B),r(ae,ie),this.r(ae.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new $(B),ae=a(ie),te=a(ie),ce=ae[0];switch(ce){case 200:return this.j?.logIncoming(B.byteLength,0,0,p(ce)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,ae[1],0,p(ce),te),this.t({type:ae[0],id:ae[1],data:te})}}t(B){if(B.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=k,ve([D.$Mh],k.prototype,"onDidInitializePromise",null);class S{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,ae){this.a=new Map,this.f=new Set,this.g=new P.$7d,this.onDidAddConnection=this.g.event,this.h=new P.$7d,this.onDidRemoveConnection=this.h.event,this.j=new d.$Tc,this.j.add(B(({protocol:te,onDidClientDisconnect:ce})=>{const H=P.Event.once(te.onMessage);this.j.add(H(q=>{const L=new $(q),F=a(L),z=new y(te,F,ie,ae),Y=new k(te,ie);this.a.forEach((ee,x)=>z.registerChannel(x,ee));const J={channelServer:z,channelClient:Y,ctx:F};this.f.add(J),this.g.fire(J),this.j.add(ce(()=>{z.dispose(),Y.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(B,ie){const ae=this;return{call(te,ce,H){let q;if((0,m.$0f)(ie)){const F=(0,R.$4b)(ae.connections.filter(ie));q=F?Promise.resolve(F):P.Event.toPromise(P.Event.filter(ae.onDidAddConnection,ie))}else q=ie.routeCall(ae,te,ce);const L=q.then(F=>F.channelClient.getChannel(B));return O(L).call(te,ce,H)},listen(te,ce){if((0,m.$0f)(ie))return ae.k(B,ie,te,ce);const H=ie.routeEvent(ae,te,ce).then(q=>q.channelClient.getChannel(B));return O(H).listen(te,ce)}}}k(B,ie,ae,te){const ce=this;let H;const q=new P.$7d({onWillAddFirstListener:()=>{H=new d.$Tc;const L=new P.$ae,F=new Map,z=J=>{const x=J.channelClient.getChannel(B).listen(ae,te),Q=L.add(x);F.set(J,Q)},Y=J=>{const ee=F.get(J);ee&&(ee.dispose(),F.delete(J))};ce.connections.filter(ie).forEach(z),P.Event.filter(ce.onDidAddConnection,ie)(z,void 0,H),ce.onDidRemoveConnection(Y,void 0,H),L.event(q.fire,q,H),H.add(L)},onDidRemoveLastListener:()=>{H?.dispose(),H=void 0}});return q.event}registerChannel(B,ie){this.a.set(B,ie);for(const ae of this.f)ae.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=S;class w{constructor(B,ie,ae=null){const te=new i;r(te,ie),B.send(te.buffer),this.a=new k(B,ae),this.d=new y(B,ie,ae)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=w;function O(W){return{call(B,ie,ae){return W.then(te=>te.call(B,ie,ae))},listen(B,ie){const ae=new P.$de;return W.then(te=>ae.input=te.listen(B,ie)),ae.event}}}function M(W){let B=!1;return{call(ie,ae,te){return B?W.call(ie,ae,te):(0,N.$jh)(0).then(()=>B=!0).then(()=>W.call(ie,ae,te))},listen(ie,ae){if(B)return W.listen(ie,ae);const te=new P.$de;return(0,N.$jh)(0).then(()=>B=!0).then(()=>te.input=W.listen(ie,ae)),te.event}}}class T{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await P.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$3h=T;var U;(function(W){function B(ce,H,q){const L=ce,F=q&&q.disableMarshalling,z=new Map;for(const Y in L)ae(Y)&&z.set(Y,P.Event.buffer(L[Y],!0,void 0,H));return new class{listen(Y,J,ee){const x=z.get(J);if(x)return x;const Q=L[J];if(typeof Q=="function"){if(te(J))return Q.call(L,ee);if(ae(J))return z.set(J,P.Event.buffer(L[J],!0,void 0,H)),z.get(J)}throw new I.$bb(`Event not found: ${J}`)}call(Y,J,ee){const x=L[J];if(typeof x=="function"){if(!F&&Array.isArray(ee))for(let ne=0;ne<ee.length;ne++)ee[ne]=(0,C.$Rh)(ee[ne]);let Q=x.apply(L,ee);return Q instanceof Promise||(Q=Promise.resolve(Q)),Q}throw new I.$bb(`Method not found: ${J}`)}}}W.fromService=B;function ie(ce,H){const q=H&&H.disableMarshalling;return new Proxy({},{get(L,F){if(typeof F=="string")return H?.properties?.has(F)?H.properties.get(F):te(F)?function(z){return ce.listen(F,z)}:ae(F)?ce.listen(F):async function(...z){let Y;H&&!(0,m.$5f)(H.context)?Y=[H.context,...z]:Y=z;const J=await ce.call(F,Y);return q?J:(0,C.$Rh)(J)};throw new I.$bb(`Property not found: ${String(F)}`)}})}W.toService=ie;function ae(ce){return ce[0]==="o"&&ce[1]==="n"&&v.$kf(ce.charCodeAt(2))}function te(ce){return/^onDynamic/.test(ce)&&v.$kf(ce.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const _=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const B=W.toString();if(B!=="[object Object]")return B}return W}function Z(W){return Array.isArray(W)?W.map(G):G(W)}function V(W,B,ie,ae,te,ce,H){H=Z(H);const q=_[te],L=q[ae%q.length];let F=[`%c[${W}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(ce)?(F=F.concat(H),F.push(")")):F.push(H),console.log.apply(console,F)}class K{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,ae,te,ce){this.b+=B,V(this.d,this.b,B,ie,ae,te,ce)}logIncoming(B,ie,ae,te,ce){this.a+=B,V(this.f,this.a,B,ie,ae,te,ce)}}e.$4h=K}),define(le[68],he([0,1,15,3,2,41]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.ProtocolConstants=e.$5h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(E,k){if(!t.has(E)){const S=String(++r);t.set(E,S)}return t.get(E)}function y(E,k,S,w){if(!s.enableDiagnostics)return;const O=a(E,k);if(w instanceof R.$ue||w instanceof Uint8Array||w instanceof ArrayBuffer||ArrayBuffer.isView(w)){const M=R.$ue.alloc(w.byteLength);M.set(w),s.records.push({timestamp:Date.now(),id:O,label:k,type:S,buff:M})}else s.records.push({timestamp:Date.now(),id:O,label:k,type:S,data:w})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let d=null;function C(){return d||(d=R.$ue.alloc(0)),d}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const k=this.a[0];return r&&(this.a.shift(),this.b-=t),k}if(this.a[0].byteLength>t){const k=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),k}const a=R.$ue.alloc(t);let y=0,E=0;for(;t>0;){const k=this.a[E];if(k.byteLength>t){const S=k.slice(0,t);a.set(S,y),y+=t,r&&(this.a[E]=k.slice(t),this.b-=t),t-=t}else a.set(k,y),y+=k.byteLength,r?(this.a.shift(),this.b-=k.byteLength):E++,t-=k.byteLength}return a}}e.$5h=v;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function f(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class b{constructor(t,r,a,y){this.type=t,this.id=r,this.ack=a,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends A.$Uc{constructor(t){super(),this.f=this.B(new N.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new v,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,y=this.g.id,E=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(a,y,E,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=R.$ue.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=R.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class g extends A.$Uc{constructor(t){super(),this.f=new N.$7d,this.onMessage=this.f.event,this.g=new N.$7d,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new u(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new b(1,0,0,t))}}e.$6h=g;class l extends j.$Zh{static fromSocket(t,r){return new l(new g(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$7h=l;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$8h=c;class ${constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new $(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let y=0;y<o.a;y++)t-this.c[y]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Tc,this.o=t.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new b(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new b(7,0,0,C());this.p.write(t)}sendResume(){const t=new b(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new A.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,y=r.length;a<y;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,y=r.length;a<y;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new b(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new b(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(r>=2e4&&a>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const E=Math.max(2e4-r,2e4-a,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},E)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new b(9,0,this.h,C());this.p.write(t)}}e.$9h=n}),define(le[92],he([0,1,67,6,15,26,142,7,3,2,30,149,89,41]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class h extends f.$Wh{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",g=>A.$ue.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Jq=h;class b{constructor(u,g){this.i=u,this.j=g,this.c=new Set,this.g=new Map,this.h=new P.$7d,this.onDidProcessExit=this.h.event;const l=g&&g.timeout?g.timeout:6e4;this.b=new N.$fh(l),this.d=null,this.f=null}getChannel(u){const g=this;return{call(l,c,$){return g.k(u,l,c,$)},listen(l,c){return g.l(u,l,c)}}}k(u,g,l,c=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const $=this.n(u),i=(0,N.$8g)(s=>$.call(g,l,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,d.$Sc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,g,l){if(!this.b)return P.Event.None;this.b.cancel();let c;const $=new P.$7d({onWillAddFirstListener:()=>{c=this.n(u).listen(g,l)($.fire,$),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,C.$On)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.$_l)(g.env),this.d=(0,R.fork)(this.i,u,g);const l=new P.$7d,$=P.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,D.$Fq)(r)){(0,D.log)(r,`IPC Library: ${this.j.serverName}`);return}l.fire(A.$ue.wrap(Buffer.from(r,"base64")))}),i=this.j.useQueue?(0,v.$bm)(this.d):this.d,o=r=>this.d&&this.d.connected&&i.send(r.buffer.toString("base64")),n=l.event,s={send:o,onMessage:n};this.f=new f.$Xh(s);const t=()=>this.o();process.once("exit",t),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",t),$.dispose(),this.c.forEach(y=>(0,d.$Pc)(y)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(u){let g=this.g.get(u);return g||(g=this.m.getChannel(u),this.g.set(u,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Kq=b}),define(le[151],he([0,1,134,15,41,3,13,17]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mW=void 0,e.$nW=C;class P{constructor(m){this.a=m,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",f=>f.data?N.$ue.wrap(f.data):N.$ue.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class d extends A.$Yh{static b(m){(0,D.$6f)((0,R.$lW)(process),"Electron Utility Process");const f=new j.$7d;return process.parentPort.on("message",h=>{if(m?.handledClientConnection(h))return;const b=(0,I.$Ob)(h.ports);b&&f.fire(b)}),j.Event.map(f.event,h=>({protocol:new P(h),onDidClientDisconnect:j.Event.fromNodeEventEmitter(h,"close")}))}constructor(m){super(d.b(m))}}e.$mW=d;function C(v,m,f){const h=b=>{b.data===m&&(v.removeListener("message",h),f())};v.on("message",h)}}),define(le[69],he([0,1,6,3,2,66,13]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.StorageState=e.StorageHint=void 0,e.$Hp=P;var I;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function P(m){const f=m;return f?.changed instanceof Map||f?.deleted instanceof Set}var d;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(d||(e.StorageState=d={}));class C extends A.$Uc{static{this.a=100}constructor(f,h=Object.create(null)){super(),this.r=f,this.s=h,this.b=this.B(new N.$0d),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new R.$gh(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((h,b)=>this.w(b,h)),f.deleted?.forEach(h=>this.w(h,void 0))}finally{this.b.resume()}}w(f,h){if(this.c===d.Closed)return;let b=!1;(0,D.$5f)(h)?b=this.f.delete(f):this.f.get(f)!==h&&(this.f.set(f,h),b=!0),b&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,h){const b=this.f.get(f);return(0,D.$5f)(b)?h:b}getBoolean(f,h){const b=this.get(f);return(0,D.$5f)(b)?h:b==="true"}getNumber(f,h){const b=this.get(f);return(0,D.$5f)(b)?h:parseInt(b,10)}getObject(f,h){const b=this.get(f);return(0,D.$5f)(b)?h:(0,j.$Qh)(b)}async set(f,h,b=!1){if(this.c===d.Closed)return;if((0,D.$5f)(h))return this.delete(f,b);const p=(0,D.$Xf)(h)||Array.isArray(h)?(0,j.$Ph)(h):String(h);if(this.f.get(f)!==p)return this.f.set(f,p),this.j.set(f,p),this.h.delete(f),this.b.fire({key:f,external:b}),this.D()}async delete(f,h=!1){if(!(this.c===d.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:h}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Ip=C;class v{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((h,b)=>this.a.set(b,h)),f.delete?.forEach(h=>this.a.delete(h))}async optimize(){}async close(){}}e.$Jp=v}),define(le[152],he([11,10]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,40,6,14,13,31,152]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.zip=p,e.$7p=u,e.$8p=l,e.$4p="end of central directory record signature not found";const P=new RegExp(e.$4p);class d extends Error{constructor($,i){let o=i.message;switch($){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=$,this.cause=i}}e.$5p=d;function C(c){const $=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>$&i).reduce((i,o)=>i+o,$&61440)}function v(c){if(c instanceof d)return c;let $;return P.test(c.message)&&($="CorruptZip"),new d($,c)}function m(c,$,i,o,n,s){const t=A.$nc($),r=A.$kc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(I.localize(0,null,$)));const a=A.$kc(o,$);let y;return s.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(D.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((E,k)=>{if(!s.isCancellationRequested)try{y=(0,R.createWriteStream)(a,{mode:i}),y.once("close",()=>E()),y.once("error",k),c.once("error",k),c.pipe(y)}catch(S){k(S)}}))}function f(c,$,i,o){let n=(0,N.$8g)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const y=new N.$dh,E=k=>{k.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new d("Incomplete",new Error(I.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",k=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(k.fileName)){E(o);return}const S=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(S)){const M=A.$kc($,S);n=(0,N.$8g)(T=>D.Promises.mkdir(M,{recursive:!0}).then(()=>E(T)).then(void 0,a));return}const w=b(c,k),O=C(k);n=(0,N.$8g)(M=>y.queue(()=>w.then(T=>m(T,S,O,$,i,M).then(()=>E(M)))).then(null,a))})}).finally(()=>t.dispose())}async function h(c,$=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,$?{lazyEntries:!0}:void 0,(s,t)=>{s?n(v(s)):o((0,j.$7f)(t))})})}function b(c,$){return new Promise((i,o)=>{c.openReadStream($,(n,s)=>{n?o(v(n)):i((0,j.$7f)(s))})})}async function p(c,$){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;$.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,R.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}function u(c,$,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=h(c,!0);return i.overwrite&&(s=s.then(t=>D.Promises.rm($).then(()=>t))),s.then(t=>f(t,$,{sourcePathRegex:n},o))}function g(c,$){return h(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===$&&b(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(I.localize(2,null,$))))}))}function l(c,$){return g(c,$).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}}),define(le[153],he([11,10]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[154],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[155],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[156],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[157],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[158],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[159],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[160],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[161],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[162],he([11,10]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[163],he([11,10]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[164],he([11,10]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[165],he([11,10]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[166],he([11,10]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[167],he([11,10]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[168],he([11,10]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(le[169],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[170],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[171],he([11,10]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[172],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[173],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[174],he([11,10]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[175],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[176],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[177],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[178],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[179],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[180],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[181],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[182],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[183],he([11,10]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[184],he([0,1,7,155]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var A;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(A||(e.TokenType=A={}));function j(...d){switch(d.length){case 1:return(0,N.localize)(0,null,d[0]);case 2:return(0,N.localize)(1,null,d[0],d[1]);case 3:return(0,N.localize)(2,null,d[0],d[1],d[2]);default:return}}const D=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class P{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,R.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const v=this.d,m=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:m};this.g.push({offset:v,lexeme:m,additionalInfo:C}),this.f.push(f)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const v=this.c.substring(this.d,this.e),m=P.b.get(v);m?this.k(m):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,v=!1,m=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(I);return}const h=this.c.charCodeAt(C);if(v)v=!1;else if(h===47&&!m){C++;break}else h===91?m=!0:h===92?v=!0:h===93&&(m=!1);C++}for(;C<this.c.length&&P.a.has(this.c.charCodeAt(C));)C++;this.e=C;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=P}),define(le[185],he([0,1,65,84,23,14,36,20,8]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=void 0,e.$Sm=C,e.$Tm=v,e.$Qm=/^([^.]+\..+)[:=](.+)$/;class d{get appRoot(){return(0,j.$nc)(A.$Cg.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,j.$kc)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,I.$Vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$Vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,R.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$kc)(this.userDataPath,"logs",f)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$Vg)(P.URI.file((0,j.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$Vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$Vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$Vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=D.env.VSCODE_PORTABLE;return f?P.URI.file((0,j.$kc)(f,"argv.json")):(0,I.$Vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,j.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,j.$lc)(f):(0,j.$ic)((0,j.$kc)(A.$Cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?P.URI.file((0,j.$lc)(f)):P.URI.file((0,j.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,j.$lc)(f);const h=D.env.VSCODE_EXTENSIONS;if(h)return h;const b=D.env.VSCODE_PORTABLE;return b?(0,j.$kc)(b,"extensions"):(0,I.$Vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(h=>/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,j.$ic)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file((0,j.$ic)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$Qm.test(f))}get extensionLogLevel(){const f=[];for(const h of this.args.log||[]){const b=e.$Qm.exec(h);b&&b[1]&&b[2]&&f.push([b[1],b[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,I.$Vg)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=D.env.VSCODE_PORTABLE;return f?P.URI.file((0,j.$kc)(f,"policy.json")):(0,I.$Vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,h,b){this.a=f,this.b=h,this.c=b,this.editSessionId=this.args.editSessionId}}e.$Rm=d,ve([N.$Mh],d.prototype,"appRoot",null),ve([N.$Mh],d.prototype,"userHome",null),ve([N.$Mh],d.prototype,"userDataPath",null),ve([N.$Mh],d.prototype,"appSettingsHome",null),ve([N.$Mh],d.prototype,"tmpDir",null),ve([N.$Mh],d.prototype,"cacheHome",null),ve([N.$Mh],d.prototype,"stateResource",null),ve([N.$Mh],d.prototype,"userRoamingDataHome",null),ve([N.$Mh],d.prototype,"userDataSyncHome",null),ve([N.$Mh],d.prototype,"sync",null),ve([N.$Mh],d.prototype,"machineSettingsResource",null),ve([N.$Mh],d.prototype,"workspaceStorageHome",null),ve([N.$Mh],d.prototype,"localHistoryHome",null),ve([N.$Mh],d.prototype,"keyboardLayoutResource",null),ve([N.$Mh],d.prototype,"argvResource",null),ve([N.$Mh],d.prototype,"isExtensionDevelopment",null),ve([N.$Mh],d.prototype,"untitledWorkspacesHome",null),ve([N.$Mh],d.prototype,"builtinExtensionsPath",null),ve([N.$Mh],d.prototype,"extensionsPath",null),ve([N.$Mh],d.prototype,"extensionDevelopmentLocationURI",null),ve([N.$Mh],d.prototype,"extensionDevelopmentKind",null),ve([N.$Mh],d.prototype,"extensionTestsLocationURI",null),ve([N.$Mh],d.prototype,"debugExtensionHost",null),ve([N.$Mh],d.prototype,"logLevel",null),ve([N.$Mh],d.prototype,"extensionLogLevel",null),ve([N.$Mh],d.prototype,"serviceMachineIdResource",null),ve([N.$Mh],d.prototype,"disableTelemetry",null),ve([N.$Mh],d.prototype,"disableWorkspaceTrust",null),ve([N.$Mh],d.prototype,"useInMemorySecretStorage",null),ve([N.$Mh],d.prototype,"policyFile",null);function C(m,f){return v(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}function v(m,f,h,b,p,u){const l=Number(f||m)||(b?null:h),c=l?!!f:!1;let $;if(u)try{$=JSON.parse(u)}catch{}return{port:l,break:c,debugId:p,env:$}}}),function(){"use strict";function se(e,R,N){function A(D,I){const P=j(D,I),d=[P];return e.isAbsolute(P)||d.unshift(N),e.resolve(...d)}function j(D,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,I);const C=D["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(v,"AppData","Roaming")}break;case"darwin":d=e.join(R.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,I)}return{getUserDataPath:A}}if(typeof define=="function")define(le[186],he([276,37,36]),function(e,R,N){return se(e,R,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=se(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[187],he([0,1,37,185,186]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Vm=D,e.$Wm=I;class j extends N.$Rm{constructor(d,C){super(d,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,A.getUserDataPath)(d,C.nameShort)},C)}}e.$Um=j;function D(P,d){return(0,N.$Tm)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,d,P.extensionEnvironment)}function I(P,d){return(0,N.$Tm)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,d,P.extensionEnvironment)}}),define(le[188],he([0,1,13,158]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=A;function A(D,I,P,d){try{j(D,I,P,d)}catch(C){D.error(C?.message??C)}return I}function j(D,I,P,d){const C=(v,m,f)=>{const h=v[m];if((0,R.$Vf)(h)){const b=h,p=b.length;if(p>1&&b[0]==="%"&&b[p-1]==="%"){const u=b.substr(1,p-2);let g=P[u];g===void 0&&d&&(g=d[u]);const l=typeof g=="string"?g:g?.message,c=d?.[u],$=typeof c=="string"?c:c?.message;if(!l){$||D.warn(`[${I.name}]: ${(0,N.localize)(0,null,u)}`);return}if(f&&(m==="title"||m==="category")&&$&&$!==l){const i={value:l,original:$};v[m]=i}else v[m]=l}}else if((0,R.$Xf)(h))for(const b in h)h.hasOwnProperty(b)&&(b==="commands"?C(h,b,!0):C(h,b,f));else if(Array.isArray(h))for(let b=0;b<h.length;b++)C(h,b,f)};for(const v in I)I.hasOwnProperty(v)&&C(I,v)}}),define(le[189],he([0,1,70,161]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=A;function A(j){return(0,R.$8p)(j,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(le[190],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=e.$3cc=void 0;class R{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$3cc=R;class N{constructor(j){this.a=j}listen(j,D){throw new Error(`Event not found: ${D}`)}call(j,D,I){switch(D){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${D}`)}}e.$4cc=N}),define(le[71],he([0,1,20,88,162,55]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=P,e.$tp=d,e.$up=C,e.$vp=v,e.$wp=m,e.$xp=f,e.$yp=h;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function P(u){return u=u.trim(),u==="*"||D.test(u)}function d(u){if(!P(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(D);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}function C(u){if(!u)return null;const g=u.majorBase,l=u.majorMustEqual,c=u.minorBase;let $=u.minorMustEqual;const i=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(g===0||($=!1),o=!1);let n=0;if(u.preRelease){const s=I.exec(u.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:g,majorMustEqual:l,minorBase:c,minorMustEqual:$,patchBase:i,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:n}}function v(u,g,l){let c;typeof u=="string"?c=C(d(u)):c=u;let $;g instanceof Date?$=g.getTime():typeof g=="string"&&($=new Date(g).getTime());let i;if(typeof l=="string"?i=C(d(l)):i=l,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const y=i.notBefore;let E=i.majorMustEqual,k=i.minorMustEqual,S=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||$&&$<y?!1:s>=a:(o===1&&t===0&&(!E||!k||!S)&&(t=1,r=0,a=0,E=!0,k=!1,S=!1),o<t?!1:o>t?!E:n<r?!1:n>r?!k:s<a?!1:s>a?!S:!($&&$<y))}function m(u,g,l,c,$){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,A.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,A.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,A.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,A.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!p(c.extensionDependencies))return i.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!p(c.activationEvents))return i.push([N.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,A.localize(9,null,"main")]),i;{const s=(0,R.$Vg)(l,c.main);(0,R.$Pg)(s,l)||i.push([N.default.Warning,A.localize(10,null,s.path,l.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,A.localize(11,null,"browser")]),i;{const s=(0,R.$Vg)(l,c.browser);(0,R.$Pg)(s,l)||i.push([N.default.Warning,A.localize(12,null,s.path,l.path)])}}if(!j.valid(c.version))return i.push([N.default.Error,A.localize(13,null)]),i;const o=[];if(!f(u,g,c,$,o))for(const s of o)i.push([N.default.Error,s]);return i}function f(u,g,l,c,$){return c||typeof l.main>"u"&&typeof l.browser>"u"?!0:b(u,g,l.engines.vscode,$)}function h(u,g,l){return u==="*"||b(g,l,u)}function b(u,g,l,c=[]){const $=C(d(l));if(!$)return c.push(A.localize(14,null,l)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return c.push(A.localize(15,null,l)),!1}else if(!$.majorMustEqual)return c.push(A.localize(16,null,l)),!1;return v(u,g,$)?!0:(c.push(A.localize(17,null,u,l)),!1)}function p(u){if(!Array.isArray(u))return!1;for(let g=0,l=u.length;g<l;g++)if(typeof u[g]!="string")return!1;return!0}}),define(le[45],he([0,1,15,32]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=A;async function A(j,D,I){let P=I&&I.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const C=(await D.readFile(j.serviceMachineIdResource)).value.toString();P=(0,N.$Dg)(C)?C:null}catch{P=null}if(!P){P=(0,N.$Eg)();try{await D.writeFile(j.serviceMachineIdResource,R.$ue.fromString(P))}catch{}}return I?.store("storage.serviceMachineId",P,-1,1),P}}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class R{constructor(A,j=[],D=!1){this.ctor=A,this.staticArguments=j,this.supportsDelayedInstantiation=D}}e.$fi=R}),define(le[191],he([0,1,72]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=j,e.$hs=D;const N=[];var A;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function j(I,P,d){P instanceof R.$fi||(P=new R.$fi(P,[],!!d)),N.push([I,P])}function D(){return N}}),define(le[192],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class R{constructor(j,D){this.key=j,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=R;class N{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const D of this.a.values())D.outgoing.size===0&&j.push(D);return j}insertEdge(j,D){const I=this.lookupOrInsertNode(j),P=this.lookupOrInsertNode(D);I.outgoing.set(P.key,P),P.incoming.set(I.key,I)}removeNode(j){const D=this.b(j);this.a.delete(D);for(const I of this.a.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(j){const D=this.b(j);let I=this.a.get(D);return I||(I=new R(D,j),this.a.set(D,I)),I}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[D,I]of this.a)j.push(`${D}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,D]of this.a){const I=new Set([j]),P=this.c(D,I);if(P)return P}}c(j,D){for(const[I,P]of j.outgoing){if(D.has(I))return[...D,I].join(" -> ");D.add(I);const d=this.c(P,D);if(d)return d;D.delete(I)}}}e.$Xq=N}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=A,e.$ji=j;var R;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function I(P){return P[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=I})(R||(e._util=R={})),e.$hi=A("instantiationService");function N(D,I,P){I[R.DI_TARGET]===I?I[R.DI_DEPENDENCIES].push({id:D,index:P}):(I[R.DI_DEPENDENCIES]=[{id:D,index:P}],I[R.DI_TARGET]=I)}function A(D){if(R.serviceIds.has(D))return R.serviceIds.get(D);const I=function(P,d,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,P,C)};return I.toString=()=>D,R.serviceIds.set(D,I),I}function j(D){return D}}),define(le[193],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0,e.$Ccc=(0,R.$ii)("checksumService")}),define(le[21],he([0,1,13,8,4]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=j,e.$Qi=D,e.$Ri=P,e.$Si=d,e.$Ti=C,e.$Ui=v,e.$Vi=m,e.$Wi=h,e.$Xi=b,e.$Yi=p,e.$Oi=(0,A.$ii)("configurationService");function j(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof N.URI)}function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof N.URI)}var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function P(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function d(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}function C(u,g){const l=Object.create(null);for(const c in u)v(l,c,u[c],g);return l}function v(u,g,l,c){const $=g.split("."),i=$.pop();let o=u;for(let n=0;n<$.length;n++){const s=$[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${g} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=l}catch{c(`Ignoring ${g} as ${$.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${g} as ${$.join(".")} is ${JSON.stringify(o)}`)}function m(u,g){const l=g.split(".");f(u,l)}function f(u,g){const l=g.shift();if(g.length===0){delete u[l];return}if(Object.keys(u).indexOf(l)!==-1){const c=u[l];typeof c=="object"&&!Array.isArray(c)&&(f(c,g),Object.keys(c).length===0&&delete u[l])}}function h(u,g,l){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const $=g.split("."),i=c(u,$);return typeof i>"u"?l:i}function b(u,g,l){Object.keys(g).forEach(c=>{c!=="__proto__"&&(c in u?R.$Xf(u[c])&&R.$Xf(g[c])?b(u[c],g[c],l):l&&(u[c]=g[c]):u[c]=g[c])})}function p(u){return u.replace(/[\[\]]/g,"")}}),define(le[93],he([0,1,5,27,184,4,154,7]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=d,e.$hj=o,e.$ij=n,e.$Bj=te;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",R.$j),P.set("isLinux",R.$k),P.set("isWindows",R.$i),P.set("isWeb",R.$o),P.set("isMacNative",R.$j&&!R.$o),P.set("isEdge",R.$H),P.set("isFirefox",R.$F),P.set("isChrome",R.$E),P.set("isSafari",R.$G);function d(q,L){if(P.get(q)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(q,L)}const C=Object.prototype.hasOwnProperty;var v;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const m={regexParsingWithErrorRecovery:!0},f=(0,D.localize)(0,null),h=(0,D.localize)(1,null),b=(0,D.localize)(2,null),p=(0,D.localize)(3,null),u=(0,D.localize)(4,null),g=(0,D.localize)(5,null),l=(0,D.localize)(6,null),c=(0,D.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=m){this.k=L,this.d=new A.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:h});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const z=this.D(),Y=z.type===17?g:void 0;throw this.h.push({message:u,offset:z.offset,lexeme:A.$dj.getLexeme(z),additionalInfo:Y}),$.c}return F}catch(F){if(F!==$.c)throw F;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const F=this.o();L.push(F)}return L.length===1?L[0]:i.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const F=this.s();L.push(F)}return L.length===1?L[0]:i.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,p),F?.negate()}case 17:return this.z(),w.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const F=this.l();return this.A(1,p),F}case 17:{const F=L.lexeme;if(this.z(),this.y(9)){const Y=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Y.type!==10)throw this.B("REGEX",Y);const J=Y.lexeme,ee=J.lastIndexOf("/"),x=ee===J.length-1?void 0:this.w(J.substring(ee+1));let Q;try{Q=new RegExp(J.substring(1,ee),x)}catch{throw this.B("REGEX",Y)}return G.create(F,Q)}switch(Y.type){case 10:case 19:{const J=[Y.lexeme];this.z();let ee=this.D(),x=0;for(let de=0;de<Y.lexeme.length;de++)Y.lexeme.charCodeAt(de)===40?x++:Y.lexeme.charCodeAt(de)===41&&x--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:x++;break;case 1:x--;break;case 10:case 18:for(let de=0;de<ee.lexeme.length;de++)ee.lexeme.charCodeAt(de)===40?x++:Y.lexeme.charCodeAt(de)===41&&x--}if(x<0)break;J.push(A.$dj.getLexeme(ee)),this.z(),ee=this.D()}const Q=J.join(""),ne=Q.lastIndexOf("/"),re=ne===Q.length-1?void 0:this.w(Q.substring(ne+1));let ue;try{ue=new RegExp(Q.substring(1,ne),re)}catch{throw this.B("REGEX",Y)}return i.regex(F,ue)}case 18:{const J=Y.lexeme;this.z();let ee=null;if(!(0,N.$Ue)(J)){const x=J.indexOf("/"),Q=J.lastIndexOf("/");if(x!==Q&&x>=0){const ne=J.slice(x+1,Q),re=J[Q+1]==="i"?"i":"";try{ee=new RegExp(ne,re)}catch{throw this.B("REGEX",Y)}}}if(ee===null)throw this.B("REGEX",Y);return G.create(F,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const Y=this.u();return i.notIn(F,Y)}switch(this.D().type){case 3:{this.z();const Y=this.u();if(this.x().type===18)return i.equals(F,Y);switch(Y){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,Y)}}case 4:{this.z();const Y=this.u();if(this.x().type===18)return i.notEquals(F,Y);switch(Y){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,Y)}}case 5:return this.z(),U.create(F,this.u());case 6:return this.z(),_.create(F,this.u());case 7:return this.z(),M.create(F,this.u());case 8:return this.z(),T.create(F,this.u());case 13:return this.z(),i.in(F,this.u());default:return i.has(F)}}case 20:throw this.h.push({message:l,offset:L.offset,lexeme:"",additionalInfo:c}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,F){if(this.C(L))return this.z();throw this.B(F,this.D())}B(L,F,z){const Y=(0,D.localize)(8,null,L,A.$dj.getLexeme(F)),J=F.offset,ee=A.$dj.getLexeme(F);return this.h.push({message:Y,offset:J,lexeme:ee,additionalInfo:z}),$.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=$;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(L){return a.create(L)}static equals(L,F){return y.create(L,F)}static notEquals(L,F){return S.create(L,F)}static regex(L,F){return G.create(L,F)}static in(L,F){return E.create(L,F)}static notIn(L,F){return k.create(L,F)}static not(L){return w.create(L)}static and(...L){return K.create(L,null,!0)}static or(...L){return W.create(L,null,!0)}static greater(L,F){return M.create(L,F)}static greaterEquals(L,F){return T.create(L,F)}static smaller(L,F){return U.create(L,F)}static smallerEquals(L,F){return _.create(L,F)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$gj=i;function o(q){const L=new $({regexParsingWithErrorRecovery:!1});return q.map(F=>(L.parse(F),L.lexingErrors.length>0?L.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,D.localize)(9,null,z.additionalInfo):(0,D.localize)(10,null),offset:z.offset,length:z.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function n(q,L){const F=q?q.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!F&&!z?!0:!F||!z?!1:F.equals(z)}function s(q,L){return q.cmp(L)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return r.INSTANCE}}e.$jj=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return t.INSTANCE}}e.$kj=r;class a{static create(L,F=null){const z=P.get(L);return typeof z=="boolean"?z?r.INSTANCE:t.INSTANCE:new a(L,F)}constructor(L,F){this.key=L,this.c=F,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:ie(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?r.INSTANCE:t.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=w.create(this.key,this)),this.c}}e.$lj=a;class y{static create(L,F,z=null){if(typeof F=="boolean")return F?a.create(L,z):w.create(L,z);const Y=P.get(L);return typeof Y=="boolean"?F===(Y?"true":"false")?r.INSTANCE:t.INSTANCE:new y(L,F,z)}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=P.get(this.c);if(typeof L=="boolean"){const F=L?"true":"false";return this.d===F?r.INSTANCE:t.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$mj=y;class E{static create(L,F){return new E(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const F=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray(F)?F.includes(z):typeof z=="string"&&typeof F=="object"&&F!==null?C.call(F,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$nj=E;class k{static create(L,F){return new k(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=11,this.c=E.create(L,F)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=k;class S{static create(L,F,z=null){if(typeof F=="boolean")return F?w.create(L,z):a.create(L,z);const Y=P.get(L);return typeof Y=="boolean"?F===(Y?"true":"false")?t.INSTANCE:r.INSTANCE:new S(L,F,z)}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=P.get(this.c);if(typeof L=="boolean"){const F=L?"true":"false";return this.d===F?t.INSTANCE:r.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$pj=S;class w{static create(L,F=null){const z=P.get(L);return typeof z=="boolean"?z?t.INSTANCE:r.INSTANCE:new w(L,F)}constructor(L,F){this.c=L,this.d=F,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:ie(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=P.get(this.c);return typeof L=="boolean"?L?t.INSTANCE:r.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$qj=w;function O(q,L){if(typeof q=="string"){const F=parseFloat(q);isNaN(F)||(q=F)}return typeof q=="string"||typeof q=="number"?L(q):t.INSTANCE}class M{static create(L,F,z=null){return O(F,Y=>new M(L,Y,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$rj=M;class T{static create(L,F,z=null){return O(F,Y=>new T(L,Y,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$sj=T;class U{static create(L,F,z=null){return O(F,Y=>new U(L,Y,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$tj=U;class _{static create(L,F,z=null){return O(F,Y=>new _(L,Y,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:ae(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$uj=_;class G{static create(L,F){return new G(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const F=this.f?this.f.source:"",z=L.f?L.f.source:"";return F<z?-1:F>z?1:0}equals(L){if(L.type===this.type){const F=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&F===z}return!1}substituteConstants(){return this}evaluate(L){const F=L.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$vj=G;class Z{static create(L){return new Z(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new Z(this.c.map(L))}negate(){return this.c}}e.$wj=Z;function V(q){let L=null;for(let F=0,z=q.length;F<z;F++){const Y=q[F].substituteConstants();if(q[F]!==Y&&L===null){L=[];for(let J=0;J<F;J++)L[J]=q[J]}L!==null&&(L[F]=Y)}return L===null?q:L}class K{static create(L,F,z){return K.d(L,F,z)}constructor(L,F){this.expr=L,this.c=F,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const Y=s(this.expr[F],L.expr[F]);if(Y!==0)return Y}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(L.expr[F]))return!1;return!0}return!1}substituteConstants(){const L=V(this.expr);return L===this.expr?this:K.create(L,this.c,!1)}evaluate(L){for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].evaluate(L))return!1;return!0}static d(L,F,z){const Y=[];let J=!1;for(const ee of L)if(ee){if(ee.type===1){J=!0;continue}if(ee.type===0)return t.INSTANCE;if(ee.type===6){Y.push(...ee.expr);continue}Y.push(ee)}if(Y.length===0&&J)return r.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(s);for(let ee=1;ee<Y.length;ee++)Y[ee-1].equals(Y[ee])&&(Y.splice(ee,1),ee--);if(Y.length===1)return Y[0];for(;Y.length>1;){const ee=Y[Y.length-1];if(ee.type!==9)break;Y.pop();const x=Y.pop(),Q=Y.length===0,ne=W.create(ee.expr.map(re=>K.create([re,x],null,z)),null,Q);ne&&(Y.push(ne),Y.sort(s))}if(Y.length===1)return Y[0];if(z){for(let ee=0;ee<Y.length;ee++)for(let x=ee+1;x<Y.length;x++)if(Y[ee].negate().equals(Y[x]))return t.INSTANCE;if(Y.length===1)return Y[0]}return new K(Y,F)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const F of this.expr)L.push(...F.keys());return L}map(L){return new K(this.expr.map(F=>F.map(L)),null)}negate(){if(!this.c){const L=[];for(const F of this.expr)L.push(F.negate());this.c=W.create(L,this,!0)}return this.c}}e.$xj=K;class W{static create(L,F,z){return W.d(L,F,z)}constructor(L,F){this.expr=L,this.c=F,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const Y=s(this.expr[F],L.expr[F]);if(Y!==0)return Y}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(L.expr[F]))return!1;return!0}return!1}substituteConstants(){const L=V(this.expr);return L===this.expr?this:W.create(L,this.c,!1)}evaluate(L){for(let F=0,z=this.expr.length;F<z;F++)if(this.expr[F].evaluate(L))return!0;return!1}static d(L,F,z){let Y=[],J=!1;if(L){for(let ee=0,x=L.length;ee<x;ee++){const Q=L[ee];if(Q){if(Q.type===0){J=!0;continue}if(Q.type===1)return r.INSTANCE;if(Q.type===9){Y=Y.concat(Q.expr);continue}Y.push(Q)}}if(Y.length===0&&J)return t.INSTANCE;Y.sort(s)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let ee=1;ee<Y.length;ee++)Y[ee-1].equals(Y[ee])&&(Y.splice(ee,1),ee--);if(Y.length===1)return Y[0];if(z){for(let ee=0;ee<Y.length;ee++)for(let x=ee+1;x<Y.length;x++)if(Y[ee].negate().equals(Y[x]))return r.INSTANCE;if(Y.length===1)return Y[0]}return new W(Y,F)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const F of this.expr)L.push(...F.keys());return L}map(L){return new W(this.expr.map(F=>F.map(L)),null)}negate(){if(!this.c){const L=[];for(const F of this.expr)L.push(F.negate());for(;L.length>1;){const F=L.shift(),z=L.shift(),Y=[];for(const J of H(F))for(const ee of H(z))Y.push(K.create([J,ee],null,!1));L.unshift(W.create(Y,null,!1))}this.c=W.create(L,this,!0)}return this.c}}e.$yj=W;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(L,F,z){super(L,null),this.f=F,typeof z=="object"?B.d.push({...z,key:L}):z!==!0&&B.d.push({key:L,description:z,type:F!=null?typeof F:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return y.create(this.key,L)}notEqualsTo(L){return S.create(this.key,L)}}e.$zj=B,e.$Aj=(0,j.$ii)("contextKeyService");function ie(q,L){return q<L?-1:q>L?1:0}function ae(q,L,F,z){return q<F?-1:q>F?1:L<z?-1:L>z?1:0}function te(q,L){if(q.type===0||L.type===1)return!0;if(q.type===9)return L.type===9?ce(q.expr,L.expr):!1;if(L.type===9){for(const F of L.expr)if(te(q,F))return!0;return!1}if(q.type===6){if(L.type===6)return ce(L.expr,q.expr);for(const F of q.expr)if(te(F,L))return!0;return!1}return q.equals(L)}function ce(q,L){let F=0,z=0;for(;F<q.length&&z<L.length;){const Y=q[F].cmp(L[z]);if(Y<0)return!1;Y===0&&F++,z++}return F===q.length}function H(q){return q.type===9?q.expr:[q]}}),define(le[94],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$2m=e.ID=void 0,e.$3m=N,e.ID="diagnosticsService",e.$2m=(0,R.$ii)(e.ID);function N(j){return!!j.hostName&&!!j.errorMessage}class A{async getPerformanceInfo(D,I){return{}}async getSystemInfo(D,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,I){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$4m=A}),define(le[95],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,e.$wo=(0,R.$ii)("downloadService")}),define(le[16],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,R.$ii)("environmentService"),e.$qi=(0,R.$ji)(e.$pi)}),define(le[29],he([0,1,157,4]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=A,e.$Mo=j,e.$No=D,e.$Oo=I,e.$Po=P,e.$Qo=d,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function A(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function j(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function D(l,c){switch(l){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function I(l,c){return c==="web"&&!l.includes("web")}function P(l,c,$){return I(c,$)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===$}function d(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var C;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var v;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$Ro=(0,N.$ii)("extensionGalleryService");var h;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(h||(e.ExtensionManagementErrorCode=h={}));var b;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class p extends Error{constructor(c,$){super(c),this.code=$,this.name=$}}e.$So=p;var u;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class g extends Error{constructor(c,$){super(c),this.code=$,this.name=$}}e.$To=g,e.$Uo=(0,N.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,N.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,N.$ii)("IExtensionTipsService"),e.$Zo=(0,R.localize2)(0,"Extensions"),e.$1o=(0,R.localize2)(1,"Preferences")}),define(le[194],he([0,1,3,2,30,8,91,29]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=e.$1p=void 0;function P(p,u){return p?j.URI.revive(u?u.transformIncoming(p):p):void 0}function d(p,u){return u?u.transformOutgoingURI(p):p}function C(p,u){u=u||D.$ln;const g=p.manifest;return{...(0,D.$on)({...p,manifest:void 0},u),manifest:g}}function v(p,u){return p?.profileLocation?(0,D.$on)(p,u??D.$ln):p}function m(p,u){return u?(0,A.$Qn)(p,g=>g instanceof j.URI?u.transformOutgoingURI(g):void 0):p}class f{constructor(u,g){this.a=u,this.b=g,this.onInstallExtension=R.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,g){const l=this.b(u);switch(g){case"onInstallExtension":return R.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?d(c.profileLocation,l):c.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,c=>c.map($=>({...$,local:$.local?m($.local,l):$.local,profileLocation:$.profileLocation?d($.profileLocation,l):$.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?d(c.profileLocation,l):c.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?d(c.profileLocation,l):c.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,c=>m(c,l))}throw new Error("Invalid listen")}async call(u,g,l){const c=this.b(u);switch(g){case"zip":{const $=C(l[0],c),i=await this.a.zip($);return d(i,c)}case"unzip":return this.a.unzip(P(l[0],c));case"install":return this.a.install(P(l[0],c),v(l[1],c));case"installFromLocation":return this.a.installFromLocation(P(l[0],c),P(l[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(l[0],P(l[1],c),P(l[2],c));case"getManifest":return this.a.getManifest(P(l[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],v(l[1],c));case"installGalleryExtensions":{const $=l[0];return this.a.installGalleryExtensions($.map(({extension:i,options:o})=>({extension:i,options:v(o,c)??{}})))}case"uninstall":return this.a.uninstall(C(l[0],c),v(l[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(l[0],c));case"getInstalled":return(await this.a.getInstalled(l[0],P(l[1],c),l[2])).map(i=>m(i,c));case"toggleAppliationScope":{const $=await this.a.toggleAppliationScope(C(l[0],c),P(l[1],c));return m($,c)}case"copyExtensions":return this.a.copyExtensions(P(l[0],c),P(l[1],c));case"updateMetadata":{const $=await this.a.updateMetadata(C(l[0],c),l[1],P(l[2],c));return m($,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1],l[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$1p=f;class h extends N.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.m=u,this.c=this.B(new R.$7d),this.f=this.B(new R.$7d),this.g=this.B(new R.$7d),this.h=this.B(new R.$7d),this.j=this.B(new R.$7d),this.B(this.m.listen("onInstallExtension")(g=>this.n(this.c,{...g,source:this.r(g.source)?j.URI.revive(g.source):g.source,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(g=>this.n(this.f,g.map(l=>({...l,local:l.local?C(l.local,null):l.local,source:this.r(l.source)?j.URI.revive(l.source):l.source,profileLocation:j.URI.revive(l.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(g=>this.n(this.g,{...g,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(g=>this.n(this.h,{...g,profileLocation:j.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(C(g,null))))}n(u,g){u.fire(g)}r(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(u){const g=await this.getTargetPlatform();return u.allTargetPlatforms.some(l=>(0,I.$Po)(l,u.allTargetPlatforms,g))}zip(u){return Promise.resolve(this.m.call("zip",[u]).then(g=>j.URI.revive(g)))}unzip(u){return Promise.resolve(this.m.call("unzip",[u]))}install(u,g){return Promise.resolve(this.m.call("install",[u,g])).then(l=>C(l,null))}installFromLocation(u,g){return Promise.resolve(this.m.call("installFromLocation",[u,g])).then(l=>C(l,null))}async installExtensionsFromProfile(u,g,l){return(await this.m.call("installExtensionsFromProfile",[u,g,l])).map($=>C($,null))}getManifest(u){return Promise.resolve(this.m.call("getManifest",[u]))}installFromGallery(u,g){return Promise.resolve(this.m.call("installFromGallery",[u,g])).then(l=>C(l,null))}async installGalleryExtensions(u){return(await this.m.call("installGalleryExtensions",[u])).map(l=>({...l,local:l.local?C(l.local,null):l.local,source:this.r(l.source)?j.URI.revive(l.source):l.source,profileLocation:j.URI.revive(l.profileLocation)}))}uninstall(u,g){if(u.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[u,g]))}reinstallFromGallery(u){return Promise.resolve(this.m.call("reinstallFromGallery",[u])).then(g=>C(g,null))}getInstalled(u=null,g,l){return Promise.resolve(this.m.call("getInstalled",[u,g,l])).then(c=>c.map($=>C($,null)))}updateMetadata(u,g,l){return Promise.resolve(this.m.call("updateMetadata",[u,g,l])).then(c=>C(c,null))}toggleAppliationScope(u,g){return this.m.call("toggleAppliationScope",[u,g]).then(l=>C(l,null))}copyExtensions(u,g){return this.m.call("copyExtensions",[u,g])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(u,g,l){const c=await this.m.call("download",[u,g,l]);return j.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$2p=h;class b{constructor(u){this.a=u}listen(u,g){throw new Error("Invalid listen")}call(u,g,l){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$3p=b}),define(le[96],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$12b=A;var N;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function A(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var j;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$22b=(0,R.$ii)("IExtensionRecommendationNotificationService")}),define(le[12],he([0,1,51,14,27,13,8,164,4,5,23,53]),function(se,e,R,N,A,j,D,I,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=m,e.$Qk=b,e.$Rk=u,e.$Sk=g,e.$Tk=l,e.$Uk=c,e.$Vk=$,e.$Wk=i,e.$Xk=o,e.$Yk=n,e.$Zk=s,e.$2k=a,e.$3k=y,e.$4k=E,e.$5k=k,e.$6k=S,e.$9k=U,e.$il=W,e.$jl=B,e.$ll=ae,e.$Ok=(0,P.$ii)("fileService");function m(te){return te.create===!0}var f;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var h;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(h||(e.FilePermission=h={}));function b(te){const ce=te;return!!ce&&typeof ce.onDidChange=="function"}var p;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function u(te){return!!(te.capabilities&2)}function g(te){return!!(te.capabilities&8)}function l(te){return!!(te.capabilities&131072)}function c(te){return!!(te.capabilities&4)}function $(te){return!!(te.capabilities&16)}function i(te){return u(te)?!!(te.capabilities&16384):!1}function o(te){return u(te)?!!(te.capabilities&32768):!1}function n(te){return!!(te.capabilities&65536)}function s(te){return!!(te.capabilities&2048)}var t;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ce,H){const q=new r(ce.toString(),H);return E(q,H),q}constructor(ce,H){super(ce),this.code=H}}e.$1k=r;function a(te,ce){return r.create(te,ce)}function y(te){return te||a((0,I.localize)(0,null),t.Unknown)}function E(te,ce){return te.name=ce?`${ce} (FileSystemError)`:"FileSystemError",te}function k(te){if(!te)return t.Unknown;if(te instanceof r)return te.code;const ce=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!ce)return t.Unknown;switch(ce[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}function S(te){if(te instanceof _)return te.fileOperationResult;switch(k(te)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}var w;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(w||(e.FileOperation=w={}));class O{constructor(ce,H,q){this.resource=ce,this.operation=H,this.target=q}isOperation(ce){return this.operation===ce}}e.$7k=O;var M;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class T{static{this.a=null}constructor(ce,H){this.c=H,this.b=void 0,this.d=new v.$V(()=>{const q=R.$oi.forUris(()=>this.c);return q.fill(this.rawAdded.map(L=>[L,!0])),q}),this.f=new v.$V(()=>{const q=R.$oi.forUris(()=>this.c);return q.fill(this.rawUpdated.map(L=>[L,!0])),q}),this.g=new v.$V(()=>{const q=R.$oi.forUris(()=>this.c);return q.fill(this.rawDeleted.map(L=>[L,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of ce){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==T.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains(ce,...H){return this.h(ce,{includeChildren:!1},...H)}affects(ce,...H){return this.h(ce,{includeChildren:!0},...H)}h(ce,H,...q){if(!ce)return!1;const L=q.length>0;return!!((!L||q.includes(1))&&(this.d.value.get(ce)||H.includeChildren&&this.d.value.findSuperstr(ce))||(!L||q.includes(0))&&(this.f.value.get(ce)||H.includeChildren&&this.f.value.findSuperstr(ce))||(!L||q.includes(2))&&(this.g.value.findSubstr(ce)||H.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$8k=T;function U(te,ce,H){return!te||!ce||te===ce||ce.length>te.length?!1:(ce.charAt(ce.length-1)!==N.sep&&(ce+=N.sep),H?(0,A.$mf)(te,ce):te.indexOf(ce)===0)}class _ extends Error{constructor(ce,H,q){super(ce),this.fileOperationResult=H,this.options=q}}e.$0k=_;class G extends _{constructor(ce,H,q,L){super(ce,H,L),this.fileOperationResult=H,this.size=q}}e.$$k=G;class Z extends _{constructor(ce,H,q){super(ce,2,q),this.stat=H}}e.$_k=Z;var V;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var K;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$hl="";function W(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function B(te,ce){if(!ce.hasProvider(D.URI.from({scheme:te.scheme})))return new Promise(H=>{const q=ce.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===te.scheme&&L.added&&(q.dispose(),H())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ce){return(0,j.$Zf)(ce)||(ce=0),ce<ie.KB?(0,I.localize)(1,null,ce.toFixed(0)):ce<ie.MB?(0,I.localize)(2,null,(ce/ie.KB).toFixed(2)):ce<ie.GB?(0,I.localize)(3,null,(ce/ie.MB).toFixed(2)):ce<ie.TB?(0,I.localize)(4,null,(ce/ie.GB).toFixed(2)):(0,I.localize)(5,null,(ce/ie.TB).toFixed(2))}}e.$kl=ie;function ae(te){const ce=typeof te=="string"||te?.scheme===C.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===C.Schemas.file?1024*ie.MB:ce?10*ie.MB:d.$o?50*ie.MB:1024*ie.MB}});var X=this&&this.__param||function(se,e){return function(R,N){e(R,N,se)}};define(le[195],he([0,1,73,50,12]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;let j=class{constructor(I){this.a=I}async checksum(I){const P=(await this.a.readFileStream(I)).value;return new Promise((d,C)=>{const v=(0,R.createHash)("sha256");(0,N.$me)(P,{onData:m=>v.update(m.buffer),onError:m=>C(m),onEnd:()=>d(v.digest("base64").replace(/=+$/,""))})})}};e.$Dcc=j,e.$Dcc=j=ve([X(0,A.$Ok)],j)}),define(le[97],he([0,1,15,7,165,12]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=D;async function D(C,v,m,f,h,b){let p;try{await I(C,v,m,f,h,b)}catch(u){p=u}finally{p&&h.errorTransformer&&(p=h.errorTransformer(p)),typeof p<"u"&&m.error(p),m.end()}}async function I(C,v,m,f,h,b){P(b);const p=await C.open(v,{create:!1});try{P(b);let u=0,g=0,l=h&&typeof h.length=="number"?h.length:void 0,c=R.$ue.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),$=h&&typeof h.position=="number"?h.position:0,i=0;do g=await C.read(p,$,c.buffer,i,c.byteLength-i),$+=g,i+=g,u+=g,typeof l=="number"&&(l-=g),i===c.byteLength&&(await m.write(f(c)),c=R.$ue.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),i=0);while(g>0&&(typeof l!="number"||l>0)&&P(b)&&d(u,h));if(i>0){let o=i;typeof l=="number"&&(o=Math.min(i,l)),m.write(f(c.slice(0,o)))}}catch(u){throw(0,j.$3k)(u)}finally{await C.close(p)}}function P(C){if(C.isCancellationRequested)throw(0,N.$6)();return!0}function d(C,v){if(typeof v?.limits?.size=="number"&&C>v.limits.size)throw(0,j.$2k)((0,A.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[46],he([0,1,90,2,14,5,8,12]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=void 0,e.$vq=P,e.$wq=d,e.$Aq=f,e.$Bq=h,e.$Cq=b,e.$Dq=p;function P(g){return typeof g.correlationId=="number"}function d(g){return g.recursive===!0}class C extends N.$Uc{static{this.a=5}constructor(l,c,$,i){super(),this.h=l,this.j=c,this.m=$,this.n=i,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const l=new N.$Tc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(c=>this.h(c))),l.add(this.b.onDidLogMessage(c=>this.j(c))),l.add(this.b.onDidError(c=>this.t(c)))}t(l){this.n.restartOnError?this.g<C.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$xq=C;class v extends C{constructor(l,c,$){super(l,c,$,{type:"node.js",restartOnError:!1})}}e.$yq=v;class m extends C{constructor(l,c,$){super(l,c,$,{type:"universal",restartOnError:!0})}}e.$zq=m;function f(g){return g.map(l=>({type:l.type,resource:D.URI.revive(l.resource),cId:l.cId}))}function h(g){const l=new u;for(const c of g)l.processEvent(c);return l.coalesce()}function b(g,l){return typeof l=="string"&&!l.startsWith(R.$$j)&&!(0,A.$jc)(l)?{base:g,pattern:l}:l}function p(g,l){const c=[];for(const $ of l)c.push((0,R.$ck)(b(g,$)));return c}class u{constructor(){this.a=new Set,this.b=new Map}c(l){return j.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const c=this.b.get(this.c(l));let $=!1;if(c){const i=c.type,o=l.type;c.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?$=!0:i===1&&o===2?(this.b.delete(this.c(l)),this.a.delete(c)):i===2&&o===1?c.type=0:i===1&&o===0||(c.type=o)}else $=!0;$&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],c=[];return Array.from(this.a).filter($=>$.type!==2?(l.push($),!1):!0).sort(($,i)=>$.resource.fsPath.length-i.resource.fsPath.length).filter($=>c.some(i=>(0,I.$9k)($.resource.fsPath,i,!j.$k))?!1:(c.push($.resource.fsPath),!0)).concat(l)}}}),define(le[196],he([0,1,15,38,7,3,2,50,32,12,46]),function(se,e,R,N,A,j,D,I,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=e.$RP=void 0,e.$RP="localFilesystem";class v extends D.$Uc{constructor(f,h){super(),this.a=f,this.b=h,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$7d),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$7d),this.onDidWatchError=this.g.event,this.h=(0,P.$Eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,h){const{buffer:b}=await this.a.call("readFile",[f,h]);return b}readFileStream(f,h,b){const p=(0,I.$ie)(g=>R.$ue.concat(g.map(l=>R.$ue.wrap(l))).buffer),u=new D.$Tc;return u.add(this.a.listen("readFileStream",[f,h])(g=>{if(g instanceof R.$ue)p.write(g.buffer);else{if(g==="end")p.end();else{let l;if(g instanceof Error)l=g;else{const c=g;l=(0,d.$2k)(c.message??(0,N.$6i)(c),c.code??d.FileSystemProviderErrorCode.Unknown)}p.error(l),p.end()}u.dispose()}})),u.add(b.onCancellationRequested(()=>{p.error((0,A.$6)()),p.end(),u.dispose()})),p}writeFile(f,h,b){return this.a.call("writeFile",[f,R.$ue.wrap(h),b])}open(f,h){return this.a.call("open",[f,h])}close(f){return this.a.call("close",[f])}async read(f,h,b,p,u){const[g,l]=await this.a.call("read",[f,h,u]);return b.set(g.buffer.slice(0,l),p),l}write(f,h,b,p,u){return this.a.call("write",[f,h,R.$ue.wrap(b),p,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,h){return this.a.call("delete",[f,h])}rename(f,h,b){return this.a.call("rename",[f,h,b])}copy(f,h,b){return this.a.call("copy",[f,h,b])}cloneFile(f,h){return this.a.call("cloneFile",[f,h])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const h=f;this.f.fire((0,C.$Aq)(h))}else{const h=f;this.g.fire(h)}}))}watch(f,h){const b=(0,P.$Eg)();return this.a.call("watch",[this.h,b,f,h]),(0,D.$Sc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$SP=v}),define(le[197],he([0,1,40,2,46,3,8]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class I extends N.$Uc{constructor(){super(),this.a=this.B(new j.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new j.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=5007,this.B(this.f(d=>this.n(d)))}n(d){this.r(d)&&this.t(d)}r(d){return(0,A.$vq)(d)}async watch(d){this.h.clear(),this.g.clear();for(const C of d)this.r(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||this.j.deleteAndDispose(C);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))])}t(d){if(this.j.has(d.correlationId))return;const C=new N.$Tc;this.j.set(d.correlationId,C),this.w(d,C),this.s()}u(d){this.j.deleteAndDispose(d.correlationId),this.s()}w(d,C){const v=D.URI.file(d.path),m=this;let f=!1;const h=(b,p)=>{if(C.isDisposed)return;const u=this.y(b),g=this.y(p),l=f;if(f=u,!u&&(g||l)){this.F(`fs.watchFile() detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const c={resource:v,type:1,cId:d.correlationId};m.a.fire([c]),this.z(c,d),this.u(d)}};this.F(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,R.watchFile)(d.path,{persistent:!1,interval:this.m},h)}catch(b){this.G(`fs.watchFile() failed with error ${b} on path ${d.path} (correlationId: ${d.correlationId})`)}C.add((0,N.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,R.unwatchFile)(d.path,h)}catch(b){this.G(`fs.unwatchFile() failed with error ${b} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}y(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll()}z(d,C){const v=` >> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.F(typeof C.correlationId=="number"?`${v} (correlationId: ${C.correlationId})`:v)}C(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}}e.$Mq=I}),define(le[198],he([0,1,40,6,26,44,2,87,14,5,20,8,148,31,46]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,e.$Sq=p;class b extends D.$Uc{static{this.a=100}static{this.b=75}constructor(g,l,c,$,i){super(),this.m=g,this.n=l,this.r=c,this.s=$,this.t=i,this.c=this.B(new N.$xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.n(o))),this.f=this.B(new N.$wh(o=>this.D(o),b.b)),this.g=(0,h.$Dq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,h.$Dq)(this.m.path,this.m.includes):void 0,this.j=new A.$ee,this.ready=this.u()}async u(){try{const g=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const l=await f.Promises.stat(g);if(this.j.token.isCancellationRequested)return;this.B(await this.y(g,l.isDirectory()))}catch(g){g.code!=="ENOENT"?this.G(g):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${g})`),this.r?.()}}async w(g){let l=g.path;try{l=await f.Promises.realpath(g.path),g.path===l&&(l=await(0,m.$Oq)(g.path,this.j.token)??g.path),g.path!==l&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${l})`)}catch{}return l}async y(g,l){if(d.$j&&(0,j.$ig)(g,"/Volumes/",!0))return this.G(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Uc.None;const c=new A.$ee(this.j.token),$=new D.$Tc;try{const i=v.URI.file(this.m.path),o=(0,P.$oc)(g),n=(0,R.watch)(g);$.add((0,D.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.I(`Started watching: '${g}'`);const s=new Set;if(l)try{for(const r of await f.Promises.readdir(g))s.add(r)}catch(r){this.G(r)}const t=new Map;$.add((0,D.$Sc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.G(`Failed to watch ${g} for changes using fs.watch() (${r}, ${a})`),this.r?.()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.I(`[raw] ["${r}"] ${a}`);let y="";if(a&&(y=a.toString(),d.$j&&(y=(0,I.$Zl)(y))),!(!y||r!=="change"&&r!=="rename"))if(l)if(r==="rename"){t.get(y)?.dispose();const E=setTimeout(async()=>{if(t.delete(y),y===o&&!await f.Promises.exists(g)){this.z(i);return}const k=await this.F((0,P.$kc)(g,y));if(c.token.isCancellationRequested)return;let S;k?s.has(y)?S=0:(S=1,s.add(y)):(s.delete(y),S=2),this.C({resource:(0,C.$Vg)(i,y),type:S,cId:this.m.correlationId})},b.a);t.set(y,(0,D.$Sc)(()=>clearTimeout(E)))}else{let E;s.has(y)?E=0:(E=1,s.add(y)),this.C({resource:(0,C.$Vg)(i,y),type:E,cId:this.m.correlationId})}else if(r==="rename"||y!==o){const E=setTimeout(async()=>{const k=await f.Promises.exists(g);c.token.isCancellationRequested||(k?(this.C({resource:i,type:0,cId:this.m.correlationId},!0),$.add(await this.y(g,!1))):this.z(i))},b.a);$.clear(),$.add((0,D.$Sc)(()=>clearTimeout(E)))}else this.C({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){c.token.isCancellationRequested||this.G(`Failed to watch ${g} for changes using fs.watch() (${i.toString()})`),this.r?.()}return(0,D.$Sc)(()=>{c.dispose(!0),$.dispose()})}z(g){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:g,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(g,l=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!l&&this.g.some(c=>c(g.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${g.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(c=>c(g.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}D(g){const l=(0,h.$Bq)(g);if(l.length>0){if(this.t)for(const $ of l)this.I(` >> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(g){if(d.$k)return f.Promises.exists(g);try{const l=(0,P.$oc)(g);return(await f.Promises.readdir((0,P.$nc)(g))).some($=>$===l)}catch(l){return this.I(l),!1}}setVerboseLogging(g){this.t=g}G(g){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}H(g){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}I(g){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Rq=b;async function p(u,g,l,c,$=512){const i=await f.Promises.open(u,"r"),o=Buffer.allocUnsafe($),n=new A.$ee(c);let s,t=!1;const r={path:u,excludes:[],recursive:!1},a=new b(r,y=>{(async()=>{for(const{type:E}of y)if(E===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:k}=await f.Promises.read(i,o,0,$,null);if(!k||n.token.isCancellationRequested)break;g(o.slice(0,k))}}catch(k){s=new Error(k),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,l(),new Promise((y,E)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await f.Promises.close(i)}catch(k){s=new Error(k)}s?E(s):y()})})}}),define(le[199],he([0,1,3,90,197,5,198,44]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class P extends A.$Mq{constructor(){super(...arguments),this.onDidError=R.Event.None,this.H=new Set,this.I=!1}async D(C){C=this.O(C);const v=[],m=new Set(Array.from(this.H));for(const f of C){const h=this.L(f);h&&(0,N.$gk)(h.request.excludes,f.excludes)&&(0,N.$gk)(h.request.includes,f.includes)?m.delete(h):v.push(f)}v.length&&this.F(`Request to start watching: ${v.map(f=>this.C(f)).join(",")}`),m.size&&this.F(`Request to stop watching: ${Array.from(m).map(f=>this.C(f.request)).join(",")}`);for(const f of m)this.N(f);for(const f of v)this.M(f)}L(C){for(const v of this.H)if(typeof C.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===C.correlationId)return v}else if((0,I.$hg)(v.request.path,C.path,!j.$k))return v}M(C){const v=new D.$Rq(C,f=>this.a.fire(f),()=>this.c.fire(C),f=>this.b.fire(f),this.I),m={request:C,instance:v};this.H.add(m)}async stop(){await super.stop();for(const C of this.H)this.N(C)}N(C){this.F("stopping file watcher",C),this.H.delete(C),C.instance.dispose()}O(C){const v=new Map;for(const m of C){const f=j.$k?m.path:m.path.toLowerCase();let h=v.get(m.correlationId);h||(h=new Map,v.set(m.correlationId,h)),h.has(f)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(m)}`),h.set(f,m)}return Array.from(v.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(C){this.I=C;for(const v of this.H)v.instance.setVerboseLogging(C)}F(C,v){this.I&&this.b.fire({type:"trace",message:this.R(C,v)})}G(C){this.b.fire({type:"warn",message:this.R(C)})}R(C,v){return v?`[File Watcher (node.js)] ${C} (${this.C(v.request)})`:`[File Watcher (node.js)] ${C}`}}e.$Tq=P}),define(le[200],he([0,1,46,199]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class A extends R.$yq{constructor(D,I,P){super(D,I,P),this.s()}r(D){return D.add(new N.$Tq)}}e.$Uq=A}),define(le[201],he([0,1,23,41,92,46]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class D extends j.$zq{constructor(P,d,C){super(P,d,C),this.s()}r(P){const d=P.add(new A.$Kq(R.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(d.onDidProcessExit(({code:C,signal:v})=>this.t(`terminated by itself with code ${C}, signal: ${v}`))),N.ProxyChannel.toService((0,N.$2h)(d.getChannel("watcher")))}}e.$Lq=D}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class R{constructor(...A){this.a=new Map;for(const[j,D]of A)this.set(j,D)}set(A,j){const D=this.a.get(A);return this.a.set(A,j),D}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$gi=R}),define(le[202],he([0,1,6,7,2,72,192,4,74,86]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const C=!1;class v extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class m{constructor(p=new P.$gi,u=!1,g,l=C){this.f=p,this.g=u,this.h=g,this.i=l,this.o=new Set,this.f.set(I.$hi,this),this._globalGraph=l?g?._globalGraph??new D.$Xq(c=>c):void 0}createChild(p){return new m(p,this.g,this,this.i)}invokeFunction(p,...u){const g=h.traceInvocation(this.i,p);let l=!1;try{return p({get:$=>{if(l)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.m($,g);if(!i)throw new Error(`[invokeFunction] unknown service '${$}'`);return i}},...u)}finally{l=!0,g.stop()}}createInstance(p,...u){let g,l;return p instanceof j.$fi?(g=h.traceCreation(this.i,p.ctor),l=this.j(p.ctor,p.staticArguments.concat(u),g)):(g=h.traceCreation(this.i,p),l=this.j(p,u,g)),g.stop(),l}j(p,u=[],g){const l=I._util.getServiceDependencies(p).sort((i,o)=>i.index-o.index),c=[];for(const i of l){const o=this.m(i.id,g);o||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const $=l.length>0?l[0].index:u.length;if(u.length!==$){console.trace(`[createInstance] First service dependency of ${p.name} at position ${$+1} conflicts with ${u.length} static arguments`);const i=$-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,$)}return Reflect.construct(p,u.concat(c))}k(p,u){if(this.f.get(p)instanceof j.$fi)this.f.set(p,u);else if(this.h)this.h.k(p,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const u=this.f.get(p);return!u&&this.h?this.h.l(p):u}m(p,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const g=this.l(p);return g instanceof j.$fi?this.q(p,g,u.branch(p,!0)):(u.branch(p,!1),g)}q(p,u,g){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,u,g)}finally{this.o.delete(p)}}r(p,u,g){const l=new D.$Xq(i=>i.id.toString());let c=0;const $=[{id:p,desc:u,_trace:g}];for(;$.length;){const i=$.pop();if(l.lookupOrInsertNode(i),c++>1e3)throw new v(l);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof j.$fi){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};l.insertEdge(i,s),$.push(s)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new v(l);break}for(const{data:o}of i){if(this.l(o.id)instanceof j.$fi){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}l.removeNode(o)}}return this.l(p)}s(p,u,g=[],l,c){if(this.f.get(p)instanceof j.$fi)return this.t(p,u,g,l,c);if(this.h)return this.h.s(p,u,g,l,c);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(p,u,g=[],l,c){if(l){const $=new m(void 0,this.g,this,this.i);$.c=String(p);const i=new Map,o=new R.$Bh(()=>{const n=$.j(u,g,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new d.$5c,i.set(s,a)),(E,k,S)=>{if(o.isInitialized)return o.value[s](E,k,S);{const w={listener:[E,k,S],disposable:void 0},O=a.push(w);return(0,A.$Sc)(()=>{O(),w.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return u.prototype}})}else return this.j(u,g,c)}u(p,u){if(u&&console.warn(p),this.g)throw new Error(p)}}e.$Yq=m;var f;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(f||(f={}));class h{static{this.all=new Set}static{this.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,u){return p?new h(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(p,u){return p?new h(1,u.name):h.c}static{this.f=0}constructor(p,u){this.type=p,this.name=u,this.g=Date.now(),this.h=[]}branch(p,u){const g=new h(3,p.toString());return this.h.push([p,u,g]),g}stop(){const p=Date.now()-this.g;h.f+=p;let u=!1;function g(c,$){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of $.h)if(s&&t){u=!0,i.push(`${o}CREATES -> ${n}`);const r=g(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(p>2||u)&&h.all.add(l.join(`
`))}}e.$Zq=h}),define(le[56],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=void 0,e.$$bc=(0,R.$ii)("mainProcessService");class N{constructor(j,D){this.a=j,this.b=D}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,D){this.a.registerChannel(j,D)}}e.$_bc=N}),define(le[75],he([0,1,26,2,5,167,29,4]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0,e.$Ar=P;function P(C){return C.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Br=(0,I.$ii)("languagePackService");let d=class extends N.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new R.$ee;setTimeout(()=>v.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const h=m.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(p=>p.startsWith("lp-"))).map(b=>{const p=b.properties.localizedLanguages?.[0],u=P(b);return{...this.f(u,p,b),extensionId:b.identifier.id,galleryExtension:b}});return h.push(this.f("en","English")),h}f(v,m,f){const h=m??v;let b;if(h!==v&&(b=`(${v})`),v.toLowerCase()===A.$w.toLowerCase()&&(b??="",b+=(0,j.localize)(0,null)),f?.installCount){b??="";const p=f.installCount;let u;p>1e6?u=`${Math.floor(p/1e5)/10}M`:p>1e3?u=`${Math.floor(p/1e3)}K`:u=String(p),b+=` $(cloud-download) ${u}`}return{id:v,label:h,description:b}}};e.$Cr=d,e.$Cr=d=ve([X(0,D.$Ro)],d)}),define(le[203],he([0,1,2,75]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;let A=class extends R.$Uc{constructor(D){super(),this.a=D,this.b()}b(){this.a.update()}};e.$zcc=A,e.$zcc=A=ve([X(0,N.$Br)],A)}),define(le[9],he([0,1,168,38,3,54,2,35,5,20,13,8,93,4]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=b,e.log=u,e.$3j=a,e.$4j=y,e.$5j=E,e.$6j=k,e.$Oj=(0,f.$ii)("logService"),e.$Pj=(0,f.$ii)("loggerService");function h(){return new Date().toISOString()}function b(S){return(0,C.$Zf)(S)}var p;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$Rj=p.Info;function u(S,w,O){switch(w){case p.Trace:S.trace(O);break;case p.Debug:S.debug(O);break;case p.Info:S.info(O);break;case p.Warning:S.warn(O);break;case p.Error:S.error(O);break;case p.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function g(S,w=!1){let O="";for(let M=0;M<S.length;M++){let T=S[M];if(T instanceof Error&&(T=(0,N.$6i)(T,w)),typeof T=="object")try{T=JSON.stringify(T)}catch{}O+=(M>0?" ":"")+T}return O}class l extends D.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new A.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==p.Off&&this.b<=w}}e.$Tj=l;class c extends l{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...O){this.f(p.Trace)&&this.g(p.Trace,g([w,...O],!0))}debug(w,...O){this.f(p.Debug)&&this.g(p.Debug,g([w,...O]))}info(w,...O){this.f(p.Info)&&this.g(p.Info,g([w,...O]))}warn(w,...O){this.f(p.Warning)&&this.g(p.Warning,g([w,...O]))}error(w,...O){if(this.f(p.Error))if(w instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=w.stack,this.g(p.Error,g(M))}else this.g(p.Error,g([w,...O]))}flush(){}}e.$Uj=c;class $ extends l{constructor(w=e.$Rj){super(),this.setLevel(w),this.g=!P.$i}trace(w,...O){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,w,...O):console.log(`[main ${h()}]`,w,...O))}debug(w,...O){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,w,...O):console.log(`[main ${h()}]`,w,...O))}info(w,...O){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,w,...O):console.log(`[main ${h()}]`,w,...O))}warn(w,...O){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,w,...O):console.warn(`[main ${h()}]`,w,...O))}error(w,...O){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,w,...O):console.error(`[main ${h()}]`,w,...O))}flush(){}}e.$Vj=$;class i extends l{constructor(w=e.$Rj,O=!0){super(),this.g=O,this.setLevel(w)}trace(w,...O){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...O):console.log(w,...O))}debug(w,...O){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...O):console.log(w,...O))}info(w,...O){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...O):console.log(w,...O))}warn(w,...O){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...O):console.log(w,...O))}error(w,...O){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...O):console.error(w,...O))}flush(){}}e.$Wj=i;class o extends l{constructor(w,O=e.$Rj){super(),this.g=w,this.setLevel(O)}trace(w,...O){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(w),...O])}debug(w,...O){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(w),...O])}info(w,...O){this.f(p.Info)&&this.g.log(p.Info,[this.h(w),...O])}warn(w,...O){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(w),...O])}error(w,...O){this.f(p.Error)&&this.g.log(p.Error,[this.h(w),...O])}h(w){return typeof w=="string"?w:(0,N.$6i)(w,this.f(p.Trace))}flush(){}}e.$Xj=o;class n extends l{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const O of this.g)O.setLevel(w);super.setLevel(w)}trace(w,...O){for(const M of this.g)M.trace(w,...O)}debug(w,...O){for(const M of this.g)M.debug(w,...O)}info(w,...O){for(const M of this.g)M.info(w,...O)}warn(w,...O){for(const M of this.g)M.warn(w,...O)}error(w,...O){for(const M of this.g)M.error(w,...O)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$Yj=n;class s extends D.$Uc{constructor(w,O,M){if(super(),this.h=w,this.j=O,this.b=new I.$Bc,this.c=this.B(new A.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$7d),this.onDidChangeVisibility=this.g.event,M)for(const T of M)this.b.set(T.resource,{logger:void 0,info:T})}m(w){return(0,C.$Vf)(w)?[...this.b.values()].find(O=>O.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,O){const M=this.n(w),T=(0,C.$Vf)(w)?w:O?.id??(0,j.$9i)(M.toString()).toString(16);let U=this.b.get(M)?.logger;const _=O?.logLevel==="always"?p.Trace:O?.logLevel;U||(U=this.s(M,_??this.getLogLevel(M)??this.h,{...O,id:T}));const G={logger:U,info:{resource:M,id:T,logLevel:_,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(G.info),this.b.set(M,G),U}n(w){return(0,C.$Vf)(w)?(0,d.$Vg)(this.j,`${w}.log`):w}setLogLevel(w,O){if(v.URI.isUri(w)){const M=w,T=O,U=this.b.get(M);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([M,T]))}else{this.h=w;for(const[M,T]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,O){const M=this.m(w);M&&O!==!M.info.hidden&&(M.info.hidden=!O,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,O]))}getLogLevel(w){let O;return w&&(O=this.b.get(w)?.info.logLevel),O??this.h}registerLogger(w){const O=this.b.get(w.resource);O?O.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const O=this.b.get(w);O&&(O.logger&&O.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=s;class t{constructor(){this.onDidChangeLogLevel=new A.$7d().event}setLevel(w){}getLevel(){return p.Info}trace(w,...O){}debug(w,...O){}info(w,...O){}warn(w,...O){}error(w,...O){}critical(w,...O){}dispose(){}flush(){}}e.$1j=t;class r extends t{}e.$2j=r;function a(S){if(S.verbose)return p.Trace;if(typeof S.logLevel=="string"){const w=k(S.logLevel.toLowerCase());if(w!==void 0)return w}return e.$Rj}function y(S){switch(S){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function E(S){switch(S){case p.Trace:return{original:"Trace",value:R.localize(0,null)};case p.Debug:return{original:"Debug",value:R.localize(1,null)};case p.Info:return{original:"Info",value:R.localize(2,null)};case p.Warning:return{original:"Warning",value:R.localize(3,null)};case p.Error:return{original:"Error",value:R.localize(4,null)};case p.Off:return{original:"Off",value:R.localize(5,null)}}}function k(S){switch(S){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$7j=new m.$zj("logLevel",y(p.Info))}),define(le[204],he([0,1,6,7,2,23,14,20,31,16,9]),function(se,e,R,N,A,j,D,I,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;let v=class extends A.$Uc{constructor(f,h){super(),this.a=f,this.b=h,this.B(new R.$uh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const f=(0,I.$Sg)(this.a.logsHome),h=(0,I.$Ug)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,u=(await P.Promises.readdir(h)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==f),g=u.slice(0,Math.max(0,u.length-9));g.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(l=>P.Promises.rm((0,D.$kc)(h,l)))))}catch(f){(0,N.$1)(f)}}};e.$Acc=v,e.$Acc=v=ve([X(0,d.$pi),X(1,C.$Oj)],v)}),define(le[205],he([0,1,17,6,7,3,2,14,46,9]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class C extends D.$Uc{constructor(m,f){super(),this.a=m,this.b=f,this.c=this.B(new j.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$gh(0)),this.w=[],this.y=this.B(new N.$gh(0))}watch(m,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(m,f):this.z(m,f)}n(m,f){const h={path:this.H(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},b=(0,R.$Ub)(this.j,h);return this.r(),(0,D.$Sc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,A.$1)(m))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,P.$Aq)(f)),f=>this.G(f),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.j)(0,P.$wq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.j)(0,P.$wq)(f)&&m.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,f){const h={path:this.H(m),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},b=(0,R.$Ub)(this.w,h);return this.C(),(0,D.$Sc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,A.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,P.$Aq)(m)),m=>this.G(m),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,I.$ic)(m.fsPath)}}e.$Eq=C}),define(le[206],he([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;let $=class extends d.$Uc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$7d),this.Y=this.B(new D.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$rh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const s=new d.$Tc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new p.$8k(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,d.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,d.$Pc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await N.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,f.$Zg)(o))throw new p.$0k((0,b.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new l.$bb;throw s.message=(0,b.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,p.$Uk)(n)||(0,p.$Rk)(n)||(0,p.$Vk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,p.$Uk)(n)||(0,p.$Rk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,p.$5k)(s)===p.FileSystemProviderErrorCode.FileNotFound?new p.$0k((0,b.localize)(2,null,this.sb(o)),1):(0,p.$3k)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,y=n?.resolveMetadata,E=await s.stat(o);let k;return this.t(s,o,E,void 0,!!y,(S,w)=>(k||(k=C.$oi.forUris(()=>!t),k.set(o,!0),r&&k.fill(!0,r)),k.get(S.resource)||k.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?w===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:y}=this.R(o),E={resource:n,name:y.basename(n),isFile:(s.type&p.FileType.File)!==0,isDirectory:(s.type&p.FileType.Directory)!==0,isSymbolicLink:(s.type&p.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&p.FilePermission.Locked),etag:(0,p.$il)({mtime:s.mtime,size:s.size}),children:void 0};if(E.isDirectory&&a(E,t)){try{const k=await o.readdir(n),S=await N.Promises.settled(k.map(async([w,O])=>{try{const M=y.joinPath(n,w),T=r?await o.stat(M):{type:O};return await this.t(o,M,T,k.length,r,a)}catch(M){return this.b.trace(M),null}}));E.children=(0,R.$Hb)(S)}catch(k){this.b.trace(k),E.children=[]}return E}return E}async resolveAll(o){return N.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new p.$0k((0,b.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=A.$ue.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new p.$7k(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,p.$Xk)(t)&&!a?.atomic){const y=t.enforceAtomicWriteFile?.(o);y&&(a={...s,atomic:y})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let E;if((0,p.$Rk)(t)&&!(n instanceof A.$ue))if((0,h.$ge)(n)){const k=await(0,h.$ne)(n,3);k.ended?E=A.$ue.concat(k.buffer):E=k}else E=(0,h.$ke)(n,k=>A.$ue.concat(k),3);else E=n;!(0,p.$Uk)(t)||(0,p.$Rk)(t)&&E instanceof A.$ue||(0,p.$Rk)(t)&&(0,p.$Xk)(t)&&a?.atomic?await this.hb(t,o,a,E):await this.db(t,o,a,E instanceof A.$ue?(0,A.$Fe)(E):E),this.r.fire(new p.$7k(o,4))}catch(y){throw new p.$0k((0,b.localize)(4,null,this.sb(o),(0,p.$3k)(y).toString()),(0,p.$6k)(y),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(n)));if(t)throw new Error((0,b.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&p.FileType.Directory)throw new p.$0k((0,b.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==p.$hl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,p.$il)({mtime:s.mtime,size:a.size}))throw new p.$0k((0,b.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const y=await this.C(o,n,s,t);r(y)}catch(y){a(y)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,A.$Ge)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new j.$ee(t);let a=s;(0,p.$Wk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const y=this.J(n,a).then(k=>k,k=>{throw r.dispose(!0),k});let E;try{return typeof a?.etag=="string"&&a.etag!==p.$hl&&await y,a?.atomic&&(0,p.$Wk)(o)||!((0,p.$Uk)(o)||(0,p.$Vk)(o))||(0,p.$Rk)(o)&&a?.preferUnbuffered?E=this.I(o,n,a):(0,p.$Vk)(o)?E=this.G(o,n,r.token,a):E=this.H(o,n,r.token,a),E.on("end",()=>r.dispose()),E.on("error",()=>r.dispose()),{...await y,value:E}}catch(k){throw E&&await(0,h.$le)(E),this.F(k,n,a)}}F(o,n,s){const t=(0,b.localize)(11,null,this.sb(n),(0,p.$3k)(o).toString());return o instanceof p.$_k?new p.$_k(t,o.stat,s):o instanceof p.$$k?new p.$$k(t,o.fileOperationResult,o.size,o.options):new p.$0k(t,(0,p.$6k)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,h.$re)(r,{data:a=>a instanceof A.$ue?a:A.$ue.wrap(a),error:a=>this.F(a,n,t)},a=>A.$ue.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,A.$Ke)();return(0,u.$tq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,h.$ie)(r=>A.$ue.concat(r));return(async()=>{try{let r;s?.atomic&&(0,p.$Wk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(A.$ue.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new p.$0k((0,b.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==p.$hl&&n.etag===s.etag)throw new p.$_k((0,b.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new p.$$k((0,b.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$7k(o,a==="move"?2:3,y)),y}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$7k(o,a==="copy"?3:2,y)),y}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:y,isSameResourceWithDifferentPathCase:E}=await this.Q(o,n,s,t,r,a);if(y&&!E&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,p.$Sk)(o))await o.copy(n,t,{overwrite:a});else{const k=await this.resolve(n);k.isDirectory?await this.P(o,k,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,p.$Uk)(o)&&(0,p.$Uk)(s))return this.jb(o,n,s,t);if((0,p.$Uk)(o)&&(0,p.$Rk)(s))return this.pb(o,n,s,t);if((0,p.$Rk)(o)&&(0,p.$Uk)(s))return this.nb(o,n,s,t);if((0,p.$Rk)(o)&&(0,p.$Rk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let y=!1;if(o===s){const{providerExtUri:k,isPathCaseSensitive:S}=this.R(o);if(S||(y=k.isEqual(n,t)),y&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(n),this.sb(t)));if(!y&&k.isEqualOrParent(t,n))throw new Error((0,b.localize)(16,null,this.sb(n),this.sb(t)))}const E=await this.exists(t);if(E&&!y){if(!a)throw new p.$0k((0,b.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:k}=this.R(o);if(k.isEqualOrParent(n,t))throw new Error((0,b.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:E,isSameResourceWithDifferentPathCase:y}}R(o){const n=this.S(o);return{providerExtUri:n?f.$Lg:f.$Ng,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$7k(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&p.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(n)));break}catch(r){if((0,p.$5k)(r)!==p.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,p.$5k)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,b.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new p.$0k((0,b.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const E=await this.resolve(o);if(E.isDirectory&&Array.isArray(E.children)&&E.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,p.$Yk)(s)&&!t?.atomic){const E=s.enforceAtomicDelete?.(o);E&&(t={...n,atomic:E})}const r=!!t?.useTrash,a=!!t?.recursive,y=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:y}),this.r.fire(new p.$7k(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,p.$Tk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,p.$Sk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new d.$Tc;let t=!1,r=()=>{t=!0};s.add((0,d.$Sc)(()=>r())),(async()=>{try{const y=await this.bb(o,n);t?(0,d.$Pc)(y):r=()=>(0,d.$Pc)(y)}catch(y){this.b.error(y)}})();const a=n.correlationId;if(typeof a=="number"){const y=s.add(new D.$7d);return s.add(this.X.event(k=>{k.correlates(a)&&y.fire(k)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,I.$9i)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,d.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,d.$Pc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,d.$Pc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,h.$ge)(t)||(0,h.$he)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,p.$3k)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,h.$he)(s)){if(s.buffer.length>0){const a=A.$ue.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,y)=>{(0,h.$me)(r,{onData:async E=>{r.pause();try{await this.gb(o,n,E,E.byteLength,t,0)}catch(k){return y(k)}t+=E.byteLength,setTimeout(()=>r.resume())},onError:E=>y(E),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let y=0;for(;y<t;){const E=await o.write(n,r+y,s.buffer,a+y,t-y);y+=E}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof A.$ue?r=t:(0,h.$ge)(t)?r=await(0,A.$Ge)(t):(0,h.$he)(t)?r=await(0,A.$He)(t):r=(0,A.$Ee)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const y=A.$ue.alloc(this.a);let E=0,k=0,S=0;do S=await o.read(r,E,y.buffer,k,y.byteLength-k),await this.gb(s,a,y,S,E,k),E+=S,k+=S,k===y.byteLength&&(k=0);while(S>0)}catch(y){throw(0,p.$3k)(y)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,A.$ue.wrap(a),a.byteLength,0,0)}catch(a){throw(0,p.$3k)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,A.$Ge)(this.H(o,n,j.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new p.$0k((0,b.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&p.FilePermission.Readonly)throw new p.$0k((0,b.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$uq=$,e.$uq=$=c=ve([X(0,g.$Oj)],$)}),define(le[207],he([0,1,40,277,6,35,15,3,44,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0,(()=>{try{(0,N.gracefulify)(R)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$6i)(o)}`)}})();class i extends g.$Eq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.N=new j.$Bc(t=>m.$Mg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await h.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:p.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await h.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$Vg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=p.FileType.Unknown:n.isFile()?t=p.FileType.File:n.isDirectory()?t=p.FileType.Directory:t=p.FileType.Unknown,s&&(t|=p.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new A.$hh;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,d.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await h.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,f.$ie)(a=>D.$ue.concat(a.map(y=>D.$ue.wrap(y))).buffer);return(0,u.$tq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,m.$Vg)((0,m.$Ug)(n),`${(0,m.$Sg)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await h.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new d.$Tc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(y){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const y=this.H(n);if(!t.create||!t.overwrite){if(await h.Promises.exists(y)){if(!t.overwrite)throw(0,p.$2k)((0,b.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,p.$2k)((0,b.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(y){throw await this.gb(n,y)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,p.$Pk)(s)&&!t&&(a=await this.O(n));let y;try{if((0,p.$Pk)(s)&&s.unlock)try{const{stat:k}=await h.SymlinkSupport.stat(r);k.mode&128||await h.Promises.chmod(r,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let E;if((0,p.$Pk)(s)){if(v.$i)try{await h.Promises.truncate(r,0),E="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}E||(E="w")}else E="r";y=await h.Promises.open(r,E)}catch(E){throw a?.dispose(),(0,p.$Pk)(s)?await this.gb(n,E):this.fb(E)}if(this.U.set(y,0),(0,p.$Pk)(s)&&this.X.set(y,n),a){const E=this.W.get(y);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${r})`),this.W.set(y,a),E&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${r})`),E.dispose())}return y}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await h.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await h.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const y=this.Z(n,s);let E=null;try{E=(await h.Promises.read(n,t,r,a,y)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(n,y,E)}return E}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,A.$Ch)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const y=this.Z(n,s);let E=null;try{E=(await h.Promises.write(n,t,r,a,y)).bytesWritten}catch(k){throw await this.gb(this.X.get(n),k)}finally{this.$(n,y,E)}return E}async mkdir(n){try{await h.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$kc)((0,C.$nc)(t),`${(0,C.$oc)(t)}${s.atomic.postfix}`)),await h.Promises.rm(t,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:y,symbolicLink:E}=await h.SymlinkSupport.stat(t);a=y.isDirectory()&&!E}catch{}if(a)await h.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await h.Promises.rename(r,a)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,b.localize)(2,null,(0,C.$oc)(r),(0,C.$oc)((0,C.$nc)(a)),y.toString()))),this.fb(y)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await h.Promises.copy(r,a,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,b.localize)(3,null,(0,C.$oc)(r),(0,C.$oc)((0,C.$nc)(a)),y.toString()))),this.fb(y)}}async bb(n,s,t,r){const a=this.H(n),y=this.H(s);let E=!1;if(!!(this.capabilities&1024)||(E=(0,P.$hg)(a,y,!0)),E){if(t==="copy")throw(0,p.$2k)((0,b.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const S=await this.L(n);if(!S)throw(0,p.$2k)((0,b.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const w=await this.L(s);if(w){if(!r)throw(0,p.$2k)((0,b.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);S.type&p.FileType.File&&w.type&p.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),y=!!(this.capabilities&1024);if((0,P.$hg)(r,a,!y))return;const E=new d.$Tc;try{E.add(await this.O(n)),E.add(await this.O(s)),t&&await h.Promises.mkdir((0,C.$nc)(a),{recursive:!0}),await h.Promises.copyFile(r,a)}catch(k){if(k.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(k)}finally{E.dispose()}}t(n,s,t){return new c.$Lq(r=>n(r),r=>s(r),t)}F(n,s,t){return new $.$Uq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof p.$1k)return n;let s=n,t;switch(n.code){case"ENOENT":t=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=p.FileSystemProviderErrorCode.Unknown;break;default:t=p.FileSystemProviderErrorCode.Unknown}return(0,p.$2k)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,p.$2k)(s,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Vq=i}),define(le[99],he([0,1,3,2,4,9]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=void 0,e.$Zcc=(0,A.$ii)("sharedProcessLifecycleService");let D=class extends N.$Uc{constructor(P){super(),this.b=P,this.a=this.B(new R.$7d),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$1cc=D,e.$1cc=D=ve([X(0,j.$Oj)],D)}),define(le[208],he([0,1,8,3,9,2]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=void 0;class D extends A.$Zj{constructor(v,m,f,h,b){super(m,f,h),this.r=v,this.t=b,this.B(b.listen("onDidChangeLogLevel",v)(p=>{(0,A.$Qj)(p)?super.setLogLevel(p):super.setLogLevel(R.URI.revive(p[0]),p[1])})),this.B(b.listen("onDidChangeVisibility",v)(([p,u])=>super.setVisibility(R.URI.revive(p),u))),this.B(b.listen("onDidChangeLoggers",v)(({added:p,removed:u})=>{for(const g of p)super.registerLogger({...g,resource:R.URI.revive(g.resource)});for(const g of u)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new A.$Xj({log:(v,m)=>{this.t.call("consoleLog",[v,m])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,m){super.setLogLevel(v,m),this.t.call("setLogLevel",[v,m])}setVisibility(v,m){super.setVisibility(v,m),this.t.call("setVisibility",[this.n(v),m])}s(v,m,f){return new I(this.t,v,m,f,this.r)}static setLogLevel(v,m,f){return v.call("setLogLevel",[m,f])}}e.$Ur=D;class I extends A.$Uj{constructor(v,m,f,h,b){super(h?.logLevel==="always"),this.r=v,this.s=m,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[m,h,b]).then(()=>{this.u(this.n),this.m=!0})}g(v,m){const f=[[v,m]];this.m?this.u(f):this.n.push(...f)}u(v){this.r.call("log",[this.s,v])}}class P{constructor(v,m){this.a=v,this.b=m}listen(v,m){const f=this.b(v);switch(m){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,h=>({added:[...h.added].map(b=>this.c(b,f)),removed:[...h.removed].map(b=>this.c(b,f))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,h=>[f.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,h=>(0,A.$Qj)(h)?h:[f.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${m}`)}async call(v,m,f){const h=this.b(v);switch(m){case"setLogLevel":return(0,A.$Qj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(R.URI.revive(h.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,h)))}throw new Error(`Call not found: ${m}`)}c(v,m){return{...v,resource:m.transformOutgoingURI(v.resource)}}}e.$Vr=P;class d extends j.$Uc{constructor(v,m){super(),m.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(f=>m.call("setLogLevel",[f]))),m.call("getRegisteredLoggers").then(f=>{for(const h of f)v.registerLogger({...h,resource:R.URI.revive(h.resource)})}),this.B(m.listen("onDidChangeVisibility")(([f,h])=>v.setVisibility(R.URI.revive(f),h))),this.B(m.listen("onDidChangeLoggers")(({added:f,removed:h})=>{for(const b of f)v.registerLogger({...b,resource:R.URI.revive(b.resource)});for(const b of h)v.deregisterLogger(b.resource)}))}}e.$Wr=d}),define(le[209],he([0,1,2,9]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=void 0;class A extends R.$Uc{constructor(D,I=[]){super(),this.a=new N.$Yj([D,...I]),this.B(D.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...I){this.a.trace(D,...I)}debug(D,...I){this.a.debug(D,...I)}info(D,...I){this.a.info(D,...I)}warn(D,...I){this.a.warn(D,...I)}error(D,...I){this.a.error(D,...I)}flush(){this.a.flush()}}e.$0P=A}),define(le[57],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0,e.$Vac=(0,R.$ii)("nativeHostService")}),define(le[210],he([0,1,41,56]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;let A=class{constructor(D,I){return this.windowId=D,R.ProxyChannel.toService(I.getChannel("nativeHost"),{context:D,properties:(()=>{const P=new Map;return P.set("windowId",D),P})()})}};e.$ecc=A,e.$ecc=A=ve([X(1,N.$$bc)],A)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=void 0,e.$3n=(0,j.$ii)("policy");class D extends A.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const C=Object.keys(this.f).length;return this.f={...d,...this.f},C!==Object.keys(this.f).length&&await this.j(d),N.Iterable.reduce(this.g.entries(),(v,[m,f])=>({...v,[m]:f}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(d,[C,v])=>({...d,[C]:{definition:v,value:this.g.get(C)}}),{})}}e.$4n=D;class I{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$5n=I}),define(le[211],he([0,1,3,2,58]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=void 0;class j{constructor(P){this.b=P,this.a=new N.$Tc}listen(P,d){switch(d){case"onDidChange":return R.Event.map(this.b.onDidChange,C=>C.reduce((v,m)=>({...v,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(P,d,C){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$Gbc=j;class D extends A.$4n{constructor(P,d){super(),this.a=d;for(const C in P){const{definition:v,value:m}=P[C];this.f[C]=v,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const v in C){const m=C[v];m===null?this.g.delete(v):this.g.set(v,m)}this.h.fire(Object.keys(C))})}async j(P){const d=await this.a.call("updatePolicyDefinitions",P);for(const C in d)this.g.set(C,d[C])}}e.$Hbc=D}),define(le[100],he([0,1,36]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const j=A.context.configuration();if(j)N=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:j.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(le[24],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,R.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"}),define(le[212],he([0,1,6,7,2,14,31,9,24]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;let d=class extends A.$Uc{constructor(v,m,f){super(),this.b=m,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,v&&this.B(new R.$uh(()=>{this.f(v)},3e4)).schedule()}async f(v){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),f=(0,j.$nc)(v),h=(0,j.$oc)(v),b=await D.Promises.readdir(f);await Promise.all(b.map(async p=>{if(p===h)return;const u=(0,j.$kc)(f,p),g=await D.Promises.stat(u);if(g.isDirectory()&&m-g.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${p}.`),D.Promises.rm(u)}))}catch(m){(0,N.$1)(m)}}};e.$xcc=d,e.$xcc=d=ve([X(1,P.$8j),X(2,I.$Oj)],d)}),define(le[213],he([0,1,6,7,2,14,31,16,9,24]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;let C=class extends A.$Uc{constructor(m,f,h){super(),this.b=m,this.c=f,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new R.$uh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),f=JSON.parse(await D.Promises.readFile((0,j.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(f)){const l=f[g];m[`${l.hash}.${g}`]=!0}const h=(0,j.$kc)(this.b.userDataPath,"clp");if(!await D.Promises.exists(h))return;const p=await D.Promises.readdir(h);for(const g of p){if(m[g]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await D.Promises.rm((0,j.$kc)(h,g))}const u=Date.now();for(const g of Object.keys(m)){const l=(0,j.$kc)(h,g),c=await D.Promises.readdir(l);for(const $ of c){if($==="tcf.json")continue;const i=(0,j.$kc)(l,$),o=await D.Promises.stat(i);o.isDirectory()&&u-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$kc)(g,$)}`),await D.Promises.rm(i))}}}catch(m){(0,N.$1)(m)}}};e.$ycc=C,e.$ycc=C=ve([X(0,I.$qi),X(1,P.$Oj),X(2,d.$8j)],C)}),define(le[214],he([0,1,14,4]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$UF=void 0,e.$UF=(0,N.$ii)("IV8InspectProfilingService");var A;(function(j){function D(P){return!!(P.samples&&P.timeDeltas)}j.isValidProfile=D;function I(P,d="noAbsolutePaths"){for(const C of P.nodes)C.callFrame&&C.callFrame.url&&((0,R.$jc)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,R.$kc)(d,(0,R.$oc)(C.callFrame.url)));return P}j.rewriteAbsolutePaths=I})(A||(e.Utils=A={}))}),define(le[215],he([0,1,32]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;class N{constructor(){this.a=new Map}async startProfiling(j){const I=await(await new Promise((d,C)=>{se(["v8-inspect-profiler"],d,C)})).startProfiling({port:j.port,checkForPaused:!0}),P=(0,R.$Eg)();return this.a.set(P,I),P}async stopProfiling(j){const D=this.a.get(j);if(!D)throw new Error(`UNKNOWN session '${j}'`);const I=await D.stop();return this.a.delete(j),I.profile}}e.$Pcc=N}),define(le[42],he([0,1,127,13]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class A{constructor(){this.a=new Map}add(D,I){R.ok(N.$Vf(D)),R.ok(N.$Xf(I)),R.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,I)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$1n=new A}),define(le[101],he([0,1,3,42]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function A(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class j{constructor(){this.b=new R.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,d){this.a[A(P)]=d,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const D=new j;N.$1n.add(e.$2n.JSONContribution,D)}),define(le[47],he([0,1,17,3,13,153,21,101,42]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=b,e.$fo=p,e.$go=u,e.$ho=l,e.$io=c;var d;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$6n={Configuration:"base.contributions.configuration"};var C;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const v=P.$1n.as(I.$2n.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$7d,this.onDidSchemaChange=this.i.event,this.j=new N.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$do.test(r)){const a=this.a.get(r),y=a?.valuesSources??new Map;if(t)for(const w of Object.keys(s[r]))y.set(w,t);const E={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:E,valuesSources:y});const k=(0,D.$Yi)(r),S={type:"object",default:E,description:j.localize(1,null,k),$ref:e.$ao,defaultDefaultValue:E,source:A.$Vf(t)?void 0:t,defaultValueSource:t};n.push(...b(r)),this.d[r]=S,this.b.properties[r]=S}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=A.$Vf(s)?s:s?.id,y=A.$Vf(r?.source)?r?.source:r?.source?.id;if(a===y)if(o.add(t),this.a.delete(t),e.$do.test(t))delete this.d[t],delete this.b.properties[t];else{const E=this.d[t];E&&(this.w(t,E),this.r(t,E))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=A.$5f(i.scope)?t:i.scope;const a=i.properties;if(a)for(const E in a){const k=a[E];if(o&&l(E,k)){delete a[E];continue}if(k.source=n,k.defaultDefaultValue=a[E].default,this.w(E,k),e.$do.test(E)?k.scope=void 0:(k.scope=A.$5f(k.scope)?t:k.scope,k.restricted=A.$5f(k.restricted)?!!s?.includes(E):k.restricted),a[E].hasOwnProperty("included")&&!a[E].included){this.f[E]=a[E],delete a[E];continue}else this.d[E]=a[E],a[E].policy?.name&&this.e.set(a[E].policy.name,E);!a[E].deprecationMessage&&a[E].markdownDeprecationMessage&&(a[E].deprecationMessage=a[E].markdownDeprecationMessage),r.add(E)}const y=i.allOf;if(y)for(const E of y)this.p(E,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$7n.properties[i]=o,o.scope){case 1:e.$8n.properties[i]=o;break;case 2:e.$9n.properties[i]=o;break;case 6:e.$0n.properties[i]=o;break;case 3:e.$$n.properties[i]=o;break;case 4:e.$_n.properties[i]=o;break;case 5:e.$_n.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$7n.properties[i],o.scope){case 1:delete e.$8n.properties[i];break;case 2:delete e.$9n.properties[i];break;case 6:delete e.$0n.properties[i];break;case 3:delete e.$$n.properties[i];break;case 4:case 5:delete e.$_n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$ao};this.w(o,n),e.$7n.properties[o]=n,e.$8n.properties[o]=n,e.$9n.properties[o]=n,e.$0n.properties[o]=n,e.$$n.properties[o]=n,e.$_n.properties[o]=n}}v(){const i={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=i,e.$8n.patternProperties[e.$co]=i,e.$9n.patternProperties[e.$co]=i,e.$0n.patternProperties[e.$co]=i,e.$$n.patternProperties[e.$co]=i,e.$_n.patternProperties[e.$co]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;A.$3f(s)&&(s=o.defaultDefaultValue,t=void 0),A.$3f(s)&&(s=u(o.type)),o.default=s,o.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",h=new RegExp(f,"g");e.$co=`^(${f})+$`,e.$do=new RegExp(e.$co);function b($){const i=[];if(e.$do.test($)){let o=h.exec($);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=h.exec($)}}return(0,R.$Mb)(i)}function p($){return $.reduce((i,o)=>`${i}[${o}]`,"")}function u($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new m;P.$1n.add(e.$6n.Configuration,g);function l($,i){return $.trim()?e.$do.test($)?j.localize(7,null,$):g.getConfigurationProperties()[$]!==void 0?j.localize(8,null,$):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?j.localize(9,null,$,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:j.localize(6,null)}function c(){const $=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))$.push([o,i[o].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(le[76],he([0,1,17,3,34,2,35,30,13,8,21,47,42]),function(se,e,R,N,A,j,D,I,P,d,C,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=l;function f(o){return Object.isFrozen(o)?o:I.$Pn(o)}class h{constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof h)return s;const t=new b("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Wi)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return f(t.rawConfiguration.getValue(n))},get override(){return s?f(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return f(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:y,keys:E}of t.rawConfiguration.overrides){const k=new h(a,E).getValue(n);k!==void 0&&r.push({identifiers:y,value:k})}return r.length?f(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$Wi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return R.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return R.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=I.$On(this.contents),t=I.$On(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const y of n)if(a.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.h(s,y.contents);for(const E of y.overrides){const[k]=t.filter(S=>R.$ub(S.identifiers,E.identifiers));k?(this.h(k.contents,E.contents),k.keys.push(...E.keys),k.keys=R.$Mb(k.keys)):t.push(I.$On(E))}for(const E of y.keys)r.indexOf(E)===-1&&r.push(E)}return new h(s,r,t,a.every(y=>y instanceof h)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of R.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const y=s[r];y&&(typeof a=="object"&&typeof y=="object"?(a=I.$On(a),this.h(a,y)):a=y),t[r]=a}return new h(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&P.$Xf(n[t])&&P.$Xf(s[t])){this.h(n[t],s[t]);continue}n[t]=I.$On(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=I.$On(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Vi)(this.contents,n),v.$do.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>R.$ub(t.identifiers,(0,v.$eo)(n))),1))}j(n,s,t){(0,C.$Ui)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),v.$do.test(n)&&this.overrides.push({identifiers:(0,v.$eo)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Ti)(this.contents[n],r=>console.error(r))})}}e.$jo=h;class b{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!P.$5f(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:y,hasExcludedProperties:E}=this.h(n,s);this.b=new h(t,r,a,E?[n]:void 0),this.c=y||[]}g(n){let s={},t=null,r=[];const a=[],y=[];function E(S){Array.isArray(r)?r.push(S):t!==null&&(r[t]=S)}const k={onObjectBegin:()=>{const S={};E(S),a.push(r),r=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const S=[];E(S),a.push(r),r=S,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:E,onError:(S,w,O)=>{y.push({error:S,offset:w,length:O})}};if(n)try{A.$Cn(n,k),s=r[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return s}h(n,s){const t=m.$1n.as(v.$6n.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$Ti)(n,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),y=Object.keys(n),E=this.j(n,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:a,keys:y,overrides:E,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const y={},E=[];for(const k in n)if(v.$do.test(k)&&t){const S=this.i(n[k],s,!1,r);y[k]=S.raw,a=a||S.hasExcludedProperties,E.push(...S.restricted)}else{const S=s[k],w=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&E.push(k),!r.exclude?.includes(k)&&(r.include?.includes(k)||(w===void 0||r.scopes===void 0||r.scopes.includes(w))&&!(r.skipRestricted&&S?.restricted))?y[k]=n[k]:a=!0}return{raw:y,restricted:E,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(v.$do.test(r)){const a={};for(const y in n[r])a[y]=n[r][y];t.push({identifiers:(0,v.$eo)(r),keys:Object.keys(a),contents:(0,C.$Ti)(a,s)})}return t}}e.$ko=b;class p extends j.$Uc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new N.$7d),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new h}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=p;class u{constructor(n,s,t,r,a,y,E,k,S,w,O,M,T){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=y,this.g=E,this.h=k,this.i=S,this.j=w,this.k=O,this.l=M,this.m=T}get value(){return f(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class g{constructor(n,s,t,r,a=new h,y=new h,E=new D.$Bc,k=new h,S=new D.$Bc){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=y,this.j=E,this.l=k,this.m=S,this.a=null,this.b=new D.$Bc,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new h,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),y=s.resource?this.m.get(s.resource)||this.l:this.l,E=new Set;for(const k of r.overrides)for(const S of k.identifiers)r.getOverrideValue(n,S)!==void 0&&E.add(S);return new u(n,s,r.getValue(n),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,y)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:y}=$(this.c,n);s=[...r,...a,...y]}for(const r of s)for(const a of(0,v.$eo)(r)){const y=this.c.getKeysForOverrideIdentifier(a),E=n.getKeysForOverrideIdentifier(a),k=[...E.filter(S=>y.indexOf(S)===-1),...y.filter(S=>E.indexOf(S)===-1),...y.filter(S=>!I.$Sn(this.c.override(a).getValue(S),n.override(a).getValue(S)))];t.push([a,k])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=$(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=$(this.applicationConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateApplicationConfiguration(n),{keys:y,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=$(this.localUserConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateLocalUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=$(this.remoteUserConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateRemoteUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=$(this.workspaceConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateWorkspaceConfiguration(n),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:y,overrides:E}=$(t,s),k=[...r,...a,...y];return(k.length||!t)&&this.updateFolderConfiguration(n,s),{keys:k,overrides:E}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:y}=$(s,void 0);return{keys:[...t,...r,...a],overrides:y}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),y=this.w(n.workspace),E=n.folders.reduce((k,S)=>(k.set(d.URI.revive(S[0]),this.w(S[1])),k),new D.$Bc);return new g(s,t,r,a,new h,y,E,new h,new D.$Bc)}static w(n){return new h(n.contents,n.keys,n.overrides)}}e.$mo=g;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,y])=>{const E=(0,D.$yc)(s,a,new Set);y.forEach(k=>E.add(k))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const y of a)this.affectedKeys.add(y);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const y=this.d.charCodeAt(a);if(y!==this.b&&y!==this.c)return!1;if(s){const E=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,k=this.g.getValue(n,s,this.h);return!I.$Sn(E,k)}return!0}}e.$oo=c;function $(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],y=o?.getAllOverrideIdentifiers()||[],E=n?.getAllOverrideIdentifiers()||[];if(n){const k=E.filter(S=>!y.includes(S));for(const S of k)a.push([S,n.getKeysForOverrideIdentifier(S)])}if(o){const k=y.filter(S=>!E.includes(S));for(const S of k)a.push([S,o.getKeysForOverrideIdentifier(S)])}if(n&&o){for(const k of y)if(E.includes(k)){const S=i({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)});a.push([k,[...S.added,...S.removed,...S.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const y=(0,C.$Wi)(n.contents,a),E=(0,C.$Wi)(o.contents,a);I.$Sn(y,E)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[216],he([0,1,17,3,2,30,13,76,47,9,58,42]),function(se,e,R,N,A,j,D,I,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=void 0;class m extends A.$Uc{constructor(){super(...arguments),this.a=this.B(new N.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new I.$jo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$1n.as(P.$6n.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:u})=>this.c(Array.from(p),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(p,u){this.h(p,v.$1n.as(P.$6n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}g(){this.b=new I.$jo;const p=v.$1n.as(P.$6n.Configuration).getConfigurationProperties();this.h(Object.keys(p),p)}h(p,u){const g=this.f();for(const l of p){const c=g[l],$=u[l];c!==void 0?this.b.addValue(l,c):$?this.b.addValue(l,$.default):this.b.removeValue(l)}}}e.$po=m;class f{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new I.$jo}async initialize(){return this.configurationModel}}e.$qo=f;let h=class extends A.$Uc{get configurationModel(){return this.b}constructor(p,u,g){super(),this.c=p,this.f=u,this.g=g,this.a=this.B(new N.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new I.$jo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const u={},g=[],l=v.$1n.as(P.$6n.Configuration).getConfigurationProperties();for(const c of p){const $=l[c];if(!$){g.push(c);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}g.push(c),u[$.policy.name]={type:$.type}}}return(0,D.$9f)(u)||await this.f.updatePolicyDefinitions(u),g}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const u=v.$1n.as(P.$6n.Configuration).getPolicyConfigurations(),g=(0,R.$Hb)(p.map(l=>u.get(l)));this.m(g,!0)}m(p,u){this.g.trace("PolicyConfiguration#update",p);const g=v.$1n.as(P.$6n.Configuration).getConfigurationProperties(),l=[],c=this.b.isEmpty();for(const $ of p){const i=g[$]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,j.$Sn)(this.b.getValue($),o))&&l.push([$,o])}else this.b.getValue($)!==void 0&&l.push([$,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const $=this.b;this.b=new I.$jo;for(const i of $.keys)this.b.setValue(i,$.getValue(i));for(const[i,o]of l)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);u&&this.a.fire(this.b)}}};e.$ro=h,e.$ro=h=ve([X(1,C.$3n),X(2,d.$Oj)],h)}),define(le[217],he([0,1,17,6,15,3,34,62,2,30,5,20,21,76,47,216,58]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0;class u extends P.$Uc{constructor(c,$,i,o){super(),this.m=c,this.h=this.B(new j.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$po),this.c=i instanceof p.$5n?new b.$qo:this.B(new b.$ro(this.b,i,o)),this.f=this.B(new f.$lo(this.m,{},v.$Mg,$)),this.a=new f.$mo(this.b.configurationModel,this.c.configurationModel,new f.$jo,new f.$jo),this.j=new g(c,$,this),this.g=this.B(new N.$uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,$,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$mo(c,$,new f.$jo,i)}getConfigurationData(){return this.a.toData()}getValue(c,$){const i=typeof c=="string"?c:void 0,o=(0,m.$Pi)(c)?c:(0,m.$Pi)($)?$:{};return this.a.getValue(i,o,void 0)}async updateValue(c,$,i,o,n){const s=(0,m.$Qi)(i)?i:(0,m.$Pi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,R.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,d.$Sn)($,r.defaultValue)&&($=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const y=s.overrideIdentifiers.sort(),E=this.a.localUserConfiguration.overrides.find(k=>(0,R.$ub)([...k.identifiers].sort(),y));E&&(s.overrideIdentifiers=E.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,h.$fo)(s.overrideIdentifiers),c]:[c];await this.j.write(a,$),await this.reloadConfiguration()}inspect(c,$={}){return this.a.inspect(c,$,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const $=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,$,2)}r(c,$){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,$);this.t(o,i,7)}s(c){const $=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,$,7)}t(c,$,i){const o=new f.$oo(c,{data:$},this.a);o.source=i,this.h.fire(o)}}e.$so=u;class g{constructor(c,$,i){this.b=c,this.c=$,this.d=i,this.a=new N.$ph}write(c,$){return this.a.queue(()=>this.e(c,$))}async e(c,$){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,D.$vn)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,$);i=(0,I.$Nn)(i,n),await this.c.writeFile(this.b,A.$ue.fromString(i))}f(c,$,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!$.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,I.$Kn)(c,$,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=C.OS===3||C.OS===2?`
`:`\r
`;const $=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});$&&typeof $=="string"&&$!=="auto"&&(c=$),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[218],he([0,1,15,3,2,68]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2tb=e.$Ztb=e.$Ytb=void 0,e.$1tb=I;const D=(d,C,v)=>{const m=new Uint8Array(16);for(let b=0;b<16;b++)m[b]=Math.round(Math.random()*256);const f=(0,R.$Oe)(R.$ue.wrap(m));return[`GET ws://localhost${d}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`].join(`\r
`)+`\r
\r
`};e.$Ytb=D,e.$Ztb=R.$ue.fromString(`\r
\r
`);async function I(d,C,v,m,f){d.write(R.$ue.fromString((0,e.$Ytb)(C,v,m)));const h=new A.$Tc;try{return await new Promise((b,p)=>{let u;h.add(d.onData(g=>{u?u=R.$ue.concat([u,g],u.byteLength+g.byteLength):u=g;const l=u.indexOf(e.$Ztb);if(l===-1)return;b(d),d.pauseData();const c=u.slice(l+e.$Ztb.byteLength);c.byteLength&&f.onData.fire(c)})),h.add(d.onClose(g=>p(g??new Error("socket closed")))),h.add(d.onEnd(()=>p(new Error("socket ended"))))})}catch(b){throw d.dispose(),b}finally{h.dispose()}}class P extends A.$Uc{constructor(C,v){super(),this.g=C,this.a=this.B(new N.$0d),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(v.onData),this.B(v.onData.event(m=>this.a.fire(m))),this.onClose=this.B(v.onClose).event,this.onEnd=this.B(v.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,v){j.SocketDiagnostics.traceSocketEvent(this,this.g,C,v)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$2tb=P}),define(le[219],he([0,1,7,4]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=d,e.$tl=(0,N.$ii)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class j{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=j;class D{constructor(v,m){this.host=v,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=D;var I;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class P extends R.$bb{static isNotAvailable(v){return v instanceof P&&v._code===I.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof P&&v._code===I.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof P&&v._code===I.NoResolverFound}static isInvalidAuthority(v){return v instanceof P&&v._code===I.InvalidAuthority}static isHandled(v){return v instanceof P&&v.isHandled}constructor(v,m=I.Unknown,f){super(v),this._message=v,this._code=m,this._detail=f,this.isHandled=m===I.NotAvailable&&f===!0,Object.setPrototypeOf(this,P.prototype)}}e.$wl=P;function d(C){const v=C.indexOf("+");return v===-1?C:C.substring(0,v)}}),define(le[220],he([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Cl=y,e.$Dl=E,e.$El=S;const h=30*1e3;var b;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function p(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(q){const L=new A.$ee;return setTimeout(()=>L.cancel(),q),L.token}function g(q,L){if(q.isCancellationRequested||L.isCancellationRequested)return A.CancellationToken.Cancelled;const F=new A.$ee;return q.onCancellationRequested(()=>F.cancel()),L.onCancellationRequested(()=>F.cancel()),F.token}class l{get didTimeout(){return this.c==="timedout"}constructor(L){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$bh)(),L.isCancellationRequested?this.h():this.d.add(L.onCancellationRequested(()=>this.h()))}registerDisposable(L){this.c==="pending"?this.d.add(L):L.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const L=new Error("Time limit reached");return L.code="ETIMEDOUT",L.syscall="connect",L}resolve(L){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(L))}reject(L){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(L))}}function c(q,L){const F=new l(L);return F.registerDisposable(q.onControlMessage(z=>{const Y=JSON.parse(z.toString()),J=B(Y);J?F.reject(J):F.resolve(Y)})),F.promise}function $(q,L,F,z,Y,J,ee,x){const Q=new l(x),ne=C.$3d.create(!1);return q.info(`Creating a socket (${ee})...`),d.mark(`code/willCreateSocket/${J}`),L.connect(F,z,Y,ee).then(re=>{Q.didTimeout?(d.mark(`code/didCreateSocketError/${J}`),q.info(`Creating a socket (${ee}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),re?.dispose()):(d.mark(`code/didCreateSocketOK/${J}`),q.info(`Creating a socket (${ee}) was successful after ${ne.elapsed()} ms.`),Q.resolve(re))},re=>{d.mark(`code/didCreateSocketError/${J}`),q.info(`Creating a socket (${ee}) returned an error after ${ne.elapsed()} ms.`),q.error(re),Q.reject(re)}),Q.promise}function i(q,L){const F=new l(L);return q.then(z=>{F.didTimeout||F.resolve(z)},z=>{F.didTimeout||F.reject(z)}),F.promise}async function o(q,L,F,z){const Y=ce(q,L);q.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let J;try{J=await $(q.logService,q.remoteSocketFactoryService,q.connectTo,P.$vg.getServerRootPath(),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,p(L),`renderer-${p(L)}-${q.reconnectionToken}`,z)}catch(re){throw q.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),q.logService.error(re),re}q.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let ee,x;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(J,null),ee=q.reconnectionProtocol,x=!1):(ee=new m.$9h({socket:J}),x=!0),q.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const Q=await i(q.signService.createNewMessage((0,v.$Eg)()),z),ne={type:"auth",auth:q.connectionToken||"00000000000000000000",data:Q.data};ee.sendControl(N.$ue.fromString(JSON.stringify(ne)));try{const re=await c(ee,g(z,u(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(q.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await i(q.signService.validate(Q,re.signedData),z)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const de=await i(q.signService.sign(re.data),z),$e={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:L};return F&&($e.args=F),q.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.$ue.fromString(JSON.stringify($e))),{protocol:ee,ownsProtocol:x}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(q.logService.error(`${Y} the handshake timed out. Error:`),q.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${Y} received error control message when negotiating connection. Error:`),q.logService.error(re)),x&&W(ee),re}}async function n(q,L,F,z){const Y=Date.now(),J=ce(q,L),{protocol:ee,ownsProtocol:x}=await o(q,L,F,z),Q=new l(z);return Q.registerDisposable(ee.onControlMessage(ne=>{const re=JSON.parse(ne.toString()),ue=B(re);ue?(q.logService.error(`${J} received error control message when negotiating connection. Error:`),q.logService.error(ue),x&&W(ee),Q.reject(ue)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${H(Y)}!`),Q.resolve({protocol:ee,firstMessage:re}))})),Q.promise}async function s(q,L){const{protocol:F}=await n(q,1,void 0,L);return{protocol:F}}async function t(q,L,F){const{protocol:z,firstMessage:Y}=await n(q,2,L,F),J=Y&&Y.debugPort;return{protocol:z,debugPort:J}}async function r(q,L,F){const z=Date.now(),Y=ce(q,3),{protocol:J}=await o(q,3,L,F);return q.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${H(z)}!`),J}async function a(q,L,F){const{connectTo:z,connectionToken:Y}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:z,connectionToken:Y,reconnectionToken:L,reconnectionProtocol:F,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function y(q,L,F){return k(q,async z=>{const{protocol:Y}=await s(z,A.CancellationToken.None);return new V(q,L,F,z.reconnectionToken,Y)})}async function E(q,L){return k(q,async F=>{const{protocol:z,debugPort:Y}=await t(F,L,A.CancellationToken.None);return new K(q,L,F.reconnectionToken,z,Y)})}async function k(q,L){for(let z=1;;z++)try{const Y=(0,v.$Eg)(),J=await a(q,Y,null);return await L(J)}catch(Y){if(z<5)q.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(Y);else throw q.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(Y),Z.triggerPermanentFailure(0,0,f.$wl.isHandled(Y)),Y}}async function S(q,L,F){const z=await a(q,(0,v.$Eg)(),null);return await r(z,{host:L,port:F},A.CancellationToken.None)}function w(q){return(0,R.$8g)(L=>new Promise((F,z)=>{const Y=setTimeout(F,q*1e3);L.onCancellationRequested(()=>{clearTimeout(Y),F()})}))}var O;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class M{constructor(L,F){this.reconnectionToken=L,this.millisSinceLastIncomingData=F,this.type=0}}e.$Fl=M;class T{constructor(L,F,z,Y){this.reconnectionToken=L,this.millisSinceLastIncomingData=F,this.durationSeconds=z,this.c=Y,this.type=1}skipWait(){this.c.cancel()}}e.$Gl=T;class U{constructor(L,F,z){this.reconnectionToken=L,this.millisSinceLastIncomingData=F,this.attempt=z,this.type=2}}e.$Hl=U;class _{constructor(L,F,z){this.reconnectionToken=L,this.millisSinceLastIncomingData=F,this.attempt=z,this.type=4}}e.$Il=_;class G{constructor(L,F,z,Y){this.reconnectionToken=L,this.millisSinceLastIncomingData=F,this.attempt=z,this.handled=Y,this.type=3}}e.$Jl=G;class Z extends I.$Uc{static triggerPermanentFailure(L,F,z){this._permanentFailure=!0,this.f=L,this.g=F,this.h=z,this.j.forEach(Y=>Y.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(L=>L.y())}static debugPauseSocketWriting(){this.j.forEach(L=>L.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Z._permanentFailure}constructor(L,F,z,Y,J){super(),this.t=L,this.u=F,this.reconnectionToken=z,this.protocol=Y,this.w=J,this.m=this.B(new D.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new _(this.reconnectionToken,0,0)),this.B(Y.onSocketClose(ee=>{const x=te(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${x} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${x} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${x} received socket close event.`),this.y()})),this.B(Y.onSocketTimeout(ee=>{const x=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),Z.j.push(this),this.B((0,I.$Sc)(()=>{const ee=Z.j.indexOf(this);ee>=0&&Z.j.splice(ee,1)})),this.n&&this.D(Z.f,Z.g,Z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const L=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${L} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const Y=z<F.length?F[z]:F[F.length-1];try{if(Y>0){const ee=w(Y);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,ee)),this.u.logService.info(`${L} waiting for ${Y} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${L} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${L} resolving connection...`);const J=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${L} connecting to ${J.connectTo}...`),await this.G(J,u(h)),this.u.logService.info(`${L} reconnected!`),this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${L} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${L} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(f.$wl.isTemporarilyNotAvailable(J)){this.u.logService.info(`${L} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${L} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,j.$4)(J)){this.u.logService.info(`${L} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof f.$wl){this.u.logService.error(`${L} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,f.$wl.isHandled(J));break}this.u.logService.error(`${L} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(L,F,z){this.w?Z.triggerPermanentFailure(L,F,z):this.D(L,F,z)}D(L,F,z){this.m.fire(new G(this.reconnectionToken,L,F,z)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Kl=Z;class V extends Z{constructor(L,F,z,Y,J){super(1,L,Y,J,!0),this.client=this.B(new m.$7h(J,{remoteAuthority:F,clientId:z},L.ipcLogger))}async G(L,F){await s(L,F)}}e.$Ll=V;class K extends Z{constructor(L,F,z,Y,J){super(2,L,z,Y,!1),this.H=F,this.debugPort=J}async G(L,F){await t(L,this.H,F)}}e.$Ml=K;function W(q){try{q.acceptDisconnect();const L=q.getSocket();q.dispose(),L.dispose()}catch(L){(0,j.$1)(L)}}function B(q){if(q&&q.type==="error"){const L=new Error(`Connection error: ${q.reason}`);return L.code="VSCODE_CONNECTION_ERROR",L}return null}function ie(q,L){for(;q.length<L;)q+=" ";return q}function ae(q,L){return`[remote-connection][${ie(p(q),13)}][${L.substr(0,5)}\u2026]`}function te(q,L,F){return`${ae(q,L)}[${F?"reconnect":"initial"}]`}function ce(q,L){return`${te(L,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function H(q){return`${Date.now()-q} ms`}}),define(le[102],he([0,1,23]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=N,e.$um=A,e.$vm=j,e.$wm=D;function N(P){return P.scheme===R.Schemas.vscodeRemote?P.authority:void 0}function A(P){if(!P)return;const d=P.indexOf("+");return d<0?P:P.substr(0,d)}function j(P){const{host:d,port:C}=I(P);if(typeof C>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:d,port:C}}function D(P,d){let{host:C,port:v}=I(P);return typeof v>"u"&&(v=d),{host:C,port:v}}function I(P){const d=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(d)return{host:d[1],port:parseInt(d[2],10)};const C=P.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const v=P.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:P,port:void 0}}}),define(le[48],he([0,1,27,4,102]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=j,e.$Gm=v,e.$Hm=m,e.$Im=f,e.$Jm=h,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function j(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var I;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class P{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,u){if(typeof p>"u"||p===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof p=="string"||typeof u=="string"){const g=typeof p=="string"?p:p.value,l=typeof u=="string"?u:u.value;return R.$lf(g,l)}return p._lower===u._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$Dm=P;class d{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const u of p)this.add(u)}add(p){this.c.add(P.toKey(p))}delete(p){return this.c.delete(P.toKey(p))}has(p){return this.c.has(P.toKey(p))}}e.$Em=d;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(P.toKey(p))}get(p){return this.c.get(P.toKey(p))}has(p){return this.c.has(P.toKey(p))}set(p,u){this.c.set(P.toKey(p),u)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=C;function v(b){return m(b)}function m(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function f(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function h(b,p){if(p){const u=`onResolveRemoteAuthority:${(0,A.$um)(p)}`;return!!b.activationEvents?.includes(u)}return!1}e.$Km=(0,N.$ii)("IBuiltinExtensionsScannerService")}),define(le[221],he([0,1,2,48,12]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class j extends R.$Uc{constructor(I,P,d,C,v){super(),this.a=I,this.b=P,this.c=d,this.f=v,this.B(C.onDidInstallExtensions(m=>this.g(m))),this.B(C.onDidUninstallExtension(m=>this.h(m)))}g(I){for(const P of I)P.local&&this.invalidate(P.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const P of this.a.profiles)this.c.extUri.isEqual(P.extensionsResource,I)&&await this.j(P);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$xm))}catch(P){(0,A.$6k)(P)!==1&&this.f.error(P)}}}e.$nq=j}),define(le[103],he([0,1,2,4]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl=(0,N.$ii)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(D,I){return this.a[D]??=[],this.a[D].push(I),(0,R.$Sc)(()=>{const P=this.a[D]?.indexOf(I);typeof P=="number"&&P>=0&&this.a[D]?.splice(P,1)})}b(D){return(this.a[D.type]||[]).find(P=>P.supports(D))}connect(D,I,P,d){const C=this.b(D);if(!C)throw new Error(`No socket factory found for ${D}`);return C.connect(D,I,P,d)}}e.$zl=A}),define(le[222],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=void 0,e.$Mcc=(0,R.$ii)("sharedProcessTunnelService"),e.$Ncc="sharedProcessTunnel"}),define(le[104],he([0,1,4,169]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=e.TunnelStates=e.$Scc=e.$Rcc=void 0,e.$Rcc=(0,R.$ii)("IRemoteTunnelService"),e.$Scc={active:!1};var A;(function(j){j.disconnected=D=>({type:"disconnected",onTokenFailed:D}),j.connected=(D,I)=>({type:"connected",info:D,serviceInstallFailed:I}),j.connecting=D=>({type:"connecting",progress:D}),j.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$Tcc="remote.tunnels.access",e.$Ucc=e.$Tcc+".hostNameOverride",e.$Vcc=e.$Tcc+".preventSleep",e.$Wcc="remoteTunnelService",e.$Xcc=(0,N.localize)(0,null)}),define(le[59],he([0,1,15,7,2,171,47,4,9,42]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=void 0,e.$Bp=m,e.$Cp=f,e.$Dp=h,e.$Ep=b,e.$Fp=p,e.$Gp=u,e.$zp=(0,I.$ii)("requestService");class C{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?$[i]="*****":$[i]=this.b[i];this.a=$}return this.a}}class v extends A.$Uc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,j.localize)(0,null),when:P.$7j.isEqualTo((0,P.$4j)(P.LogLevel.Trace)).serialize()})}async c($,i,o){const n=`${$} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,N.$0)(s)),s}}}e.$Ap=v;function m(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function f(c){return c.res.statusCode===204}async function h(c){return f(c)?null:(await(0,R.$Ge)(c.stream)).toString()}async function b(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);return h(c)}async function p(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);if(f(c))return null;const i=(await(0,R.$Ge)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function u(c){l(c)}let g;function l(c){const $=d.$1n.as(D.$6n.Configuration),i=g;g={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[g],remove:i?[i]:[]})}l(1)}),define(le[223],he([0,1,26,23,12,59]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=void 0;let D=class{constructor(P,d){this.a=P,this.b=d}async download(P,d,C=R.CancellationToken.None){if(P.scheme===N.Schemas.file||P.scheme===N.Schemas.vscodeRemote){await this.b.copy(P,d);return}const v={type:"GET",url:P.toString(!0)},m=await this.a.request(v,C);if(m.res.statusCode===200)await this.b.writeFile(d,m.stream);else{const f=await(0,j.$Ep)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${f}`)}}};e.$mQ=D,e.$mQ=D=ve([X(0,j.$zp),X(1,A.$Ok)],D)}),define(le[224],he([0,1,15,26]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;class A{constructor(I){this.a=I}listen(I,P){throw new Error("Invalid listen")}call(I,P,d,C=N.CancellationToken.None){switch(P){case"request":return this.a.request(d[0],C).then(async({res:v,stream:m})=>{const f=await(0,R.$Ge)(m);return[{statusCode:v.statusCode,headers:v.headers},f]});case"resolveProxy":return this.a.resolveProxy(d[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Er=A;class j{constructor(I){this.a=I}async request(I,P){const[d,C]=await this.a.call("request",[I],P);return{res:d,stream:(0,R.$Ie)(C)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Fr=j}),define(le[225],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=e.$ebc=void 0,e.$ebc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$fbc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$gbc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[226],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$9b=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const j=await this.c();if(j){const D=String(R.a++);return this.b.set(D,j),{id:D,data:j.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,j){if(!A.id)return!0;const D=this.b.get(A.id);if(!D)return!1;this.b.delete(A.id);try{return D.validate(j)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$$9b=R}),define(le[105],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=void 0,e.$Al="signService",e.$Bl=(0,R.$ii)(e.$Al)}),define(le[227],he([0,1,226]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=void 0;class N extends R.$$9b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(D=>new D.signer().sign(j))}h(){return new Promise((j,D)=>se(["vsda"],j,D))}}e.$7bc=N}),define(le[77],he([0,1,3,2]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJb=e.$jJb=e.$iJb=e.$hJb=void 0;class A extends N.$Uc{constructor(v,m,f){super(),this.a=v,this.b=m,this.c=f}async getItems(){const v={profile:this.b,workspace:this.c},m=await this.a.call("getItems",v);return new Map(m)}updateItems(v){const m={profile:this.b,workspace:this.c};return v.insert&&(m.insert=Array.from(v.insert.entries())),v.delete&&(m.delete=Array.from(v.delete.values())),this.a.call("updateItems",m)}optimize(){const v={profile:this.b,workspace:this.c};return this.a.call("optimize",v)}}class j extends A{constructor(v,m){super(v,m,void 0),this.f=this.B(new R.$7d),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(v=>this.h(v)))}h(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this.f.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}}class D extends j{constructor(v){super(v,void 0)}async close(){this.dispose()}}e.$hJb=D;class I extends j{constructor(v,m){super(v,m)}async close(){this.dispose()}}e.$iJb=I;class P extends A{constructor(v,m){super(v,void 0,m),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$jJb=P;class d{constructor(v){this.a=v}isUsed(v){const m={payload:v,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$kJb=d}),define(le[106],he([0,1,5,36,32]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=D,e.$3o=I;function j(P){if(R.$u===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function D(P,d,C,v,m,f,h,b,p){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=h,u.sessionID=(0,A.$Eg)()+Date.now(),u.commitHash=v,u.version=m,u["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,R.$h)(R.$u),u["common.nodePlatform"]=N.$ec,u["common.nodeArch"]=C,u["common.product"]=p||"desktop",b&&(u["common.msftInternal"]=b);let g=0;const l=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),R.$l&&(u["common.snap"]="true");const c=j(d);return c&&(u["common.platformDetail"]=c),u}function I(P){const d=N.env.USERDNSDOMAIN;if(!d)return!1;const C=d.toLowerCase();return P.some(v=>C===v)}}),define(le[22],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,R.$ii)("telemetryService"),e.$Ol=(0,R.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var N;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(le[228],he([0,1,37,6,34,23,14,5,8,144,31,150,94,12,24,22]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0,e.$ns=u,e.$os=l,e.$ps=c;const p=new Map;async function u(i,o){const n=`${i}::${o.join(":")}`,s=p.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,y=2e4;function E(S,w,O,M){const T=w.substring(S.length+1);return N.Promises.withAsyncBody(async U=>{let _;try{_=await C.Promises.readdir(w,{withFileTypes:!0})}catch{U();return}if(M.count>=y){M.count+=_.length,M.maxReached=!0,U();return}let G=_.length;if(G===0){U();return}let Z=_;M.count+_.length>y&&(M.maxReached=!0,G=y-M.count,Z=_.slice(0,G)),M.count+=_.length;for(const V of Z)if(V.isDirectory()){if(O.includes(V.name)||await E(S,(0,D.$kc)(w,V.name),O,M),--G===0){U();return}}else{const K=V.name.lastIndexOf(".");if(K>=0){const W=V.name.substring(K+1);W&&r.set(W,(r.get(W)??0)+1)}for(const W of t)W.relativePathPattern?.test(T)!==!1&&W.filePattern.test(V.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--G===0){U();return}}})}const k=N.Promises.withAsyncBody(async S=>{const w={count:0,maxReached:!1};await E(i,i,o,w);const O=await c(i);S({configFiles:g(a),fileTypes:g(r),fileCount:w.count,maxFilesReached:w.maxReached,launchConfigFiles:O})});return p.set(n,k),k}function g(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function l(){const i={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/f.$kl.GB).toFixed(2)}GB (${(R.freemem()/f.$kl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$qn.value()*100)}%`},o=R.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}async function c(i){try{const o=new Map,n=(0,D.$kc)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,A.$vn)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,A.$En)(r)==="object"&&r.configurations)for(const a of r.configurations){const y=a.type;y&&(o.has(y)?o.set(y,o.get(y)+1):o.set(y,1))}return g(o)}catch{return[]}}let $=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const s=R.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(R.totalmem()/f.$kl.GB).toFixed(2)}GB (${(R.freemem()/f.$kl.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${R.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(d.$qn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,v.$ms)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(y=>{if((0,m.$3m)(y))a+=`
${y.errorMessage}`,r+=`
${y.errorMessage}`;else if(a+=`

Remote: ${y.hostName}`,y.processes&&(a+=`
${this.m(o,y.processes)}`),y.workspaceMetadata){r+=`
|  Remote: ${y.hostName}`;for(const E of Object.keys(y.workspaceMetadata)){const k=y.workspaceMetadata[E];let S=`${k.fileCount} files`;k.maxFilesReached&&(S=`more than ${S}`),r+=`|    Folder (${E}): ${S}`,r+=this.h(k)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=l(),y={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(y.load=`${R.loadavg().map(E=>Math.round(E)).join(", ")}`),I.$k&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(o,n){const s=[];return(0,v.$ms)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$3m)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const y=r.workspaceMetadata[a];let E=`${y.fileCount} files`;y.maxFilesReached&&(E=`more than ${E}`),s.push(`Folder (${a}): ${E}`),s.push(this.h(y))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(k,S)=>{const w=` ${k}(${S})`;t+w.length>60?(n.push(a),a="|                 ",t=a.length):t+=w.length,a+=w};let a="|      File types:";const y=10,E=o.fileTypes.length>y?y:o.fileTypes.length;for(let k=0;k<E;k++){const S=o.fileTypes[k];r(S.name,S.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(k=>{r(k.name,k.count)}),n.push(a)),o.launchConfigFiles.length>0){let k="|      Launch Configs:";o.launchConfigFiles.forEach(S=>{const w=S.count>1?` ${S.name}(${S.count})`:` ${S.name}`;k+=w}),n.push(k)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=P.URI.revive(r);if(a.scheme===j.Schemas.file){const y=a.fsPath;s.push(u(y,["node_modules",".git"]).then(E=>{let k=`${E.fileCount} files`;E.maxFilesReached&&(k=`more than ${k}`),n.push(`|    Folder (${(0,D.$oc)(y)}): ${k}`),n.push(this.h(E))}).catch(E=>{n.push(`|      Error: Unable to collect workspace stats for folder ${y} (${E.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let y;a?y=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?y=n.get(t.pid):y=`${"  ".repeat(r)} ${t.name}`;const E=process.platform==="win32"?t.mem:R.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(E/f.$kl.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(t.children)&&t.children.forEach(k=>this.n(o,n,s,k,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=P.URI.revive(s);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await u(r,["node_modules",".git"])).fileTypes.forEach(y=>n.add(y.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=P.URI.revive(n);if(s.scheme!==j.Schemas.file)continue;const t=s.fsPath;try{const r=await u(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$qs=$,e.$qs=$=ve([X(0,b.$Nl),X(1,h.$8j)],$)}),define(le[107],he([0,1,7,4,9,22]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0,e.$Xp=(0,N.$ii)("IExtensionSignatureVerificationService");let D=class{constructor(P,d){this.b=P,this.c=d}d(){return this.a||(this.a=new Promise((P,d)=>se(["@vscode/vsce-sign"],async C=>P(C),d))),this.a}async verify(P,d,C){let v;try{v=await this.d()}catch(b){return this.b.error("Could not load vsce-sign module",(0,R.$0)(b)),!1}const m=new Date().getTime();let f,h;try{return f=await v.verify(P,d,C),f}catch(b){throw h=b,b}finally{const b=new Date().getTime()-m;this.c.publicLog2("extensionsignature:verification",{duration:b,verified:f,error:h?h.code??"unknown":void 0})}}};e.$Yp=D,e.$Yp=D=ve([X(0,A.$Oj),X(1,j.$Nl)],D)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=void 0;class R{constructor(j){this.b=j}listen(j,D){throw new Error(`Event not found: ${D}`)}call(j,D,{eventName:I,data:P}){return this.b.forEach(d=>d.log(I,P)),Promise.resolve(null)}}e.$jbc=R;class N{constructor(j){this.b=j}log(j,D){return this.b.call("log",{eventName:j,data:D}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$kbc=N}),define(le[49],he([0,1,30,13,102,106,22]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=C,e.$_o=v,e.$ap=m,e.$bp=f,e.$cp=b,e.$dp=u,e.$ep=g,e.$fp=$;class I{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$4o=I;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=P,e.$6o=new P;class d{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$7o=d,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function v(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function m(i){const o=i.getValue(D.$Vl),n=i.getValue(D.$Wl);if(i.getValue(D.$Xl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function f(i){const o={},n={},s={};p(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(i){if(!i)return"none";const o=(0,A.$um)(i);return h.has(o)?o:"other"}function p(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,R.$Tn)(r):r instanceof Date?o[a]=r.toISOString():(0,N.$Xf)(r)?n<2?p(r,o,n+1,a+"."):o[a]=(0,R.$Tn)(r):o[a]=r}}function u(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,j.$3o)(n)||s}function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function l(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const y of o)for(;;){const E=y.exec(i);if(!E)break;s.push([E.index,y.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const y=r.exec(i);if(!y)break;const E=s.some(([k,S])=>y.index<S&&k<r.lastIndex);!t.test(y[0])&&!E&&(n+=i.substring(a,y.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function $(i,o){return(0,R.$Qn)(i,n=>{if(n instanceof I||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=l(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}}),define(le[33],he([0,1,27,29,48,5,8,7,36,49]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=C,e.$ip=h,e.$jp=b,e.$kp=p,e.$lp=u,e.$mp=g,e.$np=l,e.$op=c,e.$qp=$,e.$rp=o;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,R.$gf)(n.id,s.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,t,r)}static parse(s){const t=v.exec(s);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$hp=m;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(n){const s=f.exec(n);return s&&s[1]?[p(s[1]),s[2]]:[p(n),void 0]}function b(n,s){return`${n}.${s}`}function p(n){return n.toLowerCase()}function u(n,s){return p(b(n??A.$zm,s))}function g(n,s){const t=[],r=a=>{for(const y of t)if(y.some(E=>C(s(E),s(a))))return y;return null};for(const a of n){const y=r(a);y?y.push(a):t.push([a])}return t}function l(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function c(n){return{id:new d.$4o(n.identifier.id),name:new d.$4o(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$pp=new A.$Dm("pprice.better-merge");function $(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(y=>!C(y.identifier,{id:a}))){const y=n.filter(E=>C(E.identifier,{id:a}));y.length===1&&(t.push(y[0]),r.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}async function i(n,s){if(!j.$k)return!1;let t;try{t=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,N.$No)(t?"alpine":j.$u,P.$fc);return s.debug("ComputeTargetPlatform:",r),r}}),define(le[229],he([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=e.$h_b=void 0;let h=class extends N.$Uc{constructor(l,c){super(),this.b=l,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,$])=>this.a.set($.configPath,$))}getConfigBasedTips(l){return this.f(l)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(l){const c=[];for(const[$,i]of this.a)if(!(i.configScheme&&i.configScheme!==l.scheme))try{const o=(await this.b.readFile((0,A.$Vg)(l,$))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$h_b=h,e.$h_b=h=ve([X(0,D.$Ok),X(1,I.$8j)],h);const b="extensionTips/promptedExecutableTips",p="extensionTips/lastPromptedMediumImpExeTime";class u extends h{constructor(l,c,$,i,o,n,s,t){super(s,t),this.r=l,this.s=c,this.t=$,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const y=[],E=[],k=[];Object.entries(a.recommendations).forEach(([S,w])=>{w.important?a.important?y.push({extensionId:S,extensionName:w.name,isExtensionPack:!!w.isExtensionPack}):E.push({extensionId:S,extensionName:w.name,isExtensionPack:!!w.isExtensionPack}):k.push({extensionId:S,extensionName:w.name,isExtensionPack:!!w.isExtensionPack})}),y.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),E.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),k.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:k})}),(0,P.$kh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const l=await this.O(this.g),c=await this.O(this.h);return[...l,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const l=await this.O(this.g),c=await this.O(this.h),$=await this.u.getInstalled();this.m=this.D(l,$),this.n=this.D(c,$)}D(l,c){const $=new Map;l.forEach(t=>$.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...$.keys()],c);for(const t of i){const r=$.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=$.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=$.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[l,c]=[...this.m.entries()][0];this.H(c).then($=>{switch($){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(l);break;case"incompatibleWindow":{const i=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new N.$Vc);i.value=(0,P.$kh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const l=this.I(),c=Date.now()-l,$=7*24*60*60*1e3;if(c<$){const n=this.B(new N.$Vc);n.value=(0,P.$kh)(()=>{n.dispose(),this.G()},$-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new N.$Vc);s.value=(0,P.$kh)(()=>{s.dispose(),this.G()},$);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Vc);s.value=(0,P.$kh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(l){const c=await this.u.getInstalled(1),$=l.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,f.$gp)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:$,source:3,name:l[0].exeFriendlyName,searchValue:`@exe:"${l[0].exeName}"`})}I(){let l=this.w.getNumber(p,-1);return l||(l=Date.now(),this.J(l)),l}J(l){this.w.store(p,l,-1,1)}L(){return JSON.parse(this.w.get(b,-1,"{}"))}M(l,c){const $=this.L();$[l]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(b,JSON.stringify($),-1,0)}N(l,c){const $=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return l.forEach(n=>{o.has(n.toLowerCase())?$.push(n):i.push(n)}),{installed:$,uninstalled:i}}async O(l){const c=[],$=new Map;for(const i of l.keys()){const o=l.get(i);if(!o||!(0,R.$Lb)(o.recommendations))continue;const n=[];v.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,C.$kc)("/usr/local/bin",i)),n.push((0,C.$kc)("/usr/bin",i)),n.push((0,C.$kc)(this.r.fsPath,i)));for(const s of n){let t=$.get(s);if(t===void 0&&(t=await this.b.exists(j.URI.file(s)),$.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:y,whenNotInstalled:E}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:y,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:E})}}return c}}e.$i_b=u}),define(le[230],he([0,1,26,33]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f3b=A;async function A(j,D,I,P,d){try{const C=await j.getExtensionsControlManifest();if(!C.deprecated)return;const v=await j.getInstalled(1);for(const[m,f]of Object.entries(C.deprecated)){if(!f?.extension)continue;const{id:h,autoMigrate:b,preRelease:p}=f.extension;if(!b)continue;const u=v.find(l=>(0,N.$gp)(l.identifier,{id:m}));if(!u)continue;const g=(await D.getExtensions([{id:h,preRelease:p}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){d.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{d.info(`Migrating '${u.identifier.id}' extension to '${h}' extension...`);const l=!P.getDisabledExtensions().some($=>(0,N.$gp)($,u.identifier));await j.uninstall(u),d.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let c=v.find($=>(0,N.$gp)($.identifier,{id:h}));(!c||!c.isPreReleaseVersion&&l)&&(c=await j.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${c.identifier.id}'`),l||(await P.disableExtension(c.identifier),d.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),b.storage&&(I.addToMigrationList((0,N.$jp)(u.manifest.publisher,u.manifest.name),(0,N.$jp)(c.manifest.publisher,c.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${u.identifier.id}' extension to '${h}' extension.`)}catch(l){d.error(l)}}}catch(C){d.error(C)}}}),define(le[231],he([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;let c=class extends A.$Uc{static{l=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,D.$Vg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new h.$So(r.message,h.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===g.LogLevel.Trace)}catch(a){const y=a;if(t=y.code,y.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${y.output}`),t===h.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===h.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(E){this.r.error(E)}throw new h.$So(v.$4p,h.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,P.$2f)(o)?o:!0}async u(i){await this.g;const o=(0,D.$Vg)(this.extensionsDownloadDir,`${this.z(i)}${l.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new h.$So(n.message,h.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await n(o);return}const s=(0,D.$Vg)(this.extensionsDownloadDir,`.${(0,d.$Eg)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(l.c))s.push(a.resource);else{const y=b.$hp.parse(a.name);y&&n.push([y,a])}const t=(0,b.$mp)(n,([a])=>a),r=[];for(const a of t)a.sort((y,E)=>I.rcompare(y[0].version,E[0].version)),o.push(...a.slice(1).map(y=>y[1].resource)),r.push(a[0][1]);r.sort((a,y)=>a.mtime-y.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await R.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?b.$hp.create(i).toString().toLowerCase():(0,d.$Eg)()}};e.$kq=c,e.$kq=c=l=ve([X(0,f.$qi),X(1,u.$Ok),X(2,h.$Ro),X(3,m.$Oi),X(4,p.$Xp),X(5,g.$Oj)],c)}),define(le[232],he([0,1,3,2,35,33,48]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class I extends N.$Uc{constructor(d,C,v,m,f,h,b){super(),this.f=d,this.g=C,this.h=v,this.j=m,this.m=f,this.n=h,this.r=b,this.a=this.B(new R.$7d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$4c),this.s().then(null,p=>b.error(p))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(C=>(this.c.set(C.id,(0,N.$Rc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(d){for(const C of d.extensions)this.I(this.L(C.identifier,C.version),d.profileLocation)}async y(d){for(const C of d.extensions){const v=this.L(C.identifier,C.version);d.error?this.J(v,d.profileLocation):this.I(v,d.profileLocation)}}async z(d){for(const C of d.extensions)this.J(this.L(C.identifier,C.version),d.profileLocation)}async C(d){const C=[],v=[];for(const m of d.extensions){const f=this.L(m.identifier,m.version);d.error?this.I(f,d.profileLocation):(this.J(f,d.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),v.push(this.f.scanInstalledExtensionAtLocation(m.location).then(h=>{h?C.push(h):this.r.info("Extension not found at the location",m.location.toString())},h=>this.r.error(h)))))}try{await Promise.all(v),C.length&&await this.H(C)}catch(m){this.r.error(m)}}D(d){for(const C of this.h.profiles)d.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(d){const C=[],v=[],m=await this.j.scanProfileExtensions(d),f=new Set,h=new Set;for(const[b,p]of this.b)p.has(d)&&h.add(b);for(const b of m){const p=this.L(b.identifier,b.version);f.add(p),h.has(p)||(C.push(b.identifier),this.I(p,d))}for(const b of h)if(!f.has(b)){const p=this.M(b);p&&(v.push(p.identifier),this.J(b,d))}(C.length||v.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:d}:void 0,removed:v.length?{extensions:v,profileLocation:d}:void 0})}async G(d){const C=await this.j.scanProfileExtensions(d);for(const v of C)this.I(this.L(v.identifier,v.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,C){let v=this.b.get(d);v||this.b.set(d,v=new A.$Cc(m=>this.m.extUri.getComparisonKey(m))),v.add(C)}J(d,C){const v=this.b.get(d);v&&v.delete(C),v?.size||this.b.delete(d)}L(d,C){return`${D.$Dm.toKey(d.id)}@${C}`}M(d){const[C,v]=(0,j.$ip)(d);return v?{identifier:{id:C},version:v}:void 0}}e.$oq=I}),define(le[233],he([0,1,45,49]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=A;async function A(j,D,I,P,d,C,v){const m={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${D.nameShort})`};if((0,N.$$o)(D,I)&&(0,N.$ap)(P)===3){const f=await(0,R.$Sp)(I,d,C);m["X-Market-User-Id"]=f,m["VSCode-SessionId"]=v.machineId||f}return m}}),define(le[234],he([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;let b=class extends f.$Cr{constructor(l,c,$,i){super($),this.h=l,this.j=i,this.g=this.B(new p(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(l,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[l];return o?h.URI.file(o):void 0}async getInstalledLanguages(){const l=await this.g.getLanguagePacks(),c=Object.keys(l).map($=>{const i=l[$];return{...this.f($,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort(($,i)=>$.label.localeCompare(i.label)),c}async m(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",l.identifier.id),await this.update())}async n(l){const c=await this.g.getLanguagePacks();Object.keys(c).some($=>c[$]&&c[$].extensions.some(i=>(0,v.$gp)(i.extensionIdentifier,l.identifier)))&&(this.j.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(c);return!(0,N.$ub)(Object.keys(l),Object.keys($))}};e.$Dr=b,e.$Dr=b=ve([X(0,C.$Uo),X(1,d.$qi),X(2,C.$Ro),X(3,m.$Oj)],b);let p=class extends j.$Uc{constructor(l,c){super(),this.j=c,this.c={},this.f=(0,I.$kc)(l.userDataPath,"languagepacks.json"),this.g=new A.$ph}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(l){return this.s(c=>{Object.keys(c).forEach($=>delete c[$]),this.m(c,...l)}).then(()=>this.c)}m(l,...c){for(const $ of c)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(l,$);Object.keys(l).forEach($=>this.r(l[$]))}n(l,c){const $=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===D.Schemas.file&&u(o)){let n=l[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},l[o.languageId]=n);const s=n.extensions.filter(t=>(0,v.$gp)(t.extensionIdentifier,$))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:$,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,I.$kc)(c.location.fsPath,t.path)}}r(l){if(l){const c=(0,R.createHash)("md5");for(const $ of l.extensions)c.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);l.hash=c.digest("hex")}}s(l=()=>null){return this.g.queue(()=>{let c=null;return P.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(c=l($),$)).then($=>{for(const o of Object.keys($))$[o]||delete $[o];this.c=$,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),P.Promises.writeFile(this.f,i)}).then(()=>c,$=>this.j.error($))})}};p=ve([X(0,d.$qi),X(1,m.$Oj)],p);function u(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const l of g.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(le[235],he([0,1,143,7,30,49]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function P(C,v,m){const f=await(0,R.$JD)("@microsoft/1ds-core-js","dist/ms.core.js"),h=await(0,R.$JD)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new f.AppInsightsCore,p=new h.PostChannel,u={instrumentationKey:C,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(m){u.extensionConfig={};const g={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};u.extensionConfig[p.identifier]=g}return b.initialize(u,[]),b.addTelemetryInitializer(g=>{g.ext=g.ext??{},g.ext.web=g.ext.web??{},g.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),b}class d{constructor(v,m,f,h,b){this.e=v,this.f=m,this.g=f,this.h=b,this.c=D,this.d=I,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(m=>{v(m)},m=>{(0,N.$1)(m),console.error(m)})}}log(v,m){if(!this.a)return;m=(0,A.$Rn)(m,this.g),m=(0,j.$bp)(m);const f=this.f+"/"+v;try{this.i(h=>{h.pluginVersionString=m?.properties.version??"Unknown",h.track({name:f,baseData:{name:f,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$WP=d}),define(le[109],he([0,1,2,172,16,9,24,49]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=void 0;let P=class extends R.$Uc{constructor(C,v,m,f,h=""){super(),this.b=h;const b=v.getLogger(I.$8o);if(b)this.a=this.B(b);else{const u=(0,I.$_o)(f,m)?" (Not Sent)":"",g=()=>(0,I.$$o)(f,m)&&C.getLevel()===j.LogLevel.Trace;this.a=this.B(v.createLogger(I.$8o,{name:(0,N.localize)(0,null,u),hidden:!g()})),this.B(C.onDidChangeLogLevel(()=>v.setVisibility(I.$8o,g()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,v){this.a.trace(`${this.b}telemetry/${C}`,(0,I.$bp)(v))}};e.$H$b=P,e.$H$b=P=ve([X(0,j.$Oj),X(1,j.$Pj),X(2,A.$pi),X(3,D.$8j)],P)}),define(le[110],he([0,1,2,30,5,27,173,21,47,100,24,42,22,49]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,g,l){this.k=g,this.l=l,this.d={},this.i=new R.$Tc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,j.$Ze)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Ze)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(m.$Vl)||c.affectsConfiguration(m.$Xl)||c.affectsConfiguration(m.$Wl))&&this.m()}))}setExperimentProperty(u,g){this.d[u]=g}m(){let u=(0,f.$ap)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const l=g.usage?3:g.error?2:0;u=Math.min(u,l)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,g,l){this.g<g||(l=(0,N.$Rn)(l,this.d),l=(0,f.$fp)(l,this.j),l=(0,N.$Rn)(l,this.c),this.b.forEach(c=>c.log(u,l)))}publicLog(u,g){this.n(u,3,g)}publicLog2(u,g){this.publicLog(u,g)}publicLogError(u,g){this.h&&this.n(u,2,g)}publicLogError2(u,g){this.publicLogError(u,g)}};e.$Jr=h,e.$Jr=h=ve([X(1,I.$Oi),X(2,C.$8j)],h);function b(){const p=(0,D.localize)(0,null,d.default.nameLong),u=d.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=A.$o?"":(0,D.localize)(3,null),l=(0,D.localize)(4,null),c=(0,D.localize)(5,null),$=(0,D.localize)(6,null),i=(0,D.localize)(7,null),o=`
|       | ${l} | ${c} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,D.localize)(8,null);return`
${p} ${u} ${g}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}v.$1n.as(P.$6n.Configuration).registerConfiguration({id:m.$Ul,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[m.$Vl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$1n.as(P.$6n.Configuration).registerConfiguration({id:m.$Ul,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[m.$Xl]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,D.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,D.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${m.$Vl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[236],he([0,1,15,26,278,235]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=void 0;async function D(C,v){const m=await v.request(C,N.CancellationToken.None),f=(await(0,R.$Ge)(m.stream)).toString(),h=m.res.statusCode??200;return{headers:m.res.headers,statusCode:h,responseData:f}}async function I(C){const v={method:C.type,headers:C.headers};return new Promise((f,h)=>{const b=A.request(C.url??"",v,p=>{p.on("data",function(u){f({headers:p.headers,statusCode:p.statusCode??200,responseData:u.toString()})}),p.on("error",function(u){h(u)})});b.write(C.data,p=>{p&&h(p)}),b.end()})}async function P(C,v,m){const f=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),h={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:f};try{const b=C?await D(h,C):await I(h);m(b.statusCode,b.headers,b.responseData)}catch{m(0,{})}}class d extends j.$WP{constructor(v,m,f,h,b){const p={sendPOST:(u,g)=>{P(v,u,g)}};super(m,f,h,b,p)}}e.$XP=d}),define(le[237],he([0,1,23,92,21,16,9,24,22,108,109,110]),function(se,e,R,N,A,j,D,I,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;let m=class{constructor(h,b,p,u,g,l){this.b=h,this.c=b,this.d=p,this.e=u,this.f=g,this.g=l,this.a=new Map}h(h){if(!this.a.has(h.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const p=[h.id,JSON.stringify(b),h.aiKey],g=new N.$Kq(R.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:p,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new d.$kbc(g),new C.$H$b(this.d,this.e,this.f,this.g,`[${h.id}] `)];this.a.set(h.id,new v.$Jr({appenders:l,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.g))}return this.a.get(h.id)}publicLog(h,b,p){this.h(h).publicLog(b,p)}publicLogError(h,b,p){this.h(h).publicLogError(b,p)}};e.$Ecc=m,e.$Ecc=m=ve([X(0,A.$Oi),X(1,P.$Nl),X(2,D.$Oj),X(3,D.$Pj),X(4,j.$pi),X(5,I.$8j)],m)}),define(le[78],he([0,1,3,8,21,4,9]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$4v=e.$2v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xv=e.$Wv=void 0,e.$Yv=d,e.$Zv=v,e.$1v=m,e.$3v=f,e.$5v=h,e.$6v=b,e.$Wv=(0,j.$ii)("tunnelService"),e.$Xv=(0,j.$ii)("sharedTunnelsService");var I;(function(g){g.Http="http",g.Https="https"})(I||(e.TunnelProtocol=I={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(g){return!!g.forwardPort}var C;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(C||(e.ProvidedOnAutoForward=C={}));function v(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(l)return{address:l[1],port:+l[2]}}function m(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const l=g.query.split("&");for(const c of l){const $=c.split("=")[1];if(/^https?:/.exec($)){const i=v(N.URI.parse($));if(i)return i}}}e.$2v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f(g){return e.$2v.indexOf(g)>=0}e.$4v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function h(g){return e.$4v.indexOf(g)>=0}function b(g,l,c,$){if(c===1)return!1;if(c===2&&h(l)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(i?.length===4&&parseInt(i[1])>=18)return!1}return g<1024}class p{constructor(l,c,$){this.remoteAddress=l,this.localAddress=c,this.b=$,this.a=new R.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$7v=p;let u=class{constructor(l,c){this.k=l,this.l=c,this.a=new R.$7d,this.onTunnelOpened=this.a.event,this.b=new R.$7d,this.onTunnelClosed=this.b.event,this.c=new R.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],c=Array.from(this.e.values());for(const $ of c){const i=Array.from($.values());for(const o of i){const n=await o.value;n&&typeof n!="string"&&l.push(n)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:c}of l.values())await c.then($=>typeof $!="string"?$?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,c,$,i,o){this.q(l,c,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:c,localAddress:$,privacy:i,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,c){(h(l)||f(l))&&(l=e.$2v[0]);const $=this.s(l,c);if($)return++$.refcount,$.value}openTunnel(l,c,$,i,o,n=!1,s,t){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${$} on local port ${o}.`);const r=this.f??l;if(!r)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(r,c,$,i,o,n,s,t);return a?a.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,$),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&y.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const c=this.e.get(l.tunnelRemoteHost);if(c){const $=c.get(l.tunnelRemotePort);$&&($.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,$))}}}}async p(l,c,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${c}.`);const i=$.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(c),i}}async closeTunnel(l,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${c} `);const $=this.e.get(l);if($&&$.has(c)){const i=$.get(c);i.refcount=0,await this.p(l,c,i)}}q(l,c,$){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(c,{refcount:1,value:$})}async r(l,c){const $=this.e.get(l);if($){const i=$.get(c),o=i?await i.value:void 0;(!o||typeof o=="string")&&$.delete(c),$.size===0&&this.e.delete(l)}}s(l,c){const $=[l];f(l)?($.push(...e.$2v),$.push(...e.$4v)):h(l)&&$.push(...e.$4v);const i=$.map(o=>this.e.get(o));for(const o of i){const n=o?.get(c);if(n)return n}}canTunnel(l){return!!v(l)}u(l,c,$,i,o,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${$} on local port ${i}.`);const t=$;this.j.add(t);const r=i===void 0?$:i,a={elevationRequired:o?this.isPortPrivileged(r):!1},y={remoteAddress:{host:c,port:$},localAddressPort:i,privacy:n,public:n?n!==P.Private:void 0,protocol:s},E=l.forwardPort(y,a);return E?(this.q(c,$,E),E.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(t)})):this.j.delete(t),E}};e.$8v=u,e.$8v=u=ve([X(0,D.$Oj),X(1,A.$Oi)],u)}),define(le[238],he([0,1,9,78,2,7,6]),function(se,e,R,N,A,j,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;class P extends A.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new D.$Fh),this.b.p)}setAddress(v){this.a=v,this.b&&(this.b.complete(v),this.b=null)}setTunnel(v){this.B(v)}}let d=class extends A.$Uc{static{I=this}static{this.a=0}constructor(v,m){super(),this.f=v,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(v=>v.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(v,m,f,h,b,p,u){const g=new P,l=await Promise.resolve(this.f.openTunnel(v,g,f,h,b,p,u));if(!l||typeof l=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${h} (remote).`),g.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),g.dispose(),await l.dispose(),(0,j.$6)();return g.setTunnel(l),this.b.set(m,g),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${l.localAddress} (local) to ${f}:${h} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(v,m){const f=this.b.get(v);f&&f.setAddress(m)}async destroyTunnel(v){const m=this.b.get(v);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${v}.`),this.b.delete(v),await m.dispose();return}this.c.add(v)}};e.$Occ=d,e.$Occ=d=I=ve([X(0,N.$Xv),X(1,R.$Oj)],d)}),define(le[28],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,R.$ii)("IUriIdentityService")}),define(le[239],he([0,1,28,191,12,20,128,3,2]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class d{static{this._clock=0}constructor(m){this.uri=m,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let C=class{constructor(m){this.g=m,this.c=new P.$Tc,this.f=2**16;const f=new Map,h=b=>{let p=f.get(b.scheme);return p===void 0&&(p=m.hasProvider(b)&&!this.g.hasCapability(b,1024),f.set(b.scheme,p)),p};this.c.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new j.$Kg(h),this.d=new D.$is((b,p)=>this.extUri.compare(b,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,j.$Wg)(m));const f=this.d.get(m);return f?f.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new d(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((h,b)=>h[1].time<b[1].time?1:h[1].time>b[1].time?-1:0);d._clock=0,this.d.clear();const f=this.f*.5;for(let h=0;h<f;h++)this.d.set(m[h][0],m[h][1].touch())}};e.$js=C,e.$js=C=ve([X(0,A.$Ok)],C),(0,N.$gs)(R.$ml,C,1)}),define(le[240],he([0,1,3,2,12,51,35]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;class I extends N.$Uc{constructor(d,C,v,m,f,h){super(),this.f=d,this.g=C,this.h=v,this.j=m,this.m=f,this.n=h,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$7d),this.onDidChangeFile=this.a.event,this.b=j.$oi.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Cc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,C){return this.g.open(this.t(d),C)}close(d){return this.g.close(d)}read(d,C,v,m,f){return this.g.read(d,C,v,m,f)}write(d,C,v,m,f){return this.g.write(d,C,v,m,f)}watch(d,C){this.b.set(d,d);const v=this.g.watch(this.t(d),C);return(0,N.$Sc)(()=>{this.b.delete(d),v.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,C,v){return this.g.rename(this.t(d),this.t(C),v)}readFile(d,C){return this.g.readFile(this.t(d),C)}readFileStream(d,C,v){return this.g.readFileStream(this.t(d),C,v)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,C,v){return this.g.writeFile(this.t(d),C,v)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,C){return this.g.delete(this.t(d),C)}copy(d,C,v){if((0,A.$Sk)(this.g))return this.g.copy(this.t(d),this.t(C),v);throw new Error("copy not supported")}cloneFile(d,C){if((0,A.$Tk)(this.g))return this.g.cloneFile(this.t(d),this.t(C));throw new Error("clone not supported")}s(d){const C=[];for(const v of d){if(v.resource.scheme!==this.f)continue;const m=this.u(v.resource);this.b.findSubstr(m)&&C.push({resource:m,type:v.type,cId:v.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$0bc=I}),define(le[79],he([0,1,62]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$ZIb=A,e.$1Ib=j;function N(D,I,P,d){const C=(0,R.$Kn)(D,I,P,d)[0];return C&&(D=D.substring(0,C.offset)+C.content+D.substring(C.offset+C.length)),D}function A(D,I,P){let d=P;for(;d>=0;){if(D.charAt(d)===I.charAt(I.length-1)&&I.length===1)return d+1;if(d--,I.length===2&&d>=0&&D.charAt(d)===I.charAt(0))return d+2}return 0}function j(D,I,P){let d=P;for(;d>=0;)if(D.charAt(d)===I.charAt(I.length-1)&&I.length===1||(d++,I.length===2&&d>=0&&D.charAt(d)===I.charAt(1)))return d;return D.length-1}}),define(le[241],he([0,1,30,55,13]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l0b=j;function j(f,h,b,p,u,g){const l=[],c=[],$=[];if(!h){const U=f.filter(({identifier:_})=>u.every(G=>G.toLowerCase()!==_.id.toLowerCase()));return{local:{added:l,removed:c,updated:$},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}f=f.map(v),h=h.map(v),b=b?b.map(v):null;const i=new Map,o=U=>{U.uuid&&i.set(U.id.toLowerCase(),U.uuid)};f.forEach(({identifier:U})=>o(U)),h.forEach(({identifier:U})=>o(U)),b?.forEach(({identifier:U})=>o(U)),p?.forEach(({identifier:U})=>o(U)),g?.forEach(U=>o(U));const n=U=>{const _=U.identifier.uuid||i.get(U.identifier.id.toLowerCase());return _?`uuid:${_}`:`id:${U.identifier.id.toLowerCase()}`},s=(U,_)=>(U.set(n(_),_),U),t=f.reduce(s,new Map),r=h.reduce(s,new Map),a=h.reduce((U,_)=>s(U,(0,R.$On)(_)),new Map),y=b?b.reduce(s,new Map):null,E=p.reduce(s,new Map),k=u.reduce((U,_)=>{const G=i.get(_.toLowerCase());return U.add(G?`uuid:${G}`:`id:${_.toLowerCase()}`)},new Set),S=g?g.reduce((U,{id:_,uuid:G})=>(G=G??i.get(_.toLowerCase()),U.add(G?`uuid:${G}`:`id:${_.toLowerCase()}`)),new Set):null,w=D(t,r,k,!1);if(w.added.size>0||w.removed.size>0||w.updated.size>0){const U=D(y,t,k,!1),_=D(y,r,k,!0),G=(Z,V,K,W)=>{let B,ie,ae;return V.installed?(B=W.pinned,ae=W.preRelease,B&&(ie=W.version)):(B=K.pinned,ae=K.preRelease,B&&(ie=K.version)),B===void 0&&(B=V.pinned,B&&(ie=V.version)),ae===void 0&&(ae=V.preRelease),{...W,installed:V.installed||K.installed,pinned:B,preRelease:ae,version:ie??(K.version&&(!V.installed||N.gt(K.version,V.version))?K.version:V.version),state:P(V,K,y?.get(Z))}};for(const Z of _.removed.values()){const V=t.get(Z);if(!V)continue;const K=(0,A.$7f)(y?.get(Z)),W=S&&!S.has(Z)&&K.installed;V.installed&&W?c.push(V.identifier):a.set(Z,V)}for(const Z of _.added.values()){const V=(0,A.$7f)(r.get(Z)),K=t.get(Z);if(K){if(w.updated.has(Z)){const W=G(Z,K,V,V);I(K,V,!1,!1)||$.push(m(W,Z)),a.set(Z,W)}}else V.installed&&l.push(m(V,Z))}for(const Z of _.updated.values()){const V=(0,A.$7f)(r.get(Z)),K=(0,A.$7f)(y?.get(Z)),W=t.get(Z);if(W)if(S&&!S.has(Z)&&K.installed&&W.installed&&!V.installed)c.push(W.identifier);else{const ie=G(Z,W,V,V);$.push(m(ie,Z)),a.set(Z,ie)}else V.installed&&l.push(m(V,Z))}for(const Z of U.added.values())_.added.has(Z)||a.set(Z,(0,A.$7f)(t.get(Z)));for(const Z of U.updated.values()){if(_.removed.has(Z)||_.updated.has(Z))continue;const V=(0,A.$7f)(t.get(Z)),K=(0,A.$7f)(r.get(Z));a.set(Z,G(Z,V,K,V))}for(const Z of U.removed.values())_.updated.has(Z)||_.removed.has(Z)||E.has(Z)||(0,A.$7f)(r.get(Z)).installed&&S&&(S.has(Z)||!(0,A.$7f)(y?.get(Z)).installed||a.delete(Z))}const O=[],M=D(r,a,new Set,!0),T=M.added.size>0||M.updated.size>0||M.removed.size>0;return T&&a.forEach((U,_)=>O.push(m(U,_))),{local:{added:l,removed:c,updated:$},remote:T?{added:[...M.added].map(U=>a.get(U)),updated:[...M.updated].map(U=>a.get(U)),removed:[...M.removed].map(U=>r.get(U)),all:O}:null}}function D(f,h,b,p){const u=f?[...f.keys()].filter(i=>!b.has(i)):[],g=[...h.keys()].filter(i=>!b.has(i)),l=g.filter(i=>!u.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=u.filter(i=>!g.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),$=new Set;for(const i of u){if(c.has(i))continue;const o=f.get(i),n=h.get(i);(!n||!I(o,n,p,!0))&&$.add(i)}return{added:l,removed:c,updated:$}}function I(f,h,b,p){return!(f.disabled!==h.disabled||!!f.isApplicationScoped!=!!h.isApplicationScoped||p&&f.installed!==h.installed||f.installed&&h.installed&&(f.preRelease!==h.preRelease||f.pinned!==h.pinned||h.pinned&&f.version!==h.version)||!C(f.state,h.state)||b&&f.version!==h.version)}function P(f,h,b){const p=f.state,u=h.state,g=b?.state;if(!h.version||p&&N.gt(f.version,h.version))return p;if(u&&N.gt(h.version,f.version)||!p)return u;if(!u)return p;const l=(0,R.$On)(p),c=g?d(g,u):{added:Object.keys(u).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},$=g?d(g,p):{added:Object.keys(p).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])l[i]=u[i];for(const i of c.removed.values())$.updated.has(i)||delete l[i];return l}function d(f,h){const b=Object.keys(f),p=Object.keys(h),u=p.filter(c=>!b.includes(c)).reduce((c,$)=>(c.add($),c),new Set),g=b.filter(c=>!p.includes(c)).reduce((c,$)=>(c.add($),c),new Set),l=new Set;for(const c of b){if(g.has(c))continue;const $=f[c],i=h[c];(0,R.$Sn)($,i)||l.add(c)}return{added:u,removed:g,updated:l}}function C(f={},h={}){const{added:b,removed:p,updated:u}=d(f,h);return b.size===0&&p.size===0&&u.size===0}function v(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function m(f,h){const b={...f,identifier:{id:f.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled||delete b.disabled,f.installed||delete b.installed,f.state||delete b.state,f.isApplicationScoped||delete b.isApplicationScoped,b}}),define(le[111],he([0,1,17,21,4]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Kb=e.$7Kb=void 0,e.$7Kb=(0,A.$ii)("IIgnoredExtensionsManagementService");let j=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,P){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return d=d.filter(C=>C!==I&&C!==`-${I}`),P&&d.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(I,P){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return d=d.filter(C=>C!==I&&C!==`-${I}`),P&&d.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(I){const P=I.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),d=this.b().map(m=>m.toLowerCase()),C=[],v=[];if(Array.isArray(d))for(const m of d)m.startsWith("-")?v.push(m.substring(1)):C.push(m);return(0,R.$Mb)([...P,...C].filter(m=>!v.includes(m)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.$8Kb=j,e.$8Kb=j=ve([X(0,N.$Oi)],j)}),define(le[242],he([0,1,17,34,30,93,79]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r0b=P;function I(c){return(0,N.$vn)(c)||[]}async function P(c,$,i,o,n){const s=I(c),t=I($),r=i?I(i):null,a=[...s,...t,...r||[]].map(G=>G.key),y=await n.resolveUserBindings(a),E=C(s,t,r,y);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const k=m(s),S=m(t),w=r?m(r):null,O=h(k,S,y),M=w?h(w,k,y):{added:[...k.keys()].reduce((G,Z)=>(G.add(Z),G),new Set),removed:new Set,updated:new Set},T=w?h(w,S,y):{added:[...S.keys()].reduce((G,Z)=>(G.add(Z),G),new Set),removed:new Set,updated:new Set},U=d(O,M,T);let _=c;for(const G of U.removed.values())U.conflicts.has(G)||(_=g(_,G,o));for(const G of U.added.values()){if(U.conflicts.has(G))continue;const Z=S.get(G);if(Z.some(V=>V.command!==`-${G}`&&E.conflicts.has(y[V.key]))){U.conflicts.add(G);continue}_=u(_,Z,o)}for(const G of U.updated.values()){if(U.conflicts.has(G))continue;const Z=S.get(G);if(Z.some(V=>V.command!==`-${G}`&&E.conflicts.has(y[V.key]))){U.conflicts.add(G);continue}_=l(_,G,Z,o)}return{mergeContent:_,hasChanges:!0,hasConflicts:U.conflicts.size>0}}function d(c,$,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of $.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||($.updated.has(r)?t.add(r):n.add(r));for(const r of $.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||($.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of $.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||($.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function C(c,$,i,o){const n=new Set,s=v(c,o),t=v($,o),r=i?v(i,o):null,a=f(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const y=r?f(r,s):{added:[...s.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const E=r?f(r,t):{added:[...t.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:k,removed:S,updated:w,conflicts:O}=d(a,y,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:k,removed:S,updated:w,conflicts:O}}function v(c,$){const i=new Map;for(const o of c){const n=$[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function m(c){const $=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=$.get(o);n||(n=[],$.set(o,n)),n.push(i)}return $}function f(c,$){const i=[...c.keys()],o=[...$.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(E=>({...E,key:r})),y=$.get(r).map(E=>({...E,key:r}));(0,R.$ub)(a,y,(E,k)=>p(E,k))||t.add(r)}return{added:n,removed:s,updated:t}}function h(c,$,i){const o=[...c.keys()],n=[...$.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const y=c.get(a).map(k=>({...k,key:i[k.key]})),E=$.get(a).map(k=>({...k,key:i[k.key]}));b(y,E)||r.add(a)}return{added:s,removed:t,updated:r}}function b(c,$){return!(!(0,R.$ub)(c.filter(({command:i})=>i[0]!=="-"),$.filter(({command:i})=>i[0]!=="-"),(i,o)=>p(i,o))||!(0,R.$ub)(c.filter(({command:i})=>i[0]==="-"),$.filter(({command:i})=>i[0]==="-"),(i,o)=>p(i,o)))}function p(c,$){if(c.command!==$.command||c.key!==$.key)return!1;const i=j.$gj.deserialize(c.when),o=j.$gj.deserialize($.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!A.$Sn(c.args,$.args))}function u(c,$,i){for(const o of $)c=D.edit(c,[-1],o,i);return c}function g(c,$,i){const o=I(c);for(let n=o.length-1;n>=0;n--)(o[n].command===$||o[n].command===`-${$}`)&&(c=D.edit(c,[n],void 0,i));return c}function l(c,$,i,o){const n=I(c),s=n.findIndex(t=>t.command===$||t.command===`-${$}`);for(let t=n.length-1;t>=0;t--)(n[t].command===$||n[t].command===`-${$}`)&&(c=D.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=D.edit(c,[s],i[t],o);return c}}),define(le[243],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y0b=R,e.$z0b=A;function R(j,D,I){const P={},d={},C=new Set;if(!D)return{local:{added:P,updated:d,removed:[...C.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const v=N(j,D);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{local:{added:P,updated:d,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=N(I,j),f=N(I,D),h={},b={},p=new Set,u=new Set;for(const g of m.removed.values())f.updated.has(g)?P[g]=D[g]:p.add(g);for(const g of f.removed.values())u.has(g)||(m.updated.has(g)?u.add(g):C.add(g));for(const g of m.updated.values())u.has(g)||(f.updated.has(g)?v.updated.has(g)&&u.add(g):b[g]=j[g]);for(const g of f.updated.values())u.has(g)||(m.updated.has(g)?v.updated.has(g)&&u.add(g):j[g]!==void 0&&(d[g]=D[g]));for(const g of m.added.values())u.has(g)||(f.added.has(g)?v.updated.has(g)&&u.add(g):h[g]=j[g]);for(const g of f.added.values())u.has(g)||(m.added.has(g)?v.updated.has(g)&&u.add(g):P[g]=D[g]);return{local:{added:P,removed:[...C.values()],updated:d},remote:{added:h,removed:[...p.values()],updated:b},conflicts:[...u.values()]}}function N(j,D){const I=j?Object.keys(j):[],P=D?Object.keys(D):[],d=P.filter(m=>!I.includes(m)).reduce((m,f)=>(m.add(f),m),new Set),C=I.filter(m=>!P.includes(m)).reduce((m,f)=>(m.add(f),m),new Set),v=new Set;for(const m of I){if(C.has(m))continue;const f=j[m],h=D[m];f!==h&&v.add(m)}return{added:d,removed:C,updated:v}}function A(j,D){const{added:I,removed:P,updated:d}=N(j,D);return I.size===0&&P.size===0&&d.size===0}}),define(le[244],he([0,1,30]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=N;function N(j,D,I,P){const d={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!D){const m=j.filter(({id:f})=>!P.includes(f));return m.length?C.added=m:C=null,{local:d,remote:C}}const v=A(j,D,P);if(v.added.length>0||v.removed.length>0||v.updated.length>0){const m=A(I,j,P),f=A(I,D,P);for(const h of f.removed){const b=j.find(p=>p.id===h);b&&d.removed.push(b)}for(const h of f.added){const b=D.find(p=>p.id===h);m.added.includes(h)?v.updated.includes(h)&&d.updated.push(b):d.added.push(b)}for(const h of f.updated)d.updated.push(D.find(b=>b.id===h));for(const h of m.added)f.added.includes(h)||C.added.push(j.find(b=>b.id===h));for(const h of m.updated)f.removed.includes(h)||f.updated.includes(h)||C.updated.push(j.find(b=>b.id===h));for(const h of m.removed){const b=D.find(p=>p.id===h);b&&C.removed.push(b)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:d,remote:C}}function A(j,D,I){j=j?j.filter(({id:f})=>!I.includes(f)):[],D=D.filter(({id:f})=>!I.includes(f));const P=j.map(({id:f})=>f),d=D.map(({id:f})=>f),C=d.filter(f=>!P.includes(f)),v=P.filter(f=>!d.includes(f)),m=[];for(const{id:f,name:h,shortName:b,icon:p,useDefaultFlags:u}of j){if(v.includes(f))continue;const g=D.find(l=>l.id===f);(!g||g.name!==h||g.shortName!==b||g.icon!==p||!(0,R.$Sn)(g.useDefaultFlags,u))&&m.push(f)}return{added:C,removed:v,updated:m}}}),define(le[25],he([0,1,17,13,179,47,29,4,101,42]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpb=e.$Lpb=e.$Kpb=e.$Jpb=e.$Ipb=e.$Hpb=e.$Gpb=e.$Fpb=e.$Epb=e.$Cpb=e.MergeState=e.Change=e.SyncStatus=e.$Bpb=e.$Apb=e.$zpb=e.UserDataSyncErrorCode=e.$xpb=e.$wpb=e.$vpb=e.$upb=e.$tpb=e.$qpb=e.SyncResource=e.$npb=e.$mpb=void 0,e.$kpb=C,e.$lpb=v,e.$opb=m,e.$ppb=f,e.$rpb=b,e.$spb=p,e.$ypb=u,e.$Dpb=s;function C(){const t=d.$1n.as(j.$6n.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}function v(){const t=d.$1n.as(j.$6n.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(E=>!!t[E].ignoreSync),a=Object.keys(t).filter(E=>t[E].scope===2||t[E].scope===6),y=C();return(0,R.$Mb)([...r,...a,...y])}e.$mpb="settingsSync",e.$npb="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=d.$1n.as(j.$6n.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$npb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:D.$Fo,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=d.$1n.as(P.$2n.JSONContribution),y=()=>{const E=C(),k=v(),S=Object.keys(j.$7n.properties).filter(M=>!k.includes(M)),w=k.filter(M=>!E.includes(M)),O={items:{type:"string",enum:[...S,...w.map(M=>`-${M}`)]}};a.registerSchema(t,O)};return r.onDidUpdateConfiguration(()=>y())}function f(t){return t&&(0,N.$Xf)(t)&&(0,N.$Vf)(t.id)&&Array.isArray(t.scopes)}var h;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(h||(e.SyncResource=h={})),e.$qpb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(t,...r){return t?[t,...r]:r}function p(t,r,a,y){return y.joinPath(a.userDataSyncHome,...b(t,r,`lastSync${r}.json`))}e.$tpb=(0,I.$ii)("IUserDataSyncStoreManagementService"),e.$upb=(0,I.$ii)("IUserDataSyncStoreService"),e.$vpb=(0,I.$ii)("IUserDataSyncLocalStoreService"),e.$wpb="x-operation-id",e.$xpb="X-Execution-Id";function u(t){const r={};return r[e.$xpb]=t,r}var g;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(g||(e.UserDataSyncErrorCode=g={}));class l extends Error{constructor(r,a,y,E){super(r),this.code=a,this.resource=y,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$zpb=l;class c extends l{constructor(r,a,y,E,k){super(r,y,void 0,k),this.url=a,this.serverCode=E}}e.$Apb=c;class $ extends l{constructor(r,a){super(r,a)}}e.$Bpb=$,function(t){function r(a){if(a instanceof t)return a;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(y&&y[1]){const E=y[2]==="unknown"?void 0:y[2],k=y[3]==="unknown"?void 0:y[3];return new t(a.message,y[1],E,k)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(l||(e.$zpb=l={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Cpb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Epb=(0,I.$ii)("IUserDataSyncEnablementService"),e.$Fpb=(0,I.$ii)("IUserDataSyncService"),e.$Gpb=(0,I.$ii)("IUserDataSyncResourceProviderService"),e.$Hpb=(0,I.$ii)("IUserDataAutoSyncService"),e.$Ipb=(0,I.$ii)("IUserDataSyncUtilService"),e.$Jpb=(0,I.$ii)("IUserDataSyncLogService"),e.$Kpb="userDataSync",e.$Lpb="vscode-userdata-sync",e.$Mpb="preview"}),define(le[245],he([0,1,30,25]),function(se,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nKb=A;function A(D,I,P,d,C){if(!I)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const v=j(D,I);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=P?j(P,I):{added:Object.keys(I).reduce((g,l)=>(g.add(l),g),new Set),removed:new Set,updated:new Set},f=P?j(P,D):{added:Object.keys(D).reduce((g,l)=>(g.add(l),g),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},b=R.$On(I),p=!P;for(const g of f.added.values())g!==N.$Cpb&&p&&m.added.has(g)||(b[g]=D[g]);for(const g of f.updated.values())b[g]=D[g];for(const g of f.removed.values())d.unregistered.includes(g)||delete b[g];for(const g of m.added.values()){const l=I[g];if(d.machine.includes(g)){C.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(P&&f.added.has(g))continue;const c=D[g];c&&c.value===l.value||g===N.$Cpb&&p&&f.added.has(g)||(c?h.updated[g]=l:h.added[g]=l)}for(const g of m.updated.values()){const l=I[g];if(d.machine.includes(g)){C.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(g)||f.removed.has(g))continue;const c=D[g];c&&c.value===l.value||(h.updated[g]=l)}for(const g of m.removed.values()){if(d.machine.includes(g)){C.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}f.updated.has(g)||f.removed.has(g)||h.removed.push(g)}const u=j(I,b);return{local:h,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:b}}}function j(D,I){const P=Object.keys(D),d=Object.keys(I),C=d.filter(f=>!P.includes(f)).reduce((f,h)=>(f.add(h),f),new Set),v=P.filter(f=>!d.includes(f)).reduce((f,h)=>(f.add(h),f),new Set),m=new Set;for(const f of P){if(v.has(f))continue;const h=D[f],b=I[f];R.$Sn(h,b)||m.add(f)}return{added:C,removed:v,updated:m}}}),define(le[246],he([0,1,17,34,62,43,30,79,25]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Ib=d,e.$3Ib=m,e.$4Ib=f,e.$5Ib=h,e.$6Ib=p,e.$7Ib=g;function d(a,y,E){let k=[];E?k=v(E):k=C(y);const S=[],w=[...(0,P.$kpb)()];if(Array.isArray(k))for(const O of k)O.startsWith("-")?w.push(O.substring(1)):S.push(O);return(0,R.$Mb)([...a,...S].filter(O=>!w.includes(O)))}function C(a){let y=a.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=a.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:a.getValue("settingsSync.ignoredSettings")||[]}function v(a){const y=(0,N.$vn)(a);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function m(a,y){const E=(0,N.$vn)(a)||{};let k="{}";for(const S of Object.keys(E)){const w=(0,A.$Kn)(k,[S],E[S],y);k=(0,A.$Nn)(k,w)}return k}function f(a,y,E,k){if(E.length){const S=r(y),w=(0,N.$vn)(y)||{},O=(0,N.$vn)(a);if(!O)return a;const M=[];for(const T of E){const U=w[T],_=O[T];U===void 0?a=I.edit(a,[T],void 0,k):_!==void 0?a=I.edit(a,[T],U,k):M.push(i(T,S))}M.sort((T,U)=>T.startOffset-U.startOffset),M.forEach(T=>a=g(T.setting.key,y,a,k))}return a}function h(a,y,E,k,S,w){const O=f(a,y,k,w),M=E!==O,T=E!==y;if(!M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(T&&!M)return{conflictsSettings:[],localContent:f(y,a,k,w),remoteContent:null,hasConflicts:!1};if(E===null&&p(a)){const F=b(a,y,k)?null:f(y,a,k,w);return{conflictsSettings:[],localContent:F,remoteContent:null,hasConflicts:!1}}let U=a,_=y;const G=(0,N.$vn)(a),Z=(0,N.$vn)(y),V=E?(0,N.$vn)(E):null,K=k.reduce((F,z)=>(F.add(z),F),new Set),W=u(G,Z,K),B=u(V,G,K),ie=u(V,Z,K),ae=new Map,te=new Set,ce=F=>{te.add(F);const z=S.filter(({key:Y})=>Y===F)[0];z?(U=I.edit(U,[F],z.value,w),_=I.edit(_,[F],z.value,w)):ae.set(F,{key:F,localValue:G[F],remoteValue:Z[F]})};for(const F of B.removed.values())ie.updated.has(F)?ce(F):_=I.edit(_,[F],void 0,w);for(const F of ie.removed.values())te.has(F)||(B.updated.has(F)?ce(F):U=I.edit(U,[F],void 0,w));for(const F of B.updated.values())te.has(F)||(ie.updated.has(F)?W.updated.has(F)&&ce(F):_=I.edit(_,[F],G[F],w));for(const F of ie.updated.values())te.has(F)||(B.updated.has(F)?W.updated.has(F)&&ce(F):U=I.edit(U,[F],Z[F],w));for(const F of B.added.values())te.has(F)||(ie.added.has(F)?W.updated.has(F)&&ce(F):_=g(F,U,_,w));for(const F of ie.added.values())te.has(F)||(B.added.has(F)?W.updated.has(F)&&ce(F):U=g(F,_,U,w));const H=ae.size>0||!b(U,_,k),q=H||!b(U,a,[]),L=H||!b(_,y,[]);return{localContent:q?U:null,remoteContent:L?_:null,conflictsSettings:[...ae.values()],hasConflicts:H}}function b(a,y,E){if(a===y)return!0;const k=(0,N.$vn)(a),S=(0,N.$vn)(y),w=E.reduce((T,U)=>(T.add(U),T),new Set),O=r(a).filter(T=>!(T.setting&&w.has(T.setting.key))),M=r(y).filter(T=>!(T.setting&&w.has(T.setting.key)));if(O.length!==M.length)return!1;for(let T=0;T<O.length;T++){const U=O[T],_=M[T];if(U.setting&&_.setting){if(U.setting.key!==_.setting.key||!D.$Sn(k[U.setting.key],S[U.setting.key]))return!1}else if(!U.setting&&!_.setting){if(U.value!==_.value)return!1}else return!1}return!0}function p(a){return a?r(a).length===0:!0}function u(a,y,E){const k=a?Object.keys(a).filter(T=>!E.has(T)):[],S=Object.keys(y).filter(T=>!E.has(T)),w=S.filter(T=>!k.includes(T)).reduce((T,U)=>(T.add(U),T),new Set),O=k.filter(T=>!S.includes(T)).reduce((T,U)=>(T.add(U),T),new Set),M=new Set;if(a)for(const T of k){if(O.has(T))continue;const U=a[T],_=y[T];D.$Sn(U,_)||M.add(T)}return{added:w,removed:O,updated:M}}function g(a,y,E,k){const S=(0,N.$vn)(y),w=r(y),O=r(E),M=l(a,w,O);return c(E,a,S[a],M,O,k)}function l(a,y,E){const k=y.findIndex(w=>w.setting?.key===a),S=y[k-1];if(S){if(S.setting){const O=i(S.setting.key,E);if(O)return{index:E.indexOf(O),insertAfter:!0}}else{const O=o(k,y);if(O){const M=i(O.setting.key,E);if(M){const T=n(E.indexOf(M),E),U=s(y,O,y[k]);if(T){const _=s(E,M,T),G=t(U,_);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.indexOf(T),insertAfter:!1}}else{const _=s(E,M,E[E.length-1]),G=t(U,_);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.length-1,insertAfter:!0}}}}}const w=y[k+1];if(w)if(w.setting){const O=i(w.setting.key,E);if(O)return{index:E.indexOf(O),insertAfter:!1}}else{const O=n(k,y);if(O){const M=i(O.setting.key,E);if(M){const T=o(E.indexOf(M),E),U=s(y,y[k],O);if(T){const _=s(E,T,M),G=t(U.reverse(),_.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:E.indexOf(T),insertAfter:!0}}else{const _=s(E,E[0],M),G=t(U.reverse(),_.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:E.length-1,insertAfter:!0}}function c(a,y,E,k,S,w){let O;return k.index===-1?O=(0,A.$Kn)(a,[y],E,w):O=$(a,y,E,k,S,w).map(M=>(0,A.$Ln)(a,M,w)[0]),(0,A.$Nn)(a,O)}function $(a,y,E,k,S,w){const O=`${JSON.stringify(y)}: ${JSON.stringify(E)}`,M=(0,j.$Hn)(w,a),T=S[k.index];if(k.insertAfter){const U=[];if(T.setting)U.push({offset:T.endOffset,length:0,content:","+O});else{const _=n(k.index,S),G=o(k.index,S),Z=G?.setting?.commaOffset;G&&Z===void 0&&U.push({offset:G.endOffset,length:0,content:","});const V=Z!==void 0&&Z>T.endOffset;U.push({offset:V?Z+1:T.endOffset,length:0,content:_?M+O+",":M+O})}return U}else{if(T.setting)return[{offset:T.startOffset,length:0,content:O+","}];const U=(S[k.index-1]&&!S[k.index-1].setting?M:"")+O+(n(k.index,S)?",":"")+M;return[{offset:T.startOffset,length:0,content:U}]}}function i(a,y){return y.filter(E=>E.setting?.key===a)[0]}function o(a,y){for(let E=a-1;E>=0;E--)if(y[E].setting)return y[E]}function n(a,y){for(let E=a+1;E<y.length;E++)if(y[E].setting)return y[E]}function s(a,y,E){const k=a.indexOf(y),S=a.indexOf(E);return a.filter((w,O)=>k<O&&O<S)}function t(a,y){if(a.length&&y.length){let E=0;for(;E<y.length&&E<a.length;E++)if(a[E].value!==y[E].value)return y[E-1];return y[E-1]}}function r(a){const y=[];let E=-1,k,S;const w={onObjectBegin:O=>{E++},onObjectProperty:(O,M,T)=>{E===0&&(k=M,S=O)},onObjectEnd:(O,M)=>{E--,E===0&&y.push({startOffset:k,endOffset:O+M,value:a.substring(k,O+M),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(O,M)=>{E++},onArrayEnd:(O,M)=>{E--,E===0&&y.push({startOffset:k,endOffset:O+M,value:a.substring(k,O+M),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(O,M,T)=>{E===0&&y.push({startOffset:k,endOffset:M+T,value:a.substring(k,M+T),setting:{key:S,commaOffset:void 0}})},onSeparator:(O,M,T)=>{if(E===0&&O===","){let U=y.length-1;for(;U>=0&&!y[U].setting;U--);const _=y[U];_&&y.splice(U,1,{startOffset:_.startOffset,endOffset:_.endOffset,value:_.value,setting:{key:_.setting.key,commaOffset:M}})}},onComment:(O,M)=>{E===0&&y.push({startOffset:O,endOffset:O+M,value:a.substring(O,O+M)})}};return(0,N.$Cn)(a,w),y}}),define(le[80],he([0,1,3,2,4,25]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MIb=e.$LIb=void 0,e.$LIb=(0,A.$ii)("IUserDataSyncAccountService");let D=class extends N.$Uc{get account(){return this.a}constructor(P,d){super(),this.g=P,this.h=d,this.b=this.B(new R.$7d),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$7d),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};e.$MIb=D,e.$MIb=D=ve([X(0,j.$upb),X(1,j.$Jpb)],D)}),define(le[247],he([0,1,20,180,16,9,25]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Kb=void 0;let I=class extends j.$Tj{constructor(d,C){super(),this.g=this.B(d.createLogger((0,R.$Vg)(C.logsHome,`${D.$Kpb}.log`),{id:D.$Kpb,name:(0,N.localize)(0,null)}))}trace(d,...C){this.g.trace(d,...C)}debug(d,...C){this.g.debug(d,...C)}info(d,...C){this.g.info(d,...C)}warn(d,...C){this.g.warn(d,...C)}error(d,...C){this.g.error(d,...C)}flush(){this.g.flush()}};e.$9Kb=I,e.$9Kb=I=ve([X(0,j.$Pj),X(1,A.$pi)],I)}),define(le[248],he([0,1,6,3,2]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;class j extends A.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:P,getActiveWindowId:d}){super(),this.a=this.B(new A.$Tc),N.Event.latch(N.Event.any(I,P))(this.f,this,this.a),this.b=(0,R.$8g)(()=>d()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Ebc=j}),define(le[112],he([0,1,183,14,51,20,8,4,23]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=d,e.$ti=C,e.$wi=v,e.$xi=m,e.$yi=f,e.$zi=b,e.$Ai=p,e.$Di=l,e.$Ii=c,e.$Ji=$,e.$Li=i,e.$Mi=o,e.$Ni=n,e.$ri=(0,I.$ii)("contextService");function d(s){const t=s;return typeof t?.id=="string"&&D.URI.isUri(t.uri)}function C(s){return typeof s?.id=="string"&&!d(s)&&!m(s)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function v(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$oc)(s)}:t?e.$ui:e.$vi;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function m(s){const t=s;return typeof t?.id=="string"&&D.URI.isUri(t.configPath)}function f(s){const t=s;if(t?.uri)return{id:t.id,uri:D.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}var h;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function b(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}function p(s){const t=s;return!!(t&&typeof t=="object"&&D.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}class u{constructor(t,r,a,y,E){this.h=t,this.j=a,this.k=y,this.l=E,this.c=A.$oi.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=A.$oi.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=u;class g{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$Vg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=g;function l(s){return new g({uri:s,index:0,name:(0,j.$Rg)(s)},{uri:s.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,R.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function c(s,t){return j.$Mg.isEqualOrParent(s,t.untitledWorkspacesHome)}function $(s){let t;return D.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===P.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Ki}function o(s,t){return!c(s,t)&&!$(s)}function n(s){return(typeof s=="string"?(0,N.$pc)(s):(0,j.$Tg)(s))===e.$Fi}}),define(le[18],he([0,1,54,3,2,20,8,174,16,12,4,9,112,35,28,6,32,27,13]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=c,e.$pl=$,e.$ql=i;var l;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&D.URI.isUri(t.location)&&D.URI.isUri(t.globalStorageHome)&&D.URI.isUri(t.settingsResource)&&D.URI.isUri(t.keybindingsResource)&&D.URI.isUri(t.tasksResource)&&D.URI.isUri(t.snippetsHome)&&D.URI.isUri(t.extensionsResource))}e.$ol=(0,C.$ii)("IUserDataProfilesService");function $(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:D.URI.revive(s.location).with({scheme:t}),globalStorageHome:D.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:D.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:D.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:D.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:D.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:D.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:D.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function i(s,t,r,a,y,E){return{id:s,name:t,location:r,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:E&&y?.useDefaultFlags?.globalState?E.globalStorageHome:(0,j.$Vg)(r,"globalStorage"),settingsResource:E&&y?.useDefaultFlags?.settings?E.settingsResource:(0,j.$Vg)(r,"settings.json"),keybindingsResource:E&&y?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,j.$Vg)(r,"keybindings.json"),tasksResource:E&&y?.useDefaultFlags?.tasks?E.tasksResource:(0,j.$Vg)(r,"tasks.json"),snippetsHome:E&&y?.useDefaultFlags?.snippets?E.snippetsHome:(0,j.$Vg)(r,"snippets"),extensionsResource:E&&y?.useDefaultFlags?.extensions?E.extensionsResource:(0,j.$Vg)(r,"extensions.json"),cacheHome:(0,j.$Vg)(a,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let o=class extends A.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,y){super(),this.t=t,this.u=r,this.w=a,this.y=y,this.f=!0,this.h=this.B(new N.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Bc,emptyWindows:new Map},this.profilesHome=(0,j.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const E of this.O()){if(!E.name||!(0,g.$Vf)(E.name)||!E.location){this.y.warn("Skipping the invalid stored profile",E.location||E.name);continue}r.push(i((0,j.$Sg)(E.location),E.name,E.location,this.g,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},t))}}catch(E){this.y.error(E)}const a=new f.$Bc,y=new Map;if(r.length)try{const E=this.Q();if(E.workspaces)for(const[k,S]of Object.entries(E.workspaces)){const w=D.URI.parse(k),O=r.find(M=>M.id===S);O&&a.set(w,O)}if(E.emptyWindows)for(const[k,S]of Object.entries(E.emptyWindows)){const w=r.find(O=>O.id===S);w&&y.set(k,w)}}catch(E){this.y.error(E)}this.z={profiles:r,workspaces:a,emptyWindows:y}}return this.z}D(){const t=i("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,u.$Ze)(r)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const S=a.exec(k.name),w=S?parseInt(S[1]):0;y=w>y?w:y}const E=`${r} ${y+1}`;return this.createProfile((0,R.$9i)((0,p.$Eg)()).toString(16),E,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,R.$9i)((0,p.$Eg)()).toString(16),t,r,a)}async createProfile(t,r,a,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.F(t,r,a);return y&&await this.setProfileForWorkspace(y,E),E}async F(t,r,a){if(!(0,g.$Vf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(r);return y||(y=(async()=>{try{const E=this.profiles.find(w=>w.name===r||w.id===t);if(E)return E;const k=i(t,r,(0,j.$Vg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(k.location);const S=[];return this.j.fire({profile:k,join(w){S.push(w)}}),await b.Promises.settled(S),this.I([k],[],[]),k}finally{this.r.delete(r)}})(),this.r.set(r,y)),y}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(y=>y.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(y=>y.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(y){a.push(y)}});try{await Promise.allSettled(a)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(y){(0,d.$6k)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(y=>y.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,m.$si)(t)?t.uri:(0,m.$xi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const y=[...this.profiles,...t],E=[];this.s.profiles=[];for(let k of y)k.isDefault||r.some(S=>k.id===S.id)||(k=a.find(S=>k.id===S.id)??k,k.isTransient?this.s.profiles.push(k):E.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(E),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const y=this.G(t),E=a?this.s:this.C;D.URI.isUri(y)?(E.workspaces.delete(y),r&&E.workspaces.set(y,r)):(E.emptyWindows.delete(y),r&&E.emptyWindows.set(y,r)),a||this.M()}M(){const t={};for(const[a,y]of this.C.workspaces.entries())t[a.toString()]=y.id;const r={};for(const[a,y]of this.C.emptyWindows.entries())r[a.toString()]=y.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[E,k]of Object.entries(t.workspaces)){const S=D.URI.parse(k);r[E]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}const y={};if(t.emptyWindows)for(const[E,k]of Object.entries(t.emptyWindows)){const S=D.URI.parse(k);y[E]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:y}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$rl=o,e.$rl=o=ve([X(0,P.$pi),X(1,d.$Ok),X(2,h.$ml),X(3,v.$Oj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$sl=n}),define(le[249],he([0,1,6,2,18]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;let j=class extends N.$Uc{constructor(I){super(),this.B(new R.$uh(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$Qcc=j,e.$Qcc=j=ve([X(0,A.$ol)],j)}),define(le[250],he([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$9p=void 0,e.$0p=$,e.$$p=i;let c=class extends I.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,y,E,k){super(),this.z=t,this.C=r,this.D=a,this.F=y,this.G=E,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$7d),this.s=this.B(new D.$7d),this.t=this.B(new D.$7d),this.u=this.B(new D.$7d),this.w=this.B(new D.$7d),this.y=[],this.B((0,I.$Sc)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.m.forEach(S=>S.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,m.$Po)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const y=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:E})=>(0,f.$gp)(E,t.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new m.$So(`Unknown error while installing extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new m.$So(v.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:y,options:E})=>{try{const k=await this.N(y,!!E?.installGivenVersion,!!E?.installPreReleaseVersion,E.productVersion??{version:this.G.version,date:this.G.date});a.push({...k,options:E})}catch(k){r.push({identifier:y.identifier,operation:2,source:y,error:k})}})),a.length&&r.push(...await this.I(a));for(const y of r)y.error&&(this.F.error("Failed to install extension.",y.identifier.id),this.F.error(y.error),y.source&&!C.URI.isUri(y.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$op)(y.source),error:y.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,h.$Gm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const y of this.H.profiles){const E=(await this.getInstalled(1,y.extensionsResource)).find(k=>(0,f.$gp)(k.identifier,t.identifier));E?this.w.fire(E):this.u.fire({identifier:t.identifier,profileLocation:y.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[],a=new Map,y=[],E=[],k=(w,O)=>`${f.$hp.create(w).toString()}-${O.toString()}`,S=(w,O,M)=>{const T=this.Y(w,O,M),U=C.URI.isUri(O)?O.path:`${O.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`;a.set(U,{task:T,manifest:w}),this.n.fire({identifier:T.identifier,source:O,profileLocation:M.profileLocation}),this.F.info("Installing extension:",T.identifier.id),C.URI.isUri(O)||this.j.set(k(O,M.profileLocation),{task:T,waitingTasks:[]})};try{for(const{manifest:w,extension:O,options:M}of t){const T=M.isApplicationScoped||M.isBuiltin||(0,h.$Gm)(w),U={...M,installOnlyNewlyAddedFromExtensionPack:M.installOnlyNewlyAddedFromExtensionPack??!C.URI.isUri(O),isApplicationScoped:T,profileLocation:T?this.H.defaultProfile.extensionsResource:M.profileLocation??this.X(),productVersion:M.productVersion??{version:this.G.version,date:this.G.date}},_=C.URI.isUri(O)?void 0:this.j.get(k(O,U.profileLocation));_?(this.F.info("Extension is already requested to install",_.task.identifier.id),y.push(_.task.waitUntilTaskIsFinished())):S(w,O,U)}await Promise.all([...a.values()].map(async({task:w,manifest:O})=>{if(w.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",w.identifier.id);else try{const M=await this.M(w.identifier,O,!!w.options.installOnlyNewlyAddedFromExtensionPack,!!w.options.installPreReleaseVersion,w.options.profileLocation,w.options.productVersion),T=await this.getInstalled(void 0,w.options.profileLocation,w.options.productVersion),U={...w.options,donotIncludePackAndDependencies:!0,context:{...w.options.context,[m.$Ko]:!0}};for(const{gallery:_,manifest:G}of(0,R.$Mb)(M,({gallery:Z})=>Z.identifier.id)){if(a.has(`${_.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`))continue;const Z=this.j.get(k(_,U.profileLocation));if(Z){if(this.J(w,Z.task)){const V=Z.task.identifier;this.F.info("Waiting for already requested installing extension",V.id,w.identifier.id),Z.waitingTasks.push(w),y.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,K=>K.some(W=>(0,f.$gp)(W.identifier,V)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",V.id,w.identifier.id),!K.find(B=>(0,f.$gp)(B.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else T.some(({identifier:V})=>(0,f.$gp)(V,_.identifier))||S(G,_,U)}}catch(M){if(C.URI.isUri(w.source))(0,R.$Lb)(O.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",w.identifier.id,M.message),(0,R.$Lb)(O.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",w.identifier.id,M.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",w.identifier.id),M}})),await this.L([...a.values()].map(async({task:w})=>{const O=new Date().getTime();try{const M=await w.run();if(await this.L(this.y.map(T=>T.postInstall(M,w.source,w.options,A.CancellationToken.None))),!C.URI.isUri(w.source)){const T=w.operation===3,U=T?void 0:(new Date().getTime()-w.source.lastUpdated)/1e3;if(o(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$op)(w.source),verificationStatus:w.verificationStatus,duration:new Date().getTime()-O,durationSinceUpdate:U}),P.$o&&w.operation!==3)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}}E.push({local:M,identifier:w.identifier,operation:w.operation,source:w.source,context:w.options.context,profileLocation:w.profileLocation,applicationScoped:M.isApplicationScoped})}catch(M){throw this.F.error("Error while installing the extension",w.identifier.id,(0,j.$0)(M)),M}})),y.length&&await this.L(y);for(const w of E)this.F.info("Extension installed successfully:",w.identifier.id),r.push(w);return r}catch(w){E.length&&(this.F.info("Rollback: Uninstalling installed extensions",(0,j.$0)(w)),await Promise.allSettled(E.map(async({local:O,profileLocation:M})=>{try{await this.Z(O,{versionOnly:!0,profileLocation:M}).run(),this.F.info("Rollback: Uninstalled extension",O.identifier.id)}catch(T){this.F.warn("Rollback: Error while uninstalling extension",O.identifier.id,(0,j.$0)(T))}})));for(const{task:O}of a.values())O.cancel(),r.push({identifier:O.identifier,operation:2,source:O.source,context:O.options.context,profileLocation:O.profileLocation,error:w});throw w}finally{for(const{task:w}of a.values())w.source&&!C.URI.isUri(w.source)&&this.j.delete(k(w.source,w.profileLocation));r.length&&this.s.fire(r)}}J(t,r){for(const[,{task:a,waitingTasks:y}]of this.j.entries())if(a===t&&(y.includes(r)||y.some(E=>this.J(E,r)))||a===r&&y[0]&&!this.J(t,y[0]))return!1;return!0}async L(t){const r=[],a=[],y=await Promise.allSettled(t);for(const E of y)E.status==="fulfilled"?r.push(E.value):a.push(E.reason);if(a.length)throw $(a);return r}async M(t,r,a,y,E,k){if(!this.z.isEnabled())return[];const S=await this.getInstalled(void 0,E,k),w=[],O=[],M=async(T,U)=>{w.push(T);const _=U.extensionDependencies||[],G=[..._];if(U.extensionPack){const Z=a?S.find(V=>(0,f.$gp)(V.identifier,T)):void 0;for(const V of U.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(K=>(0,f.$gp)({id:K},{id:V}))||G.every(K=>!(0,f.$gp)({id:K},{id:V}))&&G.push(V)}if(G.length){const Z=G.filter(V=>w.every(K=>!(0,f.$gp)(K,{id:V})));if(Z.length){const V=await this.z.getExtensions(Z.map(K=>({id:K,preRelease:y})),A.CancellationToken.None);for(const K of V){if(w.find(ie=>(0,f.$gp)(ie,K.identifier)))continue;const W=_.some(ie=>(0,f.$gp)({id:ie},K.identifier));let B;try{B=await this.N(K,!1,y,k)}catch(ie){if(W)throw ie;this.F.info("Skipping the packed extension as it cannot be installed",K.identifier.id,(0,j.$0)(ie));continue}O.push({gallery:B.extension,manifest:B.manifest}),await M(B.extension.identifier,B.manifest)}}}};return await M(t,r),O}async N(t,r,a,y){let E;const k=await this.getExtensionsControlManifest();if(k.malicious.some(O=>(0,f.$gp)(t.identifier,O)))throw new m.$So(v.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const S=k.deprecated[t.identifier.id.toLowerCase()];if(S?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${S.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:S.extension.id,preRelease:S.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},A.CancellationToken.None))[0],!E)throw new m.$So(v.localize(2,null,t.identifier.id,S.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const O=await this.getTargetPlatform();throw new m.$So(v.localize(3,null,t.identifier.id,this.G.nameLong,(0,m.$Lo)(O)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.O(t,r,a,y),!E)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],A.CancellationToken.None))[0]?new m.$So(v.localize(4,null,t.displayName??t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$So(v.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const w=await this.z.getManifest(E,A.CancellationToken.None);if(w===null)throw new m.$So(`Missing manifest for extension ${E.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(w.version!==E.version)throw new m.$So(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:w}}async O(t,r,a,y){const E=await this.getTargetPlatform();let k=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(k=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:E,compatible:!0,productVersion:y},A.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(t,a,E,y)&&(k=t),k||(r?k=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:E,compatible:!0,productVersion:y},A.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(t,a,E,y)),k}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},y=M=>`${M.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,E=this.m.get(y(t.identifier));if(E)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),E.waitUntilTaskIsFinished();const k=M=>{const T=this.Z(M,a);return this.m.set(y(T.extension.identifier),T),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped}),T},S=(M,T)=>{T?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString(),T.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,T.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$np)(M),error:T}),this.u.fire({identifier:M.identifier,error:T?.code,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped})},w=[],O=[];try{w.push(k(t));const M=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const T=this.S(t,M);for(const U of T)this.m.has(y(U.identifier))?this.F.info("Extensions is already requested to uninstall",U.identifier.id):w.push(k(U))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(w.map(T=>T.extension),M,t),await this.L(w.map(async T=>{try{if(await T.run(),await this.L(this.y.map(U=>U.postUninstall(T.extension,a,A.CancellationToken.None))),T.extension.identifier.uuid)try{await this.z.reportStatistic(T.extension.manifest.publisher,T.extension.manifest.name,T.extension.manifest.version,"uninstall")}catch{}S(T.extension)}catch(U){const _=U instanceof m.$So?U:new m.$So((0,j.$0)(U),m.ExtensionManagementErrorCode.Internal);throw S(T.extension,_),_}finally{O.push(T)}}))}catch(M){const T=M instanceof m.$So?M:new m.$So((0,j.$0)(M),m.ExtensionManagementErrorCode.Internal);for(const U of w){try{U.cancel()}catch{}O.includes(U)||S(U.extension,T)}throw T}finally{for(const M of w)this.m.delete(y(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}Q(t,r,a){for(const y of t){const E=this.U(y,r);if(E.length){const k=E.filter(S=>!t.some(w=>(0,f.$gp)(w.identifier,S.identifier)));if(k.length)throw new Error(this.R(y,k,a))}}}R(t,r,a){return a===t?r.length===1?v.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?v.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const y=t.manifest.extensionPack?t.manifest.extensionPack:[];if(y.length){const E=r.filter(S=>!S.isBuiltin&&y.some(w=>(0,f.$gp)({id:w},S.identifier))),k=[];for(const S of E)k.push(...this.S(S,r,a));return[...E,...k]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(y=>(0,f.$gp)({id:y},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,j.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$9p=c,e.$9p=c=ve([X(0,m.$Ro),X(1,u.$Nl),X(2,g.$ml),X(3,b.$Oj),X(4,p.$8j),X(5,l.$ol)],c);function $(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}function i(s){if(s instanceof m.$So)return s;if(s instanceof m.$To){const r=new m.$So(s.message,m.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new m.$So(s.message,m.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function o(s,t,{extensionData:r,verificationStatus:a,duration:y,error:E,durationSinceUpdate:k}){let S,w;(0,d.$4f)(a)&&(a===!0?a="Verified":(a===!1||(S=m.ExtensionManagementErrorCode.Signature,w=a),a="Unverified")),E&&(E instanceof m.$So||E instanceof m.$To?(S=E.code,E.code===m.ExtensionManagementErrorCode.Signature&&(w=E.message)):S=m.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!E,duration:y,errorcode:S,errorcodeDetail:w,durationSinceUpdate:k})}class n{constructor(){this.d=new N.$hh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$8g)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$8g)(t=>new Promise((r,a)=>{const y=t.onCancellationRequested(()=>{y.dispose(),a(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$_p=n}),define(le[52],he([0,1,6,15,2,3,35,8,29,33,12,4,9,18,28,13,7,22]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class l extends Error{constructor(n,s){super(n),this.code=s}}e.$aq=l,e.$bq=(0,v.$ii)("IExtensionsProfileScannerService");let c=class extends A.$Uc{constructor(n,s,t,r,a,y){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=y,this.b=this.B(new j.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new j.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,t){const r=[],a=[];try{return await this.u(s,y=>{const E=[];if(t)E.push(...y);else for(const k of y)n.some(([S])=>(0,d.$gp)(S.identifier,k.identifier)&&S.manifest.version!==k.version)?r.push(k):E.push(k);for(const[k,S]of n){const w=E.findIndex(M=>(0,d.$gp)(M.identifier,k.identifier)&&M.version===k.manifest.version),O={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:S};w===-1?(a.push(O),E.push(O)):E.splice(w,1,O)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),r.length&&this.f.fire({extensions:r,profileLocation:s}),E}),a.length&&this.c.fire({extensions:a,profileLocation:s}),r.length&&this.g.fire({extensions:r,profileLocation:s}),a}catch(y){throw a.length&&this.c.fire({extensions:a,error:y,profileLocation:s}),r.length&&this.g.fire({extensions:r,error:y,profileLocation:s}),y}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const y of r){const E=n.find(([k])=>(0,d.$gp)(k.identifier,y.identifier)&&k.manifest.version===y.version);E&&(y.metadata={...y.metadata,...E[1]},t.push(y)),a.push(y)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const y of r)(0,d.$gp)(y.identifier,n.identifier)?t.push(y):a.push(y);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const y=await this.m.readFile(n);a=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,C.$6k)(y)!==1)throw y;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new l((0,p.$0)(y),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let y=!1;for(const E of a){$(E)||this.w(n);let k;if((0,b.$Vf)(E.relativeLocation)&&E.relativeLocation)k=this.z(E.relativeLocation);else if((0,b.$Vf)(E.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${E.location}`);continue}else{k=I.URI.revive(E.location);const S=this.y(k);S&&(y=!0,E.relativeLocation=S)}(0,b.$3f)(E.metadata?.hasPreReleaseVersion)&&E.metadata?.preRelease&&(y=!0,E.metadata.hasPreReleaseVersion=!0),r.push({identifier:E.identifier,location:k,version:E.version,metadata:E.metadata})}y&&await this.m.writeFile(n,N.$ue.fromString(JSON.stringify(a)))}if(s){r=s(r);const y=r.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.y(E.location),metadata:E.metadata}));await this.m.writeFile(n,N.$ue.fromString(JSON.stringify(y)))}return r})}w(n){const s=new l(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$6k)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(y=>$(y))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$ue.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$6k)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$6k)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$6k)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new R.$ph,this.h.set(n,s)),s}};e.$cq=c,e.$cq=c=ve([X(1,C.$Ok),X(2,f.$ol),X(3,h.$ml),X(4,u.$Nl),X(5,m.$Oj)],c);function $(o){return(0,b.$Xf)(o)&&(0,P.$Qo)(o.identifier)&&(i(o.location)||(0,b.$Vf)(o.location)&&o.location)&&((0,b.$3f)(o.relativeLocation)||(0,b.$Vf)(o.relativeLocation))&&o.version&&(0,b.$Vf)(o.version)}function i(o){return o?(0,b.$Vf)(o.path)&&(0,b.$Vf)(o.scheme):!1}}),define(le[81],he([0,1,17,6,30,15,7,34,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$,i,o,n,s,t,r,a,y,E,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.$gq=e.$fq=e.Translations=void 0,e.$iq=_;var w;(function(Z){function V(K,W){if(K===W)return!0;const B=Object.keys(K),ie=new Set;for(const ae of Object.keys(W))ie.add(ae);if(B.length!==ie.size)return!1;for(const ae of B){if(K[ae]!==W[ae])return!1;ie.delete(ae)}return ie.size===0}Z.equals=V})(w||(e.Translations=w={})),e.$fq=(0,n.$ii)("IExtensionsScannerService");let O=class extends d.$Uc{constructor(V,K,W,B,ie,ae,te,ce,H,q,L,F){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=K,this.r=W,this.s=B,this.t=ie,this.u=ae,this.w=te,this.y=ce,this.z=H,this.C=q,this.D=L,this.F=F,this.g=this.B(new r.$7d),this.onDidChangeCache=this.g.event,this.h=(0,f.$Vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$rp)(this.w,this.y)),this.G}async scanAllExtensions(V,K,W){const[B,ie]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(K)]),ae=W?await this.scanExtensionsUnderDevelopment(V,[...B,...ie]):[];return this.L(B,ie,ae,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const K=[];K.push(this.M(!!V.useCache,V.language)),K.push(this.N(V.language,!!V.checkControlFile));const[W,B]=await Promise.all(K);return this.J([...W,...B],0,V,!1)}async scanUserExtensions(V){const K=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const W=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(K,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,W,V.productVersion??this.R()),ie=V.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let ae;try{ae=await ie.scanExtensions(B)}catch(te){if(te instanceof y.$aq&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ae=await ie.scanExtensions(B);else throw te}return ae=await this.J(ae,1,V,!0),this.y.trace("Scanned user extensions:",ae.length),ae}async scanExtensionsUnderDevelopment(V,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===C.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(te=>(te.type=K.find(ce=>(0,c.$gp)(ce.identifier,te.identifier))?.type??te.type,this.n.validate(te,ie)))}))).flat();return this.J(W,"development",V,!0)}return[]}async scanExistingExtension(V,K,W){const B=await this.P(V,!1,K,!0,W.language,!0,void 0,W.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!W.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(V,K,W){const B=await this.P(V,!1,K,!0,W.language,!0,void 0,W.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,K,W,!0)}async scanMultipleExtensions(V,K,W){const B=[];return await Promise.all(V.map(async ie=>{const ae=await this.scanOneOrMultipleExtensions(ie,K,W);B.push(...ae)})),this.J(B,K,W,!0)}async scanMetadata(V){const K=(0,f.$Vg)(V,"package.json"),W=(await this.w.readFile(K)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(V,K){const W=(0,f.$Vg)(V,"package.json"),B=(await this.w.readFile(W)).value.toString(),ie=JSON.parse(B);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,ie.__metadata={...ie.__metadata,...K},await this.w.writeFile((0,f.$Vg)(V,"package.json"),j.$ue.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof y.$aq&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$ue.fromString(JSON.stringify([])))}catch(K){(0,o.$6k)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,K,W,B){return W.includeAllVersions||(V=this.L(K===0?V:void 0,K===1?V:void 0,K==="development"?V:void 0,await this.getTargetPlatform(),B)),W.includeInvalid||(V=V.filter(ie=>ie.isValid)),V.sort((ie,ae)=>{const te=v.$oc(ie.location.fsPath),ce=v.$oc(ae.location.fsPath);return te<ce?-1:te>ce?1:0})}L(V,K,W,B,ie){const ae=(ce,H,q)=>{if(ce.isValid&&!H.isValid)return!1;if(ce.isValid===H.isValid){if(ie&&h.gt(ce.manifest.version,H.manifest.version))return this.y.debug(`Skipping extension ${H.location.path} with lower version ${H.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(h.eq(ce.manifest.version,H.manifest.version)){if(ce.type===0)return this.y.debug(`Skipping extension ${H.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===B)return this.y.debug(`Skipping extension ${H.location.path} from different target platform ${H.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${ce.location.path} with ${H.location.path}.`):this.y.debug(`Overwriting user extension ${ce.location.path} with ${H.location.path}.`),!0},te=new $.$Fm;return V?.forEach(ce=>{const H=te.get(ce.identifier.id);(!H||ae(H,ce,!1))&&te.set(ce.identifier.id,ce)}),K?.forEach(ce=>{const H=te.get(ce.identifier.id);if(!H&&V&&ce.type===0){this.y.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!H||ae(H,ce,!1))&&te.set(ce.identifier.id,ce)}),W?.forEach(ce=>{const H=te.get(ce.identifier.id);(!H||ae(H,ce,!0))&&te.set(ce.identifier.id,ce),te.set(ce.identifier.id,ce)}),[...te.values()]}async M(V,K){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0,this.R()),ie=await(V&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(V,K){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const B=K?await this.O():{},ie=[],ae=u.URI.file(v.$ic(v.$kc(C.$Cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of W){const H=B[ce.name]||"marketplace";switch(H){case"disabled":break;case"marketplace":ie.push((0,f.$Vg)(ae,ce.name));break;default:ie.push(u.URI.file(H));break}}const te=await Promise.all(ie.map(async ce=>this.n.scanExtension(await this.P(ce,!1,0,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,R.$Hb)(te)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,K,W,B,ie,ae,te,ce){const H=await this.f(ie??m.$w),q=await this.Q(V),L=K&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=L?await this.Q(L):void 0;return new M(V,q,L,F,K,te,W,B,ae,ce.version,ce.date,this.C.commit,!this.z.isBuilt,ie,H)}async Q(V){try{const K=await this.w.stat(V);if(typeof K.mtime=="number")return K.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$gq=O,e.$gq=O=ve([X(4,E.$ol),X(5,y.$bq),X(6,o.$Ok),X(7,s.$Oj),X(8,l.$pi),X(9,t.$8j),X(10,k.$ml),X(11,n.$hi)],O);class M{constructor(V,K,W,B,ie,ae,te,ce,H,q,L,F,z,Y,J){this.location=V,this.mtime=K,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=ae,this.type=te,this.excludeObsolete=ce,this.validate=H,this.productVersion=q,this.productDate=L,this.productCommit=F,this.devMode=z,this.language=Y,this.translations=J}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,K){return(0,f.$Og)(V.location,K.location)&&V.mtime===K.mtime&&(0,f.$Og)(V.applicationExtensionslocation,K.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&V.profile===K.profile&&A.$Sn(V.profileScanOptions,K.profileScanOptions)&&V.type===K.type&&V.excludeObsolete===K.excludeObsolete&&V.validate===K.validate&&V.productVersion===K.productVersion&&V.productDate===K.productDate&&V.productCommit===K.productCommit&&V.devMode===K.devMode&&V.language===K.language&&w.equals(V.translations,K.translations)}}e.$hq=M;let T=class extends d.$Uc{constructor(V,K,W,B,ie){super(),this.f=V,this.g=K,this.h=W,this.j=B,this.m=ie}async scanExtensions(V){const K=V.profile?await this.r(V):await this.n(V);let W={};if(V.excludeObsolete&&V.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();W=JSON.parse(B)}catch{}return(0,p.$9f)(W)?K:K.filter(B=>!W[c.$hp.create(B).toString()])}async n(V){const K=await this.j.resolve(V.location);if(!K.children?.length)return[];const W=await Promise.all(K.children.map(async B=>{if(!B.isDirectory||V.type===1&&(0,f.$Sg)(B.resource).indexOf(".")===0)return null;const ie=new M(B.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ie)}));return(0,R.$Hb)(W).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(V){let K=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){K=K.filter(B=>!B.metadata?.isApplicationScoped);const W=await this.s(V.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,V);K.push(...W)}return K}async s(V,K,W){const B=await this.g.scanProfileExtensions(V,W.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async ae=>{if(K(ae)){const te=new M(ae.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(te,ae.metadata)}return null}));return(0,R.$Hb)(ie)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,f.$Vg)(V.location,"package.json"))){const K=await this.scanExtension(V);return K?[K]:[]}else return await this.scanExtensions(V)}catch(K){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,D.$0)(K)),[]}}async scanExtension(V,K){try{let W=await this.scanExtensionManifest(V.location);if(W){W.publisher||(W.publisher=$.$zm),K=K??W.__metadata,delete W.__metadata;const B=(0,c.$lp)(W.publisher,W.name),ie=K?.id?{id:B,uuid:K.id}:{id:B},ae=K?.isSystem?0:V.type,te=ae===0||!!K?.isBuiltin;W=await this.t(V.location,W,M.createNlsConfiguration(V));const ce={type:ae,identifier:ie,manifest:W,location:V.location,isBuiltin:te,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return V.validate?this.validate(ce,V):ce}}catch(W){V.type!==0&&this.m.error(W)}return null}validate(V,K){let W=!0;const B=(0,i.$wp)(K.productVersion,K.productDate,K.location,V.manifest,V.isBuiltin);for(const[ie,ae]of B)ie===b.default.Error&&(W=!1,this.m.error(this.z(K.location,ae)));return V.isValid=W,V.validations=B,V}async scanExtensionManifest(V){const K=(0,f.$Vg)(V,"package.json");let W;try{W=(await this.j.readFile(K)).value.toString()}catch(ie){return(0,o.$6k)(ie)!==1&&this.m.error(this.z(V,(0,g.localize)(0,null,K.path,ie.message))),null}let B;try{B=JSON.parse(W)}catch{const ae=[];(0,I.$vn)(W,ae);for(const te of ae)this.m.error(this.z(V,(0,g.localize)(1,null,K.path,te.offset,te.length,(0,P.$dq)(te.error))));return null}return(0,I.$En)(B)!=="object"?(this.m.error(this.z(V,(0,g.localize)(2,null,K.path))),null):B}async t(V,K,W){const B=await this.u(V,K,W);if(B)try{const ie=[],ae=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(ce=>{this.m.error(this.z(V,(0,g.localize)(3,null,B.default?.path,(0,P.$dq)(ce.error))))}),K;if((0,I.$En)(B)!=="object")return this.m.error(this.z(V,(0,g.localize)(4,null,B.default?.path))),K;const te=B.values||Object.create(null);return(0,S.$eq)(this.m,K,te,ae)}catch{}return K}async u(V,K,W){const B=(0,f.$Vg)(V,"package.nls.json"),ie=(H,q)=>{q.forEach(L=>{this.m.error(this.z(V,(0,g.localize)(5,null,H?.path,(0,P.$dq)(L.error))))})},ae=H=>{this.m.error(this.z(V,(0,g.localize)(6,null,H?.path)))},te=`${K.publisher}.${K.name}`,ce=W.translations[te];if(ce)try{const H=u.URI.file(ce),q=(await this.j.readFile(H)).value.toString(),L=[],F=(0,I.$vn)(q,L);return L.length>0?(ie(H,L),{values:void 0,default:B}):(0,I.$En)(F)!=="object"?(ae(H),{values:void 0,default:B}):{values:F.contents?F.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let q;try{q=await this.y(V,W)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const L=(await this.j.readFile(q.localized)).value.toString(),F=[],z=(0,I.$vn)(L,F);return F.length>0?(ie(q.localized,F),{values:void 0,default:q.original}):(0,I.$En)(z)!=="object"?(ae(q.localized),{values:void 0,default:q.original}):{values:z,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(V,K){if(V)try{const W=(await this.j.readFile(V)).value.toString();return(0,I.$vn)(W,K)}catch{}}y(V,K){return new Promise((W,B)=>{const ie=ae=>{const te=(0,f.$Vg)(V,`package.nls.${ae}.json`);this.j.exists(te).then(ce=>{ce&&W({localized:te,original:(0,f.$Vg)(V,"package.nls.json")});const H=ae.lastIndexOf("-");H===-1?W({localized:(0,f.$Vg)(V,"package.nls.json"),original:null}):(ae=ae.substring(0,H),ie(ae))})};if(K.devMode||K.pseudo||!K.language)return W({localized:(0,f.$Vg)(V,"package.nls.json"),original:null});ie(K.language)})}z(V,K){return`[${V.path}]: ${K}`}};T=ve([X(1,y.$bq),X(2,k.$ml),X(3,o.$Ok),X(4,s.$Oj)],T);let U=class extends T{constructor(V,K,W,B,ie,ae,te){super(K,B,ie,ae,te),this.G=V,this.H=W,this.D=this.B(new N.$gh(3e3)),this.F=this.B(new r.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(V){const K=this.M(V),W=await this.I(K);if(this.C=V,W&&W.input&&M.equals(W.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),W.result.map(ie=>(ie.location=u.URI.revive(ie.location),ie));const B=await super.scanExtensions(V);return await this.J(K,{input:V,result:B}),B}async I(V){try{const K=await this.j.readFile(V),W=JSON.parse(K.value.toString());return{result:W.result,input:(0,a.$Rh)(W.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",V.path,(0,D.$0)(K))}return null}async J(V,K){try{await this.j.writeFile(V,j.$ue.fromString(JSON.stringify(K)))}catch(W){this.m.debug("Error while writing the extension cache file:",V.path,(0,D.$0)(W))}}async L(){if(!this.C)return;const V=this.M(this.C),K=await this.I(V);if(!K)return;const W=K.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$Sn(B,W))try{this.m.info("Invalidating Cache",W,B),await this.j.del(V),this.F.fire()}catch(ie){this.m.error(ie)}}M(V){const K=this.N(V);return this.h.extUri.joinPath(K.cacheHome,V.type===0?$.$ym:$.$xm)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(V.location,K.extensionsResource))??this.G:this.H.defaultProfile}};U=ve([X(2,E.$ol),X(3,y.$bq),X(4,k.$ml),X(5,o.$Ok),X(6,s.$Oj)],U);function _(Z,V){const K=(0,c.$jp)(Z.manifest.publisher,Z.manifest.name);return{id:K,identifier:new $.$Dm(K),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:V,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,...Z.manifest}}class G extends O{constructor(V,K,W,B,ie,ae,te,ce,H,q,L,F){super(V,K,(0,f.$Vg)(W,".vscode-oss-dev","extensions","control.json"),B,ie,ae,te,ce,H,q,L,F),this.S=(async()=>{if(m.$z)try{const z=await this.w.readFile(u.URI.file(m.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$jq=G}),define(le[251],he([0,1,67,6,38,3,2,23,14,31,9,18]),function(se,e,R,N,A,j,D,I,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;let m=class extends D.$Uc{constructor(h,b){super(),this.b=h,this.f=b,this.a=new N.$oh(5)}async postUninstall(h){const b=this.g(h,"uninstall");b&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,h),this.f.info("Finished running post uninstall script",h.identifier.id,h.manifest.version)}catch(p){this.f.error("Failed to run post uninstall script",h.identifier.id,h.manifest.version),this.f.error(p)}}));try{await d.Promises.rm(this.m(h))}catch(p){this.f.error("Error while removing extension storage path",h.identifier.id),this.f.error(p)}}g(h,b){const p=`vscode:${b}`;if(h.location.scheme===I.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[p]=="string"){const u=h.manifest.scripts[p].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${p} should be a node script`),null):{script:(0,P.$kc)(h.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(h,b,p,u,g){return new Promise((l,c)=>{const $=this.j(h,b,p,g);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):l(void 0)};$.on("error",n=>{o((0,A.$6i)(n)||"Unknown")}),$.on("exit",(n,s)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),u&&(i=setTimeout(()=>{i=null,$.kill(),c("timed out")},5e3))})}j(h,b,p,u){const g={silent:!0,execArgv:void 0},l=(0,R.fork)(h,[`--type=extension-post-${b}`,...p],g);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const c=j.Event.fromNodeEventEmitter(l.stdout,"data"),$=j.Event.fromNodeEventEmitter(l.stderr,"data");c(n=>this.f.info(u.identifier.id,u.manifest.version,`post-${b}`,n)),$(n=>this.f.error(u.identifier.id,u.manifest.version,`post-${b}`,n));const i=j.Event.any(j.Event.map(c,n=>({data:`%c${n}`,format:[""]})),j.Event.map($,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(u.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}m(h){return(0,P.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};e.$lq=m,e.$lq=m=ve([X(0,v.$ol),X(1,C.$Oj)],m)}),define(le[113],he([0,1,6,15,26,38,7,3,54,2,35,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$,i,o,n,s,t,r,a,y,E,k,S,w,O,M,T,U,_,G,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.$qq=e.$pq=void 0,e.$pq=(0,M.$ji)(n.$Uo);const V=".vsctmp";let K=class extends o.$9p{constructor(H,q,L,F,z,Y,J,ee,x,Q,ne,re){super(H,q,ne,L,Q,re),this.eb=z,this.fb=Y,this.gb=J,this.hb=x,this.db=new Map,this.qb=new C.$Cc;const ue=this.B(ee.createInstance(y.$lq));this.ab=this.B(ee.createInstance(W,$e=>ue.postUninstall($e))),this.bb=this.B(new k.$nq(re,x,ne,this,this.F)),this.cb=this.B(ee.createInstance(a.$kq));const de=this.B(new S.$oq(this,this.eb,re,Y,ne,x,L));this.B(de.onDidChangeExtensionsByAnotherSource($e=>this.pb($e))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$rp)(this.hb,this.F)),this.ib}async zip(H){this.F.trace("ExtensionManagementService#zip",H.identifier.id);const q=await this.ob(H),L=await(0,l.zip)((0,f.$Vg)(this.cb.extensionsDownloadDir,(0,u.$Eg)()).fsPath,q);return p.URI.file(L)}async unzip(H){return this.F.trace("ExtensionManagementService#unzip",H.toString()),(await this.install(H)).identifier}async getManifest(H){const{location:q,cleanup:L}=await this.kb(H),F=m.$lc(q.fsPath);try{return await(0,E.$mq)(F)}finally{await L()}}getInstalled(H,q=this.H.defaultProfile.extensionsResource,L={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(H??null,q,L)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(H){return this.ab.scanUserExtensionAtLocation(H)}async install(H,q={}){this.F.trace("ExtensionManagementService#install",H.toString());const{location:L,cleanup:F}=await this.kb(H);try{const z=await(0,E.$mq)(m.$lc(L.fsPath)),Y=(0,s.$lp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,w.$yp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,Y,this.G.version));const ee=(await this.I([{manifest:z,extension:L,options:q}])).find(({identifier:x})=>(0,s.$gp)(x,{id:Y}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,o.$$p)(new Error(`Unknown error while installing extension ${Y}`))}finally{await F()}}async installFromLocation(H,q){this.F.trace("ExtensionManagementService#installFromLocation",H.toString());const L=await this.ab.scanUserExtensionAtLocation(H);if(!L||!L.manifest.name||!L.manifest.version)throw new Error(`Cannot find a valid extension from the location ${H.toString()}`);return await this.tb([[L,{source:"resource"}]],q),this.F.info("Successfully installed extension",L.identifier.id,q.toString()),L}async installExtensionsFromProfile(H,q,L){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",H,q.toString(),L.toString());const F=(await this.getInstalled(1,q)).filter(z=>H.some(Y=>(0,s.$gp)(Y,z.identifier)));if(F.length){const z=await Promise.all(F.map(Y=>this.ab.scanMetadata(Y,q)));await this.tb(F.map((Y,J)=>[Y,z[J]]),L),this.F.info("Successfully installed extensions",F.map(Y=>Y.identifier.id),L.toString())}return F}async updateMetadata(H,q,L=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",H.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),H=await this.ab.updateMetadata(H,q,L),this.bb.invalidate(L),this.w.fire(H),H}async reinstallFromGallery(H){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",H.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const q=await this.getTargetPlatform(),[L]=await this.z.getExtensions([{...H.identifier,preRelease:H.preRelease}],{targetPlatform:q,compatible:!0},A.CancellationToken.None);if(!L)throw new Error(c.localize(2,null));await this.ab.setUninstalled(H);try{await this.ab.removeUninstalledExtension(H)}catch(F){throw new Error(c.localize(3,null,(0,j.$6i)(F)))}return this.installFromGallery(L)}$(H,q,L,F){return this.ab.copyExtension(H,q,L,F)}copyExtensions(H,q){return this.ab.copyExtensions(H,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...H){return this.ab.setUninstalled(...H)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(H){this.F.error(H)}}async download(H,q,L){const{location:F}=await this.cb.download(H,q,!L);return F}async kb(H){if(H.scheme===v.Schemas.file)return{location:H,async cleanup(){}};this.F.trace("Downloading extension from",H.toString());const q=(0,f.$Vg)(this.cb.extensionsDownloadDir,(0,u.$Eg)());return await this.gb.download(H,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.hb.del(q)}catch(F){this.F.error(F)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(H,q,L){if(p.URI.isUri(q))return new ae(H,q,L,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const F=s.$hp.create(q).toString();let z=this.db.get(F);return z||(this.db.set(F,z=new ie(H,q,L,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(F))),z}Z(H,q){return new te(H,q.profileLocation,this.fb)}async ob(H){const q=async F=>{let z=await g.Promises.readdir(F);z=z.map(ee=>m.$kc(F,ee));const Y=await Promise.all(z.map(ee=>g.Promises.stat(ee)));let J=Promise.resolve([]);return Y.forEach((ee,x)=>{const Q=z[x];ee.isFile()&&(J=J.then(ne=>[...ne,Q])),ee.isDirectory()&&(J=J.then(ne=>q(Q).then(re=>[...ne,...re])))}),J};return(await q(H.location.fsPath)).map(F=>({path:`extension/${m.$mc(H.location.fsPath,F)}`,localPath:F}))}async pb({added:H,removed:q}){if(q){const L=H&&this.D.extUri.isEqual(q.profileLocation,H.profileLocation)?q.extensions.filter(F=>H.extensions.every(z=>!(0,s.$gp)(z,F))):q.extensions;for(const F of L)this.F.info("Extensions removed from another source",F.id,q.profileLocation.toString()),this.u.fire({identifier:F,profileLocation:q.profileLocation})}if(H){const F=(await this.getInstalled(1,H.profileLocation)).filter(z=>H.extensions.some(Y=>(0,s.$gp)(Y,z.identifier)));this.s.fire(F.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,H.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:H.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(q=>this.qb.add(q)));const H=await this.hb.resolve(this.eb.userExtensionsLocation);for(const q of H.children??[])q.isDirectory&&this.qb.add(q.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(q=>this.sb(q)))}async sb(H){if(!H.affects(this.eb.userExtensionsLocation,1))return;const q=[];for(const L of H.rawAdded){if(this.qb.has(L)||!this.D.extUri.isEqual(this.D.extUri.dirname(L),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(L,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(L).startsWith(".")||!(await this.hb.stat(L)).isDirectory)continue;const F=await this.ab.scanUserExtensionAtLocation(L);F&&F.installedTimestamp===void 0&&(this.qb.add(L),q.push(F))}q.length&&(await this.tb(q.map(L=>[L,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(L=>L.identifier.id)))}async tb(H,q){const L=H.map(F=>F[0]);await this.ub(L),await this.fb.addExtensionsToProfile(H,q),this.s.fire(L.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:q})))}async ub(H){const q=await this.ab.getUninstalledExtensions();for(const L of H){const F=s.$hp.create(L);q[F.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",F.id),await this.ab.setInstalled(F),this.F.info("Removed the extension from uninstalled list:",F.id))}}};e.$qq=K,e.$qq=K=ve([X(0,n.$Ro),X(1,_.$Nl),X(2,T.$Oj),X(3,i.$qi),X(4,r.$fq),X(5,t.$bq),X(6,$.$wo),X(7,M.$hi),X(8,O.$Ok),X(9,U.$8j),X(10,G.$ml),X(11,Z.$ol)],K);let W=class extends d.$Uc{constructor(H,q,L,F,z,Y){super(),this.j=H,this.m=q,this.n=L,this.s=F,this.t=z,this.u=Y,this.h=this.B(new I.$7d),this.onExtract=this.h.event,this.c=(0,f.$Vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new R.$ph}async cleanUp(){await this.H(),await this.G()}async scanExtensions(H,q,L){const F={includeInvalid:!0,profileLocation:q,productVersion:L};let z=[];return H===null||H===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},F,!1)):H===1&&z.push(...await this.n.scanUserExtensions(F)),z=H!==null?z.filter(Y=>Y.type===H):z,Promise.all(z.map(Y=>this.F(Y)))}async scanAllUserExtensions(H){const q=await this.n.scanUserExtensions({includeAllVersions:!H,includeInvalid:!0});return Promise.all(q.map(L=>this.F(L)))}async scanUserExtensionAtLocation(H){try{const q=await this.n.scanExistingExtension(H,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(H,q,L,F,z){const Y=H.toString(),J=p.URI.file(m.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$Eg)()}`)),ee=p.URI.file(m.$kc(this.n.userExtensionsLocation.fsPath,Y));let x=await this.m.exists(ee);if(x&&F){try{await this.y(H.id,ee,"removeExisting")}catch{throw new n.$So(c.localize(4,null,ee.fsPath,H.id),n.ExtensionManagementErrorCode.Delete)}x=!1}if(x)await this.n.updateMetadata(ee,L);else try{try{this.u.trace(`Started extracting the extension from ${q} to ${ee.fsPath}`),await(0,l.$7p)(q,J.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${ee}:`,H.id)}catch(Q){let ne=n.ExtensionManagementErrorCode.Extract;throw Q instanceof l.$5p&&(Q.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:Q.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$So(Q.message,ne)}await this.n.updateMetadata(J,L);try{this.u.trace(`Started renaming the extension from ${J.fsPath} to ${ee.fsPath}`),await this.C(J.fsPath,ee.fsPath),this.u.info("Renamed to",ee.fsPath)}catch(Q){if(Q.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",H.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(Q)}. Deleted from extracted location`,J),Q}this.h.fire(ee)}catch(Q){try{await this.m.del(J,{recursive:!0})}catch{}throw Q}return this.D(ee,1)}async scanMetadata(H,q){return q?(await this.w(H,q))?.metadata:this.n.scanMetadata(H.location)}async w(H,q){return(await this.s.scanProfileExtensions(q)).find(F=>(0,s.$gp)(F.identifier,H.identifier))}async updateMetadata(H,q,L){return L?await this.s.updateMetadata([[H,q]],L):await this.n.updateMetadata(H.location,q),this.D(H.location,H.type,L)}getUninstalledExtensions(){return this.z()}async setUninstalled(...H){const q=H.map(L=>s.$hp.create(L));await this.z(L=>q.forEach(F=>{L[F.toString()]=!0,this.u.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(H){await this.z(q=>delete q[H.toString()])}async removeExtension(H,q){if(this.t.extUri.isEqualOrParent(H.location,this.n.userExtensionsLocation))return this.y(H.identifier.id,H.location,q)}async removeUninstalledExtension(H){await this.removeExtension(H,"uninstalled"),await this.z(q=>delete q[s.$hp.create(H).toString()])}async copyExtension(H,q,L,F){const z=await this.w(H,q),Y=await this.w(H,L);if(F={...z?.metadata,...F},Y)if(this.t.extUri.isEqual(Y.location,H.location))await this.s.updateMetadata([[H,{...Y.metadata,...F}]],L);else{const J=await this.D(Y.location,H.type,L);await this.s.removeExtensionFromProfile(J,L),await this.s.addExtensionsToProfile([[H,{...Y.metadata,...F}]],L)}else await this.s.addExtensionsToProfile([[H,F]],L);return this.D(H.location,H.type,L)}async copyExtensions(H,q,L){const F=await this.scanExtensions(1,H,L),z=await Promise.all(F.filter(Y=>!Y.isApplicationScoped).map(async Y=>[Y,await this.scanMetadata(Y,H)]));await this.s.addExtensionsToProfile(z,q)}async y(H,q,L){this.u.trace(`Deleting ${L} extension from disk`,H,q.fsPath);const F=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,P.$9i)((0,u.$Eg)()).toString(16)}${V}`);await this.C(q.fsPath,F.fsPath),await this.m.del(F,{recursive:!0}),this.u.info(`Deleted ${L} extension from disk`,H,q.fsPath)}async z(H){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,O.$6k)(F)!==1)throw F}let L={};if(q)try{L=JSON.parse(q)}catch{}return H&&(H(L),Object.keys(L).length?await this.m.writeFile(this.c,N.$ue.fromString(JSON.stringify(L))):await this.m.del(this.c)),L})}async C(H,q){try{await g.Promises.rename(H,q,2*60*1e3)}catch(L){throw new n.$So(L.message||c.localize(5,null,H,q),L.code||n.ExtensionManagementErrorCode.Rename)}}async D(H,q,L){if(L){const z=(await this.n.scanUserExtensions({profileLocation:L})).find(Y=>this.t.extUri.isEqual(Y.location,H));if(z)return this.F(z)}else{const F=await this.n.scanExistingExtension(H,q,{includeInvalid:!0});if(F)return this.F(F)}throw new Error(c.localize(6,null,H.path))}async F(H){const q=await this.m.resolve(H.location);let L,F;return q.children&&(L=q.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,F=q.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:H.identifier,type:H.type,isBuiltin:H.isBuiltin||!!H.metadata?.isBuiltin,location:H.location,manifest:H.manifest,targetPlatform:H.targetPlatform,validations:H.validations,isValid:H.isValid,readmeUrl:L,changelogUrl:F,publisherDisplayName:H.metadata?.publisherDisplayName||null,publisherId:H.metadata?.publisherId||null,isApplicationScoped:!!H.metadata?.isApplicationScoped,isMachineScoped:!!H.metadata?.isMachineScoped,isPreReleaseVersion:!!H.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!H.metadata?.hasPreReleaseVersion,preRelease:!!H.metadata?.preRelease,installedTimestamp:H.metadata?.installedTimestamp,updated:!!H.metadata?.updated,pinned:!!H.metadata?.pinned,isWorkspaceScoped:!1,source:H.metadata?.source??(H.identifier.uuid?"gallery":"vsix")}}async G(){const H=await this.getUninstalledExtensions();if(Object.keys(H).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(H));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const z of q)H[s.$hp.create(z).toString()]||L.add(z.identifier.id.toLowerCase());try{const z=(0,s.$mp)(q,Y=>Y.identifier);await R.Promises.settled(z.map(async Y=>{const J=Y.sort((ee,x)=>h.rcompare(ee.manifest.version,x.manifest.version))[0];L.has(J.identifier.id.toLowerCase())||await this.j(await this.F(J))}))}catch(z){this.u.error(z)}const F=q.filter(z=>z.metadata&&H[s.$hp.create(z).toString()]);await Promise.allSettled(F.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let H;try{H=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,O.$6k)(q)!==1&&this.u.error(q);return}if(H?.children)try{await Promise.allSettled(H.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(L){(0,O.$6k)(L)!==1&&this.u.error(L)}}}))}catch{}}};e.$rq=W,e.$rq=W=ve([X(1,O.$Ok),X(2,r.$fq),X(3,t.$bq),X(4,G.$ml),X(5,T.$Oj)],W);class B extends o.$_p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.$3f)(this.options.operation)?this.l:this.options.operation}constructor(H,q,L,F,z,Y,J,ee,x){super(),this.identifier=H,this.source=q,this.options=L,this.m=F,this.n=z,this.o=Y,this.p=J,this.q=ee,this.s=x,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(H){const[q,L]=await this.x(H);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,L]],this.j,!q.isValid),q}async u({zipPath:H,key:q,metadata:L},F,z){let Y=await this.v(q);return Y?Y=await this.m.updateMetadata(Y,L):(this.s.trace("Extracting extension...",q.id),Y=await this.m.extractUserExtension(q,H,L,F,z),this.s.info("Extracting extension completed.",q.id)),Y}async v(H){return await this.w(H)?(this.s.trace("Removing the extension from uninstalled list:",H.id),await this.m.setInstalled(H),this.s.info("Removed the extension from uninstalled list:",H.id),(await this.m.scanAllUserExtensions(!0)).find(F=>s.$hp.create(F).equals(H))):void 0}async w(H){return!!(await this.m.getUninstalledExtensions())[H.toString()]}}class ie extends B{constructor(H,q,L,F,z,Y,J,ee,x,Q,ne){super(q.identifier,q,L,z,Y,J,ee,x,Q),this.y=q,this.z=F,this.A=ne}async x(H){let q;try{q=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(z){throw new n.$So(z,n.ExtensionManagementErrorCode.Scanning)}const L=q.find(z=>(0,s.$gp)(z.identifier,this.y.identifier));L&&(this.l=3);const F={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||L?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:L?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??L?.pinned,preRelease:(0,b.$2f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||L?.preRelease,source:"gallery"};if(L?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(L,F),F]}catch(z){throw new n.$So((0,D.$0)(z),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(F,H)}catch(z){if(z instanceof n.$So&&(z.code===n.ExtensionManagementErrorCode.CorruptZip||z.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const Y=await this.C(F,H);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),Y}catch(Y){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),Y}}else throw z}}async C(H,q){const{location:L,verificationStatus:F}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=F,this.D(L.fsPath),[await this.u({zipPath:L.fsPath,key:s.$hp.create(this.y),metadata:H},!1,q),H]}catch(z){try{await this.z.delete(L)}catch(Y){this.s.warn("Error while deleting the downloaded file",L.toString(),(0,D.$0)(Y))}throw z}}async D(H){try{await(0,E.$mq)(H)}catch(q){throw new n.$So((0,o.$0p)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$sq=ie;class ae extends B{constructor(H,q,L,F,z,Y,J,ee,x,Q){super({id:(0,s.$lp)(H.publisher,H.name)},q,L,z,Y,J,ee,x,Q),this.y=H,this.z=q,this.A=F}async h(H){const q=await super.h(H);return this.D(q,H),q}async x(H){const q=new s.$hp(this.identifier,this.y.version),F=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(J=>(0,s.$gp)(this.identifier,J.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??F?.pinned,source:"vsix"};if(F)if(this.l=3,q.equals(new s.$hp(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(c.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&h.gt(F.manifest.version,this.y.version)&&await this.m.setUninstalled(F);else{const J=await this.v(q);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(c.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$lc(this.z.fsPath),key:q,metadata:z},!0,H),z]}async D(H,q){try{let[L]=await this.A.getExtensions([{id:H.identifier.id,version:H.manifest.version}],q);if(L||([L]=await this.A.getExtensions([{id:H.identifier.id}],q)),L){const F={id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId,isPreReleaseVersion:L.properties.isPreReleaseVersion,hasPreReleaseVersion:H.hasPreReleaseVersion||L.properties.isPreReleaseVersion,preRelease:L.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(H,F,this.options.profileLocation)}}catch{}}}class te extends o.$_p{constructor(H,q,L){super(),this.extension=H,this.j=q,this.k=L}async h(H){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[252],he([0,1,9,18,28,22,52,12,16,8]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=void 0;let C=class extends D.$cq{constructor(m,f,h,b,p,u){super(d.URI.file(m.extensionsPath),f,h,b,p,u)}};e.$9P=C,e.$9P=C=ve([X(0,P.$qi),X(1,I.$Ok),X(2,N.$ol),X(3,A.$ml),X(4,j.$Nl),X(5,R.$Oj)],C)}),define(le[253],he([0,1,8,16,52,81,12,4,9,24,28,18]),function(se,e,R,N,A,j,D,I,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;let m=class extends j.$jq{constructor(h,b,p,u,g,l,c,$){super(R.URI.file(g.builtinExtensionsPath),R.URI.file(g.extensionsPath),g.userHome,h.defaultProfile,h,b,p,u,g,l,c,$)}};e.$Ibc=m,e.$Ibc=m=ve([X(0,v.$ol),X(1,A.$bq),X(2,D.$Ok),X(3,P.$Oj),X(4,N.$qi),X(5,d.$8j),X(6,C.$ml),X(7,I.$hi)],m)}),define(le[19],he([0,1,6,3,2,98,13,69,4,18]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Op=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mp=e.$Lp=e.$Kp=void 0,e.$Np=f,e.$Pp=b,e.$Rp=u,e.$Kp="__$__isNewStorageMarker",e.$Lp="__$__targetStorageMarker",e.$Mp=(0,P.$ii)("storageService");var C;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var v;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function f(g){const l=g.get(e.$Lp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class h extends A.$Uc{static{this.a=60*1e3}constructor(l={flushInterval:h.a}){super(),this.m=l,this.b=this.B(new N.$0d),this.c=this.B(new N.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new R.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,c,$){return N.Event.filter(this.b.event,i=>i.scope===l&&(c===void 0||i.key===c),$)}n(){this.j.value=(0,R.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,c){const{key:$,external:i}=c;if($===e.$Lp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:$,target:this.J(l)[$],external:i})}w(l){this.f.fire({reason:l})}get(l,c,$){return this.P(c)?.get(l,$)}getBoolean(l,c,$){return this.P(c)?.getBoolean(l,$)}getNumber(l,c,$){return this.P(c)?.getNumber(l,$)}getObject(l,c,$){return this.P(c)?.getObject(l,$)}storeAll(l,c){this.y(()=>{for(const $ of l)this.store($.key,$.value,$.scope,$.target,c)})}store(l,c,$,i,o=!1){if((0,D.$5f)(c)){this.remove(l,$,o);return}this.y(()=>{this.z(l,$,i),this.P($)?.set(l,c,o)})}remove(l,c,$=!1){this.y(()=>{this.z(l,c,void 0),this.P(c)?.delete(l,$)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,c){const $=[],i=this.J(l);for(const o of Object.keys(i))i[o]===c&&$.push(o);return $}z(l,c,$,i=!1){const o=this.J(c);typeof $=="number"?o[l]!==$&&(o[l]=$,this.P(c)?.set(e.$Lp,JSON.stringify(o),i)):typeof o[l]=="number"&&(delete o[l],this.P(c)?.set(e.$Lp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const c=this.P(l);return c?f(c):Object.create(null)}isNew(l){return this.getBoolean(e.$Kp,l)===!0}async flush(l=C.NONE){this.f.fire({reason:l});const c=this.P(-1),$=this.P(0),i=this.P(1);switch(l){case C.NONE:await R.Promises.settled([c?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await R.Promises.settled([c?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return u(l,c,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,c){return this.w(C.NONE),(0,d.$nl)(l)?this.R(l,c):this.S(l,c)}M(l,c){return!(l.id===c.id||b(c)&&b(l))}N(l,c,$){this.y(()=>{const i=new Set;for(const[o,n]of l)i.add(o),c.get(o)!==n&&this.u($,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u($,{key:o,external:!0})})}}e.$Op=h;function b(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class p extends h{constructor(){super(),this.U=this.B(new I.$Ip(new I.$Jp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Ip(new I.$Jp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Ip(new I.$Jp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Qp=p;async function u(g,l,c,$,i,o){const n=w=>{try{return JSON.parse(w)}catch{return w}},s=new Map,t=new Map;g.forEach((w,O)=>{s.set(O,w),t.set(O,n(w))});const r=new Map,a=new Map;l.forEach((w,O)=>{r.set(O,w),a.set(O,n(w))});const y=new Map,E=new Map;c.forEach((w,O)=>{y.set(O,w),E.set(O,n(w))}),console.group($!==i?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const k=[];if(s.forEach((w,O)=>{k.push({key:O,value:w})}),console.table(k),console.groupEnd(),console.log(t),$!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const w=[];r.forEach((O,M)=>{w.push({key:M,value:O})}),console.table(w),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const S=[];y.forEach((w,O)=>{S.push({key:O,value:w})}),console.table(S),console.groupEnd(),console.log(E)}}),define(le[114],he([0,1,3,2,13,29,33,19]),function(se,e,R,N,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KIb=e.$JIb=void 0;let P=class extends N.$Uc{constructor(v,m){super(),this.a=new R.$7d,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(v)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(m.onDidInstallExtensions(f=>f.forEach(({local:h,operation:b})=>{h&&b===4&&this.f(h.identifier)})))}async enableExtension(v,m){return this.f(v)?(this.a.fire({extensions:[v],source:m}),!0):!1}async disableExtension(v,m){return this.c(v)?(this.a.fire({extensions:[v],source:m}),!0):!1}getDisabledExtensions(){return this.h(j.$Vo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(v){const m=this.getDisabledExtensions();return m.every(f=>!(0,D.$gp)(f,v))?(m.push(v),this.g(m),!0):!1}f(v){const m=this.getDisabledExtensions();for(let f=0;f<m.length;f++){const h=m[f];if((0,D.$gp)(h,v))return m.splice(f,1),this.g(m),!0}return!1}g(v){this.j(j.$Vo,v)}h(v){return this.b.get(v,0)}j(v,m){this.b.set(v,m,0)}};e.$JIb=P,e.$JIb=P=ve([X(0,I.$Mp),X(1,j.$Uo)],P);class d extends N.$Uc{constructor(v){super(),this.c=v,this.a=Object.create(null),this.b=this.B(new R.$7d),this.onDidChange=this.b.event,this.B(v.onDidChangeValue(0,void 0,this.B(new N.$Tc))(m=>this.f(m)))}get(v,m){let f;return m===0?((0,A.$5f)(this.a[v])&&(this.a[v]=this.g(v,m)),f=this.a[v]):f=this.g(v,m),JSON.parse(f)}set(v,m,f){const h=JSON.stringify(m.map(({id:p,uuid:u})=>({id:p,uuid:u})));this.g(v,f)!==h&&(f===0&&(m.length?this.a[v]=h:delete this.a[v]),this.h(v,m.length?h:void 0,f))}f(v){if(!(0,A.$5f)(this.a[v.key])&&this.g(v.key,v.scope)!==this.a[v.key]){const f=this.get(v.key,v.scope);delete this.a[v.key];const h=this.get(v.key,v.scope),b=f.filter(u=>!h.some(g=>(0,D.$gp)(u,g))),p=h.filter(u=>!f.some(g=>(0,D.$gp)(g,u)));(b.length||p.length)&&this.b.fire([...b,...p])}}g(v,m){return this.c.get(v,m,"[]")}h(v,m,f){m?this.c.store(v,m,f,1):this.c.remove(v,f)}}e.$KIb=d}),define(le[254],he([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Up=ae;const i=j.$o?"web":(0,v.$No)(j.$u,D.$fc),o="X-Market-Search-Activity-Id";var n;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...F){return String(F.reduce((z,Y)=>z|Y,0))}var t;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class k{constructor(z=E){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,Y=this.d.pageSize){return new k({...this.d,pageNumber:z,pageSize:Y})}withFilter(z,...Y){const J=[...this.d.criteria,...Y.length?Y.map(ee=>({filterType:z,value:ee})):[{filterType:z}]];return new k({...this.d,criteria:J})}withSortBy(z){return new k({...this.d,sortBy:z})}withSortOrder(z){return new k({...this.d,sortOrder:z})}withFlags(...z){return new k({...this.d,flags:z.reduce((Y,J)=>Y|J,0)})}withAssetTypes(...z){return new k({...this.d,assetTypes:z})}withSource(z){return new k({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:Y,pageSize:J,sortBy:ee,sortOrder:x,flags:Q,assetTypes:ne}=this.d;return{filters:[{criteria:z,pageNumber:Y,pageSize:J,sortBy:ee,sortOrder:x}],assetTypes:ne,flags:Q}}get searchText(){const z=this.d.criteria.filter(Y=>Y.filterType===t.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(F,z){const Y=(F||[]).filter(J=>J.statisticName===z)[0];return Y?Y.value:0}function w(F){const z="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(J=>J.assetType.indexOf(z)===0).reduce((J,ee)=>{const x=T(F,ee.assetType);return x&&J.push([ee.assetType.substring(z.length),x]),J},[])}function O(F){if(F.properties){const z=F.properties.filter(ee=>ee.key===r.Repository),Y=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=z.filter(ee=>Y.test(ee.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return T(F,r.Repository)}function M(F){return{uri:`${F.fallbackAssetUri}/${r.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${r.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function T(F,z){return F.files.filter(J=>J.assetType===z)[0]?{uri:`${F.assetUri}/${z}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${z}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function U(F,z){const Y=F.properties?F.properties.filter(ee=>ee.key===z):[],J=Y.length>0&&Y[0].value;return J?J.split(",").map(ee=>(0,m.$kp)(ee)):[]}function _(F){const z=F.properties?F.properties.filter(Y=>Y.key===a.Engine):[];return z.length>0&&z[0].value||""}function G(F){const z=F.properties?F.properties.filter(Y=>Y.key===a.PreRelease):[];return z.length>0&&z[0].value==="true"}function Z(F){const z=F.properties?F.properties.filter(J=>J.key===a.LocalizedLanguages):[],Y=z.length>0&&z[0].value||"";return Y?Y.split(","):[]}function V(F){return F.properties?.find(z=>z.key===a.SponsorLink)?.value}function K(F){return F.properties?.find(z=>z.key===a.SupportLink)?.value}function W(F){return F.indexOf("preview")!==-1}function B(F){return F.targetPlatform?(0,v.$Mo)(F.targetPlatform):"undefined"}function ie(F){const z=(0,R.$Mb)(F.versions.map(B)),Y=!!F.tags?.includes(v.$Ho),J=z.indexOf("web");return Y?J===-1&&z.push("web"):J!==-1&&z.splice(J,1),z}function ae(F,z){for(let Y=0;Y<F.length;Y++){const J=F[Y];if(J.version===F[Y-1]?.version){let ee=Y;if(B(J)===z)for(;ee>0&&F[ee-1].version===J.version;)ee--;ee!==Y&&(F.splice(Y,1),F.splice(ee,0,J))}}return F}function te(F,z,Y){F.telemetryData={index:z,querySource:Y,queryActivityId:F.queryContext?.[o]}}function ce(F,z,Y,J){const ee=F.versions[0],x={manifest:T(z,r.Manifest),readme:T(z,r.Details),changelog:T(z,r.Changelog),license:T(z,r.License),repository:O(z),download:M(z),icon:T(z,r.Icon),signature:T(z,r.Signature),coreTranslations:w(z)};return{identifier:{id:(0,m.$lp)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:z.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(ee),description:F.shortDescription??"",installCount:S(F.statistics,"install"),rating:S(F.statistics,"averagerating"),ratingCount:S(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:Y,assets:x,properties:{dependencies:U(z,a.Dependency),extensionPack:U(z,a.ExtensionPack),engine:_(z),localizedLanguages:Z(z),targetPlatform:B(z),isPreReleaseVersion:G(z)},hasPreReleaseVersion:G(ee),hasReleaseVersion:!0,preview:W(F.flags),isSigned:!!x.signature,queryContext:J,supportLink:K(ee)}}let H=class{constructor(z,Y,J,ee,x,Q,ne,re){this.k=Y,this.l=J,this.n=ee,this.o=x,this.q=Q,this.u=ne,this.w=re;const ue=ne.extensionsGallery,de=ue?.servicePPEUrl&&re.getValue("_extensionsGallery.enablePPE");this.d=de?ue.servicePPEUrl:ue?.serviceUrl,this.g=de?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,g.$Tp)(ne.version,ne,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,Y,J){const ee=N.CancellationToken.isCancellationToken(Y)?{}:Y,x=N.CancellationToken.isCancellationToken(Y)?Y:J,Q=[],ne=[],re=[],ue=[];let de=!0;for(const Se of z){Se.uuid?ne.push(Se.uuid):Q.push(Se.id);const Re=!!(Se.version||Se.preRelease);re.push({id:Se.id,uuid:Se.uuid,includePreRelease:Re}),Se.version&&ue.push({id:Se.id,uuid:Se.uuid,version:Se.version}),de=de&&!!Se.hasPreRelease&&!Re}if(!ne.length&&!Q.length)return[];let $e=new k().withPage(1,z.length);ne.length&&($e=$e.withFilter(t.ExtensionId,...ne)),Q.length&&($e=$e.withFilter(t.ExtensionName,...Q)),(ee.queryAllVersions||de)&&($e=$e.withFlags($e.flags,n.IncludeVersions)),ee.source&&($e=$e.withSource(ee.source));const{extensions:ye}=await this.z($e,{targetPlatform:ee.targetPlatform??i,includePreRelease:re,versions:ue,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},x);return ee.source&&ye.forEach((Se,Re)=>te(Se,Re,ee.source)),ye}async getCompatibleExtension(z,Y,J,ee={version:this.u.version,date:this.u.date}){if((0,v.$Oo)(z.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(z,Y,J))return z;const x=new k().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,z.identifier.uuid),{extensions:Q}=await this.z(x,{targetPlatform:J,compatible:!0,includePreRelease:Y,productVersion:ee},N.CancellationToken.None);return Q[0]||null}async isExtensionCompatible(z,Y,J,ee={version:this.u.version,date:this.u.date}){if(!(0,v.$Po)(z.properties.targetPlatform,z.allTargetPlatforms,J)||!Y&&z.properties.isPreReleaseVersion)return!1;let x=z.properties.engine;if(!x){const Q=await this.getManifest(z,N.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");x=Q.engines.vscode}return(0,f.$yp)(x,ee.version,ee.date)}async y(z,Y,J,ee,x,Q,ne={version:this.u.version,date:this.u.date}){if(!(0,v.$Po)(B(Y),x,Q)||J!=="any"&&G(Y)!==(J==="prerelease"))return!1;if(ee)try{const re=await this.E(z,Y);if(!(0,f.$yp)(re,ne.version,ne.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${Y.version}.`,(0,A.$0)(re)),!1}return!0}async query(z,Y){let J=z.text||"";const ee=z.pageSize??50;let x=new k().withPage(1,ee);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,$e,ye)=>(x=x.withFilter(t.Category,ye||$e),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,$e,ye)=>(x=x.withFilter(t.Tag,ye||$e),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(x=x.withFilter(t.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),x=x.withFilter(t.SearchText,J)),x=x.withSortBy(0)):z.ids?x=x.withFilter(t.ExtensionId,...z.ids):z.names?x=x.withFilter(t.ExtensionName,...z.names):x=x.withSortBy(4),typeof z.sortBy=="number"&&(x=x.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(x=x.withSortOrder(z.sortOrder)),z.source&&(x=x.withSource(z.source));const Q=async(de,$e)=>{const{extensions:ye,total:Se}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},$e);return ye.forEach((Re,Le)=>te(Re,(de.pageNumber-1)*de.pageSize+Le,z.source)),{extensions:ye,total:Se}},{extensions:ne,total:re}=await Q(x,Y),ue=async(de,$e)=>{if($e.isCancellationRequested)throw new A.$5;const{extensions:ye}=await Q(x.withPage(de+1),$e);return ye};return{firstPage:ne,total:re,pageSize:x.pageSize,getPage:ue}}async z(z,Y,J){const ee=z.flags;z.flags&n.IncludeLatestVersionOnly&&z.flags&n.IncludeVersions&&(z=z.withFlags(z.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(z.flags&n.IncludeLatestVersionOnly)&&!(z.flags&n.IncludeVersions)&&(z=z.withFlags(z.flags,n.IncludeLatestVersionOnly)),Y.versions?.length&&(z=z.withFlags(z.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),z=z.withFlags(z.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:x,total:Q,context:ne}=await this.B(z,J);if(!(z.flags&n.IncludeLatestVersionOnly)){const $e=[];for(const ye of x){const Se=await this.A(ye,Y,ne);Se&&$e.push(Se)}return{extensions:$e,total:Q}}const ue=[],de=new Map;for(let $e=0;$e<x.length;$e++){const ye=x[$e],Se={id:(0,m.$lp)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Re=(0,I.$2f)(Y.includePreRelease)?Y.includePreRelease:!!Y.includePreRelease.find(fe=>(0,m.$gp)(fe,Se))?.includePreRelease;if(Y.compatible&&(0,v.$Oo)(ie(ye),Y.targetPlatform))continue;const Le=await this.A(ye,Y,ne);!Le||Le.properties.isPreReleaseVersion&&(!Re||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==Y.targetPlatform&&Le.hasPreReleaseVersion?de.set(ye.extensionId,$e):ue.push([$e,Le])}if(de.size){const $e=new $.$3d,ye=new k().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Se}=await this.z(ye,Y,J);this.o.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:de.size});for(const Re of Se){const Le=de.get(Re.identifier.uuid);ue.push([Le,Re])}}return{extensions:ue.sort(($e,ye)=>$e[0]-ye[0]).map(([,$e])=>$e),total:Q}}async A(z,Y,J){const ee={id:(0,m.$lp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},x=Y.versions?.find(ue=>(0,m.$gp)(ue,ee))?.version,Q=(0,I.$2f)(Y.includePreRelease)?Y.includePreRelease:!!Y.includePreRelease.find(ue=>(0,m.$gp)(ue,ee))?.includePreRelease,ne=ie(z),re=ae(z.versions,Y.targetPlatform);if(Y.compatible&&(0,v.$Oo)(ne,Y.targetPlatform))return null;for(let ue=0;ue<re.length;ue++){const de=re[ue];if(!(x&&de.version!==x)){if(await this.y((0,m.$lp)(z.publisher.publisherName,z.extensionName),de,Q?"any":"release",Y.compatible,ne,Y.targetPlatform,Y.productVersion))return ce(z,de,ne,J);if(x&&de.version===x)return null}}return x||Y.compatible?null:ce(z,z.versions[0],ne)}async B(z,Y){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const J=await this.j,ee=JSON.stringify(z.raw),x={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Q=new $.$3d;let ne,re,ue=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&z.criteria.some($e=>$e.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:x},Y),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,u.$Fp)(ne);if(de){const $e=de.results[0],ye=$e.extensions,Se=$e.resultMetadata&&$e.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return ue=Se&&Se.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ue,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(de){const $e=(0,A.$4)(de)?v.ExtensionGalleryErrorCode.Cancelled:(0,A.$0)(de).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw re=new v.$To((0,A.$0)(de),$e),re}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(ee.length),duration:Q.elapsed(),success:!!ne&&(0,u.$Bp)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:re?.code,count:String(ue)})}}async reportStatistic(z,Y,J,ee){if(!this.isEnabled())return;const x=j.$o?this.x(`/itemName/${z}.${Y}/version/${J}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${Y}/${J}/stats?statType=${ee}`),Q=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.j,Accept:Q};try{await this.k.request({type:"POST",url:x,headers:re},N.CancellationToken.None)}catch{}}async download(z,Y,J){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const ee=(0,m.$op)(z),x=new Date().getTime(),Q=$e=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:$e}),ne=J===2?"install":J===3?"update":"",re=ne?{uri:`${z.assets.download.uri}${P.URI.parse(z.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${z.assets.download.fallbackUri}${P.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:z.assets.download,ue=z.queryContext?.[o]?{[o]:z.queryContext[o]}:void 0,de=await this.D(z.identifier.id,re,r.VSIX,ue?{headers:ue}:void 0);await this.q.writeFile(Y,de.stream),Q(new Date().getTime()-x)}async downloadSignatureArchive(z,Y){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const J=await this.D(z.identifier.id,z.assets.signature,r.Signature);await this.q.writeFile(Y,J.stream)}async getReadme(z,Y){if(z.assets.readme){const J=await this.D(z.identifier.id,z.assets.readme,r.Details,{},Y);return await(0,u.$Ep)(J)||""}return""}async getManifest(z,Y){if(z.assets.manifest){const J=await this.D(z.identifier.id,z.assets.manifest,r.Manifest,{},Y),ee=await(0,u.$Ep)(J);return ee?JSON.parse(ee):null}return null}async C(z,Y,J){const ee=T(Y,r.Manifest);if(!ee)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},Q=await this.D(z,ee,r.Manifest,{headers:x});return await(0,u.$Fp)(Q)}async getCoreTranslation(z,Y){const J=z.assets.coreTranslations.filter(ee=>ee[0]===Y.toUpperCase())[0];if(J){const ee=await this.D(z.identifier.id,J[1],J[0]),x=await(0,u.$Ep)(ee);return x?JSON.parse(x):null}return null}async getChangelog(z,Y){if(z.assets.changelog){const J=await this.D(z.identifier.id,z.assets.changelog,r.Changelog,{},Y);return await(0,u.$Ep)(J)||""}return""}async getAllCompatibleVersions(z,Y,J){let ee=new k().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?ee=ee.withFilter(t.ExtensionId,z.identifier.uuid):ee=ee.withFilter(t.ExtensionName,z.identifier.id);const{galleryExtensions:x}=await this.B(ee,N.CancellationToken.None);if(!x.length)return[];const Q=ie(x[0]);if((0,v.$Oo)(Q,J))return[];const ne=[];await Promise.all(x[0].versions.map(async de=>{try{await this.y(z.identifier.id,de,Y?"any":"release",!0,Q,J)&&ne.push(de)}catch{}}));const re=[],ue=new Set;for(const de of ae(ne,J))ue.has(de.version)||(ue.add(de.version),re.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:G(de)}));return re}async D(z,Y,J,ee={},x=N.CancellationToken.None){const Q=await this.j,ne={type:"GET"},re={...Q,...ee.headers||{}};ee={...ee,...ne,headers:re};const ue=Y.uri,de=Y.fallbackUri,$e={...ee,url:ue};try{const ye=await this.k.request($e,x);if(ye.res.statusCode===200)return ye;const Se=await(0,u.$Ep)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${Se}`)}catch(ye){if((0,A.$4)(ye))throw ye;const Se=(0,A.$0)(ye);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:J,message:Se});const Re={...ee,url:de};return this.k.request(Re,x)}}async E(z,Y){let J=_(Y);if(!J){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:Y.version});const ee=await this.C(z,Y,N.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");J=ee.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const Y=await(0,u.$Fp)(z),J=[],ee={},x=[];if(Y){for(const Q of Y.malicious)J.push({id:Q});if(Y.migrateToPreRelease)for(const[Q,ne]of Object.entries(Y.migrateToPreRelease))(!ne.engine||(0,f.$yp)(ne.engine,this.u.version,this.u.date))&&(ee[Q.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(Y.deprecated)for(const[Q,ne]of Object.entries(Y.deprecated))ne&&(ee[Q.toLowerCase()]=(0,I.$2f)(ne)?{}:ne);if(Y.search)for(const Q of Y.search)x.push(Q)}return{malicious:J,deprecated:ee,search:x}}};H=ve([X(1,u.$zp),X(2,b.$Oj),X(3,C.$pi),X(4,c.$Nl),X(5,h.$Ok),X(6,p.$8j),X(7,d.$Oi)],H);let q=class extends H{constructor(z,Y,J,ee,x,Q,ne,re){super(z,Y,J,ee,x,Q,ne,re)}};e.$Vp=q,e.$Vp=q=ve([X(0,l.$Mp),X(1,u.$zp),X(2,b.$Oj),X(3,C.$pi),X(4,c.$Nl),X(5,h.$Ok),X(6,p.$8j),X(7,d.$Oi)],q);let L=class extends H{constructor(z,Y,J,ee,x,Q,ne){super(void 0,z,Y,J,ee,x,Q,ne)}};e.$Wp=L,e.$Wp=L=ve([X(0,u.$zp),X(1,b.$Oj),X(2,C.$pi),X(3,c.$Nl),X(4,h.$Ok),X(5,p.$8j),X(6,d.$Oi)],L)}),define(le[82],he([0,1,4,3,2,19,33,24,17,9,13]),function(se,e,R,N,A,j,D,I,P,d,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=void 0,e.$Iv=(0,R.$ii)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class extends A.$Uc{static{v=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,D.$kp)(b.id)}@${b.version}`}static c(b){const p=m.exec(b);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(b,p){const u=await b.getInstalled(),g=[];for(const[l,c]of v.f(p)){const $=u.find(i=>(0,D.$gp)(i.identifier,{id:l}))?.manifest.version;for(const i of c)$!==i&&g.push(v.b({id:l,version:i}))}for(const l of g)p.remove(l,0)}static f(b){const p=new Map,u=b.keys(0,1);for(const g of u){const l=v.c(g);if(l){let c=p.get(l.id.toLowerCase());c||p.set(l.id.toLowerCase(),c=[]),c.push(l.version)}}return p}constructor(b,p,u){super(),this.j=b,this.m=p,this.n=u,this.g=this.B(new N.$7d),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=v.f(b),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$Tc))(g=>this.r(g)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const p=v.c(b.key);if(p){if(this.j.get(b.key,0)===void 0)this.h.delete(p.id.toLowerCase());else{let u=this.h.get(p.id.toLowerCase());u||this.h.set(p.id.toLowerCase(),u=[]),u.push(p.version),this.g.fire()}return}}s(b){if((0,C.$Vf)(b))return b;const p=b.manifest?b.manifest.publisher:b.publisher,u=b.manifest?b.manifest.name:b.name;return(0,D.$jp)(p,u)}getExtensionState(b,p){const u=this.s(b),g=this.getExtensionStateRaw(b,p);if(g)try{return JSON.parse(g)}catch(l){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${p}): ${l}`)}}getExtensionStateRaw(b,p){const u=this.s(b),g=this.j.get(u,p?0:1);return g&&g?.length>v.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${p}): ${g.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),g}setExtensionState(b,p,u){const g=this.s(b);p===void 0?this.j.remove(g,u?0:1):this.j.store(g,JSON.stringify(p),u?0:1,1)}setKeysForSync(b,p){this.j.store(v.b(b),JSON.stringify(p),0,1)}getKeysForSync(b){const p=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],u=this.j.get(v.b(b),0),g=u?JSON.parse(u):void 0;return g&&p?(0,P.$Mb)([...g,...p]):g||p}addToMigrationList(b,p){if(b!==p){const u=this.t.filter(g=>!g.includes(b)&&!g.includes(p));u.push([b,p]),this.t=u}}getSourceExtensionToMigrate(b){const p=this.t.find(([,u])=>b===u);return p?p[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",-1,"[]");try{const p=JSON.parse(b);if(Array.isArray(p))return p}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Jv=f,e.$Jv=f=v=ve([X(0,j.$Mp),X(1,I.$8j),X(2,d.$Oj)],f)}),define(le[255],he([0,1,2,29,82,230,113,9,19]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;let d=class extends R.$Uc{constructor(v,m,f,h,b,p){super(),v.cleanUp(),(0,j.$f3b)(v,m,f,h,p),A.$Jv.removeOutdatedExtensionVersions(v,b)}};e.$Ycc=d,e.$Ycc=d=ve([X(0,D.$pq),X(1,N.$Ro),X(2,A.$Iv),X(3,N.$Xo),X(4,P.$Mp),X(5,I.$Oj)],d)}),define(le[256],he([0,1,29,12,24,16,96,57,19,22,229]),function(se,e,R,N,A,j,D,I,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;let v=class extends C.$i_b{constructor(f,h,b,p,u,g,l,c){super(f.userHome,u,h,b,p,g,l,c)}};e.$6cc=v,e.$6cc=v=ve([X(0,j.$qi),X(1,d.$Nl),X(2,R.$Uo),X(3,P.$Mp),X(4,I.$Vac),X(5,D.$22b),X(6,N.$Ok),X(7,A.$8j)],v)}),define(le[257],he([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;const $=[R.$Ucc,R.$Vcc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends D.$Uc{constructor(a,y,E,k,S,w,O){super(),this.y=a,this.z=y,this.C=E,this.D=w,this.F=O,this.f=new N.$7d,this.onDidTokenFailed=this.f.event,this.g=new N.$7d,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$7d,this.onDidChangeMode=this.h.event,this.n=R.$Scc,this.w=!1,this.I=(M,T)=>{T?this.j.error(M):this.j.info(M)},this.j=this.B(k.createLogger((0,c.$Vg)(E.logsHome,`${R.$Wcc}.log`),{id:R.$Wcc,name:R.$Xcc})),this.t=new m.$fh(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,I.$4j)(M)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(w.onDidChangeConfiguration(M=>{$.some(T=>M.affectsConfiguration(T))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}J(){if(!this.u){let a;v.$j?a=this.C.appRoot:a=(0,P.$nc)((0,P.$nc)(this.C.appRoot)),this.u=(0,P.$kc)(a,"bin",`${this.z.tunnelApplicationName}${v.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(R.$Scc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(y){this.j.error(y)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",y=!1;const E=(T,U)=>{U?this.j.error(T):a+=T,!this.C.isBuilt&&T.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,b.localize)(0,null)))},k=this.O("status",["status"],E);this.r=k;try{if(await k,this.r!==k)return;let T;try{T=JSON.parse(a.trim().split(`
`).find(U=>U.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(R.TunnelStates.disconnected());return}if(y=T.service_installed,this.j.info(T.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!T.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(T){this.j.error(T),this.G(R.TunnelStates.disconnected());return}finally{this.r===k&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const T=S.token;this.G(R.TunnelStates.connecting((0,b.localize)(1,null,S.accountLabel,S.providerId)));const U=(G,Z)=>{G=G.replaceAll(T,"*".repeat(4)),E(G,Z)},_=this.O("login",["user","login","--provider",S.providerId,"--access-token",T,"--log",(0,I.$4j)(this.j.getLevel())],U);this.r=_;try{if(await _,this.r!==_)return}catch(G){this.j.error(G),this.r=void 0,this.f.fire(S),this.G(R.TunnelStates.disconnected(S));return}}const w=this.Q();w?this.G(R.TunnelStates.connecting((0,b.localize)(2,null,w))):this.G(R.TunnelStates.connecting((0,b.localize)(3,null)));const O=["--accept-server-license-terms","--log",(0,I.$4j)(this.j.getLevel())];w?O.push("--name",w):O.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!y&&(M=await this.M(O)===!1),this.N(S,O,M)}async M(a){let y;try{y=await this.O("serviceInstall",["service","install",...a])}catch(E){this.j.error(E),y=1}if(y!==0){const E=(0,b.localize)(4,null);return this.j.warn(E),this.G(R.TunnelStates.connecting(E)),!1}return!0}async N(a,y,E){y.push("--parent-process-id",String(process.pid)),this.P()&&y.push("--no-sleep");let k=!1;const S=this.O("tunnel",y,(w,O)=>{O?this.j.error(w):this.j.info(w),w.includes("Connected to an existing tunnel process")&&(k=!0);const M=w.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const T={link:M[1],domain:M[2],tunnelName:M[4],isAttached:k};this.G(R.TunnelStates.connected(T,E))}else w.match(/error refreshing token/)&&(S.cancel(),this.f.fire(a),this.G(R.TunnelStates.disconnected(a)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$Scc,this.G(R.TunnelStates.disconnected()))})}O(a,y,E=this.I){return(0,m.$8g)(k=>new Promise((S,w)=>{k.isCancellationRequested&&S(-1);let O;const M=["ignore","pipe","pipe"];if(k.onCancellationRequested(()=>{O&&(this.j.info(`${a} terminating(${O.pid})`),O.kill())}),!this.C.isBuilt)E(`Building tunnel CLI from sources and run
`,!1),E(`${a} Spawning: cargo run -- tunnel ${y.join(" ")}
`,!1),O=(0,d.spawn)("cargo",["run","--","tunnel",...y],{cwd:(0,P.$kc)(this.C.appRoot,"cli"),stdio:M});else{E(`Running tunnel CLI
`,!1);const T=this.J();E(`${a} Spawning: ${T} tunnel ${y.join(" ")}
`,!1),O=(0,d.spawn)(T,["tunnel",...y],{cwd:(0,p.homedir)(),stdio:M})}O.stdout.pipe(new l.$6V(`
`)).on("data",T=>{if(O){const U=T.toString();E(U,!1)}}),O.stderr.pipe(new l.$6V(`
`)).on("data",T=>{if(O){const U=T.toString();E(U,!0)}}),O.on("exit",T=>{O&&(E(`${a} exit(${O.pid}): + ${T} `,!1),O=void 0,S(T||0))}),O.on("error",T=>{O&&(E(`${a} error(${O.pid}): + ${T} `,!0),O=void 0,w())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Vcc)}Q(){let a=this.D.getValue(R.$Ucc)||(0,p.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),y=this.F.getBoolean(o,-1,!1);if(a){const E=JSON.parse(a);if(E&&(0,g.$Vf)(E.accountLabel)&&(0,g.$Vf)(E.sessionId)&&(0,g.$Vf)(E.providerId))return{active:!0,session:E,asService:y};this.j.error("Problems restoring session from storage, invalid format",E)}}catch(a){this.j.error("Problems restoring session from storage",a)}return R.$Scc}S(a){if(a.active){const y={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(y),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$2cc=n,e.$2cc=n=ve([X(0,A.$Nl),X(1,C.$8j),X(2,j.$qi),X(3,I.$Pj),X(4,f.$Zcc),X(5,h.$Oi),X(6,u.$Mp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[258],he([0,1,6,2,23,20,69,19,77,18]),function(se,e,R,N,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=void 0;class C extends I.$Op{constructor(m,f,h,b){super(),this.bb=m,this.cb=f,this.db=h,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Tc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new P.$hJb(this.db.getChannel("storage"))),f=this.B(new D.$Ip(m));return this.B(f.onDidChangeStorage(h=>this.u(-1,h))),f}gb(m){this.X.clear(),this.W=m;let f;if((0,I.$Pp)(m))f=this.U;else{const h=this.X.add(new P.$iJb(this.db.getChannel("storage"),m));f=this.X.add(new D.$Ip(h))}return this.X.add(f.onDidChangeStorage(h=>this.u(0,h))),f}hb(m){this.$.clear(),this.Z=m?.id;let f;if(m){const h=this.$.add(new P.$jJb(this.db.getChannel("storage"),m));f=this.$.add(new D.$Ip(h)),this.$.add(f.onDidChangeStorage(b=>this.u(1,b)))}return f}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(m){switch(m){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$Vg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const f=this.Y,h=f.items;f!==this.U&&await f.close(),this.Y=this.gb(m),await this.Y.init(),this.N(h,this.Y,0)}async S(m,f){const h=this.ab,b=h?.items??new Map;await h?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(b,this.ab,1)}hasScope(m){return(0,d.$nl)(m)?this.W.id===m.id:this.Z===m.id}}e.$7cc=C}),define(le[259],he([0,1,3,2,18,91]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=void 0;class D{constructor(d,C){this.a=d,this.b=C}listen(d,C){const v=this.b(d);switch(C){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(f=>(0,j.$mn)({...f},v)),added:m.added.map(f=>(0,j.$mn)({...f},v)),removed:m.removed.map(f=>(0,j.$mn)({...f},v)),updated:m.updated.map(f=>(0,j.$mn)({...f},v))}))}throw new Error(`Invalid listen ${C}`)}async call(d,C,v){const m=this.b(d);switch(C){case"createProfile":{const f=await this.a.createProfile(v[0],v[1],v[2]);return(0,j.$mn)({...f},m)}case"updateProfile":{let f=(0,A.$pl)((0,j.$nn)(v[0],m),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,v[1]),(0,j.$mn)({...f},m)}case"removeProfile":{const f=(0,A.$pl)((0,j.$nn)(v[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${C}`)}}e.$dQ=D;class I extends N.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,C,v){super(),this.profilesHome=C,this.f=v,this.a=[],this.b=this.B(new R.$7d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(m=>(0,A.$pl)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const f=m.added.map(p=>(0,A.$pl)(p,this.profilesHome.scheme)),h=m.removed.map(p=>(0,A.$pl)(p,this.profilesHome.scheme)),b=m.updated.map(p=>(0,A.$pl)(p,this.profilesHome.scheme));this.a=m.all.map(p=>(0,A.$pl)(p,this.profilesHome.scheme)),this.b.fire({added:f,removed:h,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,C,v){const m=await this.f.call("createNamedProfile",[d,C,v]);return(0,A.$pl)(m,this.profilesHome.scheme)}async createProfile(d,C,v,m){const f=await this.f.call("createProfile",[d,C,v,m]);return(0,A.$pl)(f,this.profilesHome.scheme)}async createTransientProfile(d){const C=await this.f.call("createTransientProfile",[d]);return(0,A.$pl)(C,this.profilesHome.scheme)}async setProfileForWorkspace(d,C){await this.f.call("setProfileForWorkspace",[d,C])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,C){const v=await this.f.call("updateProfile",[d,C]);return(0,A.$pl)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$eQ=I}),define(le[60],he([0,1,2,69,4,19,3,77,18]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJb=e.$mJb=e.$lJb=void 0,e.$lJb=(0,A.$ii)("IUserDataProfileStorageService");let d=class extends R.$Uc{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async h=>this.b(h))}async updateStorageData(f,h,b){return this.withProfileScopedStorageService(f,async p=>this.c(p,h,b))}async withProfileScopedStorageService(f,h){if(this.a.hasScope(f))return h(this.a);const b=await this.g(f),p=new v(b);try{await p.initialize();const u=await h(p);return await p.flush(),u}finally{p.dispose(),await this.f(b)}}b(f){const h=new Map,b=p=>{for(const u of f.keys(0,p))h.set(u,{value:f.get(u,0),target:p})};return b(0),b(1),h}c(f,h,b){f.storeAll(Array.from(h.entries()).map(([p,u])=>({key:p,value:u,scope:0,target:b})),!0)}async f(f){try{await f.close()}finally{(0,R.$Oc)(f)&&f.dispose()}}};e.$mJb=d,e.$mJb=d=ve([X(0,j.$Mp)],d);class C extends d{constructor(f,h,b,p){super(b),this.j=f;const u=f.getChannel("profileStorageListener"),g=this.B(new R.$Vc);this.h=this.B(new D.$7d({onWillAddFirstListener:()=>{g.value=u.listen("onDidChange")(l=>{p.trace("profile storage changes",l),this.h.fire({targetChanges:l.targetChanges.map(c=>(0,P.$pl)(c,h.profilesHome.scheme)),valueChanges:l.valueChanges.map(c=>({...c,profile:(0,P.$pl)(c.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>g.value=void 0})),this.onDidChange=this.h.event}async g(f){const h=this.j.getChannel("storage");return(0,j.$Pp)(f)?new I.$hJb(h):new I.$iJb(h,f)}}e.$nJb=C;class v extends j.$Op{constructor(f){super({flushInterval:100}),this.s=this.B(new N.$Ip(f))}O(){return this.s.init()}P(f){return f===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[260],he([0,1,19,9,18,56,60]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;let I=class extends D.$nJb{constructor(d,C,v,m){super(d,C,v,m)}};e.$Lcc=I,e.$Lcc=I=ve([X(0,j.$$bc),X(1,A.$ol),X(2,R.$Mp),X(3,N.$Oj)],I)}),define(le[39],he([0,1,17,6,15,26,3,34,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mKb=e.$lKb=e.$kKb=e.$jKb=void 0,e.$gKb=i,e.$hKb=o,e.$iKb=n;function i(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||o(y.syncData)))}function o(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}function n(y,E){return`${(0,d.$Nf)(y)}${E.isDefault?"":` (${E.name})`}`}let s=class extends P.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(E,k,S,w,O,M,T,U,_,G,Z,V){super(),this.syncResource=E,this.collection=k,this.G=S,this.H=w,this.I=O,this.J=M,this.L=T,this.M=U,this.N=_,this.O=G,this.P=Z,this.c=null,this.m="idle",this.n=this.B(new D.$7d),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new D.$7d),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$gh(50)),this.w=this.B(new D.$7d),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(E.syncResource,E.profile),this.h=V.extUri,this.f=this.h.joinPath(w.userDataSyncHome,...(0,c.$rpb)(E.profile.isDefault?void 0:E.profile.id,E.syncResource)),this.g=this.h.joinPath(this.f,c.$Mpb),this.y=(0,c.$spb)(E.profile.isDefault?void 0:E.profile.id,E.syncResource,w,this.h),this.j=(0,p.$Sp)(w,S,O)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const E=await this.c;this.c=null;const k=await this.Y(E.remoteUserData,E.lastSyncUserData,!0,this.ob());this.S(k)}else{this.O.trace(`${this.D}: Checking for local changes...`);const E=await this.getLastSyncUserData();(E?await this.ub(E):!0)&&this.w.fire()}}S(E){this.m!==E&&(this.m=E,this.n.fire(E))}async sync(E,k={}){await this.U(E,!0,this.ob(),k)}async preview(E,k,S={}){return this.U(E,!1,k,S)}async apply(E,k={}){try{this.F={...k};const S=await this.ab(E);return this.S(S),this.c}finally{this.F={}}}async U(E,k,S,w){try{if(this.F={...w},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let O="idle";try{const M=await this.getLastSyncUserData(),T=await this.X(E,M);return O=await this.Y(T,M,k,S),O==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(O)}}finally{this.F={}}}async replace(E){const k=this.kb(E);if(!k)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const S=await this.getLastSyncUserData(),w=await this.X(null,S),O=await this.W(w),M=await this.qb({ref:w.ref,syncData:k},S,O,this.ob(),j.CancellationToken.None),T=[];for(const U of M){const _=await this.sb(U,U.remoteResource,void 0,j.CancellationToken.None),{remoteChange:G}=await this.sb(U,U.previewResource,U.remoteContent,j.CancellationToken.None);T.push([U,{..._,remoteChange:G!==0?G:2}])}await this.tb(w,S,T,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(E){const k=await this.j;return!!E.syncData?.machineId&&E.syncData.machineId===k}async X(E,k){if(k){const S=E?E[this.resource]:void 0;if(k.ref===S||S===void 0&&k.syncData===null)return k}return this.getRemoteUserData(k)}async Y(E,k,S,w){if(E.syncData&&E.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$zpb((0,v.localize)(0,null,this.resource,this.pb,E.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(E,k,S,w)}catch(O){if(O instanceof c.$zpb)switch(O.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(E,k,S,w);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),E=await this.getRemoteUserData(null),k=await this.getLastSyncUserData(),this.Y(E,k,S,w)}throw O}}async Z(E,k,S,w){try{const O=await this.W(E),M=!O&&k===null&&this.gb()!==void 0,T=S&&!M;this.c||(this.c=(0,N.$8g)(_=>this.eb(E,k,O,T,w,_)));let U=await this.c;if(S&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const _ of U.resourcePreviews)U=await this.accept(_.remoteResource)||U}return this.cb(U.resourcePreviews),U.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":S?await this.ab(!1):"syncing"}catch(O){throw this.c=null,O}}async merge(E){return await this.$(E,async k=>{const S=await this.rb(k,j.CancellationToken.None);await this.G.writeFile(k.previewResource,A.$ue.fromString(S?.content||""));const w=S&&!S.hasConflicts?await this.sb(k,k.previewResource,void 0,j.CancellationToken.None):void 0;return k.acceptResult=w,k.mergeState=S.hasConflicts?"conflict":w?"accepted":"preview",k.localChange=w?w.localChange:S.localChange,k.remoteChange=w?w.remoteChange:S.remoteChange,k}),this.c}async accept(E,k){return await this.$(E,async S=>{const w=await this.sb(S,E,k,j.CancellationToken.None);return S.acceptResult=w,S.mergeState="accepted",S.localChange=w.localChange,S.remoteChange=w.remoteChange,S}),this.c}async discard(E){return await this.$(E,async k=>{const S=await this.rb(k,j.CancellationToken.None);return await this.G.writeFile(k.previewResource,A.$ue.fromString(S.content||"")),k.acceptResult=void 0,k.mergeState="preview",k.localChange=S.localChange,k.remoteChange=S.remoteChange,k}),this.c}async $(E,k){if(!this.c)return;let S=await this.c;const w=S.resourcePreviews.findIndex(({localResource:O,remoteResource:M,previewResource:T})=>this.h.isEqual(O,E)||this.h.isEqual(M,E)||this.h.isEqual(T,E));w!==-1&&(this.c=(0,N.$8g)(async O=>{const M=[...S.resourcePreviews];return M[w]=await k(M[w]),{...S,resourcePreviews:M}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(E){if(!this.c)return"idle";const k=await this.c;return k.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":k.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.tb(k.remoteUserData,k.lastSyncUserData,k.resourcePreviews.map(S=>[S,S.acceptResult]),E),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(E){const k=E.filter(({mergeState:S})=>S==="conflict");(0,R.$ub)(this.s,k,(S,w)=>this.h.isEqual(S.previewResource,w.previewResource))||(this.s=k,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const E=await this.getLastSyncUserData();return!!E&&E.syncData!==null}async db(E){const k=this.c?await this.c:null;if(k)for(const S of k.resourcePreviews){if(this.h.isEqual(S.acceptedResource,E))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,E))return S.remoteContent;if(this.h.isEqual(S.localResource,E))return S.localContent;if(this.h.isEqual(S.baseResource,E))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(E){(0,h.$6k)(E)!==1&&this.O.error(E)}}async eb(E,k,S,w,O,M){const T=await this.qb(E,k,S,O,M),U=[];for(const _ of T){const G=_.previewResource.with({scheme:c.$Lpb,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)U.push({..._,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Z=w?await this.rb(_,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(_.previewResource,A.$ue.fromString(Z?.content||""));const V=Z&&!Z.hasConflicts?await this.sb(_,_.previewResource,void 0,M):void 0;U.push({..._,acceptResult:V,mergeState:Z?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:Z?Z.localChange:_.localChange,remoteChange:V?V.remoteChange:Z?Z.remoteChange:_.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:E,lastSyncUserData:k,resourcePreviews:U,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let E=this.gb();if(E||(E=await this.jb()),!E)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const k=JSON.parse(E),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!k.version&&!!S&&k.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${k.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let w,O=1;for(;w===void 0&&O++<6;)try{const M=await this.hb();M&&(M.ref===k.ref?w=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof h.$0k&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof c.$zpb)throw M;this.O.error(M,O)}}if(w===void 0)try{const M=await this.J.resolveResourceContent(this.resource,k.ref,this.collection,this.F);w=M===null?null:this.kb(M),await this.ib({ref:k.ref,syncData:w})}catch(M){if(M instanceof c.$zpb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return w===void 0?null:{...k,syncData:w}}async fb(E,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),w={ref:E.ref,version:S,...k};this.I.store(this.z,JSON.stringify(w),-1,1),await this.ib(E)}gb(){return this.I.get(this.z,-1)}async hb(){const E=(await this.G.readFile(this.y)).value.toString();try{const k=E?JSON.parse(E):void 0;if(i(k))return k}catch(k){this.O.error(k)}}async ib(E){await this.G.writeFile(this.y,A.$ue.fromString(JSON.stringify(E)))}async jb(){try{const E=await this.G.readFile(this.y),k=JSON.parse(E.value.toString());await this.G.del(this.y),k.ref&&k.content!==void 0?(this.I.store(this.z,JSON.stringify({...k,content:void 0}),-1,1),await this.ib({ref:k.ref,syncData:k.content===null?null:JSON.parse(k.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,k)}catch(E){E instanceof h.$0k&&E.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(E)}return this.I.get(this.z,-1)}async getRemoteUserData(E){const{ref:k,content:S}=await this.lb(E);let w=null;return S!==null&&(w=this.kb(S)),{ref:k,syncData:w}}kb(E){try{const k=JSON.parse(E);if(o(k))return k}catch(k){this.O.error(k)}throw new c.$zpb((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(E){const k=E?{ref:E.ref,content:E.syncData?JSON.stringify(E.syncData):null}:null;return this.J.readResource(this.resource,k,this.collection,this.F)}async mb(E,k){const S=await this.j,w={version:this.pb,machineId:S,content:E};try{return k=await this.J.writeResource(this.resource,JSON.stringify(w),k,this.collection,this.F),{ref:k,syncData:w}}catch(O){throw O instanceof c.$zpb&&O.code==="TooLarge"&&(O=new c.$zpb(O.message,O.code,this.resource)),O}}async nb(E){const k={version:this.pb,content:E};return this.L.writeResource(this.resource,JSON.stringify(k),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$mpb)}};e.$jKb=s,e.$jKb=s=ve([X(2,h.$Ok),X(3,f.$pi),X(4,u.$Mp),X(5,c.$upb),X(6,c.$vpb),X(7,c.$Epb),X(8,g.$Nl),X(9,c.$Jpb),X(10,m.$Oi),X(11,l.$ml)],s);let t=class extends s{constructor(E,k,S,w,O,M,T,U,_,G,Z,V,K){super(k,S,w,O,M,T,U,_,G,Z,V,K),this.r=E,this.B(this.G.watch(this.h.dirname(E))),this.B(this.G.onDidFilesChange(W=>this.yb(W)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(E,k,S){try{k?await this.G.writeFile(this.r,A.$ue.fromString(E),S?void 0:k):await this.G.createFile(this.r,A.$ue.fromString(E),{overwrite:S})}catch(w){throw w instanceof h.$0k&&w.fileOperationResult===1||w instanceof h.$0k&&w.fileOperationResult===3?new c.$zpb(w.message,"LocalPreconditionFailed"):w}}async xb(){try{await this.G.del(this.r)}catch(E){if(!(E instanceof h.$0k&&E.fileOperationResult===1))throw E}}yb(E){E.contains(this.r)&&this.Q()}};e.$kKb=t,e.$kKb=t=ve([X(3,h.$Ok),X(4,f.$pi),X(5,u.$Mp),X(6,c.$upb),X(7,c.$vpb),X(8,c.$Epb),X(9,g.$Nl),X(10,c.$Jpb),X(11,m.$Oi),X(12,l.$ml)],t);let r=class extends t{constructor(E,k,S,w,O,M,T,U,_,G,Z,V,K,W){super(E,k,S,w,O,M,T,U,_,G,Z,K,W),this.zb=V,this.Bb=void 0}Ab(E,k){const S=[],w=(0,I.$vn)(E,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,C.$3f)(w)&&k!==Array.isArray(w)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$lKb=r,e.$lKb=r=ve([X(3,h.$Ok),X(4,f.$pi),X(5,u.$Mp),X(6,c.$upb),X(7,c.$vpb),X(8,c.$Epb),X(9,g.$Nl),X(10,c.$Jpb),X(11,c.$Ipb),X(12,m.$Oi),X(13,l.$ml)],r);let a=class{constructor(E,k,S,w,O,M,T){this.resource=E,this.g=k,this.h=S,this.j=w,this.k=O,this.l=M,this.d=T.extUri,this.f=(0,c.$spb)(void 0,this.resource,S,this.d)}async initialize({ref:E,content:k}){if(!k){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(k);if(S)try{await this.o({ref:E,syncData:S})}catch(w){this.j.error(w)}}m(E){try{const k=JSON.parse(E);if(o(k))return k}catch(k){this.j.error(k)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(E,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const S={ref:E.ref,version:void 0,...k};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),-1,1),await this.k.writeFile(this.f,A.$ue.fromString(JSON.stringify(E)))}};e.$mKb=a,e.$mKb=a=ve([X(1,$.$ol),X(2,f.$pi),X(3,b.$Oj),X(4,h.$Ok),X(5,u.$Mp),X(6,l.$ml)],a)}),define(le[115],he([0,1,6,26,7,3,43,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q0b=e.$p0b=e.$o0b=void 0,e.$m0b=E,e.$n0b=k;async function y(M,T){const U=JSON.parse(M.content);if(M.version===1||M.version===2){const _=(await T.getInstalled(0)).filter(G=>G.isBuiltin);for(const G of U)M.version===1&&(G.enabled===!1&&(G.disabled=!0),delete G.enabled),M.version===2&&_.every(Z=>!(0,f.$gp)(Z.identifier,G.identifier))&&(G.installed=!0)}return U}function E(M){return JSON.parse(M.content)}function k(M,T){return M.sort((U,_)=>!U.identifier.uuid&&_.identifier.uuid?-1:U.identifier.uuid&&!_.identifier.uuid?1:(0,P.$ef)(U.identifier.id,_.identifier.id)),T?(0,D.$Gn)(M,{}):JSON.stringify(M)}let S=class extends n.$jKb{constructor(T,U,_,G,Z,V,K,W,B,ie,ae,te,ce,H,q,L,F){super({syncResource:"extensions",profile:T},U,G,_,Z,V,K,te,ce,ie,ae,q),this.Cb=W,this.Db=B,this.Eb=F,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Lpb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Lpb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Lpb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Lpb,authority:"accepted"}),this.Bb=this.Eb.createInstance(w),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:Y})=>!!Y)),j.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),j.Event.filter(L.onDidChange,z=>z.valueChanges.some(({profile:Y,changes:J})=>this.syncResource.profile.id===Y.id&&J.some(ee=>ee.key===m.$Vo))),H.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(T,U){const _=T.syncData?await y(T.syncData,this.Cb):null,G=U?.skippedExtensions??[],Z=U?.builtinExtensions??null,V=U?.syncData?await y(U.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile);_?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,s.$l0b)(K,_,V,G,W,Z),ae={local:B,remote:ie,content:this.Hb(K,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},te=this.Ob(K,!1);return[{skippedExtensions:G,builtinExtensions:Z,baseResource:this.xb,baseContent:V?this.Ob(V,!1):te,localResource:this.yb,localContent:te,localExtensions:K,remoteResource:this.zb,remoteExtensions:_,remoteContent:_?this.Ob(_,!1):null,previewResource:this.wb,previewResult:ae,localChange:ae.localChange,remoteChange:ae.remoteChange,acceptedResource:this.Ab}]}async ub(T){const U=T.syncData?await y(T.syncData,this.Cb):null,{localExtensions:_,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Z}=(0,s.$l0b)(_,U,U,T.skippedExtensions||[],G,T.builtinExtensions||[]);return Z!==null}Hb(T,U,_,G){const Z=[...U,..._],V=new Set,K=W=>{V.add(W.id.toLowerCase()),W.uuid&&V.add(W.uuid)};Z.forEach(({identifier:W})=>K(W)),G.forEach(K);for(const W of T)V.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&V.has(W.identifier.uuid)||Z.push(W);return this.Ob(Z,!1)}async rb(T,U){return{...T.previewResult,hasConflicts:!1}}async sb(T,U,_,G){if(this.h.isEqual(U,this.yb))return this.Kb(T);if(this.h.isEqual(U,this.zb))return this.Lb(T);if(this.h.isEqual(U,this.wb))return T.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async Kb(T){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(U),G=(0,s.$l0b)(T.localExtensions,null,null,T.skippedExtensions,_,T.builtinExtensions),{local:Z,remote:V}=G;return{content:T.localContent,local:Z,remote:V,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?2:0,remoteChange:V!==null?2:0}}async Lb(T){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(U),G=T.remoteContent?JSON.parse(T.remoteContent):null;if(G!==null){const Z=(0,s.$l0b)(T.localExtensions,G,T.localExtensions,[],_,T.builtinExtensions),{local:V,remote:K}=Z;return{content:T.remoteContent,local:V,remote:K,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:T.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(T,U,_,G){let{skippedExtensions:Z,builtinExtensions:V,localExtensions:K}=_[0][0];const{local:W,remote:B,localChange:ie,remoteChange:ae}=_[0][1];if(ie===0&&ae===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(K)),Z=await this.Bb.updateLocalExtensions(W.added,W.removed,W.updated,Z,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const te=JSON.stringify(B.all);T=await this.mb(te,G?null:T.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(ce=>ce.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(ce=>ce.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(ce=>ce.identifier.id))}.`:""}`)}U?.ref!==T.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),V=this.Nb(K,V),await this.fb(T,{skippedExtensions:Z,builtinExtensions:V}),this.O.info(`${this.D}: Updated last synchronized extensions.${Z.length?` Skipped: ${JSON.stringify(Z.map(te=>te.identifier.id))}.`:""}`))}Nb(T,U){const _=new Set,G=[];for(const Z of T)_.add(Z.identifier.id.toLowerCase()),Z.installed||G.push(Z.identifier);if(U)for(const Z of U)_.has(Z.id.toLowerCase())||G.push(Z);return G}async resolveContent(T){if(this.h.isEqual(this.zb,T)||this.h.isEqual(this.xb,T)||this.h.isEqual(this.yb,T)||this.h.isEqual(this.Ab,T)){const U=await this.db(T);return U&&this.Ob(JSON.parse(U),!0)}return null}Ob(T,U){return k(T,U)}async hasLocalData(){try{const{localExtensions:T}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(T.some(U=>U.installed||U.disabled))return!0}catch{}return!1}};e.$o0b=S,e.$o0b=S=ve([X(2,C.$pi),X(3,p.$Ok),X(4,c.$Mp),X(5,r.$upb),X(6,r.$vpb),X(7,m.$Uo),X(8,t.$7Kb),X(9,r.$Jpb),X(10,d.$Oi),X(11,r.$Epb),X(12,$.$Nl),X(13,h.$Iv),X(14,i.$ml),X(15,a.$lJb),X(16,u.$hi)],S);let w=class{constructor(T,U,_,G,Z,V){this.a=T,this.b=U,this.c=_,this.d=G,this.f=Z,this.g=V}async getLocalExtensions(T){const U=await this.a.getInstalled(void 0,T.extensionsResource),_=this.d.getIgnoredExtensions(U);return{localExtensions:await this.j(T,async(Z,V)=>{const K=Z.getDisabledExtensions();return U.map(W=>{const{identifier:B,isBuiltin:ie,manifest:ae,preRelease:te,pinned:ce,isApplicationScoped:H}=W,q={identifier:B,preRelease:te,version:ae.version,pinned:!!ce};H&&!(0,b.$Gm)(ae)&&(q.isApplicationScoped=H),K.some(L=>(0,f.$gp)(L,B))&&(q.disabled=!0),ie||(q.installed=!0);try{const L=V.getKeysForSync({id:B.id,version:ae.version});if(L){const F=V.getExtensionState(W,!0)||{};q.state=Object.keys(F).reduce((z,Y)=>(L.includes(Y)&&(z[Y]=F[Y]),z),{})}}catch(L){this.g.info(`${(0,n.$iKb)("extensions",T)}: Error while parsing extension state`,(0,A.$0)(L))}return q})}),ignoredExtensions:_}}async updateLocalExtensions(T,U,_,G,Z){const V=(0,n.$iKb)("extensions",Z),K=[],W=new Map,B=[],ie=[],ae=await this.a.getInstalled(void 0,Z.extensionsResource);if((T.length||_.length)&&await this.j(Z,async(H,q)=>{await R.Promises.settled([...T,..._].map(async L=>{const F=ae.find(J=>(0,f.$gp)(J.identifier,L.identifier));if(F&&F.isBuiltin){L.state&&F.manifest.version===L.version&&this.h(L.state,F,F.manifest.version,q),H.getDisabledExtensions().some(ee=>(0,f.$gp)(ee,L.identifier))!==!!L.disabled&&(L.disabled?(this.g.trace(`${V}: Disabling extension...`,L.identifier.id),await H.disableExtension(L.identifier),this.g.info(`${V}: Disabled extension`,L.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,L.identifier.id),await H.enableExtension(L.identifier),this.g.info(`${V}: Enabled extension`,L.identifier.id))),B.push(L.identifier);return}const z=L.pinned?L.version:void 0,Y=(await this.c.getExtensions([{...L.identifier,version:z,preRelease:z?void 0:L.preRelease}],N.CancellationToken.None))[0];if(L.state&&(F?F.manifest.version===L.version:Y)&&this.h(L.state,F||Y,F?.manifest.version,q),Y)try{H.getDisabledExtensions().some(ee=>(0,f.$gp)(ee,L.identifier))!==!!L.disabled&&(L.disabled?(this.g.trace(`${V}: Disabling extension...`,L.identifier.id,Y.version),await H.disableExtension(Y.identifier),this.g.info(`${V}: Disabled extension`,L.identifier.id,Y.version)):(this.g.trace(`${V}: Enabling extension...`,L.identifier.id,Y.version),await H.enableExtension(Y.identifier),this.g.info(`${V}: Enabled extension`,L.identifier.id,Y.version))),(!F||F.preRelease!==L.preRelease||F.pinned!==L.pinned||z&&F.manifest.version!==z)&&(await this.a.canInstall(Y)?(K.push({extension:Y,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:L.pinned&&!!L.version,installPreReleaseVersion:L.preRelease,profileLocation:Z.extensionsResource,isApplicationScoped:L.isApplicationScoped,context:{[m.$Io]:!0,[m.$Jo]:!0}}}),W.set(Y.identifier.id.toLowerCase(),L)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,Y.displayName||Y.identifier.id),ie.push(L)))}catch(J){ie.push(L),this.g.error(J),this.g.info(`${V}: Skipped synchronizing extension`,Y.displayName||Y.identifier.id)}else ie.push(L),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,L.identifier.id)}))}),U.length){const H=ae.filter(({identifier:q,isBuiltin:L})=>!L&&U.some(F=>(0,f.$gp)(q,F)));await R.Promises.settled(H.map(async q=>{this.g.trace(`${V}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Z.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,q.identifier.id),B.push(q.identifier)}))}const te=await this.a.installGalleryExtensions(K);for(const{identifier:H,local:q,error:L,source:F}of te){const z=F;if(q)this.g.info(`${V}: Installed extension.`,H.id,z.version),B.push(H);else{const Y=W.get(H.id.toLowerCase());Y&&(ie.push(Y),this.g.info(`${V}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),L instanceof m.$So&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(L.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):L&&this.g.error(L)}}const ce=[];for(const H of G)B.some(q=>(0,f.$gp)(q,H.identifier))||ce.push(H);for(const H of ie)ce.some(q=>(0,f.$gp)(q.identifier,H.identifier))||ce.push(H);return ce}h(T,U,_,G){const Z=G.getExtensionState(U,!0)||{},V=_?G.getKeysForSync({id:U.identifier.id,version:_}):void 0;V?V.forEach(K=>{Z[K]=T[K]}):Object.keys(T).forEach(K=>Z[K]=T[K]),G.setExtensionState(U,Z,!0)}async j(T,U){return this.b.withProfileScopedStorageService(T,async _=>{const G=new I.$Tc,Z=this.f.createChild(new g.$gi([c.$Mp,_])),V=G.add(Z.createInstance(v.$JIb)),K=G.add(Z.createInstance(h.$Jv));try{return await U(V,K)}finally{G.dispose()}})}};e.$p0b=w,e.$p0b=w=ve([X(0,m.$Uo),X(1,a.$lJb),X(2,m.$Ro),X(3,t.$7Kb),X(4,u.$hi),X(5,r.$Jpb)],w);let O=class extends n.$mKb{constructor(T,U,_,G,Z,V,K,W){super("extensions",G,Z,V,_,K,W),this.p=T,this.q=U}async t(T){return T.syncData?await y(T.syncData,this.p):null}u(T,U){const _=[],G=[],Z=[];for(const V of T){if(this.q.hasToNeverSyncExtension(V.identifier.id))continue;const K=U.find(W=>(0,f.$gp)(W.identifier,V.identifier));K?(_.push(K),V.disabled&&Z.push(V.identifier)):V.installed&&(G.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&Z.push(V.identifier))}return{installedExtensions:_,newExtensions:G,disabledExtensions:Z,remoteExtensions:T}}};e.$q0b=O,e.$q0b=O=ve([X(0,m.$Uo),X(1,t.$7Kb),X(2,p.$Ok),X(3,o.$ol),X(4,C.$pi),X(5,l.$Oj),X(6,c.$Mp),X(7,i.$ml)],O)}),define(le[116],he([0,1,15,7,3,34,43,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sKb=e.$rKb=e.$qKb=e.$pKb=void 0,e.$oKb=t;const n="globalState.argv.",s=["locale"];function t(S,w){const O=S.storage?Object.keys(S.storage).sort():[],M={};return O.forEach(T=>M[T]=S.storage[T]),S.storage=M,w?(0,D.$Gn)(S,{}):JSON.stringify(S)}const r=1;let a=class extends u.$jKb{constructor(w,O,M,T,U,_,G,Z,V,K,W,B,ie,ae){super({syncResource:"globalState",profile:w},O,T,Z,B,U,_,V,K,G,W,ie),this.Bb=M,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$Lpb,authority:"base"}),this.xb=this.vb.with({scheme:c.$Lpb,authority:"local"}),this.yb=this.vb.with({scheme:c.$Lpb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$Lpb,authority:"accepted"}),this.Ab=ae.createInstance(y),this.B(T.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(T.onDidFilesChange,te=>te.contains(this.H.argvResource)),A.Event.filter(M.onDidChange,te=>!!(te.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||te.valueChanges.some(({profile:ce,changes:H})=>this.syncResource.profile.id===ce.id&&H.some(q=>q.target===0)))))(()=>this.Q()))}async qb(w,O,M){const T=w.syncData?JSON.parse(w.syncData.content):null;O=O===null&&M?w:O;const U=O&&O.syncData?JSON.parse(O.syncData.content):null,_=await this.Ab.getLocalGlobalState(this.syncResource.profile);T?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Jb(U),{local:Z,remote:V}=(0,l.$nKb)(_.storage,T?T.storage:null,U?U.storage:null,G,this.O),K={content:null,local:Z,remote:V,localChange:Object.keys(Z.added).length>0||Object.keys(Z.updated).length>0||Z.removed.length>0?2:0,remoteChange:V.all!==null?2:0},W=t(_,!1);return[{baseResource:this.wb,baseContent:U?t(U,!1):W,localResource:this.xb,localContent:W,localUserData:_,remoteResource:this.yb,remoteContent:T?t(T,!1):null,previewResource:this.vb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.zb,storageKeys:G}]}async ub(w){const O=w.syncData?JSON.parse(w.syncData.content):null;if(O===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),T=await this.Jb(O),{remote:U}=(0,l.$nKb)(M.storage,O.storage,O.storage,T,this.O);return U.all!==null}async rb(w,O){return{...w.previewResult,hasConflicts:!1}}async sb(w,O,M,T){if(this.h.isEqual(O,this.xb))return this.Gb(w);if(this.h.isEqual(O,this.yb))return this.Hb(w);if(this.h.isEqual(O,this.vb))return w.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async Gb(w){return{content:w.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(w.localUserData.storage),removed:[],updated:[],all:w.localUserData.storage},localChange:0,remoteChange:2}}async Hb(w){if(w.remoteContent!==null){const O=JSON.parse(w.remoteContent),{local:M,remote:T}=(0,l.$nKb)(w.localUserData.storage,O.storage,null,w.storageKeys,this.O);return{content:w.remoteContent,local:M,remote:T,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:w.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(w,O,M,T){const{localUserData:U}=M[0][0],{local:_,remote:G,localChange:Z,remoteChange:V}=M[0][1];if(Z===0&&V===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Z!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(U)),await this.Ab.writeLocalGlobalState(_,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),V!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const K=JSON.stringify({storage:G.all});w=await this.mb(K,T?null:w.ref),this.O.info(`${this.D}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}O?.ref!==w.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(w),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(w){if(this.h.isEqual(this.yb,w)||this.h.isEqual(this.wb,w)||this.h.isEqual(this.xb,w)||this.h.isEqual(this.zb,w)){const O=await this.db(w);return O&&t(JSON.parse(O),!0)}return null}async hasLocalData(){try{const{storage:w}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(w).length>1||w[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(w){const O=await this.Bb.readStorageData(this.syncResource.profile),M=[],T=[];for(const[G,Z]of O)Z.target===0?M.push(G):Z.target===1&&T.push(G);const U=[...M,...T],_=w?.storage?Object.keys(w.storage).filter(G=>!G.startsWith(n)&&!U.includes(G)&&O.get(G)!==void 0):[];if(!I.$o){const G=[...c.$qpb.map(Z=>(0,c.$Dpb)(Z)),c.$Cpb];_.push(...G),T.push(...G)}return{user:M,machine:T,unregistered:_}}};e.$pKb=a,e.$pKb=a=ve([X(2,i.$lJb),X(3,v.$Ok),X(4,c.$upb),X(5,c.$vpb),X(6,c.$Jpb),X(7,C.$pi),X(8,c.$Epb),X(9,b.$Nl),X(10,d.$Oi),X(11,h.$Mp),X(12,p.$ml),X(13,o.$hi)],a);let y=class{constructor(w,O,M,T){this.a=w,this.b=O,this.c=M,this.d=T}async getLocalGlobalState(w){const O={};if(w.isDefault){const T=await this.f(),U=(0,j.$vn)(T);for(const _ of s)U[_]!==void 0&&(O[`${n}${_}`]={version:1,value:U[_]})}const M=await this.c.readStorageData(w);for(const[T,U]of M)U.value&&U.target===0&&(O[T]={version:1,value:U.value});return{storage:O}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const w=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),w.value.toString()}catch(w){this.d.debug((0,N.$0)(w))}return"{}"}async writeLocalGlobalState({added:w,removed:O,updated:M},T){const U=(0,u.$iKb)("globalState",T),_={},G=new Map,Z=await this.c.readStorageData(T),V=(K,W)=>{for(const B of K){if(B.startsWith(n)){_[B.substring(n.length)]=W?W[B].value:void 0;continue}if(W){const ie=W[B];ie.value!==Z.get(B)?.value&&G.set(B,ie.value)}else Z.get(B)!==void 0&&G.set(B,void 0)}};if(V(Object.keys(w),w),V(Object.keys(M),M),V(O),Object.keys(_).length){this.d.trace(`${U}: Updating locale...`);const K=await this.f();let W=K;for(const B of Object.keys(_))W=(0,g.edit)(W,[B],_[B],{});K!==W&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$ue.fromString(W)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}G.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(T,G,0),this.d.info(`${U}: Updated global state`,[...G.keys()]))}};e.$qKb=y,e.$qKb=y=ve([X(0,v.$Ok),X(1,C.$pi),X(2,i.$lJb),X(3,c.$Jpb)],y);let E=class extends u.$mKb{constructor(w,O,M,T,U,_){super("globalState",M,T,U,O,w,_)}async o(w){const O=w.syncData?JSON.parse(w.syncData.content):null;if(!O){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},T={};for(const U of Object.keys(O.storage))U.startsWith(n)?M[U.substring(n.length)]=O.storage[U].value:this.l.get(U,0)===void 0&&(T[U]=O.storage[U].value);if(Object.keys(M).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const _ of Object.keys(M))U=(0,g.edit)(U,[_],M[_],{});await this.k.writeFile(this.h.argvResource,R.$ue.fromString(U))}if(Object.keys(T).length){const U=[];for(const _ of Object.keys(T))U.push({key:_,value:T[_],scope:0,target:0});this.l.storeAll(U,!0)}}};e.$rKb=E,e.$rKb=E=ve([X(0,h.$Mp),X(1,v.$Ok),X(2,$.$ol),X(3,C.$pi),X(4,c.$Jpb),X(5,p.$ml)],E);let k=class{constructor(w,O,M,T,U){this.a=w,this.b=O,this.c=M,this.d=T,this.f=U}getSyncStoreType(w){return this.h(w)?.storage[c.$Cpb]?.value}async sync(w){const O=(0,c.$ypb)((0,P.$Eg)());try{return await this.g(w,O)}catch(M){if(M instanceof c.$zpb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(w,O)}throw M}}async g(w,O){const M=await this.a.readResource("globalState",null,void 0,O),T=this.h(M)||{storage:{}};T.storage[c.$Cpb]={value:w,version:r};const U=await(0,f.$Sp)(this.c,this.d,this.b),_={version:r,machineId:U,content:t(T,!1)};await this.a.writeResource("globalState",JSON.stringify(_),M.ref,void 0,O)}h({content:w}){if(!w)return null;const O=JSON.parse(w);if((0,u.$hKb)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};e.$sKb=k,e.$sKb=k=ve([X(1,h.$Mp),X(2,C.$pi),X(3,v.$Ok),X(4,m.$Oj)],k)}),define(le[117],he([0,1,17,15,3,34,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0b=e.$t0b=void 0,e.$s0b=l;function l(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,I.$3f)(s.all)?null:s.all;switch(D.OS){case 2:return(0,I.$3f)(s.mac)?null:s.mac;case 3:return(0,I.$3f)(s.linux)?null:s.linux;case 1:return(0,I.$3f)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let c=class extends p.$lKb{constructor(o,n,s,t,r,a,y,E,k,S,w,O,M){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,E,k,S,s,t,y,O,r,w,a,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:g.$Lpb,authority:"base"}),this.Gb=this.Eb.with({scheme:g.$Lpb,authority:"local"}),this.Hb=this.Eb.with({scheme:g.$Lpb,authority:"remote"}),this.Ib=this.Eb.with({scheme:g.$Lpb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?l(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,y=await this.vb(),E=await this.Cb();let k=null,S=!1,w=!1,O=!1;if(r){let U=y?y.value.toString():"[]";if(U=U||"[]",this.Ab(U,!0))throw new g.$zpb((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const _=await(0,u.$r0b)(U,r,a,E,this.zb);_.hasChanges&&(k=_.mergeContent,O=_.hasConflicts,S=O||_.mergeContent!==U,w=O||_.mergeContent!==r)}}else y&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),k=y.value.toString(),w=!0);const M={content:O?a:k,localChange:S?y?2:1:0,remoteChange:w?2:0,hasConflicts:O},T=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:T,localChange:M.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,u.$r0b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:y,remoteChange:E}=s[0][1];if(y===0&&E===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new g.$zpb((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),E!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const k=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(k,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,j.$vn)(o.value.toString());if((0,R.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:l(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,D.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(g.$npb)}};e.$t0b=c,e.$t0b=c=ve([X(2,g.$upb),X(3,g.$vpb),X(4,g.$Jpb),X(5,d.$Oi),X(6,g.$Epb),X(7,v.$Ok),X(8,C.$pi),X(9,m.$Mp),X(10,g.$Ipb),X(11,f.$Nl),X(12,h.$ml)],c);let $=class extends p.$mKb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$ue.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$vn)(o.value.toString());return!(0,R.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return l(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$u0b=$,e.$u0b=$=ve([X(0,v.$Ok),X(1,b.$ol),X(2,C.$pi),X(3,g.$Jpb),X(4,m.$Mp),X(5,h.$ml)],$)}),define(le[118],he([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x0b=e.$w0b=void 0,e.$v0b=g;function u($){return $&&$.settings&&typeof $.settings=="string"&&Object.keys($).length===1}function g($){const i=JSON.parse($);return u(i)?i:{settings:$}}let l=class extends h.$lKb{constructor(i,o,n,s,t,r,a,y,E,k,S,w,O,M){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,S,w,y,E,k,M),this.Eb=O,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.$Lpb,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.$Lpb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.$Lpb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.$Lpb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new D.$ko(p.$mpb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(p.$mpb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,y=await this.Pb();let E=null,k=!1,S=!1,w=!1;if(r){let U=s?s.value.toString().trim():"{}";U=U||"{}",this.Qb(U),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const _=(0,b.$5Ib)(U,r.settings,a?a.settings:null,y,[],t);E=_.localContent||_.remoteContent,k=_.localContent!==null,S=_.remoteContent!==null,w=_.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),E=s.value.toString().trim()||"{}",this.Qb(E),S=!0);const O=s?s.value.toString():null,M=a?.settings??null,T={content:w?M:E,localChange:k?2:0,remoteChange:S?2:0,hasConflicts:w};return[{fileContent:s,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:O,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,b.$5Ib)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,b.$4Ib)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,b.$4Ib)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,b.$4Ib)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,b.$4Ib)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:y}=n[0][1];if(a===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),y!==0){const E=await this.Cb(),k=this.Lb(i),S=await this.Pb(r);r=(0,b.$4Ib)(r,k?k.settings:"{}",S,E),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,b.$6Ib)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,b.$4Ib)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return g(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,b.$2Ib)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new p.$zpb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$w0b=l,e.$w0b=l=ve([X(2,d.$Ok),X(3,I.$pi),X(4,C.$Mp),X(5,p.$upb),X(6,p.$vpb),X(7,p.$Jpb),X(8,p.$Ipb),X(9,j.$Oi),X(10,p.$Epb),X(11,v.$Nl),X(12,P.$Uo),X(13,m.$ml)],l);let c=class extends h.$mKb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,R.$ue.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$6Ib)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return g(i)}catch(o){this.j.error(o)}return null}};e.$x0b=c,e.$x0b=c=ve([X(0,d.$Ok),X(1,f.$ol),X(2,I.$pi),X(3,p.$Jpb),X(4,C.$Mp),X(5,m.$ml)],c)}),define(le[119],he([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=e.$B0b=void 0,e.$A0b=b;function b(g){return JSON.parse(g.content)}let p=class extends m.$jKb{constructor(l,c,$,i,o,n,s,t,r,a,y,E){super({syncResource:"snippets",profile:l},c,i,$,o,n,s,a,y,t,r,E),this.pb=1,this.vb=l.snippetsHome,this.B(this.G.watch($.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,k=>k.affects(this.vb))(()=>this.Q()))}async qb(l,c,$){const i=await this.Hb(),o=this.Gb(i),n=l.syncData?this.Fb(l.syncData):null;c=c===null&&$?l:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,f.$y0b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(l){const c=l.syncData?this.Fb(l.syncData):null;if(c===null)return!0;const $=await this.Hb(),i=this.Gb($),o=(0,f.$y0b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(l,c){return l.previewResult}async sb(l,c,$,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:h.$Lpb,authority:"local"})))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:l.fileContent?l.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:h.$Lpb,authority:"remote"})))return{content:l.remoteContent,localChange:l.remoteContent!==null?l.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return $===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:$,localChange:$===null?l.fileContent!==null?3:0:2,remoteChange:$===null?l.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(l,c,$,i){const o=$.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(l=await this.Eb(o,l,i)),c?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(l,c,$,i){const o=new Map;for(const n of Object.keys(l.local.added)){const s={content:l.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"accepted"})})}for(const n of Object.keys(l.local.updated)){const s={content:l.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"accepted"})})}for(const n of l.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"accepted"})})}for(const n of Object.keys(l.remote.added)){const s={content:l.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"accepted"})})}for(const n of Object.keys(l.remote.updated)){const s={content:l.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"accepted"})})}for(const n of l.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"accepted"})})}for(const n of l.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:$[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$Lpb,authority:"accepted"})})}return[...o.values()]}async resolveContent(l){return this.h.isEqualOrParent(l,this.g.with({scheme:h.$Lpb,authority:"remote"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$Lpb,authority:"local"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$Lpb,authority:"base"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$Lpb,authority:"accepted"}))?this.db(l):null}async hasLocalData(){try{const l=await this.Hb();if(Object.keys(l).length)return!0}catch{}return!1}async Cb(l){const c={};for(const $ of l)$.fileContent&&(c[this.h.basename($.localResource)]=$.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(l,c){for(const{fileContent:$,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of l)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,R.$ue.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,R.$ue.fromString(i.content),c?void 0:$),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(l,c,$){const i=c.syncData?this.Fb(c.syncData):{},o=(0,A.$On)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of l)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,f.$z0b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),$?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(l){return b(l)}Gb(l){const c={};for(const $ of Object.keys(l))c[$]=l[$].value.toString();return c}async Hb(){const l={};let c;try{c=await this.G.resolve(this.vb)}catch($){if($ instanceof I.$0k&&$.fileOperationResult===1)return l;throw $}for(const $ of c.children||[]){const i=$.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);l[n]=s}}return l}};e.$B0b=p,e.$B0b=p=ve([X(2,D.$pi),X(3,I.$Ok),X(4,P.$Mp),X(5,h.$upb),X(6,h.$vpb),X(7,h.$Jpb),X(8,j.$Oi),X(9,h.$Epb),X(10,d.$Nl),X(11,C.$ml)],p);let u=class extends m.$mKb{constructor(l,c,$,i,o,n){super("snippets",c,$,i,l,o,n)}async o(l){const c=l.syncData?JSON.parse(l.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,R.$ue.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(l)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(l){return l.fileOperationResult===1}}};e.$C0b=u,e.$C0b=u=ve([X(0,I.$Ok),X(1,v.$ol),X(2,D.$pi),X(3,h.$Jpb),X(4,P.$Mp),X(5,C.$ml)],u)}),define(le[120],he([0,1,15,21,16,12,19,22,28,18,39,25]),function(se,e,R,N,A,j,D,I,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=e.$E0b=void 0,e.$D0b=m;function m(p,u){try{return JSON.parse(p).tasks??null}catch(g){return u.error(g),null}}let f=class extends C.$kKb{constructor(u,g,l,c,$,i,o,n,s,t,r,a){super(u.tasksResource,{syncResource:"tasks",profile:u},g,n,s,t,l,c,o,r,$,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:v.$Lpb,authority:"base"}),this.Cb=this.Ab.with({scheme:v.$Lpb,authority:"local"}),this.Db=this.Ab.with({scheme:v.$Lpb,authority:"remote"}),this.Eb=this.Ab.with({scheme:v.$Lpb,authority:"accepted"})}async qb(u,g,l,c){const $=u.syncData?m(u.syncData.content,this.O):null;g=g===null&&l?u:g;const i=g?.syncData?m(g.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(u.syncData){const E=o?o.value.toString():null;if(!i||i!==E||i!==$){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const k=b(E,$,i);n=k.content,r=k.hasConflicts,s=k.hasLocalChanged,t=k.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},y=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:y,localChange:a.localChange,remoteResource:this.Db,remoteContent:$,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(u){const g=u?.syncData?m(u.syncData.content,this.O):null;if(g===null)return!0;const l=await this.vb(),c=l?l.value.toString():null,$=b(c,g,g);return $.hasLocalChanged||$.hasRemoteChanged}async rb(u,g){return u.previewResult}async sb(u,g,l,c){if(this.h.isEqual(g,this.Cb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(g,this.Db))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(g,this.Ab))return l===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:l,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(u,g,l,c){const{fileContent:$}=l[0][0],{content:i,localChange:o,remoteChange:n}=l[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),$&&await this.nb(JSON.stringify(this.Kb($.value.toString()))),i?await this.wb(i,$,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));u=await this.mb(s,c?null:u.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}g?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(u){return this.h.isEqual(this.Db,u)||this.h.isEqual(this.Bb,u)||this.h.isEqual(this.Cb,u)||this.h.isEqual(this.Eb,u)?this.db(u):null}Kb(u){return u?{tasks:u}:{}}};e.$E0b=f,e.$E0b=f=ve([X(2,v.$upb),X(3,v.$vpb),X(4,v.$Jpb),X(5,N.$Oi),X(6,v.$Epb),X(7,j.$Ok),X(8,A.$pi),X(9,D.$Mp),X(10,I.$Nl),X(11,P.$ml)],f);let h=class extends C.$mKb{constructor(u,g,l,c,$,i){super("tasks",g,l,c,u,$,i),this.c=this.g.defaultProfile.tasksResource}async o(u){const g=u.syncData?m(u.syncData.content,this.j):null;if(!g){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$ue.fromString(g)),await this.n(u)}async p(){return this.k.exists(this.c)}};e.$F0b=h,e.$F0b=h=ve([X(0,j.$Ok),X(1,d.$ol),X(2,A.$pi),X(3,v.$Jpb),X(4,D.$Mp),X(5,P.$ml)],h);function b(p,u,g){if(p===null&&u===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(p===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const l=g!==p,c=g!==u;return!l&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:l&&!c?{content:p,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!l?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:p,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,43,21,16,12,19,22,28,18,39,244,25]),function(se,e,R,N,A,j,D,I,P,d,C,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=void 0,e.$n_b=h,e.$o_b=b;let f=class extends C.$jKb{constructor(u,g,l,c,$,i,o,n,s,t,r,a,y){super({syncResource:"profiles",profile:u},g,c,$,i,o,n,r,a,s,t,y),this.vb=l,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$Lpb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$Lpb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$Lpb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$Lpb,authority:"accepted"}),this.B(l.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?b(u.syncData):null}async getRemoteSyncedProfiles(u){const g=await this.getLastSyncUserData(),l=await this.X(u,g);return l?.syncData?b(l.syncData):null}async qb(u,g,l){if(!this.vb.isEnabled())throw new m.$zpb("Cannot sync profiles because they are disabled","LocalError");const c=u.syncData?b(u.syncData):null,$=g?.syncData?b(g.syncData):null,i=this.Db(),{local:o,remote:n}=(0,v.$l_b)(i,c,$,[]),s={local:o,remote:n,content:$?this.Eb($):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=h(i,!1);return[{baseResource:this.baseResource,baseContent:$?this.Eb($):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(u){const g=u?.syncData?b(u.syncData):null,l=this.Db(),{remote:c}=(0,v.$l_b)(l,g,g,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(u,g){return{...u.previewResult,hasConflicts:!1}}async sb(u,g,l,c){if(this.h.isEqual(g,this.localResource))return this.Ab(u);if(this.h.isEqual(g,this.remoteResource))return this.Bb(u);if(this.h.isEqual(g,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async Ab(u){const g=this.Db(),l=(0,v.$l_b)(g,null,null,[]),{local:c,remote:$}=l;return{content:u.localContent,local:c,remote:$,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:$!==null?2:0}}async Bb(u){const g=u.remoteContent?JSON.parse(u.remoteContent):null,l=[],c=[];for(const $ of this.Db()){const i=g?.find(o=>o.id===$.id);i&&(l.push({id:$.id,name:$.name,collection:i.collection}),c.push($))}if(g!==null){const $=(0,v.$l_b)(c,g,l,[]),{local:i,remote:o}=$;return{content:u.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(u,g,l,c){const{local:$,remote:i,localChange:o,remoteChange:n}=l[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=l[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.$zpb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb(h(this.Db(),!1));const t=[];for(const r of $.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of $.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of $.updated){const a=this.vb.profiles.find(y=>y.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const y=await this.J.createCollection(this.F);t.push(y),s.push({id:a.id,name:a.name,collection:y,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:y})=>a.id===y),1);for(const a of i?.updated||[]){const y=s.find(({id:E})=>a.id===E);y&&s.splice(s.indexOf(y),1,{...y,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{u=await this.updateRemoteProfiles(s,c?null:u.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of t)await this.J.deleteCollection(y,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}g?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,g){return this.mb(this.Eb(u),g)}async hasLocalData(){return this.Db().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const g=await this.db(u);return g&&(0,R.$Gn)(JSON.parse(g),{})}return null}Db(){return this.vb.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Eb(u){return JSON.stringify([...u].sort((g,l)=>g.name.localeCompare(l.name)))}};e.$m_b=f,e.$m_b=f=ve([X(2,d.$ol),X(3,j.$Ok),X(4,A.$pi),X(5,D.$Mp),X(6,m.$upb),X(7,m.$vpb),X(8,m.$Jpb),X(9,N.$Oi),X(10,m.$Epb),X(11,I.$Nl),X(12,P.$ml)],f);function h(p,u){const g=[...p].sort((l,c)=>l.name.localeCompare(c.name)).map(l=>({id:l.id,name:l.name}));return u?(0,R.$Gn)(g,{}):JSON.stringify(g)}function b(p){return JSON.parse(p.content)}}),define(le[261],he([0,1,3,2,5,16,19,22,25]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=void 0;const d="sync.enable";let C=class extends N.$Uc{constructor(m,f,h,b){super(),this.c=m,this.f=f,this.g=h,this.h=b,this.a=new R.$7d,this.onDidChangeEnablement=this.a.event,this.b=new R.$7d,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new N.$Tc))(p=>this.m(p)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:m}),this.c.store(d,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,P.$Dpb)(m),-1,!0)}setResourceEnablement(m,f){if(this.isResourceEnabled(m)!==f){const h=(0,P.$Dpb)(m);this.j(h,f)}}getResourceSyncStateVersion(m){}j(m,f){this.c.store(m,f,-1,A.$o?0:1)}m(m){if(d===m.key){this.a.fire(this.isEnabled());return}const f=P.$qpb.filter(h=>(0,P.$Dpb)(h)===m.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};e.$_$b=C,e.$_$b=C=ve([X(0,D.$Mp),X(1,I.$Nl),X(2,j.$pi),X(3,P.$tpb)],C)}),define(le[262],he([0,1,6,15,65,2,20,21,16,12,18,25]),function(se,e,R,N,A,j,D,I,P,d,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=void 0;let m=class extends j.$Uc{constructor(h,b,p,u,g){super(),this.a=h,this.b=b,this.c=p,this.f=u,this.g=g,this.h()}async h(){for(const b of this.g.profiles)for(const p of v.$qpb)try{await this.m(this.j(p,b.isDefault?void 0:b.id))}catch(u){this.f.error(u)}let h;try{h=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,d.$6k)(b)!==1&&this.f.error(b);return}if(h.children){for(const b of h.children)if(b.isDirectory&&!this.g.profiles.some(p=>p.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch(p){this.f.error(p)}}}async getAllResourceRefs(h,b,p){const u=this.j(h,b,p);try{const g=await this.b.resolve(u);if(g.children)return g.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(g){if((0,d.$6k)(g)!==1)throw g}return[]}async resolveResourceContent(h,b,p,u){const g=this.j(h,p,u),l=(0,D.$Vg)(g,b);try{return(await this.b.readFile(l)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource(h,b,p,u,g){const l=this.j(h,u,g),c=(0,D.$Vg)(l,`${(0,A.$Pm)(p).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,N.$ue.fromString(b))}catch($){this.f.error($)}}j(h,b,p=this.a.userDataSyncHome){return(0,D.$Vg)(p,...b?[b,h]:[h])}async m(h){try{try{if(!await this.b.exists(h))return}catch{return}const b=await this.b.resolve(h);if(b.children){const p=b.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let g=p.filter(c=>Date.now()-this.n(c)>u);const l=p.length-g.length;l<10&&(g=g.slice(10-l)),await R.Promises.settled(g.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(b){this.f.error(b)}}n(h){return new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};e.$k_b=m,e.$k_b=m=ve([X(0,P.$pi),X(1,d.$Ok),X(2,I.$Oi),X(3,v.$Jpb),X(4,C.$ol)],m)}),define(le[83],he([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$jpb=e.$hpb=void 0,e.$ipb=$,e.$hpb=(0,d.$ii)("IUserDataSyncMachinesService");const b="sync.currentMachineName",p="Safari",u="Chrome",g="Edge",l="Firefox",c="Android";function $(n){switch(n){case p:case u:case g:case l:case c:case(0,A.$h)(0):return!0}return!1}function i(){return A.$G?p:A.$E?u:A.$H?g:A.$F?l:A.$I?c:(0,A.$h)(A.$o?0:A.$u)}let o=class extends N.$Uc{static{h=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,y,E){super(),this.h=r,this.j=a,this.m=y,this.n=E,this.c=this.B(new R.$7d),this.onDidChange=this.c.event,this.g=null,this.f=(0,v.$Sp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:y})=>y!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),y=a.machines.find(({id:E})=>E===s);if(y){y.name=t,await this.t(a);const E=await this.f;s===E&&this.h.store(b,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const y=t.machines.find(E=>E.id===r);y&&(y.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(b,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$Ze)(r)}\\s#(\\d+)`);let y=0;for(const E of s){const k=a.exec(E.name),S=k?parseInt(k[1]):0;y=S>y?S:y}return`${r} #${y+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==h.a)throw new Error((0,D.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(h.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[h.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(h.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:h.a,machines:[]}}};e.$jpb=o,e.$jpb=o=h=ve([X(0,I.$pi),X(1,P.$Ok),X(2,m.$Mp),X(3,f.$upb),X(4,f.$Jpb),X(5,C.$8j)],o)}),define(le[263],he([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=void 0;const g="sync.disableMachineEventually",l="sync.sessionId",c="sync.storeUrl",$="sync.productQuality";let i=class extends I.$Uc{get n(){const s=this.H.get(c,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get($,-1)}set s(s){s?this.H.store($,s,-1,1):this.H.remove($,-1)}constructor(s,t,r,a,y,E,k,S,w,O){super(),this.u=t,this.w=r,this.y=a,this.z=y,this.C=E,this.D=k,this.F=S,this.G=w,this.H=O,this.a=this.B(new I.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new D.$7d),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$gh(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,d.$Og)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(k.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(y.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(D.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$Pm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(l,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=b.$zpb.toUserDataSyncError(s);t instanceof b.$Bpb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?P.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(g,!0,-1,1),await(0,R.$jh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(g,-1,!1)}R(){this.H.remove(g,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$q_b=i,e.$q_b=i=ve([X(0,m.$8j),X(1,b.$tpb),X(2,b.$upb),X(3,b.$Epb),X(4,b.$Fpb),X(5,b.$Jpb),X(6,p.$LIb),X(7,h.$Nl),X(8,u.$hpb),X(9,f.$Mp)],i);class o extends I.$Uc{static{this.a="Interval"}constructor(s,t,r,a,y,E,k,S,w){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=y,this.w=E,this.y=k,this.z=S,this.C=w,this.b=this.B(new I.$Vc),this.c=this.B(new D.$7d),this.onDidStartSync=this.c.event,this.f=this.B(new D.$7d),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,R.$kh)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,R.$8g)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(y){if((0,j.$4)(y))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$Og)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,d.$Og)(t.defaultUrl,s.defaultUrl)||!(0,d.$Og)(t.insidersUrl,s.insidersUrl)||!(0,d.$Og)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(y){if(this.y.error(y),a=y,b.$zpb.toUserDataSyncError(y).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(E){this.y.error(E),a=E}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$Bpb((0,v.localize)(0,null),"DefaultServiceChanged"):new b.$Bpb((0,v.localize)(1,null),"ServiceChanged"):new b.$Bpb((0,v.localize)(2,null),"TurnedOff");const r=this.C.get(l,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new b.$Bpb((0,v.localize)(3,null),"DefaultServiceChanged"):new b.$Bpb((0,v.localize)(4,null),"ServiceChanged"):new b.$Bpb((0,v.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const y=a.find(k=>k.isCurrent);if(y?.disabled)throw new b.$Bpb((0,v.localize)(6,null),"TurnedOff");const E=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-E}),this.g===null)try{this.g=await this.s.manifest(null)}catch(k){throw new b.$Bpb((0,A.$6i)(k),k instanceof b.$zpb?k.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(l,this.g.session,-1,1),!t.isCancellationRequested&&(y||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[264],he([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,43,27]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,y,E,k,S,w,O,M){this.e=t,this.f=r,this.g=a,this.h=E,this.i=k,this.j=S,this.k=w,this.l=O,this.n=M,this.d=y.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$o_b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const y=this.L(a,"profiles");return(0,c.$o_b)(y)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(E=>({...E,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:y,ref:E})=>({created:y,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:E,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:E,ref:k})=>({created:E,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:k,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(y=>y.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(y=>y.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,D.$Sp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,y,E){if(t){const{content:k}=await this.M(r,y,a);return k}return this.f.resolveResourceContent(r,y,a,E)}q(t,r,a){const y=this.L(r,t);switch(t){case"settings":return this.t(y,a);case"keybindings":return this.v(y,a);case"tasks":return this.x(y,a);case"snippets":return this.z(y,a);case"globalState":return this.E(y,a);case"extensions":return this.B(y,a);case"profiles":return this.H(y,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(y=>y.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),y=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}t(t,r){switch(r){case"settings.json":return(0,f.$v0b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),y=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}v(t,r){switch(r){case"keybindings.json":return(0,h.$s0b)(t.content,!!this.l.getValue(d.$npb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),y=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}x(t,r){switch(r){case"tasks.json":return(0,p.$D0b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const y=this.L(a,"snippets");if(y){const E=(0,m.$A0b)(y),k=[];for(const S of Object.keys(E)){const w=this.d.joinPath(t,S),O=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(t,o.a);k.push({resource:w,comparableResource:O})}return k}}return[]}z(t,r){return(0,m.$A0b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),y=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}B(t,r){switch(r){case"extensions.json":return(0,u.$n0b)((0,u.$m0b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(u.$p0b).getLocalExtensions(t);return(0,u.$n0b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),y=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}E(t,r){switch(r){case"globalState.json":return(0,g.$oKb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(g.$qKb).getLocalGlobalState(t);return(0,g.$oKb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),y=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:y}]}H(t,r){switch(r){case"profiles.json":return(0,$.$Gn)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$n_b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$4e)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(R.URI.from({scheme:d.$Lpb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==d.$Lpb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let y,E;const k=[];let S,w,O,M,T;for(;r.length;){const U=r.shift();U.startsWith("scheme:")?y=U.substring(7):U.startsWith("authority:")?E=U.substring(10):U.startsWith("syncResource:")?S=U.substring(13):U.startsWith("profile:")?w=U.substring(8):U.startsWith("collection:")?O=U.substring(11):U.startsWith("ref:")?M=U.substring(4):S?T=U:k.push(U)}return{remote:a,syncResource:S,profile:w,collection:O,ref:M,node:T,location:y&&E!==void 0?this.d.joinPath(R.URI.from({scheme:y,authority:E,query:t.query,fragment:t.fragment,path:"/"}),...k):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,v.$hKb)(a))return a}catch(a){this.g.error(a)}throw new d.$zpb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const y=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:y}}};e.$Y_b=n,e.$Y_b=n=o=ve([X(0,d.$upb),X(1,d.$vpb),X(2,d.$Jpb),X(3,P.$ml),X(4,A.$pi),X(5,I.$Mp),X(6,j.$Ok),X(7,C.$ol),X(8,b.$Oi),X(9,l.$hi)],n)}),define(le[265],he([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=void 0;const t="sync.lastSyncTime";let r=class extends I.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,w,O,M,T,U,_,G,Z,V,K){super(),this.C=S,this.D=w,this.F=O,this.G=M,this.H=T,this.I=U,this.J=_,this.L=G,this.M=Z,this.N=V,this.O=K,this.f="uninitialized",this.g=this.B(new D.$7d),this.onDidChangeStatus=this.g.event,this.h=this.B(new D.$7d),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new D.$7d),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new D.$7d),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new D.$7d),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new D.$7d),this.onDidResetLocal=this.w.event,this.y=this.B(new D.$7d),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=O.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,I.$Sc)(()=>this.bb()))}async createSyncTask(S,w){this.cb(),this.H.info("Sync started.");const O=new Date().getTime(),M=(0,C.$Eg)();try{const G=(0,s.$ypb)(M);w&&(G["Cache-Control"]="no-cache"),S=await this.D.manifest(S,G)}catch(G){const Z=s.$zpb.toUserDataSyncError(G);throw E(Z,M,this.F,this.I),Z}const T=!1,U=this;let _;return{manifest:S,async run(){if(T)throw new Error("Can run a task only once");_=(0,N.$8g)(G=>U.P(S,!1,M,G)),await _.finally(()=>_=void 0),U.H.info(`Sync done. Took ${new Date().getTime()-O}ms`),U.$()},stop(){return _?.cancel(),U.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$zpb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const S=new Date().getTime(),w=(0,C.$Eg)(),O=(0,s.$ypb)(w);let M;try{M=await this.D.manifest(null,O)}catch(_){const G=s.$zpb.toUserDataSyncError(_);throw E(G,w,this.F,this.I),G}await this.resetLocal();const T=this,U=new A.$ee;return{id:w,async merge(){return T.P(M,!0,w,U.token)},async apply(){try{try{await T.R(M,w,U.token)}catch(_){if(s.$zpb.toUserDataSyncError(_).code==="MethodNotFound")T.H.info("Client is making invalid requests. Cleaning up data..."),await T.cleanUpRemoteData(),T.H.info("Applying manual sync again..."),await T.R(M,w,U.token);else throw _}}catch(_){throw T.H.error(_),_}T.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),T.$()},async stop(){U.cancel(),await T.U(),await T.resetLocal()}}}async P(S,w,O,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const T=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(T,S,w,O,M));const U=T.enabled.find(_=>_.resource==="profiles");if(U){const _=await U.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(_,S,w,O,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(S,w,O,M,T){for(const U of S){if(T.isCancellationRequested)return;const _=this.M.profiles.find(Z=>Z.id===U.id);if(!_){this.H.error(`Profile with id:${U.id} and name: ${U.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",U.name);const G=this.getOrCreateActiveProfileSynchronizer(_,U);this.n.push(...await this.S(G,w,O,M,T))}for(const[U,_]of this.z.entries())this.M.profiles.some(G=>G.id===_[0].profile.id)||(_[1].dispose(),this.z.delete(U))}async R(S,w,O){const M=this.ab();for(const Z of M){if(O.isCancellationRequested)return;await Z.apply(w,O)}const T=M.find(Z=>Z.profile.isDefault);if(!T)return;const U=T.enabled.find(Z=>Z.resource==="profiles");if(!U)return;const G=(await U.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(Z=>M.every(V=>V.profile.id!==Z.id));G.length&&await this.Q(G,S,!1,w,O)}async S(S,w,O,M,T){return(await S.sync(w,O,M,T)).map(([_,G])=>({profile:S.profile,syncResource:_,error:G}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(S=>S.stop()))}async resolveContent(S){const w=await this.N.resolveContent(S);if(w)return w;for(const O of this.ab())for(const M of O.enabled){const T=await M.resolveContent(S);if(T)return T}return null}async replace(S){this.cb();const w=this.N.resolveUserDataSyncResource(S);if(!w)return;const O=await this.resolveContent(S.uri);O&&await this.W(w.profile,async M=>{if(w.syncResource===M.resource)return await M.replace(O),!0})}async accept(S,w,O,M){this.cb(),await this.W(S.profile,async T=>{if(S.syncResource===T.resource)return await T.accept(w,O),M&&await T.apply((0,d.$2f)(M)?!1:M.force,(0,s.$ypb)((0,C.$Eg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async w=>{if(w.resource!=="globalState"&&await w.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async w=>{if(await w.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[S]of this.z.values())try{await S.resetLocal()}catch(w){this.H.error(w)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),w=S.map(U=>U.collection),O=await this.D.getAllCollections(),M=O.filter(U=>!w.includes(U));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(U=>this.D.deleteCollection(U))),this.H.info("Deleted redundant collections on server"));const T=S.filter(U=>O.includes(U.collection));if(T.length!==S.length){const U=this.G.createInstance(n.$m_b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await U.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await U.updateRemoteProfiles(T,null),this.H.info("Updated remote profiles on server")}finally{U.dispose()}}}async saveRemoteActivityData(S){this.cb();const w=await this.D.getActivityData();await this.C.writeFile(S,w)}async extractActivityData(S,w){const O=(await this.C.readFile(S)).value.toString(),M=JSON.parse(O);if(M.resources)for(const T in M.resources)for(const U of M.resources[T])await this.O.writeResource(T,U.content,new Date(U.created*1e3),void 0,w);if(M.collections)for(const T in M.collections)for(const U in M.collections[T].resources)for(const _ of M.collections[T].resources?.[U]??[])await this.O.writeResource(U,_.content,new Date(_.created*1e3),T,w)}async W(S,w){const O=new I.$Tc;try{const M=this.z.get(S.id);if(M){const Z=await this.X(M[0],w,O);return(0,d.$3f)(Z)?null:Z}if(S.isDefault){const Z=O.add(this.G.createInstance(a,S,void 0)),V=await this.X(Z,w,O);return(0,d.$3f)(V)?null:V}if(this.M.isEnabled())return null;const T=O.add(this.G.createInstance(n.$m_b,S,void 0)),U=await this.D.manifest(null),G=(await T.getRemoteSyncedProfiles(U?.latest??null)||[]).find(Z=>Z.id===S.id);if(G){const Z=O.add(this.G.createInstance(a,S,G.collection)),V=await this.X(Z,w,O);return(0,d.$3f)(V)?null:V}return null}finally{O.dispose()}}async X(S,w,O){const M=[...S.enabled,...S.disabled.reduce((T,U)=>(U!=="workspaceState"&&T.push(O.add(S.createSynchronizer(U))),T),[])];for(const T of M){const U=await w(T);if(!(0,d.$3f)(U))return U}}Y(S){const w=this.f;this.f!==S&&(this.f=S,this.g.fire(S),w==="hasConflicts"&&this.$())}Z(){const S=this.ab().map(w=>w.conflicts).flat();(0,R.$ub)(this.j,S,(w,O)=>w.profile.id===O.profile.id&&w.syncResource===O.syncResource&&(0,R.$ub)(w.conflicts,O.conflicts,(M,T)=>(0,P.$Og)(M.previewResource,T.previewResource)))||(this.j=S,this.m.fire(S))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,w){let O=this.z.get(S.id);if(O&&O[0].collection!==w?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.z.delete(S.id)),!O){const M=new I.$Tc,T=M.add(this.G.createInstance(a,S,w?.collection));M.add(T.onDidChangeStatus(U=>this.Y(U))),M.add(T.onDidChangeConflicts(U=>this.Z())),M.add(T.onDidChangeLocal(U=>this.h.fire(U))),this.z.set(S.id,O=[T,M])}return O[0]}ab(){const S=[];for(const[w]of this.z.values())S.push(w);return S}bb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$p_b=r,e.$p_b=r=ve([X(0,f.$Ok),X(1,s.$upb),X(2,s.$tpb),X(3,h.$hi),X(4,s.$Jpb),X(5,p.$Nl),X(6,b.$Mp),X(7,s.$Epb),X(8,u.$ol),X(9,s.$Gpb),X(10,s.$vpb)],r);let a=class extends I.$Uc{get enabled(){return this.f.sort((S,w)=>S[1]-w[1]).map(([S])=>S)}get disabled(){return s.$qpb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,w,O,M,T,U,_,G,Z,V){super(),this.profile=S,this.collection=w,this.r=O,this.t=M,this.u=T,this.w=U,this.y=_,this.z=G,this.C=Z,this.D=V,this.f=[],this.g="idle",this.h=this.B(new D.$7d),this.onDidChangeStatus=this.h.event,this.j=this.B(new D.$7d),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new D.$7d),this.onDidChangeConflicts=this.n.event,this.B(O.onDidChangeResourceEnablement(([K,W])=>this.F(K,W))),this.B((0,I.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of s.$qpb)O.isResourceEnabled(K)&&this.G(K)}F(S,w){w?this.G(S):this.H(S)}G(S){if(this.f.some(([T])=>T.resource===S))return;if(S==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||S==="workspaceState")return;if(S!=="profiles"&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const w=new I.$Tc,O=w.add(this.createSynchronizer(S));w.add(O.onDidChangeStatus(()=>this.L())),w.add(O.onDidChangeConflicts(()=>this.M())),w.add(O.onDidChangeLocal(()=>this.j.fire(S)));const M=this.N(S);this.f.push([O,M,w])}H(S){const w=this.f.findIndex(([O])=>O.resource===S);if(w!==-1){const[[O,,M]]=this.f.splice(w,1);M.dispose(),this.L(),Promise.allSettled([O.stop(),O.resetLocal()]).then(null,T=>this.z.error(T))}}createSynchronizer(S){switch(S){case"settings":return this.t.createInstance($.$w0b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$t0b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$B0b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$E0b,this.profile,this.collection);case"globalState":return this.t.createInstance(l.$pKb,this.profile,this.collection);case"extensions":return this.t.createInstance(g.$o0b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$m_b,this.profile,this.collection)}}async sync(S,w,O,M){if(M.isCancellationRequested)return[];const T=this.enabled;if(!T.length)return[];try{const U=[],_=(0,s.$ypb)(O),G=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,Z=w?await this.I(G):{};for(const V of T){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(V.resource))return[];try{if(w){const K=await V.preview(G,Z,_);if(K)for(const W of K.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&await V.merge(W.previewResource)}else await V.sync(G,_)}catch(K){const W=s.$zpb.toUserDataSyncError(K);if(E(W,O,this.w,this.y),y(K))throw W;this.z.error(K),this.z.error(`${V.resource}: ${(0,j.$6i)(K)}`),U.push([V.resource,W])}}return U}finally{this.L()}}async apply(S,w){const O=(0,s.$ypb)(S);for(const M of this.enabled){if(w.isCancellationRequested)return;try{await M.apply(!1,O)}catch(T){const U=s.$zpb.toUserDataSyncError(T);if(E(U,S,this.w,this.y),y(T))throw U;this.z.error(T),this.z.error(`${M.resource}: ${(0,j.$6i)(T)}`)}}}async stop(){for(const S of this.enabled)try{S.status!=="idle"&&await S.stop()}catch(w){this.z.error(w)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(w){this.z.error(`${S.resource}: ${(0,j.$6i)(w)}`),this.z.error(w)}}async I(S){if(!this.profile.isDefault)return{};const w=this.D.getValue(s.$mpb),O=this.enabled.find(M=>M instanceof $.$w0b);if(O){const M=await O.getRemoteUserDataSyncConfiguration(S);return{...w,...M}}return w}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(S=>S.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const S=this.enabled.filter(w=>w.status==="hasConflicts").filter(w=>w.conflicts.conflicts.length>0).map(w=>w.conflicts);(0,R.$ub)(this.m,S,(w,O)=>w.syncResource===O.syncResource&&(0,R.$ub)(w.conflicts,O.conflicts,(M,T)=>(0,P.$Og)(M.previewResource,T.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ve([X(2,s.$Epb),X(3,h.$hi),X(4,m.$Ro),X(5,s.$tpb),X(6,p.$Nl),X(7,s.$Jpb),X(8,u.$ol),X(9,v.$Oi)],a);function y(k){if(k instanceof s.$zpb)switch(k.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function E(k,S,w,O){O.publicLog2("sync/error",{code:k.code,serverCode:k instanceof s.$Apb?String(k.serverCode):void 0,url:k instanceof s.$Apb?k.url:void 0,resource:k.resource,executionId:S,service:w.userDataSyncStore.url.toString()})}}),define(le[266],he([0,1,3,2,8,18,25]),function(se,e,R,N,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;function I(m,f){return{...m,profile:(0,j.$pl)(m.profile,f.profilesHome.scheme)}}function P(m){return{created:m.created,uri:A.URI.revive(m.uri)}}class d{constructor(f,h,b){this.c=f,this.d=h,this.f=b,this.a=new Map,this.b=new R.$7d}listen(f,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${h}`)}async call(f,h,b){try{return await this.g(f,h,b)}catch(p){throw this.f.error(p),p}}async g(f,h,b){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(b[0]));case"accept":return this.c.accept(I(b[0],this.d),A.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(P(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(b[0]),A.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const p=h.substring(11),u=b[0],g=this.h(u);switch(b=b.slice(1),p){case"merge":return g.merge();case"apply":return g.apply().then(()=>this.a.delete(this.j(g.id)));case"stop":return g.stop().finally(()=>this.a.delete(this.j(g.id)))}}throw new Error("Invalid call")}h(f){const h=this.a.get(this.j(f));if(!h)throw new Error(`Manual sync taks not found: ${f}`);return h}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.$Jcc=d;let C=class extends N.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,h){super(),this.n=h,this.b="uninitialized",this.c=this.B(new R.$7d),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$7d),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$7d),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$7d),this.onSyncErrors=this.m.event,this.a={call(b,p,u){return f.call(b,p,u).then(null,g=>{throw D.$zpb.toUserDataSyncError(g)})},listen(b,p){return f.listen(b,p)}},this.a.call("_getInitialData").then(([b,p,u])=>{this.s(b),this.t(p),u&&this.u(u),this.B(this.a.listen("onDidChangeStatus")(g=>this.s(g))),this.B(this.a.listen("onDidChangeLastSyncTime")(g=>this.u(g)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map(p=>({...p,error:D.$zpb.toUserDataSyncError(p.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),h=this;return new v(f,{async call(p,u,g){return h.a.call(`manualSync/${p}`,[f,...Array.isArray(u)?u:[u]],g)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,h,b,p){return this.a.call("accept",[f,h,b,p])}resolveContent(f){return this.a.call("resolveContent",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}saveRemoteActivityData(f){return this.a.call("getRemoteActivityData",[f])}extractActivityData(f,h){return this.a.call("extractActivityData",[f,h])}async s(f){this.b=f,this.c.fire(f)}async t(f){this.f=f.map(h=>({syncResource:h.syncResource,profile:(0,j.$pl)(h.profile,this.n.profilesHome.scheme),conflicts:h.conflicts.map(b=>({...b,baseResource:A.URI.revive(b.baseResource),localResource:A.URI.revive(b.localResource),remoteResource:A.URI.revive(b.remoteResource),previewResource:A.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u(f){this.h!==f&&(this.h=f,this.j.fire(f))}};e.$Kcc=C,e.$Kcc=C=ve([X(1,j.$ol)],C);class v extends N.$Uc{constructor(f,h){super(),this.id=f,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fKb=e.$eKb=e.$dKb=e.$cKb=e.$bKb=void 0;const $="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends D.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$Cpb,-1)}set c(O){this.h.store(c.$Cpb,O,-1,P.$o?0:1)}constructor(O,M,T){super(),this.f=O,this.g=M,this.h=T,this.a=this.B(new j.$7d),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const U=this.B(new D.$Tc);this.B(j.Event.filter(T.onDidChangeValue(-1,c.$Cpb,U),()=>this.c!==this.userDataSyncStore?.type,U)(()=>this.j()))}j(){this.b=this.m(this.f[$]),this.a.fire()}m(O){if(O&&(O=P.$o&&O.web?{...O,...O.web}:O,(0,C.$Vf)(O.url)&&(0,C.$Xf)(O.authenticationProviders)&&Object.keys(O.authenticationProviders).every(M=>Array.isArray(O.authenticationProviders[M].scopes)))){const M=O,T=!!M.canSwitch,U=M.url===M.insidersUrl?"insiders":"stable",_=(T?this.c:void 0)||U,G=_==="insiders"?M.insidersUrl:_==="stable"?M.stableUrl:M.url;return{url:v.URI.parse(G),type:_,defaultType:U,defaultUrl:v.URI.parse(M.url),stableUrl:v.URI.parse(M.stableUrl),insidersUrl:v.URI.parse(M.insidersUrl),canSwitch:T,authenticationProviders:Object.keys(M.authenticationProviders).reduce((Z,V)=>(Z.push({id:V,scopes:M.authenticationProviders[V].scopes}),Z),[])}}}};e.$bKb=a,e.$bKb=a=ve([X(0,p.$8j),X(1,f.$Oi),X(2,l.$Mp)],a);let y=class extends a{constructor(O,M,T){super(O,M,T);const U=this.h.get(i,-1);U&&(this.n=JSON.parse(U));const _=this.f[$];_?this.h.store(i,JSON.stringify(_),-1,1):this.h.remove(i,-1)}async switch(O){O!==this.c&&(this.c=O,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$cKb=y,e.$cKb=y=ve([X(0,p.$8j),X(1,f.$Oi),X(2,l.$Mp)],y);let E=class extends D.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(O,M,T,U,_,G,Z){super(),this.n=T,this.r=U,this.s=Z,this.g=this.B(new j.$7d),this.onTokenFailed=this.g.event,this.h=this.B(new j.$7d),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$7d),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(O),this.c=(0,g.$Sp)(_,G,Z).then(V=>{const K={"X-Client-Name":`${M.applicationName}${P.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(K["X-Client-Commit"]=M.commit),K}),this.f=new S(t,r,this.n,this.r),this.u(),this.B((0,D.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(O,M){this.b={token:O,type:M}}t(O){this.a=O?(0,d.$Vg)(O,"v1"):void 0}u(){const O=this.s.getNumber(o,-1);O&&Date.now()<O&&this.y(new Date(O))}y(O){this.j?.getTime()!==O?.getTime()&&(this.j=O,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,R.$8g)(M=>(0,R.$jh)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$Vg)(this.a,"collection").toString();O={...O},O["Content-Type"]="application/json";const T=await this.D(M,{type:"GET",headers:O},[],N.CancellationToken.None);return(await(0,u.$Fp)(T))?.map(({id:U})=>U)||[]}async createCollection(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$Vg)(this.a,"collection").toString();O={...O},O["Content-Type"]=I.$zs.text;const T=await this.D(M,{type:"POST",headers:O},[],N.CancellationToken.None),U=await(0,u.$Ep)(T);if(!U)throw new c.$Apb("Server did not return the collection id",M,"NoCollection",T.res.statusCode,T.res.headers[c.$wpb]);return U}async deleteCollection(O,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=O?(0,d.$Vg)(this.a,"collection",O).toString():(0,d.$Vg)(this.a,"collection").toString();M={...M},await this.D(T,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(O,M){if(!this.a)throw new Error("No settings sync store url configured.");const T=this.z(this.a,M,O),U={},_=await this.D(T.toString(),{type:"GET",headers:U},[],N.CancellationToken.None);return(await(0,u.$Fp)(_)||[]).map(({url:Z,created:V})=>({ref:(0,d.$Xg)(T,T.with({path:Z})),created:V*1e3}))}async resolveResourceContent(O,M,T,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,d.$Vg)(this.z(this.a,T,O),M).toString();U={...U},U["Cache-Control"]="no-cache";const G=await this.D(_,{type:"GET",headers:U},[],N.CancellationToken.None);return await(0,u.$Ep)(G)}async deleteResource(O,M,T){if(!this.a)throw new Error("No settings sync store url configured.");const U=M!==null?(0,d.$Vg)(this.z(this.a,T,O),M).toString():this.z(this.a,T,O).toString(),_={};await this.D(U,{type:"DELETE",headers:_},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,d.$Vg)(this.a,"resource").toString(),M={"Content-Type":I.$zs.text};await this.D(O,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(O,M,T,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,d.$Vg)(this.z(this.a,T,O),"latest").toString();U={...U},U["Cache-Control"]="no-cache",M&&(U["If-None-Match"]=M.ref);const G=await this.D(_,{type:"GET",headers:U},[304],N.CancellationToken.None);let Z=null;if(G.res.statusCode===304&&(Z=M),Z===null){const V=G.res.headers.etag;if(!V)throw new c.$Apb("Server did not return the ref",_,"NoRef",G.res.statusCode,G.res.headers[c.$wpb]);const K=await(0,u.$Ep)(G);if(!K&&G.res.statusCode===304)throw new c.$Apb("Empty response",_,"EmptyResponse",G.res.statusCode,G.res.headers[c.$wpb]);Z={ref:V,content:K}}return Z}async writeResource(O,M,T,U,_={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=this.z(this.a,U,O).toString();_={..._},_["Content-Type"]=I.$zs.text,T&&(_["If-Match"]=T);const Z=await this.D(G,{type:"POST",data:M,headers:_},[],N.CancellationToken.None),V=Z.res.headers.etag;if(!V)throw new c.$Apb("Server did not return the ref",G,"NoRef",Z.res.statusCode,Z.res.headers[c.$wpb]);return V}async manifest(O,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$Vg)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",O&&(M["If-None-Match"]=O.ref);const U=await this.D(T,{type:"GET",headers:M},[304],N.CancellationToken.None);let _=null;if(U.res.statusCode===304&&(_=O),!_){const Z=U.res.headers.etag;if(!Z)throw new c.$Apb("Server did not return the ref",T,"NoRef",U.res.statusCode,U.res.headers[c.$wpb]);const V=await(0,u.$Ep)(U);if(!V&&U.res.statusCode===304)throw new c.$Apb("Empty response",T,"EmptyResponse",U.res.statusCode,U.res.headers[c.$wpb]);V&&(_={...JSON.parse(V),ref:Z})}const G=this.s.get(n,-1);return G&&_&&G!==_.session&&this.C(),_===null&&G&&this.C(),_&&this.s.store(n,_.session,-1,1),_}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,d.$Vg)(this.a,"download").toString(),M={},T=await this.D(O,{type:"GET",headers:M},[],N.CancellationToken.None);if(!(0,u.$Bp)(T))throw new c.$Apb("Server returned "+T.res.statusCode,O,"EmptyResponse",T.res.statusCode,T.res.headers[c.$wpb]);if((0,u.$Cp)(T))throw new c.$Apb("Empty response",O,"EmptyResponse",T.res.statusCode,T.res.headers[c.$wpb]);return T.stream}z(O,M,T){return M?(0,d.$Vg)(O,"collection",M,"resource",T):(0,d.$Vg)(O,"resource",T)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(O,M,T,U){if(!this.b)throw new c.$Apb("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$Apb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const _=await this.c;M.headers={...M.headers||{},..._,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:O,type:M.type,headers:{...M.headers,authorization:void 0}});let G;try{G=await this.f.request(O,M,U)}catch(B){if(!(B instanceof c.$Apb)){let ie="RequestFailed";const ae=(0,A.$0)(B).toLowerCase();ae.includes("xhr timeout")?ie="RequestTimeout":ae.includes("protocol")&&ae.includes("not supported")?ie="RequestProtocolNotSupported":ae.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":ae.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,A.$4)(B)&&(ie="RequestCanceled"),B=new c.$Apb(`Connection refused for the request '${O}'.`,O,ie,void 0,void 0)}throw this.r.info("Request failed",O),B}const Z=G.res.headers[c.$wpb],V={url:O,status:G.res.statusCode,"execution-id":M.headers[c.$xpb],"operation-id":Z},K=(0,u.$Bp)(G)||G.res.statusCode&&T.includes(G.res.statusCode);let W="";if(K?this.r.trace("Request succeeded",V):(W=await(0,u.$Dp)(G)||"",this.r.info("Request failed",V,W)),G.res.statusCode===401||G.res.statusCode===403){if(this.b=void 0,G.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$Apb(`${M.type} request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",G.res.statusCode,Z);if(G.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$Apb(`${M.type} request '${O}' failed because the access is forbidden (403).`,O,"Forbidden",G.res.statusCode,Z)}if(this.h.fire(),G.res.statusCode===404)throw new c.$Apb(`${M.type} request '${O}' failed because the requested resource is not found (404).`,O,"NotFound",G.res.statusCode,Z);if(G.res.statusCode===405)throw new c.$Apb(`${M.type} request '${O}' failed because the requested endpoint is not found (405). ${W}`,O,"MethodNotFound",G.res.statusCode,Z);if(G.res.statusCode===409)throw new c.$Apb(`${M.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",G.res.statusCode,Z);if(G.res.statusCode===410)throw new c.$Apb(`${M.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",G.res.statusCode,Z);if(G.res.statusCode===412)throw new c.$Apb(`${M.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",G.res.statusCode,Z);if(G.res.statusCode===413)throw new c.$Apb(`${M.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",G.res.statusCode,Z);if(G.res.statusCode===426)throw new c.$Apb(`${M.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",G.res.statusCode,Z);if(G.res.statusCode===429){const B=G.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new c.$Apb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",G.res.statusCode,Z)):new c.$Apb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",G.res.statusCode,Z)}if(!K)throw new c.$Apb("Server returned "+G.res.statusCode,O,"Unknown",G.res.statusCode,Z);return G}F(O){let M=this.s.get(s,-1);M===void 0&&(M=(0,m.$Eg)(),this.s.store(s,M,-1,1)),O["X-Machine-Session-Id"]=M;const T=this.s.get(n,-1);T!==void 0&&(O["X-User-Session-Id"]=T)}};e.$dKb=E,e.$dKb=E=ve([X(1,p.$8j),X(2,u.$zp),X(3,c.$Jpb),X(4,h.$pi),X(5,b.$Ok),X(6,l.$Mp)],E);let k=class extends E{constructor(O,M,T,U,_,G,Z){super(O.userDataSyncStore?.url,M,T,U,_,G,Z),this.B(O.onDidChangeUserDataSyncStore(()=>this.t(O.userDataSyncStore?.url)))}};e.$eKb=k,e.$eKb=k=ve([X(0,c.$tpb),X(1,p.$8j),X(2,u.$zp),X(3,c.$Jpb),X(4,h.$pi),X(5,b.$Ok),X(6,l.$Mp)],k);class S{constructor(O,M,T,U){this.c=O,this.d=M,this.f=T,this.g=U,this.a=[],this.b=void 0}request(O,M,T){if(this.h()&&this.i(),M.url=O,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$Apb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(O),this.f.request(M,T)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$fKb=S}),define(le[267],he([0,1,3,2,8,21,24,19,122]),function(se,e,R,N,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=e.$Hcc=e.$Gcc=e.$Fcc=void 0;class d{constructor(h){this.a=h}listen(h,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call(h,b,p){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(p)}throw new Error("Invalid call")}}e.$Fcc=d;class C extends N.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(h){super(),this.c=h,this.b=this.B(new R.$7d),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")(p=>{this.a=p,this.b.fire(p)}))})}updateAccount(h){return this.c.call("updateAccount",h)}}e.$Gcc=C;class v{constructor(h){this.a=h}listen(h,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call(h,b,p){switch(b){case"switch":return this.a.switch(p[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Hcc=v;let m=class extends P.$bKb{constructor(h,b,p,u){super(b,p,u),this.n=h,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(h){return this.n.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.n.call("getPreviousUserDataSyncStore");return this.r(h)}r(h){return{url:A.URI.revive(h.url),type:h.type,defaultUrl:A.URI.revive(h.defaultUrl),insidersUrl:A.URI.revive(h.insidersUrl),stableUrl:A.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}};e.$Icc=m,e.$Icc=m=ve([X(1,D.$8j),X(2,j.$Oi),X(3,I.$Mp)],m)}),define(le[268],he([0,1,3,57,24,19,22,263,25,80,83]),function(se,e,R,N,A,j,D,I,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;let v=class extends I.$q_b{constructor(f,h,b,p,u,g,l,c,$,i,o){super(f,h,b,p,u,l,c,$,i,o),this.B(R.Event.debounce(R.Event.any(R.Event.map(g.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(g.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$5cc=v,e.$5cc=v=ve([X(0,A.$8j),X(1,P.$tpb),X(2,P.$upb),X(3,P.$Epb),X(4,P.$Fpb),X(5,N.$Vac),X(6,P.$Jpb),X(7,d.$LIb),X(8,D.$Nl),X(9,C.$hpb),X(10,j.$Mp)],v)}),define(le[269],he([0,1,73,23,5,20]),function(se,e,R,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=void 0,e.$kac=D,e.$lac=I,e.$mac=P,e.$jac=128/4;function D(d){function C(){let v=d.scheme===N.Schemas.file?(0,j.$Jg)(d):d.toString();return A.$k||(v=v.toLowerCase()),(0,R.createHash)("md5").update(v).digest("hex")}return{id:C(),configPath:d}}function I(d,C){function v(){if(d.scheme!==N.Schemas.file)return(0,R.createHash)("md5").update(d.toString()).digest("hex");if(!C)return;let f;return A.$k?f=C.ino:A.$j?f=C.birthtime.getTime():A.$i&&(typeof C.birthtimeMs=="number"?f=Math.floor(C.birthtimeMs):f=C.birthtime.getTime()),(0,R.createHash)("md5").update(d.fsPath).update(f?String(f):"").digest("hex")}const m=v();if(typeof m=="string")return{id:m,uri:d}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[270],he([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;let b=class extends A.$Uc{constructor(u,g,l,c){super(),this.a=u,this.b=g,this.c=l,this.f=c,this.B(new R.$uh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const u=this.a.workspaceStorageHome.with({scheme:h.Schemas.file}).fsPath,g=await D.Promises.readdir(u),l=new d.$kJb(this.f.getChannel("storage"));await Promise.all(g.map(async c=>{const $=(0,j.$kc)(u,c);c.length===v.$jac||c===C.$ui.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await l.isUsed($)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await D.Promises.rm($))}))}catch(u){(0,N.$1)(u)}}};e.$Bcc=b,e.$Bcc=b=ve([X(0,I.$qi),X(1,P.$Oj),X(2,m.$Vac),X(3,f.$$bc)],b)}),define(le[123],he([0,1,73,64,37,279,15,7,3,2,14,5,32,41,68]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$_h=e.$$h=e.$0h=void 0,e.$ai=n,e.$bi=s,e.$di=a,e.$ei=y;class b{traceSocketEvent(k,S){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,S)}constructor(k,S=""){this.f=!0,this.debugLabel=S,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,I.$1)(w)}},this.socket.on("error",this.a),this.b=w=>{this.traceSocketEvent("close",{hadError:w}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const S=w=>{this.traceSocketEvent("read",w),k(D.$ue.wrap(w))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(k){const S=w=>{k({type:0,hadError:w,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(k){const S=()=>{k()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,I.$1)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,I.$1)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.$0h=b;var p;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var u;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(u||(u={}));class g extends d.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,S){this.socket.traceSocketEvent(k,S)}constructor(k,S,w,O){super(),this.f=this.B(new P.$7d),this.g=this.B(new P.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:w?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new l(this,S,w,O,this.f,(M,T)=>this.m(M,T))),this.B(this.a.onError(M=>{console.error(M),(0,I.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new h.$5h,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let S=0;for(;S<k.byteLength;)this.a.writeMessage(k.slice(S,Math.min(S+262144,k.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(k,{compressed:S,opcode:w}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let O=2;k.byteLength<126?O+=0:k.byteLength<2**16?O+=2:O+=8;const M=D.$ue.alloc(O),T=S?64:0,U=w&15;if(M.writeUInt8(128|T|U,0),k.byteLength<126)M.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){M.writeUInt8(126,1);let _=1;M.writeUInt8(k.byteLength>>>8&255,++_),M.writeUInt8(k.byteLength>>>0&255,++_)}else{M.writeUInt8(127,1);let _=1;M.writeUInt8(0,++_),M.writeUInt8(0,++_),M.writeUInt8(0,++_),M.writeUInt8(0,++_),M.writeUInt8(k.byteLength>>>24&255,++_),M.writeUInt8(k.byteLength>>>16&255,++_),M.writeUInt8(k.byteLength>>>8&255,++_),M.writeUInt8(k.byteLength>>>0&255,++_)}this.socket.write(D.$ue.concat([M,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),w=S.readUInt8(0),O=(w&128)>>>7,M=(w&64)>>>6,T=w&15,U=S.readUInt8(1),_=(U&128)>>>7,G=U&127;this.j.state=2,this.j.readLen=2+(_?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),w=S.readUInt8(1),O=(w&128)>>>7;let M=w&127,T=1;M===126?M=S.readUInt8(++T)*2**8+S.readUInt8(++T):M===127&&(M=S.readUInt8(++T)*0+S.readUInt8(++T)*0+S.readUInt8(++T)*0+S.readUInt8(++T)*0+S.readUInt8(++T)*2**24+S.readUInt8(++T)*2**16+S.readUInt8(++T)*2**8+S.readUInt8(++T));let U=0;O&&(U=S.readUInt8(++T)*2**24+S.readUInt8(++T)*2**16+S.readUInt8(++T)*2**8+S.readUInt8(++T)),this.j.state=3,this.j.readLen=M,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),i(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$$h=g;class l extends d.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ue.alloc(0)}constructor(k,S,w,O,M,T){super(),this.n=k,this.r=M,this.s=T,this.a=this.B(new P.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new P.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new c(this.n,O,w,{windowBits:15})),this.f=this.B(new $(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(k,S){this.g.push({data:k,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:S}=this.g.shift();if(this.f&&S.compressed){const w=await this.w(this.f,k);this.s(w,S)}else this.s(k,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,S){return new Promise((w,O)=>{k.write(S),k.flush(M=>w(M))})}acceptFrame(k,S,w){this.h.push({data:k,isCompressed:S,isLastFrameOfMessage:w}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const S=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,S,w){return new Promise((O,M)=>{k.write(S),w&&k.write(D.$ue.fromByteArray([0,0,255,255])),k.flush(T=>O(T))})}}class c extends d.$Uc{get recordedInflateBytes(){return this.j?D.$ue.concat(this.f):D.$ue.alloc(0)}constructor(k,S,w,O){super(),this.h=k,this.j=S,this.a=this.B(new P.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(O),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(D.$ue.wrap(M))}),w&&(this.h.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this.b.write(w.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=D.$ue.concat(this.g);this.g.length=0,k(S)})}}class $ extends d.$Uc{constructor(k,S){super(),this.g=k,this.a=this.B(new P.$7d),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",w=>{this.g.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.g.traceSocketEvent("zlibDeflateData",w),this.f.push(D.$ue.wrap(w))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=D.$ue.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),k(S)})}}function i(E,k){if(k===0)return;const S=E.byteLength>>>2;for(let _=0;_<S;_++){const G=E.readUInt32BE(_*4);E.writeUInt32BE(G^k,_*4)}const w=S*4,O=E.byteLength-w,M=k>>>24&255,T=k>>>16&255,U=k>>>8&255;O>=1&&E.writeUInt8(E.readUInt8(w)^M,w),O>=2&&E.writeUInt8(E.readUInt8(w+1)^T,w+1),O>=3&&E.writeUInt8(E.readUInt8(w+2)^U,w+2)}e.$_h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const E=(0,m.$Eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const k=process.platform!=="darwin"&&e.$_h?e.$_h:(0,A.tmpdir)(),S=(0,C.$kc)(k,`vscode-ipc-${E}.sock`);return t(S),S}function s(E,k,S){const O=(0,R.createHash)("sha256").update(E).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${S}-${k}-sock`;const M=S.substr(0,4),T=k.substr(0,6);let U;return process.platform!=="darwin"&&e.$_h&&!process.env.VSCODE_PORTABLE?U=(0,C.$kc)(e.$_h,`vscode-${O}-${M}-${T}.sock`):U=(0,C.$kc)(E,`${M}-${T}.sock`),t(U),U}function t(E){const k=o[v.$u];typeof k=="number"&&E.length>=k&&console.warn(`WARNING: IPC handle "${E}" is longer than ${k} chars, try a shorter --user-data-dir`)}class r extends f.$Yh{static b(k){const S=P.Event.fromNodeEventEmitter(k,"connection");return P.Event.map(S,w=>({protocol:new h.$6h(new b(w,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(w,"close"))}))}constructor(k){super(r.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ci=r;function a(E){return new Promise((k,S)=>{const w=(0,N.createServer)();w.on("error",S),w.listen(E,()=>{w.removeListener("error",S),k(new r(w))})})}function y(E,k){return new Promise((S,w)=>{const O=(0,N.createConnection)(E,()=>{O.removeListener("error",w),S(h.$7h.fromSocket(new b(O,`ipc-client${k}`),k))});O.once("error",w)})}}),define(le[271],he([0,1,64,123,218]),function(se,e,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0,e.$8cc=new class{supports(j){return!0}connect({host:j,port:D},I,P,d){return new Promise((C,v)=>{const m=R.createConnection({host:j,port:D},()=>{m.removeListener("error",v),m.write((0,A.$Ytb)(I,P,d));const f=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",f),C(new N.$0h(m,d)))};m.on("data",f)});m.setNoDelay(!0),m.once("error",v)})}}}),define(le[272],he([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=e.$3bc=e.$2bc=void 0;async function u(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new g(i,o,n,s,t).waitForReady(),!(t&&A.$Hg[t]||!A.$Hg[r.tunnelLocalPort]));a--);return r}class g extends I.$Uc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=R.createServer(),this.c=new D.$hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,b.$5v)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,A.$Ig)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,b.$3v)(this.tunnelRemoteHost)||(0,b.$5v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$El)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$0h?t.socket.destroy():t.end()}),t instanceof j.$0h?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(p.$ue.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$2bc=g;let l=class extends b.$8v{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,b.$6v)(o,this.m,P.OS,N.release())}t(o,n,s,t,r,a,y,E){const k=this.s(n,s);if(k)return++k.refcount,k.value;if((0,b.$Yv)(o))return this.u(o,n,s,r,a,y,E);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const S={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},w=u(S,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,w),w}}};e.$3bc=l,e.$3bc=l=ve([X(0,f.$yl),X(1,C.$Oj),X(2,h.$Bl),X(3,v.$8j),X(4,d.$Oi)],l);let c=class extends l{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$4bc=c,e.$4bc=c=ve([X(0,f.$yl),X(1,C.$Oj),X(2,h.$Bl),X(3,v.$8j),X(4,d.$Oi)],c);let $=class extends I.$Uc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,y,E,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const S=new c(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(o,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,y,E,k)}};e.$5bc=$,e.$5bc=$=ve([X(0,f.$yl),X(1,C.$Oj),X(2,v.$8j),X(3,h.$Bl),X(4,d.$Oi)],$)}),define(le[280],he([0,1,37,38,7,2,23,8,17,3,41,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(se,e,R,N,A,j,D,I,P,d,C,v,m,f,h,b,p,u,g,l,c,$,i,o,n,s,t,r,a,y,E,k,S,w,O,M,T,U,_,G,Z,V,K,W,B,ie,ae,te,ce,H,q,L,F,z,Y,J,ee,x,Q,ne,re,ue,de,$e,ye,Se,Re,Le,fe,me,be,Ce,Ie,Me,De,qe,Fe,Ue,ze,Ae,oe,ge,pe,we,Ee,Pe,Oe,Ne,We,Be,Te,Xe,Ge,_e,tt,St,kt,gt,Pt,Ct,It,Rt,Ot,Dt,Lt,jt,$t,At,mt,Nt,Mt,st,Ft,Tt,pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=wt;class Ut extends j.$Uc{constructor(ke){super(),this.f=ke,this.a=this.B(new v.$mW(this)),this.b=void 0,this.c=this.B(new d.$7d),this.g()}g(){let ke=!1;const je=()=>{ke||(ke=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,v.$nW)(process.parentPort,st.$ebc.exit,je)}async init(){const ke=await this.h();(0,x.$opb)(),ke.invokeFunction(je=>{const He=je.get(K.$Oj),Ve=je.get(H.$Nl),Qe=je.get(Pe.$ol);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(He),this.n(Ve,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(Ve,Qe))),this.r(Ve,He)}),this.B((0,j.$Rc)(ke.createInstance(m.$xcc,this.f.codeCachePath),ke.createInstance(f.$ycc),ke.createInstance(p.$Bcc),ke.createInstance(b.$Acc),ke.createInstance(h.$zcc),ke.createInstance(tt.$Ycc),ke.createInstance(Xe.$Qcc)))}async h(){const ke=new G.$gi,je={_serviceBrand:void 0,...B.default};ke.set(ie.$8j,je);const He=new C.$3h(Ke=>Ke==="main"),Ve=new $t.$_bc(this.a,He);ke.set($t.$$bc,Ve);const Qe=this.f.policiesData?new Ne.$Hbc(this.f.policiesData,Ve.getChannel("policy")):new We.$5n;ke.set(We.$3n,Qe);const Je=new Mt.$Um(this.f.args,je);ke.set(s.$qi,Je);const et=new W.$Ur(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:I.URI.revive(Ke.resource)})),Ve.getChannel("logger"));ke.set(K.$Pj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ht=this.B(new K.$Wj(ot.getLevel())),Ye=this.B(new kt.$0P(ot,[ht]));ke.set(K.$Oj,Ye),this.b=this.B(new gt.$1cc(Ye)),ke.set(gt.$Zcc,this.b);const Ze=this.B(new O.$uq(Ye));ke.set(w.$Ok,Ze);const ut=this.B(new M.$Vq(Ye));Ze.registerProvider(D.Schemas.file,ut);const at=new Ue.$js(Ze);ke.set(Fe.$ml,at);const xe=this.B(new Be.$eQ(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ke.set(Pe.$ol,xe);const ft=this.B(new Ae.$0bc(D.Schemas.file,this.B(new oe.$SP(Ve.getChannel(oe.$RP),{pathCaseSensitive:ze.$k})),D.Schemas.vscodeUserData,xe,at,Ye));Ze.registerProvider(D.Schemas.vscodeUserData,ft);const it=this.B(new c.$so(xe.defaultProfile.settingsResource,Ze,Qe,Ye));ke.set(l.$Oi,it);const dt=new At.$7cc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Je);ke.set(te.$Mp,dt),this.B((0,j.$Sc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new It.$Fr(Ve.getChannel("request"));ke.set(ae.$zp,bt),ke.set(u.$Ccc,new T.$fi(g.$Dcc,void 0,!1)),ke.set(pe.$UF,new T.$fi(ge.$Pcc,void 0,!1));const yt=new Dt.$ecc(-1,Ve);ke.set(Ot.$Vac,yt),ke.set(o.$wo,new T.$fi(n.$mQ,void 0,!0));const zt=this.B(new me.$Ebc(yt)),Bt=new C.$3h(Ke=>zt.getActiveClientId().then(lt=>Ke===lt));ke.set(S.$22b,new Rt.$3cc(this.a.getChannel("extensionRecommendationNotification",Bt)));let ct;const nt=[],vt=(0,z.$dp)(je,it);if((0,z.$$o)(je,Je)){const Ke=new L.$H$b(Ye,et,Je,je);if(nt.push(Ke),!(0,z.$_o)(je,Je)&&je.aiConfig?.ariaKey){const lt=new Te.$XP(bt,vt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,j.$Sc)(()=>lt.flush())),nt.push(lt)}ct=new F.$Jr({appenders:nt,commonProperties:(0,ce.$2o)((0,R.release)(),(0,R.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,vt),sendErrorTelemetry:!0,piiPaths:(0,z.$ep)(Je)},it,je)}else{ct=z.$6o;const Ke=z.$0o;nt.push(Ke)}this.a.registerChannel("telemetryAppender",new q.$jbc(nt)),ke.set(H.$Nl,ct);const Vt=new Y.$Ecc(it,ct,Ye,et,Je,je);ke.set(H.$Ol,Vt),ke.set(Oe.$bq,new T.$fi(Ct.$9P,void 0,!0)),ke.set(we.$fq,new T.$fi(Ee.$Ibc,void 0,!0)),ke.set(y.$Xp,new T.$fi(y.$Yp,void 0,!0)),ke.set(k.$pq,new T.$fi(k.$qq,void 0,!0)),ke.set(a.$Ro,new T.$fi(r.$Vp,void 0,!0)),ke.set(a.$Yo,new T.$fi(jt.$6cc,void 0,!1)),ke.set(Z.$Br,new T.$fi(V.$Dr,void 0,!1)),ke.set($.$2m,new T.$fi(i.$qs,void 0,!1)),ke.set(Q.$LIb,new T.$fi(Q.$MIb,void 0,!0)),ke.set(x.$Jpb,new T.$fi(ue.$9Kb,void 0,!0)),ke.set(x.$Ipb,C.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),ke.set(a.$Xo,new T.$fi(t.$JIb,void 0,!1)),ke.set(ee.$7Kb,new T.$fi(ee.$8Kb,void 0,!0)),ke.set(J.$Iv,new T.$fi(J.$Jv)),ke.set(x.$tpb,new T.$fi(Re.$cKb,void 0,!0)),ke.set(x.$upb,new T.$fi(Re.$eKb,void 0,!0)),ke.set(de.$hpb,new T.$fi(de.$jpb,void 0,!0)),ke.set(x.$vpb,new T.$fi(ne.$k_b,void 0,!1)),ke.set(x.$Epb,new T.$fi($e.$_$b,void 0,!0)),ke.set(x.$Fpb,new T.$fi(ye.$p_b,void 0,!1)),ke.set(Le.$lJb,new T.$fi(fe.$Lcc,void 0,!0)),ke.set(x.$Gpb,new T.$fi(_e.$Y_b,void 0,!0)),ke.set(be.$Bl,new T.$fi(Ce.$7bc,void 0,!1));const Et=new mt.$zl;return ke.set(mt.$yl,Et),Et.register(0,Nt.$8cc),ke.set(Ie.$Xv,new T.$fi(Me.$5bc)),ke.set(De.$Mcc,new T.$fi(qe.$Occ)),ke.set(Ge.$Rcc,new T.$fi(Pt.$2cc)),new _.$Yq(ke)}j(ke){const je=new E.$1p(ke.get(a.$Uo),()=>null);this.a.registerChannel("extensions",je);const He=C.ProxyChannel.fromService(ke.get(Z.$Br),this.q);this.a.registerChannel("languagePacks",He);const Ve=C.ProxyChannel.fromService(ke.get($.$2m),this.q);this.a.registerChannel("diagnostics",Ve);const Qe=new E.$3p(ke.get(a.$Yo));this.a.registerChannel("extensionTipsService",Qe);const Je=C.ProxyChannel.fromService(ke.get(u.$Ccc),this.q);this.a.registerChannel("checksum",Je);const et=C.ProxyChannel.fromService(ke.get(pe.$UF),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=C.ProxyChannel.fromService(ke.get(de.$hpb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=C.ProxyChannel.fromService(ke.get(H.$Ol),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Ye=new re.$Fcc(ke.get(Q.$LIb));this.a.registerChannel("userDataSyncAccount",Ye);const Ze=new re.$Hcc(ke.get(x.$tpb));this.a.registerChannel("userDataSyncStoreManagement",Ze);const ut=new Se.$Jcc(ke.get(x.$Fpb),ke.get(Pe.$ol),ke.get(K.$Oj));this.a.registerChannel("userDataSync",ut);const at=this.B(ke.get(U.$hi).createInstance(Lt.$5cc));this.a.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(ke.get(x.$Gpb),this.q));const xe=C.ProxyChannel.fromService(ke.get(De.$Mcc),this.q);this.a.registerChannel(De.$Ncc,xe);const ft=C.ProxyChannel.fromService(ke.get(Ge.$Rcc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(ke){process.on("uncaughtException",je=>(0,A.$1)(je)),process.on("unhandledRejection",je=>(0,A.$1)(je)),(0,A.setUnexpectedErrorHandler)(je=>{const He=(0,N.$6i)(je,!0);He&&ke.error(`[uncaught exception in sharedProcess]: ${He}`)})}n(ke,je){ke.publicLog2("profilesInfo",{count:je.profiles.length})}async r(ke,je){if(ze.$k){const[He,Ve]=await Promise.all([(0,Ft.$Fg)(je.error.bind(je)),(0,pt.$7V)(je.error.bind(je))]),Qe=(0,Tt.$MV)(),Je=(0,pt.$8V)(Ve,this.f.args["ozone-platform"]);He&&ke.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:Qe,displayProtocol:Ve,codeDisplayProtocol:Je})}}handledClientConnection(ke){if(ke.data!==st.$gbc.response)return!1;const je=(0,P.$Ob)(ke.ports);return je?(this.c.fire(je),!0):!1}}async function wt(rt){try{const ke=new Ut(rt);process.parentPort.postMessage(st.$ebc.ipcReady),await ke.init(),process.parentPort.postMessage(st.$ebc.initDone)}catch(ke){process.parentPort.postMessage({error:ke.toString()})}}const qt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(qt),wt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/409da0445d397e37a790ce5d2499688955c3fcfa/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
