/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],I=0,T=ge.length;I<T;I++)e[I]=Pe[ge[I]];return e};define(Pe[68],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=T,e.$Nh=R,e.$Oh=N;function I(A){return(g,d,E)=>{let O=null,y=null;if(typeof E.value=="function"?(O="value",y=E.value):typeof E.get=="function"&&(O="get",y=E.get),!y)throw new Error("not supported");E[O]=A(y,d)}}function T(A,g,d){let E=null,O=null;if(typeof d.value=="function"?(E="value",O=d.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(E="get",O=d.get),!O)throw new Error("not supported");const y=`$memoize$${g}`;d[E]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,u)}),this[y]}}function R(A,g,d){return I((E,O)=>{const y=`$debounce$${O}`,u=`$debounce$result$${O}`;return function(...w){this[u]||(this[u]=d?d():void 0),clearTimeout(this[y]),g&&(this[u]=g(this[u],...w),w=[this[u]]),this[y]=setTimeout(()=>{E.apply(this,w),this[u]=d?d():void 0},A)}})}function N(A,g,d){return I((E,O)=>{const y=`$throttle$timer$${O}`,u=`$throttle$result$${O}`,w=`$throttle$lastRun$${O}`,m=`$throttle$pending$${O}`;return function(...r){if(this[u]||(this[u]=d?d():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),g&&(this[u]=g(this[u],...r)),this[m])return;const o=this[w]+A;o<=Date.now()?(this[w]=Date.now(),E.apply(this,[this[u]]),this[u]=d?d():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),E.apply(this,[this[u]]),this[u]=d?d():void 0},o-Date.now()))}})}}),define(Pe[90],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=void 0;class I{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$QO=I,e.$RO=new I("id#")}),define(Pe[123],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=A,e.$un=y,e.$vn=u,e.$wn=w,e.$xn=m,e.$yn=r,e.$zn=o,e.$An=s,e.$Bn=n,e.$Cn=i,e.$Dn=a,e.$En=h;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(t,v=!1){let c=0;const $=t.length;let b="",p=0,l=16,D=0;function f(W){let M=0,z=0;for(;M<W;){const K=t.charCodeAt(c);if(K>=48&&K<=57)z=z*16+K-48;else if(K>=65&&K<=70)z=z*16+K-65+10;else if(K>=97&&K<=102)z=z*16+K-97+10;else break;c++,M++}return M<W&&(z=-1),z}function S(W){c=W,b="",p=0,l=16,D=0}function k(){const W=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&E(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&E(t.charCodeAt(c)))for(c++;c<t.length&&E(t.charCodeAt(c));)c++;else return D=3,t.substring(W,c);let M=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&E(t.charCodeAt(c))){for(c++;c<t.length&&E(t.charCodeAt(c));)c++;M=c}else D=3;return t.substring(W,M)}function P(){let W="",M=c;for(;;){if(c>=$){W+=t.substring(M,c),D=2;break}const z=t.charCodeAt(c);if(z===34){W+=t.substring(M,c),c++;break}if(z===92){if(W+=t.substring(M,c),c++,c>=$){D=2;break}switch(t.charCodeAt(c++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const ie=f(4);ie>=0?W+=String.fromCharCode(ie):D=4;break}default:D=5}M=c;continue}if(z>=0&&z<=31)if(d(z)){W+=t.substring(M,c),D=2;break}else D=6;c++}return W}function C(){if(b="",D=0,p=c,c>=$)return p=$,l=17;let W=t.charCodeAt(c);if(g(W)){do c++,b+=String.fromCharCode(W),W=t.charCodeAt(c);while(g(W));return l=15}if(d(W))return c++,b+=String.fromCharCode(W),W===13&&t.charCodeAt(c)===10&&(c++,b+=`
`),l=14;switch(W){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,b=P(),l=10;case 47:{const M=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<$&&!d(t.charCodeAt(c));)c++;return b=t.substring(M,c),l=12}if(t.charCodeAt(c+1)===42){c+=2;const z=$-1;let K=!1;for(;c<z;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,D=1),b=t.substring(M,c),l=13}return b+=String.fromCharCode(W),c++,l=16}case 45:if(b+=String.fromCharCode(W),c++,c===$||!E(t.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=k(),l=11;default:for(;c<$&&q(W);)c++,W=t.charCodeAt(c);if(p!==c){switch(b=t.substring(p,c),b){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return b+=String.fromCharCode(W),c++,l=16}}function q(W){if(g(W)||d(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let W;do W=C();while(W>=12&&W<=15);return W}return{setPosition:S,getPosition:()=>c,scan:v?V:C,getToken:()=>l,getTokenValue:()=>b,getTokenOffset:()=>p,getTokenLength:()=>c-p,getTokenError:()=>D}}function g(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function y(t,v){const c=[],$=new Object;let b;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(f,S,k,P){p.value=f,p.offset=S,p.length=k,p.type=P,p.colonOffset=void 0,b=p}try{i(t,{onObjectBegin:(f,S)=>{if(v<=f)throw $;b=void 0,l=v>f,c.push("")},onObjectProperty:(f,S,k)=>{if(v<S||(D(f,S,k,"property"),c[c.length-1]=f,v<=S+k))throw $},onObjectEnd:(f,S)=>{if(v<=f)throw $;b=void 0,c.pop()},onArrayBegin:(f,S)=>{if(v<=f)throw $;b=void 0,c.push(0)},onArrayEnd:(f,S)=>{if(v<=f)throw $;b=void 0,c.pop()},onLiteralValue:(f,S,k)=>{if(v<S||(D(f,S,k,h(f)),v<=S+k))throw $},onSeparator:(f,S,k)=>{if(v<=S)throw $;if(f===":"&&b&&b.type==="property")b.colonOffset=S,l=!1,b=void 0;else if(f===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(l=!0,c[c.length-1]=""),b=void 0}}})}catch(f){if(f!==$)throw f}return{path:c,previousNode:b,isAtPropertyKey:l,matches:f=>{let S=0;for(let k=0;S<f.length&&k<c.length;k++)if(f[S]===c[k]||f[S]==="*")S++;else if(f[S]!=="**")return!1;return S===f.length}}}function u(t,v=[],c=N.DEFAULT){let $=null,b=[];const p=[];function l(f){Array.isArray(b)?b.push(f):$!==null&&(b[$]=f)}return i(t,{onObjectBegin:()=>{const f={};l(f),p.push(b),b=f,$=null},onObjectProperty:f=>{$=f},onObjectEnd:()=>{b=p.pop()},onArrayBegin:()=>{const f=[];l(f),p.push(b),b=f,$=null},onArrayEnd:()=>{b=p.pop()},onLiteralValue:l,onError:(f,S,k)=>{v.push({error:f,offset:S,length:k})}},c),b[0]}function w(t,v=[],c=N.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(f){$.type==="property"&&($.length=f-$.offset,$=$.parent)}function p(f){return $.children.push(f),f}i(t,{onObjectBegin:f=>{$=p({type:"object",offset:f,length:-1,parent:$,children:[]})},onObjectProperty:(f,S,k)=>{$=p({type:"property",offset:S,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:f,offset:S,length:k,parent:$})},onObjectEnd:(f,S)=>{$.length=f+S-$.offset,$=$.parent,b(f+S)},onArrayBegin:(f,S)=>{$=p({type:"array",offset:f,length:-1,parent:$,children:[]})},onArrayEnd:(f,S)=>{$.length=f+S-$.offset,$=$.parent,b(f+S)},onLiteralValue:(f,S,k)=>{p({type:h(f),offset:S,length:k,parent:$,value:f}),b(S+k)},onSeparator:(f,S,k)=>{$.type==="property"&&(f===":"?$.colonOffset=S:f===","&&b(S))},onError:(f,S,k)=>{v.push({error:f,offset:S,length:k})}},c);const D=$.children[0];return D&&delete D.parent,D}function m(t,v){if(!t)return;let c=t;for(const $ of v)if(typeof $=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let b=!1;for(const p of c.children)if(Array.isArray(p.children)&&p.children[0].value===$){c=p.children[1],b=!0;break}if(!b)return}else{const b=$;if(c.type!=="array"||b<0||!Array.isArray(c.children)||b>=c.children.length)return;c=c.children[b]}return c}function r(t){if(!t.parent||!t.parent.children)return[];const v=r(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;v.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&v.push(c)}return v}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const v=Object.create(null);for(const c of t.children){const $=c.children[1];$&&(v[c.children[0].value]=o($))}return v}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,v,c=!1){return v>=t.offset&&v<t.offset+t.length||c&&v===t.offset+t.length}function n(t,v,c=!1){if(s(t,v,c)){const $=t.children;if(Array.isArray($))for(let b=0;b<$.length&&$[b].offset<=v;b++){const p=n($[b],v,c);if(p)return p}return t}}function i(t,v,c=N.DEFAULT){const $=A(t,!1);function b(ne){return ne?()=>ne($.getTokenOffset(),$.getTokenLength()):()=>!0}function p(ne){return ne?Se=>ne(Se,$.getTokenOffset(),$.getTokenLength()):()=>!0}const l=b(v.onObjectBegin),D=p(v.onObjectProperty),f=b(v.onObjectEnd),S=b(v.onArrayBegin),k=b(v.onArrayEnd),P=p(v.onLiteralValue),C=p(v.onSeparator),q=b(v.onComment),V=p(v.onError),W=c&&c.disallowComments,M=c&&c.allowTrailingComma;function z(){for(;;){const ne=$.scan();switch($.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:W||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ne){case 12:case 13:W?K(10):q();break;case 16:K(1);break;case 15:case 14:break;default:return ne}}}function K(ne,Se=[],je=[]){if(V(ne),Se.length+je.length>0){let re=$.getToken();for(;re!==17;){if(Se.indexOf(re)!==-1){z();break}else if(je.indexOf(re)!==-1)break;re=z()}}}function ie(ne){const Se=$.getTokenValue();return ne?P(Se):D(Se),z(),!0}function fe(){switch($.getToken()){case 11:{let ne=0;try{ne=JSON.parse($.getTokenValue()),typeof ne!="number"&&(K(2),ne=0)}catch{K(2)}P(ne);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return z(),!0}function De(){return $.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),$.getToken()===6?(C(":"),z(),$e()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function ye(){l(),z();let ne=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(ne||K(4,[],[]),C(","),z(),$.getToken()===2&&M)break}else ne&&K(6,[],[]);De()||K(4,[],[2,5]),ne=!0}return f(),$.getToken()!==2?K(7,[2],[]):z(),!0}function oe(){S(),z();let ne=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(ne||K(4,[],[]),C(","),z(),$.getToken()===4&&M)break}else ne&&K(6,[],[]);$e()||K(4,[],[4,5]),ne=!0}return k(),$.getToken()!==4?K(8,[4],[]):z(),!0}function $e(){switch($.getToken()){case 3:return oe();case 1:return ye();case 10:return ie(!0);default:return fe()}}return z(),$.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):$e()?($.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function a(t,v){const c=A(t),$=[];let b,p=0,l;do switch(l=c.getPosition(),b=c.scan(),b){case 12:case 13:case 17:p!==l&&$.push(t.substring(p,l)),v!==void 0&&$.push(c.getTokenValue().replace(/[^\r\n]/g,v)),p=c.getPosition();break}while(b!==17);return $.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[124],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(ke,pe){for(var de=0;de<pe.length;de++){var J=pe[de];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ke,J.key,J)}}function I(ke,pe,de){return pe&&e(ke.prototype,pe),de&&e(ke,de),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function T(ke,pe){if(ke){if(typeof ke=="string")return R(ke,pe);var de=Object.prototype.toString.call(ke).slice(8,-1);if(de==="Object"&&ke.constructor&&(de=ke.constructor.name),de==="Map"||de==="Set")return Array.from(ke);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return R(ke,pe)}}function R(ke,pe){(pe==null||pe>ke.length)&&(pe=ke.length);for(var de=0,J=new Array(pe);de<pe;de++)J[de]=ke[de];return J}function N(ke,pe){var de=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(de)return(de=de.call(ke)).next.bind(de);if(Array.isArray(ke)||(de=T(ke))||pe&&ke&&typeof ke.length=="number"){de&&(ke=de);var J=0;return function(){return J>=ke.length?{done:!0}:{done:!1,value:ke[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=A();function g(ke){ge.defaults=ke}var d=/[&<>"']/,E=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(pe){return u[pe]};function m(ke,pe){if(pe){if(d.test(ke))return ke.replace(E,w)}else if(O.test(ke))return ke.replace(y,w);return ke}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(r,function(pe,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(ke,pe){ke=typeof ke=="string"?ke:ke.source,pe=pe||"";var de={replace:function(Y,ue){return ue=ue.source||ue,ue=ue.replace(s,"$1"),ke=ke.replace(Y,ue),de},getRegex:function(){return new RegExp(ke,pe)}};return de}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ke,pe,de){if(ke){var J;try{J=decodeURIComponent(o(de)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}pe&&!a.test(de)&&(de=b(pe,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},v=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(ke,pe){t[" "+ke]||(v.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=f(ke,"/",!0)),ke=t[" "+ke];var de=ke.indexOf(":")===-1;return pe.substring(0,2)==="//"?de?pe:ke.replace(c,"$1")+pe:pe.charAt(0)==="/"?de?pe:ke.replace($,"$1")+pe:ke+pe}var p={exec:function(){}};function l(ke){for(var pe=1,de,J;pe<arguments.length;pe++){de=arguments[pe];for(J in de)Object.prototype.hasOwnProperty.call(de,J)&&(ke[J]=de[J])}return ke}function D(ke,pe){var de=ke.replace(/\|/g,function(ue,he,Ne){for(var le=!1,Ie=he;--Ie>=0&&Ne[Ie]==="\\";)le=!le;return le?"|":" |"}),J=de.split(/ \|/),Y=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>pe)J.splice(pe);else for(;J.length<pe;)J.push("");for(;Y<J.length;Y++)J[Y]=J[Y].trim().replace(/\\\|/g,"|");return J}function f(ke,pe,de){var J=ke.length;if(J===0)return"";for(var Y=0;Y<J;){var ue=ke.charAt(J-Y-1);if(ue===pe&&!de)Y++;else if(ue!==pe&&de)Y++;else break}return ke.slice(0,J-Y)}function S(ke,pe){if(ke.indexOf(pe[1])===-1)return-1;for(var de=ke.length,J=0,Y=0;Y<de;Y++)if(ke[Y]==="\\")Y++;else if(ke[Y]===pe[0])J++;else if(ke[Y]===pe[1]&&(J--,J<0))return Y;return-1}function k(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ke,pe){if(pe<1)return"";for(var de="";pe>1;)pe&1&&(de+=ke),pe>>=1,ke+=ke;return de+ke}function C(ke,pe,de,J){var Y=pe.href,ue=pe.title?m(pe.title):null,he=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){J.state.inLink=!0;var Ne={type:"link",raw:de,href:Y,title:ue,text:he,tokens:J.inlineTokens(he)};return J.state.inLink=!1,Ne}return{type:"image",raw:de,href:Y,title:ue,text:m(he)}}function q(ke,pe){var de=ke.match(/^(\s+)(?:```)/);if(de===null)return pe;var J=de[1];return pe.split(`
`).map(function(Y){var ue=Y.match(/^\s+/);if(ue===null)return Y;var he=ue[0];return he.length>=J.length?Y.slice(J.length):Y}).join(`
`)}var V=function(){function ke(de){this.options=de||ge.defaults}var pe=ke.prototype;return pe.space=function(J){var Y=this.rules.block.newline.exec(J);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},pe.code=function(J){var Y=this.rules.block.code.exec(J);if(Y){var ue=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:f(ue,`
`)}}},pe.fences=function(J){var Y=this.rules.block.fences.exec(J);if(Y){var ue=Y[0],he=q(ue,Y[3]||"");return{type:"code",raw:ue,lang:Y[2]?Y[2].trim():Y[2],text:he}}},pe.heading=function(J){var Y=this.rules.block.heading.exec(J);if(Y){var ue=Y[2].trim();if(/#$/.test(ue)){var he=f(ue,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ue=he.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:ue,tokens:this.lexer.inline(ue)}}},pe.hr=function(J){var Y=this.rules.block.hr.exec(J);if(Y)return{type:"hr",raw:Y[0]}},pe.blockquote=function(J){var Y=this.rules.block.blockquote.exec(J);if(Y){var ue=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},pe.list=function(J){var Y=this.rules.block.list.exec(J);if(Y){var ue,he,Ne,le,Ie,Ae,ze,U,j,G,H,ee,se=Y[1].trim(),Te=se.length>1,Ve={type:"list",raw:"",ordered:Te,start:Te?+se.slice(0,-1):"",loose:!1,items:[]};se=Te?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Te?se:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ee=!1,!(!(Y=Qe.exec(J))||this.rules.block.hr.test(J)));){if(ue=Y[0],J=J.substring(ue.length),U=Y[2].split(`
`,1)[0],j=J.split(`
`,1)[0],this.options.pedantic?(le=2,H=U.trimLeft()):(le=Y[2].search(/[^ ]/),le=le>4?1:le,H=U.slice(le),le+=Y[1].length),Ae=!1,!U&&/^ *$/.test(j)&&(ue+=j+`
`,J=J.substring(j.length+1),ee=!0),!ee)for(var xe=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");J&&(G=J.split(`
`,1)[0],U=G,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(U)||it.test(U)||xe.test(U)||et.test(J)));){if(U.search(/[^ ]/)>=le||!U.trim())H+=`
`+U.slice(le);else if(!Ae)H+=`
`+U;else break;!Ae&&!U.trim()&&(Ae=!0),ue+=G+`
`,J=J.substring(G.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test(ue)&&(ze=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(H),he&&(Ne=he[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ue,task:!!he,checked:Ne,loose:!1,text:H}),Ve.raw+=ue}Ve.items[Ve.items.length-1].raw=ue.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var nt=Ve.items.length;for(Ie=0;Ie<nt;Ie++){this.lexer.state.top=!1,Ve.items[Ie].tokens=this.lexer.blockTokens(Ve.items[Ie].text,[]);var at=Ve.items[Ie].tokens.filter(function(Ue){return Ue.type==="space"}),ft=at.every(function(Ue){for(var st=Ue.raw.split(""),Z=0,X=N(st),me;!(me=X()).done;){var We=me.value;if(We===`
`&&(Z+=1),Z>1)return!0}return!1});!Ve.loose&&at.length&&ft&&(Ve.loose=!0,Ve.items[Ie].loose=!0)}return Ve}},pe.html=function(J){var Y=this.rules.block.html.exec(J);if(Y){var ue={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]);ue.type="paragraph",ue.text=he,ue.tokens=this.lexer.inline(he)}return ue}},pe.def=function(J){var Y=this.rules.block.def.exec(J);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var ue=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:Y[0],href:Y[2],title:Y[3]}}},pe.table=function(J){var Y=this.rules.block.table.exec(J);if(Y){var ue={type:"table",header:D(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=Y[0];var he=ue.align.length,Ne,le,Ie,Ae;for(Ne=0;Ne<he;Ne++)/^ *-+: *$/.test(ue.align[Ne])?ue.align[Ne]="right":/^ *:-+: *$/.test(ue.align[Ne])?ue.align[Ne]="center":/^ *:-+ *$/.test(ue.align[Ne])?ue.align[Ne]="left":ue.align[Ne]=null;for(he=ue.rows.length,Ne=0;Ne<he;Ne++)ue.rows[Ne]=D(ue.rows[Ne],ue.header.length).map(function(ze){return{text:ze}});for(he=ue.header.length,le=0;le<he;le++)ue.header[le].tokens=this.lexer.inline(ue.header[le].text);for(he=ue.rows.length,le=0;le<he;le++)for(Ae=ue.rows[le],Ie=0;Ie<Ae.length;Ie++)Ae[Ie].tokens=this.lexer.inline(Ae[Ie].text);return ue}}},pe.lheading=function(J){var Y=this.rules.block.lheading.exec(J);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},pe.paragraph=function(J){var Y=this.rules.block.paragraph.exec(J);if(Y){var ue=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:ue,tokens:this.lexer.inline(ue)}}},pe.text=function(J){var Y=this.rules.block.text.exec(J);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},pe.escape=function(J){var Y=this.rules.inline.escape.exec(J);if(Y)return{type:"escape",raw:Y[0],text:m(Y[1])}},pe.tag=function(J){var Y=this.rules.inline.tag.exec(J);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]}},pe.link=function(J){var Y=this.rules.inline.link.exec(J);if(Y){var ue=Y[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var he=f(ue.slice(0,-1),"\\");if((ue.length-he.length)%2===0)return}else{var Ne=S(Y[2],"()");if(Ne>-1){var le=Y[0].indexOf("!")===0?5:4,Ie=le+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Ie).trim(),Y[3]=""}}var Ae=Y[2],ze="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);U&&(Ae=U[1],ze=U[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ue)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),C(Y,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},pe.reflink=function(J,Y){var ue;if((ue=this.rules.inline.reflink.exec(J))||(ue=this.rules.inline.nolink.exec(J))){var he=(ue[2]||ue[1]).replace(/\s+/g," ");if(he=Y[he.toLowerCase()],!he||!he.href){var Ne=ue[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return C(ue,he,ue[0],this.lexer)}},pe.emStrong=function(J,Y,ue){ue===void 0&&(ue="");var he=this.rules.inline.emStrong.lDelim.exec(J);if(he&&!(he[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=he[1]||he[2]||"";if(!Ne||Ne&&(ue===""||this.rules.inline.punctuation.exec(ue))){var le=he[0].length-1,Ie,Ae,ze=le,U=0,j=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,Y=Y.slice(-1*J.length+le);(he=j.exec(Y))!=null;)if(Ie=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Ie){if(Ae=Ie.length,he[3]||he[4]){ze+=Ae;continue}else if((he[5]||he[6])&&le%3&&!((le+Ae)%3)){U+=Ae;continue}if(ze-=Ae,!(ze>0)){if(Ae=Math.min(Ae,Ae+ze+U),Math.min(le,Ae)%2){var G=J.slice(1,le+he.index+Ae);return{type:"em",raw:J.slice(0,le+he.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=J.slice(2,le+he.index+Ae-1);return{type:"strong",raw:J.slice(0,le+he.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},pe.codespan=function(J){var Y=this.rules.inline.code.exec(J);if(Y){var ue=Y[2].replace(/\n/g," "),he=/[^ ]/.test(ue),Ne=/^ /.test(ue)&&/ $/.test(ue);return he&&Ne&&(ue=ue.substring(1,ue.length-1)),ue=m(ue,!0),{type:"codespan",raw:Y[0],text:ue}}},pe.br=function(J){var Y=this.rules.inline.br.exec(J);if(Y)return{type:"br",raw:Y[0]}},pe.del=function(J){var Y=this.rules.inline.del.exec(J);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},pe.autolink=function(J,Y){var ue=this.rules.inline.autolink.exec(J);if(ue){var he,Ne;return ue[2]==="@"?(he=m(this.options.mangle?Y(ue[1]):ue[1]),Ne="mailto:"+he):(he=m(ue[1]),Ne=he),{type:"link",raw:ue[0],text:he,href:Ne,tokens:[{type:"text",raw:he,text:he}]}}},pe.url=function(J,Y){var ue;if(ue=this.rules.inline.url.exec(J)){var he,Ne;if(ue[2]==="@")he=m(this.options.mangle?Y(ue[0]):ue[0]),Ne="mailto:"+he;else{var le;do le=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(le!==ue[0]);he=m(ue[0]),ue[1]==="www."?Ne="http://"+he:Ne=he}return{type:"link",raw:ue[0],text:he,href:Ne,tokens:[{type:"text",raw:he,text:he}]}}},pe.inlineText=function(J,Y){var ue=this.rules.inline.text.exec(J);if(ue){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):m(ue[0]):ue[0]:he=m(this.options.smartypants?Y(ue[0]):ue[0]),{type:"text",raw:ue[0],text:he}}},ke}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=n(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=n(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=n(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=n(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=n(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=n(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=l({},W),W.gfm=l({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=n(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=n(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=l({},W.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:n(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=n(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=n(W._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=n(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=n(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=n(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=n(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=n(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=n(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=n(M.reflink).replace("label",M._label).replace("ref",W._label).getRegex(),M.nolink=n(M.nolink).replace("ref",W._label).getRegex(),M.reflinkSearch=n(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=l({},M),M.pedantic=l({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=l({},M.normal,{escape:n(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=n(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=l({},M.gfm,{br:n(M.br).replace("{2,}","*").getRegex(),text:n(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ke){var pe="",de,J,Y=ke.length;for(de=0;de<Y;de++)J=ke.charCodeAt(de),Math.random()>.5&&(J="x"+J.toString(16)),pe+="&#"+J+";";return pe}var ie=function(){function ke(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ge.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:W.normal,inline:M.normal};this.options.pedantic?(J.block=W.pedantic,J.inline=M.pedantic):this.options.gfm&&(J.block=W.gfm,this.options.breaks?J.inline=M.breaks:J.inline=M.gfm),this.tokenizer.rules=J}ke.lex=function(J,Y){var ue=new ke(Y);return ue.lex(J)},ke.lexInline=function(J,Y){var ue=new ke(Y);return ue.inlineTokens(J)};var pe=ke.prototype;return pe.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},pe.blockTokens=function(J,Y){var ue=this;Y===void 0&&(Y=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ze,U,j){return U+"    ".repeat(j.length)});for(var he,Ne,le,Ie;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(he=ze.call({lexer:ue},J,Y))?(J=J.substring(he.raw.length),Y.push(he),!0):!1}))){if(he=this.tokenizer.space(J)){J=J.substring(he.raw.length),he.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(he);continue}if(he=this.tokenizer.code(J)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he);continue}if(he=this.tokenizer.fences(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.heading(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.hr(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.blockquote(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.list(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.html(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.def(J)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.lheading(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(le=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,U=J.slice(1),j=void 0;ue.options.extensions.startBlock.forEach(function(G){j=G.call({lexer:this},U),typeof j=="number"&&j>=0&&(ze=Math.min(ze,j))}),ze<1/0&&ze>=0&&(le=J.substring(0,ze+1))}(),this.state.top&&(he=this.tokenizer.paragraph(le))){Ne=Y[Y.length-1],Ie&&Ne.type==="paragraph"?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he),Ie=le.length!==J.length,J=J.substring(he.raw.length);continue}if(he=this.tokenizer.text(J)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(he);continue}if(J){var Ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Y},pe.inline=function(J,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:J,tokens:Y}),Y},pe.inlineTokens=function(J,Y){var ue=this;Y===void 0&&(Y=[]);var he,Ne,le,Ie=J,Ae,ze,U;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)j.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ze||(U=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(he=H.call({lexer:ue},J,Y))?(J=J.substring(he.raw.length),Y.push(he),!0):!1}))){if(he=this.tokenizer.escape(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.tag(J)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&he.type==="text"&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(he=this.tokenizer.link(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(he.raw.length),Ne=Y[Y.length-1],Ne&&he.type==="text"&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(he=this.tokenizer.emStrong(J,Ie,U)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.codespan(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.br(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.del(J)){J=J.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.autolink(J,K)){J=J.substring(he.raw.length),Y.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(J,K))){J=J.substring(he.raw.length),Y.push(he);continue}if(le=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=J.slice(1),se=void 0;ue.options.extensions.startInline.forEach(function(Te){se=Te.call({lexer:this},ee),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(le=J.substring(0,H+1))}(),he=this.tokenizer.inlineText(le,z)){J=J.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(U=he.raw.slice(-1)),ze=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=he.raw,Ne.text+=he.text):Y.push(he);continue}if(J){var G="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},I(ke,null,[{key:"rules",get:function(){return{block:W,inline:M}}}]),ke}(),fe=function(){function ke(de){this.options=de||ge.defaults}var pe=ke.prototype;return pe.code=function(J,Y,ue){var he=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(J,he);Ne!=null&&Ne!==J&&(ue=!0,J=Ne)}return J=J.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+m(he,!0)+'">'+(ue?J:m(J,!0))+`</code></pre>
`:"<pre><code>"+(ue?J:m(J,!0))+`</code></pre>
`},pe.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},pe.html=function(J){return J},pe.heading=function(J,Y,ue,he){if(this.options.headerIds){var Ne=this.options.headerPrefix+he.slug(ue);return"<h"+Y+' id="'+Ne+'">'+J+"</h"+Y+`>
`}return"<h"+Y+">"+J+"</h"+Y+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(J,Y,ue){var he=Y?"ol":"ul",Ne=Y&&ue!==1?' start="'+ue+'"':"";return"<"+he+Ne+`>
`+J+"</"+he+`>
`},pe.listitem=function(J){return"<li>"+J+`</li>
`},pe.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(J){return"<p>"+J+`</p>
`},pe.table=function(J,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Y+`</table>
`},pe.tablerow=function(J){return`<tr>
`+J+`</tr>
`},pe.tablecell=function(J,Y){var ue=Y.header?"th":"td",he=Y.align?"<"+ue+' align="'+Y.align+'">':"<"+ue+">";return he+J+("</"+ue+`>
`)},pe.strong=function(J){return"<strong>"+J+"</strong>"},pe.em=function(J){return"<em>"+J+"</em>"},pe.codespan=function(J){return"<code>"+J+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(J){return"<del>"+J+"</del>"},pe.link=function(J,Y,ue){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ue;var he='<a href="'+m(J)+'"';return Y&&(he+=' title="'+Y+'"'),he+=">"+ue+"</a>",he},pe.image=function(J,Y,ue){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ue;var he='<img src="'+J+'" alt="'+ue+'"';return Y&&(he+=' title="'+Y+'"'),he+=this.options.xhtml?"/>":">",he},pe.text=function(J){return J},ke}(),De=function(){function ke(){}var pe=ke.prototype;return pe.strong=function(J){return J},pe.em=function(J){return J},pe.codespan=function(J){return J},pe.del=function(J){return J},pe.html=function(J){return J},pe.text=function(J){return J},pe.link=function(J,Y,ue){return""+ue},pe.image=function(J,Y,ue){return""+ue},pe.br=function(){return""},ke}(),ye=function(){function ke(){this.seen={}}var pe=ke.prototype;return pe.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(J,Y){var ue=J,he=0;if(this.seen.hasOwnProperty(ue)){he=this.seen[J];do he++,ue=J+"-"+he;while(this.seen.hasOwnProperty(ue))}return Y||(this.seen[J]=he,this.seen[ue]=0),ue},pe.slug=function(J,Y){Y===void 0&&(Y={});var ue=this.serialize(J);return this.getNextSafeSlug(ue,Y.dryrun)},ke}(),oe=function(){function ke(de){this.options=de||ge.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new ye}ke.parse=function(J,Y){var ue=new ke(Y);return ue.parse(J)},ke.parseInline=function(J,Y){var ue=new ke(Y);return ue.parseInline(J)};var pe=ke.prototype;return pe.parse=function(J,Y){Y===void 0&&(Y=!0);var ue="",he,Ne,le,Ie,Ae,ze,U,j,G,H,ee,se,Te,Ve,Qe,xe,et,ot,it,nt=J.length;for(he=0;he<nt;he++){if(H=J[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){ue+=it||"";continue}switch(H.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(j="",U="",Ie=H.header.length,Ne=0;Ne<Ie;Ne++)U+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(j+=this.renderer.tablerow(U),G="",Ie=H.rows.length,Ne=0;Ne<Ie;Ne++){for(ze=H.rows[Ne],U="",Ae=ze.length,le=0;le<Ae;le++)U+=this.renderer.tablecell(this.parseInline(ze[le].tokens),{header:!1,align:H.align[le]});G+=this.renderer.tablerow(U)}ue+=this.renderer.table(j,G);continue}case"blockquote":{G=this.parse(H.tokens),ue+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,se=H.start,Te=H.loose,Ie=H.items.length,G="",Ne=0;Ne<Ie;Ne++)Qe=H.items[Ne],xe=Qe.checked,et=Qe.task,Ve="",Qe.task&&(ot=this.renderer.checkbox(xe),Te?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=ot+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=ot+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:ot}):Ve+=ot),Ve+=this.parse(Qe.tokens,Te),G+=this.renderer.listitem(Ve,et,xe);ue+=this.renderer.list(G,ee,se);continue}case"html":{ue+=this.renderer.html(H.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;he+1<nt&&J[he+1].type==="text";)H=J[++he],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);ue+=Y?this.renderer.paragraph(G):G;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return ue},pe.parseInline=function(J,Y){Y=Y||this.renderer;var ue="",he,Ne,le,Ie=J.length;for(he=0;he<Ie;he++){if(Ne=J[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(le=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){ue+=le||"";continue}switch(Ne.type){case"escape":{ue+=Y.text(Ne.text);break}case"html":{ue+=Y.html(Ne.text);break}case"link":{ue+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{ue+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{ue+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{ue+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{ue+=Y.codespan(Ne.text);break}case"br":{ue+=Y.br();break}case"del":{ue+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{ue+=Y.text(Ne.text);break}default:{var Ae='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ue},ke}();function $e(ke,pe,de){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof pe=="function"&&(de=pe,pe=null),pe=l({},$e.defaults,pe||{}),k(pe),de){var J=pe.highlight,Y;try{Y=ie.lex(ke,pe)}catch(Ie){return de(Ie)}var ue=function(Ae){var ze;if(!Ae)try{pe.walkTokens&&$e.walkTokens(Y,pe.walkTokens),ze=oe.parse(Y,pe)}catch(U){Ae=U}return pe.highlight=J,Ae?de(Ae):de(null,ze)};if(!J||J.length<3||(delete pe.highlight,!Y.length))return ue();var he=0;$e.walkTokens(Y,function(Ie){Ie.type==="code"&&(he++,setTimeout(function(){J(Ie.text,Ie.lang,function(Ae,ze){if(Ae)return ue(Ae);ze!=null&&ze!==Ie.text&&(Ie.text=ze,Ie.escaped=!0),he--,he===0&&ue()})},0))}),he===0&&ue();return}function Ne(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(Ie.message+"",!0)+"</pre>";throw Ie}try{var le=ie.lex(ke,pe);if(pe.walkTokens){if(pe.async)return Promise.all($e.walkTokens(le,pe.walkTokens)).then(function(){return oe.parse(le,pe)}).catch(Ne);$e.walkTokens(le,pe.walkTokens)}return oe.parse(le,pe)}catch(Ie){Ne(Ie)}}$e.options=$e.setOptions=function(ke){return l($e.defaults,ke),g($e.defaults),$e},$e.getDefaults=A,$e.defaults=ge.defaults,$e.use=function(){for(var ke=arguments.length,pe=new Array(ke),de=0;de<ke;de++)pe[de]=arguments[de];var J=l.apply(void 0,[{}].concat(pe)),Y=$e.defaults.extensions||{renderers:{},childTokens:{}},ue;pe.forEach(function(he){if(he.extensions&&(ue=!0,he.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var Ie=Y.renderers?Y.renderers[le.name]:null;Ie?Y.renderers[le.name]=function(){for(var Ae=arguments.length,ze=new Array(Ae),U=0;U<Ae;U++)ze[U]=arguments[U];var j=le.renderer.apply(this,ze);return j===!1&&(j=Ie.apply(this,ze)),j}:Y.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[le.level]?Y[le.level].unshift(le.tokenizer):Y[le.level]=[le.tokenizer],le.start&&(le.level==="block"?Y.startBlock?Y.startBlock.push(le.start):Y.startBlock=[le.start]:le.level==="inline"&&(Y.startInline?Y.startInline.push(le.start):Y.startInline=[le.start]))}le.childTokens&&(Y.childTokens[le.name]=le.childTokens)})),he.renderer&&function(){var le=$e.defaults.renderer||new fe,Ie=function(U){var j=le[U];le[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var se=he.renderer[U].apply(le,H);return se===!1&&(se=j.apply(le,H)),se}};for(var Ae in he.renderer)Ie(Ae);J.renderer=le}(),he.tokenizer&&function(){var le=$e.defaults.tokenizer||new V,Ie=function(U){var j=le[U];le[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var se=he.tokenizer[U].apply(le,H);return se===!1&&(se=j.apply(le,H)),se}};for(var Ae in he.tokenizer)Ie(Ae);J.tokenizer=le}(),he.walkTokens){var Ne=$e.defaults.walkTokens;J.walkTokens=function(le){var Ie=[];return Ie.push(he.walkTokens.call(this,le)),Ne&&(Ie=Ie.concat(Ne.call(this,le))),Ie}}ue&&(J.extensions=Y),$e.setOptions(J)})},$e.walkTokens=function(ke,pe){for(var de=[],J=function(){var Ne=ue.value;switch(de=de.concat(pe.call($e,Ne)),Ne.type){case"table":{for(var le=N(Ne.header),Ie;!(Ie=le()).done;){var Ae=Ie.value;de=de.concat($e.walkTokens(Ae.tokens,pe))}for(var ze=N(Ne.rows),U;!(U=ze()).done;)for(var j=U.value,G=N(j),H;!(H=G()).done;){var ee=H.value;de=de.concat($e.walkTokens(ee.tokens,pe))}break}case"list":{de=de.concat($e.walkTokens(Ne.items,pe));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Ne.type]?$e.defaults.extensions.childTokens[Ne.type].forEach(function(se){de=de.concat($e.walkTokens(Ne[se],pe))}):Ne.tokens&&(de=de.concat($e.walkTokens(Ne.tokens,pe)))}},Y=N(ke),ue;!(ue=Y()).done;)J();return de},$e.parseInline=function(ke,pe){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");pe=l({},$e.defaults,pe||{}),k(pe);try{var de=ie.lexInline(ke,pe);return pe.walkTokens&&$e.walkTokens(de,pe.walkTokens),oe.parseInline(de,pe)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(J.message+"",!0)+"</pre>";throw J}},$e.Parser=oe,$e.parser=oe.parse,$e.Renderer=fe,$e.TextRenderer=De,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=V,$e.Slugger=ye,$e.parse=$e;var ne=$e.options,Se=$e.setOptions,je=$e.use,re=$e.walkTokens,L=$e.parseInline,_=$e,ve=oe.parse,Oe=ie.lex;ge.Lexer=ie,ge.Parser=oe,ge.Renderer=fe,ge.Slugger=ye,ge.TextRenderer=De,ge.Tokenizer=V,ge.getDefaults=A,ge.lexer=Oe,ge.marked=$e,ge.options=ne,ge.parse=_,ge.parseInline=L,ge.parser=ve,ge.setOptions=Se,ge.use=je,ge.walkTokens=re,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=I;function I(r){const o=N(r);if(o&&o.length>0)return new Uint32Array(o)}let T=0;const R=new Uint32Array(10);function N(r){if(T=0,A(r,y,4352),T>0||(A(r,u,4449),T>0)||(A(r,w,4520),T>0)||(A(r,m,12593),T))return R.subarray(0,T);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,n=Math.floor(o/588),i=Math.floor(s/28),a=s%28-1;if(n<y.length?A(n,y,0):4352+n-12593<m.length&&A(4352+n,m,12593),i<u.length?A(i,u,0):4449+i-12593<m.length&&A(4449+i-12593,m,12593),a>=0&&(a<w.length?A(a,w,0):4520+a-12593<m.length&&A(4520+a-12593,m,12593)),T>0)return R.subarray(0,T)}}function A(r,o,s){r>=s&&r<s+o.length&&g(o[r-s])}function g(r){r!==0&&(R[T++]=r&255,r>>8&&(R[T++]=r>>8&255),r>>16&&(R[T++]=r>>16&255))}var d;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var E;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(E||(E={}));var O;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(O||(O={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[126],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=I,e.rot=T;function I(g,d,E){return Math.min(Math.max(g,d),E)}function T(g,d){return(d+g%d)%d}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=R;class N{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=N;class A{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const E=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=A}),function(){function ge(R){const N=[];typeof R=="number"&&N.push("code/timeOrigin",R);function A(d){N.push(d,Date.now())}function g(){const d=[];for(let E=0;E<N.length;E+=2)d.push({name:N[E],startTime:N[E+1]});return d}return{mark:A,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(R+A.startTime)});return N}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=I(T))}(),define(Pe[127],Re([1,0,39]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=void 0;const T=Symbol("unset");class R{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(d,E,O){this.d(d,y=>y._value=E,O)}mutate(d,E){this.d(d,O=>O._value=E(O._value===T?void 0:O._value))}delete(d){const E=this.c(d);if(!E)return;let O=E.length-1;const y=E[O].node._value;if(y!==T){for(this.b--,E[O].node._value=T;O>0;O--){const{node:u,part:w}=E[O];if(u.children?.size||u._value!==T)break;E[O-1].node.children.delete(w)}return y}}*deleteRecursive(d){const E=this.c(d);if(!E)return;const O=E[E.length-1].node;for(let y=E.length-1;y>0;y--){const u=E[y-1];if(u.node.children.delete(E[y].part),u.node.children.size>0||u.node._value!==T)break}for(const y of N(O))y._value!==T&&(this.b--,yield y._value)}find(d){let E=this.a;for(const O of d){const y=E.children?.get(O);if(!y)return;E=y}return E._value===T?void 0:E._value}hasKeyOrParent(d){let E=this.a;for(const O of d){const y=E.children?.get(O);if(!y)return!1;if(y._value!==T)return!0;E=y}return!1}hasKeyOrChildren(d){let E=this.a;for(const O of d){const y=E.children?.get(O);if(!y)return!1;E=y}return!0}hasKey(d){let E=this.a;for(const O of d){const y=E.children?.get(O);if(!y)return!1;E=y}return E._value!==T}c(d){const E=[{part:"",node:this.a}];let O=0;for(const y of d){const u=E[O].node.children?.get(y);if(!u)return;E.push({part:y,node:u}),O++}return E}d(d,E,O){let y=this.a;for(const m of d){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const r=new A;y.children.set(m,r),y=r}else{const r=new A;y.children=new Map([[m,r]]),y=r}O?.(y)}const u=y._value===T?0:1;E(y);const w=y._value===T?0:1;this.b+=w-u}*values(){for(const{_value:d}of N(this.a))d!==T&&(yield d)}}e.$AO=R;function*N(g){const d=[g];for(;d.length>0;){const E=d.pop();if(yield E,E.children)for(const O of E.children.values())d.push(O)}}class A{constructor(){this._value=T}get value(){return this._value===T?void 0:this._value}set value(d){this._value=d===void 0?T:d}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var T in I)(typeof exports=="object"?exports:ge)[T]=I[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(T){if(e[T])return e[T].exports;var R=e[T]={i:T,l:!1,exports:{}};return ge[T].call(R.exports,R,R.exports,I),R.l=!0,R.exports}return I.m=ge,I.c=e,I.d=function(T,R,N){I.o(T,R)||Object.defineProperty(T,R,{enumerable:!0,get:N})},I.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},I.t=function(T,R){if(1&R&&(T=I(T)),8&R||4&R&&typeof T=="object"&&T&&T.__esModule)return T;var N=Object.create(null);if(I.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:T}),2&R&&typeof T!="string")for(var A in T)I.d(N,A,function(g){return T[g]}.bind(null,A));return N},I.n=function(T){var R=T&&T.__esModule?function(){return T.default}:function(){return T};return I.d(R,"a",R),R},I.o=function(T,R){return Object.prototype.hasOwnProperty.call(T,R)},I.p="",I(I.s=0)}([function(ge,e,I){(function(T){var R;e=ge.exports=je,R=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],d=e.src=[],E=0,O=E++;d[O]="0|[1-9]\\d*";var y=E++;d[y]="[0-9]+";var u=E++;d[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=E++;d[w]="("+d[O]+")\\.("+d[O]+")\\.("+d[O]+")";var m=E++;d[m]="("+d[y]+")\\.("+d[y]+")\\.("+d[y]+")";var r=E++;d[r]="(?:"+d[O]+"|"+d[u]+")";var o=E++;d[o]="(?:"+d[y]+"|"+d[u]+")";var s=E++;d[s]="(?:-("+d[r]+"(?:\\."+d[r]+")*))";var n=E++;d[n]="(?:-?("+d[o]+"(?:\\."+d[o]+")*))";var i=E++;d[i]="[0-9A-Za-z-]+";var a=E++;d[a]="(?:\\+("+d[i]+"(?:\\."+d[i]+")*))";var h=E++,t="v?"+d[w]+d[s]+"?"+d[a]+"?";d[h]="^"+t+"$";var v="[v=\\s]*"+d[m]+d[n]+"?"+d[a]+"?",c=E++;d[c]="^"+v+"$";var $=E++;d[$]="((?:<|>)?=?)";var b=E++;d[b]=d[y]+"|x|X|\\*";var p=E++;d[p]=d[O]+"|x|X|\\*";var l=E++;d[l]="[v=\\s]*("+d[p]+")(?:\\.("+d[p]+")(?:\\.("+d[p]+")(?:"+d[s]+")?"+d[a]+"?)?)?";var D=E++;d[D]="[v=\\s]*("+d[b]+")(?:\\.("+d[b]+")(?:\\.("+d[b]+")(?:"+d[n]+")?"+d[a]+"?)?)?";var f=E++;d[f]="^"+d[$]+"\\s*"+d[l]+"$";var S=E++;d[S]="^"+d[$]+"\\s*"+d[D]+"$";var k=E++;d[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=E++;d[P]="(?:~>?)";var C=E++;d[C]="(\\s*)"+d[P]+"\\s+",g[C]=new RegExp(d[C],"g");var q=E++;d[q]="^"+d[P]+d[l]+"$";var V=E++;d[V]="^"+d[P]+d[D]+"$";var W=E++;d[W]="(?:\\^)";var M=E++;d[M]="(\\s*)"+d[W]+"\\s+",g[M]=new RegExp(d[M],"g");var z=E++;d[z]="^"+d[W]+d[l]+"$";var K=E++;d[K]="^"+d[W]+d[D]+"$";var ie=E++;d[ie]="^"+d[$]+"\\s*("+v+")$|^$";var fe=E++;d[fe]="^"+d[$]+"\\s*("+t+")$|^$";var De=E++;d[De]="(\\s*)"+d[$]+"\\s*("+v+"|"+d[l]+")",g[De]=new RegExp(d[De],"g");var ye=E++;d[ye]="^\\s*("+d[l]+")\\s+-\\s+("+d[l]+")\\s*$";var oe=E++;d[oe]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var $e=E++;d[$e]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)R(ne,d[ne]),g[ne]||(g[ne]=new RegExp(d[ne]));function Se(j,G){if(j instanceof je)return j;if(typeof j!="string"||j.length>N||!(G?g[c]:g[h]).test(j))return null;try{return new je(j,G)}catch{return null}}function je(j,G){if(j instanceof je){if(j.loose===G)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof je))return new je(j,G);R("SemVer",j,G),this.loose=G;var H=j.trim().match(G?g[c]:g[h]);if(!H)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<A)return se}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Se,e.valid=function(j,G){var H=Se(j,G);return H?H.version:null},e.clean=function(j,G){var H=Se(j.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=je,je.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},je.prototype.toString=function(){return this.version},je.prototype.compare=function(j){return R("SemVer.compare",this.version,this.loose,j),j instanceof je||(j=new je(j,this.loose)),this.compareMain(j)||this.comparePre(j)},je.prototype.compareMain=function(j){return j instanceof je||(j=new je(j,this.loose)),L(this.major,j.major)||L(this.minor,j.minor)||L(this.patch,j.patch)},je.prototype.comparePre=function(j){if(j instanceof je||(j=new je(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=j.prerelease[G];if(R("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return L(H,ee)}while(++G)},je.prototype.inc=function(j,G){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new je(j,H).inc(G,ee).version}catch{return null}},e.diff=function(j,G){if(ke(j,G))return null;var H=Se(j),ee=Se(G);if(H.prerelease.length||ee.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return se},e.compareIdentifiers=L;var re=/^[0-9]+$/;function L(j,G){var H=re.test(j),ee=re.test(G);return H&&ee&&(j=+j,G=+G),H&&!ee?-1:ee&&!H?1:j<G?-1:j>G?1:0}function _(j,G,H){return new je(j,H).compare(new je(G,H))}function ve(j,G,H){return _(j,G,H)>0}function Oe(j,G,H){return _(j,G,H)<0}function ke(j,G,H){return _(j,G,H)===0}function pe(j,G,H){return _(j,G,H)!==0}function de(j,G,H){return _(j,G,H)>=0}function J(j,G,H){return _(j,G,H)<=0}function Y(j,G,H,ee){var se;switch(G){case"===":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j===H;break;case"!==":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j!==H;break;case"":case"=":case"==":se=ke(j,H,ee);break;case"!=":se=pe(j,H,ee);break;case">":se=ve(j,H,ee);break;case">=":se=de(j,H,ee);break;case"<":se=Oe(j,H,ee);break;case"<=":se=J(j,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return se}function ue(j,G){if(j instanceof ue){if(j.loose===G)return j;j=j.value}if(!(this instanceof ue))return new ue(j,G);R("comparator",j,G),this.loose=G,this.parse(j),this.semver===he?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(j,G){return L(G,j)},e.major=function(j,G){return new je(j,G).major},e.minor=function(j,G){return new je(j,G).minor},e.patch=function(j,G){return new je(j,G).patch},e.compare=_,e.compareLoose=function(j,G){return _(j,G,!0)},e.rcompare=function(j,G,H){return _(G,j,H)},e.sort=function(j,G){return j.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(j,G){return j.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=ve,e.lt=Oe,e.eq=ke,e.neq=pe,e.gte=de,e.lte=J,e.cmp=Y,e.Comparator=ue;var he={};function Ne(j,G){if(j instanceof Ne)return j.loose===G?j:new Ne(j.raw,G);if(j instanceof ue)return new Ne(j.value,G);if(!(this instanceof Ne))return new Ne(j,G);if(this.loose=G,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function le(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ie(j,G,H,ee,se,Te,Ve,Qe,xe,et,ot,it,nt){return((G=le(H)?"":le(ee)?">="+H+".0.0":le(se)?">="+H+"."+ee+".0":">="+G)+" "+(Qe=le(xe)?"":le(et)?"<"+(+xe+1)+".0.0":le(ot)?"<"+xe+"."+(+et+1)+".0":it?"<="+xe+"."+et+"."+ot+"-"+it:"<="+Qe)).trim()}function Ae(j,G){for(var H=0;H<j.length;H++)if(!j[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<j.length;H++)if(R(j[H].semver),j[H].semver!==he&&j[H].semver.prerelease.length>0){var ee=j[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function ze(j,G,H){try{G=new Ne(G,H)}catch{return!1}return G.test(j)}function U(j,G,H,ee){var se,Te,Ve,Qe,xe;switch(j=new je(j,ee),G=new Ne(G,ee),H){case">":se=ve,Te=J,Ve=Oe,Qe=">",xe=">=";break;case"<":se=Oe,Te=de,Ve=ve,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(j,G,ee))return!1;for(var et=0;et<G.set.length;++et){var ot=G.set[et],it=null,nt=null;if(ot.forEach(function(at){at.semver===he&&(at=new ue(">=0.0.0")),it=it||at,nt=nt||at,se(at.semver,it.semver,ee)?it=at:Ve(at.semver,nt.semver,ee)&&(nt=at)}),it.operator===Qe||it.operator===xe||(!nt.operator||nt.operator===Qe)&&Te(j,nt.semver)||nt.operator===xe&&Ve(j,nt.semver))return!1}return!0}ue.prototype.parse=function(j){var G=this.loose?g[ie]:g[fe],H=j.match(G);if(!H)throw new TypeError("Invalid comparator: "+j);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new je(H[2],this.loose):this.semver=he},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(j){return R("Comparator.test",j,this.loose),this.semver===he||(typeof j=="string"&&(j=new je(j,this.loose)),Y(j,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(j,G){if(!(j instanceof ue))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(j.value,G),ze(this.value,H,G);if(j.operator==="")return H=new Ne(this.value,G),ze(j.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Te=this.semver.version===j.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Qe=Y(this.semver,"<",j.semver,G)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),xe=Y(this.semver,">",j.semver,G)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ee||se||Te&&Ve||Qe||xe},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(j){var G=this.loose;j=j.trim(),R("range",j,G);var H=G?g[oe]:g[ye];j=j.replace(H,Ie),R("hyphen replace",j),j=j.replace(g[De],"$1$2$3"),R("comparator trim",j,g[De]),j=(j=(j=j.replace(g[C],"$1~")).replace(g[M],"$1^")).split(/\s+/).join(" ");var ee=G?g[ie]:g[fe],se=j.split(" ").map(function(Te){return function(Ve,Qe){return R("comp",Ve),Ve=function(xe,et){return xe.trim().split(/\s+/).map(function(ot){return function(it,nt){R("caret",it,nt);var at=nt?g[K]:g[z];return it.replace(at,function(ft,Ue,st,Z,X){var me;return R("caret",it,ft,Ue,st,Z,X),le(Ue)?me="":le(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":le(Z)?me=Ue==="0"?">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+".0 <"+(+Ue+1)+".0.0":X?(R("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+Z+X+" <"+Ue+"."+st+"."+(+Z+1):">="+Ue+"."+st+"."+Z+X+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+Z+X+" <"+(+Ue+1)+".0.0"):(R("no pr"),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+Z+" <"+Ue+"."+st+"."+(+Z+1):">="+Ue+"."+st+"."+Z+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+Z+" <"+(+Ue+1)+".0.0"),R("caret return",me),me})}(ot,et)}).join(" ")}(Ve,Qe),R("caret",Ve),Ve=function(xe,et){return xe.trim().split(/\s+/).map(function(ot){return function(it,nt){var at=nt?g[V]:g[q];return it.replace(at,function(ft,Ue,st,Z,X){var me;return R("tilde",it,ft,Ue,st,Z,X),le(Ue)?me="":le(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":le(Z)?me=">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":X?(R("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=">="+Ue+"."+st+"."+Z+X+" <"+Ue+"."+(+st+1)+".0"):me=">="+Ue+"."+st+"."+Z+" <"+Ue+"."+(+st+1)+".0",R("tilde return",me),me})}(ot,et)}).join(" ")}(Ve,Qe),R("tildes",Ve),Ve=function(xe,et){return R("replaceXRanges",xe,et),xe.split(/\s+/).map(function(ot){return function(it,nt){it=it.trim();var at=nt?g[S]:g[f];return it.replace(at,function(ft,Ue,st,Z,X,me){R("xRange",it,ft,Ue,st,Z,X,me);var We=le(st),Ze=We||le(Z),Me=Ze||le(X);return Ue==="="&&Me&&(Ue=""),We?ft=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&Me?(Ze&&(Z=0),Me&&(X=0),Ue===">"?(Ue=">=",Ze?(st=+st+1,Z=0,X=0):Me&&(Z=+Z+1,X=0)):Ue==="<="&&(Ue="<",Ze?st=+st+1:Z=+Z+1),ft=Ue+st+"."+Z+"."+X):Ze?ft=">="+st+".0.0 <"+(+st+1)+".0.0":Me&&(ft=">="+st+"."+Z+".0 <"+st+"."+(+Z+1)+".0"),R("xRange return",ft),ft})}(ot,et)}).join(" ")}(Ve,Qe),R("xrange",Ve),Ve=function(xe,et){return R("replaceStars",xe,et),xe.trim().replace(g[$e],"")}(Ve,Qe),R("stars",Ve),Ve}(Te,G)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Te){return!!Te.match(ee)})),se=se.map(function(Te){return new ue(Te,G)})},Ne.prototype.intersects=function(j,G){if(!(j instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return j.set.some(function(se){return se.every(function(Te){return ee.intersects(Te,G)})})})})},e.toComparators=function(j,G){return new Ne(j,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new je(j,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],j))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(j,G,H){var ee=null,se=null;try{var Te=new Ne(G,H)}catch{return null}return j.forEach(function(Ve){Te.test(Ve)&&(ee&&se.compare(Ve)!==-1||(se=new je(ee=Ve,H)))}),ee},e.minSatisfying=function(j,G,H){var ee=null,se=null;try{var Te=new Ne(G,H)}catch{return null}return j.forEach(function(Ve){Te.test(Ve)&&(ee&&se.compare(Ve)!==1||(se=new je(ee=Ve,H)))}),ee},e.validRange=function(j,G){try{return new Ne(j,G).range||"*"}catch{return null}},e.ltr=function(j,G,H){return U(j,G,"<",H)},e.gtr=function(j,G,H){return U(j,G,">",H)},e.outside=U,e.prerelease=function(j,G){var H=Se(j,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(j,G,H){return j=new Ne(j,H),G=new Ne(G,H),j.intersects(G)},e.coerce=function(j){if(j instanceof je)return j;if(typeof j!="string")return null;var G=j.match(g[k]);return G==null?null:Se((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,T,R=ge.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function g(o){if(I===setTimeout)return setTimeout(o,0);if((I===N||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:N}catch{I=N}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var d,E=[],O=!1,y=-1;function u(){O&&d&&(O=!1,d.length?E=d.concat(E):y=-1,E.length&&w())}function w(){if(!O){var o=g(u);O=!0;for(var s=E.length;s;){for(d=E,E=[];++y<s;)d&&d[y].run();y=-1,s=E.length}d=null,O=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(o)}}function m(o,s){this.fun=o,this.array=s}function r(){}R.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];E.push(new m(o,s)),E.length!==1||O||g(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=r,R.addListener=r,R.once=r,R.off=r,R.removeListener=r,R.removeAllListeners=r,R.emit=r,R.prependListener=r,R.prependOnceListener=r,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Pe[128],Re([1,0,14,6]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=R,e.$ge=N,e.$he=A,e.$ie=g,e.$je=E,e.$ke=O,e.$le=y,e.$me=u,e.$ne=w,e.$oe=m,e.$pe=r,e.$qe=o,e.$re=s,e.$se=n,e.$te=i;function R(a){const h=a;return h?typeof h.read=="function":!1}function N(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function A(a){const h=a;return h?N(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function g(a,h){return new d(a,h)}class d{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let v;switch(h){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const c=v.indexOf(t);c>=0&&v.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(a,h){const t=[];let v;for(;(v=a.read())!==null;)t.push(v);return h(t)}function O(a,h,t){const v=[];let c;for(;(c=a.read())!==null&&v.length<t;)v.push(c);return c===null&&v.length>0?h(v):{read:()=>{if(v.length>0)return v.shift();if(typeof c<"u"){const $=c;return c=void 0,$}return a.read()}}}function y(a,h){return new Promise((t,v)=>{const c=[];u(a,{onData:$=>{h&&c.push($)},onError:$=>{h?v($):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}function u(a,h,t){a.on("error",v=>{t?.isCancellationRequested||h.onError(v)}),a.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),a.on("data",v=>{t?.isCancellationRequested||h.onData(v)})}function w(a,h){return new Promise((t,v)=>{const c=new T.$Tc,$=[],b=D=>{if($.push(D),$.length>h)return c.dispose(),a.pause(),t({stream:a,buffer:$,ended:!1})},p=D=>(c.dispose(),v(D)),l=()=>(c.dispose(),t({stream:a,buffer:$,ended:!0}));c.add((0,T.$Sc)(()=>a.removeListener("error",p))),a.on("error",p),c.add((0,T.$Sc)(()=>a.removeListener("end",l))),a.on("end",l),c.add((0,T.$Sc)(()=>a.removeListener("data",b))),a.on("data",b)})}function m(a,h){const t=g(h);return t.end(a),t}function r(){const a=g(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}function s(a,h,t){const v=g(t);return u(a,{onData:c=>v.write(h.data(c)),onError:c=>v.error(h.error?h.error(c):c),onEnd:()=>v.end()}),v}function n(a,h,t){let v=!1;return{read:()=>{const c=h.read();return v?c:(v=!0,c!==null?t([a,c]):a)}}}function i(a,h,t){let v=!1;const c=g(t);return u(h,{onData:$=>v?c.write($):(v=!0,c.write(t([a,$]))),onError:$=>c.error($),onEnd:()=>{v||(v=!0,c.write(a)),c.end()}}),c}}),define(Pe[22],Re([1,0,40,128]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=E,e.$we=O,e.$xe=y,e.$ye=u,e.$ze=w,e.$Ae=m,e.$Be=r,e.$Ce=o,e.$De=s,e.$Ee=n,e.$Fe=i,e.$Ge=a,e.$He=h,e.$Ie=t,e.$Je=v,e.$Ke=c,e.$Le=$,e.$Me=b,e.$Ne=p,e.$Oe=f;const R=typeof Buffer<"u",N=new I.$V(()=>new Uint8Array(256));let A,g;class d{static alloc(k){return R?new d(Buffer.allocUnsafe(k)):new d(new Uint8Array(k))}static wrap(k){return R&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new d(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&R?new d(Buffer.from(k)):(A||(A=new TextEncoder),new d(A.encode(k)))}static fromByteArray(k){const P=d.alloc(k.length);for(let C=0,q=k.length;C<q;C++)P.buffer[C]=k[C];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let V=0,W=k.length;V<W;V++)P+=k[V].byteLength}const C=d.alloc(P);let q=0;for(let V=0,W=k.length;V<W;V++){const M=k[V];C.set(M,q),q+=M.byteLength}return C}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=d.alloc(this.byteLength);return k.set(this),k}toString(){return R?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(k,P){return new d(this.buffer.subarray(k,P))}set(k,P){if(k instanceof d)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return u(this.buffer,k)}writeUInt32BE(k,P){w(this.buffer,k,P)}readUInt32LE(k){return m(this.buffer,k)}writeUInt32LE(k,P){r(this.buffer,k,P)}readUInt8(k){return o(this.buffer,k)}writeUInt8(k,P){s(this.buffer,k,P)}indexOf(k,P=0){return E(this.buffer,k instanceof d?k.buffer:k,P)}}e.$ue=d;function E(S,k,P=0){const C=k.byteLength,q=S.byteLength;if(C===0)return 0;if(C===1)return S.indexOf(k[0]);if(C>q-P)return-1;const V=N.value;V.fill(k.length);for(let K=0;K<k.length;K++)V[k[K]]=k.length-K-1;let W=P+k.length-1,M=W,z=-1;for(;W<q;)if(S[W]===k[M]){if(M===0){z=W;break}W--,M--}else W+=Math.max(k.length-M,V[S[W]]),M=k.length-1;return z}function O(S,k){return S[k+0]<<0>>>0|S[k+1]<<8>>>0}function y(S,k,P){S[P+0]=k&255,k=k>>>8,S[P+1]=k&255}function u(S,k){return S[k]*2**24+S[k+1]*2**16+S[k+2]*2**8+S[k+3]}function w(S,k,P){S[P+3]=k,k=k>>>8,S[P+2]=k,k=k>>>8,S[P+1]=k,k=k>>>8,S[P]=k}function m(S,k){return S[k+0]<<0>>>0|S[k+1]<<8>>>0|S[k+2]<<16>>>0|S[k+3]<<24>>>0}function r(S,k,P){S[P+0]=k&255,k=k>>>8,S[P+1]=k&255,k=k>>>8,S[P+2]=k&255,k=k>>>8,S[P+3]=k&255}function o(S,k){return S[k]}function s(S,k,P){S[P]=k}function n(S){return T.$je(S,k=>d.concat(k))}function i(S){return T.$qe(S)}function a(S){return T.$le(S,k=>d.concat(k))}async function h(S){return S.ended?d.concat(S.buffer):d.concat([...S.buffer,await a(S.stream)])}function t(S){return T.$oe(S,k=>d.concat(k))}function v(S){return T.$re(S,{data:k=>typeof k=="string"?d.fromString(k):d.wrap(k)},k=>d.concat(k))}function c(S){return T.$ie(k=>d.concat(k),S)}function $(S,k){return T.$se(S,k,P=>d.concat(P))}function b(S,k){return T.$te(S,k,P=>d.concat(P))}function p(S){let k=0,P=0,C=0;const q=new Uint8Array(Math.floor(S.length/4*3)),V=M=>{switch(P){case 3:q[C++]=k|M,P=0;break;case 2:q[C++]=k|M>>>2,k=M<<6,P=3;break;case 1:q[C++]=k|M>>>4,k=M<<4,P=2;break;default:k=M<<2,P=1}};for(let M=0;M<S.length;M++){const z=S.charCodeAt(M);if(z>=65&&z<=90)V(z-65);else if(z>=97&&z<=122)V(z-97+26);else if(z>=48&&z<=57)V(z-48+52);else if(z===43||z===45)V(62);else if(z===47||z===95)V(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${S[M]}`)}}const W=C;for(;P>0;)V(0);return d.wrap(q).slice(0,W)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:S},k=!0,P=!1){const C=P?D:l;let q="";const V=S.byteLength%3;let W=0;for(;W<S.byteLength-V;W+=3){const M=S[W+0],z=S[W+1],K=S[W+2];q+=C[M>>>2],q+=C[(M<<4|z>>>4)&63],q+=C[(z<<2|K>>>6)&63],q+=C[K&63]}if(V===1){const M=S[W+0];q+=C[M>>>2],q+=C[M<<4&63],k&&(q+="==")}else if(V===2){const M=S[W+0],z=S[W+1];q+=C[M>>>2],q+=C[(M<<4|z>>>4)&63],q+=C[z<<2&63],k&&(q+="=")}return q}}),define(Pe[129],Re([1,0,28,125,15]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=N,e.$lk=g,e.$mk=d,e.$nk=y,e.$ok=p,e.$pk=l,e.$qk=C,e.$rk=q,e.$sk=V,e.$tk=W,e.$uk=_,e.$wk=pe,e.$xk=Y,e.$yk=ue;function N(...le){return function(Ie,Ae){for(let ze=0,U=le.length;ze<U;ze++){const j=le[ze](Ie,Ae);if(j)return j}return null}}e.$jk=A.bind(void 0,!1),e.$kk=A.bind(void 0,!0);function A(le,Ie,Ae){if(!Ae||Ae.length<Ie.length)return null;let ze;return le?ze=R.$mf(Ae,Ie):ze=Ae.indexOf(Ie)===0,ze?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function g(le,Ie){const Ae=Ie.toLowerCase().indexOf(le.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+le.length}]}function d(le,Ie){return E(le.toLowerCase(),Ie.toLowerCase(),0,0)}function E(le,Ie,Ae,ze){if(Ae===le.length)return[];if(ze===Ie.length)return null;if(le[Ae]===Ie[ze]){let U=null;return(U=E(le,Ie,Ae+1,ze+1))?a({start:ze,end:ze+1},U):null}return E(le,Ie,Ae,ze+1)}function O(le){return 97<=le&&le<=122}function y(le){return 65<=le&&le<=90}function u(le){return 48<=le&&le<=57}function w(le){return le===32||le===9||le===10||le===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>m.add(le.charCodeAt(0)));function r(le){return w(le)||m.has(le)}function o(le,Ie){return le===Ie||r(le)&&r(Ie)}const s=new Map;function n(le){if(s.has(le))return s.get(le);let Ie;const Ae=(0,T.$hk)(le);return Ae&&(Ie=Ae),s.set(le,Ie),Ie}function i(le){return O(le)||y(le)||u(le)}function a(le,Ie){return Ie.length===0?Ie=[le]:le.end===Ie[0].start?Ie[0].start=le.start:Ie.unshift(le),Ie}function h(le,Ie){for(let Ae=Ie;Ae<le.length;Ae++){const ze=le.charCodeAt(Ae);if(y(ze)||u(ze)||Ae>0&&!i(le.charCodeAt(Ae-1)))return Ae}return le.length}function t(le,Ie,Ae,ze){if(Ae===le.length)return[];if(ze===Ie.length)return null;if(le[Ae]!==Ie[ze].toLowerCase())return null;{let U=null,j=ze+1;for(U=t(le,Ie,Ae+1,ze+1);!U&&(j=h(Ie,j))<Ie.length;)U=t(le,Ie,Ae+1,j),j++;return U===null?null:a({start:ze,end:ze+1},U)}}function v(le){let Ie=0,Ae=0,ze=0,U=0,j=0;for(let Te=0;Te<le.length;Te++)j=le.charCodeAt(Te),y(j)&&Ie++,O(j)&&Ae++,i(j)&&ze++,u(j)&&U++;const G=Ie/le.length,H=Ae/le.length,ee=ze/le.length,se=U/le.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:se}}function c(le){const{upperPercent:Ie,lowerPercent:Ae}=le;return Ae===0&&Ie>.6}function $(le){const{upperPercent:Ie,lowerPercent:Ae,alphaPercent:ze,numericPercent:U}=le;return Ae>.2&&Ie<.8&&ze>.6&&U<.2}function b(le){let Ie=0,Ae=0,ze=0,U=0;for(let j=0;j<le.length;j++)ze=le.charCodeAt(j),y(ze)&&Ie++,O(ze)&&Ae++,w(ze)&&U++;return(Ie===0||Ae===0)&&U===0?le.length<=30:Ie<=5}function p(le,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!b(le))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Ae=v(Ie);if(!$(Ae)){if(!c(Ae))return null;Ie=Ie.toLowerCase()}let ze=null,U=0;for(le=le.toLowerCase();U<Ie.length&&(ze=t(le,Ie,0,U))===null;)U=h(Ie,U+1);return ze}function l(le,Ie,Ae=!1){if(!Ie||Ie.length===0)return null;let ze=null,U=0;for(le=le.toLowerCase(),Ie=Ie.toLowerCase();U<Ie.length&&(ze=D(le,Ie,0,U,Ae),ze===null);)U=f(Ie,U+1);return ze}function D(le,Ie,Ae,ze,U){let j=0;if(Ae===le.length)return[];if(ze===Ie.length)return null;if(!o(le.charCodeAt(Ae),Ie.charCodeAt(ze))){const ee=n(le.charCodeAt(Ae));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!o(ee[se],Ie.charCodeAt(ze+se)))return null;j+=ee.length-1}let G=null,H=ze+j+1;if(G=D(le,Ie,Ae+1,H,U),!U)for(;!G&&(H=f(Ie,H))<Ie.length;)G=D(le,Ie,Ae+1,H,U),H++;if(!G)return null;if(le.charCodeAt(Ae)!==Ie.charCodeAt(ze)){const ee=n(le.charCodeAt(Ae));if(!ee)return G;for(let se=0;se<ee.length;se++)if(ee[se]!==Ie.charCodeAt(ze+se))return G}return a({start:ze,end:ze+j+1},G)}function f(le,Ie){for(let Ae=Ie;Ae<le.length;Ae++)if(r(le.charCodeAt(Ae))||Ae>0&&r(le.charCodeAt(Ae-1)))return Ae;return le.length}const S=N(e.$kk,p,g),k=N(e.$kk,p,d),P=new I.$Ec(1e4);function C(le,Ie,Ae=!1){if(typeof le!="string"||typeof Ie!="string")return null;let ze=P.get(le);ze||(ze=new RegExp(R.$7e(le),"i"),P.set(le,ze));const U=ze.exec(Ie);return U?[{start:U.index,end:U.index+U[0].length}]:Ae?k(le,Ie):S(le,Ie)}function q(le,Ie){const Ae=pe(le,le.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?W(Ae):null}function V(le,Ie,Ae,ze,U,j){const G=Math.min(13,le.length);for(;Ae<G;Ae++){const H=pe(le,Ie,Ae,ze,U,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,j]}function W(le){if(typeof le>"u")return[];const Ie=[],Ae=le[1];for(let ze=le.length-1;ze>1;ze--){const U=le[ze]+Ae,j=Ie[Ie.length-1];j&&j.end===U?j.end=U+1:Ie.push({start:U,end:U+1})}return Ie}const M=128;function z(){const le=[],Ie=[];for(let Ae=0;Ae<=M;Ae++)Ie[Ae]=0;for(let Ae=0;Ae<=M;Ae++)le.push(Ie.slice(0));return le}function K(le){const Ie=[];for(let Ae=0;Ae<=le;Ae++)Ie[Ae]=0;return Ie}const ie=K(2*M),fe=K(2*M),De=z(),ye=z(),oe=z(),$e=!1;function ne(le,Ie,Ae,ze,U){function j(H,ee,se=" "){for(;H.length<ee;)H=se+H;return H}let G=` |   |${ze.split("").map(H=>j(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?G+=" |":G+=`${Ie[H-1]}|`,G+=le[H].slice(0,U+1).map(ee=>j(ee.toString(),3)).join("|")+`
`;return G}function Se(le,Ie,Ae,ze){le=le.substr(Ie),Ae=Ae.substr(ze),console.log(ne(ye,le,le.length,Ae,Ae.length)),console.log(ne(oe,le,le.length,Ae,Ae.length)),console.log(ne(De,le,le.length,Ae,Ae.length))}function je(le,Ie){if(Ie<0||Ie>=le.length)return!1;const Ae=le.codePointAt(Ie);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Ef(Ae)}}function re(le,Ie){if(Ie<0||Ie>=le.length)return!1;switch(le.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function L(le,Ie,Ae){return Ie[le]!==Ae[le]}function _(le,Ie,Ae,ze,U,j,G=!1){for(;Ie<Ae&&U<j;)le[Ie]===ze[U]&&(G&&(ie[Ie]=U),Ie+=1),U+=1;return Ie===Ae}var ve;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Oe;(function(le){le.Default=[-100,0];function Ie(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}le.isDefault=Ie})(Oe||(e.FuzzyScore=Oe={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Ae){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Ae}}e.$vk=ke;function pe(le,Ie,Ae,ze,U,j,G=ke.default){const H=le.length>M?M:le.length,ee=ze.length>M?M:ze.length;if(Ae>=H||j>=ee||H-Ae>ee-j||!_(Ie,Ae,H,U,j,ee,!0))return;de(H,ee,Ae,j,Ie,U);let se=1,Te=1,Ve=Ae,Qe=j;const xe=[!1];for(se=1,Ve=Ae;Ve<H;se++,Ve++){const at=ie[Ve],ft=fe[Ve],Ue=Ve+1<H?fe[Ve+1]:ee;for(Te=at-j+1,Qe=at;Qe<Ue;Te++,Qe++){let st=Number.MIN_SAFE_INTEGER,Z=!1;Qe<=ft&&(st=J(le,Ie,Ve,Ae,ze,U,Qe,ee,j,De[se-1][Te-1]===0,xe));let X=0;st!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=st+ye[se-1][Te-1]);const me=Qe>at,We=me?ye[se][Te-1]+(De[se][Te-1]>0?-5:0):0,Ze=Qe>at+1&&De[se][Te-1]>0,Me=Ze?ye[se][Te-2]+(De[se][Te-2]>0?-5:0):0;if(Ze&&(!me||Me>=We)&&(!Z||Me>=X))ye[se][Te]=Me,oe[se][Te]=3,De[se][Te]=0;else if(me&&(!Z||We>=X))ye[se][Te]=We,oe[se][Te]=2,De[se][Te]=0;else if(Z)ye[se][Te]=X,oe[se][Te]=1,De[se][Te]=De[se-1][Te-1]+1;else throw new Error("not possible")}}if($e&&Se(le,Ae,ze,j),!xe[0]&&!G.firstMatchCanBeWeak)return;se--,Te--;const et=[ye[se][Te],j];let ot=0,it=0;for(;se>=1;){let at=Te;do{const ft=oe[se][at];if(ft===3)at=at-2;else if(ft===2)at=at-1;else break}while(at>=1);ot>1&&Ie[Ae+se-1]===U[j+Te-1]&&!L(at+j-1,ze,U)&&ot+1>De[se][at]&&(at=Te),at===Te?ot++:ot=1,it||(it=at),se--,Te=at-1,et.push(Te)}ee===H&&G.boostFullMatch&&(et[0]+=2);const nt=it-H;return et[0]-=nt,et}function de(le,Ie,Ae,ze,U,j){let G=le-1,H=Ie-1;for(;G>=Ae&&H>=ze;)U[G]===j[H]&&(fe[G]=H,G--),H--}function J(le,Ie,Ae,ze,U,j,G,H,ee,se,Te){if(Ie[Ae]!==j[G])return Number.MIN_SAFE_INTEGER;let Ve=1,Qe=!1;return G===Ae-ze?Ve=le[Ae]===U[G]?7:5:L(G,U,j)&&(G===0||!L(G-1,U,j))?(Ve=le[Ae]===U[G]?7:5,Qe=!0):je(j,G)&&(G===0||!je(j,G-1))?Ve=5:(je(j,G-1)||re(j,G-1))&&(Ve=5,Qe=!0),Ve>1&&Ae===ze&&(Te[0]=!0),Qe||(Qe=L(G,U,j)||je(j,G-1)||re(j,G-1)),Ae===ze?G>ee&&(Ve-=Qe?3:5):se?Ve+=Qe?2:0:Ve+=Qe?0:1,G+1===H&&(Ve-=Qe?3:5),Ve}function Y(le,Ie,Ae,ze,U,j,G){return he(le,Ie,Ae,ze,U,j,!0,G)}function ue(le,Ie,Ae,ze,U,j,G){return he(le,Ie,Ae,ze,U,j,!1,G)}function he(le,Ie,Ae,ze,U,j,G,H){let ee=pe(le,Ie,Ae,ze,U,j,H);if(ee&&!G)return ee;if(le.length>=3){const se=Math.min(7,le.length-1);for(let Te=Ae+1;Te<se;Te++){const Ve=Ne(le,Te);if(Ve){const Qe=pe(Ve,Ve.toLowerCase(),Ae,ze,U,j,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Ne(le,Ie){if(Ie+1>=le.length)return;const Ae=le[Ie],ze=le[Ie+1];if(Ae!==ze)return le.slice(0,Ie)+ze+Ae+le.slice(Ie+2)}}),define(Pe[32],Re([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(T||(T={})),function(R){const N="error",A="warning",g="warn",d="info",E="ignore";function O(u){return u?I.$lf(N,u)?R.Error:I.$lf(A,u)||I.$lf(g,u)?R.Warning:I.$lf(d,u)?R.Info:R.Ignore:R.Ignore}R.fromValue=O;function y(u){switch(u){case R.Error:return N;case R.Warning:return A;case R.Info:return d;default:return E}}R.toString=y}(T||(T={})),e.default=T}),define(Pe[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Pe[52],Re([1,0,18,15]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const m=w.charCodeAt(0),r=this.b.charCodeAt(this.c);return m-r}value(){return this.b[this.c]}}e.$ki=R;class N{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,T.$ff)(w,this.b,0,w.length,this.c,this.d):(0,T.$hf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=N;class A{constructor(w=!0,m=!0){this.f=w,this.g=m}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let m=w.length-1;m>=0;m--,this.c--){const r=this.b.charCodeAt(m);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,T.$ff)(w,this.b,0,w.length,this.d,this.e):(0,T.$hf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=A;var g;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(g||(g={}));class d{constructor(w,m){this.f=w,this.g=m,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,T.$gf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,T.$gf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,T.$ef)(w,this.c.query);if(this.d[this.e]===5)return(0,T.$ef)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=d;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(O||(O={}));class y{static forUris(w=()=>!1,m=()=>!1){return new y(new d(w,m))}static forPaths(w=!1){return new y(new A(void 0,!w))}static forStrings(){return new y(new R)}static forConfigKeys(){return new y(new N)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,m){if(m){const r=m.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o,w)}else{const r=w.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(w,m){const r=this.b.reset(w);let o;this.c||(this.c=new E,this.c.segment=r.value());const s=[];for(o=this.c;;){const i=r.cmp(o.segment);if(i>0)o.left||(o.left=new E,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new E,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new E,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=m,o.key=w;for(let i=s.length-1;i>=0;i--){const a=s[i][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const t=s[i][0],v=s[i+1][0];if(t===1&&v===1)s[i][1]=a.rotateLeft();else if(t===-1&&v===-1)s[i][1]=a.rotateRight();else if(t===1&&v===-1)a.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=a.rotateLeft();else if(t===-1&&v===1)a.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return n}get(w){return this.d(w)?.value}d(w){const m=this.b.reset(w);let r=this.c;for(;r;){const o=m.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(m.hasNext())m.next(),r=r.mid;else break}return r}has(w){const m=this.d(w);return!(m?.value===void 0&&m?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,m){const r=this.b.reset(w),o=[];let s=this.c;for(;s;){const n=r.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(m?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:i,value:a,segment:h}=n;this.e(n.key,!1),s.key=i,s.value=a,s.segment=h}}else{const n=s.left??s.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const i=o[n][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[n][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[n][1]=i.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const m=this.b.reset(w);let r=this.c,o;for(;r;){const s=m.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(m.hasNext())m.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(w){return this.g(w,!1)}g(w,m){const r=this.b.reset(w);let o=this.c;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[m,r]of this)w(r,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const m=[];return this.j(w,m),m[Symbol.iterator]()}j(w,m){w&&(w.left&&this.j(w.left,m),w.value&&m.push([w.key,w.value]),w.mid&&this.j(w.mid,m),w.right&&this.j(w.right,m))}_isBalanced(){const w=m=>{if(!m)return!0;const r=m.balanceFactor();return r<-1||r>1?!1:w(m.left)&&w(m.right)};return w(this.c)}}e.$oi=y}),define(Pe[41],Re([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=R;var T;(function(A){function g(d){return d&&typeof d=="object"&&typeof d.id=="string"}A.isThemeColor=g})(T||(e.ThemeColor=T={}));function R(A){return{id:A}}var N;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function d(n){const i=g.exec(n.id);if(!i)return d(I.$Hj.error);const[,a,h]=i,t=["codicon","codicon-"+a];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=d;function E(n){return d(n).join(" ")}A.asClassName=E;function O(n){return"."+d(n).join(".")}A.asCSSSelector=O;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}A.isThemeIcon=y;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function w(n){const i=u.exec(n);if(!i)return;const[,a]=i;return{id:a}}A.fromString=w;function m(n){return{id:n}}A.fromId=m;function r(n,i){let a=n.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),i&&(a=`${a}~${i}`),{id:a}}A.modify=r;function o(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}A.getModifier=o;function s(n,i){return n.id===i.id&&n.color?.id===i.color?.id}A.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Pe[131],Re([1,0,129,15,41]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=d,e.$Ak=O,e.$Bk=u,e.$Ck=w,e.$Dk=r,e.$Ek=o;const N="$(",A=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${A.source}`,"g");function d(s){return s.replace(g,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${A.source}`,"g");function O(s){return s.replace(E,n=>`\\${n}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(s){return s.indexOf(N)===-1?s:s.replace(y,(n,i,a,h)=>a?n:i||h||"")}function w(s){return s?s.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const m=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){m.lastIndex=0;let n="";const i=[];let a=0;for(;;){const h=m.lastIndex,t=m.exec(s),v=s.substring(h,t?.index);if(v.length>0){n+=v;for(let c=0;c<v.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:n,iconOffsets:i}}function o(s,n,i=!1){const{text:a,iconOffsets:h}=n;if(!h||h.length===0)return(0,I.$qk)(s,a,i);const t=(0,T.$5e)(a," "),v=a.length-t.length,c=(0,I.$qk)(s,t,i);if(c)for(const $ of c){const b=h[$.start+v]+v;$.start+=b,$.end+=b}return c}}),define(Pe[34],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=T;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(R){return I.test(R)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(g){for(let d=0;d<g.length;d++)g[d]=Math.floor(Math.random()*256);return g};const N=new Uint8Array(16),A=[];for(let g=0;g<256;g++)A.push(g.toString(16).padStart(2,"0"));return function(){R(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let d=0,E="";return E+=A[N[d++]],E+=A[N[d++]],E+=A[N[d++]],E+=A[N[d++]],E+="-",E+=A[N[d++]],E+=A[N[d++]],E+="-",E+=A[N[d++]],E+=A[N[d++]],E+="-",E+=A[N[d++]],E+=A[N[d++]],E+="-",E+=A[N[d++]],E+=A[N[d++]],E+=A[N[d++]],E+=A[N[d++]],E+=A[N[d++]],E+=A[N[d++]],E}}()}),define(Pe[132],Re([1,0,18,39,34]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.$Jt=void 0,e.$Ht=N,e.$It=A,e.$Kt=E;function N(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,u,w){const m={id:(0,R.$Eg)(),name:y,uri:u,data:w};return{asString:async()=>"",asFile:()=>m,value:void 0}}class g{constructor(){this.a=new Map}get size(){let u=0;for(const w of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const w=[...this.a.keys()];return T.Iterable.some(this,([m,r])=>r.asFile())&&w.push("files"),O(d(u),w)}get(u){return this.a.get(this.b(u))?.[0]}append(u,w){const m=this.a.get(u);m?m.push(w):this.a.set(this.b(u),[w])}replace(u,w){this.a.set(this.b(u),[w])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,w]of this.a)for(const m of w)yield[u,m]}b(u){return d(u)}}e.$Jt=g;function d(y){return y.toLowerCase()}function E(y,u){return O(d(y),u.map(d))}function O(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const w=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[m,r,o]=w;return o==="*"?u.some(s=>s.startsWith(r+"/")):!1}e.$Lt=Object.freeze({create:y=>(0,I.$Mb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Lt.split(y).filter(u=>!u.startsWith("#"))})}),define(Pe[133],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Ot=T;var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function T(R){let N=0,A=0,g=0,d=0;for(let E=0,O=R.length;E<O;E++){const y=R.charCodeAt(E);y===13?(N===0&&(A=E),N++,E+1<O&&R.charCodeAt(E+1)===10?(d|=2,E++):d|=3,g=E+1):y===10&&(d|=1,N===0&&(A=E),N++,g=E+1)}return N===0&&(A=R.length),[N,A,R.length-g,d]}}),define(Pe[134],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0,e.$Ms={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[135],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=e.$bu=e.IndentAction=void 0;var I;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class T{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let d=0,E=g.notIn.length;d<E;d++)switch(g.notIn[d]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,d){if(g.getTokenCount()===0)return!0;const E=g.findTokenIndexAtOffset(d-2),O=g.getStandardTokenType(E);return this.isOK(O)}g(g,d){for(let E=g;E<=d;E++){const O=String.fromCharCode(E);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$bu=T;class R{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const d of g)N(this.autoClosingPairsOpenByStart,d.open.charAt(0),d),N(this.autoClosingPairsOpenByEnd,d.open.charAt(d.open.length-1),d),N(this.autoClosingPairsCloseByStart,d.close.charAt(0),d),N(this.autoClosingPairsCloseByEnd,d.close.charAt(d.close.length-1),d),d.close.length===1&&d.open.length===1&&N(this.autoClosingPairsCloseSingleChar,d.close,d)}}e.$cu=R;function N(A,g,d){A.has(g)?A.get(g).push(d):A.set(g,[d])}}),define(Pe[136],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jC=e.NodeColor=e.$iC=void 0,e.$kC=R,e.$lC=N,e.$mC=E,e.$nC=O,e.$oC=y,e.$pC=u,e.$qC=w,e.$rC=m;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$jC)return R(this.right);let o=this;for(;o.parent!==e.$jC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$jC?e.$jC:o.parent}prev(){if(this.left!==e.$jC)return N(this.left);let o=this;for(;o.parent!==e.$jC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$jC?e.$jC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$iC=I;var T;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$jC=new I(null,0),e.$jC.parent=e.$jC,e.$jC.left=e.$jC,e.$jC.right=e.$jC,e.$jC.color=0;function R(r){for(;r.left!==e.$jC;)r=r.left;return r}function N(r){for(;r.right!==e.$jC;)r=r.right;return r}function A(r){return r===e.$jC?0:r.size_left+r.piece.length+A(r.right)}function g(r){return r===e.$jC?0:r.lf_left+r.piece.lineFeedCnt+g(r.right)}function d(){e.$jC.parent=e.$jC}function E(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$jC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$jC?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function O(r,o){const s=o.left;o.left=s.right,s.right!==e.$jC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$jC?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function y(r,o){let s,n;if(o.left===e.$jC?(n=o,s=n.right):o.right===e.$jC?(n=o,s=n.left):(n=R(o.right),s=n.right),n===r.root){r.root=s,s.color=0,o.detach(),d(),r.root.parent=e.$jC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===o?(s.parent=n.parent,m(r,s)):(n.parent===o?s.parent=n:s.parent=n.parent,m(r,s),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$jC&&(n.left.parent=n),n.right!==e.$jC&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,m(r,n)),o.detach(),s.parent.left===s){const h=A(s),t=g(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const v=h-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,w(r,s.parent,v,c)}}if(m(r,s.parent),i){d();return}let a;for(;s!==r.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,E(r,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,O(r,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,E(r,s.parent),s=r.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,O(r,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,E(r,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,O(r,s.parent),s=r.root));s.color=0,d()}function u(r,o){for(m(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,E(r,o)),o.parent.color=0,o.parent.parent.color=1,O(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,O(r,o)),o.parent.color=0,o.parent.parent.color=1,E(r,o.parent.parent))}r.root.color=0}function w(r,o,s,n){for(;o!==r.root&&o!==e.$jC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}function m(r,o){let s=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=A(o.left)-o.size_left,n=g(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=n;o!==r.root&&(s!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}}}),define(Pe[92],Re([1,0,93,29,94,136,95]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CC=e.$BC=e.$AC=void 0,e.$yC=O,e.$zC=y;const g=65535;function d(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class E{constructor(n,i,a,h,t){this.lineStarts=n,this.cr=i,this.lf=a,this.crlf=h,this.isBasicASCII=t}}function O(s,n=!0){const i=[0];let a=1;for(let h=0,t=s.length;h<t;h++){const v=s.charCodeAt(h);v===13?h+1<t&&s.charCodeAt(h+1)===10?(i[a++]=h+2,h++):i[a++]=h+1:v===10&&(i[a++]=h+1)}return n?d(i):i}function y(s,n){s.length=0,s[0]=0;let i=1,a=0,h=0,t=0,v=!0;for(let $=0,b=n.length;$<b;$++){const p=n.charCodeAt($);p===13?$+1<b&&n.charCodeAt($+1)===10?(t++,s[i++]=$+2,$++):(a++,s[i++]=$+1):p===10?(h++,s[i++]=$+1):v&&p!==9&&(p<32||p>126)&&(v=!1)}const c=new E(d(s),a,h,t,v);return s.length=0,c}class u{constructor(n,i,a,h,t){this.bufferIndex=n,this.start=i,this.end=a,this.lineFeedCnt=h,this.length=t}}e.$AC=u;class w{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$BC=w;class m{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==N.$jC&&n.iterate(n.root,a=>(a!==N.$jC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const a=this.b;for(let h=0;h<a.length;h++){const t=a[h];if(t.node.parent===null||t.nodeStartOffset>=n){a[h]=null,i=!0;continue}}if(i){const h=[];for(const t of a)t!==null&&h.push(t);this.b=h}}}class o{constructor(n,i,a){this.create(n,i,a)}create(n,i,a){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=N.$jC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let h=null;for(let t=0,v=n.length;t<v;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=O(n[t].buffer));const c=new u(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),h=this.S(h,c)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=g,a=i-Math.floor(i/3),h=a*2;let t="",v=0;const c=[];if(this.iterate(this.root,$=>{const b=this.R($),p=b.length;if(v<=a||v+p<h)return t+=b,v+=p,!0;const l=t.replace(/\r\n|\r|\n/g,n);return c.push(new w(l,O(l))),t=b,v=p,!0}),v>0){const $=t.replace(/\r\n|\r|\n/g,n);c.push(new w($,O($)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new m(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===N.$jC)return!0;const t=this.R(h),v=t.length,c=n.G(i),$=n.G(i+v),b=n.getValueInRange2(c,$);return i+=v,t===b})}getOffsetAt(n,i){let a=0,h=this.root;for(;h!==N.$jC;)if(h.left!==N.$jC&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){a+=h.size_left;const t=this.B(h,n-h.lf_left-2);return a+=t+i-1}else n-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,a=0;const h=n;for(;i!==N.$jC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const v=this.getOffsetAt(a+1,1),c=h-v;return new I.$bt(a+1,c+1)}return new I.$bt(a+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$jC){const t=this.getOffsetAt(a+1,1),v=h-n-t;return new I.$bt(a+1,v+1)}else i=i.right;return new I.$bt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(a,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const c=n.node,$=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);return $.substring(b+n.remainder,b+i.remainder)}let a=n.node;const h=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let v=h.substring(t+n.remainder,t+a.piece.length);for(a=a.next();a!==N.$jC;){const c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){v+=c.substring($,$+i.remainder);break}else v+=c.substr($,a.piece.length);a=a.next()}return v}getLinesContent(){const n=[];let i=0,a="",h=!1;return this.iterate(this.root,t=>{if(t===N.$jC)return!0;const v=t.piece;let c=v.length;if(c===0)return!0;const $=this.a[v.bufferIndex].buffer,b=this.a[v.bufferIndex].lineStarts,p=v.start.line,l=v.end.line;let D=b[p]+v.start.column;if(h&&($.charCodeAt(D)===10&&(D++,c--),n[i++]=a,a="",h=!1,c===0))return!0;if(p===l)return!this.f&&$.charCodeAt(D+c-1)===13?(h=!0,a+=$.substr(D,c-1)):a+=$.substr(D,c),!0;a+=this.f?$.substring(D,Math.max(D,b[p+1]-this.e)):$.substring(D,b[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;for(let f=p+1;f<l;f++)a=this.f?$.substring(b[f],b[f+1]-this.e):$.substring(b[f],b[f+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;return!this.f&&$.charCodeAt(b[l]+v.end.column-1)===13?(h=!0,v.end.column===0?i--:a=$.substr(b[l],v.end.column-1)):a=$.substr(b[l],v.end.column),!0}),h&&(n[i++]=a,a=""),n[i++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(h)}else{const i=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(n,i){const a=this.H(n,i+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,a,h,t,v,c,$,b,p,l){const D=this.a[n.piece.bufferIndex],f=this.u(n.piece.bufferIndex,n.piece.start),S=this.u(n.piece.bufferIndex,t),k=this.u(n.piece.bufferIndex,v);let P;const C={line:0,column:0};let q,V;i._wordSeparators?(q=D.buffer.substring(S,k),V=W=>W+S,i.reset(0)):(q=D.buffer,V=W=>W,i.reset(S));do if(P=i.next(q),P){if(V(P.index)>=k)return p;this.s(n,V(P.index)-f,C);const W=this.t(n.piece.bufferIndex,t,C),M=C.line===t.line?C.column-t.column+h:C.column+1,z=M+P[0].length;if(l[p++]=(0,A.$uC)(new T.$ct(a+W,M,a+W,z),P,$),V(P.index)+P[0].length>=k||p>=b)return p}while(P);return p}findMatchesLineByLine(n,i,a,h){const t=[];let v=0;const c=new A.$xC(i.wordSeparators,i.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const b=this.H(n.endLineNumber,n.endColumn);if(b===null)return[];let p=this.s($.node,$.remainder);const l=this.s(b.node,b.remainder);if($.node===b.node)return this.findMatchesInNode($.node,c,n.startLineNumber,n.startColumn,p,l,i,a,h,v,t),t;let D=n.startLineNumber,f=$.node;for(;f!==b.node;){const k=this.t(f.piece.bufferIndex,p,f.piece.end);if(k>=1){const C=this.a[f.piece.bufferIndex].lineStarts,q=this.u(f.piece.bufferIndex,f.piece.start),V=C[p.line+k],W=D===n.startLineNumber?n.startColumn:1;if(v=this.findMatchesInNode(f,c,D,W,p,this.s(f,V-q),i,a,h,v,t),v>=h)return t;D+=k}const P=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const C=this.getLineContent(D).substring(P,n.endColumn-1);return v=this.n(i,c,C,n.endLineNumber,P,v,t,a,h),t}if(v=this.n(i,c,this.getLineContent(D).substr(P),D,P,v,t,a,h),v>=h)return t;D++,$=this.H(D,1),f=$.node,p=this.s($.node,$.remainder)}if(D===n.endLineNumber){const k=D===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(D).substring(k,n.endColumn-1);return v=this.n(i,c,P,n.endLineNumber,k,v,t,a,h),t}const S=D===n.startLineNumber?n.startColumn:1;return v=this.findMatchesInNode(b.node,c,D,S,p,l,i,a,h,v,t),t}n(n,i,a,h,t,v,c,$,b){const p=n.wordSeparators;if(!$&&n.simpleSearch){const D=n.simpleSearch,f=D.length,S=a.length;let k=-f;for(;(k=a.indexOf(D,k+f))!==-1;)if((!p||(0,A.$wC)(p,a,S,k,f))&&(c[v++]=new R.$wv(new T.$ct(h,k+1+t,h,k+1+f+t),null),v>=b))return v;return v}let l;i.reset(0);do if(l=i.next(a),l&&(c[v++]=(0,A.$uC)(new T.$ct(h,l.index+1+t,h,l.index+1+l[0].length+t),l,$),v>=b))return v;while(l);return v}insert(n,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==N.$jC){const{node:h,remainder:t,nodeStartOffset:v}=this.G(n),c=h.piece,$=c.bufferIndex,b=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&v+c.length===n&&i.length<g){this.F(h,i),this.y();return}if(v===n)this.o(i,h),this.h.validate(n);else if(v+h.piece.length>n){const p=[];let l=new u(c.bufferIndex,b,c.end,this.t(c.bufferIndex,b,c.end),this.u($,c.end)-this.u($,b));if(this.K()&&this.M(i)&&this.I(h,t)===10){const k={line:l.start.line+1,column:0};l=new u(l.bufferIndex,k,l.end,this.t(l.bufferIndex,k,l.end),l.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const k=this.s(h,t-1);this.C(h,k),i="\r"+i,h.piece.length===0&&p.push(h)}else this.C(h,b);else this.C(h,b);const D=this.w(i);l.length>0&&this.S(h,l);let f=h;for(let S=0;S<D.length;S++)f=this.S(f,D[S]);this.v(p)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let v=1;v<h.length;v++)t=this.S(t,h[v])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$jC)return;const a=this.G(n),h=this.G(n+i),t=a.node,v=h.node;if(t===v){const D=this.s(t,a.remainder),f=this.s(t,h.remainder);if(a.nodeStartOffset===n){if(i===t.piece.length){const S=t.next();(0,N.$oC)(this,t),this.N(S),this.y();return}this.D(t,f),this.h.validate(n),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,f),this.y();return}const c=[],$=this.s(t,a.remainder);this.C(t,$),this.h.validate(n),t.piece.length===0&&c.push(t);const b=this.s(v,h.remainder);this.D(v,b),v.piece.length===0&&c.push(v);const p=t.next();for(let D=p;D!==N.$jC&&D!==v;D=D.next())c.push(D);const l=t.piece.length===0?t.prev():t;this.v(c),this.O(l),this.y()}o(n,i){const a=[];if(this.K()&&this.M(n)&&this.L(i)){const v=i.piece,c={line:v.start.line+1,column:0},$=new u(v.bufferIndex,c,v.end,this.t(v.bufferIndex,c,v.end),v.length-1);i.piece=$,n+=`
`,(0,N.$qC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const h=this.w(n);let t=this.T(i,h[h.length-1]);for(let v=h.length-2;v>=0;v--)t=this.T(t,h[v]);this.N(t),this.v(a)}q(n,i){this.Q(n,i)&&(n+=`
`);const a=this.w(n),h=this.S(i,a[0]);let t=h;for(let v=1;v<a.length;v++)t=this.S(t,a[v]);this.N(h)}s(n,i,a){const h=n.piece,t=n.piece.bufferIndex,v=this.a[t].lineStarts,$=v[h.start.line]+h.start.column+i;let b=h.start.line,p=h.end.line,l=0,D=0,f=0;for(;b<=p&&(l=b+(p-b)/2|0,f=v[l],l!==p);)if(D=v[l+1],$<f)p=l-1;else if($>=D)b=l+1;else break;return a?(a.line=l,a.column=$-f,null):{line:l,column:$-f}}t(n,i,a){if(a.column===0)return a.line-i.line;const h=this.a[n].lineStarts;if(a.line===h.length-1)return a.line-i.line;const t=h[a.line+1],v=h[a.line]+a.column;if(t>v+1)return a.line-i.line;const c=v-1;return this.a[n].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,N.$oC)(this,n[i])}w(n){if(n.length>g){const p=[];for(;n.length>g;){const D=n.charCodeAt(g-1);let f;D===13||D>=55296&&D<=56319?(f=n.substring(0,g-1),n=n.substring(g-1)):(f=n.substring(0,g),n=n.substring(g));const S=O(f);p.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:f.length-S[S.length-1]},S.length-1,f.length)),this.a.push(new w(f,S))}const l=O(n);return p.push(new u(this.a.length,{line:0,column:0},{line:l.length-1,column:n.length-l[l.length-1]},l.length-1,n.length)),this.a.push(new w(n,l)),p}let i=this.a[0].buffer.length;const a=O(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let p=0;p<a.length;p++)a[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let p=0;p<a.length;p++)a[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,v=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[v],$={line:v,column:c},b=new u(0,h,$,this.t(0,h,$),t-i);return this.g=$,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let a=this.root,h="";const t=this.h.get2(n);if(t){a=t.node;const v=this.B(a,n-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===n)h=c.substring($+v,$+a.piece.length);else{const b=this.B(a,n-t.nodeStartLineNumber);return c.substring($+v,$+b-i)}}else{let v=0;const c=n;for(;a!==N.$jC;)if(a.left!==N.$jC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const $=this.B(a,n-a.lf_left-2),b=this.B(a,n-a.lf_left-1),p=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return v+=a.size_left,this.h.set({node:a,nodeStartOffset:v,nodeStartLineNumber:c-(n-1-a.lf_left)}),p.substring(l+$,l+b-i)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const $=this.B(a,n-a.lf_left-2),b=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);h=b.substring(p+$,p+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,v+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==N.$jC;){const v=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),$=this.u(a.piece.bufferIndex,a.piece.start);return h+=v.substring($,$+c-i),h}else{const c=this.u(a.piece.bufferIndex,a.piece.start);h+=v.substr(c,a.piece.length)}a=a.next()}return h}y(){let n=this.root,i=1,a=0;for(;n!==N.$jC;)i+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=a,this.h.validate(this.c)}A(n,i){const a=n.piece,h=this.s(n,i),t=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const v=this.t(n.piece.bufferIndex,a.start,h);if(v!==t)return{index:v,remainder:0}}return{index:t,remainder:h.column}}B(n,i){if(i<0)return 0;const a=n.piece,h=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[t]-h[a.start.line]-a.start.column}C(n,i){const a=n.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),v=i,c=this.u(a.bufferIndex,v),$=this.t(a.bufferIndex,a.start,v),b=$-h,p=c-t,l=a.length+p;n.piece=new u(a.bufferIndex,a.start,v,$,l),(0,N.$qC)(this,n,p,b)}D(n,i){const a=n.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),v=i,c=this.t(a.bufferIndex,v,a.end),$=this.u(a.bufferIndex,v),b=c-h,p=t-$,l=a.length+p;n.piece=new u(a.bufferIndex,v,a.end,c,l),(0,N.$qC)(this,n,p,b)}E(n,i,a){const h=n.piece,t=h.start,v=h.end,c=h.length,$=h.lineFeedCnt,b=i,p=this.t(h.bufferIndex,h.start,b),l=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);n.piece=new u(h.bufferIndex,h.start,b,p,l),(0,N.$qC)(this,n,l-c,p-$);const D=new u(h.bufferIndex,a,v,this.t(h.bufferIndex,a,v),this.u(h.bufferIndex,v)-this.u(h.bufferIndex,a)),f=this.S(n,D);this.N(f)}F(n,i){this.Q(i,n)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=O(i,!1);for(let f=0;f<t.length;f++)t[f]+=h;if(a){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const v=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[v],$={line:v,column:c},b=n.piece.length+i.length,p=n.piece.lineFeedCnt,l=this.t(0,n.piece.start,$),D=l-p;n.piece=new u(n.piece.bufferIndex,n.piece.start,$,l,b),this.g=$,(0,N.$qC)(this,n,i.length,D)}G(n){let i=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let h=0;for(;i!==N.$jC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){h+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else n-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let a=this.root,h=0;for(;a!==N.$jC;)if(a.left!==N.$jC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const t=this.B(a,n-a.lf_left-2),v=this.B(a,n-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(t+i-1,v),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const t=this.B(a,n-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:h};i-=a.piece.length-t;break}else n-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==N.$jC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),v=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:v}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+i;return a.buffer.charCodeAt(h)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.$jC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,a=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=a[h]+i.start.column;return h===a.length-1||a[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.$jC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const a=[],h=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const v=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,t,c,v),(0,N.$qC)(this,n,-1,-1),n.piece.length===0&&a.push(n);const $={line:i.piece.start.line+1,column:0},b=i.piece.length-1,p=this.t(i.piece.bufferIndex,$,i.piece.end);i.piece=new u(i.piece.bufferIndex,$,i.piece.end,p,b),(0,N.$qC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const l=this.w(`\r
`);this.S(n,l[0]);for(let D=0;D<a.length;D++)(0,N.$oC)(this,a[D])}Q(n,i){if(this.K()&&this.M(n)){const a=i.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,N.$oC)(this,a);else{const h=a.piece,t={line:h.start.line+1,column:0},v=h.length-1,c=this.t(h.bufferIndex,t,h.end);a.piece=new u(h.bufferIndex,t,h.end,c,v),(0,N.$qC)(this,a,-1,-1)}return!0}}return!1}iterate(n,i){if(n===N.$jC)return i(N.$jC);const a=this.iterate(n.left,i);return a&&i(n)&&this.iterate(n.right,i)}R(n){if(n===N.$jC)return"";const i=this.a[n.piece.bufferIndex],a=n.piece,h=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(h,t)}getPieceContent(n){const i=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return i.buffer.substring(a,h)}S(n,i){const a=new N.$iC(i,1);if(a.left=N.$jC,a.right=N.$jC,a.parent=N.$jC,a.size_left=0,a.lf_left=0,this.root===N.$jC)this.root=a,a.color=0;else if(n.right===N.$jC)n.right=a,a.parent=n;else{const t=(0,N.$kC)(n.right);t.left=a,a.parent=t}return(0,N.$pC)(this,a),a}T(n,i){const a=new N.$iC(i,1);if(a.left=N.$jC,a.right=N.$jC,a.parent=N.$jC,a.size_left=0,a.lf_left=0,this.root===N.$jC)this.root=a,a.color=0;else if(n.left===N.$jC)n.left=a,a.parent=n;else{const h=(0,N.$lC)(n.left);h.right=a,a.parent=h}return(0,N.$pC)(this,a),a}U(n){let i="";return this.iterate(n,a=>(i+=this.R(a),!0)),i}}e.$CC=o}),define(Pe[137],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j0=e.$i0=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const A=this.a.get(N);return this.a.delete(N),A}}addDragOperationTransfer(N,A){this.a.set(N,A)}}e.$i0=I;class T{constructor(N){this.identifier=N}}e.$j0=T}),define(Pe[138],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[139],Re([1,0,5,6,138]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=O;class N extends T.$Uc{constructor(u,w="",m="",r=!0,o){super(),this.h=this.B(new I.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=w,this.u=m,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,w){this.C&&await this.C(u)}}e.$Zi=N;class A extends T.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$7d),this.onWillRun=this.f.event,this.m=this.B(new I.$7d),this.onDidRun=this.m.event}async run(u,w){if(!u.enabled)return;this.f.fire({action:u});let m;try{await this.u(u,w)}catch(r){m=r}this.m.fire({action:u,error:m})}async u(u,w){await u.run(w)}}e.$1i=A;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let w=[];for(const m of u)m.length&&(w.length?w=[...w,new g,...m]:w=m);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$2i=g;class d{get actions(){return this.a}constructor(u,w,m,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=w,this.class=r,this.a=m}async run(){}}e.$3i=d;class E extends N{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,R.localize(0,null),void 0,!1)}}e.$4i=E;function O(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u),tooltip:y.label}}}),define(Pe[140],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[141],Re([1,0,140]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=E,e.$Om=O,e.$Pm=y;const T=60,R=T*60,N=R*24,A=N*7,g=N*30,d=N*365;function E(u,w,m,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,E(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,I.localize)(1,null);let s;return o<T?(s=o,w?s===1?m?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):m?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?m?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):m?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<R?(s=Math.floor(o/T),w?s===1?m?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):m?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?m?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):m?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<N?(s=Math.floor(o/R),w?s===1?m?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):m?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?m?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):m?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<A?(s=Math.floor(o/N),w?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<g?(s=Math.floor(o/A),w?s===1?m?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):m?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?m?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):m?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<d?(s=Math.floor(o/g),w?s===1?m?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):m?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?m?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):m?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/d),w?s===1?m?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):m?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?m?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):m?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function O(u,w){const m=Math.abs(u/1e3);return m<1?w?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):m<T?w?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):m<R?w?(0,I.localize)(58,null,Math.round(u/(1e3*T))):(0,I.localize)(59,null,Math.round(u/(1e3*T))):m<N?w?(0,I.localize)(60,null,Math.round(u/(1e3*R))):(0,I.localize)(61,null,Math.round(u/(1e3*R))):(0,I.localize)(62,null,Math.round(u/(1e3*N)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[142],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[42],Re([1,0,18,17,142]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=d,e.$7i=E,e.$8i=O;function N(y,u){return u&&(y.stack||y.stacktrace)?R.localize(0,null,g(y),A(y.stack)||A(y.stacktrace)):g(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function g(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?R.localize(1,null,y.message):y.message||R.localize(2,null)}function d(y=null,u=!1){if(!y)return R.localize(3,null);if(Array.isArray(y)){const w=I.$Hb(y),m=d(w[0],u);return w.length>1?R.localize(4,null,m,w.length):m}if(T.$Vf(y))return y;if(y.detail){const w=y.detail;if(w.error)return N(w.error,u);if(w.exception)return N(w.exception,u)}return y.stack?N(y,u):y.message?y.message:R.localize(5,null)}function E(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function O(y,u){let w;return typeof y=="string"?w=new Error(y):w=y,w.actions=u,w}}),define(Pe[143],Re([1,0,40,19]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=g,e.$4q=d,e.$5q=E,e.$6q=O,e.$7q=y,e.$8q=u,e.$9q=w,e.$0q=m,e.$$q=r,e.$_q=o,e.$ar=b,e.$br=p,e.$cr=l;const R=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),N=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(D,f,S=!1){const k=D||"",P=f||"",C=R.value.collator.compare(k,P);return R.value.collatorIsNumeric&&C===0&&k!==P?k<P?-1:1:C}function d(D,f){const S=N.value.collator;return D=D||"",f=f||"",a(S,D,f)}function E(D,f){const S=N.value.collator;return D=D||"",f=f||"",c(D,f)||a(S,D,f)}function O(D,f){const S=N.value.collator;return D=D||"",f=f||"",v(D,f)||a(S,D,f)}function y(D,f){return D=D||"",f=f||"",D===f?0:D<f?-1:1}function u(D,f){const[S,k]=n(D),[P,C]=n(f);let q=R.value.collator.compare(k,C);if(q===0){if(R.value.collatorIsNumeric&&k!==C)return k<C?-1:1;if(q=R.value.collator.compare(S,P),R.value.collatorIsNumeric&&q===0&&S!==P)return S<P?-1:1}return q}function w(D,f){D=D||"",f=f||"";const S=i(D),k=i(f),P=N.value.collator,C=A.value.collator;return a(C,S,k)||a(P,D,f)}function m(D,f){D=D||"",f=f||"";const S=i(D),k=i(f),P=N.value.collator,C=A.value.collator;return a(C,S,k)||c(D,f)||a(P,D,f)}function r(D,f){D=D||"",f=f||"";const S=i(D),k=i(f),P=N.value.collator,C=A.value.collator;return a(C,S,k)||v(D,f)||a(P,D,f)}function o(D,f){D=D||"",f=f||"";const S=i(D).toLowerCase(),k=i(f).toLowerCase();return S!==k?S<k?-1:1:D!==f?D<f?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function n(D,f=!1){const S=D?s.exec(D):[];let k=[S&&S[1]||"",S&&S[3]||""];return f&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(D){const f=D?s.exec(D):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function a(D,f,S){const k=D.compare(f,S);return k!==0?k:f.length!==S.length?f.length<S.length?-1:1:0}function h(D){const f=D.charAt(0);return f.toLocaleUpperCase()!==f}function t(D){const f=D.charAt(0);return f.toLocaleLowerCase()!==f}function v(D,f){return h(D)&&t(f)?-1:t(D)&&h(f)?1:0}function c(D,f){return t(D)&&h(f)?-1:h(D)&&t(f)?1:0}function $(D,f,S=!1){return S||(D=D&&D.toLowerCase(),f=f&&f.toLowerCase()),D===f?0:D<f?-1:1}function b(D,f,S=!1){const k=D.split(T.sep),P=f.split(T.sep),C=k.length-1,q=P.length-1;let V,W;for(let M=0;;M++){if(V=C===M,W=q===M,V&&W)return g(k[M],P[M],S);if(V)return-1;if(W)return 1;const z=$(k[M],P[M],S);if(z!==0)return z}}function p(D,f,S){const k=D.toLowerCase(),P=f.toLowerCase(),C=l(D,f,S);if(C)return C;const q=k.endsWith(S),V=P.endsWith(S);if(q!==V)return q?-1:1;const W=g(k,P);return W!==0?W:k.localeCompare(P)}function l(D,f,S){const k=D.toLowerCase(),P=f.toLowerCase(),C=k.startsWith(S),q=P.startsWith(S);if(C!==q)return C?-1:1;if(C&&q){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}}),define(Pe[46],Re([1,0,19,21,15,17]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=A,e.$cg=g,e.$dg=d,e.$eg=E,e.$fg=O,e.$gg=m,e.$hg=r,e.$ig=o,e.$jg=s,e.$kg=n,e.$lg=i,e.$mg=a,e.$ng=h,e.$og=t,e.$pg=v,e.$qg=b;function A(p){return p===47||p===92}function g(p){return p.replace(/[\\/]/g,I.$hc.sep)}function d(p){return p.indexOf("/")===-1&&(p=g(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function E(p,l=I.$hc.sep){if(!p)return"";const D=p.length,f=p.charCodeAt(0);if(A(f)){if(A(p.charCodeAt(1))&&!A(p.charCodeAt(2))){let k=3;const P=k;for(;k<D&&!A(p.charCodeAt(k));k++);if(P!==k&&!A(p.charCodeAt(k+1))){for(k+=1;k<D;k++)if(A(p.charCodeAt(k)))return p.slice(0,k+1).replace(/[\\/]/g,l)}}return l}else if(s(f)&&p.charCodeAt(1)===58)return A(p.charCodeAt(2))?p.slice(0,2)+l:p.slice(0,2);let S=p.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(A(p.charCodeAt(S)))return p.slice(0,S+1)}return""}function O(p){if(!T.$i||!p||p.length<5)return!1;let l=p.charCodeAt(0);if(l!==92||(l=p.charCodeAt(1),l!==92))return!1;let D=2;const f=D;for(;D<p.length&&(l=p.charCodeAt(D),l!==92);D++);return!(f===D||(l=p.charCodeAt(D+1),isNaN(l)||l===92))}const y=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(p,l=T.$i){const D=l?y:u;return!(!p||p.length===0||/^\s+$/.test(p)||(D.lastIndex=0,D.test(p))||l&&w.test(p)||p==="."||p===".."||l&&p[p.length-1]==="."||l&&p.length!==p.trim().length||p.length>255)}function r(p,l,D){const f=p===l;return!D||f?f:!p||!l?!1:(0,R.$lf)(p,l)}function o(p,l,D,f=I.sep){if(p===l)return!0;if(!p||!l||l.length>p.length)return!1;if(D){if(!(0,R.$mf)(p,l))return!1;if(l.length===p.length)return!0;let k=l.length;return l.charAt(l.length-1)===f&&k--,p.charAt(k)===f}return l.charAt(l.length-1)!==f&&(l+=f),p.indexOf(l)===0}function s(p){return p>=65&&p<=90||p>=97&&p<=122}function n(p,l){return T.$i&&p.endsWith(":")&&(p+=I.sep),(0,I.$jc)(p)||(p=(0,I.$kc)(l,p)),p=(0,I.$ic)(p),T.$i?(p=(0,R.$6e)(p,I.sep),p.endsWith(":")&&(p+=I.sep)):(p=(0,R.$6e)(p,I.sep),p||(p=I.sep)),p}function i(p){const l=(0,I.$ic)(p);return T.$i?p.length>3?!1:a(l)&&(p.length===2||l.charCodeAt(2)===92):l===I.$hc.sep}function a(p,l=T.$i){return l?s(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function h(p,l=T.$i){return a(p,l)?p[0]:void 0}function t(p,l,D){return l.length>p.length?-1:p===l?0:(D&&(p=p.toLowerCase(),l=l.toLowerCase()),p.indexOf(l))}function v(p){const l=p.split(":");let D,f,S;for(const k of l){const P=Number(k);(0,N.$Zf)(P)?f===void 0?f=P:S===void 0&&(S=P):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:f!==void 0?f:void 0,column:S!==void 0?S:f!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(p,l,D=8){let f="";for(let k=0;k<D;k++){let P;k===0&&T.$i&&!l&&(D===3||D===4)?P=$:P=c,f+=P.charAt(Math.floor(Math.random()*P.length))}let S;return l?S=`${l}-${f}`:S=f,p?(0,I.$kc)(p,S):S}}),define(Pe[69],Re([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0,e.$As=N,e.$Bs=A,e.$Cs=g,e.$Ds=E,e.$zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(O){const y=(0,I.$pc)(O),u=T[y.toLowerCase()];return u!==void 0?u:A(O)}function A(O){const y=(0,I.$pc)(O);return R[y.toLowerCase()]}function g(O){for(const y in R)if(R[y]===O)return y}const d=/^(.+)\/(.+?)(;.+)?$/;function E(O,y){const u=d.exec(O);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:O}}),define(Pe[53],Re([1,0,22,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=R,e.$Qh=N,e.$Rh=g;function R(d){return JSON.stringify(d,A)}function N(d){let E=JSON.parse(d);return E=g(E),E}function A(d,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function g(d,E=0){if(!d||E>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return T.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof I.$ue||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let O=0;O<d.length;++O)d[O]=g(d[O],E+1);else for(const O in d)Object.hasOwnProperty.call(d,O)&&(d[O]=g(d[O],E+1))}return d}}),define(Pe[12],Re([1,0,14,21,15,2,19]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=d,e.$sg=E,e.$wg=y;var g;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(g||(e.Schemas=g={}));function d(m,r){return N.URI.isUri(m)?(0,R.$lf)(m.scheme,r):(0,R.$mf)(m,r+":")}function E(m,...r){return r.some(o=>d(m,o))}e.$tg="vscode-tkn",e.$ug="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=y(r,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,g.vscodeRemoteResource)}set(r,o,s){this.a[r]=o,this.b[r]=s}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(h){return I.$1(h),r}const o=r.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[o],i=this.c[o];let a=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(a+=`&${e.$ug}=${encodeURIComponent(i)}`),N.URI.from({scheme:T.$o?this.d:g.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:a})}}e.$vg=new O;function y(m,r){return A.$hc.join(r??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class u{static{this.a=e.$Bg}asBrowserUri(r){const o=this.b(r,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===g.vscodeRemote?e.$vg.rewrite(r):r.scheme===g.file&&(T.$m||T.$q===`${g.vscodeFileResource}://${u.a}`)?r.with({scheme:g.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,ge);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===g.vscodeFileResource?r.with({scheme:g.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return N.URI.isUri(r)?r:N.URI.parse(o.toUrl(r))}}e.$Cg=new u;var w;(function(m){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:N.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const h=a?.get(o);if(h)return r.get(h)}m.getHeadersFromQuery=s;function n(i,a,h){if(!globalThis.crossOriginIsolated)return;const t=a&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}m.addSearchParam=n})(w||(e.COI=w={}))}),define(Pe[23],Re([1,0,46,12,19,21,15,2]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=d,e.$5g=O,e.$6g=u;function d(w){return(0,g.$xc)(w,!0)}class E{constructor(m){this.a=m}compare(m,r,o=!1){return m===r?0:(0,A.$ef)(this.getComparisonKey(m,o),this.getComparisonKey(r,o))}isEqual(m,r,o=!1){return m===r?!0:!m||!r?!1:this.getComparisonKey(m,o)===this.getComparisonKey(r,o)}getComparisonKey(m,r=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,r,o=!1){if(m.scheme===r.scheme){if(m.scheme===T.Schemas.file)return I.$ig(d(m),d(r),this.a(m))&&m.query===r.query&&(o||m.fragment===r.fragment);if((0,e.$1g)(m.authority,r.authority))return I.$ig(m.path,r.path,this.a(m),"/")&&m.query===r.query&&(o||m.fragment===r.fragment)}return!1}joinPath(m,...r){return g.URI.joinPath(m,...r)}basenameOrAuthority(m){return(0,e.$Sg)(m)||m.authority}basename(m){return R.$hc.basename(m.path)}extname(m){return R.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let r;return m.scheme===T.Schemas.file?r=g.URI.file(R.$nc(d(m))).path:(r=R.$hc.dirname(m.path),m.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),r="/")),m.with({path:r})}normalizePath(m){if(!m.path.length)return m;let r;return m.scheme===T.Schemas.file?r=g.URI.file(R.$ic(d(m))).path:r=R.$hc.normalize(m.path),m.with({path:r})}relativePath(m,r){if(m.scheme!==r.scheme||!(0,e.$1g)(m.authority,r.authority))return;if(m.scheme===T.Schemas.file){const n=R.$mc(d(m),d(r));return N.$i?I.$cg(n):n}let o=m.path||"/";const s=r.path||"/";if(this.a(m)){let n=0;for(const i=Math.min(o.length,s.length);n<i&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return R.$hc.relative(o,s)}resolvePath(m,r){if(m.scheme===T.Schemas.file){const o=g.URI.file(R.$lc(d(m),r));return m.with({authority:o.authority,path:o.path})}return r=I.$dg(r),m.with({path:R.$hc.resolve(m.path,r)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,r){return m===r||m!==void 0&&r!==void 0&&(0,A.$lf)(m,r)}hasTrailingPathSeparator(m,r=R.sep){if(m.scheme===T.Schemas.file){const o=d(m);return o.length>I.$eg(o).length&&o[o.length-1]===r}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,r=R.sep){return(0,e.$2g)(m,r)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,r=R.sep){let o=!1;if(m.scheme===T.Schemas.file){const s=d(m);o=s!==void 0&&s.length===I.$eg(s).length&&s[s.length-1]===r}else{r="/";const s=m.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$2g)(m,r)?m.with({path:m.path+"/"}):m}}e.$Kg=E,e.$Lg=new E(()=>!1),e.$Mg=new E(w=>w.scheme===T.Schemas.file?!N.$k:!0),e.$Ng=new E(w=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function O(w,m){const r=[];for(let o=0;o<w.length;o++){const s=m(w[o]);w.some((n,i)=>i===o?!1:(0,e.$Pg)(s,m(n)))||r.push(w[o])}return r}var y;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function m(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,h]=i.split(":");a&&h&&o.set(a,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(w.META_DATA_MIME,n),o}w.parseMetaData=m})(y||(e.DataUri=y={}));function u(w,m,r){if(m){let o=w.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),w.with({scheme:r,authority:m,path:o})}return w.with({scheme:r})}}),define(Pe[11],Re([1,0,24,14,5,6,23,21,130,40]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=O,e.$8g=y,e.$9g=u,e.$0g=w,e.$$g=m,e.$_g=r,e.$ah=o,e.$bh=s,e.$jh=p,e.$kh=l,e.$lh=D,e.$mh=f,e.$nh=S,e.$Ch=ye,e.$Kh=ke;function O(de){return!!de&&typeof de.then=="function"}function y(de){const J=new I.$ee,Y=de(J.token),ue=new Promise((he,Ne)=>{const le=J.token.onCancellationRequested(()=>{le.dispose(),Ne(new T.$5)});Promise.resolve(Y).then(Ie=>{le.dispose(),J.dispose(),he(Ie)},Ie=>{le.dispose(),J.dispose(),Ne(Ie)})});return new class{cancel(){J.cancel(),J.dispose()}then(he,Ne){return ue.then(he,Ne)}catch(he){return this.then(void 0,he)}finally(he){return ue.finally(he)}}}function u(de,J,Y){return new Promise((ue,he)=>{const Ne=J.onCancellationRequested(()=>{Ne.dispose(),ue(Y)});de.then(ue,he).finally(()=>Ne.dispose())})}function w(de,J){return new Promise((Y,ue)=>{const he=J.onCancellationRequested(()=>{he.dispose(),ue(new T.$5)});de.then(Y,ue).finally(()=>he.dispose())})}async function m(de){let J=-1;const Y=de.map((ue,he)=>ue.then(Ne=>(J=he,Ne)));try{return await Promise.race(Y)}finally{de.forEach((ue,he)=>{he!==J&&ue.cancel()})}}function r(de,J,Y){let ue;const he=setTimeout(()=>{ue?.(void 0),Y?.()},J);return Promise.race([de.finally(()=>clearTimeout(he)),new Promise(Ne=>ue=Ne)])}function o(de){return new Promise((J,Y)=>{const ue=de();O(ue)?ue.then(J,Y):J(ue)})}function s(){let de,J;return{promise:new Promise((ue,he)=>{de=ue,J=he}),resolve:de,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Y=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(Y,Y).then(ue)})}return new Promise((Y,ue)=>{this.b.then(Y,ue)})}return this.a=J(),new Promise((Y,ue)=>{this.a.then(he=>{this.a=null,Y(he)},he=>{this.a=null,ue(he)})})}dispose(){this.f=!0}}e.$ch=n;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$dh=i;class a{constructor(){this.a=new Map}queue(J,Y){const he=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(J)===he&&this.a.delete(J)});return this.a.set(J,he),he}}e.$eh=a;const h=(de,J)=>{let Y=!0;const ue=setTimeout(()=>{Y=!1,J()},de);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(ue),Y=!1}}},t=de=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,de())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class v{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Y=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((he,Ne)=>{this.d=he,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=Y===d.$4d?t(ue):h(Y,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=v;class c{constructor(J){this.a=new v(J),this.b=new n}trigger(J,Y){return this.a.trigger(()=>this.b.queue(J),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=c;class ${constructor(){this.a=!1,this.b=new Promise((J,Y)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=$;class b extends ${constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$ih=b;function p(de,J){return J?new Promise((Y,ue)=>{const he=setTimeout(()=>{Ne.dispose(),Y()},de),Ne=J.onCancellationRequested(()=>{clearTimeout(he),Ne.dispose(),ue(new T.$5)})}):y(Y=>p(de,Y))}function l(de,J=0,Y){const ue=setTimeout(()=>{de(),Y&&he.dispose()},J),he=(0,N.$Sc)(()=>{clearTimeout(ue),Y?.deleteAndLeak(he)});return Y?.add(he),he}function D(de){const J=[];let Y=0;const ue=de.length;function he(){return Y<ue?de[Y++]():null}function Ne(le){le!=null&&J.push(le);const Ie=he();return Ie?Ie.then(Ne):Promise.resolve(J)}return Promise.resolve(null).then(Ne)}function f(de,J=ue=>!!ue,Y=null){let ue=0;const he=de.length,Ne=()=>{if(ue>=he)return Promise.resolve(Y);const le=de[ue++];return Promise.resolve(le()).then(Ae=>J(Ae)?Promise.resolve(Ae):Ne())};return Ne()}function S(de,J=ue=>!!ue,Y=null){if(de.length===0)return Promise.resolve(Y);let ue=de.length;const he=()=>{ue=-1;for(const Ne of de)Ne.cancel?.()};return new Promise((Ne,le)=>{for(const Ie of de)Ie.then(Ae=>{--ue>=0&&J(Ae)?(he(),Ne(Ae)):ue===0&&Ne(Y)}).catch(Ae=>{--ue>=0&&(he(),le(Ae))})})}class k{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new R.$7d}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,ue)=>{this.g.push({factory:J,c:Y,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Y=J.factory();Y.then(J.c,J.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=k;class P extends k{constructor(){super(1)}}e.$ph=P;class C{constructor(){this.a=new oe,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$qh=C;class q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new Se;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Y=A.$Lg){const ue=Y.getComparisonKey(J);return this.a.get(ue)?.size??0}queueFor(J,Y,ue=A.$Lg){const he=ue.getComparisonKey(J);let Ne=this.a.get(he);if(!Ne){Ne=new P;const le=this.f++,Ie=R.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(he),this.h(),this.d?.deleteAndDispose(le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(le,Ie),this.a.set(he,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=q;class V{constructor(J,Y){this.a=-1,typeof J=="function"&&typeof Y=="number"&&this.setIfNotSet(J,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Y)}setIfNotSet(J,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Y))}}e.$sh=V;class W{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Y,ue=globalThis){this.cancel();const he=ue.setInterval(()=>{J()},Y);this.d=(0,N.$Sc)(()=>{ue.clearInterval(he),this.d=void 0})}dispose(){this.cancel()}}e.$th=W;class M{constructor(J,Y){this.b=-1,this.a=J,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=M;class z{constructor(J,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=J,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=z;class K extends M{constructor(J,Y){super(J,Y),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$wh=K;class ie extends N.$Uc{constructor(J,Y){super(),this.g=J,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of J)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(de,J)=>{(0,g.$B)(()=>{if(Y)return;const ue=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$zh=(de,J,Y)=>{const ue=de.requestIdleCallback(J,typeof Y=="number"?{timeout:Y}:void 0);let he=!1;return{dispose(){he||(he=!0,de.cancelIdleCallback(ue))}}},e.$yh=de=>(0,e.$zh)(globalThis,de)}();class fe{constructor(J,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$zh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=fe;class De extends fe{constructor(J){super(globalThis,J)}}e.$Bh=De;async function ye(de,J,Y){let ue;for(let he=0;he<Y;he++)try{return await de()}catch(Ne){ue=Ne,await p(J)}throw ue}class oe{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Y,ue){return this.a={taskId:J,cancel:()=>ue?.(),promise:Y},Y.then(()=>this.d(J),()=>this.d(J)),Y}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Y,resolve:ue,reject:he}=s();this.b={run:J,promise:Y,promiseResolve:ue,promiseReject:he}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=oe;class $e{constructor(J,Y=()=>Date.now()){this.d=J,this.f=Y,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Eh=$e;var ne;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(ne||(ne={}));class Se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,Y)=>{this.a=J,this.b=Y})}complete(J){return new Promise(Y=>{this.a(J),this.d={outcome:0,value:J},Y()})}error(J){return new Promise(Y=>{this.b(J),this.d={outcome:1,value:J},Y()})}cancel(){return this.error(new T.$5)}}e.$Fh=Se;var je;(function(de){async function J(ue){let he;const Ne=await Promise.all(ue.map(le=>le.then(Ie=>Ie,Ie=>{he||(he=Ie)})));if(typeof he<"u")throw he;return Ne}de.settled=J;function Y(ue){return new Promise(async(he,Ne)=>{try{await ue(he,Ne)}catch(le){Ne(le)}})}de.withAsyncBody=Y})(je||(e.Promises=je={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=re;class L{constructor(J){this.b=J,this.a=new E.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=L;var _;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(_||(_={}));class ve{static fromArray(J){return new ve(Y=>{Y.emitMany(J)})}static fromPromise(J){return new ve(async Y=>{Y.emitMany(await J)})}static fromPromises(J){return new ve(async Y=>{await Promise.all(J.map(async ue=>Y.emitOne(await ue)))})}static merge(J){return new ve(async Y=>{await Promise.all(J.map(async ue=>{for await(const he of ue)Y.emitOne(he)}))})}static{this.EMPTY=ve.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new R.$7d,queueMicrotask(async()=>{const Y={emitOne:ue=>this.g(ue),emitMany:ue=>this.h(ue),reject:ue=>this.k(ue)};try{await Promise.resolve(J(Y)),this.j()}catch(ue){this.k(ue)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.f.event)}while(!0)}}}static map(J,Y){return new ve(async ue=>{for await(const he of J)ue.emitOne(Y(he))})}map(J){return ve.map(this,J)}static filter(J,Y){return new ve(async ue=>{for await(const he of J)Y(he)&&ue.emitOne(he)})}filter(J){return ve.filter(this,J)}static coalesce(J){return ve.filter(J,Y=>!!Y)}coalesce(){return ve.coalesce(this)}static async toPromise(J){const Y=[];for await(const ue of J)Y.push(ue);return Y}toPromise(){return ve.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Ih=ve;class Oe extends ve{constructor(J,Y){super(Y),this.l=J}cancel(){this.l.cancel()}}e.$Jh=Oe;function ke(de){const J=new I.$ee,Y=de(J.token);return new Oe(J,async ue=>{const he=J.token.onCancellationRequested(()=>{he.dispose(),J.dispose(),ue.reject(new T.$5)});try{for await(const Ne of Y){if(J.token.isCancellationRequested)return;ue.emitOne(Ne)}he.dispose(),J.dispose()}catch(Ne){he.dispose(),J.dispose(),ue.reject(Ne)}})}class pe{constructor(){this.a=new Se,this.b=new ve(ue=>{if(J){ue.reject(J);return}return Y&&ue.emitMany(Y),this.d=he=>ue.reject(he),this.f=he=>ue.emitOne(he),this.a.p});let J,Y;this.f=ue=>{Y||(Y=[]),Y.push(ue)},this.d=ue=>{J||(J=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Lh=pe}),define(Pe[35],Re([1,0,18,11,46,28,19,21,15]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=E,e.$ak=m,e.$bk=P,e.$ck=C,e.$dk=q,e.$ek=V,e.$fk=W,e.$gk=ie;function E(){return Object.create(null)}e.$$j="**",e.$_j="/";const O="[/\\\\]",y="[^/\\\\]",u=/\//g;function w(fe,De){switch(fe){case 0:return"";case 1:return`${y}*?`;default:return`(?:${O}|${y}+${O}${De?`|${O}${y}+`:""})*?`}}function m(fe,De){if(!fe)return[];const ye=[];let oe=!1,$e=!1,ne="";for(const Se of fe){switch(Se){case De:if(!oe&&!$e){ye.push(ne),ne="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}ne+=Se}return ne&&ye.push(ne),ye}function r(fe){if(!fe)return"";let De="";const ye=m(fe,e.$_j);if(ye.every(oe=>oe===e.$$j))De=".*";else{let oe=!1;ye.forEach(($e,ne)=>{if($e===e.$$j){if(oe)return;De+=w(2,ne===ye.length-1)}else{let Se=!1,je="",re=!1,L="";for(const _ of $e){if(_!=="}"&&Se){je+=_;continue}if(re&&(_!=="]"||!L)){let ve;_==="-"?ve=_:(_==="^"||_==="!")&&!L?ve="^":_===e.$_j?ve="":ve=(0,d.$Ze)(_),L+=ve;continue}switch(_){case"{":Se=!0;continue;case"[":re=!0;continue;case"}":{const Oe=`(?:${m(je,",").map(ke=>r(ke)).join("|")})`;De+=Oe,Se=!1,je="";break}case"]":{De+="["+L+"]",re=!1,L="";break}case"?":De+=y;continue;case"*":De+=w(1);continue;default:De+=(0,d.$Ze)(_)}}ne<ye.length-1&&(ye[ne+1]!==e.$$j||ne+2<ye.length)&&(De+=O)}oe=$e===e.$$j})}return De}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Ec(1e4),v=function(){return!1},c=function(){return null};function $(fe,De){if(!fe)return c;let ye;typeof fe!="string"?ye=fe.pattern:ye=fe,ye=ye.trim();const oe=`${ye}_${!!De.trimForExclusions}`;let $e=t.get(oe);if($e)return b($e,fe);let ne;return o.test(ye)?$e=l(ye.substr(4),ye):(ne=s.exec(p(ye,De)))?$e=D(ne[1],ye):(De.trimForExclusions?i:n).test(ye)?$e=f(ye,De):(ne=a.exec(p(ye,De)))?$e=S(ne[1].substr(1),ye,!0):(ne=h.exec(p(ye,De)))?$e=S(ne[1],ye,!1):$e=k(ye),t.set(oe,$e),b($e,fe)}function b(fe,De){if(typeof De=="string")return fe;const ye=function(oe,$e){return(0,R.$ig)(oe,De.base,!g.$k)?fe((0,d.$5e)(oe.substr(De.base.length),A.sep),$e):null};return ye.allBasenames=fe.allBasenames,ye.allPaths=fe.allPaths,ye.basenames=fe.basenames,ye.patterns=fe.patterns,ye}function p(fe,De){return De.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function l(fe,De){return function(ye,oe){return typeof ye=="string"&&ye.endsWith(fe)?De:null}}function D(fe,De){const ye=`/${fe}`,oe=`\\${fe}`,$e=function(Se,je){return typeof Se!="string"?null:je?je===fe?De:null:Se===fe||Se.endsWith(ye)||Se.endsWith(oe)?De:null},ne=[fe];return $e.basenames=ne,$e.patterns=[De],$e.allBasenames=ne,$e}function f(fe,De){const ye=K(fe.slice(1,-1).split(",").map(je=>$(je,De)).filter(je=>je!==c),fe),oe=ye.length;if(!oe)return c;if(oe===1)return ye[0];const $e=function(je,re){for(let L=0,_=ye.length;L<_;L++)if(ye[L](je,re))return fe;return null},ne=ye.find(je=>!!je.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const Se=ye.reduce((je,re)=>re.allPaths?je.concat(re.allPaths):je,[]);return Se.length&&($e.allPaths=Se),$e}function S(fe,De,ye){const oe=A.sep===A.$hc.sep,$e=oe?fe:fe.replace(u,A.sep),ne=A.sep+$e,Se=A.$hc.sep+fe;let je;return ye?je=function(re,L){return typeof re=="string"&&(re===$e||re.endsWith(ne)||!oe&&(re===fe||re.endsWith(Se)))?De:null}:je=function(re,L){return typeof re=="string"&&(re===$e||!oe&&re===fe)?De:null},je.allPaths=[(ye?"*/":"./")+fe],je}function k(fe){try{const De=new RegExp(`^${r(fe)}$`);return function(ye){return De.lastIndex=0,typeof ye=="string"&&De.test(ye)?fe:null}}catch{return c}}function P(fe,De,ye){return!fe||typeof De!="string"?!1:C(fe)(De,void 0,ye)}function C(fe,De={}){if(!fe)return v;if(typeof fe=="string"||q(fe)){const ye=$(fe,De);if(ye===c)return v;const oe=function($e,ne){return!!ye($e,ne)};return ye.allBasenames&&(oe.allBasenames=ye.allBasenames),ye.allPaths&&(oe.allPaths=ye.allPaths),oe}return M(fe,De)}function q(fe){const De=fe;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}function V(fe){return fe.allBasenames||[]}function W(fe){return fe.allPaths||[]}function M(fe,De){const ye=K(Object.getOwnPropertyNames(fe).map(je=>z(je,fe[je],De)).filter(je=>je!==c)),oe=ye.length;if(!oe)return c;if(!ye.some(je=>!!je.requiresSiblings)){if(oe===1)return ye[0];const je=function(_,ve){let Oe;for(let ke=0,pe=ye.length;ke<pe;ke++){const de=ye[ke](_,ve);if(typeof de=="string")return de;(0,T.$7g)(de)&&(Oe||(Oe=[]),Oe.push(de))}return Oe?(async()=>{for(const ke of Oe){const pe=await ke;if(typeof pe=="string")return pe}return null})():null},re=ye.find(_=>!!_.allBasenames);re&&(je.allBasenames=re.allBasenames);const L=ye.reduce((_,ve)=>ve.allPaths?_.concat(ve.allPaths):_,[]);return L.length&&(je.allPaths=L),je}const $e=function(je,re,L){let _,ve;for(let Oe=0,ke=ye.length;Oe<ke;Oe++){const pe=ye[Oe];pe.requiresSiblings&&L&&(re||(re=(0,A.$oc)(je)),_||(_=re.substr(0,re.length-(0,A.$pc)(je).length)));const de=pe(je,re,_,L);if(typeof de=="string")return de;(0,T.$7g)(de)&&(ve||(ve=[]),ve.push(de))}return ve?(async()=>{for(const Oe of ve){const ke=await Oe;if(typeof ke=="string")return ke}return null})():null},ne=ye.find(je=>!!je.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const Se=ye.reduce((je,re)=>re.allPaths?je.concat(re.allPaths):je,[]);return Se.length&&($e.allPaths=Se),$e}function z(fe,De,ye){if(De===!1)return c;const oe=$(fe,ye);if(oe===c)return c;if(typeof De=="boolean")return oe;if(De){const $e=De.when;if(typeof $e=="string"){const ne=(Se,je,re,L)=>{if(!L||!oe(Se,je))return null;const _=$e.replace("$(basename)",()=>re),ve=L(_);return(0,T.$7g)(ve)?ve.then(Oe=>Oe?fe:null):ve?fe:null};return ne.requiresSiblings=!0,ne}}return oe}function K(fe,De){const ye=fe.filter(je=>!!je.basenames);if(ye.length<2)return fe;const oe=ye.reduce((je,re)=>{const L=re.basenames;return L?je.concat(L):je},[]);let $e;if(De){$e=[];for(let je=0,re=oe.length;je<re;je++)$e.push(De)}else $e=ye.reduce((je,re)=>{const L=re.patterns;return L?je.concat(L):je},[]);const ne=function(je,re){if(typeof je!="string")return null;if(!re){let _;for(_=je.length;_>0;_--){const ve=je.charCodeAt(_-1);if(ve===47||ve===92)break}re=je.substr(_)}const L=oe.indexOf(re);return L!==-1?$e[L]:null};ne.basenames=oe,ne.patterns=$e,ne.allBasenames=oe;const Se=fe.filter(je=>!je.basenames);return Se.push(ne),Se}function ie(fe,De){return(0,I.$ub)(fe,De,(ye,oe)=>typeof ye=="string"&&typeof oe=="string"?ye===oe:typeof ye!="string"&&typeof oe!="string"?ye.base===oe.base&&ye.pattern===oe.pattern:!1)}}),define(Pe[54],Re([1,0,14,131,23,15,2]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=E,e.$Hk=O,e.$Ik=y,e.$Jk=u,e.$Kk=w,e.$Lk=m,e.$Mk=r,e.$Nk=o;var g;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class d{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,I.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=u(this.supportThemeIcons?(0,T.$zk)(n):n).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${w(i,n)}
`,this}appendLink(n,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(n,i){const a=new RegExp((0,N.$Ze)(i),"g");return n.replace(a,(h,t)=>n.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Fk=d;function E(s){return O(s)?!s.value:Array.isArray(s)?s.every(E):!0}function O(s){return s instanceof d?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function y(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,R.$Og)(A.URI.from(s.baseUri),A.URI.from(n.baseUri)))}function u(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(s,n){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${n}`,s,`${"`".repeat(a)}`].join(`
`)}function m(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const n=[],i=s.split("|").map(h=>h.trim());s=i[0];const a=i[1];if(a){const h=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),v=h?h[1]:"",c=t?t[1]:"",$=isFinite(parseInt(c)),b=isFinite(parseInt(v));$&&n.push(`width="${c}"`),b&&n.push(`height="${v}"`)}return{href:s,dimensions:n}}}),define(Pe[96],Re([1,0,18,46,19,21,23,15]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=d,e.$hw=O,e.$iw=u,e.$jw=w,e.$kw=s,e.$lw=i,e.$mw=a,e.$nw=h,e.$ow=t,e.$pw=v;function d($,b){const{os:p,tildify:l,relative:D}=b;if(D){const k=E($,D,p);if(typeof k=="string")return k}let f=$.fsPath;if(p===1&&!N.$i?f=f.replace(/\//g,"\\"):p!==1&&N.$i&&(f=f.replace(/\\/g,"/")),p!==1&&l?.userHome){const k=l.userHome.fsPath;let P;$.scheme!==l.userHome.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep?P=l.userHome.with({path:$.path}).fsPath:P=f,f=u(P,k,p)}return(p===1?R.$gc:R.$hc).normalize(O(f,p===1))}function E($,b,p){const l=p===1?R.$gc:R.$hc,D=p===3?A.$Lg:A.$Ng,f=b.getWorkspace(),S=(0,I.$Ob)(f.folders);if(!S)return;$.scheme!==S.uri.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep&&($=S.uri.with({path:$.path}));const k=b.getWorkspaceFolder($);if(!k)return;let P;if(D.isEqual(k.uri,$)?P="":P=D.relativePath(k.uri,$)??"",P&&(P=l.normalize(P)),f.folders.length>1&&!b.noPrefix){const C=k.name?k.name:D.basenameOrAuthority(k.uri);P=P?`${C} \u2022 ${P}`:C}return P}function O($,b=N.$i){return(0,T.$mg)($,b)?$.charAt(0).toUpperCase()+$.slice(1):$}let y=Object.create(null);function u($,b,p=N.OS){if(p===1||!$||!b)return $;let l=y.original===b?y.normalized:void 0;l||(l=b,N.$i&&(l=(0,T.$cg)(l)),l=`${(0,g.$6e)(l,R.$hc.sep)}${R.$hc.sep}`,y={original:b,normalized:l});let D=$;return N.$i&&(D=(0,T.$cg)(D)),(p===3?D.startsWith(l):(0,g.$mf)(D,l))?`~/${D.substr(l.length)}`:$}function w($,b){return $.replace(/^~($|\/|\\)/,`${b}$1`)}const m="\u2026",r="\\\\",o="~";function s($,b=R.sep){const p=new Array($.length);let l=!1;for(let D=0;D<$.length;D++){const f=$[D];if(f===""){p[D]=`.${b}`;continue}if(!f){p[D]=f;continue}l=!0;let S="",k=f;k.indexOf(r)===0?(S=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf(b)===0?(S=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(o)===0&&(S=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length));const P=k.split(b);for(let C=1;l&&C<=P.length;C++)for(let q=P.length-C;l&&q>=0;q--){l=!1;let V=P.slice(q,q+C).join(b);for(let W=0;!l&&W<$.length;W++)if(W!==D&&$[W]&&$[W].indexOf(V)>-1){const M=q+C===P.length,z=q>0&&$[W].indexOf(b)>-1?b+V:V,K=$[W].endsWith(z);l=!M||K}if(!l){let W="";(P[0].endsWith(":")||S!=="")&&(q===1&&(q=0,C++,V=P[0]+b+V),q>0&&(W=P[0]+b),W=S+W),q>0&&(W=W+m+b),W=W+V,q+C<P.length&&(W=W+b+m),p[D]=W}}l&&(p[D]=f)}return p}var n;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i($,b=Object.create(null)){const p=[];let l=!1,D="";for(const f of $)if(f==="$"||l&&f==="{")D&&p.push({value:D,type:n.TEXT}),D="",l=!0;else if(f==="}"&&l){const S=b[D];if(typeof S=="string")S.length&&p.push({value:S,type:n.VARIABLE});else if(S){const k=p[p.length-1];(!k||k.type!==n.SEPARATOR)&&p.push({value:S.label,type:n.SEPARATOR})}D="",l=!1}else D+=f;return D&&!l&&p.push({value:D,type:n.TEXT}),p.filter((f,S)=>{if(f.type===n.SEPARATOR){const k=p[S-1],P=p[S+1];return[k,P].every(C=>C&&(C.type===n.VARIABLE||C.type===n.TEXT)&&C.value.length>0)}return!0}).map(f=>f.value).join("")}function a($,b){return N.$j||b?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):$.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function h($,b){return N.$j||b?$.replace(/\(&&\w\)|&&/g,""):N.$i?$.replace(/&&|&/g,p=>p==="&"?"&&":"&"):$.replace(/&&/g,"_")}function t($){return $.replace(/&/g,"&&")}function v($){if($.endsWith("]")){const b=$.lastIndexOf(" [",$.length-2);if(b!==-1){const p=c($.substring(0,b)),l=$.substring(b);return{name:p.name+l,parentPath:p.parentPath}}}return c($)}function c($){const b=$.indexOf("/")!==-1?R.$hc:R.$gc,p=b.basename($),l=b.dirname($);return p.length?{name:p,parentPath:l}:{name:l,parentPath:""}}}),define(Pe[144],Re([1,0,22,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$mn=g,e.$nn=E,e.$on=O;function R(y){return y.toJSON()}class N{constructor(u){this.a=u}transformIncoming(u){const w=this.a.transformIncoming(u);return w===u?u:R(T.URI.from(w))}transformOutgoing(u){const w=this.a.transformOutgoing(u);return w===u?u:R(T.URI.from(w))}transformOutgoingURI(u){const w=this.a.transformOutgoing(u);return w===u?u:T.URI.from(w)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$kn=N,e.$ln=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function A(y,u,w){if(!y||w>200)return null;if(typeof y=="object"){if(y instanceof T.URI)return u.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const r=A(y[m],u,w+1);r!==null&&(y[m]=r)}}return null}function g(y,u){const w=A(y,u,0);return w===null?y:w}function d(y,u,w,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return w?T.URI.revive(u.transformIncoming(y)):u.transformIncoming(y);if(y instanceof I.$ue)return null;for(const r in y)if(Object.hasOwnProperty.call(y,r)){const o=d(y[r],u,w,m+1);o!==null&&(y[r]=o)}}return null}function E(y,u){const w=d(y,u,!1,0);return w===null?y:w}function O(y,u){const w=d(y,u,!0,0);return w===null?y:w}}),define(Pe[145],Re([1,0,15,21,22]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$ut=O,e.$vt=y;let N;function A(){return N||(N=new TextDecoder("UTF-16LE")),N}let g;function d(){return g||(g=new TextDecoder("UTF-16BE")),g}let E;function O(){return E||(E=T.$D()?A():d()),E}function y(m,r,o){const s=new Uint16Array(m.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?u(m,r,o):A().decode(s)}function u(m,r,o){const s=[];let n=0;for(let i=0;i<o;i++){const a=R.$we(m,r);r+=2,s[n++]=String.fromCharCode(a)}return s.join("")}class w{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return O().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||I.$pf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<o;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$wt=w}),define(Pe[146],Re([1,0,22,145]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0,e.$yt=A;function R(d){return d.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,O,y,u){this.oldPosition=E,this.oldText=O,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,O,y){const u=O.length;I.$ze(E,u,y),y+=4;for(let w=0;w<u;w++)I.$xe(E,O.charCodeAt(w),y),y+=2;return y}static d(E,O){const y=I.$ye(E,O);return O+=4,(0,T.$vt)(E,O,y)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(E,O){return I.$ze(E,this.oldPosition,O),O+=4,I.$ze(E,this.newPosition,O),O+=4,O=N.c(E,this.oldText,O),O=N.c(E,this.newText,O),O}static read(E,O,y){const u=I.$ye(E,O);O+=4;const w=I.$ye(E,O);O+=4;const m=N.d(E,O);O+=N.a(m);const r=N.d(E,O);return O+=N.a(r),y.push(new N(u,m,w,r)),O}}e.$xt=N;function A(d,E){return d===null||d.length===0?E:new g(d,E).compress()}class g{constructor(E,O){this.a=E,this.c=O,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,O=0,y=this.n(E),u=this.l(O);for(;E<this.f||O<this.h;){if(y===null){this.k(u),u=this.l(++O);continue}if(u===null){this.m(y),y=this.n(++E);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++O);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++E);continue}if(u.oldPosition<y.newPosition){const[s,n]=g.r(u,y.newPosition-u.oldPosition);this.k(s),u=n;continue}if(y.newPosition<u.oldPosition){const[s,n]=g.q(y,u.oldPosition-y.newPosition);this.m(s),y=n;continue}let r,o;if(u.oldEnd===y.newEnd)r=y,o=u,y=this.n(++E),u=this.l(++O);else if(u.oldEnd<y.newEnd){const[s,n]=g.q(y,u.oldLength);r=s,o=u,y=n,u=this.l(++O)}else{const[s,n]=g.r(u,y.newLength);r=y,o=s,y=this.n(++E),u=n}this.d[this.e++]=new N(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const w=g.s(this.d);return g.t(w)}k(E){this.d[this.e++]=g.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=g.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,O){return new N(O.oldPosition-E,O.oldText,O.newPosition,O.newText)}static p(E,O){return new N(O.oldPosition,O.oldText,O.newPosition+E,O.newText)}static q(E,O){const y=E.newText.substr(0,O),u=E.newText.substr(O);return[new N(E.oldPosition,E.oldText,E.newPosition,y),new N(E.oldEnd,"",E.newPosition+O,u)]}static r(E,O){const y=E.oldText.substr(0,O),u=E.oldText.substr(O);return[new N(E.oldPosition,y,E.newPosition,E.newText),new N(E.oldPosition+O,u,E.newEnd,"")]}static s(E){if(E.length===0)return E;const O=[];let y=0,u=E[0];for(let w=1;w<E.length;w++){const m=E[w];u.oldEnd===m.oldPosition?u=new N(u.oldPosition,u.oldText+m.oldText,u.newPosition,u.newText+m.newText):(O[y++]=u,u=m)}return O[y++]=u,O}static t(E){if(E.length===0)return E;const O=[];let y=0;for(let u=0;u<E.length;u++){const w=E[u];w.oldText!==w.newText&&(O[y++]=w)}return O}}}),define(Pe[147],Re([1,0,35,19]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=R,e.$Wt=N;function R(A,g,d,E,O,y){if(Array.isArray(A)){let u=0;for(const w of A){const m=R(w,g,d,E,O,y);if(m===10)return m;m>u&&(u=m)}return u}else{if(typeof A=="string")return E?A==="*"?5:A===d?10:0:0;if(A){const{language:u,pattern:w,scheme:m,hasAccessToAllModels:r,notebookType:o}=A;if(!E&&!r)return 0;o&&O&&(g=O);let s=0;if(m)if(m===g.scheme)s=10;else if(m==="*")s=5;else return 0;if(u)if(u===d)s=10;else if(u==="*")s=Math.max(s,5);else return 0;if(o)if(o===y)s=10;else if(o==="*"&&y!==void 0)s=Math.max(s,5);else return 0;if(w){let n;if(typeof w=="string"?n=w:n={...w,base:(0,T.$ic)(w.base)},n===g.fsPath||(0,I.$bk)(n,g.fsPath))s=10;else return 0}return s}else return 0}}function N(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(N):!!A.notebookType}}),define(Pe[148],Re([1,0,5,15,29,94,92,133,146,6]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=void 0;class O extends E.$Uc{constructor(u,w,m,r,o,s,n){super(),this.m=this.B(new I.$7d),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=r,this.h=o,this.c=new A.$CC(u,m,n)}equals(u){return!(u instanceof O)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,w){return this.c.getOffsetAt(u,w)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,w){const m=u+w,r=this.getPositionAt(u),o=this.getPositionAt(m);return new R.$ct(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,w=0){if(u.isEmpty())return"";const m=this.n(w);return this.c.getValueInRange(u,m)}getValueLengthInRange(u,w=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const m=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const s=this.n(w),n=this.getEOL();if(s.length!==n.length){const i=s.length-n.length,a=u.endLineNumber-u.startLineNumber;o=i*a}return r-m+o}getCharacterCountInRange(u,w=0){if(this.j){let m=0;const r=u.startLineNumber,o=u.endLineNumber;for(let s=r;s<=o;s++){const n=this.getLineContent(s),i=s===r?u.startColumn-1:0,a=s===o?u.endColumn-1:n.length;for(let h=i;h<a;h++)T.$pf(n.charCodeAt(h))?(m=m+1,h=h+1):m=m+1}return m+=this.n(w).length*(o-r),m}return this.getValueLengthInRange(u,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,w){return this.c.getLineCharCode(u,w)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const w=T.$af(this.getLineContent(u));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(u){const w=T.$cf(this.getLineContent(u));return w===-1?0:w+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,w,m){let r=this.g,o=this.h,s=this.j,n=!0,i=[];for(let b=0;b<u.length;b++){const p=u[b];n&&p._isTracked&&(n=!1);const l=p.range;if(p.text){let P=!0;s||(P=!T.$Af(p.text),s=P),!r&&P&&(r=T.$zf(p.text)),!o&&P&&(o=T.$Cf(p.text))}let D="",f=0,S=0,k=0;if(p.text){let P;[f,S,k,P]=(0,g.$Ot)(p.text);const C=this.getEOL();P===0||P===(C===`\r
`?2:1)?D=p.text:D=p.text.replace(/\r\n|\r|\n/g,C)}i[b]={sortIndex:b,identifier:p.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:D,eolCount:f,firstLineLength:S,lastLineLength:k,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(O.u);let a=!1;for(let b=0,p=i.length-1;b<p;b++){const l=i[b].range.getEndPosition(),D=i[b+1].range.getStartPosition();if(D.isBeforeOrEqual(l)){if(D.isBefore(l))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(i=this.s(i));const h=m||w?O._getInverseEditRanges(i):[],t=[];if(w)for(let b=0;b<i.length;b++){const p=i[b],l=h[b];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let D=l.startLineNumber;D<=l.endLineNumber;D++){let f="";D===l.startLineNumber&&(f=this.getLineContent(p.range.startLineNumber),T.$af(f)!==-1)||t.push({lineNumber:D,oldContent:f})}}let v=null;if(m){let b=0;v=[];for(let p=0;p<i.length;p++){const l=i[p],D=h[p],f=this.getValueInRange(l.range),S=l.rangeOffset+b;b+=l.text.length-f.length,v[p]={sortIndex:l.sortIndex,identifier:l.identifier,range:D,text:f,textChange:new d.$xt(l.rangeOffset,f,S,l.text)}}a||v.sort((p,l)=>p.sortIndex-l.sortIndex)}this.g=r,this.h=o,this.j=s;const c=this.t(i);let $=null;if(w&&t.length>0){t.sort((b,p)=>p.lineNumber-b.lineNumber),$=[];for(let b=0,p=t.length;b<p;b++){const l=t[b].lineNumber;if(b>0&&t[b-1].lineNumber===l)continue;const D=t[b].oldContent,f=this.getLineContent(l);f.length===0||f===D||T.$af(f)!==-1||$.push(l)}}return this.m.fire(),new N.$Av(v,c,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let w=!1;const m=u[0].range,r=u[u.length-1].range,o=new R.$ct(m.startLineNumber,m.startColumn,r.endLineNumber,r.endColumn);let s=m.startLineNumber,n=m.startColumn;const i=[];for(let c=0,$=u.length;c<$;c++){const b=u[c],p=b.range;w=w||b.forceMoveMarkers,i.push(this.getValueInRange(new R.$ct(s,n,p.startLineNumber,p.startColumn))),b.text.length>0&&i.push(b.text),s=p.endLineNumber,n=p.endColumn}const a=i.join(""),[h,t,v]=(0,g.$Ot)(a);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:h,firstLineLength:t,lastLineLength:v,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(u){u.sort(O.w);const w=[];for(let m=0;m<u.length;m++){const r=u[m],o=r.range.startLineNumber,s=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(o===n&&s===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const a=new R.$ct(o,s,n,i);w.push({range:a,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return w}findMatchesLineByLine(u,w,m,r){return this.c.findMatchesLineByLine(u,w,m,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,w){const m=u.startLineNumber,r=u.startColumn,[o,s,n]=(0,g.$Ot)(w);let i;if(w.length>0){const a=o+1;a===1?i=new R.$ct(m,r,m,r+s):i=new R.$ct(m,r,m+a-1,n+1)}else i=new R.$ct(m,r,m,r);return i}static _getInverseEditRanges(u){const w=[];let m=0,r=0,o=null;for(let s=0,n=u.length;s<n;s++){const i=u[s];let a,h;o?o.range.endLineNumber===i.range.startLineNumber?(a=m,h=r+(i.range.startColumn-o.range.endColumn)):(a=m+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(a=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const v=i.eolCount+1;v===1?t=new R.$ct(a,h,a,h+i.firstLineLength):t=new R.$ct(a,h,a+v-1,i.lastLineLength+1)}else t=new R.$ct(a,h,a,h);m=t.endLineNumber,r=t.endColumn,w.push(t),o=i}return w}static u(u,w){const m=R.$ct.compareRangesUsingEnds(u.range,w.range);return m===0?u.sortIndex-w.sortIndex:m}static w(u,w){const m=R.$ct.compareRangesUsingEnds(u.range,w.range);return m===0?w.sortIndex-u.sortIndex:-m}}e.$DC=O}),define(Pe[149],Re([1,0,15,92,148]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EC=void 0;class N{constructor(d,E,O,y,u,w,m,r,o){this.a=d,this.b=E,this.c=O,this.d=y,this.e=u,this.f=w,this.g=m,this.h=r,this.j=o}k(d){const E=this.c+this.d+this.e,O=this.c+this.e;return E===0?d===1?`
`:`\r
`:O>E/2?`\r
`:`
`}create(d){const E=this.k(d),O=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let u=0,w=O.length;u<w;u++){const m=O[u].buffer.replace(/\r\n|\r|\n/g,E),r=(0,T.$yC)(m);O[u]=new T.$BC(m,r)}const y=new R.$DC(O,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:y,disposable:y}}getFirstLineText(d){return this.a[0].buffer.substr(0,d).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(d){if(d.length===0)return;this.a.length===0&&I.$Jf(d)&&(this.b=I.$If,d=d.substr(1));const E=d.charCodeAt(d.length-1);E===13||E>=55296&&E<=56319?(this.m(d.substr(0,d.length-1),!1),this.c=!0,this.d=E):(this.m(d,!1),this.c=!1,this.d=E)}m(d,E){!E&&d.length===0||(this.c?this.n(String.fromCharCode(this.d)+d):this.n(d))}n(d){const E=(0,T.$zC)(this.e,d);this.a.push(new T.$BC(d,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=I.$zf(d)),this.k||(this.k=I.$Cf(d)))}finish(d=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,d)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const d=this.a[this.a.length-1];d.buffer+=String.fromCharCode(this.d);const E=(0,T.$yC)(d.buffer);d.lineStarts=E,this.d===13&&this.f++}}}e.$EC=A}),define(Pe[97],Re([1,0,22,21]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pab=d,e.$Qab=O;var R;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(R||(R={}));function N(y){for(let u=0,w=y.length;u<w;u+=4){const m=y[u+0],r=y[u+1],o=y[u+2],s=y[u+3];y[u+0]=s,y[u+1]=o,y[u+2]=r,y[u+3]=m}}function A(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return T.$D()||N(u),I.$ue.wrap(u)}function g(y){const u=y.buffer;if(T.$D()||N(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const w=new Uint8Array(u.byteLength);return w.set(u),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function d(y){const u=new Uint32Array(E(y));let w=0;if(u[w++]=y.id,y.type==="full")u[w++]=1,u[w++]=y.data.length,u.set(y.data,w),w+=y.data.length;else{u[w++]=2,u[w++]=y.deltas.length;for(const m of y.deltas)u[w++]=m.start,u[w++]=m.deleteCount,m.data?(u[w++]=m.data.length,u.set(m.data,w),w+=m.data.length):u[w++]=0}return A(u)}function E(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const w of y.deltas)w.data&&(u+=w.data.length)}return u}function O(y){const u=g(y);let w=0;const m=u[w++];if(u[w++]===1){const n=u[w++],i=u.subarray(w,w+n);return w+=n,{id:m,type:"full",data:i}}const o=u[w++],s=[];for(let n=0;n<o;n++){const i=u[w++],a=u[w++],h=u[w++];let t;h>0&&(t=u.subarray(w,w+h),w+=h),s[n]={start:i,deleteCount:a,data:t}}return{id:m,type:"delta",deltas:s}}}),define(Pe[150],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[151],Re([1,0,18,26,21,134,152,150]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=a,e.stringSet=v,e.cursorStyleToString=k,e.filterValidationDecorations=he;var d;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(d||(e.EditorAutoIndentStrategy=d={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=E;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class y{constructor(X,me,We,Ze){this.id=X,this.name=me,this.defaultValue=We,this.schema=Ze}applyUpdate(X,me){return w(X,me)}compute(X,me,We){return We}}class u{constructor(X,me){this.newValue=X,this.didChange=me}}e.ApplyUpdateResult=u;function w(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new u(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const We=Array.isArray(Z)&&Array.isArray(X)&&I.$ub(Z,X);return new u(X,!We)}let me=!1;for(const We in X)if(X.hasOwnProperty(We)){const Ze=w(Z[We],X[We]);Ze.didChange&&(Z[We]=Ze.newValue,me=!0)}return new u(Z,me)}class m{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,me){return w(X,me)}validate(X){return this.defaultValue}}class r{constructor(X,me,We,Ze){this.id=X,this.name=me,this.defaultValue=We,this.schema=Ze}applyUpdate(X,me){return w(X,me)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,me,We){return We}}function o(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class s extends r{constructor(X,me,We,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=We),super(X,me,We,Ze)}validate(X){return o(X,this.defaultValue)}}function n(Z,X,me,We){if(typeof Z>"u")return X;let Ze=parseInt(Z,10);return isNaN(Ze)?X:(Ze=Math.max(me,Ze),Ze=Math.min(We,Ze),Ze|0)}class i extends r{static clampedInt(X,me,We,Ze){return n(X,me,We,Ze)}constructor(X,me,We,Ze,Me,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=We,ht.minimum=Ze,ht.maximum=Me),super(X,me,We,ht),this.minimum=Ze,this.maximum=Me}validate(X){return i.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function a(Z,X,me,We){if(typeof Z>"u")return X;const Ze=h.float(Z,X);return h.clamp(Ze,me,We)}class h extends r{static clamp(X,me,We){return X<me?me:X>We?We:X}static float(X,me){if(typeof X=="number")return X;if(typeof X>"u")return me;const We=parseFloat(X);return isNaN(We)?me:We}constructor(X,me,We,Ze,Me){typeof Me<"u"&&(Me.type="number",Me.default=We),super(X,me,We,Me),this.validationFn=Ze}validate(X){return this.validationFn(h.float(X,this.defaultValue))}}class t extends r{static string(X,me){return typeof X!="string"?me:X}constructor(X,me,We,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=We),super(X,me,We,Ze)}validate(X){return t.string(X,this.defaultValue)}}function v(Z,X,me,We){return typeof Z!="string"?X:We&&Z in We?We[Z]:me.indexOf(Z)===-1?X:Z}class c extends r{constructor(X,me,We,Ze,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ze,Me.default=We),super(X,me,We,Me),this.c=Ze}validate(X){return v(X,this.defaultValue,this.c)}}class $ extends y{constructor(X,me,We,Ze,Me,ht,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=Me,Pt.default=Ze),super(X,me,We,Pt),this.c=Me,this.d=ht}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function b(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,me,We){return We===0?X.accessibilitySupport:We}}class l extends y{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:g.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function f(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function k(Z){switch(Z){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function P(Z){switch(Z){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class C extends m{constructor(){super(142)}compute(X,me,We){const Ze=["monaco-editor"];return me.get(39)&&Ze.push(me.get(39)),X.extraEditorClassName&&Ze.push(X.extraEditorClassName),me.get(74)==="default"?Ze.push("mouse-default"):me.get(74)==="copy"&&Ze.push("mouse-copy"),me.get(111)&&Ze.push("showUnused"),me.get(140)&&Ze.push("showDeprecated"),Ze.join(" ")}}class q extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(X,me,We){return We&&X.emptySelectionClipboard}}class V extends y{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:g.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:g.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":v(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":v(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class W extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?W.OFF:X==="true"?W.ON:X:X?W.ON:W.OFF}}e.EditorFontLigatures=W;class M extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?M.OFF:X==="true"?M.TRANSLATE:X:X?M.TRANSLATE:M.OFF}compute(X,me,We){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class z extends m{constructor(){super(50)}compute(X,me,We){return X.fontInfo}}class K extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(X){const me=h.float(X,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(me,6,100)}compute(X,me,We){return X.fontInfo.fontSize}}class ie extends y{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(i.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class fe extends y{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:We,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:We,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:We,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:We,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:We,description:g.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{multiple:v(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??v(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??v(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??v(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??v(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??v(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends y{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:g.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:i.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var ye;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class oe extends m{constructor(){super(145)}compute(X,me,We){return oe.computeLayout(me,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const me=X.height/X.lineHeight,We=Math.floor(X.paddingTop/X.lineHeight);let Ze=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ze=Math.max(Ze,me-1));const Me=(We+X.viewLineCount+Ze)/(X.pixelRatio*X.height),ht=Math.floor(X.viewLineCount/Me);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Ze,desiredRatio:Me,minimapLineCount:ht}}static c(X,me){const We=X.outerWidth,Ze=X.outerHeight,Me=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const ht=me.stableMinimapLayoutInput,Pt=ht&&X.outerHeight===ht.outerHeight&&X.lineHeight===ht.lineHeight&&X.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&X.pixelRatio===ht.pixelRatio&&X.scrollBeyondLastLine===ht.scrollBeyondLastLine&&X.paddingTop===ht.paddingTop&&X.paddingBottom===ht.paddingBottom&&X.minimap.enabled===ht.minimap.enabled&&X.minimap.side===ht.minimap.side&&X.minimap.size===ht.minimap.size&&X.minimap.showSlider===ht.minimap.showSlider&&X.minimap.renderCharacters===ht.minimap.renderCharacters&&X.minimap.maxColumn===ht.minimap.maxColumn&&X.minimap.scale===ht.minimap.scale&&X.verticalScrollbarWidth===ht.verticalScrollbarWidth&&X.isViewportWrapping===ht.isViewportWrapping,Bt=X.lineHeight,_t=X.typicalHalfwidthCharacterWidth,Qt=X.scrollBeyondLastLine,ei=X.minimap.renderCharacters;let St=Me>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Xt=X.minimap.maxColumn,Wt=X.minimap.size,ci=X.minimap.side,Ye=X.verticalScrollbarWidth,ti=X.viewLineCount,ii=X.remainingWidth,Ht=X.isViewportWrapping,lt=ei?2:3;let vt=Math.floor(Me*Ze);const ai=vt/Me;let Gt=!1,Vt=!1,gt=lt*St,It=St/Me,ui=1;if(Wt==="fill"||Wt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:Rt,extraLinesBeyondLastLine:Nt,desiredRatio:li,minimapLineCount:Ft}=oe.computeContainedMinimapLineCount({viewLineCount:ti,scrollBeyondLastLine:Qt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ze,lineHeight:Bt,pixelRatio:Me});if(ti/Ft>1)Gt=!0,Vt=!0,St=1,gt=1,It=St/Me;else{let Et=!1,At=St+1;if(Wt==="fit"){const ri=Math.ceil((Rt+ti+Nt)*gt);Ht&&Pt&&ii<=me.stableFitRemainingWidth?(Et=!0,At=me.stableFitMaxMinimapScale):Et=ri>vt}if(Wt==="fill"||Et){Gt=!0;const ri=St;gt=Math.min(Bt*Me,Math.max(1,Math.floor(1/li))),Ht&&Pt&&ii<=me.stableFitRemainingWidth&&(At=me.stableFitMaxMinimapScale),St=Math.min(At,Math.max(1,Math.floor(gt/lt))),St>ri&&(ui=Math.min(2,St/ri)),It=St/Me/ui,vt=Math.ceil(Math.max(Ot,Rt+ti+Nt)*gt),Ht?(me.stableMinimapLayoutInput=X,me.stableFitRemainingWidth=ii,me.stableFitMaxMinimapScale=St):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Zt=Math.floor(Xt*It),He=Math.min(Zt,Math.max(0,Math.floor((ii-Ye-2)*It/(_t+It)))+e.MINIMAP_GUTTER_WIDTH);let Tt=Math.floor(Me*He);const qt=Tt/Me;Tt=Math.floor(Tt*ui);const ni=ei?1:2,$t=ci==="left"?0:We-He-Ye;return{renderMinimap:ni,minimapLeft:$t,minimapWidth:He,minimapHeightIsEditorHeight:Gt,minimapIsSampling:Vt,minimapScale:St,minimapLineHeight:gt,minimapCanvasInnerWidth:Tt,minimapCanvasInnerHeight:vt,minimapCanvasOuterWidth:qt,minimapCanvasOuterHeight:ai}}static computeLayout(X,me){const We=me.outerWidth|0,Ze=me.outerHeight|0,Me=me.lineHeight|0,ht=me.lineNumbersDigitCount|0,Pt=me.typicalHalfwidthCharacterWidth,Bt=me.maxDigitWidth,_t=me.pixelRatio,Qt=me.viewLineCount,ei=X.get(137),St=ei==="inherit"?X.get(136):ei,Xt=St==="inherit"?X.get(132):St,Wt=X.get(135),ci=me.isDominatedByLongLines,Ye=X.get(57),ti=X.get(68).renderType!==0,ii=X.get(69),Ht=X.get(105),lt=X.get(84),vt=X.get(73),ai=X.get(103),Gt=ai.verticalScrollbarSize,Vt=ai.verticalHasArrows,gt=ai.arrowSize,It=ai.horizontalScrollbarSize,ui=X.get(43),Zt=X.get(110)!=="never";let He=X.get(66);ui&&Zt&&(He+=16);let Tt=0;if(ti){const wt=Math.max(ht,ii);Tt=Math.round(wt*Bt)}let qt=0;Ye&&(qt=Me*me.glyphMarginDecorationLaneCount);let ni=0,$t=ni+qt,Ot=$t+Tt,Rt=Ot+He;const Nt=We-qt-Tt-He;let li=!1,Ft=!1,Lt=-1;St==="inherit"&&ci?(li=!0,Ft=!0):Xt==="on"||Xt==="bounded"?Ft=!0:Xt==="wordWrapColumn"&&(Lt=Wt);const Et=oe.c({outerWidth:We,outerHeight:Ze,lineHeight:Me,typicalHalfwidthCharacterWidth:Pt,pixelRatio:_t,scrollBeyondLastLine:Ht,paddingTop:lt.top,paddingBottom:lt.bottom,minimap:vt,verticalScrollbarWidth:Gt,viewLineCount:Qt,remainingWidth:Nt,isViewportWrapping:Ft},me.memory||new O);Et.renderMinimap!==0&&Et.minimapLeft===0&&(ni+=Et.minimapWidth,$t+=Et.minimapWidth,Ot+=Et.minimapWidth,Rt+=Et.minimapWidth);const At=Nt-Et.minimapWidth,ri=Math.max(1,Math.floor((At-Gt-2)/Pt)),jt=Vt?gt:0;return Ft&&(Lt=Math.max(1,ri),Xt==="bounded"&&(Lt=Math.min(Lt,Wt))),{width:We,height:Ze,glyphMarginLeft:ni,glyphMarginWidth:qt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:$t,lineNumbersWidth:Tt,decorationsLeft:Ot,decorationsWidth:He,contentLeft:Rt,contentWidth:At,minimap:Et,viewportColumn:ri,isWordWrapMinified:li,isViewportWrapping:Ft,wrappingColumn:Lt,verticalScrollbarWidth:Gt,horizontalScrollbarHeight:It,overviewRuler:{top:jt,width:Gt,height:Ze-2*jt,right:0}}}}e.EditorLayoutInfoComputer=oe;class $e extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(X){return v(X,"simple",["simple","advanced"])}compute(X,me,We){return me.get(2)===2?"advanced":We}}var ne;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class Se extends y{constructor(){const X={enabled:ne.OnCode};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:X.enabled,enumDescriptions:[g.localize(50,null),g.localize(51,null),g.localize(52,null)],description:g.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:v(X.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class je extends y{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:g.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:g.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:g.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:g.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:v(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends y{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:g.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(59,null),g.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:g.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:g.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:g.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:v(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class L extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):i.clampedInt(X,this.defaultValue,0,1e3)}compute(X,me,We){return We<0?i.clampedInt(-We*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class _ extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>h.clamp(X,0,150),{markdownDescription:g.localize(66,null)})}compute(X,me,We){return X.fontInfo.lineHeight}}class ve extends y{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:g.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:g.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(69,null),g.localize(70,null),g.localize(71,null)],default:X.size,description:g.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:g.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:g.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:g.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:g.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:g.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:g.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:g.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:v(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(me.side,this.defaultValue.side,["right","left"]),showSlider:v(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(me.scale,1,1,3),maxColumn:i.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Oe(Z){return Z==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class ke extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{top:i.clampedInt(me.top,0,0,1e3),bottom:i.clampedInt(me.bottom,0,0,1e3)}}}class pe extends y{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:g.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:g.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class de extends m{constructor(){super(143)}compute(X,me,We){return X.pixelRatio}}class J extends y{constructor(){const X={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:X.strings,description:g.localize(88,null)},comments:{anyOf:me,default:X.comments,description:g.localize(89,null)},other:{anyOf:me,default:X.other,description:g.localize(90,null)}},default:X,markdownDescription:g.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const _t=X?"on":"off";return{comments:_t,strings:_t,other:_t}}if(!X||typeof X!="object")return this.defaultValue;const{other:me,comments:We,strings:Ze}=X,Me=["on","inline","off"];let ht,Pt,Bt;return typeof me=="boolean"?ht=me?"on":"off":ht=v(me,this.defaultValue.other,Me),typeof We=="boolean"?Pt=We?"on":"off":Pt=v(We,this.defaultValue.comments,Me),typeof Ze=="boolean"?Bt=Ze?"on":"off":Bt=v(Ze,this.defaultValue.strings,Me),{other:ht,comments:Pt,strings:Bt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class ue extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(92,null),g.localize(93,null),g.localize(94,null),g.localize(95,null)],default:"on",description:g.localize(96,null)})}validate(X){let me=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(me=4,We=X):X==="interval"?me=3:X==="relative"?me=2:X==="on"?me=1:me=0),{renderType:me,renderFn:We}}}function he(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Ne extends y{constructor(){const X=[],me={type:"number",description:g.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:g.localize(98,null),format:"color-hex"}}}]},default:X,description:g.localize(99,null)})}validate(X){if(Array.isArray(X)){const me=[];for(const We of X)if(typeof We=="number")me.push({column:i.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ze=We;me.push({column:i.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return me.sort((We,Ze)=>We.column-Ze.column),me}return this.defaultValue}}class le extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends y{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(100,null),g.localize(101,null),g.localize(102,null)],default:"auto",description:g.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(104,null),g.localize(105,null),g.localize(106,null)],default:"auto",description:g.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:g.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:g.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:g.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:g.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X,We=i.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=i.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(me.vertical,this.defaultValue.vertical),horizontal:Ie(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:i.clampedInt(me.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:i.clampedInt(me.verticalSliderSize,Ze,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends y{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:g.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:g.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:g.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:g.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:g.localize(118,null)}})}applyUpdate(X,me){let We=!1;me.allowedCharacters&&X&&(T.$Sn(X.allowedCharacters,me.allowedCharacters)||(X={...X,allowedCharacters:me.allowedCharacters},We=!0)),me.allowedLocales&&X&&(T.$Sn(X.allowedLocales,me.allowedLocales)||(X={...X,allowedLocales:me.allowedLocales},We=!0));const Ze=super.applyUpdate(X,me);return We?new u(Ze.newValue,!0):Ze}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,me){if(typeof X!="object"||!X)return me;const We={};for(const[Ze,Me]of Object.entries(X))Me===!0&&(We[Ze]=!0);return We}}class U extends y{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:g.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(120,null),g.localize(121,null),g.localize(122,null)],description:g.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:g.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:g.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:v(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class j extends y{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:g.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(127,null),g.localize(128,null),g.localize(129,null)],description:g.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:g.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:g.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:v(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends y{constructor(){const X={enabled:N.$Ms.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$Ms.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:g.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends y{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null)],default:X.bracketPairs,description:g.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(139,null),g.localize(140,null),g.localize(141,null)],default:X.bracketPairsHorizontal,description:g.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:g.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:g.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(145,null),g.localize(146,null),g.localize(147,null)],default:X.highlightActiveIndentation,description:g.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,X,me){const We=me.indexOf(Z);return We===-1?X:me[We]}class se extends y{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(149,null),g.localize(150,null)],default:X.insertMode,description:g.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:g.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:g.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:g.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(155,null),g.localize(156,null),g.localize(157,null),g.localize(158,null)],default:X.selectionMode,markdownDescription:g.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:g.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:g.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:g.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:g.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:g.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertMode:v(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:v(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Te extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends y{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:g.localize(199,null),type:"string"},{description:g.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const me=[];for(const We of X)if(typeof We=="string")try{Intl.Segmenter.supportedLocalesOf(We).length>0&&me.push(We)}catch{}return me}return this.defaultValue}}var Qe;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class xe extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(201,null),g.localize(202,null),g.localize(203,null),g.localize(204,null)],description:g.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,me,We){return me.get(2)===2?0:We}}class et extends m{constructor(){super(146)}compute(X,me,We){const Ze=me.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class ot extends y{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(208,null),g.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:v(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(212,null),g.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:v(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?at:R.$k?ft:nt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(214,null)})),acceptSuggestionOnEnter:Ue(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(215,null),""],markdownDescription:g.localize(216,null)})),accessibilitySupport:Ue(new p),accessibilityPageSize:Ue(new i(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",g.localize(218,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(220,null),g.localize(221,null),""],description:g.localize(222,null)})),autoClosingComments:Ue(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),autoClosingDelete:Ue(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(226,null),""],description:g.localize(227,null)})),autoClosingOvertype:Ue(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(228,null),""],description:g.localize(229,null)})),autoClosingQuotes:Ue(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(230,null),g.localize(231,null),""],description:g.localize(232,null)})),autoIndent:Ue(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[g.localize(233,null),g.localize(234,null),g.localize(235,null),g.localize(236,null),g.localize(237,null)],description:g.localize(238,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(239,null),g.localize(240,null),g.localize(241,null),""],description:g.localize(242,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new s(116,"stickyTabStops",!1,{description:g.localize(243,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:g.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:g.localize(245,null)})),codeLensFontSize:Ue(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(246,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:g.localize(247,null)})),colorDecoratorActivatedOn:Ue(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),colorDecoratorsLimit:Ue(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(252,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:g.localize(253,null)})),comments:Ue(new l),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(254,null)})),cursorBlinking:Ue(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:g.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(256,null),g.localize(257,null),g.localize(258,null)],description:g.localize(259,null)})),cursorStyle:Ue(new $(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:g.localize(260,null)})),cursorSurroundingLines:Ue(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(262,null),g.localize(263,null)],markdownDescription:g.localize(264,null)})),cursorWidth:Ue(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(265,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:g.localize(266,null)})),emptySelectionClipboard:Ue(new q),dropIntoEditor:Ue(new ot),stickyScroll:Ue(new je),experimentalWhitespaceRendering:Ue(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(267,null),g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:g.localize(271,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:g.localize(272,null)})),foldingStrategy:Ue(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(273,null),g.localize(274,null)],description:g.localize(275,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:g.localize(276,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:g.localize(277,null)})),foldingMaximumRegions:Ue(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(280,null)})),fontInfo:Ue(new z),fontLigatures2:Ue(new W),fontSize:Ue(new K),fontWeight:Ue(new ie),fontVariations:Ue(new M),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:g.localize(281,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:g.localize(282,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:g.localize(283,null)})),gotoLocation:Ue(new fe),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:g.localize(284,null)})),hover:Ue(new De),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:g.localize(285,null)})),lightbulb:Ue(new Se),lineDecorationsWidth:Ue(new L),lineHeight:Ue(new _),lineNumbers:Ue(new ue),lineNumbersMinChars:Ue(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(70,"linkedEditing",!1,{description:g.localize(286,null)})),links:Ue(new s(71,"links",!0,{description:g.localize(287,null)})),matchBrackets:Ue(new c(72,"matchBrackets","always",["always","near","never"],{description:g.localize(288,null)})),minimap:Ue(new ve),mouseStyle:Ue(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:g.localize(289,null)})),mouseWheelZoom:Ue(new s(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?g.localize(290,null):g.localize(291,null)})),multiCursorMergeOverlapping:Ue(new s(77,"multiCursorMergeOverlapping",!0,{description:g.localize(292,null)})),multiCursorModifier:Ue(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Oe,{markdownEnumDescriptions:[g.localize(293,null),g.localize(294,null)],markdownDescription:g.localize(295,null)})),multiCursorPaste:Ue(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(296,null),g.localize(297,null)],markdownDescription:g.localize(298,null)})),multiCursorLimit:Ue(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(299,null)})),occurrencesHighlight:Ue(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(300,null),g.localize(301,null),g.localize(302,null)],markdownDescription:g.localize(303,null)})),overviewRulerBorder:Ue(new s(82,"overviewRulerBorder",!0,{description:g.localize(304,null)})),overviewRulerLanes:Ue(new i(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ke),pasteAs:Ue(new it),parameterHints:Ue(new pe),peekWidgetDefaultFocus:Ue(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(305,null),g.localize(306,null)],description:g.localize(307,null)})),definitionLinkOpensInPeek:Ue(new s(88,"definitionLinkOpensInPeek",!1,{description:g.localize(308,null)})),quickSuggestions:Ue(new J),quickSuggestionsDelay:Ue(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(309,null)})),readOnly:Ue(new s(91,"readOnly",!1)),readOnlyMessage:Ue(new le),renameOnType:Ue(new s(93,"renameOnType",!1,{description:g.localize(310,null),markdownDeprecationMessage:g.localize(311,null)})),renderControlCharacters:Ue(new s(94,"renderControlCharacters",!0,{description:g.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new c(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:g.localize(313,null)})),renderLineHighlight:Ue(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(314,null)],description:g.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(316,null)})),renderValidationDecorations:Ue(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(317,null),g.localize(318,null),g.localize(319,null),""],description:g.localize(320,null)})),revealHorizontalRightPadding:Ue(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(101,"roundedSelection",!0,{description:g.localize(321,null)})),rulers:Ue(new Ne),scrollbar:Ue(new Ae),scrollBeyondLastColumn:Ue(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(322,null)})),scrollBeyondLastLine:Ue(new s(105,"scrollBeyondLastLine",!0,{description:g.localize(323,null)})),scrollPredominantAxis:Ue(new s(106,"scrollPredominantAxis",!0,{description:g.localize(324,null)})),selectionClipboard:Ue(new s(107,"selectionClipboard",!0,{description:g.localize(325,null),included:R.$k})),selectionHighlight:Ue(new s(108,"selectionHighlight",!0,{description:g.localize(326,null)})),selectOnLineNumbers:Ue(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(327,null),g.localize(328,null),g.localize(329,null)],description:g.localize(330,null)})),showUnused:Ue(new s(111,"showUnused",!0,{description:g.localize(331,null)})),showDeprecated:Ue(new s(140,"showDeprecated",!0,{description:g.localize(332,null)})),inlayHints:Ue(new re),snippetSuggestions:Ue(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(333,null),g.localize(334,null),g.localize(335,null),g.localize(336,null)],description:g.localize(337,null)})),smartSelect:Ue(new Te),smoothScrolling:Ue(new s(114,"smoothScrolling",!1,{description:g.localize(338,null)})),stopRenderingLineAfter:Ue(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new se),inlineSuggest:Ue(new U),inlineEdit:Ue(new j),inlineCompletionsAccessibilityVerbose:Ue(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(339,null)})),suggestFontSize:Ue(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(121,"suggestOnTriggerCharacters",!0,{description:g.localize(342,null)})),suggestSelection:Ue(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(343,null),g.localize(344,null),g.localize(345,null)],description:g.localize(346,null)})),tabCompletion:Ue(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(347,null),g.localize(348,null),g.localize(349,null)],description:g.localize(350,null)})),tabIndex:Ue(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new ze),unusualLineTerminators:Ue(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(351,null),g.localize(352,null),g.localize(353,null)],description:g.localize(354,null)})),useShadowDOM:Ue(new s(127,"useShadowDOM",!0)),useTabStops:Ue(new s(128,"useTabStops",!0,{description:g.localize(355,null)})),wordBreak:Ue(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(356,null),g.localize(357,null)],description:g.localize(358,null)})),wordSegmenterLocales:Ue(new Ve),wordSeparators:Ue(new t(131,"wordSeparators",A.$Ns,{description:g.localize(359,null)})),wordWrap:Ue(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(360,null),g.localize(361,null),g.localize(362,null),g.localize(363,null)],description:g.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(365,null)})),wordWrapOverride1:Ue(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new C),defaultColorDecorators:Ue(new s(147,"defaultColorDecorators",!1,{markdownDescription:g.localize(366,null)})),pixelRatio:Ue(new de),tabFocusMode:Ue(new s(144,"tabFocusMode",!1,{markdownDescription:g.localize(367,null)})),layoutInfo:Ue(new oe),wrappingInfo:Ue(new et),wrappingIndent:Ue(new xe),wrappingStrategy:Ue(new $e)}}),define(Pe[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[157],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[158],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[159],Re([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Pe[160],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[161],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[162],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[180],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[181],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[182],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[183],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[184],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[185],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[186],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[187],Re([1,0,14,155]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var R;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(R||(e.TokenType=R={}));function N(...E){switch(E.length){case 1:return(0,T.localize)(0,null,E[0]);case 2:return(0,T.localize)(1,null,E[0],E[1]);case 3:return(0,T.localize)(2,null,E[0],E[1],E[2]);default:return}}const A=(0,T.localize)(3,null),g=(0,T.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(O=>O.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const y=this.d,u=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:u};this.g.push({offset:y,lexeme:u,additionalInfo:O}),this.f.push(w)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const y=this.c.substring(this.d,this.e),u=d.b.get(y);u?this.k(u):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,y=!1,u=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(g);return}const m=this.c.charCodeAt(O);if(y)y=!1;else if(m===47&&!u){O++;break}else m===91?u=!0:m===92?y=!0:m===93&&(u=!1);O++}for(;O<this.c.length&&d.a.has(this.c.charCodeAt(O));)O++;this.e=O;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=d}),define(Pe[188],Re([1,0,23,32,157,301]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=d,e.$tp=E,e.$up=O,e.$vp=y,e.$wp=u,e.$xp=w,e.$yp=m;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function d(s){return s=s.trim(),s==="*"||A.test(s)}function E(s){if(!d(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function O(s){if(!s)return null;const n=s.majorBase,i=s.majorMustEqual,a=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let v=s.patchMustEqual;s.hasCaret&&(n===0||(h=!1),v=!1);let c=0;if(s.preRelease){const $=g.exec(s.preRelease);if($){const[,b,p,l]=$;c=Date.UTC(Number(b),Number(p)-1,Number(l))}}return{majorBase:n,majorMustEqual:i,minorBase:a,minorMustEqual:h,patchBase:t,patchMustEqual:v,isMinimum:s.hasGreaterEquals,notBefore:c}}function y(s,n,i){let a;typeof s=="string"?a=O(E(s)):a=s;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof i=="string"?t=O(E(i)):t=i,!a||!t)return!1;const v=a.majorBase,c=a.minorBase,$=a.patchBase;let b=t.majorBase,p=t.minorBase,l=t.patchBase;const D=t.notBefore;let f=t.majorMustEqual,S=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?v>b?!0:v<b?!1:c>p?!0:c<p||h&&h<D?!1:$>=l:(v===1&&b===0&&(!f||!S||!k)&&(b=1,p=0,l=0,f=!0,S=!1,k=!1),v<b?!1:v>b?!f:c<p?!1:c>p?!S:$<l?!1:$>l?!k:!(h&&h<D))}function u(s,n,i,a,h){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([T.default.Error,R.localize(0,null)]),t;if(typeof a.name!="string")return t.push([T.default.Error,R.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([T.default.Error,R.localize(2,null,"version")]),t;if(!a.engines)return t.push([T.default.Error,R.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([T.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([T.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([T.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([T.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([T.default.Warning,R.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([T.default.Error,R.localize(9,null,"main")]),t;{const $=(0,I.$Vg)(i,a.main);(0,I.$Pg)($,i)||t.push([T.default.Warning,R.localize(10,null,$.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([T.default.Error,R.localize(11,null,"browser")]),t;{const $=(0,I.$Vg)(i,a.browser);(0,I.$Pg)($,i)||t.push([T.default.Warning,R.localize(12,null,$.path,i.path)])}}if(!N.valid(a.version))return t.push([T.default.Error,R.localize(13,null)]),t;const v=[];if(!w(s,n,a,h,v))for(const $ of v)t.push([T.default.Error,$]);return t}function w(s,n,i,a,h){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(s,n,i.engines.vscode,h)}function m(s,n,i){return s==="*"||r(n,i,s)}function r(s,n,i,a=[]){const h=O(E(i));if(!h)return a.push(R.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(R.localize(15,null,i)),!1}else if(!h.majorMustEqual)return a.push(R.localize(16,null,i)),!1;return y(s,n,h)?!0:(a.push(R.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let n=0,i=s.length;n<i;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Pe[70],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class I{constructor(R,N=[],A=!1){this.ctor=R,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$fi=I}),define(Pe[55],Re([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=N,e.$hs=A;const T=[];var R;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function N(g,d,E){d instanceof I.$fi||(d=new I.$fi(d,[],!!E)),T.push([g,d])}function A(){return T}}),define(Pe[189],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class I{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=I;class T{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const g=this.lookupOrInsertNode(N),d=this.lookupOrInsertNode(A);g.outgoing.set(d.key,d),d.incoming.set(g.key,g)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const g of this.a.values())g.outgoing.delete(A),g.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let g=this.a.get(A);return g||(g=new I(A,N),this.a.set(A,g)),g}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,g]of this.a)N.push(`${A}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const g=new Set([N]),d=this.c(A,g);if(d)return d}}c(N,A){for(const[g,d]of N.outgoing){if(A.has(g))return[...A,g].join(" -> ");A.add(g);const E=this.c(d,A);if(E)return E;A.delete(g)}}}e.$Xq=T}),define(Pe[3],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=R,e.$ji=N;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function g(d){return d[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=g})(I||(e._util=I={})),e.$hi=R("instantiationService");function T(A,g,d){g[I.DI_TARGET]===g?g[I.DI_DEPENDENCIES].push({id:A,index:d}):(g[I.DI_DEPENDENCIES]=[{id:A,index:d}],g[I.DI_TARGET]=g)}function R(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const g=function(d,E,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(g,d,O)};return g.toString=()=>A,I.serviceIds.set(A,g),g}function N(A){return A}}),define(Pe[47],Re([1,0,17,2,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=N,e.$Qi=A,e.$Ri=d,e.$Si=E,e.$Ti=O,e.$Ui=y,e.$Vi=u,e.$Wi=m,e.$Xi=r,e.$Yi=o,e.$Oi=(0,R.$ii)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof T.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof T.URI)}var g;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function d(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function O(s,n){const i=Object.create(null);for(const a in s)y(i,a,s[a],n);return i}function y(s,n,i,a){const h=n.split("."),t=h.pop();let v=s;for(let c=0;c<h.length;c++){const $=h[c];let b=v[$];switch(typeof b){case"undefined":b=v[$]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(b)}`);return}v=b}if(typeof v=="object"&&v!==null)try{v[t]=i}catch{a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(v)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(v)}`)}function u(s,n){const i=n.split(".");w(s,i)}function w(s,n){const i=n.shift();if(n.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(w(a,n),Object.keys(a).length===0&&delete s[i])}}function m(s,n,i){function a(v,c){let $=v;for(const b of c){if(typeof $!="object"||$===null)return;$=$[b]}return $}const h=n.split("."),t=a(s,h);return typeof t>"u"?i:t}function r(s,n,i){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in s?I.$Xf(s[a])&&I.$Xf(n[a])?r(s[a],n[a],i):i&&(s[a]=n[a]):s[a]=n[a])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Pe[33],Re([1,0,21,15,187,3,154,14]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=E,e.$hj=v,e.$ij=c,e.$Bj=ne;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",I.$j),d.set("isLinux",I.$k),d.set("isWindows",I.$i),d.set("isWeb",I.$o),d.set("isMacNative",I.$j&&!I.$o),d.set("isEdge",I.$H),d.set("isFirefox",I.$F),d.set("isChrome",I.$E),d.set("isSafari",I.$G);function E(re,L){if(d.get(re)!==void 0)throw(0,g.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(re,L)}const O=Object.prototype.hasOwnProperty;var y;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const u={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),m=(0,A.localize)(1,null),r=(0,A.localize)(2,null),o=(0,A.localize)(3,null),s=(0,A.localize)(4,null),n=(0,A.localize)(5,null),i=(0,A.localize)(6,null),a=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=u){this.k=L,this.d=new R.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const ve=this.D(),Oe=ve.type===17?n:void 0;throw this.h.push({message:s,offset:ve.offset,lexeme:R.$dj.getLexeme(ve),additionalInfo:Oe}),h.c}return _}catch(_){if(_!==h.c)throw _;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const _=this.o();L.push(_)}return L.length===1?L[0]:t.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const _=this.s();L.push(_)}return L.length===1?L[0]:t.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,o),_?.negate()}case 17:return this.z(),P.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,o),_}case 17:{const _=L.lexeme;if(this.z(),this.y(9)){const Oe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Oe.type!==10)throw this.B("REGEX",Oe);const ke=Oe.lexeme,pe=ke.lastIndexOf("/"),de=pe===ke.length-1?void 0:this.w(ke.substring(pe+1));let J;try{J=new RegExp(ke.substring(1,pe),de)}catch{throw this.B("REGEX",Oe)}return z.create(_,J)}switch(Oe.type){case 10:case 19:{const ke=[Oe.lexeme];this.z();let pe=this.D(),de=0;for(let Ne=0;Ne<Oe.lexeme.length;Ne++)Oe.lexeme.charCodeAt(Ne)===40?de++:Oe.lexeme.charCodeAt(Ne)===41&&de--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let Ne=0;Ne<pe.lexeme.length;Ne++)pe.lexeme.charCodeAt(Ne)===40?de++:Oe.lexeme.charCodeAt(Ne)===41&&de--}if(de<0)break;ke.push(R.$dj.getLexeme(pe)),this.z(),pe=this.D()}const J=ke.join(""),Y=J.lastIndexOf("/"),ue=Y===J.length-1?void 0:this.w(J.substring(Y+1));let he;try{he=new RegExp(J.substring(1,Y),ue)}catch{throw this.B("REGEX",Oe)}return t.regex(_,he)}case 18:{const ke=Oe.lexeme;this.z();let pe=null;if(!(0,T.$Ue)(ke)){const de=ke.indexOf("/"),J=ke.lastIndexOf("/");if(de!==J&&de>=0){const Y=ke.slice(de+1,J),ue=ke[J+1]==="i"?"i":"";try{pe=new RegExp(Y,ue)}catch{throw this.B("REGEX",Oe)}}}if(pe===null)throw this.B("REGEX",Oe);return z.create(_,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Oe=this.u();return t.notIn(_,Oe)}switch(this.D().type){case 3:{this.z();const Oe=this.u();if(this.x().type===18)return t.equals(_,Oe);switch(Oe){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,Oe)}}case 4:{this.z();const Oe=this.u();if(this.x().type===18)return t.notEquals(_,Oe);switch(Oe){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,Oe)}}case 5:return this.z(),W.create(_,this.u());case 6:return this.z(),M.create(_,this.u());case 7:return this.z(),q.create(_,this.u());case 8:return this.z(),V.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:i,offset:L.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,_){if(this.C(L))return this.z();throw this.B(_,this.D())}B(L,_,ve){const Oe=(0,A.localize)(8,null,L,R.$dj.getLexeme(_)),ke=_.offset,pe=R.$dj.getLexeme(_);return this.h.push({message:Oe,offset:ke,lexeme:pe,additionalInfo:ve}),h.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=h;class t{static false(){return b.INSTANCE}static true(){return p.INSTANCE}static has(L){return l.create(L)}static equals(L,_){return D.create(L,_)}static notEquals(L,_){return k.create(L,_)}static regex(L,_){return z.create(L,_)}static in(L,_){return f.create(L,_)}static notIn(L,_){return S.create(L,_)}static not(L){return P.create(L)}static and(...L){return fe.create(L,null,!0)}static or(...L){return De.create(L,null,!0)}static greater(L,_){return q.create(L,_)}static greaterEquals(L,_){return V.create(L,_)}static smaller(L,_){return W.create(L,_)}static smallerEquals(L,_){return M.create(L,_)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$gj=t;function v(re){const L=new h({regexParsingWithErrorRecovery:!1});return re.map(_=>(L.parse(_),L.lexingErrors.length>0?L.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,A.localize)(9,null,ve.additionalInfo):(0,A.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function c(re,L){const _=re?re.substituteConstants():void 0,ve=L?L.substituteConstants():void 0;return!_&&!ve?!0:!_||!ve?!1:_.equals(ve)}function $(re,L){return re.cmp(L)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.$jj=b;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return b.INSTANCE}}e.$kj=p;class l{static create(L,_=null){const ve=d.get(L);return typeof ve=="boolean"?ve?p.INSTANCE:b.INSTANCE:new l(L,_)}constructor(L,_){this.key=L,this.c=_,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=d.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:b.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$lj=l;class D{static create(L,_,ve=null){if(typeof _=="boolean")return _?l.create(L,ve):P.create(L,ve);const Oe=d.get(L);return typeof Oe=="boolean"?_===(Oe?"true":"false")?p.INSTANCE:b.INSTANCE:new D(L,_,ve)}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=d.get(this.c);if(typeof L=="boolean"){const _=L?"true":"false";return this.d===_?p.INSTANCE:b.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$mj=D;class f{static create(L,_){return new f(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const _=L.getValue(this.f),ve=L.getValue(this.d);return Array.isArray(_)?_.includes(ve):typeof ve=="string"&&typeof _=="object"&&_!==null?O.call(_,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$nj=f;class S{static create(L,_){return new S(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=11,this.c=f.create(L,_)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=S;class k{static create(L,_,ve=null){if(typeof _=="boolean")return _?P.create(L,ve):l.create(L,ve);const Oe=d.get(L);return typeof Oe=="boolean"?_===(Oe?"true":"false")?b.INSTANCE:p.INSTANCE:new k(L,_,ve)}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=d.get(this.c);if(typeof L=="boolean"){const _=L?"true":"false";return this.d===_?b.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$pj=k;class P{static create(L,_=null){const ve=d.get(L);return typeof ve=="boolean"?ve?b.INSTANCE:p.INSTANCE:new P(L,_)}constructor(L,_){this.c=L,this.d=_,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:oe(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=d.get(this.c);return typeof L=="boolean"?L?b.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$qj=P;function C(re,L){if(typeof re=="string"){const _=parseFloat(re);isNaN(_)||(re=_)}return typeof re=="string"||typeof re=="number"?L(re):b.INSTANCE}class q{static create(L,_,ve=null){return C(_,Oe=>new q(L,Oe,ve))}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$rj=q;class V{static create(L,_,ve=null){return C(_,Oe=>new V(L,Oe,ve))}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$sj=V;class W{static create(L,_,ve=null){return C(_,Oe=>new W(L,Oe,ve))}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$tj=W;class M{static create(L,_,ve=null){return C(_,Oe=>new M(L,Oe,ve))}constructor(L,_,ve){this.c=L,this.d=_,this.f=ve,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:$e(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$uj=M;class z{static create(L,_){return new z(L,_)}constructor(L,_){this.d=L,this.f=_,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const _=this.f?this.f.source:"",ve=L.f?L.f.source:"";return _<ve?-1:_>ve?1:0}equals(L){if(L.type===this.type){const _=this.f?this.f.source:"",ve=L.f?L.f.source:"";return this.d===L.d&&_===ve}return!1}substituteConstants(){return this}evaluate(L){const _=L.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$vj=z;class K{static create(L){return new K(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new K(this.c.map(L))}negate(){return this.c}}e.$wj=K;function ie(re){let L=null;for(let _=0,ve=re.length;_<ve;_++){const Oe=re[_].substituteConstants();if(re[_]!==Oe&&L===null){L=[];for(let ke=0;ke<_;ke++)L[ke]=re[ke]}L!==null&&(L[_]=Oe)}return L===null?re:L}class fe{static create(L,_,ve){return fe.d(L,_,ve)}constructor(L,_){this.expr=L,this.c=_,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let _=0,ve=this.expr.length;_<ve;_++){const Oe=$(this.expr[_],L.expr[_]);if(Oe!==0)return Oe}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].equals(L.expr[_]))return!1;return!0}return!1}substituteConstants(){const L=ie(this.expr);return L===this.expr?this:fe.create(L,this.c,!1)}evaluate(L){for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].evaluate(L))return!1;return!0}static d(L,_,ve){const Oe=[];let ke=!1;for(const pe of L)if(pe){if(pe.type===1){ke=!0;continue}if(pe.type===0)return b.INSTANCE;if(pe.type===6){Oe.push(...pe.expr);continue}Oe.push(pe)}if(Oe.length===0&&ke)return p.INSTANCE;if(Oe.length!==0){if(Oe.length===1)return Oe[0];Oe.sort($);for(let pe=1;pe<Oe.length;pe++)Oe[pe-1].equals(Oe[pe])&&(Oe.splice(pe,1),pe--);if(Oe.length===1)return Oe[0];for(;Oe.length>1;){const pe=Oe[Oe.length-1];if(pe.type!==9)break;Oe.pop();const de=Oe.pop(),J=Oe.length===0,Y=De.create(pe.expr.map(ue=>fe.create([ue,de],null,ve)),null,J);Y&&(Oe.push(Y),Oe.sort($))}if(Oe.length===1)return Oe[0];if(ve){for(let pe=0;pe<Oe.length;pe++)for(let de=pe+1;de<Oe.length;de++)if(Oe[pe].negate().equals(Oe[de]))return b.INSTANCE;if(Oe.length===1)return Oe[0]}return new fe(Oe,_)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const _ of this.expr)L.push(..._.keys());return L}map(L){return new fe(this.expr.map(_=>_.map(L)),null)}negate(){if(!this.c){const L=[];for(const _ of this.expr)L.push(_.negate());this.c=De.create(L,this,!0)}return this.c}}e.$xj=fe;class De{static create(L,_,ve){return De.d(L,_,ve)}constructor(L,_){this.expr=L,this.c=_,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let _=0,ve=this.expr.length;_<ve;_++){const Oe=$(this.expr[_],L.expr[_]);if(Oe!==0)return Oe}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].equals(L.expr[_]))return!1;return!0}return!1}substituteConstants(){const L=ie(this.expr);return L===this.expr?this:De.create(L,this.c,!1)}evaluate(L){for(let _=0,ve=this.expr.length;_<ve;_++)if(this.expr[_].evaluate(L))return!0;return!1}static d(L,_,ve){let Oe=[],ke=!1;if(L){for(let pe=0,de=L.length;pe<de;pe++){const J=L[pe];if(J){if(J.type===0){ke=!0;continue}if(J.type===1)return p.INSTANCE;if(J.type===9){Oe=Oe.concat(J.expr);continue}Oe.push(J)}}if(Oe.length===0&&ke)return b.INSTANCE;Oe.sort($)}if(Oe.length!==0){if(Oe.length===1)return Oe[0];for(let pe=1;pe<Oe.length;pe++)Oe[pe-1].equals(Oe[pe])&&(Oe.splice(pe,1),pe--);if(Oe.length===1)return Oe[0];if(ve){for(let pe=0;pe<Oe.length;pe++)for(let de=pe+1;de<Oe.length;de++)if(Oe[pe].negate().equals(Oe[de]))return p.INSTANCE;if(Oe.length===1)return Oe[0]}return new De(Oe,_)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const _ of this.expr)L.push(..._.keys());return L}map(L){return new De(this.expr.map(_=>_.map(L)),null)}negate(){if(!this.c){const L=[];for(const _ of this.expr)L.push(_.negate());for(;L.length>1;){const _=L.shift(),ve=L.shift(),Oe=[];for(const ke of je(_))for(const pe of je(ve))Oe.push(fe.create([ke,pe],null,!1));L.unshift(De.create(Oe,null,!1))}this.c=De.create(L,this,!0)}return this.c}}e.$yj=De;class ye extends l{static{this.d=[]}static all(){return ye.d.values()}constructor(L,_,ve){super(L,null),this.f=_,typeof ve=="object"?ye.d.push({...ve,key:L}):ve!==!0&&ye.d.push({key:L,description:ve,type:_!=null?typeof _:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return D.create(this.key,L)}notEqualsTo(L){return k.create(this.key,L)}}e.$zj=ye,e.$Aj=(0,N.$ii)("contextKeyService");function oe(re,L){return re<L?-1:re>L?1:0}function $e(re,L,_,ve){return re<_?-1:re>_?1:L<ve?-1:L>ve?1:0}function ne(re,L){if(re.type===0||L.type===1)return!0;if(re.type===9)return L.type===9?Se(re.expr,L.expr):!1;if(L.type===9){for(const _ of L.expr)if(ne(re,_))return!0;return!1}if(re.type===6){if(L.type===6)return Se(L.expr,re.expr);for(const _ of re.expr)if(ne(_,L))return!0;return!1}return re.equals(L)}function Se(re,L){let _=0,ve=0;for(;_<re.length&&ve<L.length;){const Oe=re[_].cmp(L[ve]);if(Oe<0)return!1;Oe===0&&_++,ve++}return _===re.length}function je(re){return re.type===9?re.expr:[re]}}),define(Pe[190],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,I.$ii)("environmentService"),e.$qi=(0,I.$ji)(e.$pi)}),define(Pe[98],Re([1,0,156,3]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=R,e.$Mo=N,e.$No=A,e.$Oo=g,e.$Po=d,e.$Qo=E,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function R(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function g(i,a){return a==="web"&&!i.includes("web")}function d(i,a,h){return g(a,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var O;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var y;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Ro=(0,T.$ii)("extensionGalleryService");var m;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var r;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$So=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class n extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$To=n,e.$Uo=(0,T.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,T.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,T.$ii)("IExtensionTipsService"),e.$Zo=(0,I.localize2)(0,"Extensions"),e.$1o=(0,I.localize2)(1,"Preferences")}),define(Pe[43],Re([1,0,52,19,15,17,2,158,3,21,12,40]),function(ge,e,I,T,R,N,A,g,d,E,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=u,e.$Qk=r,e.$Rk=s,e.$Sk=n,e.$Tk=i,e.$Uk=a,e.$Vk=h,e.$Wk=t,e.$Xk=v,e.$Yk=c,e.$Zk=$,e.$2k=l,e.$3k=D,e.$4k=f,e.$5k=S,e.$6k=k,e.$9k=W,e.$il=De,e.$jl=ye,e.$ll=$e,e.$Ok=(0,d.$ii)("fileService");function u(ne){return ne.create===!0}var w;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var m;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function r(ne){const Se=ne;return!!Se&&typeof Se.onDidChange=="function"}var o;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(ne){return!!(ne.capabilities&2)}function n(ne){return!!(ne.capabilities&8)}function i(ne){return!!(ne.capabilities&131072)}function a(ne){return!!(ne.capabilities&4)}function h(ne){return!!(ne.capabilities&16)}function t(ne){return s(ne)?!!(ne.capabilities&16384):!1}function v(ne){return s(ne)?!!(ne.capabilities&32768):!1}function c(ne){return!!(ne.capabilities&65536)}function $(ne){return!!(ne.capabilities&2048)}var b;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class p extends Error{static create(Se,je){const re=new p(Se.toString(),je);return f(re,je),re}constructor(Se,je){super(Se),this.code=je}}e.$1k=p;function l(ne,Se){return p.create(ne,Se)}function D(ne){return ne||l((0,g.localize)(0,null),b.Unknown)}function f(ne,Se){return ne.name=Se?`${Se} (FileSystemError)`:"FileSystemError",ne}function S(ne){if(!ne)return b.Unknown;if(ne instanceof p)return ne.code;const Se=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!Se)return b.Unknown;switch(Se[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}function k(ne){if(ne instanceof M)return ne.fileOperationResult;switch(S(ne)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}var P;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class C{constructor(Se,je,re){this.resource=Se,this.operation=je,this.target=re}isOperation(Se){return this.operation===Se}}e.$7k=C;var q;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class V{static{this.a=null}constructor(Se,je){this.c=je,this.b=void 0,this.d=new y.$V(()=>{const re=I.$oi.forUris(()=>this.c);return re.fill(this.rawAdded.map(L=>[L,!0])),re}),this.f=new y.$V(()=>{const re=I.$oi.forUris(()=>this.c);return re.fill(this.rawUpdated.map(L=>[L,!0])),re}),this.g=new y.$V(()=>{const re=I.$oi.forUris(()=>this.c);return re.fill(this.rawDeleted.map(L=>[L,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of Se){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==V.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(Se,...je){return this.h(Se,{includeChildren:!1},...je)}affects(Se,...je){return this.h(Se,{includeChildren:!0},...je)}h(Se,je,...re){if(!Se)return!1;const L=re.length>0;return!!((!L||re.includes(1))&&(this.d.value.get(Se)||je.includeChildren&&this.d.value.findSuperstr(Se))||(!L||re.includes(0))&&(this.f.value.get(Se)||je.includeChildren&&this.f.value.findSuperstr(Se))||(!L||re.includes(2))&&(this.g.value.findSubstr(Se)||je.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$8k=V;function W(ne,Se,je){return!ne||!Se||ne===Se||Se.length>ne.length?!1:(Se.charAt(Se.length-1)!==T.sep&&(Se+=T.sep),je?(0,R.$mf)(ne,Se):ne.indexOf(Se)===0)}class M extends Error{constructor(Se,je,re){super(Se),this.fileOperationResult=je,this.options=re}}e.$0k=M;class z extends M{constructor(Se,je,re,L){super(Se,je,L),this.fileOperationResult=je,this.size=re}}e.$$k=z;class K extends M{constructor(Se,je,re){super(Se,2,re),this.stat=je}}e.$_k=K;var ie;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var fe;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$hl="";function De(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function ye(ne,Se){if(!Se.hasProvider(A.URI.from({scheme:ne.scheme})))return new Promise(je=>{const re=Se.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===ne.scheme&&L.added&&(re.dispose(),je())})})}class oe{static{this.KB=1024}static{this.MB=oe.KB*oe.KB}static{this.GB=oe.MB*oe.KB}static{this.TB=oe.GB*oe.KB}static formatSize(Se){return(0,N.$Zf)(Se)||(Se=0),Se<oe.KB?(0,g.localize)(1,null,Se.toFixed(0)):Se<oe.MB?(0,g.localize)(2,null,(Se/oe.KB).toFixed(2)):Se<oe.GB?(0,g.localize)(3,null,(Se/oe.MB).toFixed(2)):Se<oe.TB?(0,g.localize)(4,null,(Se/oe.GB).toFixed(2)):(0,g.localize)(5,null,(Se/oe.TB).toFixed(2))}}e.$kl=oe;function $e(ne){const Se=typeof ne=="string"||ne?.scheme===O.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===O.Schemas.file?1024*oe.MB:Se?10*oe.MB:E.$o?50*oe.MB:1024*oe.MB}}),define(Pe[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class I{constructor(...R){this.a=new Map;for(const[N,A]of R)this.set(N,A)}set(R,N){const A=this.a.get(R);return this.a.set(R,N),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$gi=I}),define(Pe[191],Re([1,0,11,14,6,70,189,3,71,192]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const O=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new d.$gi,s=!1,n,i=O){this.f=o,this.g=s,this.h=n,this.i=i,this.o=new Set,this.f.set(g.$hi,this),this._globalGraph=i?n?._globalGraph??new A.$Xq(a=>a):void 0}createChild(o){return new u(o,this.g,this,this.i)}invokeFunction(o,...s){const n=m.traceInvocation(this.i,o);let i=!1;try{return o({get:h=>{if(i)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,n.stop()}}createInstance(o,...s){let n,i;return o instanceof N.$fi?(n=m.traceCreation(this.i,o.ctor),i=this.j(o.ctor,o.staticArguments.concat(s),n)):(n=m.traceCreation(this.i,o),i=this.j(o,s,n)),n.stop(),i}j(o,s=[],n){const i=g._util.getServiceDependencies(o).sort((t,v)=>t.index-v.index),a=[];for(const t of i){const v=this.m(t.id,n);v||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(v)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(a))}k(o,s){if(this.f.get(o)instanceof N.$fi)this.f.set(o,s);else if(this.h)this.h.k(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const s=this.f.get(o);return!s&&this.h?this.h.l(o):s}m(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof N.$fi?this.q(o,n,s.branch(o,!0)):(s.branch(o,!1),n)}q(o,s,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,s,n)}finally{this.o.delete(o)}}r(o,s,n){const i=new A.$Xq(t=>t.id.toString());let a=0;const h=[{id:o,desc:s,_trace:n}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new y(i);for(const v of g._util.getServiceDependencies(t.desc.ctor)){const c=this.l(v.id);if(c||this.u(`[createInstance] ${o} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(v.id)),c instanceof N.$fi){const $={id:v.id,desc:c,_trace:t._trace.branch(v.id,!0)};i.insertEdge(t,$),h.push($)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:v}of t){if(this.l(v.id)instanceof N.$fi){const $=this.s(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this.k(v.id,$)}i.removeNode(v)}}return this.l(o)}s(o,s,n=[],i,a){if(this.f.get(o)instanceof N.$fi)return this.t(o,s,n,i,a);if(this.h)return this.h.s(o,s,n,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(o,s,n=[],i,a){if(i){const h=new u(void 0,this.g,this,this.i);h.c=String(o);const t=new Map,v=new I.$Bh(()=>{const c=h.j(s,n,a);for(const[$,b]of t){const p=c[$];if(typeof p=="function")for(const l of b)l.disposable=p.apply(c,l.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,$){if(!v.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let l=t.get($);return l||(l=new E.$5c,t.set($,l)),(f,S,k)=>{if(v.isInitialized)return v.value[$](f,S,k);{const P={listener:[f,S,k],disposable:void 0},C=l.push(P);return(0,R.$Sc)(()=>{C(),P.disposable?.dispose()})}}}if($ in c)return c[$];const b=v.value;let p=b[$];return typeof p!="function"||(p=p.bind(b),c[$]=p),p},set(c,$,b){return v.value[$]=b,!0},getPrototypeOf(c){return s.prototype}})}else return this.j(s,n,a)}u(o,s){if(s&&console.warn(o),this.g)throw new Error(o)}}e.$Yq=u;var w;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(w||(w={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new m(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,s){return o?new m(1,s.name):m.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const n=new m(3,o.toString());return this.h.push([o,s,n]),n}stop(){const o=Date.now()-this.g;m.f+=o;let s=!1;function n(a,h){const t=[],v=new Array(a+1).join("	");for(const[c,$,b]of h.h)if($&&b){s=!0,t.push(`${v}CREATES -> ${c}`);const p=n(a+1,b);p&&t.push(p)}else t.push(`${v}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||s)&&m.all.add(i.join(`
`))}}e.$Zq=m}),define(Pe[13],Re([1,0,159,42,5,99,6,28,21,23,17,2,33,3]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=r,e.log=s,e.$3j=l,e.$4j=D,e.$5j=f,e.$6j=S,e.$Oj=(0,w.$ii)("logService"),e.$Pj=(0,w.$ii)("loggerService");function m(){return new Date().toISOString()}function r(k){return(0,O.$Zf)(k)}var o;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Rj=o.Info;function s(k,P,C){switch(P){case o.Trace:k.trace(C);break;case o.Debug:k.debug(C);break;case o.Info:k.info(C);break;case o.Warning:k.warn(C);break;case o.Error:k.error(C);break;case o.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(k,P=!1){let C="";for(let q=0;q<k.length;q++){let V=k[q];if(V instanceof Error&&(V=(0,T.$6i)(V,P)),typeof V=="object")try{V=JSON.stringify(V)}catch{}C+=(q>0?" ":"")+V}return C}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new R.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==o.Off&&this.b<=P}}e.$Tj=i;class a extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...C){this.f(o.Trace)&&this.g(o.Trace,n([P,...C],!0))}debug(P,...C){this.f(o.Debug)&&this.g(o.Debug,n([P,...C]))}info(P,...C){this.f(o.Info)&&this.g(o.Info,n([P,...C]))}warn(P,...C){this.f(o.Warning)&&this.g(o.Warning,n([P,...C]))}error(P,...C){if(this.f(o.Error))if(P instanceof Error){const q=Array.prototype.slice.call(arguments);q[0]=P.stack,this.g(o.Error,n(q))}else this.g(o.Error,n([P,...C]))}flush(){}}e.$Uj=a;class h extends i{constructor(P=e.$Rj){super(),this.setLevel(P),this.g=!d.$i}trace(P,...C){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}debug(P,...C){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}info(P,...C){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...C):console.log(`[main ${m()}]`,P,...C))}warn(P,...C){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,P,...C):console.warn(`[main ${m()}]`,P,...C))}error(P,...C){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,P,...C):console.error(`[main ${m()}]`,P,...C))}flush(){}}e.$Vj=h;class t extends i{constructor(P=e.$Rj,C=!0){super(),this.g=C,this.setLevel(P)}trace(P,...C){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...C):console.log(P,...C))}debug(P,...C){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...C):console.log(P,...C))}info(P,...C){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...C):console.log(P,...C))}warn(P,...C){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...C):console.log(P,...C))}error(P,...C){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...C):console.error(P,...C))}flush(){}}e.$Wj=t;class v extends i{constructor(P,C=e.$Rj){super(),this.g=P,this.setLevel(C)}trace(P,...C){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(P),...C])}debug(P,...C){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(P),...C])}info(P,...C){this.f(o.Info)&&this.g.log(o.Info,[this.h(P),...C])}warn(P,...C){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(P),...C])}error(P,...C){this.f(o.Error)&&this.g.log(o.Error,[this.h(P),...C])}h(P){return typeof P=="string"?P:(0,T.$6i)(P,this.f(o.Trace))}flush(){}}e.$Xj=v;class c extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const C of this.g)C.setLevel(P);super.setLevel(P)}trace(P,...C){for(const q of this.g)q.trace(P,...C)}debug(P,...C){for(const q of this.g)q.debug(P,...C)}info(P,...C){for(const q of this.g)q.info(P,...C)}warn(P,...C){for(const q of this.g)q.warn(P,...C)}error(P,...C){for(const q of this.g)q.error(P,...C)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$Yj=c;class $ extends A.$Uc{constructor(P,C,q){if(super(),this.h=P,this.j=C,this.b=new g.$Bc,this.c=this.B(new R.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$7d),this.onDidChangeVisibility=this.g.event,q)for(const V of q)this.b.set(V.resource,{logger:void 0,info:V})}m(P){return(0,O.$Vf)(P)?[...this.b.values()].find(C=>C.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,C){const q=this.n(P),V=(0,O.$Vf)(P)?P:C?.id??(0,N.$9i)(q.toString()).toString(16);let W=this.b.get(q)?.logger;const M=C?.logLevel==="always"?o.Trace:C?.logLevel;W||(W=this.s(q,M??this.getLogLevel(q)??this.h,{...C,id:V}));const z={logger:W,info:{resource:q,id:V,logLevel:M,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(z.info),this.b.set(q,z),W}n(P){return(0,O.$Vf)(P)?(0,E.$Vg)(this.j,`${P}.log`):P}setLogLevel(P,C){if(y.URI.isUri(P)){const q=P,V=C,W=this.b.get(q);W&&V!==W.info.logLevel&&(W.info.logLevel=V===this.h?void 0:V,W.logger?.setLevel(V),this.b.set(W.info.resource,W),this.f.fire([q,V]))}else{this.h=P;for(const[q,V]of this.b.entries())this.b.get(q)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,C){const q=this.m(P);q&&C!==!q.info.hidden&&(q.info.hidden=!C,this.b.set(q.info.resource,q),this.g.fire([q.info.resource,C]))}getLogLevel(P){let C;return P&&(C=this.b.get(P)?.info.logLevel),C??this.h}registerLogger(P){const C=this.b.get(P.resource);C?C.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const C=this.b.get(P);C&&(C.logger&&C.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=$;class b{constructor(){this.onDidChangeLogLevel=new R.$7d().event}setLevel(P){}getLevel(){return o.Info}trace(P,...C){}debug(P,...C){}info(P,...C){}warn(P,...C){}error(P,...C){}critical(P,...C){}dispose(){}flush(){}}e.$1j=b;class p extends b{}e.$2j=p;function l(k){if(k.verbose)return o.Trace;if(typeof k.logLevel=="string"){const P=S(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Rj}function D(k){switch(k){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(k){switch(k){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(k){switch(k){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$7j=new u.$zj("logLevel",D(o.Info))}),define(Pe[193],Re([1,0,6,13]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=void 0;class R extends I.$Uc{constructor(A,g=[]){super(),this.a=new T.$Yj([A,...g]),this.B(A.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...g){this.a.trace(A,...g)}debug(A,...g){this.a.debug(A,...g)}info(A,...g){this.a.info(A,...g)}warn(A,...g){this.a.warn(A,...g)}error(A,...g){this.a.error(A,...g)}flush(){this.a.flush()}}e.$0P=R}),define(Pe[100],Re([1,0,32,160,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var A;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(d){function E(m,r){return r-m}d.compare=E;const O=Object.create(null);O[d.Error]=(0,T.localize)(0,null),O[d.Warning]=(0,T.localize)(1,null),O[d.Info]=(0,T.localize)(2,null);function y(m){return O[m]||""}d.toString=y;function u(m){switch(m){case I.default.Error:return d.Error;case I.default.Warning:return d.Warning;case I.default.Info:return d.Info;case I.default.Ignore:return d.Hint}}d.fromSeverity=u;function w(m){switch(m){case d.Error:return I.default.Error;case d.Warning:return I.default.Warning;case d.Info:return I.default.Info;case d.Hint:return I.default.Ignore}}d.toSeverity=w}(A||(e.MarkerSeverity=A={}));var g;(function(d){const E="";function O(u){return y(u,!0)}d.makeKey=O;function y(u,w){const m=[E];return u.source?m.push(u.source.replace("\xA6","\\\xA6")):m.push(E),u.code?typeof u.code=="string"?m.push(u.code.replace("\xA6","\\\xA6")):m.push(u.code.value.replace("\xA6","\\\xA6")):m.push(E),u.severity!==void 0&&u.severity!==null?m.push(A.toString(u.severity)):m.push(E),u.message&&w?m.push(u.message.replace("\xA6","\\\xA6")):m.push(E),u.startLineNumber!==void 0&&u.startLineNumber!==null?m.push(u.startLineNumber.toString()):m.push(E),u.startColumn!==void 0&&u.startColumn!==null?m.push(u.startColumn.toString()):m.push(E),u.endLineNumber!==void 0&&u.endLineNumber!==null?m.push(u.endLineNumber.toString()):m.push(E),u.endColumn!==void 0&&u.endColumn!==null?m.push(u.endColumn.toString()):m.push(E),m.push(E),m.join("\xA6")}d.makeKeyOptionalMessage=y})(g||(e.IMarkerData=g={})),e.$Ut=(0,R.$ii)("markerService")}),define(Pe[194],Re([1,0,5,32,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Lv=e.Severity=void 0,e.$Mv=g,e.Severity=T.default,e.$Lv=(0,R.$ii)("notificationService");var N;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function g(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var d;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(d||(e.NotificationsFilter=d={}));class E{constructor(){this.progress=new O,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Nv=E;class O{infinite(){}done(){}total(u){}worked(u){}}e.$Ov=O}),define(Pe[195],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,I.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,T){var R=arguments.length,N=R<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,I):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ge,e,I,T);else for(var g=ge.length-1;g>=0;g--)(A=ge[g])&&(N=(R<3?A(N):R>3?A(e,I,N):A(e,I))||N);return R>3&&N&&Object.defineProperty(e,I,N),N},qe=this&&this.__param||function(ge,e){return function(I,T){e(I,T,ge)}};define(Pe[101],Re([1,0,11,24,6,3]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.ProgressLocation=e.$Pv=void 0,e.$Pv=(0,N.$ii)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Qv=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Rv=g;class d{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const w=this.d;this.d=()=>{w?.(),u()}}):Promise.resolve()}}e.$Sv=d;let E=class extends R.$Uc{constructor(u,w){super(),this.a=new I.$Fh,w.withProgress(u,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Tv=E,e.$Tv=E=Je([qe(1,e.$Pv)],E);class O extends R.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new R.$Tc)}start(u){this.stop();const w=++this.a,m=new T.$ee;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>m.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:m.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Uv=O,e.$Vv=(0,N.$ii)("editorProgressService")}),define(Pe[30],Re([1,0,56,17]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class R{constructor(){this.a=new Map}add(A,g){I.ok(T.$Vf(A)),I.ok(T.$Xf(g)),I.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,g)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$1n=new R}),define(Pe[72],Re([1,0,5,30]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function R(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class N{constructor(){this.b=new I.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,E){this.a[R(d)]=E,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;T.$1n.add(e.$2n.JSONContribution,A)}),define(Pe[57],Re([1,0,18,5,17,153,47,72,30]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=r,e.$fo=o,e.$go=s,e.$ho=i,e.$io=a;var E;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$6n={Configuration:"base.contributions.configuration"};var O;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const y=d.$1n.as(g.$2n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new T.$7d,this.onDidSchemaChange=this.i.event,this.j=new T.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(t,v=!0){this.registerConfigurations([t],v)}registerConfigurations(t,v=!0){const c=new Set;this.n(t,v,c),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const v=new Set;this.o(t,v),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:v})}updateConfigurations({add:t,remove:v}){const c=new Set;this.o(v,c),this.n(t,!1,c),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const v=new Set;this.k(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}k(t,v){const c=[];for(const{overrides:$,source:b}of t)for(const p in $)if(v.add(p),e.$do.test(p)){const l=this.a.get(p),D=l?.valuesSources??new Map;if(b)for(const P of Object.keys($[p]))D.set(P,b);const f={...l?.value||{},...$[p]};this.a.set(p,{source:b,value:f,valuesSources:D});const S=(0,A.$Yi)(p),k={type:"object",default:f,description:N.localize(1,null,S),$ref:e.$ao,defaultDefaultValue:f,source:R.$Vf(b)?void 0:b,defaultValueSource:b};c.push(...r(p)),this.d[p]=k,this.b.properties[p]=k}else{this.a.set(p,{value:$[p],source:b});const l=this.d[p];l&&(this.w(p,l),this.r(p,l))}this.m(c)}deregisterDefaultConfigurations(t){const v=new Set;this.l(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}l(t,v){for(const{overrides:c,source:$}of t)for(const b in c){const p=this.a.get(b),l=R.$Vf($)?$:$?.id,D=R.$Vf(p?.source)?p?.source:p?.source?.id;if(l===D)if(v.add(b),this.a.delete(b),e.$do.test(b))delete this.d[b],delete this.b.properties[b];else{const f=this.d[b];f&&(this.w(b,f),this.r(b,f))}}this.u()}deltaConfiguration(t){let v=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),v=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),v=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:v})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const v of t)this.h.add(v);this.u()}n(t,v,c){t.forEach($=>{this.p($,v,$.extensionInfo,$.restrictedProperties,void 0,c),this.c.push($),this.q($)})}o(t,v){const c=$=>{if($.properties)for(const b in $.properties){v.add(b);const p=this.d[b];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[b],this.s(b,$.properties[b])}$.allOf?.forEach(b=>c(b))};for(const $ of t){c($);const b=this.c.indexOf($);b!==-1&&this.c.splice(b,1)}}p(t,v=!0,c,$,b=3,p){b=R.$5f(t.scope)?b:t.scope;const l=t.properties;if(l)for(const f in l){const S=l[f];if(v&&i(f,S)){delete l[f];continue}if(S.source=c,S.defaultDefaultValue=l[f].default,this.w(f,S),e.$do.test(f)?S.scope=void 0:(S.scope=R.$5f(S.scope)?b:S.scope,S.restricted=R.$5f(S.restricted)?!!$?.includes(f):S.restricted),l[f].hasOwnProperty("included")&&!l[f].included){this.f[f]=l[f],delete l[f];continue}else this.d[f]=l[f],l[f].policy?.name&&this.e.set(l[f].policy.name,f);!l[f].deprecationMessage&&l[f].markdownDeprecationMessage&&(l[f].deprecationMessage=l[f].markdownDeprecationMessage),p.add(f)}const D=t.allOf;if(D)for(const f of D)this.p(f,v,c,$,b,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const v=c=>{const $=c.properties;if($)for(const p in $)this.r(p,$[p]);c.allOf?.forEach(v)};v(t)}r(t,v){switch(e.$7n.properties[t]=v,v.scope){case 1:e.$8n.properties[t]=v;break;case 2:e.$9n.properties[t]=v;break;case 6:e.$0n.properties[t]=v;break;case 3:e.$$n.properties[t]=v;break;case 4:e.$_n.properties[t]=v;break;case 5:e.$_n.properties[t]=v,this.g.properties[t]=v;break}}s(t,v){switch(delete e.$7n.properties[t],v.scope){case 1:delete e.$8n.properties[t];break;case 2:delete e.$9n.properties[t];break;case 6:delete e.$0n.properties[t];break;case 3:delete e.$$n.properties[t];break;case 4:case 5:delete e.$_n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const v=`[${t}]`,c={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ao};this.w(v,c),e.$7n.properties[v]=c,e.$8n.properties[v]=c,e.$9n.properties[v]=c,e.$0n.properties[v]=c,e.$$n.properties[v]=c,e.$_n.properties[v]=c}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=t,e.$8n.patternProperties[e.$co]=t,e.$9n.patternProperties[e.$co]=t,e.$0n.patternProperties[e.$co]=t,e.$$n.patternProperties[e.$co]=t,e.$_n.patternProperties[e.$co]=t,this.i.fire()}w(t,v){const c=this.a.get(t);let $=c?.value,b=c?.source;R.$3f($)&&($=v.defaultDefaultValue,b=void 0),R.$3f($)&&($=s(v.type)),v.default=$,v.defaultValueSource=b}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.$co=`^(${w})+$`,e.$do=new RegExp(e.$co);function r(h){const t=[];if(e.$do.test(h)){let v=m.exec(h);for(;v?.length;){const c=v[1].trim();c&&t.push(c),v=m.exec(h)}}return(0,I.$Mb)(t)}function o(h){return h.reduce((t,v)=>`${t}[${v}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new u;d.$1n.add(e.$6n.Configuration,n);function i(h,t){return h.trim()?e.$do.test(h)?N.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?N.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function a(){const h=[],t=n.getConfigurationProperties();for(const v of Object.keys(t))h.push([v,t[v].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Pe[196],Re([1,0,18,5,123,6,28,26,17,2,47,57,30]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=i;function w(v){return Object.isFrozen(v)?v:g.$Pn(v)}class m{constructor(c={},$=[],b=[],p){this.b=c,this.c=$,this.d=b,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map($=>{if($ instanceof m)return $;const b=new r("");return b.parseRaw($),b.configurationModel});this.f=c.reduce(($,b)=>b===$?b:$.merge(b),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,O.$Wi)(this.contents,c):this.contents}inspect(c,$){const b=this;return{get value(){return w(b.rawConfiguration.getValue(c))},get override(){return $?w(b.rawConfiguration.getOverrideValue(c,$)):void 0},get merged(){return w($?b.rawConfiguration.override($).getValue(c):b.rawConfiguration.getValue(c))},get overrides(){const p=[];for(const{contents:l,identifiers:D,keys:f}of b.rawConfiguration.overrides){const S=new m(l,f).getValue(c);S!==void 0&&p.push({identifiers:D,value:S})}return p.length?w(p):void 0}}}getOverrideValue(c,$){const b=this.i($);return b?c?(0,O.$Wi)(b,c):b:void 0}getKeysForOverrideIdentifier(c){const $=[];for(const b of this.overrides)b.identifiers.includes(c)&&$.push(...b.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const c=[];for(const $ of this.overrides)c.push(...$.identifiers);return I.$Mb(c)}override(c){let $=this.a.get(c);return $||($=this.g(c),this.a.set(c,$)),$}merge(...c){const $=g.$On(this.contents),b=g.$On(this.overrides),p=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of c)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h($,D.contents);for(const f of D.overrides){const[S]=b.filter(k=>I.$ub(k.identifiers,f.identifiers));S?(this.h(S.contents,f.contents),S.keys.push(...f.keys),S.keys=I.$Mb(S.keys)):b.push(g.$On(f))}for(const f of D.keys)p.indexOf(f)===-1&&p.push(f)}return new m($,p,b,l.every(D=>D instanceof m)?void 0:l)}g(c){const $=this.i(c);if(!$||typeof $!="object"||!Object.keys($).length)return this;const b={};for(const p of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let l=this.contents[p];const D=$[p];D&&(typeof l=="object"&&typeof D=="object"?(l=g.$On(l),this.h(l,D)):l=D),b[p]=l}return new m(b,this.keys,this.overrides)}h(c,$){for(const b of Object.keys($)){if(b in c&&d.$Xf(c[b])&&d.$Xf($[b])){this.h(c[b],$[b]);continue}c[b]=g.$On($[b])}}i(c){let $=null,b=null;const p=l=>{l&&(b?this.h(b,l):b=g.$On(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===c?$=l.contents:l.identifiers.includes(c)&&p(l.contents);return p($),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,$){this.j(c,$,!0)}setValue(c,$){this.j(c,$,!1)}removeValue(c){const $=this.keys.indexOf(c);$!==-1&&(this.keys.splice($,1),(0,O.$Vi)(this.contents,c),y.$do.test(c)&&this.overrides.splice(this.overrides.findIndex(b=>I.$ub(b.identifiers,(0,y.$eo)(c))),1))}j(c,$,b){(0,O.$Ui)(this.contents,c,$,p=>console.error(p)),b=b||this.keys.indexOf(c)===-1,b&&this.keys.push(c),y.$do.test(c)&&this.overrides.push({identifiers:(0,y.$eo)(c),keys:Object.keys(this.contents[c]),contents:(0,O.$Ti)(this.contents[c],p=>console.error(p))})}}e.$jo=m;class r{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,$){if(!d.$5f(c)){const b=this.g(c);this.parseRaw(b,$)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,$){this.a=c;const{contents:b,keys:p,overrides:l,restricted:D,hasExcludedProperties:f}=this.h(c,$);this.b=new m(b,p,l,f?[c]:void 0),this.c=D||[]}g(c){let $={},b=null,p=[];const l=[],D=[];function f(k){Array.isArray(p)?p.push(k):b!==null&&(p[b]=k)}const S={onObjectBegin:()=>{const k={};f(k),l.push(p),p=k,b=null},onObjectProperty:k=>{b=k},onObjectEnd:()=>{p=l.pop()},onArrayBegin:()=>{const k=[];f(k),l.push(p),p=k,b=null},onArrayEnd:()=>{p=l.pop()},onLiteralValue:f,onError:(k,P,C)=>{D.push({error:k,offset:P,length:C})}};if(c)try{R.$Cn(c,S),$=p[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return $}h(c,$){const b=u.$1n.as(y.$6n.Configuration).getConfigurationProperties(),p=this.i(c,b,!0,$);c=p.raw;const l=(0,O.$Ti)(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(c),f=this.j(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:D,overrides:f,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(c,$,b,p){let l=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:l};const D={},f=[];for(const S in c)if(y.$do.test(S)&&b){const k=this.i(c[S],$,!1,p);D[S]=k.raw,l=l||k.hasExcludedProperties,f.push(...k.restricted)}else{const k=$[S],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&f.push(S),!p.exclude?.includes(S)&&(p.include?.includes(S)||(P===void 0||p.scopes===void 0||p.scopes.includes(P))&&!(p.skipRestricted&&k?.restricted))?D[S]=c[S]:l=!0}return{raw:D,restricted:f,hasExcludedProperties:l}}j(c,$){const b=[];for(const p of Object.keys(c))if(y.$do.test(p)){const l={};for(const D in c[p])l[D]=c[p][D];b.push({identifiers:(0,y.$eo)(p),keys:Object.keys(l),contents:(0,O.$Ti)(l,$)})}return b}}e.$ko=r;class o extends N.$Uc{constructor(c,$,b,p){super(),this.c=c,this.f=$,this.g=p,this.b=this.B(new T.$7d),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&b.isEqual(l.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=o;class s{constructor(c,$,b,p,l,D,f,S,k,P,C,q,V){this.a=c,this.b=$,this.c=b,this.overrideIdentifiers=p,this.d=l,this.f=D,this.g=f,this.h=S,this.i=k,this.j=P,this.k=C,this.l=q,this.m=V}get value(){return w(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(c,$,b,p,l=new m,D=new m,f=new A.$Bc,S=new m,k=new A.$Bc){this.c=c,this.d=$,this.f=b,this.g=p,this.h=l,this.i=D,this.j=f,this.l=S,this.m=k,this.a=null,this.b=new A.$Bc,this.n=null}getValue(c,$,b){return this.p(c,$,b).getValue(c)}updateValue(c,$,b={}){let p;b.resource?(p=this.m.get(b.resource),p||(p=new m,this.m.set(b.resource,p))):p=this.l,$===void 0?p.removeValue(c):p.setValue(c,$),b.resource||(this.a=null)}inspect(c,$,b){const p=this.p(c,$,b),l=this.t($.resource,b),D=$.resource?this.m.get($.resource)||this.l:this.l,f=new Set;for(const S of p.overrides)for(const k of S.identifiers)p.getOverrideValue(c,k)!==void 0&&f.add(k);return new s(c,$,p.getValue(c),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,l||void 0,D)}keys(c){const $=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,$){this.j.set(c,$),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,$){const b=[];if(!$){const{added:p,updated:l,removed:D}=h(this.c,c);$=[...p,...l,...D]}for(const p of $)for(const l of(0,y.$eo)(p)){const D=this.c.getKeysForOverrideIdentifier(l),f=c.getKeysForOverrideIdentifier(l),S=[...f.filter(k=>D.indexOf(k)===-1),...D.filter(k=>f.indexOf(k)===-1),...D.filter(k=>!g.$Sn(this.c.override(l).getValue(k),c.override(l).getValue(k)))];b.push([l,S])}return this.updateDefaultConfiguration(c),{keys:$,overrides:b}}compareAndUpdatePolicyConfiguration(c){const{added:$,updated:b,removed:p}=h(this.d,c),l=[...$,...b,...p];return l.length&&this.updatePolicyConfiguration(c),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:$,updated:b,removed:p,overrides:l}=h(this.applicationConfiguration,c),D=[...$,...b,...p];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(c){const{added:$,updated:b,removed:p,overrides:l}=h(this.localUserConfiguration,c),D=[...$,...b,...p];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:$,updated:b,removed:p,overrides:l}=h(this.remoteUserConfiguration,c),D=[...$,...b,...p];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:$,updated:b,removed:p,overrides:l}=h(this.workspaceConfiguration,c),D=[...$,...b,...p];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(c,$){const b=this.folderConfigurations.get(c),{added:p,updated:l,removed:D,overrides:f}=h(b,$),S=[...p,...l,...D];return(S.length||!b)&&this.updateFolderConfiguration(c,$),{keys:S,overrides:f}}compareAndDeleteFolderConfiguration(c){const $=this.folderConfigurations.get(c);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:b,updated:p,removed:l,overrides:D}=h($,void 0);return{keys:[...b,...p,...l],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,$,b){let p=this.q($,b);return $.overrideIdentifier&&(p=p.override($.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(p=p.merge(this.d)),p}q({resource:c},$){let b=this.r();if($&&c){const p=$.getFolder(c);p&&(b=this.s(p.uri)||b);const l=this.m.get(c);l&&(b=b.merge(l))}return b}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let $=this.b.get(c);if(!$){const b=this.r(),p=this.j.get(c);p?($=b.merge(p),this.b.set(c,$)):$=b}return $}t(c,$){if($&&c){const b=$.getFolder(c);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,$)=>{const{contents:b,overrides:p,keys:l}=this.j.get($);return c.push([$,{contents:b,overrides:p,keys:l}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach($=>c.add($)),this.userConfiguration.keys.forEach($=>c.add($)),this.i.keys.forEach($=>c.add($)),this.j.forEach($=>$.keys.forEach(b=>c.add(b))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach($=>c.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>c.add($)),this.i.getAllOverrideIdentifiers().forEach($=>c.add($)),this.j.forEach($=>$.getAllOverrideIdentifiers().forEach(b=>c.add(b))),[...c.values()]}v(c){const $=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(b=>$.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(b=>$.add(b)),this.i.getKeysForOverrideIdentifier(c).forEach(b=>$.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(c).forEach(p=>$.add(p))),[...$.values()]}static parse(c){const $=this.w(c.defaults),b=this.w(c.policy),p=this.w(c.application),l=this.w(c.user),D=this.w(c.workspace),f=c.folders.reduce((S,k)=>(S.set(E.URI.revive(k[0]),this.w(k[1])),S),new A.$Bc);return new n($,b,p,l,new m,D,f,new m,new A.$Bc)}static w(c){return new m(c.contents,c.keys,c.overrides)}}e.$mo=n;function i(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const c=new Set,$=new Map;for(const p of v)p.keys.forEach(l=>c.add(l)),p.overrides.forEach(([l,D])=>{const f=(0,A.$yc)($,l,new Set);D.forEach(S=>f.add(S))});const b=[];return $.forEach((p,l)=>b.push([l,[...p.values()]])),{keys:[...c.values()],overrides:b}}class a{constructor(c,$,b,p){this.change=c,this.f=$,this.g=b,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of c.keys)this.affectedKeys.add(l);for(const[,l]of c.overrides)for(const D of l)this.affectedKeys.add(D);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(c,$){const b=this.a+c,p=this.d.indexOf(b);if(p<0)return!1;const l=p+b.length;if(l>=this.d.length)return!1;const D=this.d.charCodeAt(l);if(D!==this.b&&D!==this.c)return!1;if($){const f=this.previousConfiguration?this.previousConfiguration.getValue(c,$,this.f?.workspace):void 0,S=this.g.getValue(c,$,this.h);return!g.$Sn(f,S)}return!0}}e.$oo=a;function h(v,c){const{added:$,removed:b,updated:p}=t(c?.rawConfiguration,v?.rawConfiguration),l=[],D=v?.getAllOverrideIdentifiers()||[],f=c?.getAllOverrideIdentifiers()||[];if(c){const S=f.filter(k=>!D.includes(k));for(const k of S)l.push([k,c.getKeysForOverrideIdentifier(k)])}if(v){const S=D.filter(k=>!f.includes(k));for(const k of S)l.push([k,v.getKeysForOverrideIdentifier(k)])}if(c&&v){for(const S of D)if(f.includes(S)){const k=t({contents:v.getOverrideValue(void 0,S)||{},keys:v.getKeysForOverrideIdentifier(S)},{contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)});l.push([S,[...k.added,...k.removed,...k.updated]])}}return{added:$,removed:b,updated:p,overrides:l}}function t(v,c){const $=v?c?v.keys.filter(l=>c.keys.indexOf(l)===-1):[...v.keys]:[],b=c?v?c.keys.filter(l=>v.keys.indexOf(l)===-1):[...c.keys]:[],p=[];if(v&&c){for(const l of c.keys)if(v.keys.indexOf(l)!==-1){const D=(0,O.$Wi)(c.contents,l),f=(0,O.$Wi)(v.contents,l);g.$Sn(D,f)||p.push(l)}}return{added:$,removed:b,updated:p}}}),define(Pe[102],Re([1,0,14,3]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=E,e.$tl=(0,T.$ii)("remoteAuthorityResolverService");var R;(function(O){O[O.WebSocket=0]="WebSocket",O[O.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class N{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=N;class A{constructor(y,u){this.host=y,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=A;var g;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound",O.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class d extends I.$bb{static isNotAvailable(y){return y instanceof d&&y._code===g.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof d&&y._code===g.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof d&&y._code===g.NoResolverFound}static isInvalidAuthority(y){return y instanceof d&&y._code===g.InvalidAuthority}static isHandled(y){return y instanceof d&&y.isHandled}constructor(y,u=g.Unknown,w){super(y),this._message=y,this._code=u,this._detail=w,this.isHandled=u===g.NotAvailable&&w===!0,Object.setPrototypeOf(this,d.prototype)}}e.$wl=d;function E(O){const y=O.indexOf("+");return y===-1?O:O.substring(0,y)}}),define(Pe[58],Re([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=T,e.$um=R,e.$vm=N,e.$wm=A;function T(d){return d.scheme===I.Schemas.vscodeRemote?d.authority:void 0}function R(d){if(!d)return;const E=d.indexOf("+");return E<0?d:d.substr(0,E)}function N(d){const{host:E,port:O}=g(d);if(typeof O>"u")throw new Error(`Invalid remote authority: ${d}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:O}}function A(d,E){let{host:O,port:y}=g(d);return typeof y>"u"&&(y=E),{host:O,port:y}}function g(d){const E=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const O=d.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const y=d.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:d,port:void 0}}}),define(Pe[20],Re([1,0,15,3,58]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=N,e.$Gm=y,e.$Hm=u,e.$Im=w,e.$Jm=m,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var g;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class d{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const n=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return I.$lf(n,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Dm=d;class E{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(d.toKey(o))}delete(o){return this.c.delete(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}}e.$Em=E;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(d.toKey(o))}get(o){return this.c.get(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}set(o,s){this.c.set(d.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=O;function y(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function w(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function m(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,R.$um)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Km=(0,T.$ii)("IBuiltinExtensionsScannerService")}),define(Pe[103],Re([1,0,14,20]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(A,g){this.a.set(A,g)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const g=Object.create(null);for(const d of A){const E=this.readActivationEvents(d);E.length>0&&(g[T.$Dm.toKey(d.identifier)]=E)}return g}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const g=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let d=0;d<g.length;d++)g[d]==="onUri"&&(g[d]=`onUri:${T.$Dm.toKey(A.identifier)}`);if(!A.contributes)return g;for(const d in A.contributes){const E=this.a.get(d);if(!E)continue;const O=A.contributes[d],y=Array.isArray(O)?O:[O];try{E(y,g)}catch(u){(0,I.$1)(u)}}return g}}e.$SF=R,e.$TF=new R}),define(Pe[197],Re([1,0,21,73,34]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=A,e.$3o=g;function N(d){if(I.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function A(d,E,O,y,u,w,m,r,o){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=m,s.sessionID=(0,R.$Eg)()+Date.now(),s.commitHash=y,s.version=u,s["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=T.$ec,s["common.nodeArch"]=O,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const a=N(E);return a&&(s["common.platformDetail"]=a),s}function g(d){const E=T.env.USERDNSDOMAIN;if(!E)return!1;const O=E.toLowerCase();return d.some(y=>O===y)}}),define(Pe[198],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,I.$ii)("telemetryService"),e.$Ol=(0,I.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var T;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var R;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Pe[59],Re([1,0,26,17,58,197,198]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=O,e.$_o=y,e.$ap=u,e.$bp=w,e.$cp=r,e.$dp=s,e.$ep=n,e.$fp=h;class g{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$4o=g;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=d,e.$6o=new d;class E{async publicLog(v,c,$){}async publicLogError(v,c,$){}}e.$7o=E,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function O(t,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!t.enableTelemetry)}function y(t,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const v=t.getValue(A.$Vl),c=t.getValue(A.$Wl);if(t.getValue(A.$Xl)===!1||c===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const v={},c={},$={};o(t,$);for(let b in $){b=b.length>150?b.substr(b.length-149):b;const p=$[b];typeof p=="number"?c[b]=p:typeof p=="boolean"?c[b]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${p.length}`),v[b]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(v[b]=p)}return{properties:v,measurements:c}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const v=(0,R.$um)(t);return m.has(v)?v:"other"}function o(t,v,c=0,$){if(t)for(const b of Object.getOwnPropertyNames(t)){const p=t[b],l=$?$+b:b;Array.isArray(p)?v[l]=(0,I.$Tn)(p):p instanceof Date?v[l]=p.toISOString():(0,T.$Xf)(p)?c<2?o(p,v,c+1,l+"."):v[l]=(0,I.$Tn)(p):v[l]=p}}function s(t,v){const c=t.msftInternalDomains||[],$=v.getValue("telemetry.internalTesting");return(0,N.$3o)(c)||$}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,v){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const $=[];for(const D of v)for(;;){const f=D.exec(t);if(!f)break;$.push([f.index,D.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(c="";;){const D=p.exec(t);if(!D)break;const f=$.some(([S,k])=>D.index<k&&S<p.lastIndex);!b.test(D[0])&&!f&&(c+=t.substring(l,D.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<t.length&&(c+=t.substr(l)),c}function a(t){if(!t)return t;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of v)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,v){return(0,I.$Qn)(t,c=>{if(c instanceof g||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let $=c.replaceAll("%20"," ");$=i($,v);for(const b of v)$=$.replace(b,"");return $=a($),$}})}}),define(Pe[199],Re([1,0,15,98,20,21,2,14,73,59]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=O,e.$ip=m,e.$jp=r,e.$kp=o,e.$lp=s,e.$mp=n,e.$np=i,e.$op=a,e.$qp=h,e.$rp=v;function O(c,$){return c.uuid&&$.uuid?c.uuid===$.uuid:c.id===$.id?!0:(0,I.$gf)(c.id,$.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const b=$.manifest?$.manifest.version:$.version,p=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,b,p)}static parse($){const b=y.exec($);return b&&b[1]&&b[2]?new u({id:b[1]},b[2],b[4]||void 0):null}constructor($,b,p="undefined"){this.version=b,this.targetPlatform=p,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?O(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$hp=u;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(c){const $=w.exec(c);return $&&$[1]?[o($[1]),$[2]]:[o(c),void 0]}function r(c,$){return`${c}.${$}`}function o(c){return c.toLowerCase()}function s(c,$){return o(r(c??R.$zm,$))}function n(c,$){const b=[],p=l=>{for(const D of b)if(D.some(f=>O($(f),$(l))))return D;return null};for(const l of c){const D=p(l);D?D.push(l):b.push([l])}return b}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new E.$4o(c.identifier.id),name:new E.$4o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$pp=new R.$Dm("pprice.better-merge");function h(c,$){const b=[],p=$.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const l=p.shift();if(l&&b.every(D=>!O(D.identifier,{id:l}))){const D=c.filter(f=>O(f.identifier,{id:l}));D.length===1&&(b.push(D[0]),p.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}async function t(c,$){if(!N.$k)return!1;let b;try{b=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){$.debug("Error while getting the os-release file.",(0,g.$0)(l))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function v(c,$){const b=await t(c,$),p=(0,T.$No)(b?"alpine":N.$u,d.$fc);return $.debug("ComputeTargetPlatform:",p),p}}),define(Pe[200],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=I,e.$8r=T,e.$9r=R,e.$0r=N,e.$$r=A,e.$_r=g;function I(d){return[...d.entries()]}function T(d){return d?[...d.entries()]:[]}function R(d){return new Map(d)}function N(d){return new Map(d??[])}function A(d){return Array.from(d.entries()).map(E=>[E[0],I(E[1].map),T(E[1].descriptionMap)])}function g(d){return new Map(d.map(E=>[E[0],{map:R(E[1]),descriptionMap:N(E[2])}]))}}),define(Pe[201],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hub=void 0;class I{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,N,A=5){const g=N(d=>{const E=typeof d=="string"?d:d.data;let O=this.a.get(R);if(O){O.data.push(E);return}const y=setTimeout(()=>this.flushBuffer(R),A);O={data:[E],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(R),g.dispose()}},this.a.set(R,O)});return g}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const N=this.a.get(R);N&&(this.a.delete(R),this.b(R,N.data.join("")))}}e.$hub=I}),define(Pe[202],Re([1,0,11,91,302,41,5,17,2,161,72,30]),function(ge,e,I,T,R,N,A,g,d,E,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2w=e.$1w=e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.IconFontDefinition=e.IconContribution=e.$Tw=void 0,e.$Uw=o,e.$Vw=s,e.$Tw={IconContribution:"base.contributions.icons"};var u;(function(h){function t(v,c){let $=v.defaults;for(;N.ThemeIcon.isThemeIcon($);){const b=r.getIcon($.id);if(!b)return;$=b.defaults}return $}h.getDefinition=t})(u||(e.IconContribution=u={}));var w;(function(h){function t(c){return{weight:c.weight,style:c.style,src:c.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=t;function v(c){const $=b=>(0,g.$Vf)(b)?b:void 0;if(c&&Array.isArray(c.src)&&c.src.every(b=>(0,g.$Vf)(b.format)&&(0,g.$Vf)(b.location)))return{weight:$(c.weight),style:$(c.style),src:c.src.map(b=>({format:b.format,location:d.URI.parse(b.location)}))}}h.fromJSONObject=v})(w||(e.IconFontDefinition=w={}));class m{constructor(){this.a=new A.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,v,c,$){const b=this.b[t];if(b){if(c&&!b.description){b.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=c),this.a.fire()}return b}const p={id:t,description:c,defaults:v,deprecationMessage:$};this.b[t]=p;const l={$ref:"#/definitions/icons"};return $&&(l.deprecationMessage=$),c&&(l.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const v=this.e.enum.indexOf(t);v!==-1&&(this.e.enum.splice(v,1),this.e.enumDescriptions.splice(v,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,v){const c=this.f[t];return c||(this.f[t]=v,this.a.fire(),v)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(b,p)=>b.id.localeCompare(p.id),v=b=>{for(;N.ThemeIcon.isThemeIcon(b.defaults);)b=this.b[b.defaults.id];return`codicon codicon-${b?b.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(b=>this.b[b]);for(const b of $.filter(p=>!!p.description).sort(t))c.push(`|<i class="${v(b)}"></i>|${b.id}|${N.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const b of $.filter(p=>!N.ThemeIcon.isThemeIcon(p.defaults)).sort(t))c.push(`|<i class="${v(b)}"></i>|${b.id}|`);return c.join(`
`)}}const r=new m;y.$1n.add(e.$Tw.IconContribution,r);function o(h,t,v,c){return r.registerIcon(h,t,v,c)}function s(){return r}function n(){const h=(0,R.$Dj)();for(const t in h){const v="\\"+h[t].toString(16);r.registerIcon(t,{fontCharacter:v})}}n(),e.$Ww="vscode://schemas/icons";const i=y.$1n.as(O.$2n.JSONContribution);i.registerSchema(e.$Ww,r.getIconSchema());const a=new I.$uh(()=>i.notifySchemaChanged(e.$Ww),200);r.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$Xw=o("widget-close",T.$Hj.close,(0,E.localize)(2,null)),e.$Yw=o("goto-previous-location",T.$Hj.arrowUp,(0,E.localize)(3,null)),e.$Zw=o("goto-next-location",T.$Hj.arrowDown,(0,E.localize)(4,null)),e.$1w=N.ThemeIcon.modify(T.$Hj.sync,"spin"),e.$2w=N.ThemeIcon.modify(T.$Hj.loading,"spin")}),define(Pe[203],Re([1,0,5,2,47,3,13]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$4v=e.$2v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xv=e.$Wv=void 0,e.$Yv=E,e.$Zv=y,e.$1v=u,e.$3v=w,e.$5v=m,e.$6v=r,e.$Wv=(0,N.$ii)("tunnelService"),e.$Xv=(0,N.$ii)("sharedTunnelsService");var g;(function(n){n.Http="http",n.Https="https"})(g||(e.TunnelProtocol=g={}));var d;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(d||(e.TunnelPrivacyId=d={}));function E(n){return!!n.forwardPort}var O;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(O||(e.ProvidedOnAutoForward=O={}));function y(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function u(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const a of i){const h=a.split("=")[1];if(/^https?:/.exec(h)){const t=y(T.URI.parse(h));if(t)return t}}}e.$2v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(n){return e.$2v.indexOf(n)>=0}e.$4v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(n){return e.$4v.indexOf(n)>=0}function r(n,i,a,h){if(a===1)return!1;if(a===2&&m(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class o{constructor(i,a,h){this.remoteAddress=i,this.localAddress=a,this.b=h,this.a=new I.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$7v=o;let s=class{constructor(i,a){this.k=i,this.l=a,this.a=new I.$7d,this.onTunnelOpened=this.a.event,this.b=new I.$7d,this.onTunnelClosed=this.b.event,this.c=new I.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const h of a){const t=Array.from(h.values());for(const v of t){const c=await v.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,h,t,v){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:h,privacy:t,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(m(i)||w(i))&&(i=e.$2v[0]);const h=this.s(i,a);if(h)return++h.refcount,h.value}openTunnel(i,a,h,t,v,c=!1,$,b){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${h} on local port ${v}.`);const p=this.f??i;if(!p)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(p,a,h,t,v,c,$,b);return l?l.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.o(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&D.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const h=a.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,a,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=h.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const h=this.e.get(i);if(h&&h.has(a)){const t=h.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:h})}async r(i,a){const h=this.e.get(i);if(h){const t=h.get(a),v=t?await t.value:void 0;(!v||typeof v=="string")&&h.delete(a),h.size===0&&this.e.delete(i)}}s(i,a){const h=[i];w(i)?(h.push(...e.$2v),h.push(...e.$4v)):m(i)&&h.push(...e.$4v);const t=h.map(v=>this.e.get(v));for(const v of t){const c=v?.get(a);if(c)return c}}canTunnel(i){return!!y(i)}u(i,a,h,t,v,c,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${h} on local port ${t}.`);const b=h;this.j.add(b);const p=t===void 0?h:t,l={elevationRequired:v?this.isPortPrivileged(p):!1},D={remoteAddress:{host:a,port:h},localAddressPort:t,privacy:c,public:c?c!==d.Private:void 0,protocol:$},f=i.forwardPort(D,l);return f?(this.q(a,h,f),f.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(b)})):this.j.delete(b),f}};e.$8v=s,e.$8v=s=Je([qe(0,A.$Oj),qe(1,R.$Oi)],s)}),define(Pe[204],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$9v=void 0,e.$9v=(0,I.$ii)("editSessionIdentityService");var T;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[205],Re([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=T,e.$1L=R,e.$2L=N,e.$3L=A,e.$4L=g;function T(d){return d.scheme!==I.Schemas.file&&d.scheme!==I.Schemas.vscodeRemote}function R(d){if(d.folders.length)return d.folders.every(E=>T(E.uri))?d.folders[0].uri:void 0;if(d.configuration&&T(d.configuration))return d.configuration}function N(d){return R(d)?.scheme}function A(d){return R(d)?.authority}function g(d){return R(d)!==void 0}}),define(Pe[48],Re([1,0,162,19,52,23,2,3,12]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=E,e.$ti=O,e.$wi=y,e.$xi=u,e.$yi=w,e.$zi=r,e.$Ai=o,e.$Di=i,e.$Ii=a,e.$Ji=h,e.$Li=t,e.$Mi=v,e.$Ni=c,e.$ri=(0,g.$ii)("contextService");function E($){const b=$;return typeof b?.id=="string"&&A.URI.isUri(b.uri)}function O($){return typeof $?.id=="string"&&!E($)&&!u($)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function y($,b){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,T.$oc)($)}:b?e.$ui:e.$vi;const p=$;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function u($){const b=$;return typeof b?.id=="string"&&A.URI.isUri(b.configPath)}function w($){const b=$;if(b?.uri)return{id:b.id,uri:A.URI.revive(b.uri)};const p=$;if(p?.configPath)return{id:p.id,configPath:A.URI.revive(p.configPath)};if($?.id)return{id:$.id}}var m;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function r($){const b=$;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}function o($){const b=$;return!!(b&&typeof b=="object"&&A.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}class s{constructor(b,p,l,D,f){this.h=b,this.j=l,this.k=D,this.l=f,this.c=R.$oi.forUris(this.l,()=>!0),this.folders=p}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=R.$oi.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=s;class n{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,N.$Vg)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=n;function i($){return new n({uri:$,index:0,name:(0,N.$Rg)($)},{uri:$.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,I.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function a($,b){return N.$Mg.isEqualOrParent($,b.untitledWorkspacesHome)}function h($){let b;return A.URI.isUri($)?b=$:b=$.configuration,b?.scheme===d.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t($){return $.id===e.$Ki}function v($,b){return!a($,b)&&!h($)}function c($){return(typeof $=="string"?(0,T.$pc)($):(0,N.$Tg)($))===e.$Fi}}),define(Pe[74],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;class I{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const N=this.c++;return this.b.set(N,R),this.e(),N}get(R,N){return this.b.has(R)?this.b.get(R)[N]:void 0}delete(R){this.b.delete(R),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$cjc=I}),define(Pe[44],Re([1,0,12,23,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=e.$hjc=void 0;class N{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new T.$Kg(g=>{const d=this.b.get(g.scheme);return!(d===void 0||d&1024)})}$acceptProviderInfos(g,d){d===null?this.b.delete(g.scheme):this.b.set(g.scheme,d)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$hjc=N,e.$ijc=(0,R.$ii)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=void 0,e.$2O=(0,I.$ii)("IExtHostInitDataService")}),define(Pe[206],Re([1,0,168,13,193,27]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;let A=class extends R.$0P{constructor(d,E,O){const y=O.remote.isRemote?"remoteexthost":d?"workerexthost":"exthost",u=O.remote.isRemote?(0,I.localize)(0,null):d?(0,I.localize)(1,null):(0,I.localize)(2,null);super(E.createLogger(y,{name:u}))}};e.$qlc=A,e.$qlc=A=Je([qe(1,T.$Pj),qe(2,N.$2O)],A)}),define(Pe[207],Re([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=e.$3jc=void 0;class T{constructor(A,g,d){this.h=new Map,this.a=A,this.b=g,this.c=d,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new I.$uh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of E.values())O.complete()}catch(O){for(const y of E.values())y.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,g){let d=this.f[A];return typeof d>"u"&&(d=g),d}update(A,g){this.f[A]=g;const d=this.h.get(A);if(d!==void 0)return d.p;const E=new I.$Fh;return this.h.set(A,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$3jc=T;class R extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,g){super(A.identifier.value,!0,g),this.j=A}}e.$4jc=R}),define(Pe[208],Re([1,0,5,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class R{constructor(A){this.c=A,this.a=new I.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,g,d,E){const y=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(g.value,d,E);this.b.fire(y)}$acceptDirtyStateChanged(A,g){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty(g)}$acceptModelSaved(A){const g=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire(g.apiNotebook)}}e.$Qkc=R}),define(Pe[16],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=e.$LO=void 0,e.$LO=(0,I.$ii)("IExtHostRpcService");class T{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$MO=T}),define(Pe[209],Re([1,0,20,5]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;class R{#e;constructor(A,g){this.b=new T.$7d,this.onDidChange=this.b.event,this.a=I.$Dm.toKey(A.identifier),this.#e=g,this.#e.onDidChangePassword(d=>{d.extensionId===this.a&&this.b.fire({key:d.key})})}get(A){return this.#e.get(this.a,A)}store(A,g){return this.#e.store(this.a,A,g)}delete(A){return this.#e.delete(this.a,A)}}e.$$jc=R}),define(Pe[60],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=e.$Ajc=void 0,e.$Ajc=(0,I.$ii)("IURITransformerService");class T{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Bjc=T}),define(Pe[210],Re([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ynb=R,e.$znb=A;class T{constructor(){this.buffers=[]}add(d){let E=this.buffers.indexOf(d);return E<0&&(E=this.buffers.length,this.buffers.push(d)),E}}function R(g,d){if(d.serializeBuffersForPostMessage){const E=new T,y=JSON.stringify(g,(w,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m)};if(ArrayBuffer.isView(m)){const r=N(m);if(r)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m.buffer),view:{type:r,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),u=E.buffers.map(w=>{const m=new Uint8Array(w);return I.$ue.wrap(m)});return{message:y,buffers:u}}else return{message:JSON.stringify(g),buffers:[]}}function N(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(g,d){const E=d.map(u=>{const w=new ArrayBuffer(u.byteLength);return new Uint8Array(w).set(u.buffer),w}),O=d.length?(u,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const m=w,{index:r}=m,o=E[r];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return w}:void 0;return{message:JSON.parse(g,O),arrayBuffers:E}}}),define(Pe[104],Re([1,0,177,17,2,6,3,30,43,12,42,139,32]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$tF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$kF=e.EditorInputCapabilities=e.$jF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=void 0,e.$aF=r,e.$bF=o,e.$cF=s,e.$dF=n,e.$eF=i,e.$fF=a,e.$gF=h,e.$hF=t,e.$iF=v,e.$lF=D,e.$mF=S,e.$nF=k,e.$oF=P,e.$pF=C,e.$qF=q,e.$rF=V,e.$sF=fe,e.$uF=oe,e.$vF=ne,e.$wF=Se,e.$xF=je,e.$8E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$9E={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$0E="workbench.editor.sidebysideEditor",e.$$E="workbench.editors.textDiffEditor",e.$_E="workbench.editors.binaryResourceDiffEditor";var w;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var m;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function r(re){const L=re;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function o(re){const L=re;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function s(re,L,_){for(const ve of _.visibleEditorPanes)if(ve.group.id===L&&re.matches(ve.input))return ve.getViewState()}function n(re){if(D(re))return!1;const L=re;return R.URI.isUri(L?.resource)}function i(re){if(D(re))return!1;const L=re;return L?.original!==void 0&&L.modified!==void 0}function a(re){if(D(re))return!1;const L=re;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function h(re){if(D(re)||i(re))return!1;const L=re;return L?.primary!==void 0&&L.secondary!==void 0}function t(re){if(D(re))return!1;const L=re;return L?L.resource===void 0||L.resource.scheme===E.Schemas.untitled||L.forceUntitled===!0:!1}function v(re){if(D(re))return!1;const L=re;return R.URI.isUri(L?.base?.resource)&&R.URI.isUri(L?.input1?.resource)&&R.URI.isUri(L?.input2?.resource)&&R.URI.isUri(L?.result?.resource)}var c;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var $;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})($||(e.SaveReason=$={}));class b{constructor(){this.a=new Map}registerSource(L,_){let ve=this.a.get(L);return ve||(ve={source:L,label:_},this.a.set(L,ve)),ve.source}getSourceLabel(L){return this.a.get(L)?.label??L}}e.$jF=new b;var p;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class l extends N.$Uc{}e.$kF=l;function D(re){return re instanceof l}function f(re){const L=re;return R.URI.isUri(L?.preferredResource)}function S(re){const L=re;return D(L?.primary)&&D(L?.secondary)}function k(re){const L=re;return D(L?.modified)&&D(L?.original)}function P(re,L,_,ve,Oe){return je(ve,[(0,y.$5i)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const ke={..._,limits:{size:Number.MAX_VALUE}};re.openEditor(L,ke)}}),(0,y.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Oe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function C(re){return D(re?.editor)}function q(re){const L=re;return C(re)&&L?.group!==void 0}function V(re){const L=re;return typeof L?.groupId=="number"&&D(L.editor)}var W;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var M;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",re[re.EDITOR_STICKY=12]="EDITOR_STICKY",re[re.EDITOR_DIRTY=13]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var z;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class K{getOriginalUri(L,_){if(!L)return;if(v(L))return e.$tF.getOriginalUri(L.result,_);if(_?.supportSideBySide){const{primary:Oe,secondary:ke}=this.a(L);if(Oe&&ke){if(_?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(Oe,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===z.ANY)return this.getOriginalUri(Oe,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:_.filterByScheme});L=_.supportSideBySide===z.PRIMARY?Oe:ke}}if(i(L)||a(L)||h(L)||v(L))return;const ve=f(L)?L.preferredResource:L.resource;return!ve||!_||!_.filterByScheme?ve:this.b(ve,_.filterByScheme)}a(L){return S(L)||h(L)?{primary:L.primary,secondary:L.secondary}:k(L)||i(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,_){if(!L)return;if(v(L))return e.$tF.getCanonicalUri(L.result,_);if(_?.supportSideBySide){const{primary:Oe,secondary:ke}=this.a(L);if(Oe&&ke){if(_?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(Oe,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===z.ANY)return this.getCanonicalUri(Oe,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:_.filterByScheme});L=_.supportSideBySide===z.PRIMARY?Oe:ke}}if(i(L)||a(L)||h(L)||v(L))return;const ve=L.resource;return!ve||!_||!_.filterByScheme?ve:this.b(ve,_.filterByScheme)}b(L,_){if(Array.isArray(_)){if(_.some(ve=>L.scheme===ve))return L}else if(_===L.scheme)return L}}var ie;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function fe(re,L,_,ve){if(!re.isSticky(L))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return _===ie.MOUSE||_===ie.KEYBOARD;case"mouse":return _===ie.MOUSE;case"keyboard":return _===ie.KEYBOARD}return!1}e.$tF=new K;var De;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(De||(e.CloseDirection=De={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(L){const _=this.a=L.get(A.$hi);for(const[ve,Oe]of this.c)this.e(ve,Oe,_);this.c.clear()}e(L,_,ve){const Oe=ve.createInstance(_);this.d.set(L,Oe)}registerFileEditorFactory(L){if(this.b)throw new Error("Can only register one file editor factory.");this.b=L}getFileEditorFactory(){return(0,T.$7f)(this.b)}registerEditorSerializer(L,_){if(this.c.has(L)||this.d.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.a?this.e(L,_,this.a):this.c.set(L,_),(0,N.$Sc)(()=>{this.c.delete(L),this.d.delete(L)})}getEditorSerializer(L){return this.d.get(typeof L=="string"?L:L.typeId)}}g.$1n.add(e.$8E.EditorFactory,new ye);async function oe(re,L,_){return!re||!re.length?[]:await Promise.all(re.map(async ve=>{const Oe=R.URI.revive(ve.fileUri);if(!Oe){_.info("Cannot resolve the path because it is not valid.",ve);return}if(!await L.canHandleResource(Oe)){_.info("Cannot resolve the path because it cannot be handled",ve);return}let pe=ve.exists,de=ve.type;if(typeof pe!="boolean"||typeof de!="number")try{de=(await L.stat(Oe)).isDirectory?d.FileType.Directory:d.FileType.Unknown,pe=!0}catch(Y){_.error(Y),pe=!1}if(!pe&&ve.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",ve);return}if(de===d.FileType.Directory){_.info("Cannot resolve the path because it is a directory",ve);return}const J={...ve.options,pinned:!0};return pe?{resource:Oe,options:J}:{resource:Oe,options:J,forceUntitled:!0}}))}var $e;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function ne(re){const L=re;if(!L)return!1;const _=L;if(_.modified)return ne(_.modified);const ve=L;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Se(re){return(0,O.$7i)(re)}function je(re,L,_){const ve=(0,O.$8i)(re,L);return ve.forceMessage=_?.forceMessage,ve.forceSeverity=_?.forceSeverity,ve.allowDialog=_?.allowDialog,ve}}),define(Pe[211],Re([1,0,5,178,3,6,28,30,18,26,91,202]),function(ge,e,I,T,R,N,A,g,d,E,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FF=e.$EF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$DF=e.ViewContentGroups=e.$BF=e.ViewContainerLocation=e.Extensions=e.$AF=e.$zF=e.$yF=void 0,e.$CF=m,e.$yF="views",e.$zF=(0,T.localize)(0,null),e.$AF=(0,y.$Uw)("default-view-icon",O.$Hj.window,(0,T.localize)(1,null));var u;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var w;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$BF=[0,1,2];function m(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$7d),this.onDidRegister=this.c.event,this.f=this.B(new I.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,d.$Rb)([...this.g.values()])}registerViewContainer(c,$,b){const p=this.get(c.id);if(p)return p;const l=c;return l.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,A.$yc)(this.g,$,[]).push(l),b?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:$}),l}deregisterViewContainer(c){for(const $ of this.g.keys()){const b=this.g.get($),p=b?.indexOf(c);if(p!==-1){b?.splice(p,1),b.length===0&&this.g.delete($),this.f.fire({viewContainer:c,viewContainerLocation:$});return}}}get(c){return this.all.filter($=>$.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(b=>b?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find($=>this.getViewContainerLocation($)===c)}}g.$1n.add(u.ViewContainersRegistry,new r);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(v,c){const $=v.group??o.More,b=c.group??o.More;return $!==b?$.localeCompare(b):(v.order??5)-(c.order??5)}class n extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(c,$){this.registerViews2([{views:c,viewContainer:$}])}registerViews2(c){c.forEach(({views:$,viewContainer:b})=>this.r($,b)),this.c.fire(c)}deregisterViews(c,$){const b=this.s(c,$);b.length&&this.f.fire({views:b,viewContainer:$})}moveViews(c,$){for(const b of this.m.keys())if(b!==$){const p=this.s(c,b);p.length&&(this.r(p,$),this.g.fire({views:p,from:b,to:$}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const $ of this.j){const b=(this.m.get($)||[]).filter(p=>p.id===c)[0];if(b)return b}return null}getViewContainer(c){for(const $ of this.j)if((this.m.get($)||[]).filter(p=>p.id===c)[0])return $;return null}registerViewWelcomeContent(c,$){return this.n.add(c,$),this.h.fire(c),(0,N.$Sc)(()=>{this.n.delete(c,$),this.h.fire(c)})}registerViewWelcomeContent2(c,$){const b=new Map;for(const[p,l]of $)this.n.add(c,l),b.set(p,(0,N.$Sc)(()=>{this.n.delete(c,l),this.h.fire(c)}));return this.h.fire(c),b}getViewWelcomeContent(c){const $=[];return this.n.forEach(c,b=>$.push(b)),$.sort(s)}r(c,$){let b=this.m.get($);b||(b=[],this.m.set($,b),this.j.push($));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,T.localize)(2,null,p.id));b.push(p)}}s(c,$){const b=this.m.get($);if(!b)return[];const p=[],l=[];for(const D of b)c.includes(D)?p.push(D):l.push(D);return p.length&&(l.length?this.m.set($,l):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),p}}g.$1n.add(u.ViewsRegistry,new n),e.$DF=(0,R.$ii)("viewDescriptorService");var i;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(c,$){this.c=!1,this.d=!1,(0,E.$Rn)(this,c),this.d=!!$,this.resolve=async b=>{if($&&!this.c){const p=await $(b);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$EF=h;class t extends Error{constructor(c){super((0,T.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$FF=t}),define(Pe[212],Re([1,0,5,39,6,33,3]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.ChatAgentLocation=void 0;var g;(function(O){O.Panel="panel",O.Terminal="terminal",O.Notebook="notebook",O.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(O){function y(u){switch(u){case"panel":return O.Panel;case"terminal":return O.Terminal;case"notebook":return O.Notebook}return O.Panel}O.fromRaw=y}(g||(e.ChatAgentLocation=g={})),e.$FG=(0,A.$ii)("chatAgentService");let d=class{static{this.AGENT_LEADER="@"}constructor(y){this.e=y,this.b=[],this.d=new I.$7d,this.onDidChangeAgents=this.d.event}registerAgent(y,u){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const m=this,r=u.slashCommands;u={...u,get slashCommands(){return r.filter(s=>!s.when||m.e.contextMatchesRules(N.$gj.deserialize(s.when)))}};const o={data:u};return this.b.push(o),(0,R.$Sc)(()=>{this.b=this.b.filter(s=>s!==o),this.d.fire(void 0)})}registerAgentImplementation(y,u){const w=this.f(y);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return w.impl=u,this.d.fire(new E(w.data,u)),(0,R.$Sc)(()=>{w.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(y,u){const w={data:y,impl:u};return this.b.push(w),this.d.fire(new E(y,u)),(0,R.$Sc)(()=>{this.b=this.b.filter(m=>m!==w),this.d.fire(void 0)})}updateAgent(y,u){const w=this.f(y);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);w.data.metadata={...w.data.metadata,...u},this.d.fire(new E(w.data,w.impl))}getDefaultAgent(y){return this.getActivatedAgents().find(u=>!!u.isDefault&&u.locations.includes(y))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}f(y){return this.b.find(u=>u.data.id===y)}getAgent(y){return this.f(y)?.data}getAgents(){return this.b.map(y=>y.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).map(y=>new E(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(u=>u.name===y)}async invokeAgent(y,u,w,m,r){const o=this.f(y);if(!o?.impl)throw new Error(`No activated agent with id ${y}`);return await o.impl.invoke(u,w,m,r)}async getFollowups(y,u,w,m,r){const o=this.f(y);if(!o?.impl)throw new Error(`No activated agent with id ${y}`);return o.impl?.provideFollowups?o.impl.provideFollowups(u,w,m,r):[]}};e.$GG=d,e.$GG=d=Je([qe(0,N.$Aj)],d);class E{constructor(y,u){this.b=y,this.d=u}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,u,w,m){return this.d.invoke(y,u,w,m)}async provideFollowups(y,u,w,m){return this.d.provideFollowups?this.d.provideFollowups(y,u,w,m):[]}provideWelcomeMessage(y){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y)}provideSampleQuestions(y){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y)}}e.$HG=E}),define(Pe[213],Re([1,0,2,29,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$OF=N,e.$PF=A;function N(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof I.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(T.$ct.isIRange)}function A(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(N)}var g;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var d;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(d||(e.ChatCopyKind=d={})),e.$QF=(0,R.$ii)("IChatService"),e.$RF="accessibility.voice.keywordActivation"}),define(Pe[214],Re([1,0,5,11,179]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new I.$7d,this.o=new I.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(g){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=g}onEvent(g){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=g}onRequest(g){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.u("response",g)}sendRequest(g,d,E,O){const y={command:g};if(d&&Object.keys(d).length>0&&(y.arguments=d),this.u("request",y),typeof O=="number"){const u=setTimeout(()=>{clearTimeout(u);const w=this.f.get(y.seq);if(w){this.f.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:g,message:(0,R.localize)(0,null,O,g)};w(m)}},O)}return E&&this.f.set(y.seq,E),y.seq}acceptMessage(g){this.k?this.k(g):(this.m.push(g),this.m.length===1&&this.s())}q(g,d){return g.type!=="event"||d.type!=="event"}async s(){let g;for(;this.m.length;){if((!g||this.q(this.m[0],g))&&await(0,T.$jh)(0),g=this.m.shift(),!g)return;switch(g.type){case"event":this.j?.(g);break;case"request":this.g?.(g);break;case"response":{const d=g,E=this.f.get(d.request_seq);E&&(this.f.delete(d.request_seq),E(d));break}}}}u(g,d){d.type=g,d.seq=this.d++,this.sendMessage(d)}async w(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((d,E)=>g.set(E,d)),await(0,T.$jh)(500),g.forEach((d,E)=>{d({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$6nb=N}),define(Pe[215],Re([1,0,2,180,33,3]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$WI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$VI=e.MemoryRangeType=e.State=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=void 0,e.$UI=d,e.$IH="workbench.view.debug",e.$JH="workbench.debug.variablesView",e.$KH="workbench.debug.watchExpressionsView",e.$LH="workbench.debug.callStackView",e.$MH="workbench.debug.loadedScriptsView",e.$NH="workbench.debug.breakPointsView",e.$OH="workbench.debug.disassemblyView",e.$PH="workbench.panel.repl",e.$QH="workbench.panel.repl.view",e.$RH=new R.$zj("debugType",void 0,{type:"string",description:T.localize(0,null)}),e.$SH=new R.$zj("debugConfigurationType",void 0,{type:"string",description:T.localize(1,null)}),e.$TH=new R.$zj("debugState","inactive",{type:"string",description:T.localize(2,null)}),e.$UH="debugUx",e.$VH=new R.$zj(e.$UH,"default",{type:"string",description:T.localize(3,null)}),e.$WH=new R.$zj("hasDebugged",!1,{type:"boolean",description:T.localize(4,null)}),e.$XH=new R.$zj("inDebugMode",!1,{type:"boolean",description:T.localize(5,null)}),e.$YH=new R.$zj("inDebugRepl",!1,{type:"boolean",description:T.localize(6,null)}),e.$ZH=new R.$zj("breakpointWidgetVisible",!1,{type:"boolean",description:T.localize(7,null)}),e.$1H=new R.$zj("inBreakpointWidget",!1,{type:"boolean",description:T.localize(8,null)}),e.$2H=new R.$zj("breakpointsFocused",!0,{type:"boolean",description:T.localize(9,null)}),e.$3H=new R.$zj("watchExpressionsFocused",!0,{type:"boolean",description:T.localize(10,null)}),e.$4H=new R.$zj("watchExpressionsExist",!1,{type:"boolean",description:T.localize(11,null)}),e.$5H=new R.$zj("variablesFocused",!0,{type:"boolean",description:T.localize(12,null)}),e.$6H=new R.$zj("expressionSelected",!1,{type:"boolean",description:T.localize(13,null)}),e.$7H=new R.$zj("breakpointInputFocused",!1,{type:"boolean",description:T.localize(14,null)}),e.$8H=new R.$zj("callStackItemType",void 0,{type:"string",description:T.localize(15,null)}),e.$9H=new R.$zj("callStackSessionIsAttach",!1,{type:"boolean",description:T.localize(16,null)}),e.$0H=new R.$zj("callStackItemStopped",!1,{type:"boolean",description:T.localize(17,null)}),e.$$H=new R.$zj("callStackSessionHasOneThread",!1,{type:"boolean",description:T.localize(18,null)}),e.$_H=new R.$zj("watchItemType",void 0,{type:"string",description:T.localize(19,null)}),e.$aI=new R.$zj("canViewMemory",void 0,{type:"boolean",description:T.localize(20,null)}),e.$bI=new R.$zj("breakpointItemType",void 0,{type:"string",description:T.localize(21,null)}),e.$cI=new R.$zj("breakpointItemBytes",void 0,{type:"boolean",description:T.localize(22,null)}),e.$dI=new R.$zj("breakpointHasModes",!1,{type:"boolean",description:T.localize(23,null)}),e.$eI=new R.$zj("breakpointSupportsCondition",!1,{type:"boolean",description:T.localize(24,null)}),e.$fI=new R.$zj("loadedScriptsSupported",!1,{type:"boolean",description:T.localize(25,null)}),e.$gI=new R.$zj("loadedScriptsItemType",void 0,{type:"string",description:T.localize(26,null)}),e.$hI=new R.$zj("focusedSessionIsAttach",!1,{type:"boolean",description:T.localize(27,null)}),e.$iI=new R.$zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:T.localize(28,null)}),e.$jI=new R.$zj("stepBackSupported",!1,{type:"boolean",description:T.localize(29,null)}),e.$kI=new R.$zj("restartFrameSupported",!1,{type:"boolean",description:T.localize(30,null)}),e.$lI=new R.$zj("stackFrameSupportsRestart",!1,{type:"boolean",description:T.localize(31,null)}),e.$mI=new R.$zj("jumpToCursorSupported",!1,{type:"boolean",description:T.localize(32,null)}),e.$nI=new R.$zj("stepIntoTargetsSupported",!1,{type:"boolean",description:T.localize(33,null)}),e.$oI=new R.$zj("breakpointsExist",!1,{type:"boolean",description:T.localize(34,null)}),e.$pI=new R.$zj("debuggersAvailable",!1,{type:"boolean",description:T.localize(35,null)}),e.$qI=new R.$zj("debugExtensionAvailable",!0,{type:"boolean",description:T.localize(36,null)}),e.$rI=new R.$zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:T.localize(37,null)}),e.$sI=new R.$zj("debugSetVariableSupported",!1,{type:"boolean",description:T.localize(38,null)}),e.$tI=new R.$zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:T.localize(39,null)}),e.$uI=new R.$zj("debugSetExpressionSupported",!1,{type:"boolean",description:T.localize(40,null)}),e.$vI=new R.$zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:T.localize(41,null)}),e.$wI=new R.$zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:T.localize(42,null)}),e.$xI=new R.$zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:T.localize(43,null)}),e.$yI=new R.$zj("terminateDebuggeeSupported",!1,{type:"boolean",description:T.localize(44,null)}),e.$zI=new R.$zj("suspendDebuggeeSupported",!1,{type:"boolean",description:T.localize(45,null)}),e.$AI=new R.$zj("variableEvaluateNamePresent",!1,{type:"boolean",description:T.localize(46,null)}),e.$BI=new R.$zj("variableIsReadonly",!1,{type:"boolean",description:T.localize(47,null)}),e.$CI=new R.$zj("variableValue",!1,{type:"string",description:T.localize(48,null)}),e.$DI=new R.$zj("variableType",!1,{type:"string",description:T.localize(49,null)}),e.$EI=new R.$zj("variableInterfaces",!1,{type:"array",description:T.localize(50,null)}),e.$FI=new R.$zj("variableName",!1,{type:"string",description:T.localize(51,null)}),e.$GI=new R.$zj("variableLanguage",!1,{type:"string",description:T.localize(52,null)}),e.$HI=new R.$zj("variableExtensionId",!1,{type:"string",description:T.localize(53,null)}),e.$II=new R.$zj("exceptionWidgetVisible",!1,{type:"boolean",description:T.localize(54,null)}),e.$JI=new R.$zj("multiSessionRepl",!1,{type:"boolean",description:T.localize(55,null)}),e.$KI=new R.$zj("multiSessionDebug",!1,{type:"boolean",description:T.localize(56,null)}),e.$LI=new R.$zj("disassembleRequestSupported",!1,{type:"boolean",description:T.localize(57,null)}),e.$MI=new R.$zj("disassemblyViewFocus",!1,{type:"boolean",description:T.localize(58,null)}),e.$NI=new R.$zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:T.localize(59,null)}),e.$OI=new R.$zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:T.localize(60,null)});const A=n=>T.localize(61,null,n);e.$PI=A,e.$QI="editor.contrib.debug",e.$RI="editor.contrib.breakpoint",e.$SI="debug",e.$TI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:T.localize(62,null)};var g;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(g||(e.State=g={}));function d(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$VI="vscode-debug-memory";var O;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(O||(e.DataBreakpointSetType=O={}));var y;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var u;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(u||(e.DebuggerString=u={})),e.$WI=(0,N.$ii)("debugService");var w;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var m;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(m||(e.DebugVisualizationType=m={}));var r;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(o||(e.IDebugVisualizationTreeItem=o={}));var s;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:I.URI.revive(i.iconPath.light),dark:I.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(s||(e.IDebugVisualization=s={}))}),define(Pe[216],Re([1,0,15,2,19,26,12,29,24,18]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=void 0,e.$KG=y,e.$LG=u,e.$MG=w,e.$NG=m,e.$OG=r,e.$PG=o,e.$QG=s,e.$RG=i,e.$SG=t,e.$TG=v,e.$UG=$,e.$VG=p;const O=/{([^}]+)}/g;function y(D,f,S){return D.replace(O,function(k,P){return f&&P.length>0&&P[0]!=="_"?k:S&&S.hasOwnProperty(P)?S[P]:k})}function u(D){const f={};for(const S of Object.keys(D))S.startsWith("!")||(f[S]=D[S]);return f}function w(D){return D.configuration.request==="attach"&&!m(D)&&(!D.parentSession||w(D.parentSession))}function m(D){let f=D.configuration.type;if(f)return f==="vslsShare"&&(f=D.configuration.adapterProxy.configuration.type),(0,I.$lf)(f,"extensionhost")||(0,I.$lf)(f,"pwa-extensionhost")?D:D.parentSession?m(D.parentSession):void 0}function r(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,f,S){let k,P=0;const C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let q=null;for(;q=C.exec(D);){const V=q.index+1,W=V+q[0].length;if(V<=f&&W>=S){k=q[0],P=V;break}}if(k){const V=/\w+/g;let W=null;for(;(W=V.exec(k))&&!(W.index+1+P+W[0].length>=S););W&&(k=k.substring(0,V.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}async function s(D,f,S,k){if(D.evaluatableExpressionProvider.has(f)){const P=D.evaluatableExpressionProvider.ordered(f),C=(0,E.$Hb)(await Promise.all(P.map(async q=>{try{return await q.provideEvaluatableExpression(f,S,k??d.CancellationToken.None)}catch{return}})));if(C.length>0){let q=C[0].expression;const V=C[0].range;return q||(q=f.getLineContent(S.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:q}}}else{const P=f.getLineContent(S.lineNumber),{start:C,end:q}=o(P,S.column,S.column),V=P.substring(C-1,q);return{matchingExpression:V,range:new g.$ct(S.lineNumber,C,S.lineNumber,C+V.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function a(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return T.URI.parse(D.path);if((0,R.$jc)(D.path))return T.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const f=T.URI.revive(D.path);if(f)return f.scheme===A.Schemas.file?f.fsPath:f.toString()}return D.path}function t(D,f){const S=f?a:h,k=(0,N.$On)(D);return c(k,(P,C)=>{P&&C&&(C.path=S(C))}),k}function v(D,f){const S=f?a:h,k=(0,N.$On)(D);return c(k,(P,C)=>{!P&&C&&(C.path=S(C))}),k}function c(D,f){switch(D.type){case"event":{const S=D;switch(S.event){case"output":f(!1,S.body.source);break;case"loadedSource":f(!1,S.body.source);break;case"breakpoint":f(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=D;switch(S.command){case"setBreakpoints":f(!0,S.arguments.source);break;case"breakpointLocations":f(!0,S.arguments.source);break;case"source":f(!0,S.arguments.source);break;case"gotoTargets":f(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(k=>f(!1,k));break;default:break}break}case"response":{const S=D;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(k=>f(!1,k.source));break;case"loadedSources":S.body.sources.forEach(k=>f(!1,k));break;case"scopes":S.body.scopes.forEach(k=>f(!1,k.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(k=>f(!1,k.source));break;case"setBreakpoints":S.body.breakpoints.forEach(k=>f(!1,k.source));break;case"disassemble":S.body?.instructions.forEach(P=>f(!1,P.location));break;default:break}break}}}function $(D){return D.filter(f=>!f.presentation?.hidden).sort((f,S)=>f.presentation?S.presentation?f.presentation.group?S.presentation.group?f.presentation.group!==S.presentation.group?f.presentation.group.localeCompare(S.presentation.group):b(f.presentation.order,S.presentation.order):-1:S.presentation.group?1:b(f.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function b(D,f){return typeof D!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:D-f}async function p(D,f){const S=D.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(S!=="none"&&(await f.saveAll(),S==="allEditorsInActiveGroup")){const k=f.activeEditorPane;k&&k.input.resource?.scheme===A.Schemas.untitled&&await f.save({editor:k.input,groupId:k.group.id})}await D.reloadConfiguration()}const l=(D,f)=>!D||!f?D===f:D.name===f.name&&D.path===f.path&&D.sourceReference===f.sourceReference;e.$WG=l}),define(Pe[217],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.CellExecutionUpdateType=void 0;var T;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$9J=(0,I.$ii)("INotebookExecutionService")}),define(Pe[218],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhb=e.$Lhb=e.ProxyKernelState=e.$Khb=void 0,e.$Khb=100;var T;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(T||(e.ProxyKernelState=T={})),e.$Lhb=(0,I.$ii)("INotebookKernelService"),e.$Mhb=(0,I.$ii)("INotebookKernelHistoryService")}),define(Pe[219],Re([1,0,6,29,149,95]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OUb=void 0;class A extends I.$Uc{constructor(d,E,O){super(),this._source=d,this.b=E,this.c=O,this.a=void 0}f(d){const E=d.getLineCount();return new T.$ct(1,1,E,this.g(d,E))}g(d,E){if(E<1||E>d.getLineCount())throw new Error("Illegal value for lineNumber");return d.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const d=new R.$EC;d.acceptChunk(this._source);const E=d.finish(!0),{textBuffer:O,disposable:y}=E.create(1);this.b=O,this.B(y)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(d=>{const E=new R.$EC;E.acceptChunk(d);const O=E.finish(!0),{textBuffer:y,disposable:u}=O.create(1);return this.B(u),y})),this.a}findInInputs(d){const O=new N.$sC(d,!1,!1,null).parseSearchRequest();if(!O)return[];const y=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,O,!0,5e3)}findInOutputs(d){const O=new N.$sC(d,!1,!1,null).parseSearchRequest();return O?this.outputTextBuffers.map(y=>{const u=y.findMatchesLineByLine(this.f(y),O,!0,5e3);if(u.length!==0)return{textBuffer:y,matches:u}}).filter(y=>!!y):[]}}e.$OUb=A}),define(Pe[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(N){N.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var T;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class R{static fromExtHostTestItem(A,g,d=A.parent){if(A._isRoot)return new R([g]);const E=[A.id];for(let O=d;O&&O.id!==g;O=O.parent)E.push(O.id);return E.push(g),new R(E.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const g=A.indexOf("\0");return g===-1?A:A.slice(0,g)}static fromString(A){return new R(A.split("\0"))}static join(A,g){return new R([...A.path,g])}static joinToString(A,g){return A.toString()+"\0"+g}static parentId(A){const g=A.lastIndexOf("\0");return g===-1?void 0:A.slice(0,g)}static localId(A){const g=A.lastIndexOf("\0");return g===-1?A:A.slice(g+1)}static isChild(A,g){return g.startsWith(A)&&g[A.length]==="\0"}static compare(A,g){return A===g?0:R.isChild(A,g)?2:R.isChild(g,A)?3:1}constructor(A,g=A.length){if(this.path=A,this.d=g,A.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new R(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new R(this.path,A)}compare(A){if(typeof A=="string")return R.compare(this.toString(),A);for(let g=0;g<A.d&&g<this.d;g++)if(A.path[g]!==this.path[g])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$cL=R}),define(Pe[61],Re([1,0,2,93,29,49]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$kL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$jL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$iL=e.$hL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$gL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$fL=e.$eL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$dL=e.TestResultState=void 0;var A;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$dL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var g;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var d;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$eL=[2,4,8,16,32,64];const E=M=>"runId"in M;e.$fL=E;var O;(function(M){M.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),M.deserialize=(z,K)=>({range:R.$ct.lift(K.range),uri:z.asCanonicalUri(I.URI.revive(K.uri))})})(O||(e.IRichLocation=O={}));var y;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(M){M.serialize=z=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&O.serialize(z.location)}),M.deserialize=(z,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&O.deserialize(z,K.location)})})(u||(e.ITestErrorMessage=u={}));const w=(M,z)=>`${z?"s":"e"}${M}`;e.$gL=w;var m;(function(M){M.serialize=z=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&O.serialize(z.location)}),M.deserialize=(z,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&O.deserialize(z,K.location)})})(m||(e.ITestOutputMessage=m={}));var r;(function(M){M.serialize=z=>z.type===0?u.serialize(z):m.serialize(z),M.deserialize=(z,K)=>K.type===0?u.deserialize(z,K):m.deserialize(z,K)})(r||(e.ITestMessage=r={}));var o;(function(M){M.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),M.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(r.serialize)}),M.deserialize=(z,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>r.deserialize(z,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",n=(M,z)=>M+s+z;e.$hL=n;const i=M=>{const z=M.indexOf(s);return{ctrlId:M.slice(0,z),tagId:M.slice(z+1)}};e.$iL=i;var a;(function(M){M.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),M.deserialize=(z,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?z.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?R.$ct.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(a||(e.ITestItem=a={}));var h;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(M){M.serialize=z=>({expand:z.expand,item:a.serialize(z.item)}),M.deserialize=(z,K)=>({controllerId:N.$cL.root(K.item.extId),expand:K.expand,item:a.deserialize(z,K.item)})})(t||(e.InternalTestItem=t={}));var v;(function(M){M.serialize=z=>{let K;return z.item&&(K={},z.item.label!==void 0&&(K.label=z.item.label),z.item.tags!==void 0&&(K.tags=z.item.tags),z.item.busy!==void 0&&(K.busy=z.item.busy),z.item.uri!==void 0&&(K.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(K.range=z.item.range?.toJSON()),z.item.description!==void 0&&(K.description=z.item.description),z.item.error!==void 0&&(K.error=z.item.error),z.item.sortText!==void 0&&(K.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:K}},M.deserialize=z=>{let K;return z.item&&(K={},z.item.label!==void 0&&(K.label=z.item.label),z.item.tags!==void 0&&(K.tags=z.item.tags),z.item.busy!==void 0&&(K.busy=z.item.busy),z.item.range!==void 0&&(K.range=z.item.range?R.$ct.lift(z.item.range):null),z.item.description!==void 0&&(K.description=z.item.description),z.item.error!==void 0&&(K.error=z.item.error),z.item.sortText!==void 0&&(K.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:K}}})(v||(e.ITestItemUpdate=v={}));const c=(M,z)=>{z.expand!==void 0&&(M.expand=z.expand),z.item!==void 0&&(M.item=M.item?Object.assign(M.item,z.item):z.item)};e.$jL=c;var $;(function(M){M.serializeWithoutMessages=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(o.serializeWithoutMessages)}),M.serialize=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(o.serialize)}),M.deserialize=(z,K)=>({...t.deserialize(z,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>o.deserialize(z,ie)),retired:!0})})($||(e.TestResultItem=$={}));var b;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(z,K)=>{z.covered+=K.covered,z.total+=K.total}})(b||(e.ICoverageCount=b={}));var p;(function(M){M.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,uri:z.uri.toJSON()}),M.deserialize=(z,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:z.asCanonicalUri(I.URI.revive(K.uri))})})(p||(e.IFileCoverage=p={}));function l(M){return{...M,location:M.location?.toJSON()}}function D(M){return M.location=M.location?T.$bt.isIPosition(M.location)?T.$bt.lift(M.location):R.$ct.lift(M.location):void 0,M}e.$kL=3;var f;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(f||(e.DetailType=f={}));var S;(function(M){M.serialize=z=>z.type===0?P.serialize(z):C.serialize(z),M.deserialize=z=>z.type===0?P.deserialize(z):C.deserialize(z)})(S||(e.CoverageDetails=S={}));var k;(function(M){M.serialize=l,M.deserialize=D})(k||(e.IBranchCoverage=k={}));var P;(function(M){M.serialize=l,M.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var C;(function(M){M.serialize=z=>({...l(z),branches:z.branches?.map(k.serialize)}),M.deserialize=z=>({...D(z),branches:z.branches?.map(k.deserialize)})})(C||(e.IStatementCoverage=C={}));var q;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(q||(e.TestDiffOpType=q={}));var V;(function(M){M.deserialize=(z,K)=>K.op===0?{op:K.op,item:t.deserialize(z,K.item)}:K.op===1?{op:K.op,item:v.deserialize(K.item)}:K.op===2?{op:K.op,uri:z.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,M.serialize=z=>z.op===0?{op:z.op,item:t.serialize(z.item)}:z.op===1?{op:z.op,item:v.serialize(z.item)}:z})(V||(e.TestsDiffOp=V={}));class W{constructor(z){this.l=z,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(z){const K=this.w();for(const ie of z)switch(ie.op){case 0:this.o(t.deserialize(this.l,ie.item),K);break;case 1:this.p(v.deserialize(ie.item),K);break;case 3:this.q(ie.itemId,K);break;case 5:this.v(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.f.set(ie.tag.id,ie.tag);break;case 7:this.f.delete(ie.id);break}K.complete?.()}o(z,K){const ie=N.$cL.parentId(z.item.extId)?.toString();let fe;if(!ie)fe=this.x(z),this.h.add(fe),this.g.set(z.item.extId,fe);else if(this.g.has(ie)){const De=this.g.get(ie);De.children.add(z.item.extId),fe=this.x(z,De),this.g.set(z.item.extId,fe)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return K.add?.(fe),z.expand===2&&this.j++,fe}p(z,K){const ie=this.g.get(z.extId);if(ie)return z.expand!==void 0&&(ie.expand===2&&this.j--,z.expand===2&&this.j++),(0,e.$jL)(ie,z),K.update?.(ie),ie}q(z,K){const ie=this.g.get(z);if(!ie)return;const fe=N.$cL.parentId(ie.item.extId)?.toString();fe?this.g.get(fe).children.delete(ie.item.extId):this.h.delete(ie);const De=[[z]];for(;De.length;)for(const ye of De.pop()){const oe=this.g.get(ye);oe&&(De.push(oe.children),this.g.delete(ye),K.remove?.(oe,oe!==ie),oe.expand===2&&this.j--)}}v(z){}updatePendingRoots(z){this.k+=z}w(){return{}}}e.$lL=W}),define(Pe[75],Re([1,0,11,5,6,56,61,49]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.TestItemEventOp=void 0;var d;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(d||(e.TestItemEventOp=d={}));const E=(n,i)=>n===i,y=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(a=>!i.includes(a)))}),u=(n,i)=>{let a;for(const[h,t]of y)t(n[h],i[h])||(a?a[h]=i[h]:a={[h]:i[h]});return a};class w extends R.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new I.$uh(()=>this.flushDiff(),200)),this.g=this.B(new T.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,A.$jL)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,A.$jL)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,a-1):t.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(g.$cL.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const h of a.ops)this.w(i,h);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$0c)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const h=g.$cL.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(v.fullId.toString(),v),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:v.expand,item:this.s.toITestItem(i)}}),this.I(i,v,a);return}if(v.actual===i){this.H(i,v,a);return}if(v.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,a);const c=this.s.getChildren(v.actual),$=v.actual,b=u(this.s.toITestItem($),this.s.toITestItem(i));this.s.getApiFor($).listener=void 0,v.actual=i,v.expand=0,b&&(b.hasOwnProperty("tags")&&(this.C(i.tags,$.tags,h.toString()),delete b.tags),this.w(v,{op:4,update:b})),this.I(i,v,a);for(const[p,l]of c)this.s.getChildren(i).get(l.id)||this.O(g.$cL.joinToString(h,l.id));this.y(v.actual.uri)}C(i,a,h){const t=new Set(a.map(v=>v.id));for(const v of i)t.delete(v.id)||this.D(v);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(v=>(0,A.$hL)(this.s.controllerId,v.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$hL)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,A.$hL)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=v=>this.w(a,v),this.J(a)}I(i,a,h){this.H(i,a,h);for(const[t,v]of this.s.getChildren(i))this.z(v,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const h=[];for(const[t,v]of this.s.getChildren(i.actual)){const c=this.expand(g.$cL.joinToString(i.fullId,v.id),a);(0,I.$7g)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const v=new I.$hh;return v.open(),v}i.expand=2,this.N(i);const a=i.resolveBarrier=new I.$hh,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,v)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(v){h(v)}return(0,I.$7g)(t)?t.catch(h).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[a];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const v of t.actual.tags)this.F(v.id);this.tree.delete(t.fullId.toString());for(const[v,c]of this.s.getChildren(t.actual))h.push(this.tree.get(g.$cL.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$BO=w;class m extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$CO=m;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$DO=r;class o extends Error{constructor(i,a,h){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$EO=o;const s=(n,i,a)=>{let h=new Map;return{get size(){return h.size},forEach(t,v){for(const c of h.values())t.call(v,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const v=new Map,c=new Set(h.keys()),$={op:5,ops:[]};for(const b of t){if(!(b instanceof a))throw new r(b.id);const p=i(b).controllerId;if(p!==n.controllerId)throw new o(b.id,p,n.controllerId);if(v.has(b.id))throw new m(b.id);v.set(b.id,b),c.delete(b.id),$.ops.push({op:0,item:b})}for(const b of c.keys())$.ops.push({op:3,id:b});n.listener?.($),h=v},add(t){if(!(t instanceof a))throw new r(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$FO=s}),define(Pe[105],Re([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=void 0;const T=new WeakMap,R=(A,g)=>{const d={controllerId:g};return T.set(A,d),d};e.$GO=R;const N=A=>{const g=T.get(A);if(!g)throw new I.$DO(A?.id||"<unknown>");return g};e.$HO=N}),define(Pe[76],Re([1,0,12,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jzb=e.$izb=e.$hzb=void 0,e.$kzb=R,e.$lzb=A,e.$hzb="vscode-cdn.net",e.$izb=`vscode-resource.${e.$hzb}`,e.$jzb=`'self' https://*.${e.$hzb}`;function R(g,d){return g.scheme===I.Schemas.http||g.scheme===I.Schemas.https?g:(d&&d.authority&&d.isRemote&&g.scheme===I.Schemas.file&&(g=T.URI.from({scheme:I.Schemas.vscodeRemote,authority:d.authority,path:g.path})),T.URI.from({scheme:I.Schemas.https,authority:`${g.scheme}+${N(g.authority)}.${e.$izb}`,path:g.path,fragment:g.fragment,query:g.query}))}function N(g){return g.replace(/./g,d=>{const E=d.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?d:"-"+E.toString(16).padStart(4,"0")})}function A(g){return g.replace(/-([0-9a-f]{4})/g,(d,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Pe[220],Re([1,0,5,6,76]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class N{constructor(g,d,E){this.d=g,this.e=d,this.f=E,this.a=0,this.b=new T.$Tc,this.c=new Map,this.b.add(d.onDidChangeVisibleTextEditors(()=>{const O=d.getVisibleTextEditors();for(const y of this.c.values())O.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,d,E,O,y){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===g){u=i;break}if(!u)throw new Error("not a visible editor");const w=this,m=this.a++,r=new I.$7d,o=new I.$7d,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,R.$kzb)(i,w.f)}get cspSource(){return R.$jzb}set options(i){this.b=i,w.d.$setOptions(m,i)}get options(){return this.b}set html(i){this.a=i,w.d.$setHtml(m,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return w.d.$postMessage(m,i)}},n=new class{constructor(){this.editor=g,this.line=d,this.height=E,this.webview=s,this.onDidDispose=o.event}dispose(){w.c.has(m)&&(w.c.delete(m),w.d.$disposeEditorInset(m),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(m,u.id,u.value.document.uri,d+1,E,O||{},y.identifier,y.extensionLocation),this.c.set(m,{editor:g,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(g){const d=this.c.get(g);d&&d.inset.dispose()}$onDidReceiveMessage(g,d){this.c.get(g)?.onDidReceiveMessage.fire(d)}}e.$yjc=N}),define(Pe[106],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uL=e.$tL=e.$sL=void 0,e.$sL="__",e.$tL=(0,I.$ii)("IAuthenticationService"),e.$uL=(0,I.$ii)("IAuthenticationExtensionsService")}),define(Pe[221],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.VariableKind=e.$xP=void 0,e.$xP=(0,I.$ii)("configurationResolverService");var T;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class R extends Error{constructor(A,g){super(g),this.variable=A}}e.$yP=R}),define(Pe[222],Re([1,0,19,73,17,26,21,96,183,221,15]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,m,r,o){this.h=new Map,this.a=w,this.b=m,this.g=r,o&&(this.c=o.then(s=>this.i(s)))}i(w){if(A.$i){const m=Object.create(null);return Object.keys(w).forEach(r=>{m[r.toLowerCase()]=w[r]}),m}return w}resolveWithEnvironment(w,m,r){return this.l({env:this.i(w),userHome:void 0},m?m.uri:void 0,r)}async resolveAsync(w,m){const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,m)}async j(w,m,r,o){const s=N.$On(m);A.$i&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):A.$j&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):A.$k&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,w?w.uri:void 0,s,r,o)}async resolveAnyAsync(w,m,r){return this.j(w,m,r)}async resolveAnyMap(w,m,r){const o=new Map;return{newConfig:await this.j(w,m,r,o),resolvedVariables:o}}resolveWithInteractionReplace(w,m,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,m,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,m){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,m)}async l(w,m,r,o,s){if(R.$Vf(r))return this.m(w,m,r,o,s);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(w,m,n,o,s)));if(R.$Xf(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async a=>[await this.m(w,m,a,o,s),await this.l(w,m,r[a],o,s)]));for(const[a,h]of i)n[a]=h;return n}return r}m(w,m,r,o,s){return(0,O.$df)(r,y.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(y.VARIABLE_LHS))return n;let a=await this.o(w,n,i,m,o);return s?.set(i,a),a!==n&&R.$Vf(a)&&a.match(y.VARIABLE_REGEXP)&&(a=await this.m(w,m,a,o,s)),a})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,m,r,o,s){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const a=v=>{const c=this.a.getFilePath();if(c)return(0,g.$hw)(c);throw new E.$yP(v,(0,d.localize)(0,null,m))},h=v=>{const c=a(v);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,g.$hw)($)}throw new E.$yP(v,(0,d.localize)(1,null,m,I.$oc(c)))},t=v=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new E.$yP(v,(0,d.localize)(2,null,m,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new E.$yP(v,(0,d.localize)(3,null,m)):new E.$yP(v,(0,d.localize)(4,null,m))};switch(r){case"env":if(n){if(w.env){const v=w.env[A.$i?n.toLowerCase():n];if(R.$Vf(v))return v}return""}throw new E.$yP(E.VariableKind.Env,(0,d.localize)(5,null,m));case"config":if(n){const v=this.a.getConfigurationValue(o,n);if(R.$5f(v))throw new E.$yP(E.VariableKind.Config,(0,d.localize)(6,null,m,n));if(R.$Xf(v))throw new E.$yP(E.VariableKind.Config,(0,d.localize)(7,null,m,n));return v}throw new E.$yP(E.VariableKind.Config,(0,d.localize)(8,null,m));case"command":return this.p(E.VariableKind.Command,m,n,s,"command");case"input":return this.p(E.VariableKind.Input,m,n,s,"input");case"extensionInstallFolder":if(n){const v=await this.a.getExtension(n);if(!v)throw new E.$yP(E.VariableKind.ExtensionInstallFolder,(0,d.localize)(9,null,m,n));return this.n(v.extensionLocation)}throw new E.$yP(E.VariableKind.ExtensionInstallFolder,(0,d.localize)(10,null,m));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,g.$hw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,g.$hw)(this.n(t(E.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$hw)(I.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new E.$yP(E.VariableKind.UserHome,(0,d.localize)(11,null,m))}case"lineNumber":{const v=this.a.getLineNumber();if(v)return v;throw new E.$yP(E.VariableKind.LineNumber,(0,d.localize)(12,null,m))}case"selectedText":{const v=this.a.getSelectedText();if(v)return v;throw new E.$yP(E.VariableKind.SelectedText,(0,d.localize)(13,null,m))}case"file":return a(E.VariableKind.File);case"fileWorkspaceFolder":return h(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?I.$mc(this.n(t(E.VariableKind.RelativeFile)),a(E.VariableKind.RelativeFile)):a(E.VariableKind.RelativeFile);case"relativeFileDirname":{const v=I.$nc(a(E.VariableKind.RelativeFileDirname));if(o||n){const c=I.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),v);return c.length===0?".":c}return v}case"fileDirname":return I.$nc(a(E.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(E.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const v=I.$oc(a(E.VariableKind.FileBasenameNoExtension));return v.slice(0,v.length-I.$pc(v).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(E.VariableKind.FileDirnameBasename)));case"execPath":{const v=this.a.getExecPath();return v||m}case"execInstallFolder":{const v=this.a.getAppRoot();return v||m}case"pathSeparator":case"/":return I.sep;default:try{const v=n?`${r}:${n}`:r;return this.p(E.VariableKind.Unknown,m,v,s,void 0)}catch{return m}}}}p(w,m,r,o,s){if(r&&o){const n=s===void 0?o[r]:o[s+":"+r];if(typeof n=="string")return n;throw new E.$yP(w,(0,d.localize)(14,null,m))}return m}}e.$NP=y}),define(Pe[107],Re([1,0,3,104]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$AD=void 0,e.$BD=E,e.$CD=u,e.$DD=w,e.$AD=(0,I.$ii)("editorGroupsService");var R;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var N;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var A;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var g;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var d;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(d||(e.MergeGroupMode=d={}));function E(m){const r=m;return(0,T.$lF)(r?.editor)&&(0,T.$lF)(r?.replacement)}var O;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(m){const r=m;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function w(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Pe[223],Re([1,0,3,107]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HD=e.$GD=e.$FD=e.$ED=void 0,e.$ID=R,e.$ED=(0,I.$ii)("editorService"),e.$FD=-1,e.$GD=-2,e.$HD=-3;function R(N){const A=N;return typeof N=="number"||(0,T.$CD)(A)}}),define(Pe[224],Re([1,0,3,190]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$NL=(0,I.$ji)(T.$pi)}),define(Pe[108],Re([1,0,20,5,19,6,11]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=e.$a$b=e.$_0b=e.$$0b=e.$00b=void 0;class g{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$00b=g;class d{static isHostExtension(n,i,a){if(i.getExtensionDescription(n))return!1;const h=a.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,i){this.j=n,this.c=new T.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new I.$Fm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=o(this.e,i),this.e=this.e.concat(n);const a=d.l(this.e);return this.e=o(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new g(this.d,a)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,$){this.addNode(c),this.addNode($),this.c.has(c)?this.c.get(c).push($):this.c.set(c,[$])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,$){const b=i.getArcs(c);for(let p=0;p<b.length;p++)if(!$.has(b[p]))return!1;return!0}getNodes(){return this.e}},a=new I.$Fm;for(const c of n)if(a.set(c.identifier,c),c.extensionDependencies)for(const $ of c.extensionDependencies)i.addArc(I.$Dm.toKey(c.identifier),I.$Dm.toKey($));const h=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>h.add(c));const t=i.getNodes().filter(c=>!h.has(c));let v;do{v=!1;for(let c=0;c<t.length;c++){const $=t[c];i.hasOnlyGoodArcs($,h)&&(t.splice(c,1),c--,h.add($),v=!0)}}while(v);return t.map(c=>a.get(c))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$$0b=d;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$_0b=E;class O{constructor(n){this.d=new w,this.c=new d(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new y(this,i)}deltaExtensions(n,i,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$a$b=O;class y extends N.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$b$b=y;class u{constructor(n){this.name=n;const i=(0,A.$bh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class w{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new u(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};n.resolve((0,N.$Sc)(h))}}var m;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(m||(m={}));function r(s,n){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==a)return i-a;const h=R.$hc.basename(s.extensionLocation.path),t=R.$hc.basename(n.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,n){const i=new I.$Em(n);return s.filter(a=>!i.has(a.identifier))}}),define(Pe[77],Re([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Lm=A,e.$Mm=g;var T;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(T||(e.UIKind=T={}));var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var N;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function A(E){const O=I.$ue.alloc(1);switch(E){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}function g(E,O){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}var d;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(d||(e.NativeLogMarkers=d={}))}),define(Pe[62],Re([1,0,3,5,13,27,77,58,59,26,2,6,171]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$4O=e.$3O=void 0,e.$5O=r;let w=class extends y.$Uc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new T.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=O.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:d.$9o,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,R.$Qj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,i){const a=this.getTelemetryDetails(),h=new m(n,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,n,i){this.f=s,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,g.$um)((0,d.$cp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((i,a)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let h=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$3O=w,e.$3O=w=Je([qe(0,N.$2O),qe(1,R.$Pj)],w);class m{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,i,a,h,t,v){this.g=i,this.h=a,this.i=h,this.j=t,this.a=new T.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,d.$fp)(n,[]),this.c&&(n=(0,E.$Rn)(n,this.c)),this.b||(n=(0,E.$Rn)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,d.$fp)(i,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$4O=m;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$6O=(0,I.$ii)("IExtHostTelemetry")}),define(Pe[25],Re([1,0,5,2,199,103,20,3]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hG=e.ActivationKind=e.$eG=e.$dG=e.$aG=e.ExtensionHostStartup=e.$_F=e.$$F=e.$0F=e.$9F=void 0,e.$bG=u,e.$cG=w,e.$fG=s,e.$gG=n,e.$9F=Object.freeze({identifier:new A.$Dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$0F="extensions.webWorker",e.$$F=(0,g.$ii)("extensionService");class d{constructor(h){this.dependency=h}}e.$_F=d;var E;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class O{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,v){this.c=h,this.d=t.slice(0),this.e=v.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$TF.createActivationEventsMap(this.d)}}set(h,t,v){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],$=[],b=[],p=[],l=y(this.d),D=y(t),f=(q,V)=>q.extensionLocation.toString()===V.extensionLocation.toString()||q.isBuiltin===V.isBuiltin||q.isUserBuiltin===V.isUserBuiltin||q.isUnderDevelopment===V.isUnderDevelopment;for(const q of this.d){const V=D.get(q.identifier);if(!V){c.push(q.identifier),l.delete(q.identifier);continue}if(!f(q,V)){c.push(q.identifier),l.delete(q.identifier);continue}}for(const q of t){const V=l.get(q.identifier);if(!V){$.push(q);continue}if(!f(V,q)){c.push(V.identifier),l.delete(V.identifier);continue}}const S=new A.$Em(this.e),k=new A.$Em(v);for(const q of this.e)k.has(q)||b.push(q);for(const q of v)S.has(q)||p.push(q);const P=N.$TF.createActivationEventsMap($),C={versionId:h,toRemove:c,toAdd:$,addActivationEvents:P,myToRemove:b,myToAdd:p};return this.delta(C),C}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:v,myToRemove:c,myToAdd:$}=h,b=new A.$Em(t),p=new A.$Em(c);for(let l=0;l<this.d.length;l++)b.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)p.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of v)this.d.push(l);for(const l of $)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(A.$Dm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const v=N.$TF.readActivationEvents(t);for(const c of v)h.add(c)}return h}}e.$aG=O;function y(a){const h=new A.$Fm;for(const t of a)h.set(t.identifier,t);return h}function u(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}function w(a,h){if(!u(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class m{constructor(h,t,v,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=v,this.activationReason=c}}e.$dG=m;class r{constructor(h,t){this.description=h,this.value=t}}e.$eG=r;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,R.$lp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function n(a,h){return{identifier:new A.$Dm((0,R.$jp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$hG=i}),define(Pe[225],Re([1,0,14,108,20,25,13,11]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=e.$Yjc=e.$Xjc=e.$Wjc=e.$Vjc=e.$Ujc=void 0;class d{static{this.NONE=new d(!1,-1,-1,-1)}constructor(s,n,i,a){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=a}}e.$Ujc=d;class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new d(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Vjc=E;class O{constructor(s,n,i,a,h,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=i,this.module=a,this.exports=h,this.subscriptions=t}}e.$Wjc=O;class y extends O{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xjc=y;class u extends O{constructor(){super(!1,null,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Yjc=u;class w extends O{constructor(s){super(!0,s,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(s,n,i,a){this.g=a,this.a=s,this.b=n,this.c=i,this.d=new R.$Fm,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(s){const n=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new w(h));return this.c.onExtensionActivationError(s.id,h,new N.$_F(s.id.value)),t}const i=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of a){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const v=this.a.getExtensionDescription(h);if(v){if(!v.main&&!v.browser)continue;i.push(this.j({id:v.identifier,reason:s.reason}));continue}const c=n.displayName||n.identifier.value,$=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),b=this.k(s,n.displayName,[],new w($));return this.c.onExtensionActivationError(n.identifier,$,new N.$_F(h)),b}return this.k(s,n.displayName,i,null)}k(s,n,i,a){const h=new r(s.id,n,s.reason,i,a,this.c,this.g);return this.d.set(s.id,h),h}l(s){return T.$$0b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$Zjc=m,e.$Zjc=m=Je([qe(3,A.$Oj)],m);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,i,a,h,t,v){this.c=s,this.d=n,this.f=i,this.g=a,this.h=h,this.j=t,this.k=v,this.a=new g.$hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new w(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new w(n),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([qe(6,A.$Oj)],r)}),define(Pe[226],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Re([1,0,185,14,32,98,72,30,20,226,195,103]),function(ge,e,I,T,R,N,A,g,d,E,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=void 0;const u=g.$1n.as(A.$2n.JSONContribution);class w{constructor(h,t,v){this.a=h,this.b=t,this.c=v}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(R.default.Error,h)}warn(h){this.d(R.default.Warning,h)}info(h){this.d(R.default.Info,h)}}e.$3F=w;class m{static a(h){const t=new d.$Em;for(let v=0,c=h.length;v<c;v++)t.add(h[v].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new m(t,[]);if(!t||!t.length)return new m([],h);const v=this.a(h),c=this.a(t),$=t.filter(p=>!v.has(p.description.identifier)),b=h.filter(p=>!c.has(p.description.identifier));return new m($,b)}constructor(h,t){this.added=h,this.removed=t}}e.$4F=m;class r{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=m.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$5F=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$6F={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:d.$Cm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Fo}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Fo}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&y.$TF.register(h.extensionPoint,h.activationEventsGenerator),e.$6F.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(s,e.$6F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$7F=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};g.$1n.add(i.ExtensionsRegistry,new n),e.$8F=g.$1n.as(i.ExtensionsRegistry),u.registerSchema(s,e.$6F),u.registerSchema(O.$9j,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Pe[228],Re([1,0,181,17,26,227,33,5]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xH=void 0;const d={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var E;(function(u){function w(m,r,o){if(!m)return;const s=T.$Vf(m.type)?m.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const n=[];if(Array.isArray(m.required))for(const i of m.required)T.$Vf(i)&&n.push(i);return{extensionId:r.value,taskType:s,required:n,properties:m.properties?R.$On(m.properties):{},when:m.when?A.$gj.deserialize(m.when):void 0}}u.from=w})(E||(E={}));const O=N.$8F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,w)=>{for(const m of u)m.type&&w.push(`onTaskType:${m.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:d}});class y{constructor(){this.d=new g.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,m)=>{O.setHandler((r,o)=>{this.c=void 0;try{for(const s of o.removed){const n=s.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const n=s.value;for(const i of n){const a=E.from(i,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const m of this.all()){const r={type:"object",additionalProperties:!1};m.required.length>0&&(r.required=m.required.slice(0)),m.properties!==void 0?r.properties=R.$On(m.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[m.taskType]},w.push(r)}this.c={oneOf:w}}return this.c}}e.$xH=new y}),define(Pe[229],Re([1,0,182,17,23,26,33,228]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HH=e.JsonSchemaVersion=e.ExecutionEngine=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BH=e.ShellQuoting=e.$AH=e.$zH=e.$yH=void 0,e.$yH="settings",e.$zH=new A.$zj("taskRunning",!1,I.localize(0,null)),e.$AH=I.localize2(2,"Tasks");var d;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(d||(e.ShellQuoting=d={})),e.$BH="$customized",function(M){function z(K){if(!K)return M.Strong;switch(K.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=z}(d||(e.ShellQuoting=d={}));var E;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var O;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(O||(e.RevealKind=O={})),function(M){function z(K){switch(K.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=z}(O||(e.RevealKind=O={}));var y;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(M){function z(K){switch(K.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=z}(y||(e.RevealProblemKind=y={}));var u;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(u||(e.PanelKind=u={})),function(M){function z(K){switch(K.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=z}(u||(e.PanelKind=u={}));var w;(function(M){M.defaults={echo:!0,reveal:O.Always,revealProblems:y.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var m;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(M){function z(ie){switch(ie.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=z;function K(ie){switch(ie){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=K}(m||(e.RuntimeType=m={}));var r;(function(M){function z(K){return T.$Vf(K)?K:K.value}M.value=z})(r||(e.CommandString=r={}));var o;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function z(ie){return ie===M.Clean._id||ie===M.Build._id||ie===M.Rebuild._id||ie===M.Test._id}M.is=z;function K(ie){if(ie!==void 0)return T.$Vf(ie)?z(ie)?{_id:ie,isDefault:!1}:void 0:ie}M.from=K})(o||(e.TaskGroup=o={}));var s;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function z(K){switch(K){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=z})(n||(e.TaskSourceKind=n={}));var i;(function(M){M.parallel="parallel",M.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(z,K,ie,fe,De,ye){this._label="",this._id=z,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=fe,this.configurationProperties=De,this._source=ye}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,K=!1){if(z===void 0)return!1;if(T.$Vf(z))return z===this._label||z===this.configurationProperties.identifier||K&&z===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$CH=t;class v extends t{constructor(z,K,ie,fe,De,ye,oe,$e){super(z,ie,void 0,oe,$e,K),this.command={},this._source=K,this.hasDefinedMatchers=ye,De&&(this.command=De)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(z){return z instanceof v}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$yH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.d();if(!z)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$BH,folder:z,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$Sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new v(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$DH=v;class c extends t{constructor(z,K,ie,fe,De,ye,oe){super(z,ie,fe,ye,oe,K),this._source=K,this.configures=De}static is(z){return z instanceof c}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$Sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$yH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.d();if(!z)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$BH,folder:z,id:K};return JSON.stringify(ie)}}e.$EH=c;class $ extends t{constructor(z,K,ie,fe,De,ye,oe,$e,ne){super(z,ie,fe,$e,ne,K),this.defines=De,this.hasDefinedMatchers=oe,this.command=ye,this.icon=ne.icon,this.hide=ne.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof $}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new $(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$FH=$;class b extends t{constructor(z,K,ie,fe,De,ye){super(z,ie,fe,De,ye,K),this._source=K}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new b(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$GH=b;var p;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(M){M._default=M.Terminal}(p||(e.ExecutionEngine=p={}));var l;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class D{constructor(z){this.c=new Map;for(let K=0;K<z.length;K++)this.c.set(z[K].uri.toString(),K)}compare(z,K){const ie=z.getWorkspaceFolder(),fe=K.getWorkspaceFolder();if(ie&&fe){let De=this.c.get(ie.uri.toString());De=De===void 0?0:De+1;let ye=this.c.get(fe.uri.toString());return ye=ye===void 0?0:ye+1,De===ye?z._label.localeCompare(K._label):De-ye}else return!ie&&fe?-1:ie&&!fe?1:0}}e.$HH=D;var f;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(f||(e.TaskEventKind=f={}));var S;(function(M){M.SingleRun="singleRun",M.Background="background"})(S||(e.TaskRunType=S={}));var k;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(M){function z($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function K($e,ne,Se){return{...z($e),kind:"start",terminalId:ne,resolvedVariables:Se}}M.start=K;function ie($e,ne,Se){return{...z($e),kind:"processStarted",terminalId:ne,processId:Se}}M.processStarted=ie;function fe($e,ne,Se){return{...z($e),kind:"processEnded",terminalId:ne,exitCode:Se}}M.processEnded=fe;function De($e,ne,Se){return{...z($e),kind:"terminated",exitReason:Se,terminalId:ne}}M.terminated=De;function ye($e,ne,Se){return{...z(ne),kind:$e,terminalId:Se}}M.general=ye;function oe(){return{kind:"changed"}}M.changed=oe})(P||(e.TaskEvent=P={}));var C;(function(M){function z(ie){const fe=Object.keys(ie).sort();let De="";for(const ye of fe){let oe=ie[ye];oe instanceof Object?oe=z(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),De+=ye+","+oe+","}return De}function K(ie){const De={_key:z(ie),type:ie.taskType};return Object.assign(De,ie),De}M.create=K})(C||(e.KeyedTaskIdentifier=C={}));var q;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(q||(e.TaskSettingId=q={}));var V;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var W;(function(M){function z(K,ie){const fe=g.$xH.get(K.type);if(fe===void 0){const $e=N.$On(K);return delete $e._key,C.create($e)}const De=Object.create(null);De.type=fe.taskType;const ye=new Set;fe.required.forEach($e=>ye.add($e));const oe=fe.properties;for(const $e of Object.keys(oe)){const ne=K[$e];if(ne!=null)De[$e]=ne;else if(ye.has($e)){const Se=oe[$e];if(Se.default!==void 0)De[$e]=N.$On(Se.default);else switch(Se.type){case"boolean":De[$e]=!1;break;case"number":case"integer":De[$e]=0;break;case"string":De[$e]="";break;default:ie.error(I.localize(1,null,JSON.stringify(K,void 0,0),$e));return}}}return C.create(De)}M.createTaskIdentifier=z})(W||(e.TaskDefinition=W={}))}),define(Pe[230],Re([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=e.$c$b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,g)=>{this.b=A,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,I.$1)(A))}then(A,g){return this.j().then(A,g)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$c$b=T;class R extends T{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$d$b=R}),define(Pe[50],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$bw=void 0,e.$cw=R,e.$dw=N;class I{static{this.count=0}constructor(d){this._proxyIdentifierBrand=void 0,this.sid=d,this.nid=++I.count}}e.$bw=I;const T=[];function R(g){const d=new I(g);return T[d.nid]=d,d}function N(g){return T[g].sid}class A{constructor(d){this.value=d}}e.$ew=A}),define(Pe[4],Re([1,0,50]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$pM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var R;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var g;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var d;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(d||(e.CellOutputKind=d={}));var E;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var O;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(O||(e.CandidatePortSource=O={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$pM=y;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var w;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var m;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$qM={MainThreadAuthentication:(0,I.$cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$cw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$cw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$cw)("MainThreadClipboard"),MainThreadCommands:(0,I.$cw)("MainThreadCommands"),MainThreadComments:(0,I.$cw)("MainThreadComments"),MainThreadConfiguration:(0,I.$cw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$cw)("MainThreadConsole"),MainThreadDebugService:(0,I.$cw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$cw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$cw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$cw)("MainThreadLanguages"),MainThreadLogger:(0,I.$cw)("MainThreadLogger"),MainThreadMessageService:(0,I.$cw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$cw)("MainThreadOutputService"),MainThreadProgress:(0,I.$cw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$cw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$cw)("MainThreadSecretState"),MainThreadStorage:(0,I.$cw)("MainThreadStorage"),MainThreadSpeech:(0,I.$cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$cw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$cw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$cw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$cw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$cw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$cw)("MainThreadSCM"),MainThreadSearch:(0,I.$cw)("MainThreadSearch"),MainThreadShare:(0,I.$cw)("MainThreadShare"),MainThreadTask:(0,I.$cw)("MainThreadTask"),MainThreadWindow:(0,I.$cw)("MainThreadWindow"),MainThreadLabelService:(0,I.$cw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$cw)("MainThreadInteractive"),MainThreadChat:(0,I.$cw)("MainThreadChat"),MainThreadInlineChat:(0,I.$cw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$cw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$cw)("MainThreadTimeline"),MainThreadTesting:(0,I.$cw)("MainThreadTesting"),MainThreadLocalization:(0,I.$cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$cw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$cw)("MainThreadIssueReporter")},e.$rM={ExtHostCommands:(0,I.$cw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$cw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$cw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$cw)("ExtHostStatusBar"),ExtHostShare:(0,I.$cw)("ExtHostShare"),ExtHostExtensionService:(0,I.$cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$cw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$cw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$cw)("ExtHostSCM"),ExtHostSearch:(0,I.$cw)("ExtHostSearch"),ExtHostTask:(0,I.$cw)("ExtHostTask"),ExtHostWorkspace:(0,I.$cw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$cw)("ExtHostWindow"),ExtHostWebviews:(0,I.$cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$cw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$cw)("ExtHostProgress"),ExtHostComments:(0,I.$cw)("ExtHostComments"),ExtHostSecretState:(0,I.$cw)("ExtHostSecretState"),ExtHostStorage:(0,I.$cw)("ExtHostStorage"),ExtHostUrls:(0,I.$cw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$cw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$cw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$cw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$cw)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$cw)("ExtHostChat"),ExtHostChatAgents2:(0,I.$cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$cw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$cw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$cw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$cw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$cw)("ExtHostTimeline"),ExtHostTesting:(0,I.$cw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$cw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$cw)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$cw)("ExtHostIssueReporter")}}),define(Pe[78],Re([1,0,3,13,4,16]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=e.$fjc=e.$ejc=void 0,e.$ejc=(0,I.$ii)("IExtHostApiDeprecationService");let A=class{constructor(d,E){this.c=E,this.a=new Set,this.b=d.getProxy(R.$qM.MainThreadTelemetry)}report(d,E,O){const y=this.d(d,E);this.a.has(y)||(this.a.add(y),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${d}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:d}))}d(d,E){return`${d}-${E.identifier.value}`}};e.$fjc=A,e.$fjc=A=Je([qe(0,N.$LO),qe(1,T.$Oj)],A),e.$gjc=Object.freeze(new class{report(g,d,E){}})}),define(Pe[231],Re([1,0,39,6,4]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0;class N{static{this.a=0}constructor(d,E){this.extension=d,this.provider=E,this.handle=N.a++}}class A{static{this.a=0}constructor(d){this.b=new Map,this.c=new Map,this.d=d.getProxy(R.$qM.MainThreadChat)}registerChatProvider(d,E,O){const y=new N(d,O);return this.b.set(y.handle,y),this.d.$registerChatProvider(y.handle,E),(0,T.$Sc)(()=>{this.d.$unregisterChatProvider(y.handle),this.b.delete(y.handle)})}transferChatSession(d,E){const O=I.Iterable.find(this.c.keys(),y=>this.c.get(y)===d)??0;typeof O=="number"&&this.d.$transferChatSession(O,E)}async $prepareChat(d,E){const O=this.b.get(d);if(!O)return;const y=await O.provider.prepareSession(E);if(!y)return;const u=A.a++;return this.c.set(u,y),{id:u}}$releaseSession(d){this.c.delete(d)}}e.$rjc=A}),define(Pe[232],Re([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class T{constructor(N){const A=N.getProxy(I.$qM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(g){return A.$writeText(g)}})}}e.$wjc=T}),define(Pe[233],Re([1,0,26,4,27,16]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;let A=class{constructor(O,y){this.a=O.getProxy(T.$qM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(O,y){const u=this,w=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){u.e(O,y,w,arguments)}})}e(O,y,u,w){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:d(w,this.b)}),this.c&&this.f(O,u,w)}};e.$plc=A,e.$plc=A=Je([qe(0,N.$LO),qe(1,R.$2O)],A);const g=1e5;function d(E,O){const y=[];if(E.length)for(let u=0;u<E.length;u++){let w=E[u];if(typeof w>"u")w="undefined";else if(w instanceof Error){const m=w;m.stack?w=m.stack:w=m.toString()}y.push(w)}if(O){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$Tn)(y);return u.length>g?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[234],Re([1,0,2,4,25]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;class N{constructor(g){this.a=g.getProxy(T.$qM.MainThreadDialogs)}showOpenDialog(g,d){return d?.allowUIResources&&(0,R.$cG)(g,"showLocal"),this.a.$showOpenDialog(d).then(E=>E?E.map(O=>I.URI.revive(O)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(d=>d?I.URI.revive(d):void 0)}}e.$rkc=N}),define(Pe[235],Re([1,0,6,4]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;class R{constructor(A){this.b=0,this.a=A.getProxy(T.$qM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,A),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$Mkc=R}),define(Pe[79],Re([1,0,21,15,2,3,13,4,27,16]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=e.$_jc=void 0;let O=class{constructor(u,w,m){this.f=m,this.d=new Map,this.a=w.getProxy(g.$qM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,w){const{message:m,args:r,comment:o}=w;if(this.c)return(0,T.$We)(m,r??{});let s=m;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(u)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,T.$We)(n??m,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let w;const m=await this.g(u);if(!m){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(m),o=JSON.parse(r);w=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${m}: ${r.message}`);return}w&&this.d.set(u.identifier.value,{contents:w,uri:m})}async g(u){if(u.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return R.URI.revive(w)}return u.l10n?R.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$_jc=O,e.$_jc=O=Je([qe(0,d.$2O),qe(1,E.$LO),qe(2,A.$Oj)],O),e.$akc=(0,N.$ii)("IExtHostLocalizationService")}),define(Pe[236],Re([1,0,13,4,27,16,2,53]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=void 0;let d=class extends I.$Zj{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(w=>(0,g.$Rh)(w))),this.r=y.getProxy(T.$qM.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(A.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,w){return new E(this.r,y,u,w)}};e.$olc=d,e.$olc=d=Je([qe(0,N.$LO),qe(1,R.$2O)],d);class E extends I.$Uj{constructor(y,u,w,m){super(m?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(u,m).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const w=[[y,u]];this.m?this.u(w):this.n.push(...w)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Pe[80],Re([1,0,4,3,6,16,22]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0,e.$bkc=(0,T.$ii)("IExtHostManagedSockets");let g=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(I.$qM.MainThreadManagedSockets)}setFactory(y,u){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new d(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,w=await this.c.makeConnection(),m=new R.$Tc;return this.d.set(u,new E(u,w,m)),m.add((0,R.$Sc)(()=>this.d.delete(u))),m.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),m.dispose()})),m.add(w.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),m.dispose()})),m.add(w.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,A.$ue.wrap(r)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$ckc=g,e.$ckc=g=Je([qe(0,N.$LO)],g);class d{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class E extends R.$Uc{constructor(y,u,w){super(),this.socketId=y,this.actual=u,this.B(w)}}}),define(Pe[237],Re([1,0,4,13,25]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=void 0;function N(g){return g&&g.title}let A=class{constructor(d,E){this.b=E,this.a=d.getProxy(I.$qM.MainThreadMessageService)}showMessage(d,E,O,y,u){const w={source:{identifier:d.identifier,label:d.displayName||d.name}};let m;typeof y=="string"||N(y)?m=[y,...u]:(w.modal=y?.modal,w.useCustom=y?.useCustom,w.detail=y?.detail,m=u),w.useCustom&&(0,R.$cG)(d,"resolvers");const r=[];let o=!1;for(let s=0;s<m.length;s++){const n=m[s];if(typeof n=="string")r.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:a}=n;r.push({title:i,isCloseAffordance:!!a,handle:s}),a&&(o?this.b.warn(`[${d.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${d.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,O,w,r).then(s=>{if(typeof s=="number")return m[s]})}};e.$Okc=A,e.$Okc=A=Je([qe(1,T.$Oj)],A)}),define(Pe[238],Re([1,0,6,17,2,25,4]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=void 0;class g{constructor(E){this.b=new Map,this.a=E.getProxy(A.$qM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,O,y){if((0,N.$cG)(E,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,y),this.a.$registerProfileContentHandler(O,y.name,y.description,E.identifier.value),(0,I.$Sc)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(E,O,y,u){const w=this.b.get(E);if(!w)throw new Error(`Unknown handler with id: ${E}`);return w.saveProfile(O,y,u)}async $readProfile(E,O,y){const u=this.b.get(E);if(!u)throw new Error(`Unknown handler with id: ${E}`);return u.readProfile((0,T.$Vf)(O)?O:R.URI.revive(O),y)}}e.$Xkc=g}),define(Pe[81],Re([1,0,4,5,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=e.$9jc=void 0;class N{constructor(g){this.b=new T.$7d,this.onDidChangePassword=this.b.event,this.a=g.getProxy(I.$qM.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,d){return this.a.$getPassword(g,d)}store(g,d,E){return this.a.$setPassword(g,d,E)}delete(g,d){return this.a.$deletePassword(g,d)}}e.$9jc=N,e.$0jc=(0,R.$ii)("IExtHostSecretState")}),define(Pe[239],Re([1,0,24,6,4]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=void 0;class N{static{this.a=1}constructor(g){this.c=new Map,this.d=new Map,this.b=g.getProxy(R.$qM.MainThreadSpeech)}async $createSpeechToTextSession(g,d,E){const O=this.c.get(g);if(!O)return;const y=new T.$Tc,u=new I.$ee;this.d.set(d,u);const w=y.add(O.provideSpeechToTextSession(u.token,E?{language:E}:void 0));y.add(w.onDidChange(m=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(d,m)})),y.add(u.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}async $createKeywordRecognitionSession(g,d){const E=this.c.get(g);if(!E)return;const O=new T.$Tc,y=new I.$ee;this.d.set(d,y);const u=O.add(E.provideKeywordRecognitionSession(y.token));O.add(u.onDidChange(w=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(d,w)})),O.add(y.token.onCancellationRequested(()=>O.dispose()))}async $cancelKeywordRecognitionSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}registerProvider(g,d,E){const O=N.a++;return this.c.set(O,E),this.b.$registerProvider(O,d,{extension:g,displayName:g.value}),(0,T.$Sc)(()=>{this.b.$unregisterProvider(O),this.c.delete(O)})}}e.$5kc=N}),define(Pe[82],Re([1,0,4,5,3]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=e.$1jc=void 0;class N{constructor(g,d){this.c=d,this.b=new T.$7d,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(I.$qM.MainThreadStorage)}registerExtensionStorageKeysToSync(g,d){this.a.$registerExtensionStorageKeysToSync(g,d)}async initializeExtensionStorage(g,d,E){const O=await this.a.$initializeExtensionStorage(g,d);let y;return O&&(y=this.d(g,d,O)),y||E}setValue(g,d,E){return this.a.$setValue(g,d,E)}$acceptValue(g,d,E){const O=this.d(g,d,E);O&&this.b.fire({shared:g,key:d,value:O})}d(g,d,E){try{return JSON.parse(E)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${g}): ${O}`)}}}e.$1jc=N,e.$2jc=(0,R.$ii)("IExtHostStorage")}),define(Pe[240],Re([1,0,6,12,2,4]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(d){this.c=new Map,this.b=d.getProxy(N.$qM.MainThreadUriOpeners)}registerExternalUriOpener(d,E,O,y){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const u=y.schemes.find(w=>!A.a.has(w));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(E,O),this.b.$registerUriOpener(E,y.schemes,d,y.label),(0,I.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(d,E,O){const y=this.c.get(d);if(!y)throw new Error(`Unknown opener with id: ${d}`);const u=R.URI.revive(E);return y.canOpenExternalUri(u,O)}async $openUri(d,E,O){const y=this.c.get(d);if(!y)throw new Error(`Unknown opener id: '${d}'`);return y.openExternalUri(R.URI.revive(E.resolvedUri),{sourceUri:R.URI.revive(E.sourceUri)},O)}}e.$glc=A}),define(Pe[241],Re([1,0,4,2,6,14,20]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class g{static{this.a=0}constructor(E){this.c=new A.$Em,this.d=new Map,this.b=E.getProxy(I.$qM.MainThreadUrls)}registerUriHandler(E,O){const y=E.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=g.a++;return this.c.add(y),this.d.set(u,O),this.b.$registerUriHandler(u,y,E.displayName||E.name),(0,R.$Sc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(E,O){const y=this.d.get(E);if(!y)return Promise.resolve(void 0);try{y.handleUri(T.URI.revive(O))}catch(u){(0,N.$1)(u)}return Promise.resolve(void 0)}async createAppUri(E){return T.URI.revive(await this.b.$createAppUri(E))}}e.$hlc=g}),define(Pe[63],Re([1,0,5,6,12,26,2,188,210,76,4]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=e.$Ljc=void 0,e.$Mjc=u,e.$Ojc=r,e.$Pjc=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,h,t,v,c,$,b){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$7d,this._onDidDispose=this.#h.event,this.#e=a,this.#t=h,this.#o=t,this.#n=v,this.#s=c,this.#r=$,this.#l=u($),this.#d=w($),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,E.$kzb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===R.Schemas.https||a.scheme===R.Schemas.http){let h=a.toString();return h.endsWith("/")||(h+="/"),h+" "+E.$jzb}return E.$jzb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),N.$Sn(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const h=(0,d.$ynb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const h=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,b,p,l)=>{const D=A.URI.from({scheme:b||"file",path:decodeURIComponent(p)}),f=(0,E.$kzb)(D,{isRemote:h,authority:t}).toString();return`${c}${f}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,b,p,l)=>{const D=A.URI.from({scheme:b||"file",path:decodeURIComponent(p)}),f=(0,E.$kzb)(D,{isRemote:h,authority:t}).toString();return`${c}${f}${l}`})}}e.$Ljc=y;function u(i){try{const a=(0,g.$up)((0,g.$tp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function w(i){try{const a=(0,g.$up)((0,g.$tp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class m extends T.$Uc{constructor(a,h,t,v,c){super(),this.c=h,this.f=t,this.g=v,this.h=c,this.b=new Map,this.a=a.getProxy(O.$qM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,h,t){const v=this.j(a);if(v){const{message:c}=(0,d.$znb)(h,t.value);v._onMessageEmitter.fire(c)}}$onMissingCsp(a,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,h,t){const v=new y(a,this.a,s(h),this.c,this.f,t,this.h);this.b.set(a,v);const c=v._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return v}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Njc=m;function r(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(i,a)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>A.URI.from(a))}}function n(i,a){return[...(a?.getWorkspaceFolders()||[]).map(h=>h.uri),i.extensionLocation]}}),define(Pe[109],Re([1,0,5,4,2,12,15,3,16,25]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=void 0;let y=class{static{O=this}static{this.a={focused:!0,active:!0}}getState(w){const m=this.d;return{get focused(){return m.focused},get active(){return(0,E.$cG)(w,"windowActivity"),m.active}}}constructor(w){this.c=new I.$7d,this.onDidChangeWindowState=this.c.event,this.d=O.a,this.b=w.getProxy(T.$qM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:r})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,m){m!==this.d[w]&&(this.d={...this.d,[w]:m},this.c.fire(this.d))}openUri(w,m){let r;if(typeof w=="string"){r=w;try{w=R.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,A.$Ue)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,r,m)}async asExternalUri(w,m){if((0,A.$Ue)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(w,m);return R.URI.from(r)}};e.$jlc=y,e.$jlc=y=O=Je([qe(0,d.$LO)],y),e.$klc=(0,g.$ii)("IExtHostWindow")}),define(Pe[242],Re([1,0,233,27,16]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;let N=class extends I.$plc{constructor(g,d){super(g,d)}f(g,d,E){d.apply(console,E)}};e.$xnc=N,e.$xnc=N=Je([qe(0,R.$LO),qe(1,T.$2O)],N)}),define(Pe[243],Re([1,0,11,22,24,14,5,6,144,230,50]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$g$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$e$b=o,e.$f$b=s;function u(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const w="$$ref$$",m={[w]:-1};class r{constructor(P,C){this.jsonString=P,this.referencedBuffers=C}}function o(k,P=null,C=!1){const q=[];return{jsonString:(C?u:JSON.stringify)(k,(W,M)=>{if(typeof M>"u")return m;if(typeof M=="object"){if(M instanceof T.$ue){const z=q.push(M)-1;return{[w]:z}}if(P)return P(W,M)}return M}),referencedBuffers:q}}function s(k,P,C){return JSON.parse(k,(q,V)=>{if(V){const W=V[w];if(typeof W=="number")return P[W];if(C&&V.$mid===1)return C.transformIncoming(V)}return V})}function n(k,P){return JSON.stringify(k,P)}function i(k){return k?(P,C)=>C&&C.$mid===1?k.transformOutgoing(C):C:null}var a;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},v=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class $ extends g.$Uc{static{y=v}static{this.a=3*1e3}constructor(P,C=null,q=null){super(),this[y]=!0,this.b=this.B(new A.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=C,this.g=q,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,W=O.$bw.count;V<W;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$uh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const C=this.w[P];delete this.w[P],C.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,d.$nn)(P,this.g):P}getProxy(P){const{nid:C,sid:q}=P;return this.s[C]||(this.s[C]=this.J(C,q)),this.s[C]}J(P,C){const q={get:(V,W)=>(typeof W=="string"&&!V[W]&&W.charCodeAt(0)===36&&(V[W]=(...M)=>this.U(P,W,M)),W===c?C:V[W])};return new Proxy(Object.create(null),q)}set(P,C){return this.m[P.nid]=C,C}assertRegistered(P){for(let C=0,q=P.length;C<q;C++){const V=P[C];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(P){if(this.j)return;const C=P.byteLength,q=p.read(P,0),V=q.readUInt8(),W=q.readUInt32();switch(V){case 1:case 2:{let{rpcId:M,method:z,args:K}=D.deserializeRequestJSONArgs(q);this.g&&(K=(0,d.$nn)(K,this.g)),this.M(C,W,M,z,K,V===2);break}case 3:case 4:{let{rpcId:M,method:z,args:K}=D.deserializeRequestMixedArgs(q);this.g&&(K=(0,d.$nn)(K,this.g)),this.M(C,W,M,z,K,V===4);break}case 5:{this.f?.logIncoming(C,W,0,"ack"),this.G(W);break}case 6:{this.N(C,W);break}case 7:{this.O(C,W,void 0);break}case 9:{let M=D.deserializeReplyOKJSON(q);this.g&&(M=(0,d.$nn)(M,this.g)),this.O(C,W,M);break}case 10:{const M=D.deserializeReplyOKJSONWithBuffers(q,this.g);this.O(C,W,M);break}case 8:{const M=D.deserializeReplyOKVSBuffer(q);this.O(C,W,M);break}case 11:{let M=D.deserializeReplyErrError(q);this.g&&(M=(0,d.$nn)(M,this.g)),this.P(C,W,M);break}case 12:{this.P(C,W,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,C,q,V,W,M){this.f?.logIncoming(P,C,1,`receiveRequest ${(0,O.$dw)(q)}.${V}(`,W);const z=String(C);let K,ie;if(M){const De=new R.$ee;W.push(De.token),K=this.Q(q,V,W),ie=()=>De.cancel()}else K=this.Q(q,V,W),ie=t;this.u[z]=ie;const fe=D.serializeAcknowledged(C);this.f?.logOutgoing(fe.byteLength,C,1,"ack"),this.c.send(fe),K.then(De=>{delete this.u[z];const ye=D.serializeReplyOK(C,De,this.h);this.f?.logOutgoing(ye.byteLength,C,1,"reply:",De),this.c.send(ye)},De=>{delete this.u[z];const ye=D.serializeReplyErr(C,De);this.f?.logOutgoing(ye.byteLength,C,1,"replyErr:",De),this.c.send(ye)})}N(P,C){this.f?.logIncoming(P,C,1,"receiveCancel");const q=String(C);this.u[q]?.()}O(P,C,q){this.f?.logIncoming(P,C,0,"receiveReply:",q);const V=String(C);if(!this.w.hasOwnProperty(V))return;const W=this.w[V];delete this.w[V],W.resolveOk(q)}P(P,C,q){this.f?.logIncoming(P,C,0,"receiveReplyErr:",q);const V=String(C);if(!this.w.hasOwnProperty(V))return;const W=this.w[V];delete this.w[V];let M;q&&(q.$isError?(M=new Error,M.name=q.name,M.message=q.message,M.stack=q.stack):M=q),W.resolveErr(M)}Q(P,C,q){try{return Promise.resolve(this.S(P,C,q))}catch(V){return Promise.reject(V)}}S(P,C,q){const V=this.m[P];if(!V)throw new Error("Unknown actor "+(0,O.$dw)(P));const W=V[C];if(typeof W!="function")throw new Error("Unknown method "+C+" on actor "+(0,O.$dw)(P));return W.apply(V,q)}U(P,C,q){if(this.j)return new E.$d$b;let V=null;if(q.length>0&&R.CancellationToken.isCancellationToken(q[q.length-1])&&(V=q.pop()),V&&V.isCancellationRequested)return Promise.reject(N.$6());const W=D.serializeRequestArguments(q,this.h),M=++this.t,z=String(M),K=new E.$c$b,ie=new g.$Tc;V&&ie.add(V.onCancellationRequested(()=>{const De=D.serializeCancel(M);this.f?.logOutgoing(De.byteLength,M,0,"cancel"),this.c.send(D.serializeCancel(M))})),this.w[z]=new b(K,ie),this.F(M);const fe=D.serializeRequest(M,P,C,W,!!V);return this.f?.logOutgoing(fe.byteLength,M,0,`request: ${(0,O.$dw)(P)}.${C}(`,q),this.c.send(fe),K}}e.$g$b=$;class b{constructor(P,C){this.a=P,this.b=C}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class p{static alloc(P,C,q){const V=new p(T.$ue.alloc(q+1+4),0);return V.writeUInt8(P),V.writeUInt32(C),V}static read(P,C){return new p(P,C)}get buffer(){return this.a}constructor(P,C){this.a=P,this.b=C}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+P).toString();return this.b+=P,q}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+P).toString();return this.b+=P,q}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const C=this.a.slice(this.b,this.b+P);return this.b+=P,C}static sizeMixedArray(P){let C=0;C+=1;for(let q=0,V=P.length;q<V;q++){const W=P[q];switch(C+=1,W.type){case 1:C+=this.sizeLongString(W.value);break;case 2:C+=this.sizeVSBuffer(W.value);break;case 3:C+=this.sizeUInt32,C+=this.sizeLongString(W.value);for(let M=0;M<W.buffers.length;++M)C+=this.sizeVSBuffer(W.buffers[M]);break;case 4:break}}return C}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let C=0,q=P.length;C<q;C++){const V=P[C];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let W=0;W<V.buffers.length;++W)this.writeBuffer(V.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const C=new Array(P);for(let q=0;q<P;q++)switch(this.readUInt8()){case 1:C[q]=this.readLongString();break;case 2:C[q]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),M=this.readLongString(),z=[];for(let K=0;K<W;++K)z.push(this.readVSBuffer());C[q]=new O.$ew(s(M,z,null));break}case 4:C[q]=void 0;break}return C}}var l;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(l||(l={}));class D{static a(P){for(let C=0,q=P.length;C<q;C++)if(P[C]instanceof T.$ue||P[C]instanceof O.$ew||typeof P[C]>"u")return!0;return!1}static serializeRequestArguments(P,C){if(this.a(P)){const q=[];for(let V=0,W=P.length;V<W;V++){const M=P[V];if(M instanceof T.$ue)q[V]={type:2,value:M};else if(typeof M>"u")q[V]={type:4};else if(M instanceof O.$ew){const{jsonString:z,referencedBuffers:K}=o(M.value,C);q[V]={type:3,value:T.$ue.fromString(z),buffers:K}}else q[V]={type:1,value:T.$ue.fromString(n(M,C))}}return{type:1,args:q}}return{type:0,args:n(P,C)}}static serializeRequest(P,C,q,V,W){switch(V.type){case 0:return this.b(P,C,q,V.args,W);case 1:return this.c(P,C,q,V.args,W)}}static b(P,C,q,V,W){const M=T.$ue.fromString(q),z=T.$ue.fromString(V);let K=0;K+=p.sizeUInt8(),K+=p.sizeShortString(M),K+=p.sizeLongString(z);const ie=p.alloc(W?2:1,P,K);return ie.writeUInt8(C),ie.writeShortString(M),ie.writeLongString(z),ie.buffer}static deserializeRequestJSONArgs(P){const C=P.readUInt8(),q=P.readShortString(),V=P.readLongString();return{rpcId:C,method:q,args:JSON.parse(V)}}static c(P,C,q,V,W){const M=T.$ue.fromString(q);let z=0;z+=p.sizeUInt8(),z+=p.sizeShortString(M),z+=p.sizeMixedArray(V);const K=p.alloc(W?4:3,P,z);return K.writeUInt8(C),K.writeShortString(M),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(P){const C=P.readUInt8(),q=P.readShortString(),V=P.readMixedArray(),W=new Array(V.length);for(let M=0,z=V.length;M<z;M++){const K=V[M];typeof K=="string"?W[M]=JSON.parse(K):W[M]=K}return{rpcId:C,method:q,args:W}}static serializeAcknowledged(P){return p.alloc(5,P,0).buffer}static serializeCancel(P){return p.alloc(6,P,0).buffer}static serializeReplyOK(P,C,q){if(typeof C>"u")return this.d(P);if(C instanceof T.$ue)return this.e(P,C);if(C instanceof O.$ew){const{jsonString:V,referencedBuffers:W}=o(C.value,q,!0);return this.g(P,V,W)}else return this.f(P,u(C,q))}static d(P){return p.alloc(7,P,0).buffer}static e(P,C){let q=0;q+=p.sizeVSBuffer(C);const V=p.alloc(8,P,q);return V.writeVSBuffer(C),V.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,C){const q=T.$ue.fromString(C);let V=0;V+=p.sizeLongString(q);const W=p.alloc(9,P,V);return W.writeLongString(q),W.buffer}static g(P,C,q){const V=T.$ue.fromString(C);let W=0;W+=p.sizeUInt32,W+=p.sizeLongString(V);for(const z of q)W+=p.sizeVSBuffer(z);const M=p.alloc(10,P,W);M.writeUInt32(q.length),M.writeLongString(V);for(const z of q)M.writeBuffer(z);return M.buffer}static deserializeReplyOKJSON(P){const C=P.readLongString();return JSON.parse(C)}static deserializeReplyOKJSONWithBuffers(P,C){const q=P.readUInt32(),V=P.readLongString(),W=[];for(let M=0;M<q;++M)W.push(P.readVSBuffer());return new O.$ew(s(V,W,C))}static serializeReplyErr(P,C){const q=C?u(N.$3(C),null):void 0;if(typeof q!="string")return this.h(P);const V=T.$ue.fromString(q);let W=0;W+=p.sizeLongString(V);const M=p.alloc(11,P,W);return M.writeLongString(V),M.buffer}static deserializeReplyErrError(P){const C=P.readLongString();return JSON.parse(C)}static h(P){return p.alloc(12,P,0).buffer}}var f;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var S;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(S||(S={}))}),define(Pe[244],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;const I=function(N){const A=g=>{globalThis.removeEventListener("message",A);const d=g.data;Object.defineProperties(globalThis,{postMessage:{value(E,O){d.postMessage(E,O)}},onmessage:{get(){return d.onmessage},set(E){d.onmessage=E}}}),d.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),d.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(N,A,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const d=`((${I})('${A}'))`,E=new Blob([d],{type:"application/javascript"}),O=URL.createObjectURL(E),y=new MessageChannel,u=O,w={type:"_newWorker",id:u,port:y.port2,url:O,options:g};N(w,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{N({type:"_terminateWorker",id:u}),URL.revokeObjectURL(O),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const r=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(r)}),y.port1.addEventListener("message",m=>{const r=new MessageEvent("message",{data:m.data});this.dispatchEvent(r)}),y.port1.start()}}e.$znc=T}),define(Pe[245],Re([1,0,22,28,12,55,3]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$5J=void 0,e.$6J=O,e.$7J=y,e.$5J=(0,A.$ii)("notebookDocumentService");const g=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${g.join("")}]+`),E=7;function O(w){if(w.scheme!==R.Schemas.vscodeNotebookCell)return;const m=w.fragment.indexOf("s");if(m<0)return;const r=parseInt(w.fragment.substring(0,m).replace(d,""),E),o=(0,I.$Ne)(w.fragment.substring(m+1)).toString();if(!isNaN(r))return{handle:r,notebook:w.with({scheme:o,fragment:null})}}function y(w,m){const r=m.toString(E),s=`${r.length<g.length?g[r.length-1]:"z"}${r}s${(0,I.$Oe)(I.$ue.fromString(w.scheme),!0,!0)}`;return w.with({scheme:R.Schemas.vscodeNotebookCell,fragment:s})}class u{constructor(){this.a=new T.$Bc}getNotebook(m){if(m.scheme===R.Schemas.vscodeNotebookCell){const r=O(m);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$8J=u,(0,N.$gs)(e.$5J,u,1)}),define(Pe[83],Re([1,0,22,35,39,69,12,19,21,33,245]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$mK=e.CellStatusbarAlignment=e.$lK=e.NotebookEditorPriority=e.$iK=e.$hK=e.$fK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$eK=e.$dK=e.$cK=e.$bK=e.CellKind=e.$aK=e.$_J=e.$$J=void 0,e.$gK=v,e.$jK=$,e.$kK=b,e.$nK=D,e.$oK=S,e.$$J="workbench.editor.notebook",e.$_J="workbench.editor.notebookTextDiffEditor",e.$aK="workbench.editor.interactive";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$bK=["application/json","application/javascript","text/html","image/svg+xml",N.$zs.latex,N.$zs.markdown,"image/png","image/jpeg",N.$zs.text],e.$cK=[N.$zs.latex,N.$zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$zs.text],e.$dK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$eK="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var r;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(K){K.scheme=A.Schemas.vscodeNotebookCell;function ie(ne,Se){return(0,O.$7J)(ne,Se)}K.generate=ie;function fe(ne){return(0,O.$6J)(ne)}K.parse=fe;function De(ne,Se){return ne.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Se??""},${ne.scheme!==A.Schemas.file?ne.scheme:""}`})}K.generateCellOutputUri=De;function ye(ne){if(ne.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!Se)return;const je=Se[1]&&Se[1]!==""?Se[1]:void 0,re=Se[2];return{outputId:je,notebook:ne.with({scheme:re||A.Schemas.file,fragment:null})}}K.parseCellOutputUri=ye;function oe(ne,Se,je){return K.generate(ne,Se).with({scheme:je})}K.generateCellPropertyUri=oe;function $e(ne,Se){if(ne.scheme===Se)return K.parse(ne.with({scheme:K.scheme}))}K.parseCellPropertyUri=$e})(a||(e.CellUri=a={}));const h=K=>d.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],fe=e.$bK){this.e=fe,this.d=[...new Set(ie)].map(De=>({pattern:De,matches:T.$ck(h(De))}))}sort(ie){const fe=new Map(R.Iterable.map(ie,ye=>[ye,h(ye)]));let De=[];for(const{matches:ye}of this.d)for(const[oe,$e]of fe)if(ye($e)){De.push(oe),fe.delete(oe);break}return fe.size&&(De=De.concat([...fe.keys()].sort((ye,oe)=>this.e.indexOf(ye)-this.e.indexOf(oe)))),De}prioritize(ie,fe){const De=this.f(ie);if(De===-1){this.d.unshift({pattern:ie,matches:T.$ck(h(ie))});return}const ye=new Set(fe.map($e=>this.f($e,De)));ye.delete(-1);const oe=Array.from(ye).sort();this.d.splice(De+1,0,...oe.map($e=>this.d[$e]));for(let $e=oe.length-1;$e>=0;$e--)this.d.splice(oe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,fe=this.d.length){const De=h(ie);for(let ye=0;ye<fe;ye++)if(this.d[ye].matches(De))return ye;return-1}}e.$fK=t;function v(K,ie,fe,De=(ye,oe)=>ye===oe){const ye=[];function oe(Se,je,re){if(je===0&&re.length===0)return;const L=ye[ye.length-1];L&&L.start+L.deleteCount===Se?(L.deleteCount+=je,L.toInsert.push(...re)):ye.push({start:Se,deleteCount:je,toInsert:re})}let $e=0,ne=0;for(;;){if($e===K.length){oe($e,0,ie.slice(ne));break}if(ne===ie.length){oe($e,K.length-$e,[]);break}const Se=K[$e],je=ie[ne];if(De(Se,je)){$e+=1,ne+=1;continue}fe(je)?(oe($e,1,[]),$e+=1):(oe($e,0,[je]),ne+=1)}return ye}e.$hK=new E.$zj("notebookEditorCursorAtBoundary","none"),e.$iK=new E.$zj("notebookEditorCursorAtLineBoundary","none");var c;(function(K){K.default="default",K.option="option"})(c||(e.NotebookEditorPriority=c={}));function $(K){const ie=K;return!!((typeof ie.include=="string"||T.$dk(ie.include))&&(typeof ie.exclude=="string"||T.$dk(ie.exclude)))}function b(K,ie,fe){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const De=$(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,ye=$(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(T.$bk(De,(0,g.$oc)(fe.fsPath).toLowerCase()))return!(ye&&T.$bk(ye,(0,g.$oc)(fe.fsPath).toLowerCase()))}return!1}e.$lK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.experimental.cellFailureDiagnostics"};var p;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class l{static{this.d="notebook/"}static create(ie){return`${l.d}${ie}`}static parse(ie){if(ie.startsWith(l.d))return ie.substring(l.d.length)}}e.$mK=l;function D(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const f=new TextDecoder;function S(K){const ie=[];let fe=!1;for(const $e of K)(ie.length===0||fe)&&(ie.push($e),fe=!0);let De=C(ie);const ye=I.$ue.concat(ie.map($e=>I.$ue.wrap($e))),oe=z(ye);return De=De||oe.byteLength!==ye.byteLength,{data:oe,didCompression:De}}e.$pK="\x1B[A";const k=e.$pK.split("").map(K=>K.charCodeAt(0)),P=10;function C(K){let ie=!1;return K.forEach((fe,De)=>{if(De===0||fe.length<e.$pK.length)return;const ye=K[De-1],oe=fe.subarray(0,e.$pK.length);if(oe[0]===k[0]&&oe[1]===k[1]&&oe[2]===k[2]){const $e=ye.lastIndexOf(P);if($e===-1)return;ie=!0,K[De-1]=ye.subarray(0,$e),K[De]=fe.subarray(e.$pK.length)}}),ie}function q(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let fe=K.match(/\r+(.*)$/m)[1];fe=fe+ie.slice(fe.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,fe)}return K}const W=8,M=13;function z(K){return!K.buffer.includes(W)&&!K.buffer.includes(M)?K:I.$ue.fromString(V(q(f.decode(K.buffer))))}}),define(Pe[7],Re([1,0,18,14,54,28,69,15,17,2,34,20,43,102,83]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m){"use strict";var r,o,s,n,i,a,h,t,v,c,$,b,p,l,D,f,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$zO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$yO=e.$xO=e.$wO=e.$vO=e.ChatLocation=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$mO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.TestRunProfileKind=e.TestResultState=e.$4N=e.$3N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$2N=e.NotebookVariablesRequestKind=e.$1N=e.$ZN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$YN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.ColorThemeKind=e.$SN=e.$RN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$QN=e.$PN=e.DebugConsoleMode=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$JN=e.$IN=e.FileChangeType=e.$HN=e.NewSymbolNameTag=e.$GN=e.$FN=e.$EN=e.$DN=e.InlineCompletionTriggerKind=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$qN=e.ConfigurationTarget=e.$pN=e.$oN=e.$nN=e.$mN=e.DocumentPasteTriggerKind=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$fN=e.ViewBadge=e.ProgressLocation=e.$eN=e.$dN=e.TaskScope=e.ShellQuoting=e.$cN=e.$bN=e.$aN=e.TaskPanelKind=e.TaskRevealKind=e.$_M=e.TerminalLocation=e.$$M=e.$0M=e.$9M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$8M=e.$7M=e.$6M=e.$5M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$3M=e.$2M=e.$1M=e.$ZM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$YM=e.$XM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.LanguageStatusSeverity=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.CodeActionTriggerKind=e.$LM=e.$KM=e.SymbolTag=e.SymbolKind=e.$JM=e.$IM=e.DocumentHighlightKind=e.$HM=e.$GM=e.$FM=e.$EM=e.DiagnosticSeverity=e.DiagnosticTag=e.$DM=e.$CM=e.FileEditType=e.$BM=e.$AM=e.$zM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$4M=ht,e.$rN=Q;function k(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(B,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Ee,...Ke]=te;return Reflect.construct(B,Ke,Ee.constructor)}}})}var P;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var C;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(C||(e.TerminalQuickFixType=C={}));let q=r=class{static from(...F){let te=F;return new r(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$sM=q,e.$sM=q=r=Je([k],q);let V=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Ee=1;Ee<F.length;Ee++){const Ke=F[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Ee=1;Ee<F.length;Ee++){const Ke=F[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:Ee}=F;return typeof te=="number"&&typeof Ee=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,T.$7)("line must be non-negative");if(te<0)throw(0,T.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,T.$7)();let Ee;return typeof F>"u"?Ee=0:typeof F=="number"?Ee=F:(Ee=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),Ee===0&&te===0?this:new o(this.line+Ee,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,T.$7)();let Ee;return typeof F>"u"?Ee=this.line:typeof F=="number"?Ee=F:(Ee=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),Ee===this.line&&te===this.character?this:new o(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$tM=V,e.$tM=V=o=Je([k],V);let W=s=class{static isRange(F){return F instanceof s?!0:F?V.isPosition(F.start)&&V.isPosition(F.end):!1}static of(F){if(F instanceof s)return F;if(this.isRange(F))return new s(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,Ee,Ke){let _e,ut;if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new V(F,te),ut=new V(Ee,Ke)):V.isPosition(F)&&V.isPosition(te)&&(_e=V.of(F),ut=V.of(te)),!_e||!ut)throw new Error("Invalid arguments");_e.isBefore(ut)?(this.c=_e,this.e=ut):(this.c=ut,this.e=_e)}contains(F){return s.isRange(F)?this.contains(F.start)&&this.contains(F.end):V.isPosition(F)?!(V.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=V.Max(F.start,this.c),Ee=V.Min(F.end,this.e);if(!te.isAfter(Ee))return new s(te,Ee)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=V.Min(F.start,this.c),Ee=V.Max(F.end,this.end);return new s(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,T.$7)();let Ee;return F?V.isPosition(F)?Ee=F:(Ee=F.start||this.start,te=F.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new s(Ee,te)}toJSON(){return[this.start,this.end]}};e.$uM=W,e.$uM=W=s=Je([k],W);let M=n=class extends W{static isSelection(F){return F instanceof n?!0:F?W.isRange(F)&&V.isPosition(F.anchor)&&V.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,Ee,Ke){let _e,ut;if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new V(F,te),ut=new V(Ee,Ke)):V.isPosition(F)&&V.isPosition(te)&&(_e=V.of(F),ut=V.of(te)),!_e||!ut)throw new Error("Invalid arguments");super(_e,ut),this.f=_e,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$vM=M,e.$vM=M=n=Je([k],M);const z=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class K{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,Ee){if(typeof F!="string"||F.length===0)throw(0,T.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.$7)("port");typeof Ee<"u"&&z(Ee),this.host=F,this.port=Math.round(te),this.connectionToken=Ee}}e.$wM=K;class ie{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&z(te)}}e.$xM=ie;class fe extends Error{static NotAvailable(F,te){return new fe(F,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new fe(F,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=w.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(F),this._message=F,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,fe.prototype)}}e.$yM=fe;var De;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(De||(e.EndOfLine=De={}));var ye;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ye||(e.EnvironmentVariableMutatorType=ye={}));let oe=i=class{static isTextEdit(F){return F instanceof i?!0:F?W.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new W(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new W(new V(0,0),new V(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!W.isRange(F))throw(0,T.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,T.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,T.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$zM=oe,e.$zM=oe=i=Je([k],oe);let $e=a=class{static isNotebookCellEdit(F){return F instanceof a?!0:F?hi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new a(F,te)}static insertCells(F,te){return new a(new hi(F,F),te)}static deleteCells(F){return new a(F,[])}static updateCellMetadata(F,te){const Ee=new a(new hi(F,F),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(F){const te=new a(new hi(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$AM=$e,e.$AM=$e=a=Je([k],$e);class ne{static isSnippetTextEdit(F){return F instanceof ne?!0:F?W.isRange(F.range)&&re.isSnippetString(F.snippet):!1}static replace(F,te){return new ne(F,te)}static insert(F,te){return ne.replace(new W(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$BM=ne;var Se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let je=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,Ee,Ke){this.c.push({_type:1,from:F,to:te,options:Ee,metadata:Ke})}createFile(F,te,Ee){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:Ee})}deleteFile(F,te,Ee){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:Ee})}e(F,te,Ee){this.c.push({_type:3,metadata:Ee,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,Ee,Ke){const _e=te.start,ut=te.end;(_e!==ut||Ee.length>0)&&this.c.push({_type:5,uri:F,index:_e,count:ut-_e,cells:Ee,metadata:Ke})}g(F,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:F,edit:{editType:3,index:te,metadata:Ee}})}replace(F,te,Ee,Ke){this.c.push({_type:2,uri:F,edit:new oe(te,Ee),metadata:Ke})}insert(F,te,Ee,Ke){this.replace(F,new W(te,te),Ee,Ke)}delete(F,te,Ee){this.replace(F,te,"",Ee)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,_e;Array.isArray(Ee)?(Ke=Ee[0],_e=Ee[1]):Ke=Ee,$e.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(F,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(F,Ke.newNotebookMetadata,_e):this.f(F,Ke.range,Ke.newCells,_e):ne.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:F,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:F,edit:Ke,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===F.toString()&&(this.c[Ee]=void 0);break}}(0,I.$Ib)(this.c)}}get(F){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===F.toString()&&te.push(Ee.edit);return te}entries(){const F=new N.$Bc;for(const te of this.c)if(te._type===2){let Ee=F.get(te.uri);Ee||(Ee=[te.uri,[]],F.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$CM=je,e.$CM=je=Je([k],je);let re=h=class{static isSnippetString(F){return F instanceof h?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=h.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const Ee=new h;Ee.e=this.e,F(Ee),this.e=Ee.e,F=Ee.value}else F=h.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const Ee=F.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const Ee=new h;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$DM=re,e.$DM=re=h=Je([k],re);var L;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(L||(e.DiagnosticTag=L={}));var _;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let ve=t=class{static isLocation(F){return F instanceof t?!0:F?W.isRange(F.range)&&E.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(W.isRange(te))this.range=W.of(te);else if(V.isPosition(te))this.range=new W(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$EM=ve,e.$EM=ve=t=Je([k],ve);let Oe=class{static is(F){return F?typeof F.message=="string"&&F.location&&W.isRange(F.location.range)&&E.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$FM=Oe,e.$FM=Oe=Je([k],Oe);let ke=class{constructor(F,te,Ee=_.Error){if(!W.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=Ee}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,I.$ub)(F.tags,te.tags)&&(0,I.$ub)(F.relatedInformation,te.relatedInformation,Oe.isEqual)}};e.$GM=ke,e.$GM=ke=Je([k],ke);let pe=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$HM=pe,e.$HM=pe=Je([k],pe);var de;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(de||(e.DocumentHighlightKind=de={}));let J=class{constructor(F,te=de.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:de[this.kind]}}};e.$IM=J,e.$IM=J=Je([k],J);let Y=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$JM=Y,e.$JM=Y=Je([k],Y);var ue;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ue||(e.SymbolKind=ue={}));var he;(function(B){B[B.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let Ne=v=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,Ee,Ke,_e){this.name=F,this.kind=te,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ve?this.location=Ke:Ee instanceof W&&(this.location=new ve(Ke,Ee)),v.validate(this)}toJSON(){return{name:this.name,kind:ue[this.kind],location:this.location,containerName:this.containerName}}};e.$KM=Ne,e.$KM=Ne=v=Je([k],Ne);let le=c=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(c.validate)}constructor(F,te,Ee,Ke,_e){this.name=F,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=_e,this.children=[],c.validate(this)}};e.$LM=le,e.$LM=le=c=Je([k],le);var Ie;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let Ae=class{constructor(F,te){this.title=F,this.kind=te}};e.$MM=Ae,e.$MM=Ae=Je([k],Ae);let ze=class{static{$=this}static{this.c="."}constructor(F){this.value=F}append(F){return new $(this.value?this.value+$.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+$.c)}};e.$NM=ze,e.$NM=ze=$=Je([k],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let U=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$OM=U,e.$OM=U=Je([k],U);class j{constructor(F,te,Ee,Ke,_e,ut){this.kind=F,this.name=te,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ut}}e.$PM=j;class G{constructor(F,te){this.fromRanges=te,this.from=F}}e.$QM=G;class H{constructor(F,te){this.fromRanges=te,this.to=F}}e.$RM=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$SM=se,e.$SM=se=Je([k],se);let Te=b=class{#e;static isMarkdownString(F){return F instanceof b?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new R.$Fk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$TM=Te,e.$TM=Te=b=Je([k],Te);let Ve=class{constructor(F,te){this.label=F,this.documentation=te}};e.$UM=Ve,e.$UM=Ve=Je([k],Ve);let Qe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$VM=Qe,e.$VM=Qe=Je([k],Qe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$WM=xe,e.$WM=xe=Je([k],xe);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var ot;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ot||(e.InlayHintKind=ot={}));let it=class{constructor(F){this.value=F}};e.$XM=it,e.$XM=it=Je([k],it);let nt=class{constructor(F,te,Ee){this.position=F,this.label=te,this.kind=Ee}};e.$YM=nt,e.$YM=nt=Je([k],nt);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var ft;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var Ue;(function(B){B[B.Deprecated=1]="Deprecated"})(Ue||(e.CompletionItemTag=Ue={}));let st=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$ZM=st,e.$ZM=st=Je([k],st);let Z=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$1M=Z,e.$1M=Z=Je([k],Z);let X=class{constructor(F,te,Ee){this.insertText=F,this.range=te,this.command=Ee}};e.$2M=X,e.$2M=X=Je([k],X);let me=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$3M=me,e.$3M=me=Je([k],me);var We;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(We||(e.PartialAcceptTriggerKind=We={}));var Ze;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ze||(e.ViewColumn=Ze={}));var Me;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Me||(e.StatusBarAlignment=Me={}));function ht(B,F){return`${y.$Dm.toKey(B)}.${F}`}var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Bt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Bt||(e.TextDocumentSaveReason=Bt={}));var _t;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(_t||(e.TextEditorRevealType=_t={}));var Qt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var ei;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var St;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(St||(e.DecorationRangeBehavior=St={})),function(B){function F(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Xt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Xt||(e.SyntaxTokenType=Xt={})),function(B){function F(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}(Xt||(e.SyntaxTokenType=Xt={}));let Wt=class{constructor(F,te){if(te&&!E.URI.isUri(te))throw(0,T.$7)("target");if(!W.isRange(F)||F.isEmpty)throw(0,T.$7)("range");this.range=F,this.target=te}};e.$5M=Wt,e.$5M=Wt=Je([k],Wt);let ci=class{constructor(F,te,Ee,Ke){this.red=F,this.green=te,this.blue=Ee,this.alpha=Ke}};e.$6M=ci,e.$6M=ci=Je([k],ci);let Ye=class{constructor(F,te){if(te&&!(te instanceof ci))throw(0,T.$7)("color");if(!W.isRange(F)||F.isEmpty)throw(0,T.$7)("range");this.range=F,this.color=te}};e.$7M=Ye,e.$7M=Ye=Je([k],Ye);let ti=class{constructor(F){if(!F||typeof F!="string")throw(0,T.$7)("label");this.label=F}};e.$8M=ti,e.$8M=ti=Je([k],ti);var ii;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var Ht;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class vt{constructor(F,te,Ee){if(this.startIndex=F,this.length=te,this.tooltip=Ee,typeof F!="number"||F<0)throw(0,T.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,T.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,T.$7)("tooltip")}}e.$9M=vt;class ai{constructor(F){this.uri=F}}e.$0M=ai;class Gt{constructor(F){this.terminalCommand=F}}e.$$M=Gt;var Vt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Vt||(e.TerminalLocation=Vt={}));class gt{constructor(F){if(this.options=F,typeof F!="object")throw(0,T.$7)("options")}}e.$_M=gt;var It;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var ui;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Zt=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(F){switch(F){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,T.$7)("name");this.c=F}get id(){return this.c}};e.$aN=Zt,e.$aN=Zt=p=Je([k],Zt);function He(B){let F="";for(let te=0;te<B.length;te++)F+=B[te].replace(/,/g,",,")+",";return F}let Tt=class{constructor(F,te,Ee){if(typeof F!="string")throw(0,T.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,T.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return He(F)}};e.$bN=Tt,e.$bN=Tt=Je([k],Tt);let qt=class{constructor(F,te,Ee){if(this.f=[],Array.isArray(te)){if(!F)throw(0,T.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,T.$7)("command");this.e=F,this.f=te,this.g=Ee}else{if(typeof F!="string")throw(0,T.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,T.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,T.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return He(F)}};e.$cN=qt,e.$cN=qt=Je([k],qt);var ni;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var $t;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})($t||(e.TaskScope=$t={}));class Ot{constructor(F){this.c=F}computeId(){return"customExecution"+(0,O.$Eg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$dN=Ot;let Rt=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,Ee,Ke,_e,ut){this.k=!1,this.l=this.definition=F;let mt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ke,mt=_e,this.k=!0):te===$t.Global||te===$t.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=_e,mt=ut):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=_e,mt=ut),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Tt?this.l={type:l.e,id:this.q.computeId()}:this.q instanceof qt?this.l={type:l.f,id:this.q.computeId()}:this.q instanceof Ot?this.l={type:l.c,id:this.q.computeId()}:this.l={type:l.g,id:(0,O.$Eg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,T.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,T.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(l.g===te||l.e===te||l.f===te||l.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,T.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$eN=Rt,e.$eN=Rt=l=Je([k],Rt);var Nt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Nt||(e.ProgressLocation=Nt={}));var li;(function(B){function F(te){const Ee=te;return(0,d.$Zf)(Ee.value)?Ee.tooltip&&!(0,d.$Vf)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}B.isViewBadge=F})(li||(e.ViewBadge=li={}));let Ft=D=class{static isTreeItem(F,te){const Ee=F;if(Ee.checkboxState!==void 0){const Ke=(0,d.$Zf)(Ee.checkboxState)?Ee.checkboxState:(0,d.$Xf)(Ee.checkboxState)&&(0,d.$Zf)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,d.$Zf)(Ee.checkboxState)&&(0,d.$Xf)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||_e!==void 0&&!(0,d.$Vf)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(F instanceof D)return!0;if(Ee.label!==void 0&&!(0,d.$Vf)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,d.$Vf)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,d.$Vf)(Ee.iconPath)&&!E.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,d.$Vf)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,d.$Vf)(Ke.light)&&!E.URI.isUri(Ke.light)&&!(0,d.$Vf)(Ke.dark)&&!E.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,d.$Vf)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!E.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,d.$Vf)(Ee.tooltip)&&!(Ee.tooltip instanceof Te)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<Lt.None&&Ee.collapsibleState>Lt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,d.$Vf)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(F,te=Lt.None){this.collapsibleState=te,E.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$fN=Ft,e.$fN=Ft=D=Je([k],Ft);var Lt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Lt||(e.TreeItemCollapsibleState=Lt={}));var Et;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let At=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$gN=At,e.$gN=At=Je([k],At);class ri extends At{}e.$hN=ri;class jt extends ri{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$iN=jt;class wt{constructor(F,te,Ee,Ke){this.name=F,this.uri=te,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$jN=wt;let Ct=class{#e=new Map;constructor(F){for(const[te,Ee]of F??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[Ee,Ke]of this.#e)for(const _e of Ke)F.call(te,_e,Ee,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const Ee of te)yield[F,Ee]}#t(F){return F.toLowerCase()}};e.$kN=Ct,e.$kN=Ct=Je([k],Ct);let fi=class{constructor(F,te,Ee){this.insertText=F,this.title=te,this.kind=Ee}};e.$lN=fi,e.$lN=fi=Je([k],fi);var Dt;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(Dt||(e.DocumentPasteTriggerKind=Dt={}));class si{static{this.c="."}constructor(F){this.value=F}append(...F){return new si((this.value?[this.value,...F]:F).join(si.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+si.c)}}e.$mN=si,si.Empty=new si("");let Yt=class{constructor(F,te,Ee){this.title=te,this.insertText=F,this.kind=Ee}};e.$nN=Yt,e.$nN=Yt=Je([k],Yt);let oi=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$oN=oi,e.$oN=oi=Je([k],oi),oi.File=new oi("file"),oi.Folder=new oi("folder");let gi=class{constructor(F){this.id=F}};e.$pN=gi,e.$pN=gi=Je([k],gi);var we;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let Ce=class{get base(){return this.c}set base(F){this.c=F,this.e=E.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!E.URI.isUri(F)&&!E.URI.isUri(F.uri)))throw(0,T.$7)("base");if(typeof te!="string")throw(0,T.$7)("pattern");typeof F=="string"?this.baseUri=E.URI.file(F):E.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$qN=Ce,e.$qN=Ce=Je([k],Ce);const ce=new WeakMap;function Q(B,F){ce.set(B,F)}let be=class{constructor(F,te,Ee,Ke,_e){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=ce.get(this)??(0,O.$Eg)()),this.c}};e.$sN=be,e.$sN=be=Je([k],be);let Be=class extends be{constructor(F,te,Ee,Ke,_e,ut){if(super(te,Ee,Ke,_e,ut),F===null)throw(0,T.$7)("location");this.location=F}};e.$tN=Be,e.$tN=Be=Je([k],Be);let Xe=class extends be{constructor(F,te,Ee,Ke,_e,ut){super(te,Ee,Ke,_e,ut),this.functionName=F}};e.$uN=Xe,e.$uN=Xe=Je([k],Xe);let Ge=class extends be{constructor(F,te,Ee,Ke,_e,ut,mt,Jt){if(super(Ke,_e,ut,mt,Jt),!te)throw(0,T.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=Ee}};e.$vN=Ge,e.$vN=Ge=Je([k],Ge);let ct=class{constructor(F,te,Ee){this.command=F,this.args=te||[],this.options=Ee}};e.$wN=ct,e.$wN=ct=Je([k],ct);let yt=class{constructor(F,te){this.port=F,this.host=te}};e.$xN=yt,e.$xN=yt=Je([k],yt);let kt=class{constructor(F){this.path=F}};e.$yN=kt,e.$yN=kt=Je([k],kt);let xt=class{constructor(F){this.implementation=F}};e.$zN=xt,e.$zN=xt=Je([k],xt);class zt{constructor(F,te,Ee){this.session=F,this.threadId=te,this.frameId=Ee}}e.$AN=zt;class Kt{constructor(F,te){this.session=F,this.threadId=te}}e.$BN=Kt;let wi=class{constructor(F,te){this.range=F,this.expression=te}};e.$CN=wi,e.$CN=wi=Je([k],wi);var dt;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(dt||(e.InlineCompletionTriggerKind=dt={}));let Ti=class{constructor(F,te){this.range=F,this.text=te}};e.$DN=Ti,e.$DN=Ti=Je([k],Ti);let mi=class{constructor(F,te,Ee=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$EN=mi,e.$EN=mi=Je([k],mi);let vi=class{constructor(F,te){this.range=F,this.expression=te}};e.$FN=vi,e.$FN=vi=Je([k],vi);let Si=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$GN=Si,e.$GN=Si=Je([k],Si);var Qi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Qi||(e.NewSymbolNameTag=Qi={}));class gn{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$HN=gn;var Xi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ii=f=class extends Error{static FileExists(F){return new f(F,u.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(F){return new f(F,u.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(F){return new f(F,u.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(F){return new f(F,u.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(F){return new f(F,u.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(F){return new f(F,u.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(F,te=u.FileSystemProviderErrorCode.Unknown,Ee){super(E.URI.isUri(F)?F.toString(!0):F),this.code=Ee?.name??"Unknown",(0,u.$4k)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$IN=Ii,e.$IN=Ii=f=Je([k],Ii);let Ni=class{constructor(F,te,Ee){this.start=F,this.end=te,this.kind=Ee}};e.$JN=Ni,e.$JN=Ni=Je([k],Ni);var Fi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Fi||(e.FoldingRangeKind=Fi={}));var Zi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Zi||(e.CommentThreadCollapsibleState=Zi={}));var Ci;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ci||(e.CommentMode=Ci={}));var Pi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Pi||(e.CommentState=Pi={}));var Yi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var xi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(xi||(e.CommentThreadApplicability=xi={}));class yi{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$KN=yi;function mn(B){return typeof B>"u"||(0,d.$Wf)(B)}class Li{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,Ee=F.tokenTypes.length;te<Ee;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,Ee=F.tokenModifiers.length;te<Ee;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,Ee,Ke,_e){if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(F,te,Ee,Ke,_e);if(W.isRange(F)&&typeof te=="string"&&mn(Ee))return this.o(F,te,Ee);throw(0,T.$7)()}o(F,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=F.start.line,_e=F.start.character,ut=F.end.character-F.start.character,mt=this.k.get(te);let Jt=0;if(Ee)for(const di of Ee){if(!this.l.has(di))throw new Error("`tokenModifier` is not in the provided legend");const $i=this.l.get(di);Jt|=1<<$i>>>0}this.q(Ke,_e,ut,mt,Jt)}q(F,te,Ee,Ke,_e){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Jt=this.g.length/5|0;let di=0,$i=0;for(let pi=0;pi<Jt;pi++){let bi=this.g[5*pi],Ki=this.g[5*pi+1];bi===0?(bi=di,Ki+=$i):bi+=di,this.g[5*pi]=bi,this.g[5*pi+1]=Ki,di=bi,$i=Ki}}let ut=F,mt=te;this.f&&this.j>0&&(ut-=this.c,ut===0&&(mt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=mt,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=_e,this.c=F,this.e=te}static r(F){const te=[],Ee=F.length/5|0;for(let mt=0;mt<Ee;mt++)te[mt]=mt;te.sort((mt,Jt)=>{const di=F[5*mt],$i=F[5*Jt];if(di===$i){const pi=F[5*mt+1],bi=F[5*Jt+1];return pi-bi}return di-$i});const Ke=new Uint32Array(F.length);let _e=0,ut=0;for(let mt=0;mt<Ee;mt++){const Jt=5*te[mt],di=F[Jt+0],$i=F[Jt+1],pi=F[Jt+2],bi=F[Jt+3],Ki=F[Jt+4],Tn=di-_e,sr=Tn===0?$i-ut:$i,Ji=5*mt;Ke[Ji+0]=Tn,Ke[Ji+1]=sr,Ke[Ji+2]=pi,Ke[Ji+3]=bi,Ke[Ji+4]=Ki,_e=di,ut=$i}return Ke}build(F){return this.f?new ji(new Uint32Array(this.g),F):new ji(Li.r(this.g),F)}}e.$LN=Li;class ji{constructor(F,te){this.resultId=te,this.data=F}}e.$MN=ji;class _i{constructor(F,te,Ee){this.start=F,this.deleteCount=te,this.data=Ee}}e.$NN=_i;class $n{constructor(F,te){this.resultId=te,this.edits=F}}e.$ON=$n;var zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(zi||(e.DebugConsoleMode=zi={}));class en{constructor(F){this.name=F}}e.$PN=en;let Ui=class{static{this.Back={iconPath:new oi("arrow-left")}}constructor(){}};e.$QN=Ui,e.$QN=Ui=Je([k],Ui);var Bi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Bi||(e.QuickPickItemKind=Bi={}));var Vi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Vi||(e.InputBoxValidationSeverity=Vi={}));var tn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(tn||(e.ExtensionKind=tn={}));class pn{static validate(F){if(typeof F.badge=="string"){let te=(0,g.$vf)(F.badge,0);if(te<F.badge.length&&(te+=(0,g.$vf)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!oi.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,Ee){this.badge=F,this.tooltip=te,this.color=Ee}}e.$RN=pn;let qi=class{constructor(F){this.kind=F}};e.$SN=qi,e.$SN=qi=Je([k],qi);var nn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(nn||(e.ColorThemeKind=nn={}));class hi{static isNotebookRange(F){return F instanceof hi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,T.$7)("start must be positive");if(te<0)throw(0,T.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,Ee=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(Ee=F.end),te===this.c&&Ee===this.e?this:new hi(te,Ee)}}e.$TN=hi;class ki{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>ki.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,Ee,Ke,_e,ut,mt){this.kind=F,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=_e??[],this.metadata=ut,this.executionSummary=mt,ki.validate(this)}}e.$UN=ki;class Le{constructor(F){this.cells=F}}e.$VN=Le;class Ut{static isNotebookCellOutputItem(F){return F instanceof Ut?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return Ut.json(te,"application/vnd.code.notebook.error")}static stdout(F){return Ut.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Ut.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new Ut(F,te)}static#e=new TextEncoder;static text(F,te=A.$zs.text){const Ee=Ut.#e.encode(String(F));return new Ut(Ee,te)}static json(F,te="text/x-json"){const Ee=JSON.stringify(F,void 0,"	");return Ut.text(Ee,te)}constructor(F,te){this.data=F,this.mime=te;const Ee=(0,A.$Ds)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$WN=Ut;class Ei{static isNotebookCellOutput(F){return F instanceof Ei?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const Ee=new Set,Ke=new Set;for(let _e=0;_e<F.length;_e++){const ut=F[_e],mt=(0,A.$Ds)(ut.mime);if(!Ee.has(mt)||(0,m.$nK)(mt)){Ee.add(mt);continue}Ke.add(_e),te&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ke.size===0?F:F.filter((_e,ut)=>!Ke.has(ut))}constructor(F,te,Ee){this.items=Ei.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,O.$Eg)(),this.metadata=te??Ee)}}e.$XN=Ei;var tt;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(tt||(e.NotebookCellKind=tt={}));var pt;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(pt||(e.NotebookCellExecutionState=pt={}));var rn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class on{constructor(F,te){this.text=F,this.alignment=te}}e.$YN=on;var an;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(an||(e.NotebookControllerAffinity=an={}));var Di;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Di||(e.NotebookControllerAffinity2=Di={}));class vn{constructor(F,te=[]){this.uri=F,this.provides=(0,I.$3b)(te)}}e.$ZN=vn;class bn{constructor(F){this.label=F}}e.$1N=bn;var cn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ri=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$2N=Ri,e.$2N=Ri=Je([k],Ri);var un;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var ln;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var hn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class wn{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$3N=wn;class yn{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$4N=yn;var dn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(dn||(e.TestResultState=dn={}));var fn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Wi=class{constructor(F=void 0,te=void 0,Ee=void 0,Ke=!1){this.include=F,this.exclude=te,this.profile=Ee,this.continuous=Ke}};e.$5N=Wi,e.$5N=Wi=Je([k],Wi);let Hi=S=class{static diff(F,te,Ee){const Ke=new S(F);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(F){this.message=F}};e.$6N=Hi,e.$6N=Hi=S=Je([k],Hi);let Gi=class{constructor(F){this.id=F}};e.$7N=Gi,e.$7N=Gi=Je([k],Gi);class Mi{constructor(F,te){this.covered=F,this.total=te}}e.$8N=Mi;const x=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class ae{static fromDetails(F,te){const Ee=new Mi(0,0),Ke=new Mi(0,0),_e=new Mi(0,0);for(const mt of te)if("branches"in mt){Ee.total+=1,Ee.covered+=mt.executed?1:0;for(const Jt of mt.branches)Ke.total+=1,Ke.covered+=Jt.executed?1:0}else _e.total+=1,_e.covered+=mt.executed?1:0;const ut=new ae(F,Ee,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return ut.detailedCoverage=te,ut}constructor(F,te,Ee,Ke){this.uri=F,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ke,x(te),x(Ee),x(Ke)}}e.$9N=ae;class Fe{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee=[]){this.executed=F,this.location=te,this.branches=Ee}}e.$0N=Fe;class rt{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee){this.executed=F,this.location=te,this.label=Ee}}e.$$N=rt;class bt{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee){this.name=F,this.executed=te,this.location=Ee}}e.$_N=bt;var Mt;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Mt||(e.ExternalUriOpenerPriority=Mt={}));var Ai;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Ai||(e.WorkspaceTrustState=Ai={}));var kn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Nn{constructor(F,te,Ee,Ke,_e,ut){this.kind=F,this.name=te,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ut}}e.$aO=Nn;class Fn{constructor(F){this.uri=F}}e.$bO=Fn;class Ln{constructor(F,te){this.original=F,this.modified=te}}e.$cO=Ln;class jn{constructor(F,te,Ee,Ke){this.base=F,this.input1=te,this.input2=Ee,this.result=Ke}}e.$dO=jn;class zn{constructor(F,te){this.uri=F,this.viewType=te}}e.$eO=zn;class Un{constructor(F){this.viewType=F}}e.$fO=Un;class Bn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$gO=Bn;class Vn{constructor(F,te,Ee){this.original=F,this.modified=te,this.notebookType=Ee}}e.$hO=Vn;class qn{constructor(){}}e.$iO=qn;class Wn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$jO=Wn;class Hn{constructor(F){this.providerId=F}}e.$kO=Hn;class Gn{constructor(F){this.textDiffs=F}}e.$lO=Gn;var En;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Dn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Dn||(e.ChatCopyKind=Dn={}));var Sn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Kn{constructor(F,te){this.label=F,this.values=te}}e.$mO=Kn;var In;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Cn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class Jn{constructor(F){this.value=typeof F=="string"?new Te(F):F}}e.$nO=Jn;class Qn{constructor(F,te){this.value=F,this.baseUri=te}}e.$oO=Qn;class Xn{constructor(F,te){this.value=F,this.title=te}}e.$pO=Xn;class Zn{constructor(F){this.value=F}}e.$qO=Zn;class Yn{constructor(F){this.value=F}}e.$rO=Yn;class xn{constructor(F){this.value=F}}e.$sO=xn;class _n{constructor(F,te,Ee,Ke){this.prompt=F,this.command=te,this.variables=Ee,this.participant=Ke}}e.$tO=_n;class er{constructor(F,te,Ee,Ke){this.response=F,this.result=te,this.participant=Ee,this.command=Ke}}e.$uO=er;var Pn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(Pn||(e.ChatLocation=Pn={}));class tr{constructor(F){this.content=F}}e.$vO=tr;class ir{constructor(F,te){this.content=F,this.name=te}}e.$wO=ir;class nr{constructor(F,te){this.content=F,this.name=te}}e.$xO=nr;class Oi extends Error{static NotFound(F){return new Oi(F,Oi.NotFound.name)}static NoPermissions(F){return new Oi(F,Oi.NoPermissions.name)}constructor(F,te,Ee){super(F,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$yO=Oi;var Rn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var Mn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Mn||(e.SpeechToTextStatus=Mn={}));var An;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class rr{constructor(F,te){this.text=F,this.range=te}}e.$zO=rr;var On;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(Pe[246],Re([1,0,4,7]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class R{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$qM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,g,d){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(A);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(g,d)??[]}getRelatedInformation(A,g,d){return this.c.$getAiRelatedInformation(g,d)}registerRelatedInformationProvider(A,g,d){const E=this.b;return this.b++,this.a.set(E,d),this.c.$registerAiRelatedInformationProvider(E,g),new T.$sM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$djc=R}),define(Pe[84],Re([1,0,5,4,7,20,106,3,16]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=e.$ojc=void 0,e.$ojc=(0,g.$ii)("IExtHostAuthentication");let E=class{constructor(u){this.b=new Map,this.c=new I.$7d,this.onDidChangeSessions=this.c.event,this.d=new O,this.f=new O,this.a=u.getProxy(T.$qM.MainThreadAuthentication)}async getSession(u,w,m,r={}){const o=N.$Dm.toKey(u.identifier),s=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${w} ${s}`,async()=>{await this.a.$ensureProvider(w);const n=u.displayName||u.name;return this.a.$getSession(w,m,o,n,r)})}async getSessions(u,w,m){const r=N.$Dm.toKey(u.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(w);const s=u.displayName||u.name;return this.a.$getSessions(w,m,r,s)})}async removeSession(u,w){const m=this.b.get(u);return m?m.provider.removeSession(w):this.a.$removeSession(u,w)}registerAuthenticationProvider(u,w,m,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:w,provider:m,options:r??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(u,s));return this.a.$registerAuthenticationProvider(u,w,r?.supportsMultipleAccounts??!1),new R.$sM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,w,m){const r=this.b.get(u);if(r)return Promise.resolve(r.provider.createSession(w,m));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,w){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,w){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,w){return u.startsWith(A.$sL)||this.c.fire({provider:{id:u,label:w}}),Promise.resolve()}};e.$pjc=E,e.$pjc=E=Je([qe(0,d.$LO)],E);class O{constructor(){this.a=new Map}getOrCreate(u,w){const m=this.a.get(u);if(m)return m;const r=w().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Pe[110],Re([1,0,2,4,7,3,16,13,18,15,19,25]),function(ge,e,I,T,R,N,A,g,d,E,O,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0;let w=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(T.$qM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=u.c++;this.f.set(s,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const a=(0,d.$3b)(i);if(a.length<=u.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const h=a.map(c=>({uri:c,rank:(0,E.$1e)(c.path,"/")})),t=(0,d.$zb)(h,(c,$)=>c.rank-$.rank||(0,E.$ef)(c.uri.path,$.uri.path)),v=[];e:for(const c of t){let $;for(const b of c){const p=(0,O.$nc)(b.uri.path);if($!==p&&($=p,v.push(b.uri)>=u.d))break e}}this.g.$onDidChange(s,v)});return new R.$sM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,o,s){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:t,id:v}=h,c=await Promise.resolve(i.provideFileDecoration(I.URI.revive(t),s));if(!c)return;try{R.$RN.validate(c),c.badge&&typeof c.badge!="string"&&(0,y.$cG)(a,"codiconDecoration"),n[v]=[c.propagate,c.tooltip,c.badge,c.color]}catch($){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${$}`)}}catch(t){this.h.error(t)}})),n}};e.$pkc=w,e.$pkc=w=u=Je([qe(0,A.$LO),qe(1,g.$Oj)],w),e.$qkc=(0,N.$ii)("IExtHostDecorations")}),define(Pe[247],Re([1,0,14,2,7,4,12,24,15]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class E{static{this.a=0}constructor(y,u,w){this.d=u,this.e=w,this.b=new Map,this.c=y.getProxy(N.$qM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const w=E.a++;this.b.set(w,u),this.c.$registerTextContentProvider(w,y);let m;if(typeof u.onDidChange=="function"){let r;m=u.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(w,o).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,d.$$e)(n);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,n)}).catch(I.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new R.$sM(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,u){const w=this.b.get(y);return w?Promise.resolve(w.provideTextDocumentContent(T.URI.revive(u),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$skc=E}),define(Pe[111],Re([1,0,56,12,15,303,152,7,18]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0,e.$NO=O;const E=new Map;function O(m,r){r?E.set(m,r):E.delete(m)}function y(m){return E.get(m)}class u extends N.$Hv{constructor(r,o,s,n,i,a,h){super(o,s,n,i),this.c=r,this.m=a,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,d.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===T.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,s){return r.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,I.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,I.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,n=o.start.line,i=o.end.line,a=[];a.push(this.f[n].substring(o.start.character));for(let h=n+1;h<i;h++)a.push(this.f[h]);return a.push(this.f[i].substring(0,o.end.character)),a.join(s)}t(r){let o;if(r instanceof g.$tM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new w(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),s=this.f[o.index].length;return new g.$tM(o.index,Math.min(o.remainder,s))}w(r){if(!(r instanceof g.$uM))throw new Error("Invalid argument");const o=this.x(r.start),s=this.x(r.end);return o===r.start&&s===r.end?r:new g.$uM(o.line,o.character,s.line,s.character)}x(r){if(!(r instanceof g.$tM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:s}=r,n=!1;if(o<0)o=0,s=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,n=!0;else{const i=this.f[o].length;s<0?(s=0,n=!0):s>i&&(s=i,n=!0)}return n?new g.$tM(o,s):r}y(r,o){const s=this.x(r);if(!o)o=y(this.m);else if((0,R.$0e)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,A.$Rs)(s.character+1,(0,A.$Ps)(o),this.f[s.line],0);if(n)return new g.$uM(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$OO=u;class w{constructor(r,o,s){this.a=r,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$uM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$uM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$PO=w}),define(Pe[248],Re([1,0,4,7]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class R{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$qM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,g,d){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(A);if(!E)throw new Error("Embedding vector provider not found");const O=await E.provideEmbeddingVector(g,d);if(!O)throw new Error("Embedding vector provider returned undefined");return O}registerEmbeddingVectorProvider(A,g,d){const E=this.b;return this.b++,this.a.set(E,d),this.c.$registerAiEmbeddingVectorProvider(g,E),new T.$sM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$ukc=R}),define(Pe[64],Re([1,0,4,43,7,22,3,16,44,6,11,23,12]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=e.$Hjc=void 0;let m=w=class{constructor(o,s){this.b=new Map,this.c=new O.$rh,this.a=o.getProxy(I.$qM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let a;const h=n.b.get(i.scheme);return h?(await n.a.$ensureActivation(i.scheme),a=await h.impl.stat(i)):a=await n.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===T.FilePermission.Readonly?1:void 0}}catch(a){w.e(a)}},async readDirectory(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(a){return w.e(a)}},async createDirectory(i){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(a.impl,a.extUri,i)):await n.a.$mkdir(i)}catch(a){return w.e(a)}},async readFile(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(a){return w.e(a)}},async writeFile(i,a){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,N.$ue.wrap(a))}catch(h){return w.e(h)}},async delete(i,a){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await n.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...a})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return w.e(h)}},async rename(i,a,h){try{return await n.a.$rename(i,a,{overwrite:!1,...h})}catch(t){return w.e(t)}},async copy(i,a,h){try{return await n.a.$copy(i,a,{overwrite:!1,...h})}catch(t){return w.e(t)}},isWritableFileSystem(i){const a=s.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(o,s,n){const i=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await o.stat(n)).type&T.FileType.Directory))throw R.$IN.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(T.$5k(a)!==T.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(s.basename(n)),n=s.dirname(n)}for(let a=i.length-1;a>=0;a--){n=s.joinPath(n,i[a]);try{await o.createDirectory(n)}catch(h){if(T.$5k(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof R.$IN)throw o;if(o instanceof T.$1k)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw R.$IN.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw R.$IN.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw R.$IN.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw R.$IN.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw R.$IN.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw R.$IN.Unavailable(o.message);default:throw new R.$IN(o.message,o.name)}if(!(o instanceof Error))throw new R.$IN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$IN.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw R.$IN.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw R.$IN.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw R.$IN.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw R.$IN.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw R.$IN.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw R.$IN.Unavailable(o.message);default:throw new R.$IN(o.message,o.name)}}addFileSystemProvider(o,s,n){return this.b.set(o,{impl:s,extUri:n?.isCaseSensitive?y.$Lg:y.$Ng,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$Lg}};e.$Hjc=m,e.$Hjc=m=w=Je([qe(0,g.$LO),qe(1,d.$ijc)],m),e.$Ijc=(0,A.$ii)("IExtHostConsumerFileSystem")}),define(Pe[249],Re([1,0,4,7]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;class R{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(I.$qM.MainThreadIssueReporter)}async $getIssueReporterUri(A,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const d=this.a.get(A);if(!d)throw new Error("Issue request handler not found");const E=await d.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(A,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(A);if(!d)throw new Error("Issue data provider not found");const E=await d.provideIssueData(g);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(A,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(A);if(!d)throw new Error("Issue data provider not found");const E=await d.provideIssueTemplate(g);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(A,g){const d=A.identifier.value;return this.a.set(d,g),this.c.$registerIssueUriRequestHandler(d),new T.$sM(()=>{this.c.$unregisterIssueUriRequestHandler(d),this.a.delete(d)})}registerIssueDataProvider(A,g){const d=A.identifier.value;return this.b.set(d,g),this.c.$registerIssueDataProvider(d),new T.$sM(()=>{this.c.$unregisterIssueDataProvider(d),this.b.delete(d)})}}e.$Lkc=R}),define(Pe[85],Re([1,0,3,27,13,64,2]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=e.$Jjc=void 0,e.$Jjc=(0,I.$ii)("IExtensionStoragePaths");let g=class{constructor(E,O,y){this.d=O,this.f=y,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(E){return A.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,O=await this.g(E);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(A.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(E){if(this.c)return A.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return A.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Kjc=g,e.$Kjc=g=Je([qe(0,T.$2O),qe(1,R.$Oj),qe(2,N.$Ijc)],g)}),define(Pe[250],Re([1,0,7,16,5]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;let N=class{constructor(g){this.a=new I.$SN(I.ColorThemeKind.Dark),this.b=new R.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(g){let d;switch(g){case"light":d=I.ColorThemeKind.Light;break;case"hcDark":d=I.ColorThemeKind.HighContrast;break;case"hcLight":d=I.ColorThemeKind.HighContrastLight;break;default:d=I.ColorThemeKind.Dark}this.a=new I.$SN(d),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$clc=N,e.$clc=N=Je([qe(0,T.$LO)],N)}),define(Pe[86],Re([1,0,24,5,6,174,3,13,203,4,27,16,7]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Bb=e.$8Bb=e.TunnelDtoConverter=void 0;class w extends d.$7v{}var m;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?d.TunnelPrivacyId.Public:d.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==d.TunnelPrivacyId.ConstantPrivate&&i.privacy!==d.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=n})(m||(e.TunnelDtoConverter=m={})),e.$8Bb=(0,A.$ii)("IExtHostTunnelService");let r=class extends R.$Uc{constructor(s,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$qM.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,s.displayName);if(i){const a=new w(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,i),new u.$sM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,n,i,a,h){const t=[];for(const c of s){const $=this.r.get(c);if(!$)return[];t.push(...await Promise.all(n.map(async b=>{let p;try{p=await $.provider.providePortAttributes({port:b,pid:i,commandLine:a},h)}catch{p=await $.provider.providePortAttributes(b,i,a,h)}return{providedAttributes:p,port:b}})))}const v=t.filter(c=>!!c.providedAttributes);return v.length>0?v.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await s.provideTunnel(a,h,I.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(n&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:h}),m.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),i=s.filter((a,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$9Bb=r,e.$9Bb=r=Je([qe(0,y.$LO),qe(1,O.$2O),qe(2,g.$Oj)],r)}),define(Pe[8],Re([1,0,18,22,132,251,54,28,124,53,69,26,127,23,17,2,29,87,100,105,104,212,83,49,61,223,25,7]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a,h,t,v,c,$,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$IO=K,e.$JO=fe,e.$KO=De;var l;(function(we){function Ce(Q){const{selectionStartLineNumber:be,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:Ge}=Q,ct=new p.$tM(be-1,Be-1),yt=new p.$tM(Xe-1,Ge-1);return new p.$vM(ct,yt)}we.to=Ce;function ce(Q){const{anchor:be,active:Be}=Q;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}we.from=ce})(l||(e.Selection=l={}));var D;(function(we){function Ce(Q){if(!Q)return;const{start:be,end:Be}=Q;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}we.from=Ce;function ce(Q){if(!Q)return;const{startLineNumber:be,startColumn:Be,endLineNumber:Xe,endColumn:Ge}=Q;return new p.$uM(be-1,Be-1,Xe-1,Ge-1)}we.to=ce})(D||(e.Range=D={}));var f;(function(we){function Ce(Q){return{uri:Q.uri,range:D.from(Q.range)}}we.from=Ce;function ce(Q){return new p.$EM(r.URI.revive(Q.uri),D.to(Q.range))}we.to=ce})(f||(e.Location=f={}));var S;(function(we){function Ce(ce){switch(ce){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}we.to=Ce})(S||(e.TokenType=S={}));var k;(function(we){function Ce(Q){return new p.$tM(Q.lineNumber-1,Q.column-1)}we.to=Ce;function ce(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=ce})(k||(e.Position=k={}));var P;(function(we){function Ce(be,Be,Xe){return(0,I.$Hb)((0,I.$3b)(be).map(Ge=>ce(Ge,Be,Xe)))}we.from=Ce;function ce(be,Be,Xe){if(typeof be=="string")return{$serialized:!0,language:be,isBuiltin:Xe?.isBuiltin};if(be)return{$serialized:!0,language:be.language,scheme:Q(be.scheme,Be),pattern:me.from(be.pattern)??void 0,exclusive:be.exclusive,notebookType:be.notebookType,isBuiltin:Xe?.isBuiltin}}function Q(be,Be){return Be&&typeof be=="string"?Be.transformOutgoingScheme(be):be}})(P||(e.DocumentSelector=P={}));var C;(function(we){function Ce(Q){switch(Q){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}we.from=Ce;function ce(Q){switch(Q){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}we.to=ce})(C||(e.DiagnosticTag=C={}));var q;(function(we){function Ce(Q){let be;return Q.code&&((0,m.$Vf)(Q.code)||(0,m.$Zf)(Q.code)?be=String(Q.code):be={value:String(Q.code.value),target:Q.code.target}),{...D.from(Q.range),message:Q.message,source:Q.source,code:be,severity:W.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(V.from),tags:Array.isArray(Q.tags)?(0,I.$Hb)(Q.tags.map(C.from)):void 0}}we.from=Ce;function ce(Q){const be=new p.$GM(D.to(Q),Q.message,W.to(Q.severity));return be.source=Q.source,be.code=(0,m.$Vf)(Q.code)?Q.code:Q.code?.value,be.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(V.to),be.tags=Q.tags&&(0,I.$Hb)(Q.tags.map(C.to)),be}we.to=ce})(q||(e.Diagnostic=q={}));var V;(function(we){function Ce(Q){return{...D.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Ce;function ce(Q){return new p.$FM(new p.$EM(Q.resource,D.to(Q)),Q.message)}we.to=ce})(V||(e.DiagnosticRelatedInformation=V={}));var W;(function(we){function Ce(Q){switch(Q){case p.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}we.from=Ce;function ce(Q){switch(Q){case n.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}we.to=ce})(W||(e.DiagnosticSeverity=W={}));var M;(function(we){function Ce(Q){return typeof Q=="number"&&Q>=p.ViewColumn.One?Q-1:Q===p.ViewColumn.Beside?$.$GD:$.$FD}we.from=Ce;function ce(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ce})(M||(e.ViewColumn=M={}));function z(we){return typeof we.range<"u"}function K(we){return we.length===0?!0:!!z(we[0])}var ie;(function(we){function Ce(Ge){return Ge.map(we.from)}we.fromMany=Ce;function ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Q(Ge){let ct;if(ce(Ge)){const{language:zt,value:Kt}=Ge;ct={value:"```"+zt+`
`+Kt+"\n```\n"}}else p.$TM.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const yt=Object.create(null);ct.uris=yt;const kt=zt=>{try{let Kt=r.URI.parse(zt,!0);Kt=Kt.with({query:be(Kt.query,yt)}),yt[zt]=Kt}catch{}return""},xt=new d.marked.Renderer;return xt.link=kt,xt.image=zt=>typeof zt=="string"?kt(A.$Nk(zt).href):"",(0,d.marked)(ct.value,{renderer:xt}),ct}we.from=Q;function be(Ge,ct){if(!Ge)return Ge;let yt;try{yt=(0,E.$Qh)(Ge)}catch{}if(!yt)return Ge;let kt=!1;return yt=(0,y.$Qn)(yt,xt=>{if(r.URI.isUri(xt)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[zt]=xt,kt=!0,zt}else return}),kt?JSON.stringify(yt):Ge}function Be(Ge){const ct=new p.$TM(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?r.URI.from(Ge.baseUri):void 0,ct}we.to=Be;function Xe(Ge){if(Ge)return typeof Ge=="string"?Ge:we.from(Ge)}we.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function fe(we){return K(we)?we.map(Ce=>({range:D.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?ie.fromMany(Ce.hoverMessage):Ce.hoverMessage?ie.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):we.map(Ce=>({range:D.from(Ce)}))}function De(we){return typeof we>"u"?we:typeof we=="string"?r.URI.file(we):we}var ye;(function(we){function Ce(ce){return typeof ce>"u"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?De(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}we.from=Ce})(ye||(e.ThemableDecorationAttachmentRenderOptions=ye={}));var oe;(function(we){function Ce(ce){return typeof ce>"u"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?De(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?ye.from(ce.before):void 0,after:ce.after?ye.from(ce.after):void 0}}we.from=Ce})(oe||(e.ThemableDecorationRenderOptions=oe={}));var $e;(function(we){function Ce(ce){if(typeof ce>"u")return ce;switch(ce){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ce})($e||(e.DecorationRangeBehavior=$e={}));var ne;(function(we){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?$e.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?oe.from(ce.light):void 0,dark:ce.dark?oe.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?De(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?ye.from(ce.before):void 0,after:ce.after?ye.from(ce.after):void 0}}we.from=Ce})(ne||(e.DecorationRenderOptions=ne={}));var Se;(function(we){function Ce(Q){return{text:Q.newText,eol:Q.newEol&&ft.from(Q.newEol),range:D.from(Q.range)}}we.from=Ce;function ce(Q){const be=new p.$zM(D.to(Q.range),Q.text);return be.newEol=typeof Q.eol>"u"?void 0:ft.to(Q.eol),be}we.to=ce})(Se||(e.TextEdit=Se={}));var je;(function(we){function Ce(Q,be){const Be={edits:[]};if(Q instanceof p.$CM){const Xe=new g.$Cc;for(const Ge of Q._allEntries())Ge._type===1&&r.URI.isUri(Ge.to)&&Ge.from===void 0&&Xe.add(Ge.to);for(const Ge of Q._allEntries())if(Ge._type===1){let ct;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ct={type:"base64",value:(0,T.$Oe)(T.$ue.wrap(Ge.options.contents))}:ct={type:"dataTransferItem",id:Ge.options.contents._itemId}),Be.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ct},metadata:Ge.metadata})}else Ge._type===2?Be.edits.push({resource:Ge.uri,textEdit:Se.from(Ge.edit),versionId:Xe.has(Ge.uri)?void 0:be?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Be.edits.push({resource:Ge.uri,textEdit:{range:D.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ge.uri)?void 0:be?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Be.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:be?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Be.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:be?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Qt.from)}})}return Be}we.from=Ce;function ce(Q){const be=new p.$CM,Be=new g.$Bc;for(const Xe of Q.edits)if(Xe.textEdit){const Ge=Xe,ct=r.URI.revive(Ge.resource),yt=D.to(Ge.textEdit.range),kt=Ge.textEdit.text,xt=Ge.textEdit.insertAsSnippet;let zt;xt?zt=p.$BM.replace(yt,new p.$DM(kt)):zt=p.$zM.replace(yt,kt);const Kt=Be.get(ct);Kt?Kt.push(zt):Be.set(ct,[zt])}else be.renameFile(r.URI.revive(Xe.oldResource),r.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ge]of Be)be.set(Xe,Ge);return be}we.to=ce})(je||(e.WorkspaceEdit=je={}));var re;(function(we){const Ce=Object.create(null);Ce[p.SymbolKind.File]=0,Ce[p.SymbolKind.Module]=1,Ce[p.SymbolKind.Namespace]=2,Ce[p.SymbolKind.Package]=3,Ce[p.SymbolKind.Class]=4,Ce[p.SymbolKind.Method]=5,Ce[p.SymbolKind.Property]=6,Ce[p.SymbolKind.Field]=7,Ce[p.SymbolKind.Constructor]=8,Ce[p.SymbolKind.Enum]=9,Ce[p.SymbolKind.Interface]=10,Ce[p.SymbolKind.Function]=11,Ce[p.SymbolKind.Variable]=12,Ce[p.SymbolKind.Constant]=13,Ce[p.SymbolKind.String]=14,Ce[p.SymbolKind.Number]=15,Ce[p.SymbolKind.Boolean]=16,Ce[p.SymbolKind.Array]=17,Ce[p.SymbolKind.Object]=18,Ce[p.SymbolKind.Key]=19,Ce[p.SymbolKind.Null]=20,Ce[p.SymbolKind.EnumMember]=21,Ce[p.SymbolKind.Struct]=22,Ce[p.SymbolKind.Event]=23,Ce[p.SymbolKind.Operator]=24,Ce[p.SymbolKind.TypeParameter]=25;function ce(be){return typeof Ce[be]=="number"?Ce[be]:6}we.from=ce;function Q(be){for(const Be in Ce)if(Ce[Be]===be)return Number(Be);return p.SymbolKind.Property}we.to=Q})(re||(e.SymbolKind=re={}));var L;(function(we){function Ce(Q){switch(Q){case p.SymbolTag.Deprecated:return 1}}we.from=Ce;function ce(Q){switch(Q){case 1:return p.SymbolTag.Deprecated}}we.to=ce})(L||(e.SymbolTag=L={}));var _;(function(we){function Ce(Q){return{name:Q.name,kind:re.from(Q.kind),tags:Q.tags&&Q.tags.map(L.from),containerName:Q.containerName,location:de.from(Q.location)}}we.from=Ce;function ce(Q){const be=new p.$KM(Q.name,re.to(Q.kind),Q.containerName,de.to(Q.location));return be.tags=Q.tags&&Q.tags.map(L.to),be}we.to=ce})(_||(e.WorkspaceSymbol=_={}));var ve;(function(we){function Ce(Q){const be={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),kind:re.from(Q.kind),tags:Q.tags?.map(L.from)??[]};return Q.children&&(be.children=Q.children.map(Ce)),be}we.from=Ce;function ce(Q){const be=new p.$LM(Q.name,Q.detail,re.to(Q.kind),D.to(Q.range),D.to(Q.selectionRange));return(0,I.$Lb)(Q.tags)&&(be.tags=Q.tags.map(L.to)),Q.children&&(be.children=Q.children.map(ce)),be}we.to=ce})(ve||(e.DocumentSymbol=ve={}));var Oe;(function(we){function Ce(Q){const be=new p.$PM(re.to(Q.kind),Q.name,Q.detail||"",r.URI.revive(Q.uri),D.to(Q.range),D.to(Q.selectionRange));return be._sessionId=Q._sessionId,be._itemId=Q._itemId,be}we.to=Ce;function ce(Q,be,Be){if(be=be??Q._sessionId,Be=Be??Q._itemId,be===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Be,name:Q.name,detail:Q.detail,kind:re.from(Q.kind),uri:Q.uri,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),tags:Q.tags?.map(L.from)}}we.from=ce})(Oe||(e.CallHierarchyItem=Oe={}));var ke;(function(we){function Ce(ce){return new p.$QM(Oe.to(ce.from),ce.fromRanges.map(Q=>D.to(Q)))}we.to=Ce})(ke||(e.CallHierarchyIncomingCall=ke={}));var pe;(function(we){function Ce(ce){return new p.$RM(Oe.to(ce.to),ce.fromRanges.map(Q=>D.to(Q)))}we.to=Ce})(pe||(e.CallHierarchyOutgoingCall=pe={}));var de;(function(we){function Ce(Q){return{range:Q.range&&D.from(Q.range),uri:Q.uri}}we.from=Ce;function ce(Q){return new p.$EM(r.URI.revive(Q.uri),D.to(Q.range))}we.to=ce})(de||(e.location=de={}));var J;(function(we){function Ce(Q){const be=Q,Be=Q;return{originSelectionRange:be.originSelectionRange?D.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:Be.uri,range:D.from(be.targetRange?be.targetRange:Be.range),targetSelectionRange:be.targetSelectionRange?D.from(be.targetSelectionRange):void 0}}we.from=Ce;function ce(Q){return{targetUri:r.URI.revive(Q.uri),targetRange:D.to(Q.range),targetSelectionRange:Q.targetSelectionRange?D.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?D.to(Q.originSelectionRange):void 0}}we.to=ce})(J||(e.DefinitionLink=J={}));var Y;(function(we){function Ce(Q){return{range:D.from(Q.range),contents:ie.fromMany(Q.contents)}}we.from=Ce;function ce(Q){return new p.$HM(Q.contents.map(ie.to),D.to(Q.range))}we.to=ce})(Y||(e.Hover=Y={}));var ue;(function(we){function Ce(Q){return{range:D.from(Q.range),expression:Q.expression}}we.from=Ce;function ce(Q){return new p.$CN(D.to(Q.range),Q.expression)}we.to=ce})(ue||(e.EvaluatableExpression=ue={}));var he;(function(we){function Ce(Q){if(Q instanceof p.$DN)return{type:"text",range:D.from(Q.range),text:Q.text};if(Q instanceof p.$EN)return{type:"variable",range:D.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof p.$FN)return{type:"expression",range:D.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ce;function ce(Q){switch(Q.type){case"text":return{range:D.to(Q.range),text:Q.text};case"variable":return{range:D.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:D.to(Q.range),expression:Q.expression}}}we.to=ce})(he||(e.InlineValue=he={}));var Ne;(function(we){function Ce(Q){return{frameId:Q.frameId,stoppedLocation:D.from(Q.stoppedLocation)}}we.from=Ce;function ce(Q){return new p.$GN(Q.frameId,D.to(Q.stoppedLocation))}we.to=ce})(Ne||(e.InlineValueContext=Ne={}));var le;(function(we){function Ce(Q){return{range:D.from(Q.range),kind:Q.kind}}we.from=Ce;function ce(Q){return new p.$IM(D.to(Q.range),Q.kind)}we.to=ce})(le||(e.DocumentHighlight=le={}));var Ie;(function(we){function Ce(Q){return{uri:Q.uri,highlights:Q.highlights.map(le.from)}}we.from=Ce;function ce(Q){return new p.$JM(r.URI.revive(Q.uri),Q.highlights.map(le.to))}we.to=ce})(Ie||(e.MultiDocumentHighlight=Ie={}));var Ae;(function(we){function Ce(ce){switch(ce){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}we.to=Ce})(Ae||(e.CompletionTriggerKind=Ae={}));var ze;(function(we){function Ce(ce){return{triggerKind:Ae.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}we.to=Ce})(ze||(e.CompletionContext=ze={}));var U;(function(we){function Ce(Q){switch(Q){case p.CompletionItemTag.Deprecated:return 1}}we.from=Ce;function ce(Q){switch(Q){case 1:return p.CompletionItemTag.Deprecated}}we.to=ce})(U||(e.CompletionItemTag=U={}));var j;(function(we){const Ce=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ce(Be){return Ce.get(Be)??9}we.from=ce;const Q=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function be(Be){return Q.get(Be)??p.CompletionItemKind.Property}we.to=be})(j||(e.CompletionItemKind=j={}));var G;(function(we){function Ce(ce,Q){const be=new p.$ZM(ce.label);return be.insertText=ce.insertText,be.kind=j.to(ce.kind),be.tags=ce.tags?.map(U.to),be.detail=ce.detail,be.documentation=A.$Hk(ce.documentation)?ie.to(ce.documentation):ce.documentation,be.sortText=ce.sortText,be.filterText=ce.filterText,be.preselect=ce.preselect,be.commitCharacters=ce.commitCharacters,o.$ct.isIRange(ce.range)?be.range=D.to(ce.range):typeof ce.range=="object"&&(be.range={inserting:D.to(ce.range.insert),replacing:D.to(ce.range.replace)}),be.keepWhitespace=typeof ce.insertTextRules>"u"?!1:!!(ce.insertTextRules&1),typeof ce.insertTextRules<"u"&&ce.insertTextRules&4?be.insertText=new p.$DM(ce.insertText):(be.insertText=ce.insertText,be.textEdit=be.range instanceof p.$uM?new p.$zM(be.range,be.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(be.additionalTextEdits=ce.additionalTextEdits.map(Be=>Se.to(Be))),be.command=Q&&ce.command?Q.fromInternal(ce.command):void 0,be}we.to=Ce})(G||(e.CompletionItem=G={}));var H;(function(we){function Ce(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:ie.fromStrict(Q.documentation)}}we.from=Ce;function ce(Q){return{label:Q.label,documentation:A.$Hk(Q.documentation)?ie.to(Q.documentation):Q.documentation}}we.to=ce})(H||(e.ParameterInformation=H={}));var ee;(function(we){function Ce(Q){return{label:Q.label,documentation:ie.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.from):[],activeParameter:Q.activeParameter}}we.from=Ce;function ce(Q){return{label:Q.label,documentation:A.$Hk(Q.documentation)?ie.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.to):[],activeParameter:Q.activeParameter}}we.to=ce})(ee||(e.SignatureInformation=ee={}));var se;(function(we){function Ce(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ee.from):[]}}we.from=Ce;function ce(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ee.to):[]}}we.to=ce})(se||(e.SignatureHelp=se={}));var Te;(function(we){function Ce(ce,Q){const be=new p.$YM(k.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Ve.to.bind(void 0,ce)),Q.kind&&Qe.to(Q.kind));return be.textEdits=Q.textEdits&&Q.textEdits.map(Se.to),be.tooltip=A.$Hk(Q.tooltip)?ie.to(Q.tooltip):Q.tooltip,be.paddingLeft=Q.paddingLeft,be.paddingRight=Q.paddingRight,be}we.to=Ce})(Te||(e.InlayHint=Te={}));var Ve;(function(we){function Ce(ce,Q){const be=new p.$XM(Q.label);return be.tooltip=A.$Hk(Q.tooltip)?ie.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(be.command=ce.fromInternal(Q.command)),Q.location&&(be.location=de.to(Q.location)),be}we.to=Ce})(Ve||(e.InlayHintLabelPart=Ve={}));var Qe;(function(we){function Ce(Q){return Q}we.from=Ce;function ce(Q){return Q}we.to=ce})(Qe||(e.InlayHintKind=Qe={}));var xe;(function(we){function Ce(Q){return{range:D.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Ce;function ce(Q){let be;if(Q.url)try{be=typeof Q.url=="string"?r.URI.parse(Q.url,!0):r.URI.revive(Q.url)}catch{}return new p.$5M(D.to(Q.range),be)}we.to=ce})(xe||(e.DocumentLink=xe={}));var et;(function(we){function Ce(Q){const be=new p.$8M(Q.label);return Q.textEdit&&(be.textEdit=Se.to(Q.textEdit)),Q.additionalTextEdits&&(be.additionalTextEdits=Q.additionalTextEdits.map(Be=>Se.to(Be))),be}we.to=Ce;function ce(Q){return{label:Q.label,textEdit:Q.textEdit?Se.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(be=>Se.from(be)):void 0}}we.from=ce})(et||(e.ColorPresentation=et={}));var ot;(function(we){function Ce(Q){return new p.$6M(Q[0],Q[1],Q[2],Q[3])}we.to=Ce;function ce(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=ce})(ot||(e.Color=ot={}));var it;(function(we){function Ce(Q){return{range:D.from(Q.range)}}we.from=Ce;function ce(Q){return new p.$OM(D.to(Q.range))}we.to=ce})(it||(e.SelectionRange=it={}));var nt;(function(we){function Ce(ce){switch(ce){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}we.to=Ce})(nt||(e.TextDocumentSaveReason=nt={}));var at;(function(we){function Ce(Q){switch(Q){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ce;function ce(Q){switch(Q){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}we.to=ce})(at||(e.TextEditorLineNumbersStyle=at={}));var ft;(function(we){function Ce(Q){if(Q===p.EndOfLine.CRLF)return 1;if(Q===p.EndOfLine.LF)return 0}we.from=Ce;function ce(Q){if(Q===1)return p.EndOfLine.CRLF;if(Q===0)return p.EndOfLine.LF}we.to=ce})(ft||(e.EndOfLine=ft={}));var Ue;(function(we){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ce})(Ue||(e.ProgressLocation=Ue={}));var st;(function(we){function Ce(Q){const be={start:Q.start+1,end:Q.end+1};return Q.kind&&(be.kind=Z.from(Q.kind)),be}we.from=Ce;function ce(Q){const be={start:Q.start-1,end:Q.end-1};return Q.kind&&(be.kind=Z.to(Q.kind)),be}we.to=ce})(st||(e.FoldingRange=st={}));var Z;(function(we){function Ce(Q){if(Q)switch(Q){case p.FoldingRangeKind.Comment:return s.$7t.Comment;case p.FoldingRangeKind.Imports:return s.$7t.Imports;case p.FoldingRangeKind.Region:return s.$7t.Region}}we.from=Ce;function ce(Q){if(Q)switch(Q.value){case s.$7t.Comment.value:return p.FoldingRangeKind.Comment;case s.$7t.Imports.value:return p.FoldingRangeKind.Imports;case s.$7t.Region.value:return p.FoldingRangeKind.Region}}we.to=ce})(Z||(e.FoldingRangeKind=Z={}));var X;(function(we){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?D.from(ce.selection):void 0,override:typeof ce.override=="boolean"?a.$9E.id:void 0}}we.from=Ce})(X||(e.TextEditorOpenOptions=X={}));var me;(function(we){function Ce(Be){return Be instanceof p.$qN?Be.toJSON():typeof Be=="string"?Be:ce(Be)||Q(Be)?new p.$qN(Be.baseUri??Be.base,Be.pattern).toJSON():Be}we.from=Ce;function ce(Be){const Xe=Be;return Xe?r.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Q(Be){const Xe=Be;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function be(Be){return typeof Be=="string"?Be:new p.$qN(r.URI.revive(Be.baseUri),Be.pattern)}we.to=be})(me||(e.GlobPattern=me={}));var We;(function(we){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const Q=ce;return{language:Q.language,scheme:Q.scheme,pattern:me.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Ce})(We||(e.LanguageSelector=We={}));var Ze;(function(we){function Ce(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(be=>Array.isArray(be)&&be.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&r.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Xe=>Xe instanceof p.$uM)))}we.is=Ce;function ce(Q){return{documents:Q.documents.map(be=>be.map(Be=>({uri:r.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Xe=>D.from(Xe))})))}}we.from=ce})(Ze||(e.MappedEditsContext=Ze={}));var Me;(function(we){function Ce(Q){return{start:Q.start,end:Q.end}}we.from=Ce;function ce(Q){return new p.$TN(Q.start,Q.end)}we.to=ce})(Me||(e.NotebookRange=Me={}));var ht;(function(we){function Ce(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Ce;function ce(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=ce})(ht||(e.NotebookCellExecutionSummary=ht={}));var Pt;(function(we){function Ce(ce){if(ce===t.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(ce===t.NotebookCellExecutionState.Pending)return;if(ce===t.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ce}`)}we.to=Ce})(Pt||(e.NotebookCellExecutionState=Pt={}));var Bt;(function(we){function Ce(Q){switch(Q){case p.NotebookCellKind.Markup:return t.CellKind.Markup;case p.NotebookCellKind.Code:default:return t.CellKind.Code}}we.from=Ce;function ce(Q){switch(Q){case t.CellKind.Markup:return p.NotebookCellKind.Markup;case t.CellKind.Code:default:return p.NotebookCellKind.Code}}we.to=ce})(Bt||(e.NotebookCellKind=Bt={}));var _t;(function(we){function Ce(Q){const be={metadata:Q.metadata??Object.create(null),cells:[]};for(const Be of Q.cells)p.$UN.validate(Be),be.cells.push(Qt.from(Be));return be}we.from=Ce;function ce(Q){const be=new p.$VN(Q.cells.map(Qt.to));return(0,m.$9f)(Q.metadata)||(be.metadata=Q.metadata),be}we.to=ce})(_t||(e.NotebookData=_t={}));var Qt;(function(we){function Ce(Q){return{cellKind:Bt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ht.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(St.from):[]}}we.from=Ce;function ce(Q){return new p.$UN(Bt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(St.to):void 0,Q.metadata,Q.internalMetadata?ht.to(Q.internalMetadata):void 0)}we.to=ce})(Qt||(e.NotebookCellData=Qt={}));var ei;(function(we){function Ce(Q){return{mime:Q.mime,valueBytes:T.$ue.wrap(Q.data)}}we.from=Ce;function ce(Q){return new p.$WN(Q.valueBytes.buffer,Q.mime)}we.to=ce})(ei||(e.NotebookCellOutputItem=ei={}));var St;(function(we){function Ce(Q){return{outputId:Q.id,items:Q.items.map(ei.from),metadata:Q.metadata}}we.from=Ce;function ce(Q){const be=Q.items.map(ei.to);return new p.$XN(be,Q.outputId,Q.metadata)}we.to=ce})(St||(e.NotebookCellOutput=St={}));var Xt;(function(we){function Ce(be){return Q(be)?{include:me.from(be.include)??void 0,exclude:me.from(be.exclude)??void 0}:me.from(be)??void 0}we.from=Ce;function ce(be){return Q(be)?{include:me.to(be.include),exclude:me.to(be.exclude)}:me.to(be)}we.to=ce;function Q(be){const Be=be;return Be?!(0,m.$5f)(Be.include)&&!(0,m.$5f)(Be.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Wt;(function(we){function Ce(ce,Q,be){const Be=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Be,be),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}we.from=Ce})(Wt||(e.NotebookStatusBarItem=Wt={}));var ci;(function(we){function Ce(ce,Q,be){const Be=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{command:Q.toInternal(Be,be),label:ce.label,description:ce.description,detail:ce.detail,documentation:ce.documentation}}we.from=Ce})(ci||(e.NotebookKernelSourceAction=ci={}));var Ye;(function(we){function Ce(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{},cellContentMetadata:ce?.cellContentMetadata??{}}}we.from=Ce})(Ye||(e.NotebookDocumentContentOptions=Ye={}));var ti;(function(we){function Ce(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Ce;function ce(Q){return new p.$ZN(r.URI.revive(Q.uri),Q.provides)}we.to=ce})(ti||(e.NotebookRendererScript=ti={}));var ii;(function(we){function Ce(Q){return{message:ie.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:D.from(Q.location.range),uri:Q.location.uri}}}we.from=Ce;function ce(Q){const be=new p.$6N(typeof Q.message=="string"?Q.message:ie.to(Q.message));return be.actualOutput=Q.actual,be.expectedOutput=Q.expected,be.contextValue=Q.contextValue,be.location=Q.location?de.to(Q.location):void 0,be}we.to=ce})(ii||(e.TestMessage=ii={}));var Ht;(function(we){we.namespace=c.$hL,we.denamespace=c.$iL})(Ht||(e.TestTag=Ht={}));var lt;(function(we){function Ce(Q){const be=(0,i.$HO)(Q).controllerId;return{extId:v.$cL.fromExtHostTestItem(Q,be).toString(),label:Q.label,uri:r.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Be=>Ht.namespace(be,Be.id)),range:o.$ct.lift(D.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&ie.fromStrict(Q.error)||null}}we.from=Ce;function ce(Q){return{parent:void 0,error:void 0,id:v.$cL.fromString(Q.extId).localId,label:Q.label,uri:r.URI.revive(Q.uri),tags:(Q.tags||[]).map(be=>{const{tagId:Be}=Ht.denamespace(be);return new p.$7N(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=ce})(lt||(e.TestItem=lt={})),function(we){function Ce(Q){return{id:Q.id}}we.from=Ce;function ce(Q){return new p.$7N(Q.id)}we.to=ce}(Ht||(e.TestTag=Ht={}));var vt;(function(we){const Ce=(Q,be)=>{const Be=Q.value;if(!Be)return;const Xe={...lt.toPlain(Be.item),parent:be,taskStates:Be.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ct=>ct.type===0).map(ii.to)})),children:[]};if(Q.children)for(const Ge of Q.children.values()){const ct=Ce(Ge,Xe);ct&&Xe.children.push(ct)}return Xe};function ce(Q){const be=new u.$AO;for(const Ge of Q.items)be.insert(v.$cL.fromString(Ge.item.extId).path,Ge);const Be=[be.nodes],Xe=[];for(;Be.length;)for(const Ge of Be.pop())Ge.value?Xe.push(Ge):Ge.children&&Be.push(Ge.children.values());return{completedAt:Q.completedAt,results:Xe.map(Ge=>Ce(Ge)).filter(m.$4f)}}we.to=ce})(vt||(e.TestResults=vt={}));var ai;(function(we){function Ce(Be){return{covered:Be.covered,total:Be.total}}function ce(Be){return"line"in Be?k.from(Be):D.from(Be)}function Q(Be){return"branches"in Be?{count:Be.executed,location:ce(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ce(Xe.location),label:Xe.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:ce(Be.location)}}we.fromDetails=Q;function be(Be,Xe){return{id:Be,uri:Xe.uri,statement:Ce(Xe.statementCoverage),branch:Xe.branchCoverage&&Ce(Xe.branchCoverage),declaration:Xe.declarationCoverage&&Ce(Xe.declarationCoverage)}}we.fromFile=be})(ai||(e.TestCoverage=ai={}));var Gt;(function(we){function Ce(ce){switch(ce){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}we.to=Ce})(Gt||(e.CodeActionTriggerKind=Gt={}));var Vt;(function(we){function Ce(Q){const be=new p.$aO(re.to(Q.kind),Q.name,Q.detail||"",r.URI.revive(Q.uri),D.to(Q.range),D.to(Q.selectionRange));return be._sessionId=Q._sessionId,be._itemId=Q._itemId,be}we.to=Ce;function ce(Q,be,Be){if(be=be??Q._sessionId,Be=Be??Q._itemId,be===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Be,kind:re.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),tags:Q.tags?.map(L.from)}}we.from=ce})(Vt||(e.TypeHierarchyItem=Vt={}));var gt;(function(we){function Ce(ce){if(ce)return{value:ce.value,tooltip:ce.tooltip}}we.from=Ce})(gt||(e.ViewBadge=gt={}));var It;(function(we){function Ce(Be,Xe,Ge){const ct=Xe.fileData;return ct?new p.$iN(new p.$jN(ct.name,r.URI.revive(ct.uri),ct.id,(0,N.$db)(()=>Ge(ct.id)))):Be===O.$zs.uriList&&Xe.uriListData?new p.$hN(be(Xe.uriListData)):new p.$hN(Xe.asString)}we.to=Ce;async function ce(Be,Xe){const Ge=await Xe.asString();if(Be===O.$zs.uriList)return{asString:Ge,fileData:void 0,uriListData:Q(Ge)};const ct=Xe.asFile();return{asString:Ge,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}we.from=ce;function Q(Be){return R.$Lt.split(Be).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return r.URI.parse(Xe)}catch{}return Xe})}function be(Be){return R.$Lt.create(Be.map(Xe=>typeof Xe=="string"?Xe:r.URI.revive(Xe)))}})(It||(e.DataTransferItem=It={}));var ui;(function(we){function Ce(Q,be){const Be=Q.items.map(([Xe,Ge])=>[Xe,It.to(Xe,Ge,be)]);return new p.$kN(Be)}we.toDataTransfer=Ce;async function ce(Q){const be={items:[]},Be=[];for(const[Xe,Ge]of Q)Be.push((async()=>{be.items.push([Xe,await It.from(Xe,Ge)])})());return await Promise.all(Be),be}we.from=ce})(ui||(e.DataTransfer=ui={}));var Zt;(function(we){function Ce(Q,be){return{kind:"reply",agentId:Q.participant??be?.agentId??"",subCommand:Q.command??be?.command,message:Q.prompt,title:Q.label}}we.from=Ce;function ce(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=ce})(Zt||(e.ChatFollowup=Zt={}));var He;(function(we){function Ce(ce){return"commandId"in ce?{kind:"command",title:ce.title??"",commandId:ce.commandId??"",when:ce.when??"",args:ce.args}:{kind:"reply",message:ce.message,title:ce.title,tooltip:ce.tooltip}}we.from=Ce})(He||(e.ChatInlineFollowup=He={}));var Tt;(function(we){function Ce(Q){switch(Q.role){case 0:return new p.$vO(Q.content);case 1:return new p.$wO(Q.content);case 2:return new p.$xO(Q.content)}}we.to=Ce;function ce(Q){if(Q instanceof p.$vO)return{role:0,content:Q.content};if(Q instanceof p.$wO)return{role:1,content:Q.content};if(Q instanceof p.$xO)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}we.from=ce})(Tt||(e.LanguageModelMessage=Tt={}));var qt;(function(we){function Ce(be){const Be={};for(const Xe of Object.keys(be))Be[Xe]=be[Xe].map(we.to);return Be}we.objectTo=Ce;function ce(be){return{level:ni.to(be.level),kind:be.kind,value:(0,r.$wc)(be.value)?r.URI.revive(be.value):be.value,description:be.description}}we.to=ce;function Q(be){return{level:ni.from(be.level),kind:be.kind,value:be.value,description:be.description}}we.from=Q})(qt||(e.ChatVariable=qt={}));var ni;(function(we){function Ce(Q){switch(Q){case"short":return p.ChatVariableLevel.Short;case"medium":return p.ChatVariableLevel.Medium;case"full":default:return p.ChatVariableLevel.Full}}we.to=Ce;function ce(Q){switch(Q){case p.ChatVariableLevel.Short:return"short";case p.ChatVariableLevel.Medium:return"medium";case p.ChatVariableLevel.Full:default:return"full"}}we.from=ce})(ni||(e.ChatVariableLevel=ni={}));var $t;(function(we){function Ce(ce){switch(ce){case 1:return p.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return p.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return p.InteractiveEditorResponseFeedbackKind.Undone;case 3:return p.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return p.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Ce})($t||(e.InteractiveEditorResponseFeedbackKind=$t={}));var Ot;(function(we){function Ce(Q){return{kind:"markdownContent",content:ie.from(Q.value)}}we.to=Ce;function ce(Q){return new p.$nO(ie.to(Q.content))}we.from=ce})(Ot||(e.ChatResponseMarkdownPart=Ot={}));var Rt;(function(we){function Ce(Q){const{value:be,baseUri:Be}=Q;function Xe(Ge,ct){return Ge.map(yt=>{const kt=r.URI.joinPath(ct,yt.name);return{label:yt.name,uri:kt,children:yt.children&&Xe(yt.children,kt)}})}return{kind:"treeData",treeData:{label:(0,w.$Sg)(Be),uri:Be,children:Xe(be,Be)}}}we.to=Ce;function ce(Q){const be=(0,E.$Rh)(Q.treeData);function Be(ct){return ct.map(yt=>({name:yt.label,children:yt.children&&Be(yt.children)}))}const Xe=be.uri,Ge=be.children?Be(be.children):[];return new p.$oO(Ge,Xe)}we.from=ce})(Rt||(e.ChatResponseFilesPart=Rt={}));var Nt;(function(we){function Ce(Q){return{kind:"inlineReference",name:Q.title,inlineReference:r.URI.isUri(Q.value)?Q.value:f.from(Q.value)}}we.to=Ce;function ce(Q){const be=(0,E.$Rh)(Q);return new p.$pO(r.URI.isUri(be.inlineReference)?be.inlineReference:f.to(be.inlineReference),Q.name)}we.from=ce})(Nt||(e.ChatResponseAnchorPart=Nt={}));var li;(function(we){function Ce(Q){return{kind:"progressMessage",content:ie.from(Q.value)}}we.to=Ce;function ce(Q){return new p.$qO(Q.content.value)}we.from=ce})(li||(e.ChatResponseProgressPart=li={}));var Ft;(function(we){function Ce(Q,be,Be){return{kind:"command",command:be.toInternal(Q.value,Be)??{command:Q.value.command,title:Q.value.title}}}we.to=Ce;function ce(Q,be){return new p.$rO(be.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.from=ce})(Ft||(e.ChatResponseCommandButtonPart=Ft={}));var Lt;(function(we){function Ce(Q){return{kind:"reference",reference:r.URI.isUri(Q.value)?Q.value:f.from(Q.value)}}we.to=Ce;function ce(Q){const be=(0,E.$Rh)(Q);return new p.$sO(r.URI.isUri(be.reference)?be.reference:f.to(be.reference))}we.from=ce})(Lt||(e.ChatResponseReferencePart=Lt={}));var Et;(function(we){function Ce(be,Be,Xe){return be instanceof p.$nO?Ot.to(be):be instanceof p.$pO?Nt.to(be):be instanceof p.$sO?Lt.to(be):be instanceof p.$qO?li.to(be):be instanceof p.$oO?Rt.to(be):be instanceof p.$rO?Ft.to(be,Be,Xe):{kind:"content",content:""}}we.to=Ce;function ce(be,Be){switch(be.kind){case"reference":return Lt.from(be);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(be,Be)}}we.from=ce;function Q(be,Be){switch(be.kind){case"markdownContent":return Ot.from(be);case"inlineReference":return Nt.from(be);case"progressMessage":return;case"treeData":return Rt.from(be);case"command":return Ft.from(be,Be)}}we.fromContent=Q})(Et||(e.ChatResponsePart=Et={}));var At;(function(we){function Ce(be,Be){return"markdownContent"in Be?((0,b.$cG)(be,"chatParticipantAdditions"),{content:ie.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,b.$cG)(be,"chatParticipantAdditions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,b.$cG)(be,"chatParticipantAdditions"),{content:ie.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(Xe=>({uri:Xe.uri,version:Xe.version,ranges:Xe.ranges.map(Ge=>D.from(Ge))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:D.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:D.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"participant"in Be?((0,b.$cG)(be,"chatParticipantAdditions"),{agentId:Be.participant,command:Be.command,kind:"agentDetection"}):"message"in Be?{content:ie.from(Be.message),kind:"progressMessage"}:void 0}we.from=Ce;function ce(be){switch(be.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(be);case"content":return{content:be.content};case"usedContext":return{documents:be.documents.map(Be=>({uri:r.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(Xe=>D.to(Xe))}))};case"reference":return{reference:(0,r.$wc)(be.reference)?r.URI.revive(be.reference):f.to(be.reference)};case"agentDetection":return;case"progressMessage":return{message:be.content.value};case"vulnerability":return{content:be.content,vulnerabilities:be.vulnerabilities};default:return}}we.to=ce;function Q(be,Be){switch(be.kind){case"markdownContent":return{content:be.content.value};case"inlineReference":return{inlineReference:(0,r.$wc)(be.inlineReference)?r.URI.revive(be.inlineReference):f.to(be.inlineReference),title:be.name};case"command":return{command:Be.fromInternal(be.command)??{command:be.command.id,title:be.command.title}};default:return}}we.toProgressContent=Q})(At||(e.ChatResponseProgress=At={}));var ri;(function(we){function Ce(ce){return{prompt:ce.message,command:ce.command,variables:ce.variables.variables.map(wt.to),location:jt.to(ce.location)}}we.to=Ce})(ri||(e.ChatAgentRequest=ri={}));var jt;(function(we){function Ce(ce){switch(ce){case h.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return p.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return p.ChatLocation.Editor}}we.to=Ce})(jt||(e.ChatLocation=jt={}));var wt;(function(we){function Ce(ce){return{name:ce.name,range:ce.range&&[ce.range.start,ce.range.endExclusive],values:ce.values.map(qt.to)}}we.to=Ce})(wt||(e.ChatAgentResolvedVariable=wt={}));var Ct;(function(we){function Ce(ce){return{label:ce.label,values:ce.values.map(qt.from),insertText:ce.insertText,detail:ce.detail,documentation:ce.documentation}}we.from=Ce})(Ct||(e.ChatAgentCompletionItem=Ct={}));var fi;(function(we){function Ce(ce){return{errorDetails:ce.errorDetails,metadata:ce.metadata}}we.to=Ce})(fi||(e.ChatAgentResult=fi={}));var Dt;(function(we){function Ce(ce,Q,be){if(Q.action.kind==="vote")return;const Be=fi.to(ce);return Q.action.kind==="command"?{action:{kind:"command",commandButton:At.toProgressContent(Q.action.commandButton,be)},result:Be}:Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Zt.to(Q.action.followup)},result:Be}:{action:Q.action,result:Be}}we.to=Ce})(Dt||(e.ChatAgentUserActionEvent=Dt={}));var si;(function(we){function Ce(ce,Q,be){return"terminalCommand"in ce?{terminalCommand:ce.terminalCommand,shouldExecute:ce.shouldExecute}:"uri"in ce?{uri:ce.uri}:Q.toInternal(ce,be)}we.from=Ce})(si||(e.TerminalQuickFix=si={}));var Yt;(function(we){function Ce(ce){return{kind:oi.to(ce.kind)}}we.to=Ce})(Yt||(e.PartialAcceptInfo=Yt={}));var oi;(function(we){function Ce(ce){switch(ce){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}we.to=Ce})(oi||(e.PartialAcceptTriggerKind=oi={}));var gi;(function(we){function Ce(ce,Q){return{id:Q,label:ce.label,description:ce.description,canEdit:ce.canEdit,collapsibleState:ce.collapsibleState||0,contextValue:ce.contextValue}}we.from=Ce})(gi||(e.DebugTreeItem=gi={}))}),define(Pe[252],Re([1,0,4,16,8]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;let N=class{constructor(g,d){this.a=g.getProxy(I.$qM.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>d.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,d,E){const O=R.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,E?.isRefactoring??!1)}};e.$qjc=N,e.$qjc=N=Je([qe(0,T.$LO)],N)}),define(Pe[253],Re([1,0,18,11,42,5,39,6,65,17,2,163,20,4,8,7,213,25]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;class n{constructor(t,v,c,$,b,p){this.i=t,this.j=v,this.k=c,this.l=$,this.m=b,this.n=p,this.b=d.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let v=function($){if(t.c){const b=new Error("Response stream has been closed");throw Error.captureStackTrace(b,$),b}};const t=this;this.b.reset();const c=$=>{typeof this.d>"u"&&"content"in $&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,$)};this.g={markdown($){v(this.markdown);const b=new r.$nO($),p=m.ChatResponseMarkdownPart.to(b);return c(p),this},filetree($,b){v(this.filetree);const p=new r.$oO($,b),l=m.ChatResponseFilesPart.to(p);return c(l),this},anchor($,b){v(this.anchor);const p=new r.$pO($,b),l=m.ChatResponseAnchorPart.to(p);return c(l),this},button($){v(this.anchor);const b=new r.$rO($),p=m.ChatResponseCommandButtonPart.to(b,t.m,t.n);return c(p),this},progress($){v(this.progress);const b=new r.$qO($),p=m.ChatResponseProgressPart.to(b);return c(p),this},reference($){v(this.reference);const b=new r.$sO($),p=m.ChatResponseReferencePart.to(b);return c(p),this},push($){v(this.push);const b=m.ChatResponsePart.to($,t.m,t.n);return c(b),this},report($){if(v(this.report),"placeholder"in $&&"resolvedContent"in $)return;const b=m.ChatResponseProgress.from(t.i,$);if(!b){t.l.error("Unknown progress type: "+JSON.stringify($));return}return c(b),this}}}return this.g}}class i{static{this.b=0}constructor(t,v,c){this.i=v,this.j=c,this.c=new Map,this.g=new g.$4c,this.d=t.getProxy(w.$qM.MainThreadChatAgents2)}createChatAgent(t,v,c){const $=i.b++,b=new a(t,v,this.d,$,c);return this.c.set($,b),this.d.$registerAgent($,t.identifier,v,{},void 0),b.apiAgent}createDynamicChatAgent(t,v,c,$,b){const p=i.b++,l=new a(t,v,this.d,p,b);return this.c.set(p,l),this.d.$registerAgent(p,t.identifier,v,{},{name:c,description:$}),l.apiAgent}async $invokeAgent(t,v,c,$){const b=this.c.get(t);if(!b)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let p=this.g.get(v.sessionId);p||(p=new g.$Tc,this.g.set(v.sessionId,p));const l=new n(b.extension,v,this.d,this.i,this.j.converter,p);try{const D=await this.k(v.agentId,c),f=b.invoke(m.ChatAgentRequest.to(v),{history:D},l.apiObject,$);return await(0,T.$9g)(Promise.resolve(f).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(k){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.i.error(`[${b.extension.identifier.value}] [@${b.id}] ${P}`,b.extension),{errorDetails:{message:P},timings:l.timings}}return{errorDetails:S?.errorDetails,timings:l.timings,metadata:S?.metadata}}),$)}catch(D){return this.i.error(D,b.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,R.$6i)(D)),responseIsIncomplete:!0}}}finally{l.close()}}async k(t,v){const c=[];for(const $ of v.history){const b=m.ChatAgentResult.to($.result),p=t===$.request.agentId?b:{...b,metadata:void 0};c.push(new r.$tO($.request.message,$.request.command,$.request.variables.variables.map(m.ChatAgentResolvedVariable.to),$.request.agentId));const l=(0,I.$Hb)($.response.map(D=>m.ChatResponsePart.fromContent(D,this.j.converter)));c.push(new r.$uO(l,p,$.request.agentId,$.request.command))}return c}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,v,c,$,b){const p=this.c.get(v);if(!p)return Promise.resolve([]);const l=await this.k(p.id,$),D=m.ChatAgentResult.to(c);return(await p.provideFollowups(D,{history:l},b)).filter(f=>{const S=!f.participant||A.Iterable.some(this.c.values(),k=>k.id===f.participant&&u.$Dm.equals(k.extension.identifier,p.extension.identifier));return S||this.i.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),S}).map(f=>m.ChatFollowup.from(f,t))}$acceptFeedback(t,v,c,$){const b=this.c.get(t);if(!b)return;const p=m.ChatAgentResult.to(v);let l;switch(c){case o.InteractiveSessionVoteDirection.Down:l=r.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:l=r.ChatResultFeedbackKind.Helpful;break}b.acceptFeedback(Object.freeze($?{result:p,kind:l,reportIssue:$}:{result:p,kind:l}))}$acceptAction(t,v,c){const $=this.c.get(t);if(!$||c.action.kind==="vote")return;const b=m.ChatAgentUserActionEvent.to(v,c,this.j.converter);b&&$.acceptAction(Object.freeze(b))}async $invokeCompletionProvider(t,v,c){const $=this.c.get(t);return $?(await $.invokeCompletionProvider(v,c)).map(m.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,v){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(v)}async $provideSampleQuestions(t,v){const c=this.c.get(t);if(c)return(await c.provideSampleQuestions(v)).map($=>m.ChatFollowup.from($,void 0))}}e.$sjc=i;class a{constructor(t,v,c,$,b){this.extension=t,this.id=v,this.w=c,this.x=$,this.y=b,this.n=new N.$7d,this.o=new N.$7d}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,v){return this.q?await this.q.provider.provideCompletionItems(t,v)??[]:[]}async provideFollowups(t,v,c){if(!this.b)return[];const $=await this.b.provideFollowups(t,v,c);return $?$.filter(b=>!(b&&"commandId"in b)).filter(b=>!(b&&"message"in b)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const v=await this.s.provideWelcomeMessage(t);return v?v.map(c=>typeof c=="string"?c:m.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const v=await this.s.provideSampleQuestions(t);return v||[]}get apiAgent(){let t=!1,v=!1;const c=()=>{t||v||(v=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{fullName:this.c,icon:this.d?this.d instanceof O.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof r.$oN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:m.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:m.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,isSticky:this.t,requester:this.u}),v=!1}))},$=this;return{get id(){return $.id},get fullName(){return(0,s.$cG)($.extension,"defaultChatParticipant"),$.c??$.extension.displayName??$.extension.name},set fullName(b){(0,s.$cG)($.extension,"defaultChatParticipant"),$.c=b,c()},get iconPath(){return $.d},set iconPath(b){$.d=b,c()},get requestHandler(){return $.y},set requestHandler(b){(0,E.$6f)(typeof b=="function","Invalid request handler"),$.y=b},get followupProvider(){return $.b},set followupProvider(b){$.b=b,c()},get isDefault(){return(0,s.$cG)($.extension,"defaultChatParticipant"),$.g},set isDefault(b){(0,s.$cG)($.extension,"defaultChatParticipant"),$.g=b,c()},get helpTextPrefix(){return(0,s.$cG)($.extension,"defaultChatParticipant"),$.i},set helpTextPrefix(b){(0,s.$cG)($.extension,"defaultChatParticipant"),$.i=b,c()},get helpTextVariablesPrefix(){return(0,s.$cG)($.extension,"defaultChatParticipant"),$.j},set helpTextVariablesPrefix(b){(0,s.$cG)($.extension,"defaultChatParticipant"),$.j=b,c()},get helpTextPostfix(){return(0,s.$cG)($.extension,"defaultChatParticipant"),$.k},set helpTextPostfix(b){(0,s.$cG)($.extension,"defaultChatParticipant"),$.k=b,c()},get isSecondary(){return(0,s.$cG)($.extension,"defaultChatParticipant"),$.m},set isSecondary(b){(0,s.$cG)($.extension,"defaultChatParticipant"),$.m=b,c()},get sampleRequest(){return $.l},set sampleRequest(b){$.l=b,c()},get supportIssueReporting(){return(0,s.$cG)($.extension,"chatParticipantAdditions"),$.p},set supportIssueReporting(b){(0,s.$cG)($.extension,"chatParticipantAdditions"),$.p=b,c()},get onDidReceiveFeedback(){return $.n.event},set participantVariableProvider(b){if((0,s.$cG)($.extension,"chatParticipantAdditions"),$.q=b,b){if(!b.triggerCharacters.length)throw new Error("triggerCharacters are required");$.w.$registerAgentCompletionsProvider($.x,b.triggerCharacters)}else $.w.$unregisterAgentCompletionsProvider($.x)},get participantVariableProvider(){return(0,s.$cG)($.extension,"chatParticipantAdditions"),$.q},set welcomeMessageProvider(b){(0,s.$cG)($.extension,"defaultChatParticipant"),$.s=b,c()},get welcomeMessageProvider(){return(0,s.$cG)($.extension,"defaultChatParticipant"),$.s},onDidPerformAction:(0,s.$bG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,get isSticky(){return $.t},set isSticky(b){$.t=b,c()},set requester(b){$.u=b,c()},get requester(){return $.u},dispose(){t=!0,$.b=void 0,$.n.dispose(),$.w.$unregisterAgent($.x)}}}invoke(t,v,c,$){return this.y(t,v,c,$)}}}),define(Pe[254],Re([1,0,14,6,4,8,7,25]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;class d{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(R.$qM.MainThreadChatVariables)}async $resolveVariable(y,u,w,m){const r=this.b.get(y);if(r)try{if(r.resolver.resolve2){(0,g.$cG)(r.extension,"chatParticipantAdditions");const o=new E(u,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:w},o.apiObject,m);if(s)return s.map(N.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:w},m);if(o)return o.map(N.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(y,u,w,m){const r=d.a++;return this.b.set(r,{extension:y,data:{name:u,description:w},resolver:m}),this.c.$registerVariable(r,{name:u,description:w}),(0,T.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$vjc=d;class E{constructor(y,u){this.c=y,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(m){if(y.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,m),r}};const y=this,w=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){u(this.progress);const r=new A.$qO(m),o=N.ChatResponseProgressPart.to(r);return w(o),this},reference(m){u(this.reference);const r=new A.$sO(m),o=N.ChatResponseReferencePart.to(r);return w(o),this},push(m){return u(this.push),m instanceof A.$sO?w(N.ChatResponseReferencePart.to(m)):m instanceof A.$qO&&w(N.ChatResponseProgressPart.to(m)),this}}}return this.b}}}),define(Pe[255],Re([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=w;function w(m,r,o){const s=m.getProxy(y.$qM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new d.$Fm,r.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=l,f=this.b.get(D.commentControlHandle);if(!f)return D;const S=f.getCommentThread(D.commentThreadHandle);return S?S.value:D}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);return f?l.$mid===8?f.value:{thread:f.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);if(!f)return l;const S=l.commentUniqueId,k=f.getCommentByUniqueId(S);return k||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);if(!f)return l;const S=l.text,k=l.commentUniqueId,P=f.getCommentByUniqueId(k);return P?(typeof P.body=="string"?P.body=S:P.body=new O.$TM(S),P):l}return l}})}createCommentController(l,D,f){const S=n.a++,k=new a(l,S,D,f);this.b.set(k.handle,k);const P=this.c.get(l.identifier)||[];return P.push(k),this.c.set(l.identifier,P),k.value}async $createCommentThreadTemplate(l,D,f){const S=this.b.get(l);S&&S.$createCommentThreadTemplate(D,f)}async $setActiveComment(l,D){const f=this.b.get(l);f&&f.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(l,D,f){const S=this.b.get(l);S&&S.$updateCommentThreadTemplate(D,f)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}async $provideCommentingRanges(l,D,f){const S=this.b.get(l);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const k=await o.ensureDocumentData(A.URI.revive(D));return(0,I.$ah)(async()=>{const P=await S.commentingRangeProvider.provideCommentingRanges(k.document,f);let C;return Array.isArray(P)?C={ranges:P,fileComments:!1}:P?C={ranges:P.ranges||[],fileComments:P.fileComments||!1}:C=P??void 0,C}).then(P=>{let C;return P&&(C={ranges:P.ranges.map(q=>E.Range.from(q)),fileComments:P.fileComments}),C})}$toggleReaction(l,D,f,S,k){const P=this.b.get(l);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,I.$ah)(()=>{const C=P.getCommentThread(D);if(C){const q=C.getCommentByUniqueId(S.uniqueIdInThread);if(P!==void 0&&q&&P.reactionHandler)return P.reactionHandler(q,v(k))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,u.$cG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,f,S,k,P,C,q){this.m=D,this.n=f,this.o=S,this.p=k,this.q=P,this.extensionDescription=C,this.r=q,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(D,this.handle,this.n,this.o,E.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{s.$deleteCommentThread(D,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(W){V.range=W},get comments(){return V.comments},set comments(W){V.comments=W},get collapsibleState(){return V.collapsibleState},set collapsibleState(W){V.collapsibleState=W},get canReply(){return V.canReply},set canReply(W){V.canReply=W},get contextValue(){return V.contextValue},set contextValue(W){V.contextValue=W},get label(){return V.label},set label(W){V.label=W},get state(){return V.state},set state(W){V.state=W},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const l=f=>Object.prototype.hasOwnProperty.call(this.b,f),D={};l("range")&&(D.range=E.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(f=>h(this,f,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=c(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=$(this.h)),l("applicability")&&(D.applicability=b(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const f=D[0],S=D[1];if(l===S)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,T.$Nh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,u.$cG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$cG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$cG)(this.h,"activeComment"),this.f}constructor(l,D,f,S){this.h=l,this.i=D,this.j=f,this.k=S,this.a=new Map,s.$registerCommentController(this.handle,f,S,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(P){k.options=P},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(P){k.commentingRangeProvider=P},get reactionHandler(){return k.reactionHandler},set reactionHandler(P){k.reactionHandler=P},get activeCommentThread(){return k.activeCommentThread},createCommentThread(P,C,q){return k.createCommentThread(P,C,q).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,f){D===void 0&&(0,u.$cG)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,l,D,f,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const D=this.a.get(l.commentThreadHandle);D&&(this.e=l.uniqueIdInThread?D.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(l,D){const f=new i(this.id,this.handle,void 0,A.URI.revive(l),E.Range.to(D),[],this.h,!0);return f.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(l,D){const f=this.a.get(l);f&&(f.range=E.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(p,l,D,f){let S=D.get(l);return S||(S=++p.commentHandle,D.set(l,S)),l.state!==void 0&&(0,u.$cG)(f,"commentsDraftState"),l.reactions?.some(k=>k.reactors!==void 0)&&(0,u.$cG)(f,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:S,body:typeof l.body=="string"?l.body:E.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(k=>t(k)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?E.$KO(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(l=>l.name):p.reactors}}function v(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?A.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(l=>({name:l}))}}function c(p){if(p!==void 0)switch(p){case O.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function $(p){let l;if(typeof p=="object"?l=p.resolved:l=p,l!==void 0)switch(l){case O.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}function b(p){let l;if(typeof p=="object"&&(l=p.applicability),l!==void 0)switch(l){case O.CommentThreadApplicability.Current:return g.CommentThreadApplicability.Current;case O.CommentThreadApplicability.Outdated:return g.CommentThreadApplicability.Outdated}return g.CommentThreadApplicability.Current}return new n}}),define(Pe[256],Re([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;class w{constructor(v,c){this.document=v,this.b=c,this.a=1,this.c=new O.$cjc("custom documents")}addEdit(v){return this.c.add([v])}async undo(v,c){await this.f(v).undo(),c||this.disposeBackup()}async redo(v,c){await this.f(v).redo(),c||this.disposeBackup()}disposeEdits(v){for(const c of v)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const v=h(this.document.uri)+this.a++;return(0,A.$Vg)(this.b,v)}updateBackup(v){this.d?.delete(),this.d=v}disposeBackup(){this.d?.delete(),this.d=void 0}f(v){const c=this.c.get(v,0);if(!c)throw new Error("No edit found");return c}}class m{constructor(){this.a=new Map}get(v,c){return this.a.get(this.b(v,c))}add(v,c,$){const b=this.b(v,c.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${v} resource:${c.uri}`);const p=new w(c,$);return this.a.set(b,p),p}delete(v,c){const $=this.b(v,c.uri);this.a.delete($)}b(v,c){return`${v}@@@${c}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(v,c,$){return this.b(0,v,c,$)}addCustomProvider(v,c,$){return this.b(1,v,c,$)}get(v){return this.a.get(v)}b(v,c,$,b){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:v,extension:$,provider:b}),new u.$sM(()=>this.a.delete(c))}}class s{constructor(v,c,$,b,p){this.d=c,this.f=$,this.g=b,this.h=p,this.b=new o,this.c=new m,this.a=v.getProxy(y.$qM.MainThreadCustomEditors)}registerCustomEditorProvider(v,c,$,b){const p=new R.$Tc;return i($)?(p.add(this.b.addTextProvider(c,v,$)),this.a.$registerTextEditorProvider((0,E.$Ojc)(v),c,b.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,E.$Mjc)(v))):(p.add(this.b.addCustomProvider(c,v,$)),n($)&&p.add($.onDidChangeCustomDocument(l=>{const D=this.i(c,l.document.uri);if(a(l)){const f=D.addEdit(l);this.a.$onDidEdit(l.document.uri,c,f,l.label)}else this.a.$onContentChange(l.document.uri,c)})),this.a.$registerCustomEditorProvider((0,E.$Ojc)(v),c,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,E.$Mjc)(v))),u.$sM.from(p,new u.$sM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(v,c,$,b,p){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=g.URI.revive(v),f=await l.provider.openCustomDocument(D,{backupId:$,untitledDocumentData:b?.buffer},p);let S;return n(l.provider)&&this.f&&(S=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(c,f,S),{editable:n(l.provider)}}async $disposeCustomDocument(v,c){const $=this.b.get(c);if(!$)throw new Error(`No provider found for '${c}'`);if($.type!==1)throw new Error(`Invalid provider type for '${c}'`);const b=g.URI.revive(v),{document:p}=this.i(c,b);this.c.delete(c,p),p.dispose()}async $resolveCustomEditor(v,c,$,b,p,l){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);const f=d.ViewColumn.to(p),S=this.g.createNewWebview(c,b.contentOptions,D.extension),k=this.h.createNewWebviewPanel(c,$,b.title,f,b.options,S,b.active),P=g.URI.revive(v);switch(D.type){case 1:{const{document:C}=this.i($,P);return D.provider.resolveCustomEditor(C,k,l)}case 0:{const C=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(C,k,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(v,c,$){this.i(c,v).disposeEdits($)}async $onMoveCustomEditor(v,c,$){const b=this.b.get($);if(!b)throw new Error(`No provider found for '${$}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const p=this.h.getWebviewPanel(v);if(!p)throw new Error("No webview found");const l=g.URI.revive(c),D=this.d.getDocument(l);await b.provider.moveCustomTextEditor(D,p,I.CancellationToken.None)}async $undo(v,c,$,b){return this.i(c,v).undo($,b)}async $redo(v,c,$,b){return this.i(c,v).redo($,b)}async $revert(v,c,$){const b=this.i(c,v);await this.j(c).revertCustomDocument(b.document,$),b.disposeBackup()}async $onSave(v,c,$){const b=this.i(c,v);await this.j(c).saveCustomDocument(b.document,$),b.disposeBackup()}async $onSaveAs(v,c,$,b){const p=this.i(c,v);return this.j(c).saveCustomDocumentAs(p.document,g.URI.revive($),b)}async $backup(v,c,$){const b=this.i(c,v),l=await this.j(c).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},$);return b.updateBackup(l),l.id}i(v,c){const $=this.c.get(v,g.URI.revive(c));if(!$)throw new Error("No custom document found");return $}j(v){const $=this.b.get(v)?.provider;if(!$||!n($))throw new Error("Custom document is not editable");return $}}e.$Rjc=s;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const v=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,T.$9i)(v)+""}}),define(Pe[257],Re([1,0,164,100,2,4,7,8,5,13,28,44]),function(ge,e,I,T,R,N,A,g,d,E,O,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=e.$jjc=void 0;class w{#e;#t;#i;constructor(o,s,n,i,a,h,t,v){this.d=o,this.e=s,this.f=n,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,n),this.#i=new O.$Bc(c=>h.getComparisonKey(c)),this.#e=t,this.#t=v}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let n=[];if(R.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(w.k);for(const t of o){const[v,c]=t;if((!h||v.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=v,n.push(v),this.#i.set(v,[])),c)this.#i.get(v)?.push(...c);else{const $=this.#i.get(v);$&&($.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let a=0;for(const h of n){let t=[];const v=this.#i.get(h);if(v)if(v.length>this.g){t=[];const c=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const b of v)if(b.severity===c[$]&&t.push({...g.Diagnostic.from(b),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,I.localize)(0,null,v.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=v.map(c=>({...g.Diagnostic.from(c),modelVersionId:this.h(h)}));if(i.push([h,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[n,i]of this)o.call(s,n,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$jjc=w;let m=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const s=new O.$Bc;for(const n of o)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,n,i){this.j=s,this.k=n,this.l=i,this.g=new Map,this.h=new d.$$d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=d.Event.map(this.h.event,u._mapper),this.f=o.getProxy(N.$qM.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:n,f:i,h:a,j:h,k:t,l:v}=this,c=new class{$changeMany(p,l){i.$changeMany(p,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,p,l.length===0?"CLEARING":l)}$clear(p){i.$clear(p),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,p)}dispose(){i.dispose()}};let $;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,$=s;else if(!n.has(s))$=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do $=s+u.c++;while(n.has($))}return new class extends w{constructor(){super(s,$,u.e,u.d,p=>v.getDocument(p)?.version,t.extUri,c,a),n.set($,this)}dispose(){super.dispose(),n.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,n=[];for(const i of this.g.values())i.forEach((a,h)=>{let t=s.get(a.toString());typeof t>"u"&&(t=n.length,s.set(a.toString(),t),n.push([a,[]])),n[t][1]=n[t][1].concat(...h)});return n}}m(o){let s=[];for(const n of this.g.values())n.has(o)&&(s=s.concat(n.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",n=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of o)this.n.set(R.URI.revive(s),n.map(g.Diagnostic.to))}};e.$kjc=m,e.$kjc=m=u=Je([qe(1,E.$Oj),qe(2,y.$ijc)],m)}),define(Pe[258],Re([1,0,2,14,7,8,192]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class g{constructor(E,O,y,u={timeout:1500,errors:3}){this.c=E,this.d=O,this.f=y,this.g=u,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(O,y,u)=>{const m={dispose:this.a.push([O,y,E])};return Array.isArray(u)&&u.push(m),m}}async $participateInSave(E,O){const y=I.URI.revive(E);let u=!1;const w=setTimeout(()=>u=!0,this.g.timeout),m=[];try{for(const r of[...this.a]){if(u)break;const o=this.d.getDocument(y),s=await this.h(r,{document:o,reason:N.TextDocumentSaveReason.to(O)});m.push(s)}}finally{clearTimeout(w)}return m}h([E,O,y],u){const w=this.b.get(E);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(y,E,O,u).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const r=this.b.get(E);this.b.set(E,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,O,y,u){const w=[],m=Date.now(),{document:r,reason:o}=u,{version:s}=r,n=Object.freeze({document:r,reason:o,waitUntil(i){if(Object.isFrozen(w))throw(0,T.$8)("waitUntil can not be called async");w.push(Promise.resolve(i))}});try{O.apply(y,[n])}catch(i){return Promise.reject(i)}return Object.freeze(w),new Promise((i,a)=>{const h=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(w).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(h),i(t)}).catch(t=>{clearTimeout(h),a(t)})}).then(i=>{const a={edits:[]};for(const h of i)if(Array.isArray(h)&&h.every(t=>t instanceof R.$zM))for(const{newText:t,newEol:v,range:c}of h)a.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:c&&N.Range.from(c),text:t,eol:v&&N.EndOfLine.from(v)}});if(a.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$tkc=g}),define(Pe[259],Re([1,0,5,6,2,4,111,8,17,26,7]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class y{constructor(w,m){this.a=new I.$7d,this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Tc,this.h=new Map,this.f=w.getProxy(N.$qM.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const m=this.g.getDocument(w);if(m)return m}getDocument(w){const m=this.getDocumentData(w);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return m.document}ensureDocumentData(w){const m=this.g.getDocument(w);if(m)return Promise.resolve(m);let r=this.h.get(w.toString());return r||(r=this.f.$tryOpenDocument(w).then(o=>{this.h.delete(w.toString());const s=R.URI.revive(o);return(0,d.$7f)(this.g.getDocument(s))},o=>(this.h.delete(w.toString()),Promise.reject(o))),this.h.set(w.toString(),r)),r}createDocumentData(w){return this.f.$tryCreateDocument(w).then(m=>R.URI.revive(m))}$acceptModelLanguageChanged(w,m){const r=R.URI.revive(w),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(w){const m=R.URI.revive(w),r=this.g.getDocument(m);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(w,m){const r=R.URI.revive(w),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,m,r){const o=R.URI.revive(w),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(m);let n;m.isUndoing?n=O.TextDocumentChangeReason.Undo:m.isRedoing&&(n=O.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Pn)({document:s.document,contentChanges:m.changes.map(i=>({range:g.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(w,m){(0,A.$NO)(w,m)}}e.$ljc=y}),define(Pe[66],Re([1,0,260,5,17,2,3,4,16,8,7]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=e.$Sjc=void 0,e.$Sjc=(0,A.$ii)("IExtHostEditorTabs");class y{constructor(o,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.$bO(N.URI.revive(this.b.input.uri));case 2:return new O.$cO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new O.$dO(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new O.$eO(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.$fO(this.b.input.viewType);case 4:return new O.$gO(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.$hO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.$iO;case 9:return new O.$jO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new O.$kO(this.b.input.providerId);case 11:return new O.$lO(this.b.input.diffEditors.map(o=>new O.$cO(N.URI.revive(o.original),N.URI.revive(o.modified))));default:return}}}class u{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new y(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return E.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const s=this.c.find(n=>n.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(o){this.b=new T.$7d,this.c=new T.$7d,this.e=[],this.a=o.getProxy(g.$qM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,R.$7f)(o.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,i)=>{const a=Array.isArray(n)?n:[n];return a.length?m(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(c=>c.groupId)),n=new Set(o.map(c=>c.groupId)),i=(0,I.$L)(s,n),a=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=o.map(c=>{const $=new u(c,()=>this.d);return i.added.includes($.groupId)?h.push($.apiObject):t.push($.apiObject),$});const v=(0,R.$7f)(o.find(c=>c.isActive===!0)?.groupId);v!==void 0&&this.d!==v&&(this.d=v),this.c.fire(Object.freeze({opened:h,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const n=[];for(const i of o){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,s)}async j(o,s){const n=[];for(const i of o){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,s)}};e.$Tjc=w,e.$Tjc=w=Je([qe(0,d.$LO)],w);function m(r){return r.tabs!==void 0}}),define(Pe[261],Re([1,0,2,4,6,7,8,304,15,22,25,54]),function(ge,e,I,T,R,N,A,g,d,E,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=void 0;class u{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let s,n,i=14,a=14;for(const h of r){let t=s?(0,d.$nf)(s,h):0;for(t===0?n=1:n=a;t<h.length;t++)t+1===h.length?(i=a,a=9):a+=1,o.push([n,h.toUpperCase().charCodeAt(t),a]),o.push([n,h.toLowerCase().charCodeAt(t),a]),n=a;s=h,a=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new g.$w2(o)}}provideDocumentLinks(r){this.c();const o=[],s=g.$x2.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of s){const i=A.DocumentLink.to(n);i.target&&o.push(i)}return o}}class w{constructor(r,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(T.$qM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,s,n={}){if(w.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,O.$cG)(r,"fsChunks"),a+=4);let h;n.isReadonly&&(0,y.$Hk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,a,h).catch(v=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(v)});const t=s.onDidChangeFile(v=>{const c=[];for(const $ of v){const{uri:b,type:p}=$;if(b.scheme!==o)continue;let l;switch(p){case N.FileChangeType.Changed:l=0;break;case N.FileChangeType.Created:l=1;break;case N.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:b,type:l})}this.a.$onFileSystemChange(i,c)});return(0,R.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:s,mtime:n,size:i,permissions:a}=r;return{type:o,ctime:s,mtime:n,size:i,permissions:a}}$stat(r,o){return Promise.resolve(this.l(r).stat(I.URI.revive(o))).then(s=>w.k(s))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(I.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(I.URI.revive(o))).then(s=>E.$ue.wrap(s))}$writeFile(r,o,s,n){return Promise.resolve(this.l(r).writeFile(I.URI.revive(o),s.buffer,n))}$delete(r,o,s){return Promise.resolve(this.l(r).delete(I.URI.revive(o),s))}$rename(r,o,s,n){return Promise.resolve(this.l(r).rename(I.URI.revive(o),I.URI.revive(s),n))}$copy(r,o,s,n){const i=this.l(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(I.URI.revive(o),I.URI.revive(s),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(I.URI.revive(o)))}$watch(r,o,s,n){const i=this.l(r).watch(I.URI.revive(s),n);this.f.set(o,i)}$unwatch(r,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(r,o,s){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(o),s))}$close(r,o){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,n){const i=this.l(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=E.$ue.alloc(n);return Promise.resolve(i.read(o,s,a.buffer,0,n)).then(h=>a.slice(0,h))}$write(r,o,s,n){const i=this.l(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$vkc=w}),define(Pe[262],Re([1,0,5,35,2,4,8,7,40]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,m,r,o,s,n){this.a=Math.random(),this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,T.$ck)(s),a=typeof s=="string",h=n?.correlate,t=o(v=>{if(!(typeof v.session=="number"&&v.session!==this.a)&&!(h&&typeof v.session>"u")){if(!n?.ignoreCreateEvents)for(const c of v.created){const $=R.URI.revive(c);i($.fsPath)&&(!a||m.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const c of v.changed){const $=R.URI.revive(c);i($.fsPath)&&(!a||m.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const c of v.deleted){const $=R.URI.revive(c);i($.fsPath)&&(!a||m.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=g.$sM.from(this.i(w,r,s,n,n?.correlate),this.b,this.c,this.d,t)}i(w,m,r,o,s){const n=g.$sM.from();if(typeof r=="string")return n;const i=w.getProxy(N.$qM.MainThreadFileSystemEventService);let a=!1;return(r.pattern.includes(T.$$j)||r.pattern.includes(T.$_j))&&(a=!0),i.$watch(m.identifier.value,this.a,r.baseUri,{recursive:a,excludes:o?.excludes??[]},!!s),g.$sM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class O{constructor(w){this.a=w,this.session=this.a.session,this.b=new d.$V(()=>this.a.created.map(R.URI.revive)),this.c=new d.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new d.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class y{constructor(w,m,r){this.j=w,this.k=m,this.l=r,this.a=new I.$7d,this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.g=new I.$9d,this.h=new I.$9d,this.i=new I.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,m,r,o){return new E(this.j,w,m,this.a.event,A.GlobPattern.from(r),o)}$onFileEvent(w){this.a.fire(new O(w))}$onDidRunFileOperation(w,m){switch(w){case 2:this.b.fire(Object.freeze({files:m.map(r=>({oldUri:R.URI.revive(r.source),newUri:R.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(r=>R.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(r=>R.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,m){return(r,o,s)=>{const n=function(a){r.call(o,a)};return n.extension=w,m.event(n,void 0,s)}}async $onWillRunFileOperation(w,m,r,o){switch(w){case 2:return await this.n(this.g,{files:m.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))},r,o);case 1:return await this.n(this.i,{files:m.map(s=>R.URI.revive(s.target))},r,o);case 0:case 3:return await this.n(this.h,{files:m.map(s=>R.URI.revive(s.target))},r,o)}}async n(w,m,r,o){const s=new Set,n=[];if(await w.fireAsync(m,o,async(a,h)=>{const t=Date.now(),v=await Promise.resolve(a);v instanceof g.$CM&&(n.push([h.extension,v]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,a]of n){const{edits:h}=A.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$wkc=y}),define(Pe[263],Re([1,0,18,11,24,14,90,6,26,65,15,17,2,29,305,87,97,166,20,8,7,25,74,4]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;class c{constructor(U,j){this.d=U,this.e=j}async provideDocumentSymbols(U,j){const G=this.d.getDocument(U),H=await this.e.provideDocumentSymbols(G,j);if(!(0,I.$Kb)(H))return H[0]instanceof a.$LM?H.map(i.DocumentSymbol.from):c.f(H)}static f(U){U=U.slice(0).sort((H,ee)=>{let se=H.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(H.location.range.end)),se});const j=[],G=[];for(const H of U){const ee={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),j.push(ee);break}const se=G[G.length-1];if(w.$ct.containsRange(se.range,ee.range)&&!w.$ct.equalsRange(se.range,ee.range)){se.children?.push(ee),G.push(ee);break}G.pop()}}return j}}class ${constructor(U,j,G,H,ee,se){this.f=U,this.g=j,this.h=G,this.j=H,this.k=ee,this.l=se,this.d=new t.$cjc("CodeLens"),this.e=new Map}async provideCodeLenses(U,j){const G=this.f.getDocument(U),H=await this.h.provideCodeLenses(G,j);if(!H||j.isCancellationRequested)return;const ee=this.d.add(H),se=new g.$Tc;this.e.set(ee,se);const Te={cacheId:ee,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Te.lenses.push({cacheId:[ee,Ve],range:i.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,se)});return Te}async resolveCodeLens(U,j){const G=U.cacheId&&this.d.get(...U.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,j),H||(H=G),j.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return U.command=this.g.toInternal(H.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function b(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class p{constructor(U,j){this.d=U,this.e=j}async provideDefinition(U,j,G){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideDefinition(H,ee,G);return b(se)}}class l{constructor(U,j){this.d=U,this.e=j}async provideDeclaration(U,j,G){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideDeclaration(H,ee,G);return b(se)}}class D{constructor(U,j){this.d=U,this.e=j}async provideImplementation(U,j,G){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideImplementation(H,ee,G);return b(se)}}class f{constructor(U,j){this.d=U,this.e=j}async provideTypeDefinition(U,j,G){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideTypeDefinition(H,ee,G);return b(se)}}class S{constructor(U,j){this.d=U,this.e=j}async provideHover(U,j,G){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideHover(H,ee,G);if(!(!se||(0,I.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(ee)),se.range||(se.range=new a.$uM(ee,ee)),i.Hover.from(se)}}class k{constructor(U,j){this.d=U,this.e=j}async provideEvaluatableExpression(U,j,G){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideEvaluatableExpression(H,ee,G);if(se)return i.EvaluatableExpression.from(se)}}class P{constructor(U,j){this.d=U,this.e=j}async provideInlineValues(U,j,G,H){const ee=this.d.getDocument(U),se=await this.e.provideInlineValues(ee,i.Range.to(j),i.InlineValueContext.to(G),H);if(Array.isArray(se))return se.map(Te=>i.InlineValue.from(Te))}}class C{constructor(U,j){this.d=U,this.e=j}async provideDocumentHighlights(U,j,G){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class q{constructor(U,j){this.d=U,this.e=j}async provideMultiDocumentHighlights(U,j,G,H){const ee=this.d.getDocument(U),se=G.map(Qe=>this.d.getDocument(Qe)),Te=i.Position.to(j),Ve=await this.e.provideMultiDocumentHighlights(ee,Te,se,H);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class V{constructor(U,j){this.d=U,this.e=j}async provideLinkedEditingRanges(U,j,G){const H=this.d.getDocument(U),ee=i.Position.to(j),se=await this.e.provideLinkedEditingRanges(H,ee,G);if(se&&Array.isArray(se.ranges))return{ranges:(0,I.$Hb)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class W{constructor(U,j){this.d=U,this.e=j}async provideReferences(U,j,G,H){const ee=this.d.getDocument(U),se=i.Position.to(j),Te=await this.e.provideReferences(ee,se,G,H);if(Array.isArray(Te))return Te.map(i.location.from)}}class M{static{this.d=1e3}constructor(U,j,G,H,ee,se,Te){this.g=U,this.h=j,this.j=G,this.k=H,this.l=ee,this.m=se,this.n=Te,this.e=new t.$cjc("CodeAction"),this.f=new Map}async provideCodeActions(U,j,G,H){const ee=this.g.getDocument(U),se=m.$et.isISelection(j)?i.Selection.to(j):i.Range.to(j),Te=[];for(const it of this.j.getDiagnostics(U))if(se.intersection(it.range)&&Te.push(it)>M.d)break;const Ve={diagnostics:Te,only:G.only?new a.$NM(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(ee,se,Ve,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const xe=this.e.add(Qe),et=new g.$Tc;this.f.set(xe,et);const ot=[];for(let it=0;it<Qe.length;it++){const nt=Qe[it];if(nt)if(M.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,et)});else{Ve.only&&(nt.kind?Ve.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=nt.ranges??[];ot.push({cacheId:[xe,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(i.Diagnostic.from),edit:nt.edit&&i.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$bG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$bG)(this.m,"codeActionRanges")?(0,I.$Hb)(at.map(i.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:xe,actions:ot}}async resolveCodeAction(U,j){const[G,H]=U,ee=this.e.get(G,H);if(!ee||M.o(ee))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(ee,j)??ee;let Te;se.edit&&(Te=i.WorkspaceEdit.from(se.edit,void 0));let Ve;if(se.command){const Qe=this.f.get(G);Qe&&(Ve=this.h.toInternal(se.command,Qe))}return{edit:Te,command:Ve}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class z{constructor(U,j,G,H,ee){this.e=U,this.f=j,this.g=G,this.h=H,this.j=ee,this.d=new t.$cjc("DocumentPasteEdit")}async prepareDocumentPaste(U,j,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),se=j.map(Qe=>i.Range.to(Qe)),Te=i.DataTransfer.toDataTransfer(G,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(ee,se,Te,H),H.isCancellationRequested)return;const Ve=Array.from(Te).filter(([,Qe])=>!(Qe instanceof a.$hN));return i.DataTransfer.from(Ve)}async providePasteEdits(U,j,G,H,ee,se){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(j),Ve=G.map(ot=>i.Range.to(ot)),Qe=i.DataTransfer.toDataTransfer(H,async ot=>(await this.e.$resolvePasteFileData(this.h,U,ot)).buffer),xe=await this.g.provideDocumentPasteEdits(Te,Ve,Qe,{only:ee.only?new a.$mN(ee.only):void 0,triggerKind:ee.triggerKind},se);if(!xe||se.isCancellationRequested)return[];const et=this.d.add(xe);return xe.map((ot,it)=>({_cacheId:[et,it],title:ot.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(nt=>nt.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?i.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,j){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(ee,j)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,j){this.d=U,this.e=j}async provideDocumentFormattingEdits(U,j,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(H,j,G);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(U,j){this.d=U,this.e=j}async provideDocumentRangeFormattingEdits(U,j,G,H){const ee=this.d.getDocument(U),se=i.Range.to(j),Te=await this.e.provideDocumentRangeFormattingEdits(ee,se,G,H);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,j,G,H){(0,y.$6f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),se=j.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(ee,se,G,H);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class fe{constructor(U,j){this.d=U,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,j,G,H,ee){const se=this.d.getDocument(U),Te=i.Position.to(j),Ve=await this.e.provideOnTypeFormattingEdits(se,Te,G,H,ee);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class De{constructor(U,j){this.e=U,this.f=j,this.d=new t.$cjc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,j){const G=await this.e.provideWorkspaceSymbols(U,j);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let se=0;se<G.length;se++){const Te=G[se];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[H,se]})}return ee}async resolveWorkspaceSymbol(U,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this.d.get(...U.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,j);return H&&(0,d.$Rn)(U,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class ye{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,j,G){this.d=U,this.e=j,this.f=G}async provideRenameEdits(U,j,G,H){const ee=this.d.getDocument(U),se=i.Position.to(j);try{const Te=await this.e.provideRenameEdits(ee,se,G,H);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const Ve=ye.g(Te);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(U,j,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(U),ee=i.Position.to(j);try{const se=await this.e.prepareRename(H,ee,G);let Te,Ve;if(a.$uM.isRange(se)?(Te=se,Ve=H.getText(se)):(0,y.$Xf)(se)&&(Te=se.range,Ve=se.placeholder),!Te||!Ve)return;if(Te.start.line>ee.line||Te.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:Ve}}catch(se){const Te=ye.g(se);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(se)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class oe{constructor(U,j,G){this.d=U,this.e=j,this.f=G}async provideNewSymbolNames(U,j,G){const H=this.d.getDocument(U),ee=i.Range.to(j);try{const se=await this.e.provideNewSymbolNames(H,ee,G);return se?se.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(se){this.f.error(oe.g(se)??JSON.stringify(se,null,"	"));return}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class $e{constructor(U,j){this.resultId=U,this.tokens=j}}class ne{constructor(U,j){this.f=U,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,j,G){const H=this.f.getDocument(U),ee=j!==0?this.d.get(j):null;let se=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(j),se?(se=ne.h(se),this.o(ne.n(ee,se),se)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return ne.j(U)?ne.k(U)?U:new a.$MN(new Uint32Array(U.data),U.resultId):ne.l(U)?ne.m(U)?U:new a.$ON(U.edits.map(j=>new a.$NN(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const j of U.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(U,j){if(!ne.j(j)||!U||!U.tokens)return j;const G=U.tokens,H=G.length,ee=j.data,se=ee.length;let Te=0;const Ve=Math.min(H,se);for(;Te<Ve&&G[Te]===ee[Te];)Te++;if(Te===H&&Te===se)return new a.$ON([],j.resultId);let Qe=0;const xe=Ve-Te;for(;Qe<xe&&G[H-Qe-1]===ee[se-Qe-1];)Qe++;return new a.$ON([{start:Te,deleteCount:H-Te-Qe,data:ee.subarray(Te,se-Qe)}],j.resultId)}o(U,j){if(ne.j(U)){const G=this.e++;return this.d.set(G,new $e(U.resultId,U.data)),(0,o.$Pab)({id:G,type:"full",data:U.data})}if(ne.l(U)){const G=this.e++;return ne.j(j)?this.d.set(G,new $e(j.resultId,j.data)):this.d.set(G,new $e(U.resultId)),(0,o.$Pab)({id:G,type:"delta",deltas:(U.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Se{constructor(U,j){this.d=U,this.e=j}async provideDocumentRangeSemanticTokens(U,j,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(j),G);return ee?this.f(ee):null}f(U){return(0,o.$Pab)({id:0,type:"full",data:U.data})}}class je{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,j,G,H,ee){this.f=U,this.g=j,this.h=G,this.j=H,this.k=ee,this.d=new t.$cjc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,j,G,H){const ee=this.f.getDocument(U),se=i.Position.to(j),Te=ee.getWordRangeAtPosition(se)||new a.$uM(se,se),Ve=Te.with({end:se}),Qe=new E.$3d,xe=await this.h.provideCompletionItems(ee,se,H,i.CompletionContext.to(G));if(!xe||H.isCancellationRequested)return;const et=Array.isArray(xe)?new a.$1M(xe):xe,ot=je.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new g.$Tc;this.e.set(ot,it);const nt=[],at={x:ot,b:nt,a:{replace:i.Range.from(Te),insert:i.Range.from(Ve)},c:et.isIncomplete||void 0,d:Qe.elapsed()};for(let ft=0;ft<et.items.length;ft++){const Ue=et.items[ft],st=this.l(Ue,[ot,ft],Ve,Te);nt.push(st)}return at}async resolveCompletionItem(U,j){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...U);if(!G)return;const H=this.l(G,U),ee=await this.h.resolveCompletionItem(G,j);if(!ee)return;const se=this.l(ee,U);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,d.$Sn)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,j,G,H){const ee=this.e.get(j[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this.g.toInternal(U.command,ee),Te={x:j,a:U.label,b:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(i.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=U.textEdit.newText):typeof U.insertText=="string"?Te.h=U.insertText:U.insertText instanceof a.$DM&&(Te.h=U.insertText.value,Te.i|=4);let Ve;return U.textEdit?Ve=U.textEdit.range:U.range&&(Ve=U.range),a.$uM.isRange(Ve)?Te.j=i.Range.from(Ve):Ve&&(!G?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Te.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Te}}class re{async provideInlineCompletions(U,j,G,H){}disposeCompletions(U){}handleDidShowCompletionItem(U,j,G){}handlePartialAccept(U,j,G,H){}}class L extends re{constructor(U,j,G,H){super(),this.f=U,this.g=j,this.h=G,this.j=H,this.d=new ve,this.e=(0,h.$bG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$bG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,j,G,H){const ee=this.g.getDocument(U),se=i.Position.to(j),Te=await this.h.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Te||H.isCancellationRequested)return;const Ve=Array.isArray(Te)?Te:Te.items,Qe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],xe=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Ve}),items:Ve.map((it,nt)=>{let at;it.command&&(et||(et=new g.$Tc),at=this.j.toInternal(it.command,et));const ft=it.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:at,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(et||(et=new g.$Tc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,j,G){const H=this.d.get(U)?.items[j];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(U,j,G,H){const ee=this.d.get(U)?.items[j];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(H)))}}class _{async provideInlineEdits(U,j,G){const H=this.f.getDocument(U),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[j.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let se;const Te=this.d.createReferenceId({dispose(){se?.dispose()},item:ee});let Ve;ee.accepted&&(se||(se=new g.$Tc),Ve=this.h.toInternal(ee.accepted,se));let Qe;return ee.rejected&&(se||(se=new g.$Tc),Qe=this.h.toInternal(ee.rejected,se)),{pid:Te,text:ee.text,range:i.Range.from(ee.range),accepted:Ve,rejected:Qe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,j,G,H){this.f=j,this.g=G,this.h=H,this.d=new ve,this.e={[r.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const j=this.e++;return this.d.set(j,U),j}disposeReferenceId(U){const j=this.d.get(U);return this.d.delete(U),j}get(U){return this.d.get(U)}}class Oe{constructor(U,j){this.e=U,this.f=j,this.d=new t.$cjc("SignatureHelp")}async provideSignatureHelp(U,j,G,H){const ee=this.e.getDocument(U),se=i.Position.to(j),Te=this.g(G),Ve=await this.f.provideSignatureHelp(ee,se,H,Te);if(Ve){const Qe=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Qe}}}g(U){let j;if(U.activeSignatureHelp){const G=i.SignatureHelp.to(U.activeSignatureHelp),H=this.d.get(U.activeSignatureHelp.id,0);H?(j=H,j.activeSignature=G.activeSignature,j.activeParameter=G.activeParameter):j=G}return{...U,activeSignatureHelp:j}}releaseSignatureHelp(U){this.d.delete(U)}}class ke{constructor(U,j,G,H,ee){this.f=U,this.g=j,this.h=G,this.j=H,this.k=ee,this.d=new t.$cjc("InlayHints"),this.e=new Map}async provideInlayHints(U,j,G){const H=this.f.getDocument(U),ee=i.Range.to(j),se=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(G.isCancellationRequested)return;const Te=this.d.add(se);this.e.set(Te,new g.$Tc);const Ve={hints:[],cacheId:Te};for(let Qe=0;Qe<se.length;Qe++)this.l(se[Qe],ee)&&Ve.hints.push(this.m(se[Qe],[Te,Qe]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ve}async resolveInlayHint(U,j){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.h.resolveInlayHint(G,j);if(H&&this.l(H))return this.m(H,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,j){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(j&&!j.contains(U.position))}m(U,j){const G=this.e.get(j[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")H.label=U.label;else{const ee=[];H.label=ee;for(const se of U.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};a.$EM.isLocation(se.location)&&(Te.location=i.location.from(se.location)),se.command&&(Te.command=this.g.toInternal(se.command,G)),ee.push(Te)}}return H}}class pe{constructor(U,j){this.e=U,this.f=j,this.d=new t.$cjc("DocumentLink")}async provideLinks(U,j){const G=this.e.getDocument(U),H=await this.f.provideDocumentLinks(G,j);if(!(!Array.isArray(H)||H.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(pe.g).map(i.DocumentLink.from)};{const ee=this.d.add(H),se={links:[],cacheId:ee};for(let Te=0;Te<H.length;Te++){if(!pe.g(H[Te]))continue;const Ve=i.DocumentLink.from(H[Te]);Ve.cacheId=[ee,Te],se.links.push(Ve)}return se}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,j){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.f.resolveDocumentLink(G,j);if(!(!H||!pe.g(H)))return i.DocumentLink.from(H)}releaseLinks(U){this.d.delete(U)}}class de{constructor(U,j){this.d=U,this.e=j}async provideColors(U,j){const G=this.d.getDocument(U),H=await this.e.provideDocumentColors(G,j);return Array.isArray(H)?H.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(U,j,G){const H=this.d.getDocument(U),ee=i.Range.to(j.range),se=i.Color.to(j.color),Te=await this.e.provideColorPresentations(se,{document:H,range:ee},G);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class J{constructor(U,j){this.d=U,this.e=j}async provideFoldingRanges(U,j,G){const H=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(H,j,G);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class Y{constructor(U,j,G){this.d=U,this.e=j,this.f=G}async provideSelectionRanges(U,j,G){const H=this.d.getDocument(U),ee=j.map(i.Position.to),se=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(se))return[];if(se.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let Ve=0;Ve<ee.length;Ve++){const Qe=[];Te.push(Qe);let xe=ee[Ve],et=se[Ve];for(;;){if(!et.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(et)),!et.parent)break;xe=et.range,et=et.parent}}return Te}}class ue{constructor(U,j){this.f=U,this.g=j,this.d=new A.$QO(""),this.e=new Map}async prepareSession(U,j,G){const H=this.f.getDocument(U),ee=i.Position.to(j),se=await this.g.prepareCallHierarchy(H,ee,G);if(!se)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(se)?se.map(Ve=>this.h(Te,Ve)):[this.h(Te,se)]}async provideCallsTo(U,j,G){const H=this.j(U,j);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(se=>({from:this.h(U,se.from),fromRanges:se.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(U,j,G){const H=this.j(U,j);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(se=>({to:this.h(U,se.to),fromRanges:se.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(U){this.e.delete(U)}h(U,j){const G=this.e.get(U),H=i.CallHierarchyItem.from(j,U,G.size.toString(36));return G.set(H._itemId,j),H}j(U,j){return this.e.get(U)?.get(j)}}class he{constructor(U,j){this.f=U,this.g=j,this.d=new A.$QO(""),this.e=new Map}async prepareSession(U,j,G){const H=this.f.getDocument(U),ee=i.Position.to(j),se=await this.g.prepareTypeHierarchy(H,ee,G);if(!se)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(se)?se.map(Ve=>this.h(Te,Ve)):[this.h(Te,se)]}async provideSupertypes(U,j,G){const H=this.j(U,j);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(se=>this.h(U,se))}async provideSubtypes(U,j,G){const H=this.j(U,j);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(se=>this.h(U,se))}releaseSession(U){this.e.delete(U)}h(U,j){const G=this.e.get(U),H=i.TypeHierarchyItem.from(j,U,G.size.toString(36));return G.set(H._itemId,j),H}j(U,j){return this.e.get(U)?.get(j)}}class Ne{constructor(U,j,G,H,ee){this.d=U,this.e=j,this.f=G,this.g=H,this.h=ee}async provideDocumentOnDropEdits(U,j,G,H,ee){const se=this.e.getDocument(j),Te=i.Position.to(G),Ve=i.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,xe)).buffer),Qe=await this.f.provideDocumentDropEdits(se,Te,Ve,ee);if(Qe)return(0,I.$3b)(Qe).map(xe=>({title:xe.title??(0,s.localize)(1,null,this.h.displayName||this.h.name),kind:xe.kind?.value,yieldTo:xe.yieldTo?.map(et=>et.value),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?i.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}))}}class le{constructor(U,j){this.d=U,this.e=j}async provideMappedEdits(U,j,G,H){const ee=u.URI.revive(U),se=this.d.getDocument(ee),Te=G.documents.map(xe=>xe.map(et=>({uri:u.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(ot=>i.Range.to(ot))}))),Ve={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(se,j,Ve,H);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ie{constructor(U,j){this.adapter=U,this.extension=j}}class Ae{static{this.d=0}constructor(U,j,G,H,ee,se,Te,Ve){this.g=j,this.h=G,this.j=H,this.k=ee,this.l=se,this.m=Te,this.n=Ve,this.f=new Map,this.e=U.getProxy(v.$qM.MainThreadLanguageFeatures)}o(U,j){return i.DocumentSelector.from(U,this.g,j)}p(U){return new a.$sM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ae.d++}async s(U,j,G,H,ee,se=!1){const Te=this.f.get(U);if(!Te||!(Te.adapter instanceof j))return H;const Ve=Date.now();se||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Te.adapter,Te.extension);return Promise.resolve(Qe).catch(xe=>{(0,N.$4)(xe)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Te.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,T.$0g)(Qe,ee):Qe}t(U,j){const G=this.q();return this.f.set(G,new Ie(U,j)),G}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,j,G,H){const ee=this.t(new c(this.h,G),U),se=H&&H.label||Ae.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(j,U),se),this.p(ee)}$provideDocumentSymbols(U,j,G){return this.s(U,c,H=>H.provideDocumentSymbols(u.URI.revive(j),G),void 0,G)}registerCodeLensProvider(U,j,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ie(new $(this.h,this.j.converter,G,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(H,this.o(j,U),ee);let se=this.p(H);if(ee!==void 0){const Te=G.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(ee));se=a.$sM.from(se,Te)}return se}$provideCodeLenses(U,j,G){return this.s(U,$,H=>H.provideCodeLenses(u.URI.revive(j),G),void 0,G)}$resolveCodeLens(U,j,G){return this.s(U,$,H=>H.resolveCodeLens(j,G),void 0,void 0)}$releaseCodeLenses(U,j){this.s(U,$,G=>Promise.resolve(G.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(U,j,G){const H=this.t(new p(this.h,G),U);return this.e.$registerDefinitionSupport(H,this.o(j,U)),this.p(H)}$provideDefinition(U,j,G,H){return this.s(U,p,ee=>ee.provideDefinition(u.URI.revive(j),G,H),[],H)}registerDeclarationProvider(U,j,G){const H=this.t(new l(this.h,G),U);return this.e.$registerDeclarationSupport(H,this.o(j,U)),this.p(H)}$provideDeclaration(U,j,G,H){return this.s(U,l,ee=>ee.provideDeclaration(u.URI.revive(j),G,H),[],H)}registerImplementationProvider(U,j,G){const H=this.t(new D(this.h,G),U);return this.e.$registerImplementationSupport(H,this.o(j,U)),this.p(H)}$provideImplementation(U,j,G,H){return this.s(U,D,ee=>ee.provideImplementation(u.URI.revive(j),G,H),[],H)}registerTypeDefinitionProvider(U,j,G){const H=this.t(new f(this.h,G),U);return this.e.$registerTypeDefinitionSupport(H,this.o(j,U)),this.p(H)}$provideTypeDefinition(U,j,G,H){return this.s(U,f,ee=>ee.provideTypeDefinition(u.URI.revive(j),G,H),[],H)}registerHoverProvider(U,j,G,H){const ee=this.t(new S(this.h,G),U);return this.e.$registerHoverProvider(ee,this.o(j,U)),this.p(ee)}$provideHover(U,j,G,H){return this.s(U,S,ee=>ee.provideHover(u.URI.revive(j),G,H),void 0,H)}registerEvaluatableExpressionProvider(U,j,G,H){const ee=this.t(new k(this.h,G),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(j,U)),this.p(ee)}$provideEvaluatableExpression(U,j,G,H){return this.s(U,k,ee=>ee.provideEvaluatableExpression(u.URI.revive(j),G,H),void 0,H)}registerInlineValuesProvider(U,j,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new P(this.h,G),U);this.e.$registerInlineValuesProvider(se,this.o(j,U),ee);let Te=this.p(se);if(ee!==void 0){const Ve=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Te=a.$sM.from(Te,Ve)}return Te}$provideInlineValues(U,j,G,H,ee){return this.s(U,P,se=>se.provideInlineValues(u.URI.revive(j),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(U,j,G){const H=this.t(new C(this.h,G),U);return this.e.$registerDocumentHighlightProvider(H,this.o(j,U)),this.p(H)}registerMultiDocumentHighlightProvider(U,j,G){const H=this.t(new q(this.h,G),U);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(j,U)),this.p(H)}$provideDocumentHighlights(U,j,G,H){return this.s(U,C,ee=>ee.provideDocumentHighlights(u.URI.revive(j),G,H),void 0,H)}$provideMultiDocumentHighlights(U,j,G,H,ee){return this.s(U,q,se=>se.provideMultiDocumentHighlights(u.URI.revive(j),G,H.map(Te=>u.URI.revive(Te)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,j,G){const H=this.t(new V(this.h,G),U);return this.e.$registerLinkedEditingRangeProvider(H,this.o(j,U)),this.p(H)}$provideLinkedEditingRanges(U,j,G,H){return this.s(U,V,async ee=>{const se=await ee.provideLinkedEditingRanges(u.URI.revive(j),G,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ae.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(U,j,G){const H=this.t(new W(this.h,G),U);return this.e.$registerReferenceSupport(H,this.o(j,U)),this.p(H)}$provideReferences(U,j,G,H,ee){return this.s(U,W,se=>se.provideReferences(u.URI.revive(j),G,H,ee),void 0,ee)}registerCodeActionProvider(U,j,G,H){const ee=new g.$Tc,se=this.t(new M(this.h,this.j.converter,this.k,G,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(se,this.o(j,U),{providedKinds:H?.providedCodeActionKinds?.map(Te=>Te.value),documentation:H?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,ee)}))},Ae.u(U),!!G.resolveCodeAction),ee.add(this.p(se)),ee}$provideCodeActions(U,j,G,H,ee){return this.s(U,M,se=>se.provideCodeActions(u.URI.revive(j),G,H,ee),void 0,ee)}$resolveCodeAction(U,j,G){return this.s(U,M,H=>H.resolveCodeAction(j,G),{},void 0)}$releaseCodeActions(U,j){this.s(U,M,G=>Promise.resolve(G.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(U,j,G){const H=this.t(new K(this.h,G),U);return this.e.$registerDocumentFormattingSupport(H,this.o(j,U),U.identifier,U.displayName||U.name),this.p(H)}$provideDocumentFormattingEdits(U,j,G,H){return this.s(U,K,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(j),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(U,j,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,G),U);return this.e.$registerRangeFormattingSupport(ee,this.o(j,U),U.identifier,U.displayName||U.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(U,j,G,H,ee){return this.s(U,ie,se=>se.provideDocumentRangeFormattingEdits(u.URI.revive(j),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,j,G,H,ee){return this.s(U,ie,se=>se.provideDocumentRangesFormattingEdits(u.URI.revive(j),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,j,G,H){const ee=this.t(new fe(this.h,G),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(j,U),H,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,j,G,H,ee,se){return this.s(U,fe,Te=>Te.provideOnTypeFormattingEdits(u.URI.revive(j),G,H,ee,se),void 0,se)}registerWorkspaceSymbolProvider(U,j){const G=this.t(new De(j,this.l),U);return this.e.$registerNavigateTypeSupport(G,typeof j.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(U,j,G){return this.s(U,De,H=>H.provideWorkspaceSymbols(j,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,j,G){return this.s(U,De,H=>H.resolveWorkspaceSymbol(j,G),void 0,void 0)}$releaseWorkspaceSymbols(U,j){this.s(U,De,G=>G.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(U,j,G){const H=this.t(new ye(this.h,G,this.l),U);return this.e.$registerRenameSupport(H,this.o(j,U),ye.supportsResolving(G)),this.p(H)}$provideRenameEdits(U,j,G,H,ee){return this.s(U,ye,se=>se.provideRenameEdits(u.URI.revive(j),G,H,ee),void 0,ee)}$resolveRenameLocation(U,j,G,H){return this.s(U,ye,ee=>ee.resolveRenameLocation(u.URI.revive(j),G,H),void 0,H)}registerNewSymbolNamesProvider(U,j,G){const H=this.t(new oe(this.h,G,this.l),U);return this.e.$registerNewSymbolNamesProvider(H,this.o(j,U)),this.p(H)}$provideNewSymbolNames(U,j,G,H){return this.s(U,oe,ee=>ee.provideNewSymbolNames(u.URI.revive(j),G,H),void 0,H)}registerDocumentSemanticTokensProvider(U,j,G,H){const ee=this.t(new ne(this.h,G),U),se=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(j,U),H,se);let Te=this.p(ee);if(se){const Ve=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(se));Te=a.$sM.from(Te,Ve)}return Te}$provideDocumentSemanticTokens(U,j,G,H){return this.s(U,ne,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(j),G,H),null,H)}$releaseDocumentSemanticTokens(U,j){this.s(U,ne,G=>G.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,j,G,H){const ee=this.t(new Se(this.h,G),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(j,U),H),this.p(ee)}$provideDocumentRangeSemanticTokens(U,j,G,H){return this.s(U,Se,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(j),G,H),null,H)}registerCompletionItemProvider(U,j,G,H){const ee=this.t(new je(this.h,this.j.converter,G,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(j,U),H,je.supportsResolving(G),U.identifier),this.p(ee)}$provideCompletionItems(U,j,G,H,ee){return this.s(U,je,se=>se.provideCompletionItems(u.URI.revive(j),G,H,ee),void 0,ee)}$resolveCompletionItem(U,j,G){return this.s(U,je,H=>H.resolveCompletionItem(j,G),void 0,G)}$releaseCompletionItems(U,j){this.s(U,je,G=>G.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(U,j,G,H){const ee=new L(U,this.h,G,this.j.converter),se=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(se,this.o(j,U),ee.supportsHandleEvents,n.$Dm.toKey(U.identifier.value),H?.yieldTo?.map(Te=>n.$Dm.toKey(Te))||[]),this.p(se)}$provideInlineCompletions(U,j,G,H,ee){return this.s(U,re,se=>se.provideInlineCompletions(u.URI.revive(j),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(U,j,G,H){this.s(U,re,async ee=>{ee.handleDidShowCompletionItem(j,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,j,G,H,ee){this.s(U,re,async se=>{se.handlePartialAccept(j,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(U,j){this.s(U,re,async G=>{G.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(U,j,G){const H=new _(U,this.h,G,this.j.converter),ee=this.t(H,U);return this.e.$registerInlineEditProvider(ee,this.o(j,U),U.identifier),this.p(ee)}$provideInlineEdit(U,j,G,H){return this.s(U,_,ee=>ee.provideInlineEdits(u.URI.revive(j),G,H),void 0,H)}$freeInlineEdit(U,j){this.s(U,_,async G=>{G.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(U,j,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Oe(this.h,G),U);return this.e.$registerSignatureHelpProvider(se,this.o(j,U),ee),this.p(se)}$provideSignatureHelp(U,j,G,H,ee){return this.s(U,Oe,se=>se.provideSignatureHelp(u.URI.revive(j),G,H,ee),void 0,ee)}$releaseSignatureHelp(U,j){this.s(U,Oe,G=>G.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(U,j,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ke(this.h,this.j.converter,G,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(j,U),typeof G.resolveInlayHint=="function",H,Ae.u(U));let se=this.p(ee);if(H!==void 0){const Te=G.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));se=a.$sM.from(se,Te)}return se}$provideInlayHints(U,j,G,H){return this.s(U,ke,ee=>ee.provideInlayHints(u.URI.revive(j),G,H),void 0,H)}$resolveInlayHint(U,j,G){return this.s(U,ke,H=>H.resolveInlayHint(j,G),void 0,G)}$releaseInlayHints(U,j){this.s(U,ke,G=>G.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(U,j,G){const H=this.t(new pe(this.h,G),U);return this.e.$registerDocumentLinkProvider(H,this.o(j,U),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(U,j,G){return this.s(U,pe,H=>H.provideLinks(u.URI.revive(j),G),void 0,G,j.scheme==="output")}$resolveDocumentLink(U,j,G){return this.s(U,pe,H=>H.resolveLink(j,G),void 0,void 0,!0)}$releaseDocumentLinks(U,j){this.s(U,pe,G=>G.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(U,j,G){const H=this.t(new de(this.h,G),U);return this.e.$registerDocumentColorProvider(H,this.o(j,U)),this.p(H)}$provideDocumentColors(U,j,G){return this.s(U,de,H=>H.provideColors(u.URI.revive(j),G),[],G)}$provideColorPresentations(U,j,G,H){return this.s(U,de,ee=>ee.provideColorPresentations(u.URI.revive(j),G,H),void 0,H)}registerFoldingRangeProvider(U,j,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ie(new J(this.h,G),U)),this.e.$registerFoldingRangeProvider(H,this.o(j,U),U.identifier,ee);let se=this.p(H);if(ee!==void 0){const Te=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));se=a.$sM.from(se,Te)}return se}$provideFoldingRanges(U,j,G,H){return this.s(U,J,ee=>ee.provideFoldingRanges(u.URI.revive(j),G,H),void 0,H)}registerSelectionRangeProvider(U,j,G){const H=this.t(new Y(this.h,G,this.l),U);return this.e.$registerSelectionRangeProvider(H,this.o(j,U)),this.p(H)}$provideSelectionRanges(U,j,G,H){return this.s(U,Y,ee=>ee.provideSelectionRanges(u.URI.revive(j),G,H),[],H)}registerCallHierarchyProvider(U,j,G){const H=this.t(new ue(this.h,G),U);return this.e.$registerCallHierarchyProvider(H,this.o(j,U)),this.p(H)}$prepareCallHierarchy(U,j,G,H){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(j),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(U,j,G,H){return this.s(U,ue,ee=>ee.provideCallsTo(j,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(U,j,G,H){return this.s(U,ue,ee=>ee.provideCallsFrom(j,G,H),void 0,H)}$releaseCallHierarchy(U,j){this.s(U,ue,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(U,j,G){const H=this.t(new he(this.h,G),U);return this.e.$registerTypeHierarchyProvider(H,this.o(j,U)),this.p(H)}$prepareTypeHierarchy(U,j,G,H){return this.s(U,he,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(j),G,H)),void 0,H)}$provideTypeHierarchySupertypes(U,j,G,H){return this.s(U,he,ee=>ee.provideSupertypes(j,G,H),void 0,H)}$provideTypeHierarchySubtypes(U,j,G,H){return this.s(U,he,ee=>ee.provideSubtypes(j,G,H),void 0,H)}$releaseTypeHierarchy(U,j){this.s(U,he,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(U,j,G,H){const ee=this.q();return this.f.set(ee,new Ie(new Ne(this.e,this.h,G,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(j,U),(0,h.$bG)(U,"dropMetadata")?H:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,j,G,H,ee,se){return this.s(U,Ne,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(j,u.URI.revive(G),H,ee,se)),void 0,void 0)}registerMappedEditsProvider(U,j,G){const H=this.t(new le(this.h,G),U);return this.e.$registerMappedEditsProvider(H,this.o(j,U)),this.p(H)}$provideMappedEdits(U,j,G,H,ee){return this.s(U,le,se=>Promise.resolve(se.provideMappedEdits(j,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(U,j,G,H){const ee=this.q();return this.f.set(ee,new Ie(new z(this.e,this.h,G,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(j,U),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,j,G,H,ee){return this.s(U,z,se=>se.prepareDocumentPaste(u.URI.revive(j),G,H,ee),void 0,ee)}$providePasteEdits(U,j,G,H,ee,se,Te){return this.s(U,z,Ve=>Ve.providePasteEdits(j,u.URI.revive(G),H,ee,se,Te),void 0,Te)}$resolvePasteEdit(U,j,G){return this.s(U,z,H=>H.resolvePasteEdit(j,G),{},void 0)}$releasePasteEdits(U,j){this.s(U,z,G=>Promise.resolve(G.releasePasteEdits(j)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Ae.w(U.decreaseIndentPattern),increaseIndentPattern:Ae.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ae.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ae.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Ae.w(U.beforeText),afterText:U.afterText?Ae.w(U.afterText):void 0,previousLineText:U.previousLineText?Ae.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Ae.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(j=>a.SyntaxTokenType.toString(j)):void 0}}static D(U){return U.map(Ae.C)}setLanguageConfiguration(U,j,G){const{wordPattern:H}=G;if(H&&(0,O.$0e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(j,H):this.h.setWordDefinitionFor(j,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),se={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ae.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Ae.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ae.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ae.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,j,se),this.p(ee)}$setWordDefinitions(U){for(const j of U)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$mjc=Ae}),define(Pe[88],Re([1,0,6,4,8,7,101,20,11,5,167,106,14,3,16,84,13]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=e.$tjc=void 0,e.$tjc=(0,w.$ii)("IExtHostLanguageModels");class n{constructor(t,v){this.option=t,this.stream=new d.$Lh,this.stream=v??new d.$Lh}}class i{constructor(){this.a=new Map,this.b=new d.$Lh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let v=this.a.get(t.index);v||(this.a.size===0?v=new n(t.index,this.b):v=new n(t.index),this.a.set(t.index,v)),v.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const v of this.f())v.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let a=class{static{s=this}static{this.a=1}constructor(t,v,c){this.j=v,this.k=c,this.c=new E.$7d,this.d=new E.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new g.$Fm,this.i=new Map,this.o=new Set,this.b=t.getProxy(T.$qM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,v,c,$){const b=s.a++;this.f.set(b,{extension:t.identifier,provider:c,languageModelId:v});let p;return $.auth&&(p={providerLabel:t.displayName||t.name,accountLabel:typeof $.auth=="object"?$.auth.label:void 0}),this.b.$registerLanguageModelProvider(b,v,{extension:t.identifier,identifier:v,model:$.name??"",auth:p}),(0,I.$Sc)(()=>{this.f.delete(b),this.b.$unregisterProvider(b)})}async $provideLanguageModelResponse(t,v,c,$,b,p){const l=this.f.get(t);if(!l)return;const D=new A.$Rv(async f=>{if(p.isCancellationRequested){this.j.warn(`[CHAT](${l.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(v,{index:f.index,part:f.part})});return l.provider.provideLanguageModelResponse2($.map(R.LanguageModelMessage.to),b,g.$Dm.toKey(c),D,p)}$updateLanguageModels(t){const v=[],c=[];if(t.added)for(const $ of t.added)this.g.set($.identifier,$),v.push($.model);if(t.removed)for(const $ of t.removed){this.g.delete($),c.push($);for(const[b,p]of this.i)p.languageModelId===$&&(p.res.reject(new u.$5),this.i.delete(b))}this.d.fire(Object.freeze({added:Object.freeze(v),removed:Object.freeze(c)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const v=new Array;for(const{from:c,to:$,enabled:b}of t){const p=this.h.get(c)??new g.$Em;if(p.has($)!==b){b?p.add($):p.delete($),this.h.set(c,p);const D={from:c,to:$};v.push(D),this.c.fire(D)}}}async sendChatRequest(t,v,c,$,b){const p=t.identifier,l=await this.b.$prepareChatAccess(p,v,$.justification);if(!l||!this.g.has(v))throw N.$yO.NotFound(`Language model '${v}' is unknown.`);if(this.m(p,l)&&(!await this.l(t,{identifier:l.extension,displayName:l.auth.providerLabel},$.justification,$.silent)||!this.h.get(p)?.has(l.extension)))throw N.$yO.NoPermissions(`Language model '${v}' cannot be used by '${p.value}'.`);const D=Math.random()*1e6|0,f=this.b.$fetchResponse(p,v,D,c.map(R.LanguageModelMessage.from),$.modelOptions??{},b),S=new d.$hh,k=new i;this.i.set(D,{languageModelId:v,res:k});let P;if(f.catch(C=>{S.isOpen()?k.reject(C):P=C}).finally(()=>{this.i.delete(D),k.resolve(),S.open()}),await S.wait(),P)throw new N.$yO(`Language model '${v}' errored, check cause for more details`,"Unknown",P);return k.apiObject}async $handleResponseFragment(t,v){const c=this.i.get(t);c&&c.res.handleFragment(v)}async l(t,v,c,$){const b=y.$sL+v.identifier.value;if(await this.k.getSession(t,b,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0;if($)return!1;try{const l=c?(0,O.localize)(0,null,v.displayName,c):(0,O.localize)(1,null,v.displayName);return await this.k.getSession(t,b,[],{forceNewSession:{detail:l}}),this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0}catch{return!1}}m(t,v){return!!v.auth&&!g.$Dm.equals(v.extension,t)}async n(t){for(const v of this.o)try{await this.l(v,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}createLanguageModelAccessInformation(t){this.o.add(t);const v=this,c=E.Event.signal(E.Event.filter(this.c.event,b=>g.$Dm.equals(b.from,t.identifier))),$=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(c,$)},canSendRequest(b){const p=v.g.get(b);if(!p)return;if(!v.m(t.identifier,p))return!0;const l=v.h.get(t.identifier);if(l)return l.has(p.extension)}}}};e.$ujc=a,e.$ujc=a=s=Je([qe(0,m.$LO),qe(1,o.$Oj),qe(2,r.$ojc)],a)}),define(Pe[264],Re([1,0,4,8,7,32,11,6,25]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;class E{constructor(y,u,w,m){this.c=u,this.d=w,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(I.$qM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const w=this.c.getDocumentData(y);if(!w)throw new Error(`document '${y.toString()}' NOT found`);return w.document}async tokenAtPosition(y,u){const w=y.version,m=T.Position.from(u),r=await this.a.$tokensAtPosition(y.uri,m),o={type:R.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new R.$uM(u.line,u.character,u.line,u.character)};if(!r)return o;const s={range:T.Range.to(r.range),type:T.TokenType.to(r.type)};return!s.range.contains(u)||w!==y.version?o:s}createLanguageStatusItem(y,u,w){const m=this.f++,r=this.a,o=this.g,s=`${y.identifier.value}/${u}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(s);const n={selector:w,id:u,name:y.displayName??y.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new g.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$kh)(()=>{a.clear(),this.a.$setLanguageStatus(m,{id:s,name:n.name??y.displayName??y.name,source:y.displayName??y.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===R.LanguageStatusSeverity.Error?N.default.Error:n.severity===R.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),r.$removeLanguageStatus(m),o.delete(s)},get id(){return n.id},get name(){return n.name},set name(v){n.name=v,h()},get selector(){return n.selector},set selector(v){n.selector=v,h()},get text(){return n.text},set text(v){n.text=v,h()},set text2(v){(0,d.$cG)(y,"languageStatusText"),n.text=v,h()},get text2(){return(0,d.$cG)(y,"languageStatusText"),n.text},get detail(){return n.detail},set detail(v){n.detail=v,h()},get severity(){return n.severity},set severity(v){n.severity=v,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(v){n.accessibilityInformation=v,h()},get command(){return n.command},set command(v){n.command=v,h()},get busy(){return n.busy},set busy(v){n.busy=v,h()}};return h(),t}}e.$Nkc=E}),define(Pe[265],Re([1,0,12,2,8,7,83]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=e.$ykc=void 0;class g{constructor(y,u,w,m){this.start=y,this.deletedCount=u,this.deletedItems=w,this.items=m}asApiEvent(){return{range:new N.$TN(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class d{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,w){this.notebook=y,this.h=u,this.j=w,this.handle=w.handle,this.uri=T.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(R.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(m){y.g=m},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(w)}return this.f}setOutputs(y){this.a=y.map(R.NotebookCellOutput.to)}setOutputItems(y,u,w){const m=w.map(R.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===y);if(r&&(u||(r.items.length=0),r.items.push(...m),r.items.length>1&&r.items.every(o=>A.$nK(o.mime)))){const o=new Map,s=[];r.items.forEach(n=>{let i;o.has(n.mime)?i=o.get(n.mime):(i=[],o.set(n.mime,i),s.push(n.mime)),i.push(n.data)}),r.items.length=0,s.forEach(n=>{const i=A.$oK(o.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$ykc=d;class E{static{this.a=0}constructor(y,u,w,m,r){this.k=y,this.l=u,this.m=w,this.uri=m,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===I.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(w){return w=y.n(w),y.b[w].apiCell},getCells(w){return(w?y.p(w):y.b).map(r=>r.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,w){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:w});const m={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},r=[];for(const s of y.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,m.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,m.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const n=r[s],i=o.get(n.cell);if(i===void 0){const a=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,a-1)}else m.cellChanges[i]={...m.cellChanges[i],...n}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,w=y.end|0;return u<0&&(u=0),w>this.b.length&&(w=this.b.length),y.with({start:u,end:w})}p(y){y=this.o(y);const u=[];for(let w=y.start;w<y.end;w++)u.push(this.b[w]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,w){if(this.j)return;const m=[],r=[],o=[];if(y.reverse().forEach(s=>{const i=s[2].map(t=>{const v=new d(this,this.l,t);return u||r.push(d.asModelAddData(t)),v}),a=new g(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),a.deletedItems.push(t.apiCell);m.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),w)for(const s of m)w.push(s.asApiEvent())}s(y,u,w,m){const r=this.b.splice(y,u);this.b.splice(w,0,...r);const o=[new g(y,u,r.map(s=>s.apiCell),[]),new g(w,0,[],r)];for(const s of o)m.push(s.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,w,m){this.b[y].setOutputItems(u,w,m)}v(y,u){const w=this.b[y];w.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(w.uri,u)}w(y,u){const w=this.b[y];w.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$zkc=E}),define(Pe[266],Re([1,0,5,2,8,7]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class A{constructor(d,E,O,y={timeout:1500,errors:3}){this.b=d,this.c=E,this.d=O,this.f=y,this.a=new I.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent(d){return(E,O,y)=>{const u=function(m){E.call(O,m)};return u.extension=d,this.a.event(u,void 0,y)}}async $participateInSave(d,E,O){const y=T.URI.revive(d),u=this.c.getNotebookDocument(y);if(!u)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:R.TextDocumentSaveReason.to(E)},O,async(r,o)=>{const s=Date.now(),n=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!O.isCancellationRequested&&n&&(n instanceof N.$CM?w.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),O.isCancellationRequested)return!1;if(w.length===0)return!0;const m={edits:[]};for(const r of w){const{edits:o}=R.WorkspaceEdit.from(r);m.edits=m.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(m)}}e.$Pkc=A}),define(Pe[112],Re([1,0,14,8,7]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,d,E,O,y,u){this.id=g,this.f=d,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=O,this.c=u}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(d){this.selections=[d]},get selections(){return g.a},set selections(d){if(!Array.isArray(d)||!d.every(R.$TN.isNotebookRange))throw(0,I.$7)("selections");g.a=d,g.g(d)},get visibleRanges(){return g.b},revealRange(d,E){g.f.$tryRevealRange(g.id,T.NotebookRange.from(d),E??R.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(T.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$Akc=N}),define(Pe[267],Re([1,0,5,13,8]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;let N=class{constructor(g,d){this.c=g,this.d=d,this.a=new I.$7d,this.b=new I.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,d);const E=this.d.getEditorById(g);d.visibleRanges&&E._acceptVisibleRanges(d.visibleRanges.ranges.map(R.NotebookRange.to)),d.selections&&E._acceptSelections(d.selections.selections.map(R.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const d in g)this.d.getEditorById(d)._acceptViewColumn(R.ViewColumn.to(g[d]))}};e.$Rkc=N,e.$Rkc=N=Je([qe(0,T.$Oj)],N)}),define(Pe[268],Re([1,0,5,4,112]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=void 0;class N{constructor(g,d){this.c=d,this.a=new Map,this.b=g.getProxy(T.$qM.MainThreadNotebookRenderers)}$postRendererMessage(g,d,E){const O=this.c.getEditorById(g);this.a.get(d)?.fire({editor:O.apiEditor,message:E})}createRendererMessaging(g,d){if(!g.contributes?.notebookRenderer?.some(O=>O.id===d))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${d})`);return{onDidReceiveMessage:(O,y,u)=>this.d(d).event(O,y,u),postMessage:(O,y)=>{R.$Akc.apiEditorsToExtHost.has(O)&&([O,y]=[y,O]);const u=y&&R.$Akc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,d,O)}}}d(g){let d=this.a.get(g);return d||(d=new I.$7d({onDidRemoveLastListener:()=>{d?.dispose(),this.a.delete(g)}}),this.a.set(g,d),d)}}e.$Ukc=N}),define(Pe[269],Re([1,0,8,101,24,68,14]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=void 0;class g{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,w){const m=this.b++,{title:r,location:o,cancellable:s}=u,n={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(m,{location:I.ProgressLocation.from(o),title:r,source:n,cancellable:s},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$2),this.d(m,w,!!s)}d(y,u,w){let m;w&&(m=new R.$ee,this.c.set(y,m));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),m?.dispose()};let o;try{o=u(new E(this.a,y),w&&m?m.token:R.CancellationToken.None)}catch(s){throw r(y),s}return o.then(s=>r(y),s=>r(y)),o}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$Ykc=g;function d(O,y){return O.message=y.message,typeof y.increment=="number"&&(typeof O.increment=="number"?O.increment+=y.increment:O.increment=y.increment),O}class E extends T.$Rv{constructor(y,u){super(w=>this.throttledReport(w)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,N.$Oh)(100,(O,y)=>d(O,y),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Pe[270],Re([1,0,2,4,11,8]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=void 0;class A{static{this.a=0}constructor(d,E){this.d=E,this.c=new Map,this.b=d.getProxy(T.$qM.MainThreadQuickDiff)}$provideOriginalResource(d,E,O){const y=I.URI.revive(E),u=this.c.get(d);return u?(0,R.$ah)(()=>u.provideOriginalResource(y,O)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(d,E,O,y){const u=A.a++;return this.c.set(u,E),this.b.$registerQuickDiffProvider(u,N.DocumentSelector.from(d,this.d),O,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Zkc=A}),define(Pe[271],Re([1,0,24,5,6,4,2,7,14,18,32,41,25,8]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=m;function m(r,o,s){const n=r.getProxy(N.$qM.MainThreadQuickOpen);class i{constructor(l,D){this.e=new Map,this.f=0,this.a=l,this.b=D}showQuickPick(l,D,f,S=I.CancellationToken.None){this.c=void 0;const k=Promise.resolve(D),P=++this.f,C=n.$show(P,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},S),q={},V=C.then(()=>q);return Promise.race([V,k]).then(W=>{if(W===q)return;const M=(0,u.$bG)(l,"quickPickItemTooltip");return k.then(z=>{const K=[];for(let ie=0;ie<z.length;ie++){const fe=z[ie];if(typeof fe=="string")K.push({label:fe,handle:ie});else if(fe.kind===g.QuickPickItemKind.Separator)K.push({type:"separator",label:fe.label});else{fe.tooltip&&!M&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const De=fe.iconPath?c(fe.iconPath):void 0;K.push({label:fe.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:M?w.MarkdownString.fromStrict(fe.tooltip):void 0,handle:ie})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=ie=>{f.onDidSelectItem(z[ie])}),n.$setItems(P,K),C.then(ie=>{if(typeof ie=="number")return z[ie];if(Array.isArray(ie))return ie.map(fe=>z[fe])})})}).then(void 0,W=>{if(!(0,d.$4)(W))return n.$setError(P,W),Promise.reject(W)})}$onItemSelected(l){this.c?.(l)}showInput(l,D=I.CancellationToken.None){return this.d=l?.validateInput,n.$input(l,typeof this.d=="function",D).then(void 0,f=>{if(!(0,d.$4)(f))return Promise.reject(f)})}async $validateInput(l){if(!this.d)return;const D=await this.d(l);if(!D||typeof D=="string")return D;let f;switch(D.severity){case g.InputBoxValidationSeverity.Info:f=O.default.Info;break;case g.InputBoxValidationSeverity.Warning:f=O.default.Warning;break;case g.InputBoxValidationSeverity.Error:f=O.default.Error;break;default:f=D.message?O.default.Error:O.default.Ignore;break}return{content:D.message,severity:f}}async showWorkspaceFolderPick(l,D=I.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!f)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(k=>k.uri.toString()===f.uri.toString())}createQuickPick(l){const D=new $(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(l){const D=new b(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(l,D){this.e.get(l)?._fireDidChangeValue(D)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,D){const f=this.e.get(l);f instanceof $&&f._fireDidChangeActive(D)}$onDidChangeSelection(l,D){const f=this.e.get(l);f instanceof $&&f._fireDidChangeSelection(D)}$onDidTriggerButton(l,D){this.e.get(l)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(l,D,f){const S=this.e.get(l);S instanceof $&&S._fireDidTriggerItemButton(D,f)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class a{static{this.a=1}constructor(l,D){this.x=l,this.y=D,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$7d,this.q=new T.$7d,this.r=new T.$7d,this.s=new T.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((D,f)=>{const S=D===g.$QN.Back?-1:f;this.o.set(S,D)}),this.z({buttons:l.map((D,f)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===g.$QN.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const D=this.o.get(l);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(l){if(!this.v){for(const D of Object.keys(l)){const f=l[D];this.u[D]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(p){if(p instanceof g.$oN)return{id:p.id};const l=v(p),D=t(p);return{dark:typeof l=="string"?A.URI.file(l):l,light:typeof D=="string"?A.URI.file(D):D}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function v(p){return typeof p=="object"&&"dark"in p?p.dark:p}function c(p){const l=h(p);let D,f;return"id"in l?f=y.ThemeIcon.asClassName(l):D=l,{iconPath:D,iconClass:f}}class $ extends a{constructor(l,D){super(l.identifier,D),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$7d,this.L=[],this.M=new T.$7d,this.N=new T.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((S,k)=>{this.C.set(k,S),this.D.set(S,k)});const D=(0,u.$bG)(this.O,"quickPickItemTooltip"),f=[];for(let S=0;S<l.length;S++){const k=l[S];if(k.kind===g.QuickPickItemKind.Separator)f.push({type:"separator",label:k.label});else{k.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?c(k.iconPath):void 0;f.push({handle:S,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:D?w.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((C,q)=>({...c(C.iconPath),tooltip:C.tooltip,handle:q}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(l){const D=(0,E.$Hb)(l.map(f=>this.C.get(f)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(l){const D=(0,E.$Hb)(l.map(f=>this.C.get(f)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(l,D){const f=this.C.get(l);if(!f||!f.buttons||!f.buttons.length)return;const S=f.buttons[D];S&&this.N.fire({button:S,item:f})}}class b extends a{constructor(l,D){super(l.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:O.default.Error}):this.z({validationMessage:l.message,severity:l.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new i(o,s)}}),define(Pe[272],Re([1,0,2,5,68,6,11,4,18,143,13,20,41,8,25,12,21]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=e.$2kc=void 0;function n(P){return P instanceof I.URI}function i(P,C){return P.scheme===r.Schemas.file&&C.scheme===r.Schemas.file&&o.$k?P.toString()===C.toString():P.toString().toLowerCase()===C.toString().toLowerCase()}function a(P){if(P)return typeof P.iconPath=="string"?I.URI.file(P.iconPath):I.URI.isUri(P.iconPath)||u.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function h(P){if(P.icon){if(I.URI.isUri(P.icon))return P.icon;if(u.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const C=P.icon;return{light:C.light,dark:C.dark}}}else return}function t(P,C){if(!P.iconPath&&!C.iconPath)return 0;if(P.iconPath){if(!C.iconPath)return 1}else return-1;const q=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,V=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,E.$ar)(q,V)}function v(P,C){let q=0;if(P.strikeThrough!==C.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==C.faded)return P.faded?1:-1;if(P.tooltip!==C.tooltip)return(P.tooltip||"").localeCompare(C.tooltip||"");if(q=t(P,C),q!==0)return q;if(P.light&&C.light)q=t(P.light,C.light);else{if(P.light)return 1;if(C.light)return-1}if(q!==0)return q;if(P.dark&&C.dark)q=t(P.dark,C.dark);else{if(P.dark)return 1;if(C.dark)return-1}return q}function c(P,C){if(P.command!==C.command)return P.command<C.command?-1:1;if(P.title!==C.title)return P.title<C.title?-1:1;if(P.tooltip!==C.tooltip){if(P.tooltip!==void 0&&C.tooltip!==void 0)return P.tooltip<C.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(P.arguments===C.arguments)return 0;if(P.arguments)if(C.arguments){if(P.arguments.length!==C.arguments.length)return P.arguments.length-C.arguments.length}else return 1;else return-1;for(let q=0;q<P.arguments.length;q++){const V=P.arguments[q],W=C.arguments[q];if(V!==W&&!(n(V)&&n(W)&&i(V,W)))return V<W?-1:1}return 0}function $(P,C){let q=(0,E.$ar)(P.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(q!==0)return q;if(P.command&&C.command)q=c(P.command,C.command);else{if(P.command)return 1;if(C.command)return-1}if(q!==0)return q;if(P.decorations&&C.decorations)q=v(P.decorations,C.decorations);else{if(P.decorations)return 1;if(C.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&C.multiFileDiffEditorModifiedUri)q=(0,E.$ar)(P.multiFileDiffEditorModifiedUri.fsPath,C.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(C.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&C.multiDiffEditorOriginalUri)q=(0,E.$ar)(P.multiDiffEditorOriginalUri.fsPath,C.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(C.multiDiffEditorOriginalUri)return-1}return q}function b(P,C){for(let q=0;q<P.length;q++)if(P[q]!==C[q])return!1;return!0}function p(P,C){return P.command===C.command&&P.title===C.title&&P.tooltip===C.tooltip&&(P.arguments&&C.arguments?b(P.arguments,C.arguments):P.arguments===C.arguments)}function l(P,C){return(0,d.$ub)(P,C,p)}class D{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.l,C),this.n(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.l,C),this.f=C}get validateInput(){return(0,m.$cG)(this.k,"scmValidation"),this.g}set validateInput(C){if((0,m.$cG)(this.k,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.l,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.l,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.l,C))}get document(){return(0,m.$cG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(C,q,V,W,M){this.k=C,this.l=W,this.m=M,this.d="",this.e=new T.$7d,this.f="",this.h=!0,this.j=!0,this.#t=q,this.#e=V}showValidationMessage(C,q){(0,m.$cG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,C,q)}$onInputBoxValueChange(C){this.n(C)}n(C){this.d=C,this.e.fire(C)}}e.$2kc=D;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,q,V,W,M,z,K){this.q=C,this.s=q,this.t=V,this.u=W,this.v=M,this.multiDiffEditorEnableViewChanges=z,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,q){const V=this.h.get(C);return V?(0,A.$ah)(()=>this.s.executeCommand(V.command,...V.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort($),V=(0,d.$Db)(this.o,C,$).map(z=>{const K=z.toInsert.map(ie=>{const fe=this.e++;this.g.set(fe,ie);const De=ie.resourceUri;let ye;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const de=new N.$Tc;ye=this.s.converter.toInternal(ie.command,de),this.j.set(fe,de)}else this.h.set(fe,ie.command);const oe=(0,m.$bG)(this.w,"scmMultiDiffEditor"),$e=oe?ie.multiDiffEditorOriginalUri:void 0,ne=oe?ie.multiFileDiffEditorModifiedUri:void 0,Se=a(ie.decorations),je=ie.decorations&&a(ie.decorations.light)||Se,re=ie.decorations&&a(ie.decorations.dark)||Se,L=[je,re],_=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Oe=ie.decorations&&!!ie.decorations.faded,ke=ie.contextValue||"";return{rawResource:[fe,De,L,_,ve,Oe,ke,ye,$e,ne],handle:fe}});return{start:z.start,deleteCount:z.deleteCount,toInsert:K}}),W=V.map(({start:z,deleteCount:K,toInsert:ie})=>[z,K,ie.map(fe=>fe.rawResource)]),M=V.reverse();for(const{start:z,deleteCount:K,toInsert:ie}of M){const fe=ie.map(ye=>ye.handle),De=this.n.splice(z,K,...fe);for(const ye of De)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=C,W}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.w,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let q;(0,m.$bG)(this.x,"quickDiffProvider")&&(q=C?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!C,quickDiffLabel:q})}get historyProvider(){return(0,m.$cG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(C){(0,m.$cG)(this.x,"scmHistoryProvider"),this.j=C,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!C}),C&&this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(C){C!==this.m&&(this.m=C,this.#e.$updateSourceControl(this.w,{commitTemplate:C}))}get acceptInputCommand(){return this.o}set acceptInputCommand(C){this.n.value=new N.$Tc,this.o=C;const q=this.y.converter.toInternal(C,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:q})}get actionButton(){return(0,m.$cG)(this.x,"scmActionButton"),this.q}set actionButton(C){(0,m.$cG)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=C;const q=C!==void 0?{command:this.y.converter.toInternal(C.command,this.p.value),secondaryCommands:C.secondaryCommands?.map(V=>V.map(W=>this.y.converter.toInternal(W,this.p.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:q??null})}get statusBarCommands(){return this.t}set statusBarCommands(C){if(this.t&&C&&l(this.t,C))return;this.s.value=new N.$Tc,this.t=C;const q=(C||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:q})}get selected(){return this.u}constructor(C,q,V,W,M,z,K){this.x=C,this.y=W,this.z=M,this.A=z,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new T.$7d,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=I.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new D(C,q,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,M,z,K,ie)}createResourceGroup(C,q,V){const W=(0,m.$bG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,M=new f(this.#e,this.y,this.w,C,q,W,this.x),z=T.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,z),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const C=[],q=[];for(const[V,W]of this.C){W.dispose();const M=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});T.Event.once(V.onDidDispose)(()=>{this.D.delete(V),M.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),C.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const z=V._takeResourceStateSnapshot();z.length>0&&q.push([V.handle,z]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,C,q),this.C.clear()}eventuallyUpdateResourceStates(){const C=[];this.D.forEach(q=>{const V=q._takeResourceStateSnapshot();V.length!==0&&C.push([q.handle,V])}),C.length>0&&this.#e.$spliceResourceStates(this.w,C),this.D.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.u=C,this.v.fire(C)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$Nh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$Nh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,q,V,W){this.l=q,this.m=V,this.n=W,this.g=new Map,this.h=new y.$Fm,this.j=new T.$7d,this.e=C.getProxy(g.$qM.MainThreadSCM),this.f=C.getProxy(g.$qM.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const z=this.g.get(M.sourceControlHandle);if(!z)return M;const K=z.getResourceGroup(M.groupHandle);return K?K.getResourceState(M.handle):M}else if(M&&M.$mid===4){const z=this.g.get(M.sourceControlHandle);return z?z.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const z=this.g.get(M.handle);return z||M}return M}})}createSourceControl(C,q,V,W){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,q,V,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const M=s.d++,z=new S(C,this.m,this.e,this.l,q,V,W);this.g.set(M,z);const K=this.h.get(C.identifier)||[];return K.push(z),this.h.set(C.identifier,K),z}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const q=this.h.get(C.identifier),V=q&&q[q.length-1];return V&&V.inputBox}$provideOriginalResource(C,q,V){const W=I.URI.revive(q);this.n.trace("ExtHostSCM#$provideOriginalResource",C,W.toString());const M=this.g.get(C);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$ah)(()=>M.quickDiffProvider.provideOriginalResource(W,V)).then(z=>z||null)}$onInputBoxValueChange(C,q){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const V=this.g.get(C);return V&&V.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(C,q,V,W){this.n.trace("ExtHostSCM#$executeResourceCommand",C,q,V);const M=this.g.get(C);if(!M)return Promise.resolve(void 0);const z=M.getResourceGroup(q);return z?z.$executeResourceCommand(V,W):Promise.resolve(void 0)}$validateInput(C,q,V){this.n.trace("ExtHostSCM#$validateInput",C);const W=this.g.get(C);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,A.$ah)(()=>W.inputBox.validateInput(q,V)).then(M=>{if(!M)return Promise.resolve(void 0);const z=w.MarkdownString.fromStrict(M.message);return z?Promise.resolve([z,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(C,q,V,W){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,V,W)??void 0}async $provideHistoryItems(C,q,V,W){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(q,V,W))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(C,q,V,W){const M=this.g.get(C)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const z=await M.provideHistoryItemSummary(q,V,W);return z?{...z,icon:h(z)}:void 0}async $provideHistoryItemChanges(C,q,V,W){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(q,V,W)??void 0}};e.$3kc=k,e.$3kc=k=s=Je([qe(3,O.$Oj)],k)}),define(Pe[273],Re([1,0,4,8,2]),function(ge,e,I,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=void 0;class N{static{this.a=0}constructor(g,d){this.d=d,this.c=new Map,this.b=g.getProxy(I.$qM.MainThreadShare)}async $provideShare(g,d,E){return await this.c.get(g)?.provideShare({selection:T.Range.to(d.selection),resourceUri:R.URI.revive(d.resourceUri)},E)??void 0}registerShareProvider(g,d){const E=N.a++;return this.c.set(E,d),this.b.$registerShareProvider(E,T.DocumentSelector.from(g,this.d),d.id,d.label,d.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$4kc=N}),define(Pe[274],Re([1,0,7,4,170,6,8,17]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=e.$6kc=void 0;class d{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$pN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$pN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,w,m,r,o,s=I.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=u,this.#t=w,o&&r){this.c=(0,I.$4M)(r.identifier,o);const i=m.get(this.c);i&&(s=i.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(d.a++);this.e=r,this.f=o,this.g=s,this.h=this.u(n)}u(u){if((0,g.$Zf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!d.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let w;this.m?w=this.m:w=(0,R.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=d.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,w,this.k,r,this.r?.internal,m,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$6kc=d;class E{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const w={message:u};return this.b.unshift(w),this.c(),new I.$sM(()=>{const m=this.b.indexOf(w);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class O{constructor(u,w){this.e=new Map,this.a=u.getProxy(T.$qM.MainThreadStatusBar),this.b=w,this.c=new E(this)}$acceptStaticEntries(u){for(const w of u)this.e.set(w.entryId,w)}createStatusBarEntry(u,w,m,r){return new d(this.a,this.b,this.e,u,w,m,r)}setStatusBarMessage(u,w){const m=this.c.setMessage(u);let r;return typeof w=="number"?r=setTimeout(()=>m.dispose(),w):typeof w<"u"&&w.then(()=>m.dispose(),()=>m.dispose()),new I.$sM(()=>{m.dispose(),clearTimeout(r)})}}e.$7kc=O}),define(Pe[113],Re([1,0,29,105,49,75,61,8,2]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=e.$YO=e.$XO=void 0;const E=(i,a,h,t)=>{let v=a;return{enumerable:!0,configurable:!1,get(){return v},set(c){if(!h(v,c)){const $=v;v=c,i.listener?.(t(c,$))}}}},O=(i,a)=>i===a,y={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(i,a)=>!(i.length!==a.length||i.some(h=>!a.find(t=>h.id===t.id)))},u=i=>a=>({op:4,update:i(a)}),w=(i,a)=>({range:(()=>{let h;const t=u(v=>({range:I.$ct.lift(g.Range.from(v))}));return{enumerable:!0,configurable:!1,get(){return h},set(v){i.listener?.({op:6}),y.range(h,v)||(h=v,i.listener?.(t(v)))}}})(),label:E(i,a,y.label,u(h=>({label:h}))),description:E(i,void 0,y.description,u(h=>({description:h}))),sortText:E(i,void 0,y.sortText,u(h=>({sortText:h}))),canResolveChildren:E(i,!1,y.canResolveChildren,h=>({op:2,state:h})),busy:E(i,!1,y.busy,u(h=>({busy:h}))),error:E(i,void 0,y.error,u(h=>({error:g.MarkdownString.fromStrict(h)||null}))),tags:E(i,[],y.tags,(h,t)=>({op:1,new:h.map(g.TestTag.from),old:t.map(g.TestTag.from)}))}),m=i=>{const a=R.$cL.fromString(i.extId),h=new o(a.controllerId,a.localId,i.label,d.URI.revive(i.uri)||void 0);return h.range=g.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>g.TestTag.to({id:(0,A.$iL)(t).tagId})),h},r=i=>{let a;for(const h of i.tests){const t=m(h.item);(0,T.$HO)(t).parent=a,a=t}return a};e.$XO=r;class o{constructor(a,h,t,v){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,T.$GO)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:v,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,N.$FO)(c,T.$HO,o),enumerable:!0,writable:!1},...w(c,t)})}}e.$YO=o;class s extends o{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$ZO=s;class n extends N.$BO{constructor(a,h,t){super({controllerId:a,getDocumentVersion:v=>v&&t.getDocument(v)?.version,getApiFor:T.$HO,getChildren:v=>v.children,root:new s(a,h),toITestItem:g.TestItem.from})}}e.$1O=n}),define(Pe[31],Re([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,22,50,42,65,59,62,34]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=void 0;let c=class{#e;#t;#i;constructor(f,S,k){this.b=new Map,this.c=new Map,this.#e=f.getProxy(A.$qM.MainThreadCommands),this.d=S,this.#i=k,this.#t=f.getProxy(A.$qM.MainThreadTelemetry),this.converter=new $(this,P=>{const C=this.c.get(P);return C?.result===p.Void?C:void 0},S),this.f=[{processArgument(P){return(0,E.$Rh)(P)}},{processArgument(P){return(0,N.$Qn)(P,function(C){if(O.$ct.isIRange(C))return R.Range.to(C);if(y.$bt.isIPosition(C))return R.Position.to(C);if(O.$ct.isIRange(C.range)&&u.URI.isUri(C.uri))return R.location.to(C);if(C instanceof s.$ue)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const S=this.registerCommand(!1,f.id,async(...k)=>{const P=f.args.map((q,V)=>{if(!q.validate(k[V]))throw new Error(`Invalid argument '${q.name}' when running '${f.id}', received: ${typeof k[V]=="object"?JSON.stringify(k[V],null,"	"):k[V]} `);return q.convert(k[V])}),C=await this.executeCommand(f.internalId,...P);return f.result.convert(C,k,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new T.$sM(()=>{S.dispose(),this.c.delete(f.id)})}registerCommand(f,S,k,P,C,q){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:k,thisArg:P,metadata:C,extension:q}),f&&this.#e.$registerCommand(S),new T.$sM(()=>{this.b.delete(S)&&f&&this.#e.$unregisterCommand(S)})}executeCommand(f,...S){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,S,!0)}async g(f,S,k){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,S,!1);{let P=!1;const C=(0,N.$Qn)(S,function(q){if(q instanceof T.$tM)return R.Position.from(q);if(q instanceof T.$uM)return R.Range.from(q);if(q instanceof T.$EM)return R.location.from(q);if(T.$TN.isNotebookRange(q))return R.NotebookRange.from(q);if(q instanceof ArrayBuffer)return P=!0,s.$ue.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return P=!0,s.$ue.wrap(q);if(q instanceof s.$ue)return P=!0,q;if(!Array.isArray(q))return q});try{const q=await this.#e.$executeCommand(f,P?new n.$ew(C):C,k);return(0,E.$Rh)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(f,S,!1);throw q}}}async h(f,S,k){const P=this.b.get(f);if(!P)throw new Error("Unknown command");const{callback:C,thisArg:q,metadata:V}=P;if(V?.args)for(let M=0;M<V.args.length;M++)try{(0,I.$ag)(S[M],V.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${V.args[M].name}' - ${V.args[M].description}`)}const W=a.$3d.create();try{return await C.apply(q,S)}catch(M){if(f===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...S);z&&(f=z.command)}if(this.d.error(M,f,P.extension?.identifier),!k)throw M;if(P.extension?.identifier){const z=this.#i.onExtensionError(P.extension.identifier,M);this.d.trace("forwarded error to extension?",z,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$6i)(M)),this.id=f,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,f,W.elapsed())}}j(f,S,k){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new h.$4o(S),duration:k})}$executeContributedCommand(f,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const k=this.b.get(f);return k?(S=S.map(P=>this.f.reduce((C,q)=>q.processArgument(C,k.extension?.identifier),P)),this.h(f,S,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(S=>(f&&(S=S.filter(k=>k[0]!=="_")),S))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[S,k]of this.b){const{metadata:P}=k;P&&(f[S]=P)}return Promise.resolve(f)}};e.$7O=c,e.$7O=c=Je([qe(0,r.$LO),qe(1,d.$Oj),qe(2,t.$6O)],c),e.$8O=(0,m.$ii)("IExtHostCommands");class ${constructor(f,S,k){this.d=f,this.f=S,this.g=k,this.delegatingCommandId=`__vsc${(0,v.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,S){if(!f)return;const k={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return k;const P=this.f(f.command);if(P)k.id=P.internalId,k.arguments=P.args.map((C,q)=>C.convert(f.arguments&&f.arguments[q]));else if((0,g.$Lb)(f.arguments)){const C=`${f.command} /${++this.c}`;this.b.set(C,f),S.add((0,w.$Sc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),k.$ident=C,k.id=this.delegatingCommandId,k.arguments=[C],this.g.trace("CommandsConverter#CREATE",f.command,C)}return k}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const S=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$9O=$;class b{static{this.Uri=new b("uri","Uri of a text document",f=>u.URI.isUri(f),f=>f)}static{this.Position=new b("position","A position in a text document",f=>T.$tM.isPosition(f),R.Position.from)}static{this.Range=new b("range","A range in a text document",f=>T.$uM.isRange(f),R.Range.from)}static{this.Selection=new b("selection","A selection in a text document",f=>T.$vM.isSelection(f),R.Selection.from)}static{this.Number=new b("number","",f=>typeof f=="number",f=>f)}static{this.String=new b("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=b.Arr(b.String)}static Arr(f){return new b(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,S=>Array.isArray(S)&&S.every(k=>f.validate(k)),S=>S.map(k=>f.convert(k)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",f=>f instanceof T.$PM,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",f=>f instanceof T.$aO,R.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",f=>f instanceof o.$YO,R.TestItem.from)}constructor(f,S,k,P){this.name=f,this.description=S,this.validate=k,this.convert=P}optional(){return new b(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,S){return new b(f??this.name,S??this.description,this.validate,this.convert)}}e.$0O=b;class p{static{this.Void=new p("no result",f=>f)}constructor(f,S){this.description=f,this.convert=S}}e.$$O=p;class l{constructor(f,S,k,P,C){this.id=f,this.internalId=S,this.description=k,this.args=P,this.result=C}}e.$_O=l}),define(Pe[275],Re([1,0,18,12,2,87,97,33,31,8,7]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;const y=[new d.$_O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of DocumentHighlight-instances.",w(E.DocumentHighlight.to))),new d.$_O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$0O.Uri],new d.$$O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,I.$Kb)(r))return;class s extends O.$KM{static to(i){const a=new s(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new O.$EM(o[0],E.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=E.Range.to(i.selectionRange),a.children=i.children?i.children.map(s.to):[],a}}return r.map(s.to)})),new d.$_O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$0O.Uri,new d.$0O("options","Formatting options",r=>!0,r=>r)],new d.$$O("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new d.$_O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$0O.Uri,d.$0O.Range,new d.$0O("options","Formatting options",r=>!0,r=>r)],new d.$$O("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new d.$_O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$0O.Uri,d.$0O.Position,new d.$0O("ch","Trigger character",r=>typeof r=="string",r=>r),new d.$0O("options","Formatting options",r=>!0,r=>r)],new d.$$O("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new d.$_O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of Location or LocationLink instances.",m)),new d.$_O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of Location or LocationLink instances.",m)),new d.$_O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of Location or LocationLink instances.",m)),new d.$_O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of Location or LocationLink instances.",m)),new d.$_O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of Location-instances.",w(E.location.to))),new d.$_O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of Hover-instances.",w(E.Hover.to))),new d.$_O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$0O.Uri,new d.$0O("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>O.$tM.isPosition(o)),r=>r.map(E.Position.from))],new d.$$O("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const n of o.reverse())s=new O.$OM(E.Range.to(n),s);return s}))),new d.$_O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$0O.String.with("query","Search string")],new d.$$O("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(E.WorkspaceSymbol.to))),new d.$_O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(E.CallHierarchyItem.to))),new d.$_O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$0O.CallHierarchyItem],new d.$$O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(E.CallHierarchyIncomingCall.to))),new d.$_O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$0O.CallHierarchyItem],new d.$$O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(E.CallHierarchyOutgoingCall.to))),new d.$_O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:E.Range.to(r.range),placeholder:r.text}})),new d.$_O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$0O.Uri,d.$0O.Position,d.$0O.String.with("newName","The new symbol name")],new d.$$O("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return E.WorkspaceEdit.to(r)}})),new d.$_O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$0O.Uri,d.$0O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$$O("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(E.DocumentLink.to))),new d.$_O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$0O.Uri],new d.$$O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new O.$KN(r.tokenTypes,r.tokenModifiers)})),new d.$_O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$0O.Uri],new d.$$O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Qab)(r);if(o.type==="full")return new O.$MN(o.data,void 0)})),new d.$_O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$0O.Uri,d.$0O.Range.optional()],new d.$$O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new O.$KN(r.tokenTypes,r.tokenModifiers)})),new d.$_O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$0O.Uri,d.$0O.Range],new d.$$O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Qab)(r);if(o.type==="full")return new O.$MN(o.data,void 0)})),new d.$_O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$0O.Uri,d.$0O.Position,d.$0O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$0O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$$O("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new O.$1M([]);const n=r.suggestions.map(i=>E.CompletionItem.to(i,s));return new O.$1M(n,r.incomplete)})),new d.$_O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$0O.Uri,d.$0O.Position,d.$0O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$$O("A promise that resolves to SignatureHelp.",r=>{if(r)return E.SignatureHelp.to(r)})),new d.$_O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$0O.Uri,d.$0O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$$O("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>w(n=>new O.$SM(E.Range.to(n.range),n.command&&s.fromInternal(n.command)))(r))),new d.$_O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$0O.Uri,new d.$0O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>O.$uM.isRange(r),r=>O.$vM.isSelection(r)?E.Selection.from(r):E.Range.from(r)),d.$0O.String.with("kind","Code action kind to return code actions for").optional(),d.$0O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$$O("A promise that resolves to an array of Command-instances.",(r,o,s)=>w(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const i=new O.$MM(n.title,n.kind?new O.$NM(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=s.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new d.$_O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$0O.Uri],new d.$$O("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new O.$7M(E.Range.to(o.range),E.Color.to(o.color))):[])),new d.$_O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$0O("color","The color to show and insert",r=>r instanceof O.$6M,E.Color.from),new d.$0O("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:E.Range.from(r.range)}))],new d.$$O("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(E.ColorPresentation.to):[])),new d.$_O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$0O.Uri,d.$0O.Range],new d.$$O("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(E.InlayHint.to.bind(void 0,s)))),new d.$_O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$0O.Uri],new d.$$O("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(E.FoldingRange.to)})),new d.$_O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$$O("A promise that resolves to an array of NotebookContentProvider static info objects.",w(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.to(o))})))),new d.$_O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$0O.Uri,d.$0O.Range,new d.$0O("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof O.$uM,r=>E.InlineValueContext.from(r))],new d.$$O("A promise that resolves to an array of InlineValue objects",r=>r.map(E.InlineValue.to))),new d.$_O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$0O("uriOrString","Uri-instance or string (only http/https)",r=>R.URI.isUri(r)||typeof r=="string"&&(0,T.$sg)(r,T.Schemas.http,T.Schemas.https),r=>r),new d.$0O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional(),d.$0O.String.with("label","").optional()],d.$$O.Void),new d.$_O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$0O.Uri.with("resource","Resource to open"),d.$0O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$0O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional()],d.$$O.Void),new d.$_O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$0O.Uri.with("left","Left-hand side resource of the diff editor"),d.$0O.Uri.with("right","Right-hand side resource of the diff editor"),d.$0O.String.with("title","Human readable title for the diff editor").optional(),new d.$0O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)]).optional()],d.$$O.Void),new d.$_O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[d.$0O.String.with("title","Human readable title for the changes editor"),new d.$0O("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,n,i]=o;if(!R.URI.isUri(s)||!R.URI.isUri(n)&&n!==void 0&&n!==null||!R.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],d.$$O.Void),new d.$_O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$0O.Uri,d.$0O.Position],new d.$$O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new d.$_O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$0O.TypeHierarchyItem],new d.$$O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new d.$_O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$0O.TypeHierarchyItem],new d.$$O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new d.$_O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$0O.TestItem],d.$$O.Void),new d.$_O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$0O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$$O.Void),new d.$_O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$0O.String.with("name","The context key name"),new d.$0O("value","The context key value",()=>!0,r=>r)],d.$$O.Void),new d.$_O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$0O.Uri,d.$0O.StringArray,new d.$0O("MappedEditsContext","Mapped Edits Context",r=>E.MappedEditsContext.is(r),r=>E.MappedEditsContext.from(r))],new d.$$O("A promise that resolves to a workspace edit or null",r=>r?E.WorkspaceEdit.to(r):null))];class u{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",g.$hj)}}e.$njc=u;function w(r){return o=>{if(Array.isArray(o))return o.map(r)}}function m(r){if(!Array.isArray(r))return;const o=[];for(const s of r)N.$3t(s)?o.push(E.DefinitionLink.to(s)):o.push(E.location.to(s));return o}}),define(Pe[276],Re([1,0,11,6,2,4,31,8,7]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=void 0;class E{static{this.a=0}constructor(w,m){this.extension=w,this.provider=m,this.handle=E.a++}}class O{constructor(w){this.session=w,this.responses=[]}}class y{static{this.a=0}constructor(w,m,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=w.getProxy(N.$qM.MainThreadInlineChat),m.registerApiCommand(new A.$_O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$0O("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?g.Range.from(s.initialRange):void 0,initialSelection:d.$vM.isSelection(s.initialSelection)?g.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?g.Position.from(s.position):void 0}})],A.$$O.Void))}registerProvider(w,m,r){const o=new E(w,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??w.displayName??w.name,w.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",r?.supportReportIssue??!1),(0,T.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(w,m,r,o){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(R.URI.revive(m)),i=g.Selection.to(r),a=await s.provider.prepareInteractiveEditorSession({document:n,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=y.a++;return this.d.set(h,new O(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:g.Range.from(a.wholeRange),message:a.message}}async $provideResponse(w,m,r,o){const s=this.b.get(w);if(!s)return;const n=this.d.get(m.id);if(!n)return;const i={prompt:r.prompt,selection:g.Selection.to(r.selection),wholeRange:g.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(R.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let a=!1;const h={report:async D=>{if(!r.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:D.message,edits:D.edits?.map(g.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:d.$TM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,i,h,o));let v;try{v=await(0,I.$9g)(t,o)}finally{a=!0}if(!v)return;const c=n.responses.push(v)-1,$={wholeRange:g.Range.from(v.wholeRange),placeholder:v.placeholder};if(!y.h(v))return{...$,id:c,type:"editorEdit",message:g.MarkdownString.from(v.contents),edits:[]};const{edits:b,contents:p}=v,l=p!==void 0?g.MarkdownString.from(p):void 0;return b instanceof d.$CM?{...$,id:c,type:"bulkEdit",edits:g.WorkspaceEdit.from(b),message:l}:{...$,id:c,type:"editorEdit",edits:b.map(g.TextEdit.from),message:l}}async $provideFollowups(w,m,r,o){const s=this.b.get(w),n=this.d.get(m),i=n?.responses[r];if(s&&i&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(n.session,i,o));return(await(0,I.$9g)(a,o))?.map(g.ChatInlineFollowup.from)}}$handleFeedback(w,m,r,o){const s=this.b.get(w),n=this.d.get(m),i=n?.responses[r];if(s&&i){const a=g.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,a)}}$releaseSession(w,m){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$xkc=y}),define(Pe[277],Re([1,0,2,31]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;class R{constructor(A,g,d,E,O){this.a=g,this.b=d,this.c=E;const y=new T.$_O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$0O("showOptions","Show Options",u=>!0,u=>u),new T.$0O("resource","Interactive resource Uri",u=>!0,u=>u),new T.$0O("controllerId","Notebook controller Id",u=>!0,u=>u),new T.$0O("title","Interactive editor title",u=>!0,u=>u)],new T.$$O("Notebook and input URI",u=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const w=this.a.getEditorById(u.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:w.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,g,d,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:d,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Kkc=R}),define(Pe[278],Re([1,0,18,11,24,5,6,28,2,20,13,4,31,8,7,76,217,25,50,218]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0,e.$Tkc=b;let a=class{constructor(l,D,f,S,k){this.m=D,this.n=f,this.o=S,this.q=k,this.b=new g.$Bc,this.c=new g.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(y.$qM.MainThreadNotebookKernels);const P=new u.$_O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$0O("options","Select kernel options",q=>!0,q=>{if(q&&"notebookEditor"in q&&"id"in q){const V=this.n.getIdByEditor(q.notebookEditor);return{id:q.id,extension:q.extension,notebookEditorId:V}}else if(q&&"notebookEditor"in q){const V=this.n.getIdByEditor(q.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${q.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return q})],u.$$O.Void),C=new u.$_O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$0O.Uri],new u.$$O("A promise that resolves to an array of variables",(q,V)=>q.map(W=>({variable:{name:W.name,value:W.value,expression:W.expression,type:W.type,language:W.language},hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(C)}createNotebookController(l,D,f,S,k,P){for(const Se of this.j.values())if(Se.controller.id===D&&E.$Dm.equals(l.identifier,Se.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const C=this.k++,q=this;this.q.trace(`NotebookController[${C}], CREATED by ${l.identifier.value}, ${D}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${l.identifier}'`);let W=!1;const M=new N.$7d,z=new N.$7d,K={id:b(l.identifier,D),notebookType:f,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:S||l.identifier.value,preloads:P?P.map(w.NotebookRendererScript.from):[]};let ie=k??V,fe,De;this.a.$addKernel(C,K).catch(Se=>{console.log(Se),W=!0});let ye=0;const oe=()=>{if(W)return;const Se=++ye;Promise.resolve().then(()=>{Se===ye&&this.a.$updateKernel(C,K)})},$e=new g.$Bc,ne={get id(){return D},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return K.label},set label(Se){K.label=Se??l.displayName??l.name,oe()},get detail(){return K.detail??""},set detail(Se){K.detail=Se,oe()},get description(){return K.description??""},set description(Se){K.description=Se,oe()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(Se){K.supportedLanguages=Se,oe()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(Se){K.supportsExecutionOrder=Se,oe()},get rendererScripts(){return K.preloads?K.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(Se){ie=Se??V},get interruptHandler(){return fe},set interruptHandler(Se){fe=Se,K.supportsInterrupt=!!Se,oe()},set variableProvider(Se){(0,s.$cG)(l,"notebookVariableProvider"),De=Se,K.hasVariableProvider=!!Se,Se?.onDidChangeVariables(je=>q.a.$variablesUpdated(je.uri)),oe()},get variableProvider(){return De},createNotebookCellExecution(Se){if(W)throw new Error("notebook controller is DISPOSED");if(!$e.has(Se.notebook.uri))throw q.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(je=>je.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.notebook.uri.toString()}`);return q._createNotebookCellExecution(Se,b(l.identifier,this.id))},createNotebookExecution(Se){if((0,s.$cG)(l,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!$e.has(Se.uri))throw q.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(je=>je.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.uri.toString()}`);return q._createNotebookExecution(Se,b(l.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${C}], DISPOSED`),W=!0,this.j.delete(C),M.dispose(),z.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(Se,je){je===m.NotebookControllerAffinity2.Hidden&&(0,s.$cG)(l,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(C,Se.uri,je)},onDidReceiveMessage:z.event,postMessage(Se,je){return(0,s.$cG)(l,"notebookMessaging"),q.a.$postMessage(C,je&&q.n.getIdByEditor(je),Se)},asWebviewUri(Se){return(0,s.$cG)(l,"notebookMessaging"),(0,r.$kzb)(Se,q.m.remote)}};return this.j.set(C,{extensionId:l.identifier,controller:ne,onDidReceiveMessage:z,onDidChangeSelection:M,associatedNotebooks:$e}),ne}getIdByController(l){for(const[D,f]of this.j)if(f.controller===l)return b(f.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const f=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(f,D);const k={dispose:()=>{this.f.delete(f),S.a.$removeKernelDetectionTask(f)}};return this.f.set(f,k),k}registerKernelSourceActionProvider(l,D,f){const S=this.i++,k=typeof f.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,P=this;this.h.set(S,f),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,D);let C;return k!==void 0&&(C=f.onDidChangeNotebookKernelSourceActions(q=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(S),P.a.$removeKernelSourceActionProvider(S,S),C?.dispose()}}}async $provideKernelSourceActions(l,D){const f=this.h.get(l);if(f){const S=new A.$Tc;return(await f.provideNotebookKernelSourceActions(D)??[]).map(P=>w.NotebookKernelSourceAction.from(P,this.o.converter,S))}return[]}$acceptNotebookAssociation(l,D,f){const S=this.j.get(l);if(S){const k=this.n.getNotebookDocument(d.URI.revive(D));f?S.associatedNotebooks.set(k.uri,!0):S.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,k.uri.toString(),f),S.onDidChangeSelection.fire({selected:f,notebook:k.apiNotebook})}}async $executeCells(l,D,f){const S=this.j.get(l);if(!S)return;const k=this.n.getNotebookDocument(d.URI.revive(D)),P=[];for(const C of f){const q=k.getCell(C);q&&P.push(q.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,k.uri.toString(),P.length),await S.controller.executeHandler.call(S.controller,P,k.apiNotebook,S.controller)}catch(C){this.q.error(`NotebookController[${l}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(l,D,f){const S=this.j.get(l);if(!S)return;const k=this.n.getNotebookDocument(d.URI.revive(D));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,k.apiNotebook);else for(const P of f){const C=k.getCell(P);C&&this.b.get(C.uri)?.cancel()}if(S.controller.interruptHandler){const P=this.c.get(k.uri);f.length&&Array.isArray(P)&&P.length&&P.forEach(C=>C.dispose())}}async $provideVariables(l,D,f,S,k,P,C){const q=this.j.get(l);if(!q)return;const V=this.n.getNotebookDocument(d.URI.revive(f)),W=q.controller.variableProvider;if(!W)return;let M;if(S!==void 0){if(M=this.s[S],!M)return}else this.s={};const z=k==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=W.provideVariables(V.apiNotebook,M,z,P,C);let ie=0;for await(const fe of K){if(C.isCancellationRequested)return;const De={id:this.r++,name:fe.variable.name,value:fe.variable.value,type:fe.variable.type,interfaces:fe.variable.interfaces,language:fe.variable.language,expression:fe.variable.expression,hasNamedChildren:fe.hasNamedChildren,indexedChildrenCount:fe.indexedChildrenCount,extensionId:q.extensionId.value};if(this.s[De.id]=fe.variable,this.a.$receiveVariable(D,De),ie++>=i.$Khb)return}}$acceptKernelMessageFromRenderer(l,D,f){const S=this.j.get(l);if(!S)return;const k=this.n.getEditorById(D);S.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:f}))}$cellExecutionChanged(l,D,f){const k=this.n.getNotebookDocument(d.URI.revive(l)).getCell(D);if(k){const P=f?w.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:k.apiCell,state:P})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const k=new t(D,S,this.a);this.b.set(S.uri,k);const P=k.onDidChangeState(()=>{k.state===h.Resolved&&(k.dispose(),P.dispose(),this.b.delete(S.uri))});return k.asApiObject()}_createNotebookExecution(l,D){const f=this.n.getNotebookDocument(l.uri),S=l.getCells().find(C=>{const q=f.getCellFromApiCell(C);return q&&this.b.has(q.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const k=new c(D,f,this.a),P=k.onDidChangeState(()=>{k.state===v.Resolved&&(k.dispose(),P.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[k,P]),k.asApiObject()}};e.$Skc=a,e.$Skc=a=Je([qe(4,O.$Oj)],a);var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,f){super(),this.m=D,this.n=f,this.b=t.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new R.$ee),this.h=new $(10,S=>this.s(S)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new n.$ew(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const f=m.$XN.ensureUniqueMimeTypes(D.items,!0);return f===D.items?w.NotebookCellOutput.from(D):w.NotebookCellOutput.from({items:f,id:D.id,metadata:D.metadata})})}async z(l,D,f){const S=this.w(D),k=this.y((0,I.$3b)(l));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:f,outputs:k})}async C(l,D,f){return l=m.$XN.ensureUniqueMimeTypes((0,I.$3b)(l),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(w.NotebookCellOutputItem.from),outputId:D.id,append:f})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(f){l.j=f,l.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(f){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,S,k){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const P=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;l.n.$completeExecution(l.b,new n.$ew({runEndTime:S,lastRunSuccess:f,error:P}))},clearOutput(f){return l.t(),l.z([],f,!1)},appendOutput(f,S){return l.t(),l.z(f,S,!0)},replaceOutput(f,S){return l.t(),l.z(f,S,!1)},appendOutputItems(f,S){return l.t(),l.C(f,S,!0)},replaceOutputItems(f,S){return l.t(),l.C(f,S,!1)}})}}var v;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(v||(v={}));class c extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,f){super(),this.h=D,this.j=f,this.b=c.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new R.$ee),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===v.Resolved||this.f===v.Started)throw new Error("Cannot call start again");this.f=v.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===v.Resolved)throw new Error("Cannot call resolve twice");this.f=v.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(l,D){this.f=l,this.g=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new T.$Fh,this.b=Date.now(),(0,T.$jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>l.complete())}}function b(p,l){return`${p.value}/${l}`}}),define(Pe[51],Re([1,0,5,4,3,2,16,6,7,172,14,200,24,34,201,41,11,8,31]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=e.$7jc=e.$6jc=e.$5jc=void 0,e.$5jc=(0,R.$ii)("IExtHostTerminalService");class i extends g.$Uc{constructor(f,S,k,P){super(),this.u=f,this._id=S,this.w=k,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$7d),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(q=>this.g=q);const C=this;this.value={get name(){return C.y||""},get processId(){return C.b},get creationOptions(){return C.w},get exitStatus(){return C.j},get state(){return C.m},get selection(){return C.n},get shellIntegration(){return C.shellIntegration},sendText(q,V=!0){C.C(),C.u.$sendText(C._id,q,V)},show(q){C.C(),C.u.$show(C._id,q)},hide(){C.C(),C.u.$hide(C._id)},dispose(){C.a||(C.a=!0,C.u.$dispose(C._id))},get dimensions(){if(!(C.f===void 0||C.h===void 0))return{columns:C.f,rows:C.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??S?.cwd??void 0,env:f.env??void 0,icon:b(f.iconPath)??void 0,color:r.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.z(f.location,S?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,S,k,P,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:r.ThemeColor.isThemeColor(C)?C.id:void 0,location:S?.location||this.z(f,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,S){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in f?{viewColumn:s.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,S){this.j=Object.freeze({code:f,reason:S})}setDimensions(f,S){return f===this.f&&S===this.h||f===0||S===0?!1:(this.f=f,this.h=S,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(S=>{S!==f&&(this.b=Promise.resolve(f))})}}e.$6jc=i;class a{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new I.$7d,this.onProcessData=this.a.event,this.b=new I.$7d,this.d=new I.$7d,this.onDidChangeProperty=this.d.event,this.f=new I.$7d,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,S){this.g.setDimensions?.({columns:f,rows:S})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends g.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,S,k){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new g.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$7d,this.onDidCloseTerminal=this.H.event,this.I=new I.$7d,this.onDidOpenTerminal=this.I.event,this.J=new I.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new I.$7d,this.onDidChangeShell=this.N.event,this.O=new I.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$qM.MainThreadTerminalService),this.y=new m.$hub(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:P=>{const C=q=>{const V=q;return this.getTerminalById(V.instanceId)?.value};switch(P?.$mid){case 15:return C(P);default:{if(Array.isArray(P))for(let q=0;q<P.length&&P[q].$mid===15;q++)P[q]=C(P[q]);return P}}}}),this.B({dispose:()=>{for(const[P,C]of this.g)C.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,S){const k=new i(this.a,(0,w.$Eg)(),f,f.name),P=new a(f.pty);return k.createExtensionTerminal(f.location,S,this.R(f,S).resolvedExtHostIdentifier,b(f.iconPath),p(f.color)).then(C=>{const q=this.S(C,P);this.h[C]=q}),this.f.push(k),k.value}R(f,S){if(S=S||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const k=f.location.parentTerminal;if(k){const P=this.f.find(C=>C.value===k);P&&(S.resolvedExtHostIdentifier=P._id)}}else f.location&&typeof f.location!="object"?S.location=f.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(f,S){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const P=new a(S),C=this.S(f,P);this.h[f]=C}async $acceptActiveTerminalChanged(f){const S=this.b;if(f===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(f);k&&(this.b=k,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,S){const k=this.getTerminalById(f);k&&this.O.fire({terminal:k.value,data:S})}async $acceptTerminalDimensions(f,S,k){const P=this.getTerminalById(f);P&&P.setDimensions(S,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(f,S){const k=this.getTerminalById(f);k&&this.P.fire({terminal:k.value,...S})}async $acceptTerminalMaximumDimensions(f,S,k){this.g.get(f)?.resize(S,k)}async $acceptTerminalTitleChange(f,S){const k=this.getTerminalById(f);k&&(k.name=S)}async $acceptTerminalClosed(f,S,k){const P=this.X(this.f,f);if(P!==null){const C=this.f.splice(P,1)[0];C.setExitStatus(S,k),this.H.fire(C.value)}}$acceptTerminalOpened(f,S,k,P){if(S){const V=this.X(this.f,S);if(V!==null){this.f[V]._id=f,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const C={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:N.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},q=new i(this.a,f,C,k);this.f.push(q),this.I.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(f,S){this.getTerminalById(f)?._setProcessId(S)}async $startExtensionTerminal(f,S){const k=this.getTerminalById(f);if(!k)return{message:(0,E.localize)(0,null,f)};k.isOpen||await new Promise(C=>{const q=this.onDidOpenTerminal(async V=>{V===k.value&&(q.dispose(),C())})});const P=this.g.get(f);P?P.startSendingEvents(S):this.j[f]={initialDimensions:S}}S(f,S){const k=new g.$Tc;k.add(S.onProcessReady(C=>this.a.$sendProcessReady(f,C.pid,C.cwd,C.windowsPty))),k.add(S.onDidChangeProperty(C=>this.a.$sendProcessProperty(f,C))),this.y.startBuffering(f,S.onProcessData),k.add(S.onProcessExit(C=>this.U(f,C))),this.g.set(f,S);const P=this.j[f];return P&&S instanceof a&&(S.startSendingEvents(P.initialDimensions),delete this.j[f]),k}$acceptProcessAckDataEvent(f,S){this.g.get(f)?.acknowledgeDataEvent(S)}$acceptProcessInput(f,S){this.g.get(f)?.input(S)}$acceptTerminalInteraction(f){const S=this.getTerminalById(f);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(f,S){this.getTerminalById(f)?.setSelection(S)}$acceptProcessResize(f,S,k){try{this.g.get(f)?.resize(S,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(f,S){this.g.get(f)?.shutdown(S)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(S=>this.a.$sendProcessProperty(f,{type:"cwd",value:S}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new d.$sM(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,S,k){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,k),this.a.$registerProfileProvider(S,f.identifier.value),new d.$sM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(f,S,k){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,k),this.a.$registerQuickFixProvider(f,S),new d.$sM(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,S){const k=new u.$ee().token;if(k.isCancellationRequested)return;const P=this.D.get(f);if(!P)return;const C=await P.provideTerminalQuickFixes(S,k);if(C===null||Array.isArray(C)&&C.length===0)return;const q=new g.$Tc;if(this.w.value=q,!Array.isArray(C))return C?s.TerminalQuickFix.from(C,this.Q.converter,q):void 0;const V=[];for(const W of C){const M=s.TerminalQuickFix.from(W,this.Q.converter,q);M&&V.push(M)}return V}async $createContributedProfileTerminal(f,S){const k=new u.$ee().token;let P=await this.C.get(f)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,S);return}this.createTerminalFromOptions(P.options,S)}}async $provideLinks(f,S){const k=this.getTerminalById(f);if(!k)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const C=new u.$ee;this.G.set(f,C);const q=[],V={terminal:k.value,line:S},W=[];for(const K of this.z)W.push(o.Promises.withAsyncBody(async ie=>{C.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const fe=await K.provideTerminalLinks(V,C.token)||[];C.token.isCancellationRequested||ie({provider:K,links:fe})}));const M=await Promise.all(W);if(C.token.isCancellationRequested)return[];const z=new Map;for(const K of M)K&&K.links.length>0&&q.push(...K.links.map(ie=>{const fe={id:h++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return z.set(fe.id,{provider:K.provider,link:ie}),fe}));return this.F.set(f,z),q}$activateLink(f,S){const k=this.F.get(f)?.get(S);k&&k.provider.handleTerminalLink(k.link)}U(f,S){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const k=this.h[f];k&&(k.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,S)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const S=this.f.findIndex(k=>k.value===f);return S>=0?S:null}W(f,S){const k=this.X(f,S);return k!==null?f[k]:null}X(f,S){const k=f.findIndex(P=>P._id===S);return k>=0?k:null}getEnvironmentVariableCollection(f){let S=this.n.get(f.identifier.value);return S||(S=new v,this.Z(f.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Y(f,S){const k=(0,y.$7r)(S.map),P=(0,y.$8r)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(f,S.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(f){f.forEach(S=>{const k=S[0],P=new v(S[1]);this.Z(k,P)})}$acceptDefaultProfile(f,S){const k=this.s;this.s=f,this.u=S,k?.path!==f.path&&this.N.fire(f.path)}Z(f,S){this.n.set(f,S),S.onDidChangeCollection(()=>{this.Y(f,S)})}};e.$7jc=t,e.$7jc=t=Je([qe(1,n.$8O),qe(2,A.$LO)],t);class v{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$7d,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const S=this.h(f);let k=this.a.get(S);return k||(k=new c(this,f),this.a.set(S,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(f,S,k,P){this.f(f,{value:S,type:d.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(f,S,k,P){this.f(f,{value:S,type:d.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(f,S,k,P){this.f(f,{value:S,type:d.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(f,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(f,S.scope),P=this.map.get(k),C=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==S.value||P.type!==S.type||P.options?.applyAtProcessCreation!==C.applyAtProcessCreation||P.options?.applyAtShellIntegration!==C.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const q=this.g(f,S.scope),V={variable:f,...S,options:C};this.map.set(q,V),this.d.fire()}}get(f,S){const k=this.g(f,S),P=this.map.get(k);return P?l(P):void 0}g(f,S){const k=this.h(S);return k.length?`${f}:::${k}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const S=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(f)&&S.set(P.variable,l(P));return S}delete(f,S){const k=this.g(f,S);this.map.delete(k),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[S,k]of this.map)k.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(S);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,S){const k=this.h(S),P=this.descriptionMap.get(k);if(!P||P.description!==f){let C;typeof f=="string"?C=f:C=f?.value.split(`

`)[0];const q={description:C,scope:S};this.descriptionMap.set(k,q),this.d.fire()}}getDescription(f){const S=this.h(f);return this.descriptionMap.get(S)?.description}k(f){const S=this.h(f);this.descriptionMap.delete(S)}}class c{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,S){this.b=f,this.d=S,this.a=new I.$7d}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,S,k){this.b.replace(f,S,k,this.d)}append(f,S,k){this.b.append(f,S,k,this.d)}prepend(f,S,k){this.b.prepend(f,S,k,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,S){this.b.getVariableMap(this.d).forEach((k,P)=>f.call(S,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends t{constructor(f,S){super(!1,f,S)}createTerminal(f,S,k){throw new O.$_}createTerminalFromOptions(f,S){throw new O.$_}};e.$8jc=$,e.$8jc=$=Je([qe(0,n.$8O),qe(1,A.$LO)],$);function b(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function p(D){return r.ThemeColor.isThemeColor(D)?D:void 0}function l(D){const f={...D};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Pe[114],Re([1,0,6,3,4,16,51,5,2,11]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=e.$llc=void 0,e.$llc=(0,T.$ii)("IExtHostTerminalShellIntegration");let O=class extends I.$Uc{constructor(r,o){super(),this.h=o,this.b=new Map,this.c=new g.$7d,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new g.$7d,this.onDidStartTerminalShellExecution=this.f.event,this.g=new g.$7d,this.onDidEndTerminalShellExecution=this.g.event,this.a=r.getProxy(R.$qM.MainThreadTerminalShellIntegration),this.B((0,I.$Sc)(()=>{for(const[s,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(r){const o=this.h.getTerminalById(r);if(!o)return;const s=o.value;let n=this.b.get(r);n||(n=new y(o.value,this.f),this.b.set(r,n),n.store.add(o.onWillDispose(()=>this.b.get(r)?.dispose())),n.store.add(n.onDidRequestShellExecution(i=>this.a.$executeCommand(r,i))),n.store.add(n.onDidRequestEndExecution(i=>this.g.fire(i.value))),n.store.add(n.onDidRequestChangeShellIntegration(i=>this.c.fire(i))),o.shellIntegration=n.value),this.c.fire({terminal:s,shellIntegration:n.value})}$shellExecutionStart(r,o,s){this.b.has(r)||this.$shellIntegrationChange(r),this.b.get(r)?.startShellExecution(o,s)}$shellExecutionEnd(r,o,s){this.b.get(r)?.endShellExecution(o,s)}$shellExecutionData(r,o){this.b.get(r)?.emitData(o)}$cwdChange(r,o){this.b.get(r)?.setCwd(o)}$closeTerminal(r){this.b.get(r)?.dispose(),this.b.delete(r)}};e.$mlc=O,e.$mlc=O=Je([qe(0,N.$LO),qe(1,A.$5jc)],O);class y extends I.$Uc{get currentExecution(){return this.a}constructor(r,o){super(),this.j=r,this.m=o,this.b=!1,this.store=this.B(new I.$Tc),this.f=this.B(new g.$7d),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new g.$7d),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new g.$7d),this.onDidRequestEndExecution=this.h.event;const s=this;this.value={get cwd(){return s.c},executeCommand(n){s.g.fire(n);const i=s.startShellExecution(n,s.c).value;return s.b=!0,i}}}startShellExecution(r,o){return this.b&&this.a?this.b=!1:(this.a&&(this.a.endExecution(void 0,void 0),this.h.fire(this.a)),this.a=new u(this.j,r,o),this.m.fire(this.a.value)),this.a}emitData(r){this.currentExecution?.emitData(r)}endShellExecution(r,o){this.a&&(this.a.endExecution(r,o),this.h.fire(this.a),this.a=void 0)}setCwd(r){let o=!1;d.URI.isUri(this.c)?this.c.toString()!==r.toString()&&(o=!0):this.c!==r&&(o=!0),o&&(this.c=r,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class u{constructor(r,o,s){this.terminal=r,this.d=o,this.cwd=s,this.b=new Promise(i=>{this.c=i});const n=this;this.value={get terminal(){return r},get commandLine(){return n.d},get cwd(){return s},get exitCode(){return n.b},createDataStream(){return n.f()}}}f(){if(!this.a){if(this.c===void 0)return E.$Ih.EMPTY;this.a=new w}return this.a.createIterable()}emitData(r){this.a?.emitData(r)}endExecution(r,o){r&&(this.d=r),this.a?.endExecution(),this.a=void 0,this.c?.(o),this.c=void 0}}class w extends I.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const r=this.a=new E.$hh;return new E.$Ih(async s=>{this.b.push(s),await r.wait()})}emitData(r){for(const o of this.b)o.emitOne(r)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Pe[279],Re([1,0,11,22,24,5,251,99,6,17,34,13,4,16,113,8,7,49,75,61]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=e.$alc=e.$_kc=e.$$kc=void 0;let a=class extends d.$Uc{constructor(C,q,V,W){super(),this.w=W,this.f=this.B(new N.$7d),this.g=new Map,this.s=this.B(new N.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=C.getProxy(u.$qM.MainThreadTesting),this.m=new D(this.h),this.j=new c(this.h,q),V.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 16:{const z=M,K=z.tests[z.tests.length-1].item.extId;return this.g.get(s.$cL.root(K))?.collection.tree.get(K)?.actual??(0,m.$XO)(M)}case 18:{const{test:z,message:K}=M,ie=z.item.extId;return{test:this.g.get(s.$cL.root(ie))?.collection.tree.get(ie)?.actual??(0,m.$XO)({$mid:16,tests:[z]}),message:r.TestMessage.to(K)}}default:return M}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await V.executeCommand("_testing.getExplorerSelection"),z=K=>{const ie=this.g.get(s.$cL.root(K));if(ie)return s.$cL.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:M?.include.map(z).filter(E.$4f)||[],exclude:M?.exclude.map(z).filter(E.$4f)||[]}})}createTestController(C,q,V,W){if(this.g.has(q))throw new Error(`Attempt to insert a duplicate controller with ID "${q}"`);const M=new d.$Tc,z=M.add(new m.$1O(q,V,this.w));z.root.label=V;const K=new Map,ie=new Set,fe=this.h,De={items:z.root.children,get label(){return V},set label(oe){V=oe,z.root.label=oe,fe.$updateController(q,{label:V})},get refreshHandler(){return W},set refreshHandler(oe){W=oe,fe.$updateController(q,{canRefresh:!!oe})},get id(){return q},createRunProfile:(oe,$e,ne,Se,je,re)=>{let L=(0,g.$9i)(oe);for(;K.has(L);)L++;return new S(this.h,K,ie,this.s.event,q,L,oe,$e,ne,Se,je,re)},createTestItem(oe,$e,ne){return new m.$YO(q,oe,$e,ne)},createTestRun:(oe,$e,ne=!0)=>this.j.createTestRun(q,z,oe,$e,ne),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const $e=oe instanceof Array?oe:[oe];this.h.$markTestRetired($e.map(ne=>s.$cL.fromExtHostTestItem(ne,q).toString()))}},set resolveHandler(oe){z.resolveHandler=oe},get resolveHandler(){return z.resolveHandler},dispose:()=>{M.dispose()}};fe.$registerTestController(q,V,!!W),M.add((0,d.$Sc)(()=>fe.$unregisterTestController(q)));const ye={controller:De,collection:z,profiles:K,extension:C,activeProfiles:ie};return this.g.set(q,ye),M.add((0,d.$Sc)(()=>this.g.delete(q))),M.add(z.onDidGenerateDiff(oe=>fe.$publishDiff(q,oe.map(i.TestsDiffOp.serialize)))),De}createTestObserver(){return this.m.checkout()}async runTests(C,q=R.CancellationToken.None){const V=$(C);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.g.get(V.controllerId);if(!W)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:C.include?.map(M=>s.$cL.fromExtHostTestItem(M,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:k[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:C.exclude?.map(M=>M.id)},q)}$syncTests(){for(const{collection:C}of this.g.values())C.flushDiff();return Promise.resolve()}async $getCoverageDetails(C,q){return(await this.j.getCoverageDetails(C,q))?.map(r.TestCoverage.fromDetails)}async $disposeRun(C){this.j.disposeTestRun(C)}$configureRunProfile(C,q){this.g.get(C)?.profiles.get(q)?.configureHandler?.()}$setDefaultRunProfiles(C){const q=new Map;for(const[V,W]of Object.entries(C)){const M=this.g.get(V);if(!M)continue;const z=new Map,K=W.filter(fe=>!M.activeProfiles.has(fe)),ie=[...M.activeProfiles].filter(fe=>!W.includes(fe));for(const fe of K)z.set(fe,!0),M.activeProfiles.add(fe);for(const fe of ie)z.set(fe,!1),M.activeProfiles.delete(fe);z.size&&q.set(V,z)}this.s.fire(q)}async $refreshTests(C,q){await this.g.get(C)?.controller.refreshHandler?.(q)}$publishTestResults(C){this.results=Object.freeze(C.map(r.TestResults.to).concat(this.results).sort((q,V)=>V.completedAt-q.completedAt).slice(0,32)),this.f.fire()}async $expandTest(C,q){const V=this.g.get(s.$cL.fromString(C).controllerId)?.collection;V&&(await V.expand(C,q<0?1/0:q),V.flushDiff())}$acceptDiff(C){this.m.applyDiff(C.map(q=>i.TestsDiffOp.deserialize({asCanonicalUri:V=>V},q)))}async $runControllerTests(C,q){return Promise.all(C.map(V=>this.y(V,!1,q)))}async $startContinuousRun(C,q){const V=new R.$ee(q),W=await Promise.all(C.map(M=>this.y(M,!0,V.token)));return!q.isCancellationRequested&&!W.some(M=>M.error)&&await new Promise(M=>q.onCancellationRequested(M)),V.dispose(!0),W}async y(C,q,V){const W=this.g.get(C.controllerId);if(!W)return{};const{collection:M,profiles:z}=W,K=z.get(C.profileId);if(!K)return{};const ie=C.testIds.map(oe=>M.tree.get(oe)).filter(E.$4f),fe=C.excludeExtIds.map(oe=>W.collection.tree.get(oe)).filter(E.$4f).filter(oe=>ie.some($e=>$e.fullId.compare(oe.fullId)===2));if(!ie.length)return{};const De=new o.$5N(ie.some(oe=>oe.actual instanceof m.$ZO)?void 0:ie.map(oe=>oe.actual),fe.map(oe=>oe.actual),K,q),ye=(0,i.$fL)(C)&&this.j.prepareForMainThreadTestRun(De,b.fromInternal(C,W.collection),K,V);try{return await K.runHandler(De,V),{}}catch(oe){return{error:String(oe)}}finally{ye&&ye.hasRunningTasks&&!V.isCancellationRequested&&await N.Event.toPromise(ye.onEnd)}}$cancelExtensionTestRun(C){C===void 0?this.j.cancelAllRuns():this.j.cancelRunById(C)}};e.$$kc=a,e.$$kc=a=Je([qe(0,w.$LO),qe(1,y.$Oj)],a);const h=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class v extends d.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(C,q,V,W,M){super(),this.z=C,this.C=q,this.D=V,this.F=W,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new N.$7d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new R.$ee(M));const z=this.B(new I.$uh(()=>this.G(),h));this.B(this.m.token.onCancellationRequested(()=>z.schedule()));const K=new N.$7d;this.w=K.event,this.B((0,d.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.G()}getCoverageDetails(C,q){const[,V,W]=s.$cL.fromString(C).path,M=this.y.get(W);if(!M)return[];if(M.backCompatResolve)return M.backCompatResolve(q);const z=this.h.get(V);if(!z)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(z.run,M.coverage,q)??[]}createRun(C){const q=this.z.id,V=this.z.controllerId,W=(0,O.$Eg)(),M=ye=>(oe,...$e)=>{if(ie){this.D.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.z.isIncluded(oe)&&(this.I(oe),ye(oe,...$e))},z=(ye,oe)=>{const $e=oe instanceof Array?oe.map(r.TestMessage.from):[r.TestMessage.from(oe)];if(ye.uri&&ye.range){const ne={range:r.Range.from(ye.range),uri:ye.uri};for(const Se of $e)Se.location=Se.location||ne}this.C.$appendTestMessagesInRun(q,W,s.$cL.fromExtHostTestItem(ye,V).toString(),$e)},K=(ye,oe)=>{const $e=ye.uri.toString(),ne=new s.$cL([q,W,$e]).toString();this.y.set($e,{coverage:ye,backCompatResolve:oe}),this.C.$appendCoverage(q,W,r.TestCoverage.fromFile(ne,ye))};let ie=!1,fe;const De={isPersisted:this.z.isPersisted,token:this.m.token,name:C,onDidDispose:this.w,get coverageProvider(){return fe},set coverageProvider(ye){fe=ye,ye&&Promise.resolve(ye.provideFileCoverage(R.CancellationToken.None)).then(oe=>{oe?.forEach($e=>K($e,ye.resolveFileCoverage&&(async ne=>(await ye.resolveFileCoverage($e,ne)||$e).detailedCoverage)))})},addCoverage:K,enqueued:M(ye=>{this.C.$updateTestStateInRun(q,W,s.$cL.fromExtHostTestItem(ye,V).toString(),1)}),skipped:M(ye=>{this.C.$updateTestStateInRun(q,W,s.$cL.fromExtHostTestItem(ye,V).toString(),5)}),started:M(ye=>{this.C.$updateTestStateInRun(q,W,s.$cL.fromExtHostTestItem(ye,V).toString(),2)}),errored:M((ye,oe,$e)=>{z(ye,oe),this.C.$updateTestStateInRun(q,W,s.$cL.fromExtHostTestItem(ye,V).toString(),6,$e)}),failed:M((ye,oe,$e)=>{z(ye,oe),this.C.$updateTestStateInRun(q,W,s.$cL.fromExtHostTestItem(ye,V).toString(),4,$e)}),passed:M((ye,oe)=>{this.C.$updateTestStateInRun(q,W,s.$cL.fromExtHostTestItem(ye,this.z.controllerId).toString(),3,oe)}),appendOutput:(ye,oe,$e)=>{ie||($e&&(this.z.isIncluded($e)?this.I($e):$e=void 0),this.C.$appendOutputToRun(q,W,T.$ue.fromString(ye),oe&&r.location.from(oe),$e&&s.$cL.fromExtHostTestItem($e,V).toString()))},end:()=>{ie||(ie=!0,this.C.$finishedTestRunTask(q,W),--this.g||this.H())}};return this.g++,this.h.set(W,{run:De}),this.C.$startedTestRunTask(q,{id:W,name:C,running:!0}),De}G(){for(const{run:C}of this.h.values())C.end()}H(){this.f!==2&&(this.f=2,this.s.fire())}I(C){if(!(C instanceof m.$YO))throw new n.$DO(C.id);if(this.j.has(s.$cL.fromExtHostTestItem(C,this.z.controllerId).toString()))return;const q=[],V=this.z.colllection.root;for(;;){const W=r.TestItem.from(C);if(q.unshift(W),this.j.has(W.extId)||(this.j.add(W.extId),C===V))break;C=C.parent||V}this.C.$addTestsToRun(this.z.controllerId,this.z.id,q)}dispose(){this.H(),super.dispose()}}class c{get trackers(){return this.f.values()}constructor(C,q){this.h=C,this.j=q,this.f=new Map,this.g=new Map}getCoverageDetails(C,q){const V=s.$cL.root(C);return this.g.get(V)?.getCoverageDetails(C,q)||[]}disposeTestRun(C){this.g.get(C)?.dispose(),this.g.delete(C);for(const[q,{id:V}]of this.f)V===C&&this.f.delete(q)}prepareForMainThreadTestRun(C,q,V,W){return this.k(C,q,V,W)}cancelRunById(C){this.g.get(C)?.cancel()}cancelAllRuns(){for(const C of this.f.values())C.cancel()}createTestRun(C,q,V,W,M){const z=this.f.get(V);if(z)return z.createRun(W);const K=b.fromPublic(C,q,V,M),ie=$(V);this.h.$startedExtensionTestRun({controllerId:C,continuous:!!V.continuous,profile:ie&&{group:k[ie.kind],id:ie.profileId},exclude:V.exclude?.map(De=>s.$cL.fromExtHostTestItem(De,q.root.id).toString())??[],id:K.id,include:V.include?.map(De=>s.$cL.fromExtHostTestItem(De,q.root.id).toString())??[q.root.id],persist:M});const fe=this.k(V,K,V.profile);return N.Event.once(fe.onEnd)(()=>{this.h.$finishedExtensionTestRun(K.id)}),fe.createRun(W)}k(C,q,V,W){const M=new v(q,this.h,this.j,V,W);return this.f.set(C,M),this.g.set(M.id,M),M}}e.$_kc=c;const $=P=>{if(P.profile){if(!(P.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class b{static fromPublic(C,q,V,W){return new b(C,(0,O.$Eg)(),V.include?.map(M=>s.$cL.fromExtHostTestItem(M,C).toString())??[C],V.exclude?.map(M=>s.$cL.fromExtHostTestItem(M,C).toString())??[],W,q)}static fromInternal(C,q){return new b(C.controllerId,C.runId,C.testIds,C.excludeExtIds,!0,q)}constructor(C,q,V,W,M,z){this.controllerId=C,this.id=q,this.isPersisted=M,this.colllection=z,this.f=V.map(K=>K+"\0"),this.g=W.map(K=>K+"\0")}isIncluded(C){const q=s.$cL.fromExtHostTestItem(C,this.controllerId).toString()+"\0";for(const V of this.g)if(q===V||q.startsWith(V))return!1;for(const V of this.f)if(q===V||q.startsWith(V))return!0;return!1}}e.$alc=b;class p{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(C){this.k=C,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(C){this.f.add(C)}update(C){Object.assign(C.revived,r.TestItem.toPlain(C.item)),this.f.has(C)||this.g.add(C)}remove(C){if(this.f.has(C)){this.f.delete(C);return}this.g.delete(C);const q=s.$cL.parentId(C.item.extId);if(q&&this.j.has(q.toString())){this.j.add(C.item.extId);return}this.h.add(C)}getChangeEvent(){const{f:C,g:q,h:V}=this;return{get added(){return[...C].map(W=>W.revived)},get updated(){return[...q].map(W=>W.revived)},get removed(){return[...V].map(W=>W.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class l extends i.$lL{constructor(){super(...arguments),this.s=new N.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(C){return this.g.get(C)}getMirroredTestDataByReference(C){return this.g.get(C.id)}x(C,q){return{...C,revived:r.TestItem.toPlain(C.item),depth:q?q.depth+1:0,children:new Set}}w(){return new p(this.s)}}class D{constructor(C){this.g=C}checkout(){this.f||(this.f=this.h());const C=this.f;return C.observers++,{onDidChangeTest:C.tests.onDidChangeTests,get tests(){return[...C.tests.rootTests].map(q=>q.revived)},dispose:(0,A.$db)(()=>{--C.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(C){return this.f?.tests.getMirroredTestDataByReference(C)}applyDiff(C){this.f?.tests.apply(C)}h(){const C=new l({asCanonicalUri:q=>q});return this.g.$subscribeToDiffs(),{observers:0,tests:C}}}const f=(P,C,q,V)=>{q?Object.assign(q,V):C.$updateTestRunConfig(P.controllerId,P.profileId,V)};class S{#e;#t;#i;#n;#s;get label(){return this.g}set label(C){C!==this.g&&(this.g=C,f(this,this.#e,this.#n,{label:C}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(C){C!==this.h&&(this.h=C,f(this,this.#e,this.#n,{supportsContinuousRun:C}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(C){C!==this.isDefault&&(C?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:C}))}get tag(){return this._tag}set tag(C){C?.id!==this._tag?.id&&(this._tag=C,f(this,this.#e,this.#n,{tag:C?r.TestTag.namespace(this.controllerId,C.id):null}))}get configureHandler(){return this.f}set configureHandler(C){C!==this.f&&(this.f=C,f(this,this.#e,this.#n,{hasConfigurationHandler:!!C}))}get onDidChangeDefault(){return N.Event.chain(this.#i,C=>C.map(q=>q.get(this.controllerId)?.get(this.profileId)).filter(E.$4f))}constructor(C,q,V,W,M,z,K,ie,fe,De=!1,ye=void 0,oe=!1){this.controllerId=M,this.profileId=z,this.g=K,this.kind=ie,this.runHandler=fe,this._tag=ye,this.h=oe,this.#e=C,this.#s=q,this.#t=V,this.#i=W,q.set(z,this);const $e=k[ie];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);De&&V.add(z),this.#n={profileId:z,controllerId:M,tag:ye?r.TestTag.namespace(this.controllerId,ye.id):null,label:K,group:$e,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$blc=S;const k={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[115],Re([1,0,56,14,90,8,7]),function(ge,e,I,T,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=e.$SO=void 0;class g{static{this.c=new R.$QO("TextEditorDecorationType")}constructor(u,w,m){const r=g.c.nextId();u.$registerTextEditorDecorationType(w.identifier,r,N.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$SO=g;class d{constructor(u,w){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,w){this.k();let m=null;if(u instanceof A.$tM)m=new A.$uM(u,u);else if(u instanceof A.$uM)m=u;else throw new Error("Unrecognized location");this.l(m,w,!1)}insert(u,w){this.k(),this.l(new A.$uM(u,u),w,!0)}delete(u){this.k();let w=null;if(u instanceof A.$uM)w=u;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(u,w,m){const r=this.c.validateRange(u);this.g.push({range:r,text:w,forceMoveMarkers:m})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=u}}class E{constructor(u,w,m,r){this.c=u,this.d=w,this._accept(m),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const w=Math.floor(u);return w>0?w:null}if(typeof u=="string"){const w=parseInt(u,10);return isNaN(w)?null:w>0?w:null}return null}n(u){const w=this.m(u);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const w=Math.floor(u);return w>0?w:null}if(typeof u=="string"){const w=parseInt(u,10);return isNaN(w)?null:w>0?w:null}return null}p(u){const w=this.o(u);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const w=this.q(u);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(u)})))}assign(u){const w={};let m=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(m=!0,w.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,m=!0,w.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(m=!0,w.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,m=!0,w.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(m=!0,w.insertSpaces=r):this.j!==r&&(this.j=r,m=!0,w.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,m=!0,w.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,m=!0,w.lineNumbers=N.TextEditorLineNumbersStyle.from(u.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(u,w){w.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(m)})}}e.$TO=E;class O{constructor(u,w,m,r,o,s,n,i){this.id=u,this.j=w,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new E(this.j,this.id,s,m),this.e=n,this.f=i;const a=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new T.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof A.$vM))throw(0,T.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof A.$vM)))throw(0,T.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new d(r.value,t);return h(v),a.m(v)},insertSnippet(h,t,v={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map($=>N.Range.from($));else if(t instanceof A.$tM){const{lineNumber:$,column:b}=N.Position.from(t);c=[{startLineNumber:$,startColumn:b,endLineNumber:$,endColumn:b}]}else if(t instanceof A.$uM)c=[N.Range.from(t)];else{c=[];for(const $ of t)if($ instanceof A.$uM)c.push(N.Range.from($));else{const{lineNumber:b,column:p}=N.Position.from($);c.push({startLineNumber:b,startColumn:p,endLineNumber:b,endColumn:p})}}return w.$tryInsertSnippet(u,r.value.version,h.value,c,v)},setDecorations(h,t){const v=t.length===0;v&&!a.h.has(h.key)||(v?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(N.$IO(t))return w.$trySetDecorations(u,h.key,N.$JO(t));{const c=new Array(4*t.length);for(let $=0,b=t.length;$<b;$++){const p=t[$];c[4*$]=p.start.line+1,c[4*$+1]=p.start.character+1,c[4*$+2]=p.end.line+1,c[4*$+3]=p.end.character+1}return w.$trySetDecorationsFast(u,h.key,c)}}))},revealRange(h,t){a.n(()=>w.$tryRevealRange(u,N.Range.from(h),t||A.TextEditorRevealType.Default))},show(h){w.$tryShowEditor(u,N.ViewColumn.from(h))},hide(){w.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const w=u.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const m=w.edits.map(o=>o.range);m.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=m.length-1;o<s;o++){const n=m[o].end;if(m[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=w.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,r,{setEndOfLine:typeof w.setEndOfLine=="number"?N.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$UO=O}),define(Pe[67],Re([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,39,40]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=e.$VO=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new w.$Bc,this.d=new T.$7d,this.e=new T.$7d,this.f=new T.$7d,this.g=new T.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],t=[],v=[];if(a.removedDocuments)for(const c of a.removedDocuments){const $=N.URI.revive(c),b=this.c.get($);b?.unref()&&(this.c.delete($),h.push(b.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const $=N.URI.revive(c.uri);let b=this.c.get($);if(b&&$.scheme!==m.Schemas.vscodeNotebookCell&&$.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);b||(b=new s(new d.$OO(this.h.getProxy(g.$qM.MainThreadDocuments),$,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set($,b),t.push(b.value)),b.ref()}if(a.removedEditors)for(const c of a.removedEditors){const $=this.b.get(c);this.b.delete(c),$&&v.push($)}if(a.addedEditors)for(const c of a.addedEditors){const $=N.URI.revive(c.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const b=this.c.get($).value,p=new O.$UO(c.id,this.h.getProxy(g.$qM.MainThreadTextEditors),this.i,new o.$V(()=>b.document),c.selections.map(y.Selection.to),c.options,c.visibleRanges.map(l=>y.Range.to(l)),typeof c.editorPosition=="number"?y.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,p)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,R.$Pc)(h),(0,R.$Pc)(v),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return r.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$VO=n,e.$VO=n=Je([qe(0,E.$LO),qe(1,u.$Oj)],n),e.$WO=(0,A.$ii)("IExtHostDocumentsAndEditors")}),define(Pe[280],Re([1,0,18,5,4,115,8,7]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class d{constructor(O,y){this.i=y,this.a=new T.$7d,this.b=new T.$7d,this.c=new T.$7d,this.d=new T.$7d,this.f=new T.$7d,this.g=new T.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(R.$qM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const y=this.i.allEditors();return O?y:y.map(u=>u.value)}async showTextDocument(O,y,u){let w;typeof y=="number"?w={position:A.ViewColumn.from(y),preserveFocus:u}:typeof y=="object"?w={position:A.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?A.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:w={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(O.uri,w),r=m&&this.i.getEditor(m);if(r)return r.value;throw m?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,y){return new N.$SO(this.h,O,y).value}$acceptEditorPropertiesChanged(O,y){const u=this.i.getEditor(O);if(!u)throw new Error("unknown text editor");if(y.options&&u._acceptOptions(y.options),y.selections){const w=y.selections.selections.map(A.Selection.to);u._acceptSelections(w)}if(y.visibleRanges){const w=I.$Hb(y.visibleRanges.map(A.Range.to));u._acceptVisibleRanges(w)}if(y.options&&this.b.fire({textEditor:u.value,options:{...y.options,lineNumbers:A.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const w=g.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(A.Selection.to);this.a.fire({textEditor:u.value,selections:m,kind:w})}if(y.visibleRanges){const w=I.$Hb(y.visibleRanges.map(A.Range.to));this.c.fire({textEditor:u.value,visibleRanges:w})}}$acceptEditorPositionData(O){for(const y in O){const u=this.i.getEditor(y);if(!u)throw new Error("Unknown text editor");const w=A.ViewColumn.to(O[y]);u.value.viewColumn!==w&&(u._acceptViewColumn(w),this.d.fire({textEditor:u.value,viewColumn:w}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.$xjc=d}),define(Pe[281],Re([1,0,2,3,4,6,7,8,20,17]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=e.$dlc=void 0,e.$dlc=(0,T.$ii)("IExtHostTimeline");class O{constructor(w,m){this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$qM.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&d.$Dm.equals(o,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:I.URI.revive(r.uri);return this.c.get(r.source)?.get(y(s))?.get(r.handle)}else return;return r}})}async $getTimeline(w,m,r,o){return this.b.get(w)?.provider.provideTimeline(I.URI.revive(m),r,o)}registerTimelineProvider(w,m,r,o){const s=new N.$Tc,n=this.d(m.id,o,s).bind(this);let i;m.onDidChange&&(i=m.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:m.id}),this));const a=this.c;return this.f({...m,scheme:w,onDidChange:void 0,async provideTimeline(h,t,v){t?.resetCache&&(s.clear(),a.get(m.id)?.clear());const c=await m.provideTimeline(h,t,v);if(c==null)return;const $=n(h,t);return{...c,source:m.id,items:c.items.map($)}},dispose(){for(const h of a.values())h.get(m.id)?.clear();i?.dispose(),s.dispose()}},r)}d(w,m,r){return(o,s)=>{let n;if(s?.cacheResults){let i=this.c.get(w);i===void 0&&(i=new Map,this.c.set(w,i));const a=y(o);n=i.get(a),n===void 0&&(n=new Map,i.set(a,n))}return i=>{const{iconPath:a,...h}=i,t=`${w}|${i.id??i.timestamp}`;n?.set(t,i);let v,c,$;i.iconPath&&(a instanceof A.$oN?$={id:a.id,color:a.color}:I.URI.isUri(a)?(v=a,c=a):{light:v,dark:c}=a);let b;return A.$TM.isMarkdownString(h.tooltip)?b=g.MarkdownString.from(h.tooltip):(0,E.$Vf)(h.tooltip)?b=h.tooltip:A.$TM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=g.MarkdownString.from(h.detail)):(0,E.$Vf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=h.detail),{...h,id:h.id??void 0,handle:t,source:w,command:i.command?m.toInternal(i.command,r):void 0,icon:v,iconDark:c,themeIcon:$,tooltip:b,accessibilityInformation:i.accessibilityInformation}}}}f(w,m){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:m}),(0,N.$Sc)(()=>{for(const o of this.c.values())o.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$elc=O;function y(u){return u?.toString()}}),define(Pe[282],Re([1,0,173,23,2,5,6,211,11,7,17,18,8,54,24,137,25]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;function s(a,h){if((0,O.$Vf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class n extends A.$Uc{constructor(h,t,v){super(),this.f=h,this.g=t,this.h=v,this.a=new Map,this.b=new r.$i0;function c($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:$=>c($)?this.r($):Array.isArray($)&&$.length>0?$.map(b=>c(b)?this.r(b):b):$})}registerTreeDataProvider(h,t,v){const c=this.createTreeView(h,{treeDataProvider:t},v);return{dispose:()=>c.dispose()}}createTreeView(h,t,v){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],$=t.dragAndDropController?.dragMimeTypes??[],b=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,v),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:$,hasHandleDrag:b,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(h,D),S={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,o.$cG)(v,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,o.$cG)(v,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(k){(0,w.$Hk)(k)&&(0,o.$cG)(v,"treeViewMarkdownMessage"),l.message=k},get title(){return l.title},set title(k){l.title=k},get description(){return l.description},set description(k){l.description=k},get badge(){return l.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?l.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(l.badge=void 0)},reveal:(k,P)=>l.reveal(k,P),dispose:async()=>{await f,this.a.delete(h),l.dispose()}};return this.B(S),S}$getChildren(h,t){const v=this.a.get(h);return v?v.getChildren(t):Promise.reject(new g.$FF(h))}async $handleDrop(h,t,v,c,$,b,p,l){const D=this.a.get(h);if(!D)return Promise.reject(new g.$FF(h));const f=u.DataTransfer.toDataTransfer(v,async S=>(await this.f.$resolveDropFileData(h,t,S)).buffer);return p===h&&l&&await this.j(f,D,l,$,b),D.onDrop(f,c,$)}async j(h,t,v,c,$){const b=this.b.removeDragOperationTransfer($);if(b)(await b)?.forEach((p,l)=>{p&&h.set(l,p)});else if($&&t.handleDrag){const p=t.handleDrag(v,h,c);this.b.addDragOperationTransfer($,p),await p}return h}async $handleDrag(h,t,v,c){const $=this.a.get(h);if(!$)return Promise.reject(new g.$FF(h));const b=await this.j(new E.$kN,$,t,c,v);if(!(!b||c.isCancellationRequested))return u.DataTransfer.from(b)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new g.$FF(h);return t.hasResolve}$resolve(h,t,v){const c=this.a.get(h);if(!c)throw new g.$FF(h);return c.resolveTreeItem(t,v)}$setExpanded(h,t,v){const c=this.a.get(h);if(!c)throw new g.$FF(h);c.setExpanded(t,v)}$setSelectionAndFocus(h,t,v){const c=this.a.get(h);if(!c)throw new g.$FF(h);c.setSelectionAndFocus(t,v)}$setVisible(h,t){const v=this.a.get(h);if(!v){if(!t)return;throw new g.$FF(h)}v.setVisible(t)}$changeCheckboxState(h,t){const v=this.a.get(h);if(!v)throw new g.$FF(h);v.setCheckboxState(t)}m(h,t,v){const c=this.B(new i(h,t,this.f,this.g.converter,this.h,v));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$flc=n;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,O.$5f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,v,c,$,b){if(super(),this.I=h,this.J=v,this.L=c,this.M=$,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$ee,b.contributes&&b.contributes.views)for(const f in b.contributes.views)for(const S of b.contributes.views[f])S.id===h&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let p,l;const D=N.Event.debounce(this.F.event,(f,S)=>(f||(f={message:!1,elements:[]}),S.element!==!1&&(p||(p=new Promise(k=>l=k),this.G=this.G.then(()=>p)),Array.isArray(S.element)?f.elements.push(...S.element):f.elements.push(S.element)),S.message&&(f.message=!0),f),200,!0);this.B(D(({message:f,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const k=l;return p=null,this.$(S).then(()=>k())})),f&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let v=this.X(h);return v||(v=await this.Y(t)),v?v.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const v=(0,O.$5f)(t.select)?!0:t.select,c=(0,O.$5f)(t.focus)?!1:t.focus,$=(0,O.$5f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(b=>this.W(h,b[b.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:b.map(l=>l.item)},{select:v,focus:c,expand:$})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:v,focus:c,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const v=this.getExtensionElement(h);v&&(t?this.u.fire(Object.freeze({element:v})):this.w.fire(Object.freeze({element:v})))}setSelectionAndFocus(h,t){const v=!(0,y.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,v&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async v=>{const c=this.getExtensionElement(v.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:v.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(v=>v!==void 0);t.forEach(v=>{v.treeItem.checkboxState=v.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(v=>[v.extensionItem,v.newState])})}async handleDrag(h,t,v){const c=[];for(const $ of h){const b=this.getExtensionElement($);b&&c.push(b)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,v),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,v){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,d.$ah)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,v):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const v=this.j.get(h);if(v){const c=this.m.get(v);if(c){const $=await this.f.resolveTreeItem(c.extensionItem,v,t)??c.extensionItem;return this.hb($),c.item.tooltip=this.eb($.tooltip),c.item.command=this.fb(c.disposableStore,$.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(v=>this.W(t,v[v.length-1]).then(c=>(v.push(c),v))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,d.$ah)(()=>this.f.getParent(h))}W(h,t){const v=this.m.get(h);return v?Promise.resolve(v):(0,d.$ah)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const $=this.getExtensionElement(c);if($){const b=this.m.get($);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const v=this.getExtensionElement(h);t=v?this.m.get(v):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new m.$ee(this.Z.token);try{const v=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const $=(0,y.$Hb)(c||[]),b=await Promise.all((0,y.$Hb)($).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const p=b.map((l,D)=>l?this.db($[D],l,v):null);return(0,y.$Hb)(p)}finally{t.dispose()}}$(h){if(h.some(v=>!v))return this.Z.dispose(!0),this.Z=new m.$ee,this.tb(),this.J.$refresh(this.I);{const v=this.ab(h);if(v.length)return this.bb(v)}return Promise.resolve(void 0)}ab(h){const t=new Set,v=h.map($=>this.m.get($));for(const $ of v)if($&&!t.has($.item.handle)){let b=$;for(;b&&b.parent&&v.findIndex(p=>b&&b.parent&&p&&p.item.handle===b.parent.item.handle)===-1;){const p=this.j.get(b.parent.item.handle);b=p?this.m.get(p):void 0}b&&!b.parent&&t.add($.item.handle)}const c=[];return t.forEach($=>{const b=this.j.get($);if(b){const p=this.m.get(b);p&&(!p.parent||!t.has(p.parent.item.handle))&&c.push($)}}),c}bb(h){const t={};return Promise.all(h.map(v=>this.cb(v).then(c=>{c&&(t[v]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const v=this.m.get(t);if(v)return this.rb(t),(0,d.$ah)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const $=this.ib(t,c,v.parent);return this.pb(t,$,v,v.parent),v.dispose(),$}return null})}return Promise.resolve(null)}db(h,t,v){const c=this.ib(h,t,v);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,v),c}eb(h){return E.$TM.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,v,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,v=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:v,accessibilityInformation:c}}hb(h){if(!E.$fN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,v){this.hb(t);const c=this.B(new A.$Tc),$=this.kb(h,t,v),b=this.lb(t);return{item:{handle:$,parentHandle:v?v.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:b,iconDark:this.mb(t)||b,themeIcon:this.jb(t),collapsibleState:(0,O.$5f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:v,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof E.$oN?h.iconPath:void 0}kb(h,{id:t,label:v,resourceUri:c},$,b){if(t)return`${i.b}/${t}`;const p=s(v,this.N),l=$?$.item.handle:i.a;let D=p?p.label:c?(0,T.$Sg)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const f=this.m.has(h)?this.m.get(h).item.handle:void 0,S=this.X($)||[];let k,P=0;do{if(k=`${l}/${P}:${D}`,b||!this.j.has(k)||f===k)break;P++}while(P<=S.length);return k}lb(h){if(h.iconPath&&!(h.iconPath instanceof E.$oN))return typeof h.iconPath=="string"||R.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof E.$oN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return R.URI.isUri(h)?h:R.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,v,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==v.item.handle&&this.j.delete(v.item.handle),this.ob(h,t);const $=this.X(c)||[],b=$.filter(p=>p.item.handle===v.item.handle)[0];b&&$.splice($.indexOf(b),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[283],Re([1,0,5,6,2,34,8,63,4,7]),function(ge,e,I,T,R,N,A,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;class O extends T.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$7d),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,R.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:A.ViewColumn.from(m),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends T.$Uc{static c(){return(0,N.$Eg)()}constructor(m,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy(d.$qM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,r,o,s,n={}){const i=typeof s=="object"?s.viewColumn:s,a={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,g.$Mjc)(m),t=y.c();this.f.$createWebviewPanel((0,g.$Ojc)(m),t,r,{title:o,panelOptions:u(n),webviewOptions:(0,g.$Pjc)(m,this.m,n),serializeBuffersForPostMessage:h},a);const v=this.j.createNewWebview(t,n,m);return this.createNewWebviewPanel(t,r,o,i,n,v,!0)}$onDidChangeWebviewPanelViewStates(m){const r=Object.keys(m);r.sort((o,s)=>{const n=m[o],i=m[s];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const n=m[o];s._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:m}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,g.$Mjc)(m)}),new E.$sM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(m,r,o,s){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:a}=n,h=this.j.createNewWebview(m,o.webviewOptions,a),t=this.createNewWebviewPanel(m,r,o.title,s,o.panelOptions,h,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(m,r,o,s,n,i,a){const h=new O(m,this.f,i,{viewType:r,title:o,viewColumn:s,panelOptions:n,active:a});return this.g.set(m,h),h}getWebviewPanel(m){return this.g.get(m)}}e.$Qjc=y;function u(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Pe[284],Re([1,0,5,6,63,8,4,7]),function(ge,e,I,T,R,N,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class d extends T.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,w,m,r,o){super(),this.#s=!1,this.#u=this.B(new I.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$7d),this.onDidDispose=this.#l.event,this.#i=w,this.#a=m,this.#e=y,this.#t=u,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$qM.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,w,m){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:w,extension:y}),this.a.$registerWebviewViewProvider((0,R.$Ojc)(y),u,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$Mjc)(y)}),new g.$sM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,w,m,r){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:n}=o,i=this.d.createNewWebview(y,{},n),a=new d(y,this.a,u,w,i,!0);this.c.set(y,a),await s.resolveWebviewView(a,{state:m},r)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$ilc=E}),define(Pe[285],Re([1,0,5,30,33,3]),function(ge,e,I,T,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=e.OutputChannelUpdateMode=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=void 0,e.$yL="text/x-code-output",e.$zL="output",e.$AL="Log",e.$BL="text/x-code-log-output",e.$CL="log",e.$DL="workbench.panel.output",e.$EL=new R.$zj("inOutput",!1),e.$FL=new R.$zj("activeLogOutput",!1),e.$GL=new R.$zj("activeLogOutput.levelSettable",!1),e.$HL=new R.$zj("activeLogOutput.level",""),e.$IL=new R.$zj("activeLogOutput.levelIsDefault",!1),e.$JL=new R.$zj("outputView.scrollLock",!1),e.$KL=(0,N.$ii)("outputService");var A;(function(d){d[d.Append=1]="Append",d[d.Replace=2]="Replace",d[d.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$LL={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new I.$7d,this.onDidRegisterChannel=this.b.event,this.c=new I.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(O=>E.push(O)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}T.$1n.add(e.$LL.OutputChannels,new g),e.$ML=new R.$zj("activeOutputChannel","")}),define(Pe[116],Re([1,0,4,3,16,20,13,285,64,27,44,141,22,17,43,5,6]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=e.$Vkc=void 0;class s extends A.$Uj{get disposed(){return this.n}constructor(h,t,v,c,$){super(),this.id=h,this.name=t,this.r=v,this.s=c,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(v.getLevel()),this.B(v.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,g.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=u.$ue.fromString(t).byteLength,(0,A.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,v,c,$,b){this.i=t,this.j=v,this.k=c,this.l=$,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$qM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,y.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,v]of this.g)v.visible=t===this.h}createOutputChannel(h,t,v){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,$=(0,w.$Vf)(t)?t:void 0;if((0,w.$Vf)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const p=this.i.environment.extensionLogLevel?.find(([D])=>N.$Dm.equals(v.identifier,D))?.[1];p&&(b=(0,A.$6j)(p));const l=c?this.o(h,b,v):this.n(h,$,v);return l.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(h,b??this.m.getLevel(),l):this.q(h,l)}async n(h,t,v){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,$=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(h,$,t,v.identifier.value);return new s(p,h,b,this.a,v)}async o(h,t,v){const c=await this.p(v),$=h.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(c,`${$}.log`),p=`${v.identifier.value}.${$}`,l=this.l.createLogger(b,{id:p,name:h,logLevel:t,extensionId:v.identifier.value});return new n(p,h,l,this.a,v)}p(h){let t=this.d.get(h.identifier.value);if(!t){const v=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(v)}catch(c){if((0,m.$5k)(c)!==m.FileSystemProviderErrorCode.FileExists)throw c}return v})())}return t}q(h,t){let v=!1;const c=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return h},append($){c(),t.then(b=>b.append($))},appendLine($){c(),t.then(b=>b.appendLine($))},clear(){c(),t.then($=>$.clear())},replace($){c(),t.then(b=>b.replace($))},show($,b){c(),t.then(p=>p.show($,b))},hide(){c(),t.then($=>$.hide())},dispose(){v=!0,t.then($=>$.dispose())}}}r(h,t,v){const c=new o.$Tc,$=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},b=c.add(new r.$7d);function p(l){t=l,b.fire(l)}return v.then(l=>{c.add(l),l.logLevel!==t&&p(l.logLevel),c.add(l.onDidChangeLogLevel(D=>p(D)))}),{...this.q(h,v),get logLevel(){return t},onDidChangeLogLevel:b.event,trace(l,...D){$(),v.then(f=>f.trace(l,...D))},debug(l,...D){$(),v.then(f=>f.debug(l,...D))},info(l,...D){$(),v.then(f=>f.info(l,...D))},warn(l,...D){$(),v.then(f=>f.warn(l,...D))},error(l,...D){$(),v.then(f=>f.error(l,...D))},dispose(){c.dispose()}}}};e.$Vkc=i,e.$Vkc=i=Je([qe(0,R.$LO),qe(1,E.$2O),qe(2,d.$Ijc),qe(3,O.$ijc),qe(4,A.$Pj),qe(5,A.$Oj)],i),e.$Wkc=(0,T.$ii)("IExtHostOutputService")}),define(Pe[117],Re([1,0,3,11]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$5m=(0,I.$ii)("remoteAgentService"),e.$6m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let N=1/0;for(let g=0;g<this.maxSampleCount;g++){const d=await R.getRoundTripTime();if(d===void 0)return;N=Math.min(N,d/2),await(0,T.$jh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(N):A=this.initial.reduce((g,d)=>g+d,0)/this.initial.length,this.lastMeasurement={initial:A,current:N,average:this.average.reduce((g,d)=>g+d,0)/this.average.length,high:typeof A>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[286],Re([1,0,176,57,30,48,47,6,5,117,21,26,11]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=void 0,e.$5I=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$6I=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$7I=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$8I=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$9I={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new d.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const m=new w;R.$1n.add(e.$9I.ConfigurationMigration,m);let r=class extends g.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(a=>this.g(a,n?.uri))])}async g(n,i){const a=this.a.inspect(n.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,v]of h){const c=a[t];if(!c)continue;const $=[];if(c.value!==void 0){const b=await this.h(n,t,c.value,i,void 0);for(const p of b??[])$.push([p,[]])}for(const{identifiers:b,value:p}of c.overrides??[])if(p!==void 0){const l=await this.h(n,t,p,i,b);for(const D of l??[])$.push([D,b])}$.length&&await Promise.allSettled($.map(async([[b,p],l])=>this.a.updateValue(b,p.value,{resource:i,overrideIdentifiers:l},v)))}}async h(n,i,a,h,t){const v=$=>{const p=this.a.inspect($,{resource:h})[i];if(p)return t?p.overrides?.find(({identifiers:l})=>(0,y.$Sn)(l,t))?.value:p.value},c=await n.migrateFn(a,v);return Array.isArray(c)?c:[[n.key,c]]}};e.$0I=r,e.$0I=r=Je([qe(0,A.$Oi),qe(1,N.$ri)],r);let o=class extends g.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$Fh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!O.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$1n.as(T.$6n.Configuration).registerConfiguration({...e.$7I,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$$I=o,e.$$I=o=Je([qe(0,E.$5m)],o)}),define(Pe[287],Re([1,0,35,12,19,23,184,286,57,3,30]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Kfb=e.$Jfb=void 0,e.$Lfb=r,e.$Mfb=o,e.$Jfb=(0,E.$ii)("editorResolverService"),e.$Kfb="workbench.editorAssociations";const y=O.$1n.as(d.$6n.Configuration),u={...g.$6I,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var m;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function r(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function o(s,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof s=="string"&&s.indexOf(R.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,N.$Sg)(n);return I.$bk(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Pe[288],Re([1,0,46,12,19,21,23,2,3,205,48,224,117]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0,e.$5L=(0,d.$ii)("pathService");let m=w=class{constructor(o,s,n,i){this.d=o,this.e=s,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,n)}h(o,s,n){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,I.$gg)(n??(0,A.$Sg)(o),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,E.$2L)(s.getWorkspace());if(n)return n;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return g.URI.from({scheme:T.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$6L=m,e.$6L=m=w=Je([qe(1,u.$5m),qe(2,y.$NL),qe(3,O.$ri)],m)}),define(Pe[118],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$yK=e.$xK=void 0;class I{constructor(A,g){this.line=A,this.character=g}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,g){return new I(0,0)}with(A){return new I(0,0)}}e.$xK=I;class T{constructor(A,g,d,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(A,g),this.end=new I(d,E)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$yK=T;var R;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Pe[45],Re([1,0,18,35,26,46,15,3,19,14,118,11]),function(ge,e,I,T,R,N,A,g,d,E,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$VK=e.$OK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$LK=e.$KK=e.$JK=e.$IK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.TextSearchCompleteMessageType=void 0,e.$FK=s,e.$GK=n,e.$HK=i,e.$MK=l,e.$NK=D,e.$PK=k,e.$QK=P,e.$RK=C,e.$SK=q,e.$TK=V,e.$UK=W,e.$WK=z,e.$YK=fe,e.$ZK=De,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.$zK="workbench.view.search",e.$AK="workbench.panel.search",e.$BK="workbench.view.search",e.$CK="search-result",e.$DK="search.exclude";const u="\u27EA ",w=" characters skipped \u27EB",m=(u.length+w.length+5)*2;e.$EK=(0,g.$ii)("searchService");var r;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text",oe[oe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text",oe[oe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(oe){return!!oe.preview}function n(oe){return!!oe.resource}function i(oe){return!!oe.message}var a;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor($e){this.resource=$e,this.results=[]}}e.$IK=h;class t{constructor($e,ne,Se,je){this.ranges=ne,this.webviewIndex=je;const re=Array.isArray(ne)?ne:[ne];if(Se&&Se.matchLines===1&&v(re)){$e=(0,A.$Of)($e,Se.matchLines);let L="",_=0,ve=0;const Oe=Math.floor(Se.charsPerLine/5),ke=[];for(const pe of re){const de=Math.max(pe.startColumn-Oe,0),J=pe.startColumn+Se.charsPerLine;if(de>ve+Oe+m){const Y=u+(de-ve)+w;L+=Y+$e.slice(de,J),_+=de-(ve+Y.length)}else L+=$e.slice(ve,J);ke.push(new $(0,pe.startColumn-_,pe.endColumn-_)),ve=J}this.preview={text:L,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const L=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:$e,matches:(0,I.$2b)(ne,_=>new c(_.startLineNumber-L,_.startColumn,_.endLineNumber-L,_.endColumn))}}}}e.$JK=t;function v(oe){const $e=oe[0].startLineNumber;for(const ne of oe)if(ne.startLineNumber!==$e||ne.endLineNumber!==$e)return!1;return!0}class c{constructor($e,ne,Se,je){this.startLineNumber=$e,this.startColumn=ne,this.endLineNumber=Se,this.endColumn=je}}e.$KK=c;class $ extends c{constructor($e,ne,Se){super($e,ne,$e,Se)}}e.$LK=$;var b;(function(oe){oe.List="list",oe.Tree="tree"})(b||(e.ViewMode=b={}));var p;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function l(oe,$e=!0){const ne=oe&&oe.files&&oe.files.exclude,Se=$e&&oe&&oe.search&&oe.search.exclude;if(!ne&&!Se)return;if(!ne||!Se)return ne||Se;let je=Object.create(null);return je=R.$Rn(je,R.$On(ne)),je=R.$Rn(je,R.$On(Se),!0),je}function D(oe,$e){return oe.excludePattern&&T.$bk(oe.excludePattern,$e)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&T.$bk(oe.includePattern,$e)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ne=>{const Se=ne.folder.fsPath;if(N.$ig($e,Se)){const je=d.$mc(Se,$e);return!ne.includePattern||!!T.$bk(ne.includePattern,je)}else return!1}):!1:!0}var f;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class S extends Error{constructor($e,ne){super($e),this.code=ne}}e.$OK=S;function k(oe){const $e=oe.message;if((0,E.$4)(oe))return new S($e,f.canceled);try{const ne=JSON.parse($e);return new S(ne.message,ne.code)}catch{return new S($e,f.other)}}function P(oe){const $e={message:oe.message,code:oe.code};return new Error(JSON.stringify($e))}function C(oe){return oe.type==="error"?!0:oe.type==="success"}function q(oe){return oe.type==="success"}function V(oe){return!!oe.path}function W(oe,$e,ne=!0){const Se=oe.searchPath?oe.searchPath:oe.relativePath;return ne?(0,A.$Lf)(Se,$e):T.$bk($e,Se)}class M{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$VK=M;function z(oe,$e){const ne={...oe||{},...$e||{}};return Object.keys(ne).filter(Se=>{const je=ne[Se];return typeof je=="boolean"&&je})}class K{constructor($e,ne){this.c=null,this.a={...$e.excludePattern||{},...ne.excludePattern||{}},this.b=T.$ck(this.a);let Se=$e.includePattern;ne.includePattern&&(Se?Se={...Se,...ne.includePattern}:Se=ne.includePattern),Se&&(this.c=T.$ck(Se))}matchesExcludesSync($e,ne,Se){return!!(this.b&&this.b($e,ne,Se))}includedInQuerySync($e,ne,Se){return!(this.b&&this.b($e,ne,Se)||this.c&&!this.c($e,ne,Se))}includedInQuery($e,ne,Se){const je=this.b($e,ne,Se),re=()=>this.c?!!this.c($e,ne,Se):!0;return(0,y.$7g)(je)?je.then(L=>L?!1:re()):re()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$XK=K;function ie(oe){for(const $e in oe)if(typeof oe[$e]!="boolean")return!0;return!1}function fe(oe){if(!oe)return;let $e;return ne=>($e||($e=(oe()||Promise.resolve([])).then(Se=>Se?ye(Se):{})),$e.then(Se=>!!Se[ne]))}function De(oe){if(!oe)return;let $e;return ne=>{if(!$e){const Se=oe();$e=Se?ye(Se):{}}return!!$e[ne]}}function ye(oe){const $e={};for(const ne of oe)$e[ne]=!0;return $e}}),define(Pe[36],Re([1,0,18,11,24,5,6,52,12,126,23,15,2,175,3,13,194,48,44,27,16,8,7,60,45,4,53]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a,h,t,v,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=e.$Cjc=void 0;function p(q,V,W){return new O.$Kg(M=>S(M,W)).isEqual(q,V)}function l(q,V,W){return p(q.uri,V.uri,W)?0:(0,y.$ef)(q.uri.toString(),V.uri.toString())}function D(q,V,W){return q.index!==V.index?q.index<V.index?-1:1:p(q.uri,V.uri,W)?(0,y.$ef)(q.name,V.name):(0,y.$ef)(q.uri.toString(),V.uri.toString())}function f(q,V,W,M){const z=q.slice(0).sort((ie,fe)=>W(ie,fe,M)),K=V.slice(0).sort((ie,fe)=>W(ie,fe,M));return(0,I.$Eb)(z,K,(ie,fe)=>W(ie,fe,M))}function S(q,V){const W=V.getCapabilities(q.scheme);return!(W&&W&1024)}class k extends s.$Bi{static toExtHostWorkspace(V,W,M,z){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:fe,configuration:De,transient:ye,isUntitled:oe}=V,$e=[],ne=W;W?fe.forEach((L,_)=>{const ve=u.URI.revive(L.uri),Oe=k.o(M||W,ve,z);Oe?(Oe.name=L.name,Oe.index=L.index,$e.push(Oe)):$e.push({uri:ve,name:L.name,index:_})}):$e.push(...fe.map(({uri:L,name:_,index:ve})=>({uri:u.URI.revive(L),name:_,index:ve}))),$e.sort((L,_)=>L.index<_.index?-1:1);const Se=new k(K,ie,$e,!!ye,De?u.URI.revive(De):null,!!oe,L=>S(L,z)),{added:je,removed:re}=f(ne?ne.workspaceFolders:[],Se.workspaceFolders,l,z);return{workspace:Se,added:je,removed:re}}static o(V,W,M){for(let z=0;z<V.folders.length;z++){const K=V.workspaceFolders[z];if(p(K.uri,W,M))return K}}constructor(V,W,M,z,K,ie,fe){super(V,M.map(De=>new s.$Ci(De)),z,K,fe),this.t=W,this.u=ie,this.q=[],this.s=g.$oi.forUris(fe),M.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,W){return W&&this.s.get(V)&&(V=(0,O.$Ug)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let P=class{constructor(V,W,M,z,K){this.c=new N.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new N.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$9d,this.C=new Map,this.h=z,this.s=M,this.t=K,this.j=new E.$pm,this.k=new T.$hh,this.o=V.getProxy($.$qM.MainThreadWorkspace),this.q=V.getProxy($.$qM.MainThreadMessageService);const ie=W.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,fe=>S(fe,M)):void 0}$initializeWorkspace(V,W){this.v=W,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:d.Schemas.untitled,path:(0,O.$Sg)((0,O.$Ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,W,M,...z){const K=[];if(Array.isArray(z)&&z.forEach(oe=>{u.URI.isUri(oe.uri)&&!K.some($e=>p($e.uri,oe.uri,this.s))&&K.push({uri:oe.uri,name:oe.name||(0,O.$Rg)(oe.uri)})}),this.n||[W,M].some(oe=>typeof oe!="number"||oe<0)||M===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(W+M>ie.length)return!1;const fe=ie.slice(0);fe.splice(W,M,...K.map(oe=>({uri:oe.uri,name:oe.name||(0,O.$Rg)(oe.uri),index:void 0})));for(let oe=0;oe<fe.length;oe++){const $e=fe[oe];if(fe.some((ne,Se)=>Se!==oe&&p($e.uri,ne.uri,this.s)))return!1}fe.forEach((oe,$e)=>oe.index=$e);const{added:De,removed:ye}=f(ie,fe,D,this.s);if(De.length===0&&ye.length===0)return!1;if(this.o){const oe=V.displayName||V.name;this.o.$updateWorkspaceFolders(oe,W,M,K).then(void 0,$e=>{this.n=void 0;const ne={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,w.localize)(0,null,oe,$e.toString()),ne,[])})}return this.y(fe),!0}getWorkspaceFolder(V,W){if(this.x)return this.x.getWorkspaceFolder(V,W)}async getWorkspaceFolder2(V,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,W)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,W){let M,z="";if(typeof V=="string"?(M=u.URI.file(V),z=V):typeof V<"u"&&(M=V,z=V.fsPath),!M)return z;const K=this.getWorkspaceFolder(M,!0);if(!K)return z;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ie=(0,O.$Xg)(K.uri,M);return W&&K.name&&(ie=`${K.name}/${ie}`),ie}y(V){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:W,added:M,removed:z}=k.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:z}))}findFiles(V,W,M,z,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let ie="",fe=!0;return W===null?fe=!1:W!==void 0&&(typeof W=="string"?ie=W:ie=W.pattern),this.z(V,void 0,{exclude:ie,maxResults:M,useDefaultExcludes:fe,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,W={},M,z=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,V,W,z)}async z(V,W,M,z=R.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const K=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ie={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:K,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let fe;if(V){const{includePattern:De,folder:ye}=C(h.GlobPattern.from(V));fe=ye,ie.includePattern=De}else{const{includePattern:De,folder:ye}=C(h.GlobPattern.from(W));fe=ye,ie.filePattern=De}return this.o.$startFileSearch(fe??null,ie,z).then(De=>Array.isArray(De)?De.map(ye=>u.URI.revive(ye)):[])}async findTextInFiles(V,W,M,z,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),fe=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:De,folder:ye}=C(h.GlobPattern.from(W.include)),oe=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,$e={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:fe,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:De,excludePattern:oe},ne=!1;if(this.u[ie]=Se=>{if(ne)return;const je=u.URI.revive(Se.resource);Se.results.forEach(re=>{const L=(0,b.$Rh)(re);(0,c.$FK)(L)?M({uri:je,preview:{text:L.preview.text,matches:(0,I.$2b)(L.preview.matches,_=>new t.$uM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,I.$2b)(L.ranges,_=>new t.$uM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):M({uri:je,text:L.text,lineNumber:L.lineNumber})})},K.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(V,ye??null,$e,ie,K);return delete this.u[ie],Se||{}}catch(Se){throw delete this.u[ie],Se}}$handleTextSearchResult(V,W){this.u[W]?.(V)}async save(V){const W=await this.o.$save(V,{saveAs:!1});return u.URI.revive(W)}async saveAs(V){const W=await this.o.$save(V,{saveAs:!0});return u.URI.revive(W)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,W){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,W);const M=this.t.transformOutgoingScheme(V),z=this.A++;return this.o.$registerEditSessionIdentityProvider(z,M),(0,A.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(V,W){this.h.info("Getting edit session identifier for workspaceFolder",V);const M=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const z=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!z),!z)return;const K=await z.provideEditSessionIdentity(M,W);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,W,M,z){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const fe=await ie.provideEditSessionIdentityMatch?.(W,M,z);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(V){return(W,M,z)=>{const K=function(fe){W.call(M,fe)};return K.extension=V,this.B.event(K,void 0,z)}}async $onWillCreateEditSessionIdentity(V,W,M){const z=await this.resolveWorkspaceFolder(u.URI.revive(V));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:z},W,async(K,ie)=>{const fe=Date.now();await Promise.resolve(K),Date.now()-fe>M&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(V,W){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,W);const M=this.t.transformOutgoingScheme(V),z=this.A++;return this.o.$registerCanonicalUriProvider(z,M),(0,A.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(V,W,M){const z=this.C.get(V.scheme);if(!z)return;const K=await z.provideCanonicalUri?.(u.URI.revive(V),W,M);if(K)return K}async $provideCanonicalUri(V,W,M){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:W},M)}};e.$Cjc=P,e.$Cjc=P=Je([qe(0,a.$LO),qe(1,i.$2O),qe(2,n.$ijc),qe(3,r.$Oj),qe(4,v.$Ajc)],P),e.$Djc=(0,m.$ii)("IExtHostWorkspace");function C(q){let V,W;return q&&(typeof q=="string"?V=q:(V=q.pattern,W=u.URI.revive(q.baseUri))),{includePattern:V,folder:W}}}),define(Pe[37],Re([1,0,26,5,36,4,7,196,57,17,11,3,16,13,2]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=e.$Fjc=e.$Ejc=void 0;function r(v,c){if(c){const $=c.split(".");let b=v;for(let p=0;b&&p<$.length;p++)b=b[$[p]];return b}}function o(v){return v instanceof m.URI}function s(v){return v&&v.uri instanceof m.URI&&v.languageId&&typeof v.languageId=="string"}function n(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function i(v){return v&&v.uri instanceof m.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function a(v){if(o(v))return{resource:v};if(s(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(n(v))return{overrideIdentifier:v.languageId};if(i(v))return{resource:v.uri};if(v===null)return{resource:null}}let h=class{constructor(c,$,b){this.a=c.getProxy(N.$qM.MainThreadConfiguration),this.c=$,this.b=b,this.d=new O.$hh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,$){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(c,$))}};e.$Ejc=h,e.$Ejc=h=Je([qe(0,u.$LO),qe(1,R.$Djc),qe(2,w.$Oj)],h);class t{constructor(c,$,b,p){this.a=new T.$7d,this.b=c,this.f=p,this.c=$,this.e=g.$mo.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,$){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$mo.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j($,b))}getConfiguration(c,$,b){const p=a($)||{},l=this.g(c?r(this.e.getValue(void 0,p,this.c.workspace),c):this.e.getValue(void 0,p,this.c.workspace));c&&this.h(c,p,b?.identifier);function D(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(S){return typeof r(l,S)<"u"},get:(S,k)=>{this.h(c?`${c}.${S}`:S,p,b?.identifier);let P=r(l,S);if(typeof P>"u")P=k;else{let C;const q=(V,W)=>{if((0,E.$Xf)(V)){let M;const z=()=>{C=C||(0,I.$On)(l),M=M||r(C,W)};return new Proxy(V,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return z(),()=>M;if(C)return M=M||r(C,W),M[ie];const fe=K[ie];return typeof ie=="string"?q(fe,`${W}.${ie}`):fe},set:(K,ie,fe)=>(z(),M&&(M[ie]=fe),!0),deleteProperty:(K,ie)=>(z(),M&&delete M[ie],!0),defineProperty:(K,ie,fe)=>(z(),M&&Object.defineProperty(M,ie,fe),!0)})}return Array.isArray(V)?(0,I.$On)(V):V};P=q(P,S)}return P},update:(S,k,P,C)=>{S=c?`${c}.${S}`:S;const q=D(P);return k!==void 0?this.b.$updateConfigurationOption(q,S,k,p,C):this.b.$removeConfigurationOption(q,S,p,C)},inspect:S=>{S=c?`${c}.${S}`:S;const k=this.e.inspect(S,p,this.c.workspace);if(k)return{key:S,defaultValue:(0,I.$On)(k.policy?.value??k.default?.value),globalValue:(0,I.$On)(k.user?.value??k.application?.value),workspaceValue:(0,I.$On)(k.workspace?.value),workspaceFolderValue:(0,I.$On)(k.workspaceFolder?.value),defaultLanguageValue:(0,I.$On)(k.default?.override),globalLanguageValue:(0,I.$On)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,I.$On)(k.workspace?.override),workspaceFolderLanguageValue:(0,I.$On)(k.workspaceFolder?.override),languageIds:(0,I.$On)(k.overrideIdentifiers)}}};return typeof l=="object"&&(0,I.$Rn)(f,l,!1),Object.freeze(f)}g(c){const $=b=>(0,E.$Xf)(b)?new Proxy(b,{get:(p,l)=>$(p[l]),set:(p,l,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(p,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(p,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return $(c)}h(c,$,b){const p=d.$do.test(c)?4:this.d.get(c),l=b?`[${b.value}] `:"";if(p===4){typeof $?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){$?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,$){const b=new g.$oo(c,$,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,l)=>b.affectsConfiguration(p,a(l))})}k(c){return c.reduce(($,b)=>($.set(b[0],b[1]),$),new Map)}}e.$Fjc=t,e.$Gjc=(0,y.$ii)("IExtHostConfiguration")}),define(Pe[119],Re([1,0,2,11,5,4,7,36,67,37,24,51,16,27,3,12,21,13,78,229,14]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=e.$9kc=e.$8kc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(q){function V(M){if(M!=null)return M}q.from=V;function W(M){if(M!=null)return M}q.to=W})(h||(h={}));var t;(function(q){function V(M){if(M!=null)return M}q.from=V;function W(M){if(M!=null)return M}q.to=W})(t||(t={}));var v;(function(q){function V(M){if(M!=null)return M}q.from=V;function W(M){if(M!=null)return M}q.to=W})(v||(v={}));var c;(function(q){function V(z){if(z){const K=z;return K&&!!K.process}else return!1}q.is=V;function W(z){if(z==null)return;const K={process:z.process,args:z.args};return z.options&&(K.options=v.from(z.options)),K}q.from=W;function M(z){if(z!=null)return new A.$bN(z.process,z.args,z.options)}q.to=M})(c||(c={}));var $;(function(q){function V(M){if(M!=null)return M}q.from=V;function W(M){if(M!=null)return M}q.to=W})($||($={}));var b;(function(q){function V(z){if(z){const K=z;return K&&(!!K.commandLine||!!K.command)}else return!1}q.is=V;function W(z){if(z==null)return;const K={};return z.commandLine!==void 0?K.commandLine=z.commandLine:(K.command=z.command,K.args=z.args),z.options&&(K.options=$.from(z.options)),K}q.from=W;function M(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$cN(z.commandLine,z.options):new A.$cN(z.command,z.args?z.args:[],z.options)}q.to=M})(b||(b={}));var p;(function(q){function V(z){if(z){const K=z;return K&&K.customExecution==="customExecution"}else return!1}q.is=V;function W(z){return{customExecution:"customExecution"}}q.from=W;function M(z,K){return K.get(z)}q.to=M})(p||(e.CustomExecutionDTO=p={}));var l;(function(q){function V(W,M){let z;return W.scope!==void 0&&typeof W.scope!="number"?z=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&M&&M.workspaceFile?z=M.workspaceFile:z=i.$yH),{id:W._id,workspaceFolder:z}}q.from=V})(l||(e.TaskHandleDTO=l={}));var D;(function(q){function V(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}q.from=V})(D||(D={}));var f;(function(q){function V(z,K){if(z==null)return[];const ie=[];for(const fe of z){const De=W(fe,K);De&&ie.push(De)}return ie}q.fromMany=V;function W(z,K){if(z==null)return;let ie;z.execution instanceof A.$bN?ie=c.from(z.execution):z.execution instanceof A.$cN?ie=b.from(z.execution):z.execution&&z.execution instanceof A.$dN&&(ie=p.from(z.execution));const fe=h.from(z.definition);let De;return z.scope?typeof z.scope=="number"?De=z.scope:De=z.scope.uri:De=A.TaskScope.Workspace,!fe||!De?void 0:{_id:z._id,definition:fe,name:z.name,source:{extensionId:K.identifier.value,label:z.source,scope:De},execution:ie,isBackground:z.isBackground,group:D.from(z.group),presentationOptions:t.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}q.from=W;async function M(z,K,ie){if(z==null)return;let fe;c.is(z.execution)?fe=c.to(z.execution):b.is(z.execution)?fe=b.to(z.execution):p.is(z.execution)&&(fe=p.to(z._id,ie));const De=h.to(z.definition);let ye;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ye=z.source.scope:ye=await K.resolveWorkspaceFolder(I.URI.revive(z.source.scope)):ye=A.TaskScope.Workspace),!De||!ye)return;const oe=new A.$eN(De,ye,z.name,z.source.label,fe,z.problemMatchers);return z.isBackground!==void 0&&(oe.isBackground=z.isBackground),z.group!==void 0&&(oe.group=A.$aN.from(z.group._id),oe.group&&z.group.isDefault&&(oe.group=new A.$aN(oe.group.id,oe.group.label),z.group.isDefault===!0&&(oe.group.isDefault=z.group.isDefault))),z.presentationOptions&&(oe.presentationOptions=t.to(z.presentationOptions)),z._id&&(oe._id=z._id),z.detail&&(oe.detail=z.detail),oe}q.to=M})(f||(e.TaskDTO=f={}));var S;(function(q){function V(M){return M}q.from=V;function W(M){if(M)return Object.assign(Object.create(null),M)}q.to=W})(S||(S={}));class k{#e;constructor(V,W,M){this._id=W,this.a=M,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let P=class{constructor(V,W,M,z,K,ie,fe,De){this.q=new R.$7d,this.r=new R.$7d,this.s=new R.$7d,this.u=new R.$7d,this.a=V.getProxy(N.$qM.MainThreadTask),this.b=M,this.c=z,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,W,M){if(!M)return new A.$sM(()=>{});const z=this.x();return this.j.set(z,{type:W,provider:M,extension:V}),this.a.$registerTaskProvider(z,W),new A.$sM(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(V,W){this.a.$registerTaskSystem(V,W)}fetchTasks(V){return this.a.$fetchTasks(S.from(V)).then(async W=>{const M=[];for(const z of W){const K=await f.to(z,this.b,this.m);K&&M.push(K)}return M})}get taskExecutions(){const V=[];return this.k.forEach(W=>V.push(W)),V}terminateTask(V){if(!(V instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,W,M){const z=this.m.get(V.id);z&&(this.o.set(V.id,z),this.e.attachPtyToTerminal(W,await z.callback(M))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const W=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const W=await this.z(V.id);this.s.fire({execution:W,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const W=await this.z(V.id);this.u.fire({execution:W,exitCode:V.exitCode})}$provideTasks(V,W){const M=this.j.get(V);if(!M)return Promise.reject(new Error("no handler found"));const z=[],K=(0,T.$ah)(()=>M.provider.provideTasks(O.CancellationToken.None)).then(ie=>this.v(W,z,M,ie));return new Promise(ie=>{K.then(fe=>{Promise.all(z).then(()=>{ie(fe)})})})}async $resolveTask(V,W){const M=this.j.get(V);if(!M)return Promise.reject(new Error("no handler found"));if(W.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${M.type}].`);const z=await f.to(W,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const K=await M.provider.resolveTask(z,O.CancellationToken.None);if(!K)return;this.A(K,M);const ie=f.from(K,M.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(V,W,M){const z=await this.a.$createTaskId(V);!M&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,W.execution)),this.m.set(z,W.execution)}async z(V,W){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new a.$bb("Unexpected: The specified task is missing an execution");return K}const M=this.l.get(V.id);if(M)return M;let z;return W?z=Promise.resolve(new k(this,V.id,W)):z=f.to(V.task,this.b,this.m).then(K=>{if(!K)throw new a.$bb("Unexpected: Task does not exist.");return new k(this,V.id,K)}),this.l.set(V.id,z),z.then(K=>(this.k.set(V.id,K),K))}A(V,W){V._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const M=this.n.values();let z=M.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=M.next()}};e.$8kc=P,e.$8kc=P=Je([qe(0,u.$LO),qe(1,w.$2O),qe(2,g.$Djc),qe(3,d.$WO),qe(4,E.$Gjc),qe(5,y.$5jc),qe(6,s.$Oj),qe(7,n.$ejc)],P);let C=class extends P{constructor(V,W,M,z,K,ie,fe,De){super(V,W,M,z,K,ie,fe,De),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const M=f.from(W,V);if(M===void 0)throw new Error("Task is not valid");if(p.is(M.execution))await this.y(M,W,!1);else throw new a.$_;const z=await this.z(await this.a.$getTaskExecution(M),W);return this.a.$executeTask(M).catch(K=>{throw new Error(K)}),z}v(V,W,M,z){const K=[];if(z)for(const ie of z){if(this.A(ie,M),!ie.definition||!V[ie.definition.type]){const De=ie.source?ie.source:"No task source";this.f.warn(`The task [${De}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const fe=f.from(ie,M.extension);fe&&p.is(fe.execution)?(K.push(fe),W.push(this.y(fe,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:M.extension}}async w(V){if(p.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,W,M){}};e.$9kc=C,e.$9kc=C=Je([qe(0,u.$LO),qe(1,w.$2O),qe(2,g.$Djc),qe(3,d.$WO),qe(4,E.$Gjc),qe(5,y.$5jc),qe(6,s.$Oj),qe(7,n.$ejc)],C),e.$0kc=(0,m.$ii)("IExtHostTask")}),define(Pe[289],Re([1,0,45,29]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=void 0,e.$6K=R,e.$8K=N;function R(A){return"cellResults"in A}e.$7K="rawCell#";function N(A,g){let d=-1;const E=[];let O=[];return A.forEach(u=>{u.range.startLineNumber!==d&&O.length>0&&(E.push([...O]),O=[]),O.push(u),d=u.range.endLineNumber}),O.length>0&&E.push([...O]),E.map(u=>{const w=[],m=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=m;o<=r;o++)w.push(g.getLineContent(o));return new I.$JK(w.join(`
`)+`
`,u.map(o=>new T.$ct(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Pe[290],Re([1,0,169,22,5,6,28,15,17,2,43,74,4,31,8,7,50,265,112,26,12,219,289,287]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,p,l,D,f,S){this.q=l,this.r=D,this.s=f,this.t=S,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new R.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.$cjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=b.getProxy(u.$qM.MainThreadNotebook),this.c=b.getProxy(u.$qM.MainThreadNotebookDocuments),this.d=b.getProxy(u.$qM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const P=k.notebookEditor?.notebookUri,C=k.cell.handle,V=this.g.get(P)?.getCell(C);if(V)return V.apiCell}if(k&&k.$mid===14){const P=k.uri,C=this.g.get(P);if(C)return C.apiNotebook}return k}}),c.B(p)}getEditorById(b){const p=this.h.get(b);if(!p)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(b){for(const[p,l]of this.h)if(l.apiEditor===b)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,p){const l=this.g.get(b);if(!l&&!p)throw new Error(`NO notebook document for '${b}'`);return l}static u(b,p){if(!p)return;const l=p.filenamePattern.map(D=>m.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(p.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:p.displayName,filenamePattern:l,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,p,l){const D=c.a++,f=typeof l.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,l),this.b.$registerNotebookCellStatusBarItemProvider(D,f,p);let S;return f!==void 0&&(S=l.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(f))),new r.$sM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,f),S?.dispose()})}async createNotebookDocument(b){const p=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&m.NotebookData.from(b.content)});return E.URI.revive(p)}async openNotebookDocument(b){const p=this.g.get(b);if(p)return p.apiNotebook;const l=await this.c.$tryOpenNotebook(b),D=this.g.get(E.URI.revive(l));return(0,d.$7f)(D?.apiNotebook)}async showNotebookDocument(b,p){E.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let l;typeof p=="object"?l={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(m.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:l={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,l),f=D&&this.h.get(D)?.apiEditor;if(f)return f;throw D?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,p,l,D){const f=this.f.get(b),S=E.URI.revive(p),k=this.g.get(S);if(!k||!f)return;const P=k.getCellFromIndex(l);if(!P)return;const C=await f.provideCellStatusBarItems(P.apiCell,D);if(!C)return;const q=new N.$Tc,V=this.p.add([q]),M=(Array.isArray(C)?C:[C]).map(z=>m.NotebookStatusBarItem.from(z,this.i,q));return{cacheId:V,items:M}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,p,l,D,f){if((0,g.$Ue)(p))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:p,serializer:l,options:D}),this.b.$registerNotebookSerializer(S,{id:b.identifier,location:b.extensionLocation},p,m.NotebookDocumentContentOptions.from(D),c.u(b,f)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(b,p,l){const D=this.x.get(b);if(!D)throw new Error("NO serializer found");const f=await D.serializer.deserializeNotebook(p.buffer,l);return new o.$ew(m.NotebookData.from(f))}async $notebookToData(b,p,l){const D=this.x.get(b);if(!D)throw new Error("NO serializer found");const f=await D.serializer.serializeNotebook(m.NotebookData.to(p.value),l);return T.$ue.wrap(f)}async $saveNotebook(b,p,l,D,f){const S=E.URI.revive(p),k=this.x.get(b);if(!k)throw new Error("NO serializer found");const P=this.g.get(S);if(!P)throw new Error("Document NOT found");if(P.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new O.$0k((0,I.localize)(0,null,this.z(S)),6);await this.y(S,D);const C={metadata:(0,i.$Wn)(P.apiNotebook.metadata,z=>!(k.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of P.apiNotebook.getCells()){const K=new r.$UN(z.kind,z.document.getText(),z.document.languageId,z.mime,k.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);K.metadata=(0,i.$Wn)(z.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),C.cells.push(K)}const q=await k.serializer.serializeNotebook(C,f);await this.s.value.writeFile(S,q);const V=this.s.getFileSystemProviderExtUri(S.scheme),W=await this.s.value.stat(S);return{name:V.basename(S),isFile:(W.type&O.FileType.File)!==0,isDirectory:(W.type&O.FileType.Directory)!==0,isSymbolicLink:(W.type&O.FileType.SymbolicLink)!==0,mtime:W.mtime,ctime:W.ctime,size:W.size,readonly:!!((W.permissions??0)&O.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((W.permissions??0)&O.FilePermission.Locked),etag:O.$il({mtime:W.mtime,size:W.size}),children:void 0}}async $searchInNotebooks(b,p,l,D,f){const S=this.x.get(b)?.serializer;if(!S)return{limitHit:!1,results:[]};const k=new A.$Cc;await(async(W,M,z)=>{await Promise.all(W.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const fe={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(fe,M,De=>{De.forEach(ye=>{k.has(ye)||D.some($e=>K.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(ne=>(0,v.$Mfb)(ne,ye)))||k.add(ye)})}).catch(De=>{if(De.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw De})}))))})(l,f,p);const C=new A.$Bc;let q=!1;const V=Array.from(k).map(async W=>{const M=[];try{if(f.isCancellationRequested)return;if(p.maxResults&&[...C.values()].reduce((fe,De)=>fe+De.cellResults.length,0)>p.maxResults){q=!0;return}const z=[],K=this.g.get(W);if(K)K.apiNotebook.getCells().forEach(De=>z.push({input:De.document.getText(),outputs:De.outputs.flatMap(ye=>ye.items.map(oe=>oe.data.toString()))}));else{const fe=await this.s.value.readFile(W),De=T.$ue.fromString(fe.toString()),ye=await S.deserializeNotebook(De.buffer,f);if(f.isCancellationRequested)return;m.NotebookData.from(ye).cells.forEach($e=>z.push({input:$e.source,outputs:$e.outputs.flatMap(ne=>ne.items.map(Se=>Se.valueBytes.toString()))}))}if(f.isCancellationRequested)return;z.forEach((fe,De)=>{const ye=p.contentPattern.pattern,oe=new h.$OUb(fe.input,void 0,fe.outputs),$e=oe.findInInputs(ye),ne=oe.findInOutputs(ye),Se=ne.flatMap(je=>(0,t.$8K)(je.matches,je.textBuffer)).map((je,re)=>(je.webviewIndex=re,je));if($e.length>0||ne.length>0){const je={index:De,contentResults:(0,t.$8K)($e,oe.inputTextBuffer),webviewResults:Se};M.push(je)}});const ie={resource:W,cellResults:M};C.set(W,ie);return}catch{return}});return await Promise.all(V),{limitHit:q,results:[...C.values()]}}async y(b,p){const l=await this.s.value.stat(b);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==O.$hl&&typeof l.mtime=="number"&&typeof l.size=="number"&&p.mtime<l.mtime&&p.etag!==O.$il({mtime:p.mtime,size:l.size}))throw new O.$0k((0,I.localize)(1,null),3,p)}z(b){return b.scheme===a.Schemas.file?b.fsPath:b.toString()}A(b,p,l){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const D=new n.$Akc(p,this.d,b,l.visibleRanges.map(m.NotebookRange.to),l.selections.map(m.NotebookRange.to),typeof l.viewColumn=="number"?m.ViewColumn.to(l.viewColumn):void 0);this.h.set(p,D)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const l of b.value.removedDocuments){const D=E.URI.revive(l),f=this.g.get(D);f&&(f.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(f.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===D.toString()&&this.h.delete(S.id)}if(b.value.addedDocuments){const l=[];for(const D of b.value.addedDocuments){const f=E.URI.revive(D.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const S=new s.$zkc(this.c,this.q,this.r,f,D);l.push(...D.cells.map(k=>s.$ykc.asModelAddData(k))),this.g.get(f)?.dispose(),this.g.set(f,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(S.apiNotebook)}}if(b.value.addedEditors)for(const l of b.value.addedEditors){if(this.h.has(l.id))return;const D=E.URI.revive(l.documentUri),f=this.g.get(D);f&&this.A(f,l.id,l)}const p=[];if(b.value.removedEditors)for(const l of b.value.removedEditors){const D=this.h.get(l);D&&(this.h.delete(l),this.k?.id===D.id&&(this.k=void 0),p.push(D))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const l=new Set;this.l.forEach(D=>l.add(D.id));for(const D of this.h.values()){const f=l.has(D.id);D._acceptVisibility(f)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(b){const p=w.$0O.String.with("notebookType","A notebook type"),l=new w.$_O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new w.$0O("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>T.$ue.wrap(f))],new w.$$O("Notebook Data",f=>m.NotebookData.to(f.value))),D=new w.$_O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new w.$0O("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$ew(m.NotebookData.from(f)))],new w.$$O("Bytes",f=>f.buffer));b.registerApiCommand(l),b.registerApiCommand(D)}}e.$Jkc=c}),define(Pe[291],Re([1,0,19,24,42,35,23,65,45]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0;class E{constructor(u,w,m){this.k=u,this.l=w,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&N.$ck(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&N.$ck(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const w=this.k.folderQueries||[];return new Promise((m,r)=>{const o=s=>{this.f++,u(s)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),i=I.$oc(n);this.j&&this.j(n,i)||this.v(o,{base:s,basename:i})}),Promise.all(w.map(s=>this.p(s,o))).then(s=>{m({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,R.$6i)(s)))})})}async p(u,w){const m=new T.$ee,r=this.q(u),o=this.r(),s=new d.$XK(this.k,u),n=!s.hasSiblingExcludeClauses();let i;try{this.h.add(m),i=g.$3d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,m.token),h=i.elapsed(),t=g.$3d.create();return this.g&&!this.e||(a&&a.forEach(v=>{const c=I.$hc.relative(u.folder.path,v.path);if(n){const $=I.$oc(v.path);this.v(w,{base:u.folder,relativePath:c,basename:$});return}this.s(o,u.folder,c,w)}),this.g&&!this.e)?null:(this.u(o,s,w),{providerTime:h,postProcessTime:t.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(u){const w=(0,d.$WK)(this.k.includePattern,u.includePattern),m=(0,d.$WK)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:m,includes:w,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},w,m,r){if(m===this.a){const s=I.$oc(this.a);this.v(r,{base:w,relativePath:this.a,basename:s})}function o(s){const n=I.$oc(s),i=I.$nc(s);let a=u[i];a||(a=u[i]=[],o(i)),a.push({base:w,relativePath:s,basename:n})}o(m)}u({rootEntries:u,pathToEntries:w},m,r){const o=this,s=this.a;function n(i){const a=(0,d.$ZK)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const v=i[h],{relativePath:c,basename:$}=v;if(m.matchesExcludesSync(c,$,s!==$?a:void 0))continue;const b=w[c];if(b)n(b);else{if(c===s)continue;o.v(r,v)}if(o.e)break}}n(u)}v(u,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(w))}}class O{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,w,m,r){const o=this.c(u.cacheKey),s=new E(u,w,o&&o.token);let n=0;const i=a=>{n+=a.length,m(a.map(h=>this.d(h)))};return this.e(s,O.a,i,r).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new T.$ee),this.b.get(u)}d(u){return u.relativePath?{resource:A.$Vg(u.base,u.relativePath)}:{resource:u.base}}e(u,w,m,r){const o=r.onCancellationRequested(()=>{u.cancel()}),s=i=>{i&&(n.push(i),w>0&&n.length>=w&&(m(n),n=[]))};let n=[];return u.search(s).then(i=>(n.length&&m(n),o.dispose(),i),i=>(n.length&&m(n),o.dispose(),Promise.reject(i)))}}e.$Bkc=O}),define(Pe[292],Re([1,0,18,260,35,96,28,12,19,23,15,17,2,95,186,47,13,48,107,288,45]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=void 0,e.$8L=D;let h=class{constructor(S,k,P,C,q){this.a=S,this.b=k,this.c=P,this.d=C,this.e=q}text(S,k,P={}){S=this.f(S,P);const C=this.a.getValue(),q=k&&k.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(k?.map(s.$Di),P),type:2,contentPattern:S,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:C.search.usePCRE2||q||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(S,k){const P=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const C={...S,wordSeparators:P.editor.wordSeparators};return this.j(S,k)&&(C.isCaseSensitive=!0),this.k(S)&&(C.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(C.notebookInfo||(C.notebookInfo={}),C.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),C}file(S,k={}){return{...this.h(S,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(S,k){return S?(S=Array.isArray(S)?S.map(b):b(S),k?this.parseSearchPaths(S):{pattern:v(...Array.isArray(S)?S:[S])}):{}}h(S=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),C=this.g(k.excludePattern,k.expandPatterns),q=S.length>1,V=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(z=>this.q(z,k,C)):S.map(z=>this.r(z,k,C,q))).filter(z=>!!z),W={_reason:k._reason,folderQueries:V,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:C.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const z=I.$Hb(I.$Rb(this.c.groups.map(fe=>fe.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const K=z.filter(fe=>(0,a.$NK)(W,fe.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...W,...ie}}const M=k.extraFileResources&&k.extraFileResources.filter(z=>(0,a.$NK)(W,z.fsPath));return W.extraFileResources=M&&M.length?M:void 0,W}i(S){const k=[],P=new A.$Bc,C={};let q=!1;return S.forEach(V=>{if(V.scheme===g.Schemas.walkThrough)return;if((0,E.$Zg)(V)){const M=this.b.getWorkspaceFolder(V)?.uri??V.with({path:d.$nc(V.fsPath)});let z=P.get(M);z||(q=!0,z={folder:M,includePattern:{}},k.push(z),P.set(M,z));const K=d.$mc(M.fsPath,V.fsPath);(0,y.$7f)(z.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(q=!0,C[V.fsPath]=!0)}),{folderQueries:k,includePattern:C,usingSearchPaths:!0,excludePattern:q?void 0:{"**/*":!0}}}j(S,k){if(k.isSmartCase){if(S.isRegExp){if(O.$Mf(S.pattern,!0))return!0}else if(O.$Mf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,w.$tC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const k=ie=>d.$jc(ie)||/^\.\.?([\/\\]|$)/.test(ie),C=(Array.isArray(S)?S:c(S)).map(ie=>{const fe=this.e.resolvedUserHome;return fe?(0,N.$jw)(ie,fe.scheme===g.Schemas.file?fe.fsPath:fe.path):ie}),q=T.$K(C,ie=>k(ie)?"searchPaths":"exprSegments"),V=(q.exprSegments||[]).map(ie=>O.$6e(ie,"/")).map(ie=>O.$6e(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),$(ie))),W={},M=this.m(q.searchPaths||[]);M&&M.length&&(W.searchPaths=M);const z=I.$Rb(V),K=v(...z);return K&&(W.pattern=K),W}l(S,k){return k.disregardExcludeSettings?void 0:(0,a.$MK)(S,!k.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const k=S.flatMap(C=>{let{pathPortion:q,globPortion:V}=t(C);return V&&(V=p(V)),this.n(q).flatMap(M=>this.o(M,V))}),P=new Map;return k.forEach(C=>{const q=C.searchPath.toString(),V=P.get(q);V?C.pattern&&(V.pattern=V.pattern||{},V.pattern[C.pattern]=!0):P.set(q,{searchPath:C.searchPath,pattern:C.pattern?v(C.pattern):void 0})}),Array.from(P.values())}n(S){if(d.$jc(S)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==g.Schemas.file?[{searchPath:k[0].uri.with({path:S})}]:[{searchPath:u.URI.file(d.$ic(S))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(S=b(S),S.startsWith("../")||S===".."){const C=d.$hc.resolve(k.path,S);return[{searchPath:k.with({path:C})}]}const P=p(S);return[{searchPath:k,pattern:P}]}else{if(S==="./"||S===".\\")return[];{const k=S.replace(/^\.[\/\\]/,""),C=this.b.getWorkspace().folders.map(q=>{const V=k.match(new RegExp(`^${O.$Ze(q.name)}(?:/(.*)|$)`));return V?{match:V,folder:q}:null}).filter(y.$4f);if(C.length)return C.map(q=>{const V=q.match[1];return{searchPath:q.folder.uri,pattern:V&&p(V)}});{const q=S.match(/\.[\/\\](.+)[\/\\]?/),V=q?q[1]:S,W=m.localize(0,null,V);throw new Error(W)}}}}o(S,k){const P=S.pattern&&k?`${S.pattern}/${k}`:S.pattern||k,C=[{searchPath:S.searchPath,pattern:P}];return P&&!P.endsWith("**")&&C.push({searchPath:S.searchPath,pattern:P+"/**"}),C}q(S,k,P){const C=this.r((0,s.$Di)(S.searchPath),k,P,!1);return C?{...C,includePattern:S.pattern}:null}r(S,k,P,C){let q;const V=u.URI.isUri(S)?S:S.uri;if(P.searchPaths){const ie=P.searchPaths.filter(fe=>(0,E.$Og)(fe.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(q=ie.pattern)}const W=this.a.getValue({resource:V}),z={...this.l(W,k)||{},...q||{}},K=u.URI.isUri(S)?(0,E.$Sg)(S):S.name;return{folder:V,folderName:C?K:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!W.search.followSymlinks}}};e.$7L=h,e.$7L=h=Je([qe(0,r.$Oi),qe(1,s.$ri),qe(2,n.$AD),qe(3,o.$Oj),qe(4,i.$5L)],h);function t(f){const S=f.match(/[\*\{\}\(\)\[\]\?]/);if(S){const k=S.index,P=f.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let C=f.substr(0,P.index);return C.match(/[/\\]/)||(C+="/"),{pathPortion:C,globPortion:f.substr((P.index||0)+1)}}}return{pathPortion:f}}function v(...f){return f.length?f.reduce((S,k)=>(S[k]=!0,S),Object.create(null)):void 0}function c(f){return R.$ak(f,",").map(S=>S.trim()).filter(S=>!!S.length)}function $(f){return[`**/${f}/**`,`**/${f}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function b(f){return f.replace(/\\/g,"/")}function p(f){return b(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(f){return f.replace(/([?*[\]])/g,"[$1]")}function D(f,S){f=I.$Mb(f,C=>C.toString());const k=[],P=S.getWorkspace();return f&&f.forEach(C=>{let q;if(S.getWorkbenchState()===2)q=(0,E.$Xg)(P.folders[0].uri,C),q&&q!=="."&&(q="./"+q);else{const V=S.getWorkspaceFolder(C);if(V){const W=V.name;if(P.folders.filter(z=>z.name===W).length===1){const z=(0,E.$Xg)(V.uri,C);z===""?q=`./${V.name}`:q=`./${V.name}/${z}`}else q=C.fsPath}}q&&k.push(l(q))}),k}}),define(Pe[293],Re([1,0,23,2,24,14,3,292,45,48,11]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ub=u,e.$2ub=r;const y=7e3;function u(o,s){const n=s.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],a=[];for(const b of n)if(/^workspaceContains:/.test(b)){const p=b.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||o.forceUsingSearch?a.push(p):i.push(p)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,O.$bh)(),v=b=>t({activationEvent:b}),c=Promise.all(i.map(b=>w(o,b,v))).then(()=>{}),$=m(o,s.identifier,a,v);return Promise.all([c,$]).then(()=>{t(void 0)}),h}async function w(o,s,n){for(const i of o.folders)if(await o.exists(I.$Vg(T.URI.revive(i),s))){n(`workspaceContains:${s}`);return}}async function m(o,s,n,i){if(n.length===0)return Promise.resolve(void 0);const a=new R.$ee,h=o.checkExists(o.folders,n,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},y);let v=!1;try{v=await h}catch(c){N.$4(c)||N.$1(c)}a.dispose(),clearTimeout(t),v&&i(`workspaceContains:${n.join(",")}`)}function r(o,s,n,i){const a=o.get(A.$hi),h=o.get(d.$EK),v=a.createInstance(g.$7L).file(s.map(c=>(0,E.$Di)(T.URI.revive(c))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(v,i).then(c=>!!c.limitHit,c=>N.$4(c)?!1:Promise.reject(c))}}),define(Pe[38],Re([1,0,165,19,89,23,11,6,52,2,13,4,37,225,82,36,25,108,14,20,22,207,7,102,3,27,85,16,71,86,51,88,5,293,81,209,12,79,65,21,80]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a,h,t,v,c,$,b,p,l,D,f,S,k,P,C,q,V,W,M,z,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=e.$gkc=e.$fkc=e.$ekc=e.$dkc=void 0,e.$dkc=(0,c.$ii)("IHostUtils");let fe=ie=class extends g.$Uc{constructor(L,_,ve,Oe,ke,pe,de,J,Y,ue,he,Ne,le){super(),this.Y=Ne,this.Z=le,this.a=this.B(new k.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=ve,this.f=de,this.j=Oe,this.m=ke,this.s=pe,this.t=Y,this.u=ue,this.w=he,this.y=this.g.getProxy(y.$qM.MainThreadWorkspace),this.z=this.g.getProxy(y.$qM.MainThreadTelemetry),this.C=this.g.getProxy(y.$qM.MainThreadExtensionService),this.D=new A.$hh,this.F=new A.$hh,this.G=new A.$hh,this.H=new A.$hh,this.I=new je(this.f.extensions.activationEvents),this.L=new s.$$0b(this.I,this.f.extensions.allExtensions);const Ie=new i.$Em(this.f.extensions.myExtensions);this.J=new s.$$0b(this.I,ne(this.L,Ie)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new m.$1jc(this.g,this.s),this.N=new C.$9jc(this.g),this.O=J,this.h=L.createChild(new l.$gi([m.$2jc,this.M],[C.$0jc,this.N])),this.P=this.B(new w.$Zjc(this.J,this.L,{onExtensionActivationError:(Ae,ze,U)=>{this.C.$onExtensionActivationError(Ae,n.$3(ze),U)},actualActivateExtension:async(Ae,ze)=>{if(s.$$0b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,ze),new w.$Yjc;const U=this.J.getExtensionDescription(Ae);return this.fb(U,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(L){n.$1(L)}}async $(){this.O.onWillDeactivateAll();let L=[];try{L=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(L)}terminate(L,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${L}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Oe=>{this.s.error(Oe)}),this.g.dispose();const ve=this.$();Promise.race([(0,A.$jh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(L){return this.G.isOpen()?this.P.isActivated(L):!1}async getExtension(L){const _=await this.C.$getExtension(L);return _&&{..._,identifier:new i.$Dm(_.identifier.value),extensionLocation:E.URI.revive(_.extensionLocation)}}ab(L,_){return this.P.activateByEvent(L,_)}bb(L,_){return this.P.activateById(L,_)}activateByIdWithErrors(L,_){return this.bb(L,_).then(()=>{const ve=this.P.getActivatedExtension(L);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(L=>this.J)}getExtensionExports(L){if(this.G.isOpen())return this.P.getActivatedExtension(L).exports;try{return this.P.getActivatedExtension(L).exports}catch{return null}}async cb(L){if(L.scheme===V.Schemas.file&&this.c.fsRealpath){const _=L.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const ve=await this.R.get(_);return E.URI.file(ve)}return L}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(L=>new Se(L))),this.Q}async db(L){const _=d.$oi.forUris(ve=>N.$Mg.ignorePathCasing(ve));return await Promise.all(L.map(async ve=>{if(this.wb(ve)){const Oe=await this.cb(ve.extensionLocation);_.set(Oe,ve)}})),_}eb(L){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(L))return _;const ve=this.P.getActivatedExtension(L);if(!ve)return _;try{typeof ve.module.deactivate=="function"&&(_=Promise.resolve(ve.module.deactivate()).then(void 0,Oe=>(this.s.error(Oe),Promise.resolve(void 0))))}catch(Oe){this.s.error(`An error occurred when deactivating the extension '${L.value}':`),this.s.error(Oe)}try{(0,g.$Pc)(ve.subscriptions)}catch(Oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${L.value}':`),this.s.error(Oe)}return _}async fb(L,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(L.identifier):await this.C.$onWillActivateExtension(L.identifier),this.hb(L,_).then(ve=>{const Oe=ve.activationTimes;return this.C.$onDidActivateExtension(L.identifier,Oe.codeLoadingTime,Oe.activateCallTime,Oe.activateResolvedTime,_),this.gb(L,_,"success",Oe),ve},ve=>{throw this.gb(L,_,"failure"),ve})}gb(L,_,ve,Oe){const ke=ye(L,_);this.z.$publicLog2("extensionActivationTimes",{...ke,...Oe||{},outcome:ve})}hb(L,_){const ve=ye(L,_);this.z.$publicLog2("activatePlugin",ve);const Oe=this.wb(L);if(!Oe)return Promise.resolve(new w.$Xjc(w.$Ujc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${L.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${L.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const ke=new w.$Vjc(_.startup);return Promise.all([this.xb(L,(0,N.$Vg)(L.extensionLocation,Oe),ke),this.ib(L)]).then(pe=>(R.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),ie.jb(this.s,L.identifier,pe[0],pe[1],ke))).then(pe=>(R.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),pe))}ib(L){const _=this.Z.createLanguageModelAccessInformation(L),ve=new h.$4jc(L,this.M),Oe=new h.$3jc(L.identifier.value,!1,this.M),ke=new q.$$jc(L,this.N),pe=L.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([ve.whenReady,Oe.whenReady,this.O.whenReady]).then(()=>{const J=this;let Y,ue;const he=(0,o.$bG)(L,"ipc")?this.f.messagePorts?.get(i.$Dm.toKey(L.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Oe,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Ne){return T.$kc(L.extensionLocation.fsPath,Ne)},get storagePath(){return J.O.workspaceValue(L)?.fsPath},get globalStoragePath(){return J.O.globalValue(L).fsPath},get logPath(){return T.$kc(J.f.logsLocation.fsPath,L.identifier.value)},get logUri(){return E.URI.joinPath(J.f.logsLocation,L.identifier.value)},get storageUri(){return J.O.workspaceValue(L)},get globalStorageUri(){return J.O.globalValue(L)},get extensionMode(){return pe},get extension(){return Y===void 0&&(Y=new $e(J,L.identifier,L,de,!1)),Y},get extensionRuntime(){return(0,o.$cG)(L,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(L)},get messagePassingProtocol(){if(!ue){if(!he)return;const Ne=k.Event.buffer(k.Event.fromDOMEventEmitter(he,"message",le=>le.data));he.start(),ue={onDidReceiveMessage:Ne,postMessage:he.postMessage.bind(he)}}return ue}})})}static jb(L,_,ve,Oe,ke){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(L,_,ve,Oe,ke).then(pe=>new w.$Wjc(!1,null,ke.build(),ve,pe,Oe.subscriptions))}static kb(L,_,ve,Oe,ke){if(typeof ve.activate=="function")try{ke.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${_.value}`);const pe=typeof global=="object"?global:self,de=ve.activate.apply(pe,[Oe]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(de).then(J=>(ke.activateResolveStop(),J))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(ve)}lb(L,_){this.bb(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:_}).then(void 0,ve=>{this.s.error(ve)})}mb(L,_=0){const Oe=Date.now();(0,z.$B)(()=>{for(let ke=_;ke<L.length;ke+=1){const pe=L[ke];for(const de of pe.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-Oe>50){this.mb(L,ke);break}else this.lb(pe,de)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(L=>{const _=L.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(_)this.mb(ve);else for(const Oe of ve)if(Oe.activationEvents)for(const ke of Oe.activationEvents)ke==="onStartupFinished"&&this.lb(Oe,ke)})}ob(){const L=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const _=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(_),Oe=this.rb(),ke=Promise.all([Oe,L,ve]).then(()=>{});return Promise.race([ke,(0,A.$jh)(1e4)]).then(()=>{this.nb()}),ke}pb(L){return L.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(L,_))).then(()=>{})}async qb(L,_){if(this.isActivated(_.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Oe={logService:this.s,folders:L.map(pe=>pe.uri),forceUsingSearch:ve||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,de,J)=>this.y.$checkExists(pe,de,J)},ke=await(0,P.$1ub)(Oe,_);if(ke)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:ke.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(L){throw console.error(L),L}}async sb(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:_}=this.f.environment;if(!L||!_)throw new Error(I.localize(0,null));const ve=await this.xb(null,_,new w.$Vjc(!1));if(!ve||typeof ve.run!="function")throw new Error(I.localize(1,null,_.toString()));return new Promise((Oe,ke)=>{const pe=(Y,ue)=>{Y?(z.$t&&this.s.error("Test runner called back with error",Y),ke(Y)):(z.$t&&(ue?this.s.info(`Test runner called back with ${ue} failures.`):this.s.info("Test runner called back with successful outcome.")),Oe(typeof ue=="number"&&ue>0?1:0))},de=(0,N.$Jg)(_),J=ve.run(de,pe);J&&J.then&&J.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),Oe(0)}).catch(Y=>{z.$t&&this.s.error("Test runner finished with error",Y),ke(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(L,_){return this.S[L]=_,(0,g.$Sc)(()=>{delete this.S[L]})}async getRemoteExecServer(L){const{resolver:_}=await this.ub(L);return _?.resolveExecServer?.(L,{resolveAttempt:0})}async ub(L){const _=L.indexOf("+");if(_===-1)throw new t.$yM("Not an authority that can be resolved!",v.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=L.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(L,_){const ve=M.$3d.create(!1),Oe=()=>`[resolveAuthority(${(0,v.$xl)(L)},${_})][${ve.elapsed()}ms] `,ke=j=>this.s.info(`${Oe()}${j}`),pe=j=>this.s.warn(`${Oe()}${j}`),de=(j,G=void 0)=>this.s.error(`${Oe()}${j}`,G),J=j=>{if(j instanceof t.$yM)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},Y=async j=>{ke(`activating resolver for ${j}...`);const{resolver:G,authorityPrefix:H}=await this.ub(j);if(!G)throw de(`no resolver for ${H}`),new t.$yM(`No remote extension installed to resolve ${H}.`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:j}},ue=L.split(/@|%40/g).reverse();ke(`activating remote resolvers ${ue.join(" -> ")}`);let he;try{he=await Promise.all(ue.map(Y)).catch(async j=>{if(!(j instanceof t.$yM)||j._code!==v.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return pe(`resolving nested authorities failed: ${j.message}`),[await Y(L)]})}catch(j){return J(j)}const Ne=new A.$th;Ne.cancelAndSet(()=>ke("waiting..."),1e3);let le,Ie;for(const[j,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of he.entries())try{if(j===he.length-1)ke("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),le=await H.resolve(ee,{resolveAttempt:_,execServer:Ie}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$xM.isManagedResolvedAuthority(le)?le:void 0));else{if(ke(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Ie=await H.resolveExecServer?.(ee,{resolveAttempt:_,execServer:Ie}),!Ie)throw new t.$yM(`Exec server was not available for ${ee}`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(se){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),de("returned an error",se),Ne.dispose(),J(se)}Ne.dispose();const Ae={environmentTunnels:le.environmentTunnels,features:le.tunnelFeatures?{elevation:le.tunnelFeatures.elevation,privacyOptions:le.tunnelFeatures.privacyOptions,protocol:le.tunnelFeatures.protocol===void 0?!0:le.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted,authenticationSession:le.authenticationSessionForInitializingExtensions?{id:le.authenticationSessionForInitializingExtensions.id,providerId:le.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${t.$xM.isManagedResolvedAuthority(le)?"managed authority":`${le.host}:${le.port}`}`);let U;if(t.$xM.isManagedResolvedAuthority(le)){const j=_;this.Y.setFactory(j,le.makeConnection),U={authority:L,connectTo:new v.$ul(j),connectionToken:le.connectionToken}}else U={authority:L,connectTo:new v.$vl(le.host,le.port),connectionToken:le.connectionToken};return{type:"ok",value:{authority:U,options:ze,tunnelInformation:Ae}}}async $getCanonicalURI(L,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,v.$xl)(L)})`);const{resolver:ve}=await this.ub(L);if(!ve)return null;const Oe=E.URI.revive(_);if(typeof ve.getCanonicalURI>"u")return Oe;const ke=await(0,A.$ah)(()=>ve.getCanonicalURI(Oe));return ke||Oe}async $startExtensionHost(L){L.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:_,myExtensions:ve}=De(this.I,this.L,this.J,L),Oe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(_.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(L,_){return _===1?this.D.wait().then(ve=>this.ab(L,!1)):this.G.wait().then(ve=>this.ab(L,!1))}async $activate(L,_){return await this.G.wait(),this.J.getExtensionDescription(L)?(await this.bb(L,_),!0):!1}async $deltaExtensions(L){L.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:_,myExtensions:ve}=De(this.I,this.L,this.J,L),Oe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(_.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){const _=a.$ue.alloc(L),ve=Math.random()%256;for(let Oe=0;Oe<L;Oe++)_.writeUInt8(ve,Oe);return _}async $updateRemoteConnectionData(L){this.X=L,this.a.fire()}};e.$ekc=fe,e.$ekc=fe=ie=Je([qe(0,c.$hi),qe(1,e.$dkc),qe(2,p.$LO),qe(3,r.$Djc),qe(4,u.$Gjc),qe(5,O.$Oj),qe(6,$.$2O),qe(7,b.$Jjc),qe(8,D.$8Bb),qe(9,f.$5jc),qe(10,W.$akc),qe(11,K.$bkc),qe(12,S.$tjc)],fe);function De(re,L,_,ve){re.addActivationEvents(ve.addActivationEvents);const Oe=new s.$$0b(re,L.getAllExtensionDescriptions());Oe.deltaExtensions(ve.toAdd,ve.toRemove);const ke=new i.$Em(_.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ve.myToRemove)ke.delete(de);for(const de of ve.myToAdd)ke.add(de);const pe=ne(Oe,ke);return{globalRegistry:Oe,myExtensions:pe}}function ye(re,L){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}function oe(re){return re.getAllExtensionDescriptions().map(L=>L.identifier.value).join(",")}e.$fkc=(0,c.$ii)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(L,_,ve,Oe,ke){this.#e=L,this.#t=_,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=T.$ic((0,N.$Jg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Oe,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$gkc=$e;function ne(re,L){return re.getAllExtensionDescriptions().filter(_=>L.has(_.identifier))}class Se{constructor(L){this.a=L}setSearchTree(L){this.a=L}findSubstr(L){return this.a.findSubstr(L)}forEach(L){return this.a.forEach(L)}}e.$hkc=Se;class je{constructor(L){this.a=new i.$Fm,this.addActivationEvents(L)}readActivationEvents(L){return this.a.get(L.identifier)??[]}addActivationEvents(L){for(const _ of Object.keys(L))this.a.set(_,L[_])}}}),define(Pe[294],Re([1,0,89,2,4,37,25,20,16,27,3,38,13,15]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;let r=class{constructor(a,h,t,v,c,$,b){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.h=$,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$rlc=r,e.$rlc=r=Je([qe(2,O.$hi),qe(3,N.$Gjc),qe(4,y.$fkc),qe(5,E.$2O),qe(6,u.$Oj)],r);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&m.a.size){const h=(0,w.$Ze)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",v=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${v})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,t,v,c]=h,$=m.a.get(v);if($!==void 0)return console.warn(`${v} as been renamed to ${$}, please update your imports`),t+$+c}c(a){return a.replace(/\\/g,"/")}};o=m=Je([qe(0,E.$2O)],o);class s{constructor(a,h,t,v,c){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.nodeModuleName="vscode",this.a=new g.$Fm}load(a,h){const t=this.d.findSubstr(h);if(t){let v=this.a.get(t.identifier);return v||(v=this.c(t,this.e,this.f),this.a.set(t.identifier,v)),v}if(!this.b){let v="";this.d.forEach((c,$)=>v+=`	${$} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${v}`),this.b=this.c(A.$9F,this.e,this.f)}return this.b}}let n=class{constructor(a,h,t){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$qM.MainThreadTelemetry);const v=t.getProxy(R.$qM.MainThreadWindow);this.c=(c,$)=>{const b=T.URI.parse(c);return $?this.g(c,$):b.scheme==="http"||b.scheme==="https"?v.$openUri(b,c,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?v.$openUri(b,c,{}):this.g(c,$)}}load(a,h,t){const v=this.e.findSubstr(h);return v&&(this.a=v.identifier.value,this.h()),this.b=t(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,d.$LO)],n)}),define(Pe[120],Re([1,0,40,6,19,73,3,67,66,38,7,36,222,37]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=void 0,e.$ikc=(0,A.$ii)("IExtHostVariableResolverProvider");class m extends u.$NP{constructor(s,n,i,a,h,t,v){function c(){if(i){const $=i.activeEditor();if($)return $.document.uri;const b=a.tabGroups.all.find(p=>p.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof O.$cO||b.input instanceof O.$hO)return b.input.modified;if(b.input instanceof O.$bO||b.input instanceof O.$gO||b.input instanceof O.$eO)return b.input.uri}}}super({getFolderUri:$=>{const b=t.folders.filter(p=>p.name===$);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:($,b)=>h.getConfiguration(void 0,$).get(b),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=c();if($)return R.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const $=c();if($){const b=n.getWorkspaceFolder($);if(b)return R.$ic(b.uri.fsPath)}}},getSelectedText:()=>{if(i){const $=i.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(i){const $=i.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>s.getExtension($)},void 0,v?Promise.resolve(v):void 0,Promise.resolve(N.env))}}let r=class extends T.$Uc{constructor(s,n,i,a,h){super(),this.b=s,this.c=n,this.g=i,this.h=a,this.j=h,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$jkc=r,e.$jkc=r=Je([qe(0,E.$fkc),qe(1,y.$Djc),qe(2,g.$WO),qe(3,w.$Gjc),qe(4,d.$Sjc)],r)}),define(Pe[121],Re([1,0,11,5,2,20,3,4,66,38,16,7,36,214,216,37,120,6,41,31,8]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=e.$nkc=e.$mkc=e.$lkc=e.$kkc=void 0,e.$kkc=(0,A.$ii)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,D,f,S,k,P,C){this.N=D,this.O=f,this.P=S,this.Q=k,this.R=P,this.S=C,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new T.$7d,this.o=new T.$7d,this.q=new T.$7d,this.w=new T.$7d,this.l=l.getProxy(g.$qM.MainThreadDebugService),this.A=new T.$7d,this.C=new T.$7d,this.y=new v(this.l),this.z=new Map,this.O.getExtensionRegistry().then(q=>{q.onDidChange(V=>{this.V(q)}),this.V(q)})}async $getVisualizerTreeItem(l,D){const f=this.W(D);if(!f)return;const S=await this.H.get(l)?.getTreeItem?.(f);return S?this.U(l,S):void 0}registerDebugVisualizationTree(l,D,f){const S=N.$Dm.toKey(l.identifier),k=this.jb(S,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(k,f),this.l.$registerDebugVisualizerTree(k,!!f.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(D)})}async $getVisualizerTreeItemChildren(l,D){const f=this.J.get(D)?.item;return f?(await this.H.get(l)?.getChildren?.(f))?.map(k=>this.U(l,k))||[]:[]}async $editVisualizerTreeItem(l,D){const f=this.J.get(l);if(!f)return;const S=await this.H.get(f.provider)?.editItem?.(f.item,D);return this.U(f.provider,S||f.item)}$disposeVisualizedTree(l){const D=this.J.get(l);if(!D)return;const f=[D.children];for(const S of f)if(S)for(const k of S)f.push(this.J.get(k)?.children),this.J.delete(k)}U(l,D){let f=this.I.get(D);return f||(f=this.F++,this.I.set(D,f),this.J.set(f,{provider:l,item:D})),a.DebugTreeItem.from(D,f)}asDebugSourceUri(l,D){const f=l;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let S=`debug:${encodeURIComponent(f.path||"")}`,k="?";return D&&(S+=`${k}session=${encodeURIComponent(D.id)}`,k="&"),S+=`${k}ref=${f.sourceReference}`,R.URI.parse(S)}else{if(f.path)return R.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const D=[];for(const f of l.getAllExtensionDescriptions())if(f.contributes){const S=f.contributes.debuggers;if(S&&S.length>0)for(const k of S)(0,m.$OG)(k)&&D.push(k.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(D=>l.push(D)),l}async $resolveDebugVisualizer(l,D){const f=this.L.get(l);if(!f)throw new Error(`No debug visualizer found with id '${l}'`);let{v:S,provider:k,extensionId:P}=f;if(S.visualization||(S=await k.resolveDebugVisualization?.(S,D)||S,f.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(P,S.visualization)}async $executeDebugVisualizerCommand(l){const D=this.L.get(l);if(!D)throw new Error(`No debug visualizer found with id '${l}'`);const f=D.v.visualization;f&&"command"in f&&this.S.executeCommand(f.command,...f.arguments||[])}W(l){const D=this.m.get(l.sessionId);return D&&{session:D.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,D,f,S){const k=this.W(f),P=this.jb(l,D),C=this.G.get(P);if(!k||!C)return[];const q=await C.provideDebugVisualization(k,S);return q?q.map(V=>{const W=++this.M;this.L.set(W,{v:V,provider:C,extensionId:l});const M=V.iconPath?this.lb(V.iconPath):void 0;return{id:W,name:V.name,iconClass:M?.iconClass,iconPath:M?.iconPath,visualization:this.kb(l,V.visualization)}}):[]}$disposeDebugVisualizers(l){for(const D of l)this.L.delete(D)}registerDebugVisualizationProvider(l,D,f){if(!l.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=N.$Dm.toKey(l.identifier),k=this.jb(S,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(k,f),this.l.$registerDebugVisualizer(S,D),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,D),this.G.delete(D)})}addBreakpoints(l){const D=l.filter(k=>{const P=k.id;return this.z.has(P)?!1:(this.z.set(P,k),!0)});this.gb(D,[],[]);const f=[],S=new Map;for(const k of D)if(k instanceof y.$tN){let P=S.get(k.location.uri.toString());P||(P={type:"sourceMulti",uri:k.location.uri,lines:[]},S.set(k.location.uri.toString(),P),f.push(P)),P.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof y.$uN&&f.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(f)}removeBreakpoints(l){const D=l.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const f=D.filter(P=>P instanceof y.$tN).map(P=>P.id),S=D.filter(P=>P instanceof y.$uN).map(P=>P.id),k=D.filter(P=>P instanceof y.$vN).map(P=>P.id);return this.l.$unregisterBreakpoints(f,S,k)}startDebugging(l,D,f){return this.l.$startDebugging(l?l.uri:void 0,D,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,D,f){if(!D)return new y.$sM(()=>{});const S=this.d++;return this.f.push({type:l,handle:S,provider:D}),this.l.$registerDebugConfigurationProvider(l,f,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new y.$sM(()=>{this.f=this.f.filter(k=>k.provider!==D),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,D,f){if(!f)return new y.$sM(()=>{});if(!this.cb(l,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:D,handle:S,factory:f}),this.l.$registerDebugAdapterDescriptorFactory(D,S),new y.$sM(()=>{this.h=this.h.filter(k=>k.factory!==f),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,D){if(!D)return new y.$sM(()=>{});const f=this.j++;return this.k.push({type:l,handle:f,factory:D}),new y.$sM(()=>{this.k=this.k.filter(S=>S.factory!==D)})}async $runInTerminal(l,D){return Promise.resolve(void 0)}async $substituteVariables(l,D){let f;const S=await this.ib(l);return S&&(f={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(f,D)}X(l,D){if(l.type==="implementation")return new $(l.implementation)}Y(){}async $startDASession(l,D){const f=this,S=await this.hb(D);return this.eb(this.$(S.type),S).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const P=this.Z(k),C=this.X(P,S);if(!C)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const q=C;return this.D.set(l,q),this.db(S).then(V=>(V&&this.E.set(l,V),q.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const M=W,z={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(M.arguments.value);z.body={signature:K},q.sendResponse(z)}else throw new Error("no signer")}catch(K){z.success=!1,z.message=K.message,q.sendResponse(z)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(W),W=(0,m.$TG)(W,!0),f.l.$acceptDAMessage(l,W)}),q.onError(W=>{V&&V.onError&&V.onError(W),this.l.$acceptDAError(l,W.name,W.message,W.stack)}),q.onExit(W=>{V&&V.onExit&&V.onExit(W??void 0,void 0),this.l.$acceptDAExit(l,W??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),q.startSession()))})}$sendDAMessage(l,D){D=(0,m.$SG)(D,!1);const f=this.E.get(l);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(D),this.D.get(l)?.sendMessage(D)}$stopDASession(l){const D=this.E.get(l);this.E.delete(l),D&&D.onWillStopSession&&D.onWillStopSession();const f=this.D.get(l);return this.D.delete(l),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const D=[],f=[],S=[];if(l.added)for(const k of l.added){const P=k.id;if(P&&!this.z.has(P)){let C;if(k.type==="function")C=new y.$uN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")C=new y.$vN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const q=R.URI.revive(k.uri);C=new y.$tN(new y.$EM(q,new y.$tM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,y.$rN)(C,P),this.z.set(P,C),D.push(C)}}if(l.removed)for(const k of l.removed){const P=this.z.get(k);P&&(this.z.delete(k),f.push(P))}if(l.changed){for(const k of l.changed)if(k.id){const P=this.z.get(k.id);if(P){if(P instanceof y.$uN&&k.type==="function"){const C=P;C.enabled=k.enabled,C.condition=k.condition,C.hitCondition=k.hitCondition,C.logMessage=k.logMessage,C.functionName=k.functionName}else if(P instanceof y.$tN&&k.type==="source"){const C=P;C.enabled=k.enabled,C.condition=k.condition,C.hitCondition=k.hitCondition,C.logMessage=k.logMessage,C.location=new y.$EM(R.URI.revive(k.uri),new y.$tM(k.line,k.character))}S.push(P)}}}this.gb(D,f,S)}async $acceptStackFrameFocus(l){let D;if(l){const f=await this.hb(l.sessionId);l.kind==="thread"?D=new y.$BN(f.api,l.threadId):D=new y.$AN(f.api,l.threadId,l.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(l,D,f){return(0,I.$ah)(async()=>{const S=this.bb(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(D);return S.provideDebugConfigurations(k,f)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,D,f,S){return(0,I.$ah)(async()=>{const k=this.bb(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return k.resolveDebugConfiguration(P,f,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,D,f,S){return(0,I.$ah)(async()=>{const k=this.bb(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return k.resolveDebugConfigurationWithSubstitutedVariables(P,f,S)})}async $provideDebugAdapter(l,D){const f=this.ab(l);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(D);return this.eb(f,S).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(l){const D=await this.hb(l);this.n.fire(D.api)}async $acceptDebugSessionTerminated(l){const D=await this.hb(l);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,D){(await this.hb(l))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(l,D){const S={session:(await this.hb(l)).api,event:D.event,body:D.body};this.w.fire(S)}Z(l){if(l instanceof y.$wN)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof y.$xN)return{type:"server",port:l.port,host:l.host};if(l instanceof y.$yN)return{type:"pipeServer",path:l.path};if(l instanceof y.$zN)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const D=this.h.filter(f=>f.type===l);if(D.length>0)return D[0].factory}ab(l){const D=this.h.filter(f=>f.handle===l);if(D.length>0)return D[0].factory}bb(l){const D=this.f.filter(f=>f.handle===l);if(D.length>0)return D[0].provider}cb(l,D){if(l.contributes){const f=l.contributes.debuggers;if(f&&f.length>0){for(const S of f)if(S.label&&S.type&&S.type===D)return!0}}return!1}db(l){const f=l.configuration.type,S=this.k.filter(k=>k.type===f||k.type==="*").map(k=>(0,I.$ah)(()=>k.factory.createDebugAdapterTracker(l.api)).then(P=>P,P=>null));return Promise.race([Promise.all(S).then(k=>{const P=k.filter(C=>!!C);if(P.length>0)return new c(P)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(l,D){const f=D.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new y.$xN(f));if(l){const k=await this.O.getExtensionRegistry();return(0,I.$ah)(()=>l.createDebugAdapterDescriptor(D.api,this.fb(D,k))).then(P=>{if(P)return P})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,S))}fb(l,D){}gb(l,D,f){(l.length>0||D.length>0||f.length>0)&&this.A.fire(Object.freeze({added:l,removed:D,changed:f}))}async hb(l){if(l)if(typeof l=="string"){const D=this.m.get(l);if(D)return D}else{let D=this.m.get(l.id);if(!D){const f=await this.ib(l.folderUri),S=l.parent?this.m.get(l.parent):void 0;D=new t(this.l,l.id,l.type,l.name,f,l.configuration,S?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(l){if(l){const D=R.URI.revive(l);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(l,D){return`${l}\0${D}`}kb(l,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${l}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const D=this.mb(l);let f,S;return"id"in D?S=n.ThemeIcon.asClassName(D):f=D,{iconPath:f,iconClass:S}}mb(l){if(l instanceof y.$oN)return{id:l.id};const D=typeof l=="object"&&"dark"in l?l.dark:l,f=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof f=="string"?R.URI.file(f):f}}};e.$lkc=h,e.$lkc=h=Je([qe(0,O.$LO),qe(1,u.$Djc),qe(2,E.$fkc),qe(3,r.$Gjc),qe(4,d.$Sjc),qe(5,o.$ikc),qe(6,i.$8O)],h);class t{constructor(l,D,f,S,k,P,C){this.f=l,this.g=D,this.h=f,this.j=S,this.k=k,this.l=P,this.m=C}get api(){const l=this;return this.d??=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(D){l.j=D,l.f.$setDebugSessionName(l.g,D)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(D,f){return l.f.$customDebugAdapterRequest(l.g,D,f)},getDebugProtocolBreakpoint(D){return l.f.$getDebugProtocolBreakpoint(l.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$mkc=t;class v{constructor(l){this.value=Object.freeze({append(D){l.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$nkc=v;class c{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(D=>D.onError?D.onError(l):void 0)}onExit(l,D){this.d.forEach(f=>f.onExit?f.onExit(l,D):void 0)}}class $ extends w.$6nb{constructor(l){super(),this.h=l,l.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends h{constructor(l,D,f,S,k,P,C){super(l,D,f,S,k,P,C)}};e.$okc=b,e.$okc=b=Je([qe(0,O.$LO),qe(1,u.$Djc),qe(2,E.$fkc),qe(3,r.$Gjc),qe(4,d.$Sjc),qe(5,o.$ikc),qe(6,i.$8O)],b)}),define(Pe[295],Re([1,0,14,89,2,4,243,13,55,71,27,191,16,60,38,62]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(g.$Oj),t=i.get(u.$LO).getProxy(N.$qM.MainThreadErrors);I.setUnexpectedErrorHandler(v=>{a.error(v);const c=I.$3(v);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(g.$Oj),h=i.get(u.$LO),t=i.get(m.$fkc),v=i.get(r.$6O),c=h.getProxy(N.$qM.MainThreadExtensionService),$=h.getProxy(N.$qM.MainThreadErrors),b=await t.getExtensionPathIndex(),p=new WeakMap;function l(S,k){if(p.has(S))return p.get(S).stack;let P="",C,q;for(const W of k)P+=`
	at ${W.toString()}`,q=W.getFileName(),!C&&q&&(C=b.findSubstr(R.URI.file(q)));const V=`${S.name||"Error"}: ${S.message||""}${P}`;return p.set(S,{extensionIdentifier:C?.identifier,stack:V}),V}const D=Symbol("prepareStackTrace wrapped");let f=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(S){if(S===l||!S||S[D]){f=S||l;return}f=function(k,P){return l(k,P),S.call(Error,k,P)},Object.assign(f,{[D]:!0})}}),I.setUnexpectedErrorHandler(S=>{a.error(S);const k=I.$3(S),P=p.get(S);if(!P?.extensionIdentifier){$.$onUnexpectedError(k);return}c.$onExtensionRuntimeError(P.extensionIdentifier,k);const C=v.onExtensionError(P.extensionIdentifier,S);a.trace("forwarded error to extension?",C,P)})}}e.$slc=o;class s{constructor(i,a,h,t,v){this.a=h,this.b=new A.$g$b(i,null,t),a=s.e(a,this.b);const c=new E.$gi(...(0,d.$hs)());c.set(O.$2O,{_serviceBrand:void 0,...a,messagePorts:v}),c.set(u.$LO,new u.$MO(this.b)),c.set(w.$Ajc,new w.$Bjc(t)),c.set(m.$dkc,h);const $=new y.$Yq(c,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(b=>b.get(g.$Oj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=$.invokeFunction(b=>b.get(m.$fkc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(N.$qM.MainThreadExtensionService);return R.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=R.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>R.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=R.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=R.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$tlc=s}),define(Pe[296],Re([1,0,18,11,24,42,12,19,23,2,45]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=e.$Dkc=e.$Ckc=void 0,e.$Ekc=r;class y{constructor(n,i,a){this.d=n,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const a=this.g.folderQueries||[],h=new R.$ee(i);return new Promise((t,v)=>{this.a=new w(n);let c=!1;const $=(b,p)=>{if(!c&&!this.b){const l=this.h(b);r(b)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,c=!0,h.cancel(),b=this.j(b,this.g.maxResults-this.c));const D=this.h(b);this.c+=D,(D>0||!r(b))&&this.a.add(b,p)}};Promise.all(a.map((b,p)=>this.k(b,l=>$(l,p),h.token))).then(b=>{h.dispose(),this.a.flush();const p=b.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||p,messages:(0,I.$Rb)(b.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},b=>{h.dispose();const p=(0,N.$6i)(b);v(new Error(p))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,i),preview:{matches:h.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,a){const h=new O.$XK(this.g,n),t=[],v={report:b=>{if(!this.l(b))return;const p=n.folder.scheme===A.Schemas.file?(0,O.$YK)(()=>this.e.readdir(d.$Ug(b.uri))):void 0,l=d.$Xg(n.folder,b.uri);if(l){const D=h.includedInQuery(l,g.$oc(l),p);(0,T.$7g)(D)?t.push(D.then(f=>{f&&i(b)})):D&&i(b)}}},c=this.n(n);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,v,a):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),c,v,a),t.length&&await Promise.all(t),$}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,O.$WK)(this.g.includePattern,n.includePattern),a=(0,O.$WK)(this.g.excludePattern,n.excludePattern),h={folder:E.URI.from(n.folder),excludes:a,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$Ckc=y;function u(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!d.$Og(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(m(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Dkc=w;function m(s){return r(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Fkc=o}),define(Pe[122],Re([1,0,6,4,3,291,16,60,13,2,296]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=e.$Gkc=void 0,e.$Ikc=u,e.$Gkc=(0,R.$ii)("IExtHostSearch");let y=class{constructor(r,o,s){this.n=r,this.o=o,this.q=s,this.c=this.n.getProxy(T.$qM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$Bkc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,n){const i=u(s),a=this.j.get(r);if(a)return this.l.fileSearch(i,a,h=>{this.c.$handleFileMatch(r,o,h.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,n){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const a=u(s);return this.t(a,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$provideAITextSearchResults(r,o,s,n){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const a=u(s);return this.v(a,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$enableExtensionHostSearch(){}t(r,o){return new O.$Ckc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,o){return new O.$Ckc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$Hkc=y,e.$Hkc=y=Je([qe(0,A.$LO),qe(1,g.$Ajc),qe(2,d.$Oj)],y);function u(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(w),extraFileResources:m.extraFileResources&&m.extraFileResources.map(r=>E.URI.revive(r))}}function w(m){return{...m,folder:E.URI.revive(m.folder)}}}),define(Pe[297],Re([1,0,24,14,5,6,12,32,2,151,147,135,94,20,43,13,58,59,204,4,246,275,78,84,252,231,253,88,254,232,220,31,255,37,256,121,110,257,234,247,258,259,67,66,248,38,261,64,262,44,27,276,277,249,235,263,264,79,80,237,290,266,208,267,278,268,116,238,269,270,271,16,272,122,81,273,239,274,82,85,119,62,51,279,280,250,281,282,86,8,7,240,60,241,63,283,284,109,36,215,77,25,118,114]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a,h,t,v,c,$,b,p,l,D,f,S,k,P,C,q,V,W,M,z,K,ie,fe,De,ye,oe,$e,ne,Se,je,re,L,_,ve,Oe,ke,pe,de,J,Y,ue,he,Ne,le,Ie,Ae,ze,U,j,G,H,ee,se,Te,Ve,Qe,xe,et,ot,it,nt,at,ft,Ue,st,Z,X,me,We,Ze,Me,ht,Pt,Bt,_t,Qt,ei,St,Xt,Wt,ci,Ye,ti,ii){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=Ht;function Ht(lt){const vt=lt.get(re.$2O),ai=lt.get(je.$ijc),Gt=lt.get(ne.$Ijc),Vt=lt.get(oe.$fkc),gt=lt.get(Xt.$Djc),It=lt.get(at.$6O),ui=lt.get(P.$Gjc),Zt=lt.get(Pt.$Ajc),He=lt.get(ee.$LO),Tt=lt.get(ot.$2jc),qt=lt.get(it.$Jjc),ni=lt.get(r.$Pj),$t=lt.get(r.$Oj),Ot=lt.get(We.$8Bb),Rt=lt.get(t.$ejc),Nt=lt.get(St.$klc),li=lt.get(Ve.$0jc),Ft=lt.get(De.$Sjc),Lt=lt.get(J.$bkc),Et=lt.get(v.$ojc),At=lt.get(p.$tjc);He.set(i.$rM.ExtHostFileSystemInfo,ai),He.set(i.$rM.ExtHostLogLevelServiceShape,ni),He.set(i.$rM.ExtHostWorkspace,gt),He.set(i.$rM.ExtHostConfiguration,ui),He.set(i.$rM.ExtHostExtensionService,Vt),He.set(i.$rM.ExtHostStorage,Tt),He.set(i.$rM.ExtHostTunnelService,Ot),He.set(i.$rM.ExtHostWindow,Nt),He.set(i.$rM.ExtHostSecretState,li),He.set(i.$rM.ExtHostTelemetry,It),He.set(i.$rM.ExtHostEditorTabs,Ft),He.set(i.$rM.ExtHostManagedSockets,Lt),He.set(i.$rM.ExtHostAuthentication,Et),He.set(i.$rM.ExtHostChatProvider,At);const ri=He.set(i.$rM.ExtHostDecorations,lt.get(V.$qkc)),jt=He.set(i.$rM.ExtHostDocumentsAndEditors,lt.get(fe.$WO)),wt=He.set(i.$rM.ExtHostCommands,lt.get(S.$8O)),Ct=He.set(i.$rM.ExtHostTerminalService,lt.get(ft.$5jc)),fi=He.set(i.$rM.ExtHostTerminalShellIntegration,lt.get(ii.$llc)),Dt=He.set(i.$rM.ExtHostDebugService,lt.get(q.$kkc)),si=He.set(i.$rM.ExtHostSearch,lt.get(Te.$Gkc)),Yt=He.set(i.$rM.ExtHostTask,lt.get(nt.$0kc)),oi=He.set(i.$rM.ExtHostOutputService,lt.get(ze.$Wkc)),gi=He.set(i.$rM.ExtHostLocalization,lt.get(de.$akc)),we=He.set(i.$rM.ExtHostUrls,new Bt.$hlc(He)),Ce=He.set(i.$rM.ExtHostDocuments,new ie.$ljc(He,jt)),ce=He.set(i.$rM.ExtHostDocumentContentProviders,new z.$skc(He,jt,$t)),Q=He.set(i.$rM.ExtHostDocumentSaveParticipant,new K.$tkc($t,Ce,He.getProxy(i.$qM.MainThreadBulkEdits))),be=He.set(i.$rM.ExtHostNotebook,new ue.$Jkc(He,wt,jt,Ce,Gt,si)),Be=He.set(i.$rM.ExtHostNotebookDocuments,new Ne.$Qkc(be)),Xe=He.set(i.$rM.ExtHostNotebookEditors,new le.$Rkc($t,be)),Ge=He.set(i.$rM.ExtHostNotebookKernels,new Ie.$Skc(He,vt,be,wt,$t)),ct=He.set(i.$rM.ExtHostNotebookRenderers,new Ae.$Ukc(He,be)),yt=He.set(i.$rM.ExtHostNotebookDocumentSaveParticipant,new he.$Pkc($t,be,He.getProxy(i.$qM.MainThreadBulkEdits))),kt=He.set(i.$rM.ExtHostEditors,new st.$xjc(He,jt)),xt=He.set(i.$rM.ExtHostTreeViews,new me.$flc(He.getProxy(i.$qM.MainThreadTreeViews),wt,$t)),zt=He.set(i.$rM.ExtHostEditorInsets,new f.$yjc(He.getProxy(i.$qM.MainThreadEditorInsets),kt,vt.remote)),Kt=He.set(i.$rM.ExtHostDiagnostics,new W.$kjc(He,$t,ai,jt)),wi=He.set(i.$rM.ExtHostLanguages,new pe.$Nkc(He,Ce,wt.converter,Zt)),dt=He.set(i.$rM.ExtHostLanguageFeatures,new ke.$mjc(He,Zt,Ce,wt,Kt,$t,Rt,It)),Ti=He.set(i.$rM.ExtHostFileSystem,new $e.$vkc(He,dt)),mi=He.set(i.$rM.ExtHostFileSystemEventService,new Se.$wkc(He,$t,jt)),vi=He.set(i.$rM.ExtHostQuickOpen,(0,H.$1kc)(He,gt,wt)),Si=He.set(i.$rM.ExtHostSCM,new se.$3kc(He,wt,Ce,$t)),Qi=He.set(i.$rM.ExtHostQuickDiff,new G.$Zkc(He,Zt)),gn=He.set(i.$rM.ExtHostShare,new Qe.$4kc(He,Zt)),Xi=He.set(i.$rM.ExtHostComments,(0,k.$zjc)(He,wt,Ce)),Ii=He.set(i.$rM.ExtHostProgress,new j.$Ykc(He.getProxy(i.$qM.MainThreadProgress))),Ni=He.set(i.$rM.ExtHostLabelService,new Oe.$Mkc(He)),Fi=He.set(i.$rM.ExtHostTheming,new Z.$clc(He)),Zi=He.set(i.$rM.ExtHostTimeline,new X.$elc(He,wt)),Ci=He.set(i.$rM.ExtHostWebviews,new _t.$Njc(He,vt.remote,gt,$t,Rt)),Pi=He.set(i.$rM.ExtHostWebviewPanels,new Qt.$Qjc(He,Ci,gt)),Yi=He.set(i.$rM.ExtHostCustomEditors,new C.$Rjc(He,Ce,qt,Ci,Pi)),xi=He.set(i.$rM.ExtHostWebviewViews,new ei.$ilc(He,Ci)),yi=He.set(i.$rM.ExtHostTesting,new Ue.$$kc(He,$t,wt,jt)),mn=He.set(i.$rM.ExtHostUriOpeners,new ht.$glc(He)),Li=He.set(i.$rM.ExtHostProfileContentHandlers,new U.$Xkc(He));He.set(i.$rM.ExtHostInteractive,new _.$Kkc(He,be,jt,wt,$t));const ji=He.set(i.$rM.ExtHostInlineChat,new L.$xkc(He,wt,Ce,$t)),_i=He.set(i.$rM.ExtHostChatAgents2,new b.$sjc(He,$t,wt)),$n=He.set(i.$rM.ExtHostChatVariables,new l.$vjc(He)),zi=He.set(i.$rM.ExtHostChat,new $.$rjc(He)),en=He.set(i.$rM.ExtHostAiRelatedInformation,new a.$djc(He)),Ui=He.set(i.$rM.ExtHostAiEmbeddingVector,new ye.$ukc(He)),Bi=He.set(i.$rM.ExtHostIssueReporter,new ve.$Lkc(He)),Vi=He.set(i.$rM.ExtHostStatusBar,new et.$7kc(He,wt.converter)),tn=He.set(i.$rM.ExtHostSpeech,new xe.$5kc(He)),pn=Object.values(i.$rM);He.assertRegistered(pn);const qi=new c.$qjc(He,jt),nn=new D.$wjc(He),hi=new Y.$Okc(He,$t),ki=new M.$rkc(He);return h.$njc.register(wt),function(Le,Ut,Ei){function tt(x){return(ae,Fe,rt)=>{const bt=x(Mt=>{try{ae.call(Fe,Mt)}catch(Ai){T.$2(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),It.onExtensionError(Le.identifier,Ai)}});return rt?.push(bt),bt}}const pt=function(){let x=!Le.isUnderDevelopment;function ae(){x||($t.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),x=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")ae();else{const bt=rt;typeof bt.scheme>"u"&&ae(),typeof bt.exclusive=="boolean"&&(0,Ye.$cG)(Le,"documentFiltersExclusive")}return rt}}(),rn={getSession(x,ae,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ye.$cG)(Le,"authLearnMore"),Et.getSession(Le,x,ae,Fe)},getSessions(x,ae){return(0,Ye.$cG)(Le,"authGetSessions"),Et.getSessions(Le,x,ae)},async hasSession(x,ae){return(0,Ye.$cG)(Le,"authSession"),!!await Et.getSession(Le,x,ae,{silent:!0})},get onDidChangeSessions(){return tt(Et.onDidChangeSessions)},registerAuthenticationProvider(x,ae,Fe,rt){return Et.registerAuthenticationProvider(x,ae,Fe,rt)}},sn={registerCommand(x,ae,Fe){return wt.registerCommand(!0,x,ae,Fe,void 0,Le)},registerTextEditorCommand(x,ae,Fe){return wt.registerCommand(!0,x,(...rt)=>{const bt=kt.getActiveTextEditor();if(!bt){$t.warn("Cannot execute "+x+" because there is no active text editor.");return}return bt.edit(Mt=>{ae.apply(Fe,[bt,Mt,...rt])}).then(Mt=>{Mt||$t.warn("Edits from command "+x+" were not applied.")},Mt=>{$t.warn("An error occurred while running command "+x,Mt)})},void 0,void 0,Le)},registerDiffInformationCommand:(x,ae,Fe)=>((0,Ye.$cG)(Le,"diffCommand"),wt.registerCommand(!0,x,async(...rt)=>{const bt=jt.activeEditor(!0);if(!bt){$t.warn("Cannot execute "+x+" because there is no active text editor.");return}const Mt=await kt.getDiffInformation(bt.id);ae.apply(Fe,[Mt,...rt])},void 0,void 0,Le)),executeCommand(x,...ae){return wt.executeCommand(x,...ae)},getCommands(x=!1){return wt.getCommands(x)}},on={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return tt(Ct.onDidChangeShell)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return tt(It.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$cG)(Le,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$cG)(Le,"telemetry"),tt(It.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$5O)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(x,ae){return at.$4O.validateSender(x),It.instantiateLogger(Le,x,ae)},openExternal(x,ae){return Nt.openUri(x,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(x){if(x.scheme===vt.environment.appUriScheme)return we.createAppUri(x);try{return await Nt.asExternalUri(x,{allowTunneling:!!vt.remote.authority})}catch(ae){if((0,A.$rg)(x,A.Schemas.http)||(0,A.$rg)(x,A.Schemas.https))return x;throw ae}},get remoteName(){return(0,o.$um)(vt.remote.authority)},get remoteAuthority(){return(0,Ye.$cG)(Le,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return tt($t.onDidChangeLogLevel)},registerIssueUriRequestHandler(x){return(0,Ye.$cG)(Le,"handleIssueUri"),Bi.registerIssueUriRequestHandler(Le,x)},registerIssueDataProvider(x){return(0,Ye.$cG)(Le,"handleIssueUri"),Bi.registerIssueDataProvider(Le,x)},get appQuality(){return(0,Ye.$cG)(Le,"resolvers"),vt.quality},get appCommit(){return(0,Ye.$cG)(Le,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(on);const an={createTestController(x,ae,Fe){return yi.createTestController(Le,x,ae,Fe)},createTestObserver(){return(0,Ye.$cG)(Le,"testObserver"),yi.createTestObserver()},runTests(x){return(0,Ye.$cG)(Le,"testObserver"),yi.runTests(x)},get onDidChangeTestResults(){return(0,Ye.$cG)(Le,"testObserver"),tt(yi.onResultsChanged)},get testResults(){return(0,Ye.$cG)(Le,"testObserver"),yi.results}},Di=vt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,vn={getExtension(x,ae){(0,Ye.$bG)(Le,"extensionsAny")||(ae=!1);const Fe=Ut.mine.getExtensionDescription(x);if(Fe)return new oe.$gkc(Vt,Le.identifier,Fe,Di,!1);if(ae){const rt=Ut.all.getExtensionDescription(x);if(rt)return new oe.$gkc(Vt,Le.identifier,rt,Di,!0)}},get all(){const x=[];for(const ae of Ut.mine.getAllExtensionDescriptions())x.push(new oe.$gkc(Vt,Le.identifier,ae,Di,!1));return x},get allAcrossExtensionHosts(){(0,Ye.$cG)(Le,"extensionsAny");const x=new w.$Em(Ut.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ae=[];for(const Fe of Ut.all.getAllExtensionDescriptions()){const rt=!x.has(Fe.identifier);ae.push(new oe.$gkc(Vt,Le.identifier,Fe,Di,rt))}return ae},get onDidChange(){return(0,Ye.$bG)(Le,"extensionsAny")?tt(R.Event.any(Ut.mine.onDidChange,Ut.all.onDidChange)):tt(Ut.mine.onDidChange)}},bn={createDiagnosticCollection(x){return Kt.createDiagnosticCollection(Le.identifier,x)},get onDidChangeDiagnostics(){return tt(Kt.onDidChangeDiagnostics)},getDiagnostics:x=>Kt.getDiagnostics(x),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage(x,ae){return wi.changeLanguage(x.uri,ae)},match(x,ae){const Fe=Ze.LanguageSelector.from(x);let rt;return(0,O.$Wt)(Fe)&&(rt=be.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(Mt=>Mt.document===ae))?.apiNotebook),(0,O.$Vt)(Fe,ae.uri,ae.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(x,ae,Fe){return dt.registerCodeActionProvider(Le,pt(x),ae,Fe)},registerDocumentPasteEditProvider(x,ae,Fe){return(0,Ye.$cG)(Le,"documentPaste"),dt.registerDocumentPasteEditProvider(Le,pt(x),ae,Fe)},registerCodeLensProvider(x,ae){return dt.registerCodeLensProvider(Le,pt(x),ae)},registerDefinitionProvider(x,ae){return dt.registerDefinitionProvider(Le,pt(x),ae)},registerDeclarationProvider(x,ae){return dt.registerDeclarationProvider(Le,pt(x),ae)},registerImplementationProvider(x,ae){return dt.registerImplementationProvider(Le,pt(x),ae)},registerTypeDefinitionProvider(x,ae){return dt.registerTypeDefinitionProvider(Le,pt(x),ae)},registerHoverProvider(x,ae){return dt.registerHoverProvider(Le,pt(x),ae,Le.identifier)},registerEvaluatableExpressionProvider(x,ae){return dt.registerEvaluatableExpressionProvider(Le,pt(x),ae,Le.identifier)},registerInlineValuesProvider(x,ae){return dt.registerInlineValuesProvider(Le,pt(x),ae,Le.identifier)},registerDocumentHighlightProvider(x,ae){return dt.registerDocumentHighlightProvider(Le,pt(x),ae)},registerMultiDocumentHighlightProvider(x,ae){return dt.registerMultiDocumentHighlightProvider(Le,pt(x),ae)},registerLinkedEditingRangeProvider(x,ae){return dt.registerLinkedEditingRangeProvider(Le,pt(x),ae)},registerReferenceProvider(x,ae){return dt.registerReferenceProvider(Le,pt(x),ae)},registerRenameProvider(x,ae){return dt.registerRenameProvider(Le,pt(x),ae)},registerNewSymbolNamesProvider(x,ae){return(0,Ye.$cG)(Le,"newSymbolNamesProvider"),dt.registerNewSymbolNamesProvider(Le,pt(x),ae)},registerDocumentSymbolProvider(x,ae,Fe){return dt.registerDocumentSymbolProvider(Le,pt(x),ae,Fe)},registerWorkspaceSymbolProvider(x){return dt.registerWorkspaceSymbolProvider(Le,x)},registerDocumentFormattingEditProvider(x,ae){return dt.registerDocumentFormattingEditProvider(Le,pt(x),ae)},registerDocumentRangeFormattingEditProvider(x,ae){return dt.registerDocumentRangeFormattingEditProvider(Le,pt(x),ae)},registerOnTypeFormattingEditProvider(x,ae,Fe,...rt){return dt.registerOnTypeFormattingEditProvider(Le,pt(x),ae,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(x,ae,Fe){return dt.registerDocumentSemanticTokensProvider(Le,pt(x),ae,Fe)},registerDocumentRangeSemanticTokensProvider(x,ae,Fe){return dt.registerDocumentRangeSemanticTokensProvider(Le,pt(x),ae,Fe)},registerSignatureHelpProvider(x,ae,Fe,...rt){return typeof Fe=="object"?dt.registerSignatureHelpProvider(Le,pt(x),ae,Fe):dt.registerSignatureHelpProvider(Le,pt(x),ae,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(x,ae,...Fe){return dt.registerCompletionItemProvider(Le,pt(x),ae,Fe)},registerInlineCompletionItemProvider(x,ae,Fe){return ae.handleDidShowCompletionItem&&(0,Ye.$cG)(Le,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$cG)(Le,"inlineCompletionsAdditions"),Fe&&(0,Ye.$cG)(Le,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Le,pt(x),ae,Fe)},registerInlineEditProvider(x,ae){return(0,Ye.$cG)(Le,"inlineEdit"),dt.registerInlineEditProvider(Le,pt(x),ae)},registerDocumentLinkProvider(x,ae){return dt.registerDocumentLinkProvider(Le,pt(x),ae)},registerColorProvider(x,ae){return dt.registerColorProvider(Le,pt(x),ae)},registerFoldingRangeProvider(x,ae){return dt.registerFoldingRangeProvider(Le,pt(x),ae)},registerSelectionRangeProvider(x,ae){return dt.registerSelectionRangeProvider(Le,x,ae)},registerCallHierarchyProvider(x,ae){return dt.registerCallHierarchyProvider(Le,x,ae)},registerTypeHierarchyProvider(x,ae){return dt.registerTypeHierarchyProvider(Le,x,ae)},setLanguageConfiguration:(x,ae)=>dt.setLanguageConfiguration(Le,x,ae),getTokenInformationAtPosition(x,ae){return(0,Ye.$cG)(Le,"tokenInformation"),wi.tokenAtPosition(x,ae)},registerInlayHintsProvider(x,ae){return dt.registerInlayHintsProvider(Le,x,ae)},createLanguageStatusItem(x,ae){return wi.createLanguageStatusItem(Le,x,ae)},registerDocumentDropEditProvider(x,ae,Fe){return dt.registerDocumentOnDropEditProvider(Le,x,ae,(0,Ye.$bG)(Le,"dropMetadata")?Fe:void 0)}},cn={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(x,ae,Fe){d.URI.isUri(x)&&x.scheme===A.Schemas.vscodeRemote&&!x.authority&&Rt.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(d.URI.isUri(x)?Promise.resolve(Ri.openTextDocument(x)):Promise.resolve(x));return kt.showTextDocument(rt,ae,Fe)},createTextEditorDecorationType(x){return kt.createTextEditorDecorationType(Le,x)},onDidChangeActiveTextEditor(x,ae,Fe){return tt(kt.onDidChangeActiveTextEditor)(x,ae,Fe)},onDidChangeVisibleTextEditors(x,ae,Fe){return tt(kt.onDidChangeVisibleTextEditors)(x,ae,Fe)},onDidChangeTextEditorSelection(x,ae,Fe){return tt(kt.onDidChangeTextEditorSelection)(x,ae,Fe)},onDidChangeTextEditorOptions(x,ae,Fe){return tt(kt.onDidChangeTextEditorOptions)(x,ae,Fe)},onDidChangeTextEditorVisibleRanges(x,ae,Fe){return tt(kt.onDidChangeTextEditorVisibleRanges)(x,ae,Fe)},onDidChangeTextEditorViewColumn(x,ae,Fe){return tt(kt.onDidChangeTextEditorViewColumn)(x,ae,Fe)},onDidCloseTerminal(x,ae,Fe){return tt(Ct.onDidCloseTerminal)(x,ae,Fe)},onDidOpenTerminal(x,ae,Fe){return tt(Ct.onDidOpenTerminal)(x,ae,Fe)},onDidChangeActiveTerminal(x,ae,Fe){return tt(Ct.onDidChangeActiveTerminal)(x,ae,Fe)},onDidChangeTerminalDimensions(x,ae,Fe){return(0,Ye.$cG)(Le,"terminalDimensions"),tt(Ct.onDidChangeTerminalDimensions)(x,ae,Fe)},onDidChangeTerminalState(x,ae,Fe){return tt(Ct.onDidChangeTerminalState)(x,ae,Fe)},onDidWriteTerminalData(x,ae,Fe){return(0,Ye.$cG)(Le,"terminalDataWriteEvent"),tt(Ct.onDidWriteTerminalData)(x,ae,Fe)},onDidExecuteTerminalCommand(x,ae,Fe){return(0,Ye.$cG)(Le,"terminalExecuteCommandEvent"),tt(Ct.onDidExecuteTerminalCommand)(x,ae,Fe)},onDidChangeTerminalShellIntegration(x,ae,Fe){return(0,Ye.$cG)(Le,"terminalShellIntegration"),tt(fi.onDidChangeTerminalShellIntegration)(x,ae,Fe)},onDidStartTerminalShellExecution(x,ae,Fe){return(0,Ye.$cG)(Le,"terminalShellIntegration"),tt(fi.onDidStartTerminalShellExecution)(x,ae,Fe)},onDidEndTerminalShellExecution(x,ae,Fe){return(0,Ye.$cG)(Le,"terminalShellIntegration"),tt(fi.onDidEndTerminalShellExecution)(x,ae,Fe)},get state(){return Nt.getState(Le)},onDidChangeWindowState(x,ae,Fe){return tt(Nt.onDidChangeWindowState)(x,ae,Fe)},showInformationMessage(x,...ae){return hi.showMessage(Le,g.default.Info,x,ae[0],ae.slice(1))},showWarningMessage(x,...ae){return hi.showMessage(Le,g.default.Warning,x,ae[0],ae.slice(1))},showErrorMessage(x,...ae){return hi.showMessage(Le,g.default.Error,x,ae[0],ae.slice(1))},showQuickPick(x,ae,Fe){return vi.showQuickPick(Le,x,ae,Fe)},showWorkspaceFolderPick(x){return vi.showWorkspaceFolderPick(x)},showInputBox(x,ae){return vi.showInput(x,ae)},showOpenDialog(x){return ki.showOpenDialog(Le,x)},showSaveDialog(x){return ki.showSaveDialog(x)},createStatusBarItem(x,ae,Fe){let rt,bt,Mt;return typeof x=="string"?(rt=x,bt=ae,Mt=Fe):(bt=x,Mt=ae),Vi.createStatusBarEntry(Le,rt,bt,Mt)},setStatusBarMessage(x,ae){return Vi.setStatusBarMessage(x,ae)},withScmProgress(x){return Rt.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ii.withProgress(Le,{location:Me.ProgressLocation.SourceControl},(ae,Fe)=>x({report(rt){}}))},withProgress(x,ae){return Ii.withProgress(Le,x,ae)},createOutputChannel(x,ae){return oi.createOutputChannel(x,ae,Le)},createWebviewPanel(x,ae,Fe,rt){return Pi.createWebviewPanel(Le,x,ae,Fe,rt)},createWebviewTextEditorInset(x,ae,Fe,rt){return(0,Ye.$cG)(Le,"editorInsets"),zt.createWebviewEditorInset(x,ae,Fe,rt,Le)},createTerminal(x,ae,Fe){return typeof x=="object"?"pty"in x?Ct.createExtensionTerminal(x):Ct.createTerminalFromOptions(x):Ct.createTerminal(x,ae,Fe)},registerTerminalLinkProvider(x){return Ct.registerLinkProvider(x)},registerTerminalProfileProvider(x,ae){return Ct.registerProfileProvider(Le,x,ae)},registerTerminalQuickFixProvider(x,ae){return(0,Ye.$cG)(Le,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(x,Le.identifier.value,ae)},registerTreeDataProvider(x,ae){return xt.registerTreeDataProvider(x,ae,Le)},createTreeView(x,ae){return xt.createTreeView(x,ae,Le)},registerWebviewPanelSerializer:(x,ae)=>Pi.registerWebviewPanelSerializer(Le,x,ae),registerCustomEditorProvider:(x,ae,Fe={})=>Yi.registerCustomEditorProvider(Le,x,ae,Fe),registerFileDecorationProvider(x){return ri.registerFileDecorationProvider(x,Le)},registerUriHandler(x){return we.registerUriHandler(Le,x)},createQuickPick(){return vi.createQuickPick(Le)},createInputBox(){return vi.createInputBox(Le)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(x,ae,Fe){return tt(Fi.onDidChangeActiveColorTheme)(x,ae,Fe)},registerWebviewViewProvider(x,ae,Fe){return xi.registerWebviewViewProvider(Le,x,ae,Fe?.webviewOptions)},get activeNotebookEditor(){return be.activeNotebookEditor},onDidChangeActiveNotebookEditor(x,ae,Fe){return tt(be.onDidChangeActiveNotebookEditor)(x,ae,Fe)},get visibleNotebookEditors(){return be.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return tt(be.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(x,ae,Fe){return tt(Xe.onDidChangeNotebookEditorSelection)(x,ae,Fe)},onDidChangeNotebookEditorVisibleRanges(x,ae,Fe){return tt(Xe.onDidChangeNotebookEditorVisibleRanges)(x,ae,Fe)},showNotebookDocument(x,ae){return be.showNotebookDocument(x,ae)},registerExternalUriOpener(x,ae,Fe){return(0,Ye.$cG)(Le,"externalUriOpener"),mn.registerExternalUriOpener(Le.identifier,x,ae,Fe)},registerProfileContentHandler(x,ae){return(0,Ye.$cG)(Le,"profileContentHandlers"),Li.registerProfileContentHandler(Le,x,ae)},registerQuickDiffProvider(x,ae,Fe,rt){return(0,Ye.$cG)(Le,"quickDiffProvider"),Qi.registerQuickDiffProvider(pt(x),ae,Fe,rt)},get tabGroups(){return Ft.tabGroups},registerShareProvider(x,ae){return(0,Ye.$cG)(Le,"shareProvider"),gn.registerShareProvider(pt(x),ae)}},Ri={get rootPath(){return Rt.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(x){throw new T.$9("rootPath")},getWorkspaceFolder(x){return gt.getWorkspaceFolder(x)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(x){throw new T.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(x){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(x,ae,...Fe)=>gt.updateWorkspaceFolders(Le,x,ae||0,...Fe),onDidChangeWorkspaceFolders:function(x,ae,Fe){return tt(gt.onDidChangeWorkspace)(x,ae,Fe)},asRelativePath:(x,ae)=>gt.getRelativePath(x,ae),findFiles:(x,ae,Fe,rt)=>gt.findFiles(x,ae,Fe,Le.identifier,rt),findFiles2:(x,ae,Fe)=>((0,Ye.$cG)(Le,"findFiles2"),gt.findFiles2(x,ae,Le.identifier,Fe)),findTextInFiles:(x,ae,Fe,rt)=>{(0,Ye.$cG)(Le,"findTextInFiles");let bt,Mt;return typeof ae=="object"?(bt=ae,Mt=Fe):(bt={},Mt=ae,rt=Fe),gt.findTextInFiles(x,bt||{},Mt,Le.identifier,rt)},save:x=>gt.save(x),saveAs:x=>gt.saveAs(x),saveAll:x=>gt.saveAll(x),applyEdit(x,ae){return qi.applyWorkspaceEdit(x,Le,ae)},createFileSystemWatcher:(x,ae,Fe,rt)=>{let bt;return typeof ae=="boolean"?bt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:ae&&((0,Ye.$cG)(Le,"createFileSystemWatcher"),bt={...ae,correlate:!0}),mi.createFileSystemWatcher(gt,Le,x,bt)},get textDocuments(){return Ce.getAllDocumentData().map(x=>x.document)},set textDocuments(x){throw new T.$9("textDocuments")},openTextDocument(x){let ae;const Fe=x;if(typeof x=="string")ae=Promise.resolve(d.URI.file(x));else if(d.URI.isUri(x))ae=Promise.resolve(x);else if(!Fe||typeof Fe=="object")ae=Ce.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(rt=>(rt.scheme===A.Schemas.vscodeRemote&&!rt.authority&&Rt.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Ce.ensureDocumentData(rt).then(bt=>bt.document)))},onDidOpenTextDocument:(x,ae,Fe)=>tt(Ce.onDidAddDocument)(x,ae,Fe),onDidCloseTextDocument:(x,ae,Fe)=>tt(Ce.onDidRemoveDocument)(x,ae,Fe),onDidChangeTextDocument:(x,ae,Fe)=>tt(Ce.onDidChangeDocument)(x,ae,Fe),onDidSaveTextDocument:(x,ae,Fe)=>tt(Ce.onDidSaveDocument)(x,ae,Fe),onWillSaveTextDocument:(x,ae,Fe)=>tt(Q.getOnWillSaveTextDocumentEvent(Le))(x,ae,Fe),get notebookDocuments(){return be.notebookDocuments.map(x=>x.apiNotebook)},async openNotebookDocument(x,ae){let Fe;if(d.URI.isUri(x))Fe=x,await be.openNotebookDocument(x);else if(typeof x=="string")Fe=d.URI.revive(await be.createNotebookDocument({viewType:x,content:ae}));else throw new Error("Invalid arguments");return be.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(x,ae,Fe){return tt(Be.onDidSaveNotebookDocument)(x,ae,Fe)},onDidChangeNotebookDocument(x,ae,Fe){return tt(Be.onDidChangeNotebookDocument)(x,ae,Fe)},onWillSaveNotebookDocument(x,ae,Fe){return tt(yt.getOnWillSaveNotebookDocumentEvent(Le))(x,ae,Fe)},get onDidOpenNotebookDocument(){return tt(be.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return tt(be.onDidCloseNotebookDocument)},registerNotebookSerializer(x,ae,Fe,rt){return be.registerNotebookSerializer(Le,x,ae,Fe,(0,Ye.$bG)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(x,ae,Fe)=>tt(Ei.onDidChangeConfiguration)(x,ae,Fe),getConfiguration(x,ae){return ae=arguments.length===1?void 0:ae,Ei.getConfiguration(x,ae,Le)},registerTextDocumentContentProvider(x,ae){return ce.registerTextDocumentContentProvider(x,ae)},registerTaskProvider:(x,ae)=>(Rt.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(Le,x,ae)),registerFileSystemProvider(x,ae,Fe){return(0,N.$Rc)(Ti.registerFileSystemProvider(Le,x,ae,Fe),Gt.addFileSystemProvider(x,ae,Fe))},get fs(){return Gt.value},registerFileSearchProvider:(x,ae)=>((0,Ye.$cG)(Le,"fileSearchProvider"),si.registerFileSearchProvider(x,ae)),registerTextSearchProvider:(x,ae)=>((0,Ye.$cG)(Le,"textSearchProvider"),si.registerTextSearchProvider(x,ae)),registerAITextSearchProvider:(x,ae)=>((0,Ye.$cG)(Le,"aiTextSearchProvider"),(0,Ye.$cG)(Le,"textSearchProvider"),si.registerAITextSearchProvider(x,ae)),registerRemoteAuthorityResolver:(x,ae)=>((0,Ye.$cG)(Le,"resolvers"),Vt.registerRemoteAuthorityResolver(x,ae)),registerResourceLabelFormatter:x=>((0,Ye.$cG)(Le,"resolvers"),Ni.$registerResourceLabelFormatter(x)),getRemoteExecServer:x=>((0,Ye.$cG)(Le,"resolvers"),Vt.getRemoteExecServer(x)),onDidCreateFiles:(x,ae,Fe)=>tt(mi.onDidCreateFile)(x,ae,Fe),onDidDeleteFiles:(x,ae,Fe)=>tt(mi.onDidDeleteFile)(x,ae,Fe),onDidRenameFiles:(x,ae,Fe)=>tt(mi.onDidRenameFile)(x,ae,Fe),onWillCreateFiles:(x,ae,Fe)=>tt(mi.getOnWillCreateFileEvent(Le))(x,ae,Fe),onWillDeleteFiles:(x,ae,Fe)=>tt(mi.getOnWillDeleteFileEvent(Le))(x,ae,Fe),onWillRenameFiles:(x,ae,Fe)=>tt(mi.getOnWillRenameFileEvent(Le))(x,ae,Fe),openTunnel:x=>((0,Ye.$cG)(Le,"tunnels"),Ot.openTunnel(Le,x).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Ye.$cG)(Le,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(x,ae,Fe)=>((0,Ye.$cG)(Le,"tunnels"),tt(Ot.onDidChangeTunnels)(x,ae,Fe)),registerPortAttributesProvider:(x,ae)=>((0,Ye.$cG)(Le,"portsAttributes"),Ot.registerPortsAttributesProvider(x,ae)),registerTunnelProvider:(x,ae)=>((0,Ye.$cG)(Le,"tunnelFactory"),Ot.registerTunnelProvider(x,ae)),registerTimelineProvider:(x,ae)=>((0,Ye.$cG)(Le,"timeline"),Zi.registerTimelineProvider(x,ae,Le.identifier,wt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:x=>((0,Ye.$cG)(Le,"workspaceTrust"),gt.requestWorkspaceTrust(x)),onDidGrantWorkspaceTrust:(x,ae,Fe)=>tt(gt.onDidGrantWorkspaceTrust)(x,ae,Fe),registerEditSessionIdentityProvider:(x,ae)=>((0,Ye.$cG)(Le,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(x,ae)),onWillCreateEditSessionIdentity:(x,ae,Fe)=>((0,Ye.$cG)(Le,"editSessionIdentityProvider"),tt(gt.getOnWillCreateEditSessionIdentityEvent(Le))(x,ae,Fe)),registerCanonicalUriProvider:(x,ae)=>((0,Ye.$cG)(Le,"canonicalUriProvider"),gt.registerCanonicalUriProvider(x,ae)),getCanonicalUri:(x,ae,Fe)=>((0,Ye.$cG)(Le,"canonicalUriProvider"),gt.provideCanonicalUri(x,ae,Fe))},un={get inputBox(){return Rt.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Le)},createSourceControl(x,ae,Fe){return Si.createSourceControl(Le,x,ae,Fe)}},ln={createCommentController(x,ae){return Xi.createCommentController(Le,x,ae)}},hn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,Ye.$bG)(Le,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(x,ae){return(0,Ye.$cG)(Le,"debugVisualization"),Dt.registerDebugVisualizationProvider(Le,x,ae)},registerDebugVisualizationTreeProvider(x,ae){return(0,Ye.$cG)(Le,"debugVisualization"),Dt.registerDebugVisualizationTree(Le,x,ae)},onDidStartDebugSession(x,ae,Fe){return tt(Dt.onDidStartDebugSession)(x,ae,Fe)},onDidTerminateDebugSession(x,ae,Fe){return tt(Dt.onDidTerminateDebugSession)(x,ae,Fe)},onDidChangeActiveDebugSession(x,ae,Fe){return tt(Dt.onDidChangeActiveDebugSession)(x,ae,Fe)},onDidReceiveDebugSessionCustomEvent(x,ae,Fe){return tt(Dt.onDidReceiveDebugSessionCustomEvent)(x,ae,Fe)},onDidChangeBreakpoints(x,ae,Fe){return tt(Dt.onDidChangeBreakpoints)(x,ae,Fe)},onDidChangeActiveStackItem(x,ae,Fe){return(0,Ye.$cG)(Le,"debugFocus"),tt(Dt.onDidChangeActiveStackItem)(x,ae,Fe)},registerDebugConfigurationProvider(x,ae,Fe){return Dt.registerDebugConfigurationProvider(x,ae,Fe||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(x,ae){return Dt.registerDebugAdapterDescriptorFactory(Le,x,ae)},registerDebugAdapterTrackerFactory(x,ae){return Dt.registerDebugAdapterTrackerFactory(x,ae)},startDebugging(x,ae,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?Dt.startDebugging(x,ae,{parentSession:Fe}):Dt.startDebugging(x,ae,Fe||{})},stopDebugging(x){return Dt.stopDebugging(x)},addBreakpoints(x){return Dt.addBreakpoints(x)},removeBreakpoints(x){return Dt.removeBreakpoints(x)},asDebugSourceUri(x,ae){return Dt.asDebugSourceUri(x,ae)}},wn={registerTaskProvider:(x,ae)=>Yt.registerTaskProvider(Le,x,ae),fetchTasks:x=>Yt.fetchTasks(x),executeTask:x=>Yt.executeTask(Le,x),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(x,ae,Fe)=>tt(Yt.onDidStartTask)(x,ae,Fe),onDidEndTask:(x,ae,Fe)=>tt(Yt.onDidEndTask)(x,ae,Fe),onDidStartTaskProcess:(x,ae,Fe)=>tt(Yt.onDidStartTaskProcess)(x,ae,Fe),onDidEndTaskProcess:(x,ae,Fe)=>tt(Yt.onDidEndTaskProcess)(x,ae,Fe)},yn={createNotebookController(x,ae,Fe,rt,bt){return Ge.createNotebookController(Le,x,ae,Fe,rt,(0,Ye.$bG)(Le,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(x,ae)=>be.registerNotebookCellStatusBarItemProvider(Le,x,ae),createRendererMessaging(x){return ct.createRendererMessaging(Le,x)},createNotebookControllerDetectionTask(x){return(0,Ye.$cG)(Le,"notebookKernelSource"),Ge.createNotebookControllerDetectionTask(Le,x)},registerKernelSourceActionProvider(x,ae){return(0,Ye.$cG)(Le,"notebookKernelSource"),Ge.registerKernelSourceActionProvider(Le,x,ae)},onDidChangeNotebookCellExecutionState(x,ae,Fe){return(0,Ye.$cG)(Le,"notebookCellExecutionState"),tt(Ge.onDidChangeNotebookCellExecutionState)(x,ae,Fe)}},dn={t(...x){if(typeof x[0]=="string"){const ae=x.shift(),Fe=!x||typeof x[0]!="object"?x:x[0];return gi.getMessage(Le.identifier.value,{message:ae,args:Fe})}return gi.getMessage(Le.identifier.value,x[0])},get bundle(){return gi.getBundle(Le.identifier.value)},get uri(){return gi.getBundleUri(Le.identifier.value)}},fn={_version:1,registerInteractiveEditorSessionProvider(x,ae){return(0,Ye.$cG)(Le,"interactive"),ji.registerProvider(Le,x,ae)},registerInteractiveSessionProvider(x,ae){return(0,Ye.$cG)(Le,"interactive"),zi.registerChatProvider(Le,x,ae)},transferChatSession(x,ae){return(0,Ye.$cG)(Le,"interactive"),zi.transferChatSession(x,ae)}},Wi={getRelatedInformation(x,ae){return(0,Ye.$cG)(Le,"aiRelatedInformation"),en.getRelatedInformation(Le,x,ae)},registerRelatedInformationProvider(x,ae){return(0,Ye.$cG)(Le,"aiRelatedInformation"),en.registerRelatedInformationProvider(Le,x,ae)},registerEmbeddingVectorProvider(x,ae){return(0,Ye.$cG)(Le,"aiRelatedInformation"),Ui.registerEmbeddingVectorProvider(Le,x,ae)}},Hi={registerChatResponseProvider(x,ae,Fe){return(0,Ye.$cG)(Le,"chatProvider"),At.registerLanguageModel(Le,x,ae,Fe)},registerChatVariableResolver(x,ae,Fe){return(0,Ye.$cG)(Le,"chatVariableResolver"),$n.registerVariableResolver(Le,x,ae,Fe)},registerMappedEditsProvider(x,ae){return(0,Ye.$cG)(Le,"mappedEditsProvider"),dt.registerMappedEditsProvider(Le,x,ae)},createChatParticipant(x,ae){return(0,Ye.$cG)(Le,"chatParticipant"),_i.createChatAgent(Le,x,ae)},createDynamicChatParticipant(x,ae,Fe,rt){return(0,Ye.$cG)(Le,"chatParticipantAdditions"),_i.createDynamicChatAgent(Le,x,ae,Fe,rt)}},Gi={get languageModels(){return(0,Ye.$cG)(Le,"languageModels"),At.getLanguageModelIds()},onDidChangeLanguageModels:(x,ae,Fe)=>((0,Ye.$cG)(Le,"languageModels"),At.onDidChangeProviders(x,ae,Fe)),sendChatRequest(x,ae,Fe,rt){return(0,Ye.$cG)(Le,"languageModels"),At.sendChatRequest(Le,x,ae,Fe,rt)}},Mi={registerSpeechProvider(x,ae){return(0,Ye.$cG)(Le,"speech"),tn.registerProvider(Le.identifier,x,ae)}};return{version:vt.version,ai:Wi,authentication:rn,commands:sn,comments:ln,chat:Hi,debug:hn,env:on,extensions:vn,interactive:fn,l10n:dn,languages:bn,lm:Gi,notebooks:yn,scm:un,speech:Mi,tasks:wn,tests:an,window:cn,workspace:Ri,Breakpoint:Me.$sN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$mO,CallHierarchyIncomingCall:Me.$QM,CallHierarchyItem:Me.$PM,CallHierarchyOutgoingCall:Me.$RM,CancellationError:T.$5,CancellationTokenSource:I.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$MM,CodeActionKind:Me.$NM,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$SM,Color:Me.$6M,ColorInformation:Me.$7M,ColorPresentation:Me.$8M,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$ZM,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$1M,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$dN,DebugAdapterExecutable:Me.$wN,DebugAdapterInlineImplementation:Me.$zN,DebugAdapterNamedPipeServer:Me.$yN,DebugAdapterServer:Me.$xN,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$PN,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$GM,DiagnosticRelatedInformation:Me.$FM,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$sM,DocumentHighlight:Me.$IM,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$JM,DocumentLink:Me.$5M,DocumentSymbol:Me.$LM,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$CN,InlineValueText:Me.$DN,InlineValueVariableLookup:Me.$EN,InlineValueEvaluatableExpression:Me.$FN,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:R.$7d,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$RN,FileDecoration2:Me.$RN,FileSystemError:Me.$IN,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:Me.$JN,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$uN,InlineCompletionItem:Me.$2M,InlineCompletionList:Me.$3M,Hover:Me.$HM,IndentAction:y.IndentAction,Location:Me.$EM,MarkdownString:Me.$TM,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Me.$UM,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$tM,ProcessExecution:Me.$bN,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$QN,Range:Me.$uM,RelativePattern:Me.$qN,Selection:Me.$vM,SelectionRange:Me.$OM,SemanticTokens:Me.$MN,SemanticTokensBuilder:Me.$LN,SemanticTokensEdit:Me.$NN,SemanticTokensEdits:Me.$ON,SemanticTokensLegend:Me.$KN,ShellExecution:Me.$cN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$WM,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$VM,SnippetString:Me.$DM,SourceBreakpoint:Me.$tN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$KM,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$eN,TaskGroup:Me.$aN,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$9M,TerminalQuickFixTerminalCommand:Me.$$M,TerminalQuickFixOpener:Me.$0M,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$_M,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$zM,SnippetTextEdit:Me.$BM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$pN,ThemeIcon:Me.$oN,TreeItem:Me.$fN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$aO,UIKind:ci.UIKind,Uri:d.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$CM,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$lN,DocumentPasteEditKind:Me.$mN,DocumentPasteEdit:Me.$nN,InlayHint:Me.$YM,InlayHintLabelPart:Me.$XM,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$yM,ResolvedAuthority:Me.$wM,ManagedResolvedAuthority:Me.$xM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$2N,NotebookRange:Me.$TN,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$UN,NotebookData:Me.$VN,NotebookRendererScript:Me.$ZN,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$XN,NotebookCellOutputItem:Me.$WN,NotebookCellStatusBarItem:Me.$YN,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$AM,NotebookKernelSourceAction:Me.$1N,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$4N,LinkedEditingRanges:Me.$3N,TestResultState:Me.TestResultState,TestRunRequest:Me.$5N,TestMessage:Me.$6N,TestTag:Me.$7N,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:ti.TextSearchCompleteMessageType,DataTransfer:Me.$kN,DataTransferItem:Me.$gN,TestCoverageCount:Me.$8N,FileCoverage:Me.$9N,StatementCoverage:Me.$0N,BranchCoverage:Me.$$N,DeclarationCoverage:Me.$_N,FunctionCoverage:Me.$_N,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$bO,TabInputTextDiff:Me.$cO,TabInputTextMerge:Me.$dO,TabInputCustom:Me.$eO,TabInputNotebook:Me.$gO,TabInputNotebookDiff:Me.$hO,TabInputWebview:Me.$fO,TabInputTerminal:Me.$iO,TabInputInteractiveWindow:Me.$jO,TabInputChat:Me.$kO,TabInputTextMultiDiff:Me.$lO,TelemetryTrustedValue:s.$4o,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$AN,Thread:Me.$BN,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$nO,ChatResponseFileTreePart:Me.$oO,ChatResponseAnchorPart:Me.$pO,ChatResponseProgressPart:Me.$qO,ChatResponseReferencePart:Me.$sO,ChatResponseCommandButtonPart:Me.$rO,ChatRequestTurn:Me.$tO,ChatResponseTurn:Me.$uO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$vO,LanguageModelChatUserMessage:Me.$wO,LanguageModelChatAssistantMessage:Me.$xO,LanguageModelSystemMessage:Me.$vO,LanguageModelUserMessage:Me.$wO,LanguageModelAssistantMessage:Me.$xO,LanguageModelError:Me.$yO,NewSymbolName:Me.$HN,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$zO,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(Pe[298],Re([1,0,55,116,36,110,37,31,67,51,119,121,122,82,86,78,109,64,44,81,62,66,236,13,120,79,80,84,88,114]),function(ge,e,I,T,R,N,A,g,d,E,O,y,u,w,m,r,o,s,n,i,a,h,t,v,c,$,b,p,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$gs)($.$akc,$.$_jc,1),(0,I.$gs)(v.$Pj,t.$olc,1),(0,I.$gs)(r.$ejc,r.$fjc,1),(0,I.$gs)(g.$8O,g.$7O,0),(0,I.$gs)(p.$ojc,p.$pjc,0),(0,I.$gs)(l.$tjc,l.$ujc,0),(0,I.$gs)(A.$Gjc,A.$Ejc,0),(0,I.$gs)(s.$Ijc,s.$Hjc,0),(0,I.$gs)(y.$kkc,y.$okc,0),(0,I.$gs)(N.$qkc,N.$pkc,0),(0,I.$gs)(d.$WO,d.$VO,0),(0,I.$gs)(b.$bkc,b.$ckc,0),(0,I.$gs)(n.$ijc,n.$hjc,0),(0,I.$gs)(T.$Wkc,T.$Vkc,1),(0,I.$gs)(u.$Gkc,u.$Hkc,0),(0,I.$gs)(w.$2jc,w.$1jc,0),(0,I.$gs)(O.$0kc,O.$9kc,0),(0,I.$gs)(E.$5jc,E.$8jc,0),(0,I.$gs)(D.$llc,D.$mlc,0),(0,I.$gs)(m.$8Bb,m.$9Bb,0),(0,I.$gs)(o.$klc,o.$jlc,0),(0,I.$gs)(R.$Djc,R.$Cjc,0),(0,I.$gs)(i.$0jc,i.$9jc,0),(0,I.$gs)(a.$6O,a.$3O,0),(0,I.$gs)(h.$Sjc,h.$Tjc,0),(0,I.$gs)(c.$ikc,c.$jkc,0)}),define(Pe[299],Re([1,0,297,38,2,294,7,11,242]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;class E extends N.$rlc{j(){}getModule(w,m){for(const r of this.b){const o=r(w);if(o){w=o;break}}if(this.a.has(w))return this.a.get(w).load(w,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends T.$ekc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(d.$xnc);const w=this.h.invokeFunction(I.$nlc);this.r=this.h.createInstance(E,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,m,r){m=m.with({path:y(m.path,".js")});const o=w?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=R.URI.revive(await this.C.$asBrowserUri(m)),n=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),a=`${m.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",h)}catch(b){throw console.error(o?`Loading code for extension ${o} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${m.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}w&&await this.w.initializeLocalizedMessages(w);const v={},c={exports:v},$=b=>{const p=this.r.getModule(b,m);if(p===void 0)throw new Error(`Cannot load module '${b}'`);return p};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,v,$),c.exports!==v?c.exports:v}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+w;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,g.$jh)(10)}}e.$ync=O;function y(u,w){return u.endsWith(w)?u:u+w}}),define(Pe[300],Re([1,0,70,55,13,38,206,85,299]),function(ge,e,I,T,R,N,A,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$gs)(R.$Oj,new I.$fi(A.$qlc,[!0],!0)),(0,T.$gs)(N.$fkc,d.$ync,0),(0,T.$gs)(g.$Jjc,g.$Kjc,0)}),define(Pe[306],Re([1,0,22,5,77,295,244,19,89,12,2,298,300]),function(ge,e,I,T,R,N,A,g,d,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function r(t){self.fetch=async function(v,c){return v instanceof Request||w(String(v))&&(v=(await t(O.URI.parse(String(v)))).toString(!0)),m(v,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,c,$,b,p){(async()=>(w(c.toString())&&(c=(await t(O.URI.parse(c.toString()))).toString(!0)),super.open(v,c,$??!0,b,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(v,c){if(/^file:/i.test(v.toString()))v=E.$Cg.uriToBrowserUri(O.URI.parse(v.toString())).toString(!0);else if(/^vscode-remote:/i.test(v.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(f){function S(C){return typeof C=="string"||C instanceof URL?String(C).replace(/^file:\/\//i,"vscode-file://vscode-app"):C}const k=fetch.bind(self);self.fetch=function(C,q){return C instanceof Request?k(C,q):k(S(C),q)},self.XMLHttpRequest=class extends XMLHttpRequest{open(C,q,V,W,M){return super.open(C,S(q),V??!0,W,M)}};const P=importScripts.bind(self);self.importScripts=(...C)=>{P(...C.map(S))},P(f)}.toString()}('${v}'))`;c=c||{},c.name=`${name} -> ${c.name||g.$oc(v.toString())}`;const p=new Blob([b],{type:"application/javascript"}),l=URL.createObjectURL(p);return new t(l,c)}}else self.Worker=class extends A.$znc{constructor(t,v){super(u,t,{name:g.$oc(t.toString()),...v})}};const o=new class{constructor(){this.pid=void 0}exit(t){y()}};class s{constructor(){const v=new MessageChannel,c=new T.$7d;let $=!1;u(v.port2,[v.port2]),v.port1.onmessage=b=>{const{data:p}=b;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const l=I.$ue.wrap(new Uint8Array(p,0,p.byteLength));if((0,R.$Mm)(l,2)){$=!0,i("received terminate message from renderer");return}c.fire(l)},this.protocol={onMessage:c.event,send:b=>{if(!$){const p=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);v.port1.postMessage(p,[p])}}}}}function n(t){return new Promise(v=>{const c=t.onMessage($=>{c.dispose();const b=JSON.parse($.toString());t.send((0,R.$Lm)(0)),v({protocol:t,initData:b})});t.send((0,R.$Lm)(1))})}let i=t=>y();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){d.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(v){a(v)&&n(t.protocol).then(c=>{d.mark("code/extHost/didWaitForInitData");const $=new N.$tlc(c.protocol,c.initData,o,null,v.data);r(b=>$.asBrowserUri(b)),i=b=>$.terminate(b)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/409da0445d397e37a790ce5d2499688955c3fcfa/core/vs/workbench/api/worker/extensionHostWorker.js.map
