/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(z){for(var e=[],I=0,E=z.length;I<E;I++)e[I]=K[z[I]];return e};define(K[24],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const S=new Map,C=new Map,r=new Map,c=new Map;function i(o,n){o.has(n.detail)||o.set(n.detail,-n.timestamp)}function u(o,n){const t=o.get(n.detail);t&&(t>=0||o.set(n.detail,t+n.timestamp))}let m=[];typeof z=="function"&&typeof z.getStats=="function"&&(m=z.getStats().slice(0).sort((o,n)=>o.timestamp-n.timestamp));for(const o of m)switch(o.type){case 10:i(S,o);break;case 11:case 12:u(S,o);break;case 21:i(C,o);break;case 22:u(C,o);break;case 33:i(r,o);break;case 34:u(r,o);break;case 31:i(c,o);break;case 32:u(c,o);break}let d=0;r.forEach(o=>d+=o);function b(o){const n=[];return o.forEach((t,s)=>n.push([s,t])),n}return{amdLoad:b(S),amdInvoke:b(C),nodeRequire:b(r),nodeEval:b(c),nodeRequireTotal:d}}static toMarkdownTable(S,C){let r="";const c=[];return S.forEach((i,u)=>{c[u]=i.length}),C.forEach(i=>{i.forEach((u,m)=>{typeof u>"u"&&(u=i[m]="-");const d=u.toString().length;c[m]=Math.max(d,c[m])})}),S.forEach((i,u)=>{r+=`| ${i+" ".repeat(c[u]-i.toString().length)} `}),r+=`|
`,S.forEach((i,u)=>{r+=`| ${"-".repeat(c[u])} `}),r+=`|
`,C.forEach(i=>{i.forEach((u,m)=>{typeof u<"u"&&(r+=`| ${u+" ".repeat(c[m]-u.toString().length)} `)}),r+=`|
`}),r}}e.$U=I}),define(K[4],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=C,e.$8c=b;class I{constructor(n,t,s){this.owner=n,this.debugNameSource=t,this.referenceFn=s}getDebugName(n){return C(n,this)}}e.$6c=I;const E=new Map,S=new WeakMap;function C(o,n){const t=S.get(o);if(t)return t;const s=r(o,n);if(s){let l=E.get(s)??0;l++,E.set(s,l);const T=l===1?s:`${s}#${l}`;return S.set(o,T),T}}function r(o,n){const t=S.get(o);if(t)return t;const s=n.owner?m(n.owner)+".":"";let l;const T=n.debugNameSource;if(T!==void 0)if(typeof T=="function"){if(l=T(),l!==void 0)return s+l}else return s+T;const P=n.referenceFn;if(P!==void 0&&(l=b(P),l!==void 0))return s+l;if(n.owner!==void 0){const A=c(n.owner,o);if(A!==void 0)return s+A}}function c(o,n){for(const t in o)if(o[t]===n)return t}const i=new Map,u=new WeakMap;function m(o){const n=u.get(o);if(n)return n;const t=d(o);let s=i.get(t)??0;s++,i.set(t,s);const l=s===1?t:`${t}#${s}`;return u.set(o,l),l}function d(o){const n=o.constructor;return n?n.name:"Object"}function b(o){const n=o.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(n);return(s?s[1]:void 0)?.trim()}}),define(K[5],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ad=void 0,e.$yd=E,e.$zd=S;let I;function E(t){I=t}function S(){return I}class C{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([c(o("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[c(" "),u(m(s.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),u(m(s.newValue,60),{color:"green"})]:[c(" (unchanged)")]:[c(" "),u(m(s.newValue,60),{color:"green"}),c(" (initial)")]}handleObservableChanged(s,l){console.log(...this.b([i("observable value changed"),u(s.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(s){if(s.size!==0)return u(" (changed deps: "+[...s].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(T,P)=>(this.d.get(s).add(T),l.apply(s,[T,P]))}handleDerivedRecomputed(s,l){const T=this.d.get(s);console.log(...this.b([i("derived recomputed"),u(s.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(T),{data:[{fn:s._computeFn}]}])),T.clear()}handleFromEventObservableTriggered(s,l){console.log(...this.b([i("observable from event triggered"),u(s.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(T,P)=>(this.d.get(s).add(T),l.apply(s,[T,P]))}handleAutorunTriggered(s){const l=this.d.get(s);console.log(...this.b([i("autorun"),u(s.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:s._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let l=s.getDebugName();l===void 0&&(l=""),console.log(...this.b([i("transaction"),u(l,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Ad=C;function r(t){const s=new Array,l=[];let T="";function P(k){if("length"in k)for(const a of k)a&&P(a);else"text"in k?(T+=`%c${k.text}`,s.push(k.style),k.data&&l.push(...k.data)):"data"in k&&l.push(...k.data)}P(t);const A=[T,...s];return A.push(...l),A}function c(t){return u(t,{color:"black"})}function i(t){return u(n(`${t}: `,10),{color:"black",bold:!0})}function u(t,s={color:"black"}){function l(P){return Object.entries(P).reduce((A,[k,a])=>`${A}${k}:${a};`,"")}const T={color:s.color};return s.strikeThrough&&(T["text-decoration"]="line-through"),s.bold&&(T["font-weight"]="bold"),{text:t,style:l(T)}}function m(t,s){switch(typeof t){case"number":return""+t;case"string":return t.length+2<=s?`"${t}"`:`"${t.substr(0,s-7)}"+...`;case"boolean":return t?"true":"false";case"undefined":return"undefined";case"object":return t===null?"null":Array.isArray(t)?d(t,s):b(t,s);case"symbol":return t.toString();case"function":return`[[Function${t.name?" "+t.name:""}]]`;default:return""+t}}function d(t,s){let l="[ ",T=!0;for(const P of t){if(T||(l+=", "),l.length-5>s){l+="...";break}T=!1,l+=`${m(P,s-l.length)}`}return l+=" ]",l}function b(t,s){let l="{ ",T=!0;for(const[P,A]of Object.entries(t)){if(T||(l+=", "),l.length-5>s){l+="...";break}T=!1,l+=`${P}: ${m(A,s-l.length)}`}return l+=" }",l}function o(t,s){let l="";for(let T=1;T<=s;T++)l+=t;return l}function n(t,s){for(;t.length<s;)t+=" ";return t}}),define(K[7],V([0,1,25,2,4,5]),function(z,e,I,E,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=void 0,e.$cd=r,e.$dd=c,e.$ed=i,e.$fd=u,e.$gd=m,e.$hd=d;function r(n){return new o(new S.$6c(void 0,void 0,n),n,void 0,void 0)}function c(n,t){return new o(new S.$6c(n.owner,n.debugName,n.debugReferenceFn??t),t,void 0,void 0)}function i(n,t){return new o(new S.$6c(n.owner,n.debugName,n.debugReferenceFn??t),t,n.createEmptyChangeSummary,n.handleChange)}function u(n,t){const s=new E.$Tc,l=i({owner:n.owner,debugName:n.debugName,debugReferenceFn:n.debugReferenceFn,createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(T,P)=>{s.clear(),t(T,P,s)});return(0,E.$Sc)(()=>{l.dispose(),s.dispose()})}function m(n){const t=new E.$Tc,s=c({owner:void 0,debugName:void 0,debugReferenceFn:n},l=>{t.clear(),n(l,t)});return(0,E.$Sc)(()=>{s.dispose(),t.dispose()})}function d(n,t){let s;return c({debugReferenceFn:t},l=>{const T=n.read(l),P=s;s=T,t({lastValue:P,newValue:T})})}var b;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(b||(b={}));class o{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(t,s,l,T){this.h=t,this._runFn=s,this.i=l,this.j=T,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,C.$zd)()?.handleAutorunCreated(this),this.k(),(0,E.$Lc)(this)}dispose(){this.c=!0;for(const t of this.e)t.removeObserver(this);this.e.clear(),(0,E.$Mc)(this)}k(){if(this.a===3)return;const t=this.f;this.f=this.e,this.e=t,this.a=3;const s=this.c;try{if(!s){(0,C.$zd)()?.handleAutorunTriggered(this);const l=this.g;this.g=this.i?.(),this._runFn(this,l)}}finally{s||(0,C.$zd)()?.handleAutorunFinished(this);for(const l of this.f)l.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const t of this.e)if(t.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,I.$ad)(()=>this.b>=0)}handlePossibleChange(t){this.a===3&&this.e.has(t)&&!this.f.has(t)&&(this.a=1)}handleChange(t,s){this.e.has(t)&&!this.f.has(t)&&(!this.j||this.j({changedObservable:t,change:s,didChange:T=>T===t},this.g))&&(this.a=2)}readObservable(t){if(this.c)return t.get();t.addObserver(this);const s=t.get();return this.e.add(t),this.f.delete(t),s}}e.$id=o,function(n){n.Observer=o}(r||(e.$cd=r={}))}),define(K[6],V([0,1,4,5]),function(z,e,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Td=e.$Rd=e.$Md=e.$Ld=void 0,e.$Id=C,e.$Jd=c,e.$Kd=u,e.$Nd=b,e.$Od=n,e.$Pd=t,e.$Qd=s,e.$Sd=T,e.$Ud=A;let S;function C(a){S=a}let r;function c(a){r=a}let i;function u(a){i=a}class m{get TChange(){return null}reportChanges(){this.get()}read($){return $?$.readObservable(this):this.get()}map($,w){const U=w===void 0?void 0:$,p=w===void 0?$:w;return i({owner:U,debugName:()=>{const f=(0,I.$8c)(p);if(f!==void 0)return f;const N=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(p.toString());if(N)return`${this.debugName}.${N[2]}`;if(!U)return`${this.debugName} (mapped)`}},f=>p(this.read(f),f))}recomputeInitiallyAndOnChange($,w){return $.add(S(this,w)),this}keepObserved($){return $.add(r(this)),this}}e.$Ld=m;class d extends m{constructor(){super(...arguments),this.c=new Set}addObserver($){const w=this.c.size;this.c.add($),w===0&&this.f()}removeObserver($){this.c.delete($)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Md=d;function b(a,$){const w=new l(a,$);try{a(w)}finally{w.finish()}}let o;function n(a){if(o)a(o);else{const $=new l(a,void 0);o=$;try{a($)}finally{$.finish(),o=void 0}}}async function t(a,$){const w=new l(a,$);try{await a(w)}finally{w.finish()}}function s(a,$,w){a?$(a):b($,w)}class l{constructor($,w){this._fn=$,this.b=w,this.a=[],(0,E.$zd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,I.$8c)(this._fn)}updateObserver($,w){this.a.push({observer:$,observable:w}),$.beginUpdate(w)}finish(){const $=this.a;for(let w=0;w<$.length;w++){const{observer:U,observable:p}=$[w];U.endUpdate(p)}this.a=null,(0,E.$zd)()?.handleEndTransaction()}}e.$Rd=l;function T(a,$){return typeof a=="string"?new P(void 0,a,$):new P(a,void 0,$)}class P extends d{get debugName(){return new I.$6c(this.b,this.d,void 0).getDebugName(this)??"ObservableValue"}constructor($,w,U){super(),this.b=$,this.d=w,this.a=U}get(){return this.a}set($,w,U){if(this.a===$)return;let p;w||(w=p=new l(()=>{},()=>`Setting ${this.debugName}`));try{const f=this.a;this.e($),(0,E.$zd)()?.handleObservableChanged(this,{oldValue:f,newValue:$,change:U,didChange:!0,hadValue:!0});for(const v of this.c)w.updateObserver(v,this),v.handleChange(this,U)}finally{p&&p.finish()}}toString(){return`${this.debugName}: ${this.a}`}e($){this.a=$}}e.$Td=P;function A(a,$){return typeof a=="string"?new k(void 0,a,$):new k(a,void 0,$)}class k extends P{e($){this.a!==$&&(this.a&&this.a.dispose(),this.a=$)}dispose(){this.a?.dispose()}}e.$Vd=k}),define(K[8],V([0,1,25,2,6,4,5]),function(z,e,I,E,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=e.$Bd=void 0,e.$Cd=i,e.$Dd=u,e.$Ed=m,e.$Fd=d,e.$Gd=b;const c=(t,s)=>t===s;e.$Bd=c;function i(t,s){return s!==void 0?new n(new C.$6c(t,void 0,s),s,void 0,void 0,void 0,e.$Bd):new n(new C.$6c(void 0,void 0,t),t,void 0,void 0,void 0,e.$Bd)}function u(t,s){return new n(new C.$6c(t.owner,t.debugName,t.debugReferenceFn),s,void 0,void 0,t.onLastObserverRemoved,t.equalityComparer??e.$Bd)}(0,S.$Kd)(u);function m(t,s){return new n(new C.$6c(t.owner,t.debugName,void 0),s,t.createEmptyChangeSummary,t.handleChange,void 0,t.equalityComparer??e.$Bd)}function d(t,s){let l,T;s===void 0?(l=t,T=void 0):(T=t,l=s);const P=new E.$Tc;return new n(new C.$6c(T,void 0,l),A=>(P.clear(),l(A,P)),void 0,void 0,()=>P.dispose(),e.$Bd)}function b(t,s){let l,T;s===void 0?(l=t,T=void 0):(T=t,l=s);const P=new E.$Tc;return new n(new C.$6c(T,void 0,l),A=>{P.clear();const k=l(A);return k&&P.add(k),k},void 0,void 0,()=>P.dispose(),e.$Bd)}var o;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(o||(o={}));class n extends S.$Md{get debugName(){return this.n.getDebugName(this)??"(anonymous)"}constructor(s,l,T,P,A=void 0,k){super(),this.n=s,this._computeFn=l,this.p=T,this.q=P,this.s=A,this.t=k,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.p?.(),(0,r.$zd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const s of this.k)s.removeObserver(this);this.k.clear(),this.s?.()}get(){if(this.c.size===0){const s=this._computeFn(this,this.p?.());return this.g(),s}else{do{if(this.e===1){for(const s of this.k)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const s=this.l;this.l=this.k,this.k=s;const l=this.e!==0,T=this.h;this.e=3;const P=this.m;this.m=this.p?.();try{this.h=this._computeFn(this,P)}finally{for(const k of this.l)k.removeObserver(this);this.l.clear()}const A=l&&!this.t(T,this.h);if((0,r.$zd)()?.handleDerivedRecomputed(this,{oldValue:T,newValue:this.h,change:void 0,didChange:A,hadValue:l}),A)for(const k of this.c)k.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.j++;const l=this.j===1;if(this.e===3&&(this.e=1,!l))for(const T of this.c)T.handlePossibleChange(this);if(l)for(const T of this.c)T.beginUpdate(this)}endUpdate(s){if(this.j--,this.j===0){const l=[...this.c];for(const T of l)T.endUpdate(this)}(0,I.$ad)(()=>this.j>=0)}handlePossibleChange(s){if(this.e===3&&this.k.has(s)&&!this.l.has(s)){this.e=1;for(const l of this.c)l.handlePossibleChange(this)}}handleChange(s,l){if(this.k.has(s)&&!this.l.has(s)){const T=this.q?this.q({changedObservable:s,change:l,didChange:A=>A===s},this.m):!0,P=this.e===3;if(T&&(this.e===1||P)&&(this.e=2,P))for(const A of this.c)A.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const l=s.get();return this.k.add(s),this.l.delete(s),l}addObserver(s){const l=!this.c.has(s)&&this.j>0;super.addObserver(s),l&&s.beginUpdate(this)}removeObserver(s){const l=this.c.has(s)&&this.j>0;super.removeObserver(s),l&&s.endUpdate(this)}}e.$Hd=n}),define(K[26],V([0,1,2,7,6,4,8,5]),function(z,e,I,E,S,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ud=e.$md=void 0,e.$jd=i,e.$kd=m,e.$ld=d,e.$nd=o,e.$od=t,e.$pd=l,e.$qd=T,e.$rd=P,e.$sd=A,e.$td=k,e.$vd=$,e.$wd=w,e.$xd=U;function i(f){return new u(f)}class u extends S.$Ld{constructor(v){super(),this.a=v}get debugName(){return this.toString()}get(){return this.a}addObserver(v){}removeObserver(v){}toString(){return`Const: ${this.a}`}}function m(f){const v=(0,S.$Sd)("promiseValue",{});return f.then(N=>{v.set({value:N},void 0)}),v}function d(f,v){return new b(f,v)}class b extends S.$Md{constructor(v,N){super(),this.h=v,this._getValue=N,this.b=!1,this.l=D=>{const O=this._getValue(D),g=this.a,j=!this.b||g!==O;let B=!1;j&&(this.a=O,this.b&&(B=!0,(0,S.$Qd)(b.globalTransaction,q=>{(0,c.$zd)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:j,hadValue:this.b});for(const G of this.c)q.updateObserver(G,this),G.handleChange(this,void 0)},()=>{const q=this.j();return"Event fired"+(q?`: ${q}`:"")})),this.b=!0),B||(0,c.$zd)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:j,hadValue:this.b})}}j(){return(0,C.$8c)(this._getValue)}get debugName(){const v=this.j();return"From Event"+(v?`: ${v}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$md=b,function(f){f.Observer=b;function v(N,D){let O=!1;b.globalTransaction===void 0&&(b.globalTransaction=N,O=!0);try{D()}finally{O&&(b.globalTransaction=void 0)}}f.batchEventsGlobally=v}(d||(e.$ld=d={}));function o(f,v){return new n(f,v)}class n extends S.$Md{constructor(v,N){super(),this.debugName=v,this.b=N,this.h=()=>{(0,S.$Nd)(D=>{for(const O of this.c)D.updateObserver(O,this),O.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function t(f){return typeof f=="string"?new s(f):new s(void 0,f)}class s extends S.$Md{get debugName(){return new C.$6c(this.b,this.a,void 0).getDebugName(this)??"Observable Signal"}constructor(v,N){super(),this.a=v,this.b=N}trigger(v,N){if(!v){(0,S.$Nd)(D=>{this.trigger(D,N)},()=>`Trigger signal ${this.debugName}`);return}for(const D of this.c)v.updateObserver(D,this),D.handleChange(this,N)}get(){}}function l(f,v,N){const D=(0,S.$Sd)("debounced",void 0);let O;return N.add((0,E.$cd)(g=>{const j=f.read(g);O&&clearTimeout(O),O=setTimeout(()=>{(0,S.$Nd)(B=>{D.set(j,B)})},v)})),D}function T(f,v){let N=!1,D,O;return d(g=>{const j=(0,E.$cd)(B=>{const q=f.read(B);N?(O&&clearTimeout(O),O=setTimeout(()=>{D=q,g()},v)):(N=!0,D=q)});return{dispose(){j.dispose(),N=!1,D=void 0}}},()=>N?D:f.get())}function P(f,v,N){const D=(0,S.$Sd)("triggeredRecently",!1);let O;return N.add(f(()=>{D.set(!0,void 0),O&&clearTimeout(O),O=setTimeout(()=>{D.set(!1,void 0)},v)})),D}function A(f){const v=new a(!1,void 0);return f.addObserver(v),(0,I.$Sc)(()=>{f.removeObserver(v)})}(0,S.$Jd)(A);function k(f,v){const N=new a(!0,v);return f.addObserver(N),v?v(f.get()):f.reportChanges(),(0,I.$Sc)(()=>{f.removeObserver(N)})}(0,S.$Id)(k);class a{constructor(v,N){this.b=v,this.c=N,this.a=0}beginUpdate(v){this.a++}endUpdate(v){this.a--,this.a===0&&this.b&&(this.c?this.c(v.get()):v.reportChanges())}handlePossibleChange(v){}handleChange(v,N){}}e.$ud=a;function $(f){let v;return(0,r.$Cd)(D=>(v=f(D,v),v))}function w(f,v){let N;const D=(0,S.$Sd)("derivedObservableWithWritableCache.counter",0),O=(0,r.$Cd)(f,g=>(D.read(g),N=v(g,N),N));return Object.assign(O,{clearCache:g=>{N=void 0,D.set(D.get()+1,g)}})}function U(f,v,N,D){let O=new p(N,D);return(0,r.$Dd)({debugReferenceFn:N,owner:f,onLastObserverRemoved:()=>{O.dispose(),O=new p(N)}},j=>(O.setItems(v.read(j)),O.getItems()))}class p{constructor(v,N){this.c=v,this.e=N,this.a=new Map,this.b=[]}dispose(){this.a.forEach(v=>v.store.dispose()),this.a.clear()}setItems(v){const N=[],D=new Set(this.a.keys());for(const O of v){const g=this.e?this.e(O):O;let j=this.a.get(g);if(j)D.delete(g);else{const B=new I.$Tc;j={out:this.c(O,B),store:B},this.a.set(g,j)}N.push(j.out)}for(const O of D)this.a.get(O).store.dispose(),this.a.delete(O);this.b=N}getItems(){return this.b}}}),define(K[27],V([0,1,7,6,8,28,4]),function(z,e,I,E,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0,e.$1d=d,e.$2d=b;class c{get cachedValue(){return this.a}constructor(n){this.b=n,this.a=(0,E.$Sd)(this,void 0)}getValue(){let n=this.a.get();return n||(n=this.b(),this.a.set(n,void 0)),n}}e.$Wd=c;class i{constructor(n){this.a=(0,E.$Sd)(this,void 0),this.promiseResult=this.a,this.promise=n.then(t=>((0,E.$Nd)(s=>{this.a.set(new u(t,void 0),s)}),t),t=>{throw(0,E.$Nd)(s=>{this.a.set(new u(void 0,t),s)}),t})}}e.$Xd=i;class u{constructor(n,t){this.data=n,this.error=t}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.$Yd=u;class m{constructor(n){this.b=n,this.a=new c(()=>new i(this.b())),this.cachedPromiseResult=(0,S.$Cd)(this,t=>this.a.cachedValue.read(t)?.promiseResult.read(t))}getPromise(){return this.a.getValue().promise}}e.$Zd=m;function d(o,n,t){return new Promise((s,l)=>{let T=!0,P=!1;const A=o.map(a=>({isFinished:n(a),error:t?t(a):!1,state:a})),k=(0,I.$cd)(a=>{const{isFinished:$,error:w,state:U}=A.read(a);($||w)&&(T?P=!0:k.dispose(),w?l(w===!0?U:w):s(U))});T=!1,P&&k.dispose()})}function b(o,n){let t,s;n===void 0?(t=o,s=void 0):(s=o,t=n);let l;return new S.$Hd(new r.$6c(s,void 0,t),T=>(l&&l.dispose(!0),l=new C.$ee,t(T,l.token)),void 0,void 0,()=>l?.dispose(),S.$Bd)}}),define(K[12],V([0,1,6,8,7,26,27,5]),function(z,e,I,E,S,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return I.$Sd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return I.$Ud}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return I.$Nd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return I.$Qd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.$Cd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return E.$Dd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return E.$Ed}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return E.$Fd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return S.$cd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return S.$hd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return S.$ed}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return S.$gd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return S.$dd}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return S.$fd}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return C.$jd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return C.$pd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return C.$vd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return C.$wd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return C.$sd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return C.$td}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return C.$ld}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return C.$kd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return C.$od}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return C.$nd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return C.$rd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return r.$Wd}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return r.$Zd}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return r.$Xd}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return r.$Yd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return r.$1d}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return r.$2d}}),!1&&(0,c.$yd)(new c.$Ad)}),define(K[29],V([0,1,9,2]),function(z,e,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=S,e.$ge=C,e.$he=r,e.$ie=c,e.$je=u,e.$ke=m,e.$le=d,e.$me=b,e.$ne=o,e.$oe=n,e.$pe=t,e.$qe=s,e.$re=l,e.$se=T,e.$te=P;function S(A){const k=A;return k?typeof k.read=="function":!1}function C(A){const k=A;return k?[k.on,k.pause,k.resume,k.destroy].every(a=>typeof a=="function"):!1}function r(A){const k=A;return k?C(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}function c(A,k){return new i(A,k)}class i{constructor(k,a){this.e=k,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(a=>a(k))}h(k){this.c.error.length===0?(0,I.$1)(k):this.c.error.slice(0).forEach(a=>a(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,a){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(k,a){if(this.a.destroyed)return;let $;switch(k){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const w=$.indexOf(a);w>=0&&$.splice(w,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach($=>$())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(A,k){const a=[];let $;for(;($=A.read())!==null;)a.push($);return k(a)}function m(A,k,a){const $=[];let w;for(;(w=A.read())!==null&&$.length<a;)$.push(w);return w===null&&$.length>0?k($):{read:()=>{if($.length>0)return $.shift();if(typeof w<"u"){const U=w;return w=void 0,U}return A.read()}}}function d(A,k){return new Promise((a,$)=>{const w=[];b(A,{onData:U=>{k&&w.push(U)},onError:U=>{k?$(U):a(void 0)},onEnd:()=>{a(k?k(w):void 0)}})})}function b(A,k,a){A.on("error",$=>{a?.isCancellationRequested||k.onError($)}),A.on("end",()=>{a?.isCancellationRequested||k.onEnd()}),A.on("data",$=>{a?.isCancellationRequested||k.onData($)})}function o(A,k){return new Promise((a,$)=>{const w=new E.$Tc,U=[],p=N=>{if(U.push(N),U.length>k)return w.dispose(),A.pause(),a({stream:A,buffer:U,ended:!1})},f=N=>(w.dispose(),$(N)),v=()=>(w.dispose(),a({stream:A,buffer:U,ended:!0}));w.add((0,E.$Sc)(()=>A.removeListener("error",f))),A.on("error",f),w.add((0,E.$Sc)(()=>A.removeListener("end",v))),A.on("end",v),w.add((0,E.$Sc)(()=>A.removeListener("data",p))),A.on("data",p)})}function n(A,k){const a=c(k);return a.end(A),a}function t(){const A=c(()=>{throw new Error("not supported")});return A.end(),A}function s(A){let k=!1;return{read:()=>k?null:(k=!0,A)}}function l(A,k,a){const $=c(a);return b(A,{onData:w=>$.write(k.data(w)),onError:w=>$.error(k.error?k.error(w):w),onEnd:()=>$.end()}),$}function T(A,k,a){let $=!1;return{read:()=>{const w=k.read();return $?w:($=!0,w!==null?a([A,w]):A)}}}function P(A,k,a){let $=!1;const w=c(a);return b(k,{onData:U=>$?w.write(U):($=!0,w.write(a([A,U]))),onError:U=>w.error(U),onEnd:()=>{$||($=!0,w.write(A)),w.end()}}),w}}),define(K[13],V([0,1,30,29]),function(z,e,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=u,e.$we=m,e.$xe=d,e.$ye=b,e.$ze=o,e.$Ae=n,e.$Be=t,e.$Ce=s,e.$De=l,e.$Ee=T,e.$Fe=P,e.$Ge=A,e.$He=k,e.$Ie=a,e.$Je=$,e.$Ke=w,e.$Le=U,e.$Me=p,e.$Ne=f,e.$Oe=D;const S=typeof Buffer<"u",C=new I.$V(()=>new Uint8Array(256));let r,c;class i{static alloc(g){return S?new i(Buffer.allocUnsafe(g)):new i(new Uint8Array(g))}static wrap(g){return S&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new i(g)}static fromString(g,j){return!(j?.dontUseNodeBuffer||!1)&&S?new i(Buffer.from(g)):(r||(r=new TextEncoder),new i(r.encode(g)))}static fromByteArray(g){const j=i.alloc(g.length);for(let B=0,q=g.length;B<q;B++)j.buffer[B]=g[B];return j}static concat(g,j){if(typeof j>"u"){j=0;for(let G=0,J=g.length;G<J;G++)j+=g[G].byteLength}const B=i.alloc(j);let q=0;for(let G=0,J=g.length;G<J;G++){const W=g[G];B.set(W,q),q+=W.byteLength}return B}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=i.alloc(this.byteLength);return g.set(this),g}toString(){return S?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(g,j){return new i(this.buffer.subarray(g,j))}set(g,j){if(g instanceof i)this.buffer.set(g.buffer,j);else if(g instanceof Uint8Array)this.buffer.set(g,j);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),j);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return b(this.buffer,g)}writeUInt32BE(g,j){o(this.buffer,g,j)}readUInt32LE(g){return n(this.buffer,g)}writeUInt32LE(g,j){t(this.buffer,g,j)}readUInt8(g){return s(this.buffer,g)}writeUInt8(g,j){l(this.buffer,g,j)}indexOf(g,j=0){return u(this.buffer,g instanceof i?g.buffer:g,j)}}e.$ue=i;function u(O,g,j=0){const B=g.byteLength,q=O.byteLength;if(B===0)return 0;if(B===1)return O.indexOf(g[0]);if(B>q-j)return-1;const G=C.value;G.fill(g.length);for(let Y=0;Y<g.length;Y++)G[g[Y]]=g.length-Y-1;let J=j+g.length-1,W=J,H=-1;for(;J<q;)if(O[J]===g[W]){if(W===0){H=J;break}J--,W--}else J+=Math.max(g.length-W,G[O[J]]),W=g.length-1;return H}function m(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0}function d(O,g,j){O[j+0]=g&255,g=g>>>8,O[j+1]=g&255}function b(O,g){return O[g]*2**24+O[g+1]*2**16+O[g+2]*2**8+O[g+3]}function o(O,g,j){O[j+3]=g,g=g>>>8,O[j+2]=g,g=g>>>8,O[j+1]=g,g=g>>>8,O[j]=g}function n(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0|O[g+2]<<16>>>0|O[g+3]<<24>>>0}function t(O,g,j){O[j+0]=g&255,g=g>>>8,O[j+1]=g&255,g=g>>>8,O[j+2]=g&255,g=g>>>8,O[j+3]=g&255}function s(O,g){return O[g]}function l(O,g,j){O[j]=g}function T(O){return E.$je(O,g=>i.concat(g))}function P(O){return E.$qe(O)}function A(O){return E.$le(O,g=>i.concat(g))}async function k(O){return O.ended?i.concat(O.buffer):i.concat([...O.buffer,await A(O.stream)])}function a(O){return E.$oe(O,g=>i.concat(g))}function $(O){return E.$re(O,{data:g=>typeof g=="string"?i.fromString(g):i.wrap(g)},g=>i.concat(g))}function w(O){return E.$ie(g=>i.concat(g),O)}function U(O,g){return E.$se(O,g,j=>i.concat(j))}function p(O,g){return E.$te(O,g,j=>i.concat(j))}function f(O){let g=0,j=0,B=0;const q=new Uint8Array(Math.floor(O.length/4*3)),G=W=>{switch(j){case 3:q[B++]=g|W,j=0;break;case 2:q[B++]=g|W>>>2,g=W<<6,j=3;break;case 1:q[B++]=g|W>>>4,g=W<<4,j=2;break;default:g=W<<2,j=1}};for(let W=0;W<O.length;W++){const H=O.charCodeAt(W);if(H>=65&&H<=90)G(H-65);else if(H>=97&&H<=122)G(H-97+26);else if(H>=48&&H<=57)G(H-48+52);else if(H===43||H===45)G(62);else if(H===47||H===95)G(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${O[W]}`)}}const J=B;for(;j>0;)G(0);return i.wrap(q).slice(0,J)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:O},g=!0,j=!1){const B=j?N:v;let q="";const G=O.byteLength%3;let J=0;for(;J<O.byteLength-G;J+=3){const W=O[J+0],H=O[J+1],Y=O[J+2];q+=B[W>>>2],q+=B[(W<<4|H>>>4)&63],q+=B[(H<<2|Y>>>6)&63],q+=B[Y&63]}if(G===1){const W=O[J+0];q+=B[W>>>2],q+=B[W<<4&63],g&&(q+="==")}else if(G===2){const W=O[J+0],H=O[J+1];q+=B[W>>>2],q+=B[(W<<4|H>>>4)&63],q+=B[H<<2&63],g&&(q+="=")}return q}}),define(K[31],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(K[14],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Ot=E;var I;(function(S){S[S.Unknown=0]="Unknown",S[S.Invalid=3]="Invalid",S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function E(S){let C=0,r=0,c=0,i=0;for(let u=0,m=S.length;u<m;u++){const d=S.charCodeAt(u);d===13?(C===0&&(r=u),C++,u+1<m&&S.charCodeAt(u+1)===10?(i|=2,u++):i|=3,c=u+1):d===10&&(i|=1,C===0&&(r=u),C++,c=u+1)}return C===0&&(r=S.length),[C,r,S.length-c,i]}}),define(K[15],V([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(i){i[i.Null=0]="Null",i[i.PlainText=1]="PlainText"})(I||(e.LanguageId=I={}));var E;(function(i){i[i.NotSet=-1]="NotSet",i[i.None=0]="None",i[i.Italic=1]="Italic",i[i.Bold=2]="Bold",i[i.Underline=4]="Underline",i[i.Strikethrough=8]="Strikethrough"})(E||(e.FontStyle=E={}));var S;(function(i){i[i.None=0]="None",i[i.DefaultForeground=1]="DefaultForeground",i[i.DefaultBackground=2]="DefaultBackground"})(S||(e.ColorId=S={}));var C;(function(i){i[i.Other=0]="Other",i[i.Comment=1]="Comment",i[i.String=2]="String",i[i.RegEx=3]="RegEx"})(C||(e.StandardTokenType=C={}));var r;(function(i){i[i.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",i[i.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",i[i.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",i[i.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",i[i.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",i[i.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",i[i.ITALIC_MASK=2048]="ITALIC_MASK",i[i.BOLD_MASK=4096]="BOLD_MASK",i[i.UNDERLINE_MASK=8192]="UNDERLINE_MASK",i[i.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",i[i.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",i[i.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",i[i.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",i[i.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",i[i.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",i[i.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",i[i.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",i[i.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",i[i.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",i[i.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",i[i.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",i[i.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class c{static getLanguageId(u){return(u&255)>>>0}static getTokenType(u){return(u&768)>>>8}static containsBalancedBrackets(u){return(u&1024)!==0}static getFontStyle(u){return(u&30720)>>>11}static getForeground(u){return(u&16744448)>>>15}static getBackground(u){return(u&4278190080)>>>24}static getClassNameFromMetadata(u){let d="mtk"+this.getForeground(u);const b=this.getFontStyle(u);return b&1&&(d+=" mtki"),b&2&&(d+=" mtkb"),b&4&&(d+=" mtku"),b&8&&(d+=" mtks"),d}static getInlineStyleFromMetadata(u,m){const d=this.getForeground(u),b=this.getFontStyle(u);let o=`color: ${m[d]};`;b&1&&(o+="font-style: italic;"),b&2&&(o+="font-weight: bold;");let n="";return b&4&&(n+=" underline"),b&8&&(n+=" line-through"),n&&(o+=`text-decoration:${n};`),o}static getPresentationFromMetadata(u){const m=this.getForeground(u),d=this.getFontStyle(u);return{foreground:m,italic:!!(d&1),bold:!!(d&2),underline:!!(d&4),strikethrough:!!(d&8)}}}e.$Mt=c}),define(K[32],V([0,1,33]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=void 0;class E{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,c){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=c}replace(r,c,i){if(r>=this.a.length)return;if(c===0){this.insert(r,i);return}else if(i===0){this.delete(r,c);return}const u=this.a.slice(0,r),m=this.a.slice(r+c),d=S(i,this.b);this.a=u.concat(d,m)}delete(r,c){c===0||r>=this.a.length||this.a.splice(r,c)}insert(r,c){if(c===0||r>=this.a.length)return;const i=[];for(let u=0;u<c;u++)i[u]=this.b;this.a=(0,I.$Wb)(this.a,r,i)}}e.$IC=E;function S(C,r){const c=[];for(let i=0;i<C;i++)c[i]=r;return c}}),define(K[10],V([0,1,15]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=void 0;class E{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(r,c){const i=E.defaultTokenMetadata,u=new Uint32Array(2);return u[0]=r.length,u[1]=i,new E(u,r,c)}constructor(r,c,i){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=c,this.d=i}equals(r){return r instanceof E?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,c,i){if(this.c!==r.c||this.b!==r.b)return!1;const u=c<<1,m=u+(i<<1);for(let d=u;d<m;d++)if(this.a[d]!==r.a[d])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const c=this.a[(r<<1)+1],i=I.$Mt.getLanguageId(c);return this.d.decodeLanguageId(i)}getStandardTokenType(r){const c=this.a[(r<<1)+1];return I.$Mt.getTokenType(c)}getForeground(r){const c=this.a[(r<<1)+1];return I.$Mt.getForeground(c)}getClassName(r){const c=this.a[(r<<1)+1];return I.$Mt.getClassNameFromMetadata(c)}getInlineStyle(r,c){const i=this.a[(r<<1)+1];return I.$Mt.getInlineStyleFromMetadata(i,c)}getPresentation(r){const c=this.a[(r<<1)+1];return I.$Mt.getPresentationFromMetadata(c)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return E.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,c,i){return new S(this,r,c,i)}static convertToEndOffset(r,c){const u=(r.length>>>1)-1;for(let m=0;m<u;m++)r[m<<1]=r[m+1<<1];r[u<<1]=c}static findIndexInTokensArray(r,c){if(r.length<=2)return 0;let i=0,u=(r.length>>>1)-1;for(;i<u;){const m=i+Math.floor((u-i)/2),d=r[m<<1];if(d===c)return m+1;d<c?i=m+1:d>c&&(u=m)}return i}withInserted(r){if(r.length===0)return this;let c=0,i=0,u="";const m=new Array;let d=0;for(;;){const b=c<this.b?this.a[c<<1]:-1,o=i<r.length?r[i]:null;if(b!==-1&&(o===null||b<=o.offset)){u+=this.c.substring(d,b);const n=this.a[(c<<1)+1];m.push(u.length,n),c++,d=b}else if(o){if(o.offset>d){u+=this.c.substring(d,o.offset);const n=this.a[(c<<1)+1];m.push(u.length,n),d=o.offset}u+=o.text,m.push(u.length,o.tokenMetadata),i++}else break}return new E(new Uint32Array(m),u,this.d)}}e.$Pt=E;class S{constructor(r,c,i,u){this.a=r,this.b=c,this.c=i,this.d=u,this.e=r.findTokenIndexAtOffset(c),this.f=0;for(let m=this.e,d=r.getCount();m<d&&!(r.getStartOffset(m)>=i);m++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof S?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const c=this.a.getEndOffset(this.e+r);return Math.min(this.c,c)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,c){return this.a.getInlineStyle(this.e+r,c)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(K[34],V([0,1,10]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=e.$Qt=void 0,e.$St=S,e.$Qt=new Uint32Array(0).buffer;class E{static deleteBeginning(r,c){return r===null||r===e.$Qt?r:E.delete(r,0,c)}static deleteEnding(r,c){if(r===null||r===e.$Qt)return r;const i=S(r),u=i[i.length-2];return E.delete(r,c,u)}static delete(r,c,i){if(r===null||r===e.$Qt||c===i)return r;const u=S(r),m=u.length>>>1;if(c===0&&u[u.length-2]===i)return e.$Qt;const d=I.$Pt.findIndexInTokensArray(u,c),b=d>0?u[d-1<<1]:0,o=u[d<<1];if(i<o){const T=i-c;for(let P=d;P<m;P++)u[P<<1]-=T;return r}let n,t;b!==c?(u[d<<1]=c,n=d+1<<1,t=c):(n=d<<1,t=b);const s=i-c;for(let T=d+1;T<m;T++){const P=u[T<<1]-s;P>t&&(u[n++]=P,u[n++]=u[(T<<1)+1],t=P)}if(n===u.length)return r;const l=new Uint32Array(n);return l.set(u.subarray(0,n),0),l.buffer}static append(r,c){if(c===e.$Qt)return r;if(r===e.$Qt)return c;if(r===null)return r;if(c===null)return null;const i=S(r),u=S(c),m=u.length>>>1,d=new Uint32Array(i.length+u.length);d.set(i,0);let b=i.length;const o=i[i.length-2];for(let n=0;n<m;n++)d[b++]=u[n<<1]+o,d[b++]=u[(n<<1)+1];return d.buffer}static insert(r,c,i){if(r===null||r===e.$Qt)return r;const u=S(r),m=u.length>>>1;let d=I.$Pt.findIndexInTokensArray(u,c);d>0&&u[d-1<<1]===c&&d--;for(let b=d;b<m;b++)u[b<<1]+=i;return r}}e.$Rt=E;function S(C){return C instanceof Uint32Array?C:new Uint32Array(C)}}),define(K[35],V([0,1,33,13,47,14,34,16]),function(z,e,I,E,S,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=void 0;class i{static deserialize(m,d,b){const o=new Uint32Array(m.buffer),n=(0,E.$ye)(m,d);d+=4;const t=(0,E.$ye)(m,d);d+=4;const s=[];for(let l=0;l<t;l++){const T=(0,E.$ye)(m,d);d+=4,s.push(o.subarray(d/4,d/4+T/4)),d+=T}return b.push(new i(n,s)),d}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(m,d){this.a=m,this.b=d}getLineRange(){return new c.$lt(this.a,this.a+this.b.length)}getLineTokens(m){return this.b[m-this.a]}appendLineTokens(m){this.b.push(m)}serializeSize(){let m=0;m+=4,m+=4;for(let d=0;d<this.b.length;d++){const b=this.b[d];if(!(b instanceof Uint32Array))throw new Error("Not supported!");m+=4,m+=b.byteLength}return m}serialize(m,d){(0,E.$ze)(m,this.a,d),d+=4,(0,E.$ze)(m,this.b.length,d),d+=4;for(let b=0;b<this.b.length;b++){const o=this.b[b];if(!(o instanceof Uint32Array))throw new Error("Not supported!");(0,E.$ze)(m,o.byteLength,d),d+=4,m.set(new Uint8Array(o.buffer),d),d+=o.byteLength}return d}applyEdit(m,d){const[b,o]=(0,C.$Ot)(d);this.c(m),this.d(new S.$bt(m.startLineNumber,m.startColumn),b,o)}c(m){if(m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn)return;const d=m.startLineNumber-this.a,b=m.endLineNumber-this.a;if(b<0){const o=b-d;this.a-=o;return}if(!(d>=this.b.length)){if(d<0&&b>=this.b.length){this.a=0,this.b=[];return}if(d===b){this.b[d]=r.$Rt.delete(this.b[d],m.startColumn-1,m.endColumn-1);return}if(d>=0)if(this.b[d]=r.$Rt.deleteEnding(this.b[d],m.startColumn-1),b<this.b.length){const o=r.$Rt.deleteBeginning(this.b[b],m.endColumn-1);this.b[d]=r.$Rt.append(this.b[d],o),this.b.splice(d+1,b-d)}else this.b[d]=r.$Rt.append(this.b[d],null),this.b=this.b.slice(0,d+1);else{const o=-d;this.a-=o,this.b[b]=r.$Rt.deleteBeginning(this.b[b],m.endColumn-1),this.b=this.b.slice(b)}}}d(m,d,b){if(d===0&&b===0)return;const o=m.lineNumber-this.a;if(o<0){this.a+=d;return}if(!(o>=this.b.length)){if(d===0){this.b[o]=r.$Rt.insert(this.b[o],m.column-1,b);return}this.b[o]=r.$Rt.deleteEnding(this.b[o],m.column-1),this.b[o]=r.$Rt.insert(this.b[o],m.column-1,b),this.e(m.lineNumber,d)}}e(m,d){if(d===0)return;const b=[];for(let o=0;o<d;o++)b[o]=null;this.b=I.$Wb(this.b,m,b)}}e.$Tt=i}),define(K[17],V([0,1,13,35]),function(z,e,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=void 0;class S{static deserialize(r){let c=0;const i=(0,I.$ye)(r,c);c+=4;const u=[];for(let m=0;m<i;m++)c=E.$Tt.deserialize(r,c,u);return u}constructor(){this.a=[]}add(r,c){if(this.a.length>0){const i=this.a[this.a.length-1];if(i.endLineNumber+1===r){i.appendLineTokens(c);return}}this.a.push(new E.$Tt(r,[c]))}finalize(){return this.a}serialize(){const r=this.b(),c=new Uint8Array(r);return this.c(c),c}b(){let r=0;r+=4;for(let c=0;c<this.a.length;c++)r+=this.a[c].serializeSize();return r}c(r){let c=0;(0,I.$ze)(r,this.a.length,c),c+=4;for(let i=0;i<this.a.length;i++)c=this.a[i].serialize(r,c)}}e.$JC=S}),define(K[36],V([0,1,18,3,19,48]),function(z,e,I,E,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=r,e.$cg=c,e.$dg=i,e.$eg=u,e.$fg=m,e.$gg=n,e.$hg=t,e.$ig=s,e.$jg=l,e.$kg=T,e.$lg=P,e.$mg=A,e.$ng=k,e.$og=a,e.$pg=$,e.$qg=p;function r(f){return f===47||f===92}function c(f){return f.replace(/[\\/]/g,I.$hc.sep)}function i(f){return f.indexOf("/")===-1&&(f=c(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function u(f,v=I.$hc.sep){if(!f)return"";const N=f.length,D=f.charCodeAt(0);if(r(D)){if(r(f.charCodeAt(1))&&!r(f.charCodeAt(2))){let g=3;const j=g;for(;g<N&&!r(f.charCodeAt(g));g++);if(j!==g&&!r(f.charCodeAt(g+1))){for(g+=1;g<N;g++)if(r(f.charCodeAt(g)))return f.slice(0,g+1).replace(/[\\/]/g,v)}}return v}else if(l(D)&&f.charCodeAt(1)===58)return r(f.charCodeAt(2))?f.slice(0,2)+v:f.slice(0,2);let O=f.indexOf("://");if(O!==-1){for(O+=3;O<N;O++)if(r(f.charCodeAt(O)))return f.slice(0,O+1)}return""}function m(f){if(!E.$i||!f||f.length<5)return!1;let v=f.charCodeAt(0);if(v!==92||(v=f.charCodeAt(1),v!==92))return!1;let N=2;const D=N;for(;N<f.length&&(v=f.charCodeAt(N),v!==92);N++);return!(D===N||(v=f.charCodeAt(N+1),isNaN(v)||v===92))}const d=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,v=E.$i){const N=v?d:b;return!(!f||f.length===0||/^\s+$/.test(f)||(N.lastIndex=0,N.test(f))||v&&o.test(f)||f==="."||f===".."||v&&f[f.length-1]==="."||v&&f.length!==f.trim().length||f.length>255)}function t(f,v,N){const D=f===v;return!N||D?D:!f||!v?!1:(0,S.$lf)(f,v)}function s(f,v,N,D=I.sep){if(f===v)return!0;if(!f||!v||v.length>f.length)return!1;if(N){if(!(0,S.$mf)(f,v))return!1;if(v.length===f.length)return!0;let g=v.length;return v.charAt(v.length-1)===D&&g--,f.charAt(g)===D}return v.charAt(v.length-1)!==D&&(v+=D),f.indexOf(v)===0}function l(f){return f>=65&&f<=90||f>=97&&f<=122}function T(f,v){return E.$i&&f.endsWith(":")&&(f+=I.sep),(0,I.$jc)(f)||(f=(0,I.$kc)(v,f)),f=(0,I.$ic)(f),E.$i?(f=(0,S.$6e)(f,I.sep),f.endsWith(":")&&(f+=I.sep)):(f=(0,S.$6e)(f,I.sep),f||(f=I.sep)),f}function P(f){const v=(0,I.$ic)(f);return E.$i?f.length>3?!1:A(v)&&(f.length===2||v.charCodeAt(2)===92):v===I.$hc.sep}function A(f,v=E.$i){return v?l(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}function k(f,v=E.$i){return A(f,v)?f[0]:void 0}function a(f,v,N){return v.length>f.length?-1:f===v?0:(N&&(f=f.toLowerCase(),v=v.toLowerCase()),f.indexOf(v))}function $(f){const v=f.split(":");let N,D,O;for(const g of v){const j=Number(g);(0,C.$Zf)(j)?D===void 0?D=j:O===void 0&&(O=j):N=N?[N,g].join(":"):g}if(!N)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:N,line:D!==void 0?D:void 0,column:O!==void 0?O:D!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",U="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(f,v,N=8){let D="";for(let g=0;g<N;g++){let j;g===0&&E.$i&&!v&&(N===3||N===4)?j=U:j=w,D+=j.charAt(Math.floor(Math.random()*j.length))}let O;return v?O=`${v}-${D}`:O=D,f?(0,I.$kc)(f,O):O}}),define(K[20],V([0,1,9,3,19,11,18]),function(z,e,I,E,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=i,e.$sg=u,e.$wg=d;var c;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.vscodeManagedRemoteResource="vscode-managed-remote-resource",n.vscodeUserData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.vscodeChatCodeBlock="vscode-chat-code-block",n.vscodeChatSesssion="vscode-chat-editor",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp",n.vsls="vsls",n.vscodeSourceControl="vscode-scm",n.codeSetting="code-setting"})(c||(e.Schemas=c={}));function i(n,t){return C.URI.isUri(n)?(0,S.$lf)(n.scheme,t):(0,S.$mf)(n,t+":")}function u(n,...t){return t.some(s=>i(n,s))}e.$tg="vscode-tkn",e.$ug="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(t){this.d=t}setDelegate(t){this.e=t}setServerRootPath(t,s){this.f=d(t,s)}getServerRootPath(){return this.f}get g(){return r.$hc.join(this.f,c.vscodeRemoteResource)}set(t,s,l){this.a[t]=s,this.b[t]=l}setConnectionToken(t,s){this.c[t]=s}getPreferredWebSchema(){return this.d}rewrite(t){if(this.e)try{return this.e(t)}catch(k){return I.$1(k),t}const s=t.authority;let l=this.a[s];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const T=this.b[s],P=this.c[s];let A=`path=${encodeURIComponent(t.path)}`;return typeof P=="string"&&(A+=`&${e.$ug}=${encodeURIComponent(P)}`),C.URI.from({scheme:E.$o?this.d:c.vscodeRemoteResource,authority:`${l}:${T}`,path:this.g,query:A})}}e.$vg=new m;function d(n,t){return r.$hc.join(t??"/",`${n.quality??"oss"}-${n.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class b{static{this.a=e.$Bg}asBrowserUri(t){const s=this.b(t,z);return this.uriToBrowserUri(s)}uriToBrowserUri(t){return t.scheme===c.vscodeRemote?e.$vg.rewrite(t):t.scheme===c.file&&(E.$m||E.$q===`${c.vscodeFileResource}://${b.a}`)?t.with({scheme:c.vscodeFileResource,authority:t.authority||b.a,query:null,fragment:null}):t}asFileUri(t){const s=this.b(t,z);return this.uriToFileUri(s)}uriToFileUri(t){return t.scheme===c.vscodeFileResource?t.with({scheme:c.file,authority:t.authority!==b.a?t.authority:null,query:null,fragment:null}):t}b(t,s){return C.URI.isUri(t)?t:C.URI.parse(s.toUrl(t))}}e.$Cg=new b;var o;(function(n){const t=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);n.CoopAndCoep=Object.freeze(t.get("3"));const s="vscode-coi";function l(P){let A;typeof P=="string"?A=new URL(P).searchParams:P instanceof URL?A=P.searchParams:C.URI.isUri(P)&&(A=new URL(P.toString(!0)).searchParams);const k=A?.get(s);if(k)return t.get(k)}n.getHeadersFromQuery=l;function T(P,A,k){if(!globalThis.crossOriginIsolated)return;const a=A&&k?"3":k?"2":"1";P instanceof URLSearchParams?P.set(s,a):P[s]=a}n.addSearchParam=T})(o||(e.COI=o={}))}),define(K[37],V([0,1,24,20,3,11]),function(z,e,I,E,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JD=m;class r{constructor(b,o,n){this.id=b,this.dependencies=o,this.callback=n}}class c{static{this.INSTANCE=new c}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,o,n)=>{typeof b!="string"&&(n=o,o=b,b=null),(typeof o!="object"||!Array.isArray(o))&&(n=o,o=null),this.c.push(new r(b,o,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const o=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!o)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(o.dependencies)&&o.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${o.dependencies.join(", ")}`);return typeof o.callback=="function"?o.callback([]):o.callback}h(b){return new Promise((o,n)=>{const t=document.createElement("script");t.setAttribute("async","async"),t.setAttribute("type","text/javascript");const s=()=>{t.removeEventListener("load",l),t.removeEventListener("error",T)},l=P=>{s(),o(this.c.pop())},T=P=>{s(),n(P)};t.addEventListener("load",l),t.addEventListener("error",T),this.f&&(b=this.f.createScriptURL(b)),t.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(t)})}i(b){return new Promise((o,n)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),o(this.c.pop())}catch(t){n(t)}})}async j(b){try{const o=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,t=globalThis._VSCODE_NODE_MODULES.module,s=C.URI.parse(b).fsPath,l=o.readFileSync(s).toString(),T=t.wrap(l.replace(/^#!.*/,""));return new n.Script(T).runInThisContext().apply(),this.c.pop()}catch(o){throw o}}}const i=new Map;let u={};typeof globalThis.require=="object"&&(u=globalThis.require.paths??{});async function m(d,b,o){if(I.$T){o===void 0&&(o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),u[d]&&(d=u[d]);const n=`${d}/${b}`;if(i.has(n))return i.get(n);let t;if(/^\w[\w\d+.-]*:\/\//.test(n))t=n;else{const P=`${o&&!S.$o?E.$zg:E.$yg}/${n}`;t=E.$Cg.asBrowserUri(P).toString(!0)}const s=c.INSTANCE.load(t);return i.set(n,s),s}else return await new Promise((n,t)=>{z([d],n,t)})}}),define(K[21],V([0,1,36,20,18,3,19,11]),function(z,e,I,E,S,C,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=i,e.$5g=m,e.$6g=b;function i(o){return(0,c.$xc)(o,!0)}class u{constructor(n){this.a=n}compare(n,t,s=!1){return n===t?0:(0,r.$ef)(this.getComparisonKey(n,s),this.getComparisonKey(t,s))}isEqual(n,t,s=!1){return n===t?!0:!n||!t?!1:this.getComparisonKey(n,s)===this.getComparisonKey(t,s)}getComparisonKey(n,t=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,t,s=!1){if(n.scheme===t.scheme){if(n.scheme===E.Schemas.file)return I.$ig(i(n),i(t),this.a(n))&&n.query===t.query&&(s||n.fragment===t.fragment);if((0,e.$1g)(n.authority,t.authority))return I.$ig(n.path,t.path,this.a(n),"/")&&n.query===t.query&&(s||n.fragment===t.fragment)}return!1}joinPath(n,...t){return c.URI.joinPath(n,...t)}basenameOrAuthority(n){return(0,e.$Sg)(n)||n.authority}basename(n){return S.$hc.basename(n.path)}extname(n){return S.$hc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let t;return n.scheme===E.Schemas.file?t=c.URI.file(S.$nc(i(n))).path:(t=S.$hc.dirname(n.path),n.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),t="/")),n.with({path:t})}normalizePath(n){if(!n.path.length)return n;let t;return n.scheme===E.Schemas.file?t=c.URI.file(S.$ic(i(n))).path:t=S.$hc.normalize(n.path),n.with({path:t})}relativePath(n,t){if(n.scheme!==t.scheme||!(0,e.$1g)(n.authority,t.authority))return;if(n.scheme===E.Schemas.file){const T=S.$mc(i(n),i(t));return C.$i?I.$cg(T):T}let s=n.path||"/";const l=t.path||"/";if(this.a(n)){let T=0;for(const P=Math.min(s.length,l.length);T<P&&!(s.charCodeAt(T)!==l.charCodeAt(T)&&s.charAt(T).toLowerCase()!==l.charAt(T).toLowerCase());T++);s=l.substr(0,T)+s.substr(T)}return S.$hc.relative(s,l)}resolvePath(n,t){if(n.scheme===E.Schemas.file){const s=c.URI.file(S.$lc(i(n),t));return n.with({authority:s.authority,path:s.path})}return t=I.$dg(t),n.with({path:S.$hc.resolve(n.path,t)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,t){return n===t||n!==void 0&&t!==void 0&&(0,r.$lf)(n,t)}hasTrailingPathSeparator(n,t=S.sep){if(n.scheme===E.Schemas.file){const s=i(n);return s.length>I.$eg(s).length&&s[s.length-1]===t}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,t=S.sep){return(0,e.$2g)(n,t)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,t=S.sep){let s=!1;if(n.scheme===E.Schemas.file){const l=i(n);s=l!==void 0&&l.length===I.$eg(l).length&&l[l.length-1]===t}else{t="/";const l=n.path;s=l.length===1&&l.charCodeAt(l.length-1)===47}return!s&&!(0,e.$2g)(n,t)?n.with({path:n.path+"/"}):n}}e.$Kg=u,e.$Lg=new u(()=>!1),e.$Mg=new u(o=>o.scheme===E.Schemas.file?!C.$k:!0),e.$Ng=new u(o=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function m(o,n){const t=[];for(let s=0;s<o.length;s++){const l=n(o[s]);o.some((T,P)=>P===s?!1:(0,e.$Pg)(l,n(T)))||t.push(o[s])}return t}var d;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function n(t){const s=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(P=>{const[A,k]=P.split(":");A&&k&&s.set(A,k)});const T=t.path.substring(0,t.path.indexOf(";"));return T&&s.set(o.META_DATA_MIME,T),s}o.parseMetaData=n})(d||(e.DataUri=d={}));function b(o,n,t){if(n){let s=o.path;return s&&s[0]!==S.$hc.sep&&(s=S.$hc.sep+s),o.with({scheme:t,authority:n,path:s})}return o.with({scheme:t})}}),define(K[22],V([0,1,28,9,38,2,21,3,31,30]),function(z,e,I,E,S,C,r,c,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=m,e.$8g=d,e.$9g=b,e.$0g=o,e.$$g=n,e.$_g=t,e.$ah=s,e.$bh=l,e.$jh=f,e.$kh=v,e.$lh=N,e.$mh=D,e.$nh=O,e.$Ch=ue,e.$Kh=de;function m(M){return!!M&&typeof M.then=="function"}function d(M){const h=new I.$ee,y=M(h.token),L=new Promise((R,F)=>{const _=h.token.onCancellationRequested(()=>{_.dispose(),F(new E.$5)});Promise.resolve(y).then(Z=>{_.dispose(),h.dispose(),R(Z)},Z=>{_.dispose(),h.dispose(),F(Z)})});return new class{cancel(){h.cancel(),h.dispose()}then(R,F){return L.then(R,F)}catch(R){return this.then(void 0,R)}finally(R){return L.finally(R)}}}function b(M,h,y){return new Promise((L,R)=>{const F=h.onCancellationRequested(()=>{F.dispose(),L(y)});M.then(L,R).finally(()=>F.dispose())})}function o(M,h){return new Promise((y,L)=>{const R=h.onCancellationRequested(()=>{R.dispose(),L(new E.$5)});M.then(y,L).finally(()=>R.dispose())})}async function n(M){let h=-1;const y=M.map((L,R)=>L.then(F=>(h=R,F)));try{return await Promise.race(y)}finally{M.forEach((L,R)=>{R!==h&&L.cancel()})}}function t(M,h,y){let L;const R=setTimeout(()=>{L?.(void 0),y?.()},h);return Promise.race([M.finally(()=>clearTimeout(R)),new Promise(F=>L=F)])}function s(M){return new Promise((h,y)=>{const L=M();m(L)?L.then(h,y):h(L)})}function l(){let M,h;return{promise:new Promise((L,R)=>{M=L,h=R}),resolve:M,reject:h}}class T{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=h,!this.b){const y=()=>{if(this.b=null,this.f)return;const L=this.queue(this.d);return this.d=null,L};this.b=new Promise(L=>{this.a.then(y,y).then(L)})}return new Promise((y,L)=>{this.b.then(y,L)})}return this.a=h(),new Promise((y,L)=>{this.a.then(R=>{this.a=null,y(R)},R=>{this.a=null,L(R)})})}dispose(){this.f=!0}}e.$ch=T;class P{constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$dh=P;class A{constructor(){this.a=new Map}queue(h,y){const R=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(h)===R&&this.a.delete(h)});return this.a.set(h,R),R}}e.$eh=A;const k=(M,h)=>{let y=!0;const L=setTimeout(()=>{y=!1,h()},M);return{isTriggered:()=>y,dispose:()=>{clearTimeout(L),y=!1}}},a=M=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,M())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class ${constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,y=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((R,F)=>{this.d=R,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const L=()=>{this.a=null,this.d?.(null)};return this.a=y===i.$4d?a(L):k(y,L),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new E.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=$;class w{constructor(h){this.a=new $(h),this.b=new T}trigger(h,y){return this.a.trigger(()=>this.b.queue(h),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=w;class U{constructor(){this.a=!1,this.b=new Promise((h,y)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=U;class p extends U{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$ih=p;function f(M,h){return h?new Promise((y,L)=>{const R=setTimeout(()=>{F.dispose(),y()},M),F=h.onCancellationRequested(()=>{clearTimeout(R),F.dispose(),L(new E.$5)})}):d(y=>f(M,y))}function v(M,h=0,y){const L=setTimeout(()=>{M(),y&&R.dispose()},h),R=(0,C.$Sc)(()=>{clearTimeout(L),y?.deleteAndLeak(R)});return y?.add(R),R}function N(M){const h=[];let y=0;const L=M.length;function R(){return y<L?M[y++]():null}function F(_){_!=null&&h.push(_);const Z=R();return Z?Z.then(F):Promise.resolve(h)}return Promise.resolve(null).then(F)}function D(M,h=L=>!!L,y=null){let L=0;const R=M.length,F=()=>{if(L>=R)return Promise.resolve(y);const _=M[L++];return Promise.resolve(_()).then(X=>h(X)?Promise.resolve(X):F())};return F()}function O(M,h=L=>!!L,y=null){if(M.length===0)return Promise.resolve(y);let L=M.length;const R=()=>{L=-1;for(const F of M)F.cancel?.()};return new Promise((F,_)=>{for(const Z of M)Z.then(X=>{--L>=0&&h(X)?(R(),F(X)):L===0&&F(y)}).catch(X=>{--L>=0&&(R(),_(X))})})}class g{constructor(h){this.a=0,this.b=!1,this.f=h,this.g=[],this.d=0,this.h=new S.$7d}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(h){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((y,L)=>{this.g.push({factory:h,c:y,e:L}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const h=this.g.shift();this.d++;const y=h.factory();y.then(h.c,h.e),y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=g;class j extends g{constructor(){super(1)}}e.$ph=j;class B{constructor(){this.a=new te,this.b=0}queue(h){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,h())):this.a.run(this.b++,h())}}e.$qh=B;class q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const h=new x;return this.b.add(h),h.p}g(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueSize(h,y=r.$Lg){const L=y.getComparisonKey(h);return this.a.get(L)?.size??0}queueFor(h,y,L=r.$Lg){const R=L.getComparisonKey(h);let F=this.a.get(R);if(!F){F=new j;const _=this.f++,Z=S.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(R),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new C.$4c),this.d.set(_,Z),this.a.set(R,F)}return F.queue(y)}h(){this.g()&&this.j()}j(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=q;class G{constructor(h,y){this.a=-1,typeof h=="function"&&typeof y=="number"&&this.setIfNotSet(h,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},y)}setIfNotSet(h,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},y))}}e.$sh=G;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(h,y,L=globalThis){this.cancel();const R=L.setInterval(()=>{h()},y);this.d=(0,C.$Sc)(()=>{L.clearInterval(R),this.d=void 0})}dispose(){this.cancel()}}e.$th=J;class W{constructor(h,y){this.b=-1,this.a=h,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=W;class H{constructor(h,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=h,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=H;class Y extends W{constructor(h,y){super(h,y),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$wh=Y;class he extends C.$Uc{constructor(h,y){super(),this.g=h,this.h=y,this.a=[],this.b=this.B(new C.$Vc),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of h)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(M,h)=>{(0,c.$B)(()=>{if(y)return;const L=Date.now()+15;h(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,L-Date.now())}}))});let y=!1;return{dispose(){y||(y=!0)}}}:e.$zh=(M,h,y)=>{const L=M.requestIdleCallback(h,typeof y=="number"?{timeout:y}:void 0);let R=!1;return{dispose(){R||(R=!0,M.cancelIdleCallback(L))}}},e.$yh=M=>(0,e.$zh)(globalThis,M)}();class ee{constructor(h,y){this.g=!1,this.d=()=>{try{this.j=y()}catch(L){this.l=L}finally{this.g=!0}},this.f=(0,e.$zh)(h,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=ee;class oe extends ee{constructor(h){super(globalThis,h)}}e.$Bh=oe;async function ue(M,h,y){let L;for(let R=0;R<y;R++)try{return await M()}catch(F){L=F,await f(h)}throw L}class te{isRunning(h){return typeof h=="number"?this.a?.taskId===h:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(h,y,L){return this.a={taskId:h,cancel:()=>L?.(),promise:y},y.then(()=>this.d(h),()=>this.d(h)),y}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this.b)this.b.run=h;else{const{promise:y,resolve:L,reject:R}=l();this.b={run:h,promise:y,promiseResolve:L,promiseReject:R}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=te;class ce{constructor(h,y=()=>Date.now()){this.d=h,this.f=y,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$Eh=ce;var ne;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,y)=>{this.a=h,this.b=y})}complete(h){return new Promise(y=>{this.a(h),this.d={outcome:0,value:h},y()})}error(h){return new Promise(y=>{this.b(h),this.d={outcome:1,value:h},y()})}cancel(){return this.error(new E.$5)}}e.$Fh=x;var ie;(function(M){async function h(L){let R;const F=await Promise.all(L.map(_=>_.then(Z=>Z,Z=>{R||(R=Z)})));if(typeof R<"u")throw R;return F}M.settled=h;function y(L){return new Promise(async(R,F)=>{try{await L(R,F)}catch(_){F(_)}})}M.withAsyncBody=y})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(h){this.a=void 0,this.b=void 0,this.d=!1,this.promise=h.then(y=>(this.a=y,this.d=!0,y),y=>{throw this.b=y,this.d=!0,y})}requireValue(){if(!this.d)throw new E.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=se;class le{constructor(h){this.b=h,this.a=new u.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=le;var re;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(re||(re={}));class Q{static fromArray(h){return new Q(y=>{y.emitMany(h)})}static fromPromise(h){return new Q(async y=>{y.emitMany(await h)})}static fromPromises(h){return new Q(async y=>{await Promise.all(h.map(async L=>y.emitOne(await L)))})}static merge(h){return new Q(async y=>{await Promise.all(h.map(async L=>{for await(const R of L)y.emitOne(R)}))})}static{this.EMPTY=Q.fromArray([])}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new S.$7d,queueMicrotask(async()=>{const y={emitOne:L=>this.g(L),emitMany:L=>this.h(L),reject:L=>this.k(L)};try{await Promise.resolve(h(y)),this.j()}catch(L){this.k(L)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(h,y){return new Q(async L=>{for await(const R of h)L.emitOne(y(R))})}map(h){return Q.map(this,h)}static filter(h,y){return new Q(async L=>{for await(const R of h)y(R)&&L.emitOne(R)})}filter(h){return Q.filter(this,h)}static coalesce(h){return Q.filter(h,y=>!!y)}coalesce(){return Q.coalesce(this)}static async toPromise(h){const y=[];for await(const L of h)y.push(L);return y}toPromise(){return Q.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$Ih=Q;class ae extends Q{constructor(h,y){super(y),this.l=h}cancel(){this.l.cancel()}}e.$Jh=ae;function de(M){const h=new I.$ee,y=M(h.token);return new ae(h,async L=>{const R=h.token.onCancellationRequested(()=>{R.dispose(),h.dispose(),L.reject(new E.$5)});try{for await(const F of y){if(h.token.isCancellationRequested)return;L.emitOne(F)}R.dispose(),h.dispose()}catch(F){R.dispose(),h.dispose(),L.reject(F)}})}class fe{constructor(){this.a=new x,this.b=new Q(L=>{if(h){L.reject(h);return}return y&&L.emitMany(y),this.d=R=>L.reject(R),this.f=R=>L.emitOne(R),this.a.p});let h,y;this.f=L=>{y||(y=[]),y.push(L)},this.d=L=>{h||(h=L)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(h){this.d(h),this.a.complete()}emitOne(h){this.f(h)}}e.$Lh=fe}),define(K[23],V([0,1,39]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=void 0,e.$GC=E,e.$HC=S,e.$FC=new class{clone(){return this}equals(C){return this===C}};function E(C,r){return new I.$Zt([new I.$Yt(0,"",C)],r)}function S(C,r){const c=new Uint32Array(2);return c[0]=0,c[1]=(C<<0|0|0|32768|2<<24)>>>0,new I.$1t(c,r===null?e.$FC:r)}}),define(K[40],V([0,1,22,9,3,41,14,16,49,23,32,17,10]),function(z,e,I,E,S,C,r,c,i,u,m,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=e.$OC=e.$NC=e.$MC=e.$LC=e.$KC=void 0;var o;(function(k){k[k.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(o||(o={}));class n{constructor(a,$){this.tokenizationSupport=$,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(a)}getStartState(a){return this.store.getStartState(a,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$KC=n;class t extends n{constructor(a,$,w,U){super(a,$),this._textModel=w,this._languageIdCodec=U}updateTokensUntilLine(a,$){const w=this._textModel.getLanguageId();for(;;){const U=this.getFirstInvalidLine();if(!U||U.lineNumber>$)break;const p=this._textModel.getLineContent(U.lineNumber),f=P(this._languageIdCodec,w,this.tokenizationSupport,p,!0,U.startState);a.add(U.lineNumber,f.tokens),this.store.setEndState(U.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter(a,$){const w=this.getStartState(a.lineNumber);if(!w)return 0;const U=this._textModel.getLanguageId(),p=this._textModel.getLineContent(a.lineNumber),f=p.substring(0,a.column-1)+$+p.substring(a.column-1),v=P(this._languageIdCodec,U,this.tokenizationSupport,f,!0,w),N=new b.$Pt(v.tokens,f,this._languageIdCodec);if(N.getCount()===0)return 0;const D=N.findTokenIndexAtOffset(a.column-1);return N.getStandardTokenType(D)}tokenizeLineWithEdit(a,$,w){const U=a.lineNumber,p=a.column,f=this.getStartState(U);if(!f)return null;const v=this._textModel.getLineContent(U),N=v.substring(0,p-1)+w+v.substring(p-1+$),D=this._textModel.getLanguageIdAtPosition(U,0),O=P(this._languageIdCodec,D,this.tokenizationSupport,N,!0,f);return new b.$Pt(O.tokens,N,this._languageIdCodec)}hasAccurateTokensForLine(a){const $=this.store.getFirstInvalidEndStateLineNumberOrMax();return a<$}isCheapToTokenize(a){const $=this.store.getFirstInvalidEndStateLineNumberOrMax();return a<$||a===$&&this._textModel.getLineLength(a)<2048}tokenizeHeuristically(a,$,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if($<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(a,w),{heuristicTokens:!1};let U=this.b($);const p=this._textModel.getLanguageId();for(let f=$;f<=w;f++){const v=this._textModel.getLineContent(f),N=P(this._languageIdCodec,p,this.tokenizationSupport,v,!0,U);a.add(f,N.tokens),U=N.endState}return{heuristicTokens:!0}}b(a){let $=this._textModel.getLineFirstNonWhitespaceColumn(a);const w=[];let U=null;for(let v=a-1;$>1&&v>=1;v--){const N=this._textModel.getLineFirstNonWhitespaceColumn(v);if(N!==0&&N<$&&(w.push(this._textModel.getLineContent(v)),$=N,U=this.getStartState(v),U))break}U||(U=this.tokenizationSupport.getInitialState()),w.reverse();const p=this._textModel.getLanguageId();let f=U;for(const v of w)f=P(this._languageIdCodec,p,this.tokenizationSupport,v,!1,f).endState;return f}}e.$LC=t;class s{constructor(a){this.d=a,this.a=new l,this.b=new T,this.b.addRange(new i.$jt(1,a+1))}getEndState(a){return this.a.getEndState(a)}setEndState(a,$){if(!$)throw new E.$cb("Cannot set null/undefined state");this.b.delete(a);const w=this.a.setEndState(a,$);return w&&a<this.d&&this.b.addRange(new i.$jt(a+1,a+2)),w}acceptChange(a,$){this.d+=$-a.length,this.a.acceptChange(a,$),this.b.addRangeAndResize(new i.$jt(a.startLineNumber,a.endLineNumberExclusive),$)}acceptChanges(a){for(const $ of a){const[w]=(0,r.$Ot)($.text);this.acceptChange(new c.$lt($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}invalidateEndStateRange(a){this.b.addRange(new i.$jt(a.startLineNumber,a.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(a,$){return a===1?$:this.getEndState(a-1)}getFirstInvalidLine(a){const $=this.getFirstInvalidEndStateLineNumber();if($===null)return null;const w=this.getStartState($,a);if(!w)throw new E.$cb("Start state must be defined");return{lineNumber:$,startState:w}}}e.$MC=s;class l{constructor(){this.a=new m.$IC(null)}getEndState(a){return this.a.get(a)}setEndState(a,$){const w=this.a.get(a);return w&&w.equals($)?!1:(this.a.set(a,$),!0)}acceptChange(a,$){let w=a.length;$>0&&w>0&&(w--,$--),this.a.replace(a.startLineNumber,w,$)}acceptChanges(a){for(const $ of a){const[w]=(0,r.$Ot)($.text);this.acceptChange(new c.$lt($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}}e.$NC=l;class T{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const a=this.a[0];return a.start+1===a.endExclusive?this.a.shift():this.a[0]=new i.$jt(a.start+1,a.endExclusive),a.start}delete(a){const $=this.a.findIndex(w=>w.contains(a));if($!==-1){const w=this.a[$];w.start===a?w.endExclusive===a+1?this.a.splice($,1):this.a[$]=new i.$jt(a+1,w.endExclusive):w.endExclusive===a+1?this.a[$]=new i.$jt(w.start,a):this.a.splice($,1,new i.$jt(w.start,a),new i.$jt(a+1,w.endExclusive))}}addRange(a){i.$jt.addRange(a,this.a)}addRangeAndResize(a,$){let w=0;for(;!(w>=this.a.length||a.start<=this.a[w].endExclusive);)w++;let U=w;for(;!(U>=this.a.length||a.endExclusive<this.a[U].start);)U++;const p=$-a.length;for(let f=U;f<this.a.length;f++)this.a[f]=this.a[f].delta(p);if(w===U){const f=new i.$jt(a.start,a.start+$);f.isEmpty||this.a.splice(w,0,f)}else{const f=Math.min(a.start,this.a[w].start),v=Math.max(a.endExclusive,this.a[U-1].endExclusive),N=new i.$jt(f,v+p);N.isEmpty?this.a.splice(w,U-w):this.a.splice(w,U-w,N)}}toString(){return this.a.map(a=>a.toString()).join(" + ")}}e.$OC=T;function P(k,a,$,w,U,p){let f=null;if($)try{f=$.tokenizeEncoded(w,U,p.clone())}catch(v){(0,E.$1)(v)}return f||(f=(0,u.$HC)(k.encodeLanguageId(a),p)),b.$Pt.convertToEndOffset(f.tokens,w.length),f}class A{constructor(a,$){this.b=a,this.d=$,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,I.$yh)(a=>{this.f=!1,this.h(a)}))}h(a){const $=Date.now()+a.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<$?(0,S.$B)(w):this.g())};w()}j(){const a=this.b._textModel.getLineCount(),$=new d.$JC,w=C.$3d.create(!1);do if(w.elapsed()>1||this.l($)>=a)break;while(this.k());this.d.setTokens($.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(a){const $=this.b?.getFirstInvalidLine();return $?(this.b.updateTokensUntilLine(a,$.lineNumber),$.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(a,$){this.b.store.invalidateEndStateRange(new c.$lt(a,$))}}e.$PC=A}),define(K[42],V([0,1,38,2,41,15,39]),function(z,e,I,E,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IKb=void 0;class c extends E.$Uc{constructor(u,m,d,b,o,n,t){super(),this.c=u,this.f=m,this.g=d,this.h=b,this.j=o,this.m=n,this.n=t,this.a=[],this.b=this.B(new I.$7d),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(u,m,d){throw new Error("Not supported!")}createBackgroundTokenizer(u,m){if(this.h)return this.h(u,m)}tokenizeEncoded(u,m,d){const b=Math.random()*1e4<1,o=this.n||b,n=o?new S.$3d(!0):void 0,t=this.c.tokenizeLine2(u,d,500);if(o){const l=n.elapsed();(b||l>32)&&this.m(l,u.length,b)}if(t.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${u.substring(0,100)}`),new r.$1t(t.tokens,d);if(this.g){const l=this.a,T=t.tokens;for(let P=0,A=T.length>>>1;P<A;P++){const k=T[(P<<1)+1],a=C.$Mt.getLanguageId(k);l[a]||(l[a]=!0,this.b.fire(a))}}let s;return d.equals(t.ruleStack)?s=d:s=t.ruleStack,new r.$1t(t.tokens,s)}}e.$IKb=c}),define(K[43],V([0,1,23,2,12]),function(z,e,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JKb=void 0;class C extends E.$Uc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,i,u){super(),this.a=c,this.b=i,this.c=u,this.B((0,S.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(c,i,u){throw new Error("Not supported!")}tokenizeEncoded(c,i,u){return c.length>=this.c.get()?(0,I.$HC)(this.a,u):this.b.tokenizeEncoded(c,i,u)}createBackgroundTokenizer(c,i){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(c,i)}}e.$JKb=C}),define(K[44],V([0,1,37,22,12,3,16,50,40,17,10,42,43]),function(z,e,I,E,S,C,r,c,i,u,m,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OKb=void 0;class o extends c.$Hv{constructor(s,l,T,P,A,k,a,$){super(s,l,T,P),this.s=A,this.t=k,this.u=a,this.a=null,this.b=!1,this.c=(0,S.observableValue)(this,-1),this.q=new E.$uh(()=>this.w(),10),this.c.set($,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,l){this.t=s,this.u=l,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,l){this.a&&(this.a.store.invalidateEndStateRange(new r.$lt(s,l)),this.q.schedule())}async v(){this.a=null;const s=this.t,l=this.u,T=await this.s.getOrCreateGrammar(s,l);if(!(this.b||s!==this.t||l!==this.u||!T)){if(T.grammar){const P=new b.$JKb(this.u,new d.$IKb(T.grammar,T.initialState,!1,void 0,()=>!1,(A,k,a)=>{this.s.reportTokenizationTime(A,s,T.sourceExtensionId,k,a)},!1),this.c);this.a=new i.$KC(this.f.length,P)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:l}=await(0,I.$JD)("vscode-textmate","release/main.js");this.m=l}const s=new Date().getTime();for(;;){let l=0;const T=new u.$JC,P=new n;for(;;){const a=this.a.getFirstInvalidLine();if(a===null||l>200)break;l++;const $=this.f[a.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded($,!0,a.startState);if(this.a.store.setEndState(a.lineNumber,w.endState)){const p=this.m(a.startState,w.endState);P.setState(a.lineNumber,p)}else P.setState(a.lineNumber,null);if(m.$Pt.convertToEndOffset(w.tokens,$.length),T.add(a.lineNumber,w.tokens),new Date().getTime()-s>20)break}if(l===0)break;const A=P.getStateDeltas();if(this.s.setTokensAndStates(this.h,T.serialize(),A),new Date().getTime()-s>20){(0,C.$B)(()=>this.w());return}}}}e.$OKb=o;class n{constructor(){this.a=-1,this.b=[]}setState(s,l){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(l):this.b.push({startLineNumber:s,stateDeltas:[l]}),this.a=s}getStateDeltas(){return this.b}}}),define(K[45],V([0,1,21]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LKb=void 0;class E{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(C){if(this.a[C.scopeName]){const r=this.a[C.scopeName];I.$Og(r.location,C.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${C.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${C.location.toString()}`)}this.a[C.scopeName]=C}getGrammarDefinition(C){return this.a[C]||null}}e.$LKb=E}),define(K[46],V([0,1,2,45]),function(z,e,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NKb=e.$MKb=void 0,e.$MKb="No TM Grammar registered for this language.";class S extends I.$Uc{constructor(r,c,i,u){super(),this.a=r,this.b=i.INITIAL,this.c=new E.$LKb,this.f={},this.g={},this.h=new Map,this.j=this.B(new i.Registry({onigLib:u,loadGrammar:async m=>{const d=this.c.getGrammarDefinition(m);if(!d)return this.a.logTrace(`No grammar found for scope ${m}`),null;const b=d.location;try{const o=await this.a.readFile(b);return i.parseRawGrammar(o,b.path)}catch(o){return this.a.logError(`Unable to load and parse grammar for scope ${m} from ${b}`,o),null}},getInjections:m=>{const d=m.split(".");let b=[];for(let o=1;o<=d.length;o++){const n=d.slice(0,o).join(".");b=[...b,...this.f[n]||[]]}return b}}));for(const m of c){if(this.c.register(m),m.injectTo){for(const d of m.injectTo){let b=this.f[d];b||(this.f[d]=b=[]),b.push(m.scopeName)}if(m.embeddedLanguages)for(const d of m.injectTo){let b=this.g[d];b||(this.g[d]=b=[]),b.push(m.embeddedLanguages)}}m.language&&this.h.set(m.language,m.scopeName)}}has(r){return this.h.has(r)}setTheme(r,c){this.j.setTheme(r,c)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,c){const i=this.h.get(r);if(typeof i!="string")throw new Error(e.$MKb);const u=this.c.getGrammarDefinition(i);if(!u)throw new Error(e.$MKb);const m=u.embeddedLanguages;if(this.g[i]){const o=this.g[i];for(const n of o)for(const t of Object.keys(n))m[t]=n[t]}const d=Object.keys(m).length>0;let b;try{b=await this.j.loadGrammarWithConfiguration(i,c,{embeddedLanguages:m,tokenTypes:u.tokenTypes,balancedBracketSelectors:u.balancedBracketSelectors,unbalancedBracketSelectors:u.unbalancedBracketSelectors})}catch(o){throw o.message&&o.message.startsWith("No grammar provided for")?new Error(e.$MKb):o}return{languageId:r,grammar:b,initialState:this.b,containsEmbeddedLanguages:d,sourceExtensionId:u.sourceExtensionId}}}e.$NKb=S}),define(K[51],V([0,1,11,46,44]),function(z,e,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=void 0,e.create=C;function C(c,i){return new r(c,i)}class r{constructor(i,u){this.f=u,this.b=new Map,this.c=[],this.a=i.host;const m=u.grammarDefinitions.map(d=>({location:I.URI.revive(d.location),language:d.language,scopeName:d.scopeName,embeddedLanguages:d.embeddedLanguages,tokenTypes:d.tokenTypes,injectTo:d.injectTo,balancedBracketSelectors:d.balancedBracketSelectors,unbalancedBracketSelectors:d.unbalancedBracketSelectors,sourceExtensionId:d.sourceExtensionId}));this.d=this.g(m)}async g(i){const u=this.f.textmateMainUri,m=await new Promise((t,s)=>{z([u],t,s)}),d=await new Promise((t,s)=>{z([this.f.onigurumaMainUri],t,s)}),o=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await d.loadWASM(o);const n=Promise.resolve({createOnigScanner:t=>d.createOnigScanner(t),createOnigString:t=>d.createOnigString(t)});return new E.$NKb({logTrace:t=>{},logError:(t,s)=>console.error(t,s),readFile:t=>this.a.readFile(t)},i,m,n)}acceptNewModel(i){const u=I.URI.revive(i.uri),m=this;this.b.set(i.controllerId,new S.$OKb(u,i.lines,i.EOL,i.versionId,{async getOrCreateGrammar(d,b){const o=await m.d;return o?(m.c[b]||(m.c[b]=o.createGrammar(d,b)),m.c[b]):Promise.resolve(null)},setTokensAndStates(d,b,o){m.a.setTokensAndStates(i.controllerId,d,b,o)},reportTokenizationTime(d,b,o,n,t){m.a.reportTokenizationTime(d,b,o,n,t)}},i.languageId,i.encodedLanguageId,i.maxTokenizationLineLength))}acceptModelChanged(i,u){this.b.get(i).onEvents(u)}retokenize(i,u,m){this.b.get(i).retokenize(u,m)}acceptModelLanguageChanged(i,u,m){this.b.get(i).onLanguageId(u,m)}acceptRemovedModel(i){const u=this.b.get(i);u&&(u.dispose(),this.b.delete(i))}async acceptTheme(i,u){(await this.d)?.setTheme(i,u)}acceptMaxTokenizationLineLength(i,u){this.b.get(i).acceptMaxTokenizationLineLength(u)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/409da0445d397e37a790ce5d2499688955c3fcfa/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
